#ifndef FSLDEMOHOST_BASE_SERVICE_TEST_TESTSCREENSHOTCONFIG_HPP
#define FSLDEMOHOST_BASE_SERVICE_TEST_TESTSCREENSHOTCONFIG_HPP
/****************************************************************************************************************************************************
 * Copyright 2017 NXP
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *
 *    * Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 *    * Neither the name of the NXP. nor the names of
 *      its contributors may be used to endorse or promote products derived from
 *      this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ****************************************************************************************************************************************************/

#include <FslBase/BasicTypes.hpp>
#include <FslDemoHost/Base/Service/Test/TestScreenshotNameScheme.hpp>
#include <FslGraphics/ImageFormat.hpp>
#include <string>
#include <utility>

namespace Fsl
{
  struct TestScreenshotConfig
  {
    TestScreenshotNameScheme NamingScheme{TestScreenshotNameScheme::FrameNumber};
    ImageFormat Format{ImageFormat::Png};
    //! If zero screenshot is disabled
    uint32_t Frequency{0};
    std::string FilenamePrefix;

    TestScreenshotConfig() = default;

    TestScreenshotConfig(const TestScreenshotNameScheme namingScheme, const ImageFormat& format, const uint32_t frequency, std::string filenamePrefix)
      : NamingScheme(namingScheme)
      , Format(format)
      , Frequency(frequency)
      , FilenamePrefix(std::move(filenamePrefix))
    {
    }
  };
}

#endif
