#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
/****************************************************************************************************************************************************
 * Copyright (c) 2014 Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *
 *    * Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 *    * Neither the name of the Freescale Semiconductor, Inc. nor the names of
 *      its contributors may be used to endorse or promote products derived from
 *      this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ****************************************************************************************************************************************************/

#include "Logo.hpp"

namespace Fsl
{
  RawBitmap Logo::GetBitmap()
  {
    return {gpImageData, PxExtent2D(256, 256), PixelFormat::R8G8B8A8_UNORM, BitmapOrigin::UpperLeft};
  }

  // NOLINTNEXTLINE(modernize-avoid-c-arrays)
  const unsigned char Logo::gpImageData[] = {
    73,  101, 44,  255, 63,  95,  47,  255, 77,  102, 50,  255, 62,  91,  33,  255, 58,  91,  26,  255, 94,  128, 44,  255, 159, 180, 94,  255, 137,
    167, 119, 255, 125, 159, 119, 255, 95,  116, 69,  255, 67,  94,  28,  255, 126, 158, 84,  255, 131, 165, 108, 255, 112, 151, 100, 255, 114, 153,
    102, 255, 109, 149, 90,  255, 106, 147, 75,  255, 119, 159, 76,  255, 130, 172, 92,  255, 141, 181, 98,  255, 152, 181, 92,  255, 107, 124, 60,
    255, 79,  93,  36,  255, 106, 129, 44,  255, 133, 157, 58,  255, 124, 147, 52,  255, 150, 168, 75,  255, 79,  87,  47,  255, 19,  23,  21,  255,
    23,  26,  21,  255, 93,  113, 55,  255, 116, 147, 73,  255, 83,  118, 74,  255, 84,  117, 79,  255, 86,  118, 81,  255, 93,  126, 80,  255, 95,
    120, 63,  255, 33,  41,  21,  255, 52,  74,  34,  255, 52,  68,  32,  255, 26,  32,  23,  255, 38,  48,  25,  255, 52,  65,  26,  255, 48,  65,
    26,  255, 69,  92,  39,  255, 78,  84,  55,  255, 134, 137, 94,  255, 233, 241, 162, 255, 231, 238, 166, 255, 251, 249, 183, 255, 219, 224, 108,
    255, 185, 208, 78,  255, 197, 217, 100, 255, 175, 192, 99,  255, 168, 183, 107, 255, 189, 200, 112, 255, 219, 226, 140, 255, 223, 227, 150, 255,
    183, 191, 119, 255, 82,  89,  44,  255, 58,  87,  29,  255, 106, 138, 68,  255, 128, 153, 90,  255, 169, 186, 105, 255, 201, 213, 115, 255, 195,
    208, 116, 255, 148, 153, 90,  255, 148, 166, 82,  255, 189, 211, 110, 255, 194, 207, 108, 255, 74,  73,  31,  255, 12,  19,  12,  255, 85,  97,
    72,  255, 195, 212, 142, 255, 164, 174, 109, 255, 114, 128, 69,  255, 109, 135, 82,  255, 74,  82,  43,  255, 74,  85,  44,  255, 63,  68,  33,
    255, 45,  63,  29,  255, 44,  65,  37,  255, 53,  79,  42,  255, 119, 151, 73,  255, 107, 142, 63,  255, 162, 185, 118, 255, 129, 145, 75,  255,
    152, 176, 97,  255, 139, 169, 100, 255, 126, 159, 92,  255, 124, 155, 87,  255, 117, 149, 82,  255, 117, 149, 81,  255, 123, 155, 83,  255, 128,
    160, 86,  255, 111, 143, 65,  255, 95,  120, 47,  255, 26,  31,  17,  255, 58,  82,  43,  255, 85,  114, 53,  255, 107, 142, 65,  255, 137, 165,
    95,  255, 179, 197, 125, 255, 208, 223, 140, 255, 198, 216, 128, 255, 192, 212, 128, 255, 189, 210, 129, 255, 193, 209, 129, 255, 167, 185, 87,
    255, 163, 183, 80,  255, 148, 171, 90,  255, 160, 180, 97,  255, 191, 205, 115, 255, 185, 205, 123, 255, 198, 218, 128, 255, 198, 213, 125, 255,
    196, 213, 121, 255, 199, 203, 112, 255, 194, 199, 108, 255, 183, 192, 98,  255, 172, 186, 97,  255, 174, 188, 98,  255, 134, 148, 58,  255, 150,
    170, 74,  255, 192, 198, 91,  255, 189, 200, 114, 255, 150, 159, 74,  255, 52,  74,  32,  255, 58,  71,  32,  255, 139, 168, 78,  255, 81,  126,
    49,  255, 57,  95,  36,  255, 87,  122, 50,  255, 97,  132, 50,  255, 120, 152, 68,  255, 137, 168, 79,  255, 111, 150, 74,  255, 99,  137, 69,
    255, 104, 139, 76,  255, 112, 145, 93,  255, 128, 161, 112, 255, 132, 165, 114, 255, 101, 139, 87,  255, 76,  111, 47,  255, 85,  96,  36,  255,
    96,  115, 43,  255, 113, 146, 52,  255, 144, 172, 71,  255, 153, 175, 81,  255, 195, 203, 95,  255, 222, 224, 114, 255, 191, 199, 101, 255, 110,
    120, 62,  255, 36,  46,  29,  255, 26,  36,  26,  255, 38,  52,  32,  255, 38,  60,  31,  255, 55,  73,  42,  255, 78,  103, 53,  255, 69,  92,
    42,  255, 32,  39,  25,  255, 62,  76,  50,  255, 98,  119, 58,  255, 149, 170, 73,  255, 91,  129, 52,  255, 65,  109, 42,  255, 71,  101, 41,
    255, 154, 170, 119, 255, 135, 153, 107, 255, 89,  108, 60,  255, 158, 162, 74,  255, 162, 186, 91,  255, 139, 173, 100, 255, 159, 182, 116, 255,
    166, 189, 124, 255, 140, 173, 69,  255, 122, 155, 58,  255, 86,  112, 41,  255, 103, 128, 55,  255, 123, 145, 52,  255, 118, 139, 52,  255, 110,
    130, 52,  255, 110, 127, 55,  255, 101, 118, 53,  255, 73,  94,  40,  255, 53,  75,  32,  255, 85,  103, 39,  255, 140, 168, 76,  255, 122, 153,
    83,  255, 104, 137, 58,  255, 159, 178, 83,  255, 194, 211, 86,  255, 183, 203, 67,  255, 198, 213, 77,  255, 181, 197, 98,  255, 171, 188, 99,
    255, 185, 197, 108, 255, 194, 203, 113, 255, 191, 203, 114, 255, 195, 208, 111, 255, 190, 205, 107, 255, 181, 202, 100, 255, 187, 208, 104, 255,
    202, 220, 109, 255, 159, 176, 83,  255, 157, 173, 101, 255, 131, 155, 91,  255, 155, 168, 84,  255, 160, 178, 90,  255, 177, 187, 84,  255, 193,
    197, 71,  255, 165, 172, 62,  255, 110, 124, 45,  255, 48,  68,  37,  255, 58,  83,  38,  255, 126, 157, 95,  255, 98,  135, 98,  255, 95,  129,
    96,  255, 118, 149, 94,  255, 109, 141, 89,  255, 119, 150, 84,  255, 144, 172, 85,  255, 123, 150, 84,  255, 105, 134, 81,  255, 137, 161, 89,
    255, 142, 167, 93,  255, 114, 141, 80,  255, 140, 166, 122, 255, 63,  86,  52,  255, 63,  92,  43,  255, 74,  102, 42,  255, 92,  115, 50,  255,
    147, 172, 83,  255, 102, 134, 83,  255, 113, 141, 85,  255, 87,  120, 74,  255, 81,  115, 77,  255, 80,  114, 77,  255, 116, 148, 84,  255, 106,
    129, 56,  255, 58,  80,  33,  255, 155, 176, 117, 255, 135, 163, 108, 255, 153, 171, 111, 255, 193, 207, 155, 255, 140, 168, 123, 255, 138, 172,
    128, 255, 134, 168, 117, 255, 160, 184, 113, 255, 174, 187, 93,  255, 156, 176, 75,  255, 151, 176, 67,  255, 147, 173, 60,  255, 135, 160, 56,
    255, 89,  105, 37,  255, 55,  75,  31,  255, 58,  91,  39,  255, 98,  133, 47,  255, 91,  124, 53,  255, 73,  108, 42,  255, 84,  115, 40,  255,
    118, 157, 55,  255, 130, 161, 58,  255, 150, 175, 96,  255, 125, 155, 106, 255, 83,  101, 60,  255, 62,  77,  40,  255, 120, 156, 101, 255, 109,
    149, 95,  255, 110, 151, 90,  255, 112, 154, 80,  255, 117, 160, 73,  255, 135, 176, 76,  255, 147, 181, 77,  255, 129, 158, 68,  255, 118, 138,
    62,  255, 78,  91,  37,  255, 23,  32,  19,  255, 26,  43,  23,  255, 40,  68,  23,  255, 99,  127, 68,  255, 112, 142, 75,  255, 86,  109, 52,
    255, 49,  67,  34,  255, 47,  72,  37,  255, 34,  48,  29,  255, 21,  31,  19,  255, 91,  114, 53,  255, 129, 158, 87,  255, 121, 153, 95,  255,
    107, 140, 90,  255, 94,  128, 89,  255, 103, 131, 81,  255, 52,  73,  36,  255, 46,  71,  40,  255, 40,  62,  31,  255, 26,  33,  25,  255, 118,
    131, 79,  255, 155, 168, 101, 255, 127, 134, 86,  255, 84,  98,  55,  255, 93,  102, 62,  255, 205, 212, 133, 255, 239, 243, 154, 255, 238, 243,
    172, 255, 246, 245, 165, 255, 207, 215, 100, 255, 172, 193, 75,  255, 191, 207, 119, 255, 212, 219, 142, 255, 210, 221, 117, 255, 210, 226, 120,
    255, 225, 236, 126, 255, 238, 243, 144, 255, 238, 239, 147, 255, 143, 152, 76,  255, 124, 145, 75,  255, 143, 162, 89,  255, 122, 140, 81,  255,
    87,  100, 53,  255, 105, 123, 55,  255, 200, 215, 113, 255, 185, 192, 114, 255, 173, 187, 104, 255, 192, 213, 111, 255, 163, 178, 84,  255, 39,
    51,  19,  255, 19,  28,  23,  255, 52,  58,  47,  255, 203, 214, 165, 255, 177, 205, 126, 255, 189, 209, 117, 255, 192, 207, 156, 255, 119, 141,
    74,  255, 91,  130, 47,  255, 68,  75,  32,  255, 44,  53,  28,  255, 60,  84,  37,  255, 84,  110, 58,  255, 125, 152, 78,  255, 180, 199, 128,
    255, 214, 228, 161, 255, 178, 199, 121, 255, 148, 179, 106, 255, 132, 165, 97,  255, 133, 166, 102, 255, 130, 164, 101, 255, 125, 159, 95,  255,
    117, 152, 87,  255, 117, 153, 84,  255, 117, 152, 80,  255, 111, 144, 71,  255, 88,  111, 44,  255, 55,  80,  28,  255, 84,  128, 56,  255, 100,
    142, 71,  255, 102, 141, 74,  255, 102, 140, 73,  255, 99,  135, 68,  255, 129, 158, 82,  255, 163, 184, 87,  255, 180, 194, 95,  255, 174, 189,
    108, 255, 141, 161, 76,  255, 161, 186, 95,  255, 151, 177, 81,  255, 126, 156, 68,  255, 120, 147, 62,  255, 128, 151, 71,  255, 145, 165, 82,
    255, 171, 184, 96,  255, 142, 153, 63,  255, 119, 126, 52,  255, 97,  100, 38,  255, 140, 161, 72,  255, 166, 182, 90,  255, 170, 184, 96,  255,
    168, 184, 92,  255, 114, 132, 46,  255, 136, 159, 74,  255, 188, 199, 115, 255, 183, 190, 100, 255, 115, 136, 42,  255, 63,  87,  32,  255, 47,
    60,  26,  255, 133, 156, 68,  255, 128, 163, 80,  255, 83,  117, 60,  255, 105, 133, 56,  255, 96,  133, 43,  255, 103, 131, 43,  255, 153, 181,
    91,  255, 120, 155, 79,  255, 94,  123, 62,  255, 102, 131, 65,  255, 115, 146, 77,  255, 159, 183, 109, 255, 154, 180, 106, 255, 131, 167, 105,
    255, 97,  134, 65,  255, 78,  104, 42,  255, 89,  112, 43,  255, 125, 151, 50,  255, 145, 168, 84,  255, 150, 171, 133, 255, 185, 199, 130, 255,
    180, 197, 116, 255, 58,  84,  34,  255, 15,  26,  15,  255, 33,  46,  31,  255, 37,  52,  32,  255, 50,  73,  37,  255, 40,  62,  36,  255, 47,
    62,  38,  255, 85,  117, 65,  255, 83,  114, 58,  255, 75,  102, 47,  255, 63,  89,  40,  255, 122, 138, 65,  255, 138, 167, 80,  255, 87,  128,
    65,  255, 69,  111, 52,  255, 75,  105, 36,  255, 203, 211, 142, 255, 202, 226, 176, 255, 205, 220, 171, 255, 201, 213, 156, 255, 192, 206, 134,
    255, 159, 182, 103, 255, 194, 207, 143, 255, 197, 213, 149, 255, 150, 175, 75,  255, 161, 183, 74,  255, 99,  130, 45,  255, 53,  87,  37,  255,
    65,  95,  36,  255, 46,  75,  28,  255, 47,  75,  28,  255, 118, 143, 68,  255, 140, 169, 95,  255, 121, 156, 77,  255, 128, 152, 65,  255, 133,
    155, 68,  255, 127, 160, 73,  255, 106, 146, 62,  255, 113, 149, 62,  255, 192, 204, 98,  255, 229, 232, 112, 255, 213, 221, 87,  255, 228, 232,
    103, 255, 181, 197, 118, 255, 131, 161, 118, 255, 144, 171, 126, 255, 171, 192, 124, 255, 158, 180, 121, 255, 164, 185, 129, 255, 188, 203, 128,
    255, 202, 214, 117, 255, 177, 197, 81,  255, 154, 180, 78,  255, 120, 148, 81,  255, 91,  117, 65,  255, 84,  121, 75,  255, 121, 144, 81,  255,
    206, 202, 108, 255, 207, 207, 114, 255, 93,  112, 42,  255, 39,  58,  23,  255, 43,  63,  34,  255, 52,  82,  36,  255, 52,  82,  28,  255, 126,
    152, 86,  255, 109, 143, 101, 255, 99,  132, 99,  255, 98,  132, 95,  255, 107, 138, 95,  255, 94,  126, 81,  255, 132, 162, 84,  255, 144, 172,
    85,  255, 100, 132, 78,  255, 79,  113, 75,  255, 77,  106, 60,  255, 97,  125, 63,  255, 115, 143, 89,  255, 74,  105, 50,  255, 76,  112, 41,
    255, 84,  106, 47,  255, 135, 157, 85,  255, 143, 170, 85,  255, 99,  128, 84,  255, 104, 135, 82,  255, 123, 154, 83,  255, 87,  123, 75,  255,
    87,  122, 83,  255, 125, 155, 90,  255, 104, 131, 55,  255, 113, 138, 79,  255, 155, 184, 133, 255, 122, 150, 96,  255, 137, 170, 132, 255, 137,
    172, 129, 255, 141, 175, 133, 255, 146, 179, 128, 255, 166, 191, 123, 255, 158, 175, 89,  255, 126, 149, 68,  255, 122, 149, 63,  255, 116, 143,
    58,  255, 105, 133, 52,  255, 63,  87,  33,  255, 43,  68,  31,  255, 55,  92,  38,  255, 75,  115, 34,  255, 107, 142, 48,  255, 60,  90,  32,
    255, 57,  84,  33,  255, 79,  108, 38,  255, 119, 150, 50,  255, 124, 154, 50,  255, 128, 155, 62,  255, 126, 151, 75,  255, 76,  95,  47,  255,
    90,  117, 65,  255, 122, 161, 84,  255, 128, 166, 71,  255, 134, 171, 65,  255, 136, 168, 65,  255, 118, 147, 55,  255, 92,  108, 43,  255, 71,
    83,  37,  255, 58,  76,  37,  255, 47,  72,  31,  255, 69,  99,  38,  255, 71,  101, 40,  255, 55,  81,  31,  255, 60,  71,  44,  255, 82,  91,
    68,  255, 98,  114, 67,  255, 88,  107, 52,  255, 55,  82,  39,  255, 71,  103, 55,  255, 81,  108, 60,  255, 69,  90,  47,  255, 44,  68,  23,
    255, 65,  90,  38,  255, 107, 131, 65,  255, 111, 134, 68,  255, 110, 133, 73,  255, 94,  122, 62,  255, 48,  75,  39,  255, 38,  65,  36,  255,
    28,  55,  19,  255, 29,  52,  29,  255, 102, 122, 82,  255, 213, 230, 157, 255, 243, 248, 161, 255, 191, 200, 123, 255, 186, 200, 121, 255, 249,
    249, 168, 255, 235, 236, 154, 255, 226, 232, 132, 255, 223, 227, 134, 255, 177, 188, 94,  255, 176, 191, 101, 255, 225, 236, 148, 255, 231, 241,
    132, 255, 243, 246, 145, 255, 241, 243, 144, 255, 226, 232, 140, 255, 207, 219, 140, 255, 194, 212, 147, 255, 206, 226, 173, 255, 224, 239, 188,
    255, 222, 233, 175, 255, 198, 202, 133, 255, 98,  101, 44,  255, 33,  52,  15,  255, 72,  89,  36,  255, 153, 167, 93,  255, 174, 185, 104, 255,
    160, 181, 77,  255, 133, 160, 73,  255, 105, 123, 55,  255, 21,  26,  17,  255, 26,  34,  26,  255, 164, 177, 124, 255, 193, 217, 158, 255, 160,
    193, 127, 255, 200, 221, 149, 255, 171, 188, 105, 255, 95,  128, 44,  255, 79,  100, 36,  255, 78,  90,  45,  255, 92,  113, 52,  255, 140, 161,
    93,  255, 204, 219, 146, 255, 199, 221, 162, 255, 191, 213, 147, 255, 146, 175, 87,  255, 137, 162, 73,  255, 114, 139, 60,  255, 120, 150, 71,
    255, 138, 167, 89,  255, 117, 150, 75,  255, 142, 173, 99,  255, 162, 185, 103, 255, 115, 140, 56,  255, 84,  113, 37,  255, 75,  106, 36,  255,
    86,  118, 39,  255, 113, 146, 63,  255, 133, 166, 86,  255, 133, 165, 87,  255, 118, 153, 83,  255, 120, 157, 84,  255, 124, 157, 76,  255, 123,
    152, 71,  255, 114, 144, 69,  255, 108, 141, 69,  255, 123, 146, 74,  255, 141, 167, 80,  255, 130, 160, 72,  255, 140, 171, 84,  255, 156, 183,
    99,  255, 178, 200, 112, 255, 202, 213, 122, 255, 156, 158, 73,  255, 67,  95,  32,  255, 42,  55,  21,  255, 23,  34,  19,  255, 137, 160, 78,
    255, 165, 181, 84,  255, 167, 183, 92,  255, 144, 159, 73,  255, 88,  109, 33,  255, 161, 180, 94,  255, 172, 182, 94,  255, 102, 120, 33,  255,
    83,  114, 29,  255, 74,  97,  33,  255, 48,  75,  26,  255, 110, 132, 55,  255, 174, 190, 114, 255, 177, 199, 135, 255, 181, 201, 145, 255, 174,
    197, 110, 255, 130, 154, 65,  255, 130, 159, 74,  255, 134, 167, 82,  255, 69,  104, 50,  255, 72,  96,  55,  255, 141, 158, 84,  255, 155, 185,
    113, 255, 149, 179, 116, 255, 127, 153, 78,  255, 49,  73,  23,  255, 47,  62,  33,  255, 53,  75,  31,  255, 87,  114, 36,  255, 123, 153, 84,
    255, 140, 164, 135, 255, 183, 198, 134, 255, 113, 137, 79,  255, 17,  31,  15,  255, 21,  23,  19,  255, 34,  44,  28,  255, 32,  47,  26,  255,
    37,  51,  31,  255, 50,  73,  41,  255, 37,  52,  33,  255, 69,  86,  52,  255, 90,  119, 68,  255, 77,  116, 53,  255, 58,  91,  31,  255, 136,
    154, 74,  255, 105, 144, 75,  255, 98,  134, 74,  255, 87,  127, 62,  255, 75,  115, 43,  255, 154, 167, 89,  255, 197, 221, 168, 255, 185, 214,
    170, 255, 194, 214, 170, 255, 218, 227, 162, 255, 219, 226, 153, 255, 201, 217, 141, 255, 185, 202, 123, 255, 107, 133, 62,  255, 96,  125, 52,
    255, 63,  97,  37,  255, 73,  105, 40,  255, 58,  89,  31,  255, 31,  52,  21,  255, 99,  121, 47,  255, 141, 168, 81,  255, 83,  118, 62,  255,
    113, 140, 65,  255, 162, 186, 89,  255, 143, 177, 92,  255, 119, 156, 77,  255, 115, 154, 69,  255, 147, 175, 71,  255, 168, 183, 76,  255, 223,
    223, 116, 255, 248, 245, 142, 255, 222, 223, 138, 255, 139, 166, 128, 255, 132, 167, 139, 255, 136, 169, 141, 255, 142, 172, 143, 255, 139, 170,
    135, 255, 134, 166, 134, 255, 136, 168, 129, 255, 158, 183, 134, 255, 177, 191, 116, 255, 102, 125, 58,  255, 99,  129, 68,  255, 104, 131, 65,
    255, 87,  120, 62,  255, 122, 141, 82,  255, 193, 197, 113, 255, 181, 191, 119, 255, 167, 173, 106, 255, 69,  87,  42,  255, 49,  75,  32,  255,
    57,  83,  39,  255, 47,  74,  40,  255, 113, 131, 71,  255, 136, 166, 103, 255, 105, 136, 97,  255, 115, 147, 96,  255, 111, 140, 96,  255, 101,
    133, 89,  255, 118, 148, 83,  255, 148, 177, 90,  255, 128, 160, 84,  255, 91,  127, 71,  255, 110, 136, 68,  255, 107, 141, 62,  255, 99,  132,
    56,  255, 77,  107, 43,  255, 67,  90,  36,  255, 134, 154, 83,  255, 114, 143, 87,  255, 109, 139, 87,  255, 97,  128, 91,  255, 94,  126, 87,
    255, 142, 168, 87,  255, 136, 169, 81,  255, 111, 146, 87,  255, 118, 148, 99,  255, 104, 131, 56,  255, 164, 184, 126, 255, 128, 156, 104, 255,
    138, 170, 128, 255, 145, 180, 137, 255, 149, 183, 140, 255, 153, 183, 134, 255, 171, 193, 120, 255, 173, 187, 89,  255, 110, 132, 55,  255, 77,
    106, 60,  255, 83,  112, 65,  255, 81,  111, 55,  255, 85,  117, 44,  255, 69,  100, 31,  255, 68,  110, 36,  255, 52,  90,  29,  255, 94,  135,
    40,  255, 102, 131, 49,  255, 47,  69,  33,  255, 52,  76,  36,  255, 60,  87,  37,  255, 113, 140, 53,  255, 139, 163, 62,  255, 128, 154, 62,
    255, 120, 141, 72,  255, 98,  114, 65,  255, 100, 123, 58,  255, 93,  114, 43,  255, 96,  121, 47,  255, 85,  104, 40,  255, 52,  67,  29,  255,
    33,  49,  23,  255, 19,  33,  19,  255, 36,  52,  31,  255, 87,  119, 65,  255, 79,  114, 47,  255, 94,  134, 52,  255, 94,  130, 49,  255, 96,
    131, 50,  255, 52,  62,  31,  255, 37,  41,  32,  255, 68,  82,  55,  255, 92,  122, 52,  255, 109, 145, 68,  255, 123, 158, 83,  255, 138, 170,
    91,  255, 144, 175, 94,  255, 141, 167, 87,  255, 71,  96,  37,  255, 58,  77,  39,  255, 109, 116, 79,  255, 48,  58,  25,  255, 113, 125, 86,
    255, 131, 144, 102, 255, 124, 139, 91,  255, 129, 141, 81,  255, 129, 143, 87,  255, 101, 117, 77,  255, 143, 157, 102, 255, 219, 228, 145, 255,
    231, 238, 139, 255, 226, 233, 142, 255, 241, 241, 165, 255, 245, 246, 179, 255, 238, 241, 150, 255, 218, 224, 111, 255, 171, 186, 89,  255, 197,
    214, 134, 255, 213, 225, 138, 255, 198, 209, 112, 255, 197, 210, 114, 255, 203, 216, 134, 255, 201, 218, 146, 255, 200, 221, 165, 255, 214, 234,
    184, 255, 220, 235, 178, 255, 202, 218, 145, 255, 194, 210, 123, 255, 231, 231, 132, 255, 214, 211, 118, 255, 109, 133, 41,  255, 73,  102, 26,
    255, 132, 154, 82,  255, 177, 180, 117, 255, 137, 157, 73,  255, 147, 174, 89,  255, 149, 166, 81,  255, 33,  38,  19,  255, 23,  33,  23,  255,
    124, 141, 84,  255, 213, 226, 165, 255, 188, 213, 153, 255, 175, 201, 86,  255, 171, 198, 92,  255, 159, 178, 79,  255, 88,  111, 37,  255, 82,
    109, 56,  255, 147, 168, 107, 255, 224, 234, 162, 255, 201, 219, 168, 255, 179, 211, 168, 255, 193, 208, 135, 255, 105, 130, 49,  255, 108, 141,
    60,  255, 84,  114, 56,  255, 78,  111, 53,  255, 95,  126, 56,  255, 97,  127, 60,  255, 130, 153, 71,  255, 120, 144, 56,  255, 93,  128, 44,
    255, 84,  119, 39,  255, 87,  121, 44,  255, 96,  131, 47,  255, 96,  132, 44,  255, 107, 141, 55,  255, 138, 165, 80,  255, 138, 164, 72,  255,
    125, 152, 60,  255, 94,  110, 41,  255, 78,  100, 41,  255, 92,  125, 52,  255, 113, 144, 65,  255, 109, 133, 55,  255, 130, 155, 74,  255, 153,
    177, 86,  255, 162, 182, 97,  255, 186, 200, 109, 255, 176, 187, 109, 255, 189, 199, 117, 255, 165, 162, 75,  255, 79,  111, 39,  255, 91,  118,
    47,  255, 47,  60,  21,  255, 91,  114, 52,  255, 168, 187, 87,  255, 158, 174, 81,  255, 83,  94,  36,  255, 107, 123, 60,  255, 160, 175, 71,
    255, 140, 158, 52,  255, 116, 137, 36,  255, 102, 127, 29,  255, 75,  101, 31,  255, 63,  90,  28,  255, 166, 181, 82,  255, 162, 176, 116, 255,
    163, 187, 121, 255, 157, 186, 140, 255, 160, 190, 133, 255, 178, 201, 137, 255, 166, 190, 120, 255, 147, 174, 86,  255, 127, 150, 62,  255, 160,
    181, 87,  255, 172, 196, 110, 255, 145, 177, 122, 255, 152, 183, 126, 255, 123, 148, 87,  255, 32,  58,  21,  255, 43,  60,  29,  255, 49,  65,
    29,  255, 80,  104, 38,  255, 108, 133, 83,  255, 130, 157, 122, 255, 159, 180, 122, 255, 38,  53,  33,  255, 15,  21,  19,  255, 15,  23,  21,
    255, 17,  23,  19,  255, 21,  26,  23,  255, 21,  23,  21,  255, 42,  55,  33,  255, 47,  71,  39,  255, 36,  52,  33,  255, 48,  67,  36,  255,
    50,  75,  33,  255, 67,  92,  36,  255, 174, 183, 95,  255, 137, 170, 84,  255, 107, 146, 65,  255, 108, 146, 58,  255, 119, 152, 56,  255, 151,
    166, 73,  255, 215, 229, 158, 255, 184, 212, 165, 255, 187, 213, 172, 255, 188, 211, 138, 255, 189, 215, 117, 255, 169, 197, 95,  255, 134, 154,
    75,  255, 62,  94,  29,  255, 67,  97,  40,  255, 68,  100, 43,  255, 82,  117, 43,  255, 72,  105, 36,  255, 67,  90,  39,  255, 112, 138, 56,
    255, 89,  125, 65,  255, 72,  107, 58,  255, 116, 140, 60,  255, 185, 204, 92,  255, 139, 175, 83,  255, 131, 168, 79,  255, 152, 179, 84,  255,
    130, 155, 60,  255, 136, 167, 58,  255, 149, 175, 65,  255, 209, 217, 119, 255, 160, 180, 92,  255, 131, 160, 96,  255, 138, 169, 117, 255, 137,
    171, 127, 255, 146, 178, 140, 255, 146, 177, 143, 255, 148, 177, 146, 255, 146, 176, 145, 255, 140, 172, 141, 255, 151, 179, 138, 255, 159, 178,
    121, 255, 80,  105, 60,  255, 80,  105, 50,  255, 119, 141, 67,  255, 187, 192, 107, 255, 137, 162, 107, 255, 129, 158, 118, 255, 152, 173, 127,
    255, 181, 188, 111, 255, 82,  108, 50,  255, 60,  87,  48,  255, 63,  92,  52,  255, 95,  116, 63,  255, 156, 179, 109, 255, 111, 143, 99,  255,
    105, 137, 97,  255, 107, 140, 99,  255, 108, 140, 100, 255, 124, 155, 92,  255, 147, 178, 95,  255, 121, 145, 72,  255, 146, 164, 79,  255, 167,
    196, 95,  255, 128, 170, 77,  255, 112, 154, 68,  255, 120, 157, 68,  255, 139, 159, 80,  255, 159, 176, 95,  255, 118, 148, 92,  255, 104, 134,
    93,  255, 99,  128, 94,  255, 98,  129, 94,  255, 142, 167, 97,  255, 100, 120, 52,  255, 117, 148, 69,  255, 112, 146, 91,  255, 122, 147, 83,
    255, 154, 174, 113, 255, 127, 157, 105, 255, 154, 187, 139, 255, 164, 193, 142, 255, 178, 200, 139, 255, 187, 206, 131, 255, 174, 190, 106, 255,
    93,  109, 41,  255, 100, 113, 48,  255, 126, 145, 60,  255, 140, 157, 68,  255, 129, 149, 62,  255, 130, 159, 74,  255, 94,  118, 55,  255, 52,
    76,  31,  255, 62,  96,  32,  255, 107, 141, 49,  255, 76,  102, 39,  255, 49,  77,  36,  255, 50,  76,  41,  255, 55,  81,  43,  255, 86,  110,
    48,  255, 132, 152, 60,  255, 137, 160, 63,  255, 113, 137, 53,  255, 111, 123, 69,  255, 135, 156, 69,  255, 105, 127, 60,  255, 62,  77,  44,
    255, 17,  26,  19,  255, 34,  51,  26,  255, 36,  52,  29,  255, 29,  44,  26,  255, 58,  82,  36,  255, 81,  113, 60,  255, 48,  79,  33,  255,
    95,  127, 50,  255, 131, 162, 73,  255, 132, 157, 71,  255, 52,  62,  26,  255, 19,  26,  21,  255, 65,  84,  47,  255, 99,  134, 49,  255, 127,
    160, 63,  255, 133, 165, 75,  255, 139, 174, 87,  255, 140, 176, 96,  255, 160, 191, 115, 255, 135, 160, 82,  255, 144, 148, 101, 255, 206, 201,
    149, 255, 110, 109, 74,  255, 133, 140, 91,  255, 217, 232, 167, 255, 189, 213, 157, 255, 199, 218, 155, 255, 197, 216, 145, 255, 203, 216, 142,
    255, 141, 151, 84,  255, 168, 177, 109, 255, 232, 239, 143, 255, 207, 218, 116, 255, 217, 225, 132, 255, 238, 241, 155, 255, 231, 230, 144, 255,
    166, 174, 82,  255, 135, 159, 60,  255, 176, 196, 92,  255, 178, 192, 100, 255, 176, 194, 108, 255, 178, 198, 101, 255, 150, 167, 80,  255, 170,
    180, 112, 255, 204, 210, 140, 255, 189, 195, 118, 255, 158, 178, 91,  255, 132, 162, 65,  255, 187, 201, 94,  255, 220, 219, 114, 255, 223, 222,
    127, 255, 202, 210, 84,  255, 161, 183, 62,  255, 167, 188, 87,  255, 163, 171, 101, 255, 160, 179, 94,  255, 171, 194, 105, 255, 161, 177, 89,
    255, 50,  60,  26,  255, 43,  65,  44,  255, 71,  95,  49,  255, 112, 127, 72,  255, 194, 215, 154, 255, 170, 199, 107, 255, 153, 190, 73,  255,
    179, 195, 87,  255, 81,  98,  34,  255, 154, 179, 122, 255, 226, 238, 174, 255, 188, 213, 169, 255, 170, 204, 160, 255, 201, 230, 180, 255, 155,
    145, 94,  255, 36,  42,  17,  255, 63,  87,  36,  255, 65,  100, 43,  255, 84,  121, 48,  255, 122, 151, 63,  255, 155, 177, 82,  255, 134, 160,
    72,  255, 120, 149, 67,  255, 105, 135, 62,  255, 100, 134, 53,  255, 91,  125, 43,  255, 94,  130, 43,  255, 113, 148, 67,  255, 106, 138, 60,
    255, 87,  123, 42,  255, 96,  130, 45,  255, 74,  105, 34,  255, 73,  103, 37,  255, 116, 143, 53,  255, 128, 138, 56,  255, 69,  76,  47,  255,
    63,  90,  36,  255, 131, 159, 82,  255, 134, 151, 93,  255, 124, 149, 98,  255, 151, 170, 105, 255, 124, 148, 102, 255, 181, 198, 120, 255, 172,
    169, 80,  255, 73,  99,  40,  255, 76,  109, 52,  255, 87,  114, 45,  255, 50,  72,  26,  255, 148, 175, 86,  255, 124, 144, 76,  255, 81,  98,
    42,  255, 62,  68,  31,  255, 104, 128, 45,  255, 115, 144, 52,  255, 115, 137, 49,  255, 131, 147, 44,  255, 106, 128, 50,  255, 108, 126, 58,
    255, 182, 194, 103, 255, 148, 169, 128, 255, 140, 174, 145, 255, 161, 186, 131, 255, 177, 204, 100, 255, 148, 187, 98,  255, 161, 190, 130, 255,
    171, 197, 123, 255, 155, 186, 83,  255, 150, 182, 84,  255, 160, 188, 114, 255, 150, 181, 126, 255, 153, 184, 131, 255, 152, 174, 106, 255, 52,
    77,  26,  255, 80,  106, 47,  255, 87,  119, 47,  255, 75,  108, 43,  255, 77,  103, 48,  255, 117, 140, 92,  255, 138, 167, 94,  255, 67,  95,
    49,  255, 19,  29,  23,  255, 25,  32,  23,  255, 36,  55,  23,  255, 45,  65,  26,  255, 41,  60,  26,  255, 52,  68,  33,  255, 63,  87,  42,
    255, 51,  79,  34,  255, 32,  52,  26,  255, 29,  36,  28,  255, 55,  77,  36,  255, 112, 125, 60,  255, 139, 153, 72,  255, 148, 163, 71,  255,
    168, 176, 74,  255, 184, 183, 75,  255, 157, 160, 65,  255, 184, 180, 102, 255, 206, 226, 163, 255, 187, 212, 167, 255, 185, 210, 155, 255, 169,
    200, 105, 255, 162, 193, 86,  255, 195, 206, 139, 255, 87,  105, 52,  255, 69,  97,  39,  255, 77,  113, 43,  255, 92,  129, 45,  255, 107, 143,
    55,  255, 119, 156, 65,  255, 124, 159, 63,  255, 87,  120, 58,  255, 86,  120, 58,  255, 95,  125, 45,  255, 172, 182, 80,  255, 177, 203, 112,
    255, 185, 203, 108, 255, 160, 185, 86,  255, 137, 172, 74,  255, 139, 175, 72,  255, 132, 170, 58,  255, 127, 164, 44,  255, 151, 176, 60,  255,
    171, 187, 81,  255, 163, 180, 75,  255, 145, 175, 82,  255, 134, 170, 84,  255, 133, 166, 92,  255, 139, 170, 107, 255, 146, 176, 120, 255, 145,
    177, 128, 255, 141, 176, 135, 255, 136, 172, 130, 255, 142, 170, 117, 255, 122, 146, 78,  255, 153, 158, 79,  255, 173, 188, 113, 255, 118, 149,
    111, 255, 125, 153, 121, 255, 119, 150, 121, 255, 177, 186, 127, 255, 170, 178, 96,  255, 80,  107, 47,  255, 79,  106, 55,  255, 83,  109, 58,
    255, 146, 164, 87,  255, 159, 186, 112, 255, 122, 154, 104, 255, 108, 140, 104, 255, 112, 142, 107, 255, 134, 164, 105, 255, 148, 178, 102, 255,
    102, 128, 65,  255, 128, 146, 58,  255, 173, 206, 104, 255, 131, 176, 92,  255, 127, 168, 87,  255, 136, 170, 92,  255, 186, 206, 118, 255, 142,
    165, 94,  255, 111, 142, 96,  255, 107, 139, 95,  255, 106, 136, 104, 255, 98,  129, 99,  255, 137, 161, 99,  255, 113, 134, 65,  255, 43,  63,
    31,  255, 96,  123, 60,  255, 133, 150, 89,  255, 131, 157, 96,  255, 157, 189, 128, 255, 175, 201, 134, 255, 190, 208, 136, 255, 187, 203, 121,
    255, 155, 178, 94,  255, 133, 167, 76,  255, 122, 150, 72,  255, 109, 130, 69,  255, 155, 179, 112, 255, 154, 180, 116, 255, 121, 148, 84,  255,
    117, 147, 68,  255, 122, 158, 75,  255, 125, 148, 74,  255, 115, 143, 60,  255, 137, 166, 84,  255, 103, 129, 58,  255, 60,  87,  36,  255, 53,
    77,  43,  255, 63,  89,  49,  255, 79,  102, 44,  255, 79,  95,  38,  255, 181, 196, 119, 255, 178, 199, 143, 255, 153, 173, 91,  255, 150, 181,
    68,  255, 131, 159, 84,  255, 91,  115, 71,  255, 31,  39,  21,  255, 31,  43,  26,  255, 34,  47,  25,  255, 38,  55,  26,  255, 65,  97,  34,
    255, 93,  123, 68,  255, 53,  81,  42,  255, 49,  75,  36,  255, 105, 136, 62,  255, 102, 125, 58,  255, 29,  37,  21,  255, 26,  32,  25,  255,
    65,  84,  42,  255, 71,  106, 33,  255, 82,  119, 36,  255, 78,  101, 36,  255, 99,  111, 56,  255, 117, 139, 67,  255, 106, 135, 62,  255, 107,
    131, 60,  255, 176, 172, 119, 255, 199, 195, 140, 255, 159, 155, 109, 255, 33,  44,  21,  255, 173, 186, 127, 255, 191, 214, 161, 255, 167, 196,
    148, 255, 165, 194, 142, 255, 167, 194, 143, 255, 184, 205, 140, 255, 212, 220, 136, 255, 241, 245, 156, 255, 216, 224, 124, 255, 209, 219, 118,
    255, 220, 229, 130, 255, 203, 208, 117, 255, 149, 169, 104, 255, 134, 156, 87,  255, 99,  126, 58,  255, 75,  95,  38,  255, 99,  114, 56,  255,
    110, 121, 50,  255, 45,  67,  19,  255, 53,  84,  34,  255, 69,  95,  41,  255, 73,  100, 36,  255, 96,  132, 52,  255, 142, 171, 87,  255, 219,
    219, 115, 255, 218, 217, 106, 255, 210, 212, 111, 255, 206, 214, 94,  255, 178, 195, 65,  255, 163, 185, 76,  255, 162, 177, 95,  255, 170, 189,
    101, 255, 182, 204, 114, 255, 162, 176, 90,  255, 73,  95,  42,  255, 68,  97,  62,  255, 55,  77,  37,  255, 26,  46,  17,  255, 80,  99,  55,
    255, 159, 185, 117, 255, 160, 191, 96,  255, 99,  108, 46,  255, 74,  86,  44,  255, 216, 228, 162, 255, 192, 214, 168, 255, 171, 204, 163, 255,
    180, 215, 168, 255, 201, 213, 148, 255, 86,  92,  33,  255, 25,  31,  19,  255, 21,  26,  21,  255, 43,  67,  28,  255, 107, 144, 55,  255, 177,
    197, 89,  255, 159, 179, 83,  255, 106, 140, 73,  255, 96,  132, 65,  255, 91,  127, 63,  255, 78,  116, 53,  255, 72,  109, 43,  255, 81,  117,
    42,  255, 92,  120, 49,  255, 129, 157, 65,  255, 154, 179, 76,  255, 118, 154, 72,  255, 112, 150, 65,  255, 111, 152, 55,  255, 137, 169, 62,
    255, 137, 155, 62,  255, 127, 132, 58,  255, 56,  73,  29,  255, 128, 156, 81,  255, 129, 150, 99,  255, 142, 165, 106, 255, 137, 156, 107, 255,
    137, 163, 111, 255, 200, 210, 126, 255, 154, 154, 68,  255, 62,  92,  42,  255, 73,  105, 52,  255, 97,  125, 53,  255, 62,  84,  29,  255, 90,
    121, 62,  255, 114, 134, 75,  255, 78,  93,  41,  255, 43,  58,  23,  255, 112, 137, 53,  255, 103, 135, 52,  255, 95,  123, 62,  255, 132, 154,
    72,  255, 137, 157, 102, 255, 176, 189, 148, 255, 195, 203, 137, 255, 149, 170, 131, 255, 116, 137, 114, 255, 76,  93,  56,  255, 95,  104, 53,
    255, 143, 162, 72,  255, 149, 184, 87,  255, 163, 189, 115, 255, 137, 176, 76,  255, 144, 169, 86,  255, 165, 192, 132, 255, 153, 185, 133, 255,
    165, 193, 136, 255, 166, 185, 110, 255, 72,  87,  28,  255, 149, 168, 68,  255, 143, 175, 60,  255, 125, 160, 55,  255, 96,  133, 48,  255, 82,
    104, 42,  255, 103, 127, 63,  255, 118, 151, 77,  255, 55,  79,  40,  255, 40,  60,  25,  255, 42,  68,  25,  255, 40,  65,  23,  255, 60,  86,
    31,  255, 80,  108, 42,  255, 60,  89,  36,  255, 58,  83,  36,  255, 77,  108, 49,  255, 65,  103, 39,  255, 43,  68,  28,  255, 42,  65,  26,
    255, 47,  75,  28,  255, 55,  81,  33,  255, 55,  77,  36,  255, 52,  68,  41,  255, 37,  52,  38,  255, 80,  80,  44,  255, 238, 232, 136, 255,
    207, 227, 130, 255, 183, 209, 134, 255, 172, 199, 139, 255, 176, 199, 111, 255, 215, 230, 148, 255, 159, 169, 90,  255, 84,  107, 42,  255, 95,
    130, 50,  255, 114, 143, 81,  255, 90,  123, 69,  255, 107, 138, 71,  255, 136, 165, 71,  255, 131, 163, 69,  255, 124, 156, 65,  255, 100, 135,
    48,  255, 75,  91,  40,  255, 188, 198, 120, 255, 179, 199, 98,  255, 148, 180, 78,  255, 141, 174, 72,  255, 140, 174, 65,  255, 135, 171, 60,
    255, 123, 158, 60,  255, 140, 169, 74,  255, 150, 178, 76,  255, 121, 139, 53,  255, 144, 154, 58,  255, 171, 189, 77,  255, 145, 178, 84,  255,
    134, 172, 84,  255, 130, 168, 86,  255, 133, 170, 93,  255, 131, 169, 98,  255, 127, 167, 98,  255, 119, 158, 89,  255, 126, 160, 89,  255, 143,
    156, 76,  255, 175, 187, 121, 255, 136, 161, 132, 255, 129, 157, 127, 255, 121, 153, 123, 255, 166, 179, 125, 255, 228, 219, 129, 255, 125, 136,
    67,  255, 101, 121, 52,  255, 107, 130, 60,  255, 87,  101, 45,  255, 117, 125, 69,  255, 167, 190, 109, 255, 144, 175, 108, 255, 113, 146, 108,
    255, 129, 157, 110, 255, 145, 176, 105, 255, 129, 161, 92,  255, 95,  120, 53,  255, 184, 204, 111, 255, 157, 197, 118, 255, 148, 184, 105, 255,
    140, 173, 104, 255, 171, 190, 113, 255, 108, 136, 81,  255, 102, 135, 96,  255, 105, 137, 98,  255, 103, 134, 100, 255, 102, 134, 100, 255, 155,
    177, 102, 255, 129, 145, 74,  255, 36,  55,  32,  255, 90,  115, 60,  255, 112, 138, 62,  255, 141, 175, 97,  255, 143, 171, 97,  255, 128, 155,
    84,  255, 112, 140, 76,  255, 90,  120, 63,  255, 79,  118, 62,  255, 103, 141, 73,  255, 154, 185, 90,  255, 139, 163, 68,  255, 119, 141, 77,
    255, 132, 161, 93,  255, 124, 162, 94,  255, 99,  138, 74,  255, 90,  127, 55,  255, 119, 152, 71,  255, 148, 176, 84,  255, 122, 148, 91,  255,
    132, 161, 98,  255, 98,  125, 62,  255, 60,  86,  47,  255, 67,  92,  55,  255, 74,  100, 42,  255, 126, 146, 75,  255, 188, 213, 166, 255, 171,
    194, 139, 255, 152, 183, 68,  255, 156, 192, 81,  255, 119, 145, 90,  255, 110, 140, 90,  255, 65,  77,  39,  255, 26,  37,  21,  255, 23,  33,
    21,  255, 32,  44,  23,  255, 65,  92,  31,  255, 122, 152, 75,  255, 82,  112, 68,  255, 62,  92,  56,  255, 78,  112, 55,  255, 106, 137, 68,
    255, 45,  58,  31,  255, 38,  49,  33,  255, 50,  68,  29,  255, 55,  90,  25,  255, 58,  96,  25,  255, 48,  79,  23,  255, 41,  62,  21,  255,
    41,  56,  23,  255, 63,  92,  26,  255, 105, 119, 58,  255, 185, 180, 131, 255, 193, 191, 133, 255, 168, 163, 113, 255, 34,  40,  23,  255, 74,
    97,  58,  255, 197, 209, 146, 255, 186, 210, 152, 255, 167, 196, 141, 255, 164, 192, 143, 255, 161, 189, 136, 255, 174, 198, 134, 255, 239, 243,
    160, 255, 236, 239, 148, 255, 209, 219, 114, 255, 214, 225, 128, 255, 231, 235, 139, 255, 198, 211, 136, 255, 170, 189, 137, 255, 98,  119, 60,
    255, 39,  58,  21,  255, 33,  49,  21,  255, 42,  62,  29,  255, 58,  90,  36,  255, 73,  106, 43,  255, 85,  115, 52,  255, 88,  114, 52,  255,
    84,  114, 44,  255, 162, 180, 94,  255, 232, 228, 126, 255, 220, 219, 104, 255, 207, 210, 105, 255, 188, 199, 103, 255, 198, 209, 97,  255, 171,
    190, 71,  255, 167, 182, 91,  255, 189, 202, 131, 255, 206, 220, 140, 255, 148, 159, 87,  255, 93,  115, 56,  255, 82,  105, 53,  255, 47,  69,
    26,  255, 31,  52,  26,  255, 32,  49,  25,  255, 44,  62,  31,  255, 117, 136, 75,  255, 49,  55,  25,  255, 92,  109, 67,  255, 203, 223, 163,
    255, 173, 204, 162, 255, 182, 215, 162, 255, 215, 228, 160, 255, 101, 101, 50,  255, 42,  72,  26,  255, 94,  115, 53,  255, 108, 127, 62,  255,
    110, 138, 62,  255, 162, 187, 84,  255, 177, 194, 94,  255, 129, 158, 84,  255, 116, 148, 80,  255, 103, 141, 75,  255, 106, 142, 76,  255, 101,
    138, 68,  255, 90,  128, 55,  255, 76,  113, 44,  255, 84,  121, 43,  255, 174, 199, 104, 255, 168, 195, 103, 255, 150, 180, 92,  255, 127, 160,
    79,  255, 115, 160, 68,  255, 167, 195, 82,  255, 104, 122, 47,  255, 138, 156, 65,  255, 122, 137, 49,  255, 129, 150, 78,  255, 131, 157, 106,
    255, 152, 171, 114, 255, 127, 150, 110, 255, 144, 171, 119, 255, 201, 204, 120, 255, 120, 136, 49,  255, 69,  102, 40,  255, 66,  96,  49,  255,
    87,  118, 52,  255, 78,  102, 39,  255, 95,  111, 52,  255, 87,  97,  33,  255, 62,  84,  36,  255, 110, 133, 68,  255, 140, 165, 74,  255, 128,
    155, 65,  255, 112, 139, 85,  255, 130, 154, 84,  255, 150, 164, 89,  255, 185, 194, 134, 255, 182, 205, 119, 255, 153, 185, 87,  255, 82,  107,
    39,  255, 12,  26,  15,  255, 12,  23,  17,  255, 55,  68,  31,  255, 105, 137, 58,  255, 103, 131, 62,  255, 125, 153, 76,  255, 126, 146, 80,
    255, 169, 193, 135, 255, 156, 186, 140, 255, 172, 199, 137, 255, 153, 169, 98,  255, 149, 153, 74,  255, 193, 209, 94,  255, 165, 188, 68,  255,
    134, 167, 60,  255, 122, 156, 60,  255, 101, 133, 55,  255, 104, 124, 58,  255, 125, 151, 81,  255, 103, 132, 63,  255, 36,  62,  21,  255, 40,
    63,  26,  255, 78,  101, 39,  255, 100, 134, 44,  255, 76,  107, 36,  255, 63,  94,  33,  255, 53,  86,  26,  255, 78,  107, 47,  255, 58,  86,
    39,  255, 43,  65,  29,  255, 39,  58,  26,  255, 37,  51,  25,  255, 53,  76,  33,  255, 49,  76,  36,  255, 46,  71,  37,  255, 52,  67,  43,
    255, 122, 125, 76,  255, 161, 168, 86,  255, 195, 203, 98,  255, 210, 224, 127, 255, 180, 203, 133, 255, 171, 189, 117, 255, 199, 217, 155, 255,
    182, 195, 131, 255, 125, 145, 55,  255, 92,  128, 55,  255, 166, 179, 113, 255, 193, 211, 154, 255, 198, 208, 143, 255, 175, 194, 127, 255, 101,
    140, 82,  255, 90,  129, 63,  255, 115, 146, 72,  255, 131, 157, 73,  255, 155, 176, 81,  255, 166, 193, 87,  255, 150, 181, 73,  255, 136, 172,
    56,  255, 126, 164, 58,  255, 105, 141, 68,  255, 110, 146, 83,  255, 124, 161, 87,  255, 140, 172, 84,  255, 135, 166, 74,  255, 50,  69,  28,
    255, 47,  55,  26,  255, 90,  100, 49,  255, 141, 156, 75,  255, 155, 178, 90,  255, 150, 177, 90,  255, 152, 181, 89,  255, 141, 171, 87,  255,
    130, 162, 76,  255, 119, 148, 74,  255, 126, 144, 74,  255, 163, 173, 102, 255, 140, 164, 131, 255, 133, 162, 136, 255, 129, 159, 129, 255, 143,
    168, 128, 255, 218, 215, 137, 255, 171, 171, 104, 255, 55,  74,  32,  255, 58,  81,  31,  255, 47,  69,  25,  255, 33,  48,  21,  255, 73,  83,
    44,  255, 136, 156, 83,  255, 151, 179, 107, 255, 123, 155, 107, 255, 148, 176, 115, 255, 123, 150, 95,  255, 72,  100, 52,  255, 118, 139, 82,
    255, 181, 204, 126, 255, 165, 198, 127, 255, 165, 194, 113, 255, 147, 174, 82,  255, 136, 167, 75,  255, 147, 175, 92,  255, 133, 161, 97,  255,
    104, 134, 99,  255, 127, 155, 103, 255, 176, 194, 108, 255, 132, 158, 74,  255, 97,  128, 55,  255, 136, 164, 77,  255, 144, 173, 86,  255, 136,
    167, 76,  255, 104, 142, 75,  255, 67,  106, 62,  255, 71,  110, 55,  255, 74,  114, 52,  255, 75,  115, 56,  255, 83,  122, 63,  255, 118, 156,
    76,  255, 175, 202, 89,  255, 115, 130, 55,  255, 29,  31,  19,  255, 97,  109, 56,  255, 151, 180, 83,  255, 135, 167, 86,  255, 121, 154, 94,
    255, 119, 149, 89,  255, 101, 133, 79,  255, 112, 138, 89,  255, 124, 152, 104, 255, 80,  105, 65,  255, 74,  99,  53,  255, 60,  81,  29,  255,
    143, 169, 113, 255, 175, 203, 159, 255, 142, 159, 86,  255, 160, 190, 75,  255, 154, 184, 86,  255, 97,  126, 90,  255, 123, 154, 102, 255, 99,
    119, 62,  255, 25,  34,  17,  255, 26,  38,  21,  255, 33,  47,  25,  255, 32,  51,  25,  255, 111, 139, 68,  255, 119, 150, 82,  255, 76,  110,
    69,  255, 78,  109, 73,  255, 102, 134, 77,  255, 72,  92,  43,  255, 53,  77,  34,  255, 52,  80,  25,  255, 36,  53,  23,  255, 60,  86,  36,
    255, 130, 160, 84,  255, 114, 142, 68,  255, 99,  120, 53,  255, 108, 118, 45,  255, 148, 148, 98,  255, 198, 194, 145, 255, 190, 187, 124, 255,
    168, 166, 111, 255, 47,  57,  31,  255, 34,  53,  33,  255, 98,  119, 74,  255, 195, 209, 135, 255, 184, 207, 146, 255, 164, 193, 133, 255, 162,
    191, 136, 255, 155, 185, 130, 255, 205, 216, 148, 255, 251, 249, 162, 255, 220, 227, 124, 255, 214, 223, 123, 255, 230, 236, 151, 255, 231, 233,
    142, 255, 186, 202, 105, 255, 181, 197, 117, 255, 134, 144, 76,  255, 56,  65,  31,  255, 53,  76,  36,  255, 56,  81,  38,  255, 65,  91,  47,
    255, 81,  108, 52,  255, 87,  115, 50,  255, 91,  112, 48,  255, 176, 185, 95,  255, 236, 229, 118, 255, 222, 219, 98,  255, 214, 217, 113, 255,
    209, 215, 121, 255, 216, 220, 105, 255, 196, 208, 91,  255, 179, 197, 92,  255, 211, 222, 163, 255, 216, 224, 157, 255, 210, 226, 157, 255, 188,
    208, 137, 255, 181, 201, 114, 255, 157, 178, 92,  255, 108, 128, 58,  255, 68,  90,  36,  255, 47,  65,  31,  255, 49,  63,  34,  255, 50,  58,
    29,  255, 121, 144, 97,  255, 179, 209, 159, 255, 172, 207, 161, 255, 208, 221, 143, 255, 111, 111, 52,  255, 60,  83,  39,  255, 134, 157, 80,
    255, 154, 177, 92,  255, 131, 162, 89,  255, 130, 166, 93,  255, 163, 184, 96,  255, 142, 168, 92,  255, 128, 161, 93,  255, 130, 162, 87,  255,
    141, 172, 82,  255, 148, 176, 75,  255, 149, 177, 74,  255, 129, 160, 60,  255, 80,  117, 37,  255, 120, 152, 63,  255, 213, 230, 134, 255, 184,
    204, 115, 255, 147, 178, 96,  255, 129, 168, 86,  255, 154, 192, 92,  255, 183, 203, 90,  255, 118, 136, 60,  255, 114, 138, 65,  255, 135, 154,
    62,  255, 131, 152, 77,  255, 139, 165, 107, 255, 138, 159, 114, 255, 130, 158, 113, 255, 191, 206, 127, 255, 156, 152, 68,  255, 79,  114, 37,
    255, 82,  114, 41,  255, 62,  92,  47,  255, 79,  109, 52,  255, 93,  118, 47,  255, 102, 122, 47,  255, 97,  130, 45,  255, 122, 151, 65,  255,
    122, 147, 67,  255, 129, 155, 63,  255, 142, 167, 75,  255, 118, 146, 89,  255, 136, 156, 94,  255, 179, 195, 89,  255, 157, 191, 75,  255, 130,
    173, 58,  255, 123, 165, 55,  255, 150, 181, 60,  255, 47,  68,  23,  255, 19,  31,  21,  255, 48,  58,  31,  255, 92,  126, 52,  255, 75,  113,
    52,  255, 79,  105, 62,  255, 134, 145, 83,  255, 165, 192, 132, 255, 152, 183, 140, 255, 164, 194, 139, 255, 156, 162, 95,  255, 196, 196, 94,
    255, 182, 200, 87,  255, 139, 167, 75,  255, 106, 144, 71,  255, 100, 139, 63,  255, 105, 139, 62,  255, 139, 162, 65,  255, 126, 146, 68,  255,
    111, 142, 73,  255, 52,  80,  34,  255, 79,  106, 52,  255, 106, 139, 50,  255, 111, 148, 53,  255, 123, 155, 63,  255, 140, 165, 76,  255, 117,
    143, 74,  255, 55,  87,  32,  255, 40,  62,  26,  255, 32,  44,  23,  255, 28,  34,  23,  255, 29,  38,  23,  255, 47,  62,  31,  255, 65,  95,
    43,  255, 51,  77,  39,  255, 47,  71,  39,  255, 52,  75,  39,  255, 52,  73,  34,  255, 111, 121, 55,  255, 222, 221, 131, 255, 213, 229, 150,
    255, 168, 197, 140, 255, 155, 176, 127, 255, 194, 205, 150, 255, 158, 172, 62,  255, 109, 144, 58,  255, 109, 135, 65,  255, 195, 213, 140, 255,
    204, 225, 147, 255, 220, 231, 130, 255, 176, 197, 111, 255, 114, 144, 74,  255, 182, 204, 103, 255, 133, 163, 75,  255, 180, 198, 105, 255, 179,
    202, 98,  255, 150, 174, 71,  255, 123, 158, 65,  255, 99,  138, 69,  255, 101, 139, 81,  255, 105, 140, 89,  255, 103, 138, 82,  255, 107, 142,
    74,  255, 146, 180, 83,  255, 84,  107, 50,  255, 15,  23,  23,  255, 26,  40,  25,  255, 47,  62,  32,  255, 60,  79,  38,  255, 122, 142, 65,
    255, 151, 177, 98,  255, 120, 154, 99,  255, 106, 143, 93,  255, 120, 149, 93,  255, 128, 146, 75,  255, 138, 153, 83,  255, 159, 181, 135, 255,
    137, 167, 139, 255, 139, 167, 139, 255, 142, 168, 134, 255, 149, 172, 127, 255, 186, 191, 126, 255, 93,  113, 47,  255, 62,  96,  26,  255, 72,
    98,  41,  255, 83,  107, 55,  255, 89,  111, 65,  255, 53,  73,  31,  255, 99,  121, 55,  255, 137, 167, 90,  255, 154, 183, 115, 255, 118, 145,
    84,  255, 73,  104, 55,  255, 78,  110, 74,  255, 147, 167, 104, 255, 195, 219, 151, 255, 174, 195, 117, 255, 103, 139, 74,  255, 109, 146, 84,
    255, 156, 183, 98,  255, 184, 203, 104, 255, 169, 187, 106, 255, 134, 159, 99,  255, 159, 180, 95,  255, 103, 130, 60,  255, 100, 131, 55,  255,
    89,  123, 47,  255, 158, 185, 109, 255, 164, 191, 106, 255, 141, 176, 86,  255, 97,  134, 77,  255, 75,  116, 60,  255, 84,  126, 55,  255, 98,
    140, 63,  255, 114, 152, 92,  255, 124, 161, 105, 255, 139, 173, 107, 255, 169, 189, 106, 255, 37,  44,  25,  255, 23,  33,  21,  255, 88,  110,
    50,  255, 117, 146, 76,  255, 108, 144, 89,  255, 103, 140, 87,  255, 170, 194, 98,  255, 162, 185, 92,  255, 145, 165, 89,  255, 102, 126, 78,
    255, 81,  105, 55,  255, 102, 124, 63,  255, 165, 198, 163, 255, 169, 194, 137, 255, 188, 205, 118, 255, 193, 218, 111, 255, 147, 168, 99,  255,
    91,  122, 89,  255, 124, 156, 101, 255, 122, 144, 87,  255, 23,  31,  19,  255, 32,  42,  23,  255, 37,  55,  25,  255, 29,  47,  25,  255, 65,
    90,  41,  255, 140, 168, 83,  255, 104, 134, 74,  255, 83,  115, 76,  255, 84,  115, 76,  255, 78,  106, 53,  255, 74,  102, 46,  255, 62,  87,
    36,  255, 74,  108, 41,  255, 63,  92,  31,  255, 153, 179, 93,  255, 156, 187, 97,  255, 145, 180, 87,  255, 125, 153, 60,  255, 165, 166, 108,
    255, 217, 199, 136, 255, 193, 185, 120, 255, 157, 159, 98,  255, 74,  92,  53,  255, 79,  96,  55,  255, 60,  84,  33,  255, 69,  84,  36,  255,
    189, 198, 126, 255, 203, 222, 150, 255, 172, 198, 140, 255, 158, 188, 130, 255, 170, 195, 135, 255, 238, 241, 163, 255, 234, 238, 143, 255, 214,
    222, 117, 255, 218, 225, 129, 255, 225, 229, 136, 255, 202, 213, 99,  255, 204, 219, 113, 255, 219, 230, 137, 255, 177, 185, 106, 255, 69,  86,
    31,  255, 60,  89,  38,  255, 68,  92,  47,  255, 75,  103, 52,  255, 84,  111, 50,  255, 80,  111, 36,  255, 167, 184, 91,  255, 235, 228, 119,
    255, 224, 221, 109, 255, 223, 224, 122, 255, 219, 223, 124, 255, 205, 216, 93,  255, 197, 210, 101, 255, 164, 178, 68,  255, 137, 147, 75,  255,
    74,  72,  39,  255, 171, 181, 116, 255, 219, 236, 165, 255, 191, 216, 145, 255, 180, 210, 134, 255, 184, 215, 130, 255, 170, 192, 110, 255, 85,
    102, 44,  255, 26,  41,  21,  255, 95,  109, 65,  255, 161, 187, 128, 255, 172, 204, 153, 255, 194, 208, 134, 255, 98,  107, 52,  255, 57,  83,
    43,  255, 143, 166, 93,  255, 133, 159, 94,  255, 118, 153, 93,  255, 118, 154, 92,  255, 146, 179, 84,  255, 139, 161, 47,  255, 160, 184, 91,
    255, 198, 217, 129, 255, 204, 221, 127, 255, 208, 220, 115, 255, 178, 193, 74,  255, 161, 178, 67,  255, 118, 133, 47,  255, 52,  71,  23,  255,
    63,  87,  37,  255, 208, 225, 125, 255, 180, 201, 130, 255, 151, 184, 114, 255, 158, 195, 105, 255, 191, 211, 113, 255, 146, 167, 100, 255, 133,
    161, 84,  255, 125, 147, 73,  255, 120, 140, 65,  255, 126, 148, 68,  255, 128, 158, 95,  255, 132, 160, 115, 255, 183, 197, 118, 255, 180, 181,
    81,  255, 85,  107, 33,  255, 69,  105, 34,  255, 81,  117, 40,  255, 60,  91,  41,  255, 72,  102, 52,  255, 123, 146, 62,  255, 144, 171, 55,
    255, 148, 177, 55,  255, 152, 176, 56,  255, 152, 176, 58,  255, 142, 163, 62,  255, 136, 161, 75,  255, 134, 155, 89,  255, 181, 200, 89,  255,
    140, 181, 60,  255, 116, 160, 55,  255, 123, 161, 55,  255, 134, 165, 72,  255, 170, 197, 120, 255, 67,  90,  34,  255, 15,  26,  12,  255, 37,
    44,  23,  255, 101, 124, 56,  255, 97,  129, 65,  255, 69,  99,  62,  255, 103, 116, 68,  255, 160, 183, 123, 255, 148, 182, 143, 255, 155, 184,
    128, 255, 143, 149, 69,  255, 197, 204, 109, 255, 134, 162, 87,  255, 121, 154, 84,  255, 121, 153, 83,  255, 112, 148, 74,  255, 115, 147, 71,
    255, 167, 183, 78,  255, 136, 148, 65,  255, 117, 144, 72,  255, 74,  110, 53,  255, 84,  113, 52,  255, 106, 140, 52,  255, 112, 145, 56,  255,
    138, 164, 71,  255, 161, 181, 92,  255, 188, 200, 137, 255, 148, 173, 110, 255, 99,  135, 69,  255, 75,  108, 58,  255, 40,  60,  33,  255, 41,
    63,  26,  255, 37,  58,  26,  255, 65,  87,  42,  255, 63,  92,  47,  255, 71,  92,  44,  255, 108, 134, 50,  255, 97,  131, 48,  255, 75,  113,
    42,  255, 73,  100, 39,  255, 164, 165, 83,  255, 210, 222, 131, 255, 161, 185, 112, 255, 162, 181, 127, 255, 138, 154, 67,  255, 169, 183, 62,
    255, 148, 165, 53,  255, 188, 193, 96,  255, 209, 227, 148, 255, 185, 213, 110, 255, 198, 220, 95,  255, 179, 201, 106, 255, 161, 189, 97,  255,
    133, 160, 86,  255, 211, 224, 125, 255, 133, 154, 69,  255, 62,  76,  31,  255, 132, 164, 93,  255, 113, 151, 95,  255, 109, 147, 87,  255, 100,
    138, 82,  255, 89,  125, 74,  255, 83,  119, 63,  255, 114, 147, 68,  255, 125, 156, 63,  255, 81,  105, 41,  255, 75,  96,  33,  255, 49,  65,
    31,  255, 50,  77,  21,  255, 130, 156, 71,  255, 125, 163, 102, 255, 111, 152, 100, 255, 112, 150, 92,  255, 136, 161, 87,  255, 190, 200, 110,
    255, 123, 140, 72,  255, 159, 180, 137, 255, 149, 176, 148, 255, 145, 171, 145, 255, 140, 169, 143, 255, 131, 164, 133, 255, 188, 195, 132, 255,
    119, 134, 58,  255, 82,  110, 33,  255, 169, 188, 121, 255, 180, 203, 139, 255, 164, 189, 113, 255, 140, 162, 84,  255, 50,  77,  25,  255, 69,
    92,  29,  255, 120, 145, 69,  255, 96,  126, 53,  255, 78,  111, 55,  255, 104, 143, 72,  255, 112, 147, 84,  255, 148, 171, 118, 255, 124, 153,
    99,  255, 100, 139, 89,  255, 113, 151, 97,  255, 136, 169, 106, 255, 150, 178, 111, 255, 174, 194, 116, 255, 192, 207, 115, 255, 144, 167, 81,
    255, 75,  105, 47,  255, 69,  102, 47,  255, 57,  87,  39,  255, 138, 159, 89,  255, 205, 224, 150, 255, 158, 183, 93,  255, 147, 181, 91,  255,
    106, 148, 69,  255, 118, 159, 91,  255, 125, 169, 101, 255, 126, 165, 95,  255, 143, 176, 116, 255, 165, 196, 125, 255, 175, 189, 109, 255, 47,
    63,  23,  255, 45,  63,  28,  255, 63,  94,  38,  255, 75,  104, 49,  255, 97,  120, 58,  255, 164, 185, 95,  255, 173, 195, 123, 255, 160, 186,
    110, 255, 133, 169, 75,  255, 131, 160, 71,  255, 202, 208, 125, 255, 207, 221, 110, 255, 186, 210, 146, 255, 172, 195, 124, 255, 160, 184, 91,
    255, 138, 170, 82,  255, 102, 133, 91,  255, 120, 150, 105, 255, 154, 179, 114, 255, 152, 169, 103, 255, 38,  46,  26,  255, 23,  34,  19,  255,
    38,  62,  26,  255, 36,  60,  26,  255, 34,  58,  23,  255, 93,  118, 50,  255, 140, 169, 78,  255, 99,  130, 78,  255, 87,  116, 79,  255, 86,
    112, 55,  255, 87,  117, 67,  255, 58,  83,  42,  255, 58,  78,  33,  255, 33,  44,  21,  255, 124, 145, 75,  255, 171, 198, 103, 255, 145, 175,
    82,  255, 118, 158, 55,  255, 160, 178, 93,  255, 232, 215, 144, 255, 210, 202, 129, 255, 159, 174, 97,  255, 164, 190, 92,  255, 166, 187, 84,
    255, 127, 155, 52,  255, 86,  112, 49,  255, 90,  105, 62,  255, 159, 165, 93,  255, 204, 214, 130, 255, 177, 199, 130, 255, 168, 194, 124, 255,
    209, 220, 146, 255, 232, 238, 142, 255, 220, 227, 126, 255, 211, 220, 113, 255, 216, 224, 122, 255, 208, 218, 106, 255, 213, 225, 122, 255, 218,
    227, 143, 255, 193, 210, 137, 255, 145, 158, 76,  255, 75,  102, 37,  255, 87,  114, 47,  255, 80,  98,  40,  255, 58,  72,  31,  255, 76,  111,
    42,  255, 151, 175, 84,  255, 238, 230, 123, 255, 230, 226, 121, 255, 229, 228, 125, 255, 225, 228, 140, 255, 201, 211, 98,  255, 180, 198, 89,
    255, 148, 159, 69,  255, 108, 113, 48,  255, 37,  47,  21,  255, 44,  62,  26,  255, 134, 143, 90,  255, 206, 215, 139, 255, 204, 221, 137, 255,
    200, 222, 134, 255, 197, 224, 153, 255, 179, 205, 134, 255, 110, 128, 72,  255, 138, 153, 97,  255, 164, 187, 117, 255, 166, 187, 108, 255, 146,
    161, 77,  255, 120, 141, 78,  255, 120, 147, 80,  255, 124, 156, 97,  255, 114, 152, 95,  255, 120, 158, 95,  255, 139, 171, 94,  255, 165, 188,
    67,  255, 172, 197, 84,  255, 191, 213, 95,  255, 201, 218, 109, 255, 210, 222, 117, 255, 155, 167, 68,  255, 99,  125, 37,  255, 73,  92,  26,
    255, 34,  51,  19,  255, 33,  52,  21,  255, 36,  56,  21,  255, 185, 205, 123, 255, 188, 211, 143, 255, 178, 203, 120, 255, 183, 202, 111, 255,
    148, 170, 115, 255, 136, 165, 121, 255, 129, 159, 96,  255, 122, 148, 73,  255, 112, 134, 67,  255, 110, 136, 55,  255, 117, 148, 84,  255, 157,
    178, 101, 255, 153, 165, 68,  255, 116, 138, 47,  255, 101, 130, 50,  255, 82,  114, 43,  255, 76,  111, 34,  255, 71,  100, 36,  255, 101, 122,
    52,  255, 112, 139, 58,  255, 154, 177, 69,  255, 182, 201, 65,  255, 167, 190, 77,  255, 193, 204, 109, 255, 204, 209, 115, 255, 150, 173, 91,
    255, 122, 149, 81,  255, 156, 184, 82,  255, 130, 170, 62,  255, 114, 152, 52,  255, 183, 191, 98,  255, 239, 236, 165, 255, 203, 217, 165, 255,
    145, 165, 109, 255, 145, 167, 102, 255, 165, 188, 114, 255, 183, 205, 126, 255, 169, 198, 120, 255, 142, 172, 108, 255, 84,  113, 72,  255, 124,
    141, 93,  255, 150, 181, 137, 255, 148, 177, 103, 255, 124, 138, 53,  255, 194, 205, 125, 255, 150, 179, 106, 255, 153, 180, 98,  255, 152, 178,
    94,  255, 179, 193, 87,  255, 199, 204, 81,  255, 197, 202, 81,  255, 197, 208, 103, 255, 203, 217, 113, 255, 128, 157, 77,  255, 69,  104, 43,
    255, 80,  114, 44,  255, 92,  125, 56,  255, 130, 157, 72,  255, 156, 181, 90,  255, 173, 190, 113, 255, 181, 197, 122, 255, 120, 156, 82,  255,
    83,  120, 58,  255, 46,  71,  32,  255, 56,  80,  31,  255, 36,  53,  23,  255, 23,  41,  21,  255, 62,  82,  33,  255, 135, 151, 55,  255, 126,
    154, 58,  255, 102, 135, 63,  255, 81,  113, 55,  255, 65,  100, 47,  255, 102, 126, 38,  255, 147, 161, 53,  255, 177, 192, 91,  255, 136, 161,
    81,  255, 120, 146, 56,  255, 144, 162, 60,  255, 185, 188, 103, 255, 209, 221, 140, 255, 208, 221, 153, 255, 205, 224, 158, 255, 176, 204, 114,
    255, 176, 198, 114, 255, 168, 191, 105, 255, 182, 199, 104, 255, 170, 185, 87,  255, 47,  65,  23,  255, 39,  48,  28,  255, 146, 169, 99,  255,
    136, 169, 103, 255, 123, 160, 95,  255, 99,  137, 84,  255, 89,  130, 74,  255, 91,  129, 71,  255, 102, 138, 68,  255, 132, 165, 68,  255, 144,
    175, 52,  255, 161, 184, 69,  255, 157, 179, 74,  255, 123, 149, 60,  255, 138, 165, 82,  255, 127, 163, 96,  255, 125, 157, 80,  255, 110, 138,
    60,  255, 101, 120, 47,  255, 200, 202, 115, 255, 122, 146, 81,  255, 129, 155, 117, 255, 145, 174, 146, 255, 140, 169, 138, 255, 140, 170, 142,
    255, 146, 172, 139, 255, 203, 207, 132, 255, 135, 153, 79,  255, 160, 178, 108, 255, 183, 211, 152, 255, 191, 213, 151, 255, 148, 178, 120, 255,
    150, 181, 114, 255, 117, 136, 80,  255, 41,  55,  19,  255, 95,  120, 45,  255, 90,  117, 50,  255, 123, 155, 68,  255, 118, 162, 74,  255, 120,
    158, 82,  255, 115, 155, 84,  255, 115, 155, 87,  255, 123, 158, 93,  255, 127, 162, 106, 255, 126, 163, 115, 255, 127, 164, 119, 255, 132, 169,
    125, 255, 163, 188, 128, 255, 158, 173, 95,  255, 67,  94,  43,  255, 63,  89,  47,  255, 60,  87,  49,  255, 107, 133, 68,  255, 161, 168, 105,
    255, 55,  55,  33,  255, 77,  87,  47,  255, 105, 131, 56,  255, 144, 171, 91,  255, 156, 183, 126, 255, 164, 187, 116, 255, 166, 183, 105, 255,
    181, 196, 116, 255, 151, 160, 87,  255, 34,  52,  17,  255, 43,  63,  26,  255, 68,  96,  43,  255, 75,  107, 50,  255, 152, 171, 102, 255, 190,
    207, 133, 255, 141, 175, 116, 255, 134, 171, 100, 255, 135, 173, 95,  255, 200, 217, 129, 255, 219, 234, 138, 255, 180, 208, 90,  255, 177, 205,
    81,  255, 152, 184, 84,  255, 120, 147, 82,  255, 124, 150, 84,  255, 149, 180, 101, 255, 188, 211, 126, 255, 200, 219, 133, 255, 207, 224, 140,
    255, 197, 209, 142, 255, 138, 143, 95,  255, 52,  68,  31,  255, 34,  51,  23,  255, 33,  47,  25,  255, 37,  55,  26,  255, 93,  114, 49,  255,
    131, 162, 68,  255, 88,  116, 63,  255, 82,  112, 58,  255, 102, 132, 93,  255, 75,  106, 52,  255, 46,  69,  26,  255, 43,  51,  31,  255, 79,
    89,  52,  255, 173, 200, 100, 255, 155, 182, 84,  255, 127, 161, 62,  255, 157, 176, 93,  255, 233, 220, 141, 255, 229, 217, 137, 255, 194, 203,
    106, 255, 168, 195, 89,  255, 138, 165, 71,  255, 125, 156, 67,  255, 122, 155, 55,  255, 93,  124, 38,  255, 41,  62,  21,  255, 131, 150, 82,
    255, 207, 220, 121, 255, 191, 205, 104, 255, 173, 186, 87,  255, 209, 221, 121, 255, 227, 236, 136, 255, 211, 218, 111, 255, 214, 224, 124, 255,
    217, 228, 132, 255, 217, 230, 135, 255, 224, 233, 149, 255, 187, 206, 144, 255, 184, 196, 118, 255, 52,  55,  19,  255, 32,  38,  21,  255, 26,
    26,  19,  255, 26,  29,  25,  255, 39,  52,  31,  255, 133, 151, 71,  255, 230, 225, 112, 255, 234, 227, 117, 255, 232, 228, 123, 255, 232, 229,
    140, 255, 230, 228, 143, 255, 200, 210, 96,  255, 182, 191, 77,  255, 166, 170, 98,  255, 118, 136, 62,  255, 69,  86,  28,  255, 47,  65,  28,
    255, 164, 174, 101, 255, 194, 194, 111, 255, 150, 166, 80,  255, 168, 181, 109, 255, 179, 195, 111, 255, 183, 201, 110, 255, 176, 188, 112, 255,
    153, 168, 103, 255, 197, 210, 113, 255, 206, 224, 115, 255, 213, 226, 128, 255, 184, 196, 100, 255, 125, 157, 83,  255, 125, 163, 96,  255, 157,
    185, 95,  255, 154, 171, 69,  255, 148, 172, 65,  255, 161, 185, 72,  255, 154, 179, 56,  255, 162, 182, 68,  255, 127, 145, 53,  255, 86,  115,
    32,  255, 90,  122, 36,  255, 60,  81,  25,  255, 32,  47,  21,  255, 33,  52,  21,  255, 29,  48,  19,  255, 155, 175, 111, 255, 193, 210, 111,
    255, 149, 174, 69,  255, 174, 184, 82,  255, 158, 176, 91,  255, 141, 168, 95,  255, 146, 172, 91,  255, 130, 158, 76,  255, 106, 133, 62,  255,
    113, 137, 63,  255, 148, 168, 78,  255, 131, 152, 60,  255, 116, 140, 53,  255, 107, 134, 41,  255, 106, 137, 55,  255, 108, 140, 65,  255, 97,
    126, 49,  255, 98,  124, 47,  255, 116, 145, 65,  255, 116, 147, 63,  255, 112, 144, 55,  255, 161, 181, 68,  255, 178, 198, 109, 255, 194, 205,
    136, 255, 215, 214, 125, 255, 140, 159, 75,  255, 107, 138, 75,  255, 139, 166, 86,  255, 133, 171, 68,  255, 118, 149, 55,  255, 226, 225, 145,
    255, 224, 231, 154, 255, 224, 231, 137, 255, 220, 230, 118, 255, 205, 217, 136, 255, 200, 220, 139, 255, 184, 212, 122, 255, 178, 210, 115, 255,
    181, 211, 115, 255, 169, 200, 107, 255, 144, 164, 84,  255, 136, 155, 98,  255, 132, 163, 103, 255, 134, 156, 73,  255, 173, 181, 93,  255, 165,
    169, 101, 255, 177, 174, 100, 255, 175, 174, 82,  255, 177, 171, 68,  255, 177, 182, 73,  255, 167, 183, 82,  255, 184, 198, 99,  255, 217, 226,
    117, 255, 212, 221, 125, 255, 179, 194, 122, 255, 137, 162, 80,  255, 138, 163, 65,  255, 151, 174, 69,  255, 169, 184, 76,  255, 120, 145, 58,
    255, 96,  125, 50,  255, 56,  74,  36,  255, 45,  65,  26,  255, 63,  89,  37,  255, 62,  82,  38,  255, 58,  68,  40,  255, 87,  102, 65,  255,
    131, 140, 84,  255, 185, 196, 101, 255, 167, 184, 94,  255, 134, 158, 85,  255, 117, 143, 73,  255, 135, 155, 77,  255, 182, 195, 108, 255, 168,
    189, 96,  255, 131, 155, 67,  255, 102, 128, 58,  255, 138, 158, 65,  255, 172, 194, 101, 255, 180, 206, 136, 255, 183, 208, 149, 255, 183, 207,
    156, 255, 187, 209, 151, 255, 185, 207, 126, 255, 196, 211, 128, 255, 223, 233, 171, 255, 206, 218, 140, 255, 80,  94,  52,  255, 23,  44,  19,
    255, 37,  60,  21,  255, 134, 154, 68,  255, 173, 198, 105, 255, 149, 179, 97,  255, 124, 160, 92,  255, 102, 140, 86,  255, 87,  128, 76,  255,
    141, 171, 94,  255, 166, 188, 111, 255, 117, 147, 75,  255, 146, 172, 81,  255, 165, 186, 86,  255, 170, 190, 95,  255, 140, 170, 76,  255, 110,
    141, 55,  255, 76,  109, 37,  255, 73,  104, 31,  255, 52,  68,  26,  255, 167, 164, 92,  255, 162, 181, 102, 255, 110, 133, 87,  255, 146, 175,
    148, 255, 140, 169, 137, 255, 137, 166, 139, 255, 164, 183, 136, 255, 203, 205, 122, 255, 156, 171, 96,  255, 206, 223, 155, 255, 169, 202, 156,
    255, 200, 219, 157, 255, 165, 186, 129, 255, 122, 163, 113, 255, 150, 180, 117, 255, 108, 130, 68,  255, 84,  114, 52,  255, 86,  108, 52,  255,
    88,  107, 55,  255, 142, 165, 74,  255, 167, 197, 86,  255, 163, 195, 80,  255, 138, 173, 74,  255, 126, 165, 80,  255, 117, 159, 89,  255, 118,
    158, 95,  255, 129, 168, 110, 255, 135, 172, 123, 255, 135, 171, 128, 255, 167, 191, 128, 255, 94,  110, 67,  255, 42,  65,  39,  255, 76,  104,
    60,  255, 77,  115, 53,  255, 57,  92,  34,  255, 47,  79,  29,  255, 44,  73,  31,  255, 49,  69,  32,  255, 63,  84,  36,  255, 58,  69,  34,
    255, 60,  68,  40,  255, 63,  79,  43,  255, 39,  47,  28,  255, 48,  55,  33,  255, 42,  58,  31,  255, 45,  65,  31,  255, 56,  79,  38,  255,
    81,  111, 48,  255, 172, 194, 123, 255, 152, 184, 128, 255, 160, 193, 120, 255, 176, 202, 125, 255, 175, 198, 112, 255, 165, 180, 98,  255, 187,
    202, 116, 255, 179, 200, 123, 255, 200, 217, 145, 255, 183, 201, 109, 255, 137, 155, 69,  255, 140, 169, 83,  255, 171, 200, 98,  255, 186, 210,
    99,  255, 191, 216, 106, 255, 194, 219, 121, 255, 206, 225, 141, 255, 222, 235, 158, 255, 141, 142, 99,  255, 17,  21,  12,  255, 29,  37,  23,
    255, 32,  43,  26,  255, 29,  40,  23,  255, 76,  97,  36,  255, 75,  103, 34,  255, 105, 136, 80,  255, 130, 159, 105, 255, 104, 136, 58,  255,
    84,  115, 33,  255, 56,  68,  31,  255, 53,  53,  48,  255, 101, 117, 58,  255, 159, 183, 89,  255, 183, 204, 131, 255, 191, 200, 121, 255, 224,
    217, 140, 255, 217, 216, 124, 255, 150, 181, 65,  255, 164, 187, 91,  255, 110, 128, 47,  255, 125, 152, 62,  255, 120, 160, 63,  255, 109, 153,
    48,  255, 100, 139, 43,  255, 142, 167, 84,  255, 192, 211, 126, 255, 169, 187, 95,  255, 164, 186, 98,  255, 173, 192, 96,  255, 229, 238, 137,
    255, 214, 221, 111, 255, 212, 220, 115, 255, 214, 224, 124, 255, 207, 218, 134, 255, 227, 236, 148, 255, 193, 207, 149, 255, 197, 214, 151, 255,
    146, 150, 96,  255, 85,  87,  62,  255, 49,  52,  38,  255, 31,  38,  34,  255, 42,  46,  44,  255, 110, 124, 80,  255, 208, 213, 121, 255, 238,
    232, 130, 255, 235, 228, 123, 255, 225, 221, 112, 255, 218, 219, 120, 255, 219, 216, 121, 255, 213, 215, 115, 255, 238, 232, 135, 255, 153, 160,
    60,  255, 131, 147, 65,  255, 199, 202, 124, 255, 241, 233, 141, 255, 221, 213, 124, 255, 103, 126, 55,  255, 75,  108, 32,  255, 89,  114, 31,
    255, 167, 186, 100, 255, 183, 191, 128, 255, 142, 149, 101, 255, 211, 220, 132, 255, 214, 234, 126, 255, 224, 233, 139, 255, 221, 233, 151, 255,
    169, 194, 100, 255, 163, 185, 84,  255, 175, 187, 69,  255, 178, 195, 67,  255, 189, 204, 78,  255, 137, 155, 53,  255, 108, 135, 40,  255, 94,
    122, 33,  255, 86,  117, 32,  255, 95,  123, 36,  255, 96,  121, 36,  255, 58,  84,  23,  255, 47,  75,  26,  255, 42,  65,  26,  255, 38,  58,
    23,  255, 50,  68,  29,  255, 73,  101, 36,  255, 118, 159, 65,  255, 126, 157, 69,  255, 175, 181, 89,  255, 199, 202, 101, 255, 187, 197, 100,
    255, 155, 177, 98,  255, 163, 181, 89,  255, 147, 155, 83,  255, 132, 149, 72,  255, 115, 142, 48,  255, 124, 149, 56,  255, 107, 136, 41,  255,
    101, 133, 47,  255, 104, 134, 55,  255, 102, 128, 49,  255, 101, 123, 47,  255, 108, 130, 58,  255, 118, 141, 62,  255, 125, 152, 73,  255, 135,
    160, 105, 255, 154, 178, 158, 255, 200, 207, 153, 255, 200, 203, 119, 255, 119, 148, 74,  255, 106, 138, 74,  255, 118, 145, 71,  255, 138, 168,
    73,  255, 106, 145, 55,  255, 121, 156, 62,  255, 147, 177, 112, 255, 182, 205, 165, 255, 170, 190, 98,  255, 123, 142, 60,  255, 123, 134, 65,
    255, 147, 159, 84,  255, 156, 164, 90,  255, 152, 165, 76,  255, 125, 132, 52,  255, 165, 176, 84,  255, 150, 158, 104, 255, 132, 158, 113, 255,
    125, 157, 96,  255, 131, 160, 83,  255, 77,  100, 45,  255, 28,  41,  19,  255, 31,  39,  21,  255, 23,  31,  17,  255, 53,  63,  29,  255, 154,
    165, 74,  255, 190, 205, 106, 255, 198, 209, 117, 255, 199, 210, 120, 255, 203, 213, 108, 255, 193, 205, 105, 255, 146, 164, 60,  255, 121, 140,
    48,  255, 77,  102, 33,  255, 53,  87,  25,  255, 33,  52,  19,  255, 21,  19,  21,  255, 41,  52,  21,  255, 136, 149, 91,  255, 181, 201, 147,
    255, 178, 201, 143, 255, 186, 210, 149, 255, 180, 207, 147, 255, 179, 203, 142, 255, 174, 197, 132, 255, 200, 209, 126, 255, 215, 217, 123, 255,
    225, 229, 149, 255, 196, 218, 159, 255, 175, 205, 137, 255, 165, 196, 108, 255, 169, 191, 102, 255, 146, 163, 69,  255, 206, 211, 116, 255, 189,
    211, 131, 255, 174, 199, 127, 255, 169, 197, 134, 255, 170, 196, 141, 255, 205, 218, 113, 255, 193, 209, 94,  255, 214, 226, 161, 255, 212, 228,
    182, 255, 220, 228, 175, 255, 168, 177, 124, 255, 94,  118, 67,  255, 73,  103, 34,  255, 148, 168, 78,  255, 180, 200, 96,  255, 174, 197, 98,
    255, 131, 164, 86,  255, 138, 164, 103, 255, 182, 202, 107, 255, 140, 166, 101, 255, 93,  127, 87,  255, 139, 167, 84,  255, 156, 181, 74,  255,
    167, 188, 92,  255, 170, 191, 90,  255, 149, 173, 73,  255, 84,  122, 38,  255, 73,  102, 36,  255, 29,  42,  23,  255, 96,  97,  52,  255, 202,
    211, 117, 255, 116, 136, 72,  255, 137, 163, 132, 255, 140, 170, 136, 255, 126, 158, 123, 255, 167, 183, 122, 255, 187, 192, 108, 255, 181, 192,
    122, 255, 188, 214, 161, 255, 169, 199, 133, 255, 220, 233, 162, 255, 182, 200, 132, 255, 134, 170, 118, 255, 146, 178, 119, 255, 169, 191, 114,
    255, 86,  119, 53,  255, 60,  89,  47,  255, 49,  71,  50,  255, 55,  74,  43,  255, 92,  114, 47,  255, 139, 160, 62,  255, 171, 187, 74,  255,
    185, 200, 81,  255, 182, 202, 95,  255, 157, 186, 95,  255, 150, 183, 105, 255, 162, 190, 116, 255, 167, 189, 115, 255, 172, 196, 134, 255, 152,
    170, 112, 255, 67,  96,  43,  255, 98,  134, 60,  255, 107, 143, 60,  255, 71,  106, 52,  255, 61,  92,  50,  255, 67,  101, 47,  255, 80,  114,
    41,  255, 69,  87,  36,  255, 39,  47,  28,  255, 44,  52,  34,  255, 62,  80,  43,  255, 43,  55,  29,  255, 60,  73,  43,  255, 68,  80,  47,
    255, 60,  79,  40,  255, 81,  115, 48,  255, 94,  128, 53,  255, 173, 197, 125, 255, 159, 194, 129, 255, 149, 167, 96,  255, 151, 170, 84,  255,
    128, 149, 68,  255, 108, 135, 60,  255, 160, 181, 100, 255, 159, 186, 127, 255, 176, 203, 162, 255, 137, 163, 98,  255, 92,  116, 49,  255, 108,
    137, 82,  255, 129, 158, 118, 255, 141, 166, 123, 255, 171, 191, 130, 255, 161, 173, 109, 255, 135, 146, 72,  255, 212, 222, 119, 255, 175, 180,
    100, 255, 95,  112, 52,  255, 33,  53,  19,  255, 36,  52,  23,  255, 37,  55,  23,  255, 46,  67,  33,  255, 84,  105, 52,  255, 91,  112, 58,
    255, 72,  94,  42,  255, 45,  58,  21,  255, 29,  38,  23,  255, 26,  38,  26,  255, 47,  44,  37,  255, 87,  89,  62,  255, 191, 206, 143, 255,
    196, 218, 157, 255, 217, 228, 150, 255, 215, 225, 152, 255, 153, 181, 71,  255, 159, 195, 77,  255, 195, 204, 101, 255, 158, 173, 87,  255, 193,
    209, 108, 255, 185, 206, 98,  255, 146, 177, 69,  255, 112, 152, 56,  255, 166, 191, 108, 255, 190, 206, 123, 255, 169, 189, 101, 255, 175, 200,
    120, 255, 143, 165, 73,  255, 197, 213, 113, 255, 222, 231, 127, 255, 205, 216, 101, 255, 210, 219, 104, 255, 176, 188, 93,  255, 207, 218, 121,
    255, 173, 183, 113, 255, 185, 203, 151, 255, 177, 194, 148, 255, 190, 205, 145, 255, 223, 227, 168, 255, 218, 222, 188, 255, 229, 233, 174, 255,
    238, 241, 163, 255, 241, 245, 174, 255, 227, 227, 145, 255, 233, 225, 112, 255, 235, 224, 111, 255, 208, 209, 97,  255, 207, 203, 106, 255, 191,
    199, 91,  255, 163, 168, 78,  255, 150, 164, 73,  255, 205, 213, 128, 255, 227, 223, 137, 255, 228, 222, 128, 255, 229, 222, 127, 255, 136, 141,
    53,  255, 73,  97,  21,  255, 107, 135, 52,  255, 202, 219, 152, 255, 177, 199, 150, 255, 139, 153, 104, 255, 147, 171, 100, 255, 199, 223, 109,
    255, 215, 231, 140, 255, 178, 200, 123, 255, 171, 185, 94,  255, 138, 152, 52,  255, 127, 149, 48,  255, 161, 186, 80,  255, 174, 193, 92,  255,
    154, 180, 80,  255, 150, 173, 68,  255, 141, 163, 58,  255, 112, 138, 43,  255, 98,  125, 34,  255, 83,  105, 31,  255, 37,  63,  23,  255, 52,
    86,  28,  255, 57,  86,  26,  255, 44,  65,  26,  255, 39,  62,  21,  255, 36,  55,  19,  255, 75,  114, 43,  255, 116, 154, 67,  255, 110, 147,
    67,  255, 146, 167, 81,  255, 202, 205, 110, 255, 212, 214, 121, 255, 200, 193, 89,  255, 144, 154, 83,  255, 108, 126, 52,  255, 80,  112, 32,
    255, 135, 159, 63,  255, 140, 162, 62,  255, 141, 163, 65,  255, 145, 163, 74,  255, 135, 148, 68,  255, 75,  96,  32,  255, 79,  99,  43,  255,
    113, 134, 65,  255, 127, 150, 95,  255, 139, 168, 128, 255, 153, 180, 152, 255, 195, 206, 152, 255, 170, 185, 104, 255, 80,  115, 58,  255, 81,
    110, 42,  255, 130, 142, 87,  255, 146, 166, 81,  255, 105, 143, 50,  255, 113, 150, 62,  255, 172, 196, 162, 255, 172, 194, 150, 255, 69,  91,
    40,  255, 58,  81,  36,  255, 58,  97,  43,  255, 60,  92,  34,  255, 76,  98,  48,  255, 43,  67,  26,  255, 43,  58,  28,  255, 150, 164, 90,
    255, 134, 157, 93,  255, 132, 154, 101, 255, 130, 164, 112, 255, 144, 174, 111, 255, 169, 188, 111, 255, 44,  62,  36,  255, 33,  42,  28,  255,
    33,  47,  26,  255, 33,  41,  26,  255, 81,  87,  37,  255, 185, 191, 87,  255, 193, 208, 116, 255, 191, 206, 129, 255, 203, 213, 116, 255, 174,
    190, 87,  255, 89,  121, 47,  255, 43,  75,  19,  255, 43,  62,  25,  255, 38,  60,  28,  255, 23,  37,  23,  255, 19,  19,  21,  255, 56,  76,
    31,  255, 88,  107, 41,  255, 175, 186, 113, 255, 195, 220, 153, 255, 170, 203, 144, 255, 159, 193, 139, 255, 157, 190, 142, 255, 154, 184, 129,
    255, 209, 214, 135, 255, 230, 232, 152, 255, 139, 164, 103, 255, 172, 202, 142, 255, 175, 207, 137, 255, 192, 214, 134, 255, 202, 213, 133, 255,
    93,  125, 77,  255, 128, 140, 79,  255, 194, 205, 120, 255, 187, 204, 116, 255, 171, 194, 101, 255, 176, 198, 111, 255, 188, 209, 130, 255, 204,
    218, 121, 255, 229, 235, 143, 255, 204, 225, 172, 255, 202, 225, 180, 255, 223, 241, 192, 255, 228, 235, 184, 255, 103, 119, 80,  255, 141, 155,
    60,  255, 206, 221, 82,  255, 105, 134, 48,  255, 140, 159, 76,  255, 179, 203, 96,  255, 183, 207, 111, 255, 126, 150, 105, 255, 103, 134, 90,
    255, 151, 174, 91,  255, 151, 179, 62,  255, 157, 181, 76,  255, 171, 192, 83,  255, 164, 185, 74,  255, 86,  119, 38,  255, 79,  110, 38,  255,
    39,  53,  26,  255, 29,  32,  21,  255, 151, 160, 94,  255, 130, 152, 84,  255, 113, 140, 95,  255, 138, 168, 137, 255, 136, 163, 124, 255, 175,
    188, 113, 255, 192, 196, 105, 255, 202, 220, 166, 255, 176, 209, 168, 255, 154, 184, 86,  255, 206, 219, 130, 255, 186, 204, 147, 255, 151, 179,
    112, 255, 152, 180, 110, 255, 155, 182, 123, 255, 100, 125, 58,  255, 49,  77,  44,  255, 52,  76,  50,  255, 53,  81,  47,  255, 47,  75,  40,
    255, 53,  89,  33,  255, 62,  92,  31,  255, 74,  93,  42,  255, 90,  100, 55,  255, 98,  111, 58,  255, 109, 128, 65,  255, 94,  113, 50,  255,
    99,  121, 44,  255, 108, 138, 65,  255, 102, 137, 71,  255, 87,  128, 58,  255, 92,  137, 62,  255, 140, 173, 79,  255, 82,  108, 58,  255, 72,
    99,  60,  255, 93,  125, 52,  255, 98,  132, 49,  255, 84,  111, 39,  255, 62,  76,  38,  255, 55,  67,  34,  255, 69,  84,  41,  255, 69,  81,
    44,  255, 58,  69,  47,  255, 62,  74,  43,  255, 87,  121, 55,  255, 83,  123, 52,  255, 87,  120, 58,  255, 162, 180, 109, 255, 156, 178, 108,
    255, 120, 144, 65,  255, 126, 150, 62,  255, 167, 187, 80,  255, 149, 176, 100, 255, 133, 163, 104, 255, 160, 186, 129, 255, 177, 203, 157, 255,
    140, 161, 93,  255, 91,  115, 55,  255, 107, 136, 87,  255, 120, 154, 119, 255, 122, 156, 121, 255, 144, 172, 122, 255, 125, 145, 83,  255, 140,
    157, 77,  255, 214, 223, 120, 255, 219, 228, 122, 255, 225, 231, 130, 255, 139, 149, 79,  255, 47,  68,  26,  255, 58,  87,  28,  255, 67,  97,
    26,  255, 103, 125, 63,  255, 113, 136, 83,  255, 98,  121, 63,  255, 94,  106, 56,  255, 101, 113, 63,  255, 63,  79,  46,  255, 65,  65,  43,
    255, 170, 177, 113, 255, 201, 224, 168, 255, 180, 205, 157, 255, 211, 225, 146, 255, 221, 227, 132, 255, 159, 185, 84,  255, 218, 227, 122, 255,
    226, 233, 115, 255, 224, 238, 117, 255, 219, 231, 122, 255, 214, 226, 122, 255, 208, 221, 105, 255, 164, 186, 82,  255, 173, 195, 121, 255, 180,
    194, 108, 255, 178, 202, 121, 255, 171, 193, 109, 255, 126, 149, 58,  255, 176, 198, 84,  255, 225, 235, 128, 255, 208, 218, 104, 255, 206, 217,
    103, 255, 186, 205, 111, 255, 193, 212, 108, 255, 205, 215, 115, 255, 177, 195, 121, 255, 210, 221, 158, 255, 243, 246, 165, 255, 246, 249, 165,
    255, 245, 248, 156, 255, 243, 248, 156, 255, 250, 253, 178, 255, 230, 227, 152, 255, 169, 173, 65,  255, 182, 188, 72,  255, 229, 223, 112, 255,
    228, 221, 126, 255, 191, 186, 92,  255, 171, 182, 78,  255, 135, 150, 72,  255, 177, 188, 109, 255, 208, 212, 122, 255, 221, 217, 128, 255, 225,
    221, 123, 255, 234, 227, 131, 255, 189, 182, 81,  255, 115, 124, 40,  255, 101, 119, 48,  255, 188, 204, 135, 255, 174, 201, 155, 255, 145, 164,
    113, 255, 103, 127, 52,  255, 181, 204, 94,  255, 188, 214, 145, 255, 126, 150, 82,  255, 106, 130, 47,  255, 104, 130, 47,  255, 111, 141, 49,
    255, 170, 194, 87,  255, 176, 195, 89,  255, 170, 190, 80,  255, 174, 194, 84,  255, 188, 206, 96,  255, 195, 209, 104, 255, 146, 163, 67,  255,
    69,  92,  29,  255, 43,  65,  29,  255, 50,  77,  34,  255, 68,  100, 36,  255, 49,  71,  25,  255, 47,  68,  23,  255, 33,  44,  19,  255, 36,
    56,  25,  255, 67,  103, 36,  255, 84,  122, 44,  255, 90,  127, 48,  255, 95,  128, 53,  255, 132, 156, 67,  255, 137, 154, 62,  255, 122, 141,
    68,  255, 96,  120, 43,  255, 109, 135, 52,  255, 156, 174, 74,  255, 153, 170, 76,  255, 140, 161, 82,  255, 187, 196, 102, 255, 173, 177, 82,
    255, 67,  96,  34,  255, 73,  109, 40,  255, 111, 138, 44,  255, 148, 163, 84,  255, 112, 140, 92,  255, 145, 173, 140, 255, 186, 201, 147, 255,
    136, 153, 90,  255, 73,  102, 62,  255, 113, 126, 75,  255, 174, 187, 105, 255, 188, 203, 116, 255, 161, 178, 105, 255, 137, 166, 102, 255, 169,
    196, 166, 255, 97,  126, 71,  255, 36,  60,  21,  255, 53,  81,  36,  255, 57,  95,  42,  255, 65,  100, 41,  255, 58,  89,  36,  255, 55,  84,
    34,  255, 63,  84,  33,  255, 152, 169, 87,  255, 133, 166, 101, 255, 133, 153, 93,  255, 144, 173, 117, 255, 140, 172, 115, 255, 189, 207, 127,
    255, 104, 118, 63,  255, 36,  62,  21,  255, 52,  80,  31,  255, 34,  47,  29,  255, 23,  36,  19,  255, 129, 128, 62,  255, 191, 213, 127, 255,
    184, 207, 131, 255, 211, 220, 127, 255, 202, 214, 95,  255, 158, 179, 69,  255, 44,  60,  25,  255, 29,  36,  26,  255, 31,  43,  26,  255, 26,
    36,  21,  255, 55,  67,  36,  255, 96,  125, 47,  255, 101, 136, 52,  255, 106, 134, 50,  255, 124, 131, 63,  255, 183, 190, 113, 255, 185, 214,
    137, 255, 165, 199, 131, 255, 158, 186, 126, 255, 217, 221, 147, 255, 188, 207, 144, 255, 94,  123, 63,  255, 158, 184, 106, 255, 213, 225, 133,
    255, 196, 206, 118, 255, 138, 161, 113, 255, 135, 160, 115, 255, 141, 161, 86,  255, 122, 147, 81,  255, 129, 155, 81,  255, 146, 167, 87,  255,
    169, 186, 107, 255, 175, 197, 130, 255, 164, 184, 106, 255, 206, 211, 107, 255, 229, 241, 171, 255, 192, 220, 173, 255, 189, 218, 178, 255, 215,
    234, 194, 255, 227, 232, 183, 255, 217, 228, 110, 255, 168, 192, 68,  255, 110, 139, 58,  255, 186, 209, 96,  255, 177, 207, 105, 255, 188, 208,
    146, 255, 110, 141, 101, 255, 120, 149, 98,  255, 152, 168, 87,  255, 117, 136, 43,  255, 163, 186, 69,  255, 176, 197, 81,  255, 132, 160, 52,
    255, 74,  108, 34,  255, 103, 132, 52,  255, 60,  74,  33,  255, 12,  15,  17,  255, 65,  74,  40,  255, 124, 149, 90,  255, 119, 138, 84,  255,
    191, 205, 152, 255, 208, 220, 158, 255, 219, 227, 155, 255, 230, 233, 158, 255, 213, 229, 172, 255, 184, 214, 166, 255, 162, 190, 102, 255, 198,
    211, 117, 255, 181, 199, 135, 255, 144, 177, 67,  255, 158, 185, 107, 255, 181, 200, 135, 255, 186, 197, 142, 255, 123, 140, 119, 255, 103, 122,
    93,  255, 76,  96,  65,  255, 63,  94,  49,  255, 73,  108, 42,  255, 52,  84,  29,  255, 40,  65,  33,  255, 29,  51,  31,  255, 47,  65,  36,
    255, 60,  82,  37,  255, 62,  99,  31,  255, 72,  112, 34,  255, 105, 139, 56,  255, 91,  136, 58,  255, 87,  132, 65,  255, 100, 143, 71,  255,
    147, 177, 81,  255, 89,  119, 47,  255, 90,  127, 49,  255, 100, 134, 48,  255, 102, 133, 53,  255, 84,  110, 45,  255, 69,  89,  41,  255, 58,
    69,  37,  255, 34,  39,  26,  255, 60,  68,  36,  255, 56,  60,  33,  255, 76,  91,  50,  255, 100, 138, 71,  255, 84,  120, 60,  255, 63,  100,
    49,  255, 65,  97,  42,  255, 105, 131, 55,  255, 83,  105, 37,  255, 176, 185, 87,  255, 174, 196, 95,  255, 122, 157, 91,  255, 119, 153, 87,
    255, 150, 177, 112, 255, 170, 196, 142, 255, 142, 164, 93,  255, 106, 129, 65,  255, 112, 140, 95,  255, 124, 156, 122, 255, 145, 172, 126, 255,
    138, 159, 98,  255, 126, 139, 67,  255, 157, 168, 90,  255, 195, 203, 109, 255, 218, 225, 128, 255, 218, 223, 126, 255, 234, 236, 140, 255, 152,
    165, 81,  255, 94,  125, 47,  255, 132, 159, 55,  255, 186, 202, 100, 255, 215, 226, 127, 255, 206, 220, 116, 255, 199, 218, 113, 255, 200, 220,
    114, 255, 191, 208, 103, 255, 197, 212, 122, 255, 198, 216, 118, 255, 195, 213, 117, 255, 178, 202, 132, 255, 198, 217, 152, 255, 224, 226, 128,
    255, 178, 200, 95,  255, 175, 197, 87,  255, 198, 214, 101, 255, 208, 222, 103, 255, 209, 222, 100, 255, 215, 226, 115, 255, 207, 222, 110, 255,
    207, 222, 111, 255, 195, 210, 120, 255, 176, 197, 122, 255, 172, 196, 115, 255, 106, 137, 48,  255, 85,  121, 32,  255, 176, 197, 87,  255, 239,
    245, 144, 255, 238, 239, 142, 255, 225, 229, 135, 255, 176, 195, 127, 255, 157, 186, 115, 255, 201, 217, 124, 255, 229, 236, 133, 255, 248, 250,
    153, 255, 236, 241, 134, 255, 238, 245, 160, 255, 248, 249, 177, 255, 251, 251, 178, 255, 220, 220, 149, 255, 167, 178, 78,  255, 168, 176, 69,
    255, 142, 156, 53,  255, 174, 186, 75,  255, 215, 215, 110, 255, 193, 191, 87,  255, 182, 189, 86,  255, 143, 158, 77,  255, 177, 188, 108, 255,
    208, 210, 118, 255, 220, 216, 120, 255, 228, 224, 124, 255, 223, 217, 121, 255, 185, 189, 111, 255, 177, 178, 85,  255, 160, 166, 74,  255, 184,
    202, 128, 255, 171, 201, 160, 255, 126, 148, 93,  255, 65,  94,  12,  255, 157, 181, 90,  255, 178, 209, 130, 255, 123, 153, 65,  255, 75,  104,
    34,  255, 60,  87,  21,  255, 56,  83,  21,  255, 106, 126, 43,  255, 168, 186, 82,  255, 197, 214, 94,  255, 202, 217, 102, 255, 209, 224, 109,
    255, 216, 229, 116, 255, 191, 198, 98,  255, 85,  107, 39,  255, 49,  79,  29,  255, 53,  84,  39,  255, 83,  115, 47,  255, 47,  57,  23,  255,
    33,  44,  23,  255, 29,  38,  21,  255, 26,  41,  19,  255, 46,  73,  25,  255, 71,  104, 36,  255, 87,  119, 46,  255, 71,  102, 33,  255, 87,
    118, 42,  255, 152, 163, 63,  255, 91,  112, 37,  255, 122, 152, 62,  255, 153, 175, 76,  255, 149, 166, 79,  255, 129, 151, 83,  255, 163, 179,
    101, 255, 197, 200, 99,  255, 161, 169, 74,  255, 74,  103, 36,  255, 65,  98,  38,  255, 84,  103, 52,  255, 110, 127, 65,  255, 161, 182, 113,
    255, 141, 169, 130, 255, 185, 199, 136, 255, 89,  109, 47,  255, 106, 123, 74,  255, 177, 191, 118, 255, 180, 196, 107, 255, 122, 145, 72,  255,
    153, 173, 117, 255, 159, 183, 136, 255, 116, 142, 90,  255, 58,  79,  23,  255, 65,  87,  40,  255, 82,  112, 53,  255, 74,  110, 47,  255, 92,
    128, 52,  255, 90,  119, 55,  255, 44,  55,  34,  255, 53,  74,  29,  255, 147, 157, 69,  255, 158, 189, 112, 255, 133, 158, 98,  255, 149, 173,
    119, 255, 146, 179, 126, 255, 171, 192, 128, 255, 154, 172, 98,  255, 67,  96,  43,  255, 75,  107, 43,  255, 60,  90,  32,  255, 86,  100, 49,
    255, 159, 174, 101, 255, 170, 203, 130, 255, 186, 210, 132, 255, 207, 213, 116, 255, 218, 220, 83,  255, 227, 233, 119, 255, 106, 126, 65,  255,
    28,  38,  23,  255, 19,  28,  25,  255, 42,  52,  28,  255, 110, 138, 49,  255, 108, 144, 55,  255, 122, 153, 71,  255, 96,  134, 50,  255, 26,
    49,  15,  255, 45,  47,  28,  255, 149, 146, 84,  255, 175, 191, 107, 255, 179, 199, 108, 255, 218, 226, 149, 255, 170, 191, 133, 255, 108, 132,
    65,  255, 144, 164, 87,  255, 169, 186, 121, 255, 131, 155, 87,  255, 154, 177, 108, 255, 162, 186, 113, 255, 144, 173, 109, 255, 119, 152, 102,
    255, 111, 146, 92,  255, 122, 156, 100, 255, 126, 159, 103, 255, 149, 175, 119, 255, 133, 163, 114, 255, 131, 154, 86,  255, 203, 207, 117, 255,
    224, 236, 174, 255, 195, 222, 172, 255, 189, 216, 173, 255, 214, 230, 189, 255, 225, 235, 158, 255, 132, 155, 63,  255, 164, 187, 92,  255, 168,
    202, 90,  255, 192, 214, 129, 255, 138, 165, 123, 255, 109, 146, 102, 255, 129, 160, 104, 255, 151, 168, 87,  255, 53,  72,  26,  255, 127, 141,
    58,  255, 172, 188, 84,  255, 105, 130, 38,  255, 158, 172, 73,  255, 207, 215, 103, 255, 191, 204, 94,  255, 116, 134, 58,  255, 58,  68,  37,
    255, 183, 198, 138, 255, 205, 229, 167, 255, 194, 223, 164, 255, 179, 212, 157, 255, 174, 208, 152, 255, 184, 211, 151, 255, 201, 221, 156, 255,
    202, 221, 160, 255, 180, 201, 119, 255, 183, 201, 117, 255, 169, 194, 104, 255, 173, 199, 93,  255, 180, 204, 113, 255, 183, 210, 142, 255, 206,
    228, 182, 255, 183, 201, 156, 255, 127, 143, 99,  255, 84,  107, 65,  255, 86,  119, 55,  255, 56,  81,  32,  255, 49,  76,  31,  255, 39,  60,
    32,  255, 39,  60,  33,  255, 55,  74,  36,  255, 68,  102, 36,  255, 69,  109, 41,  255, 55,  94,  40,  255, 76,  106, 49,  255, 135, 163, 86,
    255, 131, 168, 94,  255, 156, 186, 82,  255, 143, 162, 60,  255, 96,  127, 44,  255, 104, 134, 46,  255, 98,  123, 43,  255, 80,  108, 43,  255,
    65,  94,  44,  255, 62,  82,  38,  255, 71,  92,  41,  255, 53,  62,  37,  255, 62,  69,  40,  255, 60,  68,  39,  255, 50,  68,  34,  255, 79,
    103, 48,  255, 92,  123, 52,  255, 99,  135, 58,  255, 93,  132, 56,  255, 96,  131, 50,  255, 82,  97,  47,  255, 204, 215, 123, 255, 159, 184,
    104, 255, 130, 164, 93,  255, 124, 160, 91,  255, 120, 155, 81,  255, 134, 163, 89,  255, 118, 146, 67,  255, 114, 138, 65,  255, 110, 139, 94,
    255, 147, 176, 134, 255, 139, 157, 103, 255, 108, 130, 73,  255, 153, 166, 96,  255, 167, 176, 97,  255, 170, 179, 90,  255, 219, 225, 119, 255,
    217, 224, 124, 255, 217, 223, 129, 255, 213, 219, 123, 255, 164, 185, 65,  255, 187, 211, 67,  255, 162, 173, 75,  255, 163, 175, 84,  255, 205,
    218, 103, 255, 196, 213, 102, 255, 189, 207, 104, 255, 184, 205, 89,  255, 199, 215, 121, 255, 198, 218, 164, 255, 186, 210, 151, 255, 184, 205,
    128, 255, 194, 211, 128, 255, 191, 200, 101, 255, 182, 198, 87,  255, 172, 193, 75,  255, 165, 188, 65,  255, 166, 189, 62,  255, 171, 193, 65,
    255, 178, 198, 72,  255, 191, 207, 87,  255, 206, 221, 105, 255, 204, 222, 113, 255, 184, 201, 120, 255, 123, 156, 56,  255, 103, 139, 47,  255,
    161, 179, 96,  255, 239, 243, 154, 255, 255, 255, 169, 255, 255, 251, 166, 255, 255, 253, 159, 255, 250, 245, 141, 255, 197, 197, 123, 255, 218,
    214, 136, 255, 241, 246, 126, 255, 233, 239, 125, 255, 243, 246, 161, 255, 251, 251, 174, 255, 251, 250, 168, 255, 199, 205, 144, 255, 144, 168,
    120, 255, 170, 186, 92,  255, 172, 179, 74,  255, 156, 166, 68,  255, 134, 154, 52,  255, 175, 185, 79,  255, 188, 191, 81,  255, 188, 193, 86,
    255, 153, 167, 84,  255, 175, 187, 109, 255, 212, 214, 122, 255, 221, 217, 119, 255, 237, 227, 124, 255, 208, 199, 93,  255, 172, 177, 90,  255,
    185, 190, 109, 255, 158, 172, 93,  255, 176, 190, 133, 255, 197, 216, 179, 255, 194, 211, 168, 255, 87,  113, 49,  255, 130, 159, 71,  255, 138,
    164, 74,  255, 73,  110, 29,  255, 32,  60,  23,  255, 55,  81,  23,  255, 52,  77,  19,  255, 47,  73,  21,  255, 48,  63,  23,  255, 86,  96,
    42,  255, 129, 141, 63,  255, 132, 140, 60,  255, 105, 109, 43,  255, 96,  116, 39,  255, 113, 142, 42,  255, 120, 146, 55,  255, 121, 148, 65,
    255, 125, 152, 62,  255, 60,  74,  26,  255, 19,  31,  17,  255, 39,  60,  26,  255, 89,  122, 49,  255, 106, 139, 49,  255, 93,  128, 44,  255,
    112, 142, 68,  255, 109, 125, 62,  255, 33,  43,  17,  255, 84,  100, 47,  255, 156, 166, 79,  255, 150, 170, 81,  255, 156, 174, 83,  255, 136,
    157, 83,  255, 153, 173, 94,  255, 194, 201, 104, 255, 177, 185, 93,  255, 114, 135, 55,  255, 113, 135, 50,  255, 82,  104, 52,  255, 62,  80,
    62,  255, 44,  68,  42,  255, 122, 140, 77,  255, 163, 186, 122, 255, 158, 179, 109, 255, 106, 126, 62,  255, 157, 175, 105, 255, 147, 169, 89,
    255, 81,  100, 49,  255, 34,  58,  17,  255, 91,  116, 53,  255, 155, 178, 99,  255, 174, 192, 113, 255, 166, 182, 113, 255, 166, 181, 110, 255,
    151, 163, 84,  255, 160, 176, 75,  255, 137, 160, 58,  255, 125, 151, 55,  255, 109, 125, 49,  255, 107, 136, 60,  255, 118, 150, 60,  255, 168,
    201, 83,  255, 148, 180, 98,  255, 142, 162, 107, 255, 153, 181, 131, 255, 160, 186, 127, 255, 188, 201, 119, 255, 203, 215, 154, 255, 196, 213,
    163, 255, 143, 164, 100, 255, 158, 178, 79,  255, 192, 221, 144, 255, 161, 199, 132, 255, 187, 214, 121, 255, 107, 124, 68,  255, 97,  109, 46,
    255, 137, 144, 76,  255, 132, 146, 71,  255, 80,  96,  43,  255, 65,  79,  36,  255, 122, 135, 49,  255, 165, 182, 68,  255, 161, 179, 79,  255,
    135, 165, 74,  255, 93,  131, 48,  255, 55,  84,  36,  255, 21,  42,  19,  255, 31,  47,  21,  255, 85,  101, 60,  255, 146, 160, 101, 255, 212,
    225, 153, 255, 173, 186, 116, 255, 93,  118, 50,  255, 135, 159, 93,  255, 144, 172, 122, 255, 150, 177, 102, 255, 156, 179, 103, 255, 159, 184,
    114, 255, 152, 181, 107, 255, 145, 176, 100, 255, 141, 177, 100, 255, 131, 166, 89,  255, 132, 166, 86,  255, 142, 172, 91,  255, 154, 180, 96,
    255, 138, 167, 84,  255, 137, 159, 65,  255, 217, 220, 123, 255, 230, 239, 171, 255, 198, 224, 171, 255, 185, 213, 168, 255, 212, 226, 171, 255,
    201, 216, 119, 255, 185, 210, 98,  255, 187, 210, 109, 255, 142, 171, 119, 255, 114, 151, 111, 255, 108, 146, 102, 255, 150, 176, 104, 255, 121,
    139, 65,  255, 44,  69,  26,  255, 52,  77,  31,  255, 52,  73,  28,  255, 160, 157, 65,  255, 228, 227, 105, 255, 195, 204, 106, 255, 178, 195,
    101, 255, 173, 193, 87,  255, 158, 175, 75,  255, 129, 146, 74,  255, 151, 167, 107, 255, 191, 207, 136, 255, 197, 219, 140, 255, 196, 221, 139,
    255, 188, 215, 130, 255, 174, 204, 117, 255, 182, 208, 125, 255, 188, 211, 107, 255, 175, 199, 96,  255, 155, 184, 90,  255, 134, 172, 92,  255,
    147, 185, 95,  255, 165, 194, 93,  255, 187, 201, 95,  255, 86,  109, 53,  255, 68,  101, 55,  255, 94,  130, 62,  255, 65,  87,  40,  255, 37,
    49,  29,  255, 53,  83,  36,  255, 46,  67,  40,  255, 48,  67,  37,  255, 71,  92,  39,  255, 84,  121, 44,  255, 63,  100, 41,  255, 69,  105,
    48,  255, 62,  98,  50,  255, 90,  118, 63,  255, 164, 183, 107, 255, 186, 199, 92,  255, 62,  76,  29,  255, 36,  46,  32,  255, 49,  62,  36,
    255, 38,  55,  31,  255, 41,  67,  33,  255, 52,  80,  37,  255, 52,  74,  34,  255, 62,  83,  36,  255, 45,  60,  31,  255, 34,  37,  31,  255,
    52,  63,  38,  255, 36,  55,  25,  255, 32,  47,  25,  255, 38,  55,  25,  255, 52,  65,  28,  255, 58,  77,  32,  255, 50,  71,  32,  255, 84,
    99,  56,  255, 165, 177, 106, 255, 168, 189, 90,  255, 199, 213, 87,  255, 181, 200, 83,  255, 144, 172, 76,  255, 127, 159, 75,  255, 123, 150,
    74,  255, 97,  125, 55,  255, 115, 143, 94,  255, 125, 142, 90,  255, 81,  101, 44,  255, 114, 141, 65,  255, 137, 155, 76,  255, 139, 154, 74,
    255, 116, 144, 52,  255, 165, 186, 69,  255, 217, 227, 100, 255, 196, 212, 83,  255, 188, 204, 95,  255, 193, 214, 74,  255, 184, 201, 92,  255,
    162, 174, 110, 255, 150, 168, 102, 255, 172, 190, 96,  255, 197, 214, 86,  255, 190, 209, 85,  255, 179, 201, 86,  255, 204, 215, 131, 255, 194,
    212, 165, 255, 188, 212, 173, 255, 183, 209, 159, 255, 154, 176, 92,  255, 157, 180, 80,  255, 193, 210, 106, 255, 165, 188, 65,  255, 151, 180,
    50,  255, 164, 188, 63,  255, 160, 187, 55,  255, 149, 175, 68,  255, 132, 157, 83,  255, 172, 189, 92,  255, 199, 216, 98,  255, 188, 206, 94,
    255, 135, 170, 65,  255, 183, 203, 113, 255, 255, 255, 181, 255, 255, 254, 174, 255, 254, 249, 162, 255, 254, 250, 161, 255, 254, 250, 160, 255,
    254, 250, 160, 255, 249, 248, 124, 255, 233, 238, 112, 255, 222, 236, 123, 255, 226, 235, 127, 255, 231, 236, 134, 255, 230, 233, 132, 255, 238,
    236, 133, 255, 232, 230, 141, 255, 185, 196, 131, 255, 168, 185, 87,  255, 165, 178, 68,  255, 185, 192, 78,  255, 151, 168, 55,  255, 125, 140,
    49,  255, 163, 165, 65,  255, 200, 200, 83,  255, 166, 174, 82,  255, 175, 185, 112, 255, 228, 225, 125, 255, 172, 180, 93,  255, 114, 139, 62,
    255, 130, 146, 63,  255, 190, 186, 99,  255, 153, 160, 89,  255, 87,  97,  56,  255, 75,  86,  49,  255, 69,  94,  34,  255, 166, 183, 130, 255,
    182, 202, 150, 255, 146, 169, 101, 255, 146, 167, 91,  255, 89,  107, 38,  255, 97,  97,  52,  255, 67,  92,  29,  255, 52,  82,  19,  255, 52,
    82,  23,  255, 26,  34,  21,  255, 3,   3,   12,  255, 26,  39,  19,  255, 37,  55,  19,  255, 29,  49,  15,  255, 111, 145, 41,  255, 163, 186,
    65,  255, 168, 186, 75,  255, 170, 187, 78,  255, 171, 189, 84,  255, 143, 158, 63,  255, 38,  52,  17,  255, 116, 141, 72,  255, 154, 178, 83,
    255, 111, 140, 56,  255, 86,  117, 47,  255, 91,  121, 62,  255, 134, 160, 89,  255, 116, 131, 58,  255, 71,  98,  34,  255, 150, 171, 87,  255,
    188, 197, 108, 255, 185, 194, 105, 255, 212, 212, 109, 255, 221, 217, 117, 255, 197, 200, 105, 255, 191, 198, 102, 255, 156, 177, 89,  255, 128,
    153, 68,  255, 115, 137, 60,  255, 52,  77,  23,  255, 39,  58,  23,  255, 40,  63,  31,  255, 125, 150, 73,  255, 141, 159, 87,  255, 142, 158,
    93,  255, 76,  101, 37,  255, 65,  92,  26,  255, 53,  79,  25,  255, 40,  68,  19,  255, 73,  100, 34,  255, 143, 165, 71,  255, 192, 212, 121,
    255, 177, 200, 129, 255, 171, 197, 130, 255, 173, 195, 117, 255, 179, 197, 103, 255, 150, 171, 80,  255, 116, 141, 44,  255, 123, 147, 60,  255,
    56,  82,  52,  255, 47,  69,  36,  255, 79,  104, 42,  255, 143, 179, 104, 255, 138, 163, 98,  255, 146, 174, 107, 255, 159, 184, 125, 255, 191,
    203, 117, 255, 229, 235, 165, 255, 212, 231, 188, 255, 196, 220, 155, 255, 180, 205, 101, 255, 188, 212, 123, 255, 166, 203, 132, 255, 181, 209,
    104, 255, 97,  125, 53,  255, 58,  90,  36,  255, 56,  79,  31,  255, 26,  36,  23,  255, 80,  94,  33,  255, 169, 180, 58,  255, 208, 214, 74,
    255, 212, 215, 82,  255, 217, 219, 94,  255, 162, 182, 78,  255, 114, 146, 56,  255, 86,  109, 52,  255, 97,  116, 77,  255, 149, 165, 104, 255,
    142, 150, 84,  255, 108, 122, 72,  255, 130, 149, 90,  255, 172, 187, 104, 255, 89,  112, 49,  255, 131, 156, 102, 255, 106, 125, 80,  255, 138,
    156, 73,  255, 112, 140, 69,  255, 131, 157, 104, 255, 155, 177, 117, 255, 150, 169, 97,  255, 153, 171, 96,  255, 166, 187, 113, 255, 174, 195,
    95,  255, 149, 169, 77,  255, 119, 144, 71,  255, 107, 133, 52,  255, 174, 192, 99,  255, 193, 211, 119, 255, 208, 216, 128, 255, 230, 236, 148,
    255, 195, 223, 157, 255, 200, 221, 157, 255, 201, 219, 141, 255, 179, 205, 113, 255, 220, 229, 150, 255, 164, 183, 129, 255, 131, 161, 113, 255,
    153, 175, 112, 255, 190, 205, 109, 255, 136, 148, 75,  255, 103, 117, 68,  255, 88,  108, 60,  255, 67,  84,  42,  255, 193, 190, 87,  255, 153,
    178, 100, 255, 154, 179, 107, 255, 140, 169, 94,  255, 130, 159, 74,  255, 145, 172, 77,  255, 128, 158, 62,  255, 67,  98,  31,  255, 88,  106,
    47,  255, 111, 124, 58,  255, 132, 146, 71,  255, 161, 174, 96,  255, 134, 156, 77,  255, 132, 156, 68,  255, 156, 186, 77,  255, 172, 201, 86,
    255, 184, 206, 101, 255, 153, 186, 81,  255, 169, 193, 76,  255, 137, 167, 62,  255, 162, 194, 91,  255, 185, 202, 122, 255, 96,  122, 55,  255,
    58,  79,  36,  255, 23,  34,  21,  255, 34,  49,  26,  255, 62,  92,  46,  255, 56,  79,  47,  255, 53,  73,  38,  255, 87,  117, 44,  255, 108,
    144, 52,  255, 65,  110, 47,  255, 73,  114, 44,  255, 84,  126, 60,  255, 84,  123, 79,  255, 87,  121, 74,  255, 114, 144, 72,  255, 86,  105,
    42,  255, 25,  42,  23,  255, 41,  62,  36,  255, 38,  56,  38,  255, 36,  53,  31,  255, 43,  65,  31,  255, 40,  65,  31,  255, 47,  62,  31,
    255, 43,  56,  31,  255, 26,  34,  28,  255, 50,  65,  39,  255, 42,  65,  28,  255, 50,  74,  37,  255, 39,  60,  33,  255, 23,  37,  23,  255,
    23,  37,  23,  255, 33,  51,  28,  255, 53,  75,  33,  255, 58,  76,  34,  255, 89,  109, 41,  255, 144, 162, 55,  255, 167, 181, 71,  255, 158,
    179, 73,  255, 157, 184, 82,  255, 167, 197, 113, 255, 141, 170, 92,  255, 132, 154, 72,  255, 159, 172, 82,  255, 169, 186, 105, 255, 181, 199,
    118, 255, 175, 191, 111, 255, 163, 178, 108, 255, 106, 140, 63,  255, 126, 163, 68,  255, 166, 181, 72,  255, 158, 173, 74,  255, 156, 177, 71,
    255, 186, 198, 112, 255, 203, 204, 164, 255, 199, 205, 170, 255, 181, 192, 151, 255, 143, 161, 109, 255, 136, 155, 76,  255, 167, 186, 68,  255,
    191, 209, 87,  255, 212, 223, 143, 255, 185, 208, 165, 255, 182, 209, 164, 255, 178, 200, 143, 255, 142, 163, 82,  255, 144, 172, 60,  255, 160,
    186, 71,  255, 181, 202, 83,  255, 194, 211, 90,  255, 176, 197, 84,  255, 167, 191, 72,  255, 162, 184, 62,  255, 144, 167, 93,  255, 137, 160,
    83,  255, 186, 206, 114, 255, 194, 211, 97,  255, 216, 226, 150, 255, 254, 253, 174, 255, 255, 254, 172, 255, 255, 253, 169, 255, 255, 253, 170,
    255, 255, 251, 172, 255, 254, 249, 166, 255, 251, 248, 144, 255, 255, 250, 105, 255, 243, 248, 95,  255, 232, 241, 105, 255, 224, 233, 117, 255,
    225, 231, 104, 255, 226, 229, 98,  255, 229, 229, 101, 255, 245, 241, 120, 255, 255, 246, 142, 255, 217, 222, 131, 255, 199, 206, 105, 255, 239,
    230, 87,  255, 226, 222, 74,  255, 185, 186, 67,  255, 108, 110, 40,  255, 135, 135, 47,  255, 156, 159, 75,  255, 158, 165, 93,  255, 169, 176,
    74,  255, 139, 156, 65,  255, 124, 147, 65,  255, 165, 169, 90,  255, 215, 208, 131, 255, 209, 205, 133, 255, 210, 201, 148, 255, 201, 199, 149,
    255, 175, 179, 115, 255, 104, 122, 58,  255, 135, 159, 79,  255, 151, 173, 108, 255, 147, 169, 100, 255, 168, 181, 93,  255, 212, 228, 140, 255,
    160, 185, 113, 255, 75,  111, 50,  255, 69,  107, 42,  255, 68,  97,  36,  255, 62,  77,  42,  255, 69,  97,  40,  255, 85,  114, 31,  255, 116,
    143, 42,  255, 157, 181, 58,  255, 177, 196, 87,  255, 183, 198, 99,  255, 164, 181, 68,  255, 168, 186, 80,  255, 184, 201, 91,  255, 112, 122,
    45,  255, 88,  107, 44,  255, 153, 176, 69,  255, 118, 144, 55,  255, 89,  120, 50,  255, 83,  112, 53,  255, 104, 134, 77,  255, 151, 170, 91,
    255, 99,  120, 43,  255, 141, 163, 81,  255, 178, 195, 113, 255, 200, 206, 128, 255, 196, 198, 111, 255, 206, 205, 112, 255, 179, 189, 91,  255,
    137, 161, 67,  255, 157, 180, 65,  255, 137, 165, 76,  255, 128, 155, 65,  255, 91,  114, 50,  255, 92,  112, 55,  255, 72,  92,  31,  255, 114,
    125, 68,  255, 156, 168, 114, 255, 104, 124, 72,  255, 60,  83,  28,  255, 80,  107, 36,  255, 41,  68,  23,  255, 32,  60,  17,  255, 75,  100,
    46,  255, 75,  105, 36,  255, 180, 200, 102, 255, 177, 200, 105, 255, 168, 193, 115, 255, 163, 189, 120, 255, 157, 186, 117, 255, 160, 187, 116,
    255, 151, 175, 91,  255, 121, 141, 56,  255, 45,  62,  28,  255, 52,  69,  28,  255, 98,  117, 74,  255, 159, 189, 121, 255, 118, 155, 72,  255,
    121, 156, 82,  255, 131, 166, 100, 255, 156, 179, 98,  255, 225, 226, 155, 255, 205, 227, 177, 255, 192, 219, 160, 255, 164, 194, 100, 255, 183,
    209, 117, 255, 167, 199, 118, 255, 186, 209, 104, 255, 125, 150, 67,  255, 108, 140, 73,  255, 120, 153, 82,  255, 106, 135, 75,  255, 76,  102,
    56,  255, 92,  106, 41,  255, 144, 150, 58,  255, 180, 189, 86,  255, 169, 185, 83,  255, 155, 179, 104, 255, 126, 155, 113, 255, 178, 190, 129,
    255, 207, 225, 162, 255, 193, 215, 146, 255, 175, 191, 112, 255, 187, 193, 101, 255, 151, 155, 69,  255, 136, 157, 86,  255, 90,  121, 55,  255,
    116, 143, 100, 255, 56,  74,  53,  255, 83,  94,  48,  255, 103, 128, 58,  255, 99,  129, 68,  255, 80,  107, 55,  255, 113, 141, 77,  255, 127,
    149, 77,  255, 131, 150, 101, 255, 140, 163, 90,  255, 74,  109, 37,  255, 108, 140, 52,  255, 165, 188, 79,  255, 183, 203, 92,  255, 181, 200,
    92,  255, 181, 201, 90,  255, 187, 198, 80,  255, 212, 219, 112, 255, 192, 218, 132, 255, 179, 201, 121, 255, 175, 199, 136, 255, 208, 226, 160,
    255, 207, 222, 146, 255, 188, 212, 137, 255, 196, 220, 126, 255, 204, 226, 140, 255, 219, 236, 165, 255, 231, 243, 174, 255, 214, 227, 164, 255,
    178, 192, 131, 255, 213, 205, 95,  255, 200, 208, 96,  255, 159, 179, 102, 255, 144, 171, 98,  255, 133, 165, 87,  255, 128, 159, 84,  255, 128,
    157, 84,  255, 127, 156, 84,  255, 142, 159, 83,  255, 92,  115, 53,  255, 43,  75,  33,  255, 94,  120, 65,  255, 102, 136, 83,  255, 129, 156,
    82,  255, 100, 124, 49,  255, 116, 137, 58,  255, 171, 184, 79,  255, 173, 193, 87,  255, 177, 199, 101, 255, 194, 215, 118, 255, 199, 218, 133,
    255, 207, 217, 153, 255, 88,  94,  63,  255, 12,  25,  17,  255, 29,  44,  28,  255, 34,  48,  28,  255, 65,  87,  47,  255, 55,  75,  36,  255,
    49,  76,  34,  255, 89,  115, 47,  255, 163, 184, 65,  255, 134, 167, 58,  255, 89,  132, 52,  255, 89,  132, 56,  255, 98,  140, 73,  255, 90,
    132, 79,  255, 136, 167, 83,  255, 127, 144, 69,  255, 26,  40,  21,  255, 47,  72,  39,  255, 43,  68,  43,  255, 41,  62,  37,  255, 38,  60,
    28,  255, 29,  46,  26,  255, 36,  53,  29,  255, 42,  58,  36,  255, 38,  56,  31,  255, 55,  82,  39,  255, 67,  98,  46,  255, 72,  105, 49,
    255, 78,  115, 50,  255, 71,  99,  47,  255, 65,  92,  47,  255, 62,  87,  42,  255, 71,  99,  38,  255, 52,  76,  34,  255, 63,  87,  47,  255,
    98,  132, 45,  255, 109, 139, 55,  255, 141, 161, 79,  255, 169, 197, 115, 255, 155, 188, 111, 255, 172, 200, 124, 255, 190, 211, 130, 255, 176,
    197, 115, 255, 129, 160, 117, 255, 135, 166, 113, 255, 190, 206, 116, 255, 184, 197, 108, 255, 136, 169, 81,  255, 157, 179, 72,  255, 140, 168,
    67,  255, 145, 168, 73,  255, 152, 174, 77,  255, 149, 163, 80,  255, 158, 163, 108, 255, 168, 175, 121, 255, 161, 169, 115, 255, 119, 132, 76,
    255, 81,  101, 50,  255, 67,  87,  31,  255, 109, 126, 47,  255, 209, 217, 138, 255, 184, 208, 166, 255, 175, 203, 160, 255, 160, 178, 116, 255,
    155, 173, 74,  255, 137, 170, 49,  255, 137, 172, 53,  255, 149, 181, 65,  255, 186, 207, 93,  255, 158, 180, 65,  255, 143, 173, 60,  255, 152,
    175, 68,  255, 112, 138, 47,  255, 148, 176, 78,  255, 191, 212, 117, 255, 196, 211, 126, 255, 234, 236, 148, 255, 237, 236, 149, 255, 246, 243,
    154, 255, 238, 236, 134, 255, 230, 231, 136, 255, 230, 232, 120, 255, 224, 230, 104, 255, 225, 231, 107, 255, 253, 250, 120, 255, 255, 255, 109,
    255, 254, 250, 114, 255, 183, 193, 91,  255, 205, 217, 125, 255, 238, 239, 147, 255, 255, 254, 160, 255, 255, 253, 165, 255, 255, 255, 176, 255,
    255, 255, 176, 255, 255, 250, 171, 255, 251, 238, 115, 255, 243, 230, 76,  255, 241, 231, 89,  255, 243, 232, 91,  255, 235, 223, 82,  255, 207,
    198, 84,  255, 162, 160, 98,  255, 141, 163, 81,  255, 172, 187, 101, 255, 198, 201, 110, 255, 217, 219, 137, 255, 226, 239, 182, 255, 216, 234,
    183, 255, 222, 238, 187, 255, 217, 231, 179, 255, 205, 219, 147, 255, 160, 182, 123, 255, 92,  121, 58,  255, 112, 132, 56,  255, 164, 176, 101,
    255, 223, 229, 148, 255, 241, 245, 169, 255, 235, 241, 175, 255, 164, 179, 120, 255, 113, 139, 79,  255, 108, 145, 67,  255, 142, 170, 89,  255,
    154, 172, 92,  255, 125, 146, 55,  255, 135, 157, 47,  255, 165, 185, 63,  255, 176, 195, 84,  255, 181, 202, 101, 255, 176, 192, 87,  255, 165,
    182, 74,  255, 179, 197, 89,  255, 169, 177, 74,  255, 47,  58,  19,  255, 81,  105, 40,  255, 150, 172, 68,  255, 119, 145, 62,  255, 96,  123,
    60,  255, 87,  117, 62,  255, 126, 152, 81,  255, 116, 139, 65,  255, 136, 164, 92,  255, 165, 187, 100, 255, 151, 172, 86,  255, 133, 154, 65,
    255, 153, 168, 76,  255, 175, 190, 74,  255, 123, 151, 58,  255, 147, 171, 52,  255, 156, 178, 68,  255, 129, 157, 71,  255, 111, 139, 62,  255,
    69,  101, 36,  255, 78,  93,  39,  255, 126, 138, 94,  255, 166, 169, 90,  255, 136, 143, 63,  255, 69,  92,  32,  255, 55,  69,  28,  255, 48,
    63,  25,  255, 45,  62,  23,  255, 86,  104, 52,  255, 32,  58,  17,  255, 113, 136, 58,  255, 189, 211, 106, 255, 162, 187, 87,  255, 160, 186,
    101, 255, 160, 186, 112, 255, 156, 185, 113, 255, 158, 185, 114, 255, 142, 163, 77,  255, 69,  96,  32,  255, 67,  92,  36,  255, 90,  110, 58,
    255, 127, 147, 74,  255, 75,  95,  37,  255, 101, 131, 53,  255, 110, 147, 68,  255, 109, 140, 91,  255, 169, 175, 99,  255, 217, 235, 162, 255,
    206, 229, 179, 255, 175, 208, 149, 255, 162, 193, 105, 255, 168, 200, 106, 255, 178, 196, 102, 255, 112, 142, 68,  255, 133, 169, 98,  255, 143,
    173, 100, 255, 157, 188, 108, 255, 165, 196, 118, 255, 117, 148, 77,  255, 85,  108, 48,  255, 118, 142, 93,  255, 129, 148, 92,  255, 92,  124,
    68,  255, 139, 170, 132, 255, 176, 196, 145, 255, 225, 238, 174, 255, 207, 218, 141, 255, 159, 174, 102, 255, 114, 139, 68,  255, 111, 140, 47,
    255, 142, 159, 62,  255, 120, 138, 55,  255, 115, 142, 82,  255, 55,  79,  42,  255, 50,  68,  33,  255, 52,  72,  36,  255, 42,  68,  28,  255,
    67,  100, 44,  255, 95,  131, 74,  255, 110, 141, 75,  255, 130, 156, 74,  255, 84,  121, 52,  255, 60,  83,  32,  255, 103, 111, 50,  255, 154,
    173, 69,  255, 165, 186, 69,  255, 168, 188, 68,  255, 169, 191, 67,  255, 150, 176, 58,  255, 114, 133, 47,  255, 159, 175, 82,  255, 154, 176,
    91,  255, 176, 198, 112, 255, 180, 210, 118, 255, 176, 208, 111, 255, 181, 212, 119, 255, 192, 220, 136, 255, 203, 227, 161, 255, 208, 230, 182,
    255, 219, 238, 199, 255, 234, 249, 205, 255, 164, 174, 130, 255, 164, 161, 84,  255, 215, 213, 108, 255, 193, 201, 110, 255, 196, 200, 107, 255,
    209, 209, 98,  255, 198, 202, 90,  255, 193, 195, 89,  255, 203, 206, 100, 255, 179, 180, 75,  255, 71,  96,  44,  255, 62,  92,  60,  255, 82,
    110, 67,  255, 125, 153, 84,  255, 118, 138, 71,  255, 104, 124, 65,  255, 101, 127, 60,  255, 129, 151, 69,  255, 144, 167, 98,  255, 164, 190,
    145, 255, 191, 207, 151, 255, 146, 160, 86,  255, 55,  74,  26,  255, 43,  53,  34,  255, 39,  55,  33,  255, 28,  47,  31,  255, 34,  51,  31,
    255, 52,  68,  32,  255, 65,  92,  31,  255, 82,  110, 33,  255, 62,  87,  33,  255, 91,  104, 50,  255, 192, 198, 65,  255, 152, 181, 69,  255,
    108, 150, 65,  255, 106, 151, 62,  255, 115, 157, 86,  255, 166, 189, 104, 255, 140, 157, 80,  255, 26,  44,  19,  255, 46,  68,  36,  255, 49,
    76,  41,  255, 46,  68,  40,  255, 42,  71,  32,  255, 37,  60,  23,  255, 62,  101, 31,  255, 60,  95,  36,  255, 60,  89,  38,  255, 74,  111,
    37,  255, 75,  114, 48,  255, 75,  110, 58,  255, 82,  119, 60,  255, 79,  115, 58,  255, 84,  121, 62,  255, 92,  125, 58,  255, 114, 143, 62,
    255, 106, 133, 55,  255, 102, 130, 60,  255, 121, 151, 62,  255, 143, 170, 73,  255, 157, 179, 94,  255, 188, 204, 132, 255, 161, 189, 123, 255,
    145, 175, 105, 255, 181, 206, 149, 255, 156, 184, 136, 255, 130, 163, 114, 255, 154, 182, 101, 255, 180, 188, 91,  255, 123, 138, 58,  255, 136,
    155, 69,  255, 117, 146, 48,  255, 133, 164, 65,  255, 174, 194, 96,  255, 198, 214, 107, 255, 183, 200, 78,  255, 162, 177, 65,  255, 103, 132,
    49,  255, 90,  116, 53,  255, 115, 132, 74,  255, 95,  115, 52,  255, 111, 136, 60,  255, 119, 144, 67,  255, 199, 210, 125, 255, 191, 211, 163,
    255, 156, 178, 120, 255, 175, 192, 87,  255, 166, 189, 53,  255, 167, 191, 58,  255, 161, 185, 60,  255, 158, 184, 68,  255, 169, 192, 82,  255,
    149, 173, 68,  255, 116, 153, 45,  255, 121, 149, 60,  255, 112, 136, 49,  255, 126, 154, 55,  255, 160, 180, 77,  255, 191, 205, 97,  255, 222,
    228, 105, 255, 225, 230, 111, 255, 223, 228, 102, 255, 202, 216, 92,  255, 181, 203, 93,  255, 196, 212, 106, 255, 202, 215, 103, 255, 203, 215,
    102, 255, 187, 196, 86,  255, 225, 227, 104, 255, 177, 179, 74,  255, 109, 131, 52,  255, 124, 144, 62,  255, 141, 160, 73,  255, 157, 172, 78,
    255, 164, 175, 87,  255, 187, 195, 128, 255, 201, 207, 132, 255, 189, 196, 97,  255, 235, 231, 112, 255, 251, 238, 103, 255, 246, 234, 104, 255,
    248, 234, 87,  255, 249, 236, 90,  255, 255, 241, 92,  255, 194, 187, 79,  255, 179, 194, 101, 255, 211, 212, 121, 255, 220, 218, 132, 255, 219,
    219, 148, 255, 211, 217, 148, 255, 223, 238, 194, 255, 224, 234, 189, 255, 238, 243, 186, 255, 220, 221, 149, 255, 116, 133, 81,  255, 84,  111,
    48,  255, 118, 148, 67,  255, 92,  120, 68,  255, 110, 134, 74,  255, 117, 143, 77,  255, 106, 127, 72,  255, 69,  101, 49,  255, 69,  103, 56,
    255, 94,  134, 65,  255, 110, 148, 60,  255, 126, 150, 50,  255, 152, 168, 71,  255, 153, 171, 62,  255, 172, 189, 68,  255, 178, 195, 73,  255,
    182, 200, 108, 255, 159, 174, 98,  255, 164, 181, 81,  255, 191, 203, 93,  255, 171, 185, 74,  255, 85,  104, 38,  255, 25,  36,  19,  255, 104,
    128, 55,  255, 149, 167, 74,  255, 138, 161, 86,  255, 145, 172, 97,  255, 146, 173, 95,  255, 153, 176, 107, 255, 172, 198, 131, 255, 196, 215,
    125, 255, 153, 177, 79,  255, 130, 158, 63,  255, 127, 152, 72,  255, 182, 192, 75,  255, 139, 160, 62,  255, 127, 153, 56,  255, 159, 179, 63,
    255, 137, 164, 77,  255, 103, 133, 52,  255, 102, 124, 49,  255, 122, 131, 77,  255, 157, 157, 69,  255, 234, 226, 144, 255, 227, 225, 141, 255,
    189, 185, 110, 255, 184, 185, 122, 255, 182, 188, 134, 255, 203, 202, 146, 255, 141, 151, 89,  255, 60,  80,  31,  255, 47,  73,  26,  255, 127,
    147, 67,  255, 187, 202, 96,  255, 185, 201, 103, 255, 179, 197, 118, 255, 169, 192, 121, 255, 159, 186, 113, 255, 149, 175, 87,  255, 77,  102,
    34,  255, 41,  55,  29,  255, 47,  52,  26,  255, 119, 136, 60,  255, 120, 142, 67,  255, 114, 145, 90,  255, 117, 148, 84,  255, 111, 143, 97,
    255, 132, 163, 92,  255, 174, 187, 106, 255, 162, 183, 118, 255, 152, 184, 131, 255, 145, 179, 107, 255, 155, 183, 92,  255, 197, 215, 136, 255,
    140, 170, 99,  255, 151, 174, 79,  255, 134, 161, 75,  255, 152, 182, 86,  255, 184, 209, 105, 255, 169, 194, 109, 255, 158, 191, 104, 255, 144,
    177, 97,  255, 136, 159, 97,  255, 58,  76,  34,  255, 112, 151, 91,  255, 117, 150, 97,  255, 118, 141, 92,  255, 76,  89,  55,  255, 42,  62,
    33,  255, 58,  86,  33,  255, 92,  115, 47,  255, 106, 144, 55,  255, 128, 161, 52,  255, 141, 162, 58,  255, 77,  84,  38,  255, 52,  76,  36,
    255, 51,  80,  36,  255, 44,  72,  38,  255, 94,  130, 65,  255, 103, 138, 76,  255, 97,  134, 83,  255, 130, 162, 82,  255, 125, 166, 55,  255,
    120, 151, 60,  255, 73,  92,  44,  255, 122, 148, 74,  255, 138, 166, 89,  255, 139, 166, 82,  255, 130, 162, 68,  255, 74,  103, 42,  255, 49,
    76,  36,  255, 84,  111, 43,  255, 123, 138, 63,  255, 185, 199, 104, 255, 208, 217, 119, 255, 219, 228, 133, 255, 219, 230, 148, 255, 220, 231,
    164, 255, 221, 231, 174, 255, 217, 229, 174, 255, 224, 230, 153, 255, 191, 197, 121, 255, 99,  105, 75,  255, 40,  47,  29,  255, 68,  76,  37,
    255, 166, 168, 84,  255, 166, 172, 83,  255, 142, 149, 73,  255, 151, 153, 81,  255, 163, 165, 84,  255, 167, 175, 84,  255, 115, 137, 62,  255,
    65,  90,  43,  255, 72,  102, 65,  255, 93,  115, 71,  255, 141, 157, 78,  255, 194, 210, 111, 255, 194, 214, 119, 255, 155, 184, 102, 255, 99,
    128, 65,  255, 117, 139, 72,  255, 163, 188, 133, 255, 191, 207, 143, 255, 89,  106, 47,  255, 47,  80,  23,  255, 40,  62,  26,  255, 41,  55,
    31,  255, 65,  92,  37,  255, 67,  97,  36,  255, 71,  99,  39,  255, 92,  126, 36,  255, 130, 161, 46,  255, 119, 147, 47,  255, 38,  60,  38,
    255, 74,  91,  49,  255, 141, 148, 65,  255, 150, 164, 71,  255, 159, 177, 74,  255, 147, 173, 85,  255, 185, 196, 117, 255, 123, 143, 65,  255,
    36,  58,  23,  255, 31,  46,  23,  255, 50,  76,  38,  255, 40,  63,  36,  255, 41,  63,  36,  255, 42,  63,  32,  255, 65,  95,  33,  255, 81,
    117, 38,  255, 80,  112, 48,  255, 84,  122, 42,  255, 77,  107, 39,  255, 71,  101, 56,  255, 77,  111, 60,  255, 82,  114, 62,  255, 100, 131,
    68,  255, 114, 143, 63,  255, 104, 132, 71,  255, 122, 150, 67,  255, 121, 154, 65,  255, 126, 154, 68,  255, 160, 185, 74,  255, 150, 173, 78,
    255, 151, 167, 91,  255, 174, 194, 135, 255, 153, 179, 121, 255, 163, 190, 120, 255, 203, 221, 167, 255, 149, 177, 114, 255, 186, 201, 115, 255,
    154, 160, 75,  255, 85,  109, 40,  255, 60,  84,  31,  255, 82,  102, 41,  255, 141, 164, 69,  255, 221, 228, 132, 255, 224, 229, 127, 255, 216,
    222, 105, 255, 233, 235, 129, 255, 135, 148, 67,  255, 123, 153, 75,  255, 163, 187, 81,  255, 162, 186, 78,  255, 158, 185, 87,  255, 140, 173,
    82,  255, 155, 179, 93,  255, 168, 188, 119, 255, 150, 172, 68,  255, 181, 202, 72,  255, 170, 193, 68,  255, 163, 187, 58,  255, 147, 169, 63,
    255, 140, 165, 74,  255, 135, 164, 68,  255, 153, 186, 99,  255, 153, 182, 84,  255, 136, 162, 74,  255, 138, 166, 67,  255, 135, 162, 62,  255,
    191, 200, 103, 255, 206, 206, 92,  255, 205, 207, 100, 255, 187, 199, 77,  255, 168, 191, 74,  255, 173, 200, 97,  255, 206, 220, 126, 255, 224,
    229, 137, 255, 222, 228, 135, 255, 222, 230, 127, 255, 123, 128, 55,  255, 68,  81,  32,  255, 81,  108, 36,  255, 65,  102, 37,  255, 63,  100,
    44,  255, 83,  119, 37,  255, 101, 126, 40,  255, 112, 136, 43,  255, 101, 126, 49,  255, 137, 163, 78,  255, 156, 171, 74,  255, 216, 218, 110,
    255, 255, 249, 131, 255, 255, 250, 116, 255, 255, 243, 101, 255, 255, 238, 98,  255, 243, 227, 86,  255, 206, 207, 74,  255, 210, 214, 87,  255,
    218, 219, 92,  255, 225, 223, 108, 255, 183, 176, 92,  255, 128, 141, 63,  255, 167, 186, 131, 255, 212, 232, 197, 255, 214, 235, 200, 255, 226,
    243, 209, 255, 221, 226, 181, 255, 115, 133, 65,  255, 75,  107, 45,  255, 76,  101, 55,  255, 88,  109, 67,  255, 55,  87,  21,  255, 94,  122,
    55,  255, 87,  123, 62,  255, 84,  120, 68,  255, 97,  133, 77,  255, 113, 145, 77,  255, 101, 126, 55,  255, 71,  92,  38,  255, 97,  119, 48,
    255, 146, 169, 69,  255, 183, 198, 74,  255, 222, 232, 183, 255, 168, 200, 127, 255, 180, 208, 116, 255, 216, 224, 167, 255, 204, 208, 145, 255,
    103, 112, 58,  255, 29,  34,  15,  255, 44,  68,  26,  255, 95,  115, 52,  255, 146, 163, 80,  255, 138, 157, 80,  255, 138, 163, 84,  255, 161,
    174, 95,  255, 191, 213, 136, 255, 161, 192, 125, 255, 156, 180, 86,  255, 140, 170, 75,  255, 124, 156, 71,  255, 182, 189, 76,  255, 161, 175,
    69,  255, 162, 174, 75,  255, 161, 184, 69,  255, 108, 136, 47,  255, 128, 142, 56,  255, 164, 175, 96,  255, 125, 143, 65,  255, 218, 217, 117,
    255, 238, 236, 156, 255, 220, 228, 152, 255, 192, 216, 161, 255, 178, 210, 162, 255, 189, 214, 167, 255, 170, 190, 125, 255, 121, 146, 58,  255,
    119, 146, 56,  255, 97,  114, 48,  255, 168, 177, 96,  255, 184, 208, 136, 255, 178, 204, 146, 255, 192, 211, 142, 255, 177, 198, 116, 255, 160,
    185, 109, 255, 158, 184, 101, 255, 84,  104, 40,  255, 25,  26,  19,  255, 75,  87,  31,  255, 167, 190, 81,  255, 130, 165, 107, 255, 109, 143,
    102, 255, 126, 151, 89,  255, 122, 155, 93,  255, 149, 174, 85,  255, 152, 158, 79,  255, 79,  107, 43,  255, 77,  111, 58,  255, 126, 153, 80,
    255, 114, 145, 56,  255, 125, 156, 75,  255, 184, 203, 110, 255, 161, 187, 73,  255, 104, 138, 43,  255, 87,  124, 43,  255, 77,  115, 49,  255,
    81,  114, 49,  255, 78,  95,  53,  255, 86,  104, 53,  255, 126, 149, 74,  255, 123, 147, 89,  255, 83,  118, 52,  255, 90,  122, 56,  255, 65,
    102, 36,  255, 63,  84,  38,  255, 49,  68,  36,  255, 44,  75,  29,  255, 90,  120, 49,  255, 65,  98,  34,  255, 82,  124, 40,  255, 75,  99,
    37,  255, 45,  58,  31,  255, 58,  87,  40,  255, 42,  65,  33,  255, 60,  79,  45,  255, 128, 169, 89,  255, 114, 149, 77,  255, 120, 155, 100,
    255, 124, 159, 107, 255, 149, 173, 90,  255, 110, 145, 58,  255, 96,  133, 65,  255, 105, 137, 71,  255, 130, 159, 81,  255, 120, 149, 72,  255,
    118, 149, 63,  255, 95,  124, 49,  255, 68,  92,  39,  255, 87,  117, 48,  255, 123, 142, 67,  255, 160, 181, 105, 255, 159, 184, 130, 255, 177,
    200, 147, 255, 188, 206, 154, 255, 185, 206, 147, 255, 183, 207, 148, 255, 212, 222, 151, 255, 197, 210, 124, 255, 169, 191, 96,  255, 87,  105,
    53,  255, 36,  53,  32,  255, 52,  80,  38,  255, 138, 148, 73,  255, 157, 171, 82,  255, 104, 130, 60,  255, 98,  123, 67,  255, 91,  119, 76,
    255, 105, 130, 77,  255, 94,  124, 60,  255, 67,  91,  44,  255, 75,  101, 58,  255, 121, 135, 72,  255, 195, 211, 106, 255, 170, 203, 89,  255,
    179, 208, 110, 255, 208, 226, 128, 255, 206, 219, 121, 255, 132, 152, 67,  255, 144, 166, 91,  255, 169, 183, 105, 255, 53,  72,  31,  255, 49,
    76,  31,  255, 51,  80,  28,  255, 63,  81,  33,  255, 150, 176, 53,  255, 132, 162, 44,  255, 99,  132, 50,  255, 159, 177, 106, 255, 179, 195,
    102, 255, 134, 158, 47,  255, 50,  75,  36,  255, 49,  71,  50,  255, 29,  40,  31,  255, 52,  69,  36,  255, 86,  111, 48,  255, 123, 148, 63,
    255, 110, 131, 60,  255, 91,  116, 47,  255, 103, 129, 65,  255, 39,  53,  31,  255, 29,  41,  26,  255, 36,  58,  31,  255, 43,  63,  36,  255,
    48,  75,  39,  255, 36,  55,  33,  255, 63,  84,  36,  255, 102, 133, 49,  255, 90,  118, 45,  255, 63,  90,  42,  255, 69,  97,  46,  255, 65,
    91,  36,  255, 124, 146, 69,  255, 133, 156, 75,  255, 104, 131, 73,  255, 77,  107, 68,  255, 83,  114, 63,  255, 107, 139, 62,  255, 97,  128,
    56,  255, 107, 136, 56,  255, 124, 148, 55,  255, 149, 175, 106, 255, 138, 170, 126, 255, 141, 173, 126, 255, 142, 173, 109, 255, 160, 182, 117,
    255, 203, 216, 136, 255, 176, 186, 91,  255, 109, 131, 53,  255, 113, 140, 56,  255, 108, 134, 52,  255, 95,  117, 47,  255, 124, 144, 58,  255,
    225, 230, 131, 255, 224, 228, 129, 255, 221, 227, 123, 255, 231, 235, 133, 255, 126, 137, 55,  255, 93,  115, 42,  255, 151, 176, 62,  255, 161,
    184, 86,  255, 145, 177, 81,  255, 131, 166, 62,  255, 130, 163, 60,  255, 134, 159, 71,  255, 163, 189, 76,  255, 184, 207, 118, 255, 176, 199,
    105, 255, 157, 182, 62,  255, 146, 169, 71,  255, 121, 147, 58,  255, 108, 135, 46,  255, 140, 169, 87,  255, 183, 210, 123, 255, 179, 208, 119,
    255, 173, 202, 105, 255, 157, 188, 84,  255, 155, 183, 83,  255, 120, 147, 58,  255, 121, 146, 58,  255, 165, 188, 62,  255, 167, 191, 65,  255,
    198, 213, 105, 255, 216, 226, 128, 255, 215, 224, 126, 255, 215, 224, 129, 255, 221, 229, 132, 255, 223, 230, 127, 255, 102, 105, 48,  255, 79,
    94,  38,  255, 131, 151, 62,  255, 108, 132, 55,  255, 124, 146, 49,  255, 209, 213, 74,  255, 196, 202, 58,  255, 151, 166, 48,  255, 119, 140,
    55,  255, 120, 139, 72,  255, 171, 185, 107, 255, 228, 223, 120, 255, 191, 182, 81,  255, 212, 206, 86,  255, 203, 201, 75,  255, 188, 194, 74,
    255, 192, 200, 73,  255, 221, 217, 92,  255, 234, 228, 118, 255, 231, 229, 121, 255, 229, 230, 129, 255, 199, 194, 110, 255, 74,  81,  34,  255,
    184, 203, 178, 255, 212, 234, 201, 255, 206, 227, 196, 255, 230, 241, 199, 255, 197, 202, 135, 255, 75,  104, 52,  255, 72,  99,  56,  255, 98,
    113, 75,  255, 55,  67,  37,  255, 97,  121, 63,  255, 117, 143, 65,  255, 108, 143, 82,  255, 88,  121, 81,  255, 84,  113, 76,  255, 89,  118,
    79,  255, 80,  108, 68,  255, 114, 140, 62,  255, 142, 165, 60,  255, 130, 153, 55,  255, 166, 182, 123, 255, 176, 206, 127, 255, 189, 215, 164,
    255, 207, 226, 190, 255, 204, 217, 168, 255, 129, 132, 97,  255, 197, 197, 141, 255, 187, 193, 123, 255, 144, 151, 84,  255, 85,  103, 40,  255,
    84,  116, 36,  255, 62,  101, 26,  255, 106, 122, 60,  255, 138, 163, 90,  255, 153, 183, 98,  255, 149, 171, 68,  255, 168, 185, 75,  255, 189,
    200, 85,  255, 219, 220, 105, 255, 206, 211, 114, 255, 141, 162, 72,  255, 144, 170, 58,  255, 133, 149, 55,  255, 165, 177, 94,  255, 106, 126,
    62,  255, 176, 185, 106, 255, 211, 224, 155, 255, 214, 224, 152, 255, 193, 213, 157, 255, 173, 200, 159, 255, 196, 214, 151, 255, 196, 201, 126,
    255, 98,  102, 49,  255, 136, 154, 74,  255, 137, 152, 74,  255, 187, 201, 108, 255, 187, 213, 142, 255, 142, 175, 131, 255, 175, 195, 135, 255,
    186, 207, 111, 255, 141, 177, 75,  255, 159, 187, 103, 255, 161, 188, 104, 255, 96,  125, 45,  255, 103, 108, 52,  255, 149, 161, 68,  255, 165,
    187, 93,  255, 110, 144, 106, 255, 116, 150, 113, 255, 105, 133, 74,  255, 142, 167, 86,  255, 142, 164, 74,  255, 86,  118, 47,  255, 99,  132,
    58,  255, 112, 147, 60,  255, 128, 165, 58,  255, 147, 167, 65,  255, 95,  117, 41,  255, 101, 132, 53,  255, 114, 139, 50,  255, 81,  110, 39,
    255, 60,  89,  37,  255, 58,  84,  39,  255, 68,  102, 36,  255, 96,  112, 49,  255, 122, 128, 47,  255, 158, 166, 71,  255, 109, 118, 67,  255,
    71,  97,  55,  255, 89,  118, 60,  255, 80,  113, 58,  255, 83,  114, 53,  255, 52,  80,  31,  255, 65,  96,  37,  255, 85,  113, 47,  255, 68,
    87,  40,  255, 69,  98,  39,  255, 33,  44,  25,  255, 38,  53,  28,  255, 47,  74,  34,  255, 33,  49,  25,  255, 62,  83,  39,  255, 182, 203,
    100, 255, 142, 178, 93,  255, 131, 168, 103, 255, 139, 175, 123, 255, 155, 179, 104, 255, 114, 145, 46,  255, 111, 143, 58,  255, 92,  129, 68,
    255, 113, 144, 71,  255, 133, 164, 74,  255, 124, 154, 75,  255, 123, 154, 77,  255, 117, 151, 77,  255, 108, 136, 65,  255, 141, 159, 89,  255,
    157, 182, 136, 255, 162, 188, 149, 255, 163, 193, 141, 255, 166, 196, 135, 255, 180, 204, 140, 255, 218, 227, 150, 255, 232, 234, 143, 255, 194,
    210, 117, 255, 186, 205, 110, 255, 150, 170, 90,  255, 58,  90,  42,  255, 53,  86,  41,  255, 106, 117, 62,  255, 167, 176, 87,  255, 121, 145,
    63,  255, 99,  126, 58,  255, 93,  120, 68,  255, 83,  111, 68,  255, 90,  119, 62,  255, 78,  106, 47,  255, 103, 121, 58,  255, 159, 180, 103,
    255, 168, 190, 122, 255, 211, 221, 121, 255, 197, 218, 100, 255, 175, 206, 114, 255, 195, 219, 138, 255, 221, 233, 139, 255, 154, 171, 75,  255,
    93,  116, 52,  255, 55,  79,  43,  255, 55,  84,  37,  255, 55,  87,  31,  255, 58,  80,  33,  255, 146, 160, 49,  255, 169, 187, 73,  255, 200,
    209, 139, 255, 254, 251, 179, 255, 203, 213, 104, 255, 136, 151, 47,  255, 29,  42,  23,  255, 40,  58,  34,  255, 38,  53,  31,  255, 47,  75,
    36,  255, 86,  118, 48,  255, 124, 159, 60,  255, 84,  125, 47,  255, 74,  107, 39,  255, 114, 141, 72,  255, 102, 131, 72,  255, 26,  39,  25,
    255, 26,  38,  23,  255, 47,  71,  36,  255, 44,  72,  36,  255, 38,  63,  34,  255, 36,  62,  32,  255, 49,  68,  31,  255, 45,  65,  31,  255,
    58,  81,  39,  255, 50,  71,  33,  255, 36,  55,  23,  255, 94,  110, 52,  255, 126, 148, 73,  255, 90,  121, 65,  255, 135, 155, 77,  255, 109,
    135, 68,  255, 83,  113, 62,  255, 87,  118, 58,  255, 79,  108, 52,  255, 92,  123, 60,  255, 139, 171, 115, 255, 136, 169, 112, 255, 123, 159,
    97,  255, 117, 153, 100, 255, 138, 169, 113, 255, 170, 187, 99,  255, 96,  119, 55,  255, 75,  108, 56,  255, 84,  113, 55,  255, 89,  121, 55,
    255, 107, 139, 55,  255, 96,  113, 43,  255, 189, 195, 110, 255, 238, 241, 142, 255, 241, 243, 145, 255, 173, 180, 87,  255, 67,  96,  31,  255,
    80,  110, 33,  255, 145, 173, 68,  255, 157, 184, 84,  255, 148, 179, 68,  255, 153, 183, 58,  255, 134, 153, 55,  255, 138, 154, 75,  255, 168,
    196, 113, 255, 163, 196, 126, 255, 163, 195, 122, 255, 159, 188, 111, 255, 173, 195, 107, 255, 121, 139, 58,  255, 101, 123, 56,  255, 185, 209,
    124, 255, 184, 210, 122, 255, 179, 208, 120, 255, 182, 208, 117, 255, 166, 194, 103, 255, 162, 193, 97,  255, 130, 159, 60,  255, 148, 169, 56,
    255, 228, 234, 101, 255, 216, 225, 97,  255, 215, 224, 95,  255, 215, 225, 117, 255, 210, 223, 126, 255, 211, 223, 126, 255, 216, 224, 124, 255,
    220, 230, 123, 255, 207, 211, 106, 255, 167, 172, 73,  255, 177, 180, 75,  255, 163, 169, 67,  255, 196, 199, 69,  255, 225, 222, 71,  255, 220,
    218, 76,  255, 193, 200, 78,  255, 143, 164, 68,  255, 130, 149, 69,  255, 113, 134, 72,  255, 157, 168, 73,  255, 129, 145, 48,  255, 140, 163,
    52,  255, 158, 178, 56,  255, 192, 207, 75,  255, 197, 202, 75,  255, 228, 226, 126, 255, 229, 232, 138, 255, 231, 236, 148, 255, 241, 241, 147,
    255, 192, 189, 96,  255, 155, 164, 104, 255, 199, 218, 194, 255, 204, 227, 205, 255, 194, 219, 191, 255, 209, 228, 192, 255, 192, 203, 141, 255,
    87,  112, 50,  255, 69,  100, 58,  255, 90,  109, 68,  255, 81,  91,  67,  255, 56,  75,  32,  255, 136, 160, 75,  255, 97,  132, 83,  255, 89,
    121, 86,  255, 95,  125, 87,  255, 97,  126, 86,  255, 108, 135, 90,  255, 129, 147, 76,  255, 105, 117, 45,  255, 65,  84,  32,  255, 52,  77,
    32,  255, 160, 188, 112, 255, 218, 225, 189, 255, 228, 241, 211, 255, 207, 221, 187, 255, 202, 217, 185, 255, 230, 245, 208, 255, 233, 245, 207,
    255, 228, 238, 202, 255, 198, 191, 145, 255, 118, 120, 56,  255, 110, 126, 48,  255, 112, 121, 60,  255, 91,  98,  50,  255, 116, 133, 55,  255,
    137, 160, 53,  255, 194, 208, 80,  255, 204, 215, 111, 255, 212, 219, 119, 255, 221, 222, 117, 255, 120, 146, 60,  255, 135, 162, 55,  255, 136,
    162, 89,  255, 97,  119, 62,  255, 135, 152, 83,  255, 186, 212, 149, 255, 192, 212, 154, 255, 204, 219, 161, 255, 183, 208, 151, 255, 196, 212,
    139, 255, 195, 208, 134, 255, 206, 214, 124, 255, 198, 200, 115, 255, 153, 170, 87,  255, 204, 215, 121, 255, 183, 206, 123, 255, 142, 177, 124,
    255, 141, 171, 114, 255, 184, 203, 117, 255, 115, 144, 69,  255, 110, 149, 58,  255, 138, 170, 75,  255, 161, 190, 103, 255, 114, 141, 55,  255,
    157, 169, 80,  255, 187, 203, 97,  255, 169, 188, 107, 255, 109, 141, 104, 255, 122, 156, 115, 255, 106, 138, 80,  255, 143, 170, 82,  255, 106,
    139, 52,  255, 92,  124, 47,  255, 101, 134, 52,  255, 117, 148, 60,  255, 146, 175, 74,  255, 162, 182, 77,  255, 143, 162, 65,  255, 81,  99,
    33,  255, 126, 152, 62,  255, 130, 158, 62,  255, 133, 161, 65,  255, 145, 167, 68,  255, 124, 145, 52,  255, 129, 151, 52,  255, 147, 166, 55,
    255, 153, 167, 62,  255, 138, 147, 71,  255, 99,  114, 63,  255, 114, 136, 71,  255, 89,  116, 56,  255, 94,  125, 68,  255, 52,  75,  36,  255,
    45,  67,  31,  255, 80,  110, 49,  255, 82,  105, 47,  255, 65,  83,  33,  255, 34,  40,  23,  255, 40,  62,  32,  255, 36,  55,  26,  255, 34,
    47,  29,  255, 29,  44,  32,  255, 94,  105, 52,  255, 180, 197, 97,  255, 161, 191, 116, 255, 162, 197, 137, 255, 144, 170, 105, 255, 53,  89,
    23,  255, 75,  102, 33,  255, 129, 155, 58,  255, 128, 160, 65,  255, 103, 137, 65,  255, 86,  121, 69,  255, 89,  122, 82,  255, 98,  134, 92,
    255, 109, 136, 78,  255, 154, 176, 123, 255, 160, 187, 152, 255, 154, 183, 129, 255, 163, 190, 123, 255, 194, 211, 136, 255, 225, 229, 141, 255,
    194, 197, 106, 255, 157, 175, 84,  255, 153, 172, 81,  255, 136, 157, 68,  255, 97,  123, 50,  255, 60,  89,  42,  255, 58,  86,  41,  255, 55,
    77,  41,  255, 138, 147, 71,  255, 153, 168, 75,  255, 115, 143, 62,  255, 87,  116, 58,  255, 82,  110, 65,  255, 91,  114, 69,  255, 99,  120,
    63,  255, 134, 159, 90,  255, 150, 181, 128, 255, 130, 167, 130, 255, 150, 176, 131, 255, 206, 214, 135, 255, 223, 233, 129, 255, 200, 223, 129,
    255, 199, 224, 153, 255, 217, 230, 156, 255, 118, 138, 73,  255, 60,  87,  47,  255, 60,  91,  41,  255, 58,  90,  33,  255, 36,  56,  25,  255,
    127, 132, 82,  255, 243, 243, 167, 255, 248, 249, 175, 255, 238, 239, 162, 255, 187, 200, 89,  255, 109, 120, 44,  255, 21,  32,  23,  255, 26,
    33,  23,  255, 34,  51,  28,  255, 36,  58,  26,  255, 75,  98,  38,  255, 152, 180, 65,  255, 90,  131, 45,  255, 84,  123, 50,  255, 110, 143,
    52,  255, 115, 146, 65,  255, 80,  101, 53,  255, 34,  51,  23,  255, 44,  68,  31,  255, 40,  63,  28,  255, 42,  62,  28,  255, 42,  67,  29,
    255, 34,  55,  26,  255, 34,  49,  26,  255, 40,  58,  28,  255, 50,  71,  33,  255, 60,  79,  49,  255, 65,  81,  40,  255, 135, 158, 89,  255,
    132, 155, 77,  255, 110, 138, 65,  255, 174, 188, 81,  255, 147, 167, 82,  255, 172, 193, 96,  255, 136, 159, 58,  255, 96,  130, 60,  255, 114,
    154, 84,  255, 122, 159, 96,  255, 129, 166, 113, 255, 141, 173, 112, 255, 148, 172, 98,  255, 109, 131, 75,  255, 69,  100, 53,  255, 75,  108,
    49,  255, 65,  102, 42,  255, 94,  128, 47,  255, 130, 145, 65,  255, 69,  96,  46,  255, 121, 150, 74,  255, 202, 209, 121, 255, 155, 168, 90,
    255, 93,  124, 58,  255, 72,  107, 58,  255, 52,  87,  36,  255, 126, 152, 67,  255, 164, 186, 78,  255, 144, 164, 65,  255, 132, 149, 55,  255,
    94,  112, 37,  255, 103, 129, 47,  255, 176, 195, 105, 255, 175, 196, 107, 255, 145, 171, 87,  255, 170, 199, 134, 255, 166, 197, 135, 255, 164,
    190, 113, 255, 156, 180, 96,  255, 195, 217, 132, 255, 188, 211, 125, 255, 185, 210, 122, 255, 176, 202, 111, 255, 162, 191, 98,  255, 163, 193,
    92,  255, 138, 167, 68,  255, 124, 152, 52,  255, 243, 241, 123, 255, 232, 235, 120, 255, 223, 230, 105, 255, 222, 228, 109, 255, 215, 226, 128,
    255, 209, 223, 127, 255, 212, 222, 122, 255, 214, 224, 116, 255, 206, 211, 107, 255, 109, 114, 47,  255, 161, 169, 67,  255, 164, 171, 68,  255,
    203, 204, 78,  255, 183, 193, 96,  255, 165, 185, 102, 255, 150, 174, 80,  255, 151, 178, 80,  255, 183, 201, 81,  255, 142, 148, 60,  255, 139,
    154, 82,  255, 163, 174, 67,  255, 138, 163, 48,  255, 157, 181, 55,  255, 193, 211, 65,  255, 211, 220, 106, 255, 232, 233, 143, 255, 241, 239,
    152, 255, 246, 243, 146, 255, 210, 206, 103, 255, 155, 165, 68,  255, 149, 160, 79,  255, 202, 205, 140, 255, 227, 234, 198, 255, 224, 231, 192,
    255, 224, 232, 175, 255, 198, 206, 134, 255, 116, 125, 68,  255, 63,  92,  47,  255, 65,  78,  46,  255, 103, 123, 82,  255, 91,  117, 47,  255,
    132, 164, 91,  255, 92,  129, 87,  255, 96,  127, 95,  255, 103, 132, 99,  255, 105, 134, 101, 255, 139, 165, 105, 255, 131, 149, 81,  255, 53,
    68,  38,  255, 26,  46,  19,  255, 33,  48,  21,  255, 34,  48,  21,  255, 104, 113, 58,  255, 202, 214, 144, 255, 205, 216, 174, 255, 227, 241,
    213, 255, 219, 236, 213, 255, 216, 234, 208, 255, 212, 232, 205, 255, 230, 243, 200, 255, 243, 241, 181, 255, 229, 230, 163, 255, 183, 193, 137,
    255, 174, 182, 120, 255, 202, 209, 143, 255, 182, 190, 101, 255, 192, 202, 109, 255, 189, 204, 120, 255, 212, 217, 100, 255, 155, 169, 68,  255,
    134, 149, 65,  255, 151, 166, 75,  255, 142, 151, 91,  255, 130, 139, 74,  255, 183, 204, 146, 255, 171, 200, 152, 255, 194, 214, 154, 255, 182,
    204, 125, 255, 200, 216, 132, 255, 195, 210, 141, 255, 151, 178, 130, 255, 193, 209, 125, 255, 173, 187, 103, 255, 167, 173, 63,  255, 205, 218,
    115, 255, 150, 182, 110, 255, 132, 166, 102, 255, 152, 180, 109, 255, 156, 179, 102, 255, 101, 129, 53,  255, 110, 141, 49,  255, 123, 149, 62,
    255, 149, 170, 76,  255, 159, 178, 73,  255, 166, 182, 75,  255, 177, 194, 109, 255, 131, 158, 107, 255, 103, 139, 100, 255, 115, 148, 102, 255,
    124, 156, 87,  255, 96,  125, 58,  255, 97,  128, 47,  255, 65,  87,  43,  255, 33,  48,  23,  255, 58,  84,  31,  255, 112, 137, 52,  255, 147,
    163, 67,  255, 141, 162, 62,  255, 116, 140, 52,  255, 120, 153, 58,  255, 164, 193, 68,  255, 168, 191, 75,  255, 183, 203, 95,  255, 197, 212,
    103, 255, 130, 144, 55,  255, 112, 131, 44,  255, 132, 153, 68,  255, 124, 152, 73,  255, 117, 140, 65,  255, 124, 154, 75,  255, 115, 145, 62,
    255, 107, 133, 52,  255, 62,  74,  34,  255, 55,  62,  32,  255, 126, 148, 65,  255, 157, 180, 86,  255, 185, 199, 107, 255, 141, 138, 78,  255,
    28,  43,  21,  255, 26,  41,  23,  255, 28,  42,  31,  255, 36,  47,  34,  255, 49,  63,  34,  255, 103, 120, 47,  255, 145, 158, 82,  255, 177,
    198, 130, 255, 152, 177, 115, 255, 65,  100, 39,  255, 71,  107, 37,  255, 124, 153, 65,  255, 84,  121, 60,  255, 72,  106, 62,  255, 85,  117,
    75,  255, 95,  127, 84,  255, 98,  131, 85,  255, 114, 139, 74,  255, 156, 182, 136, 255, 157, 187, 127, 255, 169, 192, 114, 255, 198, 208, 116,
    255, 195, 201, 110, 255, 129, 146, 83,  255, 96,  124, 52,  255, 92,  123, 34,  255, 103, 132, 48,  255, 108, 135, 56,  255, 106, 135, 58,  255,
    58,  83,  43,  255, 52,  75,  44,  255, 47,  75,  44,  255, 67,  87,  42,  255, 144, 155, 69,  255, 147, 167, 68,  255, 116, 143, 60,  255, 92,
    121, 62,  255, 89,  116, 68,  255, 116, 137, 74,  255, 153, 180, 130, 255, 139, 173, 133, 255, 131, 167, 123, 255, 123, 160, 116, 255, 158, 180,
    119, 255, 185, 201, 132, 255, 197, 211, 136, 255, 200, 216, 132, 255, 228, 236, 166, 255, 186, 201, 121, 255, 102, 130, 58,  255, 71,  100, 43,
    255, 42,  68,  25,  255, 118, 123, 86,  255, 246, 245, 182, 255, 243, 245, 174, 255, 245, 245, 167, 255, 232, 233, 157, 255, 161, 176, 92,  255,
    73,  96,  37,  255, 28,  41,  26,  255, 33,  52,  26,  255, 36,  58,  28,  255, 36,  53,  29,  255, 44,  68,  31,  255, 135, 157, 65,  255, 143,
    172, 65,  255, 94,  132, 60,  255, 133, 166, 58,  255, 166, 186, 56,  255, 123, 144, 65,  255, 41,  55,  29,  255, 29,  42,  23,  255, 26,  38,
    25,  255, 26,  38,  25,  255, 36,  55,  26,  255, 29,  43,  26,  255, 25,  33,  23,  255, 52,  76,  31,  255, 43,  72,  23,  255, 49,  73,  36,
    255, 94,  110, 60,  255, 130, 157, 79,  255, 89,  125, 63,  255, 86,  123, 56,  255, 128, 156, 86,  255, 167, 181, 93,  255, 183, 194, 87,  255,
    148, 168, 67,  255, 129, 159, 63,  255, 148, 178, 75,  255, 157, 183, 102, 255, 156, 172, 94,  255, 148, 166, 75,  255, 91,  115, 52,  255, 65,
    97,  50,  255, 65,  103, 45,  255, 71,  109, 38,  255, 104, 139, 46,  255, 117, 130, 47,  255, 69,  84,  43,  255, 82,  123, 55,  255, 80,  116,
    56,  255, 77,  112, 55,  255, 69,  105, 55,  255, 79,  112, 69,  255, 85,  117, 80,  255, 73,  108, 60,  255, 93,  121, 39,  255, 112, 130, 47,
    255, 78,  96,  32,  255, 97,  121, 58,  255, 167, 192, 109, 255, 174, 193, 96,  255, 136, 159, 60,  255, 113, 140, 50,  255, 84,  116, 34,  255,
    132, 158, 82,  255, 180, 201, 132, 255, 193, 214, 149, 255, 195, 214, 130, 255, 189, 212, 125, 255, 188, 211, 122, 255, 183, 207, 118, 255, 168,
    194, 101, 255, 163, 192, 94,  255, 169, 195, 93,  255, 146, 173, 75,  255, 107, 148, 60,  255, 173, 188, 87,  255, 245, 241, 130, 255, 238, 238,
    129, 255, 223, 229, 111, 255, 217, 226, 107, 255, 210, 224, 124, 255, 205, 219, 123, 255, 207, 220, 117, 255, 224, 232, 123, 255, 83,  83,  36,
    255, 74,  85,  36,  255, 160, 170, 55,  255, 195, 201, 111, 255, 169, 189, 113, 255, 154, 181, 82,  255, 175, 195, 84,  255, 208, 213, 80,  255,
    223, 222, 91,  255, 208, 206, 100, 255, 183, 189, 100, 255, 167, 176, 84,  255, 183, 196, 82,  255, 195, 210, 81,  255, 208, 222, 91,  255, 222,
    229, 127, 255, 238, 238, 141, 255, 236, 233, 129, 255, 208, 211, 116, 255, 175, 185, 90,  255, 186, 203, 116, 255, 187, 211, 115, 255, 218, 228,
    154, 255, 228, 236, 181, 255, 215, 227, 153, 255, 212, 226, 162, 255, 163, 187, 114, 255, 114, 126, 62,  255, 71,  84,  39,  255, 58,  79,  32,
    255, 113, 132, 89,  255, 106, 129, 63,  255, 126, 156, 91,  255, 99,  131, 99,  255, 106, 137, 106, 255, 115, 146, 114, 255, 113, 145, 115, 255,
    134, 162, 109, 255, 190, 209, 120, 255, 111, 133, 72,  255, 23,  40,  17,  255, 29,  41,  21,  255, 29,  43,  19,  255, 78,  94,  34,  255, 165,
    180, 76,  255, 157, 169, 74,  255, 185, 196, 118, 255, 220, 233, 181, 255, 226, 243, 213, 255, 215, 234, 212, 255, 214, 231, 204, 255, 215, 232,
    200, 255, 225, 238, 187, 255, 189, 200, 141, 255, 166, 183, 131, 255, 196, 221, 181, 255, 193, 216, 160, 255, 196, 212, 138, 255, 202, 211, 98,
    255, 200, 202, 102, 255, 200, 199, 139, 255, 239, 238, 179, 255, 232, 238, 174, 255, 231, 238, 171, 255, 238, 241, 177, 255, 215, 225, 163, 255,
    180, 204, 154, 255, 196, 213, 140, 255, 178, 202, 97,  255, 177, 202, 96,  255, 167, 193, 129, 255, 151, 177, 130, 255, 181, 201, 124, 255, 157,
    172, 89,  255, 188, 192, 74,  255, 175, 200, 106, 255, 137, 170, 98,  255, 138, 169, 92,  255, 167, 188, 98,  255, 116, 141, 65,  255, 127, 157,
    65,  255, 107, 143, 49,  255, 60,  94,  52,  255, 74,  101, 53,  255, 123, 152, 65,  255, 129, 155, 67,  255, 93,  128, 65,  255, 81,  117, 72,
    255, 87,  126, 73,  255, 119, 150, 71,  255, 144, 165, 77,  255, 95,  114, 52,  255, 99,  123, 62,  255, 32,  43,  28,  255, 69,  82,  43,  255,
    86,  114, 47,  255, 87,  119, 55,  255, 99,  127, 60,  255, 104, 136, 58,  255, 87,  125, 39,  255, 81,  121, 40,  255, 153, 178, 74,  255, 205,
    221, 110, 255, 212, 224, 120, 255, 224, 232, 138, 255, 178, 186, 96,  255, 137, 157, 65,  255, 145, 166, 68,  255, 138, 163, 75,  255, 106, 136,
    74,  255, 92,  119, 65,  255, 87,  123, 72,  255, 96,  131, 69,  255, 125, 154, 68,  255, 146, 173, 74,  255, 162, 192, 95,  255, 175, 200, 109,
    255, 163, 187, 108, 255, 111, 119, 76,  255, 25,  31,  21,  255, 25,  31,  19,  255, 69,  76,  40,  255, 115, 132, 62,  255, 127, 153, 63,  255,
    140, 171, 76,  255, 128, 160, 80,  255, 85,  108, 52,  255, 85,  109, 67,  255, 57,  84,  52,  255, 81,  106, 55,  255, 129, 156, 78,  255, 154,
    171, 94,  255, 162, 182, 102, 255, 140, 164, 84,  255, 124, 155, 77,  255, 112, 147, 80,  255, 124, 151, 77,  255, 161, 184, 105, 255, 168, 189,
    93,  255, 160, 180, 83,  255, 120, 141, 58,  255, 84,  111, 43,  255, 103, 132, 77,  255, 100, 130, 73,  255, 95,  125, 39,  255, 103, 132, 47,
    255, 109, 136, 55,  255, 116, 143, 62,  255, 65,  89,  41,  255, 38,  56,  36,  255, 55,  79,  46,  255, 53,  79,  41,  255, 63,  84,  39,  255,
    106, 119, 48,  255, 142, 160, 65,  255, 141, 164, 68,  255, 104, 129, 52,  255, 136, 158, 103, 255, 146, 175, 136, 255, 130, 166, 119, 255, 121,
    158, 114, 255, 122, 155, 108, 255, 183, 198, 116, 255, 149, 182, 122, 255, 136, 174, 120, 255, 144, 175, 108, 255, 174, 191, 101, 255, 195, 210,
    108, 255, 165, 187, 91,  255, 55,  81,  34,  255, 103, 112, 67,  255, 250, 249, 180, 255, 248, 248, 177, 255, 241, 241, 168, 255, 255, 254, 177,
    255, 192, 196, 128, 255, 77,  107, 42,  255, 92,  124, 50,  255, 48,  62,  36,  255, 40,  62,  26,  255, 43,  71,  29,  255, 39,  60,  33,  255,
    39,  62,  31,  255, 73,  97,  39,  255, 172, 187, 87,  255, 144, 170, 87,  255, 173, 191, 77,  255, 201, 206, 65,  255, 150, 163, 69,  255, 58,
    75,  38,  255, 62,  80,  42,  255, 36,  42,  31,  255, 15,  19,  21,  255, 21,  33,  26,  255, 28,  42,  33,  255, 29,  43,  29,  255, 62,  84,
    37,  255, 60,  91,  31,  255, 53,  83,  26,  255, 80,  101, 42,  255, 142, 165, 79,  255, 93,  130, 65,  255, 102, 136, 68,  255, 145, 171, 100,
    255, 140, 165, 99,  255, 107, 140, 47,  255, 106, 131, 47,  255, 163, 181, 77,  255, 177, 195, 87,  255, 159, 181, 78,  255, 138, 148, 72,  255,
    116, 128, 74,  255, 67,  98,  50,  255, 69,  105, 42,  255, 89,  124, 38,  255, 131, 159, 46,  255, 124, 147, 42,  255, 81,  105, 37,  255, 65,
    99,  41,  255, 69,  102, 50,  255, 63,  92,  55,  255, 65,  98,  60,  255, 72,  104, 65,  255, 82,  112, 69,  255, 78,  110, 65,  255, 97,  131,
    60,  255, 100, 131, 50,  255, 84,  113, 53,  255, 99,  122, 55,  255, 178, 197, 120, 255, 182, 197, 102, 255, 124, 147, 48,  255, 100, 133, 41,
    255, 100, 133, 50,  255, 92,  126, 47,  255, 77,  113, 33,  255, 89,  120, 41,  255, 134, 158, 79,  255, 185, 206, 116, 255, 187, 210, 120, 255,
    186, 209, 126, 255, 178, 204, 115, 255, 169, 195, 100, 255, 171, 196, 96,  255, 169, 192, 80,  255, 140, 169, 74,  255, 123, 160, 78,  255, 98,
    132, 48,  255, 129, 150, 60,  255, 222, 224, 118, 255, 238, 243, 127, 255, 220, 230, 108, 255, 215, 227, 112, 255, 210, 224, 126, 255, 210, 223,
    122, 255, 229, 235, 131, 255, 129, 131, 60,  255, 29,  44,  15,  255, 90,  107, 38,  255, 176, 188, 106, 255, 177, 192, 95,  255, 170, 179, 67,
    255, 172, 177, 65,  255, 198, 202, 87,  255, 233, 231, 123, 255, 234, 234, 128, 255, 238, 235, 125, 255, 208, 205, 100, 255, 153, 168, 62,  255,
    192, 204, 72,  255, 198, 211, 91,  255, 219, 226, 104, 255, 218, 221, 98,  255, 182, 192, 97,  255, 173, 195, 130, 255, 198, 216, 172, 255, 229,
    243, 210, 255, 199, 225, 172, 255, 174, 205, 121, 255, 214, 230, 159, 255, 199, 210, 139, 255, 203, 225, 172, 255, 146, 175, 110, 255, 154, 181,
    98,  255, 152, 177, 94,  255, 60,  75,  34,  255, 62,  72,  47,  255, 106, 120, 77,  255, 127, 156, 87,  255, 105, 140, 105, 255, 113, 142, 110,
    255, 139, 161, 123, 255, 126, 155, 124, 255, 145, 170, 116, 255, 188, 205, 125, 255, 79,  94,  58,  255, 34,  48,  26,  255, 26,  40,  21,  255,
    42,  62,  25,  255, 40,  62,  26,  255, 72,  86,  49,  255, 116, 136, 65,  255, 88,  112, 42,  255, 72,  92,  39,  255, 137, 152, 99,  255, 210,
    224, 177, 255, 217, 234, 209, 255, 211, 232, 213, 255, 213, 233, 202, 255, 177, 183, 133, 255, 130, 140, 74,  255, 180, 197, 131, 255, 196, 215,
    165, 255, 195, 212, 156, 255, 215, 222, 136, 255, 211, 223, 141, 255, 196, 222, 125, 255, 178, 209, 105, 255, 186, 207, 107, 255, 189, 206, 115,
    255, 190, 214, 150, 255, 189, 211, 141, 255, 208, 215, 138, 255, 185, 205, 145, 255, 173, 198, 133, 255, 181, 200, 97,  255, 162, 187, 120, 255,
    146, 173, 129, 255, 180, 198, 122, 255, 153, 168, 84,  255, 189, 201, 91,  255, 149, 180, 96,  255, 130, 163, 90,  255, 150, 176, 90,  255, 140,
    166, 77,  255, 106, 138, 55,  255, 113, 149, 58,  255, 73,  113, 39,  255, 68,  105, 47,  255, 83,  123, 72,  255, 99,  131, 71,  255, 113, 139,
    71,  255, 92,  121, 71,  255, 84,  117, 65,  255, 105, 140, 55,  255, 142, 168, 60,  255, 121, 144, 56,  255, 80,  106, 52,  255, 55,  76,  42,
    255, 56,  72,  33,  255, 111, 143, 63,  255, 92,  127, 49,  255, 96,  132, 58,  255, 83,  116, 53,  255, 68,  100, 29,  255, 87,  125, 36,  255,
    100, 128, 45,  255, 145, 168, 76,  255, 161, 183, 87,  255, 171, 192, 104, 255, 190, 207, 123, 255, 191, 208, 114, 255, 157, 182, 84,  255, 166,
    186, 90,  255, 173, 189, 93,  255, 147, 163, 89,  255, 104, 126, 68,  255, 92,  118, 71,  255, 111, 135, 81,  255, 133, 160, 77,  255, 136, 166,
    89,  255, 134, 164, 100, 255, 148, 173, 91,  255, 122, 138, 60,  255, 45,  58,  28,  255, 44,  62,  23,  255, 107, 125, 53,  255, 148, 172, 79,
    255, 150, 176, 83,  255, 134, 164, 69,  255, 127, 162, 83,  255, 121, 151, 79,  255, 66,  97,  48,  255, 55,  87,  50,  255, 47,  75,  40,  255,
    78,  97,  50,  255, 203, 206, 114, 255, 223, 231, 131, 255, 197, 216, 126, 255, 188, 209, 106, 255, 169, 193, 83,  255, 141, 166, 73,  255, 124,
    151, 67,  255, 133, 162, 75,  255, 122, 152, 68,  255, 118, 148, 65,  255, 120, 152, 67,  255, 115, 147, 73,  255, 124, 152, 75,  255, 90,  119,
    60,  255, 95,  124, 37,  255, 101, 133, 39,  255, 109, 138, 56,  255, 125, 150, 67,  255, 69,  91,  40,  255, 101, 111, 55,  255, 191, 200, 98,
    255, 188, 199, 99,  255, 131, 154, 73,  255, 50,  65,  31,  255, 55,  62,  32,  255, 86,  94,  41,  255, 96,  122, 52,  255, 120, 153, 99,  255,
    130, 162, 108, 255, 137, 166, 103, 255, 140, 167, 94,  255, 136, 160, 74,  255, 179, 195, 93,  255, 153, 185, 125, 255, 146, 179, 126, 255, 134,
    171, 97,  255, 153, 185, 104, 255, 210, 217, 100, 255, 121, 141, 62,  255, 109, 133, 77,  255, 218, 219, 153, 255, 254, 253, 181, 255, 238, 241,
    170, 255, 245, 245, 168, 255, 255, 255, 182, 255, 162, 177, 96,  255, 94,  127, 43,  255, 107, 135, 60,  255, 83,  100, 49,  255, 49,  68,  36,
    255, 51,  87,  32,  255, 48,  81,  32,  255, 44,  72,  31,  255, 43,  76,  26,  255, 119, 136, 62,  255, 211, 210, 110, 255, 179, 187, 71,  255,
    146, 161, 52,  255, 97,  126, 40,  255, 106, 137, 46,  255, 124, 152, 72,  255, 85,  102, 55,  255, 55,  74,  29,  255, 91,  117, 41,  255, 96,
    119, 49,  255, 55,  68,  36,  255, 29,  43,  26,  255, 42,  58,  28,  255, 48,  63,  31,  255, 34,  37,  23,  255, 108, 123, 58,  255, 118, 150,
    73,  255, 111, 141, 69,  255, 156, 182, 103, 255, 171, 195, 108, 255, 125, 159, 71,  255, 89,  114, 52,  255, 91,  112, 55,  255, 89,  111, 42,
    255, 92,  115, 42,  255, 94,  112, 58,  255, 122, 131, 74,  255, 89,  119, 47,  255, 105, 138, 42,  255, 133, 156, 48,  255, 110, 138, 42,  255,
    105, 143, 48,  255, 103, 131, 55,  255, 63,  91,  44,  255, 58,  84,  50,  255, 60,  89,  52,  255, 60,  92,  53,  255, 119, 146, 68,  255, 142,
    170, 75,  255, 122, 156, 68,  255, 131, 158, 63,  255, 106, 130, 76,  255, 125, 151, 87,  255, 163, 184, 102, 255, 152, 170, 87,  255, 71,  94,
    21,  255, 116, 140, 49,  255, 120, 150, 55,  255, 108, 140, 50,  255, 105, 135, 52,  255, 92,  126, 47,  255, 81,  118, 42,  255, 82,  120, 40,
    255, 165, 188, 95,  255, 191, 212, 121, 255, 187, 207, 124, 255, 175, 197, 105, 255, 175, 198, 102, 255, 171, 192, 84,  255, 158, 181, 62,  255,
    155, 181, 91,  255, 133, 163, 89,  255, 94,  127, 52,  255, 75,  119, 37,  255, 113, 144, 56,  255, 182, 193, 95,  255, 221, 226, 110, 255, 227,
    234, 106, 255, 222, 232, 118, 255, 217, 228, 132, 255, 234, 239, 144, 255, 148, 153, 74,  255, 40,  62,  19,  255, 42,  73,  23,  255, 63,  90,
    31,  255, 104, 122, 40,  255, 130, 141, 48,  255, 114, 133, 42,  255, 176, 183, 87,  255, 243, 238, 116, 255, 236, 232, 114, 255, 235, 230, 112,
    255, 232, 229, 110, 255, 187, 195, 80,  255, 125, 150, 47,  255, 171, 185, 82,  255, 169, 183, 74,  255, 149, 170, 73,  255, 167, 187, 100, 255,
    218, 229, 176, 255, 202, 222, 153, 255, 158, 182, 95,  255, 194, 206, 165, 255, 208, 227, 184, 255, 191, 216, 157, 255, 212, 230, 153, 255, 206,
    225, 132, 255, 136, 162, 89,  255, 119, 151, 112, 255, 129, 162, 109, 255, 138, 159, 87,  255, 34,  43,  21,  255, 114, 126, 87,  255, 131, 157,
    100, 255, 116, 144, 109, 255, 183, 192, 142, 255, 192, 205, 159, 255, 142, 167, 132, 255, 179, 195, 126, 255, 123, 142, 84,  255, 26,  34,  23,
    255, 48,  57,  37,  255, 38,  49,  26,  255, 42,  60,  25,  255, 33,  48,  23,  255, 23,  41,  25,  255, 58,  82,  32,  255, 63,  80,  28,  255,
    40,  60,  25,  255, 60,  86,  29,  255, 124, 152, 63,  255, 171, 189, 106, 255, 215, 228, 173, 255, 214, 233, 211, 255, 209, 221, 193, 255, 138,
    147, 74,  255, 175, 185, 74,  255, 195, 216, 103, 255, 168, 198, 92,  255, 162, 191, 86,  255, 174, 200, 106, 255, 126, 150, 67,  255, 101, 125,
    47,  255, 156, 180, 115, 255, 186, 206, 152, 255, 169, 191, 131, 255, 95,  119, 49,  255, 194, 200, 120, 255, 195, 207, 146, 255, 171, 193, 133,
    255, 168, 192, 116, 255, 155, 181, 114, 255, 161, 184, 120, 255, 177, 197, 118, 255, 138, 160, 82,  255, 161, 188, 95,  255, 133, 165, 91,  255,
    149, 173, 90,  255, 139, 169, 68,  255, 77,  117, 45,  255, 104, 140, 53,  255, 82,  122, 41,  255, 86,  116, 47,  255, 84,  104, 47,  255, 90,
    128, 65,  255, 87,  118, 69,  255, 107, 134, 76,  255, 95,  122, 76,  255, 117, 146, 68,  255, 154, 175, 69,  255, 133, 157, 55,  255, 99,  125,
    50,  255, 75,  95,  47,  255, 72,  92,  43,  255, 87,  120, 48,  255, 87,  119, 44,  255, 107, 139, 53,  255, 111, 144, 55,  255, 105, 139, 47,
    255, 98,  132, 42,  255, 81,  107, 44,  255, 92,  111, 49,  255, 85,  107, 40,  255, 144, 167, 69,  255, 157, 179, 81,  255, 159, 183, 94,  255,
    152, 179, 98,  255, 147, 175, 95,  255, 150, 180, 95,  255, 162, 187, 100, 255, 179, 199, 104, 255, 163, 185, 98,  255, 118, 143, 68,  255, 122,
    153, 60,  255, 102, 138, 80,  255, 92,  128, 87,  255, 89,  126, 86,  255, 99,  136, 86,  255, 151, 178, 90,  255, 118, 135, 62,  255, 95,  122,
    53,  255, 116, 155, 69,  255, 115, 152, 77,  255, 129, 163, 87,  255, 123, 157, 65,  255, 156, 177, 107, 255, 95,  113, 65,  255, 62,  99,  43,
    255, 46,  76,  39,  255, 36,  68,  31,  255, 105, 118, 56,  255, 231, 235, 139, 255, 187, 212, 131, 255, 178, 205, 122, 255, 178, 203, 124, 255,
    171, 198, 103, 255, 159, 190, 87,  255, 181, 199, 93,  255, 144, 167, 74,  255, 128, 156, 71,  255, 148, 170, 90,  255, 128, 157, 87,  255, 147,
    174, 95,  255, 74,  87,  43,  255, 50,  68,  31,  255, 63,  82,  33,  255, 103, 127, 42,  255, 114, 141, 55,  255, 117, 145, 62,  255, 113, 127,
    55,  255, 207, 215, 120, 255, 185, 206, 117, 255, 176, 198, 108, 255, 158, 187, 98,  255, 135, 165, 74,  255, 43,  67,  29,  255, 28,  39,  23,
    255, 96,  124, 55,  255, 103, 133, 56,  255, 98,  126, 53,  255, 89,  114, 50,  255, 107, 135, 48,  255, 117, 143, 38,  255, 162, 182, 96,  255,
    150, 184, 132, 255, 149, 182, 107, 255, 156, 188, 103, 255, 188, 206, 115, 255, 163, 176, 105, 255, 96,  125, 72,  255, 203, 217, 135, 255, 254,
    254, 186, 255, 243, 245, 179, 255, 243, 243, 173, 255, 255, 255, 181, 255, 224, 221, 152, 255, 110, 128, 58,  255, 105, 126, 42,  255, 109, 130,
    53,  255, 83,  109, 40,  255, 77,  101, 41,  255, 60,  95,  34,  255, 62,  100, 40,  255, 52,  84,  34,  255, 65,  99,  39,  255, 63,  92,  39,
    255, 73,  97,  34,  255, 86,  117, 37,  255, 80,  109, 41,  255, 60,  90,  46,  255, 73,  106, 47,  255, 112, 139, 65,  255, 82,  114, 40,  255,
    77,  119, 38,  255, 94,  131, 43,  255, 122, 151, 55,  255, 151, 169, 62,  255, 83,  106, 48,  255, 57,  90,  46,  255, 67,  102, 42,  255, 55,
    79,  39,  255, 47,  62,  33,  255, 124, 146, 62,  255, 132, 154, 65,  255, 158, 179, 101, 255, 162, 189, 93,  255, 142, 166, 79,  255, 62,  83,
    42,  255, 80,  105, 65,  255, 116, 138, 73,  255, 157, 179, 103, 255, 165, 185, 109, 255, 110, 127, 53,  255, 122, 133, 55,  255, 111, 137, 52,
    255, 143, 168, 78,  255, 137, 167, 72,  255, 149, 176, 74,  255, 90,  114, 50,  255, 53,  84,  44,  255, 65,  95,  48,  255, 67,  100, 47,  255,
    87,  120, 53,  255, 155, 183, 98,  255, 153, 184, 107, 255, 135, 169, 81,  255, 121, 153, 68,  255, 101, 133, 67,  255, 133, 156, 86,  255, 174,
    189, 102, 255, 89,  114, 28,  255, 78,  109, 29,  255, 78,  108, 28,  255, 97,  124, 40,  255, 106, 135, 49,  255, 111, 141, 53,  255, 105, 137,
    52,  255, 84,  122, 42,  255, 82,  114, 37,  255, 165, 182, 96,  255, 197, 215, 125, 255, 182, 202, 112, 255, 178, 200, 98,  255, 178, 198, 86,
    255, 161, 184, 71,  255, 175, 196, 95,  255, 167, 187, 93,  255, 122, 150, 74,  255, 86,  123, 49,  255, 93,  129, 49,  255, 100, 136, 52,  255,
    106, 142, 56,  255, 131, 156, 63,  255, 177, 190, 80,  255, 215, 219, 105, 255, 239, 243, 149, 255, 251, 255, 165, 255, 167, 168, 90,  255, 47,
    77,  21,  255, 58,  96,  37,  255, 49,  87,  37,  255, 45,  84,  33,  255, 65,  98,  34,  255, 92,  116, 39,  255, 131, 150, 56,  255, 209, 211,
    92,  255, 238, 230, 90,  255, 236, 230, 90,  255, 233, 230, 115, 255, 225, 228, 118, 255, 207, 219, 101, 255, 170, 180, 73,  255, 145, 167, 69,
    255, 164, 187, 92,  255, 193, 210, 116, 255, 155, 188, 81,  255, 95,  138, 38,  255, 72,  111, 31,  255, 83,  118, 39,  255, 164, 183, 108, 255,
    220, 241, 182, 255, 225, 239, 158, 255, 215, 233, 117, 255, 198, 211, 118, 255, 148, 174, 129, 255, 136, 165, 127, 255, 143, 174, 124, 255, 104,
    124, 74,  255, 73,  82,  48,  255, 161, 176, 118, 255, 199, 207, 146, 255, 208, 223, 147, 255, 145, 171, 135, 255, 182, 194, 138, 255, 218, 223,
    151, 255, 92,  110, 58,  255, 40,  62,  23,  255, 47,  62,  31,  255, 47,  58,  31,  255, 43,  57,  26,  255, 41,  58,  28,  255, 32,  41,  23,
    255, 94,  107, 47,  255, 92,  111, 52,  255, 44,  60,  31,  255, 50,  69,  28,  255, 110, 140, 60,  255, 108, 134, 52,  255, 185, 194, 90,  255,
    217, 228, 144, 255, 204, 223, 185, 255, 165, 174, 107, 255, 176, 200, 86,  255, 117, 157, 58,  255, 120, 148, 58,  255, 149, 172, 76,  255, 170,
    195, 99,  255, 170, 187, 99,  255, 154, 171, 103, 255, 129, 160, 110, 255, 160, 188, 125, 255, 184, 190, 111, 255, 107, 114, 50,  255, 166, 177,
    101, 255, 219, 227, 149, 255, 189, 205, 132, 255, 173, 196, 139, 255, 145, 173, 116, 255, 132, 161, 95,  255, 155, 182, 112, 255, 128, 154, 76,
    255, 138, 171, 93,  255, 135, 164, 87,  255, 146, 168, 69,  255, 95,  131, 39,  255, 106, 136, 55,  255, 116, 147, 56,  255, 117, 146, 58,  255,
    115, 140, 58,  255, 113, 139, 62,  255, 91,  128, 67,  255, 85,  118, 73,  255, 100, 128, 71,  255, 98,  123, 62,  255, 170, 183, 87,  255, 129,
    148, 52,  255, 108, 134, 50,  255, 104, 129, 52,  255, 94,  121, 56,  255, 87,  117, 53,  255, 63,  96,  29,  255, 136, 158, 63,  255, 155, 182,
    75,  255, 137, 167, 58,  255, 149, 178, 65,  255, 83,  98,  47,  255, 47,  65,  29,  255, 86,  121, 44,  255, 80,  117, 45,  255, 65,  100, 49,
    255, 68,  97,  52,  255, 121, 147, 73,  255, 152, 175, 87,  255, 141, 165, 87,  255, 136, 159, 83,  255, 130, 152, 75,  255, 124, 148, 68,  255,
    126, 150, 71,  255, 113, 147, 68,  255, 105, 138, 63,  255, 108, 143, 81,  255, 105, 140, 91,  255, 103, 137, 91,  255, 97,  132, 90,  255, 100,
    138, 86,  255, 141, 169, 89,  255, 105, 134, 65,  255, 107, 145, 74,  255, 124, 156, 83,  255, 143, 171, 78,  255, 124, 153, 60,  255, 172, 197,
    97,  255, 68,  87,  39,  255, 49,  81,  33,  255, 58,  97,  40,  255, 45,  82,  37,  255, 107, 122, 68,  255, 220, 232, 147, 255, 192, 217, 143,
    255, 196, 217, 138, 255, 195, 217, 124, 255, 209, 223, 125, 255, 188, 200, 104, 255, 157, 173, 80,  255, 148, 172, 80,  255, 138, 165, 84,  255,
    119, 152, 91,  255, 140, 170, 91,  255, 146, 166, 84,  255, 58,  86,  38,  255, 57,  84,  31,  255, 52,  80,  34,  255, 63,  87,  36,  255, 96,
    117, 44,  255, 114, 135, 55,  255, 163, 166, 81,  255, 217, 230, 142, 255, 164, 194, 126, 255, 152, 184, 112, 255, 137, 172, 90,  255, 131, 168,
    77,  255, 91,  128, 52,  255, 73,  99,  43,  255, 139, 156, 55,  255, 123, 147, 52,  255, 97,  126, 47,  255, 81,  114, 44,  255, 82,  114, 47,
    255, 95,  124, 36,  255, 165, 185, 101, 255, 174, 201, 139, 255, 203, 218, 129, 255, 222, 231, 133, 255, 187, 196, 119, 255, 100, 127, 94,  255,
    132, 162, 105, 255, 201, 216, 127, 255, 251, 250, 187, 255, 248, 246, 175, 255, 254, 250, 168, 255, 231, 232, 149, 255, 108, 130, 60,  255, 47,
    75,  32,  255, 44,  67,  36,  255, 53,  84,  38,  255, 76,  111, 38,  255, 110, 136, 58,  255, 89,  120, 52,  255, 82,  117, 52,  255, 77,  116,
    50,  255, 89,  122, 50,  255, 73,  102, 34,  255, 60,  99,  28,  255, 57,  87,  31,  255, 63,  89,  46,  255, 65,  92,  49,  255, 87,  119, 53,
    255, 115, 141, 56,  255, 63,  98,  36,  255, 74,  114, 45,  255, 84,  122, 50,  255, 106, 140, 60,  255, 151, 173, 73,  255, 160, 174, 75,  255,
    105, 133, 68,  255, 108, 136, 69,  255, 72,  111, 43,  255, 72,  112, 45,  255, 110, 135, 53,  255, 98,  123, 43,  255, 130, 158, 65,  255, 157,
    189, 96,  255, 138, 167, 74,  255, 112, 132, 65,  255, 183, 201, 133, 255, 173, 200, 130, 255, 175, 201, 112, 255, 155, 170, 82,  255, 81,  105,
    43,  255, 98,  112, 52,  255, 108, 125, 60,  255, 165, 188, 96,  255, 169, 190, 91,  255, 135, 157, 72,  255, 75,  101, 41,  255, 57,  84,  38,
    255, 52,  74,  31,  255, 42,  55,  23,  255, 92,  120, 68,  255, 179, 207, 159, 255, 149, 174, 113, 255, 114, 142, 83,  255, 107, 132, 72,  255,
    92,  124, 55,  255, 150, 171, 89,  255, 174, 180, 81,  255, 101, 125, 38,  255, 82,  116, 31,  255, 77,  111, 32,  255, 68,  102, 26,  255, 67,
    99,  26,  255, 56,  79,  25,  255, 68,  98,  36,  255, 84,  116, 43,  255, 85,  111, 36,  255, 153, 173, 90,  255, 209, 221, 137, 255, 191, 209,
    115, 255, 175, 190, 87,  255, 130, 151, 55,  255, 151, 169, 67,  255, 196, 207, 108, 255, 153, 169, 81,  255, 93,  127, 47,  255, 95,  133, 48,
    255, 93,  121, 43,  255, 77,  99,  33,  255, 135, 164, 74,  255, 136, 164, 71,  255, 124, 152, 53,  255, 131, 155, 48,  255, 161, 174, 78,  255,
    213, 214, 135, 255, 176, 173, 100, 255, 52,  81,  19,  255, 65,  106, 47,  255, 65,  102, 52,  255, 65,  102, 58,  255, 55,  96,  46,  255, 103,
    132, 56,  255, 193, 200, 90,  255, 196, 200, 93,  255, 201, 203, 93,  255, 220, 220, 104, 255, 235, 233, 125, 255, 232, 232, 121, 255, 234, 232,
    107, 255, 162, 170, 62,  255, 165, 188, 74,  255, 221, 230, 107, 255, 236, 236, 121, 255, 107, 142, 40,  255, 74,  112, 29,  255, 103, 138, 55,
    255, 145, 168, 68,  255, 141, 158, 67,  255, 130, 144, 97,  255, 227, 243, 144, 255, 197, 229, 94,  255, 208, 227, 109, 255, 145, 169, 93,  255,
    142, 171, 110, 255, 134, 166, 124, 255, 143, 167, 121, 255, 156, 160, 97,  255, 212, 223, 151, 255, 217, 227, 141, 255, 170, 188, 135, 255, 182,
    203, 162, 255, 221, 233, 176, 255, 153, 166, 120, 255, 62,  83,  39,  255, 73,  98,  36,  255, 83,  113, 47,  255, 73,  95,  44,  255, 55,  74,
    32,  255, 77,  89,  40,  255, 86,  92,  47,  255, 74,  90,  45,  255, 53,  69,  31,  255, 67,  67,  38,  255, 36,  42,  19,  255, 85,  114, 48,
    255, 40,  55,  28,  255, 85,  101, 43,  255, 165, 184, 87,  255, 169, 192, 106, 255, 150, 167, 92,  255, 144, 167, 82,  255, 128, 153, 65,  255,
    155, 179, 84,  255, 159, 187, 83,  255, 158, 183, 76,  255, 189, 202, 110, 255, 148, 175, 104, 255, 122, 152, 85,  255, 144, 173, 107, 255, 205,
    217, 136, 255, 214, 223, 135, 255, 182, 200, 114, 255, 202, 215, 138, 255, 172, 193, 141, 255, 159, 188, 156, 255, 160, 184, 162, 255, 134, 160,
    114, 255, 129, 158, 97,  255, 120, 150, 72,  255, 141, 169, 84,  255, 151, 176, 77,  255, 89,  122, 36,  255, 79,  117, 39,  255, 81,  111, 55,
    255, 97,  124, 62,  255, 101, 131, 55,  255, 74,  105, 34,  255, 139, 161, 62,  255, 151, 175, 79,  255, 113, 142, 74,  255, 87,  111, 49,  255,
    141, 157, 84,  255, 137, 159, 75,  255, 85,  109, 38,  255, 90,  115, 49,  255, 85,  116, 41,  255, 74,  109, 39,  255, 78,  102, 48,  255, 46,
    75,  23,  255, 142, 164, 73,  255, 186, 207, 102, 255, 182, 203, 93,  255, 155, 176, 81,  255, 80,  105, 40,  255, 82,  119, 47,  255, 83,  121,
    52,  255, 63,  96,  47,  255, 52,  80,  52,  255, 52,  79,  50,  255, 76,  108, 49,  255, 57,  86,  39,  255, 47,  75,  36,  255, 51,  80,  38,
    255, 48,  75,  36,  255, 42,  67,  32,  255, 32,  53,  25,  255, 39,  65,  29,  255, 69,  100, 42,  255, 106, 139, 68,  255, 124, 156, 90,  255,
    119, 152, 92,  255, 116, 150, 92,  255, 103, 136, 91,  255, 99,  135, 87,  255, 114, 141, 77,  255, 107, 136, 55,  255, 146, 172, 65,  255, 116,
    149, 56,  255, 77,  100, 48,  255, 170, 198, 87,  255, 75,  93,  47,  255, 17,  36,  19,  255, 55,  76,  34,  255, 92,  126, 52,  255, 101, 129,
    71,  255, 179, 193, 133, 255, 195, 209, 132, 255, 193, 206, 120, 255, 187, 198, 109, 255, 162, 172, 89,  255, 98,  117, 47,  255, 117, 141, 62,
    255, 111, 128, 62,  255, 106, 140, 73,  255, 128, 164, 73,  255, 150, 172, 78,  255, 103, 128, 55,  255, 123, 158, 65,  255, 83,  122, 44,  255,
    68,  111, 36,  255, 96,  136, 43,  255, 77,  109, 40,  255, 91,  107, 45,  255, 204, 212, 127, 255, 205, 221, 141, 255, 180, 205, 130, 255, 167,
    196, 114, 255, 153, 185, 96,  255, 142, 178, 81,  255, 149, 184, 81,  255, 165, 191, 85,  255, 131, 146, 49,  255, 139, 153, 50,  255, 137, 157,
    55,  255, 104, 135, 52,  255, 98,  131, 50,  255, 111, 144, 52,  255, 184, 195, 105, 255, 204, 218, 139, 255, 201, 225, 153, 255, 184, 215, 129,
    255, 190, 216, 124, 255, 163, 186, 125, 255, 127, 157, 98,  255, 192, 206, 124, 255, 243, 243, 160, 255, 198, 217, 87,  255, 224, 234, 118, 255,
    167, 184, 99,  255, 93,  124, 65,  255, 78,  107, 73,  255, 68,  99,  62,  255, 87,  122, 62,  255, 110, 145, 62,  255, 128, 154, 79,  255, 134,
    163, 95,  255, 105, 136, 68,  255, 104, 137, 68,  255, 99,  130, 60,  255, 55,  78,  26,  255, 58,  92,  29,  255, 55,  82,  36,  255, 63,  91,
    47,  255, 73,  105, 47,  255, 108, 139, 48,  255, 110, 142, 43,  255, 111, 145, 47,  255, 103, 138, 50,  255, 94,  130, 55,  255, 112, 147, 62,
    255, 144, 172, 78,  255, 184, 197, 102, 255, 135, 155, 81,  255, 110, 137, 67,  255, 60,  87,  38,  255, 62,  98,  36,  255, 63,  101, 33,  255,
    109, 133, 62,  255, 96,  123, 47,  255, 146, 171, 93,  255, 145, 175, 81,  255, 160, 184, 91,  255, 155, 187, 123, 255, 162, 194, 101, 255, 164,
    182, 79,  255, 147, 165, 76,  255, 109, 129, 58,  255, 60,  86,  36,  255, 115, 126, 65,  255, 173, 192, 104, 255, 169, 184, 95,  255, 95,  121,
    48,  255, 78,  105, 41,  255, 60,  84,  36,  255, 34,  49,  21,  255, 69,  75,  47,  255, 175, 195, 147, 255, 164, 185, 121, 255, 141, 158, 81,
    255, 114, 140, 98,  255, 101, 126, 69,  255, 93,  119, 65,  255, 154, 170, 91,  255, 156, 168, 77,  255, 96,  117, 40,  255, 87,  118, 40,  255,
    84,  115, 37,  255, 81,  114, 36,  255, 74,  108, 32,  255, 42,  65,  19,  255, 60,  89,  40,  255, 83,  109, 45,  255, 87,  113, 37,  255, 134,
    161, 71,  255, 217, 222, 134, 255, 184, 193, 87,  255, 127, 149, 60,  255, 136, 165, 87,  255, 149, 175, 93,  255, 158, 179, 87,  255, 154, 173,
    84,  255, 122, 147, 65,  255, 92,  130, 40,  255, 78,  100, 31,  255, 74,  94,  39,  255, 152, 178, 90,  255, 150, 174, 83,  255, 127, 154, 65,
    255, 125, 155, 58,  255, 113, 143, 44,  255, 80,  100, 33,  255, 60,  75,  28,  255, 60,  89,  31,  255, 84,  124, 47,  255, 104, 141, 52,  255,
    102, 135, 60,  255, 72,  109, 50,  255, 89,  119, 50,  255, 170, 174, 76,  255, 214, 208, 98,  255, 197, 198, 89,  255, 215, 219, 122, 255, 236,
    234, 128, 255, 221, 219, 102, 255, 159, 166, 58,  255, 95,  116, 36,  255, 121, 144, 47,  255, 187, 200, 65,  255, 203, 206, 77,  255, 118, 146,
    65,  255, 133, 162, 87,  255, 171, 188, 100, 255, 202, 204, 116, 255, 189, 189, 124, 255, 146, 152, 95,  255, 123, 140, 63,  255, 184, 213, 87,
    255, 190, 205, 111, 255, 118, 126, 69,  255, 88,  111, 42,  255, 143, 155, 80,  255, 206, 217, 147, 255, 224, 236, 160, 255, 200, 217, 109, 255,
    179, 202, 112, 255, 178, 204, 165, 255, 217, 230, 175, 255, 188, 192, 132, 255, 25,  32,  17,  255, 26,  36,  26,  255, 63,  84,  44,  255, 109,
    143, 68,  255, 112, 143, 83,  255, 91,  124, 60,  255, 72,  104, 41,  255, 52,  79,  25,  255, 67,  93,  17,  255, 127, 149, 42,  255, 160, 183,
    68,  255, 128, 146, 62,  255, 93,  113, 55,  255, 83,  99,  49,  255, 73,  92,  41,  255, 87,  116, 42,  255, 134, 164, 73,  255, 143, 163, 87,
    255, 143, 169, 92,  255, 120, 152, 60,  255, 132, 164, 60,  255, 115, 145, 52,  255, 146, 153, 74,  255, 180, 201, 145, 255, 146, 171, 119, 255,
    110, 129, 56,  255, 156, 174, 114, 255, 183, 203, 138, 255, 202, 210, 134, 255, 129, 157, 75,  255, 163, 187, 103, 255, 173, 195, 141, 255, 150,
    181, 148, 255, 156, 184, 156, 255, 156, 184, 150, 255, 112, 141, 83,  255, 100, 131, 52,  255, 132, 168, 65,  255, 97,  137, 46,  255, 81,  121,
    41,  255, 40,  71,  29,  255, 33,  58,  37,  255, 58,  90,  47,  255, 80,  113, 47,  255, 60,  87,  28,  255, 127, 153, 65,  255, 156, 183, 96,
    255, 157, 178, 104, 255, 186, 191, 104, 255, 185, 198, 114, 255, 78,  113, 43,  255, 74,  102, 41,  255, 94,  125, 47,  255, 92,  131, 44,  255,
    76,  115, 39,  255, 76,  104, 49,  255, 63,  92,  34,  255, 106, 130, 52,  255, 184, 205, 112, 255, 129, 154, 69,  255, 101, 131, 52,  255, 79,
    114, 47,  255, 58,  84,  48,  255, 65,  92,  53,  255, 60,  84,  55,  255, 58,  83,  55,  255, 62,  90,  58,  255, 100, 131, 62,  255, 60,  87,
    43,  255, 49,  76,  38,  255, 52,  82,  41,  255, 55,  84,  44,  255, 58,  87,  39,  255, 51,  79,  32,  255, 55,  80,  31,  255, 76,  106, 44,
    255, 87,  117, 47,  255, 98,  123, 55,  255, 117, 144, 74,  255, 125, 153, 84,  255, 121, 149, 84,  255, 109, 141, 84,  255, 92,  124, 76,  255,
    85,  113, 43,  255, 122, 151, 56,  255, 49,  79,  37,  255, 107, 125, 62,  255, 180, 214, 89,  255, 103, 116, 65,  255, 79,  82,  60,  255, 50,
    68,  39,  255, 52,  71,  23,  255, 100, 129, 52,  255, 116, 146, 73,  255, 126, 154, 96,  255, 108, 138, 89,  255, 116, 146, 86,  255, 131, 156,
    78,  255, 108, 131, 53,  255, 133, 152, 71,  255, 62,  83,  41,  255, 103, 132, 50,  255, 137, 157, 58,  255, 69,  84,  32,  255, 135, 157, 65,
    255, 142, 169, 67,  255, 112, 145, 60,  255, 81,  117, 52,  255, 91,  126, 49,  255, 127, 159, 58,  255, 143, 163, 83,  255, 197, 211, 151, 255,
    193, 213, 150, 255, 199, 217, 141, 255, 220, 232, 145, 255, 199, 222, 154, 255, 190, 210, 136, 255, 160, 172, 81,  255, 125, 146, 62,  255, 89,
    117, 53,  255, 80,  106, 42,  255, 99,  117, 41,  255, 96,  108, 47,  255, 122, 134, 53,  255, 159, 171, 76,  255, 103, 115, 52,  255, 89,  105,
    49,  255, 154, 171, 93,  255, 171, 194, 104, 255, 180, 204, 106, 255, 183, 212, 113, 255, 151, 181, 99,  255, 206, 219, 136, 255, 196, 215, 119,
    255, 208, 224, 136, 255, 197, 210, 119, 255, 138, 165, 84,  255, 105, 137, 87,  255, 104, 137, 77,  255, 131, 158, 69,  255, 151, 176, 74,  255,
    105, 126, 48,  255, 125, 147, 87,  255, 151, 177, 109, 255, 116, 145, 76,  255, 68,  90,  38,  255, 85,  102, 60,  255, 43,  60,  31,  255, 49,
    81,  32,  255, 57,  86,  36,  255, 91,  123, 55,  255, 118, 150, 55,  255, 100, 124, 36,  255, 133, 162, 48,  255, 161, 183, 62,  255, 163, 184,
    65,  255, 152, 175, 65,  255, 145, 168, 75,  255, 155, 171, 77,  255, 168, 178, 89,  255, 149, 164, 84,  255, 130, 152, 75,  255, 96,  119, 68,
    255, 80,  106, 58,  255, 111, 134, 65,  255, 108, 132, 60,  255, 87,  116, 53,  255, 101, 128, 60,  255, 137, 167, 84,  255, 139, 177, 91,  255,
    168, 198, 101, 255, 186, 204, 96,  255, 159, 178, 65,  255, 123, 141, 58,  255, 60,  87,  39,  255, 82,  109, 62,  255, 96,  111, 58,  255, 167,
    179, 99,  255, 165, 186, 87,  255, 89,  115, 43,  255, 52,  68,  28,  255, 31,  44,  25,  255, 43,  62,  29,  255, 154, 169, 93,  255, 194, 206,
    137, 255, 131, 159, 71,  255, 146, 174, 77,  255, 136, 156, 83,  255, 88,  112, 58,  255, 108, 135, 94,  255, 149, 168, 83,  255, 98,  117, 40,
    255, 58,  79,  26,  255, 122, 143, 62,  255, 116, 136, 58,  255, 92,  121, 42,  255, 82,  108, 38,  255, 45,  65,  19,  255, 63,  95,  41,  255,
    82,  110, 42,  255, 83,  113, 40,  255, 138, 164, 68,  255, 189, 200, 97,  255, 143, 165, 76,  255, 118, 151, 87,  255, 145, 175, 103, 255, 142,
    173, 111, 255, 127, 164, 102, 255, 149, 179, 110, 255, 139, 158, 80,  255, 116, 143, 58,  255, 99,  125, 39,  255, 121, 149, 68,  255, 164, 184,
    96,  255, 154, 175, 82,  255, 101, 124, 43,  255, 100, 131, 44,  255, 121, 153, 58,  255, 106, 132, 55,  255, 60,  89,  26,  255, 87,  124, 38,
    255, 111, 147, 47,  255, 117, 152, 52,  255, 121, 157, 58,  255, 111, 151, 53,  255, 75,  108, 36,  255, 29,  38,  19,  255, 110, 124, 53,  255,
    176, 181, 75,  255, 185, 187, 74,  255, 164, 176, 60,  255, 119, 142, 32,  255, 82,  114, 23,  255, 86,  118, 31,  255, 114, 145, 47,  255, 129,
    157, 48,  255, 143, 169, 69,  255, 176, 197, 137, 255, 198, 216, 145, 255, 157, 169, 98,  255, 192, 202, 129, 255, 203, 227, 166, 255, 212, 229,
    165, 255, 224, 225, 162, 255, 204, 213, 136, 255, 196, 211, 112, 255, 138, 166, 87,  255, 98,  117, 38,  255, 210, 215, 145, 255, 219, 233, 144,
    255, 188, 208, 95,  255, 175, 198, 109, 255, 172, 200, 154, 255, 192, 211, 167, 255, 233, 236, 165, 255, 96,  112, 53,  255, 67,  84,  26,  255,
    68,  81,  32,  255, 52,  68,  26,  255, 97,  130, 60,  255, 104, 135, 71,  255, 108, 138, 75,  255, 114, 143, 62,  255, 116, 143, 41,  255, 156,
    183, 65,  255, 145, 174, 65,  255, 112, 136, 56,  255, 98,  119, 62,  255, 76,  104, 46,  255, 68,  100, 33,  255, 110, 143, 55,  255, 118, 153,
    60,  255, 79,  118, 37,  255, 111, 139, 62,  255, 120, 151, 71,  255, 84,  118, 44,  255, 67,  100, 39,  255, 38,  51,  19,  255, 167, 165, 108,
    255, 189, 206, 157, 255, 192, 204, 163, 255, 209, 212, 153, 255, 228, 230, 164, 255, 191, 204, 139, 255, 197, 209, 119, 255, 144, 167, 82,  255,
    146, 176, 97,  255, 148, 181, 121, 255, 148, 180, 129, 255, 143, 176, 124, 255, 142, 177, 130, 255, 129, 158, 89,  255, 97,  132, 39,  255, 81,
    124, 39,  255, 82,  123, 37,  255, 93,  121, 38,  255, 85,  97,  36,  255, 42,  60,  31,  255, 51,  82,  36,  255, 63,  99,  34,  255, 57,  84,
    36,  255, 112, 144, 76,  255, 92,  133, 73,  255, 99,  134, 72,  255, 113, 141, 73,  255, 108, 145, 77,  255, 94,  128, 65,  255, 75,  105, 41,
    255, 104, 138, 49,  255, 109, 146, 53,  255, 99,  138, 49,  255, 86,  117, 50,  255, 80,  111, 48,  255, 84,  121, 47,  255, 65,  98,  36,  255,
    68,  102, 28,  255, 97,  131, 50,  255, 68,  96,  52,  255, 58,  83,  53,  255, 62,  87,  56,  255, 62,  89,  56,  255, 55,  83,  55,  255, 84,
    114, 58,  255, 108, 136, 60,  255, 55,  82,  38,  255, 58,  87,  38,  255, 63,  94,  44,  255, 58,  87,  41,  255, 58,  87,  36,  255, 81,  115,
    47,  255, 77,  110, 53,  255, 73,  108, 58,  255, 69,  104, 55,  255, 84,  117, 53,  255, 89,  126, 55,  255, 72,  97,  36,  255, 58,  80,  33,
    255, 95,  124, 60,  255, 106, 132, 60,  255, 87,  116, 49,  255, 95,  124, 55,  255, 96,  118, 55,  255, 161, 187, 78,  255, 181, 207, 111, 255,
    193, 206, 124, 255, 208, 220, 159, 255, 142, 145, 101, 255, 136, 133, 100, 255, 129, 148, 82,  255, 91,  122, 49,  255, 108, 133, 75,  255, 113,
    145, 94,  255, 134, 163, 84,  255, 135, 170, 72,  255, 128, 163, 62,  255, 148, 176, 71,  255, 149, 170, 75,  255, 132, 153, 73,  255, 56,  80,
    38,  255, 62,  89,  36,  255, 151, 170, 72,  255, 150, 174, 68,  255, 112, 144, 63,  255, 83,  116, 62,  255, 79,  114, 55,  255, 132, 161, 65,
    255, 140, 159, 69,  255, 68,  73,  38,  255, 75,  80,  46,  255, 80,  83,  44,  255, 125, 124, 65,  255, 188, 193, 112, 255, 129, 146, 82,  255,
    76,  102, 47,  255, 94,  123, 75,  255, 86,  116, 76,  255, 74,  102, 58,  255, 58,  89,  42,  255, 53,  80,  31,  255, 60,  81,  33,  255, 63,
    86,  38,  255, 52,  72,  42,  255, 53,  79,  38,  255, 58,  84,  34,  255, 77,  101, 42,  255, 96,  118, 44,  255, 81,  97,  36,  255, 116, 134,
    58,  255, 197, 211, 123, 255, 230, 239, 169, 255, 210, 211, 131, 255, 116, 139, 60,  255, 110, 147, 60,  255, 122, 156, 68,  255, 120, 156, 73,
    255, 143, 173, 73,  255, 178, 197, 80,  255, 186, 197, 75,  255, 167, 182, 87,  255, 157, 181, 112, 255, 142, 170, 101, 255, 69,  108, 44,  255,
    60,  87,  36,  255, 60,  83,  34,  255, 91,  124, 41,  255, 101, 137, 44,  255, 127, 153, 52,  255, 82,  101, 36,  255, 34,  51,  21,  255, 78,
    95,  34,  255, 78,  82,  36,  255, 89,  96,  43,  255, 117, 136, 58,  255, 101, 123, 58,  255, 80,  106, 52,  255, 126, 147, 76,  255, 192, 211,
    134, 255, 176, 201, 130, 255, 190, 208, 127, 255, 203, 213, 127, 255, 171, 183, 92,  255, 145, 164, 74,  255, 112, 134, 53,  255, 132, 160, 69,
    255, 132, 161, 77,  255, 145, 176, 78,  255, 149, 171, 71,  255, 167, 183, 63,  255, 190, 201, 81,  255, 87,  107, 42,  255, 73,  98,  47,  255,
    189, 205, 131, 255, 178, 191, 116, 255, 156, 163, 87,  255, 167, 193, 83,  255, 128, 153, 58,  255, 38,  55,  25,  255, 48,  67,  34,  255, 129,
    160, 72,  255, 140, 169, 74,  255, 139, 166, 74,  255, 141, 171, 74,  255, 149, 175, 80,  255, 98,  121, 55,  255, 85,  116, 72,  255, 141, 167,
    104, 255, 153, 168, 83,  255, 62,  83,  23,  255, 62,  87,  31,  255, 114, 143, 72,  255, 130, 147, 72,  255, 77,  93,  31,  255, 48,  73,  23,
    255, 48,  71,  25,  255, 60,  84,  33,  255, 80,  109, 40,  255, 77,  106, 42,  255, 175, 193, 103, 255, 176, 197, 110, 255, 135, 165, 113, 255,
    137, 170, 115, 255, 157, 183, 115, 255, 155, 184, 115, 255, 179, 202, 123, 255, 216, 227, 157, 255, 223, 230, 165, 255, 214, 226, 149, 255, 200,
    216, 134, 255, 199, 214, 127, 255, 173, 191, 103, 255, 151, 173, 76,  255, 81,  106, 29,  255, 115, 146, 58,  255, 144, 169, 75,  255, 147, 171,
    84,  255, 145, 171, 75,  255, 136, 165, 60,  255, 118, 152, 44,  255, 118, 156, 50,  255, 122, 159, 52,  255, 122, 160, 53,  255, 117, 149, 55,
    255, 68,  97,  34,  255, 58,  101, 34,  255, 77,  115, 37,  255, 102, 129, 40,  255, 116, 139, 41,  255, 98,  124, 36,  255, 74,  108, 34,  255,
    110, 139, 58,  255, 160, 181, 117, 255, 148, 175, 80,  255, 180, 198, 114, 255, 204, 220, 140, 255, 168, 194, 112, 255, 175, 197, 105, 255, 86,
    103, 50,  255, 68,  86,  50,  255, 52,  60,  33,  255, 133, 144, 105, 255, 135, 161, 96,  255, 130, 162, 68,  255, 60,  98,  23,  255, 169, 185,
    103, 255, 210, 229, 142, 255, 182, 203, 114, 255, 166, 192, 109, 255, 179, 203, 158, 255, 214, 225, 175, 255, 230, 233, 169, 255, 124, 147, 80,
    255, 55,  92,  25,  255, 76,  116, 42,  255, 92,  126, 41,  255, 116, 135, 60,  255, 123, 145, 65,  255, 109, 137, 58,  255, 121, 148, 58,  255,
    154, 177, 82,  255, 140, 171, 55,  255, 98,  131, 40,  255, 65,  94,  32,  255, 50,  68,  34,  255, 36,  52,  26,  255, 47,  75,  32,  255, 48,
    74,  28,  255, 52,  77,  25,  255, 105, 135, 55,  255, 127, 163, 62,  255, 131, 166, 77,  255, 127, 157, 81,  255, 119, 159, 76,  255, 79,  113,
    45,  255, 73,  65,  34,  255, 186, 194, 146, 255, 194, 215, 180, 255, 195, 214, 183, 255, 197, 216, 181, 255, 222, 226, 165, 255, 221, 230, 149,
    255, 184, 208, 128, 255, 164, 195, 111, 255, 163, 191, 111, 255, 159, 186, 110, 255, 161, 187, 109, 255, 162, 190, 104, 255, 156, 184, 95,  255,
    171, 192, 81,  255, 127, 156, 62,  255, 108, 139, 53,  255, 131, 163, 62,  255, 161, 187, 80,  255, 197, 216, 96,  255, 150, 158, 74,  255, 46,
    75,  26,  255, 60,  89,  31,  255, 72,  97,  40,  255, 117, 153, 84,  255, 82,  125, 75,  255, 107, 145, 75,  255, 98,  130, 62,  255, 95,  129,
    63,  255, 95,  124, 68,  255, 60,  94,  34,  255, 43,  75,  28,  255, 73,  107, 41,  255, 84,  122, 43,  255, 78,  113, 45,  255, 78,  103, 52,
    255, 57,  87,  36,  255, 47,  77,  23,  255, 94,  127, 47,  255, 89,  122, 55,  255, 62,  92,  58,  255, 62,  89,  62,  255, 67,  92,  62,  255,
    63,  92,  60,  255, 74,  103, 58,  255, 117, 150, 65,  255, 89,  110, 52,  255, 29,  38,  21,  255, 48,  67,  25,  255, 45,  63,  26,  255, 36,
    58,  25,  255, 46,  73,  28,  255, 78,  113, 42,  255, 87,  123, 52,  255, 62,  92,  52,  255, 58,  87,  53,  255, 65,  98,  49,  255, 75,  108,
    53,  255, 75,  112, 53,  255, 78,  103, 49,  255, 76,  103, 55,  255, 92,  119, 55,  255, 82,  110, 50,  255, 80,  110, 49,  255, 144, 170, 87,
    255, 184, 211, 94,  255, 193, 216, 115, 255, 197, 220, 140, 255, 221, 233, 191, 255, 224, 241, 201, 255, 188, 204, 166, 255, 110, 136, 65,  255,
    55,  79,  34,  255, 52,  67,  36,  255, 159, 173, 87,  255, 176, 203, 86,  255, 149, 185, 77,  255, 149, 183, 78,  255, 151, 181, 82,  255, 134,
    162, 89,  255, 133, 148, 84,  255, 138, 162, 85,  255, 65,  102, 40,  255, 132, 152, 60,  255, 164, 183, 71,  255, 121, 153, 62,  255, 84,  121,
    62,  255, 93,  126, 65,  255, 148, 174, 71,  255, 141, 164, 65,  255, 39,  60,  23,  255, 26,  39,  26,  255, 26,  37,  26,  255, 25,  40,  25,
    255, 113, 121, 58,  255, 109, 132, 62,  255, 101, 127, 65,  255, 111, 135, 80,  255, 102, 129, 77,  255, 94,  121, 71,  255, 75,  106, 65,  255,
    55,  82,  43,  255, 55,  75,  31,  255, 55,  77,  36,  255, 60,  84,  44,  255, 69,  98,  44,  255, 79,  109, 38,  255, 92,  117, 38,  255, 88,
    111, 50,  255, 79,  99,  63,  255, 161, 174, 102, 255, 170, 187, 94,  255, 213, 224, 126, 255, 216, 228, 110, 255, 151, 176, 92,  255, 96,  136,
    56,  255, 110, 147, 67,  255, 119, 155, 74,  255, 139, 171, 80,  255, 157, 182, 84,  255, 174, 193, 94,  255, 194, 205, 98,  255, 159, 181, 96,
    255, 148, 177, 105, 255, 100, 138, 68,  255, 105, 146, 68,  255, 91,  121, 58,  255, 78,  89,  38,  255, 89,  107, 40,  255, 67,  83,  31,  255,
    40,  52,  29,  255, 107, 123, 87,  255, 104, 121, 81,  255, 44,  51,  38,  255, 38,  52,  31,  255, 73,  104, 45,  255, 60,  87,  47,  255, 73,
    99,  55,  255, 92,  122, 52,  255, 156, 171, 97,  255, 179, 205, 136, 255, 149, 186, 136, 255, 171, 197, 140, 255, 188, 204, 123, 255, 191, 210,
    138, 255, 114, 132, 71,  255, 117, 138, 72,  255, 142, 157, 72,  255, 131, 156, 73,  255, 133, 157, 84,  255, 193, 201, 86,  255, 159, 161, 62,
    255, 49,  73,  23,  255, 122, 140, 79,  255, 187, 210, 150, 255, 190, 212, 146, 255, 199, 213, 135, 255, 156, 186, 67,  255, 149, 181, 63,  255,
    74,  98,  33,  255, 97,  128, 52,  255, 136, 168, 71,  255, 135, 164, 74,  255, 139, 166, 71,  255, 151, 177, 74,  255, 131, 153, 63,  255, 82,
    111, 60,  255, 123, 155, 98,  255, 147, 165, 83,  255, 89,  106, 37,  255, 58,  84,  26,  255, 78,  108, 45,  255, 100, 129, 68,  255, 111, 136,
    68,  255, 98,  115, 40,  255, 38,  68,  19,  255, 52,  80,  29,  255, 62,  84,  29,  255, 38,  60,  15,  255, 89,  110, 48,  255, 193, 210, 123,
    255, 148, 176, 117, 255, 153, 181, 127, 255, 164, 190, 129, 255, 160, 187, 122, 255, 162, 191, 92,  255, 179, 209, 107, 255, 184, 212, 123, 255,
    188, 215, 128, 255, 187, 217, 124, 255, 181, 201, 101, 255, 135, 156, 62,  255, 151, 176, 81,  255, 140, 163, 68,  255, 121, 150, 58,  255, 149,
    173, 76,  255, 151, 175, 81,  255, 161, 187, 89,  255, 147, 164, 73,  255, 78,  87,  31,  255, 93,  117, 39,  255, 113, 144, 48,  255, 106, 138,
    47,  255, 87,  121, 42,  255, 72,  107, 34,  255, 71,  110, 34,  255, 82,  122, 44,  255, 78,  117, 38,  255, 67,  105, 29,  255, 69,  105, 29,
    255, 87,  118, 43,  255, 108, 140, 60,  255, 152, 173, 75,  255, 200, 215, 126, 255, 180, 201, 135, 255, 188, 205, 114, 255, 153, 182, 103, 255,
    172, 185, 124, 255, 219, 226, 150, 255, 201, 208, 143, 255, 150, 157, 114, 255, 148, 152, 118, 255, 89,  95,  73,  255, 56,  71,  31,  255, 117,
    149, 63,  255, 85,  111, 36,  255, 184, 204, 113, 255, 166, 195, 132, 255, 170, 197, 157, 255, 200, 216, 163, 255, 220, 228, 155, 255, 198, 207,
    139, 255, 159, 171, 129, 255, 67,  91,  34,  255, 51,  84,  31,  255, 52,  86,  37,  255, 51,  84,  37,  255, 76,  107, 44,  255, 167, 191, 102,
    255, 135, 160, 67,  255, 146, 170, 79,  255, 129, 160, 81,  255, 65,  90,  32,  255, 155, 161, 101, 255, 108, 125, 62,  255, 52,  74,  26,  255,
    43,  52,  28,  255, 47,  68,  26,  255, 65,  95,  31,  255, 44,  75,  23,  255, 33,  60,  17,  255, 49,  75,  33,  255, 72,  96,  47,  255, 122,
    154, 71,  255, 125, 165, 82,  255, 167, 178, 100, 255, 229, 226, 155, 255, 187, 210, 176, 255, 185, 207, 180, 255, 184, 209, 186, 255, 194, 212,
    177, 255, 223, 228, 167, 255, 202, 217, 152, 255, 191, 209, 136, 255, 195, 212, 121, 255, 165, 184, 92,  255, 160, 176, 82,  255, 144, 166, 75,
    255, 140, 169, 109, 255, 139, 169, 125, 255, 165, 183, 87,  255, 213, 227, 107, 255, 176, 201, 97,  255, 160, 190, 91,  255, 162, 193, 92,  255,
    207, 225, 123, 255, 144, 157, 87,  255, 47,  76,  31,  255, 68,  101, 31,  255, 112, 143, 55,  255, 105, 144, 86,  255, 87,  125, 76,  255, 123,
    153, 82,  255, 129, 160, 84,  255, 135, 163, 82,  255, 138, 168, 79,  255, 119, 148, 63,  255, 81,  100, 43,  255, 32,  53,  23,  255, 26,  47,
    23,  255, 29,  52,  23,  255, 68,  86,  45,  255, 38,  58,  19,  255, 60,  87,  23,  255, 100, 135, 52,  255, 87,  118, 58,  255, 76,  102, 65,
    255, 69,  95,  67,  255, 68,  95,  62,  255, 76,  106, 63,  255, 116, 148, 71,  255, 130, 159, 76,  255, 69,  98,  36,  255, 68,  106, 26,  255,
    83,  114, 31,  255, 55,  77,  26,  255, 42,  65,  32,  255, 39,  62,  31,  255, 47,  76,  32,  255, 96,  127, 49,  255, 81,  110, 47,  255, 63,
    94,  50,  255, 62,  92,  52,  255, 69,  101, 52,  255, 71,  101, 52,  255, 97,  130, 60,  255, 82,  108, 52,  255, 71,  107, 49,  255, 65,  103,
    47,  255, 71,  104, 40,  255, 130, 153, 76,  255, 191, 212, 102, 255, 186, 211, 138, 255, 204, 226, 202, 255, 194, 220, 191, 255, 216, 233, 172,
    255, 119, 128, 81,  255, 125, 133, 84,  255, 184, 184, 144, 255, 202, 207, 165, 255, 185, 197, 126, 255, 150, 163, 74,  255, 137, 152, 73,  255,
    126, 153, 99,  255, 121, 150, 100, 255, 122, 155, 99,  255, 117, 150, 90,  255, 135, 151, 84,  255, 132, 155, 84,  255, 115, 135, 52,  255, 170,
    189, 74,  255, 111, 144, 68,  255, 86,  121, 68,  255, 108, 139, 74,  255, 169, 186, 78,  255, 113, 139, 50,  255, 48,  76,  29,  255, 43,  63,
    32,  255, 40,  56,  31,  255, 34,  47,  29,  255, 58,  69,  39,  255, 108, 127, 58,  255, 159, 178, 93,  255, 142, 162, 87,  255, 132, 152, 82,
    255, 113, 136, 74,  255, 94,  123, 68,  255, 69,  95,  49,  255, 48,  67,  29,  255, 52,  74,  31,  255, 74,  100, 42,  255, 83,  107, 34,  255,
    134, 144, 84,  255, 208, 215, 155, 255, 197, 215, 141, 255, 195, 218, 139, 255, 197, 219, 119, 255, 176, 192, 95,  255, 217, 223, 128, 255, 219,
    230, 112, 255, 227, 236, 127, 255, 161, 185, 95,  255, 100, 141, 55,  255, 117, 154, 68,  255, 130, 163, 84,  255, 143, 173, 94,  255, 173, 197,
    99,  255, 195, 212, 111, 255, 184, 201, 105, 255, 154, 180, 97,  255, 114, 148, 75,  255, 127, 161, 84,  255, 135, 167, 93,  255, 65,  86,  47,
    255, 49,  58,  38,  255, 49,  73,  38,  255, 39,  56,  31,  255, 159, 171, 107, 255, 211, 230, 164, 255, 193, 207, 146, 255, 155, 167, 106, 255,
    90,  114, 49,  255, 65,  91,  36,  255, 65,  86,  45,  255, 114, 142, 65,  255, 103, 129, 60,  255, 190, 197, 116, 255, 197, 214, 125, 255, 173,
    198, 122, 255, 166, 192, 142, 255, 181, 209, 145, 255, 166, 188, 119, 255, 84,  111, 52,  255, 161, 178, 90,  255, 140, 164, 75,  255, 117, 142,
    65,  255, 189, 197, 95,  255, 103, 113, 47,  255, 87,  101, 60,  255, 182, 190, 129, 255, 195, 215, 151, 255, 174, 201, 145, 255, 180, 205, 143,
    255, 167, 198, 91,  255, 167, 195, 97,  255, 90,  116, 53,  255, 128, 156, 72,  255, 161, 183, 98,  255, 171, 187, 105, 255, 163, 182, 86,  255,
    154, 176, 76,  255, 100, 124, 45,  255, 107, 132, 69,  255, 107, 124, 55,  255, 85,  103, 34,  255, 73,  97,  32,  255, 74,  101, 33,  255, 87,
    118, 53,  255, 85,  114, 56,  255, 106, 131, 62,  255, 113, 139, 39,  255, 92,  131, 33,  255, 85,  124, 36,  255, 79,  108, 37,  255, 141, 152,
    87,  255, 202, 210, 125, 255, 193, 209, 130, 255, 156, 184, 117, 255, 218, 226, 113, 255, 192, 210, 90,  255, 171, 197, 104, 255, 194, 214, 111,
    255, 201, 220, 119, 255, 205, 222, 112, 255, 209, 225, 125, 255, 221, 229, 138, 255, 176, 185, 96,  255, 106, 138, 48,  255, 131, 161, 65,  255,
    138, 160, 68,  255, 146, 169, 75,  255, 155, 178, 86,  255, 162, 183, 84,  255, 153, 173, 77,  255, 74,  84,  26,  255, 34,  49,  17,  255, 49,
    75,  31,  255, 68,  106, 38,  255, 67,  104, 36,  255, 65,  104, 36,  255, 65,  106, 37,  255, 80,  118, 43,  255, 90,  129, 41,  255, 90,  123,
    37,  255, 96,  123, 38,  255, 108, 136, 53,  255, 113, 137, 53,  255, 123, 151, 60,  255, 154, 181, 60,  255, 177, 201, 110, 255, 189, 207, 165,
    255, 183, 202, 110, 255, 119, 152, 87,  255, 127, 156, 106, 255, 149, 171, 87,  255, 201, 214, 121, 255, 198, 221, 136, 255, 200, 226, 138, 255,
    222, 241, 183, 255, 196, 210, 158, 255, 135, 157, 81,  255, 148, 165, 75,  255, 171, 198, 138, 255, 175, 201, 155, 255, 203, 217, 145, 255, 195,
    210, 135, 255, 133, 161, 96,  255, 89,  120, 52,  255, 133, 152, 106, 255, 155, 173, 106, 255, 120, 139, 71,  255, 60,  89,  36,  255, 55,  82,
    37,  255, 63,  87,  34,  255, 145, 171, 87,  255, 164, 191, 91,  255, 169, 194, 107, 255, 84,  113, 56,  255, 100, 101, 62,  255, 220, 238, 183,
    255, 187, 198, 140, 255, 48,  68,  23,  255, 53,  73,  29,  255, 42,  56,  25,  255, 73,  98,  32,  255, 69,  87,  34,  255, 74,  93,  40,  255,
    58,  76,  32,  255, 44,  55,  26,  255, 95,  123, 55,  255, 135, 145, 74,  255, 251, 246, 170, 255, 212, 226, 170, 255, 186, 208, 176, 255, 196,
    213, 187, 255, 188, 209, 181, 255, 190, 211, 173, 255, 206, 219, 171, 255, 165, 190, 141, 255, 174, 194, 127, 255, 129, 159, 73,  255, 83,  111,
    33,  255, 142, 162, 75,  255, 105, 135, 55,  255, 49,  79,  26,  255, 109, 137, 83,  255, 95,  126, 50,  255, 129, 150, 63,  255, 195, 204, 107,
    255, 219, 230, 136, 255, 211, 223, 131, 255, 155, 170, 98,  255, 58,  86,  44,  255, 66,  96,  39,  255, 73,  105, 26,  255, 134, 166, 77,  255,
    100, 138, 84,  255, 121, 146, 87,  255, 126, 157, 90,  255, 93,  134, 87,  255, 98,  134, 92,  255, 107, 144, 93,  255, 119, 158, 87,  255, 147,
    184, 84,  255, 122, 147, 63,  255, 95,  115, 55,  255, 102, 125, 58,  255, 94,  117, 53,  255, 95,  116, 52,  255, 107, 133, 56,  255, 113, 145,
    62,  255, 93,  124, 65,  255, 84,  112, 73,  255, 76,  103, 74,  255, 84,  111, 71,  255, 117, 147, 77,  255, 136, 166, 84,  255, 124, 150, 77,
    255, 47,  76,  25,  255, 76,  111, 26,  255, 101, 126, 38,  255, 52,  72,  36,  255, 36,  52,  33,  255, 36,  58,  26,  255, 32,  53,  32,  255,
    74,  101, 47,  255, 122, 157, 63,  255, 102, 135, 56,  255, 87,  117, 58,  255, 74,  105, 58,  255, 73,  104, 48,  255, 84,  120, 58,  255, 96,
    131, 56,  255, 76,  106, 48,  255, 79,  107, 48,  255, 115, 133, 69,  255, 197, 200, 142, 255, 193, 211, 154, 255, 206, 229, 209, 255, 200, 224,
    186, 255, 224, 234, 162, 255, 204, 210, 145, 255, 178, 187, 140, 255, 241, 245, 196, 255, 222, 227, 183, 255, 193, 198, 164, 255, 128, 142, 98,
    255, 38,  55,  23,  255, 88,  111, 49,  255, 122, 150, 86,  255, 115, 148, 84,  255, 127, 159, 82,  255, 145, 177, 82,  255, 157, 179, 76,  255,
    177, 195, 87,  255, 106, 131, 56,  255, 138, 157, 62,  255, 130, 158, 76,  255, 93,  127, 76,  255, 141, 166, 78,  255, 127, 144, 68,  255, 65,
    95,  52,  255, 68,  104, 40,  255, 55,  82,  34,  255, 60,  90,  39,  255, 43,  65,  33,  255, 42,  62,  32,  255, 68,  83,  40,  255, 145, 142,
    75,  255, 178, 182, 95,  255, 177, 192, 115, 255, 153, 176, 105, 255, 134, 151, 89,  255, 130, 146, 83,  255, 111, 125, 72,  255, 133, 144, 90,
    255, 127, 138, 89,  255, 116, 127, 68,  255, 219, 220, 150, 255, 222, 234, 196, 255, 182, 211, 140, 255, 176, 209, 120, 255, 176, 206, 113, 255,
    212, 227, 117, 255, 227, 231, 130, 255, 223, 230, 124, 255, 220, 229, 112, 255, 212, 226, 129, 255, 164, 189, 87,  255, 139, 172, 67,  255, 132,
    165, 74,  255, 175, 199, 91,  255, 192, 214, 99,  255, 196, 216, 106, 255, 203, 221, 116, 255, 205, 221, 122, 255, 160, 185, 105, 255, 128, 162,
    87,  255, 144, 176, 99,  255, 82,  113, 52,  255, 50,  68,  33,  255, 69,  89,  47,  255, 55,  82,  42,  255, 124, 136, 84,  255, 198, 219, 148,
    255, 182, 209, 151, 255, 221, 232, 161, 255, 196, 204, 123, 255, 87,  113, 47,  255, 79,  104, 43,  255, 144, 167, 82,  255, 155, 180, 90,  255,
    178, 204, 114, 255, 183, 208, 95,  255, 195, 212, 107, 255, 193, 214, 137, 255, 163, 175, 96,  255, 169, 189, 113, 255, 89,  110, 47,  255, 176,
    194, 122, 255, 148, 185, 127, 255, 153, 187, 111, 255, 209, 223, 139, 255, 203, 216, 151, 255, 214, 227, 160, 255, 208, 224, 162, 255, 189, 210,
    124, 255, 183, 205, 129, 255, 174, 202, 157, 255, 186, 209, 127, 255, 153, 177, 87,  255, 115, 137, 65,  255, 211, 226, 145, 255, 209, 225, 163,
    255, 204, 224, 163, 255, 215, 227, 159, 255, 193, 206, 130, 255, 112, 136, 63,  255, 93,  125, 50,  255, 72,  95,  39,  255, 65,  76,  36,  255,
    68,  79,  34,  255, 63,  81,  34,  255, 85,  116, 56,  255, 83,  113, 58,  255, 102, 127, 55,  255, 143, 168, 60,  255, 136, 165, 52,  255, 120,
    151, 39,  255, 184, 199, 104, 255, 245, 248, 170, 255, 213, 226, 160, 255, 190, 212, 136, 255, 180, 202, 106, 255, 216, 224, 105, 255, 190, 215,
    106, 255, 195, 221, 91,  255, 220, 231, 123, 255, 188, 212, 157, 255, 184, 210, 153, 255, 178, 206, 151, 255, 177, 206, 150, 255, 194, 217, 146,
    255, 207, 219, 125, 255, 147, 161, 76,  255, 68,  82,  29,  255, 75,  91,  36,  255, 113, 134, 49,  255, 106, 130, 46,  255, 101, 122, 40,  255,
    60,  79,  19,  255, 60,  91,  33,  255, 77,  115, 47,  255, 77,  115, 42,  255, 76,  115, 41,  255, 76,  113, 40,  255, 87,  119, 47,  255, 113,
    139, 58,  255, 119, 147, 52,  255, 121, 149, 55,  255, 122, 148, 58,  255, 108, 136, 47,  255, 97,  128, 33,  255, 109, 140, 55,  255, 146, 171,
    95,  255, 157, 178, 123, 255, 194, 211, 143, 255, 158, 185, 104, 255, 118, 151, 100, 255, 109, 143, 84,  255, 166, 188, 87,  255, 135, 158, 77,
    255, 41,  52,  23,  255, 116, 125, 77,  255, 152, 160, 120, 255, 116, 133, 87,  255, 124, 148, 68,  255, 144, 166, 84,  255, 170, 196, 119, 255,
    174, 199, 113, 255, 138, 171, 101, 255, 107, 143, 94,  255, 108, 141, 91,  255, 122, 151, 81,  255, 124, 147, 82,  255, 149, 169, 120, 255, 154,
    180, 102, 255, 147, 168, 90,  255, 94,  117, 53,  255, 65,  84,  52,  255, 126, 135, 92,  255, 160, 188, 113, 255, 148, 179, 94,  255, 104, 118,
    55,  255, 186, 195, 142, 255, 194, 220, 175, 255, 225, 235, 171, 255, 112, 119, 72,  255, 32,  47,  17,  255, 52,  55,  26,  255, 127, 141, 67,
    255, 151, 171, 89,  255, 165, 180, 92,  255, 168, 187, 82,  255, 137, 165, 65,  255, 118, 139, 60,  255, 213, 209, 140, 255, 221, 231, 168, 255,
    180, 204, 173, 255, 186, 209, 185, 255, 191, 212, 192, 255, 186, 209, 181, 255, 199, 215, 172, 255, 177, 189, 129, 255, 131, 164, 123, 255, 158,
    184, 115, 255, 107, 141, 55,  255, 97,  123, 44,  255, 156, 183, 98,  255, 89,  121, 47,  255, 60,  87,  21,  255, 126, 144, 82,  255, 112, 143,
    75,  255, 44,  75,  29,  255, 76,  98,  37,  255, 142, 155, 84,  255, 95,  118, 60,  255, 32,  58,  26,  255, 60,  86,  37,  255, 87,  118, 43,
    255, 109, 139, 55,  255, 148, 180, 94,  255, 113, 143, 86,  255, 151, 175, 96,  255, 104, 139, 90,  255, 95,  130, 92,  255, 98,  132, 93,  255,
    100, 133, 95,  255, 106, 141, 94,  255, 132, 170, 91,  255, 150, 184, 94,  255, 151, 180, 87,  255, 129, 157, 77,  255, 110, 138, 65,  255, 96,
    121, 65,  255, 108, 138, 68,  255, 111, 140, 72,  255, 93,  122, 76,  255, 88,  116, 77,  255, 104, 133, 81,  255, 120, 148, 87,  255, 103, 136,
    85,  255, 131, 160, 94,  255, 114, 137, 69,  255, 80,  108, 50,  255, 116, 141, 52,  255, 82,  100, 39,  255, 42,  63,  31,  255, 48,  71,  32,
    255, 34,  55,  21,  255, 38,  58,  31,  255, 37,  60,  33,  255, 95,  126, 55,  255, 139, 170, 71,  255, 133, 161, 69,  255, 139, 163, 75,  255,
    117, 142, 68,  255, 81,  111, 53,  255, 83,  116, 60,  255, 185, 197, 100, 255, 186, 205, 96,  255, 190, 208, 120, 255, 208, 221, 134, 255, 220,
    236, 176, 255, 213, 234, 186, 255, 223, 236, 163, 255, 213, 221, 136, 255, 198, 207, 134, 255, 216, 222, 158, 255, 214, 223, 161, 255, 203, 208,
    147, 255, 136, 120, 76,  255, 28,  26,  19,  255, 53,  80,  36,  255, 102, 129, 56,  255, 107, 138, 62,  255, 107, 143, 76,  255, 111, 148, 82,
    255, 113, 147, 80,  255, 126, 156, 79,  255, 169, 188, 89,  255, 187, 202, 91,  255, 96,  122, 48,  255, 132, 152, 75,  255, 148, 169, 92,  255,
    109, 128, 68,  255, 62,  91,  63,  255, 73,  103, 72,  255, 89,  126, 65,  255, 65,  98,  39,  255, 63,  92,  40,  255, 62,  87,  41,  255, 55,
    81,  39,  255, 25,  38,  23,  255, 26,  34,  23,  255, 62,  65,  32,  255, 115, 126, 75,  255, 178, 188, 109, 255, 246, 241, 156, 255, 251, 250,
    164, 255, 243, 243, 160, 255, 250, 246, 164, 255, 248, 245, 163, 255, 248, 245, 160, 255, 243, 243, 153, 255, 199, 220, 146, 255, 188, 217, 142,
    255, 190, 216, 135, 255, 221, 238, 139, 255, 233, 233, 119, 255, 224, 227, 117, 255, 209, 219, 91,  255, 194, 211, 77,  255, 215, 224, 114, 255,
    190, 200, 95,  255, 137, 152, 55,  255, 188, 206, 89,  255, 199, 216, 103, 255, 203, 219, 111, 255, 205, 219, 113, 255, 207, 222, 118, 255, 212,
    226, 125, 255, 220, 233, 141, 255, 168, 189, 112, 255, 143, 178, 100, 255, 121, 156, 74,  255, 84,  121, 38,  255, 81,  112, 41,  255, 71,  92,
    47,  255, 83,  102, 52,  255, 185, 193, 117, 255, 190, 214, 150, 255, 179, 203, 148, 255, 209, 225, 153, 255, 151, 163, 98,  255, 82,  106, 52,
    255, 146, 174, 90,  255, 185, 215, 104, 255, 176, 202, 86,  255, 170, 187, 80,  255, 142, 164, 60,  255, 155, 170, 72,  255, 58,  80,  31,  255,
    93,  116, 55,  255, 109, 128, 65,  255, 169, 192, 129, 255, 160, 190, 131, 255, 131, 146, 74,  255, 165, 178, 103, 255, 197, 217, 132, 255, 206,
    223, 136, 255, 189, 213, 134, 255, 161, 195, 121, 255, 166, 196, 117, 255, 180, 206, 145, 255, 173, 199, 134, 255, 161, 181, 94,  255, 169, 192,
    104, 255, 177, 209, 136, 255, 169, 206, 139, 255, 176, 211, 145, 255, 182, 213, 152, 255, 209, 228, 163, 255, 208, 220, 147, 255, 158, 180, 107,
    255, 131, 159, 83,  255, 40,  51,  29,  255, 17,  19,  21,  255, 43,  58,  31,  255, 90,  120, 60,  255, 83,  112, 60,  255, 97,  124, 50,  255,
    156, 174, 65,  255, 151, 173, 62,  255, 149, 169, 52,  255, 208, 217, 134, 255, 194, 217, 162, 255, 186, 214, 151, 255, 189, 213, 136, 255, 193,
    210, 107, 255, 212, 221, 118, 255, 221, 226, 130, 255, 207, 211, 101, 255, 183, 203, 107, 255, 193, 218, 132, 255, 194, 219, 138, 255, 189, 216,
    141, 255, 180, 210, 147, 255, 181, 212, 157, 255, 202, 225, 162, 255, 211, 223, 154, 255, 133, 144, 77,  255, 55,  78,  17,  255, 67,  87,  26,
    255, 86,  107, 37,  255, 81,  96,  34,  255, 45,  62,  26,  255, 84,  118, 49,  255, 92,  124, 48,  255, 87,  121, 43,  255, 90,  122, 42,  255,
    91,  123, 42,  255, 86,  117, 39,  255, 72,  100, 36,  255, 93,  123, 39,  255, 131, 170, 65,  255, 133, 171, 74,  255, 133, 167, 73,  255, 123,
    153, 55,  255, 130, 156, 78,  255, 156, 182, 134, 255, 169, 184, 118, 255, 180, 199, 122, 255, 135, 167, 100, 255, 120, 156, 97,  255, 116, 151,
    83,  255, 183, 202, 97,  255, 110, 142, 62,  255, 12,  25,  17,  255, 6,   9,   12,  255, 23,  41,  15,  255, 37,  58,  17,  255, 98,  125, 49,
    255, 116, 143, 65,  255, 60,  79,  31,  255, 134, 156, 74,  255, 122, 159, 95,  255, 117, 153, 96,  255, 122, 156, 107, 255, 133, 162, 100, 255,
    130, 157, 78,  255, 138, 155, 112, 255, 125, 154, 104, 255, 126, 157, 103, 255, 160, 183, 109, 255, 133, 142, 102, 255, 60,  71,  56,  255, 121,
    142, 83,  255, 147, 179, 89,  255, 171, 185, 112, 255, 198, 222, 175, 255, 181, 208, 166, 255, 207, 225, 168, 255, 169, 178, 120, 255, 40,  55,
    17,  255, 106, 116, 60,  255, 163, 183, 109, 255, 151, 171, 102, 255, 195, 205, 94,  255, 181, 204, 92,  255, 132, 169, 82,  255, 143, 164, 86,
    255, 209, 221, 161, 255, 199, 214, 165, 255, 182, 207, 185, 255, 185, 209, 185, 255, 187, 213, 184, 255, 185, 208, 169, 255, 200, 214, 155, 255,
    117, 146, 84,  255, 122, 154, 109, 255, 141, 172, 108, 255, 107, 139, 55,  255, 87,  118, 40,  255, 98,  133, 52,  255, 77,  106, 34,  255, 90,
    114, 42,  255, 102, 127, 62,  255, 73,  102, 49,  255, 44,  68,  23,  255, 86,  113, 44,  255, 100, 128, 55,  255, 71,  94,  40,  255, 67,  86,
    43,  255, 112, 138, 65,  255, 115, 154, 65,  255, 128, 164, 76,  255, 150, 178, 96,  255, 165, 185, 100, 255, 151, 177, 98,  255, 120, 155, 102,
    255, 109, 145, 105, 255, 111, 144, 109, 255, 113, 144, 107, 255, 111, 147, 104, 255, 118, 156, 100, 255, 130, 167, 98,  255, 147, 181, 98,  255,
    145, 172, 89,  255, 98,  125, 68,  255, 95,  119, 58,  255, 119, 146, 62,  255, 113, 143, 84,  255, 90,  119, 86,  255, 113, 139, 86,  255, 121,
    152, 91,  255, 101, 132, 92,  255, 124, 149, 94,  255, 81,  100, 53,  255, 62,  79,  39,  255, 130, 148, 77,  255, 92,  111, 45,  255, 32,  46,
    25,  255, 33,  52,  28,  255, 52,  82,  34,  255, 41,  65,  23,  255, 42,  68,  26,  255, 26,  43,  21,  255, 68,  89,  48,  255, 137, 166, 87,
    255, 149, 172, 71,  255, 193, 210, 85,  255, 156, 185, 80,  255, 124, 153, 65,  255, 80,  108, 50,  255, 134, 163, 78,  255, 161, 199, 77,  255,
    170, 205, 101, 255, 189, 211, 138, 255, 176, 194, 132, 255, 129, 149, 90,  255, 126, 146, 80,  255, 178, 197, 129, 255, 190, 213, 154, 255, 193,
    216, 165, 255, 207, 221, 168, 255, 207, 223, 169, 255, 224, 238, 171, 255, 159, 145, 94,  255, 40,  40,  19,  255, 108, 136, 58,  255, 112, 153,
    67,  255, 120, 158, 82,  255, 124, 159, 84,  255, 126, 159, 83,  255, 142, 174, 84,  255, 174, 196, 92,  255, 214, 222, 98,  255, 190, 202, 96,
    255, 100, 121, 58,  255, 94,  122, 62,  255, 60,  94,  56,  255, 65,  96,  67,  255, 75,  104, 74,  255, 96,  131, 78,  255, 82,  117, 53,  255,
    65,  91,  40,  255, 67,  95,  43,  255, 39,  60,  28,  255, 26,  37,  26,  255, 26,  42,  26,  255, 21,  37,  23,  255, 32,  48,  28,  255, 55,
    65,  33,  255, 119, 119, 63,  255, 181, 174, 92,  255, 249, 243, 142, 255, 249, 245, 152, 255, 243, 239, 154, 255, 246, 241, 159, 255, 241, 241,
    161, 255, 206, 225, 160, 255, 218, 233, 150, 255, 217, 224, 137, 255, 155, 152, 84,  255, 153, 156, 81,  255, 204, 205, 95,  255, 221, 227, 98,
    255, 190, 210, 89,  255, 203, 216, 97,  255, 189, 201, 91,  255, 123, 143, 55,  255, 191, 205, 83,  255, 226, 233, 122, 255, 226, 232, 133, 255,
    230, 235, 140, 255, 236, 241, 145, 255, 227, 231, 135, 255, 185, 196, 102, 255, 147, 163, 76,  255, 147, 168, 95,  255, 146, 172, 86,  255, 121,
    154, 45,  255, 108, 140, 42,  255, 74,  105, 41,  255, 60,  92,  37,  255, 127, 146, 62,  255, 207, 219, 136, 255, 183, 211, 146, 255, 188, 211,
    149, 255, 193, 206, 117, 255, 124, 150, 76,  255, 137, 164, 80,  255, 107, 125, 48,  255, 114, 133, 55,  255, 115, 134, 53,  255, 99,  120, 42,
    255, 58,  80,  26,  255, 52,  82,  33,  255, 60,  94,  37,  255, 97,  121, 60,  255, 150, 172, 109, 255, 99,  121, 62,  255, 47,  72,  32,  255,
    53,  74,  36,  255, 123, 142, 63,  255, 167, 181, 86,  255, 201, 209, 104, 255, 198, 215, 102, 255, 187, 210, 102, 255, 177, 203, 111, 255, 165,
    187, 114, 255, 184, 203, 103, 255, 180, 200, 91,  255, 190, 213, 100, 255, 193, 215, 103, 255, 196, 211, 119, 255, 211, 223, 140, 255, 214, 223,
    145, 255, 199, 215, 149, 255, 201, 218, 148, 255, 202, 216, 131, 255, 146, 156, 73,  255, 52,  76,  23,  255, 68,  98,  31,  255, 83,  113, 49,
    255, 84,  115, 53,  255, 92,  117, 47,  255, 146, 163, 67,  255, 170, 185, 83,  255, 155, 174, 80,  255, 202, 214, 145, 255, 197, 218, 159, 255,
    193, 211, 119, 255, 193, 202, 104, 255, 180, 194, 108, 255, 179, 194, 117, 255, 183, 192, 107, 255, 128, 152, 72,  255, 115, 144, 65,  255, 127,
    138, 62,  255, 123, 135, 62,  255, 136, 148, 72,  255, 187, 205, 116, 255, 187, 201, 110, 255, 153, 162, 84,  255, 146, 154, 82,  255, 113, 128,
    53,  255, 78,  104, 34,  255, 62,  89,  26,  255, 60,  84,  26,  255, 65,  84,  31,  255, 76,  110, 36,  255, 89,  127, 38,  255, 79,  114, 32,
    255, 62,  97,  28,  255, 62,  99,  29,  255, 60,  95,  26,  255, 57,  89,  25,  255, 39,  56,  23,  255, 62,  83,  32,  255, 158, 189, 76,  255,
    154, 185, 85,  255, 154, 188, 92,  255, 154, 183, 104, 255, 160, 181, 120, 255, 167, 193, 155, 255, 156, 176, 84,  255, 168, 191, 105, 255, 130,
    163, 103, 255, 117, 154, 90,  255, 139, 166, 82,  255, 168, 190, 91,  255, 62,  98,  40,  255, 39,  60,  26,  255, 19,  23,  19,  255, 36,  53,
    23,  255, 50,  75,  25,  255, 104, 134, 58,  255, 86,  117, 47,  255, 47,  68,  28,  255, 85,  101, 39,  255, 151, 180, 94,  255, 116, 154, 94,
    255, 123, 160, 115, 255, 120, 154, 106, 255, 136, 164, 87,  255, 124, 143, 94,  255, 131, 154, 112, 255, 111, 143, 101, 255, 128, 155, 116, 255,
    141, 167, 104, 255, 78,  87,  47,  255, 28,  37,  23,  255, 136, 154, 87,  255, 201, 217, 156, 255, 179, 209, 166, 255, 173, 202, 161, 255, 211,
    226, 169, 255, 119, 128, 89,  255, 39,  53,  19,  255, 133, 154, 98,  255, 153, 172, 112, 255, 175, 189, 107, 255, 178, 193, 94,  255, 173, 195,
    102, 255, 145, 175, 101, 255, 137, 159, 85,  255, 180, 201, 154, 255, 201, 215, 175, 255, 187, 209, 188, 255, 189, 209, 187, 255, 180, 206, 174,
    255, 189, 209, 152, 255, 167, 190, 128, 255, 106, 142, 87,  255, 104, 139, 87,  255, 131, 164, 92,  255, 94,  127, 39,  255, 58,  92,  26,  255,
    87,  111, 40,  255, 86,  109, 39,  255, 83,  111, 42,  255, 90,  117, 53,  255, 71,  92,  39,  255, 87,  115, 53,  255, 90,  121, 60,  255, 143,
    171, 104, 255, 124, 156, 82,  255, 139, 171, 81,  255, 148, 171, 84,  255, 96,  129, 52,  255, 114, 148, 65,  255, 135, 166, 90,  255, 140, 167,
    107, 255, 184, 200, 116, 255, 159, 186, 119, 255, 127, 164, 120, 255, 127, 160, 117, 255, 125, 162, 111, 255, 117, 156, 100, 255, 117, 155, 103,
    255, 126, 161, 109, 255, 128, 166, 105, 255, 143, 177, 100, 255, 143, 170, 79,  255, 93,  118, 50,  255, 94,  120, 55,  255, 129, 159, 100, 255,
    115, 141, 97,  255, 121, 150, 96,  255, 110, 139, 97,  255, 121, 144, 89,  255, 68,  87,  48,  255, 26,  47,  23,  255, 31,  53,  26,  255, 50,
    79,  26,  255, 43,  63,  25,  255, 26,  42,  25,  255, 26,  42,  23,  255, 38,  63,  26,  255, 52,  80,  33,  255, 29,  43,  23,  255, 15,  21,
    17,  255, 109, 129, 87,  255, 123, 157, 107, 255, 123, 143, 84,  255, 133, 146, 55,  255, 166, 191, 92,  255, 132, 165, 84,  255, 118, 150, 74,
    255, 114, 137, 67,  255, 175, 193, 92,  255, 161, 182, 91,  255, 83,  112, 55,  255, 47,  75,  36,  255, 63,  84,  41,  255, 50,  72,  44,  255,
    112, 131, 80,  255, 208, 220, 161, 255, 202, 221, 180, 255, 194, 217, 177, 255, 204, 221, 167, 255, 201, 220, 166, 255, 209, 230, 169, 255, 160,
    157, 94,  255, 117, 142, 55,  255, 128, 168, 68,  255, 123, 158, 65,  255, 141, 172, 73,  255, 130, 165, 69,  255, 125, 148, 69,  255, 155, 171,
    86,  255, 203, 213, 110, 255, 226, 229, 123, 255, 188, 199, 107, 255, 87,  119, 65,  255, 92,  133, 65,  255, 83,  121, 63,  255, 81,  116, 71,
    255, 83,  115, 65,  255, 91,  127, 58,  255, 69,  103, 47,  255, 66,  96,  41,  255, 63,  95,  47,  255, 74,  105, 53,  255, 87,  120, 60,  255,
    101, 131, 69,  255, 134, 164, 107, 255, 116, 145, 74,  255, 72,  102, 47,  255, 29,  44,  23,  255, 100, 94,  52,  255, 219, 212, 117, 255, 239,
    243, 136, 255, 213, 221, 136, 255, 225, 228, 147, 255, 234, 238, 157, 255, 250, 245, 153, 255, 226, 226, 140, 255, 56,  68,  37,  255, 43,  60,
    28,  255, 123, 138, 60,  255, 202, 212, 111, 255, 198, 216, 120, 255, 199, 219, 121, 255, 193, 211, 108, 255, 199, 208, 110, 255, 179, 185, 93,
    255, 184, 187, 89,  255, 215, 216, 115, 255, 213, 214, 115, 255, 171, 173, 86,  255, 146, 162, 76,  255, 150, 181, 86,  255, 139, 174, 68,  255,
    133, 162, 55,  255, 135, 160, 58,  255, 136, 157, 60,  255, 120, 147, 52,  255, 107, 137, 49,  255, 112, 140, 58,  255, 97,  114, 41,  255, 93,
    97,  42,  255, 189, 199, 111, 255, 194, 216, 131, 255, 170, 194, 106, 255, 149, 169, 84,  255, 78,  86,  38,  255, 17,  23,  17,  255, 29,  42,
    21,  255, 31,  44,  21,  255, 38,  53,  23,  255, 44,  65,  29,  255, 114, 144, 73,  255, 107, 138, 55,  255, 97,  128, 49,  255, 95,  120, 55,
    255, 52,  83,  33,  255, 58,  86,  43,  255, 47,  67,  40,  255, 60,  77,  36,  255, 119, 148, 63,  255, 137, 164, 73,  255, 179, 192, 98,  255,
    195, 213, 137, 255, 179, 202, 150, 255, 153, 171, 106, 255, 188, 196, 115, 255, 150, 169, 65,  255, 177, 202, 74,  255, 106, 121, 44,  255, 154,
    168, 96,  255, 195, 214, 151, 255, 174, 203, 151, 255, 178, 208, 159, 255, 197, 209, 134, 255, 177, 177, 100, 255, 150, 156, 74,  255, 69,  99,
    23,  255, 62,  94,  33,  255, 82,  115, 45,  255, 112, 140, 55,  255, 77,  106, 33,  255, 93,  112, 47,  255, 145, 161, 68,  255, 153, 172, 81,
    255, 183, 195, 113, 255, 192, 205, 126, 255, 151, 174, 75,  255, 158, 183, 95,  255, 148, 174, 100, 255, 153, 175, 93,  255, 133, 161, 80,  255,
    105, 140, 71,  255, 132, 141, 53,  255, 166, 164, 49,  255, 52,  77,  25,  255, 77,  102, 37,  255, 130, 153, 53,  255, 156, 183, 58,  255, 130,
    160, 47,  255, 157, 169, 81,  255, 171, 179, 90,  255, 173, 180, 89,  255, 148, 158, 72,  255, 67,  75,  34,  255, 33,  49,  19,  255, 103, 146,
    47,  255, 106, 150, 48,  255, 104, 149, 55,  255, 93,  135, 49,  255, 65,  105, 36,  255, 62,  98,  25,  255, 65,  99,  26,  255, 96,  123, 52,
    255, 118, 141, 55,  255, 154, 181, 79,  255, 151, 177, 75,  255, 183, 200, 113, 255, 164, 188, 139, 255, 163, 181, 122, 255, 191, 207, 137, 255,
    150, 170, 76,  255, 146, 177, 105, 255, 115, 154, 97,  255, 129, 157, 87,  255, 189, 204, 93,  255, 131, 152, 63,  255, 55,  79,  34,  255, 39,
    62,  26,  255, 29,  37,  21,  255, 38,  49,  21,  255, 52,  77,  25,  255, 65,  96,  40,  255, 53,  77,  26,  255, 80,  101, 45,  255, 39,  51,
    19,  255, 135, 156, 68,  255, 126, 162, 91,  255, 122, 156, 107, 255, 127, 156, 106, 255, 166, 187, 106, 255, 159, 181, 125, 255, 174, 190, 135,
    255, 160, 178, 122, 255, 132, 153, 107, 255, 126, 150, 92,  255, 177, 194, 112, 255, 45,  57,  31,  255, 84,  89,  48,  255, 202, 214, 155, 255,
    173, 202, 157, 255, 177, 203, 157, 255, 208, 222, 153, 255, 62,  73,  43,  255, 47,  55,  26,  255, 148, 168, 109, 255, 169, 185, 92,  255, 159,
    177, 76,  255, 58,  73,  36,  255, 72,  89,  40,  255, 73,  86,  50,  255, 105, 128, 65,  255, 174, 197, 154, 255, 200, 215, 177, 255, 186, 208,
    185, 255, 185, 208, 183, 255, 179, 202, 168, 255, 210, 220, 147, 255, 177, 199, 112, 255, 123, 156, 94,  255, 91,  129, 68,  255, 112, 150, 72,
    255, 39,  68,  15,  255, 71,  91,  36,  255, 62,  82,  36,  255, 81,  106, 41,  255, 134, 164, 83,  255, 111, 140, 74,  255, 91,  127, 69,  255,
    74,  111, 67,  255, 65,  99,  60,  255, 96,  125, 81,  255, 162, 189, 130, 255, 123, 163, 83,  255, 157, 186, 102, 255, 120, 143, 65,  255, 53,
    76,  23,  255, 118, 148, 80,  255, 93,  131, 86,  255, 105, 137, 81,  255, 153, 174, 100, 255, 154, 181, 121, 255, 136, 170, 122, 255, 128, 166,
    119, 255, 125, 163, 107, 255, 111, 151, 78,  255, 117, 156, 84,  255, 119, 156, 95,  255, 119, 157, 99,  255, 135, 169, 86,  255, 89,  117, 47,
    255, 95,  117, 62,  255, 135, 164, 117, 255, 120, 150, 107, 255, 118, 148, 97,  255, 109, 133, 76,  255, 50,  71,  34,  255, 31,  52,  26,  255,
    29,  52,  25,  255, 32,  58,  21,  255, 29,  51,  17,  255, 26,  38,  15,  255, 15,  23,  15,  255, 19,  31,  19,  255, 26,  42,  21,  255, 52,
    81,  34,  255, 40,  52,  29,  255, 32,  42,  25,  255, 139, 160, 110, 255, 113, 148, 108, 255, 130, 157, 111, 255, 90,  108, 55,  255, 123, 139,
    68,  255, 172, 191, 108, 255, 154, 173, 98,  255, 142, 161, 87,  255, 121, 137, 58,  255, 77,  97,  36,  255, 84,  118, 44,  255, 62,  87,  41,
    255, 63,  91,  43,  255, 58,  81,  48,  255, 123, 139, 71,  255, 186, 207, 115, 255, 198, 216, 153, 255, 213, 227, 187, 255, 197, 218, 177, 255,
    198, 220, 166, 255, 187, 214, 164, 255, 208, 229, 165, 255, 212, 214, 116, 255, 152, 168, 74,  255, 158, 179, 80,  255, 173, 192, 76,  255, 160,
    187, 81,  255, 114, 146, 65,  255, 136, 167, 77,  255, 90,  116, 62,  255, 164, 180, 104, 255, 209, 218, 126, 255, 102, 123, 77,  255, 97,  129,
    79,  255, 110, 141, 84,  255, 109, 135, 67,  255, 102, 134, 53,  255, 76,  113, 47,  255, 63,  95,  43,  255, 77,  109, 53,  255, 91,  128, 60,
    255, 91,  134, 53,  255, 126, 162, 84,  255, 146, 178, 102, 255, 143, 173, 100, 255, 136, 161, 85,  255, 168, 193, 93,  255, 151, 177, 89,  255,
    69,  92,  47,  255, 58,  62,  29,  255, 178, 175, 87,  255, 213, 221, 118, 255, 201, 221, 141, 255, 199, 215, 126, 255, 212, 220, 128, 255, 234,
    236, 146, 255, 206, 211, 133, 255, 84,  99,  50,  255, 169, 184, 89,  255, 217, 223, 115, 255, 200, 212, 108, 255, 193, 210, 116, 255, 192, 209,
    129, 255, 199, 215, 143, 255, 228, 233, 145, 255, 174, 179, 92,  255, 105, 120, 44,  255, 103, 125, 37,  255, 81,  106, 33,  255, 151, 183, 96,
    255, 161, 190, 102, 255, 150, 181, 78,  255, 151, 181, 62,  255, 180, 195, 79,  255, 182, 189, 84,  255, 170, 180, 80,  255, 112, 125, 55,  255,
    62,  71,  36,  255, 42,  48,  28,  255, 52,  62,  34,  255, 78,  97,  39,  255, 125, 141, 65,  255, 140, 161, 80,  255, 131, 154, 77,  255, 138,
    159, 96,  255, 161, 184, 121, 255, 152, 169, 106, 255, 123, 138, 87,  255, 114, 134, 84,  255, 93,  118, 62,  255, 168, 182, 111, 255, 202, 220,
    150, 255, 175, 190, 116, 255, 80,  93,  42,  255, 53,  84,  32,  255, 63,  92,  42,  255, 52,  73,  41,  255, 53,  72,  33,  255, 67,  84,  33,
    255, 92,  112, 47,  255, 155, 175, 87,  255, 204, 216, 128, 255, 188, 211, 149, 255, 155, 175, 116, 255, 174, 188, 110, 255, 166, 188, 83,  255,
    169, 198, 86,  255, 121, 139, 73,  255, 193, 214, 157, 255, 174, 203, 160, 255, 174, 203, 159, 255, 196, 221, 155, 255, 171, 176, 98,  255, 42,
    57,  19,  255, 63,  90,  32,  255, 49,  76,  26,  255, 84,  107, 42,  255, 186, 199, 73,  255, 172, 189, 62,  255, 133, 162, 65,  255, 128, 157,
    65,  255, 193, 204, 90,  255, 192, 204, 109, 255, 146, 179, 83,  255, 146, 179, 90,  255, 140, 177, 79,  255, 203, 222, 97,  255, 161, 174, 67,
    255, 107, 141, 65,  255, 118, 152, 75,  255, 122, 153, 78,  255, 218, 216, 104, 255, 208, 206, 89,  255, 149, 164, 80,  255, 134, 144, 74,  255,
    79,  100, 37,  255, 178, 203, 87,  255, 187, 207, 93,  255, 192, 199, 105, 255, 189, 190, 95,  255, 185, 185, 83,  255, 184, 188, 83,  255, 171,
    182, 80,  255, 101, 128, 45,  255, 127, 168, 74,  255, 135, 171, 76,  255, 131, 165, 74,  255, 117, 159, 62,  255, 100, 138, 49,  255, 118, 143,
    47,  255, 129, 154, 53,  255, 113, 141, 47,  255, 148, 171, 65,  255, 128, 152, 52,  255, 112, 130, 39,  255, 203, 208, 127, 255, 161, 183, 134,
    255, 168, 182, 112, 255, 168, 186, 98,  255, 131, 156, 62,  255, 137, 169, 99,  255, 116, 150, 87,  255, 158, 181, 84,  255, 112, 142, 50,  255,
    143, 164, 56,  255, 184, 193, 83,  255, 140, 147, 77,  255, 152, 163, 97,  255, 180, 193, 108, 255, 157, 168, 82,  255, 97,  118, 56,  255, 48,
    67,  28,  255, 90,  110, 49,  255, 26,  39,  21,  255, 69,  87,  26,  255, 140, 169, 81,  255, 121, 156, 104, 255, 148, 172, 110, 255, 167, 190,
    102, 255, 112, 143, 92,  255, 139, 158, 113, 255, 137, 161, 105, 255, 140, 168, 97,  255, 173, 193, 107, 255, 187, 206, 108, 255, 146, 170, 80,
    255, 90,  104, 43,  255, 172, 181, 123, 255, 175, 205, 160, 255, 189, 213, 167, 255, 141, 165, 95,  255, 93,  110, 34,  255, 163, 160, 69,  255,
    222, 222, 124, 255, 209, 217, 134, 255, 98,  107, 55,  255, 21,  28,  19,  255, 12,  19,  17,  255, 3,   3,   6,   255, 75,  94,  42,  255, 174,
    199, 157, 255, 188, 211, 185, 255, 185, 209, 187, 255, 180, 205, 177, 255, 219, 226, 169, 255, 180, 193, 115, 255, 94,  127, 50,  255, 134, 167,
    84,  255, 87,  126, 52,  255, 84,  121, 36,  255, 95,  115, 36,  255, 123, 137, 60,  255, 47,  67,  31,  255, 48,  76,  23,  255, 100, 132, 58,
    255, 125, 153, 78,  255, 100, 132, 74,  255, 80,  114, 68,  255, 75,  107, 65,  255, 69,  102, 60,  255, 112, 141, 90,  255, 150, 180, 107, 255,
    128, 167, 91,  255, 149, 184, 99,  255, 142, 164, 72,  255, 142, 167, 84,  255, 99,  132, 83,  255, 99,  131, 78,  255, 72,  92,  40,  255, 119,
    138, 67,  255, 167, 188, 108, 255, 171, 194, 118, 255, 172, 195, 108, 255, 167, 188, 92,  255, 154, 182, 86,  255, 130, 160, 74,  255, 131, 162,
    84,  255, 128, 164, 82,  255, 107, 138, 58,  255, 81,  106, 52,  255, 126, 156, 106, 255, 120, 149, 97,  255, 79,  103, 52,  255, 32,  55,  23,
    255, 29,  52,  26,  255, 41,  56,  31,  255, 79,  84,  52,  255, 139, 142, 89,  255, 159, 148, 99,  255, 157, 145, 101, 255, 153, 141, 96,  255,
    138, 137, 84,  255, 60,  55,  33,  255, 23,  31,  17,  255, 52,  76,  36,  255, 53,  69,  34,  255, 139, 161, 107, 255, 115, 149, 107, 255, 112,
    146, 109, 255, 128, 152, 91,  255, 97,  123, 53,  255, 108, 137, 58,  255, 107, 121, 63,  255, 52,  80,  36,  255, 36,  65,  26,  255, 42,  62,
    29,  255, 94,  129, 52,  255, 93,  125, 50,  255, 69,  100, 46,  255, 69,  90,  44,  255, 171, 186, 105, 255, 148, 182, 113, 255, 123, 161, 93,
    255, 198, 211, 144, 255, 233, 238, 183, 255, 218, 229, 178, 255, 193, 215, 166, 255, 174, 205, 156, 255, 209, 228, 159, 255, 105, 92,  55,  255,
    73,  86,  39,  255, 186, 195, 87,  255, 198, 202, 84,  255, 133, 158, 71,  255, 161, 173, 79,  255, 155, 166, 109, 255, 200, 215, 160, 255, 157,
    176, 100, 255, 91,  115, 69,  255, 145, 168, 109, 255, 138, 166, 112, 255, 159, 176, 108, 255, 162, 174, 76,  255, 127, 154, 79,  255, 107, 133,
    65,  255, 96,  130, 52,  255, 93,  126, 44,  255, 152, 170, 84,  255, 135, 154, 91,  255, 134, 154, 84,  255, 162, 172, 87,  255, 159, 177, 96,
    255, 141, 167, 94,  255, 167, 189, 99,  255, 185, 203, 102, 255, 105, 131, 63,  255, 82,  101, 39,  255, 161, 165, 62,  255, 195, 192, 101, 255,
    234, 234, 142, 255, 223, 227, 116, 255, 199, 211, 102, 255, 204, 215, 106, 255, 169, 186, 92,  255, 173, 186, 87,  255, 187, 202, 95,  255, 156,
    185, 94,  255, 164, 192, 119, 255, 166, 194, 128, 255, 167, 197, 127, 255, 181, 206, 138, 255, 218, 228, 152, 255, 161, 178, 85,  255, 126, 154,
    47,  255, 134, 163, 62,  255, 163, 191, 99,  255, 154, 184, 93,  255, 152, 180, 77,  255, 196, 208, 102, 255, 187, 197, 89,  255, 169, 186, 84,
    255, 195, 203, 92,  255, 193, 200, 84,  255, 92,  111, 45,  255, 47,  73,  32,  255, 55,  71,  36,  255, 62,  77,  41,  255, 63,  87,  40,  255,
    94,  114, 47,  255, 162, 180, 87,  255, 193, 218, 135, 255, 188, 212, 138, 255, 197, 217, 147, 255, 205, 220, 142, 255, 179, 201, 135, 255, 159,
    180, 113, 255, 149, 169, 76,  255, 202, 218, 134, 255, 194, 219, 150, 255, 192, 204, 132, 255, 95,  114, 55,  255, 58,  89,  32,  255, 65,  87,
    43,  255, 49,  68,  31,  255, 38,  56,  25,  255, 42,  62,  26,  255, 60,  77,  31,  255, 80,  89,  39,  255, 164, 180, 107, 255, 141, 164, 92,
    255, 99,  120, 50,  255, 150, 173, 84,  255, 177, 199, 100, 255, 185, 196, 117, 255, 202, 220, 148, 255, 192, 214, 137, 255, 190, 213, 138, 255,
    216, 230, 149, 255, 170, 173, 89,  255, 39,  55,  19,  255, 47,  67,  28,  255, 47,  77,  25,  255, 152, 164, 63,  255, 232, 226, 96,  255, 147,
    172, 75,  255, 134, 169, 86,  255, 162, 187, 84,  255, 220, 227, 123, 255, 181, 203, 120, 255, 163, 193, 101, 255, 152, 183, 95,  255, 139, 176,
    87,  255, 200, 219, 102, 255, 139, 153, 52,  255, 93,  130, 60,  255, 106, 144, 68,  255, 129, 152, 75,  255, 217, 219, 120, 255, 135, 147, 74,
    255, 109, 121, 53,  255, 97,  111, 58,  255, 31,  47,  21,  255, 137, 164, 73,  255, 183, 195, 104, 255, 200, 207, 103, 255, 190, 199, 90,  255,
    185, 190, 90,  255, 186, 196, 94,  255, 195, 209, 104, 255, 212, 221, 136, 255, 217, 225, 156, 255, 229, 235, 169, 255, 235, 241, 175, 255, 216,
    225, 153, 255, 173, 189, 108, 255, 108, 131, 53,  255, 106, 129, 52,  255, 126, 138, 55,  255, 165, 180, 82,  255, 180, 197, 103, 255, 172, 196,
    101, 255, 193, 210, 135, 255, 149, 174, 113, 255, 165, 179, 84,  255, 132, 156, 75,  255, 67,  97,  28,  255, 113, 143, 62,  255, 134, 166, 74,
    255, 116, 149, 55,  255, 81,  105, 40,  255, 148, 162, 83,  255, 196, 215, 134, 255, 191, 216, 139, 255, 162, 191, 117, 255, 111, 132, 75,  255,
    91,  105, 45,  255, 160, 179, 85,  255, 63,  89,  37,  255, 91,  117, 43,  255, 55,  82,  33,  255, 46,  73,  23,  255, 115, 142, 56,  255, 132,
    164, 99,  255, 158, 182, 110, 255, 163, 186, 96,  255, 140, 162, 97,  255, 112, 131, 95,  255, 125, 146, 109, 255, 111, 142, 109, 255, 142, 169,
    111, 255, 179, 197, 108, 255, 177, 198, 98,  255, 146, 172, 65,  255, 139, 154, 78,  255, 179, 203, 157, 255, 170, 195, 130, 255, 98,  127, 62,
    255, 92,  124, 49,  255, 132, 149, 62,  255, 219, 225, 142, 255, 216, 231, 159, 255, 174, 185, 111, 255, 69,  76,  43,  255, 17,  21,  19,  255,
    19,  26,  17,  255, 68,  89,  36,  255, 166, 193, 153, 255, 185, 209, 196, 255, 177, 205, 177, 255, 200, 216, 170, 255, 188, 199, 127, 255, 74,
    103, 39,  255, 60,  92,  36,  255, 105, 132, 55,  255, 105, 133, 43,  255, 124, 142, 48,  255, 136, 157, 62,  255, 116, 142, 60,  255, 93,  127,
    55,  255, 72,  110, 39,  255, 91,  118, 44,  255, 132, 164, 67,  255, 132, 164, 72,  255, 139, 167, 75,  255, 105, 140, 68,  255, 85,  122, 68,
    255, 74,  111, 65,  255, 83,  117, 72,  255, 102, 137, 74,  255, 147, 179, 91,  255, 149, 188, 90,  255, 110, 140, 62,  255, 103, 138, 75,  255,
    82,  114, 62,  255, 55,  77,  36,  255, 65,  94,  52,  255, 73,  98,  58,  255, 108, 128, 69,  255, 128, 152, 75,  255, 112, 142, 62,  255, 78,
    117, 47,  255, 52,  84,  28,  255, 65,  87,  36,  255, 92,  121, 48,  255, 92,  122, 53,  255, 105, 123, 65,  255, 113, 135, 73,  255, 67,  91,
    48,  255, 33,  55,  26,  255, 36,  58,  26,  255, 31,  58,  23,  255, 132, 143, 100, 255, 227, 236, 190, 255, 232, 249, 198, 255, 220, 243, 192,
    255, 211, 235, 185, 255, 212, 236, 181, 255, 222, 238, 182, 255, 219, 219, 161, 255, 176, 168, 119, 255, 87,  90,  48,  255, 36,  58,  23,  255,
    116, 139, 82,  255, 117, 148, 99,  255, 104, 138, 104, 255, 142, 169, 103, 255, 122, 152, 74,  255, 121, 134, 84,  255, 69,  89,  40,  255, 48,
    75,  29,  255, 52,  77,  31,  255, 42,  73,  23,  255, 67,  102, 42,  255, 99,  132, 60,  255, 78,  111, 60,  255, 72,  97,  47,  255, 161, 179,
    100, 255, 169, 195, 118, 255, 157, 187, 106, 255, 154, 184, 97,  255, 183, 198, 104, 255, 181, 196, 117, 255, 198, 213, 144, 255, 202, 219, 154,
    255, 190, 217, 151, 255, 183, 192, 111, 255, 82,  102, 36,  255, 134, 160, 79,  255, 113, 137, 65,  255, 131, 155, 87,  255, 110, 133, 69,  255,
    183, 208, 135, 255, 201, 224, 153, 255, 113, 138, 82,  255, 101, 128, 84,  255, 157, 178, 102, 255, 114, 141, 90,  255, 113, 141, 76,  255, 135,
    160, 68,  255, 180, 202, 119, 255, 179, 201, 90,  255, 125, 151, 50,  255, 144, 165, 82,  255, 136, 159, 101, 255, 162, 176, 108, 255, 168, 178,
    102, 255, 126, 151, 71,  255, 129, 160, 90,  255, 116, 151, 100, 255, 129, 157, 100, 255, 181, 199, 107, 255, 166, 185, 97,  255, 118, 136, 75,
    255, 139, 148, 71,  255, 71,  76,  34,  255, 230, 221, 127, 255, 251, 238, 146, 255, 197, 208, 139, 255, 155, 181, 124, 255, 141, 164, 96,  255,
    148, 164, 78,  255, 226, 232, 121, 255, 193, 210, 99,  255, 181, 202, 100, 255, 181, 206, 120, 255, 172, 201, 125, 255, 177, 207, 150, 255, 189,
    215, 166, 255, 209, 219, 134, 255, 148, 172, 58,  255, 144, 169, 67,  255, 165, 192, 97,  255, 153, 184, 83,  255, 148, 176, 68,  255, 185, 193,
    84,  255, 166, 185, 87,  255, 129, 159, 91,  255, 138, 163, 95,  255, 175, 191, 84,  255, 180, 193, 78,  255, 89,  116, 37,  255, 69,  100, 37,
    255, 62,  79,  36,  255, 67,  78,  42,  255, 149, 166, 103, 255, 208, 226, 170, 255, 221, 231, 158, 255, 184, 197, 107, 255, 176, 198, 115, 255,
    195, 213, 133, 255, 197, 210, 126, 255, 154, 174, 83,  255, 169, 192, 93,  255, 171, 193, 95,  255, 176, 205, 118, 255, 182, 209, 147, 255, 193,
    203, 124, 255, 115, 133, 55,  255, 165, 183, 86,  255, 141, 156, 84,  255, 128, 147, 80,  255, 87,  120, 52,  255, 111, 135, 60,  255, 182, 190,
    97,  255, 188, 201, 112, 255, 189, 203, 128, 255, 98,  119, 60,  255, 83,  109, 43,  255, 142, 165, 75,  255, 201, 212, 110, 255, 192, 213, 90,
    255, 204, 221, 101, 255, 207, 221, 128, 255, 234, 239, 153, 255, 153, 163, 75,  255, 65,  97,  31,  255, 53,  76,  26,  255, 55,  76,  25,  255,
    149, 167, 58,  255, 228, 223, 101, 255, 160, 181, 101, 255, 178, 194, 94,  255, 219, 205, 82,  255, 210, 209, 102, 255, 196, 215, 116, 255, 165,
    193, 111, 255, 145, 180, 97,  255, 169, 202, 112, 255, 182, 190, 87,  255, 86,  113, 41,  255, 84,  122, 50,  255, 92,  129, 49,  255, 88,  113,
    47,  255, 125, 146, 86,  255, 63,  89,  31,  255, 65,  83,  38,  255, 71,  87,  37,  255, 34,  53,  23,  255, 60,  100, 25,  255, 113, 137, 58,
    255, 197, 207, 90,  255, 184, 208, 74,  255, 165, 179, 92,  255, 220, 225, 151, 255, 248, 249, 186, 255, 229, 238, 184, 255, 228, 238, 189, 255,
    206, 222, 175, 255, 148, 162, 117, 255, 205, 219, 160, 255, 126, 152, 74,  255, 91,  123, 43,  255, 75,  87,  23,  255, 173, 166, 83,  255, 220,
    227, 148, 255, 181, 200, 136, 255, 151, 181, 116, 255, 162, 185, 120, 255, 145, 162, 89,  255, 171, 188, 107, 255, 100, 132, 55,  255, 74,  97,
    38,  255, 97,  115, 44,  255, 124, 153, 60,  255, 119, 141, 58,  255, 186, 206, 111, 255, 176, 203, 121, 255, 160, 189, 105, 255, 154, 185, 93,
    255, 108, 142, 71,  255, 29,  47,  12,  255, 79,  102, 32,  255, 177, 198, 87,  255, 124, 142, 71,  255, 133, 157, 73,  255, 74,  107, 38,  255,
    52,  87,  28,  255, 79,  107, 33,  255, 139, 164, 77,  255, 165, 184, 110, 255, 169, 183, 99,  255, 144, 160, 99,  255, 93,  120, 72,  255, 130,
    149, 106, 255, 130, 162, 130, 255, 146, 172, 125, 255, 190, 205, 114, 255, 149, 178, 74,  255, 98,  135, 65,  255, 116, 142, 79,  255, 181, 192,
    142, 255, 148, 166, 79,  255, 108, 135, 53,  255, 69,  100, 41,  255, 67,  92,  43,  255, 154, 166, 121, 255, 194, 209, 144, 255, 203, 223, 142,
    255, 186, 197, 110, 255, 84,  85,  37,  255, 21,  25,  17,  255, 49,  67,  23,  255, 157, 183, 147, 255, 186, 211, 195, 255, 194, 216, 174, 255,
    193, 208, 141, 255, 92,  115, 53,  255, 138, 153, 68,  255, 118, 136, 67,  255, 130, 147, 67,  255, 161, 177, 79,  255, 132, 158, 56,  255, 135,
    158, 53,  255, 136, 161, 65,  255, 90,  121, 49,  255, 91,  123, 52,  255, 121, 147, 67,  255, 112, 146, 80,  255, 97,  129, 71,  255, 139, 168,
    71,  255, 139, 170, 68,  255, 101, 137, 68,  255, 109, 139, 69,  255, 130, 158, 77,  255, 122, 151, 83,  255, 101, 134, 74,  255, 89,  126, 63,
    255, 82,  120, 50,  255, 87,  125, 48,  255, 77,  111, 48,  255, 69,  92,  47,  255, 68,  93,  58,  255, 63,  91,  48,  255, 63,  96,  41,  255,
    62,  101, 39,  255, 48,  77,  36,  255, 29,  52,  25,  255, 40,  67,  25,  255, 44,  68,  28,  255, 65,  101, 42,  255, 71,  101, 49,  255, 126,
    142, 92,  255, 124, 135, 92,  255, 72,  96,  50,  255, 60,  97,  37,  255, 62,  94,  38,  255, 55,  87,  33,  255, 69,  100, 44,  255, 93,  105,
    74,  255, 138, 148, 115, 255, 195, 207, 164, 255, 213, 230, 183, 255, 211, 233, 191, 255, 203, 227, 190, 255, 207, 229, 188, 255, 217, 236, 188,
    255, 222, 231, 167, 255, 94,  92,  56,  255, 72,  92,  50,  255, 131, 160, 101, 255, 106, 140, 102, 255, 131, 161, 97,  255, 121, 145, 75,  255,
    104, 125, 60,  255, 74,  108, 36,  255, 79,  112, 41,  255, 72,  101, 32,  255, 94,  117, 42,  255, 104, 123, 48,  255, 91,  114, 50,  255, 72,
    103, 58,  255, 52,  83,  47,  255, 124, 141, 73,  255, 208, 218, 119, 255, 146, 158, 76,  255, 113, 131, 67,  255, 102, 130, 67,  255, 71,  100,
    52,  255, 90,  126, 62,  255, 134, 160, 93,  255, 176, 194, 113, 255, 183, 203, 106, 255, 120, 144, 58,  255, 97,  119, 47,  255, 137, 157, 76,
    255, 215, 227, 132, 255, 149, 170, 84,  255, 123, 147, 71,  255, 94,  116, 63,  255, 75,  102, 55,  255, 77,  110, 55,  255, 50,  74,  31,  255,
    52,  77,  26,  255, 127, 157, 56,  255, 164, 188, 95,  255, 178, 199, 99,  255, 119, 150, 53,  255, 134, 163, 68,  255, 128, 156, 84,  255, 80,
    113, 71,  255, 107, 138, 65,  255, 99,  130, 49,  255, 103, 136, 68,  255, 127, 158, 99,  255, 130, 160, 98,  255, 111, 141, 84,  255, 161, 182,
    92,  255, 187, 204, 107, 255, 166, 178, 95,  255, 58,  63,  32,  255, 58,  75,  36,  255, 196, 200, 109, 255, 229, 222, 117, 255, 227, 224, 133,
    255, 167, 189, 137, 255, 122, 154, 109, 255, 144, 161, 80,  255, 154, 158, 79,  255, 100, 110, 47,  255, 94,  108, 45,  255, 138, 151, 68,  255,
    183, 201, 105, 255, 193, 209, 124, 255, 192, 214, 155, 255, 209, 223, 166, 255, 168, 182, 65,  255, 151, 174, 62,  255, 168, 195, 92,  255, 152,
    175, 65,  255, 127, 145, 40,  255, 142, 154, 43,  255, 201, 206, 82,  255, 160, 181, 82,  255, 130, 160, 89,  255, 143, 169, 90,  255, 182, 197,
    87,  255, 155, 171, 62,  255, 98,  118, 36,  255, 119, 136, 62,  255, 191, 202, 132, 255, 216, 234, 178, 255, 231, 243, 175, 255, 197, 204, 118,
    255, 170, 189, 105, 255, 190, 206, 118, 255, 202, 211, 115, 255, 173, 190, 98,  255, 187, 203, 104, 255, 177, 198, 122, 255, 175, 203, 116, 255,
    187, 212, 103, 255, 159, 193, 122, 255, 193, 214, 139, 255, 207, 219, 102, 255, 183, 200, 102, 255, 163, 184, 113, 255, 149, 178, 118, 255, 148,
    172, 112, 255, 192, 201, 117, 255, 194, 208, 103, 255, 196, 219, 109, 255, 198, 220, 120, 255, 199, 216, 122, 255, 148, 170, 77,  255, 155, 175,
    76,  255, 194, 213, 119, 255, 182, 206, 145, 255, 177, 206, 157, 255, 200, 219, 160, 255, 206, 208, 121, 255, 151, 169, 81,  255, 129, 156, 69,
    255, 92,  118, 40,  255, 41,  53,  19,  255, 116, 141, 58,  255, 186, 192, 106, 255, 183, 192, 108, 255, 167, 174, 73,  255, 84,  97,  31,  255,
    119, 132, 56,  255, 220, 227, 124, 255, 170, 200, 131, 255, 173, 198, 116, 255, 171, 182, 96,  255, 95,  119, 45,  255, 74,  113, 45,  255, 83,
    120, 47,  255, 85,  114, 39,  255, 76,  102, 36,  255, 36,  51,  21,  255, 57,  86,  34,  255, 34,  46,  21,  255, 98,  117, 44,  255, 98,  129,
    48,  255, 71,  109, 31,  255, 77,  109, 31,  255, 155, 169, 75,  255, 171, 186, 71,  255, 49,  65,  23,  255, 94,  113, 44,  255, 169, 179, 91,
    255, 216, 222, 145, 255, 219, 235, 161, 255, 159, 179, 119, 255, 26,  47,  12,  255, 93,  120, 56,  255, 99,  123, 41,  255, 169, 167, 86,  255,
    224, 220, 150, 255, 236, 243, 183, 255, 221, 233, 163, 255, 198, 212, 129, 255, 173, 191, 112, 255, 160, 182, 90,  255, 152, 177, 79,  255, 169,
    194, 113, 255, 126, 162, 93,  255, 90,  115, 47,  255, 172, 186, 110, 255, 173, 197, 122, 255, 186, 205, 124, 255, 203, 218, 117, 255, 189, 205,
    91,  255, 169, 190, 81,  255, 179, 195, 104, 255, 184, 199, 112, 255, 156, 170, 91,  255, 120, 142, 67,  255, 171, 196, 90,  255, 216, 233, 137,
    255, 154, 181, 92,  255, 90,  117, 39,  255, 118, 135, 62,  255, 172, 182, 99,  255, 206, 215, 131, 255, 212, 220, 141, 255, 197, 206, 125, 255,
    191, 195, 114, 255, 179, 187, 116, 255, 131, 149, 105, 255, 138, 162, 129, 255, 165, 184, 107, 255, 138, 174, 60,  255, 91,  133, 47,  255, 118,
    151, 84,  255, 107, 135, 68,  255, 141, 148, 112, 255, 82,  91,  58,  255, 78,  105, 36,  255, 63,  92,  34,  255, 63,  90,  36,  255, 71,  100,
    46,  255, 86,  112, 62,  255, 111, 140, 63,  255, 161, 187, 90,  255, 182, 197, 89,  255, 150, 154, 73,  255, 143, 153, 69,  255, 168, 187, 110,
    255, 196, 215, 157, 255, 168, 187, 138, 255, 77,  97,  55,  255, 91,  112, 72,  255, 58,  92,  36,  255, 60,  76,  34,  255, 60,  87,  32,  255,
    75,  110, 39,  255, 115, 142, 49,  255, 126, 152, 50,  255, 90,  122, 36,  255, 82,  115, 41,  255, 107, 136, 52,  255, 136, 164, 82,  255, 128,
    159, 86,  255, 97,  128, 62,  255, 82,  113, 47,  255, 133, 152, 72,  255, 184, 201, 111, 255, 183, 210, 129, 255, 166, 199, 121, 255, 134, 175,
    104, 255, 122, 163, 95,  255, 122, 162, 93,  255, 128, 158, 74,  255, 113, 143, 58,  255, 83,  121, 55,  255, 74,  105, 50,  255, 76,  106, 47,
    255, 79,  112, 48,  255, 65,  95,  44,  255, 42,  62,  37,  255, 34,  52,  32,  255, 34,  53,  31,  255, 39,  63,  29,  255, 65,  95,  34,  255,
    76,  110, 55,  255, 48,  74,  44,  255, 63,  90,  43,  255, 104, 124, 71,  255, 90,  121, 48,  255, 80,  111, 47,  255, 55,  76,  40,  255, 36,
    52,  31,  255, 41,  63,  31,  255, 26,  41,  19,  255, 12,  19,  12,  255, 40,  48,  29,  255, 93,  103, 69,  255, 144, 159, 116, 255, 189, 204,
    159, 255, 201, 218, 179, 255, 211, 229, 191, 255, 209, 232, 193, 255, 212, 221, 165, 255, 82,  83,  47,  255, 90,  118, 71,  255, 117, 151, 106,
    255, 124, 148, 90,  255, 119, 135, 69,  255, 91,  119, 45,  255, 105, 136, 44,  255, 123, 148, 55,  255, 149, 167, 77,  255, 199, 212, 126, 255,
    206, 222, 140, 255, 191, 204, 123, 255, 160, 171, 97,  255, 123, 135, 75,  255, 68,  83,  40,  255, 78,  107, 50,  255, 32,  44,  26,  255, 36,
    53,  26,  255, 79,  114, 41,  255, 84,  121, 40,  255, 84,  122, 37,  255, 84,  122, 36,  255, 90,  126, 49,  255, 109, 140, 65,  255, 124, 148,
    67,  255, 117, 140, 58,  255, 111, 142, 72,  255, 115, 142, 87,  255, 91,  126, 74,  255, 87,  119, 62,  255, 130, 139, 69,  255, 167, 174, 85,
    255, 122, 127, 52,  255, 23,  33,  21,  255, 17,  34,  17,  255, 85,  114, 37,  255, 165, 188, 93,  255, 144, 167, 72,  255, 55,  87,  25,  255,
    119, 149, 65,  255, 104, 136, 78,  255, 77,  110, 60,  255, 104, 138, 55,  255, 93,  125, 49,  255, 110, 144, 84,  255, 117, 150, 97,  255, 91,
    128, 77,  255, 97,  132, 58,  255, 162, 184, 84,  255, 213, 222, 116, 255, 158, 173, 89,  255, 40,  58,  26,  255, 28,  48,  29,  255, 128, 146,
    76,  255, 163, 183, 68,  255, 217, 216, 111, 255, 212, 216, 145, 255, 131, 164, 118, 255, 127, 152, 74,  255, 116, 138, 65,  255, 23,  52,  15,
    255, 67,  92,  43,  255, 127, 151, 74,  255, 143, 169, 90,  255, 149, 172, 98,  255, 174, 187, 102, 255, 172, 181, 106, 255, 139, 146, 47,  255,
    135, 149, 47,  255, 149, 164, 62,  255, 128, 142, 40,  255, 127, 141, 38,  255, 142, 154, 49,  255, 159, 165, 67,  255, 190, 198, 78,  255, 172,
    190, 75,  255, 196, 208, 108, 255, 194, 208, 104, 255, 161, 184, 82,  255, 188, 203, 111, 255, 221, 233, 166, 255, 211, 231, 174, 255, 217, 231,
    166, 255, 245, 243, 157, 255, 196, 200, 87,  255, 199, 211, 109, 255, 154, 162, 75,  255, 128, 154, 69,  255, 132, 161, 78,  255, 154, 178, 97,
    255, 146, 168, 87,  255, 172, 189, 100, 255, 178, 189, 95,  255, 188, 212, 126, 255, 167, 197, 113, 255, 203, 220, 124, 255, 153, 176, 114, 255,
    151, 175, 113, 255, 149, 174, 110, 255, 133, 166, 112, 255, 145, 170, 114, 255, 119, 141, 81,  255, 161, 178, 86,  255, 187, 205, 99,  255, 157,
    185, 110, 255, 154, 181, 98,  255, 163, 180, 90,  255, 196, 213, 145, 255, 169, 198, 154, 255, 182, 208, 156, 255, 216, 218, 131, 255, 136, 147,
    62,  255, 112, 139, 58,  255, 162, 178, 83,  255, 123, 136, 47,  255, 39,  49,  17,  255, 143, 161, 63,  255, 129, 155, 74,  255, 124, 149, 75,
    255, 98,  129, 60,  255, 96,  134, 62,  255, 99,  136, 62,  255, 138, 162, 80,  255, 185, 198, 115, 255, 130, 142, 62,  255, 55,  73,  23,  255,
    68,  108, 41,  255, 76,  114, 43,  255, 81,  111, 41,  255, 105, 131, 49,  255, 142, 167, 80,  255, 33,  46,  19,  255, 38,  62,  21,  255, 55,
    71,  23,  255, 121, 155, 62,  255, 119, 151, 65,  255, 105, 141, 50,  255, 62,  97,  21,  255, 56,  77,  26,  255, 164, 178, 87,  255, 41,  51,
    28,  255, 26,  40,  17,  255, 47,  62,  15,  255, 178, 190, 96,  255, 208, 229, 115, 255, 143, 165, 92,  255, 31,  56,  19,  255, 26,  43,  6,
    255, 161, 150, 84,  255, 248, 253, 185, 255, 221, 238, 195, 255, 193, 214, 183, 255, 164, 194, 144, 255, 162, 193, 131, 255, 137, 172, 102, 255,
    136, 166, 71,  255, 137, 164, 60,  255, 154, 170, 80,  255, 114, 131, 58,  255, 170, 171, 83,  255, 189, 206, 106, 255, 175, 202, 142, 255, 158,
    191, 139, 255, 168, 197, 135, 255, 201, 220, 138, 255, 201, 216, 127, 255, 180, 193, 106, 255, 184, 205, 94,  255, 182, 206, 91,  255, 173, 195,
    93,  255, 187, 216, 100, 255, 179, 213, 104, 255, 128, 149, 73,  255, 161, 175, 84,  255, 220, 234, 148, 255, 223, 235, 158, 255, 207, 223, 143,
    255, 205, 219, 135, 255, 211, 221, 132, 255, 229, 233, 136, 255, 248, 248, 155, 255, 186, 193, 124, 255, 167, 183, 82,  255, 135, 170, 55,  255,
    91,  133, 42,  255, 69,  100, 40,  255, 74,  103, 47,  255, 55,  84,  34,  255, 80,  99,  48,  255, 97,  110, 69,  255, 43,  72,  21,  255, 50,
    68,  29,  255, 107, 126, 44,  255, 132, 152, 50,  255, 111, 131, 34,  255, 105, 126, 34,  255, 107, 128, 42,  255, 108, 138, 52,  255, 134, 175,
    68,  255, 143, 183, 72,  255, 149, 180, 69,  255, 154, 178, 95,  255, 36,  51,  31,  255, 19,  31,  15,  255, 91,  95,  80,  255, 47,  63,  32,
    255, 49,  73,  23,  255, 52,  83,  29,  255, 73,  107, 39,  255, 79,  111, 45,  255, 76,  112, 38,  255, 73,  102, 32,  255, 85,  105, 40,  255,
    142, 165, 80,  255, 137, 166, 80,  255, 118, 152, 77,  255, 84,  112, 60,  255, 94,  120, 62,  255, 173, 190, 133, 255, 197, 227, 171, 255, 164,
    200, 146, 255, 151, 191, 125, 255, 147, 184, 116, 255, 147, 183, 114, 255, 173, 202, 118, 255, 177, 201, 102, 255, 83,  116, 42,  255, 74,  108,
    48,  255, 76,  107, 45,  255, 82,  119, 48,  255, 68,  101, 44,  255, 60,  84,  50,  255, 48,  67,  47,  255, 41,  60,  38,  255, 41,  62,  34,
    255, 42,  67,  33,  255, 83,  115, 49,  255, 82,  113, 58,  255, 55,  77,  53,  255, 52,  74,  44,  255, 89,  110, 60,  255, 100, 126, 56,  255,
    94,  116, 56,  255, 41,  52,  34,  255, 33,  49,  33,  255, 41,  65,  36,  255, 48,  68,  34,  255, 29,  37,  23,  255, 36,  52,  28,  255, 21,
    37,  21,  255, 31,  41,  31,  255, 69,  78,  55,  255, 71,  86,  50,  255, 118, 137, 91,  255, 166, 189, 132, 255, 198, 222, 162, 255, 197, 209,
    148, 255, 84,  94,  53,  255, 116, 149, 87,  255, 119, 137, 77,  255, 116, 138, 60,  255, 159, 175, 84,  255, 189, 200, 122, 255, 201, 215, 158,
    255, 200, 220, 173, 255, 194, 219, 174, 255, 187, 213, 171, 255, 180, 207, 164, 255, 178, 206, 153, 255, 192, 213, 149, 255, 189, 202, 142, 255,
    166, 169, 108, 255, 88,  96,  52,  255, 46,  72,  32,  255, 42,  68,  31,  255, 47,  75,  31,  255, 51,  87,  29,  255, 58,  96,  31,  255, 72,
    110, 32,  255, 79,  114, 38,  255, 99,  128, 49,  255, 87,  118, 55,  255, 67,  102, 62,  255, 63,  103, 65,  255, 88,  116, 72,  255, 188, 196,
    112, 255, 219, 226, 133, 255, 196, 216, 108, 255, 178, 187, 80,  255, 60,  67,  31,  255, 69,  77,  39,  255, 107, 122, 47,  255, 160, 181, 71,
    255, 85,  114, 40,  255, 55,  84,  31,  255, 112, 141, 75,  255, 92,  121, 77,  255, 79,  111, 55,  255, 106, 140, 60,  255, 79,  111, 44,  255,
    98,  135, 80,  255, 101, 135, 76,  255, 116, 146, 60,  255, 168, 186, 77,  255, 179, 192, 87,  255, 91,  103, 49,  255, 47,  72,  31,  255, 75,
    98,  55,  255, 130, 146, 86,  255, 159, 179, 85,  255, 133, 167, 53,  255, 207, 212, 114, 255, 254, 245, 166, 255, 181, 197, 134, 255, 121, 148,
    74,  255, 153, 168, 87,  255, 77,  103, 37,  255, 145, 169, 87,  255, 125, 156, 92,  255, 112, 147, 84,  255, 141, 171, 90,  255, 154, 165, 58,
    255, 132, 139, 33,  255, 124, 137, 38,  255, 79,  106, 26,  255, 67,  92,  26,  255, 75,  95,  34,  255, 62,  79,  40,  255, 63,  84,  41,  255,
    69,  99,  43,  255, 115, 135, 60,  255, 187, 189, 68,  255, 221, 226, 123, 255, 184, 203, 124, 255, 210, 222, 148, 255, 213, 231, 174, 255, 190,
    218, 171, 255, 202, 221, 161, 255, 243, 245, 174, 255, 229, 228, 143, 255, 179, 189, 89,  255, 175, 199, 90,  255, 127, 140, 65,  255, 119, 141,
    65,  255, 140, 168, 78,  255, 154, 175, 80,  255, 123, 150, 74,  255, 134, 161, 73,  255, 104, 132, 52,  255, 172, 188, 90,  255, 166, 190, 86,
    255, 178, 199, 95,  255, 150, 175, 103, 255, 148, 178, 112, 255, 160, 184, 116, 255, 158, 181, 113, 255, 133, 167, 113, 255, 141, 170, 97,  255,
    84,  103, 36,  255, 143, 157, 74,  255, 160, 186, 109, 255, 152, 180, 111, 255, 154, 172, 91,  255, 167, 190, 133, 255, 167, 195, 133, 255, 212,
    218, 135, 255, 127, 132, 52,  255, 140, 155, 76,  255, 126, 146, 68,  255, 120, 140, 50,  255, 74,  87,  31,  255, 17,  19,  17,  255, 86,  95,
    42,  255, 174, 184, 85,  255, 198, 206, 107, 255, 146, 165, 80,  255, 103, 140, 69,  255, 110, 146, 72,  255, 107, 143, 68,  255, 105, 139, 62,
    255, 96,  134, 55,  255, 69,  99,  31,  255, 102, 129, 47,  255, 87,  116, 38,  255, 103, 131, 55,  255, 162, 184, 90,  255, 173, 192, 98,  255,
    33,  47,  23,  255, 44,  63,  21,  255, 110, 118, 62,  255, 156, 176, 98,  255, 153, 169, 96,  255, 163, 182, 91,  255, 138, 143, 91,  255, 92,
    95,  67,  255, 128, 139, 68,  255, 29,  37,  19,  255, 21,  32,  19,  255, 25,  34,  19,  255, 148, 163, 86,  255, 212, 239, 126, 255, 94,  125,
    56,  255, 45,  68,  17,  255, 147, 139, 79,  255, 226, 238, 173, 255, 216, 233, 185, 255, 210, 224, 177, 255, 190, 210, 156, 255, 169, 196, 134,
    255, 147, 175, 99,  255, 130, 159, 74,  255, 117, 147, 58,  255, 130, 157, 75,  255, 137, 149, 77,  255, 149, 149, 80,  255, 167, 183, 93,  255,
    155, 176, 77,  255, 199, 211, 137, 255, 202, 222, 166, 255, 179, 206, 157, 255, 175, 202, 147, 255, 190, 214, 154, 255, 191, 216, 151, 255, 195,
    209, 127, 255, 164, 187, 87,  255, 159, 189, 84,  255, 146, 178, 76,  255, 152, 177, 77,  255, 190, 206, 125, 255, 210, 231, 145, 255, 217, 233,
    134, 255, 199, 215, 121, 255, 181, 201, 116, 255, 196, 211, 117, 255, 216, 225, 125, 255, 206, 219, 131, 255, 185, 195, 128, 255, 225, 232, 142,
    255, 149, 178, 53,  255, 87,  131, 39,  255, 91,  128, 47,  255, 68,  103, 39,  255, 58,  91,  37,  255, 63,  98,  36,  255, 67,  91,  31,  255,
    122, 131, 79,  255, 94,  115, 49,  255, 74,  93,  41,  255, 56,  82,  28,  255, 63,  83,  29,  255, 96,  109, 52,  255, 65,  89,  34,  255, 52,
    79,  32,  255, 29,  47,  26,  255, 28,  41,  21,  255, 106, 140, 52,  255, 165, 193, 82,  255, 84,  100, 50,  255, 29,  37,  26,  255, 19,  31,
    17,  255, 73,  75,  58,  255, 67,  82,  48,  255, 39,  65,  21,  255, 62,  97,  39,  255, 67,  104, 47,  255, 65,  99,  38,  255, 52,  75,  31,
    255, 47,  67,  23,  255, 125, 152, 71,  255, 127, 161, 84,  255, 130, 160, 83,  255, 108, 138, 81,  255, 90,  117, 60,  255, 145, 165, 100, 255,
    198, 224, 166, 255, 168, 196, 129, 255, 185, 208, 133, 255, 190, 219, 149, 255, 189, 217, 149, 255, 193, 216, 141, 255, 165, 185, 115, 255, 73,
    103, 60,  255, 60,  92,  46,  255, 86,  109, 58,  255, 68,  92,  47,  255, 65,  100, 47,  255, 72,  109, 42,  255, 75,  115, 48,  255, 63,  91,
    53,  255, 52,  72,  47,  255, 55,  77,  47,  255, 51,  83,  39,  255, 82,  115, 50,  255, 79,  105, 60,  255, 62,  89,  62,  255, 62,  89,  62,
    255, 77,  101, 62,  255, 89,  116, 62,  255, 96,  131, 68,  255, 104, 124, 63,  255, 40,  58,  39,  255, 40,  65,  39,  255, 58,  87,  39,  255,
    36,  48,  26,  255, 25,  33,  21,  255, 38,  52,  26,  255, 65,  84,  42,  255, 83,  110, 50,  255, 76,  114, 44,  255, 71,  108, 41,  255, 69,
    107, 38,  255, 91,  129, 55,  255, 152, 181, 99,  255, 158, 177, 87,  255, 123, 145, 75,  255, 126, 148, 74,  255, 161, 183, 107, 255, 199, 217,
    160, 255, 194, 219, 180, 255, 184, 213, 176, 255, 184, 214, 171, 255, 181, 212, 166, 255, 185, 213, 163, 255, 188, 213, 159, 255, 194, 216, 157,
    255, 189, 211, 153, 255, 174, 196, 141, 255, 170, 189, 130, 255, 122, 133, 87,  255, 42,  63,  34,  255, 44,  67,  39,  255, 44,  65,  36,  255,
    42,  68,  34,  255, 41,  68,  34,  255, 40,  68,  31,  255, 75,  111, 47,  255, 94,  129, 48,  255, 69,  104, 47,  255, 69,  104, 62,  255, 76,
    109, 65,  255, 181, 192, 104, 255, 216, 223, 135, 255, 149, 181, 111, 255, 141, 174, 81,  255, 150, 172, 74,  255, 167, 188, 77,  255, 198, 217,
    84,  255, 166, 183, 74,  255, 96,  123, 43,  255, 76,  108, 37,  255, 86,  117, 36,  255, 101, 133, 65,  255, 138, 161, 81,  255, 135, 157, 62,
    255, 127, 151, 56,  255, 92,  116, 50,  255, 100, 134, 75,  255, 119, 157, 53,  255, 165, 191, 62,  255, 187, 204, 76,  255, 99,  104, 48,  255,
    43,  53,  29,  255, 72,  99,  52,  255, 156, 187, 136, 255, 169, 196, 126, 255, 157, 185, 84,  255, 149, 179, 76,  255, 170, 181, 78,  255, 245,
    232, 142, 255, 241, 236, 158, 255, 137, 157, 80,  255, 153, 171, 80,  255, 122, 150, 65,  255, 111, 145, 77,  255, 112, 147, 84,  255, 136, 166,
    87,  255, 173, 183, 82,  255, 142, 147, 49,  255, 103, 114, 42,  255, 94,  120, 36,  255, 68,  92,  28,  255, 63,  87,  33,  255, 58,  83,  40,
    255, 44,  65,  47,  255, 49,  74,  44,  255, 55,  87,  38,  255, 73,  111, 45,  255, 89,  109, 44,  255, 195, 204, 132, 255, 207, 219, 155, 255,
    221, 233, 173, 255, 192, 219, 173, 255, 194, 218, 168, 255, 211, 228, 164, 255, 230, 239, 175, 255, 166, 177, 111, 255, 167, 186, 110, 255, 171,
    201, 80,  255, 141, 158, 69,  255, 149, 163, 91,  255, 164, 184, 100, 255, 137, 159, 79,  255, 140, 165, 102, 255, 174, 190, 113, 255, 186, 204,
    104, 255, 175, 186, 87,  255, 172, 182, 84,  255, 207, 220, 92,  255, 215, 229, 97,  255, 234, 238, 117, 255, 227, 231, 143, 255, 197, 211, 136,
    255, 152, 179, 116, 255, 137, 169, 107, 255, 81,  109, 44,  255, 82,  106, 36,  255, 189, 197, 112, 255, 174, 192, 121, 255, 124, 145, 75,  255,
    137, 163, 84,  255, 194, 207, 109, 255, 217, 210, 111, 255, 118, 133, 49,  255, 111, 130, 53,  255, 90,  115, 37,  255, 87,  122, 36,  255, 68,
    94,  31,  255, 26,  38,  23,  255, 29,  47,  26,  255, 68,  81,  36,  255, 162, 164, 81,  255, 123, 140, 58,  255, 103, 141, 68,  255, 115, 153,
    75,  255, 118, 154, 71,  255, 113, 153, 73,  255, 106, 143, 60,  255, 85,  115, 36,  255, 174, 181, 81,  255, 190, 189, 90,  255, 154, 169, 84,
    255, 173, 193, 96,  255, 146, 168, 87,  255, 17,  31,  17,  255, 53,  68,  21,  255, 158, 171, 107, 255, 195, 201, 159, 255, 225, 238, 190, 255,
    233, 248, 201, 255, 241, 255, 221, 255, 238, 245, 209, 255, 202, 199, 163, 255, 130, 127, 99,  255, 37,  41,  26,  255, 21,  32,  19,  255, 63,
    72,  38,  255, 141, 171, 96,  255, 37,  63,  17,  255, 144, 140, 74,  255, 239, 249, 181, 255, 204, 225, 160, 255, 182, 194, 122, 255, 175, 178,
    119, 255, 165, 175, 108, 255, 161, 183, 93,  255, 146, 170, 79,  255, 132, 159, 74,  255, 119, 143, 62,  255, 189, 183, 97,  255, 225, 224, 137,
    255, 120, 148, 68,  255, 118, 143, 76,  255, 158, 183, 132, 255, 186, 196, 126, 255, 217, 223, 143, 255, 204, 220, 167, 255, 191, 217, 173, 255,
    180, 208, 161, 255, 173, 203, 150, 255, 199, 218, 152, 255, 195, 207, 129, 255, 101, 133, 58,  255, 136, 166, 75,  255, 165, 188, 104, 255, 184,
    210, 123, 255, 159, 184, 93,  255, 176, 199, 77,  255, 156, 189, 73,  255, 152, 180, 94,  255, 187, 202, 113, 255, 221, 232, 135, 255, 105, 121,
    72,  255, 29,  44,  17,  255, 118, 137, 73,  255, 141, 171, 81,  255, 87,  126, 42,  255, 69,  100, 42,  255, 47,  74,  29,  255, 51,  81,  29,
    255, 55,  82,  31,  255, 62,  87,  26,  255, 85,  98,  56,  255, 58,  75,  39,  255, 38,  55,  17,  255, 36,  62,  12,  255, 40,  73,  17,  255,
    40,  65,  31,  255, 26,  49,  23,  255, 36,  62,  23,  255, 36,  58,  25,  255, 15,  19,  17,  255, 69,  81,  36,  255, 150, 169, 90,  255, 173,
    190, 130, 255, 94,  108, 67,  255, 15,  23,  9,   255, 65,  75,  46,  255, 93,  101, 68,  255, 39,  65,  23,  255, 43,  65,  28,  255, 21,  26,
    21,  255, 50,  74,  28,  255, 39,  58,  21,  255, 74,  91,  34,  255, 127, 159, 89,  255, 101, 134, 81,  255, 116, 147, 87,  255, 93,  127, 76,
    255, 105, 130, 69,  255, 136, 161, 115, 255, 113, 141, 94,  255, 51,  84,  25,  255, 55,  81,  36,  255, 82,  107, 63,  255, 87,  103, 62,  255,
    98,  126, 68,  255, 78,  108, 63,  255, 62,  87,  60,  255, 58,  83,  56,  255, 76,  95,  55,  255, 60,  84,  40,  255, 51,  81,  41,  255, 49,
    79,  38,  255, 53,  90,  34,  255, 77,  118, 48,  255, 86,  122, 65,  255, 72,  104, 69,  255, 65,  99,  60,  255, 95,  130, 58,  255, 100, 126,
    67,  255, 68,  97,  68,  255, 75,  103, 74,  255, 78,  102, 65,  255, 88,  108, 65,  255, 96,  129, 67,  255, 141, 167, 81,  255, 79,  97,  58,
    255, 40,  62,  40,  255, 58,  94,  40,  255, 41,  58,  28,  255, 68,  87,  41,  255, 102, 134, 63,  255, 106, 140, 62,  255, 99,  135, 60,  255,
    93,  128, 58,  255, 90,  126, 56,  255, 86,  123, 53,  255, 81,  117, 49,  255, 120, 146, 65,  255, 140, 165, 79,  255, 128, 142, 82,  255, 133,
    159, 84,  255, 185, 207, 136, 255, 188, 210, 144, 255, 194, 215, 150, 255, 197, 218, 152, 255, 185, 206, 134, 255, 187, 203, 126, 255, 158, 175,
    104, 255, 126, 144, 80,  255, 115, 135, 68,  255, 86,  110, 48,  255, 48,  69,  26,  255, 47,  74,  25,  255, 52,  71,  36,  255, 47,  68,  42,
    255, 47,  72,  44,  255, 49,  73,  44,  255, 52,  72,  43,  255, 47,  69,  38,  255, 39,  60,  31,  255, 48,  75,  33,  255, 92,  126, 47,  255,
    71,  104, 47,  255, 67,  103, 65,  255, 125, 147, 83,  255, 216, 225, 122, 255, 154, 184, 108, 255, 142, 171, 85,  255, 183, 194, 83,  255, 197,
    208, 87,  255, 203, 219, 91,  255, 163, 175, 80,  255, 39,  58,  26,  255, 65,  96,  31,  255, 38,  55,  26,  255, 29,  44,  19,  255, 67,  87,
    42,  255, 112, 144, 71,  255, 112, 147, 52,  255, 110, 148, 50,  255, 145, 170, 75,  255, 154, 174, 79,  255, 140, 170, 68,  255, 153, 181, 74,
    255, 185, 200, 81,  255, 147, 174, 90,  255, 154, 181, 111, 255, 170, 184, 105, 255, 166, 190, 119, 255, 159, 191, 112, 255, 155, 184, 83,  255,
    167, 191, 72,  255, 134, 164, 67,  255, 159, 173, 69,  255, 216, 217, 110, 255, 137, 157, 65,  255, 120, 149, 55,  255, 121, 154, 67,  255, 133,
    164, 74,  255, 146, 168, 77,  255, 142, 159, 68,  255, 108, 127, 52,  255, 74,  103, 52,  255, 85,  117, 58,  255, 95,  120, 44,  255, 45,  62,
    31,  255, 58,  87,  43,  255, 55,  84,  43,  255, 52,  76,  52,  255, 51,  76,  49,  255, 58,  89,  44,  255, 110, 138, 50,  255, 117, 137, 46,
    255, 153, 163, 91,  255, 227, 235, 168, 255, 196, 222, 173, 255, 188, 217, 171, 255, 195, 221, 168, 255, 207, 229, 181, 255, 208, 213, 151, 255,
    100, 127, 63,  255, 159, 183, 95,  255, 168, 200, 79,  255, 199, 215, 99,  255, 201, 210, 114, 255, 142, 171, 97,  255, 118, 152, 93,  255, 234,
    239, 172, 255, 233, 238, 176, 255, 227, 233, 165, 255, 216, 227, 156, 255, 194, 205, 129, 255, 224, 227, 98,  255, 238, 238, 102, 255, 250, 249,
    132, 255, 223, 226, 127, 255, 180, 200, 114, 255, 170, 190, 103, 255, 139, 173, 93,  255, 119, 150, 72,  255, 131, 152, 68,  255, 211, 216, 116,
    255, 164, 183, 99,  255, 118, 144, 68,  255, 138, 163, 73,  255, 173, 190, 97,  255, 168, 185, 96,  255, 173, 191, 102, 255, 179, 193, 94,  255,
    129, 148, 56,  255, 114, 144, 56,  255, 74,  93,  38,  255, 38,  53,  26,  255, 46,  68,  31,  255, 37,  58,  26,  255, 52,  76,  31,  255, 83,
    113, 40,  255, 83,  116, 39,  255, 84,  113, 43,  255, 85,  112, 45,  255, 92,  121, 48,  255, 74,  98,  32,  255, 63,  86,  28,  255, 140, 151,
    77,  255, 212, 214, 104, 255, 204, 216, 92,  255, 179, 198, 97,  255, 68,  90,  43,  255, 36,  36,  21,  255, 68,  84,  31,  255, 47,  73,  26,
    255, 17,  26,  12,  255, 60,  74,  37,  255, 124, 140, 91,  255, 196, 208, 173, 255, 229, 249, 221, 255, 231, 255, 220, 255, 238, 255, 213, 255,
    197, 202, 161, 255, 63,  72,  47,  255, 40,  51,  21,  255, 109, 127, 71,  255, 55,  56,  32,  255, 206, 217, 160, 255, 187, 208, 138, 255, 169,
    175, 93,  255, 194, 192, 119, 255, 231, 232, 181, 255, 199, 206, 139, 255, 150, 170, 80,  255, 145, 169, 81,  255, 135, 162, 74,  255, 127, 141,
    63,  255, 234, 223, 139, 255, 218, 227, 163, 255, 89,  120, 58,  255, 130, 150, 95,  255, 167, 185, 137, 255, 205, 210, 128, 255, 167, 191, 116,
    255, 167, 185, 120, 255, 208, 224, 166, 255, 194, 220, 174, 255, 184, 212, 163, 255, 179, 207, 152, 255, 224, 235, 152, 255, 155, 172, 105, 255,
    109, 135, 74,  255, 150, 177, 107, 255, 153, 184, 122, 255, 126, 156, 77,  255, 131, 161, 75,  255, 148, 178, 118, 255, 188, 204, 128, 255, 213,
    225, 131, 255, 115, 132, 74,  255, 23,  40,  17,  255, 52,  74,  28,  255, 62,  90,  28,  255, 84,  119, 50,  255, 96,  127, 55,  255, 71,  99,
    46,  255, 37,  58,  26,  255, 46,  71,  26,  255, 48,  75,  26,  255, 41,  68,  25,  255, 78,  90,  42,  255, 174, 166, 113, 255, 159, 158, 108,
    255, 142, 147, 87,  255, 104, 117, 52,  255, 77,  102, 39,  255, 52,  79,  29,  255, 29,  55,  21,  255, 32,  47,  23,  255, 37,  37,  21,  255,
    127, 140, 82,  255, 134, 155, 86,  255, 154, 176, 118, 255, 48,  68,  29,  255, 32,  47,  21,  255, 42,  62,  26,  255, 96,  106, 68,  255, 50,
    76,  31,  255, 36,  55,  25,  255, 12,  19,  17,  255, 37,  53,  21,  255, 33,  48,  21,  255, 83,  101, 53,  255, 117, 149, 96,  255, 111, 142,
    90,  255, 102, 135, 87,  255, 108, 139, 75,  255, 128, 155, 84,  255, 97,  123, 99,  255, 96,  126, 78,  255, 49,  84,  26,  255, 26,  55,  21,
    255, 28,  52,  21,  255, 26,  44,  21,  255, 47,  65,  32,  255, 79,  112, 47,  255, 86,  118, 55,  255, 75,  105, 55,  255, 63,  87,  42,  255,
    68,  100, 40,  255, 72,  106, 47,  255, 74,  101, 53,  255, 122, 141, 62,  255, 117, 145, 55,  255, 104, 139, 53,  255, 108, 143, 76,  255, 94,
    129, 82,  255, 97,  135, 72,  255, 116, 148, 74,  255, 85,  114, 73,  255, 77,  107, 77,  255, 80,  109, 74,  255, 88,  111, 67,  255, 93,  125,
    72,  255, 144, 173, 84,  255, 118, 138, 74,  255, 43,  63,  41,  255, 74,  104, 44,  255, 99,  130, 56,  255, 113, 151, 68,  255, 111, 147, 72,
    255, 109, 144, 68,  255, 108, 141, 68,  255, 105, 137, 68,  255, 101, 137, 67,  255, 93,  130, 60,  255, 113, 144, 67,  255, 129, 158, 84,  255,
    128, 150, 87,  255, 138, 150, 87,  255, 169, 181, 107, 255, 191, 202, 141, 255, 205, 221, 150, 255, 143, 157, 91,  255, 73,  92,  47,  255, 118,
    130, 74,  255, 109, 136, 60,  255, 39,  69,  21,  255, 26,  48,  19,  255, 41,  69,  23,  255, 37,  68,  26,  255, 47,  74,  32,  255, 45,  65,
    31,  255, 44,  63,  31,  255, 63,  87,  40,  255, 62,  89,  47,  255, 48,  74,  47,  255, 48,  73,  46,  255, 49,  74,  43,  255, 47,  68,  41,
    255, 41,  62,  36,  255, 83,  116, 44,  255, 75,  108, 48,  255, 80,  111, 69,  255, 195, 203, 113, 255, 173, 195, 99,  255, 147, 178, 87,  255,
    169, 189, 71,  255, 158, 181, 58,  255, 207, 220, 105, 255, 176, 184, 90,  255, 52,  52,  31,  255, 19,  28,  17,  255, 69,  99,  32,  255, 21,
    34,  19,  255, 45,  60,  37,  255, 134, 161, 97,  255, 105, 131, 73,  255, 92,  125, 47,  255, 89,  129, 44,  255, 87,  130, 47,  255, 100, 138,
    55,  255, 125, 148, 69,  255, 108, 136, 62,  255, 108, 140, 81,  255, 138, 165, 97,  255, 183, 192, 96,  255, 202, 204, 101, 255, 187, 194, 102,
    255, 132, 159, 91,  255, 146, 168, 87,  255, 143, 173, 74,  255, 126, 165, 72,  255, 132, 168, 72,  255, 141, 170, 68,  255, 118, 147, 63,  255,
    101, 129, 53,  255, 113, 134, 52,  255, 100, 111, 46,  255, 42,  47,  21,  255, 69,  81,  41,  255, 119, 148, 78,  255, 118, 145, 78,  255, 127,
    150, 65,  255, 60,  81,  31,  255, 48,  69,  34,  255, 69,  100, 48,  255, 63,  92,  50,  255, 55,  81,  55,  255, 49,  75,  50,  255, 92,  115,
    53,  255, 132, 151, 53,  255, 87,  113, 37,  255, 153, 170, 111, 255, 205, 225, 159, 255, 195, 218, 152, 255, 188, 216, 155, 255, 201, 225, 154,
    255, 219, 232, 151, 255, 191, 205, 109, 255, 146, 172, 87,  255, 177, 199, 93,  255, 167, 200, 74,  255, 200, 216, 112, 255, 205, 215, 120, 255,
    205, 217, 143, 255, 213, 223, 157, 255, 219, 232, 192, 255, 210, 228, 189, 255, 215, 233, 188, 255, 227, 238, 180, 255, 169, 181, 100, 255, 150,
    162, 65,  255, 176, 182, 75,  255, 218, 218, 122, 255, 203, 204, 113, 255, 166, 176, 77,  255, 137, 150, 58,  255, 97,  116, 40,  255, 117, 140,
    60,  255, 217, 228, 143, 255, 192, 214, 135, 255, 161, 193, 116, 255, 160, 189, 98,  255, 174, 193, 104, 255, 126, 158, 84,  255, 114, 152, 86,
    255, 118, 156, 93,  255, 142, 174, 103, 255, 173, 193, 110, 255, 131, 141, 65,  255, 37,  46,  23,  255, 31,  42,  26,  255, 44,  62,  28,  255,
    44,  65,  26,  255, 46,  68,  28,  255, 65,  95,  33,  255, 79,  111, 36,  255, 47,  68,  21,  255, 39,  53,  21,  255, 45,  58,  23,  255, 43,
    60,  23,  255, 47,  73,  23,  255, 42,  73,  26,  255, 85,  115, 42,  255, 189, 206, 87,  255, 155, 181, 84,  255, 111, 122, 52,  255, 198, 196,
    111, 255, 182, 191, 117, 255, 50,  71,  26,  255, 34,  46,  23,  255, 26,  38,  17,  255, 26,  43,  9,   255, 45,  60,  23,  255, 113, 122, 82,
    255, 166, 177, 131, 255, 189, 209, 160, 255, 225, 245, 191, 255, 205, 221, 169, 255, 65,  84,  39,  255, 83,  105, 45,  255, 109, 120, 69,  255,
    180, 194, 125, 255, 171, 161, 103, 255, 233, 238, 184, 255, 225, 243, 203, 255, 230, 239, 201, 255, 222, 227, 162, 255, 161, 179, 87,  255, 158,
    179, 87,  255, 146, 171, 81,  255, 132, 146, 69,  255, 197, 207, 147, 255, 183, 208, 175, 255, 107, 136, 82,  255, 154, 169, 101, 255, 201, 207,
    128, 255, 205, 215, 121, 255, 197, 210, 113, 255, 197, 209, 102, 255, 194, 209, 120, 255, 208, 223, 172, 255, 208, 226, 180, 255, 189, 215, 172,
    255, 189, 213, 146, 255, 201, 214, 133, 255, 128, 150, 89,  255, 141, 172, 115, 255, 141, 175, 127, 255, 124, 159, 102, 255, 105, 137, 62,  255,
    174, 192, 124, 255, 208, 219, 127, 255, 105, 118, 67,  255, 68,  74,  46,  255, 82,  101, 45,  255, 115, 137, 60,  255, 100, 130, 55,  255, 82,
    112, 41,  255, 105, 124, 55,  255, 94,  107, 55,  255, 39,  53,  21,  255, 33,  51,  21,  255, 48,  73,  25,  255, 47,  75,  23,  255, 60,  76,
    26,  255, 221, 216, 142, 255, 197, 216, 169, 255, 182, 202, 156, 255, 227, 225, 147, 255, 218, 217, 136, 255, 200, 202, 122, 255, 118, 125, 69,
    255, 101, 108, 62,  255, 135, 149, 98,  255, 165, 194, 145, 255, 124, 152, 86,  255, 124, 140, 78,  255, 107, 126, 72,  255, 33,  46,  26,  255,
    15,  31,  17,  255, 60,  71,  49,  255, 41,  51,  36,  255, 19,  28,  19,  255, 23,  28,  17,  255, 86,  102, 47,  255, 101, 121, 55,  255, 123,
    146, 83,  255, 111, 145, 99,  255, 106, 139, 87,  255, 116, 144, 83,  255, 148, 172, 84,  255, 105, 133, 89,  255, 95,  122, 99,  255, 106, 134,
    84,  255, 49,  81,  32,  255, 31,  58,  23,  255, 36,  58,  29,  255, 39,  56,  29,  255, 55,  75,  36,  255, 68,  104, 34,  255, 75,  116, 47,
    255, 92,  133, 52,  255, 95,  124, 47,  255, 44,  68,  26,  255, 46,  77,  31,  255, 110, 123, 82,  255, 212, 224, 124, 255, 170, 198, 98,  255,
    128, 164, 68,  255, 103, 143, 55,  255, 125, 166, 74,  255, 141, 170, 81,  255, 131, 158, 84,  255, 112, 141, 76,  255, 88,  119, 83,  255, 96,
    127, 98,  255, 91,  116, 71,  255, 89,  117, 68,  255, 142, 169, 87,  255, 139, 159, 82,  255, 52,  79,  44,  255, 102, 139, 65,  255, 122, 160,
    77,  255, 125, 162, 80,  255, 128, 162, 81,  255, 125, 160, 81,  255, 120, 155, 80,  255, 117, 153, 77,  255, 115, 151, 74,  255, 113, 149, 71,
    255, 131, 161, 92,  255, 107, 136, 84,  255, 117, 133, 73,  255, 165, 182, 129, 255, 184, 208, 169, 255, 174, 199, 162, 255, 179, 203, 138, 255,
    148, 157, 93,  255, 105, 119, 80,  255, 168, 191, 107, 255, 65,  101, 32,  255, 40,  65,  31,  255, 49,  77,  26,  255, 65,  98,  28,  255, 49,
    81,  26,  255, 67,  97,  40,  255, 58,  77,  42,  255, 38,  51,  26,  255, 50,  71,  31,  255, 83,  117, 48,  255, 71,  102, 50,  255, 55,  83,
    47,  255, 53,  79,  47,  255, 49,  69,  43,  255, 47,  65,  41,  255, 71,  101, 38,  255, 76,  114, 50,  255, 132, 154, 87,  255, 203, 214, 116,
    255, 152, 178, 96,  255, 118, 139, 65,  255, 110, 143, 43,  255, 143, 174, 52,  255, 146, 175, 60,  255, 92,  108, 44,  255, 163, 171, 96,  255,
    164, 171, 81,  255, 82,  96,  36,  255, 39,  53,  28,  255, 130, 164, 93,  255, 133, 168, 90,  255, 101, 136, 60,  255, 87,  122, 44,  255, 111,
    141, 58,  255, 94,  126, 60,  255, 65,  102, 41,  255, 55,  96,  31,  255, 67,  103, 43,  255, 101, 133, 65,  255, 154, 157, 71,  255, 216, 208,
    86,  255, 205, 201, 84,  255, 172, 182, 80,  255, 135, 162, 65,  255, 149, 175, 74,  255, 172, 193, 84,  255, 130, 167, 67,  255, 133, 170, 69,
    255, 138, 174, 84,  255, 138, 170, 84,  255, 146, 175, 81,  255, 177, 197, 83,  255, 132, 143, 52,  255, 19,  33,  17,  255, 43,  62,  36,  255,
    116, 135, 74,  255, 121, 138, 77,  255, 62,  84,  40,  255, 69,  100, 40,  255, 81,  112, 44,  255, 72,  104, 47,  255, 67,  98,  52,  255, 60,
    86,  55,  255, 53,  76,  50,  255, 108, 121, 55,  255, 132, 152, 52,  255, 110, 133, 48,  255, 200, 212, 162, 255, 196, 224, 177, 255, 185, 210,
    116, 255, 181, 203, 113, 255, 183, 208, 90,  255, 179, 206, 97,  255, 195, 215, 129, 255, 180, 196, 106, 255, 175, 196, 98,  255, 161, 194, 75,
    255, 191, 212, 123, 255, 219, 230, 161, 255, 224, 234, 162, 255, 224, 235, 194, 255, 221, 238, 183, 255, 225, 239, 184, 255, 219, 225, 155, 255,
    196, 201, 98,  255, 138, 156, 56,  255, 144, 155, 63,  255, 170, 181, 90,  255, 168, 178, 106, 255, 153, 165, 95,  255, 192, 195, 105, 255, 192,
    196, 105, 255, 119, 130, 65,  255, 120, 132, 63,  255, 229, 238, 154, 255, 183, 208, 140, 255, 174, 201, 123, 255, 185, 209, 140, 255, 212, 222,
    139, 255, 131, 162, 71,  255, 138, 171, 71,  255, 166, 192, 78,  255, 164, 192, 98,  255, 173, 202, 125, 255, 136, 149, 84,  255, 39,  60,  26,
    255, 56,  75,  36,  255, 58,  74,  37,  255, 50,  62,  33,  255, 48,  63,  33,  255, 52,  73,  36,  255, 68,  92,  33,  255, 52,  74,  26,  255,
    47,  65,  26,  255, 34,  51,  25,  255, 47,  74,  26,  255, 49,  76,  23,  255, 52,  81,  26,  255, 65,  101, 36,  255, 121, 151, 65,  255, 132,
    150, 58,  255, 202, 208, 117, 255, 191, 208, 141, 255, 220, 222, 145, 255, 95,  120, 50,  255, 58,  87,  26,  255, 44,  68,  25,  255, 38,  58,
    21,  255, 33,  52,  19,  255, 15,  26,  12,  255, 21,  32,  12,  255, 47,  65,  26,  255, 82,  100, 43,  255, 166, 188, 115, 255, 131, 152, 99,
    255, 76,  92,  37,  255, 172, 175, 95,  255, 234, 234, 169, 255, 228, 243, 203, 255, 216, 239, 202, 255, 211, 233, 197, 255, 238, 243, 200, 255,
    222, 227, 159, 255, 168, 185, 93,  255, 169, 187, 95,  255, 154, 176, 87,  255, 126, 144, 79,  255, 173, 196, 167, 255, 170, 199, 170, 255, 114,
    140, 69,  255, 186, 195, 106, 255, 198, 212, 116, 255, 197, 210, 104, 255, 194, 211, 100, 255, 168, 193, 98,  255, 139, 169, 110, 255, 150, 178,
    134, 255, 159, 182, 132, 255, 188, 206, 144, 255, 193, 217, 158, 255, 196, 217, 138, 255, 148, 172, 90,  255, 147, 175, 100, 255, 152, 178, 96,
    255, 150, 173, 99,  255, 116, 138, 60,  255, 173, 184, 92,  255, 190, 198, 111, 255, 56,  60,  36,  255, 130, 146, 84,  255, 177, 195, 117, 255,
    170, 192, 123, 255, 141, 166, 96,  255, 156, 175, 98,  255, 181, 198, 126, 255, 185, 200, 129, 255, 174, 180, 103, 255, 124, 133, 58,  255, 94,
    113, 41,  255, 83,  102, 41,  255, 50,  68,  21,  255, 185, 181, 109, 255, 221, 228, 165, 255, 163, 189, 153, 255, 185, 202, 150, 255, 209, 219,
    142, 255, 214, 221, 139, 255, 224, 224, 139, 255, 206, 217, 141, 255, 175, 202, 151, 255, 172, 199, 148, 255, 136, 158, 89,  255, 131, 155, 96,
    255, 151, 175, 124, 255, 60,  65,  31,  255, 49,  55,  23,  255, 71,  77,  48,  255, 58,  58,  48,  255, 12,  12,  12,  255, 97,  108, 60,  255,
    153, 175, 96,  255, 103, 132, 55,  255, 128, 161, 91,  255, 105, 140, 80,  255, 131, 160, 87,  255, 156, 180, 93,  255, 127, 155, 87,  255, 96,
    122, 92,  255, 94,  122, 86,  255, 97,  128, 68,  255, 44,  68,  31,  255, 31,  55,  23,  255, 33,  55,  26,  255, 42,  58,  32,  255, 60,  86,
    39,  255, 69,  107, 45,  255, 62,  95,  56,  255, 77,  113, 58,  255, 102, 142, 50,  255, 92,  121, 40,  255, 41,  68,  21,  255, 79,  83,  58,
    255, 212, 225, 149, 255, 173, 200, 122, 255, 150, 184, 107, 255, 141, 177, 92,  255, 151, 185, 100, 255, 189, 207, 115, 255, 169, 188, 104, 255,
    141, 165, 87,  255, 115, 144, 86,  255, 100, 132, 101, 255, 96,  126, 85,  255, 92,  118, 67,  255, 143, 169, 93,  255, 145, 164, 87,  255, 53,
    83,  43,  255, 57,  90,  37,  255, 46,  67,  36,  255, 71,  98,  52,  255, 94,  122, 65,  255, 107, 137, 74,  255, 116, 148, 83,  255, 107, 137,
    77,  255, 92,  119, 62,  255, 93,  119, 62,  255, 130, 156, 100, 255, 139, 152, 95,  255, 143, 160, 100, 255, 179, 203, 165, 255, 161, 189, 161,
    255, 173, 196, 146, 255, 186, 203, 118, 255, 195, 214, 133, 255, 192, 211, 145, 255, 102, 126, 58,  255, 39,  62,  28,  255, 39,  63,  34,  255,
    60,  95,  32,  255, 79,  115, 32,  255, 77,  103, 39,  255, 69,  97,  42,  255, 60,  89,  40,  255, 56,  77,  41,  255, 43,  60,  28,  255, 104,
    122, 58,  255, 133, 153, 67,  255, 133, 151, 67,  255, 102, 123, 53,  255, 67,  92,  43,  255, 65,  98,  36,  255, 76,  110, 33,  255, 84,  121,
    47,  255, 179, 198, 95,  255, 173, 194, 97,  255, 100, 124, 53,  255, 68,  97,  38,  255, 113, 149, 76,  255, 124, 160, 74,  255, 115, 151, 43,
    255, 165, 184, 86,  255, 218, 231, 147, 255, 194, 216, 124, 255, 171, 189, 93,  255, 135, 162, 72,  255, 122, 158, 68,  255, 110, 145, 58,  255,
    90,  124, 46,  255, 117, 146, 80,  255, 120, 149, 93,  255, 95,  130, 69,  255, 97,  132, 65,  255, 108, 141, 65,  255, 137, 166, 68,  255, 113,
    141, 68,  255, 62,  86,  48,  255, 164, 164, 74,  255, 210, 209, 81,  255, 192, 200, 75,  255, 175, 188, 72,  255, 160, 177, 67,  255, 188, 199,
    94,  255, 182, 200, 93,  255, 153, 181, 81,  255, 158, 186, 97,  255, 158, 186, 84,  255, 164, 179, 75,  255, 147, 164, 53,  255, 97,  127, 49,
    255, 84,  117, 52,  255, 80,  106, 52,  255, 73,  96,  53,  255, 65,  84,  49,  255, 53,  80,  47,  255, 63,  91,  47,  255, 76,  106, 47,  255,
    84,  117, 48,  255, 68,  98,  50,  255, 52,  79,  53,  255, 47,  71,  47,  255, 95,  111, 58,  255, 163, 175, 68,  255, 156, 168, 65,  255, 203,
    223, 177, 255, 183, 210, 152, 255, 165, 192, 96,  255, 165, 191, 94,  255, 204, 220, 125, 255, 182, 205, 140, 255, 161, 176, 111, 255, 179, 180,
    92,  255, 197, 201, 111, 255, 178, 198, 104, 255, 195, 214, 141, 255, 185, 211, 114, 255, 213, 229, 120, 255, 225, 238, 165, 255, 206, 209, 129,
    255, 161, 164, 87,  255, 100, 116, 37,  255, 148, 160, 65,  255, 147, 160, 68,  255, 136, 155, 60,  255, 163, 177, 75,  255, 177, 184, 106, 255,
    137, 159, 92,  255, 178, 193, 95,  255, 169, 189, 97,  255, 177, 198, 102, 255, 203, 214, 117, 255, 245, 243, 152, 255, 200, 214, 136, 255, 185,
    207, 110, 255, 209, 222, 129, 255, 193, 195, 105, 255, 123, 138, 47,  255, 133, 146, 52,  255, 132, 137, 46,  255, 98,  95,  40,  255, 96,  94,
    53,  255, 102, 117, 55,  255, 86,  117, 44,  255, 85,  115, 47,  255, 81,  110, 41,  255, 68,  78,  41,  255, 72,  67,  52,  255, 55,  55,  36,
    255, 65,  79,  36,  255, 69,  98,  34,  255, 73,  111, 40,  255, 77,  118, 47,  255, 82,  118, 47,  255, 75,  111, 40,  255, 58,  92,  28,  255,
    69,  99,  31,  255, 167, 171, 76,  255, 216, 217, 121, 255, 180, 204, 136, 255, 166, 185, 132, 255, 238, 231, 151, 255, 164, 174, 93,  255, 109,
    125, 52,  255, 79,  100, 38,  255, 73,  97,  34,  255, 89,  112, 39,  255, 92,  109, 44,  255, 60,  79,  31,  255, 34,  58,  19,  255, 41,  69,
    21,  255, 36,  58,  15,  255, 103, 119, 55,  255, 124, 134, 65,  255, 211, 210, 143, 255, 223, 241, 202, 255, 211, 233, 199, 255, 210, 232, 199,
    255, 215, 231, 195, 255, 250, 249, 197, 255, 205, 213, 139, 255, 175, 190, 99,  255, 180, 198, 106, 255, 156, 174, 89,  255, 144, 158, 104, 255,
    183, 205, 173, 255, 184, 200, 123, 255, 122, 144, 55,  255, 177, 194, 94,  255, 189, 209, 99,  255, 178, 202, 84,  255, 130, 164, 55,  255, 120,
    152, 62,  255, 143, 171, 80,  255, 157, 186, 96,  255, 143, 176, 92,  255, 118, 152, 67,  255, 126, 149, 74,  255, 157, 184, 93,  255, 122, 153,
    78,  255, 148, 174, 84,  255, 173, 191, 83,  255, 176, 189, 108, 255, 186, 197, 126, 255, 193, 206, 130, 255, 201, 211, 128, 255, 173, 187, 129,
    255, 107, 132, 71,  255, 75,  98,  33,  255, 174, 196, 114, 255, 164, 191, 126, 255, 154, 186, 129, 255, 154, 188, 137, 255, 157, 191, 141, 255,
    172, 200, 140, 255, 198, 216, 129, 255, 160, 182, 82,  255, 136, 162, 62,  255, 92,  121, 38,  255, 150, 159, 79,  255, 220, 227, 160, 255, 171,
    199, 159, 255, 165, 193, 160, 255, 175, 197, 149, 255, 181, 200, 141, 255, 194, 207, 132, 255, 214, 218, 133, 255, 205, 214, 132, 255, 195, 207,
    127, 255, 126, 147, 68,  255, 128, 158, 104, 255, 188, 199, 101, 255, 190, 199, 74,  255, 178, 194, 73,  255, 159, 178, 68,  255, 134, 154, 58,
    255, 124, 143, 55,  255, 152, 176, 92,  255, 159, 181, 109, 255, 91,  120, 53,  255, 105, 136, 58,  255, 149, 172, 78,  255, 142, 169, 79,  255,
    96,  135, 52,  255, 120, 149, 67,  255, 111, 132, 84,  255, 88,  117, 68,  255, 77,  113, 48,  255, 41,  67,  26,  255, 33,  55,  23,  255, 33,
    55,  23,  255, 48,  63,  32,  255, 60,  92,  36,  255, 63,  99,  47,  255, 69,  101, 55,  255, 80,  113, 62,  255, 72,  111, 49,  255, 99,  136,
    60,  255, 94,  111, 52,  255, 28,  31,  19,  255, 203, 211, 152, 255, 189, 215, 151, 255, 165, 196, 119, 255, 168, 199, 126, 255, 176, 206, 141,
    255, 220, 236, 167, 255, 124, 141, 78,  255, 143, 168, 94,  255, 141, 166, 97,  255, 110, 143, 93,  255, 114, 142, 101, 255, 96,  118, 67,  255,
    151, 174, 94,  255, 139, 158, 86,  255, 53,  84,  39,  255, 51,  80,  33,  255, 23,  37,  23,  255, 29,  47,  26,  255, 26,  43,  23,  255, 29,
    48,  25,  255, 39,  56,  33,  255, 37,  48,  34,  255, 21,  34,  21,  255, 47,  62,  36,  255, 174, 181, 124, 255, 183, 191, 124, 255, 141, 167,
    124, 255, 163, 191, 158, 255, 160, 187, 150, 255, 178, 200, 138, 255, 206, 221, 143, 255, 151, 177, 87,  255, 162, 182, 106, 255, 133, 139, 78,
    255, 100, 112, 58,  255, 42,  68,  34,  255, 47,  75,  34,  255, 74,  102, 39,  255, 68,  84,  40,  255, 34,  51,  25,  255, 92,  120, 43,  255,
    65,  98,  36,  255, 63,  87,  34,  255, 210, 216, 103, 255, 205, 216, 119, 255, 176, 198, 106, 255, 163, 184, 90,  255, 120, 128, 60,  255, 94,
    117, 38,  255, 110, 139, 44,  255, 139, 165, 62,  255, 171, 190, 86,  255, 92,  116, 47,  255, 63,  97,  36,  255, 114, 152, 77,  255, 112, 148,
    94,  255, 92,  130, 79,  255, 65,  95,  36,  255, 166, 179, 107, 255, 202, 218, 142, 255, 181, 204, 131, 255, 186, 208, 119, 255, 188, 206, 104,
    255, 147, 167, 78,  255, 143, 165, 74,  255, 109, 133, 55,  255, 126, 156, 91,  255, 130, 159, 75,  255, 148, 176, 76,  255, 169, 193, 94,  255,
    176, 196, 95,  255, 124, 150, 80,  255, 78,  108, 72,  255, 82,  114, 60,  255, 100, 125, 56,  255, 127, 126, 52,  255, 194, 201, 84,  255, 197,
    210, 95,  255, 194, 203, 92,  255, 193, 203, 89,  255, 206, 212, 103, 255, 212, 218, 117, 255, 215, 220, 120, 255, 135, 146, 65,  255, 73,  91,
    29,  255, 97,  128, 53,  255, 90,  126, 72,  255, 104, 138, 89,  255, 134, 162, 94,  255, 152, 173, 91,  255, 90,  114, 62,  255, 69,  102, 55,
    255, 82,  111, 60,  255, 113, 133, 92,  255, 164, 180, 126, 255, 178, 193, 137, 255, 174, 184, 130, 255, 166, 176, 127, 255, 174, 181, 127, 255,
    187, 188, 104, 255, 211, 215, 127, 255, 180, 198, 137, 255, 156, 179, 113, 255, 158, 189, 133, 255, 219, 228, 152, 255, 215, 226, 132, 255, 187,
    212, 118, 255, 124, 155, 75,  255, 68,  92,  40,  255, 151, 155, 90,  255, 205, 220, 144, 255, 221, 238, 167, 255, 218, 235, 161, 255, 207, 219,
    137, 255, 202, 208, 128, 255, 142, 163, 73,  255, 125, 148, 62,  255, 107, 134, 52,  255, 113, 134, 49,  255, 136, 153, 58,  255, 136, 159, 55,
    255, 183, 200, 74,  255, 205, 211, 118, 255, 205, 214, 142, 255, 139, 164, 97,  255, 136, 167, 101, 255, 131, 164, 98,  255, 158, 179, 102, 255,
    241, 239, 155, 255, 206, 220, 149, 255, 176, 181, 87,  255, 115, 123, 43,  255, 67,  79,  31,  255, 21,  28,  17,  255, 40,  52,  23,  255, 34,
    46,  21,  255, 6,   12,  17,  255, 12,  15,  19,  255, 52,  65,  32,  255, 106, 134, 55,  255, 100, 128, 53,  255, 89,  117, 47,  255, 67,  87,
    34,  255, 77,  65,  49,  255, 58,  58,  32,  255, 50,  72,  26,  255, 65,  96,  26,  255, 102, 138, 42,  255, 110, 145, 58,  255, 105, 138, 58,
    255, 104, 137, 60,  255, 104, 135, 60,  255, 65,  92,  31,  255, 126, 138, 68,  255, 202, 216, 141, 255, 158, 186, 139, 255, 172, 188, 132, 255,
    230, 225, 142, 255, 231, 232, 139, 255, 228, 227, 121, 255, 158, 176, 89,  255, 103, 134, 47,  255, 127, 154, 55,  255, 149, 171, 65,  255, 145,
    164, 65,  255, 65,  91,  34,  255, 37,  56,  26,  255, 34,  48,  21,  255, 55,  63,  28,  255, 144, 145, 83,  255, 215, 220, 170, 255, 218, 238,
    206, 255, 211, 232, 202, 255, 212, 230, 197, 255, 235, 241, 193, 255, 255, 253, 193, 255, 194, 204, 122, 255, 187, 198, 103, 255, 186, 202, 109,
    255, 162, 179, 83,  255, 160, 177, 120, 255, 184, 200, 114, 255, 181, 198, 91,  255, 114, 140, 53,  255, 182, 200, 87,  255, 150, 178, 65,  255,
    94,  130, 36,  255, 91,  128, 34,  255, 125, 161, 53,  255, 136, 171, 68,  255, 127, 158, 71,  255, 137, 164, 78,  255, 136, 160, 104, 255, 114,
    127, 69,  255, 141, 160, 74,  255, 126, 148, 78,  255, 169, 189, 107, 255, 191, 216, 138, 255, 189, 218, 151, 255, 193, 222, 161, 255, 194, 222,
    167, 255, 192, 221, 166, 255, 201, 226, 163, 255, 187, 196, 128, 255, 123, 134, 65,  255, 115, 140, 39,  255, 164, 185, 99,  255, 172, 198, 127,
    255, 160, 192, 128, 255, 153, 185, 132, 255, 155, 188, 141, 255, 164, 195, 147, 255, 182, 204, 138, 255, 193, 205, 112, 255, 136, 164, 67,  255,
    137, 158, 77,  255, 228, 225, 146, 255, 179, 201, 154, 255, 167, 194, 160, 255, 164, 190, 160, 255, 158, 186, 159, 255, 156, 181, 143, 255, 198,
    209, 135, 255, 211, 216, 133, 255, 197, 208, 122, 255, 142, 163, 86,  255, 127, 150, 76,  255, 184, 190, 101, 255, 141, 152, 87,  255, 136, 150,
    77,  255, 172, 187, 90,  255, 155, 174, 83,  255, 150, 171, 71,  255, 154, 172, 72,  255, 158, 178, 84,  255, 99,  126, 47,  255, 99,  124, 50,
    255, 135, 159, 86,  255, 82,  107, 42,  255, 118, 142, 72,  255, 104, 131, 87,  255, 77,  108, 62,  255, 83,  119, 55,  255, 65,  94,  46,  255,
    46,  73,  28,  255, 38,  63,  25,  255, 38,  60,  26,  255, 56,  80,  38,  255, 55,  89,  33,  255, 62,  98,  47,  255, 69,  107, 55,  255, 81,
    114, 63,  255, 99,  134, 60,  255, 137, 166, 73,  255, 100, 118, 62,  255, 15,  21,  15,  255, 89,  98,  58,  255, 203, 219, 153, 255, 188, 213,
    150, 255, 200, 221, 150, 255, 189, 203, 123, 255, 136, 149, 91,  255, 34,  46,  26,  255, 67,  86,  47,  255, 149, 173, 101, 255, 130, 157, 96,
    255, 110, 142, 99,  255, 102, 128, 74,  255, 148, 169, 92,  255, 121, 141, 84,  255, 63,  94,  46,  255, 47,  69,  32,  255, 73,  83,  43,  255,
    48,  62,  32,  255, 34,  52,  26,  255, 34,  51,  28,  255, 34,  43,  29,  255, 40,  49,  33,  255, 43,  58,  21,  255, 123, 131, 79,  255, 217,
    225, 162, 255, 142, 163, 105, 255, 159, 185, 153, 255, 163, 189, 154, 255, 157, 185, 145, 255, 199, 214, 155, 255, 200, 217, 162, 255, 148, 172,
    97,  255, 184, 205, 120, 255, 170, 200, 89,  255, 72,  84,  42,  255, 23,  37,  23,  255, 42,  65,  32,  255, 41,  60,  32,  255, 25,  39,  23,
    255, 47,  58,  28,  255, 136, 165, 56,  255, 84,  127, 34,  255, 37,  68,  17,  255, 152, 164, 68,  255, 198, 205, 106, 255, 155, 172, 92,  255,
    152, 169, 89,  255, 145, 166, 78,  255, 134, 161, 63,  255, 137, 168, 65,  255, 118, 147, 55,  255, 108, 135, 68,  255, 90,  122, 50,  255, 109,
    149, 68,  255, 104, 143, 74,  255, 87,  124, 65,  255, 72,  111, 55,  255, 78,  113, 43,  255, 74,  97,  40,  255, 69,  91,  40,  255, 95,  124,
    53,  255, 102, 122, 63,  255, 105, 123, 71,  255, 92,  120, 60,  255, 96,  127, 52,  255, 98,  125, 53,  255, 77,  106, 39,  255, 56,  69,  28,
    255, 73,  97,  37,  255, 110, 143, 55,  255, 117, 149, 60,  255, 98,  125, 76,  255, 85,  115, 74,  255, 115, 147, 72,  255, 86,  114, 52,  255,
    29,  47,  33,  255, 83,  87,  43,  255, 156, 164, 71,  255, 180, 189, 84,  255, 187, 198, 90,  255, 188, 200, 93,  255, 199, 209, 98,  255, 196,
    208, 99,  255, 124, 143, 60,  255, 65,  92,  31,  255, 118, 147, 65,  255, 118, 150, 72,  255, 141, 166, 72,  255, 154, 177, 76,  255, 181, 197,
    98,  255, 153, 171, 90,  255, 111, 139, 69,  255, 203, 215, 143, 255, 227, 236, 174, 255, 213, 231, 179, 255, 204, 226, 180, 255, 209, 228, 180,
    255, 229, 238, 178, 255, 234, 238, 175, 255, 217, 223, 153, 255, 217, 220, 125, 255, 160, 181, 104, 255, 163, 195, 116, 255, 213, 226, 138, 255,
    238, 241, 171, 255, 194, 219, 141, 255, 193, 218, 120, 255, 203, 226, 114, 255, 158, 174, 87,  255, 113, 133, 65,  255, 140, 157, 77,  255, 186,
    195, 104, 255, 176, 190, 94,  255, 112, 134, 62,  255, 124, 146, 68,  255, 120, 147, 75,  255, 108, 139, 74,  255, 108, 140, 62,  255, 120, 151,
    52,  255, 99,  130, 38,  255, 101, 129, 52,  255, 201, 215, 130, 255, 216, 233, 177, 255, 212, 226, 171, 255, 141, 164, 87,  255, 114, 151, 77,
    255, 135, 166, 89,  255, 125, 155, 86,  255, 184, 194, 122, 255, 209, 216, 140, 255, 145, 162, 82,  255, 68,  87,  36,  255, 69,  96,  40,  255,
    73,  91,  47,  255, 79,  100, 49,  255, 69,  87,  45,  255, 47,  60,  31,  255, 47,  71,  31,  255, 47,  68,  29,  255, 84,  98,  41,  255, 109,
    131, 49,  255, 101, 130, 47,  255, 86,  112, 39,  255, 75,  89,  39,  255, 55,  78,  29,  255, 57,  92,  26,  255, 55,  95,  23,  255, 122, 154,
    75,  255, 153, 178, 101, 255, 137, 163, 82,  255, 152, 173, 92,  255, 145, 168, 87,  255, 116, 142, 68,  255, 44,  68,  15,  255, 99,  120, 72,
    255, 166, 190, 139, 255, 182, 197, 139, 255, 206, 212, 141, 255, 241, 232, 135, 255, 213, 218, 107, 255, 84,  121, 49,  255, 78,  115, 38,  255,
    108, 136, 53,  255, 138, 157, 62,  255, 173, 185, 73,  255, 119, 137, 53,  255, 41,  60,  15,  255, 62,  84,  23,  255, 105, 109, 43,  255, 176,
    175, 117, 255, 200, 215, 172, 255, 210, 234, 206, 255, 207, 229, 197, 255, 228, 236, 192, 255, 249, 249, 193, 255, 228, 233, 165, 255, 186, 198,
    111, 255, 149, 176, 76,  255, 133, 167, 62,  255, 149, 172, 65,  255, 152, 169, 81,  255, 188, 204, 94,  255, 180, 202, 89,  255, 104, 132, 44,
    255, 142, 171, 75,  255, 100, 136, 55,  255, 107, 140, 56,  255, 118, 154, 62,  255, 97,  135, 53,  255, 42,  58,  32,  255, 25,  31,  21,  255,
    94,  111, 58,  255, 165, 187, 119, 255, 185, 211, 153, 255, 165, 188, 125, 255, 151, 170, 91,  255, 196, 213, 131, 255, 207, 221, 149, 255, 209,
    223, 160, 255, 208, 226, 165, 255, 213, 229, 172, 255, 217, 228, 165, 255, 220, 231, 165, 255, 223, 236, 174, 255, 228, 239, 181, 255, 145, 168,
    87,  255, 79,  110, 32,  255, 112, 135, 63,  255, 165, 186, 111, 255, 185, 205, 133, 255, 183, 206, 140, 255, 171, 199, 144, 255, 166, 196, 150,
    255, 181, 207, 152, 255, 189, 207, 126, 255, 150, 169, 93,  255, 191, 195, 116, 255, 228, 229, 143, 255, 195, 209, 147, 255, 171, 195, 154, 255,
    162, 189, 158, 255, 153, 182, 154, 255, 162, 185, 148, 255, 193, 205, 143, 255, 213, 220, 138, 255, 163, 182, 100, 255, 91,  111, 56,  255, 19,
    21,  25,  255, 23,  23,  17,  255, 132, 144, 63,  255, 158, 183, 96,  255, 140, 164, 106, 255, 95,  114, 48,  255, 133, 156, 68,  255, 157, 180,
    102, 255, 112, 138, 58,  255, 100, 127, 47,  255, 96,  127, 47,  255, 118, 144, 75,  255, 103, 130, 90,  255, 73,  102, 62,  255, 73,  107, 47,
    255, 52,  83,  41,  255, 40,  62,  42,  255, 33,  47,  26,  255, 46,  73,  28,  255, 47,  75,  32,  255, 53,  82,  34,  255, 58,  92,  36,  255,
    76,  111, 58,  255, 75,  116, 56,  255, 103, 140, 58,  255, 125, 155, 58,  255, 81,  112, 47,  255, 33,  51,  33,  255, 32,  47,  33,  255, 29,
    46,  23,  255, 96,  108, 58,  255, 232, 239, 168, 255, 161, 172, 117, 255, 52,  68,  37,  255, 19,  33,  17,  255, 26,  39,  23,  255, 21,  32,
    21,  255, 42,  56,  34,  255, 113, 136, 79,  255, 129, 155, 95,  255, 90,  120, 68,  255, 112, 137, 87,  255, 91,  112, 77,  255, 74,  100, 56,
    255, 97,  110, 52,  255, 78,  90,  45,  255, 34,  47,  28,  255, 32,  42,  26,  255, 28,  42,  26,  255, 31,  46,  26,  255, 36,  51,  28,  255,
    148, 158, 76,  255, 196, 217, 167, 255, 154, 179, 132, 255, 141, 167, 124, 255, 172, 199, 172, 255, 161, 188, 147, 255, 183, 203, 137, 255, 189,
    201, 136, 255, 193, 213, 169, 255, 172, 192, 121, 255, 165, 194, 83,  255, 90,  109, 48,  255, 17,  25,  19,  255, 23,  33,  25,  255, 34,  49,
    29,  255, 43,  62,  31,  255, 26,  39,  23,  255, 96,  114, 45,  255, 138, 173, 48,  255, 129, 149, 55,  255, 141, 147, 68,  255, 161, 167, 83,
    255, 165, 169, 83,  255, 73,  71,  37,  255, 23,  31,  19,  255, 40,  68,  23,  255, 41,  73,  26,  255, 73,  107, 42,  255, 80,  111, 42,  255,
    86,  115, 47,  255, 93,  126, 62,  255, 84,  117, 52,  255, 47,  74,  29,  255, 36,  56,  25,  255, 55,  84,  36,  255, 90,  128, 43,  255, 105,
    137, 47,  255, 65,  91,  39,  255, 39,  67,  21,  255, 42,  67,  31,  255, 49,  76,  36,  255, 93,  124, 56,  255, 83,  112, 49,  255, 83,  108,
    52,  255, 74,  93,  44,  255, 82,  108, 52,  255, 84,  109, 48,  255, 68,  95,  34,  255, 75,  105, 40,  255, 80,  110, 62,  255, 105, 136, 75,
    255, 98,  130, 55,  255, 67,  102, 36,  255, 48,  75,  44,  255, 31,  51,  34,  255, 39,  67,  31,  255, 57,  83,  38,  255, 77,  101, 44,  255,
    82,  103, 41,  255, 91,  108, 37,  255, 110, 122, 39,  255, 143, 166, 60,  255, 114, 142, 60,  255, 139, 162, 68,  255, 175, 191, 60,  255, 194,
    203, 58,  255, 214, 216, 67,  255, 221, 220, 89,  255, 173, 185, 95,  255, 97,  112, 49,  255, 100, 105, 52,  255, 107, 107, 58,  255, 188, 195,
    126, 255, 203, 216, 142, 255, 208, 224, 151, 255, 199, 221, 161, 255, 195, 220, 172, 255, 181, 205, 155, 255, 172, 189, 112, 255, 182, 196, 87,
    255, 191, 212, 104, 255, 210, 223, 127, 255, 232, 238, 140, 255, 218, 224, 130, 255, 220, 220, 125, 255, 163, 161, 80,  255, 95,  119, 47,  255,
    65,  104, 38,  255, 55,  89,  31,  255, 72,  98,  31,  255, 96,  122, 39,  255, 165, 182, 74,  255, 156, 174, 83,  255, 107, 143, 75,  255, 112,
    147, 68,  255, 147, 172, 60,  255, 127, 156, 40,  255, 143, 160, 91,  255, 215, 224, 156, 255, 207, 224, 167, 255, 194, 220, 174, 255, 218, 228,
    167, 255, 145, 160, 73,  255, 135, 163, 63,  255, 125, 159, 60,  255, 115, 153, 60,  255, 111, 148, 62,  255, 111, 143, 65,  255, 117, 152, 71,
    255, 130, 155, 62,  255, 101, 127, 55,  255, 145, 167, 84,  255, 148, 168, 77,  255, 114, 142, 58,  255, 130, 161, 73,  255, 147, 172, 71,  255,
    119, 142, 55,  255, 40,  52,  21,  255, 81,  102, 36,  255, 103, 132, 42,  255, 111, 138, 50,  255, 109, 138, 53,  255, 83,  112, 38,  255, 73,
    105, 37,  255, 118, 148, 75,  255, 159, 182, 106, 255, 159, 180, 101, 255, 156, 178, 99,  255, 189, 202, 103, 255, 197, 211, 101, 255, 158, 179,
    94,  255, 163, 176, 89,  255, 192, 199, 115, 255, 169, 192, 141, 255, 170, 194, 145, 255, 198, 204, 145, 255, 245, 236, 147, 255, 160, 179, 76,
    255, 103, 134, 41,  255, 76,  112, 40,  255, 78,  113, 45,  255, 95,  124, 55,  255, 158, 171, 72,  255, 148, 161, 65,  255, 77,  103, 23,  255,
    83,  108, 31,  255, 157, 155, 80,  255, 198, 199, 142, 255, 189, 205, 165, 255, 205, 230, 204, 255, 204, 226, 193, 255, 226, 235, 192, 255, 238,
    241, 174, 255, 189, 201, 114, 255, 190, 198, 100, 255, 164, 182, 81,  255, 136, 167, 65,  255, 120, 145, 50,  255, 154, 172, 73,  255, 142, 169,
    72,  255, 90,  120, 47,  255, 78,  110, 38,  255, 112, 148, 74,  255, 104, 144, 60,  255, 96,  132, 55,  255, 77,  105, 44,  255, 52,  82,  37,
    255, 17,  19,  21,  255, 26,  33,  21,  255, 37,  62,  28,  255, 72,  100, 46,  255, 127, 150, 82,  255, 135, 162, 96,  255, 143, 173, 118, 255,
    159, 190, 143, 255, 157, 183, 97,  255, 190, 206, 124, 255, 189, 202, 135, 255, 187, 202, 127, 255, 174, 195, 135, 255, 176, 196, 114, 255, 171,
    197, 121, 255, 136, 171, 98,  255, 152, 181, 97,  255, 87,  118, 46,  255, 63,  94,  28,  255, 79,  112, 31,  255, 110, 141, 58,  255, 145, 163,
    87,  255, 172, 187, 111, 255, 174, 195, 123, 255, 174, 201, 144, 255, 175, 204, 151, 255, 164, 187, 125, 255, 146, 162, 98,  255, 205, 212, 129,
    255, 237, 235, 142, 255, 205, 215, 138, 255, 176, 196, 147, 255, 162, 190, 159, 255, 158, 185, 164, 255, 175, 194, 155, 255, 218, 223, 149, 255,
    173, 191, 105, 255, 76,  96,  45,  255, 23,  26,  15,  255, 121, 136, 55,  255, 162, 184, 92,  255, 142, 171, 100, 255, 88,  104, 62,  255, 72,
    84,  38,  255, 120, 144, 48,  255, 141, 169, 90,  255, 94,  126, 72,  255, 60,  87,  39,  255, 78,  107, 49,  255, 74,  103, 58,  255, 65,  92,
    55,  255, 63,  92,  46,  255, 48,  76,  34,  255, 37,  62,  25,  255, 38,  62,  26,  255, 29,  33,  26,  255, 39,  55,  29,  255, 63,  95,  34,
    255, 57,  92,  36,  255, 65,  104, 48,  255, 76,  114, 58,  255, 99,  136, 60,  255, 153, 178, 74,  255, 79,  102, 45,  255, 38,  56,  36,  255,
    39,  55,  31,  255, 63,  92,  28,  255, 76,  110, 31,  255, 84,  117, 31,  255, 128, 153, 72,  255, 49,  63,  33,  255, 26,  42,  25,  255, 29,
    42,  26,  255, 31,  43,  23,  255, 34,  52,  26,  255, 33,  53,  25,  255, 32,  55,  26,  255, 97,  119, 62,  255, 128, 153, 75,  255, 116, 137,
    69,  255, 112, 130, 63,  255, 115, 139, 68,  255, 67,  96,  43,  255, 23,  42,  21,  255, 28,  47,  26,  255, 45,  62,  34,  255, 52,  67,  34,
    255, 37,  47,  31,  255, 23,  26,  21,  255, 125, 137, 99,  255, 172, 200, 167, 255, 128, 152, 106, 255, 153, 182, 149, 255, 162, 191, 151, 255,
    184, 206, 139, 255, 149, 158, 94,  255, 85,  96,  67,  255, 206, 223, 169, 255, 158, 182, 89,  255, 149, 172, 74,  255, 47,  69,  31,  255, 36,
    62,  26,  255, 40,  63,  29,  255, 40,  62,  31,  255, 36,  58,  28,  255, 41,  60,  26,  255, 148, 168, 72,  255, 187, 196, 92,  255, 199, 203,
    109, 255, 211, 215, 111, 255, 206, 212, 110, 255, 193, 202, 100, 255, 185, 189, 87,  255, 107, 110, 47,  255, 33,  52,  21,  255, 36,  60,  25,
    255, 63,  96,  31,  255, 80,  109, 43,  255, 47,  62,  34,  255, 46,  68,  29,  255, 55,  90,  36,  255, 32,  55,  25,  255, 40,  68,  25,  255,
    73,  105, 45,  255, 92,  132, 47,  255, 103, 140, 46,  255, 75,  106, 37,  255, 36,  58,  21,  255, 46,  76,  31,  255, 55,  86,  36,  255, 95,
    126, 60,  255, 94,  120, 48,  255, 102, 131, 55,  255, 69,  94,  34,  255, 65,  98,  34,  255, 68,  102, 33,  255, 74,  109, 36,  255, 67,  98,
    33,  255, 67,  95,  41,  255, 82,  111, 47,  255, 75,  111, 37,  255, 87,  123, 47,  255, 52,  77,  34,  255, 44,  65,  36,  255, 37,  60,  28,
    255, 53,  82,  33,  255, 74,  105, 43,  255, 68,  99,  41,  255, 46,  77,  29,  255, 78,  94,  29,  255, 190, 203, 67,  255, 141, 170, 63,  255,
    121, 152, 68,  255, 158, 177, 75,  255, 188, 199, 67,  255, 217, 216, 73,  255, 235, 229, 93,  255, 174, 181, 89,  255, 17,  23,  9,   255, 58,
    65,  42,  255, 157, 171, 115, 255, 158, 182, 133, 255, 173, 192, 123, 255, 196, 200, 104, 255, 205, 213, 127, 255, 197, 210, 135, 255, 178, 200,
    128, 255, 145, 175, 110, 255, 125, 152, 77,  255, 173, 188, 105, 255, 194, 213, 126, 255, 187, 200, 106, 255, 129, 148, 83,  255, 131, 143, 72,
    255, 60,  82,  33,  255, 55,  80,  34,  255, 76,  103, 40,  255, 75,  106, 41,  255, 57,  87,  33,  255, 94,  114, 40,  255, 191, 198, 80,  255,
    143, 166, 79,  255, 149, 172, 65,  255, 171, 189, 56,  255, 149, 171, 45,  255, 178, 191, 107, 255, 241, 243, 185, 255, 213, 228, 173, 255, 180,
    210, 160, 255, 192, 219, 169, 255, 230, 235, 159, 255, 129, 149, 58,  255, 98,  126, 58,  255, 131, 155, 68,  255, 153, 174, 67,  255, 136, 163,
    55,  255, 138, 168, 58,  255, 129, 158, 55,  255, 104, 135, 44,  255, 111, 138, 55,  255, 124, 149, 67,  255, 94,  131, 48,  255, 92,  135, 50,
    255, 117, 156, 74,  255, 150, 179, 84,  255, 188, 205, 84,  255, 116, 131, 45,  255, 85,  117, 40,  255, 97,  127, 42,  255, 107, 134, 46,  255,
    102, 134, 47,  255, 75,  98,  31,  255, 119, 140, 79,  255, 165, 186, 106, 255, 159, 180, 99,  255, 157, 179, 100, 255, 158, 181, 93,  255, 184,
    202, 71,  255, 201, 216, 87,  255, 229, 231, 126, 255, 249, 241, 129, 255, 229, 227, 121, 255, 170, 195, 143, 255, 167, 192, 147, 255, 222, 219,
    146, 255, 198, 202, 126, 255, 85,  109, 28,  255, 136, 152, 49,  255, 136, 153, 55,  255, 126, 146, 55,  255, 123, 142, 60,  255, 163, 172, 91,
    255, 175, 184, 95,  255, 124, 140, 56,  255, 104, 125, 38,  255, 171, 173, 94,  255, 189, 196, 146, 255, 186, 200, 164, 255, 206, 228, 201, 255,
    218, 230, 188, 255, 232, 238, 168, 255, 209, 215, 115, 255, 203, 210, 119, 255, 194, 202, 105, 255, 195, 201, 98,  255, 159, 174, 85,  255, 106,
    132, 49,  255, 83,  113, 47,  255, 43,  75,  33,  255, 42,  73,  26,  255, 68,  103, 39,  255, 84,  121, 56,  255, 76,  113, 45,  255, 68,  92,
    52,  255, 72,  97,  48,  255, 62,  94,  40,  255, 34,  47,  25,  255, 55,  86,  40,  255, 42,  75,  34,  255, 36,  60,  31,  255, 48,  68,  23,
    255, 97,  122, 47,  255, 167, 189, 110, 255, 166, 193, 136, 255, 150, 182, 115, 255, 150, 181, 111, 255, 162, 186, 131, 255, 173, 200, 133, 255,
    160, 192, 130, 255, 177, 202, 119, 255, 144, 173, 100, 255, 120, 153, 87,  255, 141, 177, 106, 255, 144, 169, 81,  255, 174, 183, 74,  255, 193,
    197, 83,  255, 108, 137, 42,  255, 93,  121, 43,  255, 85,  103, 55,  255, 73,  102, 48,  255, 101, 128, 55,  255, 153, 176, 96,  255, 154, 180,
    122, 255, 133, 152, 100, 255, 152, 176, 109, 255, 187, 198, 111, 255, 228, 229, 131, 255, 207, 218, 138, 255, 181, 201, 149, 255, 170, 197, 164,
    255, 162, 192, 161, 255, 202, 215, 154, 255, 193, 205, 131, 255, 85,  107, 47,  255, 83,  100, 36,  255, 156, 181, 84,  255, 137, 166, 92,  255,
    95,  125, 60,  255, 26,  44,  23,  255, 45,  57,  32,  255, 108, 131, 43,  255, 128, 156, 65,  255, 100, 132, 65,  255, 55,  81,  36,  255, 72,
    92,  47,  255, 58,  86,  43,  255, 53,  77,  46,  255, 37,  52,  36,  255, 38,  55,  32,  255, 41,  67,  34,  255, 39,  67,  31,  255, 36,  53,
    29,  255, 26,  28,  23,  255, 73,  95,  38,  255, 95,  131, 48,  255, 109, 142, 62,  255, 123, 152, 72,  255, 134, 156, 72,  255, 78,  92,  44,
    255, 33,  47,  31,  255, 42,  65,  29,  255, 67,  105, 26,  255, 68,  112, 26,  255, 80,  120, 32,  255, 104, 142, 42,  255, 116, 150, 40,  255,
    125, 144, 58,  255, 45,  55,  28,  255, 47,  65,  31,  255, 79,  111, 49,  255, 65,  103, 37,  255, 51,  87,  31,  255, 47,  77,  36,  255, 44,
    72,  39,  255, 86,  119, 55,  255, 108, 146, 55,  255, 92,  132, 47,  255, 74,  109, 47,  255, 49,  76,  36,  255, 32,  49,  25,  255, 26,  49,
    19,  255, 55,  87,  36,  255, 124, 156, 75,  255, 104, 132, 58,  255, 90,  107, 55,  255, 158, 180, 144, 255, 143, 169, 136, 255, 126, 150, 111,
    255, 162, 190, 155, 255, 162, 190, 136, 255, 185, 200, 119, 255, 41,  43,  29,  255, 15,  21,  19,  255, 171, 190, 129, 255, 171, 194, 90,  255,
    126, 150, 77,  255, 42,  74,  28,  255, 46,  75,  31,  255, 40,  72,  26,  255, 57,  83,  36,  255, 53,  74,  34,  255, 85,  101, 62,  255, 207,
    214, 136, 255, 157, 177, 120, 255, 134, 165, 114, 255, 153, 177, 118, 255, 164, 185, 115, 255, 153, 175, 103, 255, 155, 177, 98,  255, 176, 194,
    97,  255, 118, 128, 52,  255, 49,  75,  21,  255, 97,  125, 42,  255, 69,  87,  36,  255, 34,  49,  26,  255, 107, 140, 74,  255, 81,  114, 65,
    255, 60,  95,  41,  255, 89,  124, 41,  255, 110, 142, 58,  255, 81,  118, 52,  255, 83,  122, 47,  255, 74,  117, 40,  255, 65,  98,  31,  255,
    26,  34,  21,  255, 32,  47,  23,  255, 89,  121, 49,  255, 77,  112, 39,  255, 69,  100, 36,  255, 62,  87,  32,  255, 69,  104, 38,  255, 68,
    101, 37,  255, 62,  92,  41,  255, 55,  84,  40,  255, 58,  86,  36,  255, 65,  101, 28,  255, 90,  124, 43,  255, 100, 129, 60,  255, 53,  86,
    40,  255, 41,  65,  31,  255, 72,  87,  40,  255, 147, 163, 76,  255, 169, 183, 83,  255, 163, 179, 83,  255, 135, 160, 74,  255, 75,  104, 40,
    255, 122, 134, 48,  255, 182, 190, 68,  255, 168, 191, 77,  255, 160, 182, 78,  255, 171, 187, 91,  255, 221, 220, 87,  255, 234, 228, 100, 255,
    123, 128, 63,  255, 72,  78,  48,  255, 202, 212, 133, 255, 176, 197, 132, 255, 157, 182, 125, 255, 206, 216, 124, 255, 171, 180, 91,  255, 173,
    184, 124, 255, 143, 164, 126, 255, 184, 206, 145, 255, 165, 190, 96,  255, 138, 168, 93,  255, 162, 185, 117, 255, 151, 171, 105, 255, 104, 132,
    87,  255, 120, 142, 72,  255, 144, 155, 71,  255, 28,  39,  17,  255, 15,  23,  17,  255, 23,  34,  23,  255, 36,  48,  28,  255, 32,  47,  23,
    255, 125, 135, 55,  255, 153, 174, 78,  255, 117, 150, 69,  255, 162, 169, 55,  255, 110, 127, 31,  255, 146, 163, 83,  255, 221, 230, 177, 255,
    221, 234, 179, 255, 201, 221, 168, 255, 192, 218, 169, 255, 211, 228, 174, 255, 226, 224, 137, 255, 167, 179, 82,  255, 121, 152, 69,  255, 105,
    137, 58,  255, 103, 132, 46,  255, 82,  103, 32,  255, 142, 164, 91,  255, 138, 172, 123, 255, 100, 142, 71,  255, 128, 165, 52,  255, 159, 180,
    68,  255, 133, 162, 77,  255, 127, 160, 75,  255, 127, 163, 77,  255, 139, 173, 78,  255, 184, 204, 87,  255, 197, 206, 89,  255, 149, 169, 84,
    255, 115, 139, 53,  255, 93,  123, 38,  255, 89,  124, 41,  255, 92,  119, 47,  255, 163, 179, 102, 255, 164, 183, 101, 255, 161, 181, 97,  255,
    158, 178, 96,  255, 189, 205, 114, 255, 194, 211, 79,  255, 193, 211, 79,  255, 222, 224, 121, 255, 228, 228, 120, 255, 205, 215, 118, 255, 163,
    190, 144, 255, 184, 198, 143, 255, 251, 243, 156, 255, 127, 140, 86,  255, 17,  33,  12,  255, 39,  52,  19,  255, 65,  84,  31,  255, 71,  90,
    36,  255, 87,  94,  38,  255, 184, 192, 100, 255, 192, 203, 106, 255, 195, 201, 111, 255, 98,  118, 52,  255, 79,  86,  42,  255, 186, 192, 140,
    255, 181, 198, 161, 255, 219, 234, 190, 255, 217, 227, 171, 255, 188, 198, 132, 255, 211, 214, 116, 255, 212, 221, 120, 255, 207, 217, 113, 255,
    210, 206, 84,  255, 179, 190, 82,  255, 151, 181, 91,  255, 127, 161, 80,  255, 98,  130, 65,  255, 68,  99,  41,  255, 77,  105, 36,  255, 76,
    105, 39,  255, 60,  97,  36,  255, 71,  95,  55,  255, 79,  100, 58,  255, 79,  112, 58,  255, 55,  77,  39,  255, 37,  60,  31,  255, 37,  65,
    32,  255, 38,  62,  36,  255, 55,  74,  32,  255, 68,  97,  41,  255, 60,  75,  37,  255, 106, 132, 55,  255, 137, 164, 89,  255, 149, 178, 113,
    255, 136, 173, 116, 255, 147, 182, 109, 255, 123, 157, 67,  255, 159, 184, 73,  255, 143, 178, 68,  255, 141, 173, 72,  255, 158, 182, 83,  255,
    175, 194, 92,  255, 204, 215, 104, 255, 165, 181, 84,  255, 48,  72,  23,  255, 48,  79,  25,  255, 80,  99,  53,  255, 63,  86,  52,  255, 76,
    101, 42,  255, 139, 161, 86,  255, 130, 153, 92,  255, 151, 164, 115, 255, 137, 158, 104, 255, 134, 158, 87,  255, 187, 196, 105, 255, 216, 219,
    125, 255, 202, 215, 133, 255, 182, 205, 151, 255, 167, 197, 162, 255, 180, 203, 156, 255, 202, 211, 138, 255, 108, 130, 52,  255, 139, 159, 71,
    255, 146, 171, 87,  255, 96,  121, 65,  255, 67,  96,  42,  255, 68,  89,  38,  255, 116, 116, 53,  255, 142, 150, 63,  255, 129, 154, 65,  255,
    112, 139, 65,  255, 58,  83,  36,  255, 65,  86,  38,  255, 63,  94,  55,  255, 55,  80,  52,  255, 44,  62,  36,  255, 41,  60,  36,  255, 40,
    58,  40,  255, 42,  63,  40,  255, 37,  58,  32,  255, 43,  55,  34,  255, 50,  69,  36,  255, 60,  84,  33,  255, 82,  105, 41,  255, 78,  103,
    41,  255, 50,  75,  31,  255, 34,  47,  25,  255, 29,  44,  28,  255, 44,  75,  23,  255, 52,  87,  25,  255, 68,  102, 31,  255, 94,  127, 39,
    255, 118, 150, 47,  255, 145, 170, 56,  255, 180, 196, 81,  255, 151, 159, 69,  255, 117, 148, 69,  255, 116, 155, 72,  255, 97,  134, 60,  255,
    74,  111, 50,  255, 52,  84,  41,  255, 58,  87,  52,  255, 65,  96,  60,  255, 78,  111, 53,  255, 83,  116, 48,  255, 62,  86,  46,  255, 43,
    62,  36,  255, 43,  62,  32,  255, 82,  103, 55,  255, 85,  103, 56,  255, 126, 148, 91,  255, 167, 182, 128, 255, 164, 176, 109, 255, 183, 200,
    139, 255, 155, 171, 110, 255, 158, 180, 124, 255, 180, 201, 140, 255, 175, 197, 126, 255, 166, 193, 102, 255, 77,  86,  47,  255, 3,   6,   9,
    255, 101, 121, 79,  255, 164, 186, 108, 255, 69,  106, 37,  255, 55,  92,  33,  255, 47,  84,  29,  255, 55,  87,  26,  255, 167, 185, 102, 255,
    193, 200, 123, 255, 87,  100, 50,  255, 152, 171, 84,  255, 184, 193, 106, 255, 158, 177, 108, 255, 141, 166, 112, 255, 136, 163, 117, 255, 130,
    158, 110, 255, 120, 149, 99,  255, 125, 154, 100, 255, 137, 164, 82,  255, 115, 137, 46,  255, 69,  87,  38,  255, 47,  65,  26,  255, 83,  111,
    52,  255, 131, 169, 89,  255, 81,  122, 56,  255, 84,  123, 43,  255, 127, 159, 63,  255, 100, 137, 62,  255, 84,  120, 56,  255, 65,  104, 47,
    255, 57,  92,  40,  255, 68,  108, 38,  255, 45,  62,  26,  255, 63,  87,  44,  255, 86,  118, 49,  255, 72,  107, 39,  255, 71,  100, 40,  255,
    62,  90,  36,  255, 63,  100, 41,  255, 52,  79,  42,  255, 50,  75,  44,  255, 63,  92,  43,  255, 89,  118, 43,  255, 97,  124, 42,  255, 77,
    104, 48,  255, 71,  106, 53,  255, 60,  100, 47,  255, 65,  98,  37,  255, 167, 176, 84,  255, 167, 177, 89,  255, 164, 174, 81,  255, 154, 167,
    79,  255, 135, 155, 81,  255, 129, 154, 65,  255, 87,  119, 42,  255, 86,  105, 40,  255, 153, 157, 62,  255, 198, 197, 84,  255, 178, 190, 108,
    255, 216, 216, 126, 255, 223, 222, 119, 255, 115, 126, 63,  255, 206, 211, 128, 255, 213, 222, 144, 255, 154, 180, 122, 255, 176, 195, 120, 255,
    216, 220, 117, 255, 173, 186, 106, 255, 142, 164, 121, 255, 165, 196, 163, 255, 175, 202, 128, 255, 198, 211, 104, 255, 179, 194, 91,  255, 167,
    186, 93,  255, 130, 156, 96,  255, 100, 127, 76,  255, 148, 170, 75,  255, 157, 164, 80,  255, 77,  84,  55,  255, 102, 109, 75,  255, 81,  89,
    65,  255, 56,  67,  46,  255, 39,  55,  33,  255, 121, 134, 73,  255, 154, 164, 71,  255, 164, 168, 55,  255, 76,  104, 48,  255, 58,  91,  31,
    255, 188, 202, 104, 255, 209, 229, 161, 255, 204, 223, 167, 255, 199, 218, 139, 255, 226, 238, 168, 255, 231, 231, 136, 255, 189, 196, 93,  255,
    153, 167, 95,  255, 86,  115, 52,  255, 65,  97,  37,  255, 57,  94,  36,  255, 78,  112, 38,  255, 138, 163, 92,  255, 135, 173, 142, 255, 148,
    184, 128, 255, 130, 157, 60,  255, 148, 164, 48,  255, 165, 176, 72,  255, 167, 185, 92,  255, 193, 212, 113, 255, 186, 208, 107, 255, 189, 205,
    111, 255, 166, 180, 97,  255, 158, 181, 95,  255, 176, 193, 99,  255, 125, 147, 68,  255, 82,  114, 40,  255, 111, 135, 60,  255, 173, 189, 111,
    255, 165, 183, 99,  255, 164, 183, 92,  255, 168, 186, 98,  255, 216, 224, 126, 255, 197, 211, 77,  255, 186, 208, 77,  255, 198, 214, 123, 255,
    175, 194, 111, 255, 171, 196, 135, 255, 164, 191, 143, 255, 209, 210, 142, 255, 222, 220, 141, 255, 44,  55,  31,  255, 32,  47,  19,  255, 43,
    68,  23,  255, 57,  87,  31,  255, 49,  84,  29,  255, 91,  97,  37,  255, 188, 200, 105, 255, 186, 199, 103, 255, 220, 222, 134, 255, 214, 218,
    145, 255, 103, 115, 65,  255, 148, 154, 101, 255, 194, 202, 154, 255, 246, 245, 172, 255, 213, 220, 153, 255, 161, 180, 135, 255, 199, 206, 124,
    255, 190, 202, 104, 255, 197, 217, 102, 255, 203, 219, 103, 255, 180, 192, 93,  255, 162, 188, 102, 255, 123, 156, 92,  255, 117, 150, 84,  255,
    113, 147, 68,  255, 156, 177, 67,  255, 171, 193, 74,  255, 60,  99,  31,  255, 38,  65,  26,  255, 60,  71,  46,  255, 84,  114, 65,  255, 69,
    99,  49,  255, 50,  68,  26,  255, 67,  87,  43,  255, 68,  87,  45,  255, 65,  87,  36,  255, 67,  94,  37,  255, 60,  77,  37,  255, 99,  122,
    49,  255, 118, 153, 79,  255, 119, 154, 86,  255, 102, 139, 60,  255, 104, 142, 44,  255, 108, 140, 49,  255, 126, 156, 53,  255, 122, 161, 55,
    255, 115, 152, 52,  255, 136, 163, 67,  255, 143, 169, 75,  255, 164, 184, 84,  255, 168, 184, 86,  255, 133, 146, 68,  255, 74,  99,  36,  255,
    73,  100, 41,  255, 82,  98,  60,  255, 97,  118, 58,  255, 135, 165, 96,  255, 105, 135, 86,  255, 126, 145, 95,  255, 132, 150, 98,  255, 133,
    156, 94,  255, 170, 184, 99,  255, 136, 152, 71,  255, 151, 163, 80,  255, 199, 208, 123, 255, 199, 216, 144, 255, 187, 208, 159, 255, 204, 217,
    160, 255, 134, 155, 73,  255, 175, 188, 103, 255, 152, 170, 96,  255, 125, 147, 75,  255, 149, 166, 74,  255, 189, 200, 74,  255, 226, 232, 101,
    255, 230, 228, 109, 255, 120, 139, 60,  255, 101, 138, 62,  255, 73,  97,  41,  255, 62,  84,  41,  255, 55,  87,  39,  255, 62,  97,  47,  255,
    55,  92,  31,  255, 69,  109, 33,  255, 60,  82,  41,  255, 38,  55,  43,  255, 38,  58,  38,  255, 55,  77,  40,  255, 44,  69,  32,  255, 41,
    68,  36,  255, 29,  48,  31,  255, 31,  52,  26,  255, 40,  68,  26,  255, 55,  89,  31,  255, 68,  92,  29,  255, 81,  108, 31,  255, 91,  123,
    34,  255, 112, 138, 39,  255, 141, 164, 44,  255, 174, 190, 56,  255, 167, 180, 58,  255, 116, 131, 48,  255, 128, 154, 68,  255, 145, 181, 89,
    255, 120, 156, 86,  255, 94,  130, 86,  255, 80,  113, 77,  255, 67,  96,  60,  255, 65,  98,  55,  255, 65,  100, 60,  255, 79,  109, 63,  255,
    82,  102, 52,  255, 49,  71,  32,  255, 60,  81,  43,  255, 55,  74,  39,  255, 88,  114, 69,  255, 154, 184, 116, 255, 182, 201, 110, 255, 167,
    190, 90,  255, 141, 176, 76,  255, 132, 171, 72,  255, 142, 180, 74,  255, 157, 188, 100, 255, 156, 182, 103, 255, 150, 175, 94,  255, 159, 192,
    102, 255, 126, 144, 74,  255, 23,  26,  23,  255, 118, 125, 92,  255, 143, 158, 96,  255, 80,  115, 37,  255, 68,  109, 31,  255, 79,  113, 32,
    255, 171, 187, 91,  255, 209, 222, 132, 255, 221, 230, 143, 255, 160, 172, 87,  255, 46,  77,  19,  255, 89,  105, 44,  255, 189, 192, 84,  255,
    210, 210, 95,  255, 167, 181, 89,  255, 142, 163, 87,  255, 124, 152, 86,  255, 109, 141, 81,  255, 93,  127, 68,  255, 98,  132, 52,  255, 55,
    71,  32,  255, 37,  58,  21,  255, 120, 154, 71,  255, 106, 145, 71,  255, 94,  131, 55,  255, 71,  105, 37,  255, 89,  118, 49,  255, 137, 161,
    68,  255, 91,  126, 58,  255, 71,  109, 44,  255, 63,  99,  41,  255, 52,  89,  37,  255, 60,  101, 36,  255, 67,  103, 44,  255, 65,  100, 38,
    255, 77,  112, 50,  255, 68,  94,  42,  255, 55,  81,  38,  255, 53,  83,  46,  255, 73,  102, 50,  255, 90,  120, 55,  255, 95,  129, 56,  255,
    109, 145, 68,  255, 117, 146, 65,  255, 78,  108, 47,  255, 62,  97,  44,  255, 52,  79,  36,  255, 71,  87,  36,  255, 170, 177, 86,  255, 129,
    151, 78,  255, 117, 141, 82,  255, 112, 137, 84,  255, 99,  127, 75,  255, 92,  119, 55,  255, 90,  122, 41,  255, 68,  102, 37,  255, 71,  96,
    32,  255, 110, 127, 55,  255, 154, 160, 74,  255, 197, 195, 108, 255, 197, 215, 145, 255, 161, 191, 126, 255, 176, 198, 115, 255, 163, 191, 112,
    255, 147, 179, 98,  255, 184, 199, 100, 255, 210, 212, 114, 255, 136, 153, 76,  255, 164, 190, 124, 255, 169, 191, 95,  255, 152, 171, 74,  255,
    102, 128, 74,  255, 110, 136, 98,  255, 128, 154, 108, 255, 125, 145, 79,  255, 124, 148, 72,  255, 163, 187, 89,  255, 182, 203, 131, 255, 197,
    219, 161, 255, 210, 229, 172, 255, 213, 226, 168, 255, 199, 215, 146, 255, 193, 209, 139, 255, 175, 190, 127, 255, 83,  99,  47,  255, 63,  84,
    36,  255, 74,  103, 55,  255, 80,  108, 52,  255, 185, 205, 124, 255, 196, 217, 131, 255, 198, 217, 130, 255, 190, 211, 111, 255, 187, 204, 103,
    255, 208, 217, 99,  255, 191, 196, 87,  255, 110, 124, 55,  255, 60,  90,  44,  255, 75,  107, 58,  255, 103, 135, 69,  255, 92,  124, 44,  255,
    110, 131, 60,  255, 139, 171, 116, 255, 147, 171, 102, 255, 104, 124, 52,  255, 142, 167, 67,  255, 152, 177, 83,  255, 155, 186, 112, 255, 182,
    205, 137, 255, 184, 205, 116, 255, 185, 205, 113, 255, 160, 184, 105, 255, 150, 176, 103, 255, 159, 182, 103, 255, 189, 202, 113, 255, 79,  97,
    32,  255, 97,  115, 55,  255, 175, 194, 113, 255, 168, 185, 100, 255, 163, 182, 90,  255, 172, 189, 100, 255, 221, 227, 130, 255, 191, 207, 80,
    255, 185, 205, 87,  255, 179, 197, 94,  255, 178, 198, 68,  255, 152, 165, 100, 255, 179, 194, 138, 255, 230, 227, 140, 255, 173, 189, 110, 255,
    122, 143, 71,  255, 52,  80,  25,  255, 43,  68,  26,  255, 50,  76,  31,  255, 53,  84,  25,  255, 145, 148, 68,  255, 191, 204, 111, 255, 181,
    194, 102, 255, 180, 190, 99,  255, 200, 207, 115, 255, 219, 225, 158, 255, 190, 194, 129, 255, 180, 188, 110, 255, 223, 222, 135, 255, 208, 218,
    135, 255, 165, 186, 131, 255, 161, 181, 118, 255, 144, 167, 98,  255, 175, 194, 100, 255, 177, 211, 80,  255, 204, 221, 107, 255, 171, 192, 109,
    255, 140, 166, 114, 255, 160, 182, 101, 255, 148, 176, 77,  255, 140, 160, 56,  255, 152, 171, 75,  255, 133, 149, 86,  255, 155, 159, 111, 255,
    173, 167, 131, 255, 85,  105, 65,  255, 76,  104, 52,  255, 65,  90,  33,  255, 89,  109, 55,  255, 126, 146, 72,  255, 147, 170, 75,  255, 150,
    171, 77,  255, 163, 190, 98,  255, 160, 188, 104, 255, 161, 190, 112, 255, 139, 171, 91,  255, 112, 143, 69,  255, 129, 158, 84,  255, 134, 164,
    74,  255, 84,  119, 41,  255, 105, 137, 55,  255, 116, 147, 67,  255, 127, 159, 62,  255, 129, 159, 67,  255, 136, 163, 77,  255, 153, 173, 83,
    255, 162, 181, 85,  255, 154, 172, 84,  255, 97,  123, 50,  255, 79,  94,  55,  255, 101, 120, 60,  255, 131, 159, 92,  255, 108, 134, 95,  255,
    117, 141, 94,  255, 137, 159, 89,  255, 161, 187, 95,  255, 164, 189, 94,  255, 149, 174, 80,  255, 144, 167, 87,  255, 122, 141, 75,  255, 111,
    117, 60,  255, 164, 176, 98,  255, 190, 211, 129, 255, 116, 144, 62,  255, 148, 165, 84,  255, 150, 167, 101, 255, 139, 158, 83,  255, 171, 191,
    75,  255, 176, 199, 86,  255, 170, 192, 96,  255, 220, 224, 111, 255, 97,  102, 48,  255, 23,  42,  23,  255, 63,  87,  37,  255, 63,  87,  38,
    255, 58,  92,  38,  255, 52,  84,  38,  255, 60,  89,  37,  255, 84,  121, 38,  255, 92,  122, 45,  255, 43,  67,  41,  255, 40,  63,  40,  255,
    55,  73,  42,  255, 39,  62,  28,  255, 60,  100, 43,  255, 46,  69,  38,  255, 41,  65,  36,  255, 43,  68,  36,  255, 47,  76,  31,  255, 91,
    127, 36,  255, 133, 151, 45,  255, 158, 170, 52,  255, 161, 169, 52,  255, 146, 153, 53,  255, 106, 116, 47,  255, 62,  89,  32,  255, 32,  58,
    19,  255, 113, 143, 68,  255, 115, 152, 93,  255, 93,  128, 91,  255, 89,  124, 92,  255, 90,  127, 84,  255, 81,  117, 71,  255, 74,  105, 63,
    255, 71,  103, 63,  255, 98,  134, 69,  255, 89,  108, 55,  255, 56,  77,  36,  255, 68,  94,  47,  255, 77,  103, 52,  255, 46,  67,  32,  255,
    119, 142, 76,  255, 161, 186, 84,  255, 146, 174, 79,  255, 107, 148, 60,  255, 106, 149, 58,  255, 136, 174, 77,  255, 145, 174, 86,  255, 126,
    152, 71,  255, 141, 170, 83,  255, 149, 180, 89,  255, 140, 158, 84,  255, 69,  69,  60,  255, 125, 146, 84,  255, 122, 141, 71,  255, 90,  126,
    41,  255, 100, 130, 42,  255, 178, 194, 96,  255, 208, 219, 124, 255, 199, 212, 122, 255, 217, 225, 135, 255, 186, 194, 113, 255, 48,  75,  31,
    255, 42,  72,  28,  255, 60,  91,  36,  255, 116, 133, 60,  255, 167, 176, 78,  255, 186, 187, 75,  255, 168, 177, 74,  255, 150, 166, 68,  255,
    138, 156, 67,  255, 115, 139, 58,  255, 62,  83,  32,  255, 79,  108, 50,  255, 129, 165, 85,  255, 105, 142, 65,  255, 82,  116, 41,  255, 41,
    75,  21,  255, 28,  52,  23,  255, 79,  106, 45,  255, 108, 138, 60,  255, 77,  114, 45,  255, 63,  98,  39,  255, 60,  92,  38,  255, 77,  105,
    43,  255, 80,  108, 38,  255, 65,  96,  37,  255, 74,  106, 58,  255, 52,  77,  38,  255, 63,  92,  44,  255, 82,  117, 58,  255, 92,  128, 58,
    255, 82,  115, 52,  255, 95,  129, 60,  255, 86,  112, 58,  255, 63,  84,  43,  255, 55,  75,  37,  255, 44,  60,  29,  255, 34,  48,  26,  255,
    89,  107, 47,  255, 175, 186, 94,  255, 151, 168, 78,  255, 134, 157, 72,  255, 119, 145, 73,  255, 106, 137, 68,  255, 96,  129, 56,  255, 95,
    129, 47,  255, 75,  104, 37,  255, 65,  92,  36,  255, 95,  117, 47,  255, 68,  79,  37,  255, 156, 167, 97,  255, 171, 200, 133, 255, 152, 185,
    124, 255, 141, 176, 110, 255, 139, 174, 99,  255, 140, 175, 92,  255, 154, 182, 87,  255, 181, 191, 91,  255, 114, 136, 58,  255, 88,  106, 37,
    255, 89,  107, 36,  255, 116, 141, 80,  255, 96,  130, 95,  255, 116, 149, 111, 255, 115, 144, 98,  255, 114, 133, 65,  255, 167, 186, 102, 255,
    201, 213, 105, 255, 189, 211, 117, 255, 187, 211, 144, 255, 187, 211, 161, 255, 191, 215, 169, 255, 182, 211, 162, 255, 183, 211, 157, 255, 205,
    222, 161, 255, 115, 133, 80,  255, 60,  94,  42,  255, 75,  105, 52,  255, 80,  108, 60,  255, 142, 164, 90,  255, 173, 187, 106, 255, 162, 166,
    93,  255, 133, 150, 72,  255, 135, 163, 80,  255, 150, 177, 87,  255, 97,  127, 62,  255, 71,  106, 63,  255, 77,  111, 58,  255, 173, 188, 100,
    255, 190, 200, 102, 255, 97,  125, 55,  255, 119, 144, 81,  255, 118, 143, 67,  255, 120, 146, 68,  255, 113, 137, 62,  255, 128, 149, 73,  255,
    156, 190, 80,  255, 154, 191, 91,  255, 150, 188, 101, 255, 152, 194, 106, 255, 163, 200, 109, 255, 180, 206, 115, 255, 187, 205, 126, 255, 172,
    190, 115, 255, 137, 141, 68,  255, 42,  53,  23,  255, 91,  110, 55,  255, 167, 187, 100, 255, 159, 178, 84,  255, 155, 176, 77,  255, 167, 185,
    95,  255, 223, 230, 137, 255, 202, 216, 120, 255, 188, 205, 101, 255, 186, 200, 80,  255, 126, 121, 41,  255, 85,  90,  55,  255, 207, 217, 131,
    255, 150, 173, 99,  255, 136, 158, 86,  255, 175, 192, 107, 255, 121, 142, 74,  255, 50,  75,  26,  255, 62,  89,  34,  255, 62,  87,  23,  255,
    164, 166, 81,  255, 193, 207, 114, 255, 180, 193, 101, 255, 181, 191, 99,  255, 181, 191, 94,  255, 184, 191, 104, 255, 151, 168, 89,  255, 96,
    125, 52,  255, 171, 171, 87,  255, 215, 224, 131, 255, 167, 189, 120, 255, 156, 177, 116, 255, 141, 162, 109, 255, 129, 148, 81,  255, 197, 220,
    95,  255, 188, 212, 93,  255, 212, 221, 120, 255, 195, 215, 120, 255, 113, 138, 65,  255, 102, 114, 43,  255, 148, 149, 90,  255, 205, 213, 156,
    255, 221, 238, 186, 255, 228, 236, 183, 255, 122, 135, 99,  255, 58,  84,  47,  255, 53,  82,  36,  255, 47,  68,  33,  255, 49,  73,  34,  255,
    47,  75,  31,  255, 60,  89,  31,  255, 103, 133, 62,  255, 119, 152, 81,  255, 109, 141, 69,  255, 122, 152, 65,  255, 128, 157, 68,  255, 127,
    151, 74,  255, 144, 162, 109, 255, 136, 167, 77,  255, 94,  125, 47,  255, 78,  109, 44,  255, 104, 133, 75,  255, 130, 158, 69,  255, 132, 160,
    67,  255, 128, 155, 68,  255, 112, 143, 65,  255, 111, 143, 62,  255, 141, 165, 80,  255, 144, 168, 86,  255, 88,  111, 53,  255, 101, 115, 62,
    255, 131, 156, 97,  255, 106, 136, 100, 255, 111, 139, 89,  255, 143, 161, 89,  255, 147, 175, 84,  255, 126, 156, 69,  255, 148, 175, 94,  255,
    118, 153, 96,  255, 126, 155, 89,  255, 126, 149, 69,  255, 75,  90,  38,  255, 96,  112, 40,  255, 166, 179, 78,  255, 162, 175, 83,  255, 190,
    199, 116, 255, 188, 199, 107, 255, 180, 195, 120, 255, 183, 199, 126, 255, 203, 210, 131, 255, 199, 207, 118, 255, 121, 142, 65,  255, 38,  51,
    26,  255, 56,  76,  34,  255, 86,  113, 43,  255, 74,  107, 41,  255, 68,  101, 37,  255, 92,  127, 45,  255, 117, 148, 50,  255, 127, 147, 58,
    255, 47,  65,  36,  255, 47,  67,  37,  255, 49,  67,  39,  255, 42,  62,  26,  255, 87,  128, 52,  255, 69,  103, 48,  255, 50,  73,  46,  255,
    52,  75,  47,  255, 55,  86,  42,  255, 68,  108, 38,  255, 55,  72,  32,  255, 42,  51,  26,  255, 55,  63,  29,  255, 44,  52,  28,  255, 23,
    26,  23,  255, 34,  48,  23,  255, 58,  87,  26,  255, 117, 149, 78,  255, 93,  128, 91,  255, 90,  124, 84,  255, 101, 139, 82,  255, 86,  128,
    65,  255, 74,  111, 72,  255, 76,  110, 78,  255, 80,  112, 68,  255, 100, 137, 58,  255, 80,  108, 47,  255, 84,  101, 52,  255, 77,  93,  47,
    255, 34,  49,  28,  255, 23,  36,  21,  255, 106, 131, 75,  255, 159, 186, 107, 255, 158, 180, 87,  255, 107, 143, 48,  255, 102, 140, 47,  255,
    116, 154, 60,  255, 125, 157, 74,  255, 163, 185, 101, 255, 170, 190, 99,  255, 162, 186, 92,  255, 136, 152, 84,  255, 43,  52,  36,  255, 75,
    98,  49,  255, 92,  99,  63,  255, 44,  62,  25,  255, 163, 174, 96,  255, 218, 226, 130, 255, 205, 215, 126, 255, 205, 214, 121, 255, 224, 227,
    137, 255, 168, 181, 102, 255, 63,  94,  47,  255, 60,  87,  53,  255, 53,  81,  46,  255, 40,  65,  43,  255, 51,  78,  50,  255, 69,  92,  46,
    255, 42,  47,  25,  255, 52,  60,  28,  255, 68,  81,  38,  255, 53,  63,  36,  255, 36,  55,  26,  255, 96,  127, 65,  255, 139, 172, 89,  255,
    103, 131, 60,  255, 42,  71,  31,  255, 46,  77,  26,  255, 48,  79,  34,  255, 43,  67,  40,  255, 74,  103, 40,  255, 116, 142, 52,  255, 125,
    147, 68,  255, 130, 154, 71,  255, 132, 156, 62,  255, 89,  120, 42,  255, 121, 148, 62,  255, 98,  118, 60,  255, 50,  75,  34,  255, 83,  119,
    56,  255, 86,  120, 58,  255, 67,  97,  58,  255, 111, 136, 74,  255, 152, 177, 83,  255, 104, 125, 63,  255, 49,  60,  36,  255, 60,  76,  41,
    255, 85,  108, 53,  255, 63,  92,  39,  255, 79,  106, 44,  255, 171, 172, 83,  255, 208, 208, 98,  255, 189, 197, 82,  255, 156, 174, 73,  255,
    160, 176, 73,  255, 178, 189, 74,  255, 153, 168, 58,  255, 74,  102, 34,  255, 63,  91,  34,  255, 55,  84,  38,  255, 75,  90,  55,  255, 200,
    215, 141, 255, 167, 196, 123, 255, 162, 188, 104, 255, 160, 188, 92,  255, 157, 188, 89,  255, 171, 197, 94,  255, 181, 200, 90,  255, 132, 141,
    58,  255, 34,  46,  19,  255, 47,  75,  26,  255, 97,  127, 63,  255, 127, 156, 110, 255, 125, 157, 116, 255, 136, 165, 113, 255, 110, 133, 72,
    255, 149, 174, 98,  255, 200, 212, 118, 255, 190, 194, 110, 255, 161, 169, 84,  255, 194, 207, 115, 255, 195, 217, 144, 255, 190, 213, 159, 255,
    186, 212, 165, 255, 181, 209, 162, 255, 187, 214, 164, 255, 190, 200, 140, 255, 72,  96,  49,  255, 89,  117, 49,  255, 146, 164, 86,  255, 110,
    134, 62,  255, 77,  97,  47,  255, 52,  81,  41,  255, 62,  92,  49,  255, 85,  110, 47,  255, 115, 140, 62,  255, 92,  122, 56,  255, 87,  123,
    65,  255, 158, 180, 93,  255, 210, 221, 100, 255, 197, 206, 103, 255, 157, 173, 98,  255, 174, 192, 106, 255, 131, 169, 90,  255, 139, 178, 104,
    255, 155, 188, 102, 255, 109, 138, 56,  255, 156, 181, 76,  255, 178, 196, 79,  255, 184, 199, 96,  255, 195, 210, 106, 255, 189, 205, 105, 255,
    193, 207, 114, 255, 225, 231, 165, 255, 210, 221, 166, 255, 193, 203, 153, 255, 194, 201, 145, 255, 186, 194, 133, 255, 196, 206, 128, 255, 169,
    187, 95,  255, 145, 168, 63,  255, 153, 175, 78,  255, 217, 227, 147, 255, 199, 203, 125, 255, 193, 200, 109, 255, 91,  103, 37,  255, 47,  62,
    32,  255, 172, 193, 117, 255, 141, 173, 87,  255, 102, 134, 76,  255, 141, 166, 96,  255, 158, 181, 102, 255, 177, 194, 113, 255, 96,  118, 53,
    255, 65,  92,  31,  255, 52,  71,  23,  255, 151, 154, 75,  255, 193, 207, 110, 255, 182, 196, 103, 255, 186, 196, 105, 255, 185, 194, 101, 255,
    181, 191, 97,  255, 146, 161, 84,  255, 86,  121, 62,  255, 107, 126, 56,  255, 217, 218, 119, 255, 165, 189, 120, 255, 153, 174, 112, 255, 195,
    206, 117, 255, 183, 200, 103, 255, 181, 200, 96,  255, 189, 214, 96,  255, 194, 222, 102, 255, 152, 182, 75,  255, 106, 122, 40,  255, 196, 200,
    133, 255, 205, 230, 180, 255, 203, 226, 176, 255, 209, 221, 160, 255, 116, 134, 84,  255, 60,  74,  43,  255, 60,  84,  47,  255, 58,  84,  39,
    255, 60,  74,  39,  255, 65,  97,  42,  255, 58,  87,  36,  255, 79,  109, 36,  255, 107, 146, 60,  255, 97,  135, 56,  255, 95,  133, 48,  255,
    77,  111, 38,  255, 40,  68,  21,  255, 65,  91,  39,  255, 122, 132, 87,  255, 133, 160, 73,  255, 116, 150, 69,  255, 76,  110, 44,  255, 95,
    125, 72,  255, 123, 152, 75,  255, 133, 161, 72,  255, 143, 165, 67,  255, 152, 174, 65,  255, 141, 167, 68,  255, 120, 149, 60,  255, 123, 153,
    74,  255, 110, 138, 68,  255, 89,  106, 55,  255, 125, 148, 92,  255, 107, 137, 89,  255, 112, 140, 82,  255, 113, 137, 74,  255, 58,  90,  23,
    255, 96,  121, 52,  255, 119, 149, 98,  255, 97,  132, 89,  255, 110, 143, 91,  255, 100, 125, 67,  255, 58,  77,  31,  255, 71,  91,  36,  255,
    154, 177, 73,  255, 142, 172, 65,  255, 183, 194, 107, 255, 176, 193, 126, 255, 154, 176, 129, 255, 163, 183, 133, 255, 214, 216, 139, 255, 159,
    173, 95,  255, 111, 139, 62,  255, 95,  123, 50,  255, 69,  90,  43,  255, 91,  115, 48,  255, 101, 129, 45,  255, 111, 139, 48,  255, 105, 132,
    47,  255, 71,  87,  38,  255, 41,  46,  31,  255, 25,  23,  23,  255, 44,  52,  33,  255, 40,  53,  31,  255, 37,  56,  23,  255, 101, 135, 56,
    255, 114, 150, 67,  255, 87,  117, 62,  255, 69,  97,  58,  255, 68,  98,  58,  255, 87,  123, 56,  255, 102, 133, 52,  255, 79,  102, 38,  255,
    79,  106, 39,  255, 82,  108, 47,  255, 101, 124, 60,  255, 80,  98,  43,  255, 52,  71,  26,  255, 105, 138, 80,  255, 123, 157, 95,  255, 139,
    172, 86,  255, 108, 143, 78,  255, 81,  115, 75,  255, 79,  112, 68,  255, 94,  128, 76,  255, 115, 147, 74,  255, 86,  114, 53,  255, 40,  55,
    31,  255, 99,  124, 67,  255, 143, 166, 80,  255, 72,  74,  40,  255, 12,  17,  12,  255, 82,  98,  52,  255, 152, 184, 124, 255, 169, 188, 130,
    255, 167, 184, 76,  255, 143, 169, 68,  255, 134, 164, 82,  255, 131, 166, 96,  255, 148, 181, 117, 255, 170, 196, 126, 255, 186, 206, 114, 255,
    138, 158, 73,  255, 38,  52,  21,  255, 19,  31,  19,  255, 77,  80,  58,  255, 62,  77,  37,  255, 207, 217, 132, 255, 212, 218, 131, 255, 211,
    217, 126, 255, 214, 219, 129, 255, 232, 231, 143, 255, 123, 145, 68,  255, 68,  102, 47,  255, 62,  87,  56,  255, 53,  79,  46,  255, 53,  80,
    52,  255, 57,  87,  53,  255, 71,  101, 47,  255, 26,  37,  23,  255, 12,  17,  19,  255, 43,  52,  34,  255, 32,  41,  26,  255, 25,  37,  21,
    255, 49,  75,  34,  255, 140, 173, 89,  255, 115, 144, 71,  255, 69,  97,  52,  255, 65,  95,  48,  255, 62,  94,  46,  255, 52,  84,  41,  255,
    105, 124, 58,  255, 110, 134, 60,  255, 102, 137, 58,  255, 98,  133, 56,  255, 68,  103, 37,  255, 65,  104, 38,  255, 92,  128, 50,  255, 114,
    144, 53,  255, 103, 131, 53,  255, 131, 157, 76,  255, 118, 137, 72,  255, 84,  108, 67,  255, 97,  126, 65,  255, 148, 174, 77,  255, 140, 164,
    81,  255, 97,  129, 68,  255, 114, 150, 72,  255, 116, 150, 72,  255, 81,  114, 49,  255, 57,  84,  33,  255, 74,  100, 36,  255, 146, 151, 62,
    255, 184, 184, 78,  255, 184, 186, 76,  255, 173, 174, 69,  255, 119, 117, 43,  255, 58,  65,  26,  255, 60,  87,  31,  255, 44,  60,  26,  255,
    38,  55,  29,  255, 68,  90,  49,  255, 136, 146, 86,  255, 195, 203, 115, 255, 173, 191, 127, 255, 169, 189, 129, 255, 201, 212, 134, 255, 155,
    170, 100, 255, 157, 167, 86,  255, 92,  111, 43,  255, 52,  84,  26,  255, 91,  124, 36,  255, 130, 158, 83,  255, 126, 158, 120, 255, 139, 170,
    120, 255, 121, 143, 83,  255, 128, 151, 89,  255, 183, 201, 122, 255, 192, 198, 103, 255, 146, 166, 105, 255, 137, 159, 94,  255, 179, 189, 101,
    255, 220, 228, 142, 255, 208, 224, 153, 255, 196, 220, 162, 255, 186, 213, 162, 255, 181, 209, 165, 255, 202, 222, 164, 255, 156, 169, 103, 255,
    197, 205, 106, 255, 237, 241, 105, 255, 179, 207, 104, 255, 161, 190, 108, 255, 110, 133, 73,  255, 79,  105, 55,  255, 82,  113, 52,  255, 92,
    126, 55,  255, 99,  131, 60,  255, 114, 140, 58,  255, 202, 212, 94,  255, 201, 213, 92,  255, 222, 226, 119, 255, 219, 220, 120, 255, 203, 215,
    106, 255, 157, 189, 107, 255, 146, 181, 106, 255, 153, 189, 107, 255, 173, 200, 96,  255, 102, 121, 50,  255, 68,  90,  37,  255, 106, 131, 44,
    255, 123, 145, 49,  255, 138, 160, 65,  255, 171, 195, 96,  255, 203, 214, 126, 255, 202, 219, 166, 255, 187, 212, 170, 255, 192, 213, 169, 255,
    188, 212, 168, 255, 201, 216, 163, 255, 225, 229, 158, 255, 196, 205, 108, 255, 154, 178, 68,  255, 191, 201, 118, 255, 188, 193, 115, 255, 150,
    169, 91,  255, 83,  106, 39,  255, 127, 149, 60,  255, 168, 190, 92,  255, 114, 150, 74,  255, 114, 143, 87,  255, 138, 168, 104, 255, 133, 161,
    97,  255, 179, 197, 110, 255, 107, 131, 68,  255, 29,  43,  21,  255, 15,  17,  17,  255, 80,  78,  36,  255, 195, 205, 105, 255, 184, 198, 103,
    255, 186, 198, 109, 255, 183, 195, 103, 255, 181, 193, 100, 255, 135, 156, 84,  255, 101, 131, 69,  255, 122, 138, 77,  255, 134, 144, 69,  255,
    181, 192, 94,  255, 146, 173, 103, 255, 124, 155, 85,  255, 128, 157, 75,  255, 132, 156, 74,  255, 136, 164, 68,  255, 153, 182, 76,  255, 155,
    175, 78,  255, 192, 206, 117, 255, 191, 218, 165, 255, 199, 219, 159, 255, 181, 196, 128, 255, 97,  122, 73,  255, 62,  96,  46,  255, 79,  108,
    55,  255, 62,  75,  33,  255, 134, 159, 82,  255, 112, 149, 81,  255, 69,  108, 52,  255, 74,  108, 40,  255, 79,  110, 40,  255, 74,  107, 37,
    255, 80,  114, 36,  255, 104, 138, 56,  255, 87,  126, 60,  255, 71,  109, 44,  255, 53,  87,  33,  255, 65,  86,  37,  255, 131, 148, 72,  255,
    141, 172, 85,  255, 96,  131, 67,  255, 80,  111, 52,  255, 116, 145, 83,  255, 146, 170, 87,  255, 101, 123, 56,  255, 68,  84,  32,  255, 133,
    151, 60,  255, 155, 175, 74,  255, 136, 161, 69,  255, 116, 145, 62,  255, 84,  103, 49,  255, 94,  115, 65,  255, 77,  104, 52,  255, 52,  72,
    32,  255, 83,  106, 53,  255, 101, 123, 50,  255, 132, 158, 93,  255, 102, 134, 94,  255, 102, 133, 92,  255, 105, 139, 91,  255, 121, 141, 84,
    255, 23,  29,  21,  255, 19,  26,  21,  255, 60,  84,  31,  255, 142, 160, 74,  255, 212, 218, 127, 255, 163, 184, 128, 255, 153, 177, 137, 255,
    163, 186, 143, 255, 209, 212, 147, 255, 184, 189, 113, 255, 100, 125, 53,  255, 114, 140, 63,  255, 82,  98,  50,  255, 60,  79,  36,  255, 68,
    90,  39,  255, 55,  79,  32,  255, 38,  52,  26,  255, 29,  37,  23,  255, 17,  21,  21,  255, 21,  25,  19,  255, 55,  68,  37,  255, 31,  43,
    25,  255, 48,  74,  28,  255, 73,  103, 41,  255, 129, 157, 74,  255, 144, 173, 79,  255, 135, 164, 80,  255, 122, 151, 79,  255, 127, 157, 77,
    255, 128, 160, 72,  255, 76,  105, 43,  255, 57,  84,  40,  255, 62,  91,  40,  255, 87,  121, 46,  255, 78,  105, 41,  255, 26,  31,  19,  255,
    80,  96,  55,  255, 122, 148, 77,  255, 117, 144, 71,  255, 121, 147, 75,  255, 121, 154, 80,  255, 122, 155, 75,  255, 111, 143, 69,  255, 92,
    122, 60,  255, 56,  77,  39,  255, 53,  72,  36,  255, 88,  108, 62,  255, 132, 169, 80,  255, 141, 171, 60,  255, 91,  102, 47,  255, 91,  124,
    48,  255, 163, 179, 87,  255, 176, 188, 115, 255, 139, 163, 95,  255, 125, 152, 74,  255, 152, 172, 81,  255, 187, 202, 104, 255, 175, 198, 117,
    255, 162, 190, 125, 255, 164, 193, 129, 255, 179, 205, 122, 255, 141, 155, 81,  255, 38,  46,  23,  255, 71,  71,  55,  255, 80,  87,  47,  255,
    216, 225, 140, 255, 216, 222, 142, 255, 214, 220, 130, 255, 237, 236, 145, 255, 181, 187, 118, 255, 73,  102, 50,  255, 69,  102, 55,  255, 65,
    96,  52,  255, 52,  79,  43,  255, 58,  82,  56,  255, 58,  90,  55,  255, 72,  108, 42,  255, 31,  48,  21,  255, 34,  44,  26,  255, 36,  46,
    28,  255, 21,  29,  21,  255, 31,  42,  23,  255, 36,  56,  23,  255, 85,  115, 53,  255, 146, 176, 87,  255, 143, 171, 84,  255, 130, 160, 76,
    255, 115, 143, 69,  255, 87,  116, 62,  255, 58,  90,  48,  255, 46,  75,  34,  255, 52,  81,  36,  255, 47,  68,  31,  255, 47,  74,  26,  255,
    53,  86,  31,  255, 72,  112, 37,  255, 107, 148, 58,  255, 139, 177, 82,  255, 160, 187, 93,  255, 172, 195, 97,  255, 173, 191, 94,  255, 124,
    149, 55,  255, 111, 148, 47,  255, 153, 178, 75,  255, 140, 163, 84,  255, 84,  115, 48,  255, 79,  111, 37,  255, 76,  113, 33,  255, 62,  98,
    29,  255, 53,  81,  31,  255, 57,  92,  26,  255, 65,  94,  26,  255, 60,  74,  26,  255, 62,  87,  40,  255, 44,  76,  37,  255, 60,  91,  38,
    255, 60,  91,  32,  255, 40,  60,  32,  255, 47,  68,  33,  255, 50,  71,  31,  255, 47,  60,  26,  255, 185, 194, 122, 255, 144, 173, 136, 255,
    160, 185, 139, 255, 156, 176, 118, 255, 130, 148, 84,  255, 161, 170, 83,  255, 71,  102, 34,  255, 90,  122, 43,  255, 118, 150, 40,  255, 144,
    169, 75,  255, 135, 166, 119, 255, 131, 156, 101, 255, 112, 139, 84,  255, 161, 187, 121, 255, 163, 175, 91,  255, 103, 131, 60,  255, 160, 180,
    104, 255, 182, 196, 114, 255, 196, 209, 113, 255, 179, 193, 111, 255, 189, 196, 124, 255, 204, 211, 137, 255, 210, 221, 145, 255, 197, 217, 153,
    255, 191, 216, 163, 255, 208, 219, 152, 255, 225, 229, 137, 255, 236, 234, 112, 255, 188, 210, 109, 255, 200, 224, 131, 255, 233, 238, 132, 255,
    192, 201, 120, 255, 164, 181, 97,  255, 123, 158, 86,  255, 108, 147, 87,  255, 158, 181, 87,  255, 197, 210, 75,  255, 209, 220, 98,  255, 229,
    232, 131, 255, 212, 213, 117, 255, 202, 205, 100, 255, 202, 214, 111, 255, 175, 204, 116, 255, 167, 195, 105, 255, 201, 221, 110, 255, 103, 124,
    52,  255, 46,  73,  34,  255, 87,  123, 44,  255, 92,  128, 47,  255, 136, 162, 76,  255, 189, 207, 112, 255, 189, 204, 106, 255, 220, 226, 143,
    255, 206, 223, 168, 255, 188, 211, 168, 255, 182, 208, 169, 255, 180, 208, 167, 255, 197, 215, 164, 255, 234, 235, 164, 255, 229, 230, 142, 255,
    189, 201, 99,  255, 170, 191, 89,  255, 164, 188, 107, 255, 150, 170, 60,  255, 156, 176, 65,  255, 134, 166, 81,  255, 133, 166, 91,  255, 122,
    151, 96,  255, 126, 159, 101, 255, 128, 155, 91,  255, 183, 200, 107, 255, 88,  106, 56,  255, 15,  21,  12,  255, 17,  19,  15,  255, 45,  41,
    17,  255, 170, 176, 82,  255, 192, 205, 109, 255, 179, 195, 101, 255, 183, 196, 100, 255, 160, 180, 94,  255, 108, 132, 71,  255, 142, 153, 87,
    255, 139, 151, 87,  255, 132, 150, 77,  255, 169, 184, 105, 255, 180, 195, 114, 255, 185, 195, 123, 255, 170, 182, 123, 255, 112, 133, 65,  255,
    99,  127, 45,  255, 131, 160, 68,  255, 146, 169, 84,  255, 181, 203, 139, 255, 199, 216, 148, 255, 129, 157, 81,  255, 75,  111, 36,  255, 67,
    103, 44,  255, 69,  103, 53,  255, 76,  108, 55,  255, 133, 157, 86,  255, 158, 195, 125, 255, 71,  108, 53,  255, 60,  86,  26,  255, 63,  92,
    31,  255, 74,  105, 34,  255, 79,  109, 33,  255, 71,  101, 31,  255, 60,  87,  33,  255, 71,  104, 42,  255, 75,  116, 50,  255, 80,  121, 55,
    255, 80,  118, 52,  255, 108, 127, 65,  255, 140, 167, 80,  255, 121, 154, 83,  255, 75,  110, 45,  255, 112, 141, 80,  255, 142, 166, 90,  255,
    80,  96,  49,  255, 19,  38,  15,  255, 39,  68,  21,  255, 62,  94,  34,  255, 75,  108, 40,  255, 67,  96,  31,  255, 81,  102, 48,  255, 100,
    113, 71,  255, 62,  76,  44,  255, 26,  47,  17,  255, 81,  100, 49,  255, 128, 156, 94,  255, 105, 135, 93,  255, 113, 139, 100, 255, 112, 143,
    98,  255, 106, 138, 87,  255, 134, 157, 84,  255, 55,  60,  38,  255, 33,  41,  26,  255, 80,  94,  39,  255, 157, 171, 86,  255, 207, 217, 132,
    255, 155, 179, 130, 255, 158, 182, 141, 255, 169, 189, 139, 255, 229, 226, 151, 255, 198, 200, 122, 255, 111, 136, 65,  255, 113, 137, 68,  255,
    81,  99,  52,  255, 36,  53,  23,  255, 36,  53,  23,  255, 47,  68,  26,  255, 79,  106, 34,  255, 122, 148, 49,  255, 73,  80,  36,  255, 21,
    28,  21,  255, 55,  71,  37,  255, 46,  71,  26,  255, 52,  84,  34,  255, 44,  68,  36,  255, 56,  81,  42,  255, 88,  113, 56,  255, 112, 138,
    68,  255, 106, 136, 58,  255, 96,  125, 48,  255, 65,  91,  38,  255, 48,  73,  36,  255, 60,  92,  34,  255, 80,  114, 37,  255, 103, 132, 52,
    255, 62,  82,  36,  255, 29,  41,  21,  255, 33,  37,  26,  255, 21,  25,  21,  255, 31,  37,  21,  255, 45,  55,  29,  255, 62,  69,  40,  255,
    45,  55,  32,  255, 56,  82,  36,  255, 67,  98,  42,  255, 80,  115, 58,  255, 65,  101, 46,  255, 60,  84,  41,  255, 114, 148, 68,  255, 132,
    173, 63,  255, 141, 171, 65,  255, 157, 171, 92,  255, 190, 204, 128, 255, 117, 143, 81,  255, 107, 138, 65,  255, 74,  116, 47,  255, 117, 147,
    63,  255, 113, 136, 65,  255, 162, 179, 100, 255, 186, 200, 108, 255, 178, 199, 108, 255, 177, 202, 121, 255, 189, 213, 127, 255, 124, 136, 74,
    255, 67,  65,  49,  255, 128, 134, 77,  255, 223, 229, 147, 255, 219, 225, 142, 255, 230, 232, 145, 255, 194, 201, 127, 255, 76,  101, 65,  255,
    57,  87,  48,  255, 76,  110, 50,  255, 58,  86,  48,  255, 53,  84,  43,  255, 58,  86,  47,  255, 57,  87,  50,  255, 65,  100, 37,  255, 43,
    62,  25,  255, 43,  55,  31,  255, 17,  21,  19,  255, 15,  17,  17,  255, 28,  39,  23,  255, 41,  60,  29,  255, 39,  60,  31,  255, 67,  92,
    52,  255, 128, 155, 82,  255, 148, 176, 84,  255, 131, 159, 72,  255, 95,  123, 62,  255, 72,  102, 43,  255, 53,  79,  29,  255, 46,  68,  31,
    255, 49,  68,  29,  255, 42,  69,  23,  255, 62,  99,  34,  255, 86,  127, 49,  255, 94,  133, 71,  255, 114, 151, 98,  255, 126, 159, 107, 255,
    152, 181, 107, 255, 190, 210, 116, 255, 165, 177, 84,  255, 65,  84,  31,  255, 47,  68,  31,  255, 109, 129, 60,  255, 138, 161, 71,  255, 83,
    112, 53,  255, 67,  100, 46,  255, 63,  96,  41,  255, 55,  86,  36,  255, 47,  71,  28,  255, 32,  47,  25,  255, 40,  62,  31,  255, 67,  108,
    44,  255, 71,  109, 47,  255, 77,  111, 48,  255, 95,  122, 60,  255, 71,  101, 52,  255, 81,  114, 44,  255, 106, 134, 44,  255, 99,  121, 42,
    255, 185, 196, 127, 255, 145, 177, 137, 255, 152, 178, 132, 255, 116, 138, 82,  255, 171, 183, 104, 255, 130, 152, 74,  255, 107, 139, 41,  255,
    121, 151, 44,  255, 134, 161, 44,  255, 149, 173, 68,  255, 128, 155, 91,  255, 118, 142, 74,  255, 165, 189, 116, 255, 180, 197, 108, 255, 118,
    152, 94,  255, 114, 155, 101, 255, 160, 185, 111, 255, 207, 216, 129, 255, 202, 216, 146, 255, 171, 191, 111, 255, 177, 198, 131, 255, 162, 182,
    121, 255, 147, 167, 109, 255, 192, 201, 120, 255, 188, 196, 115, 255, 199, 212, 138, 255, 202, 213, 129, 255, 223, 229, 142, 255, 204, 222, 142,
    255, 230, 236, 140, 255, 211, 214, 137, 255, 166, 191, 137, 255, 190, 209, 140, 255, 201, 216, 135, 255, 146, 172, 103, 255, 183, 200, 94,  255,
    198, 214, 73,  255, 219, 227, 100, 255, 238, 236, 142, 255, 211, 212, 121, 255, 206, 207, 109, 255, 181, 183, 87,  255, 196, 202, 100, 255, 192,
    209, 106, 255, 210, 229, 130, 255, 110, 123, 52,  255, 34,  49,  17,  255, 82,  101, 42,  255, 120, 149, 72,  255, 142, 165, 79,  255, 197, 211,
    114, 255, 192, 206, 114, 255, 202, 209, 113, 255, 223, 228, 148, 255, 203, 221, 166, 255, 195, 217, 167, 255, 188, 211, 165, 255, 185, 210, 169,
    255, 193, 212, 160, 255, 232, 232, 158, 255, 221, 228, 148, 255, 166, 191, 98,  255, 176, 202, 109, 255, 149, 168, 82,  255, 113, 134, 62,  255,
    120, 149, 71,  255, 141, 175, 95,  255, 132, 164, 102, 255, 120, 152, 102, 255, 138, 163, 96,  255, 178, 196, 107, 255, 120, 141, 74,  255, 76,
    86,  32,  255, 119, 124, 47,  255, 176, 185, 73,  255, 154, 169, 71,  255, 184, 194, 98,  255, 185, 199, 102, 255, 177, 194, 102, 255, 86,  108,
    53,  255, 102, 107, 58,  255, 168, 180, 111, 255, 191, 205, 137, 255, 204, 221, 150, 255, 202, 220, 156, 255, 206, 224, 165, 255, 204, 224, 163,
    255, 215, 236, 183, 255, 215, 231, 175, 255, 186, 203, 132, 255, 148, 170, 84,  255, 121, 145, 65,  255, 174, 192, 110, 255, 140, 159, 87,  255,
    65,  102, 32,  255, 81,  119, 43,  255, 72,  109, 36,  255, 68,  100, 49,  255, 91,  117, 68,  255, 171, 194, 136, 255, 159, 193, 133, 255, 32,
    48,  32,  255, 23,  29,  19,  255, 53,  77,  26,  255, 44,  69,  26,  255, 42,  67,  26,  255, 52,  76,  32,  255, 67,  90,  37,  255, 82,  109,
    40,  255, 90,  127, 50,  255, 81,  118, 58,  255, 89,  129, 69,  255, 95,  126, 69,  255, 120, 142, 71,  255, 150, 177, 84,  255, 103, 136, 68,
    255, 89,  120, 55,  255, 129, 157, 87,  255, 44,  62,  31,  255, 41,  67,  23,  255, 44,  73,  25,  255, 48,  81,  31,  255, 55,  91,  34,  255,
    65,  97,  36,  255, 65,  91,  32,  255, 75,  95,  48,  255, 72,  89,  52,  255, 36,  60,  21,  255, 71,  91,  39,  255, 121, 149, 90,  255, 109,
    139, 98,  255, 115, 144, 105, 255, 109, 141, 95,  255, 114, 145, 87,  255, 140, 162, 84,  255, 94,  102, 63,  255, 71,  77,  50,  255, 131, 143,
    73,  255, 155, 171, 86,  255, 193, 208, 137, 255, 161, 183, 141, 255, 165, 187, 146, 255, 183, 198, 137, 255, 235, 232, 147, 255, 185, 192, 122,
    255, 97,  125, 68,  255, 105, 126, 68,  255, 67,  83,  47,  255, 29,  42,  21,  255, 63,  84,  32,  255, 107, 138, 52,  255, 127, 157, 55,  255,
    144, 169, 55,  255, 153, 162, 60,  255, 55,  63,  31,  255, 60,  89,  39,  255, 92,  120, 47,  255, 69,  91,  44,  255, 47,  65,  43,  255, 47,
    69,  44,  255, 43,  67,  37,  255, 50,  74,  36,  255, 65,  96,  34,  255, 63,  92,  38,  255, 55,  82,  39,  255, 69,  99,  37,  255, 87,  119,
    37,  255, 112, 141, 52,  255, 110, 128, 65,  255, 36,  39,  32,  255, 19,  23,  21,  255, 31,  37,  23,  255, 37,  40,  28,  255, 47,  53,  31,
    255, 48,  58,  29,  255, 65,  68,  37,  255, 80,  98,  37,  255, 101, 137, 49,  255, 109, 146, 87,  255, 105, 143, 95,  255, 69,  106, 52,  255,
    60,  78,  38,  255, 93,  116, 50,  255, 123, 162, 73,  255, 137, 167, 69,  255, 173, 192, 131, 255, 135, 161, 112, 255, 102, 130, 52,  255, 101,
    135, 72,  255, 120, 153, 73,  255, 140, 172, 75,  255, 82,  110, 50,  255, 110, 135, 87,  255, 131, 153, 86,  255, 94,  122, 53,  255, 119, 150,
    67,  255, 135, 165, 74,  255, 151, 174, 84,  255, 105, 113, 63,  255, 185, 194, 123, 255, 227, 232, 150, 255, 225, 229, 141, 255, 192, 203, 122,
    255, 98,  123, 71,  255, 81,  116, 67,  255, 81,  115, 60,  255, 68,  101, 41,  255, 68,  97,  41,  255, 49,  76,  40,  255, 55,  84,  39,  255,
    55,  84,  42,  255, 53,  80,  37,  255, 44,  57,  32,  255, 40,  52,  28,  255, 23,  31,  21,  255, 19,  23,  21,  255, 23,  36,  21,  255, 36,
    55,  29,  255, 39,  60,  38,  255, 40,  60,  32,  255, 65,  96,  38,  255, 62,  81,  38,  255, 42,  62,  29,  255, 55,  89,  37,  255, 46,  76,
    26,  255, 33,  53,  23,  255, 29,  42,  25,  255, 58,  81,  34,  255, 78,  111, 37,  255, 82,  121, 46,  255, 82,  123, 56,  255, 98,  135, 73,
    255, 111, 148, 95,  255, 117, 153, 109, 255, 124, 161, 115, 255, 162, 190, 120, 255, 196, 203, 114, 255, 47,  53,  25,  255, 19,  37,  19,  255,
    26,  49,  19,  255, 92,  121, 47,  255, 131, 158, 69,  255, 103, 131, 68,  255, 77,  105, 58,  255, 55,  86,  42,  255, 46,  74,  32,  255, 34,
    49,  28,  255, 52,  84,  36,  255, 63,  101, 40,  255, 69,  103, 58,  255, 60,  98,  52,  255, 100, 126, 74,  255, 116, 135, 84,  255, 111, 132,
    77,  255, 111, 128, 62,  255, 147, 159, 68,  255, 195, 205, 131, 255, 157, 184, 136, 255, 120, 144, 92,  255, 128, 151, 94,  255, 135, 161, 102,
    255, 122, 152, 81,  255, 122, 148, 52,  255, 149, 172, 53,  255, 145, 168, 50,  255, 139, 157, 58,  255, 86,  109, 44,  255, 82,  102, 42,  255,
    132, 138, 68,  255, 178, 192, 109, 255, 147, 182, 124, 255, 144, 176, 122, 255, 181, 202, 124, 255, 164, 190, 128, 255, 167, 198, 134, 255, 138,
    170, 78,  255, 149, 177, 86,  255, 164, 191, 113, 255, 161, 189, 112, 255, 181, 199, 104, 255, 154, 175, 71,  255, 186, 199, 100, 255, 172, 195,
    120, 255, 192, 208, 142, 255, 222, 229, 146, 255, 210, 218, 131, 255, 174, 198, 130, 255, 171, 199, 136, 255, 169, 197, 139, 255, 197, 214, 134,
    255, 207, 222, 135, 255, 198, 211, 98,  255, 204, 218, 77,  255, 228, 233, 99,  255, 228, 226, 126, 255, 213, 213, 118, 255, 219, 218, 114, 255,
    147, 153, 72,  255, 65,  87,  36,  255, 113, 134, 55,  255, 171, 186, 97,  255, 116, 136, 60,  255, 60,  83,  28,  255, 60,  79,  29,  255, 124,
    150, 80,  255, 127, 149, 75,  255, 179, 191, 96,  255, 214, 221, 121, 255, 201, 212, 115, 255, 212, 216, 123, 255, 229, 231, 154, 255, 216, 227,
    163, 255, 201, 220, 163, 255, 194, 215, 165, 255, 189, 213, 164, 255, 190, 213, 161, 255, 197, 213, 156, 255, 216, 224, 135, 255, 183, 203, 101,
    255, 117, 133, 63,  255, 141, 141, 58,  255, 162, 166, 69,  255, 144, 171, 97,  255, 127, 160, 106, 255, 134, 162, 112, 255, 165, 184, 105, 255,
    167, 188, 104, 255, 138, 163, 75,  255, 170, 190, 74,  255, 179, 201, 81,  255, 208, 216, 86,  255, 155, 171, 74,  255, 111, 136, 56,  255, 171,
    189, 87,  255, 125, 150, 74,  255, 94,  102, 52,  255, 129, 144, 75,  255, 145, 162, 73,  255, 180, 189, 91,  255, 178, 189, 87,  255, 188, 195,
    87,  255, 158, 176, 82,  255, 87,  113, 41,  255, 154, 169, 97,  255, 182, 196, 135, 255, 201, 217, 140, 255, 158, 184, 92,  255, 117, 144, 58,
    255, 143, 162, 80,  255, 121, 138, 69,  255, 72,  103, 36,  255, 72,  100, 36,  255, 87,  123, 38,  255, 75,  115, 40,  255, 105, 125, 58,  255,
    223, 227, 147, 255, 187, 206, 118, 255, 58,  87,  37,  255, 37,  49,  23,  255, 52,  80,  29,  255, 53,  84,  31,  255, 80,  113, 45,  255, 103,
    139, 58,  255, 110, 147, 60,  255, 114, 150, 72,  255, 120, 154, 63,  255, 121, 155, 68,  255, 106, 141, 76,  255, 100, 139, 80,  255, 114, 138,
    83,  255, 154, 176, 87,  255, 119, 150, 71,  255, 76,  112, 41,  255, 71,  97,  46,  255, 36,  52,  21,  255, 55,  84,  31,  255, 49,  77,  26,
    255, 52,  84,  31,  255, 58,  87,  34,  255, 55,  81,  31,  255, 67,  96,  31,  255, 63,  89,  32,  255, 80,  92,  60,  255, 55,  77,  31,  255,
    123, 143, 68,  255, 115, 142, 86,  255, 113, 145, 102, 255, 113, 145, 106, 255, 110, 142, 91,  255, 127, 156, 87,  255, 148, 172, 83,  255, 105,
    127, 69,  255, 92,  98,  65,  255, 146, 160, 84,  255, 132, 152, 77,  255, 170, 191, 141, 255, 159, 182, 143, 255, 163, 187, 145, 255, 170, 192,
    135, 255, 225, 224, 144, 255, 145, 163, 95,  255, 84,  112, 73,  255, 90,  110, 65,  255, 72,  95,  41,  255, 58,  79,  26,  255, 110, 137, 53,
    255, 125, 155, 53,  255, 127, 155, 53,  255, 142, 165, 55,  255, 194, 201, 91,  255, 116, 128, 65,  255, 125, 141, 42,  255, 169, 188, 55,  255,
    140, 165, 47,  255, 103, 127, 43,  255, 65,  89,  47,  255, 53,  82,  46,  255, 63,  87,  37,  255, 62,  87,  42,  255, 75,  102, 52,  255, 94,
    120, 53,  255, 114, 139, 52,  255, 141, 165, 68,  255, 128, 148, 68,  255, 58,  65,  46,  255, 29,  29,  28,  255, 17,  19,  19,  255, 33,  34,
    26,  255, 38,  42,  31,  255, 36,  40,  31,  255, 39,  44,  31,  255, 58,  71,  31,  255, 144, 175, 76,  255, 123, 161, 93,  255, 116, 152, 114,
    255, 109, 144, 101, 255, 79,  111, 55,  255, 91,  114, 55,  255, 137, 166, 80,  255, 134, 167, 65,  255, 159, 187, 87,  255, 148, 177, 131, 255,
    116, 138, 84,  255, 156, 180, 119, 255, 137, 171, 116, 255, 161, 187, 83,  255, 137, 168, 83,  255, 111, 129, 75,  255, 74,  90,  65,  255, 71,
    96,  52,  255, 76,  89,  53,  255, 40,  65,  28,  255, 62,  96,  36,  255, 80,  107, 53,  255, 135, 150, 91,  255, 185, 193, 129, 255, 206, 217,
    140, 255, 144, 169, 106, 255, 146, 173, 94,  255, 67,  78,  44,  255, 37,  53,  33,  255, 44,  65,  36,  255, 34,  47,  26,  255, 41,  60,  26,
    255, 60,  90,  37,  255, 57,  84,  42,  255, 51,  81,  36,  255, 47,  68,  31,  255, 43,  58,  31,  255, 37,  56,  25,  255, 42,  65,  25,  255,
    42,  62,  26,  255, 32,  46,  23,  255, 33,  52,  26,  255, 49,  75,  32,  255, 58,  87,  31,  255, 49,  71,  28,  255, 41,  58,  31,  255, 46,
    71,  39,  255, 44,  74,  36,  255, 62,  99,  38,  255, 48,  76,  33,  255, 36,  52,  26,  255, 49,  76,  28,  255, 81,  118, 36,  255, 129, 158,
    49,  255, 104, 139, 48,  255, 120, 156, 68,  255, 127, 161, 84,  255, 125, 158, 91,  255, 132, 166, 101, 255, 175, 199, 112, 255, 192, 206, 109,
    255, 67,  77,  36,  255, 31,  48,  21,  255, 40,  62,  25,  255, 28,  47,  21,  255, 53,  76,  36,  255, 97,  129, 55,  255, 80,  116, 47,  255,
    58,  97,  36,  255, 49,  83,  37,  255, 51,  80,  37,  255, 77,  118, 45,  255, 89,  133, 47,  255, 90,  131, 58,  255, 83,  118, 74,  255, 82,
    117, 65,  255, 108, 142, 63,  255, 80,  97,  41,  255, 128, 144, 77,  255, 187, 199, 110, 255, 197, 210, 130, 255, 132, 159, 103, 255, 116, 139,
    80,  255, 128, 158, 103, 255, 128, 162, 93,  255, 139, 162, 74,  255, 148, 175, 76,  255, 151, 178, 69,  255, 146, 167, 62,  255, 112, 130, 56,
    255, 86,  120, 39,  255, 58,  95,  25,  255, 44,  75,  12,  255, 149, 165, 84,  255, 163, 191, 127, 255, 158, 186, 130, 255, 170, 192, 124, 255,
    164, 188, 110, 255, 181, 199, 107, 255, 136, 166, 65,  255, 142, 171, 71,  255, 177, 197, 111, 255, 157, 186, 103, 255, 130, 169, 73,  255, 153,
    188, 75,  255, 178, 198, 100, 255, 113, 126, 56,  255, 161, 179, 92,  255, 201, 214, 110, 255, 212, 218, 112, 255, 219, 224, 113, 255, 205, 211,
    95,  255, 185, 192, 81,  255, 179, 185, 75,  255, 218, 229, 93,  255, 203, 218, 89,  255, 208, 221, 84,  255, 225, 227, 97,  255, 216, 214, 112,
    255, 219, 219, 121, 255, 227, 223, 121, 255, 158, 166, 78,  255, 83,  116, 45,  255, 94,  126, 62,  255, 73,  107, 44,  255, 84,  119, 48,  255,
    113, 143, 60,  255, 94,  122, 44,  255, 100, 124, 55,  255, 101, 130, 53,  255, 91,  118, 36,  255, 186, 190, 86,  255, 220, 225, 117, 255, 208,
    217, 113, 255, 213, 218, 129, 255, 225, 228, 147, 255, 211, 226, 161, 255, 198, 220, 157, 255, 197, 218, 158, 255, 197, 217, 166, 255, 184, 207,
    161, 255, 193, 207, 139, 255, 174, 189, 87,  255, 198, 215, 115, 255, 230, 229, 112, 255, 253, 241, 127, 255, 239, 235, 142, 255, 159, 181, 125,
    255, 133, 164, 111, 255, 164, 188, 106, 255, 145, 171, 82,  255, 152, 179, 77,  255, 160, 187, 82,  255, 178, 194, 84,  255, 169, 186, 87,  255,
    111, 139, 67,  255, 73,  112, 41,  255, 109, 132, 56,  255, 122, 134, 69,  255, 144, 153, 68,  255, 155, 167, 79,  255, 195, 193, 89,  255, 231,
    225, 104, 255, 215, 211, 97,  255, 160, 170, 71,  255, 87,  116, 34,  255, 86,  101, 39,  255, 90,  102, 43,  255, 65,  84,  15,  255, 193, 194,
    101, 255, 201, 222, 146, 255, 179, 206, 132, 255, 213, 224, 139, 255, 154, 176, 89,  255, 78,  111, 37,  255, 77,  112, 41,  255, 86,  125, 43,
    255, 93,  129, 47,  255, 85,  112, 44,  255, 165, 173, 90,  255, 169, 193, 89,  255, 73,  114, 34,  255, 58,  87,  32,  255, 58,  87,  26,  255,
    87,  124, 42,  255, 82,  122, 52,  255, 81,  120, 56,  255, 83,  117, 60,  255, 87,  120, 68,  255, 99,  129, 68,  255, 136, 167, 79,  255, 151,
    176, 83,  255, 166, 186, 102, 255, 135, 160, 101, 255, 140, 155, 96,  255, 109, 130, 55,  255, 65,  92,  33,  255, 55,  77,  31,  255, 41,  56,
    23,  255, 58,  91,  32,  255, 57,  92,  31,  255, 65,  94,  33,  255, 80,  106, 45,  255, 71,  96,  44,  255, 75,  102, 47,  255, 71,  103, 40,
    255, 77,  99,  49,  255, 81,  90,  52,  255, 149, 170, 89,  255, 111, 138, 83,  255, 112, 145, 101, 255, 117, 150, 107, 255, 105, 141, 91,  255,
    127, 154, 89,  255, 132, 157, 68,  255, 97,  124, 47,  255, 76,  86,  44,  255, 141, 159, 80,  255, 109, 138, 73,  255, 157, 181, 144, 255, 161,
    186, 147, 255, 154, 182, 138, 255, 183, 198, 135, 255, 211, 214, 127, 255, 131, 156, 62,  255, 83,  115, 65,  255, 82,  105, 58,  255, 74,  100,
    42,  255, 114, 141, 55,  255, 131, 155, 62,  255, 113, 140, 56,  255, 117, 143, 55,  255, 164, 176, 81,  255, 101, 108, 62,  255, 78,  93,  45,
    255, 200, 204, 82,  255, 192, 204, 62,  255, 167, 185, 53,  255, 150, 174, 50,  255, 127, 153, 48,  255, 89,  117, 47,  255, 63,  90,  39,  255,
    80,  105, 49,  255, 132, 154, 74,  255, 155, 175, 80,  255, 156, 173, 83,  255, 109, 125, 62,  255, 39,  52,  31,  255, 36,  39,  36,  255, 23,
    25,  23,  255, 19,  21,  19,  255, 36,  38,  28,  255, 39,  47,  28,  255, 32,  38,  26,  255, 21,  26,  21,  255, 75,  100, 39,  255, 167, 192,
    109, 255, 130, 165, 121, 255, 127, 162, 124, 255, 121, 156, 117, 255, 102, 133, 77,  255, 55,  76,  33,  255, 67,  90,  44,  255, 154, 179, 106,
    255, 143, 178, 82,  255, 125, 153, 95,  255, 133, 157, 99,  255, 154, 189, 134, 255, 144, 178, 109, 255, 142, 166, 87,  255, 97,  134, 71,  255,
    88,  98,  68,  255, 50,  58,  38,  255, 21,  38,  19,  255, 58,  84,  47,  255, 88,  103, 63,  255, 94,  113, 68,  255, 62,  80,  45,  255, 104,
    111, 78,  255, 180, 184, 134, 255, 150, 172, 110, 255, 114, 148, 97,  255, 154, 179, 102, 255, 52,  60,  34,  255, 9,   15,  15,  255, 26,  38,
    21,  255, 34,  48,  26,  255, 37,  52,  29,  255, 34,  52,  26,  255, 46,  71,  33,  255, 50,  75,  36,  255, 48,  60,  33,  255, 46,  68,  33,
    255, 51,  82,  46,  255, 63,  102, 47,  255, 67,  107, 43,  255, 63,  100, 40,  255, 52,  82,  31,  255, 60,  98,  29,  255, 73,  103, 37,  255,
    40,  53,  26,  255, 31,  52,  31,  255, 47,  75,  42,  255, 43,  67,  37,  255, 52,  84,  37,  255, 65,  98,  40,  255, 53,  77,  31,  255, 55,
    87,  29,  255, 44,  80,  23,  255, 115, 145, 43,  255, 188, 204, 69,  255, 188, 202, 83,  255, 183, 201, 94,  255, 193, 207, 95,  255, 170, 183,
    92,  255, 125, 145, 68,  255, 60,  90,  34,  255, 47,  75,  32,  255, 47,  72,  36,  255, 40,  60,  36,  255, 40,  62,  31,  255, 102, 124, 62,
    255, 116, 149, 68,  255, 94,  136, 49,  255, 84,  123, 38,  255, 43,  62,  26,  255, 73,  102, 43,  255, 114, 157, 62,  255, 127, 169, 76,  255,
    127, 170, 71,  255, 120, 159, 62,  255, 108, 145, 55,  255, 123, 149, 73,  255, 163, 183, 97,  255, 196, 210, 114, 255, 156, 179, 108, 255, 151,
    167, 100, 255, 112, 135, 62,  255, 138, 168, 79,  255, 138, 173, 77,  255, 153, 182, 76,  255, 181, 197, 80,  255, 175, 196, 87,  255, 133, 168,
    76,  255, 138, 171, 84,  255, 143, 172, 75,  255, 196, 214, 73,  255, 127, 147, 45,  255, 43,  73,  17,  255, 125, 138, 63,  255, 170, 195, 127,
    255, 145, 178, 130, 255, 136, 171, 121, 255, 141, 171, 110, 255, 164, 183, 109, 255, 130, 159, 84,  255, 144, 171, 96,  255, 141, 175, 98,  255,
    118, 162, 60,  255, 150, 183, 74,  255, 130, 148, 65,  255, 71,  82,  31,  255, 153, 172, 108, 255, 214, 222, 122, 255, 217, 223, 113, 255, 216,
    219, 113, 255, 218, 221, 117, 255, 221, 223, 117, 255, 215, 220, 112, 255, 214, 218, 111, 255, 213, 220, 100, 255, 204, 218, 87,  255, 213, 224,
    98,  255, 215, 214, 106, 255, 218, 216, 117, 255, 224, 222, 123, 255, 230, 227, 123, 255, 120, 121, 52,  255, 71,  89,  33,  255, 133, 158, 72,
    255, 104, 134, 68,  255, 97,  126, 62,  255, 118, 144, 72,  255, 128, 150, 63,  255, 87,  115, 47,  255, 84,  120, 42,  255, 67,  106, 33,  255,
    68,  99,  26,  255, 149, 160, 67,  255, 210, 215, 106, 255, 216, 224, 117, 255, 201, 210, 119, 255, 203, 208, 120, 255, 220, 223, 136, 255, 215,
    225, 132, 255, 220, 226, 109, 255, 202, 217, 109, 255, 188, 208, 121, 255, 168, 181, 98,  255, 174, 193, 86,  255, 202, 213, 92,  255, 245, 238,
    141, 255, 255, 255, 175, 255, 212, 222, 160, 255, 120, 148, 84,  255, 130, 159, 76,  255, 138, 169, 76,  255, 161, 186, 87,  255, 152, 175, 78,
    255, 141, 164, 68,  255, 129, 154, 77,  255, 109, 141, 69,  255, 102, 130, 55,  255, 104, 117, 58,  255, 74,  92,  52,  255, 58,  75,  34,  255,
    108, 119, 58,  255, 147, 153, 81,  255, 143, 147, 86,  255, 79,  92,  52,  255, 58,  74,  28,  255, 78,  104, 34,  255, 135, 145, 71,  255, 198,
    210, 145, 255, 153, 171, 95,  255, 174, 176, 96,  255, 225, 232, 161, 255, 219, 236, 181, 255, 191, 204, 146, 255, 93,  124, 41,  255, 112, 148,
    49,  255, 100, 135, 52,  255, 74,  111, 45,  255, 84,  121, 42,  255, 108, 139, 47,  255, 117, 140, 55,  255, 123, 154, 60,  255, 72,  108, 34,
    255, 69,  99,  32,  255, 89,  125, 42,  255, 90,  129, 49,  255, 89,  126, 58,  255, 84,  119, 60,  255, 83,  118, 65,  255, 86,  122, 67,  255,
    99,  131, 63,  255, 123, 153, 71,  255, 97,  125, 48,  255, 185, 194, 113, 255, 204, 222, 125, 255, 154, 171, 89,  255, 150, 177, 74,  255, 146,
    173, 69,  255, 145, 168, 68,  255, 149, 167, 67,  255, 115, 140, 53,  255, 31,  52,  25,  255, 52,  65,  29,  255, 101, 125, 62,  255, 113, 132,
    74,  255, 93,  114, 68,  255, 73,  102, 50,  255, 74,  106, 45,  255, 89,  106, 58,  255, 156, 175, 95,  255, 116, 142, 80,  255, 109, 144, 99,
    255, 115, 147, 102, 255, 144, 163, 91,  255, 172, 187, 86,  255, 144, 170, 65,  255, 104, 128, 49,  255, 80,  83,  58,  255, 113, 133, 63,  255,
    106, 135, 68,  255, 151, 178, 138, 255, 156, 183, 138, 255, 179, 197, 133, 255, 198, 207, 123, 255, 111, 136, 68,  255, 89,  118, 44,  255, 93,
    119, 47,  255, 71,  92,  44,  255, 74,  103, 36,  255, 119, 148, 58,  255, 110, 135, 56,  255, 128, 147, 62,  255, 160, 172, 76,  255, 87,  106,
    52,  255, 38,  60,  26,  255, 92,  112, 55,  255, 171, 181, 98,  255, 174, 184, 74,  255, 188, 198, 73,  255, 184, 194, 68,  255, 170, 187, 65,
    255, 155, 173, 68,  255, 84,  100, 48,  255, 19,  29,  21,  255, 48,  62,  34,  255, 60,  80,  41,  255, 45,  60,  36,  255, 26,  37,  23,  255,
    28,  38,  25,  255, 36,  37,  32,  255, 17,  19,  19,  255, 23,  26,  23,  255, 34,  39,  26,  255, 52,  60,  33,  255, 34,  39,  26,  255, 34,
    47,  25,  255, 67,  94,  40,  255, 139, 160, 90,  255, 163, 190, 127, 255, 138, 172, 129, 255, 143, 176, 119, 255, 121, 151, 80,  255, 40,  53,
    26,  255, 71,  80,  52,  255, 176, 194, 137, 255, 152, 173, 119, 255, 111, 138, 65,  255, 143, 172, 97,  255, 130, 168, 96,  255, 107, 140, 67,
    255, 69,  108, 43,  255, 60,  91,  38,  255, 60,  65,  48,  255, 49,  60,  36,  255, 39,  63,  29,  255, 32,  52,  31,  255, 78,  100, 62,  255,
    103, 125, 73,  255, 42,  55,  31,  255, 94,  104, 68,  255, 163, 167, 113, 255, 144, 165, 106, 255, 121, 152, 102, 255, 146, 163, 98,  255, 29,
    32,  21,  255, 32,  43,  25,  255, 52,  82,  34,  255, 47,  68,  32,  255, 43,  58,  36,  255, 25,  36,  23,  255, 36,  52,  26,  255, 60,  74,
    41,  255, 47,  62,  32,  255, 52,  83,  46,  255, 62,  92,  60,  255, 67,  98,  60,  255, 63,  96,  56,  255, 65,  102, 55,  255, 72,  109, 41,
    255, 53,  82,  29,  255, 67,  103, 39,  255, 62,  84,  38,  255, 17,  26,  19,  255, 26,  43,  23,  255, 26,  40,  23,  255, 39,  56,  23,  255,
    67,  94,  36,  255, 53,  76,  36,  255, 44,  63,  34,  255, 40,  60,  31,  255, 49,  83,  32,  255, 78,  101, 38,  255, 100, 116, 48,  255, 110,
    128, 53,  255, 71,  81,  38,  255, 49,  72,  33,  255, 38,  69,  23,  255, 38,  60,  31,  255, 38,  55,  36,  255, 40,  60,  37,  255, 38,  60,
    34,  255, 81,  108, 50,  255, 133, 158, 68,  255, 137, 163, 67,  255, 128, 157, 65,  255, 60,  84,  32,  255, 26,  39,  25,  255, 56,  74,  34,
    255, 111, 139, 60,  255, 116, 139, 68,  255, 115, 135, 58,  255, 115, 132, 50,  255, 88,  104, 36,  255, 152, 165, 87,  255, 198, 212, 115, 255,
    176, 193, 111, 255, 143, 167, 104, 255, 136, 160, 79,  255, 121, 157, 68,  255, 121, 162, 67,  255, 114, 157, 74,  255, 122, 160, 79,  255, 197,
    208, 101, 255, 185, 203, 93,  255, 133, 171, 82,  255, 142, 176, 87,  255, 147, 177, 71,  255, 216, 222, 84,  255, 195, 202, 113, 255, 142, 160,
    96,  255, 141, 155, 83,  255, 170, 192, 115, 255, 164, 190, 104, 255, 164, 191, 93,  255, 159, 186, 95,  255, 172, 191, 98,  255, 146, 170, 90,
    255, 121, 157, 68,  255, 129, 167, 65,  255, 147, 178, 65,  255, 148, 168, 76,  255, 104, 131, 68,  255, 108, 136, 91,  255, 135, 156, 89,  255,
    192, 191, 100, 255, 241, 241, 136, 255, 230, 234, 136, 255, 222, 227, 132, 255, 222, 225, 126, 255, 220, 224, 124, 255, 219, 223, 121, 255, 219,
    221, 122, 255, 208, 215, 112, 255, 201, 205, 106, 255, 216, 213, 115, 255, 222, 220, 120, 255, 227, 224, 122, 255, 228, 223, 121, 255, 90,  93,
    47,  255, 17,  25,  9,   255, 116, 129, 52,  255, 139, 161, 76,  255, 108, 136, 73,  255, 135, 159, 76,  255, 139, 160, 67,  255, 103, 133, 58,
    255, 99,  137, 60,  255, 87,  123, 47,  255, 77,  113, 40,  255, 65,  103, 33,  255, 92,  109, 40,  255, 157, 164, 65,  255, 174, 189, 76,  255,
    136, 149, 68,  255, 151, 162, 75,  255, 214, 220, 115, 255, 207, 220, 105, 255, 203, 216, 98,  255, 200, 213, 122, 255, 183, 195, 110, 255, 192,
    199, 87,  255, 203, 211, 94,  255, 213, 219, 122, 255, 181, 197, 133, 255, 135, 154, 92,  255, 123, 135, 56,  255, 147, 164, 75,  255, 157, 182,
    94,  255, 125, 156, 84,  255, 77,  115, 49,  255, 100, 129, 43,  255, 144, 165, 84,  255, 135, 158, 81,  255, 98,  114, 58,  255, 41,  56,  33,
    255, 23,  36,  21,  255, 19,  31,  17,  255, 80,  95,  49,  255, 56,  79,  38,  255, 17,  25,  12,  255, 6,   12,  12,  255, 29,  37,  21,  255,
    85,  101, 47,  255, 95,  109, 36,  255, 176, 189, 115, 255, 185, 211, 156, 255, 193, 213, 158, 255, 182, 205, 147, 255, 182, 198, 140, 255, 147,
    165, 105, 255, 121, 138, 76,  255, 94,  117, 52,  255, 121, 147, 58,  255, 138, 163, 77,  255, 131, 158, 74,  255, 94,  128, 45,  255, 92,  123,
    60,  255, 105, 137, 68,  255, 69,  101, 37,  255, 77,  110, 44,  255, 41,  65,  29,  255, 45,  60,  26,  255, 95,  119, 55,  255, 109, 141, 67,
    255, 106, 140, 67,  255, 104, 139, 63,  255, 107, 143, 60,  255, 122, 152, 65,  255, 105, 133, 63,  255, 68,  86,  58,  255, 90,  109, 55,  255,
    154, 178, 68,  255, 125, 160, 58,  255, 151, 177, 68,  255, 176, 202, 86,  255, 187, 210, 87,  255, 134, 151, 65,  255, 15,  21,  19,  255, 41,
    46,  23,  255, 160, 173, 87,  255, 191, 210, 112, 255, 153, 174, 103, 255, 81,  106, 67,  255, 71,  102, 53,  255, 71,  99,  48,  255, 136, 154,
    83,  255, 134, 160, 86,  255, 108, 143, 100, 255, 119, 150, 104, 255, 213, 212, 106, 255, 223, 226, 92,  255, 188, 207, 81,  255, 154, 177, 74,
    255, 112, 124, 74,  255, 88,  114, 52,  255, 92,  125, 56,  255, 141, 171, 119, 255, 164, 189, 116, 255, 142, 160, 91,  255, 62,  82,  36,  255,
    58,  83,  32,  255, 42,  60,  26,  255, 68,  77,  47,  255, 110, 119, 58,  255, 162, 166, 77,  255, 151, 164, 74,  255, 159, 171, 74,  255, 152,
    165, 75,  255, 72,  92,  45,  255, 39,  68,  26,  255, 62,  87,  38,  255, 76,  106, 52,  255, 60,  92,  48,  255, 55,  86,  41,  255, 97,  125,
    50,  255, 122, 147, 58,  255, 122, 142, 53,  255, 119, 138, 58,  255, 74,  83,  46,  255, 12,  15,  17,  255, 21,  31,  23,  255, 26,  38,  25,
    255, 28,  41,  26,  255, 32,  47,  28,  255, 31,  41,  26,  255, 37,  38,  31,  255, 19,  21,  19,  255, 29,  29,  26,  255, 31,  32,  26,  255,
    32,  34,  29,  255, 15,  17,  17,  255, 34,  48,  28,  255, 62,  87,  46,  255, 107, 121, 62,  255, 192, 209, 128, 255, 172, 187, 125, 255, 154,
    167, 86,  255, 144, 167, 93,  255, 125, 143, 69,  255, 132, 157, 63,  255, 142, 172, 102, 255, 115, 140, 90,  255, 108, 139, 58,  255, 126, 157,
    68,  255, 139, 167, 73,  255, 111, 132, 60,  255, 75,  109, 44,  255, 60,  87,  36,  255, 69,  73,  52,  255, 50,  62,  38,  255, 31,  52,  25,
    255, 63,  84,  47,  255, 69,  84,  52,  255, 76,  105, 56,  255, 76,  86,  55,  255, 69,  78,  49,  255, 151, 165, 101, 255, 133, 161, 100, 255,
    124, 156, 100, 255, 90,  104, 60,  255, 31,  43,  23,  255, 65,  94,  40,  255, 57,  87,  41,  255, 55,  91,  36,  255, 48,  68,  32,  255, 21,
    33,  21,  255, 40,  56,  31,  255, 67,  75,  46,  255, 58,  82,  36,  255, 58,  92,  47,  255, 63,  96,  55,  255, 69,  100, 62,  255, 72,  100,
    68,  255, 77,  103, 75,  255, 105, 133, 76,  255, 73,  94,  44,  255, 65,  99,  36,  255, 58,  74,  34,  255, 19,  29,  21,  255, 19,  28,  19,
    255, 15,  19,  17,  255, 63,  87,  40,  255, 65,  87,  40,  255, 60,  83,  55,  255, 60,  82,  49,  255, 52,  80,  38,  255, 65,  94,  36,  255,
    47,  62,  29,  255, 41,  62,  29,  255, 41,  60,  31,  255, 12,  12,  15,  255, 38,  58,  31,  255, 47,  72,  36,  255, 38,  56,  36,  255, 40,
    60,  37,  255, 47,  74,  36,  255, 53,  90,  33,  255, 74,  104, 47,  255, 63,  92,  43,  255, 85,  115, 44,  255, 101, 128, 55,  255, 96,  132,
    53,  255, 63,  97,  37,  255, 60,  92,  36,  255, 58,  87,  36,  255, 23,  25,  21,  255, 26,  33,  21,  255, 34,  48,  23,  255, 110, 131, 68,
    255, 199, 214, 121, 255, 179, 196, 110, 255, 157, 178, 104, 255, 161, 184, 86,  255, 131, 170, 74,  255, 119, 160, 71,  255, 126, 166, 81,  255,
    121, 163, 82,  255, 120, 162, 86,  255, 167, 187, 111, 255, 193, 207, 104, 255, 151, 182, 84,  255, 150, 183, 94,  255, 156, 186, 80,  255, 216,
    220, 107, 255, 201, 207, 125, 255, 213, 217, 126, 255, 214, 220, 125, 255, 201, 215, 121, 255, 168, 196, 87,  255, 146, 184, 65,  255, 140, 179,
    60,  255, 150, 181, 76,  255, 135, 158, 69,  255, 121, 149, 67,  255, 127, 153, 80,  255, 122, 151, 91,  255, 119, 151, 101, 255, 119, 154, 103,
    255, 124, 160, 100, 255, 87,  119, 49,  255, 60,  91,  38,  255, 153, 156, 79,  255, 230, 225, 127, 255, 249, 246, 146, 255, 245, 243, 143, 255,
    233, 235, 138, 255, 230, 233, 127, 255, 227, 231, 110, 255, 221, 231, 97,  255, 207, 214, 91,  255, 211, 212, 108, 255, 218, 221, 109, 255, 224,
    227, 121, 255, 235, 234, 133, 255, 238, 234, 139, 255, 178, 179, 111, 255, 128, 133, 74,  255, 163, 177, 87,  255, 141, 161, 87,  255, 161, 180,
    89,  255, 143, 157, 67,  255, 79,  101, 36,  255, 91,  114, 48,  255, 94,  124, 49,  255, 94,  127, 49,  255, 85,  111, 45,  255, 45,  67,  23,
    255, 65,  94,  31,  255, 120, 134, 58,  255, 138, 143, 72,  255, 149, 173, 80,  255, 187, 206, 114, 255, 203, 210, 108, 255, 199, 200, 84,  255,
    184, 195, 96,  255, 171, 188, 98,  255, 172, 184, 97,  255, 157, 178, 101, 255, 117, 154, 84,  255, 94,  133, 60,  255, 96,  125, 48,  255, 76,
    107, 36,  255, 84,  114, 39,  255, 113, 144, 69,  255, 89,  122, 76,  255, 72,  104, 48,  255, 106, 133, 50,  255, 134, 158, 86,  255, 78,  98,
    50,  255, 23,  37,  19,  255, 17,  26,  15,  255, 26,  39,  21,  255, 37,  47,  21,  255, 96,  113, 58,  255, 88,  105, 47,  255, 125, 130, 60,
    255, 91,  93,  55,  255, 91,  96,  55,  255, 134, 147, 67,  255, 163, 180, 101, 255, 176, 200, 149, 255, 174, 202, 163, 255, 148, 182, 140, 255,
    119, 152, 87,  255, 161, 183, 116, 255, 131, 151, 72,  255, 100, 122, 65,  255, 65,  92,  48,  255, 60,  89,  40,  255, 114, 138, 60,  255, 120,
    148, 74,  255, 58,  80,  34,  255, 101, 131, 78,  255, 67,  95,  47,  255, 52,  79,  31,  255, 40,  62,  31,  255, 25,  39,  23,  255, 12,  15,
    17,  255, 15,  17,  19,  255, 26,  32,  23,  255, 57,  84,  33,  255, 72,  109, 42,  255, 69,  101, 47,  255, 63,  96,  47,  255, 63,  89,  50,
    255, 37,  58,  32,  255, 31,  48,  26,  255, 91,  107, 48,  255, 149, 168, 81,  255, 152, 173, 84,  255, 123, 138, 69,  255, 95,  115, 50,  255,
    47,  62,  32,  255, 9,   12,  15,  255, 74,  80,  39,  255, 185, 208, 107, 255, 178, 201, 108, 255, 185, 204, 116, 255, 122, 143, 96,  255, 85,
    112, 77,  255, 65,  95,  56,  255, 94,  116, 58,  255, 140, 167, 86,  255, 108, 141, 97,  255, 119, 152, 111, 255, 197, 198, 109, 255, 245, 235,
    103, 255, 210, 216, 89,  255, 169, 194, 89,  255, 158, 186, 92,  255, 123, 149, 69,  255, 100, 125, 52,  255, 132, 161, 84,  255, 108, 139, 65,
    255, 76,  97,  45,  255, 94,  112, 43,  255, 80,  107, 41,  255, 67,  95,  36,  255, 115, 129, 55,  255, 168, 182, 84,  255, 148, 163, 63,  255,
    132, 144, 62,  255, 93,  111, 53,  255, 48,  74,  41,  255, 46,  76,  36,  255, 49,  75,  39,  255, 58,  79,  39,  255, 67,  99,  41,  255, 58,
    92,  33,  255, 67,  105, 32,  255, 63,  96,  34,  255, 49,  73,  36,  255, 52,  81,  33,  255, 60,  87,  33,  255, 55,  67,  36,  255, 23,  29,
    21,  255, 26,  37,  25,  255, 31,  44,  26,  255, 32,  46,  28,  255, 32,  44,  28,  255, 28,  37,  26,  255, 42,  43,  36,  255, 26,  26,  25,
    255, 40,  40,  32,  255, 39,  41,  32,  255, 25,  26,  25,  255, 12,  15,  15,  255, 29,  39,  23,  255, 68,  96,  47,  255, 159, 169, 89,  255,
    183, 198, 94,  255, 135, 163, 67,  255, 137, 166, 65,  255, 133, 165, 65,  255, 103, 150, 45,  255, 87,  135, 41,  255, 102, 141, 69,  255, 110,
    143, 62,  255, 124, 153, 65,  255, 110, 140, 62,  255, 137, 157, 78,  255, 85,  100, 49,  255, 36,  58,  25,  255, 44,  71,  26,  255, 74,  84,
    50,  255, 53,  68,  38,  255, 50,  69,  33,  255, 107, 131, 71,  255, 88,  115, 60,  255, 39,  53,  31,  255, 39,  52,  33,  255, 82,  91,  62,
    255, 134, 147, 97,  255, 130, 161, 106, 255, 111, 139, 87,  255, 41,  58,  25,  255, 63,  92,  38,  255, 67,  100, 47,  255, 53,  83,  46,  255,
    58,  99,  38,  255, 58,  89,  33,  255, 26,  31,  23,  255, 32,  40,  29,  255, 55,  68,  33,  255, 96,  121, 58,  255, 113, 142, 75,  255, 86,
    118, 67,  255, 75,  108, 74,  255, 80,  112, 80,  255, 114, 141, 90,  255, 120, 145, 83,  255, 69,  91,  45,  255, 79,  105, 39,  255, 39,  51,
    23,  255, 28,  40,  21,  255, 17,  26,  19,  255, 23,  34,  23,  255, 71,  95,  44,  255, 58,  80,  48,  255, 65,  89,  63,  255, 60,  86,  52,
    255, 89,  120, 52,  255, 87,  105, 47,  255, 37,  48,  26,  255, 47,  69,  28,  255, 31,  39,  23,  255, 19,  26,  21,  255, 52,  75,  40,  255,
    47,  68,  41,  255, 44,  65,  38,  255, 55,  87,  37,  255, 60,  98,  38,  255, 90,  120, 55,  255, 87,  103, 52,  255, 83,  103, 47,  255, 98,
    122, 52,  255, 71,  95,  50,  255, 65,  92,  36,  255, 74,  109, 42,  255, 72,  110, 36,  255, 75,  113, 38,  255, 46,  69,  36,  255, 26,  38,
    26,  255, 79,  100, 44,  255, 173, 192, 103, 255, 194, 209, 116, 255, 203, 213, 110, 255, 203, 208, 103, 255, 189, 202, 84,  255, 141, 177, 75,
    255, 126, 165, 75,  255, 121, 162, 75,  255, 132, 169, 91,  255, 132, 172, 106, 255, 132, 169, 110, 255, 200, 208, 119, 255, 200, 216, 108, 255,
    171, 199, 113, 255, 183, 205, 108, 255, 172, 185, 123, 255, 139, 166, 116, 255, 140, 165, 110, 255, 162, 181, 114, 255, 202, 213, 131, 255, 185,
    210, 114, 255, 180, 206, 100, 255, 185, 209, 96,  255, 139, 159, 67,  255, 101, 128, 52,  255, 117, 145, 75,  255, 123, 156, 95,  255, 124, 160,
    92,  255, 128, 163, 86,  255, 128, 156, 75,  255, 106, 129, 58,  255, 85,  109, 42,  255, 81,  114, 49,  255, 58,  90,  44,  255, 103, 127, 58,
    255, 159, 161, 76,  255, 189, 180, 96,  255, 238, 230, 125, 255, 248, 245, 128, 255, 243, 241, 121, 255, 235, 238, 95,  255, 241, 239, 110, 255,
    211, 216, 99,  255, 221, 231, 99,  255, 227, 233, 121, 255, 235, 235, 136, 255, 245, 241, 146, 255, 255, 254, 156, 255, 255, 250, 157, 255, 230,
    226, 136, 255, 207, 205, 107, 255, 211, 208, 111, 255, 205, 201, 110, 255, 143, 146, 76,  255, 58,  69,  31,  255, 47,  60,  26,  255, 53,  68,
    28,  255, 40,  58,  23,  255, 29,  43,  19,  255, 60,  73,  34,  255, 139, 148, 72,  255, 161, 171, 87,  255, 150, 170, 91,  255, 141, 163, 75,
    255, 178, 192, 90,  255, 184, 192, 78,  255, 132, 163, 68,  255, 152, 169, 84,  255, 137, 164, 89,  255, 145, 173, 93,  255, 146, 179, 92,  255,
    160, 191, 87,  255, 165, 195, 83,  255, 89,  121, 48,  255, 47,  71,  23,  255, 79,  105, 39,  255, 97,  129, 68,  255, 74,  105, 52,  255, 93,
    125, 38,  255, 109, 134, 52,  255, 90,  106, 40,  255, 109, 121, 45,  255, 95,  105, 45,  255, 33,  41,  25,  255, 33,  39,  21,  255, 96,  114,
    60,  255, 52,  72,  38,  255, 40,  51,  31,  255, 53,  60,  40,  255, 78,  86,  45,  255, 157, 176, 129, 255, 175, 203, 171, 255, 140, 175, 144,
    255, 121, 152, 114, 255, 140, 168, 106, 255, 158, 184, 105, 255, 184, 212, 165, 255, 153, 181, 112, 255, 73,  96,  42,  255, 52,  81,  36,  255,
    60,  91,  36,  255, 63,  98,  36,  255, 52,  81,  36,  255, 73,  96,  49,  255, 86,  118, 67,  255, 52,  80,  36,  255, 41,  69,  31,  255, 38,
    62,  29,  255, 31,  47,  25,  255, 23,  34,  23,  255, 25,  37,  25,  255, 29,  40,  23,  255, 52,  86,  34,  255, 47,  79,  34,  255, 52,  82,
    39,  255, 49,  75,  44,  255, 47,  73,  42,  255, 49,  76,  41,  255, 50,  75,  39,  255, 75,  104, 40,  255, 97,  129, 52,  255, 110, 137, 65,
    255, 75,  98,  49,  255, 49,  65,  36,  255, 43,  68,  29,  255, 58,  67,  31,  255, 168, 183, 95,  255, 181, 204, 114, 255, 174, 196, 111, 255,
    189, 208, 117, 255, 155, 177, 105, 255, 103, 130, 90,  255, 94,  121, 87,  255, 67,  89,  53,  255, 114, 137, 74,  255, 110, 141, 92,  255, 124,
    159, 110, 255, 194, 202, 119, 255, 255, 248, 138, 255, 226, 223, 122, 255, 197, 204, 117, 255, 204, 207, 106, 255, 189, 198, 96,  255, 161, 174,
    87,  255, 111, 136, 63,  255, 96,  118, 53,  255, 134, 147, 71,  255, 115, 138, 65,  255, 90,  116, 60,  255, 105, 122, 56,  255, 175, 192, 95,
    255, 128, 162, 86,  255, 69,  106, 41,  255, 40,  71,  19,  255, 40,  68,  21,  255, 55,  86,  28,  255, 68,  108, 28,  255, 69,  99,  37,  255,
    71,  89,  47,  255, 48,  73,  32,  255, 36,  49,  26,  255, 82,  104, 43,  255, 76,  102, 47,  255, 62,  84,  47,  255, 65,  92,  47,  255, 69,
    95,  43,  255, 45,  57,  33,  255, 23,  28,  25,  255, 23,  32,  26,  255, 26,  40,  26,  255, 29,  42,  28,  255, 25,  34,  26,  255, 28,  31,
    23,  255, 44,  44,  36,  255, 28,  29,  26,  255, 23,  26,  23,  255, 29,  33,  28,  255, 21,  23,  21,  255, 26,  31,  33,  255, 38,  41,  36,
    255, 67,  92,  48,  255, 76,  101, 58,  255, 99,  120, 53,  255, 145, 164, 65,  255, 155, 184, 67,  255, 117, 158, 48,  255, 106, 148, 50,  255,
    123, 153, 63,  255, 131, 158, 62,  255, 107, 133, 52,  255, 103, 133, 60,  255, 110, 139, 68,  255, 65,  89,  39,  255, 34,  55,  23,  255, 42,
    65,  28,  255, 71,  100, 39,  255, 75,  89,  48,  255, 63,  76,  42,  255, 118, 148, 68,  255, 131, 165, 87,  255, 122, 156, 87,  255, 93,  113,
    69,  255, 69,  81,  50,  255, 69,  87,  52,  255, 129, 142, 98,  255, 125, 152, 99,  255, 53,  74,  38,  255, 33,  55,  21,  255, 90,  115, 52,
    255, 74,  99,  55,  255, 51,  77,  46,  255, 55,  96,  34,  255, 63,  99,  34,  255, 19,  26,  19,  255, 47,  57,  33,  255, 100, 123, 58,  255,
    128, 159, 84,  255, 130, 163, 81,  255, 125, 156, 68,  255, 119, 150, 74,  255, 106, 132, 71,  255, 72,  91,  42,  255, 60,  80,  26,  255, 76,
    97,  42,  255, 74,  90,  37,  255, 31,  46,  19,  255, 26,  36,  21,  255, 12,  17,  17,  255, 29,  44,  26,  255, 55,  77,  41,  255, 60,  89,
    55,  255, 69,  99,  53,  255, 92,  122, 58,  255, 94,  122, 53,  255, 48,  69,  32,  255, 36,  47,  26,  255, 45,  62,  32,  255, 26,  37,  21,
    255, 44,  71,  28,  255, 69,  107, 40,  255, 79,  108, 44,  255, 72,  105, 39,  255, 72,  109, 44,  255, 88,  115, 60,  255, 150, 161, 93,  255,
    211, 221, 125, 255, 204, 216, 116, 255, 193, 205, 105, 255, 182, 194, 97,  255, 148, 164, 80,  255, 117, 145, 58,  255, 63,  101, 33,  255, 62,
    100, 36,  255, 84,  120, 62,  255, 34,  55,  31,  255, 100, 118, 55,  255, 186, 203, 115, 255, 226, 225, 123, 255, 214, 216, 114, 255, 177, 191,
    99,  255, 145, 169, 85,  255, 164, 185, 89,  255, 150, 184, 83,  255, 144, 179, 86,  255, 121, 162, 79,  255, 135, 172, 109, 255, 137, 174, 121,
    255, 158, 177, 108, 255, 219, 215, 127, 255, 219, 228, 155, 255, 185, 197, 127, 255, 132, 161, 112, 255, 129, 162, 112, 255, 128, 162, 112, 255,
    127, 161, 110, 255, 132, 159, 103, 255, 156, 178, 110, 255, 157, 181, 102, 255, 146, 168, 83,  255, 113, 135, 52,  255, 138, 168, 67,  255, 154,
    179, 84,  255, 164, 187, 102, 255, 171, 191, 108, 255, 147, 172, 103, 255, 149, 174, 108, 255, 82,  98,  55,  255, 41,  58,  19,  255, 82,  110,
    47,  255, 74,  107, 60,  255, 77,  108, 52,  255, 53,  80,  25,  255, 47,  63,  23,  255, 101, 99,  39,  255, 248, 243, 123, 255, 250, 248, 133,
    255, 245, 239, 117, 255, 218, 216, 109, 255, 202, 209, 104, 255, 201, 203, 87,  255, 243, 241, 117, 255, 249, 246, 126, 255, 246, 241, 136, 255,
    248, 241, 147, 255, 250, 245, 150, 255, 255, 248, 158, 255, 228, 222, 128, 255, 217, 210, 115, 255, 220, 213, 117, 255, 225, 216, 113, 255, 178,
    178, 91,  255, 58,  77,  37,  255, 36,  60,  31,  255, 38,  65,  23,  255, 114, 128, 68,  255, 181, 193, 114, 255, 206, 212, 128, 255, 215, 219,
    132, 255, 213, 216, 125, 255, 193, 204, 120, 255, 188, 197, 98,  255, 148, 173, 65,  255, 128, 165, 67,  255, 144, 165, 81,  255, 163, 186, 98,
    255, 159, 185, 99,  255, 134, 162, 78,  255, 147, 173, 82,  255, 140, 167, 82,  255, 85,  117, 65,  255, 63,  90,  55,  255, 49,  67,  26,  255,
    58,  87,  32,  255, 65,  102, 38,  255, 57,  89,  29,  255, 56,  83,  29,  255, 111, 126, 55,  255, 168, 185, 86,  255, 155, 175, 74,  255, 50,
    62,  31,  255, 21,  21,  12,  255, 101, 116, 58,  255, 116, 127, 65,  255, 95,  104, 53,  255, 58,  62,  38,  255, 153, 164, 140, 255, 176, 204,
    176, 255, 127, 164, 125, 255, 90,  127, 60,  255, 108, 140, 60,  255, 165, 186, 94,  255, 181, 205, 129, 255, 160, 194, 150, 255, 156, 188, 137,
    255, 164, 176, 100, 255, 80,  107, 52,  255, 60,  92,  36,  255, 58,  83,  49,  255, 52,  75,  44,  255, 79,  108, 48,  255, 69,  102, 49,  255,
    55,  87,  38,  255, 58,  92,  46,  255, 46,  75,  34,  255, 33,  52,  26,  255, 31,  49,  28,  255, 33,  51,  31,  255, 32,  44,  26,  255, 39,
    58,  26,  255, 49,  76,  31,  255, 60,  99,  36,  255, 68,  103, 43,  255, 68,  103, 42,  255, 58,  92,  37,  255, 79,  110, 44,  255, 86,  122,
    55,  255, 74,  109, 50,  255, 94,  120, 60,  255, 95,  122, 63,  255, 65,  96,  52,  255, 48,  76,  31,  255, 130, 147, 65,  255, 187, 209, 114,
    255, 174, 196, 111, 255, 179, 199, 112, 255, 183, 205, 114, 255, 166, 188, 104, 255, 113, 136, 81,  255, 112, 135, 83,  255, 94,  114, 71,  255,
    91,  112, 52,  255, 107, 138, 83,  255, 142, 172, 114, 255, 185, 199, 111, 255, 195, 197, 125, 255, 104, 106, 63,  255, 67,  68,  46,  255, 49,
    48,  34,  255, 69,  71,  43,  255, 74,  97,  41,  255, 102, 128, 60,  255, 137, 152, 73,  255, 149, 159, 77,  255, 117, 136, 76,  255, 88,  113,
    65,  255, 149, 160, 80,  255, 188, 202, 98,  255, 144, 168, 73,  255, 131, 156, 58,  255, 123, 152, 41,  255, 121, 149, 36,  255, 127, 157, 39,
    255, 100, 132, 40,  255, 73,  94,  48,  255, 76,  93,  52,  255, 36,  52,  32,  255, 32,  49,  26,  255, 84,  106, 47,  255, 93,  119, 60,  255,
    72,  97,  55,  255, 65,  87,  52,  255, 67,  87,  44,  255, 39,  47,  33,  255, 19,  19,  21,  255, 45,  55,  31,  255, 60,  74,  34,  255, 40,
    48,  31,  255, 17,  21,  21,  255, 36,  41,  28,  255, 41,  41,  32,  255, 23,  26,  26,  255, 17,  21,  19,  255, 25,  29,  23,  255, 17,  19,
    17,  255, 42,  51,  53,  255, 65,  72,  68,  255, 58,  78,  41,  255, 63,  94,  50,  255, 63,  87,  43,  255, 145, 163, 95,  255, 165, 188, 100,
    255, 184, 201, 95,  255, 144, 168, 76,  255, 98,  125, 52,  255, 83,  111, 43,  255, 84,  109, 50,  255, 102, 131, 60,  255, 89,  123, 60,  255,
    85,  116, 47,  255, 55,  80,  32,  255, 69,  98,  41,  255, 99,  134, 52,  255, 106, 130, 58,  255, 115, 138, 62,  255, 138, 171, 87,  255, 120,
    157, 98,  255, 113, 149, 96,  255, 117, 157, 99,  255, 126, 163, 100, 255, 117, 150, 80,  255, 129, 142, 84,  255, 128, 137, 87,  255, 48,  60,
    33,  255, 50,  72,  31,  255, 109, 133, 60,  255, 75,  100, 48,  255, 76,  98,  55,  255, 122, 144, 71,  255, 151, 162, 84,  255, 132, 127, 72,
    255, 142, 149, 77,  255, 139, 164, 83,  255, 125, 158, 82,  255, 133, 162, 83,  255, 65,  82,  38,  255, 43,  58,  31,  255, 36,  52,  31,  255,
    23,  37,  19,  255, 48,  68,  28,  255, 60,  82,  33,  255, 48,  68,  26,  255, 41,  60,  26,  255, 23,  28,  19,  255, 26,  34,  23,  255, 40,
    55,  26,  255, 79,  112, 36,  255, 103, 135, 47,  255, 82,  112, 52,  255, 74,  94,  47,  255, 31,  42,  21,  255, 25,  37,  21,  255, 36,  48,
    23,  255, 42,  65,  31,  255, 52,  89,  31,  255, 58,  97,  29,  255, 60,  101, 34,  255, 97,  134, 49,  255, 117, 141, 52,  255, 98,  119, 68,
    255, 191, 193, 157, 255, 213, 214, 174, 255, 235, 245, 197, 255, 231, 243, 196, 255, 227, 238, 178, 255, 222, 233, 152, 255, 196, 218, 130, 255,
    172, 203, 104, 255, 144, 174, 83,  255, 84,  121, 52,  255, 81,  112, 58,  255, 39,  62,  25,  255, 97,  119, 67,  255, 200, 210, 126, 255, 243,
    238, 137, 255, 214, 221, 118, 255, 146, 177, 92,  255, 126, 162, 84,  255, 122, 153, 72,  255, 155, 175, 82,  255, 169, 188, 83,  255, 152, 182,
    87,  255, 149, 176, 107, 255, 152, 175, 136, 255, 157, 180, 124, 255, 152, 171, 81,  255, 207, 208, 117, 255, 136, 161, 84,  255, 120, 157, 87,
    255, 124, 156, 99,  255, 123, 156, 97,  255, 124, 156, 94,  255, 130, 163, 96,  255, 154, 173, 89,  255, 157, 170, 68,  255, 126, 147, 65,  255,
    127, 158, 74,  255, 129, 166, 97,  255, 141, 174, 111, 255, 151, 181, 113, 255, 178, 199, 121, 255, 162, 187, 115, 255, 137, 166, 100, 255, 62,
    81,  36,  255, 134, 145, 82,  255, 173, 179, 98,  255, 187, 194, 107, 255, 143, 156, 81,  255, 69,  89,  44,  255, 47,  73,  32,  255, 42,  60,
    21,  255, 206, 204, 114, 255, 233, 226, 119, 255, 183, 181, 83,  255, 166, 180, 75,  255, 183, 190, 87,  255, 102, 116, 41,  255, 113, 118, 47,
    255, 199, 191, 94,  255, 248, 241, 126, 255, 254, 249, 143, 255, 249, 243, 146, 255, 255, 248, 156, 255, 246, 241, 152, 255, 223, 214, 127, 255,
    220, 213, 124, 255, 215, 209, 120, 255, 207, 206, 106, 255, 152, 165, 81,  255, 49,  76,  32,  255, 115, 143, 65,  255, 189, 203, 122, 255, 147,
    174, 118, 255, 143, 173, 121, 255, 146, 175, 126, 255, 148, 176, 122, 255, 161, 185, 127, 255, 185, 200, 122, 255, 172, 191, 87,  255, 144, 176,
    72,  255, 144, 172, 94,  255, 160, 188, 108, 255, 154, 184, 112, 255, 67,  95,  50,  255, 62,  92,  26,  255, 74,  108, 33,  255, 87,  119, 44,
    255, 89,  118, 65,  255, 58,  82,  46,  255, 47,  65,  25,  255, 47,  75,  26,  255, 41,  68,  21,  255, 53,  83,  26,  255, 36,  53,  28,  255,
    39,  51,  31,  255, 25,  37,  21,  255, 49,  37,  44,  255, 185, 174, 181, 255, 149, 165, 135, 255, 112, 134, 74,  255, 163, 179, 104, 255, 179,
    201, 156, 255, 174, 204, 179, 255, 132, 170, 130, 255, 135, 163, 78,  255, 97,  119, 43,  255, 69,  86,  36,  255, 110, 123, 58,  255, 207, 222,
    139, 255, 181, 208, 137, 255, 154, 188, 143, 255, 153, 177, 106, 255, 119, 136, 80,  255, 40,  65,  31,  255, 62,  84,  47,  255, 62,  84,  43,
    255, 79,  112, 45,  255, 55,  83,  33,  255, 47,  67,  36,  255, 42,  58,  34,  255, 32,  41,  25,  255, 36,  52,  26,  255, 31,  49,  28,  255,
    33,  51,  31,  255, 32,  48,  29,  255, 19,  25,  21,  255, 15,  17,  17,  255, 26,  37,  23,  255, 43,  60,  31,  255, 53,  80,  36,  255, 47,
    73,  32,  255, 76,  99,  41,  255, 107, 138, 68,  255, 97,  132, 69,  255, 89,  125, 62,  255, 105, 132, 68,  255, 74,  105, 47,  255, 71,  99,
    33,  255, 170, 188, 93,  255, 177, 201, 115, 255, 154, 183, 112, 255, 170, 194, 111, 255, 184, 206, 116, 255, 171, 192, 105, 255, 69,  83,  39,
    255, 68,  82,  34,  255, 118, 142, 58,  255, 116, 145, 58,  255, 116, 140, 73,  255, 155, 178, 97,  255, 180, 194, 95,  255, 174, 188, 100, 255,
    161, 177, 92,  255, 145, 162, 82,  255, 102, 111, 55,  255, 69,  68,  53,  255, 52,  68,  31,  255, 60,  75,  36,  255, 117, 121, 58,  255, 149,
    163, 84,  255, 102, 125, 78,  255, 89,  110, 65,  255, 184, 194, 100, 255, 204, 216, 102, 255, 198, 211, 82,  255, 192, 208, 73,  255, 189, 204,
    65,  255, 180, 194, 65,  255, 117, 137, 53,  255, 44,  62,  37,  255, 65,  84,  47,  255, 58,  74,  43,  255, 33,  47,  33,  255, 34,  55,  31,
    255, 52,  73,  31,  255, 109, 129, 62,  255, 120, 142, 78,  255, 91,  114, 62,  255, 62,  80,  44,  255, 32,  36,  25,  255, 88,  105, 41,  255,
    128, 153, 55,  255, 140, 165, 65,  255, 140, 157, 68,  255, 63,  65,  36,  255, 32,  36,  26,  255, 38,  38,  33,  255, 26,  28,  28,  255, 29,
    31,  26,  255, 29,  31,  25,  255, 29,  29,  26,  255, 47,  48,  40,  255, 28,  31,  29,  255, 32,  42,  26,  255, 65,  92,  46,  255, 50,  75,
    38,  255, 78,  98,  47,  255, 155, 165, 74,  255, 159, 177, 79,  255, 128, 149, 65,  255, 81,  112, 42,  255, 87,  119, 48,  255, 84,  122, 58,
    255, 103, 138, 65,  255, 91,  125, 55,  255, 83,  117, 50,  255, 94,  125, 52,  255, 81,  116, 45,  255, 112, 143, 62,  255, 148, 175, 86,  255,
    146, 175, 87,  255, 147, 178, 107, 255, 129, 164, 97,  255, 129, 163, 90,  255, 124, 160, 78,  255, 117, 147, 65,  255, 109, 136, 60,  255, 116,
    133, 73,  255, 119, 132, 84,  255, 93,  99,  60,  255, 50,  77,  32,  255, 104, 132, 58,  255, 157, 170, 89,  255, 222, 222, 137, 255, 234, 235,
    144, 255, 225, 230, 143, 255, 220, 229, 147, 255, 210, 222, 142, 255, 209, 214, 131, 255, 161, 176, 94,  255, 140, 169, 81,  255, 69,  84,  43,
    255, 17,  32,  21,  255, 29,  47,  31,  255, 32,  51,  25,  255, 50,  76,  31,  255, 50,  76,  29,  255, 49,  74,  29,  255, 67,  92,  29,  255,
    107, 128, 41,  255, 90,  123, 39,  255, 86,  120, 43,  255, 128, 164, 47,  255, 140, 158, 56,  255, 29,  37,  21,  255, 43,  60,  28,  255, 55,
    77,  36,  255, 45,  65,  26,  255, 79,  101, 36,  255, 93,  117, 39,  255, 82,  112, 37,  255, 74,  107, 38,  255, 79,  111, 38,  255, 90,  126,
    48,  255, 149, 165, 72,  255, 44,  46,  31,  255, 32,  41,  26,  255, 81,  102, 49,  255, 140, 155, 96,  255, 175, 182, 132, 255, 222, 233, 184,
    255, 224, 239, 195, 255, 226, 238, 189, 255, 236, 241, 181, 255, 198, 213, 138, 255, 113, 152, 62,  255, 137, 150, 80,  255, 92,  105, 49,  255,
    104, 139, 81,  255, 205, 209, 130, 255, 255, 246, 151, 255, 211, 214, 123, 255, 146, 178, 104, 255, 126, 163, 86,  255, 115, 153, 69,  255, 128,
    165, 77,  255, 149, 177, 86,  255, 162, 178, 72,  255, 149, 164, 68,  255, 174, 184, 115, 255, 168, 177, 115, 255, 125, 152, 53,  255, 111, 144,
    47,  255, 100, 136, 55,  255, 127, 160, 73,  255, 159, 181, 97,  255, 164, 182, 96,  255, 176, 188, 92,  255, 162, 170, 74,  255, 104, 124, 45,
    255, 100, 121, 52,  255, 139, 158, 69,  255, 146, 180, 86,  255, 127, 167, 92,  255, 140, 176, 115, 255, 146, 181, 127, 255, 151, 185, 127, 255,
    183, 206, 136, 255, 159, 174, 94,  255, 90,  108, 50,  255, 239, 228, 126, 255, 234, 223, 117, 255, 236, 224, 113, 255, 241, 228, 122, 255, 209,
    209, 113, 255, 116, 129, 60,  255, 77,  87,  44,  255, 191, 192, 108, 255, 189, 185, 95,  255, 162, 166, 75,  255, 163, 168, 76,  255, 179, 179,
    84,  255, 142, 151, 69,  255, 38,  55,  19,  255, 29,  34,  15,  255, 75,  67,  33,  255, 200, 188, 99,  255, 248, 238, 127, 255, 246, 238, 134,
    255, 251, 245, 154, 255, 226, 217, 125, 255, 219, 212, 105, 255, 225, 216, 92,  255, 224, 218, 95,  255, 197, 205, 80,  255, 125, 147, 48,  255,
    194, 202, 120, 255, 177, 196, 108, 255, 154, 183, 101, 255, 145, 176, 96,  255, 140, 172, 95,  255, 141, 172, 96,  255, 141, 172, 94,  255, 153,
    181, 105, 255, 156, 181, 92,  255, 157, 187, 90,  255, 169, 197, 105, 255, 125, 154, 77,  255, 50,  63,  32,  255, 53,  77,  25,  255, 65,  97,
    23,  255, 73,  105, 29,  255, 86,  118, 34,  255, 105, 136, 49,  255, 104, 137, 52,  255, 87,  122, 43,  255, 73,  95,  36,  255, 102, 128, 65,
    255, 118, 146, 77,  255, 67,  87,  47,  255, 41,  51,  26,  255, 58,  76,  31,  255, 95,  97,  73,  255, 255, 255, 255, 255, 201, 211, 204, 255,
    117, 138, 72,  255, 147, 169, 134, 255, 173, 202, 176, 255, 153, 181, 143, 255, 160, 185, 110, 255, 168, 188, 94,  255, 97,  119, 49,  255, 62,
    71,  40,  255, 26,  33,  21,  255, 74,  86,  39,  255, 150, 171, 78,  255, 174, 203, 125, 255, 144, 173, 104, 255, 124, 151, 77,  255, 55,  84,
    31,  255, 69,  91,  34,  255, 63,  86,  29,  255, 60,  92,  31,  255, 39,  58,  25,  255, 17,  21,  21,  255, 17,  21,  19,  255, 32,  43,  25,
    255, 33,  49,  26,  255, 31,  47,  29,  255, 34,  51,  32,  255, 33,  52,  28,  255, 26,  36,  23,  255, 23,  31,  21,  255, 21,  29,  21,  255,
    17,  19,  19,  255, 21,  23,  23,  255, 33,  42,  31,  255, 38,  52,  31,  255, 65,  87,  41,  255, 91,  121, 55,  255, 107, 140, 65,  255, 118,
    146, 68,  255, 115, 141, 68,  255, 69,  99,  39,  255, 151, 168, 84,  255, 190, 213, 117, 255, 170, 193, 110, 255, 173, 195, 116, 255, 181, 206,
    117, 255, 176, 199, 106, 255, 137, 155, 69,  255, 152, 170, 77,  255, 150, 173, 81,  255, 133, 162, 68,  255, 114, 147, 63,  255, 127, 157, 62,
    255, 180, 196, 97,  255, 173, 190, 103, 255, 160, 181, 96,  255, 159, 182, 89,  255, 169, 191, 93,  255, 149, 162, 87,  255, 77,  91,  40,  255,
    52,  71,  31,  255, 101, 105, 47,  255, 145, 159, 84,  255, 94,  117, 76,  255, 90,  113, 68,  255, 153, 167, 87,  255, 148, 165, 77,  255, 125,
    140, 62,  255, 97,  109, 49,  255, 99,  120, 53,  255, 81,  107, 49,  255, 63,  94,  42,  255, 42,  58,  40,  255, 65,  78,  47,  255, 52,  67,
    41,  255, 39,  52,  38,  255, 39,  55,  36,  255, 36,  58,  28,  255, 52,  71,  38,  255, 75,  91,  50,  255, 78,  96,  47,  255, 58,  74,  38,
    255, 71,  92,  36,  255, 117, 151, 58,  255, 123, 151, 56,  255, 151, 173, 73,  255, 173, 189, 84,  255, 161, 163, 78,  255, 37,  47,  26,  255,
    29,  41,  26,  255, 26,  29,  25,  255, 29,  31,  26,  255, 29,  31,  26,  255, 26,  33,  26,  255, 68,  79,  63,  255, 28,  34,  31,  255, 19,
    23,  21,  255, 43,  60,  29,  255, 63,  83,  32,  255, 183, 185, 94,  255, 176, 189, 92,  255, 162, 173, 74,  255, 93,  114, 52,  255, 82,  111,
    58,  255, 97,  128, 60,  255, 87,  122, 56,  255, 87,  123, 55,  255, 90,  124, 53,  255, 82,  117, 55,  255, 81,  114, 44,  255, 83,  119, 47,
    255, 115, 142, 65,  255, 144, 172, 81,  255, 146, 177, 87,  255, 137, 169, 83,  255, 120, 151, 65,  255, 108, 139, 52,  255, 123, 150, 55,  255,
    140, 151, 69,  255, 62,  68,  36,  255, 81,  97,  56,  255, 62,  75,  46,  255, 65,  82,  52,  255, 71,  87,  42,  255, 139, 159, 77,  255, 226,
    232, 138, 255, 226, 229, 142, 255, 195, 212, 145, 255, 184, 206, 148, 255, 174, 200, 148, 255, 166, 195, 146, 255, 179, 204, 149, 255, 202, 212,
    143, 255, 173, 188, 97,  255, 75,  95,  41,  255, 26,  47,  25,  255, 34,  48,  31,  255, 37,  52,  26,  255, 63,  92,  36,  255, 57,  84,  36,
    255, 50,  74,  32,  255, 136, 161, 48,  255, 175, 193, 53,  255, 124, 154, 45,  255, 96,  132, 58,  255, 157, 182, 65,  255, 133, 139, 56,  255,
    41,  63,  25,  255, 76,  114, 39,  255, 63,  97,  44,  255, 49,  81,  33,  255, 58,  87,  29,  255, 123, 148, 48,  255, 148, 165, 56,  255, 126,
    145, 53,  255, 131, 150, 55,  255, 147, 166, 60,  255, 170, 178, 82,  255, 62,  72,  29,  255, 86,  119, 38,  255, 81,  120, 38,  255, 52,  90,
    25,  255, 40,  62,  23,  255, 92,  116, 56,  255, 147, 159, 97,  255, 195, 208, 144, 255, 210, 224, 163, 255, 137, 170, 96,  255, 111, 150, 69,
    255, 201, 219, 158, 255, 137, 164, 92,  255, 135, 158, 84,  255, 189, 193, 113, 255, 222, 225, 152, 255, 199, 213, 134, 255, 186, 207, 118, 255,
    153, 184, 108, 255, 163, 191, 101, 255, 191, 206, 97,  255, 155, 171, 74,  255, 99,  120, 34,  255, 89,  113, 36,  255, 102, 125, 44,  255, 97,
    124, 50,  255, 80,  114, 52,  255, 87,  123, 60,  255, 84,  121, 65,  255, 119, 147, 67,  255, 137, 152, 56,  255, 149, 164, 58,  255, 123, 136,
    39,  255, 90,  115, 38,  255, 101, 140, 58,  255, 97,  123, 58,  255, 135, 158, 67,  255, 188, 205, 97,  255, 168, 194, 107, 255, 149, 180, 106,
    255, 153, 184, 120, 255, 160, 190, 134, 255, 160, 192, 136, 255, 196, 213, 136, 255, 229, 225, 121, 255, 225, 216, 110, 255, 222, 213, 107, 255,
    226, 216, 107, 255, 232, 220, 117, 255, 228, 220, 116, 255, 218, 215, 106, 255, 194, 194, 100, 255, 198, 198, 103, 255, 187, 197, 78,  255, 174,
    189, 68,  255, 179, 185, 76,  255, 181, 181, 84,  255, 160, 163, 75,  255, 34,  42,  17,  255, 23,  33,  21,  255, 21,  34,  19,  255, 62,  67,
    26,  255, 187, 174, 79,  255, 231, 218, 92,  255, 222, 212, 92,  255, 216, 209, 90,  255, 223, 215, 73,  255, 224, 217, 68,  255, 220, 215, 68,
    255, 211, 212, 60,  255, 185, 200, 52,  255, 157, 173, 58,  255, 146, 156, 62,  255, 170, 175, 68,  255, 171, 181, 69,  255, 177, 195, 82,  255,
    165, 192, 82,  255, 150, 181, 74,  255, 161, 187, 83,  255, 154, 176, 84,  255, 125, 152, 78,  255, 73,  104, 44,  255, 49,  80,  31,  255, 55,
    77,  28,  255, 68,  99,  26,  255, 63,  97,  29,  255, 63,  97,  32,  255, 85,  114, 42,  255, 99,  129, 55,  255, 84,  114, 41,  255, 129, 150,
    60,  255, 185, 204, 133, 255, 193, 215, 155, 255, 188, 214, 155, 255, 168, 198, 136, 255, 149, 176, 107, 255, 132, 158, 91,  255, 117, 131, 90,
    255, 228, 224, 228, 255, 251, 253, 255, 255, 187, 200, 172, 255, 177, 193, 128, 255, 196, 209, 138, 255, 195, 209, 120, 255, 190, 207, 101, 255,
    180, 195, 80,  255, 199, 203, 109, 255, 213, 214, 138, 255, 206, 206, 134, 255, 192, 193, 128, 255, 163, 171, 99,  255, 178, 193, 97,  255, 163,
    190, 91,  255, 112, 146, 60,  255, 97,  137, 39,  255, 117, 146, 55,  255, 140, 159, 96,  255, 149, 164, 102, 255, 151, 158, 98,  255, 50,  52,
    39,  255, 12,  19,  17,  255, 31,  42,  25,  255, 32,  47,  26,  255, 31,  46,  31,  255, 36,  52,  31,  255, 55,  77,  33,  255, 63,  92,  36,
    255, 58,  91,  32,  255, 49,  79,  28,  255, 43,  68,  26,  255, 33,  48,  25,  255, 33,  40,  26,  255, 38,  51,  31,  255, 34,  47,  32,  255,
    25,  31,  23,  255, 31,  38,  28,  255, 36,  47,  28,  255, 78,  97,  50,  255, 39,  47,  29,  255, 111, 124, 55,  255, 204, 223, 123, 255, 175,
    198, 86,  255, 181, 203, 112, 255, 169, 195, 119, 255, 163, 188, 98,  255, 131, 155, 60,  255, 157, 182, 81,  255, 125, 159, 58,  255, 101, 139,
    42,  255, 87,  124, 41,  255, 117, 144, 58,  255, 161, 182, 90,  255, 153, 177, 91,  255, 142, 165, 96,  255, 137, 161, 90,  255, 158, 178, 91,
    255, 174, 192, 96,  255, 150, 170, 83,  255, 63,  90,  37,  255, 86,  99,  45,  255, 146, 160, 87,  255, 99,  122, 77,  255, 82,  105, 68,  255,
    58,  72,  38,  255, 52,  75,  28,  255, 37,  51,  23,  255, 33,  46,  21,  255, 62,  92,  34,  255, 69,  100, 41,  255, 78,  107, 50,  255, 65,
    92,  47,  255, 71,  87,  48,  255, 42,  60,  39,  255, 42,  60,  44,  255, 41,  58,  39,  255, 40,  62,  32,  255, 42,  58,  34,  255, 19,  21,
    23,  255, 17,  19,  17,  255, 85,  100, 40,  255, 138, 157, 58,  255, 122, 145, 52,  255, 130, 154, 60,  255, 162, 176, 68,  255, 204, 207, 83,
    255, 217, 212, 118, 255, 72,  80,  44,  255, 105, 116, 75,  255, 75,  84,  52,  255, 23,  28,  23,  255, 29,  37,  26,  255, 41,  60,  31,  255,
    31,  52,  26,  255, 34,  39,  25,  255, 63,  65,  39,  255, 97,  110, 58,  255, 181, 178, 87,  255, 195, 201, 97,  255, 157, 173, 71,  255, 125,
    140, 55,  255, 74,  107, 37,  255, 74,  102, 46,  255, 82,  111, 56,  255, 81,  110, 52,  255, 95,  126, 53,  255, 98,  130, 52,  255, 84,  115,
    55,  255, 75,  110, 44,  255, 84,  119, 56,  255, 92,  124, 68,  255, 106, 134, 55,  255, 144, 168, 62,  255, 144, 171, 60,  255, 140, 165, 67,
    255, 155, 175, 86,  255, 179, 196, 107, 255, 199, 216, 118, 255, 197, 207, 113, 255, 133, 142, 74,  255, 75,  83,  55,  255, 25,  37,  28,  255,
    125, 137, 72,  255, 219, 227, 133, 255, 219, 226, 143, 255, 185, 205, 144, 255, 166, 196, 148, 255, 171, 198, 144, 255, 171, 199, 144, 255, 179,
    204, 152, 255, 189, 208, 154, 255, 208, 220, 162, 255, 220, 224, 143, 255, 79,  93,  42,  255, 28,  47,  23,  255, 26,  39,  23,  255, 29,  47,
    23,  255, 72,  102, 40,  255, 69,  95,  47,  255, 63,  84,  43,  255, 89,  111, 38,  255, 175, 187, 60,  255, 179, 189, 74,  255, 145, 165, 89,
    255, 171, 183, 83,  255, 76,  94,  31,  255, 79,  120, 44,  255, 82,  116, 48,  255, 55,  87,  36,  255, 47,  81,  32,  255, 65,  102, 36,  255,
    55,  77,  33,  255, 71,  87,  40,  255, 136, 146, 60,  255, 159, 174, 77,  255, 202, 207, 95,  255, 159, 159, 74,  255, 92,  121, 32,  255, 115,
    146, 47,  255, 73,  110, 41,  255, 69,  106, 42,  255, 63,  103, 37,  255, 58,  98,  31,  255, 94,  125, 41,  255, 101, 129, 43,  255, 116, 148,
    65,  255, 128, 167, 77,  255, 170, 193, 119, 255, 162, 187, 116, 255, 123, 156, 76,  255, 189, 206, 123, 255, 217, 223, 147, 255, 220, 228, 161,
    255, 241, 232, 146, 255, 227, 218, 124, 255, 187, 186, 101, 255, 159, 159, 76,  255, 109, 114, 42,  255, 56,  78,  31,  255, 52,  84,  36,  255,
    63,  95,  37,  255, 97,  130, 55,  255, 80,  116, 62,  255, 74,  111, 65,  255, 80,  117, 68,  255, 94,  130, 72,  255, 97,  129, 56,  255, 62,
    91,  42,  255, 86,  119, 44,  255, 83,  112, 45,  255, 87,  124, 44,  255, 114, 143, 65,  255, 85,  115, 67,  255, 122, 146, 82,  255, 172, 185,
    85,  255, 213, 219, 110, 255, 197, 216, 134, 255, 178, 204, 142, 255, 167, 198, 142, 255, 164, 198, 140, 255, 178, 204, 137, 255, 226, 223, 123,
    255, 230, 219, 108, 255, 227, 217, 112, 255, 226, 217, 114, 255, 229, 220, 118, 255, 224, 216, 113, 255, 217, 213, 105, 255, 217, 214, 102, 255,
    200, 210, 84,  255, 193, 209, 77,  255, 195, 210, 80,  255, 201, 213, 80,  255, 191, 196, 84,  255, 166, 168, 77,  255, 41,  53,  17,  255, 31,
    48,  23,  255, 36,  52,  21,  255, 26,  46,  19,  255, 43,  53,  19,  255, 158, 151, 62,  255, 217, 205, 77,  255, 220, 212, 76,  255, 231, 222,
    83,  255, 227, 218, 74,  255, 220, 214, 62,  255, 212, 211, 65,  255, 202, 207, 68,  255, 180, 195, 55,  255, 146, 167, 47,  255, 96,  120, 39,
    255, 81,  105, 32,  255, 140, 158, 74,  255, 194, 204, 115, 255, 155, 171, 86,  255, 165, 181, 84,  255, 95,  113, 53,  255, 39,  62,  26,  255,
    46,  75,  26,  255, 52,  80,  29,  255, 65,  97,  32,  255, 63,  100, 36,  255, 63,  95,  39,  255, 71,  100, 41,  255, 80,  109, 44,  255, 96,
    127, 56,  255, 109, 126, 55,  255, 205, 207, 148, 255, 207, 228, 193, 255, 178, 203, 148, 255, 118, 147, 89,  255, 80,  108, 60,  255, 95,  127,
    55,  255, 121, 147, 75,  255, 170, 190, 119, 255, 221, 225, 204, 255, 246, 248, 255, 255, 232, 238, 245, 255, 218, 217, 128, 255, 211, 216, 115,
    255, 196, 205, 102, 255, 209, 213, 113, 255, 225, 227, 137, 255, 229, 231, 155, 255, 224, 228, 149, 255, 224, 229, 146, 255, 222, 227, 142, 255,
    222, 229, 138, 255, 219, 225, 133, 255, 164, 187, 92,  255, 143, 163, 69,  255, 159, 181, 89,  255, 167, 191, 109, 255, 178, 205, 138, 255, 179,
    208, 145, 255, 206, 226, 164, 255, 157, 163, 108, 255, 19,  25,  15,  255, 26,  37,  23,  255, 32,  47,  28,  255, 32,  46,  26,  255, 60,  84,
    34,  255, 80,  115, 41,  255, 76,  112, 40,  255, 60,  90,  37,  255, 43,  63,  33,  255, 41,  63,  29,  255, 39,  62,  28,  255, 34,  49,  26,
    255, 40,  52,  31,  255, 29,  40,  31,  255, 17,  23,  21,  255, 12,  12,  15,  255, 34,  37,  25,  255, 90,  102, 49,  255, 104, 124, 56,  255,
    127, 146, 62,  255, 198, 217, 123, 255, 171, 201, 93,  255, 165, 192, 76,  255, 163, 187, 115, 255, 158, 186, 96,  255, 142, 174, 80,  255, 138,
    169, 87,  255, 117, 147, 67,  255, 110, 143, 50,  255, 101, 137, 37,  255, 101, 130, 43,  255, 144, 167, 86,  255, 135, 160, 87,  255, 142, 166,
    90,  255, 135, 161, 97,  255, 140, 164, 93,  255, 157, 180, 90,  255, 154, 175, 89,  255, 81,  106, 45,  255, 65,  81,  33,  255, 127, 139, 71,
    255, 112, 131, 77,  255, 71,  91,  56,  255, 56,  69,  31,  255, 78,  99,  36,  255, 90,  114, 33,  255, 109, 132, 41,  255, 72,  100, 40,  255,
    65,  92,  46,  255, 86,  115, 56,  255, 82,  111, 53,  255, 71,  90,  48,  255, 47,  65,  42,  255, 52,  74,  52,  255, 48,  68,  47,  255, 39,
    63,  31,  255, 43,  62,  32,  255, 19,  25,  23,  255, 29,  38,  23,  255, 88,  100, 40,  255, 177, 182, 74,  255, 194, 197, 98,  255, 182, 187,
    91,  255, 179, 184, 77,  255, 143, 148, 68,  255, 90,  94,  52,  255, 147, 155, 105, 255, 220, 232, 173, 255, 103, 121, 72,  255, 47,  69,  36,
    255, 39,  55,  31,  255, 32,  51,  23,  255, 90,  98,  47,  255, 161, 164, 87,  255, 159, 172, 102, 255, 180, 188, 114, 255, 213, 213, 121, 255,
    160, 174, 76,  255, 126, 140, 52,  255, 63,  87,  31,  255, 49,  68,  32,  255, 26,  33,  26,  255, 65,  92,  46,  255, 71,  102, 50,  255, 52,
    79,  40,  255, 86,  113, 52,  255, 99,  129, 56,  255, 87,  119, 60,  255, 78,  107, 58,  255, 68,  101, 50,  255, 108, 136, 65,  255, 159, 179,
    83,  255, 204, 214, 113, 255, 196, 207, 100, 255, 199, 211, 115, 255, 206, 218, 137, 255, 204, 218, 133, 255, 210, 223, 132, 255, 204, 212, 124,
    255, 97,  108, 58,  255, 67,  81,  40,  255, 208, 218, 126, 255, 210, 220, 134, 255, 181, 204, 123, 255, 174, 201, 115, 255, 182, 208, 121, 255,
    190, 214, 135, 255, 200, 218, 150, 255, 204, 219, 148, 255, 199, 211, 132, 255, 175, 191, 104, 255, 161, 183, 91,  255, 68,  89,  38,  255, 31,
    52,  26,  255, 33,  48,  25,  255, 29,  48,  23,  255, 58,  87,  38,  255, 86,  115, 60,  255, 87,  113, 53,  255, 68,  96,  36,  255, 65,  84,
    39,  255, 136, 157, 69,  255, 172, 183, 89,  255, 138, 152, 71,  255, 62,  94,  31,  255, 99,  134, 62,  255, 69,  98,  58,  255, 65,  95,  47,
    255, 75,  111, 42,  255, 79,  105, 42,  255, 32,  47,  26,  255, 23,  38,  23,  255, 32,  52,  23,  255, 75,  96,  50,  255, 131, 143, 84,  255,
    87,  102, 44,  255, 135, 161, 60,  255, 174, 190, 110, 255, 106, 132, 53,  255, 78,  117, 45,  255, 71,  109, 37,  255, 104, 136, 52,  255, 153,
    174, 67,  255, 117, 143, 49,  255, 96,  127, 48,  255, 156, 180, 106, 255, 213, 226, 186, 255, 174, 192, 132, 255, 135, 159, 85,  255, 184, 207,
    153, 255, 209, 219, 142, 255, 165, 175, 90,  255, 136, 155, 68,  255, 107, 132, 48,  255, 62,  83,  26,  255, 45,  67,  25,  255, 34,  52,  23,
    255, 43,  63,  31,  255, 44,  63,  26,  255, 58,  81,  34,  255, 113, 145, 69,  255, 89,  125, 73,  255, 87,  125, 74,  255, 87,  123, 72,  255,
    127, 160, 79,  255, 90,  117, 53,  255, 62,  89,  55,  255, 82,  113, 58,  255, 101, 130, 65,  255, 97,  124, 56,  255, 102, 128, 65,  255, 87,
    125, 83,  255, 94,  126, 80,  255, 153, 171, 93,  255, 158, 173, 84,  255, 171, 183, 98,  255, 214, 220, 129, 255, 192, 206, 134, 255, 192, 214,
    154, 255, 185, 215, 156, 255, 223, 225, 136, 255, 235, 222, 112, 255, 232, 221, 106, 255, 232, 221, 113, 255, 233, 222, 117, 255, 228, 217, 104,
    255, 219, 212, 95,  255, 212, 214, 86,  255, 205, 213, 72,  255, 208, 215, 86,  255, 202, 211, 86,  255, 206, 214, 75,  255, 211, 218, 84,  255,
    160, 162, 68,  255, 45,  67,  23,  255, 60,  84,  38,  255, 96,  117, 55,  255, 88,  109, 53,  255, 53,  77,  34,  255, 39,  74,  17,  255, 91,
    108, 31,  255, 191, 182, 73,  255, 248, 234, 112, 255, 234, 222, 91,  255, 219, 215, 68,  255, 212, 210, 62,  255, 203, 207, 58,  255, 196, 205,
    52,  255, 195, 205, 58,  255, 122, 142, 52,  255, 85,  115, 41,  255, 83,  116, 37,  255, 86,  116, 46,  255, 103, 129, 58,  255, 109, 136, 62,
    255, 71,  94,  48,  255, 41,  48,  26,  255, 49,  63,  28,  255, 50,  76,  25,  255, 60,  92,  31,  255, 65,  97,  41,  255, 74,  103, 48,  255,
    85,  113, 49,  255, 100, 131, 49,  255, 119, 145, 52,  255, 171, 171, 94,  255, 226, 229, 186, 255, 203, 221, 171, 255, 175, 203, 149, 255, 93,
    117, 68,  255, 34,  46,  6,   255, 123, 136, 58,  255, 193, 199, 116, 255, 206, 222, 132, 255, 193, 200, 161, 255, 224, 227, 249, 255, 215, 222,
    198, 255, 200, 206, 83,  255, 223, 219, 125, 255, 238, 231, 158, 255, 238, 232, 158, 255, 229, 229, 153, 255, 222, 228, 147, 255, 213, 225, 140,
    255, 204, 220, 134, 255, 196, 215, 134, 255, 182, 208, 114, 255, 162, 192, 91,  255, 127, 161, 68,  255, 108, 139, 52,  255, 141, 160, 80,  255,
    181, 198, 105, 255, 180, 203, 117, 255, 187, 211, 144, 255, 199, 220, 165, 255, 214, 224, 146, 255, 99,  121, 49,  255, 23,  32,  19,  255, 26,
    39,  23,  255, 56,  76,  33,  255, 92,  123, 45,  255, 87,  119, 46,  255, 73,  103, 47,  255, 57,  83,  47,  255, 48,  73,  39,  255, 41,  63,
    33,  255, 38,  58,  33,  255, 46,  74,  31,  255, 43,  57,  28,  255, 33,  40,  28,  255, 12,  12,  15,  255, 100, 103, 48,  255, 191, 206, 109,
    255, 197, 217, 113, 255, 159, 182, 87,  255, 180, 198, 111, 255, 196, 213, 122, 255, 189, 213, 108, 255, 148, 187, 62,  255, 177, 198, 103, 255,
    156, 182, 89,  255, 137, 169, 65,  255, 127, 160, 62,  255, 128, 157, 74,  255, 118, 150, 56,  255, 124, 154, 47,  255, 117, 143, 47,  255, 127,
    145, 62,  255, 155, 177, 89,  255, 129, 157, 80,  255, 132, 161, 92,  255, 126, 155, 100, 255, 136, 163, 92,  255, 156, 176, 87,  255, 92,  120,
    47,  255, 94,  120, 49,  255, 77,  95,  38,  255, 110, 127, 60,  255, 107, 124, 52,  255, 144, 162, 56,  255, 172, 192, 71,  255, 148, 165, 58,
    255, 103, 129, 47,  255, 77,  110, 45,  255, 63,  91,  52,  255, 85,  114, 58,  255, 82,  109, 52,  255, 76,  99,  48,  255, 47,  65,  37,  255,
    55,  81,  47,  255, 63,  94,  56,  255, 62,  82,  42,  255, 69,  84,  47,  255, 29,  31,  26,  255, 52,  65,  33,  255, 44,  58,  33,  255, 55,
    71,  37,  255, 167, 180, 94,  255, 180, 188, 104, 255, 31,  40,  23,  255, 41,  41,  28,  255, 174, 179, 137, 255, 201, 225, 181, 255, 208, 226,
    177, 255, 96,  108, 68,  255, 49,  75,  38,  255, 48,  71,  34,  255, 123, 122, 62,  255, 199, 202, 116, 255, 160, 180, 117, 255, 141, 161, 107,
    255, 187, 193, 122, 255, 172, 186, 102, 255, 138, 152, 58,  255, 60,  80,  31,  255, 28,  42,  31,  255, 17,  26,  26,  255, 29,  37,  31,  255,
    31,  40,  29,  255, 53,  81,  38,  255, 73,  97,  44,  255, 124, 142, 71,  255, 128, 149, 72,  255, 95,  120, 58,  255, 83,  113, 63,  255, 65,
    100, 49,  255, 87,  120, 55,  255, 150, 179, 72,  255, 207, 220, 129, 255, 223, 226, 140, 255, 214, 221, 112, 255, 210, 221, 134, 255, 207, 221,
    142, 255, 210, 222, 143, 255, 208, 216, 137, 255, 123, 141, 67,  255, 149, 170, 72,  255, 197, 212, 103, 255, 189, 207, 103, 255, 190, 207, 101,
    255, 185, 199, 98,  255, 162, 173, 89,  255, 142, 153, 84,  255, 174, 189, 101, 255, 174, 189, 99,  255, 161, 183, 96,  255, 150, 178, 84,  255,
    122, 147, 58,  255, 34,  51,  26,  255, 38,  58,  31,  255, 38,  55,  28,  255, 26,  39,  23,  255, 41,  63,  25,  255, 95,  125, 67,  255, 89,
    120, 69,  255, 97,  124, 49,  255, 74,  97,  42,  255, 85,  117, 62,  255, 94,  121, 53,  255, 68,  104, 32,  255, 68,  102, 39,  255, 115, 145,
    74,  255, 98,  126, 58,  255, 110, 137, 72,  255, 85,  110, 47,  255, 49,  68,  29,  255, 31,  44,  25,  255, 28,  46,  23,  255, 33,  58,  26,
    255, 40,  62,  31,  255, 34,  47,  29,  255, 57,  87,  36,  255, 148, 168, 75,  255, 192, 213, 146, 255, 154, 170, 90,  255, 86,  122, 42,  255,
    102, 137, 43,  255, 130, 160, 49,  255, 101, 127, 39,  255, 101, 127, 41,  255, 117, 146, 43,  255, 124, 147, 60,  255, 220, 229, 170, 255, 194,
    205, 157, 255, 138, 165, 106, 255, 193, 217, 176, 255, 198, 210, 134, 255, 130, 158, 68,  255, 127, 163, 67,  255, 111, 148, 58,  255, 71,  112,
    41,  255, 96,  137, 44,  255, 71,  99,  34,  255, 40,  53,  31,  255, 28,  38,  26,  255, 48,  65,  34,  255, 111, 143, 78,  255, 94,  126, 77,
    255, 117, 147, 81,  255, 146, 178, 84,  255, 148, 176, 76,  255, 113, 145, 69,  255, 76,  108, 60,  255, 78,  106, 58,  255, 88,  114, 60,  255,
    75,  106, 50,  255, 87,  121, 71,  255, 90,  124, 82,  255, 89,  124, 79,  255, 101, 133, 84,  255, 113, 142, 81,  255, 103, 133, 71,  255, 130,
    151, 84,  255, 145, 152, 68,  255, 96,  97,  50,  255, 132, 142, 81,  255, 195, 193, 101, 255, 168, 164, 77,  255, 233, 218, 112, 255, 241, 228,
    117, 255, 241, 228, 116, 255, 239, 228, 110, 255, 230, 223, 99,  255, 224, 221, 80,  255, 224, 224, 75,  255, 219, 221, 90,  255, 212, 216, 90,
    255, 211, 217, 80,  255, 220, 223, 86,  255, 130, 140, 47,  255, 48,  81,  26,  255, 91,  117, 48,  255, 135, 154, 65,  255, 132, 151, 65,  255,
    123, 144, 60,  255, 101, 122, 48,  255, 52,  87,  21,  255, 173, 181, 103, 255, 255, 250, 137, 255, 245, 235, 107, 255, 231, 229, 92,  255, 224,
    223, 72,  255, 218, 219, 62,  255, 215, 217, 62,  255, 176, 180, 53,  255, 98,  122, 45,  255, 87,  117, 42,  255, 92,  119, 40,  255, 82,  112,
    40,  255, 81,  113, 41,  255, 96,  125, 48,  255, 68,  100, 34,  255, 62,  95,  31,  255, 80,  108, 41,  255, 78,  107, 47,  255, 58,  89,  36,
    255, 69,  98,  44,  255, 82,  108, 52,  255, 103, 126, 58,  255, 118, 145, 65,  255, 88,  113, 45,  255, 139, 137, 63,  255, 226, 230, 134, 255,
    174, 201, 145, 255, 174, 196, 151, 255, 198, 205, 110, 255, 163, 168, 62,  255, 214, 222, 137, 255, 217, 230, 144, 255, 210, 224, 137, 255, 207,
    215, 170, 255, 216, 223, 243, 255, 200, 202, 152, 255, 215, 213, 116, 255, 233, 233, 156, 255, 228, 229, 152, 255, 225, 228, 146, 255, 215, 222,
    132, 255, 205, 219, 132, 255, 180, 207, 142, 255, 163, 196, 137, 255, 156, 191, 136, 255, 143, 182, 114, 255, 155, 185, 101, 255, 161, 182, 94,
    255, 95,  130, 49,  255, 60,  86,  26,  255, 119, 145, 55,  255, 156, 181, 75,  255, 151, 172, 95,  255, 161, 178, 113, 255, 189, 204, 123, 255,
    115, 143, 58,  255, 29,  42,  23,  255, 37,  47,  23,  255, 92,  118, 47,  255, 91,  127, 52,  255, 74,  106, 52,  255, 63,  89,  52,  255, 65,
    91,  52,  255, 60,  87,  47,  255, 48,  74,  37,  255, 57,  84,  37,  255, 58,  87,  36,  255, 25,  26,  21,  255, 32,  37,  26,  255, 77,  82,
    38,  255, 202, 218, 110, 255, 198, 217, 115, 255, 188, 208, 104, 255, 196, 212, 102, 255, 180, 203, 118, 255, 197, 210, 122, 255, 210, 221, 126,
    255, 185, 208, 93,  255, 195, 213, 110, 255, 149, 175, 82,  255, 141, 168, 60,  255, 151, 173, 65,  255, 167, 183, 84,  255, 179, 196, 109, 255,
    190, 206, 123, 255, 190, 207, 121, 255, 130, 150, 68,  255, 166, 183, 91,  255, 145, 170, 94,  255, 117, 147, 87,  255, 124, 153, 98,  255, 134,
    162, 103, 255, 159, 179, 89,  255, 95,  124, 47,  255, 84,  118, 47,  255, 99,  123, 52,  255, 135, 155, 52,  255, 153, 183, 62,  255, 141, 175,
    60,  255, 169, 191, 65,  255, 186, 191, 87,  255, 76,  98,  40,  255, 87,  121, 53,  255, 69,  96,  55,  255, 80,  111, 60,  255, 80,  106, 49,
    255, 85,  113, 55,  255, 52,  68,  37,  255, 36,  43,  25,  255, 47,  67,  36,  255, 58,  80,  41,  255, 104, 129, 58,  255, 100, 120, 48,  255,
    94,  113, 47,  255, 56,  73,  36,  255, 40,  60,  34,  255, 109, 132, 56,  255, 195, 209, 108, 255, 87,  87,  53,  255, 186, 191, 148, 255, 208,
    231, 189, 255, 188, 215, 172, 255, 219, 231, 186, 255, 86,  99,  63,  255, 42,  68,  39,  255, 107, 118, 58,  255, 203, 204, 109, 255, 162, 177,
    111, 255, 141, 164, 113, 255, 146, 165, 108, 255, 180, 190, 122, 255, 156, 172, 78,  255, 80,  101, 36,  255, 38,  58,  32,  255, 84,  95,  38,
    255, 103, 107, 45,  255, 40,  47,  29,  255, 19,  25,  23,  255, 53,  58,  28,  255, 168, 186, 97,  255, 182, 205, 116, 255, 169, 192, 107, 255,
    140, 167, 93,  255, 117, 148, 65,  255, 82,  114, 47,  255, 89,  114, 56,  255, 133, 154, 69,  255, 163, 193, 77,  255, 190, 199, 104, 255, 215,
    223, 143, 255, 188, 204, 112, 255, 210, 220, 129, 255, 219, 226, 158, 255, 210, 220, 144, 255, 144, 162, 83,  255, 144, 171, 68,  255, 163, 190,
    63,  255, 176, 201, 76,  255, 114, 146, 55,  255, 89,  120, 46,  255, 99,  117, 52,  255, 120, 145, 67,  255, 144, 176, 101, 255, 144, 178, 106,
    255, 159, 187, 108, 255, 158, 182, 87,  255, 68,  83,  34,  255, 33,  47,  26,  255, 38,  53,  31,  255, 26,  34,  21,  255, 28,  37,  23,  255,
    37,  55,  23,  255, 97,  123, 65,  255, 90,  123, 80,  255, 99,  132, 80,  255, 107, 133, 60,  255, 96,  124, 68,  255, 102, 128, 73,  255, 73,
    107, 29,  255, 73,  106, 41,  255, 124, 153, 65,  255, 100, 131, 40,  255, 85,  114, 37,  255, 58,  83,  26,  255, 41,  55,  28,  255, 23,  33,
    21,  255, 28,  43,  23,  255, 21,  34,  23,  255, 49,  67,  42,  255, 94,  107, 58,  255, 60,  86,  32,  255, 113, 136, 68,  255, 175, 200, 142,
    255, 181, 200, 125, 255, 151, 169, 55,  255, 156, 172, 52,  255, 95,  108, 38,  255, 31,  49,  23,  255, 34,  55,  26,  255, 65,  94,  32,  255,
    97,  126, 33,  255, 170, 186, 111, 255, 222, 223, 168, 255, 148, 171, 110, 255, 199, 218, 168, 255, 206, 211, 129, 255, 147, 169, 78,  255, 128,
    162, 69,  255, 115, 149, 65,  255, 98,  135, 60,  255, 128, 164, 60,  255, 108, 146, 49,  255, 92,  128, 40,  255, 92,  123, 48,  255, 121, 155,
    76,  255, 100, 134, 72,  255, 98,  119, 69,  255, 184, 205, 107, 255, 163, 189, 95,  255, 138, 169, 87,  255, 115, 152, 81,  255, 93,  134, 62,
    255, 86,  123, 50,  255, 83,  112, 47,  255, 77,  110, 47,  255, 91,  124, 62,  255, 91,  121, 65,  255, 116, 140, 69,  255, 147, 171, 69,  255,
    139, 162, 62,  255, 102, 134, 62,  255, 87,  120, 65,  255, 121, 143, 74,  255, 87,  112, 45,  255, 73,  100, 34,  255, 103, 119, 44,  255, 90,
    115, 47,  255, 127, 140, 58,  255, 180, 174, 81,  255, 196, 183, 81,  255, 192, 174, 76,  255, 159, 140, 55,  255, 113, 99,  32,  255, 216, 205,
    78,  255, 241, 238, 103, 255, 225, 224, 98,  255, 234, 234, 92,  255, 209, 207, 73,  255, 75,  98,  31,  255, 49,  76,  26,  255, 93,  117, 45,
    255, 132, 151, 62,  255, 132, 146, 62,  255, 122, 139, 55,  255, 122, 140, 56,  255, 101, 123, 44,  255, 163, 162, 82,  255, 175, 165, 75,  255,
    156, 153, 58,  255, 170, 162, 65,  255, 172, 159, 56,  255, 174, 166, 56,  255, 136, 145, 47,  255, 111, 139, 55,  255, 118, 150, 58,  255, 132,
    159, 55,  255, 131, 151, 56,  255, 119, 142, 53,  255, 60,  94,  28,  255, 53,  86,  25,  255, 100, 134, 40,  255, 100, 134, 46,  255, 116, 153,
    67,  255, 134, 171, 97,  255, 118, 150, 89,  255, 82,  109, 52,  255, 113, 138, 60,  255, 139, 157, 72,  255, 115, 138, 69,  255, 38,  63,  25,
    255, 93,  96,  36,  255, 213, 225, 147, 255, 169, 199, 149, 255, 182, 194, 122, 255, 243, 238, 106, 255, 219, 229, 93,  255, 204, 217, 106, 255,
    214, 227, 142, 255, 215, 228, 147, 255, 194, 210, 129, 255, 160, 169, 119, 255, 208, 206, 111, 255, 229, 233, 140, 255, 219, 229, 132, 255, 208,
    221, 115, 255, 200, 213, 99,  255, 197, 209, 91,  255, 189, 210, 121, 255, 154, 189, 136, 255, 161, 193, 143, 255, 158, 190, 123, 255, 176, 199,
    116, 255, 171, 189, 107, 255, 108, 128, 55,  255, 92,  116, 40,  255, 76,  104, 37,  255, 36,  52,  25,  255, 73,  93,  37,  255, 112, 135, 62,
    255, 98,  117, 58,  255, 58,  78,  37,  255, 38,  58,  31,  255, 26,  40,  23,  255, 65,  84,  36,  255, 87,  123, 60,  255, 69,  104, 56,  255,
    69,  99,  55,  255, 79,  110, 52,  255, 73,  104, 53,  255, 65,  94,  52,  255, 82,  108, 52,  255, 87,  120, 50,  255, 45,  60,  31,  255, 34,
    47,  26,  255, 34,  44,  15,  255, 166, 178, 90,  255, 207, 224, 128, 255, 197, 215, 116, 255, 184, 206, 97,  255, 185, 202, 102, 255, 175, 202,
    119, 255, 189, 208, 126, 255, 195, 212, 131, 255, 191, 214, 118, 255, 187, 218, 97,  255, 150, 174, 80,  255, 172, 185, 102, 255, 212, 224, 155,
    255, 199, 222, 164, 255, 202, 227, 168, 255, 206, 222, 158, 255, 124, 142, 84,  255, 92,  114, 55,  255, 111, 128, 56,  255, 182, 196, 104, 255,
    154, 176, 101, 255, 122, 152, 92,  255, 120, 152, 96,  255, 151, 177, 107, 255, 102, 127, 58,  255, 119, 138, 63,  255, 151, 174, 76,  255, 134,
    167, 63,  255, 111, 148, 60,  255, 139, 167, 60,  255, 207, 214, 81,  255, 238, 230, 135, 255, 138, 149, 79,  255, 94,  121, 58,  255, 77,  102,
    68,  255, 83,  113, 62,  255, 80,  106, 49,  255, 89,  118, 55,  255, 80,  111, 38,  255, 100, 133, 38,  255, 119, 146, 47,  255, 78,  93,  37,
    255, 40,  72,  23,  255, 64,  105, 32,  255, 58,  92,  33,  255, 48,  84,  31,  255, 69,  109, 42,  255, 112, 141, 60,  255, 201, 218, 111, 255,
    211, 225, 159, 255, 195, 219, 156, 255, 185, 213, 127, 255, 210, 230, 187, 255, 185, 193, 144, 255, 42,  63,  26,  255, 47,  67,  34,  255, 185,
    183, 100, 255, 183, 190, 117, 255, 151, 165, 111, 255, 134, 157, 105, 255, 142, 163, 106, 255, 146, 164, 87,  255, 93,  111, 42,  255, 53,  77,
    26,  255, 122, 144, 47,  255, 181, 198, 62,  255, 220, 215, 74,  255, 73,  71,  38,  255, 28,  37,  23,  255, 165, 178, 98,  255, 176, 205, 128,
    255, 150, 185, 117, 255, 148, 181, 114, 255, 139, 171, 101, 255, 117, 151, 68,  255, 133, 158, 82,  255, 192, 211, 148, 255, 173, 199, 144, 255,
    169, 198, 112, 255, 179, 201, 106, 255, 153, 174, 99,  255, 192, 201, 111, 255, 238, 239, 135, 255, 227, 232, 143, 255, 217, 226, 164, 255, 160,
    172, 109, 255, 146, 172, 71,  255, 159, 188, 58,  255, 159, 184, 77,  255, 127, 155, 75,  255, 123, 157, 86,  255, 143, 174, 104, 255, 116, 155,
    84,  255, 125, 166, 87,  255, 156, 183, 94,  255, 146, 173, 75,  255, 118, 148, 58,  255, 62,  84,  41,  255, 47,  68,  42,  255, 52,  75,  46,
    255, 45,  63,  32,  255, 33,  49,  25,  255, 31,  49,  23,  255, 84,  105, 55,  255, 122, 148, 87,  255, 84,  119, 82,  255, 98,  130, 78,  255,
    118, 144, 80,  255, 83,  106, 58,  255, 86,  116, 39,  255, 105, 136, 41,  255, 91,  122, 36,  255, 104, 133, 42,  255, 85,  96,  40,  255, 34,
    41,  23,  255, 28,  37,  21,  255, 48,  65,  28,  255, 65,  91,  31,  255, 63,  89,  31,  255, 49,  69,  26,  255, 110, 134, 65,  255, 160, 178,
    83,  255, 138, 152, 84,  255, 184, 205, 135, 255, 180, 206, 141, 255, 144, 156, 68,  255, 55,  69,  31,  255, 21,  33,  23,  255, 28,  41,  26,
    255, 32,  46,  26,  255, 33,  52,  25,  255, 36,  52,  21,  255, 89,  110, 50,  255, 196, 210, 115, 255, 152, 176, 111, 255, 226, 235, 173, 255,
    133, 136, 69,  255, 68,  98,  34,  255, 76,  118, 43,  255, 146, 172, 96,  255, 154, 183, 94,  255, 92,  124, 55,  255, 63,  95,  42,  255, 122,
    149, 58,  255, 82,  109, 38,  255, 99,  121, 55,  255, 40,  51,  29,  255, 88,  99,  62,  255, 141, 168, 100, 255, 139, 172, 105, 255, 122, 159,
    101, 255, 114, 152, 87,  255, 104, 143, 69,  255, 95,  137, 53,  255, 97,  134, 52,  255, 85,  114, 62,  255, 96,  128, 56,  255, 60,  94,  34,
    255, 62,  92,  38,  255, 95,  117, 45,  255, 153, 163, 97,  255, 138, 145, 71,  255, 121, 138, 58,  255, 91,  117, 52,  255, 113, 136, 56,  255,
    85,  110, 40,  255, 69,  96,  42,  255, 97,  121, 48,  255, 125, 148, 68,  255, 140, 158, 73,  255, 131, 145, 58,  255, 115, 128, 49,  255, 73,
    91,  36,  255, 26,  48,  21,  255, 82,  79,  34,  255, 241, 230, 113, 255, 248, 245, 126, 255, 248, 235, 101, 255, 137, 130, 39,  255, 63,  92,
    34,  255, 52,  77,  25,  255, 74,  91,  34,  255, 134, 153, 65,  255, 128, 145, 58,  255, 126, 143, 60,  255, 117, 138, 55,  255, 112, 135, 53,
    255, 80,  104, 31,  255, 58,  86,  21,  255, 39,  68,  15,  255, 34,  52,  15,  255, 60,  75,  31,  255, 97,  117, 47,  255, 120, 149, 43,  255,
    135, 160, 55,  255, 99,  128, 48,  255, 145, 163, 60,  255, 172, 185, 74,  255, 125, 153, 55,  255, 52,  82,  29,  255, 39,  63,  21,  255, 63,
    90,  23,  255, 87,  124, 37,  255, 75,  112, 42,  255, 81,  109, 48,  255, 165, 192, 105, 255, 120, 150, 80,  255, 65,  89,  34,  255, 63,  87,
    37,  255, 53,  77,  39,  255, 49,  76,  37,  255, 102, 116, 53,  255, 200, 219, 156, 255, 148, 182, 138, 255, 128, 159, 104, 255, 165, 172, 77,
    255, 234, 233, 120, 255, 204, 214, 98,  255, 194, 208, 115, 255, 207, 221, 130, 255, 177, 194, 106, 255, 141, 155, 62,  255, 195, 210, 91,  255,
    181, 200, 87,  255, 169, 189, 84,  255, 160, 181, 84,  255, 157, 171, 73,  255, 147, 161, 58,  255, 188, 204, 124, 255, 174, 204, 148, 255, 160,
    181, 113, 255, 173, 189, 104, 255, 165, 182, 101, 255, 128, 151, 55,  255, 152, 173, 58,  255, 155, 177, 68,  255, 78,  107, 45,  255, 32,  42,
    29,  255, 29,  52,  19,  255, 52,  87,  28,  255, 49,  76,  29,  255, 36,  55,  25,  255, 62,  74,  36,  255, 90,  96,  45,  255, 117, 132, 69,
    255, 82,  112, 65,  255, 87,  119, 60,  255, 106, 137, 56,  255, 109, 140, 55,  255, 108, 139, 58,  255, 108, 139, 60,  255, 99,  127, 55,  255,
    53,  75,  39,  255, 34,  46,  33,  255, 31,  47,  26,  255, 83,  94,  36,  255, 195, 209, 113, 255, 195, 215, 118, 255, 181, 205, 108, 255, 173,
    191, 94,  255, 193, 203, 117, 255, 194, 213, 135, 255, 186, 208, 137, 255, 174, 199, 137, 255, 163, 194, 118, 255, 161, 185, 84,  255, 157, 178,
    106, 255, 192, 220, 164, 255, 192, 219, 157, 255, 204, 222, 152, 255, 187, 204, 132, 255, 119, 140, 68,  255, 71,  99,  36,  255, 41,  52,  32,
    255, 28,  39,  21,  255, 87,  103, 47,  255, 166, 178, 95,  255, 169, 188, 99,  255, 148, 174, 92,  255, 121, 157, 86,  255, 87,  118, 52,  255,
    130, 157, 73,  255, 128, 159, 65,  255, 131, 158, 62,  255, 158, 177, 73,  255, 185, 193, 80,  255, 131, 147, 62,  255, 91,  119, 47,  255, 102,
    122, 58,  255, 93,  119, 60,  255, 85,  112, 75,  255, 85,  113, 67,  255, 79,  106, 50,  255, 81,  117, 44,  255, 84,  124, 39,  255, 118, 148,
    47,  255, 168, 188, 65,  255, 152, 168, 72,  255, 57,  95,  28,  255, 80,  115, 38,  255, 34,  52,  26,  255, 38,  68,  31,  255, 53,  92,  38,
    255, 116, 139, 75,  255, 213, 226, 148, 255, 201, 222, 176, 255, 188, 213, 111, 255, 197, 218, 134, 255, 228, 239, 177, 255, 196, 207, 126, 255,
    134, 149, 74,  255, 118, 125, 65,  255, 197, 199, 117, 255, 146, 163, 114, 255, 140, 162, 115, 255, 135, 158, 109, 255, 137, 157, 101, 255, 112,
    122, 65,  255, 93,  117, 47,  255, 116, 149, 62,  255, 146, 172, 75,  255, 165, 184, 84,  255, 173, 177, 92,  255, 48,  60,  34,  255, 60,  87,
    38,  255, 181, 198, 115, 255, 186, 211, 134, 255, 185, 209, 124, 255, 181, 202, 110, 255, 177, 200, 104, 255, 162, 181, 87,  255, 140, 155, 77,
    255, 136, 157, 94,  255, 166, 190, 137, 255, 191, 217, 161, 255, 167, 196, 112, 255, 112, 130, 67,  255, 106, 119, 63,  255, 125, 139, 68,  255,
    186, 196, 106, 255, 217, 229, 157, 255, 162, 174, 118, 255, 135, 159, 60,  255, 142, 172, 87,  255, 165, 188, 102, 255, 184, 198, 101, 255, 116,
    146, 75,  255, 97,  141, 69,  255, 119, 156, 67,  255, 116, 142, 68,  255, 124, 155, 67,  255, 108, 142, 53,  255, 80,  111, 44,  255, 58,  77,
    48,  255, 47,  68,  50,  255, 63,  92,  52,  255, 49,  73,  34,  255, 34,  51,  25,  255, 32,  43,  25,  255, 34,  48,  25,  255, 115, 139, 68,
    255, 129, 154, 95,  255, 102, 134, 87,  255, 116, 144, 76,  255, 97,  121, 58,  255, 90,  120, 49,  255, 113, 143, 56,  255, 125, 155, 60,  255,
    136, 153, 69,  255, 47,  53,  31,  255, 29,  36,  23,  255, 73,  97,  49,  255, 79,  112, 55,  255, 65,  98,  40,  255, 63,  97,  34,  255, 69,
    105, 34,  255, 74,  104, 36,  255, 160, 190, 83,  255, 189, 209, 98,  255, 194, 209, 127, 255, 176, 206, 136, 255, 154, 162, 86,  255, 29,  37,
    19,  255, 25,  37,  21,  255, 29,  43,  25,  255, 34,  49,  26,  255, 39,  60,  23,  255, 34,  62,  17,  255, 135, 152, 90,  255, 208, 215, 120,
    255, 154, 175, 103, 255, 223, 227, 150, 255, 124, 130, 65,  255, 80,  97,  47,  255, 92,  117, 50,  255, 182, 196, 137, 255, 171, 195, 121, 255,
    145, 150, 89,  255, 60,  87,  36,  255, 47,  62,  31,  255, 45,  55,  31,  255, 55,  60,  34,  255, 6,   6,   12,  255, 17,  23,  21,  255, 43,
    58,  28,  255, 144, 170, 69,  255, 128, 155, 82,  255, 126, 160, 84,  255, 109, 151, 77,  255, 145, 182, 76,  255, 122, 147, 53,  255, 84,  107,
    47,  255, 89,  114, 42,  255, 79,  110, 43,  255, 69,  102, 46,  255, 55,  78,  28,  255, 179, 188, 131, 255, 205, 215, 166, 255, 177, 183, 138,
    255, 152, 159, 103, 255, 140, 157, 91,  255, 73,  98,  47,  255, 53,  82,  34,  255, 128, 144, 73,  255, 169, 181, 95,  255, 154, 168, 80,  255,
    144, 160, 73,  255, 132, 154, 63,  255, 129, 151, 60,  255, 111, 135, 52,  255, 38,  56,  23,  255, 129, 123, 58,  255, 241, 230, 127, 255, 138,
    134, 47,  255, 41,  63,  19,  255, 49,  74,  26,  255, 37,  52,  19,  255, 29,  33,  17,  255, 115, 130, 55,  255, 126, 148, 58,  255, 121, 141,
    56,  255, 121, 141, 55,  255, 104, 126, 45,  255, 91,  118, 41,  255, 69,  97,  26,  255, 42,  62,  19,  255, 47,  65,  23,  255, 105, 133, 65,
    255, 115, 141, 48,  255, 190, 197, 82,  255, 148, 172, 81,  255, 105, 135, 52,  255, 143, 159, 72,  255, 159, 176, 75,  255, 113, 143, 52,  255,
    52,  77,  34,  255, 50,  67,  32,  255, 41,  62,  23,  255, 53,  76,  28,  255, 25,  37,  21,  255, 19,  26,  17,  255, 78,  93,  36,  255, 117,
    142, 71,  255, 31,  55,  26,  255, 48,  80,  26,  255, 72,  108, 45,  255, 68,  97,  49,  255, 139, 159, 81,  255, 199, 218, 146, 255, 146, 178,
    133, 255, 129, 163, 116, 255, 91,  121, 50,  255, 133, 152, 92,  255, 103, 133, 60,  255, 90,  126, 26,  255, 138, 167, 48,  255, 139, 156, 71,
    255, 117, 136, 62,  255, 133, 149, 72,  255, 113, 123, 65,  255, 95,  107, 58,  255, 109, 130, 84,  255, 104, 122, 76,  255, 122, 131, 68,  255,
    117, 130, 74,  255, 86,  94,  58,  255, 72,  81,  39,  255, 115, 135, 44,  255, 138, 161, 50,  255, 152, 171, 60,  255, 166, 182, 73,  255, 172,
    190, 80,  255, 118, 145, 55,  255, 152, 165, 90,  255, 96,  116, 53,  255, 43,  80,  21,  255, 67,  98,  29,  255, 117, 130, 55,  255, 179, 192,
    97,  255, 217, 223, 117, 255, 231, 231, 128, 255, 136, 151, 72,  255, 63,  87,  34,  255, 81,  107, 47,  255, 91,  118, 47,  255, 90,  118, 48,
    255, 55,  74,  39,  255, 44,  62,  26,  255, 52,  72,  33,  255, 42,  62,  36,  255, 71,  76,  36,  255, 192, 204, 118, 255, 192, 214, 132, 255,
    167, 197, 119, 255, 162, 185, 120, 255, 222, 230, 164, 255, 206, 228, 164, 255, 183, 211, 133, 255, 182, 207, 125, 255, 176, 204, 126, 255, 160,
    189, 123, 255, 179, 199, 114, 255, 186, 210, 130, 255, 190, 211, 137, 255, 192, 207, 126, 255, 154, 176, 92,  255, 107, 136, 60,  255, 86,  114,
    47,  255, 62,  81,  36,  255, 57,  83,  34,  255, 75,  108, 45,  255, 83,  114, 48,  255, 68,  81,  48,  255, 69,  75,  47,  255, 84,  98,  44,
    255, 96,  121, 48,  255, 81,  106, 41,  255, 140, 158, 72,  255, 158, 174, 82,  255, 164, 179, 83,  255, 156, 175, 76,  255, 142, 163, 80,  255,
    105, 129, 65,  255, 101, 124, 53,  255, 56,  75,  33,  255, 49,  75,  31,  255, 101, 130, 78,  255, 87,  114, 68,  255, 67,  94,  41,  255, 68,
    106, 36,  255, 112, 139, 50,  255, 159, 175, 68,  255, 127, 146, 63,  255, 68,  104, 40,  255, 71,  117, 33,  255, 109, 145, 48,  255, 52,  75,
    31,  255, 51,  86,  34,  255, 60,  100, 39,  255, 175, 186, 127, 255, 235, 245, 185, 255, 183, 211, 155, 255, 185, 208, 123, 255, 216, 232, 136,
    255, 193, 212, 106, 255, 147, 176, 76,  255, 92,  125, 47,  255, 116, 130, 62,  255, 187, 192, 129, 255, 146, 164, 118, 255, 138, 162, 112, 255,
    136, 160, 107, 255, 111, 126, 71,  255, 196, 190, 96,  255, 199, 201, 101, 255, 180, 189, 102, 255, 175, 184, 100, 255, 126, 131, 78,  255, 52,
    58,  44,  255, 55,  84,  39,  255, 52,  87,  38,  255, 118, 140, 82,  255, 174, 189, 123, 255, 116, 127, 78,  255, 85,  97,  58,  255, 90,  102,
    55,  255, 65,  84,  42,  255, 36,  52,  28,  255, 26,  43,  19,  255, 47,  74,  26,  255, 95,  119, 69,  255, 160, 188, 108, 255, 163, 175, 101,
    255, 82,  101, 43,  255, 29,  51,  15,  255, 99,  122, 45,  255, 160, 186, 80,  255, 162, 174, 113, 255, 117, 146, 81,  255, 128, 164, 97,  255,
    169, 193, 100, 255, 183, 200, 101, 255, 167, 184, 87,  255, 103, 136, 55,  255, 109, 134, 71,  255, 88,  102, 56,  255, 90,  115, 52,  255, 94,
    121, 58,  255, 83,  105, 52,  255, 43,  62,  44,  255, 60,  89,  52,  255, 76,  107, 47,  255, 69,  99,  33,  255, 56,  82,  29,  255, 47,  68,
    28,  255, 52,  81,  26,  255, 50,  73,  26,  255, 146, 165, 95,  255, 142, 171, 108, 255, 107, 140, 75,  255, 99,  118, 56,  255, 91,  127, 62,
    255, 95,  131, 68,  255, 67,  91,  42,  255, 39,  56,  25,  255, 29,  36,  21,  255, 58,  74,  41,  255, 96,  127, 73,  255, 73,  104, 62,  255,
    66,  98,  49,  255, 58,  86,  37,  255, 55,  83,  36,  255, 57,  87,  31,  255, 79,  116, 38,  255, 137, 174, 67,  255, 186, 212, 109, 255, 187,
    210, 131, 255, 202, 214, 132, 255, 60,  69,  31,  255, 25,  44,  19,  255, 31,  49,  23,  255, 38,  55,  23,  255, 41,  63,  23,  255, 32,  52,
    17,  255, 110, 124, 69,  255, 203, 214, 115, 255, 183, 197, 126, 255, 213, 223, 162, 255, 206, 219, 153, 255, 210, 221, 156, 255, 208, 214, 147,
    255, 196, 206, 140, 255, 164, 186, 131, 255, 201, 210, 137, 255, 157, 155, 84,  255, 23,  37,  17,  255, 52,  62,  36,  255, 41,  44,  28,  255,
    6,   9,   15,  255, 23,  29,  19,  255, 52,  62,  32,  255, 149, 171, 80,  255, 162, 191, 98,  255, 160, 191, 96,  255, 173, 198, 86,  255, 150,
    165, 58,  255, 58,  72,  31,  255, 28,  38,  21,  255, 65,  92,  36,  255, 86,  114, 45,  255, 87,  115, 49,  255, 67,  103, 38,  255, 100, 119,
    52,  255, 211, 227, 168, 255, 192, 219, 170, 255, 213, 229, 172, 255, 238, 243, 181, 255, 203, 210, 155, 255, 119, 136, 87,  255, 182, 188, 95,
    255, 181, 187, 100, 255, 162, 174, 86,  255, 144, 162, 73,  255, 130, 150, 63,  255, 123, 145, 58,  255, 134, 155, 63,  255, 106, 126, 50,  255,
    73,  91,  32,  255, 108, 118, 45,  255, 85,  110, 43,  255, 75,  106, 43,  255, 43,  68,  25,  255, 34,  52,  23,  255, 32,  42,  25,  255, 65,
    75,  33,  255, 112, 131, 50,  255, 86,  103, 39,  255, 114, 136, 47,  255, 92,  119, 36,  255, 76,  104, 32,  255, 62,  92,  25,  255, 55,  82,
    26,  255, 67,  92,  31,  255, 91,  125, 44,  255, 105, 128, 48,  255, 155, 165, 75,  255, 109, 136, 62,  255, 55,  83,  32,  255, 112, 122, 47,
    255, 157, 176, 67,  255, 86,  117, 41,  255, 44,  67,  31,  255, 49,  72,  31,  255, 55,  73,  31,  255, 63,  84,  47,  255, 26,  39,  26,  255,
    26,  39,  23,  255, 25,  41,  21,  255, 47,  67,  31,  255, 48,  79,  36,  255, 58,  97,  31,  255, 73,  116, 36,  255, 95,  128, 53,  255, 137,
    163, 84,  255, 202, 215, 139, 255, 158, 188, 138, 255, 133, 167, 126, 255, 103, 137, 79,  255, 90,  122, 65,  255, 96,  132, 68,  255, 87,  124,
    36,  255, 128, 158, 38,  255, 139, 162, 62,  255, 117, 138, 55,  255, 146, 164, 65,  255, 172, 181, 78,  255, 165, 172, 83,  255, 109, 122, 69,
    255, 122, 134, 89,  255, 132, 142, 99,  255, 79,  98,  47,  255, 77,  95,  36,  255, 86,  110, 49,  255, 115, 134, 42,  255, 174, 183, 63,  255,
    184, 191, 72,  255, 174, 183, 69,  255, 178, 187, 77,  255, 125, 149, 60,  255, 151, 175, 80,  255, 164, 188, 99,  255, 111, 135, 58,  255, 116,
    132, 52,  255, 162, 187, 102, 255, 155, 184, 103, 255, 183, 196, 102, 255, 162, 178, 87,  255, 92,  120, 58,  255, 60,  87,  52,  255, 63,  92,
    52,  255, 71,  104, 52,  255, 38,  58,  32,  255, 17,  26,  19,  255, 41,  56,  28,  255, 62,  84,  36,  255, 52,  76,  29,  255, 136, 145, 73,
    255, 179, 205, 147, 255, 156, 188, 134, 255, 156, 188, 130, 255, 153, 182, 128, 255, 156, 183, 125, 255, 179, 197, 124, 255, 203, 220, 135, 255,
    200, 216, 121, 255, 198, 215, 118, 255, 166, 189, 107, 255, 162, 180, 98,  255, 167, 188, 101, 255, 100, 133, 68,  255, 86,  118, 62,  255, 108,
    144, 62,  255, 118, 151, 68,  255, 87,  122, 48,  255, 68,  102, 38,  255, 72,  107, 41,  255, 87,  129, 50,  255, 93,  125, 55,  255, 40,  48,
    31,  255, 48,  47,  38,  255, 53,  53,  31,  255, 154, 164, 91,  255, 91,  113, 55,  255, 101, 124, 60,  255, 115, 141, 85,  255, 102, 132, 73,
    255, 132, 156, 71,  255, 142, 173, 74,  255, 156, 186, 103, 255, 176, 195, 133, 255, 113, 133, 74,  255, 40,  68,  25,  255, 52,  76,  36,  255,
    88,  113, 56,  255, 105, 123, 55,  255, 125, 145, 60,  255, 124, 145, 55,  255, 84,  115, 48,  255, 52,  87,  42,  255, 68,  104, 43,  255, 81,
    124, 31,  255, 124, 156, 62,  255, 62,  94,  36,  255, 80,  117, 37,  255, 111, 143, 52,  255, 216, 222, 159, 255, 213, 229, 155, 255, 176, 200,
    123, 255, 207, 219, 154, 255, 159, 177, 98,  255, 120, 143, 55,  255, 90,  113, 39,  255, 49,  83,  25,  255, 108, 125, 62,  255, 164, 180, 125,
    255, 139, 162, 116, 255, 139, 160, 114, 255, 114, 132, 75,  255, 137, 151, 72,  255, 171, 179, 89,  255, 167, 174, 93,  255, 137, 152, 78,  255,
    85,  111, 49,  255, 25,  38,  26,  255, 28,  40,  26,  255, 68,  97,  47,  255, 60,  87,  42,  255, 79,  97,  55,  255, 58,  73,  47,  255, 29,
    47,  36,  255, 32,  48,  32,  255, 39,  53,  28,  255, 39,  58,  31,  255, 36,  52,  31,  255, 38,  53,  32,  255, 38,  62,  28,  255, 68,  90,
    38,  255, 168, 191, 98,  255, 101, 120, 53,  255, 36,  67,  21,  255, 98,  122, 37,  255, 194, 211, 65,  255, 200, 216, 76,  255, 160, 169, 90,
    255, 106, 133, 75,  255, 129, 166, 87,  255, 164, 186, 94,  255, 165, 185, 92,  255, 190, 203, 109, 255, 120, 134, 73,  255, 67,  98,  53,  255,
    72,  97,  44,  255, 110, 127, 73,  255, 203, 219, 145, 255, 167, 177, 113, 255, 102, 111, 67,  255, 69,  92,  50,  255, 81,  111, 38,  255, 87,
    119, 39,  255, 71,  102, 38,  255, 69,  97,  36,  255, 62,  82,  33,  255, 21,  25,  19,  255, 40,  58,  32,  255, 126, 152, 87,  255, 144, 171,
    116, 255, 110, 130, 84,  255, 77,  99,  55,  255, 49,  67,  29,  255, 29,  46,  21,  255, 29,  47,  23,  255, 41,  58,  29,  255, 58,  73,  36,
    255, 122, 142, 68,  255, 112, 139, 62,  255, 83,  115, 53,  255, 60,  97,  39,  255, 55,  87,  34,  255, 53,  81,  32,  255, 47,  75,  23,  255,
    41,  67,  21,  255, 89,  123, 55,  255, 166, 197, 107, 255, 197, 214, 123, 255, 56,  67,  26,  255, 43,  63,  23,  255, 55,  73,  31,  255, 44,
    60,  26,  255, 33,  47,  25,  255, 40,  52,  26,  255, 132, 154, 65,  255, 211, 223, 149, 255, 193, 213, 183, 255, 175, 199, 167, 255, 167, 191,
    143, 255, 172, 196, 136, 255, 180, 204, 138, 255, 194, 211, 138, 255, 181, 197, 135, 255, 172, 192, 133, 255, 235, 226, 140, 255, 84,  69,  41,
    255, 56,  75,  36,  255, 44,  51,  26,  255, 69,  83,  39,  255, 127, 144, 75,  255, 190, 200, 130, 255, 203, 216, 120, 255, 171, 189, 90,  255,
    138, 150, 58,  255, 127, 143, 41,  255, 90,  112, 37,  255, 48,  76,  47,  255, 42,  62,  41,  255, 62,  80,  36,  255, 94,  124, 52,  255, 90,
    120, 50,  255, 90,  120, 50,  255, 82,  111, 39,  255, 184, 194, 123, 255, 204, 228, 180, 255, 174, 206, 159, 255, 195, 216, 162, 255, 228, 238,
    178, 255, 216, 222, 145, 255, 210, 221, 121, 255, 191, 196, 102, 255, 173, 179, 84,  255, 155, 170, 80,  255, 154, 172, 83,  255, 179, 196, 97,
    255, 155, 173, 77,  255, 133, 155, 60,  255, 118, 142, 46,  255, 119, 142, 46,  255, 135, 154, 53,  255, 128, 151, 55,  255, 112, 141, 52,  255,
    99,  125, 50,  255, 103, 122, 52,  255, 83,  106, 43,  255, 39,  56,  26,  255, 34,  39,  17,  255, 106, 122, 37,  255, 97,  125, 39,  255, 84,
    119, 31,  255, 72,  113, 26,  255, 84,  119, 34,  255, 98,  124, 43,  255, 123, 147, 58,  255, 175, 191, 109, 255, 222, 228, 143, 255, 168, 187,
    98,  255, 67,  96,  36,  255, 106, 123, 42,  255, 137, 163, 55,  255, 47,  73,  34,  255, 40,  63,  32,  255, 40,  65,  31,  255, 56,  77,  31,
    255, 65,  89,  36,  255, 38,  58,  26,  255, 37,  68,  26,  255, 41,  74,  31,  255, 38,  68,  29,  255, 49,  83,  37,  255, 60,  99,  46,  255,
    68,  105, 45,  255, 110, 142, 68,  255, 118, 150, 74,  255, 194, 206, 133, 255, 169, 196, 147, 255, 139, 172, 132, 255, 125, 160, 113, 255, 111,
    143, 89,  255, 120, 150, 101, 255, 107, 140, 77,  255, 137, 161, 62,  255, 143, 165, 68,  255, 118, 142, 53,  255, 154, 174, 63,  255, 182, 195,
    82,  255, 119, 147, 62,  255, 42,  68,  23,  255, 53,  73,  36,  255, 55,  69,  46,  255, 104, 116, 45,  255, 139, 162, 67,  255, 150, 176, 82,
    255, 145, 174, 93,  255, 151, 178, 97,  255, 168, 192, 105, 255, 136, 151, 78,  255, 68,  75,  33,  255, 93,  112, 55,  255, 124, 151, 67,  255,
    140, 167, 94,  255, 151, 174, 89,  255, 162, 184, 89,  255, 147, 173, 80,  255, 109, 121, 60,  255, 68,  79,  38,  255, 81,  110, 65,  255, 72,
    104, 72,  255, 69,  101, 65,  255, 86,  118, 63,  255, 58,  84,  43,  255, 21,  31,  21,  255, 25,  34,  26,  255, 33,  46,  25,  255, 60,  86,
    36,  255, 69,  87,  31,  255, 197, 200, 120, 255, 205, 220, 142, 255, 177, 201, 124, 255, 161, 191, 112, 255, 157, 189, 106, 255, 140, 173, 92,
    255, 156, 175, 83,  255, 197, 216, 147, 255, 172, 203, 144, 255, 182, 208, 144, 255, 152, 184, 122, 255, 158, 179, 107, 255, 184, 201, 115, 255,
    112, 145, 71,  255, 83,  116, 68,  255, 115, 149, 74,  255, 134, 168, 79,  255, 108, 142, 63,  255, 65,  104, 34,  255, 67,  102, 36,  255, 89,
    124, 52,  255, 79,  109, 50,  255, 67,  96,  48,  255, 69,  77,  40,  255, 168, 174, 92,  255, 184, 202, 102, 255, 103, 124, 58,  255, 75,  105,
    53,  255, 87,  122, 76,  255, 100, 132, 67,  255, 149, 171, 76,  255, 112, 132, 58,  255, 98,  129, 45,  255, 142, 171, 97,  255, 179, 203, 144,
    255, 107, 132, 74,  255, 60,  90,  40,  255, 96,  115, 52,  255, 89,  111, 47,  255, 55,  75,  32,  255, 46,  68,  26,  255, 87,  127, 62,  255,
    74,  109, 58,  255, 140, 162, 94,  255, 173, 195, 101, 255, 122, 147, 56,  255, 89,  119, 32,  255, 119, 151, 47,  255, 111, 136, 47,  255, 185,
    200, 123, 255, 184, 199, 120, 255, 193, 204, 135, 255, 126, 148, 74,  255, 84,  116, 49,  255, 118, 143, 60,  255, 136, 155, 72,  255, 81,  112,
    52,  255, 100, 125, 52,  255, 153, 170, 118, 255, 131, 155, 109, 255, 111, 129, 73,  255, 142, 151, 71,  255, 119, 138, 63,  255, 39,  75,  19,
    255, 40,  82,  23,  255, 45,  86,  26,  255, 51,  92,  31,  255, 44,  68,  33,  255, 34,  51,  31,  255, 63,  95,  43,  255, 71,  92,  47,  255,
    75,  92,  55,  255, 41,  58,  41,  255, 39,  55,  36,  255, 44,  63,  36,  255, 50,  68,  36,  255, 39,  52,  31,  255, 36,  52,  31,  255, 42,
    65,  34,  255, 62,  94,  34,  255, 87,  118, 42,  255, 124, 150, 65,  255, 58,  90,  29,  255, 69,  104, 36,  255, 146, 170, 83,  255, 141, 168,
    84,  255, 201, 216, 110, 255, 149, 165, 77,  255, 97,  124, 63,  255, 129, 164, 80,  255, 162, 184, 95,  255, 158, 180, 91,  255, 183, 200, 108,
    255, 168, 175, 93,  255, 55,  73,  36,  255, 82,  109, 65,  255, 69,  90,  50,  255, 137, 151, 89,  255, 207, 233, 150, 255, 199, 224, 144, 255,
    162, 173, 101, 255, 56,  77,  29,  255, 52,  71,  29,  255, 55,  75,  36,  255, 37,  51,  26,  255, 9,   12,  17,  255, 6,   9,   15,  255, 40,
    55,  31,  255, 41,  62,  33,  255, 67,  92,  52,  255, 131, 153, 112, 255, 74,  82,  50,  255, 39,  68,  19,  255, 47,  76,  26,  255, 47,  74,
    31,  255, 46,  71,  31,  255, 47,  71,  26,  255, 60,  76,  33,  255, 124, 139, 62,  255, 137, 154, 60,  255, 117, 138, 58,  255, 160, 172, 86,
    255, 171, 181, 81,  255, 166, 181, 81,  255, 142, 157, 74,  255, 89,  92,  47,  255, 58,  78,  32,  255, 137, 163, 76,  255, 68,  84,  39,  255,
    175, 200, 92,  255, 133, 135, 63,  255, 31,  39,  21,  255, 17,  26,  17,  255, 96,  114, 49,  255, 193, 213, 113, 255, 191, 209, 167, 255, 178,
    203, 156, 255, 181, 201, 141, 255, 174, 191, 128, 255, 163, 184, 119, 255, 159, 181, 109, 255, 154, 181, 106, 255, 147, 179, 96,  255, 163, 187,
    109, 255, 229, 230, 149, 255, 200, 183, 117, 255, 90,  105, 39,  255, 104, 123, 52,  255, 145, 163, 92,  255, 183, 200, 148, 255, 179, 198, 146,
    255, 170, 187, 117, 255, 152, 172, 117, 255, 115, 142, 83,  255, 82,  115, 31,  255, 87,  112, 41,  255, 53,  83,  48,  255, 58,  91,  52,  255,
    48,  69,  32,  255, 91,  115, 50,  255, 106, 136, 58,  255, 97,  128, 53,  255, 97,  129, 52,  255, 129, 144, 67,  255, 221, 229, 161, 255, 198,
    225, 183, 255, 172, 205, 154, 255, 186, 211, 151, 255, 195, 217, 151, 255, 200, 219, 152, 255, 207, 210, 114, 255, 175, 178, 84,  255, 180, 191,
    86,  255, 190, 209, 93,  255, 183, 199, 95,  255, 147, 163, 65,  255, 177, 187, 65,  255, 185, 193, 62,  255, 180, 188, 67,  255, 190, 194, 60,
    255, 207, 206, 69,  255, 190, 196, 74,  255, 142, 159, 65,  255, 71,  86,  38,  255, 43,  56,  31,  255, 21,  31,  21,  255, 26,  37,  12,  255,
    128, 129, 39,  255, 172, 184, 77,  255, 116, 136, 41,  255, 171, 181, 71,  255, 197, 214, 98,  255, 177, 200, 102, 255, 178, 200, 111, 255, 183,
    208, 136, 255, 220, 227, 147, 255, 196, 205, 109, 255, 143, 163, 72,  255, 119, 145, 56,  255, 105, 138, 47,  255, 63,  99,  39,  255, 47,  73,
    37,  255, 40,  60,  23,  255, 74,  105, 26,  255, 102, 129, 39,  255, 44,  62,  26,  255, 63,  84,  31,  255, 71,  107, 40,  255, 62,  99,  36,
    255, 68,  108, 43,  255, 68,  107, 50,  255, 87,  117, 50,  255, 134, 169, 87,  255, 109, 151, 74,  255, 151, 172, 93,  255, 188, 208, 147, 255,
    151, 182, 145, 255, 140, 173, 134, 255, 130, 163, 113, 255, 123, 155, 109, 255, 118, 150, 106, 255, 130, 157, 84,  255, 141, 163, 82,  255, 139,
    161, 65,  255, 162, 182, 74,  255, 122, 151, 65,  255, 84,  120, 48,  255, 49,  73,  31,  255, 38,  55,  31,  255, 29,  40,  21,  255, 119, 124,
    47,  255, 155, 186, 84,  255, 123, 161, 80,  255, 112, 150, 84,  255, 106, 143, 90,  255, 107, 145, 97,  255, 126, 159, 95,  255, 146, 168, 81,
    255, 158, 177, 78,  255, 106, 135, 52,  255, 131, 159, 74,  255, 131, 158, 84,  255, 164, 182, 93,  255, 106, 139, 55,  255, 26,  44,  19,  255,
    72,  98,  55,  255, 83,  118, 76,  255, 87,  117, 75,  255, 97,  129, 71,  255, 73,  98,  53,  255, 25,  41,  21,  255, 29,  43,  26,  255, 28,
    39,  29,  255, 25,  34,  21,  255, 49,  65,  31,  255, 81,  106, 42,  255, 105, 129, 52,  255, 126, 151, 63,  255, 159, 179, 87,  255, 182, 198,
    99,  255, 151, 168, 86,  255, 108, 125, 60,  255, 95,  121, 47,  255, 165, 183, 104, 255, 183, 210, 150, 255, 171, 200, 146, 255, 160, 189, 133,
    255, 161, 181, 106, 255, 190, 205, 118, 255, 145, 172, 82,  255, 103, 136, 79,  255, 112, 145, 80,  255, 142, 176, 86,  255, 112, 149, 67,  255,
    76,  113, 41,  255, 76,  107, 42,  255, 71,  101, 42,  255, 74,  101, 42,  255, 115, 142, 68,  255, 160, 176, 90,  255, 172, 201, 95,  255, 178,
    194, 107, 255, 83,  104, 50,  255, 72,  104, 45,  255, 87,  120, 58,  255, 129, 159, 68,  255, 154, 178, 87,  255, 99,  125, 60,  255, 82,  113,
    43,  255, 115, 144, 60,  255, 154, 179, 104, 255, 165, 188, 106, 255, 128, 156, 65,  255, 102, 123, 53,  255, 39,  60,  26,  255, 26,  47,  23,
    255, 55,  69,  36,  255, 157, 186, 94,  255, 134, 164, 99,  255, 148, 171, 100, 255, 193, 217, 141, 255, 165, 186, 123, 255, 153, 173, 87,  255,
    119, 146, 82,  255, 97,  121, 81,  255, 133, 157, 86,  255, 114, 144, 75,  255, 118, 142, 55,  255, 90,  119, 41,  255, 77,  110, 40,  255, 104,
    133, 49,  255, 144, 164, 71,  255, 86,  108, 49,  255, 80,  92,  38,  255, 162, 173, 108, 255, 166, 180, 114, 255, 182, 190, 107, 255, 191, 201,
    116, 255, 134, 149, 81,  255, 98,  119, 48,  255, 62,  95,  28,  255, 52,  90,  26,  255, 57,  95,  29,  255, 51,  80,  33,  255, 34,  52,  34,
    255, 60,  87,  43,  255, 69,  86,  45,  255, 60,  76,  47,  255, 52,  79,  38,  255, 53,  84,  32,  255, 47,  76,  31,  255, 38,  58,  26,  255,
    55,  79,  39,  255, 65,  92,  47,  255, 52,  77,  36,  255, 60,  90,  36,  255, 80,  113, 38,  255, 84,  112, 48,  255, 65,  100, 40,  255, 144,
    163, 83,  255, 159, 186, 114, 255, 113, 149, 103, 255, 127, 159, 104, 255, 110, 142, 80,  255, 110, 135, 67,  255, 156, 183, 90,  255, 152, 178,
    90,  255, 154, 179, 86,  255, 173, 191, 99,  255, 178, 193, 103, 255, 100, 122, 50,  255, 120, 147, 77,  255, 128, 146, 87,  255, 104, 121, 62,
    255, 187, 203, 123, 255, 182, 214, 137, 255, 191, 221, 134, 255, 115, 118, 62,  255, 23,  32,  15,  255, 44,  55,  36,  255, 79,  84,  53,  255,
    67,  74,  47,  255, 121, 128, 79,  255, 106, 123, 60,  255, 42,  60,  31,  255, 31,  47,  31,  255, 78,  97,  68,  255, 55,  55,  40,  255, 43,
    67,  23,  255, 78,  111, 38,  255, 72,  105, 41,  255, 69,  102, 40,  255, 75,  103, 41,  255, 43,  53,  28,  255, 9,   12,  15,  255, 81,  89,
    49,  255, 231, 239, 141, 255, 222, 234, 138, 255, 201, 220, 116, 255, 193, 212, 104, 255, 192, 215, 106, 255, 186, 211, 102, 255, 131, 146, 63,
    255, 163, 180, 84,  255, 151, 170, 83,  255, 113, 131, 73,  255, 56,  65,  36,  255, 41,  52,  29,  255, 21,  37,  19,  255, 151, 170, 82,  255,
    207, 221, 137, 255, 168, 188, 115, 255, 153, 173, 87,  255, 109, 129, 48,  255, 129, 148, 60,  255, 212, 215, 143, 255, 188, 203, 143, 255, 182,
    201, 135, 255, 166, 187, 114, 255, 162, 184, 99,  255, 184, 203, 120, 255, 235, 232, 147, 255, 147, 152, 68,  255, 130, 150, 80,  255, 169, 189,
    134, 255, 173, 196, 136, 255, 175, 194, 130, 255, 186, 203, 132, 255, 182, 205, 118, 255, 173, 196, 102, 255, 127, 155, 67,  255, 96,  133, 50,
    255, 84,  117, 52,  255, 63,  90,  41,  255, 38,  62,  28,  255, 50,  67,  29,  255, 96,  113, 48,  255, 114, 141, 58,  255, 114, 143, 60,  255,
    119, 142, 60,  255, 175, 179, 99,  255, 230, 245, 193, 255, 195, 225, 184, 255, 173, 203, 149, 255, 182, 209, 151, 255, 168, 199, 143, 255, 187,
    202, 130, 255, 183, 191, 82,  255, 164, 194, 60,  255, 173, 197, 94,  255, 155, 171, 73,  255, 178, 185, 74,  255, 212, 209, 76,  255, 209, 207,
    75,  255, 210, 208, 84,  255, 201, 202, 71,  255, 209, 207, 69,  255, 226, 218, 84,  255, 185, 191, 79,  255, 120, 136, 58,  255, 65,  68,  31,
    255, 55,  58,  26,  255, 56,  65,  25,  255, 133, 136, 46,  255, 150, 163, 73,  255, 156, 146, 60,  255, 233, 224, 112, 255, 213, 214, 110, 255,
    189, 203, 115, 255, 194, 215, 128, 255, 203, 220, 159, 255, 228, 232, 157, 255, 227, 224, 127, 255, 228, 225, 113, 255, 206, 210, 99,  255, 116,
    141, 63,  255, 73,  106, 39,  255, 45,  65,  31,  255, 62,  79,  26,  255, 94,  121, 33,  255, 126, 145, 53,  255, 143, 150, 71,  255, 181, 186,
    95,  255, 116, 143, 71,  255, 57,  92,  33,  255, 63,  97,  38,  255, 47,  65,  33,  255, 123, 131, 69,  255, 156, 188, 96,  255, 123, 162, 81,
    255, 105, 140, 65,  255, 186, 199, 117, 255, 192, 210, 153, 255, 144, 175, 139, 255, 135, 167, 131, 255, 129, 161, 111, 255, 135, 166, 125, 255,
    130, 161, 112, 255, 140, 163, 93,  255, 106, 131, 55,  255, 50,  63,  36,  255, 31,  40,  26,  255, 52,  60,  34,  255, 21,  23,  21,  255, 17,
    19,  19,  255, 12,  12,  15,  255, 53,  56,  25,  255, 137, 163, 68,  255, 148, 173, 74,  255, 142, 170, 68,  255, 132, 163, 65,  255, 127, 163,
    73,  255, 159, 181, 84,  255, 177, 204, 97,  255, 138, 178, 75,  255, 120, 156, 68,  255, 150, 173, 62,  255, 151, 171, 84,  255, 154, 173, 98,
    255, 127, 152, 74,  255, 68,  94,  47,  255, 83,  117, 67,  255, 78,  108, 58,  255, 75,  98,  50,  255, 55,  76,  41,  255, 29,  51,  25,  255,
    38,  65,  23,  255, 47,  75,  31,  255, 31,  44,  29,  255, 28,  39,  26,  255, 23,  29,  23,  255, 67,  87,  29,  255, 76,  108, 25,  255, 100,
    137, 60,  255, 104, 144, 65,  255, 82,  112, 40,  255, 41,  65,  31,  255, 34,  47,  28,  255, 34,  48,  26,  255, 99,  125, 47,  255, 177, 200,
    122, 255, 166, 199, 143, 255, 158, 189, 129, 255, 159, 181, 103, 255, 171, 187, 109, 255, 139, 165, 76,  255, 146, 172, 95,  255, 127, 156, 89,
    255, 148, 180, 93,  255, 103, 138, 67,  255, 80,  114, 44,  255, 68,  97,  41,  255, 63,  91,  37,  255, 134, 154, 69,  255, 175, 195, 104, 255,
    185, 207, 102, 255, 166, 198, 95,  255, 163, 184, 107, 255, 58,  89,  38,  255, 55,  87,  31,  255, 80,  110, 34,  255, 85,  104, 47,  255, 146,
    162, 93,  255, 167, 193, 110, 255, 126, 158, 103, 255, 108, 140, 98,  255, 129, 159, 97,  255, 128, 161, 71,  255, 104, 132, 50,  255, 60,  74,
    36,  255, 29,  48,  21,  255, 33,  55,  23,  255, 29,  43,  23,  255, 102, 119, 47,  255, 190, 211, 103, 255, 188, 209, 108, 255, 172, 202, 128,
    255, 178, 211, 174, 255, 201, 223, 170, 255, 230, 232, 144, 255, 201, 206, 115, 255, 138, 162, 98,  255, 94,  136, 74,  255, 124, 150, 60,  255,
    102, 128, 49,  255, 73,  105, 39,  255, 90,  115, 36,  255, 141, 157, 62,  255, 124, 131, 80,  255, 175, 191, 132, 255, 178, 205, 140, 255, 168,
    197, 139, 255, 162, 192, 133, 255, 155, 186, 128, 255, 154, 185, 125, 255, 161, 185, 113, 255, 157, 174, 91,  255, 98,  123, 47,  255, 52,  93,
    23,  255, 51,  81,  29,  255, 45,  62,  39,  255, 58,  75,  42,  255, 69,  86,  55,  255, 69,  94,  46,  255, 82,  113, 47,  255, 119, 139, 71,
    255, 138, 150, 90,  255, 132, 147, 80,  255, 123, 148, 72,  255, 92,  123, 55,  255, 63,  87,  40,  255, 29,  37,  26,  255, 45,  65,  28,  255,
    85,  113, 47,  255, 97,  120, 55,  255, 185, 204, 123, 255, 148, 181, 124, 255, 138, 171, 119, 255, 128, 163, 108, 255, 124, 159, 96,  255, 125,
    145, 77,  255, 150, 176, 93,  255, 155, 181, 97,  255, 157, 182, 87,  255, 167, 187, 94,  255, 179, 196, 105, 255, 119, 146, 78,  255, 96,  131,
    75,  255, 130, 162, 90,  255, 137, 162, 90,  255, 130, 148, 82,  255, 206, 217, 128, 255, 176, 209, 120, 255, 186, 216, 124, 255, 93,  95,  49,
    255, 110, 129, 72,  255, 202, 226, 112, 255, 187, 213, 94,  255, 172, 197, 78,  255, 122, 148, 43,  255, 118, 131, 62,  255, 71,  75,  48,  255,
    50,  58,  38,  255, 47,  47,  37,  255, 15,  21,  15,  255, 55,  77,  31,  255, 69,  91,  36,  255, 63,  83,  34,  255, 43,  55,  28,  255, 32,
    37,  25,  255, 12,  15,  15,  255, 21,  26,  21,  255, 93,  102, 67,  255, 149, 165, 108, 255, 175, 190, 121, 255, 180, 196, 108, 255, 165, 182,
    90,  255, 99,  123, 55,  255, 115, 134, 69,  255, 136, 152, 75,  255, 60,  82,  32,  255, 26,  37,  23,  255, 36,  52,  33,  255, 47,  58,  34,
    255, 36,  58,  29,  255, 191, 204, 114, 255, 165, 184, 87,  255, 114, 146, 50,  255, 102, 136, 53,  255, 119, 155, 74,  255, 212, 224, 130, 255,
    211, 214, 155, 255, 156, 183, 142, 255, 154, 179, 135, 255, 161, 183, 144, 255, 169, 189, 151, 255, 150, 176, 94,  255, 173, 194, 77,  255, 163,
    169, 90,  255, 167, 185, 98,  255, 160, 184, 89,  255, 128, 148, 82,  255, 115, 135, 76,  255, 157, 174, 84,  255, 143, 157, 81,  255, 103, 118,
    60,  255, 87,  106, 52,  255, 85,  115, 55,  255, 97,  126, 53,  255, 92,  117, 43,  255, 62,  94,  44,  255, 29,  49,  21,  255, 15,  15,  12,
    255, 63,  74,  31,  255, 103, 122, 49,  255, 102, 122, 52,  255, 85,  105, 34,  255, 178, 177, 106, 255, 221, 241, 191, 255, 202, 227, 191, 255,
    169, 200, 150, 255, 170, 199, 127, 255, 173, 201, 136, 255, 175, 202, 83,  255, 157, 186, 65,  255, 148, 151, 67,  255, 128, 132, 55,  255, 140,
    146, 55,  255, 216, 211, 91,  255, 226, 220, 96,  255, 226, 220, 97,  255, 220, 218, 97,  255, 224, 220, 99,  255, 234, 227, 108, 255, 185, 189,
    87,  255, 187, 194, 76,  255, 248, 239, 83,  255, 216, 218, 77,  255, 184, 192, 73,  255, 173, 185, 77,  255, 162, 162, 69,  255, 217, 207, 101,
    255, 213, 216, 100, 255, 199, 195, 98,  255, 174, 176, 99,  255, 227, 225, 139, 255, 221, 231, 162, 255, 221, 225, 144, 255, 224, 224, 128, 255,
    211, 214, 108, 255, 156, 175, 72,  255, 103, 129, 50,  255, 67,  98,  31,  255, 49,  76,  17,  255, 85,  110, 29,  255, 124, 141, 47,  255, 176,
    185, 91,  255, 191, 204, 104, 255, 200, 209, 108, 255, 141, 156, 87,  255, 31,  58,  28,  255, 41,  62,  26,  255, 69,  82,  29,  255, 157, 162,
    83,  255, 172, 192, 101, 255, 138, 171, 82,  255, 108, 148, 72,  255, 134, 157, 80,  255, 214, 224, 151, 255, 186, 206, 146, 255, 150, 179, 139,
    255, 140, 170, 135, 255, 146, 176, 133, 255, 145, 175, 139, 255, 142, 167, 103, 255, 67,  90,  52,  255, 12,  19,  17,  255, 15,  17,  21,  255,
    32,  28,  23,  255, 68,  68,  40,  255, 26,  33,  25,  255, 17,  21,  17,  255, 19,  21,  19,  255, 49,  55,  23,  255, 108, 117, 47,  255, 147,
    159, 63,  255, 168, 179, 78,  255, 123, 138, 65,  255, 155, 165, 63,  255, 194, 216, 106, 255, 127, 167, 90,  255, 127, 166, 91,  255, 158, 185,
    76,  255, 221, 226, 98,  255, 179, 194, 97,  255, 132, 158, 86,  255, 71,  97,  56,  255, 40,  63,  26,  255, 34,  52,  25,  255, 28,  46,  23,
    255, 29,  47,  25,  255, 44,  73,  26,  255, 60,  102, 31,  255, 58,  92,  34,  255, 31,  48,  29,  255, 41,  56,  31,  255, 32,  47,  26,  255,
    42,  58,  21,  255, 75,  108, 26,  255, 104, 142, 62,  255, 109, 148, 65,  255, 79,  111, 43,  255, 55,  77,  32,  255, 53,  73,  32,  255, 52,
    60,  33,  255, 100, 126, 39,  255, 143, 171, 62,  255, 172, 201, 136, 255, 156, 189, 135, 255, 166, 186, 108, 255, 148, 169, 87,  255, 105, 130,
    58,  255, 157, 180, 95,  255, 151, 177, 95,  255, 151, 183, 98,  255, 99,  129, 71,  255, 80,  112, 48,  255, 71,  99,  38,  255, 101, 122, 56,
    255, 193, 205, 119, 255, 171, 193, 116, 255, 188, 209, 106, 255, 191, 214, 114, 255, 119, 147, 74,  255, 87,  117, 48,  255, 87,  109, 44,  255,
    86,  96,  80,  255, 17,  23,  23,  255, 34,  41,  25,  255, 143, 154, 91,  255, 174, 194, 124, 255, 167, 193, 133, 255, 174, 197, 131, 255, 163,
    190, 110, 255, 143, 173, 93,  255, 112, 134, 72,  255, 93,  109, 55,  255, 65,  87,  36,  255, 36,  53,  28,  255, 25,  39,  21,  255, 109, 135,
    58,  255, 168, 197, 89,  255, 158, 190, 91,  255, 170, 201, 125, 255, 186, 214, 177, 255, 222, 228, 158, 255, 248, 246, 140, 255, 243, 241, 136,
    255, 152, 174, 92,  255, 128, 151, 55,  255, 102, 129, 48,  255, 92,  114, 42,  255, 187, 187, 82,  255, 185, 194, 99,  255, 193, 210, 135, 255,
    190, 214, 142, 255, 183, 209, 140, 255, 172, 200, 139, 255, 160, 190, 135, 255, 153, 185, 132, 255, 153, 184, 130, 255, 147, 177, 125, 255, 147,
    177, 118, 255, 153, 176, 102, 255, 110, 134, 55,  255, 52,  80,  28,  255, 58,  75,  40,  255, 53,  68,  42,  255, 95,  108, 67,  255, 146, 162,
    99,  255, 178, 195, 126, 255, 187, 209, 141, 255, 178, 206, 139, 255, 174, 202, 133, 255, 189, 207, 129, 255, 179, 194, 107, 255, 120, 146, 68,
    255, 79,  107, 47,  255, 39,  55,  26,  255, 71,  87,  40,  255, 133, 147, 78,  255, 169, 194, 135, 255, 155, 185, 138, 255, 154, 182, 134, 255,
    142, 176, 121, 255, 163, 193, 120, 255, 138, 155, 78,  255, 136, 163, 91,  255, 159, 185, 100, 255, 157, 181, 89,  255, 167, 189, 98,  255, 185,
    202, 110, 255, 117, 140, 82,  255, 75,  112, 67,  255, 101, 136, 81,  255, 152, 176, 98,  255, 135, 151, 93,  255, 103, 124, 80,  255, 187, 203,
    108, 255, 186, 216, 110, 255, 162, 185, 93,  255, 150, 176, 85,  255, 183, 210, 94,  255, 181, 196, 97,  255, 189, 200, 115, 255, 209, 219, 143,
    255, 211, 225, 153, 255, 213, 222, 151, 255, 186, 190, 127, 255, 132, 130, 89,  255, 29,  29,  25,  255, 6,   9,   15,  255, 28,  31,  25,  255,
    78,  89,  52,  255, 101, 121, 65,  255, 125, 151, 86,  255, 91,  107, 62,  255, 12,  15,  15,  255, 3,   9,   12,  255, 15,  21,  15,  255, 38,
    52,  29,  255, 65,  87,  42,  255, 63,  87,  36,  255, 93,  112, 58,  255, 186, 202, 104, 255, 105, 116, 52,  255, 41,  58,  26,  255, 56,  77,
    34,  255, 50,  65,  40,  255, 44,  60,  34,  255, 47,  75,  36,  255, 195, 210, 128, 255, 221, 227, 148, 255, 174, 199, 129, 255, 172, 198, 127,
    255, 196, 219, 149, 255, 218, 223, 138, 255, 208, 211, 142, 255, 154, 181, 139, 255, 155, 179, 147, 255, 161, 185, 153, 255, 163, 186, 162, 255,
    158, 179, 139, 255, 129, 154, 68,  255, 153, 169, 86,  255, 135, 151, 75,  255, 91,  115, 60,  255, 73,  102, 58,  255, 106, 134, 60,  255, 125,
    145, 65,  255, 86,  104, 49,  255, 65,  91,  47,  255, 72,  100, 56,  255, 73,  101, 50,  255, 75,  98,  47,  255, 91,  119, 52,  255, 129, 159,
    80,  255, 121, 143, 83,  255, 121, 129, 85,  255, 176, 180, 115, 255, 208, 212, 130, 255, 209, 214, 126, 255, 183, 193, 114, 255, 140, 151, 80,
    255, 166, 170, 103, 255, 210, 225, 166, 255, 202, 224, 160, 255, 191, 213, 106, 255, 196, 215, 154, 255, 166, 193, 90,  255, 106, 128, 41,  255,
    43,  67,  15,  255, 15,  21,  12,  255, 52,  60,  31,  255, 172, 185, 90,  255, 238, 230, 128, 255, 245, 239, 146, 255, 243, 239, 157, 255, 241,
    239, 159, 255, 250, 246, 163, 255, 228, 230, 152, 255, 178, 189, 89,  255, 145, 162, 56,  255, 84,  110, 33,  255, 53,  77,  26,  255, 75,  85,
    29,  255, 184, 174, 73,  255, 222, 218, 106, 255, 212, 209, 91,  255, 241, 233, 144, 255, 194, 203, 121, 255, 216, 216, 126, 255, 222, 225, 134,
    255, 223, 225, 130, 255, 186, 199, 95,  255, 139, 163, 55,  255, 132, 156, 58,  255, 144, 167, 72,  255, 129, 152, 68,  255, 125, 146, 65,  255,
    138, 156, 60,  255, 168, 181, 84,  255, 188, 201, 105, 255, 194, 203, 108, 255, 208, 210, 110, 255, 169, 185, 101, 255, 99,  128, 62,  255, 147,
    161, 68,  255, 183, 202, 83,  255, 185, 205, 82,  255, 192, 209, 91,  255, 173, 195, 96,  255, 127, 162, 79,  255, 108, 144, 62,  255, 158, 167,
    87,  255, 197, 212, 156, 255, 174, 195, 151, 255, 163, 191, 153, 255, 152, 183, 145, 255, 145, 174, 146, 255, 139, 165, 114, 255, 60,  82,  50,
    255, 9,   15,  17,  255, 23,  17,  15,  255, 152, 146, 76,  255, 129, 144, 68,  255, 25,  26,  21,  255, 19,  21,  19,  255, 23,  29,  23,  255,
    33,  39,  26,  255, 40,  55,  23,  255, 52,  83,  25,  255, 60,  83,  31,  255, 26,  37,  23,  255, 72,  78,  29,  255, 203, 215, 102, 255, 162,
    193, 114, 255, 149, 178, 112, 255, 189, 206, 108, 255, 217, 224, 111, 255, 158, 180, 89,  255, 93,  128, 67,  255, 44,  72,  37,  255, 52,  84,
    34,  255, 55,  87,  42,  255, 47,  76,  37,  255, 51,  81,  37,  255, 57,  95,  36,  255, 76,  123, 38,  255, 56,  82,  36,  255, 40,  55,  28,
    255, 66,  95,  44,  255, 58,  83,  39,  255, 41,  60,  26,  255, 47,  74,  19,  255, 91,  124, 44,  255, 136, 171, 68,  255, 118, 156, 50,  255,
    112, 154, 46,  255, 101, 140, 41,  255, 100, 128, 44,  255, 122, 158, 62,  255, 127, 163, 58,  255, 159, 185, 89,  255, 172, 200, 130, 255, 163,
    188, 101, 255, 122, 151, 63,  255, 81,  113, 41,  255, 110, 135, 60,  255, 148, 174, 90,  255, 157, 185, 102, 255, 98,  128, 75,  255, 75,  107,
    55,  255, 74,  106, 42,  255, 119, 134, 69,  255, 199, 211, 128, 255, 189, 203, 123, 255, 175, 198, 99,  255, 186, 203, 109, 255, 157, 176, 89,
    255, 166, 186, 76,  255, 148, 169, 72,  255, 127, 140, 124, 255, 33,  39,  37,  255, 9,   12,  15,  255, 9,   12,  12,  255, 88,  108, 58,  255,
    155, 188, 111, 255, 163, 193, 114, 255, 146, 179, 110, 255, 122, 163, 103, 255, 123, 163, 102, 255, 119, 152, 87,  255, 132, 153, 77,  255, 104,
    121, 58,  255, 31,  44,  25,  255, 34,  48,  26,  255, 129, 158, 72,  255, 142, 179, 75,  255, 154, 179, 90,  255, 217, 222, 151, 255, 172, 185,
    116, 255, 187, 206, 151, 255, 213, 223, 152, 255, 148, 164, 78,  255, 82,  103, 41,  255, 129, 145, 62,  255, 105, 123, 48,  255, 139, 153, 67,
    255, 153, 164, 90,  255, 164, 173, 101, 255, 161, 168, 100, 255, 113, 126, 68,  255, 156, 175, 97,  255, 181, 202, 117, 255, 171, 196, 113, 255,
    156, 184, 111, 255, 147, 177, 109, 255, 136, 168, 107, 255, 123, 156, 98,  255, 131, 160, 91,  255, 98,  115, 56,  255, 40,  53,  29,  255, 55,
    67,  42,  255, 122, 133, 94,  255, 196, 214, 158, 255, 188, 212, 155, 255, 169, 198, 143, 255, 162, 193, 139, 255, 161, 190, 137, 255, 157, 188,
    134, 255, 169, 196, 132, 255, 173, 195, 114, 255, 108, 136, 63,  255, 91,  119, 52,  255, 112, 131, 58,  255, 169, 188, 116, 255, 171, 198, 150,
    255, 164, 194, 148, 255, 173, 202, 146, 255, 179, 200, 132, 255, 123, 144, 74,  255, 109, 137, 65,  255, 135, 162, 89,  255, 169, 190, 110, 255,
    165, 187, 93,  255, 171, 194, 100, 255, 188, 204, 112, 255, 111, 135, 69,  255, 75,  118, 49,  255, 150, 178, 76,  255, 137, 157, 87,  255, 68,
    91,  68,  255, 107, 131, 72,  255, 134, 161, 81,  255, 154, 180, 97,  255, 161, 190, 91,  255, 159, 182, 95,  255, 205, 215, 128, 255, 204, 218,
    146, 255, 196, 218, 153, 255, 189, 215, 157, 255, 188, 217, 155, 255, 193, 219, 157, 255, 218, 238, 169, 255, 209, 220, 145, 255, 91,  108, 52,
    255, 50,  71,  31,  255, 126, 147, 81,  255, 134, 163, 98,  255, 115, 150, 87,  255, 93,  121, 68,  255, 31,  53,  21,  255, 26,  38,  17,  255,
    17,  19,  17,  255, 17,  31,  17,  255, 28,  49,  21,  255, 119, 142, 73,  255, 199, 212, 117, 255, 196, 216, 111, 255, 169, 196, 96,  255, 175,
    193, 102, 255, 156, 169, 83,  255, 108, 125, 52,  255, 74,  97,  39,  255, 65,  87,  38,  255, 41,  75,  26,  255, 74,  106, 45,  255, 215, 220,
    157, 255, 217, 230, 185, 255, 205, 221, 178, 255, 207, 223, 158, 255, 162, 169, 87,  255, 214, 216, 132, 255, 180, 194, 143, 255, 153, 178, 148,
    255, 162, 185, 153, 255, 162, 186, 160, 255, 166, 189, 165, 255, 122, 144, 74,  255, 145, 161, 81,  255, 136, 143, 86,  255, 74,  102, 65,  255,
    82,  112, 62,  255, 96,  120, 58,  255, 91,  113, 49,  255, 97,  124, 48,  255, 65,  99,  41,  255, 82,  120, 55,  255, 93,  128, 63,  255, 109,
    137, 67,  255, 163, 182, 106, 255, 171, 188, 115, 255, 192, 207, 144, 255, 186, 207, 143, 255, 175, 198, 139, 255, 169, 192, 137, 255, 184, 202,
    137, 255, 205, 213, 138, 255, 231, 233, 140, 255, 205, 211, 106, 255, 193, 210, 80,  255, 182, 206, 67,  255, 162, 173, 87,  255, 147, 160, 77,
    255, 120, 140, 60,  255, 95,  130, 52,  255, 150, 178, 73,  255, 126, 142, 62,  255, 120, 133, 82,  255, 220, 227, 144, 255, 220, 226, 152, 255,
    212, 223, 160, 255, 212, 228, 168, 255, 218, 233, 175, 255, 217, 231, 175, 255, 224, 232, 172, 255, 91,  111, 55,  255, 68,  95,  25,  255, 80,
    104, 33,  255, 90,  112, 40,  255, 113, 119, 43,  255, 193, 189, 81,  255, 222, 214, 99,  255, 233, 222, 124, 255, 241, 238, 159, 255, 175, 187,
    95,  255, 214, 214, 114, 255, 224, 224, 131, 255, 186, 199, 87,  255, 142, 168, 58,  255, 136, 168, 73,  255, 147, 179, 86,  255, 151, 183, 96,
    255, 151, 182, 104, 255, 190, 210, 120, 255, 186, 207, 115, 255, 177, 193, 100, 255, 189, 201, 107, 255, 200, 206, 110, 255, 214, 216, 115, 255,
    180, 191, 102, 255, 166, 186, 77,  255, 193, 214, 93,  255, 183, 207, 92,  255, 181, 204, 87,  255, 188, 208, 94,  255, 149, 173, 80,  255, 123,
    157, 65,  255, 100, 123, 48,  255, 121, 128, 43,  255, 193, 202, 101, 255, 178, 194, 128, 255, 182, 197, 168, 255, 162, 191, 160, 255, 144, 177,
    138, 255, 103, 135, 85,  255, 21,  28,  19,  255, 73,  71,  39,  255, 130, 139, 74,  255, 125, 139, 76,  255, 89,  104, 52,  255, 123, 142, 77,
    255, 50,  63,  42,  255, 15,  19,  21,  255, 28,  37,  23,  255, 50,  72,  26,  255, 53,  83,  25,  255, 55,  84,  25,  255, 47,  65,  29,  255,
    9,   15,  15,  255, 65,  62,  29,  255, 181, 186, 106, 255, 184, 193, 125, 255, 164, 178, 86,  255, 115, 144, 60,  255, 100, 133, 63,  255, 69,
    103, 52,  255, 47,  76,  52,  255, 47,  73,  36,  255, 65,  99,  39,  255, 74,  113, 48,  255, 68,  106, 50,  255, 67,  106, 47,  255, 82,  124,
    44,  255, 38,  53,  29,  255, 47,  63,  31,  255, 79,  108, 47,  255, 71,  101, 47,  255, 62,  83,  36,  255, 52,  68,  31,  255, 69,  83,  37,
    255, 146, 179, 74,  255, 133, 168, 62,  255, 123, 158, 55,  255, 98,  134, 47,  255, 86,  124, 43,  255, 99,  137, 49,  255, 122, 157, 62,  255,
    132, 161, 65,  255, 147, 170, 82,  255, 128, 155, 67,  255, 111, 135, 60,  255, 87,  119, 39,  255, 149, 168, 94,  255, 158, 176, 95,  255, 147,
    177, 94,  255, 87,  122, 78,  255, 71,  102, 63,  255, 72,  106, 42,  255, 82,  106, 42,  255, 194, 198, 113, 255, 217, 225, 139, 255, 169, 192,
    105, 255, 194, 210, 117, 255, 195, 205, 110, 255, 123, 139, 60,  255, 69,  87,  31,  255, 85,  109, 52,  255, 65,  84,  42,  255, 47,  65,  21,
    255, 89,  112, 44,  255, 134, 165, 87,  255, 138, 171, 112, 255, 121, 158, 109, 255, 121, 159, 114, 255, 122, 161, 112, 255, 121, 159, 106, 255,
    119, 159, 105, 255, 118, 150, 94,  255, 131, 154, 80,  255, 101, 118, 58,  255, 34,  47,  23,  255, 47,  63,  25,  255, 149, 169, 81,  255, 220,
    225, 144, 255, 198, 208, 134, 255, 154, 179, 127, 255, 166, 195, 161, 255, 198, 214, 156, 255, 181, 184, 116, 255, 191, 195, 128, 255, 224, 224,
    138, 255, 223, 220, 122, 255, 159, 160, 77,  255, 65,  91,  33,  255, 93,  123, 45,  255, 83,  110, 42,  255, 36,  53,  26,  255, 52,  72,  34,
    255, 68,  80,  42,  255, 133, 149, 76,  255, 161, 180, 91,  255, 167, 185, 94,  255, 161, 186, 96,  255, 147, 176, 89,  255, 129, 162, 79,  255,
    103, 133, 68,  255, 56,  73,  34,  255, 101, 117, 62,  255, 23,  29,  21,  255, 106, 128, 68,  255, 179, 199, 124, 255, 198, 215, 139, 255, 212,
    226, 150, 255, 191, 211, 141, 255, 169, 196, 129, 255, 159, 187, 125, 255, 161, 189, 124, 255, 167, 187, 106, 255, 122, 144, 65,  255, 100, 128,
    52,  255, 162, 187, 131, 255, 181, 208, 163, 255, 193, 212, 152, 255, 170, 182, 112, 255, 96,  107, 52,  255, 71,  92,  42,  255, 131, 155, 80,
    255, 151, 170, 91,  255, 176, 199, 104, 255, 162, 188, 84,  255, 175, 196, 97,  255, 180, 199, 112, 255, 142, 164, 86,  255, 133, 161, 62,  255,
    144, 162, 76,  255, 97,  122, 62,  255, 100, 126, 69,  255, 157, 181, 97,  255, 140, 167, 95,  255, 115, 150, 95,  255, 128, 153, 84,  255, 185,
    199, 104, 255, 171, 204, 87,  255, 169, 203, 91,  255, 199, 220, 115, 255, 202, 220, 146, 255, 199, 219, 156, 255, 212, 224, 155, 255, 170, 180,
    102, 255, 101, 118, 55,  255, 71,  91,  38,  255, 116, 145, 80,  255, 133, 167, 105, 255, 134, 162, 109, 255, 161, 178, 110, 255, 127, 137, 79,
    255, 127, 133, 75,  255, 183, 190, 134, 255, 183, 180, 124, 255, 47,  44,  23,  255, 15,  31,  17,  255, 111, 134, 69,  255, 205, 231, 107, 255,
    192, 212, 102, 255, 163, 182, 108, 255, 160, 181, 113, 255, 158, 181, 100, 255, 144, 168, 80,  255, 103, 134, 49,  255, 101, 136, 55,  255, 71,
    98,  34,  255, 42,  81,  28,  255, 100, 128, 69,  255, 207, 218, 162, 255, 215, 226, 187, 255, 205, 217, 165, 255, 131, 143, 68,  255, 172, 184,
    99,  255, 221, 223, 145, 255, 188, 200, 141, 255, 206, 214, 142, 255, 211, 214, 137, 255, 189, 200, 144, 255, 131, 153, 80,  255, 190, 198, 119,
    255, 122, 131, 87,  255, 75,  98,  69,  255, 68,  92,  46,  255, 79,  104, 39,  255, 68,  96,  38,  255, 114, 146, 50,  255, 124, 158, 50,  255,
    101, 136, 53,  255, 89,  125, 72,  255, 122, 147, 91,  255, 182, 191, 122, 255, 197, 215, 145, 255, 172, 197, 138, 255, 158, 189, 138, 255, 157,
    189, 141, 255, 155, 187, 138, 255, 155, 185, 138, 255, 163, 190, 138, 255, 191, 206, 142, 255, 193, 207, 129, 255, 200, 217, 122, 255, 191, 210,
    111, 255, 146, 163, 84,  255, 65,  96,  23,  255, 129, 161, 68,  255, 159, 193, 81,  255, 184, 209, 96,  255, 222, 232, 124, 255, 236, 238, 151,
    255, 190, 208, 153, 255, 182, 208, 156, 255, 183, 210, 156, 255, 90,  119, 67,  255, 125, 132, 71,  255, 186, 200, 129, 255, 158, 176, 124, 255,
    96,  107, 69,  255, 135, 146, 58,  255, 180, 198, 84,  255, 176, 199, 92,  255, 168, 196, 96,  255, 160, 185, 89,  255, 195, 199, 93,  255, 233,
    227, 130, 255, 215, 225, 120, 255, 158, 175, 74,  255, 201, 207, 118, 255, 168, 181, 87,  255, 142, 168, 60,  255, 115, 149, 65,  255, 115, 149,
    83,  255, 128, 162, 98,  255, 137, 170, 110, 255, 149, 179, 105, 255, 194, 212, 106, 255, 129, 155, 60,  255, 152, 167, 80,  255, 199, 209, 118,
    255, 207, 209, 108, 255, 214, 213, 108, 255, 186, 201, 92,  255, 178, 201, 83,  255, 180, 203, 90,  255, 180, 204, 95,  255, 186, 207, 86,  255,
    185, 204, 92,  255, 106, 132, 62,  255, 104, 127, 49,  255, 83,  109, 36,  255, 85,  110, 37,  255, 131, 157, 55,  255, 120, 144, 55,  255, 133,
    148, 84,  255, 143, 164, 115, 255, 142, 174, 116, 255, 115, 140, 87,  255, 119, 129, 62,  255, 145, 173, 75,  255, 99,  121, 52,  255, 129, 150,
    71,  255, 149, 179, 83,  255, 166, 198, 100, 255, 71,  90,  55,  255, 19,  19,  19,  255, 60,  80,  33,  255, 65,  94,  36,  255, 40,  67,  23,
    255, 42,  65,  23,  255, 62,  79,  23,  255, 123, 127, 49,  255, 134, 144, 63,  255, 127, 143, 71,  255, 111, 127, 63,  255, 76,  106, 47,  255,
    62,  101, 36,  255, 68,  98,  34,  255, 63,  95,  34,  255, 69,  105, 42,  255, 52,  79,  32,  255, 26,  36,  21,  255, 53,  76,  31,  255, 73,
    104, 49,  255, 94,  131, 71,  255, 94,  134, 69,  255, 21,  31,  21,  255, 29,  39,  25,  255, 45,  62,  32,  255, 63,  81,  36,  255, 114, 132,
    56,  255, 123, 144, 62,  255, 87,  107, 45,  255, 60,  83,  31,  255, 93,  126, 44,  255, 96,  130, 49,  255, 89,  127, 48,  255, 82,  122, 42,
    255, 83,  122, 40,  255, 80,  112, 37,  255, 49,  74,  29,  255, 76,  90,  36,  255, 115, 138, 55,  255, 118, 143, 72,  255, 165, 193, 116, 255,
    180, 208, 147, 255, 199, 216, 137, 255, 112, 135, 62,  255, 109, 133, 79,  255, 115, 134, 83,  255, 102, 124, 63,  255, 145, 154, 77,  255, 214,
    223, 134, 255, 205, 216, 132, 255, 153, 178, 112, 255, 161, 187, 121, 255, 184, 188, 114, 255, 97,  100, 50,  255, 177, 177, 99,  255, 218, 218,
    135, 255, 206, 207, 122, 255, 165, 175, 94,  255, 108, 137, 62,  255, 125, 156, 75,  255, 160, 186, 107, 255, 116, 153, 101, 255, 112, 150, 108,
    255, 126, 163, 117, 255, 120, 160, 111, 255, 149, 172, 116, 255, 211, 217, 145, 255, 202, 213, 152, 255, 188, 200, 134, 255, 137, 149, 90,  255,
    86,  92,  41,  255, 208, 210, 138, 255, 221, 232, 162, 255, 156, 179, 116, 255, 160, 186, 136, 255, 189, 208, 131, 255, 210, 223, 131, 255, 210,
    225, 144, 255, 204, 223, 139, 255, 196, 214, 128, 255, 200, 215, 127, 255, 234, 234, 137, 255, 150, 166, 77,  255, 108, 138, 46,  255, 100, 133,
    41,  255, 45,  67,  28,  255, 29,  44,  28,  255, 25,  37,  26,  255, 65,  92,  41,  255, 75,  106, 47,  255, 84,  111, 52,  255, 102, 126, 60,
    255, 114, 134, 62,  255, 104, 122, 55,  255, 77,  99,  41,  255, 72,  94,  37,  255, 114, 148, 55,  255, 99,  121, 56,  255, 128, 156, 77,  255,
    108, 136, 71,  255, 96,  125, 74,  255, 151, 166, 103, 255, 206, 216, 137, 255, 207, 222, 140, 255, 190, 210, 125, 255, 177, 202, 115, 255, 173,
    200, 116, 255, 131, 155, 91,  255, 86,  116, 62,  255, 150, 178, 125, 255, 184, 202, 135, 255, 120, 135, 75,  255, 95,  109, 47,  255, 156, 174,
    72,  255, 148, 172, 76,  255, 148, 173, 82,  255, 133, 167, 68,  255, 118, 156, 62,  255, 143, 171, 78,  255, 176, 198, 96,  255, 173, 196, 95,
    255, 148, 177, 104, 255, 133, 155, 82,  255, 69,  91,  40,  255, 92,  113, 41,  255, 136, 161, 73,  255, 137, 167, 99,  255, 155, 185, 103, 255,
    157, 175, 95,  255, 148, 167, 100, 255, 205, 222, 142, 255, 212, 224, 111, 255, 204, 223, 105, 255, 209, 228, 110, 255, 246, 246, 141, 255, 228,
    231, 152, 255, 171, 181, 93,  255, 91,  111, 32,  255, 91,  111, 53,  255, 88,  108, 56,  255, 133, 162, 97,  255, 126, 160, 109, 255, 140, 173,
    112, 255, 147, 161, 96,  255, 120, 132, 81,  255, 194, 212, 133, 255, 219, 241, 168, 255, 213, 239, 165, 255, 155, 166, 87,  255, 32,  37,  19,
    255, 29,  44,  23,  255, 161, 185, 76,  255, 208, 213, 110, 255, 234, 229, 133, 255, 233, 228, 131, 255, 221, 220, 126, 255, 188, 194, 110, 255,
    129, 151, 72,  255, 84,  121, 44,  255, 83,  107, 47,  255, 38,  74,  23,  255, 87,  126, 50,  255, 125, 151, 63,  255, 181, 202, 139, 255, 204,
    213, 151, 255, 144, 161, 65,  255, 174, 193, 80,  255, 203, 217, 111, 255, 176, 196, 116, 255, 175, 199, 114, 255, 201, 217, 112, 255, 196, 209,
    107, 255, 188, 204, 96,  255, 201, 205, 103, 255, 82,  94,  48,  255, 56,  80,  39,  255, 83,  111, 33,  255, 105, 136, 40,  255, 101, 126, 47,
    255, 94,  124, 44,  255, 131, 158, 55,  255, 160, 175, 65,  255, 77,  95,  47,  255, 111, 142, 92,  255, 129, 139, 72,  255, 171, 178, 100, 255,
    185, 209, 136, 255, 164, 195, 133, 255, 170, 196, 137, 255, 178, 201, 146, 255, 163, 191, 144, 255, 161, 190, 141, 255, 164, 192, 142, 255, 159,
    188, 139, 255, 165, 187, 132, 255, 192, 204, 131, 255, 190, 206, 148, 255, 145, 165, 89,  255, 195, 215, 87,  255, 171, 205, 97,  255, 164, 201,
    107, 255, 178, 210, 134, 255, 225, 234, 166, 255, 209, 221, 152, 255, 179, 208, 142, 255, 162, 187, 127, 255, 126, 145, 81,  255, 179, 190, 117,
    255, 202, 210, 121, 255, 210, 204, 87,  255, 214, 212, 117, 255, 190, 211, 112, 255, 150, 184, 98,  255, 142, 177, 98,  255, 129, 169, 94,  255,
    124, 163, 84,  255, 128, 164, 76,  255, 150, 174, 73,  255, 191, 204, 100, 255, 184, 199, 102, 255, 197, 214, 121, 255, 204, 220, 130, 255, 160,
    186, 102, 255, 103, 137, 65,  255, 130, 160, 93,  255, 136, 168, 108, 255, 145, 177, 113, 255, 179, 198, 114, 255, 195, 209, 91,  255, 173, 194,
    69,  255, 155, 175, 77,  255, 190, 202, 113, 255, 199, 206, 98,  255, 188, 199, 84,  255, 174, 196, 77,  255, 176, 199, 84,  255, 178, 202, 93,
    255, 185, 207, 87,  255, 185, 205, 82,  255, 168, 182, 98,  255, 116, 131, 60,  255, 121, 143, 52,  255, 135, 161, 53,  255, 166, 192, 75,  255,
    158, 189, 71,  255, 131, 159, 56,  255, 129, 153, 52,  255, 112, 133, 47,  255, 142, 157, 87,  255, 163, 184, 103, 255, 116, 152, 67,  255, 78,
    103, 41,  255, 137, 160, 68,  255, 148, 178, 81,  255, 148, 175, 84,  255, 163, 186, 96,  255, 141, 157, 84,  255, 135, 153, 80,  255, 104, 138,
    63,  255, 87,  119, 50,  255, 37,  60,  25,  255, 31,  49,  19,  255, 118, 131, 45,  255, 172, 196, 89,  255, 138, 171, 82,  255, 109, 147, 75,
    255, 104, 140, 67,  255, 109, 140, 60,  255, 123, 152, 53,  255, 96,  128, 47,  255, 104, 129, 48,  255, 157, 174, 62,  255, 164, 178, 69,  255,
    98,  112, 47,  255, 40,  52,  26,  255, 29,  36,  23,  255, 34,  44,  28,  255, 52,  73,  46,  255, 17,  23,  19,  255, 19,  19,  19,  255, 19,
    25,  26,  255, 72,  81,  36,  255, 125, 147, 62,  255, 121, 143, 60,  255, 98,  127, 44,  255, 69,  92,  36,  255, 95,  130, 47,  255, 95,  132,
    50,  255, 87,  126, 45,  255, 87,  124, 44,  255, 83,  119, 44,  255, 69,  100, 33,  255, 43,  65,  26,  255, 76,  89,  36,  255, 187, 201, 103,
    255, 178, 208, 121, 255, 164, 198, 125, 255, 175, 205, 138, 255, 216, 224, 144, 255, 201, 204, 125, 255, 216, 225, 157, 255, 211, 224, 158, 255,
    208, 220, 156, 255, 194, 212, 142, 255, 172, 196, 126, 255, 167, 186, 114, 255, 145, 165, 116, 255, 188, 204, 137, 255, 216, 225, 150, 255, 224,
    232, 156, 255, 212, 227, 156, 255, 195, 216, 152, 255, 205, 222, 152, 255, 217, 229, 162, 255, 194, 201, 130, 255, 108, 122, 55,  255, 115, 134,
    68,  255, 141, 171, 106, 255, 124, 161, 111, 255, 116, 154, 112, 255, 137, 165, 115, 255, 227, 229, 159, 255, 235, 241, 171, 255, 213, 223, 157,
    255, 214, 225, 165, 255, 210, 226, 157, 255, 207, 221, 141, 255, 226, 232, 154, 255, 203, 216, 158, 255, 142, 167, 105, 255, 153, 178, 104, 255,
    185, 206, 140, 255, 208, 221, 137, 255, 213, 221, 122, 255, 178, 190, 107, 255, 191, 206, 126, 255, 185, 206, 125, 255, 209, 222, 143, 255, 174,
    186, 102, 255, 112, 137, 52,  255, 104, 125, 45,  255, 67,  74,  39,  255, 52,  60,  40,  255, 37,  52,  28,  255, 81,  110, 50,  255, 76,  105,
    48,  255, 60,  92,  43,  255, 47,  75,  31,  255, 62,  77,  37,  255, 33,  37,  26,  255, 37,  47,  32,  255, 89,  108, 58,  255, 101, 138, 47,
    255, 130, 160, 68,  255, 141, 159, 81,  255, 132, 159, 80,  255, 112, 139, 75,  255, 88,  114, 74,  255, 99,  123, 81,  255, 123, 145, 98,  255,
    175, 192, 111, 255, 147, 165, 81,  255, 130, 154, 82,  255, 131, 158, 87,  255, 110, 138, 72,  255, 125, 149, 90,  255, 77,  107, 58,  255, 68,
    99,  47,  255, 42,  62,  34,  255, 95,  128, 49,  255, 126, 163, 67,  255, 114, 152, 60,  255, 115, 151, 62,  255, 119, 152, 68,  255, 167, 188,
    96,  255, 170, 191, 92,  255, 165, 192, 81,  255, 140, 174, 87,  255, 161, 175, 100, 255, 192, 197, 116, 255, 184, 196, 125, 255, 188, 206, 129,
    255, 169, 191, 120, 255, 140, 170, 104, 255, 140, 163, 79,  255, 156, 180, 86,  255, 169, 191, 105, 255, 211, 225, 137, 255, 238, 241, 155, 255,
    222, 229, 141, 255, 188, 204, 120, 255, 157, 181, 107, 255, 142, 173, 95,  255, 129, 150, 74,  255, 74,  97,  47,  255, 96,  120, 65,  255, 130,
    165, 106, 255, 141, 175, 115, 255, 148, 168, 94,  255, 75,  89,  45,  255, 36,  52,  33,  255, 47,  60,  42,  255, 137, 154, 94,  255, 185, 208,
    123, 255, 194, 222, 120, 255, 136, 159, 71,  255, 114, 121, 50,  255, 212, 211, 104, 255, 229, 225, 131, 255, 228, 225, 127, 255, 227, 227, 129,
    255, 234, 230, 130, 255, 230, 231, 127, 255, 218, 221, 112, 255, 158, 169, 65,  255, 82,  99,  38,  255, 44,  81,  23,  255, 111, 148, 58,  255,
    112, 148, 60,  255, 127, 164, 83,  255, 162, 187, 95,  255, 169, 194, 89,  255, 165, 193, 91,  255, 154, 183, 94,  255, 150, 180, 103, 255, 149,
    182, 106, 255, 145, 178, 109, 255, 140, 172, 97,  255, 159, 187, 94,  255, 170, 194, 98,  255, 150, 159, 63,  255, 91,  122, 37,  255, 145, 174,
    55,  255, 124, 153, 56,  255, 119, 145, 60,  255, 125, 147, 60,  255, 118, 136, 56,  255, 92,  100, 42,  255, 110, 117, 52,  255, 139, 150, 84,
    255, 73,  86,  42,  255, 69,  84,  39,  255, 169, 176, 102, 255, 184, 205, 123, 255, 166, 197, 123, 255, 169, 195, 129, 255, 165, 193, 134, 255,
    162, 191, 139, 255, 175, 200, 144, 255, 192, 209, 145, 255, 193, 212, 148, 255, 189, 206, 151, 255, 171, 199, 155, 255, 162, 189, 114, 255, 218,
    223, 103, 255, 220, 238, 129, 255, 191, 222, 122, 255, 180, 215, 131, 255, 196, 221, 160, 255, 227, 236, 169, 255, 215, 231, 163, 255, 184, 198,
    132, 255, 196, 217, 159, 255, 206, 226, 170, 255, 230, 230, 125, 255, 243, 233, 87,  255, 231, 232, 100, 255, 196, 215, 118, 255, 157, 189, 111,
    255, 151, 185, 104, 255, 141, 176, 84,  255, 137, 171, 71,  255, 159, 182, 80,  255, 194, 202, 84,  255, 154, 178, 58,  255, 174, 195, 90,  255,
    207, 222, 125, 255, 187, 210, 122, 255, 110, 143, 74,  255, 127, 160, 90,  255, 140, 172, 111, 255, 150, 181, 112, 255, 172, 194, 105, 255, 184,
    198, 101, 255, 190, 203, 94,  255, 189, 205, 76,  255, 172, 190, 73,  255, 182, 197, 99,  255, 163, 183, 75,  255, 153, 175, 56,  255, 175, 198,
    78,  255, 180, 203, 89,  255, 192, 211, 92,  255, 175, 199, 76,  255, 153, 178, 67,  255, 168, 179, 111, 255, 177, 193, 90,  255, 182, 201, 81,
    255, 177, 199, 82,  255, 174, 198, 83,  255, 138, 169, 62,  255, 117, 146, 43,  255, 122, 149, 43,  255, 150, 166, 60,  255, 153, 160, 97,  255,
    156, 178, 126, 255, 46,  74,  34,  255, 87,  105, 41,  255, 153, 179, 78,  255, 164, 184, 91,  255, 175, 191, 103, 255, 177, 194, 107, 255, 163,
    187, 107, 255, 154, 178, 102, 255, 125, 157, 68,  255, 63,  92,  31,  255, 34,  53,  23,  255, 36,  51,  19,  255, 141, 158, 65,  255, 154, 183,
    87,  255, 122, 154, 76,  255, 138, 164, 72,  255, 153, 177, 74,  255, 128, 157, 55,  255, 148, 170, 53,  255, 159, 186, 68,  255, 134, 166, 74,
    255, 135, 161, 72,  255, 188, 201, 73,  255, 182, 198, 74,  255, 133, 152, 67,  255, 134, 152, 73,  255, 101, 112, 60,  255, 58,  62,  32,  255,
    96,  108, 45,  255, 97,  114, 48,  255, 62,  75,  36,  255, 88,  105, 39,  255, 112, 136, 50,  255, 100, 131, 45,  255, 90,  122, 40,  255, 75,
    105, 36,  255, 97,  137, 49,  255, 105, 140, 55,  255, 91,  122, 47,  255, 74,  111, 45,  255, 57,  84,  37,  255, 41,  58,  28,  255, 34,  47,
    26,  255, 29,  46,  19,  255, 94,  111, 41,  255, 190, 205, 107, 255, 187, 211, 138, 255, 178, 206, 145, 255, 225, 232, 160, 255, 223, 238, 182,
    255, 203, 227, 173, 255, 199, 223, 156, 255, 196, 217, 140, 255, 194, 213, 130, 255, 176, 197, 114, 255, 144, 163, 92,  255, 173, 191, 117, 255,
    196, 214, 130, 255, 181, 204, 126, 255, 188, 211, 135, 255, 190, 217, 152, 255, 191, 218, 161, 255, 197, 221, 162, 255, 196, 220, 167, 255, 215,
    236, 178, 255, 173, 178, 126, 255, 32,  44,  19,  255, 76,  94,  43,  255, 149, 172, 92,  255, 151, 179, 117, 255, 193, 205, 146, 255, 196, 213,
    155, 255, 179, 196, 135, 255, 207, 215, 124, 255, 227, 229, 131, 255, 234, 235, 132, 255, 223, 228, 134, 255, 210, 220, 127, 255, 191, 209, 150,
    255, 131, 155, 87,  255, 156, 183, 136, 255, 178, 206, 180, 255, 198, 214, 167, 255, 235, 234, 149, 255, 112, 116, 81,  255, 134, 147, 91,  255,
    154, 185, 77,  255, 135, 170, 79,  255, 117, 140, 65,  255, 132, 145, 69,  255, 155, 176, 87,  255, 150, 175, 84,  255, 75,  105, 39,  255, 65,
    97,  39,  255, 73,  105, 45,  255, 74,  104, 47,  255, 79,  106, 50,  255, 119, 139, 82,  255, 154, 171, 108, 255, 152, 162, 100, 255, 140, 156,
    69,  255, 144, 165, 72,  255, 113, 139, 62,  255, 108, 136, 55,  255, 52,  62,  32,  255, 122, 145, 72,  255, 138, 165, 82,  255, 166, 192, 103,
    255, 166, 188, 107, 255, 92,  117, 80,  255, 91,  117, 62,  255, 83,  113, 60,  255, 88,  116, 79,  255, 107, 136, 94,  255, 108, 134, 69,  255,
    93,  119, 75,  255, 73,  107, 62,  255, 71,  102, 47,  255, 47,  71,  31,  255, 73,  99,  41,  255, 107, 141, 52,  255, 125, 156, 65,  255, 116,
    149, 68,  255, 131, 161, 82,  255, 167, 190, 96,  255, 154, 174, 84,  255, 99,  126, 49,  255, 167, 182, 97,  255, 241, 241, 149, 255, 206, 222,
    152, 255, 180, 208, 140, 255, 174, 204, 124, 255, 179, 205, 109, 255, 177, 196, 84,  255, 132, 156, 73,  255, 135, 157, 80,  255, 69,  80,  34,
    255, 89,  105, 50,  255, 145, 159, 93,  255, 150, 166, 86,  255, 133, 152, 62,  255, 139, 167, 72,  255, 137, 170, 79,  255, 128, 164, 77,  255,
    116, 143, 62,  255, 97,  118, 65,  255, 141, 174, 122, 255, 131, 153, 87,  255, 53,  58,  34,  255, 34,  48,  26,  255, 63,  87,  52,  255, 47,
    68,  48,  255, 43,  60,  44,  255, 56,  71,  38,  255, 98,  121, 50,  255, 167, 183, 101, 255, 241, 239, 144, 255, 204, 215, 135, 255, 198, 211,
    132, 255, 201, 212, 128, 255, 196, 210, 131, 255, 194, 208, 124, 255, 187, 203, 108, 255, 189, 205, 106, 255, 196, 210, 98,  255, 174, 185, 69,
    255, 163, 179, 60,  255, 150, 172, 67,  255, 124, 154, 58,  255, 189, 204, 83,  255, 157, 185, 84,  255, 143, 179, 90,  255, 154, 183, 89,  255,
    146, 177, 87,  255, 140, 175, 94,  255, 137, 171, 94,  255, 133, 168, 90,  255, 126, 164, 84,  255, 128, 167, 90,  255, 129, 169, 97,  255, 174,
    196, 103, 255, 147, 162, 58,  255, 126, 152, 50,  255, 121, 139, 56,  255, 88,  98,  43,  255, 71,  87,  32,  255, 58,  73,  26,  255, 43,  55,
    26,  255, 56,  69,  38,  255, 45,  62,  26,  255, 41,  62,  26,  255, 43,  65,  28,  255, 73,  93,  41,  255, 132, 145, 73,  255, 202, 210, 115,
    255, 192, 212, 119, 255, 168, 196, 117, 255, 196, 212, 132, 255, 225, 226, 147, 255, 212, 220, 163, 255, 191, 215, 172, 255, 179, 207, 172, 255,
    158, 188, 114, 255, 180, 206, 108, 255, 159, 167, 73,  255, 183, 185, 104, 255, 232, 238, 151, 255, 218, 235, 156, 255, 206, 229, 154, 255, 213,
    231, 165, 255, 245, 243, 165, 255, 241, 241, 154, 255, 225, 233, 156, 255, 229, 238, 159, 255, 241, 238, 139, 255, 210, 210, 113, 255, 211, 222,
    126, 255, 198, 219, 140, 255, 185, 208, 128, 255, 172, 190, 101, 255, 191, 200, 96,  255, 201, 210, 102, 255, 218, 218, 108, 255, 198, 209, 92,
    255, 150, 176, 72,  255, 180, 198, 82,  255, 196, 217, 112, 255, 140, 175, 99,  255, 138, 169, 106, 255, 156, 184, 114, 255, 172, 195, 106, 255,
    159, 184, 86,  255, 108, 135, 41,  255, 121, 143, 41,  255, 152, 168, 67,  255, 170, 187, 68,  255, 168, 188, 67,  255, 153, 174, 76,  255, 126,
    153, 52,  255, 162, 184, 52,  255, 186, 206, 80,  255, 195, 213, 86,  255, 165, 192, 74,  255, 125, 158, 44,  255, 130, 151, 42,  255, 140, 156,
    71,  255, 143, 168, 84,  255, 138, 158, 73,  255, 139, 162, 75,  255, 128, 152, 68,  255, 111, 136, 41,  255, 124, 149, 46,  255, 134, 158, 49,
    255, 121, 143, 43,  255, 118, 121, 98,  255, 156, 176, 161, 255, 38,  53,  21,  255, 130, 143, 67,  255, 184, 200, 108, 255, 182, 197, 109, 255,
    180, 195, 111, 255, 163, 187, 113, 255, 119, 149, 104, 255, 148, 166, 104, 255, 134, 160, 81,  255, 40,  65,  28,  255, 40,  53,  26,  255, 47,
    63,  26,  255, 98,  120, 48,  255, 127, 152, 68,  255, 121, 142, 68,  255, 129, 144, 63,  255, 134, 156, 65,  255, 86,  124, 38,  255, 55,  87,
    23,  255, 81,  102, 36,  255, 124, 147, 58,  255, 150, 168, 84,  255, 166, 182, 81,  255, 137, 160, 62,  255, 132, 159, 72,  255, 139, 164, 80,
    255, 164, 183, 92,  255, 163, 176, 83,  255, 162, 180, 69,  255, 147, 173, 60,  255, 128, 156, 49,  255, 113, 141, 42,  255, 112, 148, 47,  255,
    102, 144, 47,  255, 94,  135, 41,  255, 94,  131, 39,  255, 113, 150, 62,  255, 114, 149, 68,  255, 92,  121, 45,  255, 83,  109, 44,  255, 38,
    49,  28,  255, 41,  52,  29,  255, 47,  55,  32,  255, 29,  36,  21,  255, 52,  77,  28,  255, 114, 135, 52,  255, 217, 232, 139, 255, 210, 226,
    163, 255, 222, 232, 162, 255, 207, 221, 141, 255, 168, 187, 107, 255, 123, 141, 68,  255, 183, 192, 104, 255, 188, 207, 134, 255, 148, 177, 116,
    255, 126, 150, 74,  255, 157, 181, 114, 255, 203, 214, 126, 255, 179, 191, 101, 255, 144, 166, 84,  255, 185, 193, 131, 255, 175, 186, 132, 255,
    159, 172, 112, 255, 154, 169, 112, 255, 156, 174, 121, 255, 141, 164, 107, 255, 58,  87,  31,  255, 46,  79,  21,  255, 58,  92,  26,  255, 99,
    126, 56,  255, 131, 156, 84,  255, 141, 164, 87,  255, 168, 191, 102, 255, 153, 182, 103, 255, 143, 177, 98,  255, 163, 188, 97,  255, 223, 228,
    144, 255, 225, 230, 153, 255, 181, 198, 113, 255, 130, 153, 86,  255, 178, 204, 170, 255, 178, 207, 169, 255, 209, 221, 162, 255, 213, 221, 134,
    255, 144, 153, 94,  255, 156, 177, 117, 255, 148, 180, 105, 255, 124, 153, 67,  255, 91,  111, 47,  255, 162, 184, 90,  255, 163, 187, 95,  255,
    72,  102, 37,  255, 51,  80,  34,  255, 52,  76,  36,  255, 55,  84,  39,  255, 69,  102, 47,  255, 95,  119, 58,  255, 190, 206, 134, 255, 178,
    206, 146, 255, 162, 194, 131, 255, 155, 189, 111, 255, 154, 186, 108, 255, 160, 189, 107, 255, 127, 154, 68,  255, 26,  36,  19,  255, 39,  55,
    28,  255, 134, 169, 84,  255, 151, 184, 102, 255, 163, 193, 116, 255, 115, 138, 72,  255, 87,  119, 56,  255, 101, 138, 71,  255, 124, 155, 82,
    255, 121, 147, 103, 255, 83,  114, 63,  255, 88,  119, 83,  255, 87,  122, 68,  255, 98,  126, 60,  255, 111, 136, 65,  255, 123, 154, 75,  255,
    84,  118, 53,  255, 97,  129, 49,  255, 129, 159, 67,  255, 143, 170, 86,  255, 173, 190, 96,  255, 127, 151, 67,  255, 60,  82,  28,  255, 161,
    168, 104, 255, 222, 235, 163, 255, 201, 222, 145, 255, 207, 222, 125, 255, 175, 191, 100, 255, 170, 181, 97,  255, 145, 164, 81,  255, 117, 150,
    96,  255, 123, 153, 87,  255, 85,  99,  52,  255, 45,  60,  36,  255, 55,  71,  36,  255, 79,  93,  50,  255, 40,  48,  26,  255, 69,  84,  41,
    255, 123, 147, 60,  255, 122, 150, 58,  255, 113, 144, 55,  255, 97,  122, 65,  255, 122, 149, 91,  255, 55,  67,  29,  255, 29,  34,  26,  255,
    36,  51,  31,  255, 44,  63,  39,  255, 50,  68,  47,  255, 52,  73,  52,  255, 40,  60,  36,  255, 47,  75,  32,  255, 72,  97,  58,  255, 119,
    139, 82,  255, 177, 189, 104, 255, 204, 212, 108, 255, 172, 184, 84,  255, 161, 175, 86,  255, 161, 175, 87,  255, 167, 187, 97,  255, 177, 194,
    101, 255, 162, 180, 85,  255, 168, 185, 82,  255, 166, 183, 69,  255, 127, 146, 60,  255, 100, 134, 52,  255, 172, 190, 91,  255, 184, 196, 90,
    255, 184, 202, 97,  255, 175, 196, 96,  255, 185, 205, 87,  255, 180, 200, 82,  255, 163, 187, 76,  255, 160, 187, 78,  255, 161, 190, 93,  255,
    155, 186, 106, 255, 158, 188, 111, 255, 197, 213, 124, 255, 189, 191, 86,  255, 91,  116, 32,  255, 106, 129, 50,  255, 68,  87,  41,  255, 29,
    51,  21,  255, 23,  29,  17,  255, 21,  26,  21,  255, 52,  67,  34,  255, 48,  68,  33,  255, 42,  65,  29,  255, 44,  69,  29,  255, 41,  60,
    26,  255, 42,  55,  26,  255, 126, 132, 69,  255, 189, 193, 103, 255, 226, 227, 134, 255, 222, 225, 156, 255, 187, 209, 161, 255, 180, 211, 178,
    255, 180, 210, 180, 255, 171, 200, 149, 255, 194, 215, 133, 255, 204, 214, 106, 255, 119, 141, 58,  255, 104, 128, 50,  255, 194, 202, 109, 255,
    192, 198, 129, 255, 202, 206, 143, 255, 212, 223, 159, 255, 206, 215, 157, 255, 176, 190, 145, 255, 194, 202, 134, 255, 201, 205, 122, 255, 187,
    198, 137, 255, 173, 191, 131, 255, 194, 208, 129, 255, 176, 194, 110, 255, 152, 169, 75,  255, 74,  80,  33,  255, 181, 161, 87,  255, 223, 221,
    130, 255, 178, 185, 84,  255, 173, 197, 110, 255, 174, 195, 89,  255, 177, 196, 75,  255, 150, 177, 89,  255, 155, 180, 107, 255, 166, 189, 97,
    255, 165, 187, 80,  255, 152, 173, 56,  255, 101, 131, 34,  255, 62,  91,  23,  255, 91,  106, 26,  255, 118, 138, 38,  255, 115, 139, 36,  255,
    118, 141, 46,  255, 138, 157, 67,  255, 152, 175, 63,  255, 186, 202, 82,  255, 181, 200, 78,  255, 139, 168, 55,  255, 105, 141, 32,  255, 119,
    146, 39,  255, 116, 131, 48,  255, 134, 156, 78,  255, 129, 162, 89,  255, 75,  109, 34,  255, 51,  87,  28,  255, 49,  75,  32,  255, 53,  63,
    31,  255, 89,  105, 41,  255, 103, 118, 50,  255, 60,  81,  31,  255, 114, 125, 103, 255, 122, 145, 108, 255, 146, 159, 77,  255, 188, 204, 117,
    255, 185, 201, 115, 255, 184, 200, 112, 255, 163, 186, 114, 255, 125, 156, 112, 255, 130, 155, 107, 255, 197, 209, 116, 255, 124, 145, 77,  255,
    48,  71,  34,  255, 55,  77,  37,  255, 29,  41,  23,  255, 49,  69,  31,  255, 49,  72,  32,  255, 28,  38,  25,  255, 41,  53,  31,  255, 52,
    81,  36,  255, 63,  95,  25,  255, 68,  103, 33,  255, 49,  81,  29,  255, 47,  72,  26,  255, 75,  97,  39,  255, 100, 126, 47,  255, 119, 146,
    52,  255, 142, 165, 73,  255, 143, 168, 74,  255, 165, 178, 76,  255, 176, 186, 71,  255, 169, 184, 68,  255, 159, 176, 62,  255, 140, 164, 52,
    255, 131, 162, 47,  255, 124, 161, 60,  255, 113, 149, 62,  255, 100, 135, 43,  255, 103, 133, 42,  255, 109, 136, 50,  255, 105, 132, 47,  255,
    98,  122, 42,  255, 103, 125, 44,  255, 79,  92,  39,  255, 63,  87,  32,  255, 72,  101, 40,  255, 50,  58,  31,  255, 44,  62,  29,  255, 45,
    62,  32,  255, 69,  79,  41,  255, 86,  89,  58,  255, 60,  68,  38,  255, 84,  107, 44,  255, 55,  86,  29,  255, 41,  71,  19,  255, 165, 177,
    91,  255, 179, 203, 133, 255, 141, 169, 114, 255, 125, 155, 96,  255, 163, 189, 130, 255, 210, 217, 133, 255, 116, 144, 73,  255, 82,  121, 55,
    255, 43,  49,  31,  255, 37,  42,  25,  255, 53,  82,  26,  255, 48,  82,  21,  255, 47,  84,  25,  255, 47,  84,  25,  255, 60,  99,  29,  255,
    56,  96,  26,  255, 58,  96,  28,  255, 58,  92,  26,  255, 47,  73,  17,  255, 145, 164, 62,  255, 165, 195, 100, 255, 123, 163, 92,  255, 117,
    157, 84,  255, 119, 154, 79,  255, 203, 214, 132, 255, 225, 232, 157, 255, 185, 199, 131, 255, 126, 152, 89,  255, 178, 204, 164, 255, 189, 210,
    155, 255, 215, 222, 150, 255, 155, 179, 110, 255, 178, 195, 99,  255, 180, 202, 130, 255, 126, 158, 100, 255, 154, 176, 75,  255, 167, 192, 78,
    255, 168, 193, 84,  255, 160, 180, 85,  255, 74,  96,  46,  255, 36,  60,  29,  255, 41,  65,  29,  255, 52,  83,  38,  255, 74,  101, 47,  255,
    55,  75,  33,  255, 86,  104, 50,  255, 167, 187, 116, 255, 174, 197, 131, 255, 162, 191, 129, 255, 154, 187, 131, 255, 142, 179, 119, 255, 140,
    174, 108, 255, 69,  90,  42,  255, 48,  69,  32,  255, 135, 170, 80,  255, 157, 181, 92,  255, 110, 143, 68,  255, 104, 135, 62,  255, 85,  116,
    50,  255, 65,  89,  43,  255, 74,  92,  47,  255, 129, 156, 102, 255, 90,  119, 72,  255, 98,  130, 89,  255, 98,  132, 71,  255, 116, 146, 55,
    255, 138, 165, 69,  255, 106, 138, 69,  255, 74,  108, 58,  255, 62,  98,  46,  255, 84,  120, 50,  255, 142, 167, 84,  255, 138, 159, 74,  255,
    84,  116, 44,  255, 95,  131, 48,  255, 151, 171, 93,  255, 210, 223, 157, 255, 156, 169, 102, 255, 121, 133, 73,  255, 76,  90,  47,  255, 68,
    87,  40,  255, 116, 144, 76,  255, 132, 162, 105, 255, 126, 153, 99,  255, 91,  104, 52,  255, 84,  92,  60,  255, 53,  68,  39,  255, 49,  57,
    36,  255, 62,  71,  37,  255, 67,  102, 37,  255, 57,  95,  43,  255, 95,  125, 62,  255, 113, 133, 62,  255, 107, 124, 72,  255, 101, 118, 63,
    255, 28,  37,  19,  255, 32,  37,  29,  255, 44,  60,  33,  255, 47,  65,  38,  255, 34,  49,  29,  255, 39,  55,  34,  255, 38,  60,  32,  255,
    55,  83,  38,  255, 69,  96,  53,  255, 57,  86,  39,  255, 168, 186, 107, 255, 190, 210, 134, 255, 156, 181, 103, 255, 141, 164, 63,  255, 121,
    148, 47,  255, 126, 159, 60,  255, 170, 191, 100, 255, 122, 157, 69,  255, 141, 173, 72,  255, 119, 142, 48,  255, 79,  111, 37,  255, 118, 152,
    63,  255, 93,  124, 68,  255, 83,  114, 65,  255, 139, 163, 77,  255, 163, 185, 89,  255, 145, 159, 65,  255, 131, 145, 52,  255, 177, 193, 83,
    255, 175, 190, 84,  255, 156, 168, 68,  255, 131, 149, 72,  255, 131, 153, 69,  255, 144, 159, 82,  255, 184, 192, 102, 255, 116, 140, 39,  255,
    105, 131, 48,  255, 119, 137, 63,  255, 29,  46,  19,  255, 17,  23,  19,  255, 19,  23,  17,  255, 38,  55,  26,  255, 50,  73,  33,  255, 48,
    71,  32,  255, 52,  77,  34,  255, 52,  76,  33,  255, 12,  21,  15,  255, 53,  58,  31,  255, 168, 187, 112, 255, 214, 221, 156, 255, 181, 209,
    169, 255, 182, 215, 184, 255, 184, 212, 184, 255, 169, 197, 141, 255, 166, 197, 127, 255, 211, 213, 112, 255, 185, 197, 80,  255, 130, 155, 76,
    255, 138, 162, 81,  255, 188, 204, 107, 255, 145, 171, 110, 255, 145, 174, 120, 255, 165, 185, 136, 255, 164, 186, 137, 255, 147, 178, 142, 255,
    149, 179, 144, 255, 158, 184, 118, 255, 153, 179, 116, 255, 198, 207, 120, 255, 144, 156, 55,  255, 102, 128, 38,  255, 133, 157, 40,  255, 159,
    182, 56,  255, 153, 162, 58,  255, 206, 205, 103, 255, 179, 189, 81,  255, 199, 214, 111, 255, 177, 202, 99,  255, 117, 145, 48,  255, 150, 169,
    67,  255, 155, 174, 68,  255, 150, 170, 63,  255, 146, 167, 56,  255, 138, 162, 52,  255, 79,  111, 36,  255, 56,  81,  29,  255, 77,  90,  32,
    255, 100, 116, 40,  255, 95,  113, 38,  255, 99,  126, 50,  255, 116, 142, 60,  255, 131, 155, 55,  255, 138, 162, 55,  255, 110, 144, 36,  255,
    102, 137, 29,  255, 108, 141, 36,  255, 97,  120, 33,  255, 86,  113, 37,  255, 134, 162, 83,  255, 144, 176, 98,  255, 90,  123, 43,  255, 49,
    84,  26,  255, 57,  92,  31,  255, 55,  92,  37,  255, 52,  84,  32,  255, 69,  100, 39,  255, 67,  99,  36,  255, 97,  117, 69,  255, 155, 172,
    106, 255, 181, 200, 107, 255, 179, 199, 113, 255, 172, 192, 117, 255, 177, 194, 119, 255, 144, 172, 114, 255, 127, 156, 115, 255, 163, 179, 113,
    255, 209, 214, 123, 255, 142, 170, 73,  255, 116, 150, 53,  255, 112, 142, 60,  255, 38,  52,  31,  255, 17,  26,  19,  255, 34,  47,  23,  255,
    63,  90,  39,  255, 68,  100, 47,  255, 42,  69,  32,  255, 37,  55,  26,  255, 38,  53,  25,  255, 83,  109, 34,  255, 96,  127, 42,  255, 79,
    110, 38,  255, 98,  126, 40,  255, 114, 134, 49,  255, 132, 150, 62,  255, 112, 125, 60,  255, 84,  89,  43,  255, 148, 157, 68,  255, 155, 167,
    63,  255, 148, 164, 63,  255, 121, 144, 52,  255, 82,  114, 38,  255, 75,  101, 42,  255, 71,  91,  47,  255, 52,  71,  36,  255, 79,  104, 39,
    255, 101, 121, 47,  255, 95,  117, 40,  255, 112, 133, 43,  255, 126, 146, 52,  255, 84,  104, 39,  255, 74,  104, 33,  255, 65,  100, 37,  255,
    69,  102, 36,  255, 69,  100, 37,  255, 33,  52,  26,  255, 21,  29,  21,  255, 12,  17,  15,  255, 28,  36,  19,  255, 47,  62,  29,  255, 69,
    96,  39,  255, 84,  115, 52,  255, 165, 179, 94,  255, 176, 200, 134, 255, 123, 154, 93,  255, 144, 169, 102, 255, 204, 216, 125, 255, 161, 176,
    98,  255, 84,  124, 56,  255, 94,  127, 62,  255, 47,  43,  33,  255, 42,  43,  29,  255, 60,  83,  36,  255, 65,  91,  33,  255, 52,  75,  29,
    255, 44,  65,  29,  255, 58,  86,  28,  255, 85,  114, 41,  255, 86,  113, 47,  255, 58,  76,  34,  255, 42,  52,  21,  255, 166, 187, 82,  255,
    137, 175, 103, 255, 125, 164, 105, 255, 126, 162, 97,  255, 118, 155, 74,  255, 191, 206, 124, 255, 222, 230, 154, 255, 184, 200, 133, 255, 131,
    159, 98,  255, 172, 198, 158, 255, 198, 213, 146, 255, 173, 183, 116, 255, 136, 156, 92,  255, 174, 191, 100, 255, 167, 186, 106, 255, 148, 173,
    92,  255, 146, 170, 76,  255, 138, 163, 74,  255, 151, 173, 75,  255, 159, 181, 78,  255, 99,  120, 55,  255, 33,  58,  23,  255, 69,  96,  39,
    255, 85,  113, 48,  255, 52,  72,  32,  255, 63,  90,  31,  255, 63,  100, 26,  255, 71,  105, 31,  255, 112, 136, 60,  255, 156, 173, 92,  255,
    158, 181, 92,  255, 155, 179, 97,  255, 122, 154, 83,  255, 82,  121, 44,  255, 115, 148, 60,  255, 121, 149, 63,  255, 93,  126, 48,  255, 84,
    119, 40,  255, 80,  116, 41,  255, 69,  102, 34,  255, 37,  47,  26,  255, 34,  38,  28,  255, 97,  126, 84,  255, 91,  122, 74,  255, 105, 135,
    92,  255, 118, 149, 76,  255, 112, 146, 62,  255, 106, 139, 55,  255, 134, 157, 58,  255, 108, 137, 53,  255, 74,  110, 45,  255, 63,  98,  39,
    255, 120, 140, 75,  255, 81,  114, 50,  255, 84,  121, 58,  255, 92,  126, 65,  255, 113, 145, 74,  255, 122, 145, 73,  255, 56,  78,  28,  255,
    41,  63,  23,  255, 47,  68,  31,  255, 60,  86,  34,  255, 89,  114, 47,  255, 134, 161, 82,  255, 132, 156, 86,  255, 44,  55,  29,  255, 65,
    73,  47,  255, 93,  98,  62,  255, 55,  67,  31,  255, 87,  121, 42,  255, 82,  122, 48,  255, 68,  108, 52,  255, 105, 141, 60,  255, 135, 152,
    76,  255, 124, 141, 74,  255, 73,  89,  44,  255, 17,  21,  19,  255, 29,  36,  28,  255, 41,  55,  31,  255, 52,  77,  36,  255, 44,  67,  31,
    255, 38,  60,  31,  255, 36,  58,  32,  255, 46,  68,  33,  255, 80,  107, 55,  255, 97,  122, 56,  255, 191, 212, 146, 255, 173, 203, 155, 255,
    183, 213, 157, 255, 199, 220, 145, 255, 198, 213, 124, 255, 174, 196, 98,  255, 186, 209, 118, 255, 160, 185, 83,  255, 137, 166, 68,  255, 102,
    134, 48,  255, 77,  108, 34,  255, 98,  132, 53,  255, 103, 133, 73,  255, 76,  110, 63,  255, 101, 136, 65,  255, 113, 144, 62,  255, 38,  49,
    17,  255, 29,  52,  12,  255, 102, 134, 53,  255, 94,  128, 52,  255, 67,  99,  36,  255, 63,  92,  39,  255, 71,  101, 40,  255, 88,  113, 40,
    255, 140, 153, 67,  255, 166, 182, 84,  255, 151, 164, 75,  255, 143, 152, 77,  255, 50,  72,  36,  255, 49,  76,  38,  255, 36,  56,  31,  255,
    21,  32,  19,  255, 45,  67,  29,  255, 52,  75,  33,  255, 58,  79,  37,  255, 67,  92,  43,  255, 28,  39,  23,  255, 26,  31,  17,  255, 206,
    208, 136, 255, 217, 225, 167, 255, 191, 217, 177, 255, 190, 216, 184, 255, 174, 205, 145, 255, 164, 200, 126, 255, 201, 216, 138, 255, 125, 148,
    91,  255, 155, 173, 96,  255, 143, 161, 98,  255, 162, 181, 128, 255, 155, 174, 100, 255, 152, 175, 79,  255, 156, 180, 93,  255, 152, 178, 102,
    255, 167, 190, 115, 255, 179, 199, 125, 255, 177, 200, 136, 255, 205, 221, 139, 255, 188, 187, 97,  255, 126, 137, 56,  255, 98,  127, 52,  255,
    99,  124, 52,  255, 102, 132, 58,  255, 143, 172, 63,  255, 134, 160, 52,  255, 159, 169, 62,  255, 193, 205, 83,  255, 191, 209, 104, 255, 148,
    176, 74,  255, 99,  123, 38,  255, 166, 180, 83,  255, 168, 184, 84,  255, 170, 187, 81,  255, 166, 183, 72,  255, 104, 132, 52,  255, 31,  55,
    17,  255, 135, 132, 46,  255, 211, 221, 84,  255, 190, 208, 82,  255, 170, 189, 73,  255, 137, 163, 58,  255, 95,  128, 45,  255, 86,  117, 36,
    255, 101, 135, 40,  255, 102, 139, 37,  255, 96,  132, 37,  255, 76,  102, 31,  255, 84,  104, 37,  255, 81,  116, 40,  255, 141, 168, 69,  255,
    131, 160, 71,  255, 91,  121, 47,  255, 58,  92,  31,  255, 52,  84,  32,  255, 58,  87,  36,  255, 109, 140, 58,  255, 123, 162, 63,  255, 122,
    160, 63,  255, 129, 150, 93,  255, 156, 172, 107, 255, 181, 200, 115, 255, 177, 198, 115, 255, 160, 183, 121, 255, 149, 175, 122, 255, 133, 163,
    121, 255, 155, 176, 123, 255, 198, 207, 118, 255, 212, 217, 123, 255, 148, 173, 72,  255, 112, 144, 55,  255, 73,  99,  44,  255, 34,  47,  28,
    255, 29,  42,  21,  255, 73,  106, 44,  255, 81,  116, 55,  255, 55,  87,  44,  255, 51,  80,  34,  255, 33,  51,  26,  255, 41,  55,  21,  255,
    105, 136, 46,  255, 110, 146, 55,  255, 105, 139, 53,  255, 146, 169, 68,  255, 115, 132, 60,  255, 53,  79,  29,  255, 78,  97,  41,  255, 49,
    55,  40,  255, 25,  31,  25,  255, 65,  82,  32,  255, 83,  113, 39,  255, 65,  98,  34,  255, 62,  98,  31,  255, 48,  72,  34,  255, 36,  49,
    32,  255, 34,  46,  31,  255, 23,  34,  23,  255, 17,  19,  19,  255, 91,  92,  41,  255, 174, 193, 96,  255, 151, 178, 100, 255, 123, 152, 84,
    255, 108, 140, 58,  255, 83,  117, 44,  255, 55,  87,  34,  255, 65,  100, 33,  255, 60,  86,  33,  255, 55,  80,  33,  255, 68,  99,  43,  255,
    81,  118, 52,  255, 100, 139, 63,  255, 115, 155, 84,  255, 125, 161, 101, 255, 172, 188, 106, 255, 183, 204, 131, 255, 124, 150, 83,  255, 178,
    197, 113, 255, 146, 171, 85,  255, 98,  133, 52,  255, 103, 141, 60,  255, 91,  117, 56,  255, 65,  65,  43,  255, 67,  65,  46,  255, 44,  48,
    36,  255, 34,  46,  29,  255, 58,  75,  39,  255, 40,  65,  26,  255, 40,  62,  26,  255, 45,  60,  31,  255, 49,  60,  36,  255, 42,  53,  31,
    255, 28,  47,  23,  255, 78,  99,  33,  255, 129, 161, 76,  255, 127, 162, 89,  255, 126, 162, 81,  255, 130, 163, 76,  255, 178, 195, 109, 255,
    211, 222, 156, 255, 181, 199, 133, 255, 137, 163, 107, 255, 179, 202, 152, 255, 194, 210, 129, 255, 156, 183, 125, 255, 129, 150, 93,  255, 149,
    169, 97,  255, 151, 175, 89,  255, 88,  112, 47,  255, 26,  37,  23,  255, 62,  79,  34,  255, 155, 175, 80,  255, 158, 180, 74,  255, 121, 143,
    58,  255, 118, 138, 65,  255, 138, 161, 71,  255, 52,  62,  33,  255, 40,  49,  28,  255, 58,  82,  28,  255, 89,  120, 40,  255, 89,  120, 38,
    255, 79,  110, 40,  255, 132, 158, 77,  255, 91,  123, 44,  255, 74,  101, 42,  255, 72,  98,  40,  255, 102, 139, 62,  255, 137, 168, 77,  255,
    100, 125, 50,  255, 47,  77,  33,  255, 65,  98,  44,  255, 80,  114, 40,  255, 48,  69,  26,  255, 31,  38,  25,  255, 23,  23,  19,  255, 72,
    93,  60,  255, 91,  120, 69,  255, 105, 135, 87,  255, 111, 140, 67,  255, 145, 176, 105, 255, 122, 159, 96,  255, 101, 137, 65,  255, 121, 152,
    74,  255, 116, 141, 52,  255, 107, 135, 49,  255, 95,  119, 50,  255, 81,  115, 47,  255, 77,  116, 60,  255, 97,  131, 73,  255, 98,  134, 79,
    255, 106, 143, 75,  255, 65,  87,  36,  255, 34,  51,  23,  255, 82,  104, 44,  255, 136, 160, 65,  255, 152, 171, 73,  255, 150, 165, 73,  255,
    155, 170, 74,  255, 128, 135, 60,  255, 99,  106, 44,  255, 112, 113, 62,  255, 88,  99,  47,  255, 91,  130, 41,  255, 77,  115, 49,  255, 74,
    112, 50,  255, 110, 147, 55,  255, 113, 136, 71,  255, 134, 152, 82,  255, 81,  95,  52,  255, 12,  21,  19,  255, 25,  31,  26,  255, 34,  48,
    23,  255, 92,  115, 62,  255, 105, 119, 72,  255, 62,  81,  43,  255, 36,  55,  28,  255, 50,  68,  37,  255, 109, 136, 63,  255, 134, 164, 95,
    255, 182, 210, 156, 255, 164, 189, 118, 255, 141, 160, 92,  255, 112, 133, 62,  255, 95,  121, 45,  255, 79,  113, 49,  255, 115, 145, 63,  255,
    125, 147, 68,  255, 77,  111, 58,  255, 95,  130, 58,  255, 84,  115, 39,  255, 58,  84,  29,  255, 74,  101, 44,  255, 103, 134, 68,  255, 116,
    143, 73,  255, 136, 160, 80,  255, 121, 139, 69,  255, 109, 128, 65,  255, 129, 149, 67,  255, 117, 141, 52,  255, 104, 127, 60,  255, 119, 138,
    65,  255, 175, 189, 98,  255, 201, 213, 109, 255, 177, 196, 92,  255, 172, 188, 91,  255, 156, 169, 82,  255, 142, 149, 77,  255, 52,  68,  41,
    255, 55,  79,  52,  255, 69,  100, 55,  255, 38,  55,  34,  255, 23,  33,  19,  255, 40,  58,  26,  255, 50,  68,  32,  255, 65,  84,  40,  255,
    19,  28,  15,  255, 80,  86,  60,  255, 218, 225, 165, 255, 183, 208, 168, 255, 183, 211, 176, 255, 173, 204, 148, 255, 178, 212, 140, 255, 212,
    223, 145, 255, 176, 184, 108, 255, 134, 159, 96,  255, 133, 155, 93,  255, 166, 185, 89,  255, 156, 182, 90,  255, 143, 175, 99,  255, 123, 161,
    83,  255, 122, 160, 81,  255, 132, 168, 99,  255, 140, 171, 111, 255, 148, 176, 111, 255, 171, 190, 115, 255, 197, 201, 101, 255, 118, 134, 44,
    255, 89,  120, 49,  255, 87,  117, 47,  255, 107, 131, 53,  255, 140, 165, 77,  255, 170, 189, 107, 255, 143, 164, 81,  255, 115, 137, 44,  255,
    160, 171, 73,  255, 174, 184, 77,  255, 130, 157, 62,  255, 115, 136, 44,  255, 185, 199, 94,  255, 193, 210, 100, 255, 207, 220, 102, 255, 202,
    218, 108, 255, 58,  83,  38,  255, 44,  65,  23,  255, 175, 175, 72,  255, 226, 231, 98,  255, 208, 219, 91,  255, 200, 214, 87,  255, 189, 208,
    76,  255, 158, 182, 60,  255, 114, 142, 46,  255, 96,  127, 43,  255, 112, 135, 47,  255, 120, 138, 43,  255, 118, 133, 45,  255, 118, 136, 50,
    255, 174, 186, 62,  255, 181, 199, 72,  255, 113, 151, 42,  255, 123, 159, 58,  255, 71,  103, 47,  255, 33,  60,  17,  255, 108, 131, 52,  255,
    122, 163, 78,  255, 94,  136, 62,  255, 92,  131, 58,  255, 120, 141, 92,  255, 161, 178, 107, 255, 185, 204, 120, 255, 172, 193, 123, 255, 156,
    180, 127, 255, 141, 171, 127, 255, 133, 165, 128, 255, 153, 176, 120, 255, 206, 213, 121, 255, 205, 215, 122, 255, 140, 169, 69,  255, 74,  102,
    47,  255, 19,  28,  21,  255, 19,  25,  19,  255, 69,  92,  36,  255, 92,  128, 55,  255, 69,  101, 50,  255, 57,  90,  38,  255, 71,  108, 43,
    255, 43,  68,  31,  255, 41,  62,  25,  255, 74,  101, 34,  255, 123, 153, 58,  255, 129, 161, 68,  255, 145, 171, 75,  255, 130, 154, 65,  255,
    48,  79,  28,  255, 74,  105, 36,  255, 92,  96,  60,  255, 49,  47,  41,  255, 34,  43,  21,  255, 63,  92,  31,  255, 60,  87,  28,  255, 60,
    87,  32,  255, 37,  56,  31,  255, 31,  46,  28,  255, 33,  43,  28,  255, 19,  31,  21,  255, 34,  36,  17,  255, 173, 184, 86,  255, 134, 174,
    104, 255, 115, 153, 96,  255, 108, 148, 87,  255, 101, 142, 72,  255, 94,  132, 55,  255, 74,  111, 41,  255, 60,  94,  34,  255, 75,  109, 36,
    255, 90,  128, 44,  255, 102, 143, 65,  255, 99,  138, 69,  255, 111, 147, 82,  255, 120, 155, 99,  255, 131, 161, 100, 255, 174, 192, 99,  255,
    180, 197, 115, 255, 143, 166, 84,  255, 139, 161, 84,  255, 69,  96,  37,  255, 82,  117, 40,  255, 101, 121, 56,  255, 112, 119, 68,  255, 113,
    115, 73,  255, 95,  95,  69,  255, 69,  72,  55,  255, 37,  47,  31,  255, 124, 148, 84,  255, 58,  87,  31,  255, 43,  71,  26,  255, 37,  60,
    26,  255, 31,  40,  29,  255, 40,  55,  31,  255, 36,  52,  25,  255, 38,  58,  25,  255, 55,  83,  32,  255, 65,  87,  32,  255, 58,  65,  36,
    255, 68,  84,  36,  255, 117, 134, 60,  255, 211, 222, 155, 255, 177, 194, 132, 255, 139, 166, 111, 255, 179, 201, 138, 255, 186, 203, 116, 255,
    159, 186, 123, 255, 142, 170, 125, 255, 116, 137, 80,  255, 122, 142, 75,  255, 31,  48,  23,  255, 36,  53,  28,  255, 63,  86,  31,  255, 151,
    174, 76,  255, 160, 182, 81,  255, 152, 177, 68,  255, 157, 181, 71,  255, 56,  73,  31,  255, 36,  44,  26,  255, 40,  58,  28,  255, 36,  53,
    26,  255, 36,  49,  26,  255, 47,  58,  33,  255, 75,  95,  49,  255, 138, 168, 74,  255, 98,  122, 52,  255, 77,  100, 37,  255, 175, 197, 97,
    255, 163, 192, 101, 255, 151, 178, 100, 255, 63,  87,  38,  255, 42,  65,  40,  255, 53,  86,  42,  255, 83,  110, 47,  255, 71,  76,  48,  255,
    38,  41,  36,  255, 25,  26,  23,  255, 55,  69,  47,  255, 84,  115, 62,  255, 98,  133, 74,  255, 81,  100, 47,  255, 73,  90,  55,  255, 145,
    184, 119, 255, 131, 171, 103, 255, 110, 150, 80,  255, 82,  113, 37,  255, 76,  93,  34,  255, 95,  115, 47,  255, 106, 132, 55,  255, 108, 141,
    58,  255, 112, 145, 62,  255, 113, 144, 60,  255, 110, 142, 53,  255, 91,  114, 40,  255, 129, 146, 62,  255, 166, 183, 76,  255, 170, 184, 78,
    255, 172, 186, 83,  255, 178, 189, 86,  255, 176, 188, 80,  255, 177, 190, 76,  255, 171, 186, 81,  255, 194, 201, 94,  255, 136, 143, 65,  255,
    83,  119, 36,  255, 73,  108, 42,  255, 79,  118, 42,  255, 120, 153, 56,  255, 105, 127, 68,  255, 127, 148, 80,  255, 133, 149, 80,  255, 74,
    75,  47,  255, 37,  43,  33,  255, 34,  46,  25,  255, 90,  110, 58,  255, 121, 144, 82,  255, 123, 151, 83,  255, 62,  79,  40,  255, 65,  81,
    38,  255, 119, 144, 74,  255, 142, 173, 91,  255, 164, 184, 97,  255, 136, 148, 75,  255, 112, 124, 62,  255, 126, 147, 60,  255, 121, 143, 65,
    255, 79,  106, 60,  255, 78,  111, 62,  255, 124, 155, 76,  255, 125, 147, 77,  255, 79,  107, 52,  255, 83,  118, 48,  255, 97,  131, 58,  255,
    96,  129, 62,  255, 137, 166, 87,  255, 142, 168, 98,  255, 125, 154, 99,  255, 134, 163, 108, 255, 132, 161, 114, 255, 130, 156, 101, 255, 151,
    172, 68,  255, 136, 161, 81,  255, 138, 166, 86,  255, 153, 181, 86,  255, 146, 175, 74,  255, 151, 175, 60,  255, 132, 144, 55,  255, 151, 159,
    75,  255, 113, 123, 58,  255, 49,  73,  40,  255, 58,  86,  53,  255, 78,  108, 58,  255, 68,  97,  49,  255, 29,  49,  23,  255, 47,  75,  34,
    255, 55,  87,  33,  255, 52,  79,  28,  255, 34,  47,  23,  255, 180, 186, 131, 255, 199, 218, 170, 255, 176, 204, 169, 255, 172, 202, 154, 255,
    184, 212, 145, 255, 203, 212, 140, 255, 171, 184, 115, 255, 161, 182, 110, 255, 121, 150, 79,  255, 114, 140, 84,  255, 176, 194, 87,  255, 171,
    197, 60,  255, 159, 185, 65,  255, 149, 178, 93,  255, 130, 166, 97,  255, 127, 163, 87,  255, 131, 165, 90,  255, 127, 162, 90,  255, 131, 165,
    90,  255, 163, 183, 73,  255, 99,  127, 36,  255, 96,  125, 48,  255, 120, 145, 62,  255, 167, 188, 102, 255, 176, 195, 126, 255, 166, 191, 135,
    255, 179, 202, 109, 255, 184, 205, 81,  255, 166, 189, 84,  255, 147, 167, 71,  255, 132, 154, 62,  255, 160, 180, 69,  255, 193, 210, 100, 255,
    205, 218, 114, 255, 214, 222, 118, 255, 225, 232, 131, 255, 146, 162, 87,  255, 104, 133, 62,  255, 146, 160, 74,  255, 209, 213, 118, 255, 186,
    195, 97,  255, 187, 196, 96,  255, 184, 197, 93,  255, 171, 185, 71,  255, 140, 166, 67,  255, 103, 132, 42,  255, 196, 189, 87,  255, 243, 232,
    124, 255, 221, 217, 108, 255, 231, 226, 103, 255, 208, 214, 96,  255, 97,  130, 47,  255, 84,  117, 34,  255, 86,  119, 47,  255, 52,  89,  32,
    255, 62,  98,  21,  255, 141, 167, 68,  255, 117, 157, 78,  255, 92,  132, 62,  255, 91,  129, 56,  255, 129, 148, 102, 255, 170, 186, 117, 255,
    185, 204, 126, 255, 162, 185, 125, 255, 143, 173, 125, 255, 135, 167, 126, 255, 146, 172, 122, 255, 183, 199, 121, 255, 212, 220, 127, 255, 176,
    198, 114, 255, 126, 164, 82,  255, 85,  115, 55,  255, 9,   17,  12,  255, 26,  37,  21,  255, 86,  117, 50,  255, 81,  113, 56,  255, 60,  92,
    43,  255, 78,  116, 48,  255, 71,  108, 42,  255, 44,  68,  28,  255, 39,  63,  26,  255, 58,  84,  31,  255, 83,  105, 41,  255, 118, 142, 67,
    255, 91,  114, 56,  255, 53,  67,  28,  255, 78,  104, 39,  255, 80,  108, 48,  255, 52,  62,  36,  255, 34,  41,  29,  255, 23,  29,  21,  255,
    34,  47,  26,  255, 38,  55,  26,  255, 39,  62,  31,  255, 36,  55,  32,  255, 34,  51,  29,  255, 36,  52,  29,  255, 26,  40,  26,  255, 49,
    47,  17,  255, 188, 197, 92,  255, 127, 165, 93,  255, 118, 155, 84,  255, 114, 154, 77,  255, 107, 149, 73,  255, 97,  140, 60,  255, 120, 156,
    56,  255, 90,  121, 44,  255, 65,  98,  31,  255, 81,  111, 39,  255, 100, 126, 60,  255, 145, 175, 77,  255, 180, 199, 104, 255, 176, 195, 106,
    255, 181, 202, 115, 255, 167, 189, 102, 255, 144, 169, 79,  255, 126, 152, 78,  255, 95,  129, 68,  255, 69,  98,  42,  255, 63,  84,  36,  255,
    115, 122, 68,  255, 141, 144, 94,  255, 139, 139, 96,  255, 132, 129, 89,  255, 81,  76,  62,  255, 71,  81,  52,  255, 161, 190, 121, 255, 99,
    127, 58,  255, 53,  84,  23,  255, 50,  76,  28,  255, 48,  60,  34,  255, 38,  51,  29,  255, 55,  75,  33,  255, 45,  67,  28,  255, 34,  55,
    25,  255, 42,  65,  23,  255, 53,  77,  26,  255, 63,  87,  32,  255, 73,  96,  34,  255, 191, 205, 130, 255, 165, 184, 117, 255, 144, 171, 106,
    255, 152, 165, 113, 255, 148, 161, 98,  255, 164, 189, 95,  255, 147, 178, 111, 255, 131, 159, 97,  255, 96,  118, 53,  255, 84,  104, 48,  255,
    97,  126, 49,  255, 76,  111, 36,  255, 119, 146, 58,  255, 167, 190, 89,  255, 138, 162, 63,  255, 60,  80,  26,  255, 38,  52,  26,  255, 78,
    90,  52,  255, 116, 135, 83,  255, 101, 119, 71,  255, 77,  87,  47,  255, 104, 114, 68,  255, 154, 173, 90,  255, 136, 170, 60,  255, 130, 166,
    67,  255, 95,  122, 58,  255, 141, 156, 74,  255, 197, 213, 127, 255, 140, 165, 95,  255, 39,  65,  31,  255, 42,  65,  42,  255, 92,  111, 58,
    255, 158, 176, 103, 255, 181, 199, 133, 255, 101, 117, 67,  255, 41,  65,  31,  255, 58,  84,  47,  255, 81,  114, 55,  255, 92,  124, 53,  255,
    62,  69,  33,  255, 58,  65,  26,  255, 122, 144, 81,  255, 162, 195, 133, 255, 130, 165, 86,  255, 90,  118, 47,  255, 39,  58,  28,  255, 56,
    78,  36,  255, 92,  111, 56,  255, 78,  100, 56,  255, 79,  105, 55,  255, 74,  100, 55,  255, 83,  110, 41,  255, 139, 166, 65,  255, 162, 182,
    78,  255, 166, 182, 74,  255, 166, 179, 72,  255, 165, 180, 73,  255, 171, 184, 73,  255, 169, 181, 77,  255, 129, 154, 82,  255, 118, 149, 77,
    255, 195, 203, 99,  255, 162, 176, 92,  255, 87,  122, 40,  255, 78,  118, 43,  255, 89,  130, 41,  255, 98,  131, 58,  255, 108, 135, 69,  255,
    126, 151, 74,  255, 147, 171, 85,  255, 148, 172, 83,  255, 139, 161, 79,  255, 124, 141, 71,  255, 125, 144, 69,  255, 112, 131, 63,  255, 117,
    136, 67,  255, 175, 189, 98,  255, 152, 170, 77,  255, 139, 168, 86,  255, 174, 199, 79,  255, 188, 197, 83,  255, 200, 210, 107, 255, 206, 216,
    114, 255, 203, 213, 114, 255, 195, 209, 102, 255, 160, 176, 84,  255, 109, 136, 76,  255, 107, 139, 82,  255, 134, 166, 89,  255, 112, 135, 56,
    255, 89,  124, 55,  255, 113, 151, 77,  255, 106, 142, 78,  255, 91,  124, 79,  255, 94,  128, 87,  255, 101, 131, 97,  255, 104, 134, 97,  255,
    107, 139, 100, 255, 97,  127, 80,  255, 122, 148, 65,  255, 186, 200, 89,  255, 137, 161, 75,  255, 121, 157, 84,  255, 141, 168, 71,  255, 117,
    130, 41,  255, 42,  48,  17,  255, 74,  85,  42,  255, 69,  95,  47,  255, 52,  83,  49,  255, 62,  89,  52,  255, 82,  114, 62,  255, 86,  122,
    60,  255, 71,  108, 39,  255, 84,  118, 44,  255, 84,  117, 39,  255, 58,  94,  19,  255, 104, 119, 65,  255, 211, 224, 167, 255, 179, 205, 165,
    255, 176, 205, 161, 255, 193, 216, 155, 255, 192, 203, 132, 255, 138, 159, 100, 255, 127, 160, 107, 255, 128, 157, 101, 255, 107, 145, 71,  255,
    107, 138, 65,  255, 151, 168, 65,  255, 182, 200, 68,  255, 148, 176, 63,  255, 143, 174, 65,  255, 138, 168, 90,  255, 132, 165, 93,  255, 126,
    162, 84,  255, 124, 161, 84,  255, 121, 158, 72,  255, 174, 192, 74,  255, 158, 174, 60,  255, 156, 177, 77,  255, 171, 190, 108, 255, 159, 185,
    136, 255, 153, 184, 139, 255, 165, 194, 137, 255, 209, 220, 116, 255, 178, 198, 75,  255, 155, 181, 68,  255, 132, 161, 60,  255, 141, 160, 55,
    255, 193, 208, 94,  255, 208, 219, 109, 255, 217, 224, 131, 255, 218, 227, 136, 255, 227, 232, 133, 255, 179, 199, 109, 255, 123, 156, 68,  255,
    101, 140, 55,  255, 90,  127, 45,  255, 97,  132, 43,  255, 100, 137, 43,  255, 105, 134, 39,  255, 144, 159, 52,  255, 152, 170, 74,  255, 131,
    159, 62,  255, 119, 144, 50,  255, 179, 184, 99,  255, 235, 229, 158, 255, 178, 191, 112, 255, 102, 133, 46,  255, 98,  133, 38,  255, 100, 127,
    48,  255, 82,  116, 38,  255, 63,  101, 33,  255, 49,  76,  21,  255, 130, 151, 68,  255, 146, 178, 84,  255, 136, 170, 72,  255, 117, 157, 68,
    255, 117, 138, 74,  255, 176, 190, 118, 255, 177, 200, 136, 255, 156, 184, 134, 255, 135, 167, 126, 255, 133, 166, 123, 255, 151, 176, 123, 255,
    193, 207, 124, 255, 214, 224, 133, 255, 139, 171, 99,  255, 119, 155, 87,  255, 133, 168, 96,  255, 74,  98,  52,  255, 48,  67,  26,  255, 85,
    116, 56,  255, 75,  107, 52,  255, 81,  116, 50,  255, 73,  110, 47,  255, 46,  68,  32,  255, 42,  55,  31,  255, 39,  58,  26,  255, 47,  68,
    31,  255, 42,  58,  33,  255, 43,  67,  31,  255, 44,  55,  23,  255, 143, 158, 77,  255, 85,  103, 52,  255, 26,  38,  23,  255, 15,  25,  19,
    255, 29,  41,  23,  255, 37,  51,  31,  255, 38,  49,  31,  255, 41,  65,  31,  255, 39,  63,  29,  255, 38,  55,  31,  255, 36,  55,  31,  255,
    42,  65,  31,  255, 26,  37,  23,  255, 60,  60,  26,  255, 220, 220, 121, 255, 193, 210, 116, 255, 179, 200, 104, 255, 169, 194, 105, 255, 151,
    181, 84,  255, 140, 173, 84,  255, 160, 182, 81,  255, 69,  99,  46,  255, 63,  96,  36,  255, 52,  71,  34,  255, 12,  9,   15,  255, 81,  92,
    44,  255, 169, 187, 92,  255, 173, 194, 100, 255, 152, 178, 92,  255, 132, 161, 84,  255, 107, 139, 58,  255, 120, 153, 72,  255, 111, 146, 76,
    255, 109, 144, 65,  255, 73,  101, 36,  255, 98,  108, 55,  255, 155, 152, 103, 255, 154, 143, 103, 255, 145, 138, 87,  255, 74,  81,  44,  255,
    123, 138, 91,  255, 165, 196, 128, 255, 145, 168, 105, 255, 53,  78,  23,  255, 95,  122, 47,  255, 77,  90,  52,  255, 127, 139, 101, 255, 117,
    143, 82,  255, 44,  74,  21,  255, 53,  76,  26,  255, 84,  116, 31,  255, 81,  120, 29,  255, 84,  121, 38,  255, 91,  126, 44,  255, 141, 169,
    84,  255, 143, 168, 93,  255, 131, 150, 80,  255, 116, 128, 94,  255, 126, 152, 65,  255, 149, 179, 75,  255, 160, 190, 111, 255, 159, 189, 109,
    255, 157, 188, 105, 255, 187, 207, 112, 255, 184, 197, 99,  255, 91,  125, 45,  255, 110, 142, 55,  255, 140, 171, 72,  255, 94,  117, 53,  255,
    68,  80,  40,  255, 87,  102, 45,  255, 106, 120, 67,  255, 194, 207, 142, 255, 207, 229, 164, 255, 198, 222, 156, 255, 211, 228, 167, 255, 199,
    219, 140, 255, 160, 188, 80,  255, 126, 161, 56,  255, 75,  105, 44,  255, 68,  103, 47,  255, 68,  98,  48,  255, 58,  75,  37,  255, 38,  65,
    31,  255, 91,  108, 60,  255, 191, 203, 124, 255, 163, 191, 128, 255, 173, 199, 133, 255, 117, 136, 76,  255, 40,  68,  37,  255, 47,  72,  40,
    255, 66,  96,  41,  255, 62,  82,  34,  255, 91,  120, 48,  255, 157, 185, 80,  255, 112, 129, 62,  255, 156, 184, 124, 255, 103, 130, 67,  255,
    53,  80,  46,  255, 55,  84,  47,  255, 58,  87,  42,  255, 81,  102, 50,  255, 69,  92,  55,  255, 60,  90,  52,  255, 62,  86,  42,  255, 100,
    131, 50,  255, 151, 177, 76,  255, 161, 179, 80,  255, 174, 187, 82,  255, 176, 187, 76,  255, 171, 182, 72,  255, 155, 172, 80,  255, 126, 152,
    93,  255, 114, 144, 94,  255, 173, 186, 93,  255, 173, 189, 104, 255, 183, 206, 119, 255, 158, 172, 84,  255, 76,  111, 32,  255, 82,  116, 55,
    255, 74,  107, 68,  255, 81,  113, 75,  255, 89,  118, 78,  255, 97,  132, 75,  255, 120, 152, 80,  255, 140, 167, 83,  255, 143, 171, 75,  255,
    140, 169, 71,  255, 143, 164, 83,  255, 209, 215, 110, 255, 194, 211, 115, 255, 153, 185, 98,  255, 150, 184, 92,  255, 175, 194, 81,  255, 150,
    171, 68,  255, 128, 158, 73,  255, 127, 157, 79,  255, 123, 153, 79,  255, 135, 165, 75,  255, 142, 172, 72,  255, 130, 159, 71,  255, 104, 134,
    72,  255, 111, 144, 78,  255, 103, 133, 56,  255, 99,  136, 68,  255, 120, 150, 80,  255, 102, 129, 71,  255, 93,  123, 73,  255, 87,  122, 84,
    255, 94,  127, 87,  255, 87,  121, 74,  255, 97,  134, 75,  255, 92,  123, 56,  255, 147, 173, 94,  255, 173, 192, 117, 255, 185, 198, 113, 255,
    180, 192, 99,  255, 143, 161, 84,  255, 60,  79,  37,  255, 21,  28,  17,  255, 47,  60,  31,  255, 75,  102, 48,  255, 81,  111, 60,  255, 73,
    105, 62,  255, 78,  109, 65,  255, 91,  124, 63,  255, 86,  120, 44,  255, 89,  121, 46,  255, 86,  120, 37,  255, 93,  126, 34,  255, 190, 202,
    124, 255, 199, 216, 164, 255, 186, 212, 163, 255, 195, 215, 152, 255, 182, 191, 121, 255, 133, 158, 97,  255, 120, 155, 100, 255, 127, 158, 102,
    255, 123, 155, 90,  255, 122, 157, 81,  255, 148, 174, 74,  255, 110, 129, 42,  255, 148, 158, 52,  255, 172, 188, 67,  255, 172, 195, 71,  255,
    130, 163, 65,  255, 140, 172, 90,  255, 136, 170, 98,  255, 129, 167, 85,  255, 147, 179, 84,  255, 186, 204, 92,  255, 164, 179, 78,  255, 159,
    185, 104, 255, 147, 181, 137, 255, 158, 192, 149, 255, 160, 191, 140, 255, 174, 198, 124, 255, 170, 187, 81,  255, 160, 182, 65,  255, 157, 179,
    76,  255, 108, 144, 44,  255, 87,  118, 33,  255, 129, 147, 65,  255, 163, 179, 86,  255, 188, 198, 105, 255, 197, 206, 112, 255, 208, 216, 117,
    255, 165, 183, 87,  255, 115, 145, 52,  255, 104, 137, 47,  255, 107, 137, 40,  255, 106, 133, 44,  255, 92,  119, 36,  255, 99,  117, 32,  255,
    171, 178, 67,  255, 174, 188, 86,  255, 154, 176, 78,  255, 123, 152, 53,  255, 98,  129, 34,  255, 84,  113, 44,  255, 58,  92,  23,  255, 120,
    143, 36,  255, 158, 188, 58,  255, 132, 171, 68,  255, 168, 195, 87,  255, 83,  115, 44,  255, 31,  60,  25,  255, 47,  74,  32,  255, 72,  99,
    46,  255, 79,  104, 44,  255, 95,  126, 47,  255, 125, 141, 79,  255, 182, 195, 125, 255, 168, 194, 139, 255, 139, 173, 133, 255, 131, 164, 126,
    255, 140, 169, 126, 255, 186, 202, 128, 255, 202, 215, 125, 255, 155, 176, 92,  255, 134, 164, 74,  255, 119, 149, 58,  255, 147, 170, 81,  255,
    142, 167, 89,  255, 102, 123, 58,  255, 79,  112, 55,  255, 83,  120, 47,  255, 109, 136, 56,  255, 106, 124, 60,  255, 52,  68,  32,  255, 32,
    44,  26,  255, 34,  48,  26,  255, 44,  62,  26,  255, 55,  77,  36,  255, 23,  37,  17,  255, 111, 125, 48,  255, 182, 208, 98,  255, 114, 134,
    71,  255, 15,  23,  17,  255, 29,  40,  25,  255, 37,  52,  34,  255, 45,  65,  40,  255, 39,  56,  29,  255, 44,  72,  29,  255, 41,  67,  29,
    255, 39,  60,  31,  255, 44,  68,  32,  255, 44,  68,  31,  255, 19,  23,  21,  255, 45,  52,  33,  255, 112, 123, 87,  255, 84,  90,  47,  255,
    119, 128, 60,  255, 145, 157, 81,  255, 155, 168, 86,  255, 149, 170, 87,  255, 93,  118, 65,  255, 65,  94,  48,  255, 60,  91,  37,  255, 60,
    80,  36,  255, 21,  23,  21,  255, 23,  26,  23,  255, 49,  68,  31,  255, 148, 171, 78,  255, 171, 194, 93,  255, 149, 178, 87,  255, 140, 168,
    71,  255, 169, 192, 81,  255, 159, 184, 81,  255, 113, 136, 58,  255, 32,  47,  19,  255, 56,  78,  31,  255, 152, 157, 107, 255, 164, 149, 123,
    255, 127, 117, 79,  255, 91,  116, 41,  255, 154, 176, 107, 255, 162, 191, 141, 255, 125, 148, 101, 255, 90,  112, 47,  255, 137, 155, 77,  255,
    176, 187, 140, 255, 193, 217, 163, 255, 102, 121, 65,  255, 47,  77,  19,  255, 58,  83,  26,  255, 91,  118, 34,  255, 98,  132, 36,  255, 93,
    127, 39,  255, 91,  126, 41,  255, 97,  132, 47,  255, 107, 138, 52,  255, 102, 127, 60,  255, 95,  117, 58,  255, 103, 130, 44,  255, 188, 209,
    124, 255, 195, 218, 152, 255, 187, 210, 148, 255, 201, 221, 157, 255, 217, 225, 144, 255, 165, 176, 83,  255, 106, 133, 60,  255, 87,  118, 60,
    255, 121, 148, 62,  255, 144, 168, 67,  255, 177, 195, 77,  255, 182, 198, 74,  255, 148, 165, 71,  255, 88,  109, 47,  255, 170, 188, 112, 255,
    195, 220, 138, 255, 167, 204, 138, 255, 164, 201, 153, 255, 171, 200, 129, 255, 148, 175, 79,  255, 81,  108, 49,  255, 75,  100, 46,  255, 86,
    93,  48,  255, 36,  44,  28,  255, 73,  92,  43,  255, 183, 197, 113, 255, 161, 190, 136, 255, 154, 184, 133, 255, 183, 205, 136, 255, 112, 128,
    77,  255, 38,  65,  38,  255, 63,  92,  42,  255, 74,  103, 44,  255, 94,  128, 58,  255, 137, 174, 75,  255, 164, 182, 82,  255, 79,  105, 47,
    255, 63,  90,  49,  255, 43,  65,  41,  255, 44,  68,  44,  255, 52,  81,  42,  255, 49,  71,  36,  255, 60,  72,  38,  255, 74,  98,  46,  255,
    43,  68,  29,  255, 52,  77,  31,  255, 135, 164, 74,  255, 158, 180, 86,  255, 174, 190, 92,  255, 187, 196, 96,  255, 174, 189, 94,  255, 158,
    178, 102, 255, 140, 163, 103, 255, 132, 158, 99,  255, 190, 200, 102, 255, 206, 206, 107, 255, 124, 157, 101, 255, 138, 171, 104, 255, 185, 204,
    113, 255, 128, 142, 65,  255, 110, 133, 68,  255, 130, 156, 99,  255, 99,  131, 94,  255, 109, 142, 101, 255, 107, 137, 96,  255, 100, 132, 86,
    255, 110, 142, 78,  255, 119, 148, 83,  255, 121, 153, 74,  255, 139, 168, 73,  255, 195, 207, 100, 255, 181, 201, 115, 255, 167, 194, 113, 255,
    182, 200, 109, 255, 130, 156, 60,  255, 83,  122, 42,  255, 77,  117, 41,  255, 90,  127, 47,  255, 114, 146, 55,  255, 121, 156, 55,  255, 132,
    167, 56,  255, 141, 169, 63,  255, 129, 155, 65,  255, 115, 141, 62,  255, 100, 125, 47,  255, 94,  129, 52,  255, 95,  135, 49,  255, 124, 158,
    58,  255, 153, 176, 65,  255, 153, 169, 78,  255, 98,  130, 60,  255, 98,  138, 62,  255, 139, 168, 75,  255, 109, 134, 56,  255, 163, 187, 117,
    255, 143, 171, 113, 255, 135, 168, 105, 255, 165, 184, 98,  255, 214, 217, 127, 255, 167, 183, 120, 255, 39,  49,  34,  255, 21,  29,  19,  255,
    53,  65,  33,  255, 69,  89,  42,  255, 73,  97,  47,  255, 76,  99,  47,  255, 87,  122, 48,  255, 100, 131, 52,  255, 97,  128, 42,  255, 91,
    126, 37,  255, 181, 193, 98,  255, 219, 227, 155, 255, 190, 213, 163, 255, 203, 214, 146, 255, 150, 167, 103, 255, 113, 145, 91,  255, 121, 155,
    101, 255, 150, 179, 103, 255, 131, 164, 96,  255, 134, 168, 91,  255, 144, 174, 95,  255, 170, 188, 78,  255, 73,  100, 31,  255, 62,  100, 26,
    255, 122, 138, 47,  255, 188, 190, 71,  255, 169, 189, 77,  255, 146, 176, 92,  255, 147, 176, 98,  255, 144, 177, 103, 255, 183, 205, 106, 255,
    213, 221, 100, 255, 172, 185, 92,  255, 166, 193, 124, 255, 145, 183, 140, 255, 159, 193, 150, 255, 169, 200, 144, 255, 175, 198, 110, 255, 141,
    173, 79,  255, 174, 196, 90,  255, 133, 159, 55,  255, 81,  120, 38,  255, 72,  109, 40,  255, 78,  110, 53,  255, 75,  109, 60,  255, 84,  117,
    50,  255, 128, 151, 53,  255, 156, 170, 68,  255, 154, 171, 68,  255, 141, 163, 58,  255, 122, 148, 49,  255, 97,  123, 39,  255, 69,  92,  28,
    255, 84,  108, 37,  255, 77,  106, 33,  255, 93,  117, 36,  255, 118, 139, 56,  255, 115, 136, 58,  255, 103, 127, 44,  255, 95,  124, 36,  255,
    79,  115, 36,  255, 95,  120, 38,  255, 147, 164, 55,  255, 198, 218, 81,  255, 162, 196, 86,  255, 170, 199, 99,  255, 165, 182, 83,  255, 131,
    144, 56,  255, 91,  117, 50,  255, 60,  91,  47,  255, 32,  52,  32,  255, 43,  65,  29,  255, 115, 132, 68,  255, 181, 199, 129, 255, 152, 181,
    131, 255, 146, 176, 118, 255, 162, 188, 122, 255, 190, 205, 128, 255, 179, 197, 106, 255, 110, 140, 65,  255, 45,  62,  34,  255, 47,  58,  33,
    255, 32,  47,  26,  255, 33,  46,  23,  255, 29,  40,  21,  255, 56,  77,  39,  255, 68,  107, 42,  255, 73,  112, 39,  255, 134, 155, 62,  255,
    205, 219, 116, 255, 166, 185, 97,  255, 55,  73,  33,  255, 28,  38,  25,  255, 34,  43,  23,  255, 105, 120, 49,  255, 88,  104, 38,  255, 148,
    173, 55,  255, 171, 193, 87,  255, 156, 177, 93,  255, 36,  52,  26,  255, 29,  47,  26,  255, 40,  58,  38,  255, 37,  52,  36,  255, 46,  68,
    29,  255, 51,  82,  34,  255, 47,  72,  33,  255, 48,  74,  34,  255, 53,  84,  34,  255, 42,  68,  31,  255, 28,  42,  25,  255, 25,  34,  23,
    255, 23,  31,  26,  255, 21,  23,  26,  255, 17,  23,  19,  255, 29,  43,  21,  255, 29,  46,  21,  255, 58,  81,  33,  255, 81,  113, 55,  255,
    66,  96,  50,  255, 60,  89,  36,  255, 85,  116, 47,  255, 68,  91,  40,  255, 23,  29,  23,  255, 76,  80,  40,  255, 201, 218, 128, 255, 168,
    196, 115, 255, 146, 182, 101, 255, 137, 175, 87,  255, 193, 209, 95,  255, 158, 176, 75,  255, 68,  81,  39,  255, 80,  89,  60,  255, 75,  98,
    48,  255, 98,  112, 60,  255, 144, 135, 108, 255, 97,  105, 71,  255, 68,  95,  33,  255, 146, 164, 107, 255, 176, 200, 165, 255, 152, 178, 113,
    255, 157, 180, 90,  255, 203, 215, 159, 255, 179, 209, 169, 255, 146, 172, 115, 255, 47,  52,  37,  255, 60,  83,  28,  255, 58,  84,  32,  255,
    38,  55,  26,  255, 60,  75,  32,  255, 93,  116, 41,  255, 103, 133, 43,  255, 96,  128, 39,  255, 89,  120, 41,  255, 90,  120, 41,  255, 92,
    120, 47,  255, 99,  128, 47,  255, 147, 175, 95,  255, 149, 174, 98,  255, 151, 175, 92,  255, 153, 175, 94,  255, 107, 134, 55,  255, 77,  99,
    39,  255, 99,  128, 62,  255, 76,  107, 55,  255, 123, 148, 58,  255, 167, 187, 74,  255, 191, 209, 94,  255, 189, 202, 87,  255, 155, 171, 69,
    255, 79,  110, 36,  255, 67,  99,  39,  255, 105, 124, 65,  255, 160, 183, 81,  255, 179, 207, 116, 255, 178, 210, 144, 255, 183, 207, 115, 255,
    174, 196, 78,  255, 159, 182, 80,  255, 178, 193, 102, 255, 62,  65,  43,  255, 139, 152, 83,  255, 182, 204, 129, 255, 151, 181, 136, 255, 160,
    189, 135, 255, 184, 202, 131, 255, 85,  102, 56,  255, 108, 127, 49,  255, 155, 178, 72,  255, 127, 161, 71,  255, 138, 173, 81,  255, 161, 188,
    87,  255, 128, 139, 72,  255, 44,  65,  42,  255, 41,  62,  40,  255, 46,  69,  46,  255, 48,  75,  43,  255, 69,  101, 44,  255, 39,  52,  29,
    255, 41,  51,  31,  255, 79,  94,  48,  255, 28,  46,  21,  255, 90,  117, 52,  255, 154, 179, 86,  255, 170, 188, 93,  255, 169, 186, 95,  255,
    181, 193, 109, 255, 174, 189, 117, 255, 178, 195, 115, 255, 195, 201, 108, 255, 214, 213, 109, 255, 214, 211, 108, 255, 132, 157, 92,  255, 120,
    156, 105, 255, 134, 167, 106, 255, 153, 184, 105, 255, 174, 186, 98,  255, 55,  63,  25,  255, 117, 136, 76,  255, 164, 183, 115, 255, 147, 169,
    112, 255, 158, 176, 109, 255, 131, 155, 106, 255, 108, 140, 96,  255, 108, 138, 80,  255, 112, 142, 74,  255, 111, 145, 68,  255, 148, 173, 85,
    255, 203, 219, 144, 255, 198, 212, 127, 255, 172, 185, 81,  255, 130, 158, 72,  255, 142, 168, 74,  255, 148, 171, 68,  255, 159, 179, 65,  255,
    154, 176, 58,  255, 154, 177, 62,  255, 145, 166, 73,  255, 127, 152, 84,  255, 106, 133, 81,  255, 97,  123, 60,  255, 106, 130, 39,  255, 133,
    162, 60,  255, 99,  139, 60,  255, 101, 141, 65,  255, 139, 168, 74,  255, 162, 186, 76,  255, 129, 161, 62,  255, 136, 166, 67,  255, 107, 133,
    52,  255, 90,  123, 48,  255, 122, 153, 74,  255, 125, 157, 67,  255, 139, 166, 73,  255, 135, 161, 74,  255, 173, 191, 87,  255, 195, 204, 128,
    255, 65,  77,  47,  255, 23,  46,  21,  255, 26,  42,  19,  255, 40,  53,  26,  255, 81,  103, 53,  255, 52,  67,  40,  255, 99,  125, 47,  255,
    111, 141, 55,  255, 102, 134, 47,  255, 132, 158, 73,  255, 215, 217, 122, 255, 205, 215, 147, 255, 190, 203, 140, 255, 137, 159, 98,  255, 119,
    154, 100, 255, 132, 167, 106, 255, 150, 181, 105, 255, 150, 177, 97,  255, 143, 173, 97,  255, 163, 187, 97,  255, 181, 202, 103, 255, 143, 160,
    58,  255, 65,  91,  47,  255, 60,  94,  40,  255, 68,  110, 41,  255, 62,  92,  31,  255, 149, 160, 73,  255, 199, 213, 113, 255, 175, 195, 102,
    255, 176, 198, 106, 255, 186, 205, 123, 255, 191, 212, 100, 255, 180, 200, 107, 255, 149, 181, 132, 255, 161, 196, 140, 255, 178, 208, 143, 255,
    204, 223, 130, 255, 189, 207, 102, 255, 166, 196, 92,  255, 161, 185, 73,  255, 113, 144, 55,  255, 86,  122, 50,  255, 87,  123, 53,  255, 84,
    120, 53,  255, 91,  124, 74,  255, 92,  127, 68,  255, 137, 160, 69,  255, 157, 172, 73,  255, 152, 170, 74,  255, 142, 162, 68,  255, 129, 153,
    62,  255, 106, 134, 47,  255, 78,  112, 31,  255, 65,  98,  29,  255, 62,  91,  28,  255, 67,  97,  25,  255, 67,  104, 28,  255, 52,  90,  23,
    255, 46,  81,  17,  255, 75,  99,  26,  255, 110, 131, 47,  255, 121, 141, 58,  255, 80,  110, 47,  255, 90,  109, 47,  255, 185, 200, 99,  255,
    158, 186, 97,  255, 194, 189, 76,  255, 235, 241, 96,  255, 191, 210, 84,  255, 122, 151, 60,  255, 31,  51,  26,  255, 40,  53,  28,  255, 117,
    136, 72,  255, 160, 186, 110, 255, 163, 188, 105, 255, 176, 200, 104, 255, 157, 181, 91,  255, 116, 146, 69,  255, 68,  108, 36,  255, 52,  76,
    36,  255, 37,  51,  40,  255, 23,  31,  19,  255, 25,  33,  21,  255, 28,  38,  21,  255, 72,  103, 32,  255, 84,  128, 44,  255, 76,  117, 47,
    255, 73,  111, 47,  255, 130, 151, 65,  255, 196, 210, 112, 255, 196, 215, 115, 255, 154, 176, 84,  255, 41,  67,  25,  255, 28,  43,  23,  255,
    60,  73,  21,  255, 169, 194, 62,  255, 160, 187, 60,  255, 172, 194, 93,  255, 173, 192, 105, 255, 85,  94,  47,  255, 121, 131, 75,  255, 45,
    58,  36,  255, 19,  28,  19,  255, 47,  71,  31,  255, 62,  96,  42,  255, 57,  89,  39,  255, 58,  89,  40,  255, 49,  75,  36,  255, 32,  48,
    26,  255, 33,  49,  28,  255, 32,  48,  28,  255, 29,  39,  26,  255, 37,  37,  32,  255, 52,  51,  40,  255, 29,  44,  26,  255, 37,  51,  29,
    255, 41,  52,  26,  255, 56,  78,  34,  255, 65,  94,  42,  255, 62,  87,  34,  255, 78,  110, 41,  255, 87,  124, 39,  255, 60,  87,  34,  255,
    62,  65,  31,  255, 201, 217, 128, 255, 160, 192, 119, 255, 142, 179, 108, 255, 157, 185, 101, 255, 209, 219, 114, 255, 157, 177, 83,  255, 169,
    187, 92,  255, 202, 219, 133, 255, 195, 215, 134, 255, 169, 188, 106, 255, 125, 141, 80,  255, 60,  84,  37,  255, 83,  107, 58,  255, 107, 129,
    79,  255, 164, 189, 146, 255, 155, 181, 101, 255, 181, 205, 141, 255, 166, 195, 162, 255, 152, 186, 135, 255, 132, 149, 92,  255, 104, 119, 50,
    255, 105, 139, 43,  255, 93,  128, 40,  255, 77,  105, 37,  255, 47,  62,  31,  255, 76,  94,  47,  255, 114, 138, 60,  255, 160, 174, 74,  255,
    151, 171, 81,  255, 135, 158, 71,  255, 108, 136, 65,  255, 91,  121, 60,  255, 84,  118, 50,  255, 113, 146, 73,  255, 90,  129, 44,  255, 84,
    123, 37,  255, 90,  126, 43,  255, 95,  122, 52,  255, 99,  129, 60,  255, 92,  121, 52,  255, 133, 159, 65,  255, 149, 170, 73,  255, 163, 180,
    80,  255, 173, 188, 86,  255, 92,  117, 47,  255, 65,  97,  34,  255, 65,  98,  43,  255, 63,  91,  50,  255, 75,  106, 53,  255, 100, 115, 62,
    255, 128, 144, 75,  255, 150, 174, 72,  255, 122, 154, 52,  255, 132, 160, 68,  255, 166, 184, 125, 255, 91,  99,  69,  255, 170, 184, 113, 255,
    168, 195, 136, 255, 164, 192, 137, 255, 171, 197, 138, 255, 176, 192, 118, 255, 71,  100, 42,  255, 95,  117, 44,  255, 157, 173, 79,  255, 161,
    182, 87,  255, 160, 182, 95,  255, 155, 169, 95,  255, 92,  111, 55,  255, 109, 130, 68,  255, 102, 124, 65,  255, 79,  105, 53,  255, 82,  113,
    50,  255, 78,  105, 43,  255, 23,  28,  21,  255, 34,  44,  28,  255, 77,  92,  45,  255, 52,  79,  25,  255, 119, 148, 62,  255, 161, 182, 91,
    255, 157, 177, 94,  255, 164, 185, 102, 255, 195, 209, 117, 255, 211, 217, 125, 255, 215, 218, 122, 255, 232, 228, 122, 255, 226, 218, 112, 255,
    139, 154, 65,  255, 108, 146, 65,  255, 113, 153, 81,  255, 133, 170, 95,  255, 169, 194, 102, 255, 206, 217, 113, 255, 84,  87,  42,  255, 17,
    37,  17,  255, 127, 148, 78,  255, 186, 200, 114, 255, 145, 168, 94,  255, 151, 174, 89,  255, 141, 165, 112, 255, 115, 145, 109, 255, 113, 142,
    95,  255, 98,  129, 65,  255, 108, 140, 69,  255, 171, 191, 118, 255, 118, 145, 60,  255, 115, 149, 84,  255, 146, 176, 130, 255, 145, 175, 113,
    255, 141, 170, 81,  255, 98,  127, 47,  255, 92,  124, 49,  255, 105, 132, 55,  255, 104, 129, 67,  255, 95,  123, 87,  255, 101, 131, 96,  255,
    89,  116, 68,  255, 104, 128, 52,  255, 190, 204, 92,  255, 172, 191, 87,  255, 129, 158, 81,  255, 176, 192, 91,  255, 159, 181, 95,  255, 111,
    142, 73,  255, 86,  117, 47,  255, 63,  97,  31,  255, 94,  121, 52,  255, 65,  82,  31,  255, 60,  89,  23,  255, 76,  100, 36,  255, 92,  118,
    47,  255, 101, 126, 58,  255, 48,  62,  32,  255, 55,  81,  37,  255, 44,  75,  31,  255, 31,  58,  23,  255, 55,  80,  33,  255, 166, 189, 91,
    255, 112, 138, 60,  255, 112, 141, 60,  255, 110, 142, 58,  255, 117, 143, 62,  255, 178, 186, 94,  255, 206, 211, 117, 255, 160, 181, 116, 255,
    142, 172, 119, 255, 135, 170, 115, 255, 143, 178, 122, 255, 155, 187, 114, 255, 179, 202, 99,  255, 141, 174, 95,  255, 176, 201, 100, 255, 175,
    197, 102, 255, 173, 187, 71,  255, 93,  128, 32,  255, 87,  120, 49,  255, 119, 149, 73,  255, 144, 175, 77,  255, 138, 168, 75,  255, 160, 188,
    90,  255, 191, 209, 97,  255, 192, 208, 89,  255, 196, 205, 83,  255, 183, 194, 102, 255, 181, 195, 108, 255, 169, 198, 100, 255, 155, 185, 109,
    255, 179, 204, 96,  255, 193, 215, 90,  255, 200, 218, 86,  255, 215, 229, 111, 255, 190, 206, 89,  255, 179, 197, 75,  255, 211, 219, 108, 255,
    149, 174, 87,  255, 104, 142, 65,  255, 101, 139, 67,  255, 107, 142, 84,  255, 110, 144, 86,  255, 154, 176, 78,  255, 160, 176, 68,  255, 161,
    172, 68,  255, 195, 200, 107, 255, 168, 186, 91,  255, 114, 141, 39,  255, 98,  129, 31,  255, 107, 132, 32,  255, 87,  114, 33,  255, 58,  86,
    23,  255, 86,  118, 42,  255, 84,  121, 41,  255, 62,  98,  25,  255, 53,  84,  19,  255, 60,  91,  25,  255, 69,  99,  26,  255, 76,  107, 47,
    255, 29,  52,  29,  255, 73,  83,  36,  255, 101, 129, 52,  255, 142, 147, 60,  255, 236, 231, 105, 255, 193, 210, 87,  255, 174, 199, 85,  255,
    97,  126, 52,  255, 43,  60,  29,  255, 110, 132, 68,  255, 165, 187, 80,  255, 190, 204, 93,  255, 79,  109, 41,  255, 73,  109, 39,  255, 63,
    98,  36,  255, 67,  100, 37,  255, 39,  60,  28,  255, 26,  34,  26,  255, 29,  38,  26,  255, 23,  36,  21,  255, 31,  46,  25,  255, 55,  74,
    29,  255, 90,  120, 41,  255, 115, 154, 58,  255, 110, 151, 58,  255, 132, 159, 68,  255, 196, 209, 112, 255, 187, 204, 111, 255, 202, 218, 119,
    255, 128, 153, 73,  255, 34,  55,  17,  255, 131, 145, 58,  255, 169, 191, 67,  255, 163, 191, 74,  255, 164, 192, 68,  255, 181, 204, 65,  255,
    196, 219, 84,  255, 117, 133, 72,  255, 47,  58,  32,  255, 60,  74,  44,  255, 40,  55,  28,  255, 65,  96,  42,  255, 49,  73,  36,  255, 41,
    60,  32,  255, 36,  53,  32,  255, 33,  48,  31,  255, 36,  51,  32,  255, 37,  52,  31,  255, 36,  51,  31,  255, 29,  39,  25,  255, 41,  49,
    31,  255, 37,  44,  31,  255, 47,  58,  33,  255, 55,  68,  38,  255, 60,  82,  34,  255, 73,  106, 44,  255, 55,  83,  31,  255, 100, 130, 48,
    255, 124, 157, 60,  255, 126, 154, 68,  255, 120, 132, 69,  255, 181, 196, 100, 255, 169, 198, 124, 255, 167, 195, 137, 255, 199, 209, 118, 255,
    156, 177, 97,  255, 129, 157, 93,  255, 144, 169, 94,  255, 170, 197, 94,  255, 165, 196, 91,  255, 171, 201, 131, 255, 187, 214, 158, 255, 146,
    164, 108, 255, 71,  95,  38,  255, 63,  87,  41,  255, 98,  116, 71,  255, 177, 196, 136, 255, 171, 197, 161, 255, 146, 181, 146, 255, 157, 187,
    111, 255, 174, 191, 96,  255, 123, 155, 55,  255, 96,  131, 48,  255, 86,  121, 46,  255, 80,  116, 41,  255, 76,  114, 36,  255, 89,  119, 44,
    255, 141, 159, 73,  255, 225, 230, 118, 255, 188, 210, 98,  255, 117, 154, 67,  255, 85,  114, 55,  255, 76,  107, 45,  255, 68,  104, 42,  255,
    81,  115, 43,  255, 110, 145, 52,  255, 109, 144, 53,  255, 115, 150, 60,  255, 113, 146, 58,  255, 90,  118, 50,  255, 96,  126, 52,  255, 133,
    160, 67,  255, 154, 174, 76,  255, 157, 173, 79,  255, 101, 123, 65,  255, 53,  87,  38,  255, 95,  126, 55,  255, 74,  106, 60,  255, 65,  94,
    48,  255, 36,  53,  32,  255, 21,  34,  21,  255, 75,  103, 48,  255, 118, 151, 86,  255, 120, 152, 104, 255, 164, 187, 125, 255, 177, 201, 118,
    255, 102, 118, 60,  255, 174, 189, 126, 255, 163, 189, 142, 255, 159, 188, 135, 255, 195, 213, 140, 255, 138, 151, 84,  255, 43,  63,  33,  255,
    34,  47,  36,  255, 47,  60,  44,  255, 71,  84,  47,  255, 102, 120, 55,  255, 134, 155, 76,  255, 152, 173, 84,  255, 161, 184, 93,  255, 160,
    184, 95,  255, 154, 178, 91,  255, 141, 169, 82,  255, 121, 143, 65,  255, 52,  60,  31,  255, 21,  32,  21,  255, 63,  80,  39,  255, 85,  115,
    38,  255, 132, 162, 68,  255, 146, 171, 75,  255, 168, 187, 87,  255, 212, 220, 116, 255, 216, 223, 125, 255, 227, 229, 134, 255, 229, 226, 131,
    255, 196, 195, 105, 255, 93,  102, 45,  255, 44,  60,  23,  255, 108, 130, 52,  255, 145, 168, 74,  255, 144, 169, 80,  255, 149, 177, 82,  255,
    183, 201, 97,  255, 120, 129, 58,  255, 17,  31,  17,  255, 32,  49,  23,  255, 154, 172, 92,  255, 149, 171, 104, 255, 113, 144, 72,  255, 158,
    180, 84,  255, 136, 160, 109, 255, 121, 147, 119, 255, 124, 148, 108, 255, 116, 142, 92,  255, 120, 147, 84,  255, 92,  121, 60,  255, 124, 157,
    110, 255, 140, 172, 114, 255, 136, 172, 81,  255, 95,  123, 52,  255, 43,  75,  31,  255, 58,  95,  34,  255, 101, 131, 45,  255, 122, 145, 65,
    255, 97,  126, 87,  255, 102, 131, 97,  255, 89,  113, 65,  255, 122, 149, 68,  255, 154, 174, 95,  255, 156, 177, 90,  255, 175, 193, 94,  255,
    190, 197, 87,  255, 156, 175, 95,  255, 125, 153, 87,  255, 113, 144, 74,  255, 109, 141, 65,  255, 123, 152, 72,  255, 139, 149, 80,  255, 53,
    82,  29,  255, 58,  97,  36,  255, 72,  108, 37,  255, 95,  123, 52,  255, 58,  74,  40,  255, 52,  84,  38,  255, 47,  83,  32,  255, 58,  99,
    41,  255, 107, 142, 72,  255, 169, 190, 101, 255, 168, 190, 115, 255, 168, 192, 114, 255, 141, 170, 95,  255, 123, 147, 73,  255, 170, 175, 89,
    255, 182, 199, 124, 255, 147, 181, 122, 255, 153, 186, 125, 255, 152, 186, 131, 255, 166, 195, 127, 255, 203, 218, 118, 255, 207, 218, 102, 255,
    197, 215, 112, 255, 214, 225, 112, 255, 200, 209, 92,  255, 137, 165, 69,  255, 138, 168, 78,  255, 166, 183, 99,  255, 156, 179, 100, 255, 156,
    179, 98,  255, 171, 189, 95,  255, 173, 193, 96,  255, 174, 195, 100, 255, 178, 198, 97,  255, 164, 183, 67,  255, 121, 143, 62,  255, 119, 144,
    79,  255, 156, 173, 96,  255, 157, 183, 90,  255, 168, 198, 95,  255, 179, 206, 93,  255, 175, 194, 83,  255, 176, 190, 77,  255, 218, 218, 113,
    255, 189, 196, 113, 255, 189, 194, 111, 255, 187, 205, 102, 255, 144, 176, 87,  255, 127, 165, 94,  255, 126, 162, 92,  255, 144, 172, 104, 255,
    168, 186, 83,  255, 172, 179, 67,  255, 209, 210, 106, 255, 225, 232, 139, 255, 207, 217, 110, 255, 153, 167, 40,  255, 147, 160, 39,  255, 183,
    183, 58,  255, 141, 163, 62,  255, 47,  76,  23,  255, 68,  83,  31,  255, 90,  114, 42,  255, 62,  84,  29,  255, 82,  108, 34,  255, 79,  112,
    32,  255, 102, 128, 36,  255, 74,  104, 47,  255, 40,  65,  23,  255, 126, 139, 63,  255, 158, 178, 97,  255, 157, 174, 92,  255, 205, 208, 119,
    255, 209, 220, 130, 255, 193, 204, 125, 255, 197, 207, 121, 255, 159, 169, 99,  255, 168, 176, 100, 255, 128, 143, 74,  255, 55,  71,  33,  255,
    40,  58,  25,  255, 58,  96,  34,  255, 84,  116, 44,  255, 85,  116, 43,  255, 58,  87,  34,  255, 23,  31,  23,  255, 23,  31,  21,  255, 23,
    31,  17,  255, 45,  60,  31,  255, 53,  76,  37,  255, 55,  84,  36,  255, 72,  108, 41,  255, 75,  105, 44,  255, 86,  110, 49,  255, 160, 176,
    85,  255, 197, 213, 116, 255, 189, 206, 107, 255, 185, 206, 111, 255, 82,  109, 39,  255, 139, 157, 62,  255, 189, 208, 94,  255, 152, 183, 60,
    255, 172, 200, 81,  255, 171, 192, 89,  255, 78,  87,  52,  255, 21,  26,  21,  255, 112, 138, 85,  255, 98,  121, 67,  255, 39,  47,  34,  255,
    60,  69,  50,  255, 62,  73,  60,  255, 33,  43,  28,  255, 46,  68,  32,  255, 48,  72,  34,  255, 50,  73,  36,  255, 47,  69,  34,  255, 29,
    42,  26,  255, 26,  33,  25,  255, 37,  55,  28,  255, 43,  52,  32,  255, 37,  44,  31,  255, 42,  55,  31,  255, 71,  98,  38,  255, 81,  112,
    41,  255, 126, 146, 62,  255, 164, 189, 95,  255, 136, 164, 80,  255, 184, 205, 125, 255, 174, 205, 133, 255, 123, 161, 80,  255, 127, 154, 67,
    255, 186, 197, 111, 255, 160, 180, 83,  255, 99,  137, 72,  255, 146, 174, 94,  255, 164, 191, 94,  255, 147, 181, 83,  255, 144, 174, 102, 255,
    174, 197, 113, 255, 160, 194, 123, 255, 183, 209, 160, 255, 145, 168, 90,  255, 77,  108, 34,  255, 102, 125, 60,  255, 168, 185, 130, 255, 153,
    185, 148, 255, 146, 183, 127, 255, 176, 196, 115, 255, 151, 170, 74,  255, 127, 160, 60,  255, 99,  134, 53,  255, 87,  121, 52,  255, 74,  107,
    48,  255, 58,  92,  39,  255, 74,  104, 29,  255, 211, 213, 95,  255, 241, 238, 110, 255, 195, 212, 90,  255, 87,  117, 53,  255, 71,  99,  44,
    255, 89,  120, 43,  255, 93,  126, 38,  255, 109, 139, 44,  255, 130, 155, 56,  255, 123, 147, 60,  255, 106, 133, 55,  255, 86,  119, 43,  255,
    86,  113, 45,  255, 82,  107, 48,  255, 77,  104, 46,  255, 79,  108, 48,  255, 77,  101, 60,  255, 75,  97,  65,  255, 63,  87,  48,  255, 111,
    136, 73,  255, 85,  112, 60,  255, 37,  53,  29,  255, 43,  58,  32,  255, 93,  126, 58,  255, 115, 148, 82,  255, 107, 138, 68,  255, 151, 176,
    98,  255, 154, 181, 89,  255, 104, 135, 55,  255, 79,  104, 44,  255, 160, 180, 119, 255, 157, 187, 142, 255, 163, 192, 132, 255, 169, 187, 111,
    255, 60,  81,  53,  255, 46,  65,  48,  255, 47,  68,  50,  255, 84,  99,  58,  255, 149, 163, 77,  255, 158, 177, 85,  255, 165, 184, 97,  255,
    169, 185, 101, 255, 169, 187, 101, 255, 167, 186, 100, 255, 166, 186, 101, 255, 155, 179, 91,  255, 152, 178, 89,  255, 139, 163, 76,  255, 82,
    102, 44,  255, 73,  89,  42,  255, 96,  121, 49,  255, 120, 150, 56,  255, 130, 156, 55,  255, 148, 166, 69,  255, 164, 177, 86,  255, 164, 175,
    96,  255, 149, 164, 89,  255, 124, 144, 65,  255, 45,  58,  26,  255, 31,  52,  32,  255, 47,  74,  40,  255, 53,  86,  38,  255, 60,  82,  47,
    255, 68,  89,  48,  255, 76,  105, 50,  255, 69,  102, 46,  255, 57,  89,  37,  255, 49,  75,  28,  255, 50,  74,  26,  255, 161, 177, 95,  255,
    138, 161, 106, 255, 101, 135, 85,  255, 132, 162, 74,  255, 166, 185, 92,  255, 126, 151, 105, 255, 114, 141, 101, 255, 119, 143, 103, 255, 135,
    157, 100, 255, 109, 136, 69,  255, 131, 167, 97,  255, 141, 173, 71,  255, 112, 143, 55,  255, 52,  84,  37,  255, 53,  83,  42,  255, 44,  78,
    36,  255, 96,  133, 60,  255, 118, 145, 60,  255, 94,  125, 78,  255, 93,  122, 87,  255, 80,  106, 55,  255, 134, 160, 87,  255, 149, 173, 105,
    255, 112, 139, 85,  255, 132, 156, 79,  255, 200, 207, 92,  255, 158, 171, 79,  255, 113, 146, 83,  255, 133, 163, 89,  255, 152, 177, 79,  255,
    173, 193, 74,  255, 198, 209, 90,  255, 121, 138, 55,  255, 81,  116, 37,  255, 76,  103, 34,  255, 49,  68,  26,  255, 96,  124, 58,  255, 87,
    125, 58,  255, 76,  116, 53,  255, 138, 168, 87,  255, 130, 159, 90,  255, 137, 157, 95,  255, 157, 185, 115, 255, 138, 172, 118, 255, 148, 176,
    121, 255, 165, 186, 105, 255, 193, 199, 114, 255, 210, 224, 148, 255, 175, 203, 137, 255, 166, 195, 133, 255, 172, 201, 133, 255, 228, 233, 128,
    255, 238, 233, 113, 255, 216, 217, 98,  255, 194, 192, 89,  255, 140, 140, 65,  255, 125, 138, 78,  255, 134, 152, 74,  255, 171, 192, 119, 255,
    143, 171, 114, 255, 139, 169, 107, 255, 133, 166, 104, 255, 134, 165, 104, 255, 144, 173, 103, 255, 155, 180, 111, 255, 161, 185, 114, 255, 165,
    187, 99,  255, 133, 161, 84,  255, 130, 161, 91,  255, 126, 154, 95,  255, 157, 185, 110, 255, 217, 223, 111, 255, 158, 170, 65,  255, 94,  122,
    23,  255, 96,  131, 33,  255, 127, 149, 45,  255, 144, 153, 63,  255, 113, 121, 55,  255, 164, 177, 77,  255, 188, 207, 102, 255, 171, 200, 112,
    255, 161, 188, 111, 255, 188, 206, 112, 255, 147, 166, 63,  255, 182, 181, 94,  255, 227, 234, 155, 255, 219, 226, 138, 255, 223, 228, 127, 255,
    199, 199, 68,  255, 195, 191, 58,  255, 225, 216, 92,  255, 135, 161, 71,  255, 46,  80,  25,  255, 29,  37,  23,  255, 40,  44,  33,  255, 26,
    34,  19,  255, 91,  105, 36,  255, 129, 156, 53,  255, 108, 135, 49,  255, 51,  79,  34,  255, 63,  83,  26,  255, 157, 175, 91,  255, 142, 168,
    102, 255, 156, 172, 103, 255, 174, 188, 109, 255, 206, 212, 141, 255, 201, 210, 136, 255, 148, 163, 90,  255, 121, 136, 68,  255, 104, 133, 74,
    255, 34,  60,  28,  255, 21,  34,  19,  255, 52,  76,  31,  255, 67,  103, 40,  255, 110, 141, 58,  255, 100, 142, 65,  255, 97,  135, 52,  255,
    78,  102, 44,  255, 17,  25,  19,  255, 52,  68,  33,  255, 71,  97,  48,  255, 65,  95,  50,  255, 60,  91,  46,  255, 60,  95,  44,  255, 53,
    87,  34,  255, 48,  81,  28,  255, 72,  100, 32,  255, 173, 190, 98,  255, 195, 212, 111, 255, 192, 209, 110, 255, 189, 207, 109, 255, 135, 157,
    65,  255, 101, 128, 50,  255, 148, 171, 71,  255, 177, 198, 111, 255, 100, 123, 63,  255, 26,  37,  19,  255, 76,  87,  45,  255, 121, 153, 96,
    255, 107, 135, 67,  255, 101, 128, 77,  255, 82,  100, 65,  255, 98,  115, 91,  255, 62,  78,  73,  255, 26,  36,  21,  255, 43,  60,  31,  255,
    43,  60,  32,  255, 28,  38,  26,  255, 19,  21,  21,  255, 19,  23,  19,  255, 33,  43,  26,  255, 40,  52,  31,  255, 39,  40,  29,  255, 32,
    41,  23,  255, 68,  96,  34,  255, 123, 144, 52,  255, 178, 200, 104, 255, 133, 167, 104, 255, 100, 139, 78,  255, 127, 156, 77,  255, 187, 206,
    123, 255, 167, 196, 115, 255, 122, 154, 75,  255, 107, 143, 69,  255, 145, 176, 96,  255, 164, 189, 99,  255, 163, 188, 89,  255, 172, 195, 87,
    255, 166, 186, 99,  255, 152, 175, 100, 255, 180, 193, 109, 255, 189, 207, 113, 255, 167, 198, 121, 255, 174, 201, 136, 255, 165, 189, 108, 255,
    126, 153, 62,  255, 168, 184, 127, 255, 202, 220, 152, 255, 187, 207, 127, 255, 116, 139, 67,  255, 92,  117, 41,  255, 141, 157, 58,  255, 147,
    171, 60,  255, 109, 139, 43,  255, 80,  114, 42,  255, 55,  87,  28,  255, 160, 165, 68,  255, 249, 243, 131, 255, 235, 230, 110, 255, 203, 215,
    95,  255, 101, 123, 56,  255, 88,  107, 58,  255, 123, 139, 71,  255, 153, 174, 89,  255, 151, 178, 92,  255, 143, 170, 89,  255, 151, 175, 87,
    255, 145, 166, 76,  255, 122, 142, 58,  255, 105, 130, 47,  255, 77,  106, 45,  255, 57,  83,  46,  255, 55,  83,  40,  255, 132, 150, 99,  255,
    200, 210, 140, 255, 186, 196, 109, 255, 155, 169, 87,  255, 75,  101, 42,  255, 68,  98,  37,  255, 101, 134, 60,  255, 107, 138, 62,  255, 140,
    163, 94,  255, 174, 189, 111, 255, 150, 175, 73,  255, 157, 182, 83,  255, 136, 151, 84,  255, 86,  110, 49,  255, 119, 144, 77,  255, 155, 183,
    123, 255, 177, 197, 125, 255, 126, 142, 87,  255, 77,  101, 71,  255, 56,  79,  62,  255, 60,  85,  62,  255, 83,  102, 65,  255, 159, 172, 81,
    255, 188, 199, 93,  255, 181, 195, 96,  255, 178, 194, 101, 255, 180, 195, 106, 255, 179, 195, 107, 255, 175, 192, 103, 255, 171, 190, 100, 255,
    165, 185, 99,  255, 161, 181, 95,  255, 141, 166, 79,  255, 104, 128, 60,  255, 99,  117, 62,  255, 112, 138, 65,  255, 95,  130, 48,  255, 68,
    99,  42,  255, 48,  77,  39,  255, 48,  79,  38,  255, 44,  78,  36,  255, 78,  112, 44,  255, 55,  73,  32,  255, 38,  55,  31,  255, 47,  71,
    44,  255, 50,  75,  48,  255, 57,  83,  50,  255, 60,  84,  55,  255, 57,  84,  52,  255, 55,  84,  44,  255, 110, 124, 41,  255, 111, 129, 31,
    255, 87,  115, 38,  255, 172, 187, 104, 255, 145, 166, 104, 255, 101, 131, 90,  255, 117, 148, 74,  255, 166, 185, 80,  255, 154, 175, 91,  255,
    108, 138, 89,  255, 90,  122, 84,  255, 117, 143, 86,  255, 129, 154, 68,  255, 132, 166, 62,  255, 99,  131, 56,  255, 83,  121, 55,  255, 55,
    92,  39,  255, 63,  95,  50,  255, 52,  84,  42,  255, 77,  110, 60,  255, 106, 135, 56,  255, 89,  117, 65,  255, 84,  110, 73,  255, 78,  103,
    49,  255, 108, 141, 65,  255, 139, 162, 75,  255, 161, 181, 83,  255, 129, 154, 74,  255, 140, 163, 87,  255, 184, 193, 94,  255, 146, 171, 89,
    255, 151, 173, 82,  255, 193, 202, 74,  255, 206, 213, 78,  255, 164, 179, 78,  255, 105, 141, 69,  255, 119, 157, 58,  255, 132, 157, 72,  255,
    90,  99,  53,  255, 56,  74,  36,  255, 86,  115, 60,  255, 135, 162, 94,  255, 147, 174, 98,  255, 102, 135, 89,  255, 134, 156, 102, 255, 170,
    194, 113, 255, 138, 173, 116, 255, 140, 175, 124, 255, 155, 183, 124, 255, 209, 215, 137, 255, 198, 198, 134, 255, 180, 189, 129, 255, 193, 197,
    128, 255, 192, 192, 113, 255, 179, 174, 93,  255, 130, 139, 67,  255, 87,  111, 45,  255, 58,  91,  31,  255, 34,  56,  19,  255, 75,  96,  50,
    255, 103, 132, 42,  255, 163, 184, 65,  255, 161, 184, 98,  255, 150, 180, 109, 255, 137, 170, 104, 255, 138, 169, 106, 255, 133, 166, 104, 255,
    138, 170, 107, 255, 148, 175, 110, 255, 202, 216, 121, 255, 212, 226, 116, 255, 203, 220, 98,  255, 157, 180, 93,  255, 169, 186, 102, 255, 185,
    199, 99,  255, 159, 178, 84,  255, 112, 141, 55,  255, 122, 155, 63,  255, 136, 171, 79,  255, 132, 160, 76,  255, 87,  107, 47,  255, 58,  80,
    31,  255, 106, 112, 37,  255, 188, 198, 86,  255, 185, 199, 104, 255, 174, 189, 93,  255, 142, 147, 55,  255, 230, 229, 150, 255, 223, 232, 177,
    255, 221, 228, 137, 255, 229, 230, 130, 255, 227, 220, 92,  255, 233, 220, 99,  255, 208, 214, 121, 255, 91,  122, 49,  255, 38,  62,  23,  255,
    28,  38,  21,  255, 43,  47,  38,  255, 41,  52,  26,  255, 48,  58,  21,  255, 76,  93,  36,  255, 52,  69,  26,  255, 47,  75,  28,  255, 69,
    84,  28,  255, 169, 187, 105, 255, 137, 166, 107, 255, 145, 167, 104, 255, 165, 183, 104, 255, 164, 184, 101, 255, 165, 185, 101, 255, 162, 186,
    99,  255, 141, 162, 92,  255, 94,  116, 65,  255, 33,  38,  33,  255, 23,  26,  21,  255, 65,  90,  36,  255, 92,  123, 45,  255, 124, 156, 74,
    255, 103, 139, 75,  255, 131, 164, 72,  255, 116, 146, 65,  255, 31,  43,  21,  255, 67,  94,  47,  255, 65,  92,  52,  255, 58,  87,  44,  255,
    69,  103, 46,  255, 55,  84,  38,  255, 40,  60,  32,  255, 52,  72,  38,  255, 62,  86,  44,  255, 80,  99,  47,  255, 159, 175, 92,  255, 187,
    206, 104, 255, 183, 205, 92,  255, 167, 190, 72,  255, 114, 144, 56,  255, 122, 148, 60,  255, 116, 139, 72,  255, 104, 136, 92,  255, 90,  120,
    46,  255, 124, 149, 87,  255, 104, 138, 89,  255, 107, 139, 62,  255, 105, 144, 82,  255, 101, 127, 68,  255, 68,  81,  62,  255, 45,  58,  52,
    255, 15,  19,  19,  255, 17,  21,  21,  255, 21,  23,  23,  255, 15,  19,  19,  255, 19,  25,  21,  255, 21,  29,  23,  255, 23,  31,  23,  255,
    26,  33,  23,  255, 33,  36,  26,  255, 31,  32,  23,  255, 58,  87,  32,  255, 115, 134, 58,  255, 165, 188, 117, 255, 120, 158, 106, 255, 115,
    155, 92,  255, 130, 161, 74,  255, 180, 195, 83,  255, 204, 211, 113, 255, 201, 217, 121, 255, 177, 205, 118, 255, 146, 185, 111, 255, 144, 180,
    102, 255, 117, 138, 56,  255, 128, 148, 60,  255, 173, 192, 97,  255, 171, 194, 107, 255, 140, 169, 91,  255, 103, 136, 65,  255, 141, 164, 75,
    255, 170, 196, 100, 255, 185, 213, 141, 255, 143, 157, 96,  255, 148, 169, 125, 255, 162, 183, 116, 255, 202, 204, 91,  255, 210, 216, 107, 255,
    78,  92,  36,  255, 50,  52,  31,  255, 120, 130, 53,  255, 169, 186, 84,  255, 158, 177, 78,  255, 153, 168, 90,  255, 235, 234, 158, 255, 251,
    249, 181, 255, 245, 243, 183, 255, 245, 245, 172, 255, 217, 222, 132, 255, 182, 197, 112, 255, 150, 174, 111, 255, 132, 163, 106, 255, 115, 149,
    96,  255, 107, 140, 94,  255, 115, 146, 91,  255, 140, 167, 93,  255, 177, 196, 94,  255, 195, 208, 108, 255, 166, 182, 93,  255, 82,  109, 53,
    255, 68,  97,  55,  255, 77,  108, 65,  255, 94,  119, 79,  255, 157, 174, 99,  255, 207, 221, 106, 255, 183, 198, 78,  255, 143, 166, 62,  255,
    149, 172, 81,  255, 157, 181, 100, 255, 150, 179, 109, 255, 155, 183, 120, 255, 153, 182, 107, 255, 167, 192, 132, 255, 193, 208, 133, 255, 190,
    200, 116, 255, 166, 185, 101, 255, 190, 209, 127, 255, 207, 222, 139, 255, 166, 184, 112, 255, 108, 133, 71,  255, 77,  102, 56,  255, 69,  96,
    68,  255, 62,  87,  71,  255, 60,  84,  58,  255, 118, 136, 63,  255, 194, 199, 94,  255, 204, 212, 101, 255, 194, 204, 99,  255, 191, 202, 101,
    255, 185, 199, 98,  255, 180, 197, 95,  255, 178, 195, 94,  255, 174, 191, 90,  255, 165, 184, 87,  255, 129, 152, 72,  255, 95,  111, 60,  255,
    100, 122, 60,  255, 102, 133, 52,  255, 108, 138, 50,  255, 86,  115, 45,  255, 55,  87,  42,  255, 52,  84,  44,  255, 78,  109, 48,  255, 68,
    86,  40,  255, 34,  48,  23,  255, 58,  81,  42,  255, 74,  101, 58,  255, 71,  97,  62,  255, 68,  94,  65,  255, 65,  94,  63,  255, 105, 125,
    56,  255, 166, 173, 44,  255, 133, 147, 36,  255, 103, 126, 44,  255, 175, 190, 104, 255, 164, 179, 107, 255, 111, 139, 98,  255, 111, 142, 72,
    255, 160, 178, 74,  255, 161, 180, 76,  255, 138, 165, 68,  255, 125, 153, 67,  255, 124, 150, 62,  255, 105, 139, 52,  255, 127, 157, 99,  255,
    92,  119, 80,  255, 74,  110, 49,  255, 100, 135, 74,  255, 108, 139, 84,  255, 65,  92,  41,  255, 55,  86,  46,  255, 77,  106, 52,  255, 85,
    115, 50,  255, 71,  97,  52,  255, 63,  86,  36,  255, 44,  69,  31,  255, 47,  69,  31,  255, 96,  118, 47,  255, 98,  112, 53,  255, 119, 142,
    79,  255, 188, 197, 107, 255, 191, 198, 95,  255, 180, 187, 73,  255, 181, 190, 65,  255, 158, 174, 78,  255, 124, 152, 80,  255, 130, 158, 82,
    255, 143, 170, 82,  255, 158, 182, 102, 255, 200, 212, 130, 255, 135, 142, 68,  255, 65,  83,  39,  255, 154, 179, 104, 255, 124, 155, 101, 255,
    102, 138, 99,  255, 142, 163, 104, 255, 178, 197, 118, 255, 137, 172, 112, 255, 141, 176, 121, 255, 136, 171, 125, 255, 157, 182, 121, 255, 132,
    153, 94,  255, 73,  101, 65,  255, 85,  106, 77,  255, 69,  96,  69,  255, 60,  94,  65,  255, 56,  98,  62,  255, 55,  98,  62,  255, 65,  104,
    48,  255, 77,  114, 38,  255, 81,  117, 36,  255, 94,  123, 49,  255, 152, 172, 58,  255, 120, 141, 43,  255, 152, 170, 78,  255, 164, 186, 102,
    255, 152, 180, 109, 255, 154, 185, 110, 255, 155, 187, 111, 255, 190, 208, 131, 255, 241, 243, 143, 255, 227, 231, 111, 255, 231, 234, 105, 255,
    174, 192, 91,  255, 127, 164, 106, 255, 138, 174, 122, 255, 173, 194, 128, 255, 197, 209, 128, 255, 201, 213, 121, 255, 189, 207, 117, 255, 166,
    185, 103, 255, 114, 136, 63,  255, 55,  78,  29,  255, 90,  89,  38,  255, 211, 209, 98,  255, 204, 211, 89,  255, 120, 132, 55,  255, 144, 139,
    77,  255, 220, 233, 164, 255, 219, 230, 124, 255, 224, 228, 119, 255, 227, 232, 135, 255, 199, 198, 100, 255, 190, 194, 108, 255, 108, 131, 55,
    255, 53,  79,  31,  255, 36,  58,  23,  255, 28,  42,  19,  255, 37,  48,  21,  255, 48,  58,  23,  255, 47,  60,  23,  255, 43,  60,  21,  255,
    50,  67,  25,  255, 50,  74,  25,  255, 63,  77,  28,  255, 180, 194, 107, 255, 162, 186, 115, 255, 137, 164, 109, 255, 149, 172, 106, 255, 159,
    180, 106, 255, 159, 180, 107, 255, 169, 190, 106, 255, 155, 180, 96,  255, 83,  105, 53,  255, 50,  58,  32,  255, 86,  108, 39,  255, 105, 135,
    46,  255, 101, 135, 41,  255, 115, 148, 72,  255, 135, 167, 93,  255, 153, 184, 87,  255, 84,  115, 50,  255, 42,  65,  26,  255, 58,  82,  44,
    255, 52,  77,  38,  255, 77,  104, 43,  255, 85,  113, 44,  255, 69,  94,  43,  255, 91,  116, 53,  255, 127, 157, 71,  255, 134, 165, 69,  255,
    118, 150, 62,  255, 103, 133, 52,  255, 135, 160, 62,  255, 144, 162, 68,  255, 164, 188, 74,  255, 172, 197, 83,  255, 169, 190, 84,  255, 172,
    192, 89,  255, 159, 182, 113, 255, 118, 143, 73,  255, 145, 170, 96,  255, 114, 149, 84,  255, 109, 141, 60,  255, 92,  131, 81,  255, 118, 148,
    80,  255, 85,  102, 55,  255, 21,  29,  26,  255, 19,  23,  23,  255, 21,  25,  25,  255, 29,  34,  32,  255, 23,  31,  26,  255, 23,  31,  21,
    255, 23,  36,  23,  255, 26,  38,  25,  255, 23,  31,  25,  255, 25,  31,  23,  255, 31,  31,  25,  255, 52,  68,  32,  255, 91,  107, 47,  255,
    190, 201, 117, 255, 150, 179, 107, 255, 161, 180, 98,  255, 182, 195, 98,  255, 120, 136, 65,  255, 40,  53,  25,  255, 88,  95,  48,  255, 150,
    156, 84,  255, 139, 160, 87,  255, 119, 149, 74,  255, 85,  111, 42,  255, 107, 134, 52,  255, 129, 169, 83,  255, 115, 157, 80,  255, 116, 154,
    79,  255, 125, 160, 81,  255, 131, 165, 87,  255, 173, 192, 106, 255, 186, 199, 101, 255, 133, 149, 86,  255, 141, 151, 112, 255, 74,  94,  50,
    255, 88,  98,  39,  255, 250, 253, 110, 255, 130, 136, 60,  255, 25,  26,  19,  255, 134, 141, 78,  255, 222, 234, 126, 255, 231, 238, 146, 255,
    255, 254, 185, 255, 249, 249, 183, 255, 243, 246, 181, 255, 251, 253, 184, 255, 241, 241, 159, 255, 149, 169, 94,  255, 118, 151, 107, 255, 112,
    145, 105, 255, 115, 148, 103, 255, 113, 146, 98,  255, 113, 145, 92,  255, 122, 155, 90,  255, 142, 171, 87,  255, 160, 182, 84,  255, 183, 198,
    93,  255, 150, 165, 84,  255, 96,  123, 53,  255, 82,  108, 58,  255, 87,  117, 72,  255, 85,  118, 82,  255, 86,  115, 71,  255, 110, 127, 67,
    255, 164, 181, 86,  255, 200, 214, 84,  255, 160, 172, 73,  255, 87,  105, 58,  255, 130, 154, 76,  255, 151, 173, 84,  255, 164, 189, 100, 255,
    176, 198, 121, 255, 187, 208, 121, 255, 190, 212, 124, 255, 202, 220, 124, 255, 203, 216, 117, 255, 143, 163, 75,  255, 78,  110, 38,  255, 55,
    92,  34,  255, 102, 130, 60,  255, 98,  123, 62,  255, 62,  89,  67,  255, 60,  87,  60,  255, 62,  86,  39,  255, 83,  101, 43,  255, 167, 176,
    82,  255, 212, 212, 102, 255, 216, 217, 105, 255, 208, 213, 106, 255, 203, 210, 100, 255, 198, 207, 92,  255, 191, 201, 77,  255, 174, 189, 73,
    255, 147, 169, 72,  255, 108, 125, 68,  255, 93,  116, 55,  255, 91,  122, 53,  255, 84,  113, 41,  255, 99,  126, 47,  255, 100, 126, 56,  255,
    72,  103, 55,  255, 82,  113, 53,  255, 69,  87,  38,  255, 45,  58,  29,  255, 28,  34,  21,  255, 74,  100, 49,  255, 92,  123, 65,  255, 96,
    118, 60,  255, 131, 142, 62,  255, 154, 164, 52,  255, 156, 170, 42,  255, 140, 156, 47,  255, 125, 144, 55,  255, 179, 193, 105, 255, 177, 190,
    109, 255, 125, 147, 102, 255, 107, 136, 75,  255, 181, 197, 83,  255, 156, 182, 84,  255, 152, 178, 89,  255, 157, 174, 84,  255, 115, 142, 58,
    255, 102, 136, 62,  255, 110, 143, 84,  255, 125, 153, 96,  255, 120, 151, 68,  255, 128, 161, 87,  255, 127, 160, 107, 255, 87,  110, 48,  255,
    41,  65,  26,  255, 36,  55,  23,  255, 47,  79,  29,  255, 62,  89,  34,  255, 44,  63,  29,  255, 37,  53,  31,  255, 47,  69,  33,  255, 50,
    76,  31,  255, 28,  39,  21,  255, 26,  33,  19,  255, 79,  109, 39,  255, 122, 146, 55,  255, 120, 149, 62,  255, 147, 172, 74,  255, 107, 138,
    53,  255, 122, 154, 58,  255, 153, 179, 62,  255, 136, 165, 68,  255, 150, 181, 80,  255, 168, 180, 96,  255, 75,  95,  37,  255, 125, 149, 82,
    255, 157, 184, 117, 255, 121, 154, 109, 255, 122, 151, 105, 255, 117, 144, 97,  255, 181, 196, 115, 255, 143, 178, 111, 255, 144, 178, 121, 255,
    166, 190, 105, 255, 168, 192, 92,  255, 156, 177, 89,  255, 79,  110, 47,  255, 78,  109, 67,  255, 69,  104, 79,  255, 74,  110, 79,  255, 68,
    108, 72,  255, 68,  102, 67,  255, 73,  103, 47,  255, 97,  132, 50,  255, 91,  127, 49,  255, 105, 133, 58,  255, 155, 174, 72,  255, 113, 141,
    52,  255, 94,  126, 52,  255, 135, 158, 60,  255, 181, 193, 73,  255, 175, 186, 73,  255, 162, 167, 74,  255, 240, 238, 150, 255, 249, 246, 148,
    255, 241, 241, 133, 255, 241, 241, 137, 255, 209, 220, 98,  255, 189, 208, 101, 255, 168, 194, 116, 255, 157, 187, 135, 255, 165, 188, 138, 255,
    177, 197, 133, 255, 192, 206, 123, 255, 187, 204, 118, 255, 180, 198, 106, 255, 143, 162, 73,  255, 62,  76,  36,  255, 92,  93,  33,  255, 228,
    223, 90,  255, 228, 228, 101, 255, 214, 223, 130, 255, 217, 230, 135, 255, 222, 229, 110, 255, 232, 234, 136, 255, 214, 225, 131, 255, 69,  87,
    36,  255, 50,  65,  28,  255, 31,  42,  21,  255, 34,  47,  23,  255, 34,  55,  23,  255, 31,  47,  19,  255, 48,  68,  25,  255, 65,  80,  26,
    255, 63,  81,  26,  255, 68,  84,  28,  255, 60,  78,  25,  255, 60,  79,  23,  255, 69,  84,  28,  255, 177, 187, 99,  255, 185, 203, 114, 255,
    155, 180, 112, 255, 139, 166, 112, 255, 147, 172, 111, 255, 130, 157, 104, 255, 151, 175, 103, 255, 147, 172, 94,  255, 91,  118, 48,  255, 105,
    134, 46,  255, 112, 149, 47,  255, 108, 140, 49,  255, 99,  135, 43,  255, 109, 144, 53,  255, 96,  126, 67,  255, 91,  122, 60,  255, 62,  91,
    36,  255, 58,  75,  38,  255, 44,  60,  33,  255, 76,  96,  42,  255, 96,  125, 60,  255, 91,  121, 62,  255, 94,  123, 56,  255, 128, 160, 68,
    255, 152, 185, 83,  255, 137, 172, 75,  255, 122, 158, 68,  255, 128, 163, 68,  255, 126, 153, 60,  255, 125, 145, 60,  255, 164, 184, 73,  255,
    189, 208, 97,  255, 189, 206, 97,  255, 193, 210, 99,  255, 207, 219, 109, 255, 218, 225, 128, 255, 180, 199, 104, 255, 158, 187, 86,  255, 164,
    189, 90,  255, 111, 146, 80,  255, 99,  136, 80,  255, 120, 145, 78,  255, 29,  37,  31,  255, 19,  25,  26,  255, 21,  23,  26,  255, 23,  28,
    31,  255, 23,  31,  26,  255, 25,  32,  23,  255, 36,  55,  28,  255, 52,  73,  39,  255, 44,  58,  38,  255, 29,  37,  23,  255, 29,  31,  23,
    255, 31,  33,  25,  255, 55,  73,  39,  255, 77,  93,  50,  255, 77,  95,  47,  255, 58,  74,  38,  255, 42,  56,  31,  255, 31,  52,  23,  255,
    43,  75,  31,  255, 47,  77,  28,  255, 23,  32,  17,  255, 15,  15,  17,  255, 21,  26,  15,  255, 106, 125, 52,  255, 174, 196, 95,  255, 169,
    194, 93,  255, 180, 204, 104, 255, 179, 196, 95,  255, 162, 173, 94,  255, 145, 159, 95,  255, 93,  104, 58,  255, 68,  87,  29,  255, 130, 140,
    93,  255, 136, 137, 109, 255, 83,  113, 44,  255, 79,  104, 39,  255, 135, 149, 56,  255, 234, 238, 101, 255, 141, 150, 68,  255, 175, 191, 94,
    255, 211, 225, 115, 255, 249, 251, 184, 255, 243, 246, 178, 255, 243, 246, 172, 255, 251, 254, 175, 255, 238, 241, 161, 255, 146, 165, 87,  255,
    110, 145, 78,  255, 107, 142, 86,  255, 108, 143, 81,  255, 105, 140, 75,  255, 107, 143, 73,  255, 113, 149, 65,  255, 137, 167, 63,  255, 157,
    181, 65,  255, 153, 170, 63,  255, 91,  105, 45,  255, 34,  47,  25,  255, 40,  52,  26,  255, 88,  105, 58,  255, 98,  122, 76,  255, 96,  128,
    87,  255, 95,  124, 76,  255, 68,  95,  41,  255, 40,  62,  36,  255, 73,  95,  44,  255, 100, 117, 43,  255, 120, 130, 72,  255, 180, 192, 132,
    255, 179, 196, 100, 255, 195, 216, 105, 255, 198, 217, 102, 255, 184, 198, 87,  255, 180, 188, 84,  255, 209, 213, 101, 255, 143, 161, 62,  255,
    83,  113, 43,  255, 72,  106, 41,  255, 58,  92,  33,  255, 140, 166, 75,  255, 149, 175, 82,  255, 69,  95,  46,  255, 58,  84,  52,  255, 52,
    73,  34,  255, 33,  51,  21,  255, 36,  62,  23,  255, 74,  95,  45,  255, 130, 149, 67,  255, 168, 182, 84,  255, 177, 187, 90,  255, 161, 170,
    83,  255, 136, 155, 63,  255, 112, 138, 58,  255, 104, 129, 62,  255, 121, 136, 81,  255, 97,  115, 58,  255, 95,  127, 58,  255, 94,  124, 56,
    255, 62,  84,  38,  255, 72,  94,  48,  255, 97,  121, 62,  255, 80,  106, 49,  255, 58,  82,  33,  255, 60,  74,  37,  255, 34,  42,  23,  255,
    37,  52,  25,  255, 87,  112, 41,  255, 140, 154, 52,  255, 155, 160, 58,  255, 152, 163, 55,  255, 163, 178, 63,  255, 148, 159, 68,  255, 121,
    137, 52,  255, 178, 193, 103, 255, 180, 193, 104, 255, 156, 171, 98,  255, 100, 131, 80,  255, 132, 157, 73,  255, 174, 191, 87,  255, 157, 180,
    113, 255, 138, 162, 102, 255, 101, 129, 67,  255, 98,  133, 95,  255, 93,  126, 79,  255, 109, 141, 71,  255, 121, 154, 71,  255, 136, 166, 93,
    255, 134, 166, 115, 255, 97,  116, 63,  255, 25,  38,  19,  255, 34,  52,  26,  255, 40,  63,  28,  255, 49,  67,  32,  255, 40,  62,  26,  255,
    57,  91,  37,  255, 77,  118, 44,  255, 100, 140, 48,  255, 120, 152, 53,  255, 90,  111, 43,  255, 63,  91,  31,  255, 65,  92,  37,  255, 167,
    187, 105, 255, 179, 196, 97,  255, 145, 168, 55,  255, 154, 176, 62,  255, 157, 174, 68,  255, 139, 166, 68,  255, 122, 160, 63,  255, 76,  97,
    42,  255, 47,  75,  39,  255, 152, 178, 105, 255, 148, 177, 124, 255, 125, 158, 111, 255, 116, 151, 103, 255, 104, 141, 99,  255, 135, 159, 98,
    255, 177, 203, 118, 255, 171, 194, 101, 255, 147, 177, 63,  255, 138, 178, 72,  255, 173, 194, 103, 255, 105, 125, 58,  255, 79,  109, 73,  255,
    80,  115, 95,  255, 80,  115, 89,  255, 77,  111, 91,  255, 73,  103, 76,  255, 101, 132, 68,  255, 120, 148, 74,  255, 103, 130, 65,  255, 83,
    113, 60,  255, 131, 149, 73,  255, 138, 157, 74,  255, 107, 139, 60,  255, 163, 180, 62,  255, 131, 148, 44,  255, 85,  118, 28,  255, 103, 126,
    36,  255, 243, 241, 154, 255, 255, 249, 158, 255, 255, 251, 160, 255, 231, 225, 126, 255, 192, 199, 77,  255, 221, 226, 102, 255, 222, 227, 105,
    255, 201, 214, 115, 255, 166, 194, 132, 255, 166, 195, 144, 255, 153, 174, 103, 255, 121, 139, 68,  255, 187, 200, 104, 255, 167, 183, 80,  255,
    87,  119, 37,  255, 55,  87,  21,  255, 179, 184, 81,  255, 212, 225, 124, 255, 212, 224, 113, 255, 219, 232, 112, 255, 221, 227, 116, 255, 241,
    243, 143, 255, 141, 155, 87,  255, 34,  43,  19,  255, 38,  47,  26,  255, 32,  47,  19,  255, 42,  67,  23,  255, 36,  62,  23,  255, 36,  55,
    21,  255, 55,  76,  29,  255, 49,  69,  31,  255, 69,  84,  31,  255, 77,  92,  33,  255, 69,  87,  26,  255, 84,  100, 36,  255, 76,  91,  34,
    255, 153, 161, 81,  255, 196, 211, 121, 255, 194, 208, 119, 255, 145, 171, 116, 255, 153, 172, 114, 255, 158, 175, 114, 255, 169, 187, 113, 255,
    154, 177, 95,  255, 104, 133, 52,  255, 113, 146, 52,  255, 109, 143, 47,  255, 112, 147, 49,  255, 124, 157, 56,  255, 114, 149, 62,  255, 73,
    105, 56,  255, 79,  112, 52,  255, 63,  91,  40,  255, 55,  75,  41,  255, 87,  114, 49,  255, 96,  127, 68,  255, 72,  100, 65,  255, 72,  99,
    65,  255, 73,  101, 56,  255, 87,  120, 55,  255, 126, 157, 65,  255, 140, 175, 74,  255, 121, 158, 65,  255, 137, 169, 80,  255, 122, 150, 58,
    255, 120, 156, 62,  255, 106, 132, 63,  255, 150, 168, 76,  255, 183, 197, 95,  255, 198, 210, 107, 255, 188, 205, 100, 255, 174, 195, 94,  255,
    163, 187, 90,  255, 165, 191, 93,  255, 156, 188, 89,  255, 113, 150, 82,  255, 99,  137, 87,  255, 110, 142, 80,  255, 34,  48,  31,  255, 21,
    31,  23,  255, 33,  49,  25,  255, 38,  58,  25,  255, 33,  46,  26,  255, 28,  39,  23,  255, 58,  81,  37,  255, 83,  115, 68,  255, 87,  121,
    72,  255, 44,  62,  33,  255, 34,  40,  26,  255, 29,  28,  25,  255, 33,  36,  31,  255, 31,  46,  26,  255, 21,  37,  21,  255, 29,  46,  25,
    255, 55,  83,  28,  255, 60,  96,  32,  255, 55,  89,  31,  255, 73,  114, 31,  255, 49,  72,  28,  255, 34,  47,  31,  255, 73,  91,  44,  255,
    143, 163, 81,  255, 151, 183, 104, 255, 141, 173, 99,  255, 183, 204, 113, 255, 98,  115, 58,  255, 34,  51,  26,  255, 38,  60,  26,  255, 26,
    44,  19,  255, 39,  62,  17,  255, 107, 116, 67,  255, 119, 125, 82,  255, 92,  119, 41,  255, 82,  115, 37,  255, 71,  109, 28,  255, 150, 166,
    58,  255, 243, 249, 122, 255, 217, 225, 136, 255, 225, 232, 159, 255, 248, 250, 181, 255, 248, 249, 172, 255, 245, 245, 165, 255, 219, 224, 139,
    255, 128, 149, 68,  255, 87,  116, 42,  255, 133, 166, 69,  255, 137, 172, 65,  255, 140, 176, 65,  255, 139, 171, 62,  255, 151, 180, 67,  255,
    157, 181, 65,  255, 148, 161, 60,  255, 108, 123, 49,  255, 69,  90,  32,  255, 83,  106, 36,  255, 91,  110, 44,  255, 56,  68,  32,  255, 65,
    73,  46,  255, 187, 195, 153, 255, 187, 201, 166, 255, 137, 153, 111, 255, 62,  77,  48,  255, 32,  49,  34,  255, 47,  72,  38,  255, 29,  42,
    17,  255, 181, 187, 122, 255, 222, 239, 177, 255, 177, 187, 105, 255, 117, 127, 60,  255, 86,  95,  41,  255, 62,  74,  41,  255, 95,  118, 62,
    255, 115, 141, 68,  255, 115, 139, 62,  255, 99,  124, 50,  255, 94,  119, 49,  255, 109, 134, 53,  255, 175, 199, 76,  255, 160, 189, 86,  255,
    134, 151, 77,  255, 60,  87,  37,  255, 53,  68,  36,  255, 85,  87,  62,  255, 105, 122, 79,  255, 80,  115, 58,  255, 68,  108, 52,  255, 69,
    104, 52,  255, 63,  94,  55,  255, 55,  80,  55,  255, 52,  84,  50,  255, 69,  101, 49,  255, 92,  122, 52,  255, 96,  122, 58,  255, 96,  112,
    55,  255, 103, 131, 65,  255, 116, 145, 68,  255, 103, 126, 58,  255, 52,  75,  40,  255, 71,  103, 43,  255, 94,  122, 50,  255, 73,  97,  39,
    255, 63,  84,  44,  255, 48,  65,  28,  255, 55,  79,  29,  255, 115, 135, 47,  255, 140, 154, 58,  255, 145, 156, 68,  255, 121, 136, 65,  255,
    93,  116, 56,  255, 81,  105, 41,  255, 77,  101, 31,  255, 143, 159, 80,  255, 192, 204, 109, 255, 166, 181, 95,  255, 116, 140, 78,  255, 127,
    152, 74,  255, 156, 175, 68,  255, 110, 131, 68,  255, 116, 140, 82,  255, 95,  130, 84,  255, 104, 136, 101, 255, 85,  117, 87,  255, 73,  104,
    74,  255, 76,  107, 67,  255, 101, 133, 69,  255, 119, 151, 93,  255, 116, 141, 74,  255, 43,  53,  26,  255, 36,  58,  28,  255, 39,  58,  32,
    255, 65,  89,  31,  255, 91,  125, 41,  255, 74,  112, 45,  255, 72,  113, 49,  255, 81,  121, 52,  255, 102, 142, 56,  255, 128, 168, 58,  255,
    114, 140, 47,  255, 69,  100, 41,  255, 139, 160, 80,  255, 115, 130, 62,  255, 67,  82,  36,  255, 55,  68,  33,  255, 29,  37,  23,  255, 102,
    124, 53,  255, 118, 157, 63,  255, 67,  98,  52,  255, 74,  99,  48,  255, 158, 185, 115, 255, 135, 163, 111, 255, 120, 153, 110, 255, 111, 150,
    102, 255, 125, 163, 103, 255, 135, 165, 95,  255, 138, 149, 69,  255, 160, 185, 68,  255, 124, 170, 65,  255, 158, 196, 87,  255, 168, 186, 90,
    255, 60,  80,  26,  255, 68,  101, 67,  255, 81,  118, 86,  255, 67,  98,  60,  255, 68,  95,  76,  255, 68,  94,  80,  255, 108, 133, 77,  255,
    94,  123, 75,  255, 80,  111, 68,  255, 74,  108, 67,  255, 109, 131, 74,  255, 142, 160, 84,  255, 141, 166, 79,  255, 150, 163, 58,  255, 86,
    120, 43,  255, 136, 168, 60,  255, 182, 204, 72,  255, 238, 239, 146, 255, 255, 253, 167, 255, 231, 223, 120, 255, 144, 155, 60,  255, 143, 165,
    65,  255, 196, 203, 86,  255, 225, 224, 109, 255, 238, 235, 117, 255, 229, 235, 135, 255, 190, 213, 144, 255, 177, 202, 145, 255, 167, 183, 111,
    255, 136, 157, 62,  255, 67,  96,  31,  255, 65,  98,  28,  255, 123, 142, 62,  255, 196, 213, 136, 255, 162, 191, 127, 255, 206, 219, 169, 255,
    213, 225, 126, 255, 218, 222, 114, 255, 209, 219, 130, 255, 33,  42,  23,  255, 26,  28,  17,  255, 49,  58,  29,  255, 58,  74,  31,  255, 44,
    74,  23,  255, 44,  75,  26,  255, 47,  71,  26,  255, 63,  87,  34,  255, 44,  73,  29,  255, 52,  72,  25,  255, 99,  107, 53,  255, 115, 124,
    60,  255, 88,  104, 41,  255, 96,  108, 47,  255, 181, 186, 91,  255, 217, 225, 109, 255, 202, 219, 120, 255, 175, 190, 113, 255, 218, 223, 133,
    255, 223, 229, 140, 255, 223, 228, 134, 255, 227, 232, 135, 255, 193, 207, 116, 255, 127, 157, 60,  255, 122, 155, 52,  255, 120, 154, 52,  255,
    81,  105, 40,  255, 74,  98,  40,  255, 91,  122, 60,  255, 89,  120, 62,  255, 65,  87,  41,  255, 67,  91,  37,  255, 105, 136, 68,  255, 91,
    120, 69,  255, 86,  113, 68,  255, 89,  118, 62,  255, 86,  118, 55,  255, 86,  121, 48,  255, 83,  115, 41,  255, 84,  114, 37,  255, 127, 157,
    65,  255, 143, 170, 77,  255, 123, 153, 60,  255, 134, 166, 74,  255, 100, 134, 63,  255, 80,  104, 41,  255, 119, 146, 60,  255, 148, 175, 73,
    255, 159, 185, 83,  255, 165, 190, 89,  255, 152, 182, 79,  255, 142, 176, 78,  255, 118, 145, 72,  255, 122, 153, 92,  255, 106, 143, 97,  255,
    110, 142, 86,  255, 47,  65,  31,  255, 36,  58,  21,  255, 52,  86,  23,  255, 58,  100, 25,  255, 62,  102, 28,  255, 62,  89,  31,  255, 83,
    116, 58,  255, 74,  110, 69,  255, 76,  112, 71,  255, 76,  107, 60,  255, 26,  33,  25,  255, 32,  32,  28,  255, 42,  58,  29,  255, 47,  72,
    29,  255, 58,  90,  33,  255, 56,  81,  26,  255, 96,  130, 36,  255, 84,  119, 36,  255, 76,  110, 34,  255, 94,  127, 36,  255, 63,  95,  28,
    255, 78,  105, 44,  255, 139, 172, 110, 255, 133, 167, 107, 255, 136, 167, 104, 255, 161, 186, 103, 255, 119, 137, 65,  255, 37,  56,  28,  255,
    47,  73,  29,  255, 55,  82,  31,  255, 44,  68,  26,  255, 39,  63,  25,  255, 69,  76,  47,  255, 87,  84,  65,  255, 47,  65,  25,  255, 74,
    110, 31,  255, 74,  111, 29,  255, 135, 151, 58,  255, 222, 227, 130, 255, 226, 235, 145, 255, 245, 250, 141, 255, 251, 251, 134, 255, 255, 255,
    140, 255, 235, 238, 127, 255, 185, 194, 86,  255, 134, 150, 67,  255, 146, 159, 80,  255, 123, 138, 73,  255, 75,  90,  42,  255, 91,  103, 44,
    255, 116, 137, 52,  255, 108, 134, 62,  255, 69,  95,  40,  255, 43,  57,  23,  255, 76,  98,  31,  255, 124, 157, 47,  255, 126, 162, 53,  255,
    123, 160, 56,  255, 126, 157, 60,  255, 103, 131, 44,  255, 133, 152, 79,  255, 219, 236, 195, 255, 210, 230, 196, 255, 192, 204, 149, 255, 119,
    128, 83,  255, 71,  87,  43,  255, 164, 177, 97,  255, 241, 243, 161, 255, 213, 231, 172, 255, 172, 176, 129, 255, 9,   9,   12,  255, 15,  26,
    17,  255, 104, 128, 75,  255, 144, 169, 109, 255, 134, 155, 103, 255, 106, 126, 84,  255, 72,  98,  55,  255, 87,  111, 45,  255, 128, 149, 58,
    255, 179, 204, 90,  255, 165, 197, 89,  255, 152, 172, 91,  255, 68,  82,  48,  255, 172, 182, 120, 255, 219, 236, 174, 255, 204, 219, 160, 255,
    87,  111, 71,  255, 55,  86,  58,  255, 60,  85,  62,  255, 60,  83,  60,  255, 58,  84,  58,  255, 57,  86,  55,  255, 69,  105, 52,  255, 98,
    134, 56,  255, 99,  125, 60,  255, 93,  113, 52,  255, 102, 127, 60,  255, 124, 152, 75,  255, 124, 145, 71,  255, 81,  113, 36,  255, 130, 165,
    58,  255, 164, 188, 81,  255, 179, 195, 87,  255, 142, 150, 72,  255, 60,  76,  37,  255, 76,  103, 33,  255, 134, 154, 58,  255, 132, 151, 69,
    255, 97,  122, 58,  255, 69,  102, 47,  255, 77,  109, 47,  255, 140, 160, 65,  255, 108, 113, 55,  255, 40,  52,  26,  255, 159, 176, 86,  255,
    169, 186, 93,  255, 128, 151, 81,  255, 130, 156, 69,  255, 147, 172, 62,  255, 56,  72,  28,  255, 81,  110, 52,  255, 125, 156, 101, 255, 108,
    141, 94,  255, 99,  132, 79,  255, 100, 130, 71,  255, 94,  122, 74,  255, 81,  111, 63,  255, 87,  121, 58,  255, 95,  131, 72,  255, 92,  121,
    60,  255, 40,  60,  26,  255, 50,  75,  31,  255, 116, 148, 43,  255, 124, 159, 42,  255, 121, 152, 52,  255, 117, 149, 58,  255, 105, 142, 46,
    255, 102, 139, 50,  255, 120, 158, 58,  255, 134, 166, 56,  255, 74,  104, 47,  255, 50,  73,  31,  255, 23,  40,  17,  255, 32,  51,  26,  255,
    25,  37,  23,  255, 6,   9,   12,  255, 60,  82,  34,  255, 136, 175, 68,  255, 126, 157, 76,  255, 114, 138, 74,  255, 145, 174, 105, 255, 129,
    162, 101, 255, 148, 180, 118, 255, 177, 201, 124, 255, 160, 180, 87,  255, 143, 170, 62,  255, 120, 150, 58,  255, 146, 178, 71,  255, 160, 200,
    87,  255, 201, 222, 118, 255, 143, 165, 74,  255, 53,  77,  32,  255, 37,  55,  23,  255, 47,  72,  38,  255, 49,  83,  60,  255, 54,  83,  68,
    255, 60,  81,  76,  255, 63,  87,  68,  255, 88,  120, 80,  255, 85,  116, 74,  255, 79,  111, 65,  255, 96,  126, 75,  255, 158, 171, 91,  255,
    157, 163, 62,  255, 133, 154, 48,  255, 131, 162, 65,  255, 189, 205, 90,  255, 193, 209, 87,  255, 224, 226, 121, 255, 227, 226, 100, 255, 186,
    200, 60,  255, 115, 145, 56,  255, 120, 145, 68,  255, 149, 167, 72,  255, 182, 193, 78,  255, 159, 165, 62,  255, 192, 184, 90,  255, 222, 220,
    121, 255, 217, 228, 149, 255, 215, 227, 153, 255, 142, 162, 76,  255, 75,  104, 38,  255, 94,  117, 36,  255, 175, 184, 101, 255, 177, 204, 129,
    255, 170, 194, 137, 255, 198, 217, 172, 255, 185, 191, 98,  255, 236, 238, 109, 255, 232, 236, 107, 255, 189, 188, 74,  255, 161, 163, 68,  255,
    153, 154, 69,  255, 155, 169, 83,  255, 68,  91,  33,  255, 69,  99,  34,  255, 55,  86,  28,  255, 71,  96,  38,  255, 92,  108, 47,  255, 176,
    173, 87,  255, 245, 245, 149, 255, 230, 235, 131, 255, 173, 189, 81,  255, 145, 161, 62,  255, 211, 225, 103, 255, 192, 208, 92,  255, 202, 212,
    114, 255, 219, 223, 128, 255, 217, 224, 132, 255, 216, 224, 128, 255, 209, 220, 120, 255, 175, 188, 101, 255, 151, 171, 81,  255, 122, 155, 56,
    255, 122, 156, 52,  255, 134, 160, 62,  255, 148, 166, 74,  255, 172, 188, 89,  255, 159, 178, 83,  255, 98,  125, 67,  255, 69,  92,  41,  255,
    95,  126, 58,  255, 86,  120, 63,  255, 85,  117, 60,  255, 102, 132, 62,  255, 111, 142, 62,  255, 109, 142, 60,  255, 96,  126, 52,  255, 53,
    79,  32,  255, 34,  51,  19,  255, 134, 159, 73,  255, 124, 151, 63,  255, 107, 135, 58,  255, 148, 171, 75,  255, 133, 159, 71,  255, 78,  104,
    36,  255, 122, 152, 50,  255, 158, 184, 71,  255, 194, 210, 117, 255, 201, 215, 129, 255, 164, 188, 98,  255, 94,  128, 55,  255, 67,  91,  46,
    255, 107, 126, 72,  255, 117, 153, 99,  255, 117, 146, 97,  255, 52,  72,  32,  255, 47,  81,  25,  255, 51,  87,  21,  255, 56,  95,  25,  255,
    56,  98,  25,  255, 79,  117, 39,  255, 76,  115, 62,  255, 69,  101, 63,  255, 69,  102, 65,  255, 85,  120, 68,  255, 55,  77,  37,  255, 60,
    79,  32,  255, 78,  114, 42,  255, 68,  103, 37,  255, 78,  113, 36,  255, 58,  87,  25,  255, 95,  119, 38,  255, 109, 137, 48,  255, 114, 143,
    53,  255, 113, 139, 53,  255, 55,  92,  26,  255, 82,  109, 40,  255, 156, 183, 121, 255, 127, 163, 117, 255, 117, 153, 110, 255, 132, 162, 108,
    255, 134, 159, 100, 255, 130, 148, 83,  255, 92,  116, 48,  255, 74,  108, 38,  255, 76,  114, 45,  255, 74,  110, 45,  255, 91,  107, 62,  255,
    74,  81,  55,  255, 36,  62,  15,  255, 80,  112, 31,  255, 90,  115, 29,  255, 188, 191, 92,  255, 208, 214, 117, 255, 203, 216, 115, 255, 204,
    217, 108, 255, 191, 205, 93,  255, 198, 207, 104, 255, 218, 223, 124, 255, 215, 220, 122, 255, 167, 176, 91,  255, 137, 144, 78,  255, 48,  52,
    37,  255, 17,  21,  23,  255, 23,  28,  21,  255, 52,  76,  26,  255, 82,  113, 52,  255, 89,  105, 56,  255, 91,  116, 31,  255, 119, 153, 40,
    255, 138, 168, 55,  255, 113, 148, 60,  255, 96,  136, 56,  255, 97,  134, 55,  255, 103, 138, 55,  255, 91,  127, 44,  255, 164, 181, 110, 255,
    208, 232, 176, 255, 182, 216, 168, 255, 184, 209, 133, 255, 178, 193, 105, 255, 225, 231, 147, 255, 245, 245, 169, 255, 204, 222, 165, 255, 207,
    221, 167, 255, 63,  63,  46,  255, 12,  19,  17,  255, 71,  86,  42,  255, 179, 195, 123, 255, 188, 210, 149, 255, 191, 209, 146, 255, 190, 197,
    136, 255, 135, 148, 94,  255, 82,  106, 52,  255, 163, 186, 87,  255, 174, 202, 96,  255, 120, 140, 68,  255, 157, 172, 103, 255, 195, 221, 151,
    255, 185, 210, 131, 255, 116, 134, 84,  255, 53,  81,  56,  255, 65,  92,  65,  255, 65,  92,  67,  255, 65,  92,  63,  255, 62,  89,  60,  255,
    63,  96,  60,  255, 75,  112, 55,  255, 98,  131, 63,  255, 106, 131, 62,  255, 108, 128, 63,  255, 101, 120, 58,  255, 130, 156, 80,  255, 135,
    157, 78,  255, 123, 154, 58,  255, 141, 172, 65,  255, 153, 178, 77,  255, 170, 190, 95,  255, 200, 215, 96,  255, 167, 171, 77,  255, 100, 121,
    36,  255, 97,  126, 47,  255, 81,  112, 45,  255, 105, 129, 62,  255, 126, 148, 68,  255, 130, 154, 58,  255, 129, 135, 60,  255, 37,  44,  29,
    255, 26,  37,  28,  255, 43,  60,  28,  255, 129, 149, 58,  255, 138, 161, 71,  255, 126, 152, 68,  255, 140, 164, 60,  255, 53,  75,  25,  255,
    58,  91,  26,  255, 130, 164, 65,  255, 153, 178, 81,  255, 159, 184, 100, 255, 142, 178, 96,  255, 132, 170, 79,  255, 129, 161, 75,  255, 103,
    131, 62,  255, 82,  109, 69,  255, 87,  121, 75,  255, 71,  89,  43,  255, 65,  87,  26,  255, 141, 170, 48,  255, 133, 161, 47,  255, 126, 160,
    47,  255, 128, 162, 52,  255, 140, 173, 62,  255, 140, 174, 63,  255, 149, 180, 73,  255, 137, 161, 68,  255, 68,  104, 43,  255, 84,  121, 47,
    255, 107, 127, 60,  255, 58,  67,  36,  255, 9,   12,  15,  255, 29,  43,  21,  255, 101, 140, 67,  255, 140, 176, 82,  255, 147, 175, 84,  255,
    127, 149, 83,  255, 126, 152, 67,  255, 179, 194, 114, 255, 215, 224, 140, 255, 204, 214, 124, 255, 184, 204, 105, 255, 161, 191, 75,  255, 162,
    193, 81,  255, 172, 195, 98,  255, 171, 188, 86,  255, 157, 166, 90,  255, 139, 160, 89,  255, 132, 160, 94,  255, 89,  120, 65,  255, 79,  103,
    56,  255, 92,  117, 74,  255, 79,  110, 69,  255, 58,  91,  62,  255, 71,  99,  69,  255, 95,  128, 79,  255, 87,  119, 69,  255, 100, 137, 67,
    255, 134, 165, 80,  255, 89,  108, 43,  255, 63,  92,  41,  255, 145, 156, 63,  255, 189, 193, 76,  255, 196, 202, 95,  255, 209, 217, 97,  255,
    210, 217, 97,  255, 207, 215, 81,  255, 205, 218, 91,  255, 174, 193, 71,  255, 137, 165, 67,  255, 141, 165, 73,  255, 175, 191, 87,  255, 170,
    184, 81,  255, 80,  105, 25,  255, 100, 120, 31,  255, 187, 191, 89,  255, 229, 227, 132, 255, 205, 210, 114, 255, 104, 132, 60,  255, 98,  117,
    45,  255, 194, 205, 120, 255, 170, 195, 118, 255, 209, 225, 184, 255, 104, 124, 92,  255, 55,  62,  12,  255, 166, 162, 67,  255, 198, 194, 90,
    255, 238, 233, 116, 255, 231, 233, 124, 255, 197, 203, 93,  255, 178, 190, 87,  255, 88,  113, 39,  255, 94,  123, 45,  255, 63,  91,  25,  255,
    134, 141, 74,  255, 167, 173, 94,  255, 191, 193, 98,  255, 235, 235, 123, 255, 241, 241, 129, 255, 241, 243, 121, 255, 212, 224, 86,  255, 170,
    188, 76,  255, 174, 191, 82,  255, 216, 222, 111, 255, 215, 221, 116, 255, 222, 226, 127, 255, 220, 230, 135, 255, 131, 163, 87,  255, 90,  120,
    50,  255, 94,  130, 41,  255, 108, 148, 48,  255, 146, 174, 65,  255, 165, 190, 81,  255, 173, 199, 94,  255, 178, 200, 96,  255, 209, 220, 105,
    255, 161, 174, 90,  255, 73,  99,  44,  255, 67,  99,  38,  255, 84,  115, 45,  255, 108, 136, 56,  255, 123, 150, 65,  255, 115, 143, 63,  255,
    83,  108, 52,  255, 41,  58,  32,  255, 32,  47,  23,  255, 48,  65,  26,  255, 121, 146, 60,  255, 56,  74,  33,  255, 19,  23,  19,  255, 53,
    60,  26,  255, 173, 194, 69,  255, 159, 181, 71,  255, 85,  104, 42,  255, 83,  109, 32,  255, 166, 179, 89,  255, 210, 225, 135, 255, 204, 219,
    138, 255, 143, 166, 98,  255, 91,  128, 68,  255, 115, 143, 78,  255, 134, 157, 98,  255, 120, 146, 106, 255, 49,  72,  32,  255, 52,  84,  25,
    255, 52,  86,  28,  255, 48,  83,  26,  255, 48,  77,  31,  255, 68,  104, 47,  255, 72,  107, 63,  255, 71,  105, 65,  255, 72,  105, 68,  255,
    85,  123, 73,  255, 67,  96,  44,  255, 82,  114, 39,  255, 89,  124, 47,  255, 92,  126, 44,  255, 83,  116, 39,  255, 32,  53,  23,  255, 36,
    51,  23,  255, 81,  110, 38,  255, 87,  117, 42,  255, 94,  122, 44,  255, 84,  115, 40,  255, 72,  96,  33,  255, 170, 188, 105, 255, 148, 180,
    124, 255, 128, 164, 117, 255, 126, 163, 118, 255, 138, 170, 126, 255, 151, 180, 130, 255, 159, 181, 118, 255, 151, 170, 90,  255, 92,  122, 60,
    255, 75,  109, 60,  255, 101, 119, 73,  255, 118, 125, 73,  255, 123, 136, 62,  255, 118, 136, 60,  255, 74,  96,  34,  255, 136, 145, 63,  255,
    166, 185, 84,  255, 144, 164, 87,  255, 149, 166, 98,  255, 153, 170, 99,  255, 149, 166, 94,  255, 154, 172, 99,  255, 126, 146, 76,  255, 81,
    99,  47,  255, 34,  41,  25,  255, 15,  21,  19,  255, 23,  32,  21,  255, 26,  33,  23,  255, 47,  58,  31,  255, 83,  96,  50,  255, 203, 215,
    150, 255, 162, 179, 94,  255, 107, 138, 43,  255, 138, 163, 65,  255, 153, 178, 89,  255, 138, 166, 76,  255, 134, 161, 78,  255, 131, 158, 83,
    255, 128, 152, 71,  255, 120, 139, 62,  255, 163, 173, 112, 255, 192, 218, 146, 255, 172, 207, 155, 255, 187, 211, 146, 255, 225, 231, 160, 255,
    243, 243, 159, 255, 195, 214, 137, 255, 215, 234, 184, 255, 116, 119, 87,  255, 12,  17,  12,  255, 56,  80,  26,  255, 131, 149, 75,  255, 209,
    220, 158, 255, 173, 200, 152, 255, 192, 214, 153, 255, 216, 226, 164, 255, 205, 203, 142, 255, 138, 152, 83,  255, 178, 203, 91,  255, 156, 177,
    84,  255, 156, 188, 111, 255, 182, 209, 117, 255, 121, 133, 68,  255, 40,  63,  39,  255, 56,  84,  60,  255, 62,  91,  63,  255, 65,  95,  68,
    255, 69,  101, 68,  255, 71,  103, 62,  255, 68,  101, 62,  255, 80,  105, 47,  255, 120, 138, 67,  255, 115, 139, 65,  255, 117, 141, 69,  255,
    102, 119, 60,  255, 125, 151, 80,  255, 127, 158, 68,  255, 120, 152, 60,  255, 114, 147, 62,  255, 135, 162, 80,  255, 160, 187, 82,  255, 167,
    196, 97,  255, 238, 234, 136, 255, 201, 198, 110, 255, 100, 123, 36,  255, 135, 157, 63,  255, 217, 223, 111, 255, 152, 157, 65,  255, 85,  91,
    41,  255, 26,  37,  23,  255, 26,  40,  26,  255, 33,  47,  28,  255, 28,  39,  26,  255, 28,  39,  23,  255, 88,  111, 45,  255, 105, 138, 60,
    255, 104, 132, 48,  255, 53,  79,  25,  255, 84,  123, 41,  255, 112, 151, 55,  255, 112, 151, 65,  255, 150, 182, 96,  255, 146, 169, 90,  255,
    96,  124, 75,  255, 93,  124, 81,  255, 89,  119, 82,  255, 84,  115, 67,  255, 78,  108, 69,  255, 82,  111, 65,  255, 52,  73,  31,  255, 118,
    144, 47,  255, 149, 176, 52,  255, 143, 174, 50,  255, 145, 174, 49,  255, 157, 183, 72,  255, 166, 189, 86,  255, 173, 195, 93,  255, 128, 145,
    67,  255, 86,  121, 47,  255, 120, 150, 53,  255, 136, 164, 78,  255, 129, 139, 80,  255, 69,  84,  34,  255, 107, 142, 62,  255, 125, 161, 99,
    255, 129, 163, 94,  255, 151, 177, 89,  255, 127, 159, 74,  255, 172, 199, 125, 255, 189, 217, 151, 255, 163, 197, 127, 255, 150, 188, 117, 255,
    167, 197, 118, 255, 167, 200, 97,  255, 168, 199, 113, 255, 152, 181, 98,  255, 155, 182, 87,  255, 137, 165, 77,  255, 137, 166, 71,  255, 145,
    179, 101, 255, 164, 200, 138, 255, 164, 200, 137, 255, 183, 205, 133, 255, 146, 170, 82,  255, 108, 145, 60,  255, 107, 146, 73,  255, 87,  127,
    60,  255, 77,  116, 56,  255, 122, 151, 63,  255, 95,  116, 45,  255, 55,  90,  43,  255, 72,  110, 63,  255, 87,  123, 72,  255, 105, 129, 67,
    255, 156, 172, 81,  255, 224, 226, 105, 255, 218, 221, 107, 255, 211, 217, 92,  255, 212, 220, 95,  255, 195, 206, 72,  255, 193, 202, 69,  255,
    188, 200, 77,  255, 189, 203, 93,  255, 209, 215, 107, 255, 141, 158, 56,  255, 112, 141, 36,  255, 130, 154, 41,  255, 169, 178, 65,  255, 185,
    183, 75,  255, 115, 128, 53,  255, 166, 180, 99,  255, 190, 210, 107, 255, 195, 214, 100, 255, 203, 216, 121, 255, 32,  46,  21,  255, 77,  82,
    31,  255, 163, 173, 80,  255, 120, 130, 62,  255, 158, 158, 76,  255, 198, 203, 104, 255, 192, 198, 91,  255, 192, 200, 95,  255, 99,  122, 47,
    255, 118, 135, 55,  255, 166, 175, 92,  255, 207, 210, 122, 255, 202, 211, 118, 255, 191, 202, 112, 255, 214, 219, 122, 255, 228, 232, 127, 255,
    194, 209, 106, 255, 117, 143, 50,  255, 174, 177, 72,  255, 231, 238, 100, 255, 228, 231, 101, 255, 238, 238, 123, 255, 202, 211, 117, 255, 134,
    154, 77,  255, 112, 142, 68,  255, 91,  118, 47,  255, 99,  140, 50,  255, 116, 156, 50,  255, 150, 179, 80,  255, 143, 174, 83,  255, 144, 174,
    83,  255, 152, 177, 79,  255, 193, 206, 95,  255, 224, 225, 129, 255, 65,  84,  52,  255, 37,  60,  31,  255, 52,  79,  33,  255, 58,  79,  33,
    255, 55,  74,  36,  255, 37,  49,  26,  255, 32,  47,  26,  255, 37,  53,  25,  255, 45,  65,  26,  255, 62,  78,  31,  255, 79,  100, 41,  255,
    26,  40,  21,  255, 19,  29,  17,  255, 34,  37,  23,  255, 164, 181, 81,  255, 197, 218, 81,  255, 203, 217, 122, 255, 95,  122, 63,  255, 134,
    149, 69,  255, 218, 227, 136, 255, 199, 216, 126, 255, 199, 216, 129, 255, 136, 165, 100, 255, 135, 169, 101, 255, 140, 167, 90,  255, 124, 143,
    84,  255, 63,  84,  47,  255, 43,  68,  26,  255, 44,  71,  29,  255, 46,  73,  29,  255, 55,  84,  34,  255, 69,  103, 58,  255, 69,  104, 65,
    255, 75,  110, 68,  255, 78,  113, 74,  255, 75,  112, 68,  255, 60,  87,  42,  255, 74,  104, 33,  255, 99,  135, 50,  255, 107, 140, 55,  255,
    78,  104, 39,  255, 43,  60,  28,  255, 34,  48,  21,  255, 75,  95,  32,  255, 151, 174, 77,  255, 158, 186, 96,  255, 148, 181, 87,  255, 130,
    162, 58,  255, 117, 135, 52,  255, 190, 206, 125, 255, 147, 180, 120, 255, 144, 177, 125, 255, 149, 179, 136, 255, 147, 177, 135, 255, 147, 178,
    132, 255, 164, 191, 124, 255, 166, 185, 107, 255, 99,  129, 62,  255, 131, 145, 71,  255, 241, 233, 126, 255, 255, 250, 123, 255, 243, 241, 109,
    255, 220, 222, 92,  255, 201, 208, 92,  255, 202, 211, 121, 255, 207, 220, 143, 255, 199, 217, 147, 255, 200, 216, 146, 255, 214, 224, 147, 255,
    214, 223, 149, 255, 217, 225, 148, 255, 218, 225, 148, 255, 149, 154, 96,  255, 58,  62,  44,  255, 39,  44,  31,  255, 17,  23,  17,  255, 44,
    55,  36,  255, 65,  73,  41,  255, 192, 213, 153, 255, 209, 227, 180, 255, 175, 188, 118, 255, 102, 132, 53,  255, 109, 139, 60,  255, 90,  122,
    52,  255, 76,  104, 46,  255, 75,  93,  44,  255, 63,  84,  44,  255, 62,  89,  32,  255, 52,  71,  36,  255, 141, 155, 87,  255, 195, 219, 142,
    255, 157, 189, 125, 255, 191, 210, 122, 255, 197, 217, 103, 255, 186, 212, 154, 255, 216, 235, 189, 255, 150, 153, 108, 255, 25,  37,  15,  255,
    68,  103, 36,  255, 84,  110, 48,  255, 212, 215, 149, 255, 196, 213, 158, 255, 191, 211, 148, 255, 191, 212, 126, 255, 218, 230, 144, 255, 216,
    216, 147, 255, 141, 156, 80,  255, 131, 161, 69,  255, 156, 188, 86,  255, 139, 151, 74,  255, 58,  80,  31,  255, 55,  86,  40,  255, 68,  99,
    62,  255, 84,  116, 69,  255, 90,  125, 75,  255, 110, 146, 86,  255, 156, 182, 110, 255, 129, 151, 86,  255, 95,  105, 63,  255, 134, 145, 81,
    255, 161, 172, 90,  255, 141, 160, 84,  255, 118, 137, 72,  255, 103, 128, 60,  255, 105, 139, 55,  255, 99,  137, 55,  255, 117, 148, 65,  255,
    165, 189, 80,  255, 140, 178, 60,  255, 204, 219, 107, 255, 222, 221, 115, 255, 198, 193, 125, 255, 159, 164, 79,  255, 245, 250, 114, 255, 149,
    149, 72,  255, 23,  32,  19,  255, 17,  28,  21,  255, 21,  33,  21,  255, 19,  32,  19,  255, 17,  29,  19,  255, 21,  26,  21,  255, 19,  23,
    21,  255, 21,  31,  21,  255, 52,  80,  36,  255, 97,  127, 47,  255, 148, 165, 63,  255, 134, 163, 75,  255, 112, 148, 72,  255, 90,  133, 62,
    255, 134, 169, 65,  255, 137, 156, 62,  255, 60,  93,  63,  255, 71,  105, 77,  255, 81,  114, 87,  255, 88,  121, 84,  255, 83,  116, 65,  255,
    87,  118, 69,  255, 78,  111, 55,  255, 62,  94,  47,  255, 93,  125, 43,  255, 148, 171, 63,  255, 176, 195, 68,  255, 174, 195, 74,  255, 183,
    202, 100, 255, 183, 196, 101, 255, 100, 124, 60,  255, 103, 136, 55,  255, 136, 158, 56,  255, 143, 162, 82,  255, 151, 173, 102, 255, 132, 162,
    78,  255, 118, 153, 94,  255, 122, 154, 104, 255, 135, 160, 99,  255, 128, 146, 67,  255, 117, 143, 58,  255, 125, 139, 91,  255, 100, 125, 69,
    255, 138, 165, 84,  255, 180, 213, 135, 255, 200, 225, 139, 255, 197, 217, 126, 255, 184, 208, 109, 255, 155, 193, 74,  255, 171, 205, 90,  255,
    200, 216, 112, 255, 179, 201, 82,  255, 153, 186, 91,  255, 162, 192, 114, 255, 161, 196, 135, 255, 174, 203, 140, 255, 183, 198, 119, 255, 92,
    108, 31,  255, 110, 135, 41,  255, 123, 155, 52,  255, 124, 156, 60,  255, 71,  108, 44,  255, 65,  107, 53,  255, 86,  124, 72,  255, 121, 156,
    92,  255, 125, 157, 87,  255, 116, 153, 90,  255, 155, 179, 95,  255, 220, 219, 103, 255, 217, 220, 105, 255, 214, 221, 89,  255, 197, 194, 77,
    255, 197, 200, 81,  255, 202, 209, 82,  255, 205, 212, 84,  255, 216, 218, 101, 255, 221, 223, 118, 255, 193, 199, 91,  255, 145, 165, 41,  255,
    149, 168, 49,  255, 148, 168, 47,  255, 133, 153, 40,  255, 65,  75,  26,  255, 177, 200, 100, 255, 159, 193, 81,  255, 159, 191, 78,  255, 87,
    121, 41,  255, 76,  90,  29,  255, 201, 209, 115, 255, 207, 227, 126, 255, 215, 230, 120, 255, 201, 209, 102, 255, 186, 194, 87,  255, 186, 195,
    84,  255, 196, 202, 92,  255, 167, 176, 86,  255, 214, 213, 121, 255, 241, 243, 149, 255, 232, 236, 141, 255, 225, 230, 126, 255, 220, 230, 120,
    255, 208, 221, 110, 255, 195, 212, 92,  255, 165, 186, 68,  255, 126, 147, 50,  255, 144, 150, 58,  255, 238, 228, 126, 255, 255, 250, 144, 255,
    255, 250, 148, 255, 223, 226, 125, 255, 91,  115, 47,  255, 68,  89,  32,  255, 94,  113, 50,  255, 106, 141, 50,  255, 133, 167, 65,  255, 136,
    169, 81,  255, 131, 162, 71,  255, 151, 177, 65,  255, 189, 205, 72,  255, 219, 221, 99,  255, 184, 186, 110, 255, 55,  73,  39,  255, 41,  67,
    28,  255, 52,  80,  38,  255, 40,  63,  31,  255, 36,  56,  26,  255, 33,  55,  23,  255, 36,  55,  23,  255, 37,  52,  23,  255, 29,  39,  21,
    255, 83,  101, 36,  255, 94,  123, 47,  255, 38,  52,  21,  255, 92,  104, 55,  255, 110, 120, 65,  255, 194, 204, 131, 255, 208, 225, 135, 255,
    198, 218, 84,  255, 177, 196, 84,  255, 145, 160, 71,  255, 209, 218, 122, 255, 203, 218, 128, 255, 196, 215, 126, 255, 175, 194, 106, 255, 111,
    126, 65,  255, 50,  65,  31,  255, 50,  63,  32,  255, 92,  111, 63,  255, 58,  81,  40,  255, 55,  86,  32,  255, 67,  100, 36,  255, 75,  110,
    38,  255, 73,  111, 58,  255, 69,  106, 65,  255, 79,  115, 73,  255, 77,  112, 71,  255, 79,  115, 69,  255, 76,  107, 47,  255, 52,  75,  26,
    255, 81,  104, 39,  255, 142, 165, 75,  255, 155, 175, 78,  255, 142, 171, 77,  255, 120, 154, 68,  255, 130, 155, 65,  255, 189, 207, 107, 255,
    161, 188, 101, 255, 141, 168, 68,  255, 87,  116, 40,  255, 84,  111, 45,  255, 183, 193, 95,  255, 187, 207, 120, 255, 154, 185, 123, 255, 158,
    187, 126, 255, 162, 191, 146, 255, 158, 188, 145, 255, 151, 183, 131, 255, 175, 199, 126, 255, 176, 194, 96,  255, 162, 170, 81,  255, 250, 245,
    145, 255, 255, 249, 139, 255, 250, 245, 134, 255, 238, 236, 129, 255, 222, 229, 146, 255, 185, 207, 154, 255, 188, 208, 148, 255, 210, 221, 146,
    255, 227, 229, 148, 255, 232, 231, 147, 255, 234, 233, 149, 255, 231, 231, 145, 255, 233, 233, 144, 255, 236, 238, 150, 255, 224, 231, 144, 255,
    213, 219, 135, 255, 155, 160, 98,  255, 47,  58,  38,  255, 43,  51,  32,  255, 196, 213, 147, 255, 180, 209, 155, 255, 206, 222, 162, 255, 155,
    171, 100, 255, 80,  111, 45,  255, 63,  96,  50,  255, 55,  80,  43,  255, 34,  49,  26,  255, 49,  72,  36,  255, 95,  126, 52,  255, 74,  103,
    40,  255, 134, 146, 78,  255, 219, 229, 141, 255, 180, 200, 109, 255, 190, 213, 95,  255, 185, 209, 116, 255, 202, 223, 184, 255, 226, 241, 194,
    255, 159, 158, 104, 255, 26,  46,  15,  255, 75,  108, 44,  255, 55,  84,  41,  255, 148, 158, 105, 255, 217, 229, 171, 255, 198, 218, 151, 255,
    189, 211, 109, 255, 172, 199, 84,  255, 180, 205, 96,  255, 162, 177, 91,  255, 119, 144, 65,  255, 89,  107, 47,  255, 23,  41,  19,  255, 31,
    53,  26,  255, 43,  65,  32,  255, 77,  105, 50,  255, 103, 130, 63,  255, 98,  124, 55,  255, 102, 126, 60,  255, 170, 182, 123, 255, 202, 222,
    167, 255, 189, 218, 160, 255, 195, 216, 153, 255, 207, 220, 140, 255, 197, 204, 122, 255, 134, 152, 75,  255, 90,  116, 47,  255, 127, 158, 62,
    255, 154, 176, 63,  255, 182, 197, 78,  255, 150, 184, 68,  255, 177, 203, 87,  255, 197, 198, 89,  255, 134, 145, 68,  255, 193, 202, 105, 255,
    245, 251, 130, 255, 221, 221, 107, 255, 48,  52,  29,  255, 12,  19,  17,  255, 21,  25,  23,  255, 53,  56,  41,  255, 87,  91,  62,  255, 153,
    155, 108, 255, 105, 98,  68,  255, 15,  19,  15,  255, 21,  26,  21,  255, 26,  41,  26,  255, 154, 168, 62,  255, 221, 223, 83,  255, 182, 194,
    69,  255, 172, 188, 74,  255, 122, 152, 80,  255, 152, 182, 77,  255, 140, 156, 68,  255, 73,  106, 60,  255, 84,  116, 72,  255, 85,  116, 78,
    255, 78,  112, 78,  255, 79,  114, 73,  255, 84,  121, 62,  255, 87,  119, 62,  255, 48,  74,  46,  255, 46,  76,  44,  255, 60,  95,  41,  255,
    108, 135, 55,  255, 160, 178, 82,  255, 201, 214, 121, 255, 167, 178, 100, 255, 108, 134, 68,  255, 134, 162, 67,  255, 144, 164, 62,  255, 144,
    160, 80,  255, 136, 162, 87,  255, 119, 155, 100, 255, 117, 153, 103, 255, 127, 154, 101, 255, 141, 161, 80,  255, 45,  43,  23,  255, 21,  23,
    19,  255, 26,  32,  23,  255, 80,  106, 52,  255, 169, 182, 94,  255, 218, 224, 146, 255, 190, 207, 145, 255, 171, 195, 137, 255, 186, 208, 119,
    255, 183, 213, 92,  255, 168, 205, 87,  255, 206, 218, 116, 255, 185, 195, 84,  255, 175, 201, 97,  255, 157, 189, 100, 255, 167, 196, 120, 255,
    166, 198, 137, 255, 187, 208, 128, 255, 89,  114, 37,  255, 60,  87,  38,  255, 90,  108, 47,  255, 86,  111, 41,  255, 121, 157, 74,  255, 117,
    154, 75,  255, 128, 165, 91,  255, 163, 188, 100, 255, 143, 172, 75,  255, 157, 182, 74,  255, 174, 193, 82,  255, 201, 207, 101, 255, 229, 231,
    125, 255, 179, 179, 78,  255, 98,  110, 52,  255, 169, 181, 89,  255, 202, 208, 100, 255, 200, 207, 111, 255, 212, 215, 118, 255, 226, 223, 126,
    255, 225, 222, 126, 255, 190, 198, 78,  255, 184, 190, 63,  255, 188, 195, 63,  255, 104, 120, 39,  255, 82,  89,  25,  255, 176, 192, 87,  255,
    174, 198, 83,  255, 188, 200, 90,  255, 137, 155, 65,  255, 183, 193, 107, 255, 216, 227, 131, 255, 195, 213, 112, 255, 204, 216, 108, 255, 195,
    204, 93,  255, 188, 196, 87,  255, 190, 197, 83,  255, 197, 200, 87,  255, 222, 223, 126, 255, 234, 238, 144, 255, 226, 228, 132, 255, 226, 227,
    125, 255, 223, 227, 122, 255, 204, 217, 110, 255, 176, 197, 90,  255, 162, 189, 74,  255, 119, 151, 49,  255, 94,  118, 43,  255, 81,  103, 32,
    255, 149, 160, 74,  255, 212, 219, 131, 255, 234, 235, 146, 255, 251, 249, 165, 255, 192, 210, 119, 255, 133, 161, 65,  255, 117, 133, 52,  255,
    168, 177, 60,  255, 176, 190, 65,  255, 167, 186, 67,  255, 182, 196, 65,  255, 197, 206, 73,  255, 179, 188, 76,  255, 95,  111, 50,  255, 45,
    62,  25,  255, 89,  106, 47,  255, 126, 151, 67,  255, 126, 157, 63,  255, 86,  117, 46,  255, 38,  65,  26,  255, 48,  84,  34,  255, 58,  91,
    41,  255, 34,  52,  32,  255, 32,  37,  17,  255, 141, 167, 53,  255, 155, 190, 73,  255, 75,  98,  36,  255, 191, 199, 106, 255, 227, 238, 134,
    255, 215, 228, 129, 255, 212, 225, 144, 255, 202, 220, 117, 255, 192, 209, 95,  255, 124, 144, 65,  255, 137, 152, 62,  255, 207, 218, 125, 255,
    204, 221, 127, 255, 158, 176, 96,  255, 17,  26,  12,  255, 15,  26,  19,  255, 21,  32,  19,  255, 52,  65,  28,  255, 76,  96,  50,  255, 68,
    96,  41,  255, 58,  86,  31,  255, 47,  68,  23,  255, 77,  115, 52,  255, 76,  113, 69,  255, 83,  120, 77,  255, 84,  122, 77,  255, 85,  121,
    74,  255, 82,  109, 62,  255, 29,  38,  19,  255, 68,  78,  31,  255, 180, 196, 97,  255, 155, 180, 92,  255, 134, 166, 89,  255, 115, 153, 86,
    255, 108, 145, 81,  255, 126, 156, 80,  255, 115, 145, 65,  255, 69,  99,  36,  255, 74,  109, 34,  255, 114, 152, 62,  255, 105, 137, 60,  255,
    162, 178, 84,  255, 177, 196, 113, 255, 157, 187, 112, 255, 158, 187, 124, 255, 168, 196, 152, 255, 166, 196, 147, 255, 161, 190, 134, 255, 183,
    203, 118, 255, 184, 193, 104, 255, 223, 225, 144, 255, 193, 197, 107, 255, 208, 211, 121, 255, 186, 204, 134, 255, 175, 201, 153, 255, 197, 211,
    150, 255, 226, 229, 151, 255, 227, 231, 151, 255, 229, 231, 155, 255, 228, 232, 153, 255, 226, 231, 148, 255, 234, 236, 140, 255, 232, 234, 129,
    255, 217, 222, 110, 255, 181, 193, 87,  255, 168, 191, 97,  255, 216, 238, 153, 255, 158, 175, 116, 255, 56,  68,  36,  255, 168, 194, 97,  255,
    175, 206, 145, 255, 173, 203, 156, 255, 191, 206, 131, 255, 89,  116, 55,  255, 69,  101, 56,  255, 68,  92,  52,  255, 44,  57,  32,  255, 81,
    102, 49,  255, 111, 141, 68,  255, 80,  105, 47,  255, 169, 182, 109, 255, 204, 216, 142, 255, 174, 186, 118, 255, 198, 213, 118, 255, 192, 210,
    146, 255, 203, 223, 182, 255, 214, 233, 186, 255, 163, 163, 116, 255, 26,  42,  17,  255, 69,  102, 46,  255, 60,  87,  47,  255, 73,  96,  50,
    255, 196, 204, 138, 255, 208, 224, 169, 255, 193, 212, 164, 255, 199, 215, 158, 255, 193, 212, 154, 255, 202, 218, 154, 255, 155, 169, 85,  255,
    150, 165, 56,  255, 77,  91,  36,  255, 38,  65,  32,  255, 52,  80,  36,  255, 52,  76,  37,  255, 50,  75,  37,  255, 47,  75,  32,  255, 62,
    91,  31,  255, 63,  91,  25,  255, 170, 184, 116, 255, 203, 227, 167, 255, 177, 209, 150, 255, 179, 215, 154, 255, 203, 226, 160, 255, 183, 200,
    121, 255, 162, 177, 73,  255, 199, 206, 69,  255, 217, 216, 74,  255, 205, 214, 92,  255, 166, 198, 98,  255, 153, 174, 79,  255, 132, 149, 69,
    255, 185, 198, 117, 255, 248, 255, 133, 255, 215, 217, 96,  255, 82,  89,  42,  255, 19,  28,  17,  255, 69,  73,  47,  255, 174, 177, 111, 255,
    226, 228, 146, 255, 238, 243, 155, 255, 249, 248, 157, 255, 81,  74,  48,  255, 9,   15,  17,  255, 17,  19,  17,  255, 29,  42,  26,  255, 96,
    114, 42,  255, 195, 199, 74,  255, 210, 217, 73,  255, 201, 212, 71,  255, 170, 191, 93,  255, 157, 182, 102, 255, 111, 131, 52,  255, 76,  109,
    39,  255, 74,  105, 37,  255, 82,  113, 50,  255, 82,  106, 52,  255, 60,  89,  42,  255, 65,  94,  52,  255, 81,  113, 52,  255, 58,  83,  43,
    255, 42,  65,  38,  255, 41,  68,  36,  255, 52,  90,  36,  255, 74,  106, 45,  255, 87,  98,  55,  255, 73,  87,  52,  255, 110, 126, 68,  255,
    96,  108, 49,  255, 99,  113, 58,  255, 100, 123, 55,  255, 125, 158, 93,  255, 122, 157, 108, 255, 124, 149, 94,  255, 141, 165, 80,  255, 134,
    151, 74,  255, 130, 141, 84,  255, 118, 129, 80,  255, 115, 148, 81,  255, 115, 153, 76,  255, 140, 171, 95,  255, 189, 210, 139, 255, 167, 199,
    130, 255, 178, 205, 123, 255, 191, 208, 106, 255, 182, 187, 94,  255, 193, 212, 118, 255, 185, 193, 105, 255, 106, 125, 39,  255, 162, 176, 74,
    255, 193, 209, 107, 255, 178, 198, 104, 255, 174, 199, 116, 255, 187, 208, 128, 255, 172, 192, 91,  255, 154, 184, 102, 255, 144, 174, 103, 255,
    127, 164, 87,  255, 148, 180, 60,  255, 137, 171, 65,  255, 153, 179, 87,  255, 173, 198, 114, 255, 154, 189, 95,  255, 118, 161, 74,  255, 126,
    166, 68,  255, 168, 190, 85,  255, 198, 198, 116, 255, 138, 155, 87,  255, 138, 165, 99,  255, 146, 173, 111, 255, 148, 175, 117, 255, 152, 178,
    124, 255, 158, 184, 128, 255, 168, 191, 128, 255, 206, 214, 142, 255, 226, 222, 134, 255, 233, 227, 115, 255, 145, 151, 68,  255, 108, 101, 38,
    255, 185, 172, 75,  255, 212, 213, 112, 255, 219, 217, 109, 255, 233, 230, 112, 255, 222, 226, 106, 255, 216, 219, 106, 255, 221, 223, 116, 255,
    217, 222, 116, 255, 214, 219, 112, 255, 194, 199, 87,  255, 195, 201, 90,  255, 202, 206, 86,  255, 211, 211, 92,  255, 205, 210, 96,  255, 201,
    214, 110, 255, 193, 211, 110, 255, 191, 210, 106, 255, 186, 207, 97,  255, 178, 199, 86,  255, 174, 196, 80,  255, 169, 194, 75,  255, 116, 151,
    47,  255, 81,  119, 36,  255, 106, 138, 39,  255, 149, 178, 62,  255, 152, 177, 69,  255, 160, 183, 84,  255, 168, 189, 92,  255, 171, 192, 92,
    255, 170, 194, 84,  255, 162, 186, 75,  255, 195, 199, 68,  255, 208, 209, 77,  255, 197, 205, 81,  255, 189, 198, 83,  255, 164, 182, 89,  255,
    82,  110, 55,  255, 101, 122, 52,  255, 156, 178, 86,  255, 164, 189, 86,  255, 155, 181, 76,  255, 148, 177, 72,  255, 138, 173, 65,  255, 101,
    139, 52,  255, 52,  84,  36,  255, 69,  97,  62,  255, 71,  105, 68,  255, 82,  105, 36,  255, 162, 188, 76,  255, 181, 207, 102, 255, 140, 172,
    69,  255, 122, 147, 58,  255, 171, 187, 94,  255, 203, 217, 122, 255, 201, 218, 120, 255, 198, 217, 123, 255, 211, 225, 139, 255, 191, 205, 133,
    255, 127, 145, 50,  255, 214, 227, 103, 255, 211, 226, 125, 255, 185, 205, 113, 255, 36,  47,  26,  255, 12,  21,  15,  255, 21,  32,  19,  255,
    32,  40,  25,  255, 32,  41,  23,  255, 67,  86,  47,  255, 40,  58,  32,  255, 34,  52,  19,  255, 90,  122, 52,  255, 82,  120, 73,  255, 87,
    123, 78,  255, 90,  125, 84,  255, 97,  130, 79,  255, 81,  103, 53,  255, 29,  34,  15,  255, 164, 173, 83,  255, 191, 207, 109, 255, 143, 172,
    100, 255, 122, 156, 97,  255, 117, 153, 87,  255, 118, 153, 77,  255, 119, 156, 68,  255, 96,  130, 47,  255, 40,  67,  25,  255, 48,  75,  28,
    255, 94,  120, 38,  255, 142, 168, 62,  255, 148, 173, 68,  255, 178, 193, 87,  255, 197, 212, 119, 255, 176, 202, 122, 255, 165, 192, 130, 255,
    173, 199, 154, 255, 168, 199, 157, 255, 171, 197, 136, 255, 155, 166, 87,  255, 145, 163, 62,  255, 188, 200, 113, 255, 186, 201, 120, 255, 178,
    201, 138, 255, 206, 217, 149, 255, 228, 231, 154, 255, 228, 232, 159, 255, 227, 230, 154, 255, 227, 231, 144, 255, 223, 231, 121, 255, 212, 219,
    105, 255, 167, 176, 78,  255, 109, 129, 52,  255, 84,  112, 41,  255, 82,  117, 39,  255, 104, 133, 49,  255, 164, 185, 92,  255, 174, 205, 105,
    255, 168, 194, 98,  255, 168, 197, 103, 255, 176, 206, 164, 255, 168, 200, 157, 255, 191, 208, 138, 255, 90,  119, 63,  255, 79,  114, 65,  255,
    86,  106, 60,  255, 55,  65,  36,  255, 123, 152, 68,  255, 118, 148, 65,  255, 105, 140, 74,  255, 165, 187, 114, 255, 183, 197, 130, 255, 127,
    142, 75,  255, 196, 202, 133, 255, 181, 198, 142, 255, 204, 223, 182, 255, 211, 233, 186, 255, 125, 124, 95,  255, 23,  37,  15,  255, 60,  90,
    38,  255, 63,  91,  44,  255, 66,  96,  42,  255, 90,  115, 55,  255, 207, 213, 138, 255, 222, 233, 167, 255, 188, 211, 167, 255, 183, 208, 182,
    255, 197, 218, 188, 255, 202, 206, 137, 255, 167, 174, 62,  255, 89,  104, 41,  255, 60,  89,  44,  255, 71,  105, 48,  255, 65,  100, 41,  255,
    83,  118, 42,  255, 92,  120, 47,  255, 79,  104, 36,  255, 71,  99,  31,  255, 71,  95,  31,  255, 188, 197, 143, 255, 225, 239, 179, 255, 184,
    212, 144, 255, 176, 209, 147, 255, 190, 221, 156, 255, 182, 197, 112, 255, 162, 163, 74,  255, 186, 191, 104, 255, 186, 206, 108, 255, 190, 211,
    113, 255, 196, 206, 129, 255, 209, 222, 171, 255, 220, 233, 148, 255, 192, 205, 83,  255, 78,  86,  37,  255, 40,  51,  32,  255, 164, 173, 101,
    255, 231, 236, 144, 255, 235, 241, 146, 255, 227, 232, 145, 255, 245, 248, 159, 255, 170, 172, 99,  255, 44,  71,  26,  255, 29,  38,  25,  255,
    15,  15,  17,  255, 47,  62,  36,  255, 50,  75,  39,  255, 58,  79,  32,  255, 103, 119, 37,  255, 137, 155, 65,  255, 161, 180, 84,  255, 147,
    158, 98,  255, 50,  63,  28,  255, 43,  67,  25,  255, 23,  39,  19,  255, 74,  98,  38,  255, 135, 161, 60,  255, 97,  125, 38,  255, 60,  83,
    29,  255, 58,  92,  32,  255, 68,  100, 39,  255, 46,  68,  38,  255, 38,  62,  36,  255, 55,  87,  37,  255, 68,  105, 45,  255, 67,  89,  43,
    255, 23,  33,  21,  255, 23,  33,  23,  255, 15,  19,  21,  255, 68,  69,  63,  255, 98,  106, 73,  255, 131, 161, 109, 255, 126, 148, 91,  255,
    151, 172, 87,  255, 145, 175, 94,  255, 160, 190, 118, 255, 168, 197, 128, 255, 176, 206, 130, 255, 165, 195, 110, 255, 118, 151, 75,  255, 100,
    128, 74,  255, 144, 164, 108, 255, 183, 203, 115, 255, 100, 106, 42,  255, 78,  87,  41,  255, 53,  73,  44,  255, 95,  104, 73,  255, 101, 113,
    60,  255, 90,  116, 42,  255, 121, 151, 71,  255, 113, 142, 86,  255, 117, 144, 82,  255, 161, 176, 87,  255, 174, 189, 96,  255, 142, 170, 101,
    255, 136, 172, 103, 255, 151, 182, 105, 255, 186, 206, 85,  255, 148, 180, 67,  255, 159, 181, 73,  255, 155, 180, 72,  255, 159, 188, 98,  255,
    172, 196, 120, 255, 174, 207, 116, 255, 145, 187, 104, 255, 145, 181, 94,  255, 141, 167, 105, 255, 146, 175, 110, 255, 136, 171, 114, 255, 136,
    170, 116, 255, 143, 176, 117, 255, 153, 184, 125, 255, 166, 198, 136, 255, 168, 189, 117, 255, 185, 182, 110, 255, 221, 224, 156, 255, 200, 212,
    150, 255, 168, 168, 99,  255, 238, 221, 121, 255, 227, 221, 122, 255, 187, 186, 90,  255, 238, 228, 113, 255, 231, 227, 106, 255, 216, 220, 106,
    255, 202, 213, 116, 255, 217, 221, 127, 255, 230, 230, 139, 255, 230, 230, 136, 255, 203, 207, 101, 255, 207, 213, 94,  255, 223, 225, 101, 255,
    227, 225, 99,  255, 227, 224, 94,  255, 210, 217, 92,  255, 192, 212, 101, 255, 189, 208, 97,  255, 187, 206, 92,  255, 182, 203, 80,  255, 160,
    184, 68,  255, 118, 143, 50,  255, 91,  124, 46,  255, 92,  132, 52,  255, 98,  133, 43,  255, 158, 183, 68,  255, 166, 189, 73,  255, 170, 193,
    79,  255, 168, 191, 84,  255, 169, 191, 83,  255, 168, 193, 84,  255, 159, 186, 81,  255, 145, 169, 77,  255, 132, 158, 80,  255, 126, 153, 71,
    255, 146, 169, 79,  255, 148, 172, 89,  255, 112, 134, 69,  255, 167, 189, 99,  255, 165, 189, 95,  255, 156, 182, 82,  255, 153, 179, 77,  255,
    147, 174, 73,  255, 141, 171, 68,  255, 139, 175, 68,  255, 87,  123, 43,  255, 40,  65,  26,  255, 82,  113, 53,  255, 94,  124, 43,  255, 132,
    160, 65,  255, 190, 213, 122, 255, 171, 200, 103, 255, 128, 159, 67,  255, 137, 164, 69,  255, 157, 178, 79,  255, 168, 189, 90,  255, 176, 199,
    106, 255, 166, 188, 105, 255, 170, 190, 97,  255, 179, 192, 84,  255, 170, 176, 94,  255, 161, 171, 89,  255, 185, 205, 95,  255, 73,  86,  43,
    255, 26,  31,  26,  255, 29,  33,  21,  255, 40,  48,  28,  255, 26,  41,  19,  255, 38,  58,  23,  255, 63,  86,  41,  255, 41,  62,  23,  255,
    93,  117, 52,  255, 93,  129, 73,  255, 90,  123, 75,  255, 98,  130, 83,  255, 113, 144, 81,  255, 77,  104, 46,  255, 55,  55,  26,  255, 207,
    213, 113, 255, 167, 191, 112, 255, 136, 169, 106, 255, 138, 166, 99,  255, 139, 169, 87,  255, 152, 180, 76,  255, 141, 169, 63,  255, 69,  92,
    32,  255, 36,  55,  23,  255, 40,  62,  31,  255, 41,  67,  31,  255, 65,  84,  31,  255, 98,  109, 42,  255, 130, 146, 65,  255, 150, 166, 81,
    255, 150, 165, 87,  255, 186, 200, 117, 255, 214, 223, 138, 255, 195, 214, 140, 255, 176, 201, 151, 255, 151, 162, 100, 255, 159, 176, 87,  255,
    188, 205, 135, 255, 181, 196, 104, 255, 212, 221, 138, 255, 234, 239, 149, 255, 228, 238, 139, 255, 224, 233, 129, 255, 212, 220, 107, 255, 189,
    201, 91,  255, 149, 166, 85,  255, 108, 126, 65,  255, 106, 128, 41,  255, 78,  114, 42,  255, 71,  105, 47,  255, 84,  118, 52,  255, 105, 140,
    53,  255, 115, 145, 48,  255, 112, 138, 47,  255, 163, 190, 83,  255, 170, 197, 99,  255, 179, 205, 148, 255, 168, 199, 155, 255, 179, 199, 131,
    255, 93,  123, 74,  255, 99,  134, 79,  255, 102, 121, 60,  255, 73,  79,  42,  255, 102, 136, 52,  255, 107, 141, 55,  255, 102, 137, 52,  255,
    139, 164, 62,  255, 147, 167, 83,  255, 101, 121, 49,  255, 187, 198, 122, 255, 168, 187, 136, 255, 193, 218, 183, 255, 205, 217, 170, 255, 76,
    83,  46,  255, 48,  72,  26,  255, 58,  87,  36,  255, 60,  92,  42,  255, 72,  104, 47,  255, 83,  116, 41,  255, 77,  96,  38,  255, 146, 151,
    91,  255, 206, 213, 131, 255, 204, 217, 154, 255, 193, 216, 185, 255, 210, 222, 170, 255, 90,  100, 47,  255, 38,  56,  25,  255, 73,  100, 41,
    255, 86,  113, 42,  255, 113, 136, 50,  255, 148, 163, 72,  255, 170, 178, 91,  255, 184, 192, 104, 255, 180, 190, 117, 255, 164, 179, 123, 255,
    128, 144, 97,  255, 152, 165, 106, 255, 211, 225, 136, 255, 196, 221, 142, 255, 175, 209, 135, 255, 184, 212, 141, 255, 239, 239, 170, 255, 250,
    249, 170, 255, 192, 204, 106, 255, 222, 225, 132, 255, 219, 211, 125, 255, 212, 223, 143, 255, 223, 234, 157, 255, 166, 172, 91,  255, 53,  62,
    32,  255, 147, 156, 84,  255, 236, 241, 144, 255, 224, 230, 142, 255, 219, 226, 134, 255, 234, 239, 143, 255, 214, 211, 126, 255, 69,  82,  49,
    255, 49,  80,  37,  255, 57,  84,  33,  255, 25,  32,  23,  255, 34,  51,  28,  255, 63,  86,  43,  255, 119, 132, 73,  255, 17,  31,  17,  255,
    48,  77,  47,  255, 55,  83,  47,  255, 41,  58,  36,  255, 26,  41,  23,  255, 36,  58,  26,  255, 69,  95,  36,  255, 156, 180, 74,  255, 119,
    157, 65,  255, 104, 144, 53,  255, 89,  133, 47,  255, 84,  126, 47,  255, 84,  127, 43,  255, 97,  127, 48,  255, 48,  71,  36,  255, 57,  89,
    44,  255, 66,  97,  49,  255, 72,  100, 52,  255, 32,  42,  28,  255, 29,  40,  31,  255, 25,  33,  26,  255, 37,  42,  38,  255, 85,  97,  75,
    255, 138, 159, 97,  255, 147, 175, 85,  255, 149, 182, 96,  255, 148, 183, 100, 255, 156, 190, 101, 255, 171, 196, 102, 255, 158, 182, 89,  255,
    128, 153, 67,  255, 105, 130, 79,  255, 109, 139, 99,  255, 143, 180, 130, 255, 162, 185, 113, 255, 34,  58,  23,  255, 33,  56,  37,  255, 47,
    73,  47,  255, 46,  73,  48,  255, 50,  74,  48,  255, 95,  114, 49,  255, 130, 164, 87,  255, 100, 141, 87,  255, 106, 145, 87,  255, 154, 179,
    97,  255, 132, 168, 94,  255, 125, 163, 94,  255, 131, 168, 92,  255, 151, 181, 96,  255, 179, 200, 82,  255, 118, 136, 74,  255, 116, 135, 73,
    255, 161, 184, 90,  255, 161, 185, 78,  255, 167, 188, 77,  255, 166, 181, 94,  255, 173, 193, 101, 255, 156, 182, 87,  255, 137, 165, 75,  255,
    138, 175, 68,  255, 152, 184, 100, 255, 144, 181, 102, 255, 161, 192, 115, 255, 180, 201, 111, 255, 172, 182, 86,  255, 96,  107, 41,  255, 128,
    145, 89,  255, 197, 218, 157, 255, 167, 197, 150, 255, 202, 217, 151, 255, 183, 193, 100, 255, 148, 158, 68,  255, 148, 156, 74,  255, 141, 159,
    78,  255, 156, 165, 84,  255, 191, 209, 134, 255, 177, 202, 141, 255, 189, 208, 144, 255, 198, 213, 149, 255, 217, 228, 161, 255, 226, 231, 134,
    255, 218, 222, 81,  255, 227, 225, 97,  255, 230, 229, 104, 255, 235, 228, 99,  255, 219, 218, 93,  255, 172, 189, 87,  255, 162, 180, 83,  255,
    150, 167, 74,  255, 139, 163, 63,  255, 110, 141, 50,  255, 84,  112, 38,  255, 104, 141, 56,  255, 104, 142, 55,  255, 96,  133, 52,  255, 142,
    164, 69,  255, 186, 205, 97,  255, 188, 209, 99,  255, 183, 204, 95,  255, 182, 205, 95,  255, 180, 203, 97,  255, 175, 198, 96,  255, 171, 194,
    91,  255, 103, 141, 58,  255, 104, 138, 58,  255, 156, 181, 82,  255, 122, 149, 74,  255, 116, 135, 65,  255, 172, 191, 101, 255, 164, 188, 91,
    255, 156, 181, 78,  255, 153, 180, 74,  255, 150, 177, 71,  255, 145, 172, 63,  255, 146, 174, 67,  255, 136, 171, 58,  255, 65,  94,  31,  255,
    60,  82,  25,  255, 84,  115, 36,  255, 115, 148, 52,  255, 171, 196, 102, 255, 186, 211, 122, 255, 150, 177, 83,  255, 152, 176, 81,  255, 153,
    175, 78,  255, 157, 179, 77,  255, 168, 185, 87,  255, 132, 147, 62,  255, 155, 170, 71,  255, 155, 171, 86,  255, 134, 151, 79,  255, 142, 153,
    60,  255, 172, 179, 81,  255, 185, 195, 120, 255, 176, 193, 128, 255, 168, 183, 119, 255, 165, 178, 111, 255, 148, 162, 97,  255, 102, 115, 65,
    255, 63,  81,  34,  255, 50,  68,  36,  255, 62,  81,  31,  255, 108, 138, 68,  255, 90,  123, 72,  255, 106, 138, 87,  255, 110, 139, 71,  255,
    68,  101, 31,  255, 60,  75,  29,  255, 174, 181, 98,  255, 194, 204, 111, 255, 194, 206, 113, 255, 193, 206, 112, 255, 183, 199, 96,  255, 150,
    167, 68,  255, 65,  87,  36,  255, 47,  77,  29,  255, 50,  77,  31,  255, 41,  63,  31,  255, 40,  65,  31,  255, 40,  56,  31,  255, 34,  43,
    26,  255, 47,  68,  28,  255, 48,  77,  31,  255, 84,  97,  44,  255, 232, 229, 135, 255, 238, 236, 130, 255, 223, 227, 100, 255, 207, 217, 96,
    255, 187, 199, 92,  255, 187, 201, 99,  255, 196, 209, 95,  255, 198, 211, 93,  255, 198, 211, 108, 255, 145, 160, 74,  255, 118, 132, 53,  255,
    100, 118, 52,  255, 74,  90,  38,  255, 96,  124, 68,  255, 74,  111, 80,  255, 113, 136, 65,  255, 155, 174, 58,  255, 130, 156, 52,  255, 120,
    150, 55,  255, 111, 144, 60,  255, 123, 156, 63,  255, 138, 162, 60,  255, 85,  113, 34,  255, 74,  104, 29,  255, 116, 148, 58,  255, 160, 192,
    121, 255, 176, 204, 152, 255, 170, 191, 109, 255, 101, 133, 82,  255, 113, 145, 84,  255, 91,  111, 48,  255, 91,  112, 53,  255, 53,  74,  33,
    255, 62,  80,  36,  255, 106, 128, 58,  255, 210, 217, 109, 255, 181, 199, 94,  255, 145, 172, 87,  255, 171, 189, 104, 255, 177, 191, 125, 255,
    188, 213, 176, 255, 177, 186, 140, 255, 42,  60,  23,  255, 48,  73,  31,  255, 52,  80,  31,  255, 68,  104, 36,  255, 73,  106, 38,  255, 55,
    77,  31,  255, 32,  48,  23,  255, 15,  31,  9,   255, 110, 120, 69,  255, 215, 225, 135, 255, 207, 220, 140, 255, 202, 218, 157, 255, 113, 133,
    65,  255, 44,  65,  26,  255, 68,  84,  34,  255, 121, 133, 52,  255, 200, 203, 102, 255, 208, 214, 122, 255, 191, 204, 134, 255, 171, 191, 143,
    255, 153, 182, 151, 255, 169, 195, 149, 255, 150, 171, 112, 255, 96,  128, 63,  255, 169, 185, 92,  255, 216, 226, 129, 255, 188, 209, 125, 255,
    165, 194, 111, 255, 235, 241, 160, 255, 235, 233, 155, 255, 234, 231, 150, 255, 216, 202, 154, 255, 156, 149, 117, 255, 176, 203, 155, 255, 180,
    209, 166, 255, 181, 208, 132, 255, 205, 213, 116, 255, 229, 231, 119, 255, 228, 229, 123, 255, 226, 229, 128, 255, 230, 234, 136, 255, 231, 230,
    130, 255, 92,  101, 53,  255, 41,  65,  41,  255, 47,  68,  40,  255, 47,  75,  33,  255, 43,  60,  28,  255, 19,  29,  19,  255, 110, 128, 58,
    255, 159, 183, 91,  255, 51,  76,  44,  255, 47,  73,  43,  255, 42,  69,  34,  255, 34,  60,  31,  255, 36,  60,  33,  255, 47,  77,  40,  255,
    126, 154, 58,  255, 199, 214, 92,  255, 132, 166, 79,  255, 101, 143, 60,  255, 105, 145, 62,  255, 110, 148, 62,  255, 103, 146, 56,  255, 158,
    187, 62,  255, 75,  95,  42,  255, 52,  83,  47,  255, 74,  103, 58,  255, 77,  104, 58,  255, 40,  52,  36,  255, 29,  43,  34,  255, 29,  43,
    34,  255, 36,  48,  38,  255, 115, 127, 87,  255, 104, 123, 50,  255, 110, 139, 52,  255, 149, 175, 77,  255, 148, 171, 76,  255, 136, 156, 68,
    255, 132, 153, 60,  255, 124, 148, 62,  255, 105, 126, 55,  255, 148, 163, 90,  255, 140, 159, 91,  255, 107, 114, 65,  255, 96,  104, 58,  255,
    47,  72,  37,  255, 38,  60,  36,  255, 47,  73,  47,  255, 52,  80,  56,  255, 44,  74,  52,  255, 107, 126, 50,  255, 171, 193, 94,  255, 122,
    155, 81,  255, 127, 157, 92,  255, 164, 191, 117, 255, 153, 187, 97,  255, 155, 184, 86,  255, 163, 189, 87,  255, 166, 185, 87,  255, 139, 154,
    80,  255, 87,  117, 83,  255, 81,  111, 77,  255, 148, 166, 89,  255, 174, 193, 91,  255, 130, 159, 75,  255, 106, 142, 80,  255, 119, 152, 92,
    255, 129, 163, 80,  255, 154, 183, 68,  255, 146, 187, 60,  255, 174, 202, 82,  255, 142, 156, 68,  255, 141, 153, 69,  255, 144, 154, 65,  255,
    96,  120, 47,  255, 62,  98,  47,  255, 130, 154, 84,  255, 192, 207, 115, 255, 185, 209, 125, 255, 172, 201, 139, 255, 149, 175, 112, 255, 126,
    142, 58,  255, 113, 138, 72,  255, 97,  128, 73,  255, 151, 173, 114, 255, 177, 203, 145, 255, 182, 205, 141, 255, 197, 218, 153, 255, 199, 216,
    152, 255, 144, 158, 81,  255, 185, 183, 62,  255, 223, 220, 76,  255, 211, 208, 74,  255, 211, 207, 86,  255, 239, 226, 106, 255, 218, 216, 111,
    255, 102, 126, 58,  255, 103, 125, 60,  255, 100, 121, 55,  255, 105, 130, 49,  255, 119, 148, 63,  255, 109, 138, 60,  255, 108, 144, 62,  255,
    106, 141, 58,  255, 99,  136, 55,  255, 94,  130, 52,  255, 134, 157, 63,  255, 177, 193, 87,  255, 190, 207, 100, 255, 188, 206, 102, 255, 186,
    204, 103, 255, 177, 196, 98,  255, 158, 180, 91,  255, 92,  125, 52,  255, 118, 148, 58,  255, 151, 176, 82,  255, 86,  113, 48,  255, 41,  62,
    21,  255, 92,  108, 40,  255, 163, 183, 87,  255, 173, 193, 91,  255, 163, 186, 75,  255, 155, 180, 68,  255, 148, 175, 60,  255, 145, 172, 58,
    255, 142, 173, 52,  255, 92,  124, 41,  255, 58,  79,  32,  255, 77,  97,  29,  255, 128, 159, 50,  255, 137, 167, 62,  255, 154, 180, 80,  255,
    168, 188, 82,  255, 164, 183, 74,  255, 164, 184, 78,  255, 169, 188, 84,  255, 183, 197, 94,  255, 206, 215, 112, 255, 208, 221, 110, 255, 196,
    213, 100, 255, 204, 221, 106, 255, 201, 221, 87,  255, 160, 175, 73,  255, 168, 173, 93,  255, 184, 196, 112, 255, 195, 211, 138, 255, 198, 216,
    144, 255, 207, 221, 141, 255, 209, 220, 139, 255, 182, 193, 126, 255, 109, 126, 73,  255, 63,  89,  37,  255, 90,  119, 49,  255, 95,  131, 68,
    255, 112, 140, 77,  255, 92,  125, 47,  255, 68,  97,  32,  255, 55,  73,  34,  255, 62,  87,  34,  255, 78,  96,  44,  255, 86,  99,  49,  255,
    87,  99,  48,  255, 80,  105, 40,  255, 60,  92,  41,  255, 55,  83,  40,  255, 75,  110, 47,  255, 63,  96,  37,  255, 43,  68,  31,  255, 41,
    65,  32,  255, 39,  60,  32,  255, 32,  44,  23,  255, 40,  67,  26,  255, 31,  58,  19,  255, 147, 150, 76,  255, 251, 248, 147, 255, 232, 231,
    124, 255, 233, 233, 111, 255, 220, 225, 104, 255, 189, 199, 102, 255, 183, 197, 97,  255, 172, 189, 74,  255, 180, 196, 93,  255, 149, 166, 83,
    255, 40,  62,  23,  255, 29,  51,  19,  255, 36,  60,  23,  255, 36,  60,  21,  255, 92,  114, 50,  255, 102, 133, 78,  255, 103, 128, 63,  255,
    159, 175, 67,  255, 155, 175, 68,  255, 144, 171, 62,  255, 142, 172, 65,  255, 160, 180, 77,  255, 214, 223, 105, 255, 190, 214, 96,  255, 139,
    166, 80,  255, 71,  99,  44,  255, 132, 162, 84,  255, 160, 187, 112, 255, 140, 164, 95,  255, 115, 147, 94,  255, 108, 134, 69,  255, 68,  82,
    41,  255, 62,  82,  31,  255, 112, 123, 72,  255, 202, 206, 150, 255, 218, 228, 166, 255, 211, 227, 157, 255, 199, 220, 150, 255, 183, 206, 133,
    255, 160, 186, 102, 255, 141, 165, 89,  255, 176, 197, 147, 255, 120, 133, 91,  255, 33,  56,  28,  255, 40,  60,  31,  255, 46,  68,  31,  255,
    52,  76,  29,  255, 39,  60,  23,  255, 26,  39,  26,  255, 29,  44,  19,  255, 110, 128, 68,  255, 189, 208, 151, 255, 182, 200, 130, 255, 161,
    177, 87,  255, 167, 185, 96,  255, 155, 175, 83,  255, 150, 173, 86,  255, 169, 192, 95,  255, 186, 208, 101, 255, 187, 208, 115, 255, 203, 217,
    122, 255, 188, 200, 143, 255, 147, 177, 152, 255, 157, 185, 144, 255, 199, 211, 143, 255, 167, 181, 95,  255, 159, 178, 84,  255, 164, 179, 87,
    255, 102, 121, 50,  255, 105, 114, 55,  255, 184, 195, 112, 255, 186, 204, 132, 255, 170, 187, 122, 255, 191, 213, 147, 255, 169, 180, 131, 255,
    173, 189, 135, 255, 186, 210, 173, 255, 178, 209, 170, 255, 164, 199, 137, 255, 217, 230, 134, 255, 239, 236, 112, 255, 238, 235, 119, 255, 254,
    249, 146, 255, 255, 255, 158, 255, 125, 128, 62,  255, 50,  75,  50,  255, 58,  80,  50,  255, 46,  69,  40,  255, 49,  75,  34,  255, 60,  87,
    34,  255, 83,  103, 47,  255, 161, 189, 68,  255, 157, 187, 82,  255, 69,  102, 42,  255, 52,  89,  44,  255, 63,  91,  52,  255, 122, 138, 95,
    255, 69,  92,  55,  255, 48,  82,  55,  255, 132, 156, 67,  255, 196, 213, 98,  255, 136, 173, 81,  255, 122, 163, 71,  255, 120, 160, 65,  255,
    112, 156, 60,  255, 169, 193, 74,  255, 146, 160, 55,  255, 60,  84,  36,  255, 51,  81,  46,  255, 69,  100, 65,  255, 75,  102, 65,  255, 43,
    55,  38,  255, 28,  46,  36,  255, 33,  55,  38,  255, 75,  87,  55,  255, 52,  62,  31,  255, 36,  55,  19,  255, 15,  26,  15,  255, 63,  92,
    40,  255, 63,  95,  43,  255, 62,  92,  41,  255, 63,  95,  32,  255, 120, 142, 65,  255, 87,  105, 50,  255, 78,  90,  42,  255, 90,  106, 38,
    255, 82,  99,  42,  255, 68,  87,  55,  255, 46,  69,  58,  255, 46,  74,  52,  255, 52,  81,  55,  255, 58,  89,  65,  255, 52,  79,  52,  255,
    83,  101, 36,  255, 175, 190, 84,  255, 114, 148, 84,  255, 105, 140, 78,  255, 130, 159, 82,  255, 157, 170, 73,  255, 117, 132, 50,  255, 145,
    161, 81,  255, 115, 137, 83,  255, 92,  125, 87,  255, 90,  121, 84,  255, 87,  117, 84,  255, 144, 166, 104, 255, 159, 186, 108, 255, 132, 170,
    106, 255, 132, 171, 107, 255, 140, 180, 112, 255, 164, 195, 99,  255, 129, 149, 60,  255, 148, 168, 77,  255, 139, 159, 72,  255, 121, 140, 71,
    255, 99,  122, 55,  255, 117, 137, 58,  255, 102, 136, 62,  255, 96,  131, 67,  255, 80,  116, 53,  255, 104, 130, 48,  255, 178, 187, 68,  255,
    193, 204, 84,  255, 170, 190, 86,  255, 168, 182, 87,  255, 132, 154, 83,  255, 175, 193, 110, 255, 205, 218, 154, 255, 205, 223, 166, 255, 217,
    229, 166, 255, 195, 206, 138, 255, 121, 140, 72,  255, 83,  105, 31,  255, 124, 137, 42,  255, 119, 144, 46,  255, 68,  87,  28,  255, 62,  68,
    29,  255, 81,  91,  31,  255, 99,  115, 47,  255, 116, 134, 62,  255, 132, 151, 76,  255, 124, 144, 74,  255, 105, 128, 56,  255, 101, 124, 55,
    255, 84,  110, 44,  255, 104, 137, 53,  255, 100, 137, 53,  255, 96,  134, 55,  255, 87,  128, 49,  255, 83,  119, 38,  255, 90,  116, 33,  255,
    99,  125, 43,  255, 79,  103, 36,  255, 92,  111, 44,  255, 88,  111, 47,  255, 80,  113, 52,  255, 92,  125, 47,  255, 131, 161, 62,  255, 90,
    109, 48,  255, 55,  80,  32,  255, 48,  87,  25,  255, 49,  90,  21,  255, 80,  110, 36,  255, 132, 153, 65,  255, 167, 184, 87,  255, 174, 193,
    87,  255, 169, 192, 81,  255, 159, 185, 73,  255, 107, 135, 55,  255, 62,  86,  36,  255, 45,  60,  29,  255, 37,  58,  21,  255, 75,  96,  25,
    255, 142, 164, 50,  255, 155, 174, 58,  255, 175, 190, 68,  255, 182, 196, 76,  255, 187, 199, 84,  255, 183, 195, 84,  255, 159, 172, 74,  255,
    146, 159, 77,  255, 179, 195, 100, 255, 191, 209, 99,  255, 189, 208, 95,  255, 180, 202, 100, 255, 162, 190, 92,  255, 170, 195, 94,  255, 175,
    194, 98,  255, 172, 186, 84,  255, 184, 201, 112, 255, 189, 207, 129, 255, 186, 202, 111, 255, 192, 209, 100, 255, 191, 210, 87,  255, 127, 148,
    69,  255, 68,  92,  42,  255, 84,  120, 52,  255, 81,  112, 45,  255, 63,  91,  31,  255, 60,  81,  33,  255, 67,  92,  37,  255, 102, 131, 52,
    255, 101, 132, 52,  255, 73,  104, 42,  255, 38,  58,  26,  255, 83,  114, 52,  255, 75,  105, 60,  255, 67,  99,  53,  255, 86,  118, 53,  255,
    50,  67,  31,  255, 45,  65,  26,  255, 46,  69,  31,  255, 71,  84,  39,  255, 142, 147, 75,  255, 164, 173, 86,  255, 146, 158, 73,  255, 163,
    168, 71,  255, 248, 241, 142, 255, 246, 243, 136, 255, 187, 192, 92,  255, 161, 173, 94,  255, 160, 159, 123, 255, 156, 168, 90,  255, 156, 177,
    73,  255, 174, 189, 98,  255, 161, 177, 92,  255, 63,  87,  36,  255, 62,  91,  34,  255, 52,  81,  32,  255, 41,  72,  28,  255, 50,  77,  26,
    255, 98,  124, 52,  255, 98,  129, 62,  255, 98,  122, 56,  255, 113, 134, 58,  255, 110, 135, 52,  255, 113, 132, 55,  255, 106, 120, 58,  255,
    97,  117, 55,  255, 168, 194, 97,  255, 184, 212, 109, 255, 161, 189, 96,  255, 124, 155, 68,  255, 101, 129, 60,  255, 107, 135, 80,  255, 121,
    149, 84,  255, 95,  115, 52,  255, 101, 121, 55,  255, 163, 174, 109, 255, 222, 233, 181, 255, 213, 234, 182, 255, 201, 225, 170, 255, 204, 224,
    160, 255, 205, 223, 147, 255, 201, 222, 142, 255, 193, 215, 133, 255, 160, 182, 104, 255, 139, 158, 86,  255, 149, 165, 95,  255, 82,  103, 58,
    255, 39,  58,  28,  255, 38,  52,  31,  255, 37,  51,  26,  255, 37,  53,  26,  255, 37,  55,  23,  255, 138, 151, 79,  255, 212, 227, 158, 255,
    180, 208, 157, 255, 183, 201, 134, 255, 99,  127, 81,  255, 101, 131, 80,  255, 127, 149, 65,  255, 186, 197, 92,  255, 182, 201, 105, 255, 173,
    197, 107, 255, 179, 201, 108, 255, 199, 213, 115, 255, 185, 200, 145, 255, 161, 187, 147, 255, 196, 209, 140, 255, 218, 219, 134, 255, 157, 171,
    76,  255, 129, 145, 62,  255, 73,  102, 42,  255, 60,  87,  39,  255, 206, 209, 143, 255, 230, 230, 155, 255, 148, 161, 97,  255, 165, 187, 121,
    255, 192, 212, 145, 255, 192, 207, 137, 255, 190, 206, 126, 255, 192, 203, 121, 255, 189, 204, 127, 255, 200, 220, 135, 255, 209, 227, 147, 255,
    234, 234, 132, 255, 243, 241, 127, 255, 201, 199, 109, 255, 195, 198, 117, 255, 173, 170, 100, 255, 62,  83,  55,  255, 68,  93,  75,  255, 85,
    107, 58,  255, 120, 143, 47,  255, 106, 132, 49,  255, 154, 178, 74,  255, 143, 183, 60,  255, 167, 189, 85,  255, 60,  83,  31,  255, 74,  113,
    44,  255, 167, 183, 128, 255, 214, 230, 181, 255, 164, 174, 114, 255, 60,  92,  49,  255, 99,  130, 55,  255, 176, 194, 81,  255, 140, 176, 87,
    255, 144, 178, 87,  255, 143, 178, 74,  255, 168, 192, 75,  255, 146, 165, 52,  255, 76,  109, 25,  255, 100, 131, 47,  255, 77,  101, 47,  255,
    55,  86,  49,  255, 69,  98,  58,  255, 46,  68,  40,  255, 44,  68,  48,  255, 87,  111, 63,  255, 97,  122, 62,  255, 82,  109, 62,  255, 102,
    129, 69,  255, 92,  108, 56,  255, 85,  107, 50,  255, 80,  110, 49,  255, 49,  76,  37,  255, 47,  75,  29,  255, 43,  63,  23,  255, 46,  68,
    26,  255, 58,  81,  31,  255, 63,  86,  31,  255, 73,  107, 29,  255, 68,  96,  47,  255, 49,  72,  68,  255, 55,  80,  63,  255, 60,  86,  65,
    255, 62,  86,  67,  255, 50,  71,  41,  255, 55,  81,  28,  255, 128, 143, 58,  255, 129, 163, 81,  255, 113, 151, 80,  255, 138, 159, 63,  255,
    88,  108, 42,  255, 106, 137, 81,  255, 106, 134, 86,  255, 94,  125, 89,  255, 105, 134, 96,  255, 96,  127, 92,  255, 100, 129, 89,  255, 170,
    189, 123, 255, 172, 199, 131, 255, 174, 205, 136, 255, 184, 212, 126, 255, 197, 214, 114, 255, 192, 206, 103, 255, 114, 149, 82,  255, 114, 149,
    77,  255, 99,  125, 58,  255, 90,  113, 52,  255, 99,  118, 56,  255, 87,  113, 52,  255, 117, 151, 75,  255, 116, 150, 71,  255, 116, 148, 65,
    255, 100, 137, 60,  255, 140, 161, 52,  255, 195, 196, 56,  255, 195, 205, 86,  255, 152, 169, 91,  255, 152, 170, 97,  255, 157, 181, 116, 255,
    179, 191, 127, 255, 197, 207, 140, 255, 203, 213, 137, 255, 101, 120, 55,  255, 83,  102, 32,  255, 96,  121, 45,  255, 100, 121, 39,  255, 84,
    109, 37,  255, 65,  92,  33,  255, 58,  72,  32,  255, 58,  79,  25,  255, 95,  108, 33,  255, 166, 168, 74,  255, 176, 180, 87,  255, 170, 176,
    79,  255, 141, 155, 74,  255, 55,  83,  26,  255, 68,  91,  26,  255, 102, 134, 49,  255, 99,  139, 53,  255, 94,  134, 52,  255, 92,  132, 52,
    255, 65,  98,  32,  255, 42,  63,  17,  255, 50,  74,  21,  255, 52,  81,  23,  255, 55,  81,  23,  255, 67,  95,  34,  255, 77,  109, 40,  255,
    89,  119, 41,  255, 67,  95,  34,  255, 60,  79,  36,  255, 53,  84,  31,  255, 48,  84,  26,  255, 55,  92,  31,  255, 67,  102, 36,  255, 68,
    99,  28,  255, 82,  110, 37,  255, 106, 133, 55,  255, 116, 138, 60,  255, 80,  99,  47,  255, 49,  71,  33,  255, 49,  65,  28,  255, 41,  60,
    21,  255, 47,  75,  29,  255, 43,  62,  28,  255, 72,  97,  33,  255, 109, 134, 43,  255, 126, 147, 52,  255, 128, 144, 55,  255, 108, 124, 50,
    255, 81,  102, 41,  255, 62,  83,  31,  255, 117, 138, 71,  255, 171, 194, 112, 255, 175, 198, 114, 255, 170, 193, 104, 255, 168, 193, 98,  255,
    171, 198, 101, 255, 172, 199, 103, 255, 168, 195, 93,  255, 182, 203, 69,  255, 176, 198, 58,  255, 176, 197, 74,  255, 177, 198, 68,  255, 179,
    200, 60,  255, 204, 215, 71,  255, 193, 206, 105, 255, 105, 128, 63,  255, 77,  104, 48,  255, 55,  77,  38,  255, 58,  73,  31,  255, 95,  121,
    47,  255, 120, 145, 60,  255, 123, 153, 60,  255, 114, 146, 58,  255, 104, 137, 55,  255, 84,  107, 40,  255, 106, 132, 68,  255, 83,  112, 68,
    255, 67,  98,  56,  255, 100, 123, 60,  255, 82,  96,  50,  255, 92,  113, 55,  255, 145, 157, 76,  255, 212, 215, 105, 255, 229, 235, 118, 255,
    226, 233, 117, 255, 222, 229, 111, 255, 218, 223, 101, 255, 232, 229, 137, 255, 141, 155, 74,  255, 79,  111, 34,  255, 138, 161, 68,  255, 146,
    156, 84,  255, 145, 158, 63,  255, 166, 182, 84,  255, 179, 194, 97,  255, 139, 152, 74,  255, 63,  84,  32,  255, 81,  112, 43,  255, 74,  103,
    38,  255, 103, 120, 60,  255, 126, 140, 72,  255, 108, 120, 52,  255, 58,  75,  32,  255, 60,  86,  36,  255, 47,  75,  31,  255, 42,  68,  26,
    255, 29,  41,  23,  255, 38,  60,  29,  255, 75,  108, 47,  255, 76,  106, 52,  255, 98,  119, 63,  255, 108, 128, 74,  255, 123, 143, 80,  255,
    102, 127, 63,  255, 77,  104, 48,  255, 91,  114, 52,  255, 116, 145, 76,  255, 135, 166, 95,  255, 196, 212, 154, 255, 196, 215, 155, 255, 199,
    216, 148, 255, 200, 214, 140, 255, 186, 198, 116, 255, 194, 207, 120, 255, 191, 205, 113, 255, 164, 179, 100, 255, 128, 154, 98,  255, 147, 162,
    100, 255, 157, 177, 113, 255, 157, 174, 105, 255, 43,  52,  31,  255, 26,  36,  25,  255, 31,  40,  26,  255, 26,  37,  21,  255, 109, 122, 58,
    255, 214, 228, 161, 255, 177, 206, 163, 255, 176, 205, 147, 255, 195, 208, 135, 255, 133, 155, 105, 255, 135, 159, 116, 255, 145, 166, 121, 255,
    143, 161, 96,  255, 176, 187, 99,  255, 184, 199, 141, 255, 174, 194, 146, 255, 188, 206, 149, 255, 156, 183, 143, 255, 159, 186, 137, 255, 211,
    220, 144, 255, 118, 122, 69,  255, 47,  68,  28,  255, 48,  72,  26,  255, 40,  68,  29,  255, 132, 146, 87,  255, 214, 227, 165, 255, 173, 188,
    128, 255, 136, 151, 97,  255, 169, 193, 144, 255, 161, 188, 134, 255, 148, 178, 117, 255, 161, 184, 95,  255, 166, 184, 78,  255, 153, 171, 69,
    255, 194, 205, 103, 255, 215, 224, 117, 255, 207, 215, 91,  255, 135, 144, 55,  255, 39,  52,  23,  255, 40,  67,  19,  255, 104, 129, 52,  255,
    75,  102, 50,  255, 74,  99,  62,  255, 148, 162, 55,  255, 164, 178, 58,  255, 154, 171, 65,  255, 178, 198, 84,  255, 142, 184, 62,  255, 158,
    177, 82,  255, 25,  37,  12,  255, 83,  103, 58,  255, 203, 223, 176, 255, 189, 213, 169, 255, 216, 226, 158, 255, 127, 139, 69,  255, 71,  101,
    36,  255, 145, 170, 85,  255, 186, 202, 117, 255, 165, 185, 96,  255, 140, 158, 68,  255, 98,  126, 40,  255, 84,  128, 34,  255, 106, 148, 45,
    255, 119, 147, 68,  255, 78,  100, 58,  255, 51,  77,  38,  255, 68,  102, 46,  255, 74,  99,  56,  255, 77,  103, 60,  255, 123, 152, 79,  255,
    101, 135, 79,  255, 87,  125, 77,  255, 102, 138, 84,  255, 119, 153, 89,  255, 122, 153, 87,  255, 128, 157, 86,  255, 112, 136, 67,  255, 62,
    84,  34,  255, 25,  42,  12,  255, 33,  55,  23,  255, 69,  92,  46,  255, 112, 130, 67,  255, 158, 179, 92,  255, 168, 185, 101, 255, 109, 131,
    87,  255, 62,  86,  71,  255, 55,  76,  65,  255, 55,  75,  62,  255, 49,  71,  58,  255, 53,  76,  44,  255, 75,  98,  39,  255, 123, 140, 63,
    255, 131, 153, 67,  255, 75,  100, 44,  255, 104, 134, 73,  255, 124, 152, 94,  255, 104, 137, 96,  255, 102, 136, 101, 255, 103, 135, 104, 255,
    101, 132, 91,  255, 107, 136, 92,  255, 133, 152, 104, 255, 148, 162, 99,  255, 170, 176, 102, 255, 157, 167, 86,  255, 156, 168, 63,  255, 150,
    161, 72,  255, 130, 162, 106, 255, 130, 167, 104, 255, 120, 149, 68,  255, 88,  114, 52,  255, 72,  99,  39,  255, 72,  104, 39,  255, 128, 157,
    82,  255, 135, 168, 80,  255, 159, 177, 65,  255, 157, 172, 58,  255, 169, 183, 62,  255, 190, 199, 73,  255, 186, 202, 113, 255, 138, 158, 92,
    255, 144, 169, 113, 255, 147, 176, 131, 255, 146, 175, 126, 255, 173, 191, 126, 255, 174, 189, 111, 255, 46,  69,  28,  255, 75,  89,  28,  255,
    127, 142, 50,  255, 116, 137, 46,  255, 118, 137, 41,  255, 114, 137, 47,  255, 62,  79,  32,  255, 98,  103, 37,  255, 177, 178, 76,  255, 176,
    181, 78,  255, 169, 176, 75,  255, 172, 176, 71,  255, 143, 158, 69,  255, 76,  100, 31,  255, 102, 130, 48,  255, 98,  130, 47,  255, 106, 143,
    60,  255, 100, 137, 58,  255, 98,  135, 56,  255, 57,  89,  28,  255, 58,  81,  21,  255, 69,  95,  31,  255, 68,  96,  32,  255, 58,  84,  29,
    255, 63,  91,  31,  255, 72,  100, 32,  255, 68,  90,  42,  255, 58,  75,  39,  255, 62,  86,  37,  255, 49,  84,  28,  255, 47,  80,  25,  255,
    58,  94,  28,  255, 68,  104, 33,  255, 74,  106, 33,  255, 69,  105, 31,  255, 58,  98,  28,  255, 47,  79,  26,  255, 40,  55,  28,  255, 53,
    74,  31,  255, 47,  73,  26,  255, 60,  94,  29,  255, 68,  103, 32,  255, 72,  104, 34,  255, 65,  101, 33,  255, 53,  91,  25,  255, 52,  87,
    21,  255, 60,  92,  25,  255, 58,  86,  23,  255, 84,  104, 41,  255, 166, 185, 103, 255, 185, 210, 121, 255, 170, 198, 107, 255, 162, 190, 92,
    255, 161, 188, 87,  255, 172, 197, 96,  255, 182, 207, 115, 255, 181, 209, 122, 255, 162, 195, 99,  255, 138, 165, 63,  255, 180, 195, 68,  255,
    195, 214, 75,  255, 189, 209, 72,  255, 207, 215, 71,  255, 207, 213, 106, 255, 200, 212, 125, 255, 166, 185, 96,  255, 103, 125, 62,  255, 68,
    83,  45,  255, 60,  75,  29,  255, 87,  117, 44,  255, 139, 165, 97,  255, 124, 153, 68,  255, 109, 143, 55,  255, 94,  132, 43,  255, 112, 141,
    53,  255, 112, 138, 67,  255, 76,  105, 62,  255, 97,  119, 65,  255, 124, 150, 87,  255, 111, 145, 87,  255, 169, 183, 104, 255, 235, 238, 140,
    255, 222, 229, 113, 255, 217, 225, 106, 255, 221, 227, 113, 255, 219, 224, 103, 255, 210, 220, 90,  255, 195, 212, 80,  255, 111, 141, 46,  255,
    95,  128, 47,  255, 159, 181, 84,  255, 144, 156, 77,  255, 155, 169, 71,  255, 169, 185, 87,  255, 177, 193, 92,  255, 71,  84,  36,  255, 65,
    79,  36,  255, 129, 149, 69,  255, 168, 173, 87,  255, 188, 195, 114, 255, 190, 194, 109, 255, 188, 188, 99,  255, 121, 127, 68,  255, 135, 146,
    86,  255, 162, 174, 99,  255, 175, 183, 104, 255, 182, 187, 112, 255, 181, 187, 108, 255, 150, 164, 91,  255, 82,  107, 67,  255, 58,  92,  62,
    255, 65,  97,  67,  255, 65,  95,  60,  255, 86,  110, 55,  255, 127, 141, 81,  255, 181, 192, 111, 255, 176, 194, 103, 255, 133, 159, 77,  255,
    144, 169, 89,  255, 149, 174, 97,  255, 144, 167, 84,  255, 121, 142, 67,  255, 100, 127, 67,  255, 153, 179, 89,  255, 146, 171, 76,  255, 140,
    164, 98,  255, 113, 150, 108, 255, 124, 151, 92,  255, 142, 166, 113, 255, 170, 193, 129, 255, 129, 133, 80,  255, 12,  21,  15,  255, 26,  33,
    23,  255, 19,  26,  15,  255, 171, 179, 118, 255, 204, 224, 151, 255, 178, 207, 140, 255, 190, 213, 145, 255, 197, 210, 133, 255, 195, 218, 182,
    255, 202, 227, 189, 255, 177, 194, 126, 255, 115, 139, 63,  255, 184, 198, 118, 255, 155, 179, 144, 255, 145, 174, 139, 255, 147, 178, 137, 255,
    160, 187, 135, 255, 205, 215, 139, 255, 136, 136, 81,  255, 32,  47,  23,  255, 53,  77,  33,  255, 50,  69,  32,  255, 32,  37,  21,  255, 171,
    180, 125, 255, 203, 220, 159, 255, 145, 163, 108, 255, 161, 186, 136, 255, 164, 190, 137, 255, 153, 181, 119, 255, 168, 186, 110, 255, 124, 139,
    65,  255, 137, 169, 74,  255, 150, 173, 65,  255, 182, 199, 74,  255, 186, 202, 74,  255, 166, 184, 77,  255, 58,  71,  31,  255, 55,  82,  33,
    255, 75,  102, 48,  255, 105, 127, 65,  255, 140, 157, 91,  255, 152, 167, 94,  255, 200, 201, 102, 255, 198, 200, 87,  255, 178, 190, 86,  255,
    192, 207, 99,  255, 175, 205, 87,  255, 127, 144, 58,  255, 127, 137, 97,  255, 165, 186, 149, 255, 182, 207, 170, 255, 192, 215, 167, 255, 210,
    224, 165, 255, 175, 186, 104, 255, 101, 133, 65,  255, 124, 151, 107, 255, 134, 156, 87,  255, 124, 147, 67,  255, 100, 130, 55,  255, 115, 147,
    55,  255, 118, 144, 62,  255, 86,  114, 62,  255, 68,  103, 53,  255, 65,  95,  56,  255, 65,  91,  49,  255, 60,  86,  39,  255, 96,  125, 60,
    255, 114, 146, 74,  255, 93,  128, 78,  255, 80,  117, 74,  255, 85,  123, 79,  255, 93,  130, 87,  255, 95,  133, 86,  255, 97,  134, 87,  255,
    107, 142, 92,  255, 124, 156, 93,  255, 128, 155, 86,  255, 110, 126, 68,  255, 178, 189, 116, 255, 213, 224, 134, 255, 207, 219, 124, 255, 201,
    214, 121, 255, 198, 214, 116, 255, 134, 158, 99,  255, 62,  90,  77,  255, 80,  104, 81,  255, 73,  96,  76,  255, 62,  87,  75,  255, 62,  85,
    75,  255, 58,  81,  48,  255, 67,  87,  36,  255, 109, 140, 65,  255, 107, 146, 82,  255, 175, 194, 110, 255, 135, 164, 104, 255, 112, 149, 107,
    255, 111, 145, 104, 255, 107, 141, 100, 255, 104, 138, 94,  255, 106, 136, 92,  255, 99,  132, 86,  255, 91,  128, 78,  255, 95,  131, 79,  255,
    123, 155, 81,  255, 104, 121, 50,  255, 71,  87,  45,  255, 134, 161, 110, 255, 144, 174, 116, 255, 113, 129, 60,  255, 86,  105, 42,  255, 69,
    98,  33,  255, 60,  79,  28,  255, 119, 142, 79,  255, 166, 184, 89,  255, 181, 186, 71,  255, 159, 172, 65,  255, 181, 192, 72,  255, 201, 206,
    91,  255, 180, 202, 132, 255, 139, 160, 101, 255, 151, 175, 125, 255, 159, 186, 142, 255, 170, 190, 141, 255, 211, 217, 138, 255, 115, 133, 58,
    255, 143, 142, 48,  255, 204, 195, 65,  255, 199, 198, 62,  255, 181, 187, 55,  255, 190, 197, 52,  255, 145, 163, 49,  255, 56,  63,  26,  255,
    143, 140, 58,  255, 179, 183, 80,  255, 167, 174, 75,  255, 165, 171, 65,  255, 177, 179, 72,  255, 98,  121, 45,  255, 80,  103, 31,  255, 97,
    125, 45,  255, 90,  119, 40,  255, 93,  125, 47,  255, 114, 145, 68,  255, 104, 134, 58,  255, 77,  100, 25,  255, 161, 170, 50,  255, 159, 185,
    58,  255, 119, 152, 52,  255, 87,  119, 52,  255, 99,  131, 42,  255, 149, 176, 53,  255, 109, 137, 50,  255, 56,  67,  39,  255, 37,  48,  28,
    255, 26,  42,  19,  255, 23,  37,  21,  255, 50,  69,  26,  255, 81,  115, 37,  255, 82,  120, 42,  255, 79,  114, 39,  255, 77,  111, 36,  255,
    60,  92,  28,  255, 45,  60,  26,  255, 52,  71,  28,  255, 62,  96,  31,  255, 73,  109, 37,  255, 81,  114, 42,  255, 87,  120, 46,  255, 85,
    117, 43,  255, 71,  107, 33,  255, 56,  96,  23,  255, 73,  105, 32,  255, 81,  114, 31,  255, 154, 171, 79,  255, 184, 204, 104, 255, 176, 198,
    92,  255, 174, 199, 87,  255, 174, 200, 90,  255, 181, 206, 100, 255, 187, 208, 112, 255, 179, 201, 114, 255, 159, 181, 99,  255, 124, 155, 72,
    255, 74,  109, 44,  255, 91,  115, 45,  255, 163, 177, 73,  255, 205, 216, 95,  255, 191, 202, 82,  255, 158, 172, 74,  255, 182, 195, 99,  255,
    192, 206, 111, 255, 115, 134, 63,  255, 81,  99,  40,  255, 101, 131, 45,  255, 79,  104, 39,  255, 130, 157, 106, 255, 121, 149, 69,  255, 109,
    140, 52,  255, 112, 146, 63,  255, 121, 150, 68,  255, 78,  105, 38,  255, 103, 126, 58,  255, 154, 176, 96,  255, 117, 151, 98,  255, 104, 128,
    94,  255, 215, 213, 145, 255, 228, 229, 134, 255, 213, 221, 118, 255, 204, 212, 113, 255, 206, 215, 112, 255, 202, 211, 101, 255, 188, 199, 86,
    255, 194, 208, 79,  255, 181, 199, 74,  255, 164, 180, 74,  255, 175, 194, 78,  255, 152, 170, 69,  255, 155, 175, 62,  255, 168, 186, 80,  255,
    177, 191, 102, 255, 162, 172, 100, 255, 205, 211, 130, 255, 222, 228, 137, 255, 224, 226, 129, 255, 181, 194, 106, 255, 174, 186, 109, 255, 166,
    190, 120, 255, 165, 195, 126, 255, 171, 199, 132, 255, 190, 211, 131, 255, 196, 214, 136, 255, 211, 224, 141, 255, 224, 231, 144, 255, 233, 234,
    136, 255, 221, 224, 134, 255, 158, 172, 110, 255, 86,  112, 80,  255, 111, 133, 85,  255, 152, 166, 94,  255, 209, 218, 131, 255, 220, 231, 129,
    255, 104, 116, 58,  255, 73,  93,  36,  255, 72,  84,  39,  255, 62,  68,  37,  255, 80,  103, 38,  255, 99,  124, 58,  255, 130, 158, 87,  255,
    118, 147, 63,  255, 67,  84,  33,  255, 160, 179, 116, 255, 135, 169, 129, 255, 129, 162, 110, 255, 137, 164, 109, 255, 152, 181, 136, 255, 179,
    189, 114, 255, 37,  46,  26,  255, 23,  36,  23,  255, 58,  68,  40,  255, 200, 215, 161, 255, 185, 210, 126, 255, 161, 193, 77,  255, 182, 206,
    106, 255, 177, 202, 148, 255, 185, 213, 157, 255, 186, 200, 106, 255, 150, 165, 63,  255, 123, 144, 58,  255, 188, 202, 125, 255, 148, 175, 137,
    255, 161, 184, 131, 255, 182, 200, 127, 255, 202, 204, 114, 255, 127, 123, 65,  255, 29,  40,  19,  255, 36,  53,  26,  255, 45,  62,  29,  255,
    29,  40,  23,  255, 38,  52,  23,  255, 185, 196, 141, 255, 186, 200, 142, 255, 147, 168, 119, 255, 169, 196, 144, 255, 161, 187, 123, 255, 196,
    212, 126, 255, 169, 173, 83,  255, 112, 129, 44,  255, 153, 180, 69,  255, 142, 165, 58,  255, 157, 178, 73,  255, 149, 174, 76,  255, 158, 179,
    82,  255, 107, 126, 48,  255, 133, 152, 83,  255, 213, 223, 160, 255, 209, 224, 160, 255, 197, 222, 151, 255, 189, 218, 136, 255, 192, 221, 143,
    255, 205, 222, 147, 255, 207, 215, 129, 255, 180, 196, 95,  255, 172, 192, 91,  255, 165, 172, 112, 255, 212, 229, 181, 255, 203, 223, 181, 255,
    205, 221, 162, 255, 202, 220, 163, 255, 221, 231, 166, 255, 164, 174, 101, 255, 113, 145, 94,  255, 130, 158, 87,  255, 149, 173, 77,  255, 83,
    107, 44,  255, 69,  103, 55,  255, 82,  108, 65,  255, 69,  98,  67,  255, 68,  101, 68,  255, 74,  103, 65,  255, 63,  97,  58,  255, 61,  94,
    47,  255, 68,  99,  47,  255, 112, 144, 82,  255, 99,  131, 84,  255, 87,  125, 80,  255, 91,  129, 82,  255, 100, 136, 91,  255, 103, 140, 94,
    255, 104, 143, 95,  255, 107, 144, 96,  255, 112, 147, 96,  255, 114, 149, 97,  255, 120, 158, 97,  255, 172, 200, 115, 255, 197, 207, 112, 255,
    191, 199, 109, 255, 216, 222, 126, 255, 219, 225, 127, 255, 214, 223, 123, 255, 151, 168, 104, 255, 137, 159, 101, 255, 178, 196, 110, 255, 81,
    109, 87,  255, 69,  99,  86,  255, 76,  106, 91,  255, 56,  76,  63,  255, 21,  26,  15,  255, 122, 139, 71,  255, 167, 189, 106, 255, 153, 176,
    110, 255, 155, 185, 114, 255, 125, 160, 111, 255, 111, 146, 106, 255, 108, 145, 101, 255, 142, 173, 99,  255, 129, 161, 92,  255, 136, 168, 90,
    255, 154, 183, 91,  255, 153, 173, 87,  255, 123, 135, 62,  255, 63,  84,  41,  255, 53,  83,  41,  255, 119, 143, 74,  255, 133, 151, 75,  255,
    72,  87,  36,  255, 48,  67,  25,  255, 52,  74,  26,  255, 53,  76,  32,  255, 92,  116, 52,  255, 161, 169, 65,  255, 223, 212, 87,  255, 214,
    211, 92,  255, 194, 198, 80,  255, 205, 207, 97,  255, 184, 204, 138, 255, 141, 163, 106, 255, 157, 182, 138, 255, 172, 194, 152, 255, 210, 222,
    153, 255, 154, 171, 87,  255, 156, 150, 40,  255, 233, 218, 69,  255, 213, 205, 63,  255, 201, 196, 58,  255, 216, 207, 60,  255, 195, 198, 68,
    255, 103, 122, 47,  255, 67,  68,  26,  255, 166, 166, 72,  255, 170, 177, 76,  255, 160, 168, 63,  255, 171, 174, 60,  255, 150, 161, 65,  255,
    52,  81,  23,  255, 73,  93,  26,  255, 98,  124, 44,  255, 86,  117, 38,  255, 74,  109, 33,  255, 74,  106, 37,  255, 72,  100, 34,  255, 52,
    67,  28,  255, 89,  83,  29,  255, 198, 201, 73,  255, 152, 178, 69,  255, 141, 162, 74,  255, 175, 192, 71,  255, 154, 176, 81,  255, 73,  105,
    42,  255, 65,  84,  37,  255, 40,  52,  28,  255, 40,  52,  26,  255, 34,  40,  26,  255, 17,  21,  17,  255, 49,  62,  25,  255, 84,  109, 41,
    255, 89,  122, 47,  255, 68,  101, 36,  255, 52,  73,  31,  255, 47,  55,  29,  255, 58,  77,  28,  255, 83,  114, 37,  255, 96,  124, 47,  255,
    100, 129, 50,  255, 97,  127, 48,  255, 92,  122, 48,  255, 91,  121, 47,  255, 84,  120, 40,  255, 82,  117, 38,  255, 81,  110, 47,  255, 87,
    114, 47,  255, 89,  118, 38,  255, 83,  96,  40,  255, 85,  99,  43,  255, 83,  97,  44,  255, 92,  107, 49,  255, 104, 132, 56,  255, 80,  111,
    52,  255, 60,  87,  42,  255, 63,  89,  42,  255, 80,  107, 44,  255, 84,  115, 45,  255, 95,  123, 47,  255, 129, 151, 65,  255, 142, 166, 74,
    255, 143, 167, 67,  255, 133, 156, 58,  255, 148, 167, 68,  255, 147, 166, 65,  255, 56,  73,  29,  255, 69,  92,  36,  255, 94,  124, 44,  255,
    125, 154, 84,  255, 111, 140, 55,  255, 108, 139, 50,  255, 119, 149, 62,  255, 116, 146, 62,  255, 69,  87,  33,  255, 146, 167, 105, 255, 133,
    162, 111, 255, 108, 139, 97,  255, 108, 141, 100, 255, 117, 143, 98,  255, 154, 176, 87,  255, 140, 172, 96,  255, 140, 173, 79,  255, 138, 169,
    58,  255, 71,  96,  37,  255, 82,  105, 36,  255, 130, 160, 47,  255, 134, 156, 65,  255, 182, 198, 83,  255, 169, 188, 68,  255, 141, 161, 60,
    255, 168, 188, 74,  255, 194, 208, 99,  255, 207, 217, 117, 255, 218, 226, 121, 255, 217, 223, 113, 255, 217, 223, 119, 255, 218, 224, 119, 255,
    218, 221, 109, 255, 206, 210, 107, 255, 181, 197, 115, 255, 176, 200, 127, 255, 179, 205, 134, 255, 178, 200, 125, 255, 173, 197, 107, 255, 180,
    202, 135, 255, 177, 198, 135, 255, 202, 214, 137, 255, 219, 227, 123, 255, 220, 228, 120, 255, 206, 212, 129, 255, 228, 232, 139, 255, 200, 212,
    125, 255, 160, 182, 87,  255, 118, 135, 69,  255, 56,  72,  36,  255, 123, 142, 76,  255, 121, 135, 76,  255, 135, 146, 96,  255, 172, 196, 139,
    255, 183, 207, 156, 255, 203, 217, 144, 255, 133, 144, 84,  255, 60,  68,  36,  255, 162, 177, 110, 255, 151, 183, 143, 255, 141, 173, 132, 255,
    133, 159, 102, 255, 153, 184, 142, 255, 188, 200, 122, 255, 52,  60,  32,  255, 17,  31,  19,  255, 79,  90,  55,  255, 197, 219, 169, 255, 175,
    205, 161, 255, 155, 188, 93,  255, 156, 187, 84,  255, 173, 199, 119, 255, 177, 197, 100, 255, 168, 181, 90,  255, 165, 178, 98,  255, 107, 129,
    48,  255, 159, 177, 93,  255, 165, 185, 117, 255, 196, 204, 109, 255, 141, 145, 65,  255, 50,  55,  31,  255, 17,  26,  21,  255, 31,  41,  26,
    255, 29,  37,  26,  255, 21,  26,  23,  255, 29,  41,  23,  255, 44,  58,  31,  255, 187, 198, 147, 255, 158, 176, 127, 255, 171, 196, 149, 255,
    172, 197, 139, 255, 201, 217, 136, 255, 201, 212, 96,  255, 182, 200, 73,  255, 193, 209, 82,  255, 189, 205, 73,  255, 179, 194, 68,  255, 147,
    170, 74,  255, 141, 170, 74,  255, 170, 190, 94,  255, 200, 208, 111, 255, 218, 224, 112, 255, 215, 222, 103, 255, 216, 223, 123, 255, 217, 227,
    138, 255, 212, 226, 129, 255, 192, 218, 117, 255, 189, 221, 122, 255, 193, 223, 120, 255, 162, 183, 87,  255, 110, 127, 56,  255, 178, 191, 122,
    255, 200, 221, 128, 255, 194, 215, 111, 255, 190, 213, 109, 255, 221, 234, 151, 255, 223, 218, 134, 255, 123, 132, 68,  255, 125, 153, 56,  255,
    120, 155, 65,  255, 132, 159, 74,  255, 93,  126, 44,  255, 74,  114, 50,  255, 68,  106, 52,  255, 67,  102, 50,  255, 73,  109, 55,  255, 104,
    137, 62,  255, 115, 139, 60,  255, 81,  108, 45,  255, 103, 138, 75,  255, 111, 144, 81,  255, 91,  128, 67,  255, 92,  135, 74,  255, 98,  140,
    80,  255, 105, 144, 92,  255, 110, 150, 101, 255, 111, 154, 104, 255, 119, 159, 108, 255, 122, 162, 113, 255, 126, 165, 115, 255, 154, 185, 119,
    255, 141, 160, 93,  255, 60,  69,  32,  255, 36,  52,  21,  255, 85,  108, 47,  255, 164, 180, 92,  255, 197, 206, 111, 255, 222, 227, 121, 255,
    207, 216, 120, 255, 115, 140, 102, 255, 76,  109, 96,  255, 77,  106, 90,  255, 58,  75,  58,  255, 32,  38,  23,  255, 15,  26,  15,  255, 108,
    120, 65,  255, 161, 189, 106, 255, 126, 148, 74,  255, 115, 108, 52,  255, 140, 153, 92,  255, 167, 190, 116, 255, 156, 180, 109, 255, 117, 116,
    60,  255, 103, 100, 50,  255, 92,  87,  41,  255, 128, 128, 63,  255, 136, 147, 68,  255, 115, 137, 60,  255, 100, 129, 55,  255, 120, 152, 65,
    255, 110, 140, 55,  255, 82,  115, 42,  255, 69,  105, 37,  255, 46,  69,  26,  255, 47,  72,  31,  255, 65,  91,  39,  255, 81,  105, 48,  255,
    104, 126, 48,  255, 161, 172, 63,  255, 194, 188, 82,  255, 227, 215, 107, 255, 226, 222, 123, 255, 188, 207, 142, 255, 141, 163, 108, 255, 166,
    190, 148, 255, 209, 221, 159, 255, 184, 198, 115, 255, 108, 124, 42,  255, 210, 197, 73,  255, 218, 209, 81,  255, 213, 203, 83,  255, 220, 212,
    81,  255, 186, 191, 75,  255, 136, 154, 67,  255, 104, 124, 50,  255, 106, 122, 43,  255, 152, 163, 58,  255, 162, 171, 62,  255, 174, 177, 65,
    255, 157, 163, 69,  255, 60,  76,  31,  255, 41,  60,  21,  255, 68,  84,  26,  255, 101, 125, 42,  255, 86,  118, 39,  255, 74,  110, 34,  255,
    55,  91,  23,  255, 52,  84,  25,  255, 33,  43,  23,  255, 43,  51,  26,  255, 132, 133, 56,  255, 199, 204, 107, 255, 201, 206, 109, 255, 169,
    182, 81,  255, 90,  121, 55,  255, 68,  92,  40,  255, 80,  108, 39,  255, 89,  124, 46,  255, 100, 132, 48,  255, 105, 130, 56,  255, 36,  44,
    26,  255, 32,  38,  23,  255, 60,  81,  26,  255, 126, 151, 81,  255, 87,  118, 60,  255, 117, 142, 74,  255, 63,  91,  44,  255, 60,  81,  28,
    255, 102, 131, 42,  255, 108, 134, 47,  255, 113, 141, 52,  255, 113, 141, 53,  255, 118, 143, 52,  255, 100, 125, 50,  255, 55,  72,  32,  255,
    78,  100, 40,  255, 87,  114, 48,  255, 81,  111, 44,  255, 38,  58,  29,  255, 19,  23,  26,  255, 12,  19,  17,  255, 15,  21,  17,  255, 21,
    32,  17,  255, 48,  74,  23,  255, 69,  100, 36,  255, 73,  104, 40,  255, 65,  99,  42,  255, 53,  83,  34,  255, 92,  113, 50,  255, 120, 145,
    71,  255, 118, 144, 72,  255, 122, 143, 68,  255, 117, 139, 60,  255, 108, 128, 43,  255, 121, 145, 39,  255, 136, 161, 53,  255, 107, 129, 55,
    255, 69,  90,  37,  255, 65,  92,  36,  255, 108, 134, 68,  255, 98,  132, 41,  255, 100, 134, 40,  255, 112, 143, 58,  255, 101, 136, 60,  255,
    126, 148, 74,  255, 163, 183, 113, 255, 161, 181, 106, 255, 154, 178, 97,  255, 138, 168, 87,  255, 114, 145, 76,  255, 141, 167, 87,  255, 135,
    166, 83,  255, 123, 141, 55,  255, 58,  74,  31,  255, 41,  56,  32,  255, 47,  60,  26,  255, 118, 133, 53,  255, 183, 199, 105, 255, 158, 178,
    75,  255, 135, 156, 62,  255, 140, 161, 62,  255, 187, 202, 86,  255, 201, 213, 91,  255, 204, 215, 91,  255, 208, 217, 87,  255, 213, 219, 98,
    255, 211, 220, 101, 255, 204, 215, 100, 255, 203, 214, 106, 255, 199, 210, 106, 255, 204, 203, 100, 255, 142, 141, 69,  255, 119, 127, 69,  255,
    176, 190, 110, 255, 180, 204, 105, 255, 175, 202, 105, 255, 170, 197, 130, 255, 168, 195, 133, 255, 189, 212, 102, 255, 179, 203, 123, 255, 202,
    217, 151, 255, 216, 226, 143, 255, 166, 186, 90,  255, 89,  112, 43,  255, 67,  90,  41,  255, 147, 177, 95,  255, 168, 200, 115, 255, 168, 200,
    128, 255, 177, 207, 153, 255, 173, 205, 156, 255, 178, 207, 157, 255, 181, 209, 154, 255, 196, 220, 156, 255, 186, 204, 138, 255, 195, 205, 129,
    255, 174, 197, 148, 255, 150, 182, 151, 255, 127, 156, 108, 255, 153, 185, 147, 255, 185, 198, 128, 255, 47,  52,  33,  255, 12,  21,  17,  255,
    81,  96,  62,  255, 188, 216, 167, 255, 174, 201, 148, 255, 142, 167, 94,  255, 129, 160, 94,  255, 141, 171, 107, 255, 152, 182, 112, 255, 159,
    184, 102, 255, 158, 180, 103, 255, 119, 143, 74,  255, 137, 158, 65,  255, 146, 163, 73,  255, 69,  75,  34,  255, 23,  37,  21,  255, 40,  58,
    29,  255, 49,  68,  31,  255, 42,  58,  29,  255, 37,  52,  29,  255, 32,  44,  25,  255, 23,  36,  21,  255, 99,  114, 63,  255, 211, 220, 166,
    255, 152, 174, 123, 255, 184, 209, 147, 255, 202, 217, 131, 255, 190, 206, 97,  255, 165, 189, 68,  255, 165, 186, 67,  255, 167, 188, 60,  255,
    171, 193, 73,  255, 164, 187, 86,  255, 170, 189, 96,  255, 173, 192, 95,  255, 191, 208, 99,  255, 204, 215, 97,  255, 201, 211, 86,  255, 194,
    208, 87,  255, 204, 215, 116, 255, 218, 226, 140, 255, 229, 230, 141, 255, 167, 171, 79,  255, 129, 136, 67,  255, 99,  107, 52,  255, 89,  104,
    47,  255, 133, 151, 77,  255, 192, 210, 112, 255, 186, 209, 102, 255, 187, 211, 100, 255, 192, 219, 114, 255, 208, 227, 131, 255, 214, 226, 134,
    255, 175, 184, 103, 255, 97,  116, 55,  255, 78,  104, 53,  255, 84,  116, 60,  255, 100, 130, 44,  255, 83,  110, 42,  255, 76,  104, 46,  255,
    75,  107, 47,  255, 67,  84,  40,  255, 55,  79,  29,  255, 133, 156, 62,  255, 118, 141, 62,  255, 94,  132, 53,  255, 133, 165, 69,  255, 132,
    159, 68,  255, 127, 152, 86,  255, 133, 165, 100, 255, 138, 175, 106, 255, 142, 178, 112, 255, 148, 183, 118, 255, 147, 181, 120, 255, 152, 182,
    112, 255, 154, 180, 102, 255, 131, 154, 79,  255, 84,  111, 47,  255, 53,  75,  33,  255, 26,  28,  23,  255, 33,  58,  23,  255, 65,  104, 36,
    255, 63,  92,  41,  255, 88,  112, 53,  255, 107, 131, 68,  255, 83,  109, 90,  255, 69,  85,  74,  255, 37,  43,  32,  255, 21,  21,  15,  255,
    21,  25,  19,  255, 17,  29,  21,  255, 76,  83,  46,  255, 130, 143, 79,  255, 38,  37,  19,  255, 3,   6,   9,   255, 49,  52,  33,  255, 90,
    83,  43,  255, 99,  95,  48,  255, 39,  60,  38,  255, 19,  29,  21,  255, 17,  26,  23,  255, 36,  44,  32,  255, 76,  81,  41,  255, 105, 110,
    49,  255, 152, 170, 74,  255, 159, 179, 87,  255, 90,  125, 63,  255, 87,  124, 55,  255, 87,  126, 48,  255, 95,  132, 44,  255, 76,  107, 36,
    255, 72,  101, 40,  255, 81,  109, 58,  255, 77,  104, 67,  255, 81,  112, 47,  255, 83,  114, 29,  255, 122, 137, 48,  255, 175, 178, 86,  255,
    183, 203, 139, 255, 141, 163, 108, 255, 198, 212, 159, 255, 184, 197, 116, 255, 69,  93,  25,  255, 125, 132, 52,  255, 213, 205, 92,  255, 220,
    211, 106, 255, 214, 211, 108, 255, 178, 188, 80,  255, 151, 166, 55,  255, 139, 158, 50,  255, 97,  119, 41,  255, 91,  109, 37,  255, 119, 133,
    43,  255, 143, 153, 60,  255, 137, 152, 60,  255, 79,  105, 37,  255, 37,  55,  23,  255, 42,  55,  28,  255, 41,  51,  23,  255, 75,  90,  32,
    255, 91,  121, 41,  255, 74,  108, 33,  255, 60,  94,  26,  255, 49,  76,  21,  255, 89,  107, 44,  255, 104, 133, 67,  255, 87,  118, 58,  255,
    136, 149, 77,  255, 147, 156, 92,  255, 78,  103, 36,  255, 91,  113, 36,  255, 123, 137, 58,  255, 116, 141, 62,  255, 95,  131, 45,  255, 117,
    149, 55,  255, 119, 145, 72,  255, 53,  63,  29,  255, 73,  102, 44,  255, 74,  108, 47,  255, 126, 148, 75,  255, 163, 185, 98,  255, 157, 183,
    106, 255, 77,  111, 63,  255, 36,  62,  28,  255, 85,  106, 32,  255, 119, 143, 52,  255, 128, 154, 62,  255, 126, 150, 60,  255, 84,  101, 40,
    255, 33,  40,  23,  255, 21,  31,  21,  255, 29,  39,  21,  255, 47,  60,  29,  255, 42,  58,  31,  255, 29,  37,  28,  255, 21,  25,  25,  255,
    12,  17,  15,  255, 17,  21,  19,  255, 44,  62,  23,  255, 51,  80,  26,  255, 50,  77,  29,  255, 47,  65,  29,  255, 37,  48,  23,  255, 36,
    47,  23,  255, 93,  113, 49,  255, 108, 135, 62,  255, 115, 136, 63,  255, 114, 133, 58,  255, 149, 165, 60,  255, 187, 201, 63,  255, 185, 198,
    60,  255, 180, 195, 68,  255, 169, 191, 68,  255, 152, 173, 60,  255, 91,  112, 39,  255, 69,  87,  41,  255, 96,  121, 47,  255, 96,  129, 37,
    255, 116, 151, 83,  255, 133, 167, 105, 255, 85,  107, 48,  255, 55,  68,  29,  255, 98,  115, 52,  255, 124, 144, 65,  255, 128, 150, 65,  255,
    118, 143, 56,  255, 99,  127, 47,  255, 68,  84,  36,  255, 31,  38,  31,  255, 29,  34,  28,  255, 43,  48,  29,  255, 53,  65,  36,  255, 120,
    128, 72,  255, 196, 211, 109, 255, 144, 164, 60,  255, 103, 126, 47,  255, 103, 122, 53,  255, 152, 171, 62,  255, 187, 202, 83,  255, 185, 201,
    87,  255, 190, 204, 82,  255, 193, 205, 81,  255, 190, 205, 80,  255, 192, 206, 81,  255, 196, 210, 91,  255, 200, 216, 123, 255, 197, 214, 131,
    255, 175, 185, 114, 255, 156, 163, 102, 255, 181, 185, 106, 255, 206, 213, 119, 255, 171, 194, 93,  255, 190, 207, 108, 255, 208, 220, 124, 255,
    201, 217, 116, 255, 205, 220, 135, 255, 194, 217, 135, 255, 188, 211, 134, 255, 152, 175, 89,  255, 95,  121, 43,  255, 152, 171, 75,  255, 198,
    216, 110, 255, 180, 206, 115, 255, 171, 200, 127, 255, 172, 200, 137, 255, 178, 205, 146, 255, 184, 210, 151, 255, 179, 208, 156, 255, 176, 205,
    147, 255, 191, 213, 139, 255, 190, 209, 131, 255, 186, 205, 141, 255, 159, 189, 157, 255, 138, 165, 117, 255, 159, 186, 143, 255, 172, 191, 132,
    255, 47,  62,  31,  255, 21,  36,  19,  255, 75,  84,  58,  255, 182, 207, 155, 255, 148, 173, 108, 255, 111, 142, 81,  255, 113, 147, 86,  255,
    123, 155, 86,  255, 125, 159, 84,  255, 117, 155, 77,  255, 131, 165, 74,  255, 122, 145, 65,  255, 119, 138, 75,  255, 85,  111, 52,  255, 58,
    74,  36,  255, 72,  92,  37,  255, 108, 131, 47,  255, 77,  102, 37,  255, 56,  82,  34,  255, 52,  81,  31,  255, 58,  87,  29,  255, 38,  53,
    23,  255, 90,  98,  56,  255, 168, 180, 119, 255, 163, 186, 107, 255, 211, 216, 94,  255, 206, 214, 90,  255, 172, 193, 82,  255, 164, 186, 74,
    255, 190, 204, 98,  255, 192, 205, 97,  255, 138, 165, 93,  255, 120, 159, 100, 255, 160, 188, 112, 255, 210, 221, 124, 255, 172, 194, 72,  255,
    173, 197, 71,  255, 190, 205, 81,  255, 207, 217, 118, 255, 217, 227, 138, 255, 224, 232, 142, 255, 218, 225, 129, 255, 181, 188, 101, 255, 31,
    36,  19,  255, 3,   3,   12,  255, 23,  37,  26,  255, 121, 143, 74,  255, 220, 226, 169, 255, 191, 212, 170, 255, 218, 228, 151, 255, 199, 200,
    113, 255, 154, 172, 103, 255, 130, 155, 102, 255, 121, 147, 102, 255, 87,  119, 87,  255, 89,  128, 80,  255, 111, 146, 68,  255, 79,  106, 50,
    255, 52,  69,  39,  255, 33,  52,  31,  255, 47,  72,  31,  255, 34,  51,  26,  255, 45,  65,  31,  255, 55,  72,  33,  255, 118, 132, 68,  255,
    139, 171, 86,  255, 130, 165, 82,  255, 154, 184, 80,  255, 162, 171, 69,  255, 92,  100, 55,  255, 105, 131, 68,  255, 123, 152, 75,  255, 135,
    158, 75,  255, 117, 147, 60,  255, 106, 139, 44,  255, 94,  129, 34,  255, 83,  117, 36,  255, 71,  103, 42,  255, 72,  113, 44,  255, 65,  92,
    36,  255, 39,  65,  23,  255, 55,  91,  31,  255, 44,  74,  31,  255, 57,  90,  39,  255, 94,  131, 38,  255, 101, 137, 41,  255, 52,  62,  29,
    255, 17,  19,  15,  255, 28,  34,  25,  255, 21,  25,  21,  255, 72,  84,  58,  255, 154, 174, 98,  255, 69,  82,  52,  255, 26,  34,  29,  255,
    43,  53,  41,  255, 82,  110, 77,  255, 31,  52,  37,  255, 37,  62,  37,  255, 67,  101, 47,  255, 42,  67,  36,  255, 26,  31,  23,  255, 26,
    36,  25,  255, 15,  19,  19,  255, 28,  28,  19,  255, 175, 184, 83,  255, 146, 167, 86,  255, 99,  136, 77,  255, 102, 140, 71,  255, 101, 134,
    62,  255, 167, 182, 74,  255, 130, 153, 48,  255, 85,  117, 44,  255, 94,  123, 48,  255, 89,  116, 53,  255, 90,  125, 39,  255, 96,  134, 32,
    255, 95,  132, 29,  255, 119, 148, 39,  255, 156, 182, 116, 255, 153, 171, 118, 255, 185, 203, 136, 255, 65,  95,  31,  255, 52,  76,  15,  255,
    118, 128, 49,  255, 184, 187, 84,  255, 197, 198, 92,  255, 185, 191, 81,  255, 178, 186, 68,  255, 175, 184, 77,  255, 177, 184, 82,  255, 133,
    151, 63,  255, 81,  99,  41,  255, 39,  48,  17,  255, 76,  99,  32,  255, 84,  115, 40,  255, 58,  87,  26,  255, 52,  71,  31,  255, 31,  43,
    26,  255, 25,  34,  21,  255, 43,  57,  21,  255, 73,  97,  31,  255, 73,  108, 32,  255, 58,  92,  25,  255, 62,  79,  23,  255, 132, 150, 73,
    255, 105, 132, 79,  255, 79,  105, 65,  255, 75,  101, 48,  255, 69,  90,  29,  255, 91,  112, 37,  255, 123, 148, 52,  255, 135, 159, 62,  255,
    164, 185, 108, 255, 101, 118, 62,  255, 65,  74,  36,  255, 42,  48,  29,  255, 67,  89,  36,  255, 83,  119, 58,  255, 65,  90,  55,  255, 113,
    137, 55,  255, 149, 177, 72,  255, 159, 181, 101, 255, 90,  121, 60,  255, 84,  114, 43,  255, 42,  55,  26,  255, 56,  69,  29,  255, 63,  75,
    39,  255, 42,  48,  31,  255, 19,  17,  21,  255, 19,  25,  21,  255, 23,  37,  17,  255, 52,  65,  31,  255, 31,  37,  26,  255, 34,  44,  29,
    255, 48,  62,  36,  255, 49,  60,  31,  255, 97,  113, 48,  255, 31,  39,  26,  255, 34,  48,  21,  255, 74,  107, 38,  255, 78,  110, 47,  255,
    37,  58,  31,  255, 23,  34,  21,  255, 28,  38,  23,  255, 83,  105, 49,  255, 100, 128, 58,  255, 108, 129, 58,  255, 106, 127, 52,  255, 152,
    166, 55,  255, 197, 208, 63,  255, 195, 206, 73,  255, 191, 204, 75,  255, 184, 200, 60,  255, 193, 206, 68,  255, 146, 169, 80,  255, 107, 136,
    74,  255, 84,  104, 55,  255, 104, 130, 68,  255, 129, 158, 91,  255, 92,  119, 58,  255, 26,  37,  23,  255, 17,  26,  19,  255, 33,  58,  23,
    255, 48,  81,  31,  255, 52,  89,  34,  255, 60,  97,  33,  255, 60,  98,  31,  255, 45,  62,  32,  255, 47,  58,  37,  255, 41,  47,  31,  255,
    56,  69,  36,  255, 40,  58,  23,  255, 149, 161, 89,  255, 189, 204, 103, 255, 112, 132, 47,  255, 53,  78,  23,  255, 82,  101, 47,  255, 144,
    171, 79,  255, 145, 179, 102, 255, 116, 151, 108, 255, 126, 158, 117, 255, 128, 160, 118, 255, 125, 157, 101, 255, 158, 181, 96,  255, 187, 195,
    83,  255, 178, 179, 75,  255, 169, 183, 111, 255, 176, 206, 134, 255, 181, 208, 140, 255, 189, 210, 132, 255, 203, 217, 139, 255, 201, 214, 134,
    255, 192, 207, 116, 255, 202, 212, 113, 255, 164, 180, 95,  255, 172, 182, 99,  255, 116, 130, 65,  255, 93,  111, 52,  255, 101, 127, 52,  255,
    95,  125, 49,  255, 69,  84,  36,  255, 121, 133, 62,  255, 191, 196, 111, 255, 208, 218, 131, 255, 215, 226, 135, 255, 204, 216, 138, 255, 190,
    208, 137, 255, 199, 213, 135, 255, 184, 200, 114, 255, 166, 186, 99,  255, 154, 176, 87,  255, 155, 166, 94,  255, 180, 203, 153, 255, 135, 165,
    122, 255, 148, 174, 129, 255, 172, 191, 134, 255, 40,  62,  25,  255, 28,  48,  21,  255, 60,  69,  42,  255, 153, 173, 105, 255, 149, 169, 99,
    255, 167, 188, 100, 255, 170, 190, 77,  255, 187, 203, 82,  255, 189, 204, 83,  255, 165, 185, 73,  255, 162, 184, 91,  255, 121, 144, 92,  255,
    118, 138, 75,  255, 103, 128, 62,  255, 89,  114, 47,  255, 89,  115, 58,  255, 109, 133, 52,  255, 78,  105, 42,  255, 72,  102, 40,  255, 75,
    103, 40,  255, 111, 134, 55,  255, 89,  106, 43,  255, 12,  21,  15,  255, 90,  109, 49,  255, 138, 160, 72,  255, 178, 187, 76,  255, 169, 181,
    81,  255, 179, 197, 93,  255, 175, 194, 83,  255, 194, 208, 117, 255, 222, 229, 140, 255, 208, 221, 143, 255, 177, 200, 131, 255, 148, 178, 116,
    255, 180, 204, 123, 255, 181, 202, 87,  255, 161, 190, 69,  255, 209, 222, 125, 255, 219, 228, 139, 255, 221, 228, 134, 255, 212, 217, 130, 255,
    112, 136, 76,  255, 119, 148, 73,  255, 92,  105, 49,  255, 52,  63,  36,  255, 74,  95,  58,  255, 112, 139, 68,  255, 199, 212, 135, 255, 187,
    207, 137, 255, 170, 183, 107, 255, 113, 143, 99,  255, 110, 143, 110, 255, 104, 135, 99,  255, 89,  126, 72,  255, 96,  135, 65,  255, 109, 143,
    62,  255, 79,  106, 47,  255, 82,  111, 55,  255, 67,  82,  39,  255, 25,  44,  23,  255, 40,  65,  26,  255, 52,  75,  31,  255, 43,  58,  31,
    255, 29,  37,  28,  255, 38,  48,  26,  255, 113, 129, 80,  255, 111, 129, 83,  255, 110, 131, 76,  255, 62,  72,  37,  255, 42,  67,  23,  255,
    49,  83,  26,  255, 42,  78,  26,  255, 43,  81,  23,  255, 47,  87,  26,  255, 58,  98,  32,  255, 58,  99,  31,  255, 62,  105, 29,  255, 80,
    112, 42,  255, 58,  89,  44,  255, 57,  92,  37,  255, 43,  72,  23,  255, 57,  92,  25,  255, 117, 150, 42,  255, 137, 171, 55,  255, 138, 175,
    55,  255, 113, 147, 41,  255, 42,  58,  28,  255, 40,  52,  36,  255, 76,  93,  65,  255, 58,  68,  52,  255, 156, 185, 119, 255, 112, 138, 87,
    255, 83,  112, 68,  255, 116, 150, 89,  255, 110, 144, 84,  255, 109, 147, 87,  255, 57,  84,  46,  255, 67,  102, 47,  255, 74,  103, 52,  255,
    77,  110, 55,  255, 36,  52,  31,  255, 19,  23,  21,  255, 21,  29,  23,  255, 40,  47,  26,  255, 199, 198, 87,  255, 154, 173, 97,  255, 114,
    148, 93,  255, 117, 150, 87,  255, 106, 139, 80,  255, 181, 189, 92,  255, 183, 186, 69,  255, 100, 131, 41,  255, 117, 148, 49,  255, 83,  114,
    36,  255, 106, 130, 44,  255, 129, 156, 47,  255, 129, 156, 44,  255, 131, 158, 46,  255, 130, 153, 65,  255, 176, 187, 103, 255, 142, 157, 82,
    255, 65,  87,  37,  255, 45,  68,  17,  255, 88,  102, 33,  255, 174, 183, 89,  255, 199, 207, 99,  255, 196, 206, 96,  255, 183, 199, 103, 255,
    142, 171, 109, 255, 169, 185, 111, 255, 199, 206, 98,  255, 91,  109, 43,  255, 52,  77,  23,  255, 77,  107, 31,  255, 72,  102, 33,  255, 48,
    75,  23,  255, 49,  69,  26,  255, 39,  55,  26,  255, 44,  67,  21,  255, 39,  68,  21,  255, 41,  62,  25,  255, 58,  87,  28,  255, 41,  63,
    23,  255, 48,  60,  21,  255, 140, 149, 60,  255, 171, 182, 94,  255, 145, 165, 99,  255, 89,  118, 63,  255, 69,  90,  31,  255, 80,  108, 40,
    255, 90,  120, 53,  255, 105, 136, 68,  255, 135, 165, 92,  255, 112, 136, 90,  255, 12,  15,  19,  255, 28,  31,  17,  255, 85,  115, 55,  255,
    69,  102, 60,  255, 74,  98,  58,  255, 120, 145, 55,  255, 154, 176, 80,  255, 138, 165, 83,  255, 126, 157, 49,  255, 122, 148, 55,  255, 36,
    55,  23,  255, 37,  58,  25,  255, 37,  52,  31,  255, 28,  37,  23,  255, 29,  37,  26,  255, 39,  53,  31,  255, 33,  44,  17,  255, 90,  117,
    31,  255, 71,  91,  37,  255, 98,  124, 39,  255, 109, 139, 55,  255, 121, 145, 60,  255, 165, 188, 87,  255, 76,  99,  43,  255, 33,  42,  26,
    255, 74,  101, 39,  255, 73,  97,  47,  255, 32,  48,  28,  255, 34,  49,  31,  255, 34,  51,  29,  255, 65,  87,  37,  255, 102, 128, 58,  255,
    105, 128, 56,  255, 99,  124, 50,  255, 113, 123, 42,  255, 203, 209, 76,  255, 197, 213, 91,  255, 196, 210, 82,  255, 182, 192, 62,  255, 140,
    157, 58,  255, 131, 158, 90,  255, 145, 176, 109, 255, 125, 150, 86,  255, 110, 132, 77,  255, 53,  79,  29,  255, 41,  63,  23,  255, 29,  38,
    25,  255, 29,  38,  23,  255, 36,  53,  23,  255, 48,  74,  32,  255, 57,  90,  39,  255, 63,  99,  33,  255, 65,  104, 36,  255, 45,  62,  32,
    255, 38,  47,  28,  255, 26,  29,  21,  255, 34,  51,  23,  255, 40,  55,  21,  255, 174, 188, 102, 255, 155, 172, 78,  255, 55,  75,  28,  255,
    40,  62,  23,  255, 86,  108, 52,  255, 131, 159, 90,  255, 129, 162, 103, 255, 113, 149, 113, 255, 115, 152, 118, 255, 114, 151, 106, 255, 120,
    155, 92,  255, 150, 175, 92,  255, 170, 183, 77,  255, 142, 155, 65,  255, 155, 164, 86,  255, 213, 223, 145, 255, 215, 226, 155, 255, 194, 217,
    133, 255, 175, 205, 122, 255, 175, 202, 121, 255, 177, 202, 127, 255, 173, 193, 108, 255, 187, 199, 105, 255, 161, 172, 89,  255, 116, 128, 67,
    255, 113, 130, 62,  255, 132, 152, 72,  255, 118, 145, 62,  255, 82,  103, 49,  255, 58,  86,  40,  255, 87,  114, 44,  255, 122, 143, 52,  255,
    142, 161, 58,  255, 156, 176, 73,  255, 154, 175, 87,  255, 125, 152, 78,  255, 134, 162, 95,  255, 144, 172, 98,  255, 160, 183, 100, 255, 92,
    101, 52,  255, 157, 171, 111, 255, 160, 189, 139, 255, 147, 169, 110, 255, 149, 164, 105, 255, 26,  48,  12,  255, 55,  82,  33,  255, 90,  107,
    58,  255, 136, 151, 84,  255, 156, 182, 84,  255, 178, 203, 102, 255, 184, 211, 114, 255, 190, 209, 117, 255, 174, 182, 89,  255, 153, 169, 91,
    255, 119, 147, 105, 255, 113, 143, 108, 255, 100, 127, 63,  255, 133, 158, 71,  255, 112, 138, 65,  255, 87,  119, 52,  255, 112, 133, 55,  255,
    87,  112, 48,  255, 86,  113, 50,  255, 118, 136, 50,  255, 226, 230, 110, 255, 174, 191, 93,  255, 107, 122, 65,  255, 135, 155, 73,  255, 172,
    197, 93,  255, 229, 236, 131, 255, 201, 203, 119, 255, 181, 196, 92,  255, 134, 158, 72,  255, 144, 173, 114, 255, 200, 214, 138, 255, 229, 238,
    143, 255, 225, 236, 148, 255, 207, 221, 145, 255, 166, 194, 128, 255, 179, 204, 108, 255, 185, 207, 93,  255, 214, 223, 126, 255, 219, 226, 132,
    255, 228, 232, 137, 255, 192, 202, 119, 255, 152, 174, 101, 255, 177, 196, 114, 255, 191, 205, 130, 255, 180, 196, 124, 255, 156, 175, 100, 255,
    105, 136, 67,  255, 135, 160, 72,  255, 138, 160, 92,  255, 114, 145, 103, 255, 111, 145, 93,  255, 103, 137, 73,  255, 112, 147, 65,  255, 140,
    169, 76,  255, 134, 155, 72,  255, 79,  102, 52,  255, 51,  82,  40,  255, 98,  130, 62,  255, 68,  80,  40,  255, 26,  47,  25,  255, 47,  74,
    28,  255, 47,  62,  31,  255, 32,  41,  28,  255, 33,  41,  31,  255, 32,  42,  28,  255, 37,  62,  32,  255, 52,  80,  50,  255, 55,  81,  52,
    255, 34,  47,  29,  255, 26,  33,  19,  255, 52,  77,  31,  255, 65,  96,  33,  255, 73,  105, 33,  255, 63,  99,  32,  255, 62,  98,  33,  255,
    62,  98,  32,  255, 74,  110, 38,  255, 89,  122, 43,  255, 75,  108, 42,  255, 86,  115, 50,  255, 104, 130, 63,  255, 117, 144, 56,  255, 160,
    189, 55,  255, 149, 182, 60,  255, 144, 180, 65,  255, 76,  99,  41,  255, 44,  62,  33,  255, 65,  80,  52,  255, 62,  71,  36,  255, 136, 165,
    68,  255, 146, 181, 81,  255, 130, 163, 76,  255, 134, 171, 89,  255, 127, 165, 90,  255, 130, 170, 82,  255, 121, 157, 62,  255, 72,  105, 44,
    255, 69,  103, 50,  255, 69,  95,  50,  255, 75,  102, 58,  255, 69,  99,  48,  255, 48,  75,  38,  255, 46,  69,  40,  255, 62,  79,  46,  255,
    200, 197, 84,  255, 151, 169, 95,  255, 122, 153, 106, 255, 121, 149, 87,  255, 146, 169, 89,  255, 177, 190, 92,  255, 192, 197, 84,  255, 145,
    169, 55,  255, 167, 192, 80,  255, 102, 132, 60,  255, 157, 158, 58,  255, 201, 214, 103, 255, 162, 182, 92,  255, 133, 154, 90,  255, 159, 170,
    96,  255, 173, 190, 94,  255, 90,  116, 38,  255, 60,  71,  29,  255, 101, 103, 47,  255, 177, 186, 100, 255, 184, 199, 112, 255, 192, 207, 110,
    255, 158, 182, 103, 255, 152, 180, 112, 255, 152, 179, 106, 255, 182, 194, 90,  255, 106, 126, 43,  255, 100, 121, 40,  255, 95,  126, 39,  255,
    114, 139, 49,  255, 91,  118, 43,  255, 39,  56,  21,  255, 45,  62,  25,  255, 56,  74,  28,  255, 97,  115, 52,  255, 108, 120, 62,  255, 109,
    121, 55,  255, 103, 121, 50,  255, 74,  92,  41,  255, 52,  63,  26,  255, 85,  97,  36,  255, 129, 141, 56,  255, 139, 155, 72,  255, 101, 126,
    52,  255, 69,  87,  29,  255, 126, 136, 58,  255, 151, 166, 80,  255, 161, 179, 85,  255, 147, 163, 74,  255, 56,  67,  37,  255, 23,  23,  21,
    255, 39,  44,  23,  255, 89,  122, 62,  255, 83,  118, 68,  255, 92,  120, 67,  255, 126, 152, 68,  255, 157, 178, 94,  255, 134, 163, 72,  255,
    107, 129, 52,  255, 55,  71,  31,  255, 42,  67,  25,  255, 43,  71,  25,  255, 52,  72,  31,  255, 52,  72,  32,  255, 47,  68,  21,  255, 124,
    147, 65,  255, 120, 147, 62,  255, 127, 155, 56,  255, 128, 161, 48,  255, 113, 148, 36,  255, 125, 154, 58,  255, 152, 176, 81,  255, 148, 174,
    74,  255, 116, 147, 58,  255, 85,  112, 47,  255, 68,  87,  39,  255, 41,  53,  26,  255, 60,  81,  38,  255, 74,  94,  45,  255, 56,  77,  40,
    255, 39,  52,  29,  255, 79,  100, 39,  255, 99,  126, 48,  255, 76,  97,  39,  255, 77,  91,  33,  255, 195, 197, 97,  255, 182, 193, 91,  255,
    149, 167, 73,  255, 115, 146, 52,  255, 93,  125, 33,  255, 108, 132, 43,  255, 102, 124, 43,  255, 104, 120, 63,  255, 102, 116, 78,  255, 39,
    60,  36,  255, 62,  89,  33,  255, 65,  97,  33,  255, 60,  97,  31,  255, 60,  92,  31,  255, 37,  52,  26,  255, 49,  75,  34,  255, 57,  94,
    31,  255, 55,  91,  28,  255, 33,  51,  23,  255, 25,  37,  21,  255, 26,  40,  23,  255, 26,  43,  23,  255, 41,  53,  25,  255, 154, 169, 74,
    255, 105, 128, 44,  255, 40,  62,  23,  255, 68,  89,  31,  255, 116, 136, 67,  255, 107, 137, 83,  255, 114, 150, 105, 255, 113, 148, 116, 255,
    118, 152, 114, 255, 119, 153, 98,  255, 112, 147, 89,  255, 147, 170, 86,  255, 166, 181, 81,  255, 166, 182, 90,  255, 202, 215, 138, 255, 205,
    221, 151, 255, 202, 221, 150, 255, 202, 227, 140, 255, 196, 220, 118, 255, 189, 212, 104, 255, 187, 210, 120, 255, 164, 190, 130, 255, 161, 174,
    111, 255, 204, 212, 126, 255, 199, 213, 113, 255, 197, 211, 109, 255, 188, 203, 104, 255, 135, 159, 83,  255, 135, 156, 74,  255, 157, 173, 86,
    255, 84,  110, 44,  255, 69,  99,  42,  255, 103, 129, 60,  255, 115, 145, 80,  255, 117, 148, 91,  255, 114, 149, 95,  255, 109, 142, 93,  255,
    106, 140, 87,  255, 148, 175, 94,  255, 81,  91,  49,  255, 41,  52,  26,  255, 154, 173, 116, 255, 142, 164, 100, 255, 104, 126, 68,  255, 76,
    104, 47,  255, 158, 183, 80,  255, 157, 173, 86,  255, 136, 157, 82,  255, 172, 194, 92,  255, 181, 200, 92,  255, 144, 155, 80,  255, 53,  58,
    32,  255, 50,  71,  26,  255, 100, 119, 48,  255, 129, 150, 87,  255, 121, 150, 107, 255, 93,  119, 62,  255, 81,  104, 44,  255, 53,  84,  33,
    255, 89,  113, 41,  255, 124, 142, 55,  255, 103, 129, 58,  255, 108, 132, 68,  255, 126, 144, 53,  255, 207, 208, 90,  255, 210, 223, 109, 255,
    183, 210, 106, 255, 182, 207, 110, 255, 180, 206, 112, 255, 214, 228, 137, 255, 229, 230, 139, 255, 149, 172, 95,  255, 104, 138, 56,  255, 135,
    159, 80,  255, 191, 208, 128, 255, 205, 223, 121, 255, 184, 211, 104, 255, 186, 211, 118, 255, 183, 205, 123, 255, 188, 205, 108, 255, 179, 205,
    89,  255, 210, 224, 114, 255, 227, 232, 136, 255, 219, 227, 121, 255, 194, 210, 104, 255, 205, 219, 118, 255, 194, 211, 150, 255, 183, 208, 156,
    255, 177, 204, 140, 255, 174, 198, 110, 255, 159, 185, 84,  255, 155, 173, 84,  255, 145, 167, 89,  255, 147, 170, 77,  255, 130, 157, 68,  255,
    130, 159, 75,  255, 152, 175, 79,  255, 114, 133, 68,  255, 67,  91,  60,  255, 65,  96,  55,  255, 67,  103, 52,  255, 126, 152, 71,  255, 62,
    74,  36,  255, 44,  69,  29,  255, 63,  89,  36,  255, 36,  48,  31,  255, 32,  43,  29,  255, 31,  41,  29,  255, 31,  39,  28,  255, 33,  48,
    28,  255, 60,  86,  50,  255, 62,  87,  52,  255, 49,  73,  37,  255, 36,  48,  23,  255, 28,  38,  23,  255, 38,  56,  26,  255, 52,  71,  31,
    255, 40,  55,  26,  255, 40,  58,  28,  255, 60,  72,  36,  255, 92,  118, 45,  255, 91,  123, 46,  255, 120, 150, 71,  255, 123, 149, 71,  255,
    96,  132, 79,  255, 156, 180, 84,  255, 167, 194, 98,  255, 157, 187, 93,  255, 144, 172, 92,  255, 96,  119, 65,  255, 109, 132, 60,  255, 83,
    105, 47,  255, 80,  104, 39,  255, 93,  116, 42,  255, 103, 123, 48,  255, 109, 129, 53,  255, 98,  121, 55,  255, 118, 147, 60,  255, 111, 138,
    50,  255, 77,  105, 33,  255, 58,  92,  37,  255, 69,  100, 47,  255, 69,  100, 56,  255, 69,  99,  56,  255, 80,  113, 40,  255, 76,  115, 40,
    255, 65,  98,  39,  255, 47,  71,  33,  255, 175, 178, 89,  255, 148, 170, 77,  255, 159, 179, 109, 255, 165, 186, 108, 255, 202, 219, 140, 255,
    209, 227, 161, 255, 213, 228, 172, 255, 211, 227, 172, 255, 162, 186, 100, 255, 137, 167, 75,  255, 130, 151, 49,  255, 176, 193, 95,  255, 192,
    204, 105, 255, 211, 219, 152, 255, 191, 205, 115, 255, 140, 167, 60,  255, 91,  122, 37,  255, 98,  109, 47,  255, 188, 199, 122, 255, 153, 183,
    124, 255, 170, 187, 124, 255, 158, 185, 122, 255, 135, 167, 116, 255, 143, 172, 104, 255, 184, 199, 95,  255, 119, 135, 55,  255, 106, 126, 48,
    255, 115, 144, 48,  255, 126, 148, 55,  255, 149, 164, 77,  255, 85,  107, 47,  255, 58,  83,  23,  255, 73,  103, 36,  255, 99,  115, 45,  255,
    147, 153, 79,  255, 136, 149, 79,  255, 140, 151, 83,  255, 129, 139, 68,  255, 130, 142, 63,  255, 109, 126, 55,  255, 94,  111, 44,  255, 75,
    97,  31,  255, 72,  91,  29,  255, 79,  96,  31,  255, 60,  81,  31,  255, 88,  98,  40,  255, 139, 142, 60,  255, 138, 136, 56,  255, 60,  65,
    34,  255, 19,  23,  19,  255, 23,  26,  21,  255, 26,  29,  21,  255, 47,  58,  29,  255, 69,  91,  39,  255, 80,  109, 45,  255, 94,  116, 47,
    255, 155, 172, 104, 255, 82,  112, 48,  255, 26,  42,  19,  255, 38,  53,  19,  255, 57,  84,  28,  255, 55,  84,  31,  255, 58,  89,  32,  255,
    56,  79,  36,  255, 40,  68,  19,  255, 96,  124, 39,  255, 157, 183, 83,  255, 165, 187, 87,  255, 135, 164, 55,  255, 146, 171, 65,  255, 177,
    199, 103, 255, 153, 179, 72,  255, 134, 158, 63,  255, 113, 143, 55,  255, 113, 140, 62,  255, 88,  108, 62,  255, 47,  60,  25,  255, 103, 126,
    52,  255, 103, 130, 55,  255, 92,  118, 50,  255, 39,  55,  31,  255, 38,  51,  25,  255, 69,  86,  36,  255, 69,  89,  36,  255, 100, 125, 50,
    255, 116, 135, 55,  255, 102, 125, 45,  255, 90,  118, 36,  255, 96,  127, 42,  255, 99,  128, 47,  255, 97,  126, 49,  255, 62,  84,  38,  255,
    37,  49,  25,  255, 74,  87,  47,  255, 52,  74,  47,  255, 44,  57,  31,  255, 81,  107, 39,  255, 86,  115, 45,  255, 60,  89,  33,  255, 56,
    73,  31,  255, 100, 121, 44,  255, 83,  117, 37,  255, 41,  65,  23,  255, 65,  76,  31,  255, 94,  111, 44,  255, 88,  107, 40,  255, 65,  91,
    29,  255, 52,  77,  28,  255, 108, 129, 46,  255, 85,  108, 38,  255, 55,  81,  33,  255, 131, 149, 68,  255, 146, 164, 87,  255, 102, 133, 85,
    255, 113, 148, 109, 255, 116, 149, 114, 255, 120, 154, 108, 255, 105, 143, 95,  255, 108, 142, 87,  255, 155, 174, 86,  255, 165, 179, 84,  255,
    164, 179, 83,  255, 171, 185, 79,  255, 166, 177, 71,  255, 115, 124, 60,  255, 105, 109, 68,  255, 157, 161, 82,  255, 220, 223, 113, 255, 197,
    208, 111, 255, 195, 214, 131, 255, 178, 202, 136, 255, 151, 169, 103, 255, 179, 191, 96,  255, 181, 194, 94,  255, 158, 177, 94,  255, 108, 139,
    84,  255, 91,  125, 65,  255, 136, 163, 101, 255, 128, 145, 68,  255, 94,  118, 43,  255, 138, 168, 80,  255, 89,  123, 76,  255, 89,  125, 87,
    255, 97,  132, 92,  255, 97,  132, 90,  255, 103, 137, 84,  255, 165, 188, 94,  255, 86,  103, 43,  255, 98,  114, 55,  255, 90,  109, 60,  255,
    94,  117, 60,  255, 113, 143, 74,  255, 138, 176, 91,  255, 171, 195, 96,  255, 130, 153, 82,  255, 98,  132, 79,  255, 114, 145, 77,  255, 151,
    173, 83,  255, 107, 129, 65,  255, 62,  73,  44,  255, 58,  84,  39,  255, 87,  118, 55,  255, 133, 159, 95,  255, 115, 141, 89,  255, 81,  109,
    55,  255, 51,  80,  33,  255, 73,  106, 40,  255, 88,  112, 38,  255, 103, 128, 52,  255, 92,  118, 79,  255, 102, 129, 72,  255, 126, 143, 58,
    255, 72,  73,  29,  255, 108, 111, 50,  255, 209, 221, 116, 255, 187, 213, 124, 255, 196, 216, 116, 255, 222, 229, 120, 255, 168, 185, 117, 255,
    120, 154, 87,  255, 117, 145, 55,  255, 89,  111, 43,  255, 99,  120, 47,  255, 160, 179, 84,  255, 191, 212, 110, 255, 172, 201, 92,  255, 157,
    188, 83,  255, 178, 200, 97,  255, 200, 218, 105, 255, 206, 218, 124, 255, 178, 200, 87,  255, 162, 195, 68,  255, 175, 205, 78,  255, 201, 218,
    111, 255, 189, 209, 151, 255, 178, 204, 152, 255, 171, 198, 123, 255, 172, 198, 108, 255, 190, 206, 106, 255, 136, 156, 65,  255, 123, 153, 72,
    255, 168, 190, 97,  255, 185, 194, 90,  255, 119, 137, 53,  255, 106, 131, 62,  255, 76,  104, 68,  255, 78,  109, 72,  255, 73,  106, 58,  255,
    100, 136, 71,  255, 148, 160, 77,  255, 55,  74,  31,  255, 63,  97,  33,  255, 56,  77,  36,  255, 31,  41,  31,  255, 32,  42,  31,  255, 31,
    42,  31,  255, 29,  38,  26,  255, 34,  42,  31,  255, 37,  48,  33,  255, 40,  60,  36,  255, 63,  87,  46,  255, 40,  56,  25,  255, 45,  65,
    28,  255, 41,  58,  25,  255, 25,  37,  21,  255, 58,  69,  40,  255, 143, 158, 77,  255, 172, 192, 83,  255, 170, 189, 74,  255, 144, 170, 71,
    255, 152, 176, 90,  255, 100, 128, 89,  255, 105, 144, 82,  255, 151, 175, 75,  255, 132, 147, 79,  255, 157, 179, 102, 255, 162, 189, 107, 255,
    168, 193, 99,  255, 123, 147, 63,  255, 95,  120, 58,  255, 75,  97,  36,  255, 52,  73,  25,  255, 36,  52,  23,  255, 36,  55,  26,  255, 31,
    56,  23,  255, 80,  112, 50,  255, 163, 181, 106, 255, 94,  118, 49,  255, 60,  94,  37,  255, 58,  90,  44,  255, 174, 196, 134, 255, 164, 188,
    126, 255, 145, 173, 104, 255, 94,  128, 62,  255, 76,  102, 32,  255, 111, 122, 55,  255, 188, 193, 111, 255, 215, 221, 134, 255, 173, 189, 98,
    255, 199, 209, 104, 255, 208, 226, 134, 255, 193, 221, 141, 255, 191, 220, 146, 255, 192, 220, 151, 255, 180, 211, 136, 255, 151, 185, 87,  255,
    138, 166, 63,  255, 134, 160, 68,  255, 131, 154, 58,  255, 148, 166, 65,  255, 134, 157, 62,  255, 144, 165, 65,  255, 142, 165, 62,  255, 184,
    197, 94,  255, 196, 211, 117, 255, 170, 193, 128, 255, 156, 184, 135, 255, 142, 175, 121, 255, 144, 175, 105, 255, 174, 194, 100, 255, 116, 130,
    62,  255, 67,  86,  29,  255, 91,  128, 38,  255, 97,  128, 43,  255, 97,  115, 50,  255, 87,  103, 47,  255, 65,  86,  26,  255, 78,  109, 31,
    255, 79,  108, 36,  255, 81,  108, 37,  255, 98,  117, 41,  255, 118, 141, 65,  255, 123, 148, 71,  255, 131, 146, 77,  255, 131, 141, 80,  255,
    162, 162, 98,  255, 147, 157, 84,  255, 118, 128, 58,  255, 79,  90,  41,  255, 71,  87,  32,  255, 65,  87,  32,  255, 71,  100, 43,  255, 68,
    80,  33,  255, 41,  46,  26,  255, 17,  21,  19,  255, 28,  31,  25,  255, 23,  26,  21,  255, 31,  39,  25,  255, 44,  65,  26,  255, 31,  56,
    19,  255, 52,  83,  26,  255, 67,  95,  36,  255, 138, 149, 93,  255, 71,  99,  47,  255, 34,  58,  21,  255, 37,  52,  23,  255, 58,  82,  28,
    255, 58,  84,  31,  255, 77,  109, 43,  255, 84,  104, 47,  255, 99,  113, 58,  255, 114, 131, 58,  255, 159, 174, 85,  255, 177, 199, 98,  255,
    169, 196, 80,  255, 156, 181, 81,  255, 185, 203, 87,  255, 145, 168, 67,  255, 170, 181, 89,  255, 198, 212, 121, 255, 127, 142, 81,  255, 83,
    92,  60,  255, 76,  92,  34,  255, 101, 123, 48,  255, 103, 126, 50,  255, 94,  117, 47,  255, 40,  55,  26,  255, 40,  48,  28,  255, 65,  77,
    42,  255, 62,  80,  29,  255, 81,  108, 31,  255, 85,  115, 33,  255, 82,  108, 33,  255, 83,  114, 40,  255, 75,  109, 45,  255, 65,  97,  47,
    255, 60,  91,  46,  255, 52,  84,  41,  255, 48,  77,  36,  255, 63,  87,  39,  255, 68,  86,  47,  255, 26,  33,  26,  255, 39,  52,  28,  255,
    52,  76,  31,  255, 83,  100, 41,  255, 160, 177, 81,  255, 143, 172, 53,  255, 136, 162, 55,  255, 104, 127, 47,  255, 160, 176, 65,  255, 172,
    197, 60,  255, 160, 186, 60,  255, 154, 174, 68,  255, 143, 163, 65,  255, 159, 177, 67,  255, 162, 180, 76,  255, 106, 131, 55,  255, 156, 171,
    84,  255, 151, 168, 92,  255, 105, 134, 90,  255, 122, 153, 115, 255, 122, 152, 114, 255, 113, 147, 105, 255, 109, 145, 92,  255, 144, 170, 86,
    255, 143, 169, 55,  255, 150, 170, 65,  255, 175, 187, 84,  255, 182, 199, 91,  255, 170, 190, 73,  255, 167, 188, 63,  255, 151, 171, 60,  255,
    84,  103, 42,  255, 91,  113, 49,  255, 118, 144, 71,  255, 111, 139, 84,  255, 158, 176, 96,  255, 205, 217, 109, 255, 153, 174, 79,  255, 141,
    165, 81,  255, 117, 146, 75,  255, 133, 157, 91,  255, 93,  126, 65,  255, 111, 146, 97,  255, 111, 131, 75,  255, 106, 128, 53,  255, 114, 146,
    72,  255, 77,  110, 73,  255, 86,  120, 82,  255, 95,  128, 84,  255, 89,  123, 80,  255, 121, 153, 81,  255, 165, 186, 92,  255, 96,  115, 55,
    255, 144, 160, 80,  255, 178, 198, 112, 255, 151, 180, 99,  255, 152, 184, 105, 255, 163, 191, 98,  255, 154, 174, 93,  255, 111, 144, 94,  255,
    119, 152, 95,  255, 156, 177, 94,  255, 138, 158, 92,  255, 94,  128, 85,  255, 138, 166, 92,  255, 140, 169, 87,  255, 139, 172, 98,  255, 119,
    151, 104, 255, 86,  112, 65,  255, 55,  84,  36,  255, 75,  109, 41,  255, 87,  124, 48,  255, 94,  129, 50,  255, 143, 167, 65,  255, 150, 168,
    75,  255, 104, 128, 62,  255, 111, 133, 60,  255, 101, 120, 62,  255, 98,  121, 62,  255, 131, 150, 78,  255, 183, 201, 125, 255, 224, 234, 146,
    255, 208, 213, 126, 255, 118, 148, 92,  255, 111, 139, 65,  255, 91,  119, 47,  255, 86,  114, 37,  255, 112, 138, 37,  255, 109, 137, 34,  255,
    142, 166, 60,  255, 198, 212, 107, 255, 193, 208, 96,  255, 167, 192, 74,  255, 160, 183, 73,  255, 178, 200, 78,  255, 180, 206, 84,  255, 185,
    208, 112, 255, 174, 195, 115, 255, 193, 206, 137, 255, 172, 198, 144, 255, 177, 198, 125, 255, 178, 200, 113, 255, 195, 209, 112, 255, 160, 177,
    75,  255, 106, 136, 53,  255, 125, 158, 84,  255, 153, 180, 98,  255, 189, 201, 95,  255, 160, 173, 86,  255, 123, 143, 93,  255, 94,  122, 87,
    255, 87,  120, 72,  255, 91,  126, 71,  255, 169, 190, 95,  255, 145, 154, 73,  255, 55,  89,  31,  255, 63,  91,  36,  255, 45,  65,  36,  255,
    42,  68,  32,  255, 36,  49,  32,  255, 31,  42,  29,  255, 31,  41,  31,  255, 45,  52,  42,  255, 29,  38,  28,  255, 17,  23,  19,  255, 39,
    60,  29,  255, 37,  58,  28,  255, 40,  62,  28,  255, 39,  63,  26,  255, 87,  110, 52,  255, 187, 203, 98,  255, 173, 193, 86,  255, 143, 166,
    80,  255, 122, 154, 69,  255, 109, 143, 52,  255, 110, 147, 60,  255, 110, 143, 99,  255, 124, 158, 86,  255, 158, 178, 92,  255, 80,  92,  36,
    255, 100, 112, 48,  255, 112, 132, 55,  255, 132, 160, 75,  255, 133, 157, 86,  255, 120, 148, 87,  255, 110, 139, 65,  255, 96,  127, 48,  255,
    78,  105, 39,  255, 68,  99,  36,  255, 77,  113, 42,  255, 136, 169, 105, 255, 176, 192, 127, 255, 162, 181, 75,  255, 152, 177, 90,  255, 176,
    197, 132, 255, 174, 200, 143, 255, 151, 181, 111, 255, 153, 177, 103, 255, 133, 159, 82,  255, 129, 149, 65,  255, 217, 219, 119, 255, 219, 224,
    123, 255, 188, 201, 109, 255, 163, 179, 91,  255, 202, 205, 108, 255, 222, 228, 142, 255, 209, 226, 159, 255, 200, 220, 157, 255, 194, 216, 144,
    255, 182, 209, 133, 255, 185, 208, 124, 255, 174, 196, 107, 255, 133, 156, 68,  255, 150, 169, 71,  255, 154, 173, 73,  255, 146, 169, 89,  255,
    150, 178, 114, 255, 143, 176, 99,  255, 142, 175, 96,  255, 163, 187, 105, 255, 206, 216, 127, 255, 171, 195, 123, 255, 140, 171, 100, 255, 170,
    189, 100, 255, 98,  105, 55,  255, 21,  26,  15,  255, 74,  90,  31,  255, 89,  129, 36,  255, 116, 148, 52,  255, 62,  95,  29,  255, 49,  77,
    17,  255, 82,  104, 31,  255, 90,  117, 36,  255, 80,  109, 32,  255, 67,  99,  26,  255, 63,  91,  23,  255, 97,  116, 49,  255, 117, 149, 81,
    255, 132, 158, 73,  255, 121, 144, 77,  255, 102, 118, 65,  255, 136, 144, 84,  255, 161, 164, 91,  255, 129, 140, 65,  255, 81,  95,  40,  255,
    67,  80,  31,  255, 81,  90,  36,  255, 69,  83,  36,  255, 31,  42,  31,  255, 19,  21,  21,  255, 28,  31,  28,  255, 38,  42,  28,  255, 150,
    163, 82,  255, 174, 198, 100, 255, 116, 142, 68,  255, 60,  92,  32,  255, 89,  108, 47,  255, 109, 122, 74,  255, 58,  87,  28,  255, 72,  100,
    34,  255, 81,  107, 42,  255, 57,  84,  26,  255, 104, 121, 62,  255, 196, 208, 136, 255, 214, 220, 139, 255, 206, 219, 142, 255, 199, 212, 135,
    255, 198, 208, 126, 255, 205, 219, 128, 255, 191, 217, 113, 255, 166, 190, 78,  255, 192, 210, 85,  255, 186, 198, 83,  255, 215, 222, 105, 255,
    225, 233, 138, 255, 141, 163, 90,  255, 84,  92,  63,  255, 73,  90,  34,  255, 92,  116, 34,  255, 94,  115, 41,  255, 67,  90,  36,  255, 39,
    49,  28,  255, 47,  52,  31,  255, 44,  58,  29,  255, 42,  63,  26,  255, 55,  83,  33,  255, 57,  86,  36,  255, 65,  86,  36,  255, 92,  124,
    60,  255, 73,  107, 56,  255, 68,  98,  60,  255, 63,  94,  60,  255, 63,  92,  60,  255, 60,  91,  53,  255, 65,  96,  46,  255, 76,  96,  50,
    255, 55,  69,  29,  255, 95,  120, 32,  255, 86,  117, 29,  255, 156, 169, 71,  255, 172, 190, 91,  255, 164, 188, 103, 255, 166, 192, 125, 255,
    169, 199, 130, 255, 162, 191, 114, 255, 177, 195, 82,  255, 182, 198, 94,  255, 188, 199, 80,  255, 147, 168, 55,  255, 147, 171, 68,  255, 160,
    181, 90,  255, 154, 180, 92,  255, 150, 167, 81,  255, 134, 151, 80,  255, 112, 140, 96,  255, 129, 162, 118, 255, 118, 151, 114, 255, 113, 147,
    101, 255, 152, 178, 94,  255, 143, 171, 58,  255, 137, 167, 49,  255, 133, 164, 47,  255, 168, 184, 74,  255, 190, 206, 99,  255, 182, 199, 90,
    255, 174, 192, 80,  255, 161, 179, 77,  255, 104, 124, 67,  255, 85,  105, 60,  255, 119, 143, 75,  255, 109, 144, 89,  255, 106, 133, 83,  255,
    209, 215, 124, 255, 191, 214, 121, 255, 165, 194, 99,  255, 178, 202, 106, 255, 218, 226, 116, 255, 114, 136, 68,  255, 120, 150, 83,  255, 89,
    104, 55,  255, 118, 144, 60,  255, 91,  122, 68,  255, 74,  107, 73,  255, 91,  123, 80,  255, 88,  120, 74,  255, 84,  119, 74,  255, 121, 153,
    76,  255, 153, 175, 83,  255, 112, 135, 74,  255, 85,  108, 65,  255, 114, 134, 69,  255, 157, 174, 90,  255, 193, 211, 128, 255, 169, 186, 109,
    255, 122, 151, 97,  255, 118, 155, 107, 255, 145, 175, 103, 255, 170, 186, 97,  255, 110, 139, 83,  255, 129, 161, 90,  255, 143, 174, 91,  255,
    140, 171, 92,  255, 105, 138, 95,  255, 127, 159, 101, 255, 100, 131, 62,  255, 133, 154, 52,  255, 126, 151, 52,  255, 112, 144, 55,  255, 106,
    139, 62,  255, 130, 157, 68,  255, 180, 192, 73,  255, 169, 182, 69,  255, 142, 168, 79,  255, 124, 157, 83,  255, 103, 133, 75,  255, 94,  127,
    71,  255, 112, 141, 85,  255, 173, 186, 123, 255, 145, 164, 96,  255, 109, 138, 62,  255, 106, 136, 55,  255, 111, 145, 60,  255, 134, 162, 58,
    255, 136, 161, 53,  255, 144, 168, 55,  255, 133, 163, 47,  255, 143, 171, 62,  255, 165, 182, 82,  255, 176, 197, 84,  255, 210, 226, 84,  255,
    224, 235, 89,  255, 241, 243, 104, 255, 218, 220, 116, 255, 162, 184, 107, 255, 171, 192, 121, 255, 166, 189, 112, 255, 188, 199, 102, 255, 172,
    190, 127, 255, 149, 177, 126, 255, 171, 192, 108, 255, 135, 152, 58,  255, 147, 169, 73,  255, 162, 186, 98,  255, 169, 187, 96,  255, 142, 159,
    87,  255, 115, 139, 96,  255, 105, 133, 91,  255, 97,  130, 87,  255, 123, 156, 91,  255, 200, 206, 106, 255, 101, 111, 47,  255, 51,  81,  26,
    255, 65,  97,  33,  255, 69,  101, 38,  255, 72,  104, 40,  255, 55,  82,  38,  255, 42,  55,  33,  255, 32,  46,  36,  255, 53,  60,  52,  255,
    29,  39,  23,  255, 26,  42,  23,  255, 34,  55,  29,  255, 43,  71,  33,  255, 49,  76,  37,  255, 75,  99,  48,  255, 190, 205, 102, 255, 174,
    194, 97,  255, 137, 168, 84,  255, 127, 158, 81,  255, 97,  134, 65,  255, 97,  137, 60,  255, 107, 142, 65,  255, 105, 143, 63,  255, 121, 155,
    81,  255, 141, 164, 81,  255, 75,  79,  31,  255, 94,  104, 42,  255, 122, 140, 71,  255, 136, 166, 99,  255, 114, 143, 100, 255, 105, 137, 90,
    255, 96,  129, 85,  255, 94,  127, 86,  255, 94,  129, 79,  255, 97,  136, 73,  255, 131, 166, 87,  255, 180, 202, 95,  255, 179, 191, 90,  255,
    163, 187, 68,  255, 179, 196, 103, 255, 178, 200, 135, 255, 143, 174, 112, 255, 119, 154, 86,  255, 115, 149, 81,  255, 122, 155, 87,  255, 124,
    158, 91,  255, 159, 184, 106, 255, 172, 189, 99,  255, 169, 183, 97,  255, 214, 221, 143, 255, 212, 227, 157, 255, 191, 215, 149, 255, 174, 202,
    138, 255, 163, 193, 134, 255, 160, 190, 136, 255, 156, 187, 133, 255, 154, 185, 122, 255, 159, 188, 113, 255, 160, 187, 98,  255, 145, 166, 80,
    255, 157, 176, 93,  255, 155, 184, 125, 255, 140, 175, 116, 255, 140, 175, 100, 255, 148, 179, 102, 255, 154, 187, 120, 255, 175, 200, 138, 255,
    210, 222, 146, 255, 185, 203, 101, 255, 97,  115, 55,  255, 3,   6,   12,  255, 12,  12,  15,  255, 58,  71,  21,  255, 106, 143, 47,  255, 101,
    131, 45,  255, 101, 124, 49,  255, 135, 158, 76,  255, 146, 170, 84,  255, 145, 170, 83,  255, 154, 177, 90,  255, 137, 163, 77,  255, 78,  106,
    47,  255, 53,  68,  21,  255, 125, 154, 84,  255, 112, 143, 60,  255, 142, 168, 82,  255, 83,  106, 58,  255, 86,  96,  58,  255, 109, 118, 58,
    255, 101, 113, 47,  255, 84,  84,  47,  255, 72,  68,  42,  255, 62,  74,  36,  255, 48,  71,  33,  255, 33,  53,  31,  255, 48,  47,  33,  255,
    140, 145, 95,  255, 52,  60,  45,  255, 110, 114, 48,  255, 201, 222, 118, 255, 196, 215, 110, 255, 124, 157, 72,  255, 80,  97,  48,  255, 97,
    113, 60,  255, 137, 157, 71,  255, 200, 213, 118, 255, 186, 205, 108, 255, 93,  127, 44,  255, 89,  114, 36,  255, 145, 157, 83,  255, 190, 202,
    123, 255, 185, 205, 127, 255, 175, 201, 128, 255, 168, 195, 127, 255, 172, 198, 116, 255, 186, 212, 120, 255, 181, 203, 103, 255, 212, 225, 104,
    255, 216, 227, 93,  255, 233, 236, 146, 255, 234, 241, 167, 255, 221, 233, 150, 255, 117, 123, 79,  255, 62,  68,  42,  255, 50,  68,  25,  255,
    71,  96,  36,  255, 74,  100, 44,  255, 50,  60,  36,  255, 43,  51,  28,  255, 58,  79,  36,  255, 65,  94,  40,  255, 62,  90,  40,  255, 52,
    73,  31,  255, 101, 126, 60,  255, 99,  133, 73,  255, 81,  112, 72,  255, 80,  110, 75,  255, 75,  109, 72,  255, 77,  112, 62,  255, 83,  116,
    56,  255, 55,  79,  39,  255, 49,  60,  36,  255, 106, 120, 43,  255, 149, 174, 55,  255, 122, 147, 46,  255, 154, 171, 79,  255, 190, 212, 135,
    255, 177, 209, 142, 255, 149, 186, 135, 255, 142, 178, 136, 255, 141, 177, 128, 255, 167, 183, 108, 255, 164, 177, 94,  255, 104, 132, 47,  255,
    72,  111, 48,  255, 104, 139, 81,  255, 152, 179, 103, 255, 147, 177, 99,  255, 113, 139, 72,  255, 60,  74,  36,  255, 120, 149, 107, 255, 132,
    164, 124, 255, 117, 150, 111, 255, 148, 172, 101, 255, 126, 146, 58,  255, 106, 133, 36,  255, 117, 143, 43,  255, 117, 145, 47,  255, 119, 143,
    52,  255, 174, 187, 87,  255, 174, 194, 83,  255, 153, 176, 76,  255, 163, 182, 87,  255, 179, 195, 99,  255, 178, 191, 105, 255, 166, 178, 94,
    255, 146, 173, 107, 255, 110, 147, 102, 255, 132, 158, 107, 255, 195, 207, 128, 255, 200, 219, 129, 255, 203, 221, 127, 255, 213, 220, 126, 255,
    134, 155, 75,  255, 55,  77,  36,  255, 58,  71,  36,  255, 130, 159, 73,  255, 81,  113, 68,  255, 78,  110, 75,  255, 81,  115, 75,  255, 77,
    112, 72,  255, 105, 137, 80,  255, 134, 161, 75,  255, 102, 124, 50,  255, 97,  123, 55,  255, 72,  97,  55,  255, 65,  86,  55,  255, 113, 135,
    68,  255, 142, 158, 90,  255, 120, 149, 87,  255, 142, 178, 114, 255, 164, 191, 113, 255, 170, 187, 104, 255, 132, 155, 86,  255, 137, 167, 87,
    255, 138, 169, 87,  255, 139, 171, 89,  255, 120, 148, 94,  255, 89,  124, 94,  255, 125, 159, 101, 255, 104, 129, 63,  255, 115, 129, 45,  255,
    145, 165, 58,  255, 140, 166, 55,  255, 151, 172, 67,  255, 123, 152, 71,  255, 141, 164, 67,  255, 179, 188, 68,  255, 145, 167, 89,  255, 166,
    188, 118, 255, 142, 163, 94,  255, 169, 191, 104, 255, 183, 202, 105, 255, 174, 193, 94,  255, 164, 184, 84,  255, 144, 169, 75,  255, 117, 153,
    60,  255, 114, 151, 60,  255, 111, 150, 58,  255, 119, 158, 65,  255, 144, 175, 78,  255, 163, 188, 84,  255, 154, 176, 68,  255, 157, 177, 73,
    255, 159, 181, 90,  255, 155, 174, 80,  255, 148, 170, 92,  255, 143, 169, 92,  255, 165, 183, 87,  255, 166, 180, 82,  255, 175, 189, 95,  255,
    182, 194, 106, 255, 157, 182, 105, 255, 152, 181, 102, 255, 157, 184, 111, 255, 158, 184, 119, 255, 124, 147, 69,  255, 71,  89,  34,  255, 100,
    117, 49,  255, 151, 173, 77,  255, 135, 159, 75,  255, 160, 180, 94,  255, 179, 194, 103, 255, 154, 174, 97,  255, 170, 188, 105, 255, 154, 157,
    75,  255, 40,  65,  19,  255, 40,  75,  21,  255, 53,  95,  29,  255, 79,  120, 39,  255, 112, 147, 49,  255, 105, 129, 49,  255, 56,  76,  41,
    255, 40,  53,  37,  255, 33,  41,  33,  255, 47,  74,  36,  255, 48,  75,  33,  255, 29,  42,  26,  255, 33,  47,  26,  255, 32,  47,  26,  255,
    55,  69,  36,  255, 161, 174, 97,  255, 175, 199, 124, 255, 158, 187, 112, 255, 149, 177, 93,  255, 135, 165, 84,  255, 113, 147, 75,  255, 105,
    143, 72,  255, 100, 137, 55,  255, 124, 161, 60,  255, 131, 141, 58,  255, 81,  86,  36,  255, 114, 136, 69,  255, 126, 154, 106, 255, 104, 137,
    105, 255, 101, 133, 100, 255, 109, 140, 100, 255, 103, 136, 104, 255, 102, 132, 101, 255, 107, 137, 87,  255, 94,  132, 87,  255, 110, 150, 87,
    255, 157, 184, 77,  255, 207, 217, 119, 255, 177, 195, 100, 255, 149, 178, 95,  255, 144, 177, 107, 255, 132, 164, 74,  255, 132, 163, 94,  255,
    125, 160, 96,  255, 136, 170, 104, 255, 131, 164, 94,  255, 138, 162, 92,  255, 160, 180, 97,  255, 174, 187, 102, 255, 187, 197, 108, 255, 200,
    204, 111, 255, 210, 214, 121, 255, 202, 217, 124, 255, 189, 209, 125, 255, 195, 212, 126, 255, 182, 207, 127, 255, 186, 206, 120, 255, 177, 196,
    107, 255, 157, 178, 97,  255, 153, 177, 90,  255, 155, 175, 73,  255, 183, 200, 121, 255, 182, 205, 132, 255, 181, 204, 122, 255, 190, 211, 128,
    255, 202, 218, 134, 255, 201, 219, 143, 255, 176, 195, 129, 255, 131, 161, 82,  255, 83,  113, 53,  255, 68,  92,  47,  255, 21,  29,  21,  255,
    60,  69,  26,  255, 105, 137, 55,  255, 120, 147, 73,  255, 138, 169, 92,  255, 128, 161, 89,  255, 121, 155, 86,  255, 125, 156, 90,  255, 134,
    165, 94,  255, 141, 172, 100, 255, 162, 188, 107, 255, 116, 138, 68,  255, 148, 164, 98,  255, 122, 156, 83,  255, 120, 155, 65,  255, 83,  113,
    62,  255, 40,  58,  36,  255, 43,  60,  32,  255, 60,  71,  31,  255, 72,  74,  40,  255, 62,  68,  38,  255, 86,  103, 60,  255, 78,  104, 50,
    255, 127, 136, 84,  255, 177, 189, 117, 255, 170, 186, 130, 255, 23,  31,  19,  255, 33,  33,  12,  255, 169, 177, 87,  255, 198, 217, 114, 255,
    181, 201, 99,  255, 131, 140, 74,  255, 173, 183, 103, 255, 208, 221, 124, 255, 203, 217, 122, 255, 154, 175, 101, 255, 115, 146, 75,  255, 87,
    122, 50,  255, 39,  58,  17,  255, 132, 136, 75,  255, 201, 206, 126, 255, 214, 224, 142, 255, 200, 212, 123, 255, 177, 194, 111, 255, 169, 186,
    100, 255, 190, 209, 97,  255, 202, 221, 104, 255, 196, 215, 82,  255, 246, 246, 167, 255, 239, 243, 181, 255, 236, 243, 163, 255, 192, 199, 134,
    255, 89,  87,  68,  255, 71,  90,  47,  255, 60,  81,  33,  255, 56,  73,  29,  255, 45,  58,  26,  255, 26,  34,  21,  255, 45,  55,  26,  255,
    63,  87,  33,  255, 38,  52,  23,  255, 60,  72,  32,  255, 107, 141, 78,  255, 86,  121, 81,  255, 85,  120, 83,  255, 82,  115, 79,  255, 91,
    124, 74,  255, 122, 152, 69,  255, 62,  75,  36,  255, 19,  23,  21,  255, 33,  38,  25,  255, 138, 151, 73,  255, 148, 168, 65,  255, 136, 159,
    56,  255, 134, 158, 58,  255, 110, 130, 52,  255, 106, 124, 56,  255, 147, 172, 85,  255, 151, 187, 106, 255, 134, 175, 101, 255, 122, 163, 87,
    255, 99,  138, 62,  255, 96,  138, 75,  255, 109, 148, 96,  255, 111, 149, 102, 255, 123, 159, 104, 255, 145, 174, 104, 255, 97,  128, 53,  255,
    67,  90,  36,  255, 118, 145, 103, 255, 125, 161, 122, 255, 151, 176, 112, 255, 134, 159, 68,  255, 63,  96,  26,  255, 55,  84,  26,  255, 65,
    90,  40,  255, 65,  92,  48,  255, 68,  99,  47,  255, 68,  89,  36,  255, 80,  98,  31,  255, 131, 156, 55,  255, 146, 171, 60,  255, 151, 173,
    67,  255, 156, 176, 76,  255, 171, 186, 90,  255, 164, 184, 110, 255, 129, 161, 113, 255, 130, 163, 120, 255, 132, 162, 117, 255, 185, 201, 146,
    255, 187, 200, 135, 255, 135, 158, 98,  255, 160, 182, 124, 255, 78,  97,  47,  255, 68,  87,  34,  255, 128, 158, 81,  255, 81,  114, 74,  255,
    83,  114, 79,  255, 76,  111, 73,  255, 102, 132, 79,  255, 102, 130, 83,  255, 135, 162, 82,  255, 97,  118, 53,  255, 75,  102, 44,  255, 69,
    100, 44,  255, 49,  71,  40,  255, 132, 157, 115, 255, 123, 148, 97,  255, 129, 158, 84,  255, 158, 181, 101, 255, 132, 156, 90,  255, 110, 137,
    81,  255, 138, 166, 83,  255, 135, 164, 84,  255, 109, 139, 86,  255, 123, 154, 93,  255, 101, 132, 94,  255, 93,  128, 95,  255, 126, 158, 104,
    255, 89,  109, 62,  255, 36,  56,  31,  255, 108, 122, 47,  255, 168, 175, 62,  255, 195, 199, 71,  255, 186, 193, 83,  255, 141, 163, 80,  255,
    172, 183, 89,  255, 138, 158, 89,  255, 185, 200, 123, 255, 154, 170, 84,  255, 199, 217, 110, 255, 191, 211, 108, 255, 181, 204, 101, 255, 184,
    204, 102, 255, 193, 207, 104, 255, 189, 203, 105, 255, 191, 203, 109, 255, 183, 197, 102, 255, 173, 192, 94,  255, 163, 181, 89,  255, 193, 209,
    84,  255, 182, 203, 65,  255, 183, 205, 75,  255, 171, 191, 87,  255, 105, 138, 62,  255, 103, 137, 74,  255, 129, 161, 82,  255, 113, 138, 55,
    255, 47,  69,  23,  255, 75,  94,  39,  255, 109, 123, 60,  255, 121, 135, 60,  255, 122, 140, 55,  255, 126, 145, 55,  255, 139, 159, 60,  255,
    122, 148, 63,  255, 80,  104, 38,  255, 90,  118, 42,  255, 142, 174, 65,  255, 155, 182, 96,  255, 171, 191, 124, 255, 145, 177, 99,  255, 160,
    186, 93,  255, 186, 191, 82,  255, 82,  102, 45,  255, 92,  116, 68,  255, 137, 155, 111, 255, 91,  117, 62,  255, 60,  101, 36,  255, 89,  127,
    52,  255, 138, 165, 65,  255, 112, 132, 62,  255, 68,  87,  55,  255, 34,  38,  31,  255, 56,  77,  38,  255, 75,  101, 48,  255, 65,  84,  49,
    255, 36,  53,  31,  255, 37,  52,  33,  255, 21,  31,  23,  255, 28,  39,  23,  255, 111, 121, 67,  255, 191, 199, 103, 255, 217, 221, 109, 255,
    202, 209, 95,  255, 156, 178, 77,  255, 136, 167, 71,  255, 122, 152, 58,  255, 99,  128, 45,  255, 99,  100, 39,  255, 76,  103, 38,  255, 93,
    130, 76,  255, 115, 151, 108, 255, 127, 159, 116, 255, 114, 147, 100, 255, 101, 136, 81,  255, 97,  136, 75,  255, 102, 139, 72,  255, 136, 166,
    77,  255, 116, 150, 69,  255, 120, 152, 68,  255, 165, 184, 96,  255, 162, 183, 100, 255, 146, 166, 97,  255, 136, 161, 98,  255, 155, 182, 97,
    255, 137, 169, 62,  255, 134, 160, 91,  255, 117, 141, 76,  255, 130, 158, 95,  255, 109, 140, 68,  255, 113, 139, 69,  255, 145, 168, 79,  255,
    163, 179, 92,  255, 165, 179, 91,  255, 161, 179, 84,  255, 111, 125, 52,  255, 134, 136, 58,  255, 155, 165, 74,  255, 178, 187, 92,  255, 166,
    181, 99,  255, 143, 162, 77,  255, 126, 149, 65,  255, 123, 150, 65,  255, 140, 167, 76,  255, 168, 192, 92,  255, 147, 168, 82,  255, 176, 189,
    102, 255, 187, 200, 107, 255, 183, 199, 99,  255, 162, 182, 94,  255, 121, 153, 80,  255, 100, 138, 71,  255, 101, 140, 74,  255, 102, 142, 73,
    255, 98,  142, 67,  255, 58,  87,  37,  255, 68,  86,  31,  255, 109, 138, 65,  255, 118, 153, 82,  255, 115, 151, 80,  255, 114, 149, 83,  255,
    120, 156, 89,  255, 126, 161, 96,  255, 131, 165, 101, 255, 131, 165, 99,  255, 144, 175, 105, 255, 165, 191, 113, 255, 209, 221, 150, 255, 196,
    214, 149, 255, 135, 162, 84,  255, 106, 134, 69,  255, 63,  89,  42,  255, 49,  68,  32,  255, 50,  52,  25,  255, 87,  108, 45,  255, 84,  121,
    43,  255, 154, 170, 115, 255, 175, 193, 115, 255, 196, 219, 129, 255, 199, 222, 155, 255, 147, 155, 125, 255, 19,  29,  21,  255, 17,  23,  15,
    255, 111, 120, 50,  255, 198, 215, 113, 255, 186, 205, 109, 255, 171, 178, 104, 255, 208, 220, 125, 255, 174, 193, 96,  255, 99,  113, 52,  255,
    117, 135, 77,  255, 131, 152, 84,  255, 124, 147, 73,  255, 94,  110, 48,  255, 201, 202, 119, 255, 246, 250, 164, 255, 235, 241, 142, 255, 218,
    231, 131, 255, 209, 223, 121, 255, 206, 215, 136, 255, 201, 212, 133, 255, 175, 198, 87,  255, 190, 208, 80,  255, 241, 239, 149, 255, 246, 246,
    180, 255, 234, 239, 166, 255, 238, 243, 159, 255, 121, 125, 80,  255, 86,  98,  60,  255, 82,  99,  52,  255, 115, 126, 78,  255, 134, 151, 83,
    255, 55,  65,  43,  255, 29,  43,  26,  255, 44,  71,  36,  255, 40,  60,  36,  255, 78,  100, 55,  255, 97,  131, 90,  255, 94,  129, 87,  255,
    109, 142, 91,  255, 120, 151, 92,  255, 128, 155, 79,  255, 63,  79,  39,  255, 19,  23,  17,  255, 39,  55,  31,  255, 42,  62,  32,  255, 75,
    91,  43,  255, 94,  125, 58,  255, 116, 145, 77,  255, 66,  96,  38,  255, 32,  55,  21,  255, 21,  28,  19,  255, 53,  63,  29,  255, 123, 142,
    63,  255, 135, 161, 73,  255, 139, 174, 74,  255, 140, 179, 81,  255, 117, 160, 75,  255, 112, 154, 80,  255, 111, 152, 89,  255, 109, 148, 95,
    255, 118, 155, 104, 255, 94,  123, 68,  255, 56,  71,  32,  255, 112, 139, 94,  255, 144, 173, 115, 255, 147, 171, 80,  255, 125, 159, 55,  255,
    98,  134, 48,  255, 74,  105, 39,  255, 80,  115, 50,  255, 106, 139, 53,  255, 71,  107, 40,  255, 52,  87,  38,  255, 41,  65,  31,  255, 56,
    75,  29,  255, 101, 128, 47,  255, 122, 149, 58,  255, 125, 151, 60,  255, 130, 152, 65,  255, 154, 170, 84,  255, 164, 188, 118, 255, 143, 175,
    125, 255, 139, 174, 131, 255, 137, 170, 128, 255, 138, 168, 133, 255, 121, 149, 97,  255, 141, 170, 121, 255, 137, 159, 101, 255, 75,  102, 38,
    255, 137, 163, 87,  255, 89,  122, 82,  255, 84,  116, 76,  255, 103, 134, 77,  255, 120, 150, 83,  255, 88,  116, 81,  255, 133, 160, 84,  255,
    149, 171, 90,  255, 90,  108, 53,  255, 78,  110, 41,  255, 65,  98,  40,  255, 112, 137, 92,  255, 107, 136, 75,  255, 89,  113, 58,  255, 84,
    115, 73,  255, 82,  116, 75,  255, 128, 158, 81,  255, 142, 170, 86,  255, 106, 138, 81,  255, 97,  129, 89,  255, 106, 137, 95,  255, 96,  130,
    98,  255, 99,  133, 97,  255, 130, 160, 99,  255, 75,  101, 42,  255, 49,  81,  31,  255, 47,  68,  37,  255, 49,  65,  29,  255, 83,  100, 33,
    255, 180, 185, 90,  255, 217, 212, 116, 255, 162, 171, 95,  255, 91,  125, 74,  255, 92,  120, 73,  255, 112, 138, 72,  255, 165, 189, 89,  255,
    174, 197, 77,  255, 194, 212, 103, 255, 199, 211, 123, 255, 183, 197, 130, 255, 162, 183, 123, 255, 180, 196, 122, 255, 164, 184, 126, 255, 143,
    169, 123, 255, 159, 181, 114, 255, 225, 230, 107, 255, 211, 221, 82,  255, 218, 224, 97,  255, 214, 223, 107, 255, 128, 159, 68,  255, 105, 145,
    62,  255, 126, 161, 73,  255, 125, 149, 62,  255, 111, 133, 55,  255, 116, 148, 68,  255, 135, 164, 92,  255, 124, 149, 76,  255, 55,  84,  31,
    255, 46,  75,  26,  255, 72,  101, 37,  255, 60,  91,  37,  255, 79,  113, 41,  255, 154, 177, 69,  255, 146, 174, 72,  255, 174, 195, 121, 255,
    204, 217, 166, 255, 154, 179, 100, 255, 167, 190, 113, 255, 190, 202, 136, 255, 189, 202, 151, 255, 202, 220, 172, 255, 219, 233, 175, 255, 124,
    139, 68,  255, 60,  101, 39,  255, 77,  119, 58,  255, 125, 158, 75,  255, 146, 162, 76,  255, 75,  101, 52,  255, 63,  86,  37,  255, 86,  113,
    55,  255, 84,  118, 62,  255, 68,  86,  50,  255, 37,  55,  32,  255, 52,  75,  39,  255, 41,  56,  34,  255, 29,  46,  29,  255, 19,  31,  21,
    255, 42,  63,  21,  255, 158, 178, 96,  255, 199, 208, 126, 255, 162, 179, 128, 255, 151, 171, 100, 255, 138, 162, 55,  255, 98,  121, 43,  255,
    79,  102, 38,  255, 87,  121, 52,  255, 116, 156, 95,  255, 146, 176, 107, 255, 157, 181, 107, 255, 133, 160, 98,  255, 146, 171, 103, 255, 126,
    151, 77,  255, 98,  128, 60,  255, 122, 152, 87,  255, 131, 153, 103, 255, 138, 157, 85,  255, 168, 186, 101, 255, 145, 170, 118, 255, 131, 146,
    85,  255, 128, 145, 74,  255, 168, 188, 77,  255, 137, 161, 89,  255, 113, 139, 103, 255, 125, 151, 123, 255, 129, 156, 122, 255, 147, 167, 115,
    255, 128, 152, 89,  255, 121, 140, 58,  255, 162, 178, 89,  255, 163, 178, 86,  255, 164, 183, 86,  255, 71,  89,  44,  255, 26,  33,  17,  255,
    55,  78,  26,  255, 105, 120, 45,  255, 189, 197, 109, 255, 177, 196, 110, 255, 152, 180, 97,  255, 138, 168, 84,  255, 126, 158, 72,  255, 141,
    169, 82,  255, 128, 152, 72,  255, 116, 145, 74,  255, 108, 137, 65,  255, 133, 160, 77,  255, 119, 155, 74,  255, 115, 152, 80,  255, 112, 150,
    83,  255, 118, 153, 84,  255, 131, 165, 87,  255, 123, 158, 79,  255, 93,  128, 45,  255, 74,  105, 33,  255, 80,  107, 36,  255, 108, 135, 53,
    255, 150, 176, 90,  255, 157, 185, 110, 255, 124, 158, 86,  255, 133, 164, 90,  255, 134, 168, 91,  255, 121, 150, 69,  255, 132, 153, 68,  255,
    149, 177, 83,  255, 175, 195, 117, 255, 200, 223, 165, 255, 210, 224, 154, 255, 161, 180, 110, 255, 99,  124, 60,  255, 84,  99,  50,  255, 67,
    73,  34,  255, 90,  123, 40,  255, 118, 145, 58,  255, 205, 218, 148, 255, 180, 211, 143, 255, 164, 195, 129, 255, 214, 229, 171, 255, 87,  98,
    69,  255, 15,  21,  19,  255, 48,  57,  26,  255, 129, 156, 72,  255, 151, 172, 75,  255, 181, 200, 99,  255, 170, 179, 107, 255, 136, 152, 74,
    255, 55,  73,  29,  255, 39,  52,  12,  255, 135, 136, 74,  255, 207, 218, 153, 255, 226, 238, 181, 255, 213, 231, 175, 255, 199, 216, 151, 255,
    201, 216, 136, 255, 225, 231, 139, 255, 228, 236, 132, 255, 243, 246, 143, 255, 235, 243, 134, 255, 232, 243, 140, 255, 192, 208, 122, 255, 173,
    187, 84,  255, 197, 201, 110, 255, 236, 241, 149, 255, 227, 231, 135, 255, 248, 248, 169, 255, 215, 225, 145, 255, 155, 171, 98,  255, 217, 220,
    142, 255, 233, 243, 166, 255, 182, 199, 136, 255, 50,  69,  42,  255, 28,  52,  23,  255, 36,  62,  28,  255, 38,  67,  39,  255, 78,  106, 55,
    255, 117, 144, 83,  255, 121, 147, 83,  255, 127, 152, 80,  255, 102, 128, 63,  255, 50,  77,  26,  255, 42,  63,  29,  255, 63,  89,  47,  255,
    69,  100, 58,  255, 57,  87,  46,  255, 62,  82,  40,  255, 114, 137, 74,  255, 93,  105, 68,  255, 72,  84,  58,  255, 47,  63,  31,  255, 58,
    86,  33,  255, 68,  94,  39,  255, 53,  80,  31,  255, 47,  67,  31,  255, 73,  89,  37,  255, 103, 118, 52,  255, 119, 146, 55,  255, 134, 168,
    65,  255, 131, 170, 67,  255, 124, 165, 72,  255, 119, 160, 82,  255, 113, 148, 91,  255, 56,  72,  38,  255, 108, 132, 68,  255, 132, 160, 73,
    255, 124, 154, 55,  255, 122, 154, 49,  255, 102, 135, 47,  255, 65,  94,  34,  255, 55,  87,  33,  255, 93,  124, 43,  255, 94,  133, 41,  255,
    51,  87,  29,  255, 60,  101, 33,  255, 63,  97,  31,  255, 76,  107, 39,  255, 77,  109, 52,  255, 77,  108, 60,  255, 76,  105, 62,  255, 91,
    116, 55,  255, 164, 179, 81,  255, 175, 195, 113, 255, 149, 179, 128, 255, 146, 179, 137, 255, 141, 175, 132, 255, 140, 172, 131, 255, 120, 150,
    98,  255, 159, 184, 129, 255, 102, 126, 56,  255, 122, 150, 86,  255, 100, 133, 90,  255, 120, 154, 80,  255, 149, 173, 84,  255, 107, 138, 84,
    255, 89,  120, 87,  255, 110, 140, 87,  255, 108, 136, 84,  255, 134, 155, 84,  255, 74,  97,  39,  255, 67,  96,  36,  255, 95,  124, 56,  255,
    101, 135, 60,  255, 103, 128, 62,  255, 86,  119, 71,  255, 107, 142, 77,  255, 143, 173, 89,  255, 132, 160, 86,  255, 99,  131, 83,  255, 109,
    140, 96,  255, 109, 141, 94,  255, 111, 142, 99,  255, 114, 146, 97,  255, 147, 168, 94,  255, 53,  77,  41,  255, 55,  83,  40,  255, 49,  75,
    33,  255, 41,  62,  26,  255, 116, 126, 68,  255, 184, 193, 119, 255, 200, 204, 116, 255, 142, 154, 90,  255, 84,  118, 65,  255, 97,  125, 62,
    255, 108, 139, 74,  255, 91,  119, 55,  255, 151, 165, 85,  255, 179, 197, 135, 255, 145, 172, 129, 255, 133, 165, 130, 255, 136, 168, 132, 255,
    143, 173, 135, 255, 137, 169, 139, 255, 131, 165, 136, 255, 131, 163, 130, 255, 208, 214, 134, 255, 243, 241, 136, 255, 241, 238, 126, 255, 192,
    199, 95,  255, 153, 178, 72,  255, 118, 156, 69,  255, 114, 152, 73,  255, 136, 172, 90,  255, 161, 187, 93,  255, 132, 158, 72,  255, 83,  118,
    63,  255, 133, 161, 82,  255, 125, 147, 62,  255, 41,  63,  26,  255, 44,  73,  26,  255, 75,  109, 40,  255, 58,  92,  37,  255, 96,  127, 49,
    255, 110, 135, 60,  255, 171, 188, 109, 255, 202, 219, 148, 255, 212, 219, 147, 255, 225, 230, 162, 255, 207, 221, 169, 255, 190, 216, 173, 255,
    189, 218, 169, 255, 195, 207, 134, 255, 89,  120, 44,  255, 82,  122, 58,  255, 95,  132, 73,  255, 97,  136, 74,  255, 134, 159, 77,  255, 73,
    99,  38,  255, 71,  110, 45,  255, 87,  119, 67,  255, 85,  110, 62,  255, 43,  55,  36,  255, 44,  65,  39,  255, 45,  65,  36,  255, 34,  49,
    26,  255, 37,  55,  31,  255, 25,  31,  23,  255, 15,  26,  15,  255, 80,  107, 55,  255, 186, 200, 128, 255, 152, 172, 137, 255, 127, 155, 103,
    255, 104, 136, 47,  255, 68,  92,  33,  255, 55,  72,  36,  255, 52,  71,  29,  255, 101, 132, 60,  255, 153, 179, 110, 255, 147, 178, 111, 255,
    158, 179, 97,  255, 95,  116, 68,  255, 115, 138, 84,  255, 122, 146, 71,  255, 127, 161, 80,  255, 123, 147, 76,  255, 170, 188, 94,  255, 174,
    196, 133, 255, 144, 175, 143, 255, 163, 181, 126, 255, 140, 155, 81,  255, 129, 156, 74,  255, 108, 140, 80,  255, 125, 151, 107, 255, 124, 152,
    105, 255, 82,  116, 45,  255, 131, 155, 100, 255, 141, 156, 94,  255, 74,  86,  33,  255, 136, 149, 68,  255, 166, 182, 87,  255, 148, 171, 78,
    255, 41,  55,  23,  255, 69,  86,  31,  255, 84,  118, 46,  255, 101, 118, 43,  255, 202, 201, 109, 255, 182, 193, 113, 255, 195, 204, 114, 255,
    173, 192, 102, 255, 155, 179, 90,  255, 141, 167, 80,  255, 115, 138, 60,  255, 120, 147, 65,  255, 105, 140, 65,  255, 85,  114, 48,  255, 90,
    103, 38,  255, 126, 150, 62,  255, 134, 162, 69,  255, 145, 170, 82,  255, 134, 163, 74,  255, 103, 138, 47,  255, 98,  134, 47,  255, 91,  125,
    45,  255, 81,  115, 38,  255, 82,  119, 36,  255, 105, 135, 47,  255, 138, 159, 73,  255, 108, 138, 65,  255, 102, 131, 60,  255, 92,  126, 55,
    255, 82,  115, 55,  255, 105, 134, 60,  255, 108, 142, 58,  255, 156, 170, 84,  255, 196, 222, 168, 255, 188, 214, 167, 255, 223, 234, 169, 255,
    179, 196, 126, 255, 99,  126, 69,  255, 83,  106, 43,  255, 114, 138, 49,  255, 174, 195, 96,  255, 179, 205, 93,  255, 180, 208, 120, 255, 202,
    224, 177, 255, 191, 205, 136, 255, 65,  82,  48,  255, 12,  15,  12,  255, 90,  98,  44,  255, 163, 189, 97,  255, 130, 158, 72,  255, 168, 178,
    100, 255, 170, 181, 117, 255, 76,  103, 37,  255, 68,  97,  23,  255, 153, 162, 72,  255, 238, 234, 138, 255, 218, 227, 140, 255, 199, 218, 147,
    255, 221, 235, 178, 255, 216, 238, 188, 255, 198, 225, 172, 255, 196, 215, 150, 255, 211, 222, 144, 255, 212, 221, 133, 255, 209, 217, 119, 255,
    215, 225, 131, 255, 215, 229, 151, 255, 176, 192, 107, 255, 198, 206, 100, 255, 231, 236, 132, 255, 241, 243, 169, 255, 245, 246, 182, 255, 235,
    239, 157, 255, 228, 234, 142, 255, 241, 246, 154, 255, 197, 209, 135, 255, 112, 129, 89,  255, 95,  114, 74,  255, 112, 126, 69,  255, 105, 121,
    69,  255, 108, 125, 85,  255, 115, 130, 89,  255, 68,  82,  42,  255, 77,  84,  47,  255, 83,  99,  58,  255, 42,  68,  19,  255, 105, 128, 60,
    255, 141, 168, 89,  255, 139, 170, 92,  255, 129, 162, 86,  255, 109, 144, 74,  255, 91,  123, 50,  255, 91,  110, 60,  255, 49,  57,  41,  255,
    44,  49,  36,  255, 73,  95,  39,  255, 92,  130, 47,  255, 93,  130, 52,  255, 83,  122, 44,  255, 84,  116, 62,  255, 65,  90,  50,  255, 15,
    26,  17,  255, 33,  47,  21,  255, 58,  72,  31,  255, 80,  97,  33,  255, 112, 137, 50,  255, 105, 129, 52,  255, 112, 137, 62,  255, 87,  108,
    55,  255, 110, 128, 69,  255, 125, 151, 65,  255, 131, 157, 60,  255, 135, 160, 58,  255, 85,  114, 42,  255, 53,  81,  36,  255, 44,  68,  33,
    255, 73,  98,  40,  255, 110, 148, 47,  255, 65,  103, 31,  255, 49,  80,  28,  255, 72,  95,  42,  255, 115, 143, 67,  255, 118, 141, 58,  255,
    124, 145, 62,  255, 120, 138, 58,  255, 108, 124, 49,  255, 89,  101, 36,  255, 153, 170, 87,  255, 184, 203, 129, 255, 173, 195, 136, 255, 162,
    190, 139, 255, 153, 184, 138, 255, 133, 162, 116, 255, 142, 164, 105, 255, 138, 159, 93,  255, 101, 132, 80,  255, 126, 159, 86,  255, 109, 133,
    58,  255, 144, 164, 87,  255, 109, 138, 94,  255, 92,  123, 91,  255, 104, 133, 93,  255, 106, 136, 90,  255, 149, 171, 95,  255, 132, 148, 74,
    255, 112, 143, 62,  255, 108, 146, 63,  255, 121, 164, 74,  255, 152, 185, 87,  255, 152, 175, 84,  255, 108, 132, 60,  255, 146, 175, 91,  255,
    133, 162, 91,  255, 109, 139, 95,  255, 108, 139, 100, 255, 108, 139, 97,  255, 104, 136, 97,  255, 140, 167, 107, 255, 124, 144, 81,  255, 62,
    87,  49,  255, 62,  90,  48,  255, 63,  91,  43,  255, 142, 155, 83,  255, 183, 193, 129, 255, 132, 158, 118, 255, 141, 164, 112, 255, 186, 193,
    113, 255, 134, 152, 75,  255, 91,  118, 55,  255, 71,  97,  48,  255, 132, 149, 94,  255, 167, 190, 136, 255, 139, 171, 139, 255, 141, 173, 141,
    255, 145, 176, 145, 255, 146, 177, 147, 255, 146, 179, 147, 255, 141, 173, 138, 255, 137, 168, 127, 255, 129, 161, 113, 255, 144, 167, 97,  255,
    217, 222, 128, 255, 179, 194, 87,  255, 142, 170, 56,  255, 134, 159, 58,  255, 145, 171, 78,  255, 130, 167, 78,  255, 129, 166, 79,  255, 170,
    195, 92,  255, 153, 172, 75,  255, 74,  108, 52,  255, 83,  119, 63,  255, 122, 151, 63,  255, 71,  94,  39,  255, 58,  89,  33,  255, 80,  115,
    38,  255, 69,  102, 43,  255, 67,  98,  40,  255, 67,  100, 37,  255, 102, 125, 52,  255, 173, 197, 102, 255, 182, 208, 112, 255, 194, 213, 134,
    255, 188, 212, 163, 255, 186, 213, 170, 255, 203, 225, 167, 255, 178, 185, 98,  255, 102, 136, 47,  255, 103, 141, 58,  255, 101, 142, 63,  255,
    108, 148, 73,  255, 169, 188, 97,  255, 91,  113, 47,  255, 55,  84,  32,  255, 63,  86,  42,  255, 43,  58,  36,  255, 40,  60,  37,  255, 49,
    69,  38,  255, 26,  31,  25,  255, 19,  23,  21,  255, 19,  23,  21,  255, 17,  23,  19,  255, 17,  23,  21,  255, 23,  33,  23,  255, 144, 164,
    109, 255, 144, 168, 127, 255, 117, 144, 103, 255, 92,  117, 48,  255, 55,  72,  29,  255, 38,  53,  26,  255, 34,  55,  21,  255, 78,  103, 48,
    255, 152, 179, 118, 255, 141, 175, 122, 255, 162, 187, 112, 255, 163, 182, 95,  255, 185, 202, 134, 255, 193, 205, 137, 255, 138, 161, 81,  255,
    150, 173, 82,  255, 178, 200, 129, 255, 153, 183, 137, 255, 155, 183, 127, 255, 150, 173, 127, 255, 181, 191, 102, 255, 139, 164, 65,  255, 113,
    134, 80,  255, 110, 140, 81,  255, 98,  126, 47,  255, 83,  113, 36,  255, 129, 156, 55,  255, 78,  90,  34,  255, 84,  93,  42,  255, 82,  98,
    37,  255, 161, 180, 81,  255, 103, 129, 55,  255, 56,  76,  25,  255, 91,  121, 50,  255, 69,  100, 47,  255, 112, 124, 47,  255, 203, 205, 114,
    255, 136, 162, 109, 255, 145, 162, 103, 255, 143, 166, 101, 255, 123, 144, 92,  255, 139, 161, 91,  255, 98,  130, 56,  255, 58,  77,  37,  255,
    97,  105, 49,  255, 124, 144, 55,  255, 81,  112, 43,  255, 60,  87,  29,  255, 95,  125, 39,  255, 92,  127, 47,  255, 89,  126, 47,  255, 111,
    144, 62,  255, 102, 138, 52,  255, 93,  128, 43,  255, 98,  131, 47,  255, 109, 140, 60,  255, 114, 145, 62,  255, 131, 158, 68,  255, 150, 173,
    80,  255, 131, 157, 72,  255, 98,  130, 52,  255, 73,  111, 50,  255, 74,  106, 43,  255, 58,  82,  34,  255, 84,  73,  36,  255, 210, 223, 167,
    255, 177, 212, 168, 255, 184, 210, 167, 255, 219, 232, 173, 255, 191, 209, 149, 255, 77,  108, 52,  255, 141, 149, 58,  255, 175, 207, 89,  255,
    153, 188, 75,  255, 195, 220, 149, 255, 179, 196, 135, 255, 101, 118, 62,  255, 58,  83,  49,  255, 25,  36,  21,  255, 105, 116, 53,  255, 178,
    200, 106, 255, 163, 185, 95,  255, 165, 173, 101, 255, 168, 182, 101, 255, 154, 181, 71,  255, 168, 186, 62,  255, 220, 220, 117, 255, 224, 222,
    126, 255, 212, 216, 107, 255, 153, 179, 74,  255, 157, 178, 85,  255, 199, 206, 129, 255, 216, 221, 148, 255, 209, 218, 148, 255, 170, 187, 107,
    255, 173, 194, 96,  255, 175, 197, 106, 255, 185, 201, 110, 255, 189, 204, 104, 255, 158, 181, 77,  255, 152, 170, 68,  255, 212, 213, 120, 255,
    243, 245, 166, 255, 232, 236, 151, 255, 212, 223, 124, 255, 216, 226, 126, 255, 226, 231, 151, 255, 117, 129, 73,  255, 174, 183, 110, 255, 203,
    218, 145, 255, 210, 222, 150, 255, 199, 219, 157, 255, 201, 222, 162, 255, 208, 217, 156, 255, 75,  75,  46,  255, 166, 163, 117, 255, 183, 181,
    137, 255, 110, 127, 65,  255, 161, 191, 112, 255, 145, 181, 103, 255, 135, 172, 92,  255, 134, 171, 83,  255, 132, 166, 74,  255, 116, 152, 58,
    255, 86,  116, 55,  255, 34,  47,  31,  255, 23,  32,  17,  255, 99,  119, 47,  255, 133, 163, 73,  255, 118, 152, 65,  255, 67,  100, 36,  255,
    63,  95,  48,  255, 84,  114, 53,  255, 33,  48,  25,  255, 33,  47,  28,  255, 34,  52,  28,  255, 23,  37,  23,  255, 38,  49,  31,  255, 78,
    97,  52,  255, 121, 140, 60,  255, 124, 137, 79,  255, 103, 122, 56,  255, 124, 150, 55,  255, 142, 163, 65,  255, 117, 142, 55,  255, 67,  92,
    44,  255, 52,  77,  42,  255, 49,  75,  39,  255, 60,  90,  37,  255, 98,  129, 47,  255, 100, 134, 48,  255, 107, 128, 65,  255, 121, 153, 75,
    255, 124, 156, 73,  255, 111, 137, 65,  255, 142, 164, 96,  255, 156, 178, 109, 255, 109, 129, 68,  255, 94,  119, 53,  255, 129, 162, 74,  255,
    154, 178, 90,  255, 187, 202, 117, 255, 194, 212, 140, 255, 177, 201, 137, 255, 159, 190, 132, 255, 130, 160, 101, 255, 142, 159, 100, 255, 103,
    130, 68,  255, 69,  92,  47,  255, 74,  95,  43,  255, 152, 173, 101, 255, 101, 130, 95,  255, 102, 131, 99,  255, 106, 137, 95,  255, 112, 142,
    93,  255, 128, 153, 91,  255, 184, 202, 107, 255, 150, 181, 99,  255, 124, 163, 81,  255, 125, 169, 86,  255, 147, 188, 95,  255, 163, 182, 81,
    255, 71,  91,  36,  255, 145, 173, 97,  255, 136, 167, 101, 255, 118, 148, 106, 255, 105, 137, 103, 255, 110, 141, 101, 255, 136, 167, 107, 255,
    162, 182, 103, 255, 91,  115, 62,  255, 74,  103, 55,  255, 69,  99,  47,  255, 119, 138, 68,  255, 200, 204, 129, 255, 130, 157, 120, 255, 123,
    152, 122, 255, 117, 148, 114, 255, 150, 172, 111, 255, 179, 184, 97,  255, 108, 132, 62,  255, 131, 154, 100, 255, 144, 177, 130, 255, 137, 173,
    134, 255, 145, 177, 134, 255, 149, 178, 131, 255, 145, 174, 120, 255, 139, 170, 106, 255, 133, 168, 92,  255, 133, 168, 86,  255, 153, 177, 80,
    255, 169, 185, 80,  255, 159, 180, 68,  255, 137, 167, 47,  255, 129, 166, 55,  255, 136, 173, 67,  255, 132, 169, 69,  255, 151, 177, 79,  255,
    180, 200, 102, 255, 166, 194, 106, 255, 189, 207, 98,  255, 122, 143, 52,  255, 81,  119, 52,  255, 77,  108, 58,  255, 114, 148, 62,  255, 122,
    158, 65,  255, 114, 148, 58,  255, 98,  133, 45,  255, 78,  117, 41,  255, 73,  103, 41,  255, 67,  92,  33,  255, 146, 160, 104, 255, 179, 203,
    98,  255, 160, 195, 92,  255, 184, 211, 136, 255, 187, 213, 168, 255, 191, 217, 163, 255, 207, 214, 138, 255, 171, 172, 69,  255, 182, 186, 72,
    255, 178, 182, 72,  255, 151, 169, 69,  255, 151, 168, 77,  255, 149, 158, 81,  255, 78,  98,  43,  255, 34,  44,  29,  255, 26,  38,  25,  255,
    43,  68,  33,  255, 58,  84,  41,  255, 55,  71,  36,  255, 37,  51,  26,  255, 43,  60,  28,  255, 36,  53,  23,  255, 25,  34,  23,  255, 19,
    26,  23,  255, 33,  52,  31,  255, 123, 154, 86,  255, 135, 160, 108, 255, 89,  112, 63,  255, 72,  101, 40,  255, 80,  112, 44,  255, 89,  116,
    56,  255, 49,  73,  28,  255, 111, 139, 65,  255, 154, 185, 125, 255, 153, 181, 126, 255, 182, 202, 130, 255, 189, 209, 128, 255, 212, 226, 161,
    255, 222, 231, 168, 255, 167, 178, 102, 255, 142, 158, 68,  255, 184, 202, 117, 255, 152, 181, 135, 255, 150, 177, 138, 255, 136, 153, 110, 255,
    178, 188, 122, 255, 138, 154, 74,  255, 147, 166, 128, 255, 138, 157, 75,  255, 108, 135, 55,  255, 114, 143, 52,  255, 163, 184, 73,  255, 23,
    38,  17,  255, 38,  37,  17,  255, 83,  93,  34,  255, 112, 134, 49,  255, 63,  92,  36,  255, 87,  112, 44,  255, 84,  117, 53,  255, 60,  92,
    48,  255, 97,  114, 44,  255, 210, 205, 114, 255, 161, 183, 118, 255, 124, 148, 107, 255, 146, 166, 106, 255, 127, 150, 99,  255, 136, 160, 91,
    255, 82,  114, 50,  255, 68,  72,  37,  255, 144, 156, 71,  255, 136, 159, 62,  255, 121, 161, 55,  255, 104, 143, 58,  255, 111, 149, 63,  255,
    127, 158, 68,  255, 144, 172, 68,  255, 108, 137, 62,  255, 94,  128, 45,  255, 77,  114, 39,  255, 76,  113, 49,  255, 87,  121, 60,  255, 97,
    132, 65,  255, 100, 135, 69,  255, 134, 159, 76,  255, 184, 199, 91,  255, 136, 167, 68,  255, 68,  105, 37,  255, 28,  38,  23,  255, 23,  26,
    23,  255, 46,  52,  17,  255, 169, 173, 105, 255, 193, 226, 177, 255, 173, 206, 163, 255, 180, 209, 167, 255, 224, 238, 176, 255, 131, 149, 92,
    255, 71,  76,  26,  255, 153, 178, 81,  255, 166, 196, 109, 255, 152, 173, 114, 255, 49,  68,  31,  255, 38,  60,  23,  255, 72,  99,  60,  255,
    58,  84,  46,  255, 120, 135, 62,  255, 185, 205, 113, 255, 175, 199, 107, 255, 166, 179, 97,  255, 167, 186, 93,  255, 165, 188, 65,  255, 199,
    211, 77,  255, 212, 217, 108, 255, 218, 217, 114, 255, 224, 221, 108, 255, 184, 199, 106, 255, 108, 148, 62,  255, 92,  122, 44,  255, 80,  102,
    38,  255, 73,  96,  42,  255, 50,  76,  26,  255, 90,  103, 37,  255, 143, 155, 80,  255, 102, 117, 58,  255, 108, 130, 55,  255, 123, 149, 69,
    255, 138, 161, 90,  255, 176, 188, 111, 255, 226, 231, 134, 255, 215, 225, 125, 255, 210, 219, 116, 255, 228, 234, 141, 255, 232, 235, 153, 255,
    194, 206, 127, 255, 184, 206, 147, 255, 168, 197, 143, 255, 168, 197, 145, 255, 174, 203, 154, 255, 206, 224, 165, 255, 106, 119, 75,  255, 74,
    72,  46,  255, 202, 199, 142, 255, 194, 186, 136, 255, 141, 152, 86,  255, 115, 145, 68,  255, 135, 161, 84,  255, 131, 152, 76,  255, 99,  117,
    50,  255, 95,  127, 42,  255, 81,  119, 36,  255, 75,  105, 40,  255, 44,  58,  36,  255, 19,  25,  19,  255, 67,  81,  36,  255, 129, 158, 76,
    255, 81,  109, 48,  255, 43,  68,  31,  255, 74,  102, 58,  255, 90,  121, 55,  255, 46,  68,  23,  255, 34,  47,  26,  255, 36,  49,  26,  255,
    26,  36,  23,  255, 52,  65,  38,  255, 112, 139, 81,  255, 150, 179, 76,  255, 146, 170, 69,  255, 151, 171, 110, 255, 182, 200, 127, 255, 133,
    147, 73,  255, 69,  89,  32,  255, 77,  103, 50,  255, 55,  79,  47,  255, 52,  79,  38,  255, 72,  100, 36,  255, 118, 145, 68,  255, 145, 173,
    79,  255, 140, 168, 83,  255, 90,  127, 53,  255, 87,  124, 60,  255, 111, 146, 90,  255, 135, 168, 101, 255, 131, 158, 95,  255, 127, 150, 72,
    255, 153, 181, 84,  255, 126, 161, 83,  255, 84,  125, 65,  255, 97,  126, 67,  255, 124, 147, 84,  255, 138, 162, 90,  255, 148, 172, 99,  255,
    145, 176, 102, 255, 115, 143, 69,  255, 99,  123, 60,  255, 39,  58,  34,  255, 86,  102, 52,  255, 167, 185, 100, 255, 105, 135, 95,  255, 101,
    132, 100, 255, 105, 137, 97,  255, 100, 133, 95,  255, 97,  129, 85,  255, 158, 177, 100, 255, 152, 180, 112, 255, 140, 176, 97,  255, 145, 184,
    107, 255, 184, 213, 122, 255, 131, 151, 69,  255, 104, 136, 68,  255, 146, 176, 103, 255, 138, 166, 110, 255, 113, 144, 108, 255, 124, 156, 107,
    255, 157, 185, 112, 255, 154, 169, 97,  255, 102, 115, 55,  255, 107, 130, 60,  255, 103, 126, 55,  255, 101, 119, 50,  255, 194, 192, 107, 255,
    201, 202, 130, 255, 124, 154, 122, 255, 126, 153, 123, 255, 132, 157, 128, 255, 152, 174, 124, 255, 170, 176, 93,  255, 128, 156, 84,  255, 130,
    165, 100, 255, 123, 164, 100, 255, 134, 172, 107, 255, 134, 170, 98,  255, 132, 168, 91,  255, 128, 165, 84,  255, 136, 172, 86,  255, 160, 186,
    80,  255, 169, 183, 73,  255, 129, 142, 55,  255, 147, 171, 71,  255, 148, 177, 74,  255, 127, 160, 60,  255, 132, 169, 58,  255, 140, 176, 68,
    255, 140, 175, 72,  255, 146, 179, 78,  255, 171, 193, 91,  255, 203, 217, 127, 255, 119, 127, 68,  255, 82,  112, 36,  255, 116, 152, 60,  255,
    124, 155, 65,  255, 137, 168, 67,  255, 115, 147, 65,  255, 84,  119, 58,  255, 99,  132, 71,  255, 91,  128, 52,  255, 87,  116, 44,  255, 101,
    116, 52,  255, 219, 229, 143, 255, 184, 207, 122, 255, 165, 194, 119, 255, 180, 209, 151, 255, 190, 214, 132, 255, 239, 246, 154, 255, 143, 135,
    78,  255, 39,  52,  36,  255, 65,  73,  43,  255, 67,  83,  38,  255, 71,  92,  36,  255, 60,  86,  34,  255, 49,  74,  31,  255, 38,  62,  26,
    255, 55,  84,  33,  255, 69,  99,  43,  255, 60,  87,  38,  255, 58,  87,  38,  255, 75,  103, 42,  255, 63,  89,  32,  255, 41,  68,  23,  255,
    43,  69,  25,  255, 43,  65,  26,  255, 34,  49,  28,  255, 97,  127, 65,  255, 114, 145, 69,  255, 90,  112, 49,  255, 82,  114, 41,  255, 107,
    140, 52,  255, 131, 164, 56,  255, 156, 183, 89,  255, 85,  98,  38,  255, 111, 133, 68,  255, 155, 184, 127, 255, 164, 191, 133, 255, 201, 218,
    145, 255, 206, 221, 151, 255, 211, 224, 157, 255, 220, 230, 162, 255, 192, 199, 129, 255, 144, 155, 75,  255, 182, 204, 133, 255, 167, 189, 138,
    255, 169, 190, 129, 255, 142, 162, 128, 255, 182, 191, 135, 255, 194, 205, 152, 255, 158, 167, 102, 255, 145, 165, 84,  255, 108, 138, 74,  255,
    133, 159, 68,  255, 165, 183, 89,  255, 58,  79,  38,  255, 65,  83,  41,  255, 62,  79,  23,  255, 144, 154, 84,  255, 77,  98,  47,  255, 92,
    120, 52,  255, 74,  104, 50,  255, 63,  92,  44,  255, 86,  113, 38,  255, 188, 186, 94,  255, 174, 192, 127, 255, 125, 152, 112, 255, 142, 161,
    111, 255, 137, 163, 110, 255, 131, 154, 94,  255, 105, 127, 49,  255, 136, 149, 58,  255, 111, 134, 55,  255, 139, 160, 62,  255, 135, 179, 75,
    255, 111, 150, 67,  255, 138, 172, 87,  255, 157, 187, 94,  255, 180, 203, 104, 255, 122, 153, 68,  255, 68,  105, 36,  255, 84,  119, 52,  255,
    92,  129, 60,  255, 102, 138, 73,  255, 102, 140, 76,  255, 111, 145, 77,  255, 128, 157, 84,  255, 156, 178, 89,  255, 185, 202, 94,  255, 122,
    152, 63,  255, 95,  114, 55,  255, 87,  101, 52,  255, 58,  87,  36,  255, 62,  71,  26,  255, 204, 206, 138, 255, 195, 227, 172, 255, 174, 206,
    160, 255, 195, 217, 167, 255, 173, 190, 131, 255, 26,  38,  17,  255, 124, 135, 75,  255, 92,  115, 63,  255, 37,  52,  23,  255, 29,  47,  26,
    255, 33,  55,  23,  255, 60,  84,  39,  255, 81,  106, 53,  255, 103, 120, 56,  255, 189, 201, 117, 255, 194, 210, 132, 255, 173, 185, 108, 255,
    167, 186, 80,  255, 182, 199, 76,  255, 196, 208, 102, 255, 198, 206, 105, 255, 216, 217, 104, 255, 227, 224, 115, 255, 207, 212, 119, 255, 104,
    134, 53,  255, 87,  115, 48,  255, 86,  114, 52,  255, 79,  112, 47,  255, 63,  98,  38,  255, 48,  74,  33,  255, 36,  51,  23,  255, 29,  52,
    19,  255, 65,  86,  34,  255, 129, 149, 93,  255, 179, 199, 149, 255, 212, 219, 127, 255, 226, 233, 140, 255, 208, 221, 116, 255, 222, 228, 128,
    255, 246, 248, 161, 255, 211, 223, 150, 255, 166, 192, 132, 255, 166, 192, 144, 255, 166, 195, 143, 255, 171, 200, 145, 255, 201, 221, 159, 255,
    155, 172, 114, 255, 31,  48,  28,  255, 109, 105, 72,  255, 202, 198, 139, 255, 193, 190, 137, 255, 148, 151, 98,  255, 65,  94,  25,  255, 56,
    80,  26,  255, 36,  47,  23,  255, 43,  68,  21,  255, 49,  84,  21,  255, 65,  108, 29,  255, 47,  75,  23,  255, 50,  63,  36,  255, 21,  26,
    19,  255, 80,  101, 50,  255, 97,  131, 62,  255, 65,  97,  50,  255, 62,  90,  56,  255, 105, 135, 77,  255, 95,  126, 49,  255, 49,  71,  26,
    255, 23,  33,  21,  255, 26,  38,  23,  255, 32,  40,  21,  255, 96,  117, 63,  255, 95,  125, 87,  255, 155, 183, 93,  255, 142, 180, 62,  255,
    179, 202, 117, 255, 187, 212, 175, 255, 164, 184, 120, 255, 76,  98,  37,  255, 77,  104, 52,  255, 60,  84,  52,  255, 69,  92,  43,  255, 123,
    151, 80,  255, 133, 162, 100, 255, 126, 152, 89,  255, 113, 144, 84,  255, 122, 155, 84,  255, 140, 172, 81,  255, 132, 153, 75,  255, 62,  68,
    37,  255, 60,  68,  28,  255, 167, 189, 76,  255, 142, 174, 78,  255, 89,  128, 65,  255, 72,  111, 56,  255, 71,  109, 53,  255, 72,  109, 52,
    255, 68,  104, 58,  255, 85,  122, 71,  255, 130, 162, 76,  255, 130, 161, 71,  255, 137, 165, 80,  255, 92,  121, 55,  255, 109, 137, 62,  255,
    177, 193, 104, 255, 142, 167, 105, 255, 99,  131, 99,  255, 114, 144, 96,  255, 134, 161, 92,  255, 134, 164, 81,  255, 138, 167, 74,  255, 165,
    191, 107, 255, 159, 190, 120, 255, 175, 204, 126, 255, 160, 178, 105, 255, 79,  105, 58,  255, 98,  126, 77,  255, 152, 179, 113, 255, 120, 152,
    106, 255, 134, 165, 108, 255, 154, 179, 102, 255, 114, 129, 68,  255, 45,  55,  28,  255, 39,  60,  21,  255, 62,  83,  32,  255, 55,  75,  31,
    255, 113, 120, 65,  255, 229, 221, 135, 255, 166, 180, 129, 255, 128, 158, 129, 255, 130, 160, 130, 255, 137, 162, 136, 255, 161, 173, 113, 255,
    143, 155, 78,  255, 113, 141, 68,  255, 126, 159, 74,  255, 137, 170, 81,  255, 140, 173, 83,  255, 143, 174, 86,  255, 154, 182, 91,  255, 158,
    180, 90,  255, 122, 136, 67,  255, 78,  86,  40,  255, 52,  65,  23,  255, 107, 136, 55,  255, 146, 177, 82,  255, 129, 164, 86,  255, 115, 151,
    84,  255, 105, 141, 71,  255, 124, 162, 60,  255, 133, 171, 55,  255, 143, 176, 67,  255, 159, 187, 83,  255, 167, 187, 87,  255, 114, 140, 62,
    255, 115, 147, 68,  255, 96,  132, 63,  255, 96,  135, 72,  255, 137, 166, 102, 255, 189, 200, 132, 255, 169, 186, 135, 255, 190, 204, 138, 255,
    98,  130, 60,  255, 108, 137, 50,  255, 152, 164, 98,  255, 214, 231, 160, 255, 179, 196, 122, 255, 180, 200, 129, 255, 191, 211, 123, 255, 207,
    221, 107, 255, 198, 206, 101, 255, 154, 154, 90,  255, 58,  68,  46,  255, 42,  65,  38,  255, 44,  72,  36,  255, 50,  76,  34,  255, 41,  58,
    26,  255, 40,  60,  26,  255, 42,  62,  31,  255, 55,  84,  36,  255, 83,  114, 53,  255, 63,  92,  34,  255, 52,  83,  29,  255, 67,  96,  33,
    255, 96,  129, 42,  255, 83,  108, 40,  255, 43,  65,  25,  255, 33,  60,  21,  255, 73,  102, 46,  255, 130, 156, 83,  255, 103, 125, 63,  255,
    93,  119, 50,  255, 116, 152, 56,  255, 133, 164, 55,  255, 158, 182, 65,  255, 173, 194, 84,  255, 152, 171, 94,  255, 123, 144, 74,  255, 143,
    165, 105, 255, 158, 185, 134, 255, 188, 209, 146, 255, 213, 224, 154, 255, 213, 224, 156, 255, 215, 227, 154, 255, 200, 209, 136, 255, 181, 189,
    100, 255, 177, 199, 144, 255, 164, 191, 138, 255, 147, 181, 75,  255, 135, 173, 72,  255, 159, 188, 93,  255, 194, 208, 129, 255, 163, 191, 75,
    255, 168, 185, 95,  255, 125, 147, 84,  255, 142, 164, 74,  255, 131, 156, 65,  255, 128, 147, 62,  255, 152, 167, 87,  255, 112, 143, 81,  255,
    160, 176, 104, 255, 120, 134, 63,  255, 98,  128, 80,  255, 98,  127, 74,  255, 68,  99,  41,  255, 84,  122, 41,  255, 113, 123, 42,  255, 202,
    203, 117, 255, 142, 170, 119, 255, 129, 152, 110, 255, 144, 167, 111, 255, 132, 157, 94,  255, 126, 143, 56,  255, 138, 159, 69,  255, 97,  120,
    55,  255, 153, 170, 69,  255, 174, 206, 96,  255, 128, 169, 83,  255, 136, 172, 91,  255, 164, 191, 101, 255, 199, 216, 126, 255, 182, 207, 110,
    255, 80,  119, 38,  255, 104, 140, 52,  255, 137, 168, 68,  255, 140, 171, 75,  255, 135, 167, 77,  255, 123, 158, 80,  255, 120, 153, 86,  255,
    131, 161, 90,  255, 166, 185, 101, 255, 152, 179, 97,  255, 132, 164, 90,  255, 150, 176, 92,  255, 148, 170, 84,  255, 77,  102, 50,  255, 76,
    83,  36,  255, 194, 198, 119, 255, 188, 221, 165, 255, 168, 202, 156, 255, 183, 207, 148, 255, 53,  68,  36,  255, 79,  91,  49,  255, 37,  55,
    26,  255, 49,  75,  32,  255, 71,  91,  38,  255, 116, 137, 63,  255, 157, 177, 91,  255, 181, 199, 120, 255, 189, 206, 137, 255, 218, 230, 157,
    255, 220, 230, 169, 255, 192, 207, 128, 255, 180, 198, 81,  255, 212, 218, 98,  255, 212, 218, 118, 255, 211, 216, 121, 255, 219, 218, 102, 255,
    230, 224, 109, 255, 216, 216, 116, 255, 111, 129, 56,  255, 92,  116, 52,  255, 90,  118, 52,  255, 74,  103, 50,  255, 60,  87,  43,  255, 58,
    84,  37,  255, 43,  62,  29,  255, 74,  83,  40,  255, 152, 167, 96,  255, 180, 199, 115, 255, 210, 218, 129, 255, 238, 239, 154, 255, 225, 232,
    142, 255, 212, 220, 113, 255, 238, 241, 150, 255, 241, 241, 163, 255, 172, 196, 138, 255, 159, 189, 134, 255, 165, 194, 137, 255, 170, 197, 139,
    255, 196, 218, 151, 255, 176, 189, 123, 255, 60,  84,  52,  255, 29,  47,  23,  255, 120, 120, 81,  255, 198, 194, 130, 255, 190, 188, 133, 255,
    177, 174, 127, 255, 112, 120, 52,  255, 97,  112, 47,  255, 87,  110, 48,  255, 112, 143, 68,  255, 80,  111, 47,  255, 41,  62,  23,  255, 41,
    63,  21,  255, 58,  84,  33,  255, 43,  58,  28,  255, 102, 131, 63,  255, 88,  119, 74,  255, 76,  107, 71,  255, 87,  119, 73,  255, 131, 163,
    84,  255, 63,  86,  36,  255, 32,  47,  25,  255, 28,  41,  23,  255, 25,  36,  21,  255, 47,  58,  26,  255, 128, 155, 91,  255, 95,  128, 93,
    255, 133, 161, 91,  255, 150, 189, 69,  255, 147, 169, 72,  255, 156, 179, 130, 255, 178, 206, 158, 255, 72,  90,  38,  255, 77,  101, 49,  255,
    65,  91,  52,  255, 102, 130, 81,  255, 124, 152, 103, 255, 107, 133, 84,  255, 102, 135, 86,  255, 104, 140, 92,  255, 116, 147, 82,  255, 115,
    138, 65,  255, 42,  52,  31,  255, 9,   15,  12,  255, 124, 139, 68,  255, 159, 189, 107, 255, 120, 157, 99,  255, 110, 148, 91,  255, 102, 139,
    69,  255, 84,  125, 50,  255, 74,  114, 55,  255, 77,  116, 65,  255, 120, 156, 82,  255, 152, 182, 90,  255, 172, 197, 123, 255, 115, 147, 67,
    255, 105, 137, 55,  255, 100, 130, 58,  255, 157, 177, 90,  255, 141, 165, 99,  255, 140, 163, 100, 255, 178, 195, 103, 255, 169, 192, 96,  255,
    126, 159, 86,  255, 101, 138, 74,  255, 153, 179, 96,  255, 190, 217, 146, 255, 181, 199, 130, 255, 90,  116, 79,  255, 74,  105, 62,  255, 92,
    122, 67,  255, 155, 182, 117, 255, 139, 170, 103, 255, 127, 152, 77,  255, 68,  87,  37,  255, 63,  83,  47,  255, 72,  95,  48,  255, 69,  94,
    41,  255, 57,  87,  25,  255, 69,  97,  33,  255, 167, 171, 105, 255, 173, 188, 130, 255, 146, 170, 130, 255, 136, 165, 136, 255, 136, 167, 138,
    255, 145, 174, 137, 255, 153, 168, 100, 255, 114, 132, 62,  255, 130, 153, 92,  255, 109, 143, 90,  255, 122, 156, 98,  255, 141, 169, 93,  255,
    147, 164, 76,  255, 83,  101, 47,  255, 69,  83,  42,  255, 34,  48,  26,  255, 15,  26,  23,  255, 45,  60,  33,  255, 147, 179, 80,  255, 122,
    158, 75,  255, 107, 142, 80,  255, 109, 143, 90,  255, 101, 137, 85,  255, 100, 137, 71,  255, 116, 152, 62,  255, 148, 176, 68,  255, 174, 197,
    92,  255, 184, 203, 105, 255, 131, 156, 72,  255, 173, 198, 99,  255, 113, 143, 72,  255, 131, 160, 90,  255, 212, 223, 132, 255, 216, 230, 145,
    255, 203, 226, 157, 255, 152, 169, 97,  255, 89,  126, 58,  255, 137, 161, 55,  255, 190, 200, 128, 255, 179, 198, 153, 255, 150, 176, 123, 255,
    192, 216, 150, 255, 236, 238, 148, 255, 173, 172, 94,  255, 62,  80,  39,  255, 58,  75,  43,  255, 50,  71,  39,  255, 49,  73,  38,  255, 57,
    89,  41,  255, 58,  80,  37,  255, 29,  41,  26,  255, 28,  37,  25,  255, 34,  44,  26,  255, 34,  52,  23,  255, 43,  74,  23,  255, 81,  111,
    47,  255, 128, 152, 72,  255, 120, 150, 62,  255, 111, 146, 58,  255, 106, 141, 47,  255, 83,  111, 48,  255, 48,  74,  33,  255, 93,  124, 62,
    255, 128, 154, 81,  255, 136, 158, 65,  255, 113, 145, 60,  255, 99,  138, 62,  255, 101, 139, 65,  255, 130, 161, 72,  255, 161, 181, 78,  255,
    140, 157, 84,  255, 181, 187, 118, 255, 167, 177, 114, 255, 161, 182, 129, 255, 172, 198, 143, 255, 215, 226, 158, 255, 209, 221, 150, 255, 206,
    220, 145, 255, 206, 216, 133, 255, 185, 200, 101, 255, 176, 201, 146, 255, 163, 190, 159, 255, 145, 177, 121, 255, 119, 160, 55,  255, 122, 165,
    55,  255, 141, 181, 62,  255, 114, 162, 53,  255, 164, 196, 71,  255, 164, 179, 93,  255, 123, 148, 74,  255, 126, 150, 62,  255, 199, 198, 105,
    255, 172, 187, 94,  255, 127, 157, 112, 255, 162, 181, 126, 255, 219, 217, 136, 255, 143, 145, 79,  255, 146, 160, 82,  255, 74,  109, 40,  255,
    76,  113, 38,  255, 120, 146, 65,  255, 169, 172, 76,  255, 196, 204, 113, 255, 143, 170, 118, 255, 128, 158, 109, 255, 127, 154, 83,  255, 121,
    140, 60,  255, 124, 145, 71,  255, 131, 156, 76,  255, 137, 163, 89,  255, 184, 200, 106, 255, 177, 206, 107, 255, 142, 179, 103, 255, 163, 190,
    123, 255, 211, 227, 133, 255, 153, 177, 94,  255, 40,  62,  17,  255, 97,  115, 39,  255, 163, 180, 69,  255, 174, 194, 72,  255, 199, 213, 99,
    255, 199, 216, 120, 255, 192, 212, 126, 255, 174, 198, 112, 255, 135, 157, 58,  255, 151, 177, 69,  255, 122, 160, 92,  255, 117, 153, 92,  255,
    128, 160, 94,  255, 150, 173, 95,  255, 85,  112, 60,  255, 65,  79,  33,  255, 183, 192, 116, 255, 185, 215, 157, 255, 172, 203, 151, 255, 121,
    138, 86,  255, 49,  63,  37,  255, 38,  52,  19,  255, 124, 142, 68,  255, 183, 206, 121, 255, 182, 213, 127, 255, 185, 214, 137, 255, 203, 225,
    157, 255, 218, 232, 160, 255, 134, 139, 84,  255, 119, 120, 72,  255, 165, 183, 82,  255, 186, 198, 86,  255, 205, 216, 97,  255, 214, 222, 107,
    255, 222, 224, 130, 255, 224, 222, 110, 255, 229, 223, 110, 255, 216, 216, 113, 255, 103, 130, 49,  255, 86,  111, 45,  255, 82,  110, 55,  255,
    69,  96,  49,  255, 65,  91,  44,  255, 53,  79,  31,  255, 105, 116, 55,  255, 203, 211, 126, 255, 215, 227, 127, 255, 194, 211, 99,  255, 221,
    227, 124, 255, 225, 232, 140, 255, 217, 225, 125, 255, 220, 228, 127, 255, 245, 245, 158, 255, 213, 223, 154, 255, 156, 186, 128, 255, 164, 194,
    134, 255, 175, 203, 142, 255, 206, 223, 150, 255, 143, 150, 87,  255, 55,  79,  31,  255, 62,  83,  42,  255, 56,  74,  46,  255, 111, 117, 75,
    255, 190, 187, 118, 255, 202, 189, 126, 255, 199, 189, 133, 255, 122, 136, 62,  255, 140, 172, 76,  255, 147, 183, 92,  255, 167, 196, 105, 255,
    101, 129, 56,  255, 58,  87,  31,  255, 67,  94,  38,  255, 65,  94,  38,  255, 73,  97,  43,  255, 84,  116, 67,  255, 81,  114, 76,  255, 87,
    119, 74,  255, 126, 156, 80,  255, 120, 148, 74,  255, 38,  58,  29,  255, 33,  48,  23,  255, 37,  53,  25,  255, 19,  28,  21,  255, 63,  79,
    43,  255, 139, 169, 105, 255, 97,  130, 89,  255, 111, 138, 91,  255, 185, 207, 103, 255, 195, 215, 119, 255, 161, 182, 110, 255, 178, 210, 171,
    255, 112, 139, 91,  255, 73,  96,  41,  255, 79,  104, 63,  255, 127, 148, 93,  255, 147, 168, 87,  255, 156, 184, 93,  255, 158, 183, 95,  255,
    111, 136, 67,  255, 84,  112, 55,  255, 68,  98,  41,  255, 47,  68,  31,  255, 34,  52,  17,  255, 137, 149, 79,  255, 173, 200, 125, 255, 139,
    172, 116, 255, 126, 161, 97,  255, 115, 158, 87,  255, 114, 156, 87,  255, 93,  135, 67,  255, 128, 165, 85,  255, 158, 186, 92,  255, 185, 208,
    125, 255, 178, 197, 120, 255, 73,  101, 44,  255, 65,  97,  43,  255, 72,  103, 47,  255, 120, 145, 67,  255, 176, 195, 103, 255, 186, 202, 113,
    255, 163, 187, 111, 255, 144, 174, 107, 255, 117, 152, 97,  255, 97,  136, 87,  255, 114, 144, 92,  255, 163, 182, 126, 255, 129, 156, 97,  255,
    107, 143, 76,  255, 83,  117, 63,  255, 85,  116, 47,  255, 133, 160, 84,  255, 96,  123, 49,  255, 50,  79,  21,  255, 92,  113, 52,  255, 169,
    192, 111, 255, 163, 188, 123, 255, 175, 196, 130, 255, 81,  108, 37,  255, 95,  121, 41,  255, 194, 195, 125, 255, 142, 169, 129, 255, 137, 167,
    139, 255, 144, 170, 145, 255, 146, 173, 145, 255, 160, 183, 147, 255, 137, 151, 86,  255, 155, 167, 86,  255, 169, 185, 106, 255, 104, 143, 86,
    255, 108, 150, 99,  255, 116, 155, 99,  255, 144, 173, 91,  255, 67,  94,  29,  255, 34,  49,  23,  255, 53,  71,  29,  255, 62,  81,  33,  255,
    95,  121, 52,  255, 132, 166, 74,  255, 91,  127, 63,  255, 86,  121, 68,  255, 98,  134, 80,  255, 108, 144, 84,  255, 110, 147, 91,  255, 122,
    161, 95,  255, 101, 121, 58,  255, 112, 132, 55,  255, 207, 222, 121, 255, 154, 177, 95,  255, 142, 175, 87,  255, 170, 192, 96,  255, 195, 216,
    104, 255, 190, 215, 89,  255, 196, 220, 135, 255, 207, 215, 126, 255, 137, 154, 55,  255, 163, 180, 63,  255, 144, 160, 55,  255, 173, 188, 133,
    255, 150, 171, 110, 255, 197, 216, 138, 255, 202, 203, 114, 255, 112, 127, 55,  255, 73,  109, 39,  255, 87,  123, 46,  255, 99,  130, 48,  255,
    75,  97,  44,  255, 52,  82,  44,  255, 72,  103, 47,  255, 45,  62,  31,  255, 39,  60,  26,  255, 34,  52,  28,  255, 53,  76,  47,  255, 84,
    118, 60,  255, 110, 144, 78,  255, 178, 193, 130, 255, 169, 187, 104, 255, 145, 169, 74,  255, 117, 150, 62,  255, 110, 145, 53,  255, 95,  124,
    53,  255, 72,  102, 50,  255, 102, 135, 65,  255, 115, 133, 62,  255, 170, 182, 75,  255, 116, 147, 68,  255, 107, 144, 69,  255, 114, 148, 76,
    255, 118, 152, 83,  255, 136, 160, 84,  255, 196, 201, 127, 255, 193, 210, 153, 255, 154, 172, 120, 255, 184, 201, 142, 255, 184, 206, 146, 255,
    214, 224, 156, 255, 207, 219, 147, 255, 197, 213, 139, 255, 199, 212, 121, 255, 127, 152, 53,  255, 143, 173, 117, 255, 169, 197, 163, 255, 161,
    189, 160, 255, 155, 179, 99,  255, 133, 165, 60,  255, 119, 160, 55,  255, 117, 158, 58,  255, 148, 181, 73,  255, 127, 154, 81,  255, 129, 155,
    81,  255, 187, 196, 109, 255, 223, 221, 135, 255, 161, 183, 113, 255, 130, 161, 126, 255, 154, 175, 122, 255, 219, 223, 147, 255, 229, 234, 174,
    255, 235, 234, 158, 255, 129, 151, 69,  255, 96,  125, 48,  255, 177, 196, 106, 255, 126, 147, 60,  255, 142, 154, 58,  255, 171, 184, 97,  255,
    129, 160, 103, 255, 111, 139, 65,  255, 111, 132, 58,  255, 120, 142, 72,  255, 126, 154, 80,  255, 133, 162, 111, 255, 143, 165, 124, 255, 177,
    195, 114, 255, 177, 202, 115, 255, 174, 199, 132, 255, 208, 226, 144, 255, 113, 134, 71,  255, 21,  40,  12,  255, 38,  58,  23,  255, 60,  73,
    25,  255, 107, 130, 42,  255, 133, 150, 52,  255, 205, 213, 109, 255, 211, 224, 122, 255, 199, 217, 105, 255, 174, 198, 87,  255, 165, 190, 65,
    255, 154, 182, 87,  255, 121, 159, 95,  255, 117, 154, 97,  255, 119, 153, 97,  255, 131, 159, 94,  255, 94,  120, 65,  255, 122, 135, 69,  255,
    169, 183, 102, 255, 162, 191, 122, 255, 161, 183, 115, 255, 82,  99,  53,  255, 130, 149, 89,  255, 192, 221, 149, 255, 194, 222, 145, 255, 197,
    222, 135, 255, 205, 221, 144, 255, 202, 207, 136, 255, 103, 118, 68,  255, 33,  46,  19,  255, 65,  68,  31,  255, 136, 148, 60,  255, 163, 177,
    83,  255, 189, 207, 84,  255, 217, 222, 119, 255, 229, 229, 132, 255, 231, 227, 121, 255, 235, 227, 119, 255, 206, 211, 110, 255, 98,  136, 50,
    255, 71,  92,  37,  255, 74,  93,  36,  255, 85,  112, 47,  255, 83,  113, 47,  255, 91,  112, 40,  255, 187, 200, 118, 255, 202, 216, 139, 255,
    222, 232, 136, 255, 206, 218, 107, 255, 216, 223, 115, 255, 216, 224, 122, 255, 212, 221, 112, 255, 229, 235, 139, 255, 226, 233, 149, 255, 192,
    209, 144, 255, 161, 190, 124, 255, 190, 208, 137, 255, 207, 213, 128, 255, 149, 156, 92,  255, 74,  94,  55,  255, 97,  124, 45,  255, 145, 169,
    65,  255, 170, 192, 98,  255, 146, 166, 84,  255, 183, 184, 112, 255, 227, 209, 137, 255, 203, 201, 125, 255, 125, 158, 60,  255, 133, 168, 68,
    255, 157, 184, 94,  255, 164, 191, 99,  255, 60,  74,  34,  255, 53,  73,  28,  255, 65,  89,  41,  255, 69,  97,  52,  255, 92,  116, 58,  255,
    82,  111, 65,  255, 87,  120, 81,  255, 117, 146, 77,  255, 137, 166, 74,  255, 60,  86,  36,  255, 33,  56,  25,  255, 38,  58,  26,  255, 36,
    53,  25,  255, 9,   17,  12,  255, 87,  99,  53,  255, 160, 184, 116, 255, 127, 156, 106, 255, 98,  130, 95,  255, 130, 160, 87,  255, 160, 190,
    89,  255, 171, 192, 106, 255, 178, 205, 156, 255, 193, 215, 128, 255, 195, 205, 110, 255, 148, 165, 89,  255, 123, 158, 62,  255, 158, 187, 98,
    255, 173, 197, 116, 255, 195, 211, 129, 255, 167, 183, 108, 255, 78,  106, 52,  255, 71,  101, 46,  255, 48,  69,  31,  255, 32,  51,  17,  255,
    109, 120, 58,  255, 197, 213, 126, 255, 165, 185, 108, 255, 165, 190, 114, 255, 153, 186, 129, 255, 154, 181, 109, 255, 116, 146, 62,  255, 108,
    128, 63,  255, 60,  62,  33,  255, 156, 157, 101, 255, 147, 165, 92,  255, 67,  96,  52,  255, 58,  84,  41,  255, 67,  96,  44,  255, 118, 139,
    62,  255, 182, 200, 120, 255, 139, 172, 122, 255, 127, 164, 118, 255, 127, 163, 115, 255, 127, 162, 110, 255, 122, 157, 98,  255, 118, 155, 92,
    255, 113, 149, 89,  255, 115, 152, 82,  255, 106, 152, 73,  255, 119, 157, 69,  255, 90,  117, 50,  255, 102, 129, 52,  255, 52,  72,  21,  255,
    75,  90,  47,  255, 152, 178, 109, 255, 145, 176, 111, 255, 182, 204, 140, 255, 187, 213, 153, 255, 170, 187, 118, 255, 115, 137, 65,  255, 205,
    205, 127, 255, 160, 180, 136, 255, 139, 169, 142, 255, 140, 169, 140, 255, 144, 170, 140, 255, 144, 171, 138, 255, 105, 131, 73,  255, 188, 197,
    113, 255, 133, 143, 62,  255, 108, 136, 60,  255, 126, 158, 81,  255, 123, 161, 94,  255, 142, 172, 95,  255, 115, 140, 55,  255, 133, 155, 62,
    255, 154, 176, 67,  255, 148, 177, 53,  255, 132, 166, 56,  255, 106, 142, 65,  255, 90,  125, 67,  255, 87,  127, 72,  255, 94,  133, 79,  255,
    112, 151, 92,  255, 128, 163, 99,  255, 146, 176, 106, 255, 83,  93,  52,  255, 26,  43,  17,  255, 153, 169, 80,  255, 196, 210, 113, 255, 155,
    179, 95,  255, 178, 201, 114, 255, 174, 202, 109, 255, 193, 217, 141, 255, 209, 223, 155, 255, 212, 221, 139, 255, 193, 196, 99,  255, 152, 163,
    62,  255, 127, 151, 53,  255, 132, 156, 84,  255, 168, 189, 96,  255, 175, 184, 78,  255, 116, 133, 39,  255, 63,  97,  41,  255, 71,  105, 48,
    255, 94,  126, 58,  255, 117, 147, 58,  255, 134, 154, 55,  255, 85,  105, 40,  255, 37,  58,  26,  255, 31,  48,  23,  255, 58,  82,  31,  255,
    43,  67,  31,  255, 76,  110, 55,  255, 110, 149, 75,  255, 170, 190, 121, 255, 184, 197, 127, 255, 158, 181, 98,  255, 143, 168, 78,  255, 101,
    131, 60,  255, 84,  119, 49,  255, 71,  104, 40,  255, 89,  123, 58,  255, 175, 195, 100, 255, 192, 203, 102, 255, 198, 203, 87,  255, 188, 197,
    78,  255, 169, 185, 80,  255, 139, 166, 84,  255, 136, 166, 89,  255, 168, 189, 115, 255, 189, 206, 149, 255, 149, 172, 132, 255, 152, 169, 116,
    255, 167, 192, 140, 255, 204, 217, 148, 255, 212, 223, 148, 255, 206, 218, 142, 255, 200, 214, 142, 255, 188, 202, 110, 255, 123, 138, 48,  255,
    152, 160, 87,  255, 194, 207, 152, 255, 198, 211, 159, 255, 241, 241, 174, 255, 230, 225, 143, 255, 133, 159, 60,  255, 115, 153, 58,  255, 149,
    178, 81,  255, 109, 138, 80,  255, 121, 148, 73,  255, 185, 192, 106, 255, 221, 220, 148, 255, 157, 180, 148, 255, 142, 169, 138, 255, 158, 179,
    126, 255, 202, 208, 124, 255, 175, 193, 112, 255, 209, 228, 167, 255, 213, 223, 153, 255, 217, 219, 134, 255, 191, 203, 118, 255, 119, 143, 60,
    255, 107, 134, 43,  255, 122, 145, 56,  255, 143, 164, 72,  255, 128, 152, 72,  255, 99,  125, 55,  255, 114, 145, 69,  255, 138, 166, 86,  255,
    141, 169, 95,  255, 135, 162, 95,  255, 172, 181, 89,  255, 166, 181, 76,  255, 177, 197, 95,  255, 212, 228, 145, 255, 83,  104, 58,  255, 26,
    42,  17,  255, 33,  51,  23,  255, 37,  48,  19,  255, 83,  111, 31,  255, 82,  116, 31,  255, 116, 135, 46,  255, 172, 186, 81,  255, 171, 192,
    67,  255, 167, 191, 71,  255, 162, 187, 75,  255, 147, 165, 63,  255, 158, 182, 90,  255, 132, 169, 98,  255, 118, 156, 94,  255, 146, 169, 83,
    255, 189, 204, 95,  255, 199, 216, 106, 255, 193, 211, 103, 255, 171, 189, 105, 255, 156, 168, 104, 255, 184, 199, 115, 255, 187, 206, 119, 255,
    188, 200, 128, 255, 178, 189, 109, 255, 184, 192, 105, 255, 190, 194, 116, 255, 79,  101, 50,  255, 32,  49,  12,  255, 90,  110, 42,  255, 131,
    142, 77,  255, 162, 169, 73,  255, 192, 205, 82,  255, 211, 215, 114, 255, 235, 231, 150, 255, 231, 228, 130, 255, 232, 228, 121, 255, 238, 230,
    117, 255, 199, 205, 103, 255, 77,  100, 47,  255, 34,  44,  31,  255, 29,  32,  23,  255, 41,  47,  25,  255, 39,  49,  19,  255, 116, 121, 55,
    255, 187, 209, 140, 255, 206, 218, 146, 255, 221, 234, 141, 255, 214, 227, 127, 255, 217, 226, 128, 255, 213, 220, 115, 255, 219, 225, 121, 255,
    230, 238, 140, 255, 185, 198, 100, 255, 181, 195, 97,  255, 202, 216, 117, 255, 193, 207, 116, 255, 65,  83,  38,  255, 60,  82,  28,  255, 113,
    145, 49,  255, 127, 159, 62,  255, 128, 156, 60,  255, 159, 186, 84,  255, 175, 196, 89,  255, 217, 212, 131, 255, 238, 220, 143, 255, 200, 202,
    123, 255, 122, 156, 58,  255, 141, 171, 72,  255, 173, 199, 101, 255, 140, 161, 83,  255, 45,  48,  34,  255, 39,  53,  25,  255, 52,  81,  33,
    255, 89,  120, 74,  255, 97,  126, 77,  255, 78,  106, 55,  255, 108, 139, 74,  255, 131, 159, 67,  255, 62,  82,  37,  255, 34,  53,  23,  255,
    34,  52,  23,  255, 36,  58,  23,  255, 69,  77,  43,  255, 143, 148, 97,  255, 200, 211, 136, 255, 206, 222, 138, 255, 199, 216, 136, 255, 159,
    186, 113, 255, 126, 154, 93,  255, 122, 149, 81,  255, 131, 161, 87,  255, 169, 198, 83,  255, 174, 204, 77,  255, 199, 222, 114, 255, 227, 238,
    141, 255, 147, 180, 96,  255, 130, 170, 93,  255, 139, 172, 111, 255, 147, 179, 125, 255, 172, 197, 130, 255, 103, 129, 60,  255, 60,  86,  39,
    255, 47,  65,  29,  255, 40,  58,  26,  255, 48,  60,  33,  255, 58,  62,  37,  255, 65,  75,  40,  255, 76,  89,  48,  255, 69,  76,  44,  255,
    71,  92,  39,  255, 60,  79,  34,  255, 42,  65,  29,  255, 37,  63,  26,  255, 51,  81,  29,  255, 73,  110, 48,  255, 78,  108, 60,  255, 50,
    75,  43,  255, 58,  81,  48,  255, 158, 176, 110, 255, 140, 174, 126, 255, 131, 169, 124, 255, 133, 170, 117, 255, 122, 160, 102, 255, 115, 155,
    92,  255, 116, 157, 82,  255, 122, 162, 75,  255, 145, 180, 77,  255, 161, 195, 85,  255, 158, 189, 86,  255, 117, 139, 63,  255, 91,  112, 55,
    255, 89,  116, 53,  255, 76,  100, 47,  255, 141, 165, 100, 255, 129, 169, 114, 255, 141, 171, 119, 255, 203, 218, 151, 255, 170, 201, 153, 255,
    198, 219, 159, 255, 169, 186, 109, 255, 189, 195, 111, 255, 183, 196, 135, 255, 139, 168, 139, 255, 138, 167, 137, 255, 145, 174, 146, 255, 125,
    151, 115, 255, 118, 143, 82,  255, 199, 203, 115, 255, 68,  76,  33,  255, 72,  103, 32,  255, 75,  109, 34,  255, 100, 131, 53,  255, 128, 161,
    74,  255, 161, 183, 90,  255, 171, 192, 91,  255, 156, 180, 81,  255, 126, 155, 72,  255, 148, 173, 93,  255, 153, 179, 97,  255, 98,  135, 77,
    255, 93,  131, 82,  255, 108, 145, 87,  255, 138, 172, 96,  255, 158, 186, 102, 255, 168, 188, 96,  255, 60,  78,  31,  255, 19,  40,  17,  255,
    40,  56,  23,  255, 172, 185, 104, 255, 219, 231, 156, 255, 210, 222, 150, 255, 178, 200, 118, 255, 194, 214, 149, 255, 188, 210, 156, 255, 185,
    210, 154, 255, 183, 209, 146, 255, 165, 191, 109, 255, 145, 165, 67,  255, 101, 125, 53,  255, 117, 142, 62,  255, 153, 174, 75,  255, 173, 191,
    96,  255, 129, 149, 73,  255, 102, 133, 63,  255, 115, 144, 77,  255, 146, 166, 80,  255, 176, 189, 87,  255, 138, 145, 72,  255, 65,  77,  47,
    255, 47,  60,  36,  255, 52,  68,  32,  255, 58,  84,  32,  255, 47,  69,  28,  255, 56,  79,  36,  255, 105, 132, 58,  255, 123, 150, 63,  255,
    166, 184, 77,  255, 154, 176, 71,  255, 126, 153, 63,  255, 120, 148, 63,  255, 140, 161, 99,  255, 196, 210, 120, 255, 221, 229, 120, 255, 200,
    211, 101, 255, 165, 182, 83,  255, 188, 193, 73,  255, 207, 207, 96,  255, 198, 205, 108, 255, 196, 195, 102, 255, 184, 194, 122, 255, 153, 182,
    141, 255, 138, 158, 107, 255, 152, 170, 113, 255, 146, 177, 133, 255, 158, 181, 119, 255, 206, 220, 144, 255, 203, 216, 136, 255, 201, 215, 144,
    255, 205, 214, 108, 255, 217, 221, 82,  255, 224, 230, 84,  255, 224, 231, 96,  255, 215, 223, 123, 255, 208, 220, 142, 255, 217, 224, 144, 255,
    145, 166, 75,  255, 114, 150, 58,  255, 139, 162, 79,  255, 95,  126, 62,  255, 109, 142, 74,  255, 146, 165, 90,  255, 220, 221, 143, 255, 166,
    186, 160, 255, 146, 174, 142, 255, 152, 177, 120, 255, 194, 202, 125, 255, 149, 171, 78,  255, 155, 180, 87,  255, 200, 215, 134, 255, 241, 243,
    167, 255, 208, 206, 138, 255, 176, 192, 152, 255, 132, 158, 74,  255, 154, 177, 94,  255, 120, 142, 52,  255, 145, 157, 87,  255, 149, 163, 77,
    255, 144, 173, 93,  255, 165, 183, 95,  255, 186, 196, 98,  255, 196, 198, 98,  255, 156, 171, 81,  255, 120, 160, 63,  255, 107, 143, 52,  255,
    77,  94,  38,  255, 47,  67,  31,  255, 38,  58,  25,  255, 43,  68,  25,  255, 46,  75,  25,  255, 81,  108, 29,  255, 96,  127, 36,  255, 90,
    121, 33,  255, 90,  119, 32,  255, 108, 135, 38,  255, 115, 139, 42,  255, 169, 184, 68,  255, 176, 195, 72,  255, 182, 196, 67,  255, 171, 189,
    87,  255, 154, 180, 83,  255, 171, 190, 68,  255, 191, 206, 89,  255, 204, 216, 104, 255, 190, 205, 100, 255, 169, 185, 116, 255, 153, 156, 106,
    255, 201, 216, 132, 255, 121, 142, 53,  255, 87,  114, 34,  255, 75,  106, 36,  255, 162, 166, 89,  255, 241, 231, 140, 255, 212, 213, 130, 255,
    142, 151, 82,  255, 120, 136, 40,  255, 207, 205, 106, 255, 220, 222, 126, 255, 210, 211, 106, 255, 227, 223, 133, 255, 223, 221, 118, 255, 233,
    227, 122, 255, 236, 230, 125, 255, 232, 227, 123, 255, 162, 174, 99,  255, 42,  49,  37,  255, 17,  19,  21,  255, 19,  23,  19,  255, 52,  52,
    38,  255, 87,  89,  60,  255, 175, 182, 116, 255, 191, 213, 160, 255, 214, 225, 147, 255, 225, 236, 150, 255, 213, 223, 130, 255, 217, 228, 128,
    255, 212, 219, 108, 255, 228, 234, 132, 255, 214, 226, 125, 255, 164, 187, 95,  255, 170, 188, 93,  255, 183, 202, 115, 255, 178, 199, 113, 255,
    94,  126, 46,  255, 107, 146, 45,  255, 112, 154, 52,  255, 126, 159, 67,  255, 112, 136, 50,  255, 142, 161, 72,  255, 150, 185, 73,  255, 195,
    202, 100, 255, 232, 221, 143, 255, 205, 204, 121, 255, 170, 192, 115, 255, 168, 192, 105, 255, 143, 169, 76,  255, 78,  87,  55,  255, 49,  52,
    38,  255, 73,  97,  29,  255, 91,  127, 43,  255, 116, 146, 84,  255, 125, 155, 106, 255, 76,  105, 45,  255, 96,  123, 43,  255, 60,  74,  31,
    255, 31,  39,  26,  255, 32,  41,  26,  255, 19,  23,  19,  255, 60,  62,  42,  255, 200, 206, 143, 255, 224, 241, 160, 255, 208, 232, 141, 255,
    191, 219, 111, 255, 188, 215, 102, 255, 184, 210, 98,  255, 158, 189, 90,  255, 128, 151, 73,  255, 163, 182, 87,  255, 190, 210, 115, 255, 194,
    214, 136, 255, 189, 208, 121, 255, 184, 199, 117, 255, 178, 198, 110, 255, 172, 201, 122, 255, 161, 193, 119, 255, 151, 187, 123, 255, 170, 196,
    131, 255, 108, 137, 62,  255, 75,  108, 45,  255, 60,  81,  38,  255, 60,  72,  40,  255, 62,  73,  42,  255, 36,  49,  26,  255, 53,  69,  37,
    255, 52,  63,  39,  255, 33,  40,  25,  255, 55,  71,  33,  255, 72,  102, 37,  255, 67,  103, 42,  255, 58,  92,  47,  255, 65,  100, 48,  255,
    91,  124, 53,  255, 101, 137, 60,  255, 67,  98,  47,  255, 105, 125, 72,  255, 185, 204, 144, 255, 166, 192, 127, 255, 164, 192, 121, 255, 148,
    182, 107, 255, 144, 178, 95,  255, 166, 193, 94,  255, 185, 206, 92,  255, 183, 199, 80,  255, 160, 179, 68,  255, 128, 150, 60,  255, 78,  99,
    48,  255, 47,  68,  47,  255, 58,  84,  47,  255, 68,  102, 41,  255, 147, 170, 95,  255, 157, 185, 119, 255, 132, 169, 116, 255, 152, 179, 121,
    255, 226, 234, 159, 255, 181, 208, 148, 255, 177, 207, 153, 255, 191, 207, 136, 255, 165, 172, 94,  255, 191, 200, 128, 255, 129, 159, 124, 255,
    134, 165, 130, 255, 145, 172, 145, 255, 116, 138, 89,  255, 175, 191, 105, 255, 167, 168, 92,  255, 31,  39,  23,  255, 62,  86,  31,  255, 80,
    117, 37,  255, 117, 147, 56,  255, 165, 187, 84,  255, 166, 187, 92,  255, 162, 184, 83,  255, 148, 174, 75,  255, 100, 134, 87,  255, 124, 154,
    100, 255, 181, 203, 105, 255, 140, 163, 103, 255, 119, 153, 89,  255, 162, 190, 98,  255, 178, 199, 98,  255, 165, 185, 92,  255, 109, 134, 50,
    255, 67,  97,  39,  255, 119, 135, 84,  255, 182, 190, 141, 255, 216, 228, 176, 255, 215, 231, 176, 255, 195, 209, 110, 255, 200, 215, 99,  255,
    179, 199, 139, 255, 169, 197, 142, 255, 173, 199, 131, 255, 176, 202, 127, 255, 206, 219, 126, 255, 165, 175, 76,  255, 155, 174, 87,  255, 156,
    185, 98,  255, 174, 201, 124, 255, 192, 216, 155, 255, 220, 226, 150, 255, 203, 207, 114, 255, 192, 202, 117, 255, 182, 200, 129, 255, 185, 204,
    138, 255, 183, 204, 141, 255, 177, 201, 140, 255, 174, 194, 137, 255, 169, 188, 139, 255, 156, 169, 114, 255, 58,  71,  28,  255, 26,  28,  21,
    255, 29,  41,  21,  255, 55,  86,  25,  255, 77,  103, 36,  255, 125, 145, 52,  255, 146, 164, 55,  255, 174, 192, 89,  255, 208, 218, 120, 255,
    197, 208, 110, 255, 200, 209, 116, 255, 192, 204, 109, 255, 179, 193, 91,  255, 89,  100, 40,  255, 65,  75,  47,  255, 146, 159, 101, 255, 71,
    78,  44,  255, 69,  84,  45,  255, 154, 181, 131, 255, 135, 156, 104, 255, 160, 179, 128, 255, 176, 201, 163, 255, 168, 187, 140, 255, 190, 206,
    128, 255, 202, 218, 137, 255, 198, 215, 140, 255, 204, 219, 83,  255, 198, 218, 74,  255, 160, 184, 77,  255, 134, 158, 73,  255, 181, 203, 157,
    255, 161, 189, 149, 255, 114, 150, 58,  255, 107, 146, 55,  255, 141, 164, 74,  255, 152, 163, 93,  255, 103, 120, 60,  255, 69,  103, 42,  255,
    107, 135, 68,  255, 199, 208, 129, 255, 166, 187, 157, 255, 145, 174, 137, 255, 142, 168, 122, 255, 183, 193, 113, 255, 144, 167, 81,  255, 196,
    203, 138, 255, 208, 216, 144, 255, 215, 228, 142, 255, 180, 203, 100, 255, 186, 207, 126, 255, 167, 185, 100, 255, 120, 149, 65,  255, 77,  105,
    26,  255, 136, 149, 80,  255, 180, 174, 77,  255, 215, 215, 118, 255, 212, 214, 123, 255, 191, 199, 98,  255, 127, 154, 75,  255, 117, 153, 69,
    255, 111, 151, 65,  255, 55,  86,  33,  255, 31,  53,  17,  255, 39,  62,  23,  255, 49,  73,  26,  255, 55,  91,  26,  255, 41,  74,  28,  255,
    58,  80,  25,  255, 102, 127, 36,  255, 96,  125, 34,  255, 118, 144, 46,  255, 137, 160, 55,  255, 147, 171, 72,  255, 165, 185, 84,  255, 180,
    203, 94,  255, 144, 168, 60,  255, 134, 146, 52,  255, 161, 175, 62,  255, 185, 197, 89,  255, 184, 200, 102, 255, 139, 159, 74,  255, 141, 159,
    81,  255, 149, 171, 117, 255, 150, 163, 114, 255, 203, 223, 168, 255, 158, 180, 100, 255, 76,  106, 26,  255, 92,  111, 31,  255, 201, 196, 107,
    255, 234, 226, 130, 255, 231, 224, 134, 255, 223, 224, 140, 255, 165, 181, 89,  255, 155, 161, 68,  255, 193, 199, 96,  255, 205, 204, 106, 255,
    204, 206, 101, 255, 218, 216, 98,  255, 238, 227, 113, 255, 235, 230, 131, 255, 238, 241, 173, 255, 232, 236, 167, 255, 216, 220, 163, 255, 185,
    190, 158, 255, 188, 193, 157, 255, 200, 209, 144, 255, 170, 188, 142, 255, 192, 209, 151, 255, 177, 192, 142, 255, 197, 204, 117, 255, 187, 200,
    109, 255, 183, 193, 87,  255, 211, 224, 106, 255, 210, 219, 109, 255, 227, 238, 135, 255, 165, 183, 87,  255, 159, 186, 100, 255, 171, 193, 110,
    255, 176, 192, 105, 255, 192, 211, 130, 255, 125, 163, 68,  255, 120, 160, 58,  255, 154, 184, 75,  255, 189, 207, 102, 255, 163, 178, 90,  255,
    162, 171, 89,  255, 188, 215, 100, 255, 132, 171, 55,  255, 203, 216, 130, 255, 218, 225, 153, 255, 206, 221, 151, 255, 205, 221, 160, 255, 124,
    135, 84,  255, 58,  53,  45,  255, 34,  41,  31,  255, 36,  47,  26,  255, 48,  60,  23,  255, 75,  95,  39,  255, 99,  121, 65,  255, 92,  116,
    55,  255, 65,  87,  47,  255, 29,  47,  21,  255, 38,  52,  26,  255, 31,  47,  21,  255, 42,  62,  23,  255, 118, 127, 68,  255, 189, 196, 106,
    255, 187, 197, 104, 255, 144, 155, 86,  255, 191, 206, 130, 255, 164, 184, 122, 255, 147, 171, 121, 255, 125, 155, 104, 255, 104, 127, 62,  255,
    111, 135, 67,  255, 167, 196, 141, 255, 166, 196, 153, 255, 168, 190, 111, 255, 119, 144, 65,  255, 112, 137, 62,  255, 154, 172, 86,  255, 165,
    183, 102, 255, 164, 187, 116, 255, 171, 192, 119, 255, 110, 138, 68,  255, 78,  118, 47,  255, 91,  127, 55,  255, 65,  83,  44,  255, 55,  69,
    47,  255, 63,  77,  47,  255, 72,  87,  41,  255, 60,  72,  37,  255, 55,  65,  36,  255, 74,  92,  36,  255, 95,  129, 44,  255, 94,  127, 52,
    255, 74,  102, 58,  255, 67,  92,  58,  255, 139, 168, 76,  255, 107, 149, 65,  255, 84,  129, 55,  255, 99,  132, 67,  255, 121, 149, 83,  255,
    121, 142, 62,  255, 116, 132, 62,  255, 121, 140, 69,  255, 119, 133, 67,  255, 114, 123, 62,  255, 106, 121, 60,  255, 81,  105, 40,  255, 60,
    94,  33,  255, 44,  75,  36,  255, 50,  75,  44,  255, 52,  79,  48,  255, 55,  80,  50,  255, 72,  100, 42,  255, 155, 179, 112, 255, 149, 179,
    118, 255, 159, 186, 113, 255, 160, 184, 132, 255, 223, 232, 156, 255, 162, 190, 89,  255, 168, 203, 151, 255, 192, 219, 171, 255, 191, 198, 114,
    255, 180, 189, 105, 255, 132, 159, 119, 255, 133, 164, 131, 255, 130, 159, 124, 255, 111, 135, 73,  255, 178, 192, 115, 255, 74,  75,  44,  255,
    26,  37,  23,  255, 68,  94,  36,  255, 79,  115, 36,  255, 140, 165, 65,  255, 179, 198, 87,  255, 162, 184, 82,  255, 150, 177, 65,  255, 153,
    176, 76,  255, 112, 141, 93,  255, 109, 138, 95,  255, 184, 203, 116, 255, 177, 202, 95,  255, 161, 178, 94,  255, 109, 137, 55,  255, 192, 209,
    78,  255, 172, 185, 68,  255, 60,  83,  39,  255, 179, 189, 141, 255, 235, 246, 193, 255, 218, 236, 187, 255, 194, 220, 173, 255, 221, 232, 157,
    255, 211, 221, 116, 255, 191, 209, 121, 255, 178, 197, 118, 255, 168, 194, 105, 255, 178, 199, 112, 255, 198, 212, 126, 255, 182, 184, 109, 255,
    89,  116, 60,  255, 188, 201, 121, 255, 201, 218, 135, 255, 171, 202, 131, 255, 176, 207, 147, 255, 188, 213, 156, 255, 228, 234, 156, 255, 222,
    222, 140, 255, 156, 187, 135, 255, 156, 190, 139, 255, 158, 192, 141, 255, 163, 198, 143, 255, 182, 213, 153, 255, 197, 216, 146, 255, 128, 139,
    74,  255, 63,  87,  33,  255, 26,  28,  23,  255, 19,  28,  23,  255, 36,  56,  25,  255, 44,  68,  23,  255, 47,  75,  21,  255, 60,  92,  26,
    255, 152, 173, 76,  255, 190, 202, 98,  255, 199, 211, 126, 255, 186, 203, 116, 255, 197, 208, 102, 255, 130, 134, 60,  255, 43,  49,  28,  255,
    23,  34,  19,  255, 58,  75,  36,  255, 119, 138, 72,  255, 142, 162, 95,  255, 186, 205, 136, 255, 143, 161, 100, 255, 177, 198, 146, 255, 191,
    216, 178, 255, 187, 208, 150, 255, 138, 166, 83,  255, 175, 199, 113, 255, 192, 209, 128, 255, 174, 194, 86,  255, 102, 134, 71,  255, 52,  75,
    39,  255, 45,  67,  21,  255, 141, 163, 107, 255, 182, 205, 178, 255, 137, 166, 97,  255, 103, 139, 48,  255, 184, 198, 124, 255, 183, 200, 105,
    255, 156, 166, 102, 255, 94,  114, 69,  255, 78,  103, 60,  255, 178, 189, 121, 255, 160, 184, 150, 255, 139, 169, 127, 255, 172, 189, 119, 255,
    139, 156, 63,  255, 99,  130, 40,  255, 115, 144, 73,  255, 130, 150, 90,  255, 155, 176, 87,  255, 154, 188, 68,  255, 173, 190, 73,  255, 121,
    138, 63,  255, 98,  126, 48,  255, 79,  107, 33,  255, 119, 138, 62,  255, 120, 138, 60,  255, 165, 177, 78,  255, 127, 150, 69,  255, 98,  132,
    55,  255, 96,  132, 52,  255, 86,  122, 42,  255, 58,  90,  31,  255, 32,  47,  21,  255, 43,  62,  23,  255, 47,  73,  28,  255, 62,  87,  29,
    255, 62,  95,  36,  255, 41,  65,  33,  255, 49,  74,  26,  255, 100, 123, 36,  255, 163, 180, 80,  255, 190, 207, 97,  255, 177, 196, 86,  255,
    169, 190, 81,  255, 167, 188, 81,  255, 176, 198, 90,  255, 145, 175, 69,  255, 108, 136, 48,  255, 112, 135, 50,  255, 120, 140, 68,  255, 109,
    137, 68,  255, 121, 137, 58,  255, 173, 195, 120, 255, 146, 168, 122, 255, 163, 183, 132, 255, 188, 211, 157, 255, 158, 175, 99,  255, 85,  101,
    32,  255, 138, 141, 46,  255, 225, 214, 115, 255, 229, 225, 127, 255, 225, 221, 128, 255, 216, 215, 128, 255, 195, 204, 117, 255, 149, 161, 86,
    255, 147, 162, 67,  255, 190, 190, 89,  255, 210, 205, 110, 255, 237, 228, 124, 255, 220, 216, 99,  255, 172, 179, 62,  255, 211, 210, 124, 255,
    250, 250, 180, 255, 246, 251, 161, 255, 251, 253, 165, 255, 254, 255, 174, 255, 245, 249, 172, 255, 210, 220, 158, 255, 184, 201, 143, 255, 183,
    196, 110, 255, 204, 218, 112, 255, 187, 208, 107, 255, 204, 217, 109, 255, 206, 217, 98,  255, 217, 225, 117, 255, 219, 230, 120, 255, 139, 161,
    62,  255, 158, 180, 90,  255, 182, 205, 125, 255, 172, 189, 102, 255, 186, 203, 126, 255, 138, 166, 77,  255, 185, 203, 90,  255, 212, 225, 114,
    255, 217, 229, 123, 255, 222, 234, 122, 255, 225, 235, 116, 255, 231, 238, 121, 255, 174, 200, 98,  255, 189, 205, 105, 255, 227, 233, 148, 255,
    186, 211, 149, 255, 188, 213, 166, 255, 200, 217, 153, 255, 97,  93,  60,  255, 41,  52,  36,  255, 60,  74,  44,  255, 67,  74,  41,  255, 71,
    87,  44,  255, 89,  115, 62,  255, 103, 125, 72,  255, 82,  106, 43,  255, 57,  86,  23,  255, 46,  72,  26,  255, 62,  79,  36,  255, 178, 187,
    103, 255, 223, 231, 126, 255, 219, 228, 120, 255, 189, 200, 107, 255, 107, 125, 60,  255, 149, 172, 118, 255, 126, 160, 120, 255, 115, 151, 118,
    255, 116, 151, 108, 255, 95,  121, 67,  255, 110, 132, 60,  255, 171, 194, 136, 255, 167, 195, 147, 255, 150, 176, 114, 255, 137, 168, 102, 255,
    164, 186, 91,  255, 136, 159, 65,  255, 119, 143, 65,  255, 118, 142, 68,  255, 75,  102, 41,  255, 63,  94,  47,  255, 71,  107, 55,  255, 91,
    129, 67,  255, 90,  113, 60,  255, 52,  58,  32,  255, 62,  72,  37,  255, 42,  47,  31,  255, 42,  52,  31,  255, 73,  91,  44,  255, 75,  97,
    39,  255, 100, 131, 52,  255, 99,  131, 52,  255, 94,  127, 50,  255, 79,  107, 48,  255, 145, 171, 78,  255, 111, 152, 74,  255, 86,  129, 62,
    255, 83,  129, 56,  255, 99,  136, 55,  255, 83,  119, 37,  255, 60,  97,  28,  255, 58,  83,  33,  255, 55,  74,  39,  255, 28,  48,  29,  255,
    32,  55,  31,  255, 47,  77,  29,  255, 65,  102, 37,  255, 68,  100, 49,  255, 62,  86,  55,  255, 85,  106, 75,  255, 96,  115, 94,  255, 134,
    149, 103, 255, 184, 202, 130, 255, 155, 182, 119, 255, 145, 176, 67,  255, 159, 186, 117, 255, 211, 222, 141, 255, 160, 186, 86,  255, 177, 208,
    154, 255, 196, 220, 174, 255, 228, 234, 161, 255, 219, 225, 146, 255, 205, 216, 154, 255, 191, 207, 151, 255, 134, 154, 107, 255, 106, 135, 76,
    255, 111, 125, 68,  255, 17,  21,  19,  255, 26,  37,  21,  255, 89,  118, 44,  255, 78,  111, 37,  255, 111, 140, 42,  255, 174, 194, 75,  255,
    163, 187, 74,  255, 140, 162, 52,  255, 143, 159, 74,  255, 134, 158, 99,  255, 102, 135, 94,  255, 175, 195, 139, 255, 183, 211, 119, 255, 185,
    209, 94,  255, 127, 152, 68,  255, 135, 163, 55,  255, 218, 229, 87,  255, 194, 199, 138, 255, 234, 245, 199, 255, 196, 222, 183, 255, 188, 219,
    172, 255, 211, 232, 176, 255, 232, 234, 140, 255, 174, 187, 91,  255, 173, 196, 133, 255, 177, 194, 116, 255, 165, 183, 98,  255, 139, 162, 80,
    255, 153, 174, 90,  255, 146, 163, 90,  255, 121, 148, 98,  255, 128, 155, 115, 255, 191, 204, 123, 255, 210, 222, 132, 255, 190, 212, 136, 255,
    180, 210, 153, 255, 189, 215, 157, 255, 225, 229, 150, 255, 168, 191, 134, 255, 154, 188, 130, 255, 169, 201, 134, 255, 190, 211, 130, 255, 164,
    173, 99,  255, 117, 137, 55,  255, 99,  131, 47,  255, 94,  127, 47,  255, 62,  75,  38,  255, 23,  31,  23,  255, 31,  46,  25,  255, 31,  38,
    26,  255, 34,  46,  23,  255, 110, 135, 50,  255, 190, 204, 91,  255, 205, 212, 116, 255, 200, 216, 138, 255, 176, 203, 120, 255, 179, 180, 95,
    255, 40,  51,  21,  255, 29,  38,  26,  255, 45,  67,  31,  255, 41,  67,  23,  255, 136, 151, 86,  255, 186, 207, 134, 255, 151, 179, 120, 255,
    140, 166, 83,  255, 161, 187, 130, 255, 137, 168, 119, 255, 119, 148, 65,  255, 132, 152, 80,  255, 197, 210, 139, 255, 181, 195, 109, 255, 104,
    130, 60,  255, 43,  75,  17,  255, 50,  69,  23,  255, 41,  65,  25,  255, 53,  86,  34,  255, 141, 171, 130, 255, 152, 181, 139, 255, 150, 171,
    95,  255, 97,  124, 58,  255, 135, 153, 80,  255, 187, 201, 115, 255, 154, 168, 110, 255, 75,  96,  41,  255, 142, 160, 93,  255, 165, 185, 139,
    255, 151, 177, 122, 255, 132, 147, 75,  255, 71,  92,  52,  255, 92,  110, 60,  255, 98,  122, 50,  255, 112, 129, 48,  255, 113, 138, 55,  255,
    151, 172, 90,  255, 155, 180, 73,  255, 132, 152, 60,  255, 144, 160, 67,  255, 156, 177, 73,  255, 92,  123, 47,  255, 124, 138, 47,  255, 137,
    162, 62,  255, 68,  106, 32,  255, 78,  112, 39,  255, 79,  115, 41,  255, 55,  87,  29,  255, 31,  51,  21,  255, 26,  36,  19,  255, 36,  51,
    23,  255, 34,  46,  21,  255, 78,  100, 39,  255, 65,  100, 46,  255, 47,  73,  33,  255, 58,  84,  29,  255, 143, 155, 67,  255, 221, 232, 122,
    255, 208, 226, 111, 255, 200, 217, 103, 255, 195, 213, 95,  255, 190, 209, 93,  255, 153, 171, 72,  255, 87,  111, 34,  255, 58,  86,  19,  255,
    81,  104, 31,  255, 98,  124, 47,  255, 109, 126, 44,  255, 163, 181, 96,  255, 176, 205, 158, 255, 148, 167, 120, 255, 164, 191, 147, 255, 167,
    192, 138, 255, 165, 178, 96,  255, 151, 152, 62,  255, 176, 175, 72,  255, 222, 211, 107, 255, 231, 226, 129, 255, 222, 219, 121, 255, 217, 213,
    119, 255, 196, 204, 115, 255, 156, 169, 91,  255, 161, 174, 80,  255, 192, 193, 87,  255, 210, 206, 107, 255, 211, 215, 106, 255, 151, 165, 55,
    255, 155, 165, 58,  255, 169, 178, 69,  255, 198, 202, 121, 255, 251, 251, 181, 255, 248, 250, 173, 255, 241, 246, 169, 255, 236, 243, 142, 255,
    249, 251, 153, 255, 235, 241, 148, 255, 215, 225, 124, 255, 179, 204, 116, 255, 152, 183, 119, 255, 195, 208, 129, 255, 229, 234, 129, 255, 235,
    239, 140, 255, 214, 228, 113, 255, 121, 153, 48,  255, 87,  120, 36,  255, 153, 177, 92,  255, 183, 205, 132, 255, 177, 193, 110, 255, 202, 218,
    118, 255, 205, 221, 108, 255, 212, 226, 119, 255, 218, 229, 114, 255, 213, 224, 105, 255, 209, 223, 109, 255, 191, 209, 94,  255, 177, 201, 99,
    255, 202, 213, 106, 255, 222, 229, 146, 255, 180, 207, 149, 255, 186, 207, 126, 255, 203, 220, 119, 255, 196, 209, 117, 255, 182, 196, 107, 255,
    189, 207, 102, 255, 196, 215, 113, 255, 194, 211, 110, 255, 208, 223, 123, 255, 201, 215, 123, 255, 141, 164, 62,  255, 98,  127, 45,  255, 93,
    118, 44,  255, 192, 197, 108, 255, 231, 234, 135, 255, 215, 221, 123, 255, 216, 224, 126, 255, 173, 183, 97,  255, 141, 154, 76,  255, 124, 143,
    78,  255, 149, 176, 123, 255, 128, 160, 121, 255, 122, 154, 117, 255, 104, 131, 75,  255, 121, 143, 71,  255, 161, 187, 125, 255, 173, 196, 143,
    255, 134, 163, 96,  255, 120, 156, 94,  255, 146, 174, 87,  255, 200, 211, 101, 255, 122, 138, 58,  255, 97,  127, 47,  255, 87,  127, 52,  255,
    92,  131, 60,  255, 95,  132, 55,  255, 89,  117, 52,  255, 69,  92,  47,  255, 50,  60,  36,  255, 69,  74,  42,  255, 49,  57,  36,  255, 65,
    83,  39,  255, 65,  82,  37,  255, 67,  92,  43,  255, 79,  108, 43,  255, 100, 129, 47,  255, 104, 136, 44,  255, 97,  131, 42,  255, 131, 154,
    55,  255, 155, 185, 79,  255, 121, 161, 84,  255, 132, 166, 87,  255, 107, 132, 63,  255, 55,  92,  38,  255, 68,  109, 41,  255, 68,  106, 37,
    255, 60,  80,  38,  255, 40,  62,  34,  255, 39,  58,  32,  255, 47,  71,  31,  255, 52,  79,  29,  255, 80,  114, 48,  255, 81,  105, 63,  255,
    126, 143, 99,  255, 183, 198, 153, 255, 210, 229, 191, 255, 196, 218, 162, 255, 188, 209, 125, 255, 175, 200, 92,  255, 160, 189, 91,  255, 189,
    206, 128, 255, 170, 190, 104, 255, 196, 218, 158, 255, 208, 226, 159, 255, 200, 220, 157, 255, 184, 213, 158, 255, 183, 214, 161, 255, 192, 220,
    163, 255, 200, 222, 162, 255, 192, 211, 149, 255, 75,  81,  52,  255, 60,  74,  33,  255, 160, 175, 80,  255, 195, 207, 97,  255, 159, 176, 80,
    255, 98,  125, 36,  255, 163, 184, 76,  255, 164, 178, 75,  255, 62,  79,  26,  255, 116, 134, 65,  255, 146, 172, 106, 255, 106, 143, 101, 255,
    126, 156, 115, 255, 191, 210, 138, 255, 172, 205, 92,  255, 173, 199, 98,  255, 117, 142, 53,  255, 199, 214, 119, 255, 233, 243, 191, 255, 197,
    220, 182, 255, 187, 216, 168, 255, 208, 230, 178, 255, 228, 231, 152, 255, 163, 175, 90,  255, 117, 147, 95,  255, 152, 178, 123, 255, 134, 165,
    107, 255, 121, 155, 97,  255, 116, 150, 97,  255, 120, 156, 106, 255, 144, 175, 114, 255, 163, 187, 113, 255, 151, 175, 111, 255, 119, 145, 78,
    255, 168, 185, 111, 255, 216, 219, 128, 255, 219, 226, 140, 255, 194, 218, 161, 255, 208, 224, 160, 255, 199, 213, 121, 255, 201, 216, 119, 255,
    192, 197, 116, 255, 102, 96,  55,  255, 26,  37,  17,  255, 76,  111, 37,  255, 119, 154, 67,  255, 107, 142, 55,  255, 110, 141, 50,  255, 58,
    65,  31,  255, 19,  28,  25,  255, 25,  33,  25,  255, 58,  74,  39,  255, 199, 212, 108, 255, 230, 233, 89,  255, 212, 217, 96,  255, 196, 213,
    134, 255, 163, 197, 124, 255, 171, 186, 111, 255, 79,  93,  47,  255, 56,  80,  36,  255, 57,  90,  26,  255, 94,  116, 52,  255, 154, 183, 130,
    255, 153, 184, 128, 255, 126, 159, 117, 255, 113, 139, 76,  255, 170, 182, 117, 255, 171, 182, 87,  255, 200, 214, 84,  255, 156, 185, 80,  255,
    133, 156, 91,  255, 145, 163, 72,  255, 48,  75,  19,  255, 39,  68,  17,  255, 52,  80,  21,  255, 62,  81,  33,  255, 73,  91,  39,  255, 100,
    121, 58,  255, 151, 176, 130, 255, 155, 175, 119, 255, 46,  75,  21,  255, 39,  58,  25,  255, 104, 127, 60,  255, 148, 167, 92,  255, 137, 154,
    91,  255, 116, 138, 69,  255, 170, 190, 126, 255, 141, 162, 93,  255, 55,  76,  41,  255, 46,  68,  47,  255, 67,  86,  58,  255, 97,  114, 58,
    255, 121, 138, 60,  255, 119, 141, 65,  255, 151, 169, 83,  255, 162, 184, 87,  255, 155, 182, 83,  255, 193, 207, 83,  255, 184, 202, 81,  255,
    137, 155, 69,  255, 147, 157, 75,  255, 47,  62,  26,  255, 67,  77,  36,  255, 117, 139, 71,  255, 96,  129, 50,  255, 92,  129, 41,  255, 93,
    127, 48,  255, 52,  76,  31,  255, 29,  40,  23,  255, 28,  37,  19,  255, 101, 122, 47,  255, 113, 143, 62,  255, 106, 132, 56,  255, 103, 132,
    43,  255, 102, 125, 36,  255, 118, 127, 50,  255, 148, 156, 68,  255, 156, 164, 75,  255, 138, 149, 69,  255, 84,  99,  40,  255, 53,  76,  21,
    255, 50,  76,  19,  255, 55,  83,  21,  255, 48,  73,  21,  255, 74,  82,  26,  255, 191, 200, 100, 255, 184, 211, 150, 255, 172, 200, 164, 255,
    150, 168, 118, 255, 167, 197, 153, 255, 179, 202, 141, 255, 204, 212, 121, 255, 178, 176, 69,  255, 187, 187, 89,  255, 193, 189, 84,  255, 233,
    222, 119, 255, 230, 225, 124, 255, 220, 217, 120, 255, 194, 204, 117, 255, 157, 172, 94,  255, 173, 183, 87,  255, 189, 192, 81,  255, 186, 189,
    83,  255, 162, 178, 68,  255, 136, 154, 52,  255, 168, 175, 74,  255, 171, 182, 77,  255, 160, 179, 109, 255, 172, 184, 132, 255, 238, 238, 161,
    255, 253, 254, 177, 255, 246, 249, 168, 255, 235, 241, 137, 255, 241, 246, 127, 255, 235, 236, 135, 255, 187, 190, 126, 255, 217, 220, 127, 255,
    255, 251, 150, 255, 255, 251, 164, 255, 255, 254, 169, 255, 250, 251, 161, 255, 186, 202, 112, 255, 102, 134, 49,  255, 110, 145, 47,  255, 159,
    184, 101, 255, 200, 216, 126, 255, 204, 221, 105, 255, 204, 221, 105, 255, 189, 208, 83,  255, 180, 201, 74,  255, 173, 194, 67,  255, 172, 193,
    71,  255, 173, 194, 76,  255, 182, 201, 87,  255, 189, 199, 96,  255, 205, 213, 126, 255, 182, 205, 125, 255, 184, 204, 126, 255, 188, 210, 152,
    255, 203, 219, 144, 255, 188, 209, 96,  255, 187, 209, 99,  255, 190, 209, 105, 255, 202, 218, 104, 255, 196, 208, 99,  255, 163, 172, 85,  255,
    188, 207, 74,  255, 164, 188, 60,  255, 181, 190, 94,  255, 227, 229, 137, 255, 216, 222, 129, 255, 221, 227, 124, 255, 203, 210, 111, 255, 158,
    169, 87,  255, 169, 178, 100, 255, 122, 142, 76,  255, 133, 151, 93,  255, 151, 177, 129, 255, 125, 157, 118, 255, 110, 135, 75,  255, 127, 151,
    71,  255, 130, 157, 84,  255, 136, 166, 95,  255, 118, 154, 83,  255, 127, 162, 95,  255, 134, 166, 93,  255, 200, 213, 122, 255, 145, 155, 81,
    255, 49,  73,  28,  255, 68,  90,  39,  255, 68,  87,  37,  255, 50,  68,  28,  255, 37,  53,  25,  255, 31,  49,  23,  255, 52,  68,  36,  255,
    47,  48,  34,  255, 38,  46,  28,  255, 63,  86,  36,  255, 53,  74,  33,  255, 55,  82,  38,  255, 47,  75,  36,  255, 42,  62,  32,  255, 56,
    71,  33,  255, 47,  60,  31,  255, 43,  55,  23,  255, 160, 172, 67,  255, 190, 206, 119, 255, 122, 145, 81,  255, 60,  95,  48,  255, 65,  101,
    49,  255, 62,  101, 42,  255, 74,  113, 41,  255, 79,  104, 42,  255, 48,  67,  36,  255, 43,  65,  40,  255, 49,  75,  36,  255, 47,  65,  32,
    255, 55,  71,  36,  255, 92,  127, 60,  255, 72,  104, 56,  255, 63,  89,  47,  255, 165, 180, 93,  255, 179, 205, 108, 255, 148, 186, 96,  255,
    142, 178, 98,  255, 146, 177, 87,  255, 172, 194, 100, 255, 187, 208, 108, 255, 195, 216, 133, 255, 172, 203, 128, 255, 179, 209, 127, 255, 185,
    215, 137, 255, 194, 222, 146, 255, 199, 221, 149, 255, 177, 196, 134, 255, 152, 169, 106, 255, 143, 157, 73,  255, 167, 187, 80,  255, 183, 201,
    98,  255, 197, 207, 106, 255, 226, 226, 109, 255, 189, 186, 77,  255, 74,  89,  34,  255, 65,  87,  36,  255, 49,  76,  31,  255, 86,  105, 43,
    255, 163, 185, 104, 255, 109, 146, 101, 255, 115, 151, 110, 255, 130, 161, 117, 255, 180, 204, 112, 255, 180, 207, 99,  255, 185, 203, 98,  255,
    211, 223, 154, 255, 195, 219, 174, 255, 187, 215, 167, 255, 217, 234, 177, 255, 231, 234, 150, 255, 164, 175, 76,  255, 134, 163, 84,  255, 153,
    181, 105, 255, 142, 172, 99,  255, 129, 164, 89,  255, 127, 162, 91,  255, 133, 168, 99,  255, 140, 173, 103, 255, 151, 183, 111, 255, 160, 188,
    117, 255, 162, 185, 109, 255, 145, 170, 97,  255, 140, 175, 109, 255, 164, 189, 99,  255, 217, 222, 105, 255, 223, 227, 131, 255, 215, 231, 169,
    255, 205, 206, 121, 255, 90,  91,  36,  255, 42,  53,  26,  255, 21,  40,  21,  255, 43,  68,  32,  255, 75,  112, 39,  255, 122, 156, 68,  255,
    142, 167, 76,  255, 154, 175, 68,  255, 124, 138, 47,  255, 58,  69,  32,  255, 52,  65,  33,  255, 120, 137, 63,  255, 157, 166, 93,  255, 142,
    150, 72,  255, 97,  111, 50,  255, 178, 199, 117, 255, 166, 200, 125, 255, 174, 206, 140, 255, 171, 194, 92,  255, 105, 128, 58,  255, 154, 171,
    115, 255, 163, 188, 130, 255, 139, 172, 122, 255, 160, 187, 101, 255, 150, 171, 100, 255, 143, 162, 81,  255, 172, 198, 87,  255, 177, 207, 71,
    255, 119, 154, 55,  255, 101, 133, 62,  255, 116, 141, 56,  255, 126, 149, 55,  255, 72,  100, 26,  255, 103, 119, 50,  255, 138, 150, 83,  255,
    165, 182, 109, 255, 174, 193, 124, 255, 182, 199, 125, 255, 172, 191, 105, 255, 103, 128, 56,  255, 44,  75,  19,  255, 44,  73,  23,  255, 67,
    95,  28,  255, 58,  83,  25,  255, 106, 128, 63,  255, 153, 163, 104, 255, 140, 164, 79,  255, 65,  89,  38,  255, 39,  60,  26,  255, 47,  67,
    21,  255, 75,  97,  42,  255, 124, 145, 71,  255, 146, 171, 87,  255, 160, 178, 81,  255, 153, 173, 79,  255, 171, 192, 96,  255, 146, 172, 78,
    255, 160, 180, 75,  255, 162, 179, 87,  255, 208, 214, 119, 255, 123, 146, 75,  255, 65,  84,  29,  255, 138, 155, 78,  255, 115, 144, 80,  255,
    86,  116, 52,  255, 96,  128, 50,  255, 135, 161, 71,  255, 143, 168, 82,  255, 40,  60,  31,  255, 72,  82,  26,  255, 162, 180, 77,  255, 170,
    187, 82,  255, 170, 187, 78,  255, 164, 182, 67,  255, 143, 175, 52,  255, 50,  77,  23,  255, 28,  42,  15,  255, 41,  58,  23,  255, 12,  17,
    17,  255, 9,   12,  17,  255, 42,  63,  25,  255, 53,  84,  21,  255, 58,  87,  21,  255, 40,  63,  19,  255, 111, 108, 53,  255, 222, 234, 157,
    255, 180, 209, 164, 255, 166, 196, 159, 255, 154, 173, 123, 255, 177, 206, 165, 255, 202, 219, 152, 255, 181, 199, 115, 255, 146, 161, 74,  255,
    192, 191, 98,  255, 174, 183, 87,  255, 176, 178, 76,  255, 220, 211, 106, 255, 230, 224, 123, 255, 202, 209, 125, 255, 159, 170, 95,  255, 192,
    195, 86,  255, 196, 196, 79,  255, 144, 153, 60,  255, 126, 147, 47,  255, 167, 179, 68,  255, 175, 184, 80,  255, 162, 178, 67,  255, 166, 185,
    114, 255, 196, 203, 142, 255, 239, 236, 143, 255, 238, 238, 142, 255, 236, 239, 147, 255, 229, 238, 129, 255, 225, 238, 126, 255, 226, 233, 123,
    255, 238, 235, 117, 255, 253, 249, 147, 255, 255, 250, 159, 255, 254, 249, 155, 255, 254, 249, 161, 255, 255, 251, 168, 255, 255, 255, 183, 255,
    216, 224, 145, 255, 133, 168, 65,  255, 155, 180, 75,  255, 205, 220, 106, 255, 192, 209, 93,  255, 154, 175, 84,  255, 132, 159, 65,  255, 160,
    187, 65,  255, 160, 185, 55,  255, 153, 180, 52,  255, 149, 176, 45,  255, 186, 202, 91,  255, 176, 196, 96,  255, 155, 174, 78,  255, 173, 197,
    133, 255, 188, 212, 170, 255, 192, 214, 177, 255, 200, 214, 149, 255, 184, 204, 97,  255, 182, 202, 87,  255, 195, 214, 86,  255, 193, 210, 94,
    255, 154, 173, 94,  255, 147, 161, 96,  255, 172, 185, 98,  255, 191, 212, 68,  255, 199, 215, 95,  255, 190, 206, 92,  255, 214, 225, 98,  255,
    206, 217, 95,  255, 140, 164, 56,  255, 132, 153, 67,  255, 154, 164, 87,  255, 119, 144, 71,  255, 79,  100, 47,  255, 102, 120, 67,  255, 141,
    165, 123, 255, 99,  127, 67,  255, 114, 142, 65,  255, 124, 150, 72,  255, 129, 163, 76,  255, 156, 183, 83,  255, 184, 204, 89,  255, 187, 205,
    97,  255, 174, 194, 110, 255, 155, 166, 102, 255, 33,  52,  26,  255, 25,  37,  23,  255, 23,  31,  21,  255, 29,  43,  26,  255, 46,  68,  36,
    255, 40,  62,  26,  255, 52,  69,  37,  255, 34,  41,  31,  255, 31,  42,  25,  255, 52,  69,  33,  255, 41,  63,  28,  255, 46,  69,  31,  255,
    40,  58,  29,  255, 33,  49,  36,  255, 40,  62,  37,  255, 29,  46,  25,  255, 52,  68,  29,  255, 127, 152, 73,  255, 109, 135, 81,  255, 82,
    117, 75,  255, 83,  123, 65,  255, 75,  117, 47,  255, 65,  107, 43,  255, 87,  127, 50,  255, 100, 132, 47,  255, 55,  76,  36,  255, 53,  74,
    46,  255, 58,  89,  46,  255, 43,  63,  31,  255, 21,  31,  21,  255, 58,  77,  33,  255, 89,  120, 52,  255, 142, 162, 91,  255, 176, 199, 99,
    255, 137, 167, 62,  255, 167, 190, 75,  255, 157, 189, 86,  255, 162, 191, 94,  255, 184, 210, 94,  255, 159, 191, 77,  255, 143, 166, 67,  255,
    138, 158, 72,  255, 170, 183, 98,  255, 166, 177, 94,  255, 134, 144, 72,  255, 121, 133, 65,  255, 65,  89,  28,  255, 98,  129, 45,  255, 152,
    177, 74,  255, 139, 166, 74,  255, 136, 164, 87,  255, 154, 178, 105, 255, 147, 172, 101, 255, 197, 200, 98,  255, 76,  85,  34,  255, 60,  83,
    42,  255, 83,  101, 52,  255, 100, 113, 58,  255, 187, 200, 104, 255, 153, 176, 109, 255, 126, 157, 108, 255, 133, 160, 119, 255, 212, 221, 149,
    255, 192, 213, 115, 255, 193, 216, 128, 255, 211, 226, 158, 255, 188, 216, 159, 255, 217, 233, 158, 255, 227, 230, 146, 255, 197, 211, 118, 255,
    185, 202, 108, 255, 122, 146, 60,  255, 116, 143, 65,  255, 148, 169, 80,  255, 170, 190, 89,  255, 164, 187, 102, 255, 159, 180, 105, 255, 163,
    183, 108, 255, 164, 182, 114, 255, 153, 174, 121, 255, 118, 145, 84,  255, 133, 160, 74,  255, 113, 129, 55,  255, 99,  109, 48,  255, 89,  96,
    48,  255, 68,  79,  38,  255, 92,  105, 63,  255, 103, 117, 63,  255, 28,  41,  23,  255, 25,  37,  23,  255, 23,  37,  21,  255, 55,  77,  37,
    255, 107, 138, 55,  255, 140, 169, 74,  255, 211, 213, 96,  255, 214, 215, 89,  255, 207, 211, 75,  255, 182, 191, 63,  255, 113, 128, 44,  255,
    43,  52,  26,  255, 38,  52,  23,  255, 58,  86,  31,  255, 62,  91,  39,  255, 170, 194, 95,  255, 165, 202, 123, 255, 181, 211, 137, 255, 194,
    215, 108, 255, 140, 166, 87,  255, 166, 187, 140, 255, 157, 183, 135, 255, 157, 182, 112, 255, 146, 178, 73,  255, 133, 170, 62,  255, 116, 159,
    58,  255, 109, 152, 52,  255, 78,  101, 43,  255, 50,  68,  33,  255, 41,  63,  42,  255, 90,  115, 50,  255, 123, 147, 52,  255, 144, 166, 77,
    255, 168, 191, 111, 255, 167, 192, 119, 255, 170, 194, 126, 255, 173, 198, 127, 255, 185, 206, 119, 255, 164, 184, 89,  255, 81,  109, 36,  255,
    39,  65,  21,  255, 31,  58,  19,  255, 60,  84,  31,  255, 74,  105, 33,  255, 62,  83,  36,  255, 135, 152, 95,  255, 151, 159, 107, 255, 89,
    105, 45,  255, 92,  119, 52,  255, 78,  102, 47,  255, 118, 145, 63,  255, 128, 158, 67,  255, 155, 179, 72,  255, 143, 166, 58,  255, 132, 158,
    65,  255, 172, 189, 87,  255, 131, 155, 68,  255, 143, 165, 81,  255, 159, 176, 99,  255, 195, 211, 128, 255, 108, 132, 62,  255, 126, 143, 60,
    255, 137, 162, 94,  255, 87,  118, 63,  255, 86,  115, 49,  255, 97,  127, 52,  255, 141, 165, 62,  255, 144, 166, 72,  255, 68,  81,  26,  255,
    158, 170, 69,  255, 176, 194, 87,  255, 164, 181, 74,  255, 170, 185, 75,  255, 185, 201, 100, 255, 165, 186, 63,  255, 131, 159, 49,  255, 83,
    111, 32,  255, 69,  100, 31,  255, 36,  52,  23,  255, 45,  62,  26,  255, 65,  102, 36,  255, 68,  105, 38,  255, 60,  97,  34,  255, 36,  65,
    19,  255, 100, 101, 47,  255, 204, 223, 164, 255, 182, 211, 170, 255, 168, 194, 157, 255, 162, 183, 132, 255, 199, 218, 168, 255, 218, 228, 145,
    255, 123, 154, 87,  255, 109, 141, 80,  255, 183, 189, 99,  255, 196, 199, 105, 255, 161, 175, 84,  255, 147, 160, 63,  255, 172, 176, 73,  255,
    178, 185, 92,  255, 151, 158, 87,  255, 162, 163, 62,  255, 111, 113, 40,  255, 130, 133, 47,  255, 200, 203, 71,  255, 233, 226, 76,  255, 214,
    215, 89,  255, 183, 195, 101, 255, 234, 231, 133, 255, 253, 245, 130, 255, 234, 233, 107, 255, 223, 225, 96,  255, 223, 225, 94,  255, 221, 231,
    112, 255, 225, 238, 116, 255, 233, 243, 96,  255, 251, 250, 99,  255, 255, 249, 128, 255, 254, 249, 165, 255, 255, 251, 170, 255, 255, 251, 168,
    255, 255, 251, 164, 255, 255, 253, 172, 255, 255, 255, 170, 255, 221, 229, 155, 255, 189, 207, 101, 255, 196, 214, 102, 255, 154, 176, 95,  255,
    138, 161, 92,  255, 153, 177, 76,  255, 165, 190, 58,  255, 168, 192, 77,  255, 186, 205, 86,  255, 187, 206, 82,  255, 170, 193, 77,  255, 159,
    185, 68,  255, 137, 161, 63,  255, 163, 184, 120, 255, 186, 211, 163, 255, 183, 210, 169, 255, 199, 216, 157, 255, 205, 219, 110, 255, 182, 202,
    74,  255, 166, 184, 75,  255, 142, 162, 92,  255, 163, 178, 133, 255, 189, 198, 157, 255, 194, 200, 159, 255, 198, 207, 133, 255, 169, 189, 81,
    255, 163, 182, 75,  255, 176, 188, 75,  255, 158, 182, 74,  255, 96,  137, 55,  255, 128, 153, 78,  255, 164, 178, 105, 255, 174, 191, 106, 255,
    167, 186, 103, 255, 147, 159, 76,  255, 144, 161, 83,  255, 117, 143, 68,  255, 158, 189, 110, 255, 163, 190, 100, 255, 149, 176, 71,  255, 173,
    190, 73,  255, 172, 186, 63,  255, 138, 154, 55,  255, 82,  100, 44,  255, 58,  79,  37,  255, 53,  77,  34,  255, 55,  77,  39,  255, 58,  83,
    40,  255, 69,  100, 47,  255, 69,  103, 47,  255, 63,  92,  40,  255, 58,  84,  41,  255, 40,  58,  32,  255, 39,  55,  34,  255, 39,  53,  29,
    255, 31,  44,  25,  255, 36,  53,  26,  255, 40,  62,  34,  255, 40,  60,  39,  255, 47,  75,  42,  255, 31,  48,  26,  255, 77,  92,  45,  255,
    154, 181, 89,  255, 86,  127, 75,  255, 97,  136, 81,  255, 94,  136, 62,  255, 82,  126, 49,  255, 106, 145, 55,  255, 147, 174, 60,  255, 120,
    144, 55,  255, 53,  82,  37,  255, 52,  74,  36,  255, 63,  90,  47,  255, 41,  58,  32,  255, 29,  43,  26,  255, 19,  31,  21,  255, 49,  58,
    36,  255, 205, 212, 149, 255, 201, 221, 143, 255, 185, 210, 112, 255, 170, 194, 92,  255, 171, 192, 84,  255, 181, 197, 85,  255, 153, 171, 77,
    255, 110, 137, 55,  255, 132, 158, 76,  255, 96,  130, 76,  255, 102, 131, 73,  255, 55,  84,  36,  255, 69,  97,  40,  255, 120, 137, 71,  255,
    112, 144, 74,  255, 127, 158, 81,  255, 127, 159, 86,  255, 128, 160, 86,  255, 135, 164, 92,  255, 156, 178, 101, 255, 171, 189, 97,  255, 211,
    208, 90,  255, 162, 169, 106, 255, 200, 214, 154, 255, 224, 233, 162, 255, 223, 235, 162, 255, 210, 229, 145, 255, 202, 224, 129, 255, 188, 212,
    135, 255, 192, 209, 139, 255, 224, 233, 160, 255, 183, 206, 147, 255, 180, 202, 128, 255, 189, 215, 136, 255, 209, 227, 134, 255, 205, 210, 97,
    255, 184, 201, 94,  255, 184, 203, 100, 255, 186, 206, 102, 255, 169, 190, 86,  255, 111, 142, 53,  255, 80,  116, 42,  255, 123, 150, 68,  255,
    149, 167, 110, 255, 120, 140, 80,  255, 130, 156, 86,  255, 127, 158, 92,  255, 116, 150, 86,  255, 112, 142, 69,  255, 125, 134, 72,  255, 40,
    53,  34,  255, 29,  47,  37,  255, 49,  73,  47,  255, 73,  101, 55,  255, 81,  110, 58,  255, 89,  118, 60,  255, 92,  121, 68,  255, 91,  116,
    63,  255, 79,  98,  53,  255, 55,  73,  36,  255, 106, 128, 50,  255, 160, 178, 78,  255, 214, 218, 102, 255, 202, 207, 79,  255, 169, 175, 65,
    255, 131, 140, 52,  255, 69,  87,  41,  255, 82,  109, 62,  255, 105, 135, 71,  255, 111, 140, 72,  255, 97,  124, 55,  255, 180, 204, 99,  255,
    168, 202, 117, 255, 178, 207, 120, 255, 168, 195, 93,  255, 182, 211, 137, 255, 197, 218, 167, 255, 158, 185, 130, 255, 134, 163, 104, 255, 115,
    152, 74,  255, 95,  138, 49,  255, 94,  135, 47,  255, 96,  122, 58,  255, 49,  65,  33,  255, 67,  84,  36,  255, 40,  60,  23,  255, 101, 119,
    47,  255, 146, 170, 83,  255, 159, 186, 114, 255, 157, 185, 114, 255, 160, 188, 116, 255, 165, 190, 115, 255, 171, 194, 101, 255, 187, 207, 106,
    255, 90,  115, 47,  255, 69,  95,  40,  255, 75,  81,  39,  255, 63,  68,  29,  255, 60,  65,  25,  255, 71,  84,  33,  255, 111, 122, 50,  255,
    189, 188, 97,  255, 137, 145, 82,  255, 108, 118, 75,  255, 63,  90,  28,  255, 89,  120, 49,  255, 123, 150, 65,  255, 147, 170, 74,  255, 156,
    178, 53,  255, 128, 153, 56,  255, 155, 175, 65,  255, 176, 185, 82,  255, 138, 158, 75,  255, 126, 151, 65,  255, 170, 188, 101, 255, 175, 198,
    134, 255, 126, 150, 87,  255, 132, 150, 75,  255, 104, 133, 71,  255, 87,  116, 56,  255, 101, 130, 58,  255, 129, 154, 63,  255, 137, 161, 65,
    255, 44,  68,  23,  255, 97,  99,  36,  255, 191, 205, 96,  255, 175, 191, 83,  255, 174, 190, 78,  255, 182, 200, 99,  255, 184, 203, 102, 255,
    169, 187, 69,  255, 156, 176, 60,  255, 121, 142, 43,  255, 106, 134, 36,  255, 87,  118, 36,  255, 94,  134, 52,  255, 69,  110, 42,  255, 60,
    95,  44,  255, 52,  84,  38,  255, 42,  76,  29,  255, 69,  82,  23,  255, 194, 200, 134, 255, 190, 218, 179, 255, 167, 191, 156, 255, 164, 187,
    141, 255, 212, 226, 168, 255, 146, 172, 102, 255, 108, 145, 81,  255, 132, 164, 97,  255, 172, 186, 101, 255, 209, 206, 115, 255, 198, 199, 108,
    255, 178, 190, 100, 255, 144, 167, 79,  255, 148, 157, 87,  255, 174, 169, 95,  255, 212, 206, 75,  255, 226, 216, 81,  255, 236, 227, 90,  255,
    241, 229, 80,  255, 248, 233, 86,  255, 254, 245, 144, 255, 255, 255, 179, 255, 255, 255, 171, 255, 255, 255, 170, 255, 255, 253, 156, 255, 255,
    250, 154, 255, 234, 238, 141, 255, 193, 205, 109, 255, 226, 226, 103, 255, 255, 255, 108, 255, 255, 253, 110, 255, 241, 241, 114, 255, 228, 233,
    112, 255, 235, 236, 122, 255, 241, 239, 146, 255, 239, 238, 143, 255, 249, 246, 155, 255, 249, 249, 162, 255, 246, 245, 161, 255, 225, 232, 150,
    255, 190, 209, 118, 255, 182, 205, 115, 255, 120, 146, 56,  255, 137, 161, 58,  255, 162, 186, 72,  255, 146, 175, 63,  255, 179, 198, 83,  255,
    168, 193, 80,  255, 137, 170, 55,  255, 136, 170, 52,  255, 144, 171, 60,  255, 162, 175, 101, 255, 167, 193, 144, 255, 178, 207, 168, 255, 203,
    218, 162, 255, 171, 183, 89,  255, 90,  110, 36,  255, 75,  97,  42,  255, 102, 119, 65,  255, 149, 160, 105, 255, 180, 186, 135, 255, 180, 185,
    139, 255, 161, 167, 109, 255, 143, 165, 68,  255, 145, 167, 75,  255, 140, 165, 69,  255, 152, 175, 68,  255, 141, 174, 76,  255, 149, 173, 95,
    255, 210, 221, 126, 255, 160, 185, 118, 255, 125, 160, 113, 255, 160, 183, 116, 255, 193, 210, 116, 255, 177, 202, 124, 255, 165, 195, 114, 255,
    159, 192, 112, 255, 170, 190, 99,  255, 117, 141, 62,  255, 107, 141, 47,  255, 76,  106, 44,  255, 52,  75,  40,  255, 53,  80,  31,  255, 87,
    117, 52,  255, 89,  122, 60,  255, 84,  117, 60,  255, 84,  121, 58,  255, 77,  113, 58,  255, 69,  106, 52,  255, 75,  114, 40,  255, 58,  92,
    36,  255, 55,  84,  40,  255, 60,  98,  32,  255, 44,  67,  26,  255, 38,  63,  28,  255, 47,  73,  39,  255, 46,  69,  42,  255, 52,  79,  42,
    255, 26,  44,  21,  255, 99,  119, 60,  255, 179, 197, 104, 255, 118, 156, 91,  255, 103, 149, 67,  255, 97,  143, 58,  255, 118, 158, 65,  255,
    195, 209, 67,  255, 147, 156, 58,  255, 56,  80,  37,  255, 68,  94,  33,  255, 67,  92,  33,  255, 52,  73,  32,  255, 39,  55,  31,  255, 28,
    47,  29,  255, 34,  51,  31,  255, 45,  55,  37,  255, 65,  74,  41,  255, 115, 129, 60,  255, 201, 212, 142, 255, 173, 196, 148, 255, 155, 178,
    116, 255, 143, 160, 76,  255, 101, 126, 55,  255, 89,  109, 58,  255, 104, 125, 60,  255, 130, 156, 84,  255, 102, 133, 79,  255, 58,  87,  53,
    255, 65,  92,  50,  255, 149, 155, 63,  255, 208, 209, 104, 255, 179, 189, 92,  255, 184, 193, 90,  255, 194, 203, 95,  255, 192, 199, 104, 255,
    182, 193, 109, 255, 216, 217, 108, 255, 219, 212, 113, 255, 136, 143, 91,  255, 230, 245, 198, 255, 221, 239, 202, 255, 210, 232, 186, 255, 200,
    227, 163, 255, 191, 220, 139, 255, 180, 212, 123, 255, 177, 209, 118, 255, 175, 206, 120, 255, 179, 204, 123, 255, 154, 177, 94,  255, 170, 192,
    95,  255, 145, 158, 62,  255, 141, 165, 52,  255, 172, 194, 68,  255, 169, 191, 67,  255, 168, 188, 67,  255, 164, 186, 71,  255, 137, 150, 62,
    255, 72,  90,  36,  255, 69,  105, 47,  255, 118, 146, 73,  255, 124, 150, 74,  255, 102, 137, 75,  255, 100, 134, 74,  255, 97,  135, 62,  255,
    137, 165, 69,  255, 95,  106, 56,  255, 52,  77,  47,  255, 91,  117, 72,  255, 121, 150, 82,  255, 119, 146, 74,  255, 112, 141, 74,  255, 113,
    142, 78,  255, 114, 143, 77,  255, 120, 147, 82,  255, 113, 139, 74,  255, 102, 124, 73,  255, 84,  108, 52,  255, 138, 162, 68,  255, 154, 176,
    75,  255, 105, 117, 47,  255, 60,  75,  34,  255, 84,  108, 48,  255, 130, 163, 91,  255, 144, 177, 98,  255, 135, 168, 96,  255, 126, 161, 94,
    255, 109, 144, 68,  255, 156, 176, 90,  255, 169, 201, 112, 255, 164, 195, 108, 255, 152, 187, 111, 255, 193, 220, 171, 255, 175, 200, 128, 255,
    142, 168, 101, 255, 109, 139, 97,  255, 111, 144, 81,  255, 103, 136, 55,  255, 78,  99,  39,  255, 95,  116, 60,  255, 50,  65,  33,  255, 60,
    82,  34,  255, 68,  97,  31,  255, 124, 145, 62,  255, 158, 185, 109, 255, 155, 183, 113, 255, 157, 183, 112, 255, 159, 185, 101, 255, 157, 183,
    84,  255, 181, 203, 99,  255, 144, 164, 80,  255, 29,  55,  15,  255, 78,  98,  49,  255, 204, 207, 139, 255, 194, 202, 147, 255, 187, 196, 137,
    255, 197, 198, 127, 255, 219, 218, 133, 255, 241, 238, 155, 255, 208, 200, 106, 255, 141, 148, 72,  255, 118, 133, 71,  255, 107, 130, 49,  255,
    115, 146, 68,  255, 152, 175, 71,  255, 149, 170, 60,  255, 123, 144, 60,  255, 177, 191, 69,  255, 151, 168, 74,  255, 121, 156, 68,  255, 138,
    164, 62,  255, 182, 203, 116, 255, 172, 199, 142, 255, 181, 201, 133, 255, 136, 162, 90,  255, 133, 162, 90,  255, 127, 154, 87,  255, 142, 162,
    76,  255, 151, 171, 74,  255, 62,  84,  36,  255, 17,  23,  12,  255, 128, 123, 49,  255, 203, 217, 105, 255, 186, 201, 89,  255, 183, 202, 87,
    255, 156, 187, 80,  255, 181, 200, 91,  255, 174, 190, 65,  255, 153, 172, 55,  255, 134, 153, 46,  255, 123, 145, 40,  255, 119, 150, 58,  255,
    112, 151, 72,  255, 74,  111, 58,  255, 63,  98,  50,  255, 55,  90,  38,  255, 58,  92,  39,  255, 58,  92,  21,  255, 153, 155, 78,  255, 200,
    224, 184, 255, 162, 186, 154, 255, 189, 203, 154, 255, 189, 209, 142, 255, 110, 150, 92,  255, 126, 161, 101, 255, 172, 191, 106, 255, 195, 205,
    108, 255, 217, 210, 127, 255, 223, 218, 136, 255, 212, 212, 123, 255, 192, 205, 113, 255, 162, 173, 84,  255, 229, 214, 84,  255, 255, 243, 96,
    255, 249, 235, 87,  255, 248, 234, 96,  255, 245, 233, 101, 255, 253, 241, 108, 255, 214, 214, 112, 255, 211, 214, 129, 255, 213, 220, 152, 255,
    195, 201, 125, 255, 181, 190, 96,  255, 167, 181, 94,  255, 140, 158, 74,  255, 119, 140, 58,  255, 145, 152, 60,  255, 243, 239, 110, 255, 220,
    223, 100, 255, 206, 217, 103, 255, 205, 218, 97,  255, 203, 215, 101, 255, 188, 206, 98,  255, 191, 208, 87,  255, 221, 228, 102, 255, 227, 232,
    114, 255, 220, 227, 108, 255, 205, 214, 105, 255, 168, 188, 87,  255, 152, 177, 68,  255, 108, 136, 47,  255, 132, 153, 63,  255, 117, 152, 53,
    255, 132, 163, 53,  255, 169, 189, 81,  255, 166, 192, 77,  255, 159, 185, 65,  255, 164, 189, 62,  255, 160, 186, 52,  255, 176, 194, 75,  255,
    158, 179, 108, 255, 175, 200, 157, 255, 207, 219, 153, 255, 141, 161, 79,  255, 94,  118, 52,  255, 89,  112, 47,  255, 98,  113, 58,  255, 95,
    113, 58,  255, 92,  120, 50,  255, 128, 148, 58,  255, 166, 181, 65,  255, 185, 204, 92,  255, 184, 204, 100, 255, 145, 172, 72,  255, 126, 157,
    58,  255, 134, 156, 60,  255, 140, 161, 78,  255, 156, 163, 69,  255, 174, 196, 107, 255, 133, 166, 109, 255, 137, 167, 124, 255, 180, 205, 149,
    255, 170, 196, 136, 255, 143, 173, 103, 255, 180, 202, 139, 255, 176, 193, 113, 255, 143, 168, 79,  255, 133, 161, 62,  255, 104, 134, 62,  255,
    94,  121, 55,  255, 100, 130, 52,  255, 113, 142, 62,  255, 99,  131, 63,  255, 77,  110, 60,  255, 74,  109, 58,  255, 72,  105, 58,  255, 74,
    103, 43,  255, 87,  122, 37,  255, 75,  109, 47,  255, 77,  113, 41,  255, 74,  110, 33,  255, 47,  68,  31,  255, 39,  62,  32,  255, 40,  65,
    37,  255, 47,  75,  38,  255, 42,  62,  32,  255, 25,  43,  19,  255, 91,  117, 47,  255, 184, 194, 110, 255, 159, 185, 102, 255, 154, 180, 78,
    255, 153, 171, 74,  255, 155, 167, 73,  255, 122, 133, 58,  255, 41,  62,  41,  255, 87,  114, 42,  255, 135, 164, 47,  255, 102, 136, 34,  255,
    73,  101, 37,  255, 58,  83,  37,  255, 57,  84,  36,  255, 47,  62,  34,  255, 37,  52,  29,  255, 47,  80,  25,  255, 63,  87,  31,  255, 185,
    198, 132, 255, 169, 194, 145, 255, 135, 157, 87,  255, 98,  123, 62,  255, 124, 156, 83,  255, 183, 205, 116, 255, 194, 209, 114, 255, 151, 168,
    84,  255, 102, 124, 72,  255, 73,  103, 67,  255, 65,  91,  52,  255, 93,  117, 50,  255, 171, 179, 84,  255, 182, 183, 87,  255, 180, 176, 91,
    255, 175, 173, 87,  255, 170, 170, 82,  255, 184, 185, 92,  255, 109, 114, 58,  255, 60,  68,  37,  255, 85,  91,  68,  255, 185, 193, 137, 255,
    225, 232, 157, 255, 219, 232, 174, 255, 218, 231, 178, 255, 220, 232, 166, 255, 216, 231, 151, 255, 213, 227, 131, 255, 212, 222, 121, 255, 199,
    212, 110, 255, 142, 155, 75,  255, 102, 123, 52,  255, 63,  90,  37,  255, 68,  95,  39,  255, 129, 160, 63,  255, 142, 167, 76,  255, 141, 166,
    84,  255, 128, 155, 79,  255, 79,  95,  45,  255, 93,  116, 47,  255, 115, 157, 49,  255, 127, 162, 68,  255, 100, 134, 82,  255, 98,  135, 77,
    255, 94,  129, 63,  255, 99,  135, 68,  255, 158, 183, 80,  255, 105, 116, 55,  255, 86,  117, 56,  255, 141, 167, 87,  255, 137, 158, 91,  255,
    146, 169, 102, 255, 163, 182, 113, 255, 145, 168, 107, 255, 139, 159, 103, 255, 111, 131, 91,  255, 88,  114, 72,  255, 97,  119, 65,  255, 65,
    92,  49,  255, 89,  120, 43,  255, 112, 139, 42,  255, 58,  82,  25,  255, 80,  102, 44,  255, 123, 152, 81,  255, 153, 180, 101, 255, 150, 176,
    105, 255, 147, 176, 109, 255, 136, 169, 104, 255, 121, 158, 90,  255, 176, 192, 112, 255, 186, 206, 102, 255, 148, 183, 95,  255, 184, 215, 162,
    255, 179, 205, 145, 255, 102, 119, 52,  255, 138, 163, 86,  255, 111, 146, 92,  255, 117, 146, 93,  255, 113, 144, 87,  255, 121, 148, 87,  255,
    142, 162, 69,  255, 83,  91,  43,  255, 31,  37,  25,  255, 56,  75,  29,  255, 132, 159, 69,  255, 159, 186, 111, 255, 166, 190, 118, 255, 183,
    198, 127, 255, 187, 202, 113, 255, 194, 207, 105, 255, 154, 169, 81,  255, 52,  75,  28,  255, 67,  86,  38,  255, 110, 125, 63,  255, 127, 151,
    78,  255, 174, 193, 139, 255, 180, 209, 162, 255, 175, 205, 162, 255, 197, 217, 155, 255, 229, 233, 153, 255, 235, 235, 149, 255, 173, 181, 87,
    255, 123, 142, 77,  255, 170, 179, 89,  255, 98,  119, 39,  255, 135, 162, 56,  255, 172, 189, 80,  255, 156, 169, 75,  255, 197, 201, 83,  255,
    154, 170, 74,  255, 137, 170, 82,  255, 147, 170, 73,  255, 157, 186, 106, 255, 174, 202, 130, 255, 155, 171, 94,  255, 156, 164, 81,  255, 185,
    199, 102, 255, 174, 191, 95,  255, 143, 162, 76,  255, 76,  104, 46,  255, 28,  39,  23,  255, 17,  17,  17,  255, 121, 113, 48,  255, 223, 229,
    128, 255, 190, 210, 112, 255, 149, 187, 74,  255, 160, 189, 106, 255, 201, 215, 106, 255, 167, 185, 62,  255, 137, 158, 50,  255, 151, 167, 52,
    255, 143, 161, 52,  255, 125, 156, 62,  255, 116, 154, 83,  255, 80,  117, 74,  255, 77,  116, 60,  255, 90,  126, 60,  255, 102, 135, 63,  255,
    87,  123, 52,  255, 76,  89,  26,  255, 193, 206, 156, 255, 170, 190, 151, 255, 189, 199, 129, 255, 123, 146, 67,  255, 133, 158, 76,  255, 145,
    169, 87,  255, 147, 168, 92,  255, 153, 170, 86,  255, 149, 149, 72,  255, 219, 213, 120, 255, 219, 219, 98,  255, 215, 218, 96,  255, 199, 205,
    80,  255, 231, 221, 80,  255, 254, 238, 94,  255, 254, 238, 97,  255, 255, 245, 110, 255, 255, 246, 122, 255, 251, 243, 127, 255, 179, 190, 84,
    255, 155, 174, 82,  255, 123, 149, 75,  255, 105, 128, 47,  255, 104, 130, 42,  255, 85,  116, 33,  255, 76,  111, 41,  255, 63,  98,  40,  255,
    68,  101, 33,  255, 112, 128, 55,  255, 79,  87,  31,  255, 192, 198, 98,  255, 220, 227, 133, 255, 223, 227, 135, 255, 216, 225, 131, 255, 182,
    204, 106, 255, 177, 201, 89,  255, 190, 203, 77,  255, 215, 218, 101, 255, 221, 219, 102, 255, 213, 214, 106, 255, 146, 164, 72,  255, 130, 160,
    58,  255, 130, 156, 63,  255, 128, 156, 63,  255, 158, 191, 97,  255, 142, 172, 80,  255, 140, 167, 71,  255, 141, 164, 68,  255, 161, 183, 58,
    255, 167, 190, 60,  255, 179, 200, 73,  255, 166, 188, 68,  255, 155, 177, 109, 255, 180, 198, 123, 255, 143, 173, 85,  255, 155, 183, 89,  255,
    160, 185, 80,  255, 162, 184, 77,  255, 147, 176, 86,  255, 107, 137, 62,  255, 204, 209, 112, 255, 223, 229, 111, 255, 216, 223, 113, 255, 228,
    233, 136, 255, 177, 195, 97,  255, 113, 139, 52,  255, 62,  84,  33,  255, 69,  94,  37,  255, 108, 122, 49,  255, 194, 200, 112, 255, 136, 167,
    91,  255, 175, 199, 146, 255, 191, 215, 154, 255, 148, 176, 109, 255, 166, 189, 133, 255, 178, 194, 121, 255, 135, 154, 75,  255, 167, 192, 84,
    255, 144, 171, 69,  255, 121, 151, 67,  255, 128, 157, 68,  255, 121, 150, 72,  255, 108, 136, 72,  255, 124, 149, 74,  255, 133, 155, 77,  255,
    83,  110, 48,  255, 71,  101, 46,  255, 62,  91,  43,  255, 82,  110, 40,  255, 101, 134, 52,  255, 87,  112, 41,  255, 44,  62,  32,  255, 46,
    72,  37,  255, 46,  68,  36,  255, 36,  58,  32,  255, 39,  58,  31,  255, 25,  37,  23,  255, 73,  94,  47,  255, 100, 127, 49,  255, 111, 130,
    62,  255, 139, 159, 77,  255, 111, 132, 58,  255, 71,  87,  39,  255, 39,  48,  31,  255, 45,  63,  49,  255, 44,  68,  40,  255, 116, 142, 47,
    255, 162, 184, 74,  255, 153, 173, 95,  255, 98,  129, 55,  255, 114, 147, 41,  255, 142, 173, 50,  255, 94,  111, 42,  255, 41,  65,  26,  255,
    52,  83,  28,  255, 41,  65,  29,  255, 141, 155, 84,  255, 176, 194, 121, 255, 106, 130, 55,  255, 168, 186, 98,  255, 210, 224, 125, 255, 192,
    215, 118, 255, 172, 204, 96,  255, 188, 211, 101, 255, 142, 153, 82,  255, 76,  102, 60,  255, 67,  89,  47,  255, 83,  112, 53,  255, 112, 137,
    72,  255, 100, 125, 80,  255, 92,  118, 71,  255, 95,  123, 62,  255, 135, 155, 72,  255, 156, 166, 80,  255, 63,  87,  39,  255, 39,  56,  34,
    255, 44,  57,  33,  255, 148, 168, 84,  255, 182, 200, 107, 255, 213, 222, 148, 255, 190, 209, 150, 255, 190, 209, 149, 255, 196, 212, 155, 255,
    191, 209, 152, 255, 169, 189, 133, 255, 162, 183, 108, 255, 138, 155, 74,  255, 92,  119, 52,  255, 63,  90,  38,  255, 71,  99,  42,  255, 113,
    147, 58,  255, 113, 144, 65,  255, 132, 160, 82,  255, 118, 148, 77,  255, 97,  132, 67,  255, 104, 139, 60,  255, 137, 163, 69,  255, 138, 169,
    102, 255, 115, 151, 103, 255, 115, 149, 84,  255, 110, 150, 78,  255, 146, 177, 90,  255, 183, 198, 95,  255, 141, 163, 89,  255, 114, 144, 82,
    255, 97,  129, 80,  255, 98,  133, 85,  255, 118, 151, 96,  255, 128, 157, 112, 255, 125, 155, 117, 255, 159, 181, 126, 255, 166, 183, 125, 255,
    145, 159, 102, 255, 111, 136, 76,  255, 105, 135, 77,  255, 60,  90,  32,  255, 71,  91,  36,  255, 69,  92,  31,  255, 125, 158, 68,  255, 154,
    180, 90,  255, 157, 180, 97,  255, 157, 181, 100, 255, 156, 184, 107, 255, 149, 181, 104, 255, 120, 141, 80,  255, 207, 217, 142, 255, 186, 209,
    94,  255, 173, 202, 110, 255, 185, 214, 136, 255, 115, 148, 68,  255, 130, 139, 68,  255, 160, 177, 83,  255, 124, 156, 85,  255, 119, 146, 86,
    255, 113, 143, 98,  255, 113, 146, 105, 255, 159, 185, 93,  255, 119, 138, 48,  255, 29,  31,  19,  255, 58,  75,  26,  255, 142, 169, 84,  255,
    159, 186, 109, 255, 163, 189, 105, 255, 189, 208, 128, 255, 178, 202, 147, 255, 169, 200, 140, 255, 188, 203, 122, 255, 139, 150, 73,  255, 103,
    130, 50,  255, 127, 153, 60,  255, 121, 128, 71,  255, 146, 142, 78,  255, 217, 227, 145, 255, 181, 203, 150, 255, 176, 202, 158, 255, 208, 221,
    156, 255, 204, 218, 152, 255, 208, 219, 145, 255, 125, 138, 67,  255, 125, 144, 76,  255, 156, 167, 81,  255, 140, 163, 55,  255, 125, 154, 53,
    255, 169, 181, 93,  255, 227, 227, 121, 255, 210, 213, 96,  255, 189, 201, 84,  255, 165, 183, 71,  255, 144, 173, 80,  255, 129, 157, 82,  255,
    86,  103, 47,  255, 113, 124, 45,  255, 129, 136, 62,  255, 100, 118, 55,  255, 60,  84,  36,  255, 57,  86,  38,  255, 39,  52,  28,  255, 15,
    21,  15,  255, 118, 105, 49,  255, 233, 234, 140, 255, 178, 203, 116, 255, 146, 184, 90,  255, 182, 204, 126, 255, 162, 176, 72,  255, 144, 165,
    58,  255, 159, 176, 62,  255, 170, 180, 68,  255, 109, 123, 45,  255, 98,  119, 48,  255, 121, 159, 87,  255, 93,  129, 77,  255, 118, 153, 81,
    255, 137, 172, 89,  255, 130, 166, 83,  255, 58,  86,  39,  255, 19,  33,  9,   255, 109, 111, 60,  255, 154, 169, 105, 255, 146, 167, 87,  255,
    142, 161, 76,  255, 92,  112, 50,  255, 37,  47,  21,  255, 41,  49,  17,  255, 121, 125, 55,  255, 215, 215, 121, 255, 222, 220, 112, 255, 234,
    230, 118, 255, 226, 223, 103, 255, 207, 210, 78,  255, 188, 194, 71,  255, 208, 204, 75,  255, 228, 221, 92,  255, 220, 214, 95,  255, 223, 216,
    107, 255, 232, 233, 139, 255, 137, 155, 84,  255, 127, 146, 65,  255, 119, 141, 47,  255, 161, 176, 50,  255, 195, 202, 67,  255, 157, 172, 60,
    255, 92,  122, 47,  255, 113, 139, 60,  255, 101, 125, 49,  255, 47,  57,  21,  255, 156, 159, 83,  255, 227, 235, 133, 255, 221, 228, 133, 255,
    216, 225, 129, 255, 216, 226, 129, 255, 206, 221, 122, 255, 172, 198, 82,  255, 151, 178, 52,  255, 148, 171, 62,  255, 106, 131, 52,  255, 150,
    175, 73,  255, 153, 183, 79,  255, 163, 192, 89,  255, 172, 203, 111, 255, 181, 207, 117, 255, 170, 197, 115, 255, 117, 146, 60,  255, 125, 151,
    60,  255, 135, 157, 68,  255, 155, 179, 62,  255, 163, 189, 74,  255, 186, 207, 117, 255, 177, 201, 90,  255, 139, 165, 68,  255, 135, 163, 69,
    255, 127, 163, 58,  255, 137, 170, 75,  255, 157, 183, 87,  255, 156, 181, 72,  255, 130, 157, 62,  255, 88,  105, 38,  255, 210, 214, 116, 255,
    227, 232, 130, 255, 221, 226, 123, 255, 232, 234, 138, 255, 184, 198, 101, 255, 87,  107, 37,  255, 97,  120, 47,  255, 106, 135, 52,  255, 114,
    138, 55,  255, 149, 160, 71,  255, 201, 213, 125, 255, 189, 205, 141, 255, 155, 180, 113, 255, 145, 175, 122, 255, 135, 169, 127, 255, 151, 178,
    121, 255, 127, 149, 67,  255, 134, 161, 62,  255, 99,  129, 56,  255, 112, 144, 62,  255, 102, 134, 63,  255, 78,  109, 65,  255, 78,  111, 68,
    255, 105, 133, 63,  255, 124, 141, 69,  255, 47,  65,  29,  255, 43,  65,  29,  255, 60,  84,  37,  255, 48,  74,  33,  255, 60,  76,  34,  255,
    43,  65,  33,  255, 34,  60,  33,  255, 42,  68,  36,  255, 48,  74,  38,  255, 33,  48,  29,  255, 19,  28,  19,  255, 68,  89,  50,  255, 122,
    151, 79,  255, 83,  109, 44,  255, 77,  116, 42,  255, 110, 145, 58,  255, 104, 137, 55,  255, 49,  81,  38,  255, 40,  58,  32,  255, 44,  60,
    37,  255, 31,  49,  28,  255, 103, 119, 39,  255, 188, 203, 82,  255, 249, 248, 172, 255, 203, 211, 144, 255, 156, 176, 73,  255, 166, 182, 55,
    255, 91,  108, 41,  255, 48,  77,  29,  255, 58,  86,  36,  255, 52,  75,  41,  255, 81,  102, 52,  255, 133, 154, 65,  255, 200, 213, 112, 255,
    213, 230, 143, 255, 180, 209, 124, 255, 177, 207, 100, 255, 211, 225, 107, 255, 186, 203, 120, 255, 166, 188, 110, 255, 117, 134, 68,  255, 73,
    96,  42,  255, 87,  119, 60,  255, 85,  112, 67,  255, 91,  118, 73,  255, 102, 126, 62,  255, 110, 135, 60,  255, 152, 169, 78,  255, 143, 151,
    77,  255, 58,  87,  41,  255, 52,  83,  39,  255, 108, 132, 68,  255, 187, 206, 110, 255, 187, 205, 114, 255, 224, 228, 138, 255, 223, 230, 153,
    255, 184, 206, 144, 255, 167, 197, 137, 255, 164, 194, 141, 255, 162, 189, 148, 255, 157, 183, 137, 255, 153, 172, 104, 255, 110, 135, 62,  255,
    110, 145, 68,  255, 124, 156, 75,  255, 131, 161, 80,  255, 129, 160, 72,  255, 128, 157, 73,  255, 91,  125, 69,  255, 101, 135, 65,  255, 112,
    146, 47,  255, 137, 163, 76,  255, 144, 178, 121, 255, 131, 167, 109, 255, 124, 161, 86,  255, 164, 193, 101, 255, 193, 203, 95,  255, 152, 171,
    87,  255, 138, 164, 106, 255, 96,  128, 84,  255, 87,  125, 83,  255, 103, 139, 83,  255, 115, 146, 90,  255, 107, 139, 97,  255, 109, 141, 100,
    255, 115, 149, 109, 255, 126, 160, 119, 255, 169, 187, 125, 255, 153, 172, 105, 255, 120, 155, 90,  255, 91,  109, 55,  255, 58,  82,  31,  255,
    87,  115, 41,  255, 108, 136, 48,  255, 124, 149, 63,  255, 141, 164, 79,  255, 151, 173, 91,  255, 146, 168, 93,  255, 105, 125, 62,  255, 109,
    120, 71,  255, 227, 236, 184, 255, 185, 203, 126, 255, 169, 198, 99,  255, 202, 223, 131, 255, 198, 214, 122, 255, 103, 131, 56,  255, 97,  126,
    49,  255, 166, 187, 94,  255, 106, 135, 69,  255, 115, 148, 106, 255, 105, 141, 106, 255, 144, 167, 98,  255, 163, 181, 74,  255, 140, 141, 72,
    255, 88,  110, 37,  255, 149, 177, 92,  255, 160, 186, 105, 255, 139, 174, 80,  255, 157, 187, 86,  255, 195, 210, 131, 255, 145, 176, 127, 255,
    161, 192, 136, 255, 200, 220, 129, 255, 152, 165, 82,  255, 154, 167, 89,  255, 160, 172, 91,  255, 221, 225, 129, 255, 184, 201, 123, 255, 195,
    208, 135, 255, 186, 208, 137, 255, 192, 212, 155, 255, 201, 217, 152, 255, 180, 206, 151, 255, 177, 199, 132, 255, 102, 119, 55,  255, 111, 136,
    82,  255, 137, 163, 73,  255, 109, 141, 43,  255, 162, 180, 86,  255, 229, 229, 119, 255, 200, 211, 119, 255, 205, 215, 100, 255, 164, 183, 65,
    255, 135, 152, 65,  255, 110, 117, 56,  255, 121, 124, 69,  255, 98,  120, 52,  255, 51,  81,  31,  255, 47,  76,  26,  255, 67,  92,  39,  255,
    65,  90,  47,  255, 39,  55,  29,  255, 23,  31,  23,  255, 55,  53,  25,  255, 126, 133, 62,  255, 144, 164, 80,  255, 172, 203, 117, 255, 122,
    158, 83,  255, 85,  104, 29,  255, 132, 147, 53,  255, 105, 118, 44,  255, 55,  72,  29,  255, 19,  36,  15,  255, 58,  71,  23,  255, 126, 156,
    87,  255, 140, 173, 99,  255, 144, 177, 94,  255, 122, 149, 78,  255, 65,  87,  44,  255, 32,  51,  15,  255, 90,  99,  40,  255, 137, 156, 72,
    255, 161, 185, 94,  255, 189, 211, 128, 255, 199, 216, 100, 255, 155, 179, 87,  255, 21,  34,  19,  255, 26,  29,  17,  255, 143, 138, 65,  255,
    243, 239, 141, 255, 238, 241, 153, 255, 229, 232, 139, 255, 233, 232, 133, 255, 209, 212, 92,  255, 193, 203, 72,  255, 173, 190, 69,  255, 151,
    170, 55,  255, 127, 151, 49,  255, 143, 154, 58,  255, 139, 158, 81,  255, 111, 131, 72,  255, 127, 149, 63,  255, 171, 184, 73,  255, 218, 219,
    74,  255, 228, 223, 68,  255, 220, 219, 73,  255, 161, 171, 62,  255, 170, 175, 72,  255, 169, 173, 72,  255, 170, 172, 78,  255, 224, 231, 122,
    255, 217, 226, 124, 255, 213, 224, 126, 255, 210, 222, 126, 255, 212, 225, 124, 255, 216, 226, 107, 255, 212, 223, 91,  255, 217, 226, 97,  255,
    193, 207, 82,  255, 110, 138, 40,  255, 154, 184, 85,  255, 160, 191, 98,  255, 177, 202, 111, 255, 182, 208, 120, 255, 179, 207, 119, 255, 189,
    214, 126, 255, 140, 164, 89,  255, 81,  102, 32,  255, 154, 175, 83,  255, 169, 195, 108, 255, 159, 189, 113, 255, 167, 199, 133, 255, 164, 196,
    120, 255, 161, 184, 91,  255, 131, 148, 65,  255, 148, 176, 53,  255, 146, 178, 62,  255, 150, 180, 80,  255, 158, 185, 80,  255, 114, 142, 44,
    255, 65,  96,  28,  255, 123, 137, 53,  255, 233, 233, 136, 255, 231, 236, 139, 255, 230, 234, 136, 255, 125, 136, 60,  255, 108, 134, 52,  255,
    100, 134, 56,  255, 90,  121, 56,  255, 80,  111, 55,  255, 82,  110, 55,  255, 159, 172, 77,  255, 164, 187, 115, 255, 119, 154, 102, 255, 123,
    159, 98,  255, 134, 168, 110, 255, 144, 178, 124, 255, 125, 154, 87,  255, 77,  106, 47,  255, 81,  113, 56,  255, 84,  116, 62,  255, 83,  115,
    62,  255, 114, 139, 73,  255, 134, 153, 75,  255, 140, 162, 87,  255, 103, 120, 65,  255, 44,  62,  34,  255, 60,  79,  42,  255, 41,  62,  26,
    255, 36,  52,  26,  255, 32,  49,  26,  255, 38,  62,  28,  255, 43,  65,  28,  255, 40,  65,  28,  255, 44,  69,  31,  255, 36,  53,  25,  255,
    48,  65,  33,  255, 109, 136, 72,  255, 109, 141, 55,  255, 91,  126, 50,  255, 74,  117, 40,  255, 134, 170, 60,  255, 112, 138, 52,  255, 37,
    60,  25,  255, 36,  55,  28,  255, 28,  39,  25,  255, 19,  28,  23,  255, 73,  84,  34,  255, 178, 191, 71,  255, 227, 230, 146, 255, 250, 249,
    176, 255, 243, 246, 171, 255, 166, 169, 100, 255, 37,  56,  25,  255, 52,  84,  31,  255, 62,  92,  38,  255, 58,  86,  47,  255, 77,  103, 50,
    255, 189, 203, 124, 255, 212, 231, 161, 255, 192, 218, 139, 255, 210, 227, 122, 255, 221, 229, 131, 255, 183, 196, 134, 255, 132, 167, 128, 255,
    146, 178, 127, 255, 144, 168, 102, 255, 94,  117, 55,  255, 95,  118, 68,  255, 83,  110, 67,  255, 85,  113, 62,  255, 102, 129, 60,  255, 136,
    155, 68,  255, 163, 172, 83,  255, 85,  101, 52,  255, 53,  83,  40,  255, 57,  87,  41,  255, 81,  109, 47,  255, 139, 158, 71,  255, 161, 180,
    87,  255, 165, 184, 91,  255, 195, 200, 108, 255, 227, 229, 141, 255, 195, 212, 139, 255, 165, 192, 126, 255, 154, 184, 128, 255, 158, 186, 148,
    255, 159, 184, 138, 255, 121, 142, 81,  255, 102, 136, 92,  255, 92,  126, 85,  255, 87,  121, 74,  255, 100, 136, 68,  255, 122, 156, 68,  255,
    130, 159, 65,  255, 98,  121, 44,  255, 60,  90,  21,  255, 113, 143, 74,  255, 170, 200, 139, 255, 150, 186, 117, 255, 176, 202, 107, 255, 173,
    186, 82,  255, 105, 129, 65,  255, 78,  113, 72,  255, 90,  124, 77,  255, 91,  127, 80,  255, 102, 135, 87,  255, 115, 146, 95,  255, 116, 149,
    101, 255, 120, 153, 104, 255, 120, 153, 104, 255, 125, 160, 105, 255, 176, 194, 114, 255, 156, 174, 96,  255, 106, 141, 77,  255, 113, 150, 86,
    255, 136, 159, 78,  255, 80,  105, 36,  255, 81,  111, 45,  255, 104, 127, 63,  255, 122, 141, 77,  255, 81,  93,  48,  255, 39,  47,  26,  255,
    47,  67,  32,  255, 63,  92,  26,  255, 153, 176, 112, 255, 209, 224, 182, 255, 150, 169, 118, 255, 183, 211, 161, 255, 223, 229, 155, 255, 192,
    195, 119, 255, 107, 133, 68,  255, 78,  113, 32,  255, 133, 163, 74,  255, 108, 138, 75,  255, 119, 154, 107, 255, 108, 141, 106, 255, 139, 163,
    107, 255, 189, 205, 104, 255, 171, 185, 89,  255, 116, 138, 52,  255, 156, 184, 96,  255, 147, 176, 84,  255, 115, 148, 55,  255, 93,  127, 58,
    255, 172, 189, 106, 255, 154, 181, 113, 255, 136, 169, 119, 255, 159, 189, 121, 255, 203, 219, 120, 255, 177, 191, 100, 255, 141, 156, 69,  255,
    195, 211, 123, 255, 164, 185, 124, 255, 161, 185, 136, 255, 206, 219, 135, 255, 184, 206, 117, 255, 188, 209, 132, 255, 182, 207, 157, 255, 175,
    202, 152, 255, 179, 188, 124, 255, 139, 144, 84,  255, 163, 171, 99,  255, 151, 166, 80,  255, 143, 158, 74,  255, 182, 191, 80,  255, 207, 215,
    109, 255, 186, 201, 121, 255, 194, 202, 110, 255, 199, 209, 138, 255, 195, 207, 145, 255, 169, 180, 123, 255, 197, 211, 147, 255, 58,  80,  29,
    255, 34,  53,  17,  255, 48,  68,  23,  255, 62,  84,  39,  255, 47,  68,  37,  255, 28,  40,  25,  255, 19,  29,  17,  255, 96,  99,  42,  255,
    186, 210, 92,  255, 191, 216, 102, 255, 77,  107, 49,  255, 43,  71,  25,  255, 38,  58,  21,  255, 52,  62,  38,  255, 69,  81,  47,  255, 69,
    80,  48,  255, 52,  68,  31,  255, 87,  111, 47,  255, 87,  109, 52,  255, 55,  72,  33,  255, 34,  47,  21,  255, 26,  40,  17,  255, 47,  52,
    12,  255, 220, 215, 126, 255, 212, 236, 141, 255, 172, 196, 99,  255, 135, 151, 94,  255, 83,  101, 38,  255, 84,  101, 42,  255, 56,  62,  29,
    255, 152, 162, 84,  255, 140, 148, 62,  255, 183, 186, 84,  255, 241, 236, 140, 255, 241, 241, 153, 255, 237, 236, 147, 255, 221, 227, 128, 255,
    199, 213, 77,  255, 178, 200, 62,  255, 141, 167, 48,  255, 143, 165, 52,  255, 166, 178, 82,  255, 111, 126, 65,  255, 174, 184, 71,  255, 157,
    182, 82,  255, 148, 173, 76,  255, 168, 185, 92,  255, 176, 191, 100, 255, 211, 211, 81,  255, 176, 181, 71,  255, 171, 176, 71,  255, 139, 146,
    58,  255, 158, 159, 74,  255, 223, 231, 120, 255, 213, 222, 120, 255, 210, 223, 125, 255, 210, 224, 129, 255, 218, 228, 121, 255, 221, 228, 99,
    255, 224, 230, 110, 255, 243, 241, 124, 255, 192, 204, 89,  255, 104, 136, 38,  255, 164, 191, 89,  255, 159, 189, 95,  255, 170, 196, 107, 255,
    184, 208, 119, 255, 185, 210, 121, 255, 193, 215, 130, 255, 175, 199, 116, 255, 145, 166, 86,  255, 172, 201, 126, 255, 166, 196, 134, 255, 161,
    187, 114, 255, 160, 184, 98,  255, 187, 206, 122, 255, 136, 159, 73,  255, 88,  110, 36,  255, 125, 142, 50,  255, 147, 170, 65,  255, 156, 181,
    73,  255, 160, 185, 84,  255, 73,  105, 37,  255, 58,  94,  44,  255, 77,  112, 52,  255, 139, 157, 77,  255, 209, 214, 124, 255, 187, 201, 112,
    255, 74,  105, 48,  255, 101, 117, 52,  255, 114, 144, 53,  255, 68,  105, 40,  255, 73,  108, 50,  255, 71,  105, 53,  255, 88,  112, 58,  255,
    147, 168, 102, 255, 141, 172, 107, 255, 128, 164, 113, 255, 121, 159, 100, 255, 119, 158, 91,  255, 112, 150, 86,  255, 101, 129, 49,  255, 160,
    182, 81,  255, 138, 164, 86,  255, 155, 172, 74,  255, 157, 175, 79,  255, 91,  125, 62,  255, 114, 145, 76,  255, 122, 137, 73,  255, 58,  77,
    44,  255, 41,  67,  23,  255, 47,  72,  26,  255, 29,  39,  23,  255, 26,  39,  23,  255, 40,  60,  31,  255, 34,  49,  26,  255, 26,  39,  23,
    255, 34,  48,  26,  255, 36,  51,  25,  255, 88,  108, 53,  255, 155, 177, 62,  255, 142, 172, 55,  255, 98,  136, 62,  255, 110, 147, 55,  255,
    163, 185, 69,  255, 73,  96,  42,  255, 36,  53,  28,  255, 36,  55,  29,  255, 36,  52,  28,  255, 29,  41,  26,  255, 47,  65,  26,  255, 143,
    162, 73,  255, 210, 215, 139, 255, 248, 248, 169, 255, 241, 243, 170, 255, 249, 248, 184, 255, 142, 147, 106, 255, 42,  65,  26,  255, 66,  96,
    38,  255, 84,  110, 50,  255, 141, 163, 82,  255, 228, 237, 169, 255, 206, 224, 144, 255, 204, 217, 132, 255, 204, 214, 140, 255, 177, 193, 124,
    255, 126, 161, 116, 255, 132, 168, 124, 255, 136, 172, 132, 255, 151, 181, 133, 255, 127, 149, 83,  255, 92,  116, 71,  255, 87,  116, 65,  255,
    100, 129, 58,  255, 136, 158, 65,  255, 155, 168, 73,  255, 106, 121, 56,  255, 47,  74,  40,  255, 55,  81,  46,  255, 50,  75,  41,  255, 92,
    121, 55,  255, 109, 137, 58,  255, 104, 132, 49,  255, 99,  127, 39,  255, 94,  122, 39,  255, 136, 151, 84,  255, 194, 200, 113, 255, 208, 218,
    124, 255, 170, 193, 116, 255, 154, 183, 121, 255, 158, 188, 148, 255, 130, 152, 91,  255, 97,  130, 79,  255, 97,  128, 87,  255, 86,  118, 77,
    255, 76,  110, 67,  255, 77,  115, 60,  255, 122, 152, 65,  255, 76,  108, 37,  255, 55,  92,  31,  255, 119, 148, 87,  255, 191, 216, 149, 255,
    150, 169, 101, 255, 107, 123, 52,  255, 146, 166, 65,  255, 115, 145, 58,  255, 113, 147, 72,  255, 114, 147, 83,  255, 99,  134, 80,  255, 100,
    137, 91,  255, 113, 148, 99,  255, 112, 148, 95,  255, 133, 164, 97,  255, 144, 168, 101, 255, 145, 165, 89,  255, 159, 175, 84,  255, 114, 146,
    77,  255, 105, 140, 84,  255, 99,  138, 74,  255, 145, 172, 90,  255, 163, 176, 107, 255, 198, 206, 143, 255, 222, 229, 168, 255, 225, 234, 172,
    255, 208, 217, 155, 255, 133, 141, 93,  255, 72,  97,  36,  255, 60,  92,  21,  255, 148, 171, 120, 255, 177, 194, 150, 255, 164, 188, 126, 255,
    201, 211, 140, 255, 169, 179, 99,  255, 116, 138, 84,  255, 95,  125, 91,  255, 101, 127, 58,  255, 90,  117, 48,  255, 115, 142, 75,  255, 117,
    150, 95,  255, 104, 138, 97,  255, 106, 138, 99,  255, 155, 176, 105, 255, 169, 189, 86,  255, 162, 180, 69,  255, 149, 167, 73,  255, 122, 145,
    65,  255, 111, 142, 55,  255, 110, 138, 49,  255, 128, 152, 77,  255, 166, 190, 112, 255, 135, 166, 100, 255, 138, 170, 104, 255, 183, 206, 115,
    255, 200, 203, 86,  255, 151, 161, 69,  255, 173, 193, 114, 255, 163, 184, 126, 255, 150, 179, 133, 255, 176, 201, 106, 255, 170, 195, 89,  255,
    195, 213, 126, 255, 189, 207, 144, 255, 196, 214, 157, 255, 229, 236, 168, 255, 229, 235, 170, 255, 225, 233, 164, 255, 233, 238, 176, 255, 232,
    233, 172, 255, 204, 203, 133, 255, 210, 213, 102, 255, 196, 211, 122, 255, 190, 213, 156, 255, 191, 217, 173, 255, 182, 202, 156, 255, 167, 178,
    120, 255, 182, 195, 142, 255, 44,  62,  21,  255, 41,  55,  21,  255, 38,  52,  23,  255, 29,  43,  21,  255, 40,  55,  26,  255, 50,  69,  39,
    255, 29,  47,  25,  255, 29,  36,  19,  255, 102, 112, 44,  255, 102, 134, 53,  255, 46,  71,  28,  255, 99,  119, 60,  255, 176, 189, 122, 255,
    204, 220, 153, 255, 209, 226, 155, 255, 217, 231, 160, 255, 200, 213, 140, 255, 77,  100, 48,  255, 55,  81,  29,  255, 32,  49,  19,  255, 34,
    51,  19,  255, 44,  62,  23,  255, 34,  47,  19,  255, 132, 127, 62,  255, 218, 226, 131, 255, 128, 151, 69,  255, 38,  62,  17,  255, 42,  68,
    26,  255, 23,  37,  15,  255, 117, 117, 50,  255, 192, 206, 110, 255, 171, 187, 86,  255, 175, 185, 84,  255, 200, 202, 103, 255, 241, 235, 137,
    255, 241, 239, 139, 255, 231, 235, 144, 255, 212, 223, 102, 255, 198, 214, 84,  255, 183, 198, 72,  255, 156, 172, 73,  255, 171, 179, 89,  255,
    174, 177, 92,  255, 222, 219, 95,  255, 205, 212, 82,  255, 188, 201, 84,  255, 152, 179, 80,  255, 154, 180, 94,  255, 195, 204, 122, 255, 180,
    186, 73,  255, 137, 148, 55,  255, 53,  60,  28,  255, 187, 190, 99,  255, 218, 230, 125, 255, 205, 219, 119, 255, 207, 220, 125, 255, 215, 225,
    118, 255, 220, 228, 107, 255, 226, 233, 120, 255, 243, 243, 131, 255, 235, 232, 123, 255, 138, 167, 72,  255, 117, 152, 62,  255, 166, 192, 87,
    255, 163, 193, 95,  255, 164, 192, 97,  255, 179, 204, 113, 255, 187, 211, 122, 255, 190, 213, 126, 255, 191, 211, 126, 255, 192, 212, 140, 255,
    187, 211, 151, 255, 176, 197, 128, 255, 109, 136, 60,  255, 103, 130, 41,  255, 137, 159, 60,  255, 159, 181, 78,  255, 165, 188, 99,  255, 116,
    140, 72,  255, 77,  97,  37,  255, 107, 124, 45,  255, 121, 141, 53,  255, 69,  103, 41,  255, 78,  112, 73,  255, 86,  119, 75,  255, 74,  107,
    60,  255, 83,  115, 53,  255, 86,  119, 56,  255, 86,  126, 58,  255, 78,  105, 50,  255, 103, 109, 45,  255, 117, 145, 49,  255, 73,  112, 38,
    255, 65,  105, 43,  255, 68,  100, 52,  255, 79,  105, 52,  255, 133, 154, 68,  255, 162, 180, 96,  255, 157, 181, 113, 255, 152, 180, 94,  255,
    127, 163, 67,  255, 128, 155, 62,  255, 183, 196, 84,  255, 189, 200, 99,  255, 154, 173, 90,  255, 106, 139, 68,  255, 80,  118, 58,  255, 127,
    156, 75,  255, 112, 131, 60,  255, 51,  81,  26,  255, 58,  90,  29,  255, 69,  96,  38,  255, 40,  55,  31,  255, 23,  37,  29,  255, 23,  34,
    26,  255, 17,  25,  21,  255, 21,  23,  21,  255, 48,  62,  37,  255, 42,  55,  31,  255, 113, 129, 62,  255, 201, 207, 67,  255, 177, 194, 69,
    255, 128, 160, 79,  255, 161, 183, 87,  255, 120, 138, 58,  255, 40,  65,  31,  255, 39,  58,  34,  255, 39,  63,  31,  255, 43,  71,  29,  255,
    34,  47,  31,  255, 83,  110, 47,  255, 84,  117, 44,  255, 152, 163, 97,  255, 255, 255, 180, 255, 241, 241, 166, 255, 246, 243, 174, 255, 255,
    255, 187, 255, 138, 144, 95,  255, 43,  65,  26,  255, 127, 152, 72,  255, 185, 203, 105, 255, 195, 207, 116, 255, 156, 181, 104, 255, 144, 176,
    121, 255, 137, 173, 120, 255, 175, 195, 120, 255, 131, 161, 109, 255, 116, 156, 112, 255, 131, 165, 118, 255, 143, 173, 136, 255, 152, 173, 122,
    255, 99,  124, 55,  255, 125, 151, 65,  255, 144, 165, 68,  255, 134, 148, 60,  255, 92,  108, 47,  255, 44,  68,  34,  255, 46,  72,  41,  255,
    43,  62,  41,  255, 49,  71,  38,  255, 109, 136, 60,  255, 113, 139, 58,  255, 106, 135, 52,  255, 96,  126, 38,  255, 97,  129, 58,  255, 97,
    126, 80,  255, 90,  115, 53,  255, 115, 135, 53,  255, 167, 184, 86,  255, 171, 191, 96,  255, 170, 192, 112, 255, 134, 158, 87,  255, 110, 143,
    80,  255, 108, 144, 81,  255, 127, 154, 83,  255, 129, 155, 84,  255, 135, 156, 87,  255, 122, 151, 76,  255, 100, 126, 58,  255, 58,  84,  47,
    255, 84,  108, 71,  255, 114, 132, 74,  255, 63,  87,  36,  255, 52,  83,  41,  255, 141, 158, 83,  255, 154, 178, 87,  255, 149, 174, 69,  255,
    121, 156, 94,  255, 153, 179, 107, 255, 144, 167, 87,  255, 132, 154, 79,  255, 151, 173, 95,  255, 151, 173, 105, 255, 128, 147, 87,  255, 118,
    143, 69,  255, 146, 170, 87,  255, 103, 140, 82,  255, 104, 139, 83,  255, 124, 153, 91,  255, 214, 224, 167, 255, 222, 235, 183, 255, 209, 228,
    177, 255, 198, 220, 171, 255, 193, 216, 169, 255, 191, 217, 164, 255, 200, 224, 165, 255, 174, 192, 121, 255, 87,  116, 38,  255, 132, 155, 80,
    255, 139, 154, 83,  255, 157, 173, 92,  255, 169, 184, 108, 255, 131, 154, 92,  255, 95,  117, 68,  255, 53,  68,  47,  255, 80,  101, 58,  255,
    94,  115, 55,  255, 123, 142, 62,  255, 134, 162, 68,  255, 93,  130, 62,  255, 80,  116, 71,  255, 81,  114, 60,  255, 114, 144, 67,  255, 123,
    150, 62,  255, 85,  115, 60,  255, 57,  90,  50,  255, 79,  117, 44,  255, 130, 162, 62,  255, 108, 136, 62,  255, 150, 168, 78,  255, 146, 175,
    94,  255, 135, 167, 95,  255, 149, 181, 100, 255, 199, 211, 95,  255, 151, 164, 68,  255, 168, 187, 109, 255, 164, 186, 123, 255, 149, 177, 130,
    255, 180, 200, 105, 255, 178, 199, 119, 255, 161, 188, 144, 255, 205, 214, 142, 255, 188, 203, 124, 255, 180, 209, 147, 255, 179, 199, 124, 255,
    176, 193, 96,  255, 159, 190, 83,  255, 164, 198, 90,  255, 194, 217, 122, 255, 211, 221, 137, 255, 206, 218, 145, 255, 198, 215, 162, 255, 190,
    205, 138, 255, 146, 160, 84,  255, 139, 143, 91,  255, 162, 179, 132, 255, 79,  108, 45,  255, 71,  100, 46,  255, 34,  46,  23,  255, 40,  47,
    23,  255, 48,  68,  31,  255, 47,  65,  29,  255, 43,  60,  34,  255, 19,  31,  21,  255, 62,  68,  28,  255, 151, 166, 106, 255, 169, 188, 127,
    255, 190, 215, 154, 255, 189, 218, 147, 255, 178, 209, 131, 255, 185, 209, 129, 255, 183, 202, 120, 255, 108, 129, 71,  255, 60,  84,  44,  255,
    78,  107, 48,  255, 63,  90,  37,  255, 40,  55,  19,  255, 53,  73,  25,  255, 48,  72,  26,  255, 46,  68,  21,  255, 90,  109, 42,  255, 60,
    82,  36,  255, 29,  40,  19,  255, 25,  37,  17,  255, 76,  89,  48,  255, 167, 184, 112, 255, 158, 187, 131, 255, 165, 190, 130, 255, 162, 190,
    130, 255, 159, 187, 127, 255, 170, 186, 103, 255, 212, 214, 103, 255, 228, 232, 109, 255, 212, 221, 105, 255, 200, 214, 81,  255, 185, 199, 73,
    255, 165, 173, 74,  255, 227, 225, 117, 255, 238, 238, 127, 255, 233, 233, 125, 255, 220, 220, 104, 255, 188, 191, 71,  255, 184, 192, 77,  255,
    176, 191, 83,  255, 185, 199, 122, 255, 152, 163, 75,  255, 52,  71,  26,  255, 53,  60,  23,  255, 209, 213, 116, 255, 216, 226, 124, 255, 208,
    221, 124, 255, 211, 227, 123, 255, 215, 227, 108, 255, 226, 233, 114, 255, 241, 243, 131, 255, 201, 206, 103, 255, 106, 134, 47,  255, 114, 150,
    65,  255, 125, 159, 75,  255, 160, 184, 77,  255, 172, 196, 94,  255, 168, 193, 97,  255, 174, 199, 107, 255, 184, 208, 125, 255, 186, 208, 122,
    255, 191, 212, 121, 255, 173, 189, 108, 255, 125, 149, 73,  255, 87,  119, 38,  255, 82,  118, 36,  255, 98,  131, 50,  255, 101, 132, 47,  255,
    112, 138, 43,  255, 166, 181, 83,  255, 207, 224, 139, 255, 116, 137, 69,  255, 81,  107, 48,  255, 89,  119, 47,  255, 101, 135, 55,  255, 80,
    114, 63,  255, 78,  109, 69,  255, 75,  107, 67,  255, 67,  100, 62,  255, 65,  96,  56,  255, 67,  98,  52,  255, 68,  104, 45,  255, 58,  84,
    32,  255, 113, 133, 41,  255, 135, 162, 47,  255, 99,  134, 40,  255, 72,  106, 40,  255, 68,  100, 50,  255, 84,  109, 58,  255, 142, 149, 81,
    255, 150, 170, 74,  255, 178, 198, 91,  255, 182, 200, 87,  255, 140, 160, 65,  255, 105, 135, 41,  255, 127, 153, 65,  255, 145, 170, 111, 255,
    125, 154, 81,  255, 94,  131, 65,  255, 133, 155, 74,  255, 50,  55,  28,  255, 47,  58,  31,  255, 48,  62,  31,  255, 37,  51,  26,  255, 31,
    43,  26,  255, 72,  92,  47,  255, 79,  101, 40,  255, 56,  75,  31,  255, 55,  65,  38,  255, 126, 151, 80,  255, 113, 141, 52,  255, 102, 131,
    43,  255, 146, 160, 50,  255, 183, 192, 72,  255, 207, 211, 104, 255, 175, 181, 94,  255, 55,  86,  31,  255, 42,  72,  31,  255, 46,  75,  33,
    255, 48,  84,  31,  255, 47,  75,  33,  255, 65,  76,  43,  255, 107, 132, 60,  255, 87,  119, 47,  255, 120, 142, 62,  255, 245, 243, 171, 255,
    250, 248, 171, 255, 238, 241, 167, 255, 249, 249, 178, 255, 235, 234, 166, 255, 102, 119, 71,  255, 111, 137, 71,  255, 200, 206, 87,  255, 173,
    196, 103, 255, 132, 170, 94,  255, 145, 178, 120, 255, 144, 179, 128, 255, 179, 197, 105, 255, 148, 170, 82,  255, 134, 164, 97,  255, 137, 169,
    106, 255, 134, 166, 112, 255, 133, 163, 116, 255, 106, 134, 68,  255, 108, 121, 49,  255, 86,  93,  42,  255, 42,  52,  26,  255, 84,  110, 49,
    255, 153, 171, 84,  255, 174, 184, 93,  255, 118, 127, 67,  255, 52,  71,  33,  255, 119, 143, 65,  255, 114, 141, 58,  255, 103, 134, 46,  255,
    98,  128, 34,  255, 91,  121, 60,  255, 119, 146, 75,  255, 116, 148, 73,  255, 108, 141, 60,  255, 115, 146, 62,  255, 123, 152, 65,  255, 133,
    160, 72,  255, 126, 154, 73,  255, 134, 160, 72,  255, 153, 179, 76,  255, 185, 205, 93,  255, 199, 216, 119, 255, 219, 227, 127, 255, 211, 214,
    118, 255, 106, 122, 65,  255, 44,  71,  37,  255, 57,  87,  49,  255, 62,  92,  49,  255, 67,  96,  41,  255, 69,  104, 44,  255, 129, 152, 77,
    255, 183, 194, 98,  255, 132, 158, 63,  255, 114, 152, 91,  255, 140, 177, 115, 255, 131, 149, 75,  255, 75,  96,  37,  255, 115, 144, 87,  255,
    90,  127, 76,  255, 76,  114, 48,  255, 132, 157, 78,  255, 127, 154, 84,  255, 103, 141, 82,  255, 109, 141, 87,  255, 199, 213, 158, 255, 220,
    232, 186, 255, 202, 222, 174, 255, 195, 218, 170, 255, 190, 215, 161, 255, 185, 212, 154, 255, 180, 208, 148, 255, 176, 206, 140, 255, 186, 213,
    139, 255, 168, 189, 96,  255, 100, 122, 43,  255, 67,  94,  32,  255, 145, 167, 95,  255, 190, 202, 124, 255, 164, 182, 126, 255, 139, 164, 115,
    255, 90,  114, 60,  255, 41,  58,  26,  255, 75,  99,  52,  255, 92,  120, 47,  255, 144, 167, 58,  255, 122, 152, 55,  255, 89,  124, 62,  255,
    87,  116, 68,  255, 111, 138, 80,  255, 99,  126, 63,  255, 89,  127, 75,  255, 72,  110, 52,  255, 63,  103, 36,  255, 91,  131, 47,  255, 110,
    145, 56,  255, 114, 144, 62,  255, 157, 181, 87,  255, 131, 162, 87,  255, 135, 167, 90,  255, 181, 201, 100, 255, 138, 161, 76,  255, 147, 171,
    95,  255, 171, 193, 118, 255, 149, 176, 111, 255, 160, 186, 113, 255, 174, 195, 124, 255, 187, 201, 137, 255, 214, 222, 147, 255, 111, 128, 52,
    255, 113, 133, 73,  255, 183, 205, 147, 255, 169, 193, 142, 255, 124, 148, 76,  255, 108, 126, 53,  255, 165, 189, 106, 255, 164, 191, 92,  255,
    148, 182, 74,  255, 168, 200, 89,  255, 191, 209, 87,  255, 151, 161, 65,  255, 189, 200, 160, 255, 174, 190, 157, 255, 137, 156, 92,  255, 172,
    187, 106, 255, 192, 197, 113, 255, 214, 215, 125, 255, 220, 227, 127, 255, 201, 211, 109, 255, 160, 175, 79,  255, 84,  108, 50,  255, 87,  92,
    41,  255, 194, 207, 132, 255, 195, 220, 138, 255, 190, 213, 119, 255, 205, 220, 121, 255, 223, 228, 143, 255, 160, 174, 97,  255, 106, 128, 52,
    255, 79,  108, 55,  255, 74,  101, 60,  255, 91,  113, 58,  255, 102, 129, 63,  255, 45,  65,  31,  255, 52,  75,  26,  255, 68,  87,  44,  255,
    67,  89,  43,  255, 84,  105, 44,  255, 53,  76,  34,  255, 32,  42,  23,  255, 123, 138, 82,  255, 168, 198, 132, 255, 143, 177, 130, 255, 139,
    170, 127, 255, 162, 187, 133, 255, 170, 194, 133, 255, 164, 192, 120, 255, 165, 188, 97,  255, 157, 176, 85,  255, 165, 179, 71,  255, 187, 196,
    87,  255, 142, 163, 60,  255, 140, 158, 49,  255, 218, 218, 99,  255, 233, 229, 113, 255, 233, 231, 118, 255, 238, 235, 118, 255, 231, 229, 121,
    255, 133, 150, 62,  255, 131, 144, 47,  255, 135, 145, 52,  255, 100, 120, 43,  255, 53,  82,  28,  255, 40,  65,  26,  255, 72,  86,  32,  255,
    218, 220, 127, 255, 220, 229, 134, 255, 218, 228, 129, 255, 222, 232, 110, 255, 229, 235, 111, 255, 220, 225, 113, 255, 164, 178, 83,  255, 91,
    128, 42,  255, 77,  118, 40,  255, 119, 149, 74,  255, 140, 171, 94,  255, 161, 183, 72,  255, 164, 186, 68,  255, 177, 200, 101, 255, 171, 196,
    101, 255, 182, 203, 119, 255, 186, 208, 122, 255, 191, 212, 118, 255, 117, 145, 60,  255, 74,  114, 34,  255, 82,  119, 43,  255, 97,  130, 49,
    255, 104, 136, 52,  255, 110, 142, 50,  255, 124, 152, 53,  255, 94,  118, 34,  255, 118, 135, 58,  255, 180, 200, 116, 255, 135, 160, 83,  255,
    102, 131, 78,  255, 130, 151, 68,  255, 117, 148, 60,  255, 122, 156, 69,  255, 133, 159, 74,  255, 71,  103, 58,  255, 60,  90,  55,  255, 58,
    84,  52,  255, 60,  89,  47,  255, 83,  111, 47,  255, 108, 141, 53,  255, 101, 133, 37,  255, 133, 154, 47,  255, 116, 146, 43,  255, 82,  120,
    41,  255, 103, 119, 62,  255, 117, 127, 73,  255, 87,  109, 42,  255, 109, 130, 48,  255, 107, 126, 55,  255, 99,  120, 58,  255, 103, 137, 56,
    255, 152, 182, 94,  255, 166, 190, 107, 255, 133, 161, 90,  255, 117, 146, 62,  255, 81,  91,  43,  255, 38,  51,  32,  255, 60,  89,  40,  255,
    57,  90,  42,  255, 57,  83,  47,  255, 124, 143, 55,  255, 138, 162, 58,  255, 106, 140, 47,  255, 87,  127, 41,  255, 73,  107, 36,  255, 112,
    138, 65,  255, 83,  114, 52,  255, 63,  95,  42,  255, 74,  103, 42,  255, 97,  127, 41,  255, 96,  117, 42,  255, 68,  87,  37,  255, 63,  98,
    38,  255, 49,  83,  32,  255, 58,  92,  38,  255, 60,  97,  36,  255, 65,  90,  37,  255, 85,  109, 45,  255, 115, 136, 58,  255, 120, 142, 50,
    255, 109, 132, 47,  255, 199, 200, 131, 255, 255, 255, 183, 255, 243, 245, 171, 255, 241, 243, 175, 255, 251, 251, 185, 255, 225, 231, 154, 255,
    111, 138, 75,  255, 137, 153, 87,  255, 201, 213, 121, 255, 149, 183, 104, 255, 147, 181, 104, 255, 146, 182, 130, 255, 162, 186, 114, 255, 128,
    150, 45,  255, 115, 142, 47,  255, 97,  121, 52,  255, 99,  126, 58,  255, 109, 140, 65,  255, 101, 132, 58,  255, 47,  62,  31,  255, 23,  37,
    19,  255, 105, 131, 55,  255, 158, 185, 92,  255, 181, 203, 106, 255, 191, 209, 115, 255, 210, 222, 121, 255, 128, 137, 63,  255, 112, 136, 58,
    255, 115, 143, 60,  255, 110, 138, 46,  255, 83,  104, 34,  255, 60,  82,  38,  255, 67,  82,  37,  255, 144, 168, 90,  255, 126, 157, 86,  255,
    148, 171, 91,  255, 128, 158, 72,  255, 128, 156, 71,  255, 168, 186, 87,  255, 152, 180, 82,  255, 162, 190, 91,  255, 176, 203, 119, 255, 175,
    202, 117, 255, 179, 207, 124, 255, 223, 234, 141, 255, 157, 162, 87,  255, 38,  68,  31,  255, 46,  75,  39,  255, 60,  94,  46,  255, 71,  101,
    47,  255, 63,  89,  40,  255, 68,  87,  39,  255, 67,  84,  34,  255, 84,  115, 45,  255, 125, 162, 82,  255, 130, 167, 102, 255, 159, 186, 104,
    255, 114, 139, 65,  255, 80,  118, 56,  255, 87,  128, 53,  255, 96,  122, 50,  255, 132, 155, 76,  255, 116, 147, 82,  255, 100, 136, 81,  255,
    139, 164, 116, 255, 227, 236, 179, 255, 217, 229, 172, 255, 217, 231, 170, 255, 228, 236, 169, 255, 232, 241, 164, 255, 220, 235, 158, 255, 213,
    228, 153, 255, 218, 226, 140, 255, 187, 194, 107, 255, 153, 167, 86,  255, 110, 132, 52,  255, 144, 177, 84,  255, 171, 203, 111, 255, 180, 208,
    132, 255, 193, 218, 144, 255, 181, 200, 126, 255, 96,  125, 55,  255, 79,  104, 45,  255, 78,  96,  50,  255, 89,  111, 45,  255, 126, 150, 55,
    255, 140, 161, 55,  255, 146, 170, 73,  255, 96,  122, 71,  255, 111, 136, 81,  255, 87,  119, 68,  255, 87,  127, 69,  255, 90,  115, 53,  255,
    91,  114, 48,  255, 89,  124, 47,  255, 96,  132, 47,  255, 86,  122, 49,  255, 107, 143, 50,  255, 161, 183, 84,  255, 130, 161, 87,  255, 147,
    178, 95,  255, 139, 165, 84,  255, 134, 160, 89,  255, 142, 169, 109, 255, 131, 158, 98,  255, 163, 188, 145, 255, 180, 199, 137, 255, 205, 217,
    141, 255, 202, 211, 132, 255, 114, 128, 56,  255, 172, 173, 98,  255, 170, 191, 111, 255, 135, 167, 112, 255, 138, 163, 104, 255, 178, 191, 109,
    255, 168, 192, 97,  255, 158, 184, 84,  255, 135, 161, 72,  255, 110, 142, 52,  255, 138, 176, 68,  255, 172, 187, 91,  255, 182, 200, 157, 255,
    185, 193, 124, 255, 223, 222, 132, 255, 227, 225, 134, 255, 226, 230, 136, 255, 216, 223, 129, 255, 202, 212, 110, 255, 197, 208, 106, 255, 184,
    195, 87,  255, 154, 174, 77,  255, 123, 138, 60,  255, 187, 201, 116, 255, 197, 215, 142, 255, 202, 215, 133, 255, 194, 209, 157, 255, 177, 192,
    162, 255, 179, 194, 152, 255, 161, 178, 116, 255, 98,  126, 73,  255, 92,  118, 73,  255, 92,  116, 68,  255, 134, 154, 84,  255, 107, 132, 65,
    255, 150, 156, 87,  255, 210, 211, 135, 255, 191, 199, 122, 255, 108, 127, 63,  255, 71,  90,  37,  255, 145, 160, 94,  255, 182, 208, 135, 255,
    141, 175, 127, 255, 152, 178, 127, 255, 207, 213, 135, 255, 231, 230, 138, 255, 234, 233, 136, 255, 225, 230, 133, 255, 199, 214, 118, 255, 168,
    191, 97,  255, 144, 170, 75,  255, 152, 167, 68,  255, 184, 197, 86,  255, 208, 217, 107, 255, 231, 230, 119, 255, 235, 230, 104, 255, 238, 231,
    87,  255, 233, 230, 96,  255, 171, 182, 74,  255, 106, 126, 43,  255, 90,  116, 39,  255, 57,  91,  31,  255, 45,  83,  32,  255, 52,  89,  33,
    255, 55,  89,  34,  255, 80,  95,  34,  255, 229, 230, 140, 255, 239, 245, 156, 255, 233, 236, 128, 255, 209, 215, 97,  255, 166, 181, 78,  255,
    122, 150, 62,  255, 101, 138, 52,  255, 97,  134, 50,  255, 84,  123, 47,  255, 103, 134, 62,  255, 149, 173, 92,  255, 177, 196, 93,  255, 158,
    182, 74,  255, 174, 194, 80,  255, 180, 203, 97,  255, 176, 199, 102, 255, 189, 208, 120, 255, 191, 210, 119, 255, 108, 132, 53,  255, 79,  117,
    40,  255, 95,  129, 49,  255, 112, 143, 58,  255, 111, 142, 55,  255, 109, 136, 48,  255, 95,  121, 38,  255, 78,  108, 31,  255, 73,  101, 21,
    255, 141, 160, 71,  255, 164, 183, 105, 255, 108, 136, 76,  255, 114, 147, 65,  255, 130, 163, 72,  255, 146, 179, 94,  255, 157, 186, 99,  255,
    113, 146, 65,  255, 65,  101, 47,  255, 65,  100, 50,  255, 58,  89,  48,  255, 63,  91,  43,  255, 133, 157, 68,  255, 135, 168, 68,  255, 134,
    161, 71,  255, 125, 151, 60,  255, 114, 135, 48,  255, 118, 130, 55,  255, 141, 162, 86,  255, 157, 178, 111, 255, 120, 143, 71,  255, 83,  106,
    58,  255, 60,  83,  49,  255, 110, 135, 63,  255, 163, 191, 94,  255, 176, 198, 113, 255, 140, 163, 84,  255, 133, 155, 62,  255, 71,  103, 40,
    255, 74,  113, 47,  255, 90,  122, 55,  255, 100, 130, 68,  255, 122, 143, 67,  255, 169, 187, 74,  255, 113, 144, 58,  255, 86,  123, 50,  255,
    73,  113, 45,  255, 63,  99,  38,  255, 100, 125, 47,  255, 99,  131, 58,  255, 65,  94,  49,  255, 67,  92,  48,  255, 62,  91,  34,  255, 60,
    97,  26,  255, 63,  97,  29,  255, 92,  122, 52,  255, 74,  110, 45,  255, 77,  115, 52,  255, 78,  112, 47,  255, 98,  126, 52,  255, 89,  121,
    46,  255, 63,  92,  38,  255, 55,  75,  38,  255, 46,  69,  32,  255, 90,  111, 50,  255, 221, 222, 142, 255, 255, 251, 171, 255, 246, 246, 177,
    255, 250, 249, 188, 255, 229, 235, 153, 255, 156, 183, 108, 255, 95,  125, 93,  255, 161, 174, 108, 255, 218, 226, 127, 255, 207, 220, 122, 255,
    170, 197, 129, 255, 166, 189, 119, 255, 115, 140, 43,  255, 87,  119, 43,  255, 81,  116, 45,  255, 90,  121, 44,  255, 103, 131, 48,  255, 139,
    157, 56,  255, 81,  104, 43,  255, 67,  98,  40,  255, 128, 165, 73,  255, 131, 169, 84,  255, 147, 181, 107, 255, 159, 189, 123, 255, 196, 215,
    135, 255, 200, 202, 112, 255, 117, 138, 56,  255, 112, 136, 55,  255, 77,  98,  38,  255, 52,  76,  36,  255, 55,  82,  33,  255, 43,  68,  31,
    255, 129, 150, 76,  255, 153, 178, 94,  255, 117, 149, 91,  255, 136, 163, 87,  255, 142, 167, 79,  255, 164, 180, 83,  255, 181, 194, 94,  255,
    204, 220, 119, 255, 192, 215, 121, 255, 190, 214, 131, 255, 190, 215, 143, 255, 214, 233, 147, 255, 154, 157, 83,  255, 38,  71,  32,  255, 51,
    89,  37,  255, 60,  95,  38,  255, 63,  91,  46,  255, 58,  80,  46,  255, 38,  53,  36,  255, 40,  60,  34,  255, 47,  67,  31,  255, 117, 147,
    62,  255, 144, 179, 102, 255, 175, 203, 127, 255, 135, 155, 78,  255, 69,  97,  38,  255, 97,  117, 48,  255, 65,  90,  39,  255, 119, 146, 68,
    255, 114, 145, 78,  255, 100, 136, 85,  255, 160, 186, 106, 255, 183, 200, 102, 255, 161, 179, 97,  255, 143, 160, 68,  255, 138, 147, 65,  255,
    95,  89,  50,  255, 95,  93,  53,  255, 156, 163, 83,  255, 178, 185, 95,  255, 122, 145, 86,  255, 107, 134, 78,  255, 119, 148, 69,  255, 202,
    213, 109, 255, 216, 227, 124, 255, 190, 212, 124, 255, 176, 207, 128, 255, 166, 192, 107, 255, 65,  95,  26,  255, 78,  108, 43,  255, 87,  114,
    52,  255, 97,  124, 49,  255, 100, 127, 52,  255, 106, 130, 41,  255, 169, 180, 83,  255, 123, 142, 69,  255, 92,  120, 63,  255, 87,  118, 68,
    255, 87,  125, 68,  255, 112, 140, 65,  255, 110, 136, 53,  255, 117, 146, 62,  255, 120, 150, 60,  255, 117, 147, 60,  255, 91,  125, 42,  255,
    117, 146, 49,  255, 149, 172, 84,  255, 126, 159, 87,  255, 129, 162, 77,  255, 115, 143, 76,  255, 128, 154, 100, 255, 153, 177, 148, 255, 158,
    185, 165, 255, 158, 186, 146, 255, 189, 205, 139, 255, 190, 209, 123, 255, 192, 211, 122, 255, 219, 229, 139, 255, 163, 187, 122, 255, 126, 155,
    87,  255, 132, 158, 89,  255, 173, 192, 115, 255, 179, 193, 95,  255, 150, 180, 71,  255, 158, 185, 82,  255, 149, 172, 76,  255, 135, 160, 76,
    255, 94,  110, 58,  255, 136, 153, 83,  255, 144, 164, 83,  255, 99,  108, 49,  255, 62,  65,  26,  255, 72,  85,  34,  255, 90,  115, 55,  255,
    84,  115, 58,  255, 81,  113, 55,  255, 65,  97,  52,  255, 127, 140, 81,  255, 158, 175, 91,  255, 184, 203, 138, 255, 170, 198, 143, 255, 193,
    209, 139, 255, 172, 194, 155, 255, 153, 181, 163, 255, 152, 177, 157, 255, 200, 208, 163, 255, 179, 194, 138, 255, 109, 136, 93,  255, 100, 126,
    86,  255, 160, 172, 101, 255, 205, 205, 114, 255, 233, 229, 153, 255, 215, 217, 139, 255, 211, 212, 122, 255, 127, 144, 67,  255, 144, 161, 86,
    255, 167, 196, 136, 255, 134, 169, 124, 255, 162, 179, 122, 255, 230, 226, 139, 255, 239, 238, 139, 255, 235, 233, 134, 255, 238, 235, 143, 255,
    234, 234, 142, 255, 232, 232, 131, 255, 226, 231, 121, 255, 192, 211, 94,  255, 151, 169, 62,  255, 215, 215, 89,  255, 234, 235, 118, 255, 231,
    229, 120, 255, 231, 228, 113, 255, 212, 212, 87,  255, 201, 203, 94,  255, 191, 198, 87,  255, 143, 163, 72,  255, 58,  96,  36,  255, 60,  99,
    50,  255, 62,  99,  53,  255, 63,  103, 48,  255, 58,  98,  37,  255, 97,  107, 40,  255, 241, 238, 156, 255, 203, 208, 121, 255, 155, 172, 67,
    255, 128, 154, 47,  255, 125, 152, 60,  255, 138, 167, 76,  255, 102, 131, 52,  255, 81,  105, 34,  255, 97,  134, 49,  255, 90,  129, 47,  255,
    115, 139, 58,  255, 188, 199, 105, 255, 176, 192, 87,  255, 138, 160, 56,  255, 160, 177, 74,  255, 188, 206, 107, 255, 198, 213, 126, 255, 192,
    207, 121, 255, 98,  126, 45,  255, 84,  115, 38,  255, 80,  115, 44,  255, 68,  92,  32,  255, 69,  97,  28,  255, 68,  101, 28,  255, 69,  103,
    29,  255, 81,  114, 31,  255, 84,  116, 31,  255, 134, 148, 53,  255, 182, 193, 102, 255, 109, 140, 62,  255, 92,  122, 58,  255, 114, 142, 77,
    255, 132, 159, 95,  255, 172, 199, 149, 255, 140, 169, 112, 255, 53,  76,  28,  255, 53,  73,  31,  255, 58,  84,  36,  255, 63,  91,  40,  255,
    105, 128, 53,  255, 163, 185, 86,  255, 170, 192, 95,  255, 126, 154, 76,  255, 104, 115, 55,  255, 79,  100, 40,  255, 113, 131, 56,  255, 183,
    203, 111, 255, 172, 199, 124, 255, 188, 207, 139, 255, 128, 146, 87,  255, 120, 141, 63,  255, 153, 188, 87,  255, 157, 183, 89,  255, 116, 143,
    52,  255, 79,  109, 37,  255, 65,  103, 36,  255, 55,  86,  36,  255, 99,  123, 60,  255, 123, 147, 77,  255, 170, 185, 97,  255, 156, 180, 86,
    255, 119, 151, 65,  255, 93,  131, 55,  255, 90,  127, 50,  255, 102, 136, 48,  255, 103, 134, 41,  255, 115, 143, 50,  255, 77,  109, 45,  255,
    62,  92,  48,  255, 55,  83,  40,  255, 60,  92,  31,  255, 60,  86,  28,  255, 86,  115, 48,  255, 103, 141, 65,  255, 95,  129, 62,  255, 121,
    153, 84,  255, 128, 156, 83,  255, 115, 147, 65,  255, 87,  126, 58,  255, 65,  97,  58,  255, 67,  98,  63,  255, 85,  117, 65,  255, 135, 158,
    77,  255, 231, 236, 134, 255, 208, 223, 92,  255, 238, 241, 151, 255, 225, 229, 152, 255, 139, 169, 95,  255, 137, 162, 113, 255, 190, 212, 130,
    255, 188, 214, 124, 255, 203, 226, 152, 255, 203, 223, 147, 255, 198, 210, 125, 255, 116, 145, 52,  255, 87,  122, 47,  255, 91,  127, 48,  255,
    118, 145, 50,  255, 149, 165, 56,  255, 137, 148, 47,  255, 157, 180, 76,  255, 140, 180, 78,  255, 136, 172, 74,  255, 145, 179, 83,  255, 160,
    189, 107, 255, 174, 199, 124, 255, 199, 216, 136, 255, 216, 223, 134, 255, 122, 133, 63,  255, 69,  94,  36,  255, 87,  123, 40,  255, 78,  118,
    38,  255, 65,  106, 36,  255, 109, 148, 58,  255, 101, 130, 55,  255, 143, 163, 76,  255, 136, 172, 76,  255, 108, 145, 76,  255, 120, 140, 67,
    255, 130, 153, 72,  255, 99,  121, 47,  255, 153, 163, 81,  255, 198, 208, 117, 255, 199, 213, 122, 255, 198, 211, 129, 255, 195, 209, 141, 255,
    129, 144, 87,  255, 78,  117, 52,  255, 87,  118, 47,  255, 55,  77,  39,  255, 44,  68,  40,  255, 60,  86,  44,  255, 52,  71,  39,  255, 53,
    75,  38,  255, 72,  94,  38,  255, 119, 150, 48,  255, 147, 173, 84,  255, 170, 197, 123, 255, 126, 149, 69,  255, 53,  74,  32,  255, 63,  86,
    36,  255, 60,  87,  37,  255, 113, 138, 67,  255, 110, 143, 77,  255, 116, 152, 87,  255, 179, 202, 87,  255, 183, 204, 91,  255, 146, 166, 72,
    255, 92,  124, 26,  255, 60,  76,  26,  255, 32,  43,  34,  255, 112, 131, 84,  255, 129, 158, 95,  255, 123, 154, 95,  255, 129, 159, 99,  255,
    126, 150, 74,  255, 151, 171, 83,  255, 138, 146, 77,  255, 173, 182, 119, 255, 211, 217, 140, 255, 213, 228, 140, 255, 163, 185, 90,  255, 46,
    75,  21,  255, 65,  91,  40,  255, 72,  107, 39,  255, 79,  113, 37,  255, 87,  114, 42,  255, 81,  106, 42,  255, 92,  122, 45,  255, 161, 176,
    97,  255, 103, 122, 55,  255, 113, 138, 71,  255, 150, 175, 84,  255, 158, 176, 73,  255, 74,  102, 28,  255, 85,  116, 44,  255, 102, 131, 65,
    255, 71,  100, 55,  255, 72,  108, 41,  255, 82,  118, 36,  255, 129, 158, 58,  255, 146, 172, 82,  255, 110, 145, 55,  255, 95,  123, 55,  255,
    145, 172, 130, 255, 157, 185, 156, 255, 149, 180, 148, 255, 156, 184, 143, 255, 175, 196, 121, 255, 116, 142, 62,  255, 173, 184, 106, 255, 192,
    208, 139, 255, 179, 197, 140, 255, 132, 145, 78,  255, 136, 156, 95,  255, 158, 186, 143, 255, 183, 191, 124, 255, 107, 121, 47,  255, 115, 148,
    55,  255, 111, 144, 52,  255, 116, 149, 65,  255, 82,  101, 53,  255, 68,  84,  36,  255, 62,  74,  34,  255, 55,  60,  31,  255, 72,  62,  36,
    255, 60,  69,  33,  255, 55,  74,  31,  255, 86,  111, 50,  255, 91,  125, 53,  255, 98,  119, 50,  255, 208, 210, 124, 255, 164, 183, 101, 255,
    172, 199, 144, 255, 172, 198, 135, 255, 189, 206, 140, 255, 163, 185, 153, 255, 157, 182, 157, 255, 158, 185, 166, 255, 180, 195, 145, 255, 222,
    223, 138, 255, 149, 173, 124, 255, 110, 134, 101, 255, 168, 180, 96,  255, 194, 200, 90,  255, 222, 219, 135, 255, 196, 204, 138, 255, 179, 190,
    119, 255, 134, 147, 71,  255, 181, 199, 128, 255, 147, 180, 132, 255, 153, 177, 127, 255, 232, 228, 144, 255, 246, 241, 146, 255, 235, 235, 140,
    255, 235, 233, 129, 255, 239, 235, 125, 255, 243, 235, 113, 255, 245, 236, 97,  255, 223, 223, 81,  255, 156, 177, 56,  255, 107, 131, 43,  255,
    136, 146, 47,  255, 216, 214, 95,  255, 236, 232, 121, 255, 233, 233, 135, 255, 190, 197, 93,  255, 209, 206, 96,  255, 208, 206, 92,  255, 144,
    159, 68,  255, 67,  104, 48,  255, 82,  117, 58,  255, 101, 136, 60,  255, 89,  127, 52,  255, 65,  104, 38,  255, 65,  82,  31,  255, 91,  103,
    47,  255, 99,  124, 36,  255, 121, 152, 47,  255, 125, 154, 58,  255, 139, 165, 75,  255, 156, 181, 87,  255, 108, 133, 62,  255, 58,  73,  23,
    255, 94,  129, 42,  255, 100, 134, 49,  255, 143, 164, 79,  255, 164, 181, 82,  255, 157, 179, 89,  255, 144, 170, 92,  255, 122, 149, 65,  255,
    163, 176, 73,  255, 207, 215, 122, 255, 187, 203, 116, 255, 90,  121, 37,  255, 91,  111, 43,  255, 71,  104, 45,  255, 41,  65,  23,  255, 62,
    89,  23,  255, 78,  114, 36,  255, 81,  114, 36,  255, 83,  115, 36,  255, 87,  116, 38,  255, 132, 146, 60,  255, 174, 183, 94,  255, 121, 144,
    77,  255, 86,  113, 55,  255, 115, 139, 92,  255, 120, 142, 90,  255, 159, 177, 100, 255, 179, 204, 157, 255, 106, 121, 82,  255, 29,  39,  21,
    255, 52,  73,  31,  255, 74,  100, 43,  255, 84,  110, 43,  255, 144, 162, 77,  255, 179, 198, 105, 255, 143, 158, 83,  255, 87,  100, 48,  255,
    78,  104, 44,  255, 144, 161, 76,  255, 153, 170, 77,  255, 173, 196, 92,  255, 150, 185, 121, 255, 170, 194, 115, 255, 148, 173, 73,  255, 156,
    187, 101, 255, 122, 148, 68,  255, 101, 128, 52,  255, 102, 127, 60,  255, 76,  106, 53,  255, 67,  92,  55,  255, 114, 137, 67,  255, 132, 151,
    75,  255, 180, 189, 101, 255, 165, 181, 80,  255, 142, 168, 76,  255, 138, 164, 63,  255, 152, 176, 60,  255, 162, 187, 62,  255, 141, 170, 52,
    255, 109, 138, 39,  255, 112, 142, 48,  255, 92,  127, 56,  255, 63,  92,  42,  255, 48,  79,  31,  255, 42,  63,  28,  255, 71,  90,  47,  255,
    87,  108, 55,  255, 91,  116, 52,  255, 147, 174, 104, 255, 138, 164, 100, 255, 98,  119, 53,  255, 135, 162, 71,  255, 126, 152, 69,  255, 103,
    135, 77,  255, 97,  129, 87,  255, 126, 155, 83,  255, 184, 201, 107, 255, 209, 226, 128, 255, 190, 212, 107, 255, 220, 229, 145, 255, 154, 181,
    106, 255, 175, 207, 116, 255, 185, 213, 113, 255, 174, 203, 105, 255, 175, 196, 111, 255, 128, 143, 78,  255, 106, 115, 53,  255, 161, 174, 77,
    255, 148, 162, 67,  255, 108, 118, 50,  255, 107, 122, 45,  255, 94,  115, 42,  255, 87,  112, 47,  255, 124, 146, 62,  255, 158, 173, 77,  255,
    188, 206, 120, 255, 187, 213, 144, 255, 211, 230, 146, 255, 207, 225, 144, 255, 198, 219, 156, 255, 206, 225, 160, 255, 165, 179, 110, 255, 117,
    149, 52,  255, 110, 145, 55,  255, 77,  115, 47,  255, 96,  131, 52,  255, 131, 162, 65,  255, 147, 172, 72,  255, 85,  101, 41,  255, 133, 152,
    55,  255, 127, 156, 58,  255, 49,  68,  34,  255, 105, 125, 58,  255, 111, 133, 60,  255, 112, 137, 60,  255, 132, 156, 87,  255, 120, 146, 90,
    255, 123, 149, 94,  255, 127, 151, 87,  255, 102, 136, 60,  255, 97,  121, 49,  255, 49,  65,  31,  255, 36,  55,  31,  255, 46,  71,  33,  255,
    55,  84,  37,  255, 68,  99,  46,  255, 78,  110, 47,  255, 113, 146, 63,  255, 139, 168, 60,  255, 120, 146, 60,  255, 113, 138, 68,  255, 105,
    138, 67,  255, 133, 164, 65,  255, 100, 121, 43,  255, 58,  79,  37,  255, 92,  118, 60,  255, 111, 146, 82,  255, 130, 164, 84,  255, 191, 212,
    94,  255, 195, 210, 107, 255, 142, 162, 71,  255, 159, 180, 97,  255, 159, 171, 102, 255, 187, 203, 129, 255, 204, 220, 140, 255, 162, 182, 120,
    255, 116, 149, 97,  255, 116, 148, 97,  255, 104, 134, 69,  255, 126, 155, 77,  255, 117, 144, 63,  255, 134, 158, 120, 255, 138, 165, 140, 255,
    178, 186, 123, 255, 163, 175, 96,  255, 147, 164, 96,  255, 121, 142, 84,  255, 71,  107, 37,  255, 87,  126, 43,  255, 99,  131, 47,  255, 84,
    111, 47,  255, 68,  99,  36,  255, 143, 166, 91,  255, 204, 209, 118, 255, 147, 167, 89,  255, 141, 168, 96,  255, 137, 164, 78,  255, 65,  91,
    31,  255, 71,  101, 36,  255, 65,  102, 43,  255, 37,  62,  39,  255, 25,  48,  21,  255, 65,  101, 36,  255, 81,  123, 38,  255, 115, 155, 55,
    255, 85,  122, 36,  255, 114, 143, 58,  255, 139, 171, 116, 255, 140, 174, 116, 255, 143, 175, 118, 255, 143, 177, 122, 255, 143, 176, 110, 255,
    141, 170, 89,  255, 176, 195, 102, 255, 199, 210, 127, 255, 217, 221, 158, 255, 227, 229, 167, 255, 200, 211, 168, 255, 192, 203, 161, 255, 206,
    216, 156, 255, 87,  87,  49,  255, 40,  65,  26,  255, 79,  113, 44,  255, 106, 140, 62,  255, 124, 153, 73,  255, 79,  103, 42,  255, 55,  62,
    33,  255, 55,  63,  26,  255, 68,  62,  36,  255, 55,  53,  37,  255, 23,  28,  19,  255, 26,  28,  19,  255, 19,  23,  17,  255, 100, 93,  44,
    255, 215, 225, 136, 255, 147, 169, 100, 255, 166, 195, 142, 255, 175, 199, 125, 255, 186, 203, 119, 255, 152, 179, 133, 255, 171, 190, 121, 255,
    196, 212, 121, 255, 198, 213, 102, 255, 218, 220, 123, 255, 176, 195, 137, 255, 127, 148, 101, 255, 163, 179, 75,  255, 175, 186, 87,  255, 197,
    200, 110, 255, 185, 193, 132, 255, 185, 191, 112, 255, 155, 167, 86,  255, 170, 197, 142, 255, 143, 174, 133, 255, 176, 190, 138, 255, 238, 228,
    142, 255, 246, 236, 131, 255, 245, 238, 119, 255, 246, 239, 123, 255, 248, 238, 123, 255, 245, 235, 116, 255, 202, 207, 82,  255, 140, 164, 50,
    255, 125, 155, 52,  255, 95,  125, 34,  255, 82,  115, 28,  255, 102, 127, 26,  255, 154, 169, 55,  255, 184, 190, 76,  255, 193, 194, 82,  255,
    172, 177, 76,  255, 75,  80,  38,  255, 45,  63,  23,  255, 94,  134, 48,  255, 116, 153, 55,  255, 122, 156, 58,  255, 115, 150, 49,  255, 97,
    136, 44,  255, 57,  90,  26,  255, 69,  95,  34,  255, 118, 147, 58,  255, 114, 145, 52,  255, 100, 127, 45,  255, 139, 161, 71,  255, 160, 182,
    92,  255, 141, 168, 83,  255, 85,  114, 33,  255, 99,  130, 41,  255, 111, 139, 55,  255, 154, 176, 99,  255, 127, 163, 98,  255, 136, 169, 109,
    255, 148, 178, 107, 255, 122, 156, 92,  255, 124, 153, 74,  255, 176, 187, 84,  255, 180, 195, 96,  255, 94,  126, 41,  255, 84,  108, 42,  255,
    76,  109, 47,  255, 48,  74,  28,  255, 65,  87,  25,  255, 93,  124, 44,  255, 96,  121, 47,  255, 122, 142, 60,  255, 85,  107, 39,  255, 67,
    86,  28,  255, 143, 162, 68,  255, 130, 153, 95,  255, 80,  109, 63,  255, 115, 134, 74,  255, 148, 173, 86,  255, 136, 164, 68,  255, 163, 181,
    113, 255, 202, 211, 141, 255, 69,  87,  41,  255, 29,  41,  23,  255, 45,  58,  26,  255, 69,  92,  33,  255, 122, 145, 60,  255, 184, 202, 108,
    255, 129, 137, 75,  255, 73,  96,  50,  255, 58,  87,  41,  255, 96,  120, 49,  255, 141, 162, 62,  255, 176, 193, 80,  255, 176, 203, 106, 255,
    150, 185, 102, 255, 133, 165, 80,  255, 132, 159, 82,  255, 84,  113, 49,  255, 92,  120, 58,  255, 147, 162, 80,  255, 187, 196, 108, 255, 193,
    204, 125, 255, 185, 203, 127, 255, 184, 205, 130, 255, 164, 179, 102, 255, 87,  110, 55,  255, 103, 125, 60,  255, 128, 146, 62,  255, 127, 139,
    62,  255, 106, 109, 49,  255, 106, 122, 47,  255, 47,  63,  23,  255, 65,  86,  31,  255, 129, 156, 52,  255, 100, 135, 44,  255, 86,  122, 40,
    255, 67,  92,  36,  255, 53,  73,  33,  255, 60,  92,  37,  255, 117, 148, 78,  255, 159, 182, 115, 255, 156, 177, 100, 255, 166, 179, 68,  255,
    186, 200, 80,  255, 159, 182, 73,  255, 124, 159, 73,  255, 124, 158, 73,  255, 116, 149, 65,  255, 117, 143, 60,  255, 180, 183, 110, 255, 234,
    243, 173, 255, 218, 229, 149, 255, 153, 173, 84,  255, 115, 132, 58,  255, 108, 127, 50,  255, 96,  117, 49,  255, 73,  95,  42,  255, 56,  81,
    36,  255, 50,  73,  40,  255, 65,  84,  42,  255, 71,  92,  36,  255, 55,  76,  31,  255, 58,  86,  36,  255, 67,  96,  48,  255, 83,  111, 68,
    255, 95,  123, 76,  255, 82,  109, 52,  255, 121, 137, 75,  255, 193, 201, 124, 255, 177, 177, 101, 255, 118, 121, 63,  255, 93,  98,  55,  255,
    84,  85,  50,  255, 114, 127, 58,  255, 147, 173, 74,  255, 87,  119, 55,  255, 78,  112, 58,  255, 98,  132, 65,  255, 137, 164, 68,  255, 163,
    181, 76,  255, 96,  117, 50,  255, 39,  62,  29,  255, 106, 128, 55,  255, 139, 161, 73,  255, 153, 175, 76,  255, 134, 165, 65,  255, 127, 160,
    65,  255, 134, 164, 84,  255, 107, 141, 90,  255, 124, 154, 96,  255, 110, 135, 65,  255, 107, 137, 55,  255, 63,  84,  42,  255, 48,  77,  28,
    255, 44,  71,  31,  255, 40,  63,  36,  255, 38,  62,  38,  255, 95,  130, 69,  255, 132, 168, 87,  255, 143, 175, 89,  255, 136, 169, 55,  255,
    102, 140, 48,  255, 97,  135, 62,  255, 149, 179, 94,  255, 140, 169, 84,  255, 145, 162, 73,  255, 47,  60,  26,  255, 63,  87,  40,  255, 110,
    144, 80,  255, 136, 166, 84,  255, 201, 219, 95,  255, 198, 213, 110, 255, 203, 216, 128, 255, 212, 223, 131, 255, 212, 228, 131, 255, 219, 230,
    139, 255, 206, 214, 131, 255, 146, 168, 107, 255, 120, 154, 105, 255, 117, 146, 87,  255, 104, 135, 74,  255, 104, 140, 91,  255, 93,  125, 62,
    255, 129, 154, 112, 255, 133, 163, 139, 255, 108, 130, 68,  255, 149, 169, 93,  255, 176, 191, 120, 255, 118, 143, 75,  255, 91,  129, 45,  255,
    104, 141, 50,  255, 107, 143, 52,  255, 75,  106, 38,  255, 89,  117, 60,  255, 99,  137, 74,  255, 97,  129, 62,  255, 101, 134, 68,  255, 81,
    122, 67,  255, 112, 149, 83,  255, 67,  95,  43,  255, 58,  89,  29,  255, 55,  87,  32,  255, 46,  67,  31,  255, 101, 109, 43,  255, 115, 134,
    48,  255, 95,  130, 41,  255, 78,  119, 36,  255, 117, 146, 60,  255, 164, 186, 74,  255, 164, 184, 87,  255, 160, 186, 100, 255, 164, 192, 107,
    255, 166, 190, 110, 255, 166, 193, 112, 255, 168, 195, 113, 255, 168, 196, 116, 255, 200, 219, 141, 255, 231, 232, 156, 255, 203, 217, 170, 255,
    191, 211, 185, 255, 188, 210, 180, 255, 195, 217, 179, 255, 148, 144, 102, 255, 75,  87,  31,  255, 109, 151, 71,  255, 124, 162, 83,  255, 128,
    158, 77,  255, 105, 134, 60,  255, 76,  98,  41,  255, 40,  60,  23,  255, 75,  75,  37,  255, 113, 125, 74,  255, 45,  62,  32,  255, 21,  25,
    19,  255, 12,  12,  9,   255, 146, 145, 62,  255, 210, 224, 122, 255, 148, 171, 97,  255, 165, 194, 137, 255, 180, 202, 131, 255, 176, 197, 105,
    255, 153, 177, 65,  255, 183, 199, 82,  255, 202, 214, 111, 255, 193, 209, 130, 255, 187, 199, 161, 255, 185, 199, 141, 255, 130, 153, 100, 255,
    160, 177, 75,  255, 157, 172, 78,  255, 169, 181, 99,  255, 175, 184, 121, 255, 157, 169, 100, 255, 148, 167, 95,  255, 155, 184, 141, 255, 152,
    180, 142, 255, 156, 185, 134, 255, 144, 174, 118, 255, 162, 183, 111, 255, 185, 198, 98,  255, 172, 184, 74,  255, 160, 172, 60,  255, 146, 168,
    52,  255, 128, 156, 40,  255, 134, 161, 45,  255, 131, 158, 53,  255, 106, 136, 47,  255, 84,  122, 39,  255, 82,  110, 28,  255, 117, 141, 40,
    255, 124, 144, 45,  255, 101, 130, 42,  255, 73,  111, 36,  255, 44,  75,  26,  255, 90,  116, 43,  255, 125, 163, 60,  255, 120, 157, 55,  255,
    117, 154, 52,  255, 114, 151, 45,  255, 122, 156, 48,  255, 132, 163, 65,  255, 140, 165, 77,  255, 140, 165, 76,  255, 130, 160, 62,  255, 81,
    110, 36,  255, 121, 143, 52,  255, 164, 186, 92,  255, 187, 202, 116, 255, 189, 208, 125, 255, 201, 214, 133, 255, 213, 222, 152, 255, 223, 230,
    161, 255, 187, 209, 134, 255, 162, 191, 117, 255, 149, 179, 116, 255, 146, 179, 112, 255, 128, 161, 108, 255, 156, 179, 104, 255, 189, 205, 110,
    255, 103, 132, 58,  255, 74,  106, 38,  255, 74,  102, 39,  255, 49,  73,  28,  255, 52,  75,  26,  255, 62,  84,  28,  255, 113, 128, 52,  255,
    132, 152, 76,  255, 87,  115, 48,  255, 47,  68,  17,  255, 119, 137, 58,  255, 157, 178, 101, 255, 101, 132, 88,  255, 85,  108, 53,  255, 137,
    159, 74,  255, 147, 176, 77,  255, 140, 166, 73,  255, 146, 170, 77,  255, 139, 171, 75,  255, 78,  102, 48,  255, 23,  37,  23,  255, 80,  98,
    38,  255, 158, 186, 73,  255, 167, 181, 89,  255, 144, 151, 83,  255, 188, 202, 130, 255, 118, 139, 79,  255, 55,  81,  31,  255, 166, 178, 76,
    255, 181, 197, 71,  255, 165, 183, 74,  255, 152, 180, 75,  255, 134, 168, 82,  255, 125, 155, 73,  255, 126, 153, 65,  255, 110, 133, 52,  255,
    181, 198, 104, 255, 190, 208, 136, 255, 160, 191, 137, 255, 160, 194, 136, 255, 185, 201, 124, 255, 114, 135, 62,  255, 80,  107, 53,  255, 62,
    87,  49,  255, 69,  102, 46,  255, 58,  81,  40,  255, 9,   12,  17,  255, 75,  91,  55,  255, 95,  113, 81,  255, 55,  68,  43,  255, 60,  76,
    26,  255, 98,  120, 40,  255, 91,  107, 39,  255, 81,  100, 42,  255, 97,  137, 60,  255, 92,  133, 60,  255, 137, 168, 97,  255, 157, 182, 106,
    255, 184, 197, 94,  255, 190, 205, 95,  255, 164, 186, 86,  255, 145, 175, 80,  255, 122, 158, 75,  255, 114, 150, 71,  255, 98,  137, 56,  255,
    109, 143, 67,  255, 199, 213, 103, 255, 221, 229, 127, 255, 189, 203, 113, 255, 157, 170, 92,  255, 80,  95,  63,  255, 58,  83,  34,  255, 82,
    108, 34,  255, 73,  103, 36,  255, 68,  98,  42,  255, 58,  84,  43,  255, 52,  76,  37,  255, 58,  77,  31,  255, 55,  77,  36,  255, 67,  96,
    60,  255, 84,  113, 68,  255, 95,  124, 75,  255, 104, 131, 80,  255, 103, 128, 71,  255, 85,  114, 50,  255, 138, 151, 72,  255, 44,  55,  26,
    255, 23,  37,  26,  255, 25,  36,  23,  255, 26,  42,  19,  255, 100, 121, 45,  255, 161, 185, 74,  255, 100, 132, 63,  255, 82,  117, 63,  255,
    102, 138, 60,  255, 151, 176, 68,  255, 159, 175, 72,  255, 71,  105, 38,  255, 100, 135, 65,  255, 142, 157, 87,  255, 133, 157, 84,  255, 148,
    179, 80,  255, 145, 182, 74,  255, 147, 187, 77,  255, 158, 192, 74,  255, 172, 194, 92,  255, 109, 131, 71,  255, 65,  96,  52,  255, 115, 143,
    65,  255, 69,  84,  47,  255, 60,  94,  36,  255, 58,  89,  34,  255, 38,  65,  32,  255, 74,  108, 58,  255, 124, 159, 89,  255, 132, 164, 91,
    255, 131, 162, 74,  255, 142, 174, 56,  255, 118, 151, 62,  255, 143, 173, 92,  255, 146, 170, 94,  255, 162, 185, 77,  255, 146, 157, 60,  255,
    39,  53,  29,  255, 32,  47,  25,  255, 77,  105, 62,  255, 118, 149, 74,  255, 195, 215, 93,  255, 195, 212, 108, 255, 198, 214, 114, 255, 209,
    223, 127, 255, 227, 238, 141, 255, 209, 217, 134, 255, 145, 167, 113, 255, 122, 157, 108, 255, 131, 164, 115, 255, 114, 143, 77,  255, 112, 146,
    87,  255, 119, 153, 97,  255, 92,  127, 68,  255, 117, 144, 92,  255, 172, 189, 126, 255, 193, 202, 118, 255, 213, 222, 140, 255, 213, 224, 150,
    255, 105, 132, 71,  255, 69,  106, 36,  255, 65,  98,  36,  255, 39,  65,  26,  255, 49,  82,  26,  255, 95,  125, 60,  255, 101, 131, 68,  255,
    95,  126, 58,  255, 116, 150, 78,  255, 81,  126, 71,  255, 104, 143, 83,  255, 94,  121, 55,  255, 58,  86,  26,  255, 47,  76,  26,  255, 110,
    125, 55,  255, 206, 222, 103, 255, 170, 199, 89,  255, 143, 174, 69,  255, 126, 156, 63,  255, 209, 224, 108, 255, 190, 203, 89,  255, 124, 152,
    100, 255, 128, 161, 118, 255, 109, 138, 65,  255, 155, 175, 82,  255, 148, 168, 74,  255, 164, 182, 93,  255, 201, 215, 130, 255, 191, 211, 143,
    255, 219, 226, 163, 255, 208, 220, 171, 255, 187, 210, 182, 255, 185, 208, 182, 255, 181, 204, 176, 255, 210, 225, 175, 255, 224, 218, 138, 255,
    148, 173, 93,  255, 120, 159, 73,  255, 95,  117, 58,  255, 40,  58,  31,  255, 47,  73,  25,  255, 50,  79,  29,  255, 170, 179, 106, 255, 228,
    238, 134, 255, 94,  114, 60,  255, 6,   12,  12,  255, 44,  46,  19,  255, 186, 200, 69,  255, 186, 209, 65,  255, 146, 171, 85,  255, 166, 189,
    124, 255, 207, 218, 130, 255, 152, 179, 73,  255, 132, 160, 47,  255, 136, 162, 56,  255, 156, 177, 104, 255, 143, 171, 138, 255, 159, 180, 148,
    255, 181, 196, 149, 255, 120, 143, 99,  255, 157, 170, 82,  255, 151, 172, 76,  255, 151, 167, 85,  255, 156, 170, 99,  255, 142, 158, 84,  255,
    135, 161, 101, 255, 151, 183, 144, 255, 145, 176, 125, 255, 140, 173, 110, 255, 144, 178, 101, 255, 164, 188, 96,  255, 136, 162, 48,  255, 124,
    150, 31,  255, 142, 165, 49,  255, 153, 178, 60,  255, 151, 177, 55,  255, 148, 173, 56,  255, 120, 148, 50,  255, 124, 151, 55,  255, 121, 153,
    69,  255, 86,  118, 44,  255, 76,  111, 33,  255, 63,  103, 26,  255, 68,  111, 36,  255, 80,  120, 42,  255, 77,  117, 39,  255, 75,  110, 34,
    255, 90,  122, 42,  255, 106, 139, 47,  255, 121, 152, 52,  255, 117, 146, 49,  255, 87,  105, 32,  255, 127, 137, 58,  255, 164, 188, 90,  255,
    154, 177, 84,  255, 151, 172, 77,  255, 135, 162, 69,  255, 117, 142, 50,  255, 159, 183, 87,  255, 141, 164, 72,  255, 175, 192, 95,  255, 188,
    216, 124, 255, 186, 216, 132, 255, 191, 216, 136, 255, 189, 216, 129, 255, 172, 201, 97,  255, 158, 186, 108, 255, 162, 189, 130, 255, 151, 180,
    128, 255, 144, 175, 120, 255, 180, 199, 121, 255, 153, 172, 91,  255, 37,  62,  15,  255, 60,  84,  26,  255, 55,  81,  31,  255, 40,  69,  23,
    255, 53,  74,  21,  255, 126, 144, 63,  255, 102, 128, 71,  255, 94,  122, 60,  255, 55,  86,  26,  255, 69,  90,  28,  255, 137, 154, 72,  255,
    141, 168, 103, 255, 88,  119, 76,  255, 101, 123, 53,  255, 153, 178, 74,  255, 141, 169, 71,  255, 134, 162, 71,  255, 136, 167, 75,  255, 125,
    156, 68,  255, 52,  77,  28,  255, 116, 140, 52,  255, 143, 180, 55,  255, 182, 198, 103, 255, 203, 217, 142, 255, 188, 212, 148, 255, 176, 193,
    125, 255, 58,  81,  31,  255, 120, 131, 50,  255, 203, 206, 78,  255, 149, 169, 78,  255, 124, 151, 78,  255, 143, 164, 77,  255, 144, 160, 77,
    255, 104, 125, 62,  255, 153, 169, 96,  255, 179, 204, 145, 255, 161, 189, 131, 255, 175, 199, 122, 255, 205, 214, 131, 255, 119, 136, 71,  255,
    110, 138, 65,  255, 80,  102, 49,  255, 60,  83,  41,  255, 68,  98,  36,  255, 112, 130, 74,  255, 161, 170, 116, 255, 198, 215, 153, 255, 201,
    217, 146, 255, 67,  80,  47,  255, 39,  60,  33,  255, 50,  65,  37,  255, 52,  63,  39,  255, 108, 139, 74,  255, 134, 167, 90,  255, 112, 146,
    73,  255, 140, 168, 90,  255, 167, 189, 98,  255, 197, 212, 109, 255, 175, 197, 102, 255, 148, 177, 94,  255, 136, 167, 93,  255, 124, 162, 77,
    255, 106, 145, 63,  255, 118, 154, 69,  255, 208, 222, 122, 255, 223, 233, 113, 255, 221, 229, 126, 255, 177, 191, 99,  255, 192, 212, 110, 255,
    200, 219, 143, 255, 176, 193, 127, 255, 191, 201, 130, 255, 152, 165, 99,  255, 90,  112, 38,  255, 82,  108, 44,  255, 55,  79,  33,  255, 48,
    65,  28,  255, 55,  81,  41,  255, 84,  114, 62,  255, 105, 131, 69,  255, 123, 146, 78,  255, 135, 155, 86,  255, 152, 172, 92,  255, 121, 144,
    65,  255, 82,  96,  45,  255, 36,  51,  31,  255, 34,  47,  29,  255, 42,  60,  32,  255, 41,  65,  29,  255, 91,  119, 39,  255, 168, 184, 74,
    255, 124, 151, 74,  255, 87,  122, 69,  255, 95,  131, 65,  255, 157, 181, 73,  255, 145, 162, 62,  255, 101, 128, 60,  255, 145, 161, 90,  255,
    116, 140, 82,  255, 118, 154, 98,  255, 123, 153, 100, 255, 133, 159, 103, 255, 148, 167, 89,  255, 166, 181, 87,  255, 167, 183, 89,  255, 105,
    127, 75,  255, 72,  106, 65,  255, 105, 128, 60,  255, 39,  52,  31,  255, 57,  87,  32,  255, 74,  109, 36,  255, 60,  92,  40,  255, 119, 154,
    82,  255, 130, 161, 91,  255, 127, 159, 84,  255, 128, 161, 72,  255, 126, 155, 56,  255, 139, 165, 80,  255, 133, 158, 78,  255, 128, 157, 65,
    255, 153, 174, 71,  255, 102, 130, 62,  255, 94,  120, 60,  255, 60,  75,  36,  255, 43,  58,  31,  255, 149, 175, 91,  255, 193, 212, 100, 255,
    197, 216, 94,  255, 205, 222, 101, 255, 187, 196, 98,  255, 111, 112, 58,  255, 143, 159, 84,  255, 182, 201, 132, 255, 160, 187, 130, 255, 141,
    173, 119, 255, 110, 140, 77,  255, 124, 162, 108, 255, 123, 159, 100, 255, 146, 174, 97,  255, 198, 209, 118, 255, 213, 221, 134, 255, 198, 211,
    140, 255, 167, 189, 134, 255, 139, 165, 116, 255, 80,  102, 65,  255, 26,  44,  21,  255, 32,  51,  23,  255, 81,  103, 43,  255, 119, 146, 63,
    255, 133, 167, 79,  255, 133, 165, 84,  255, 122, 154, 86,  255, 135, 163, 87,  255, 97,  130, 78,  255, 90,  131, 81,  255, 129, 162, 79,  255,
    77,  110, 28,  255, 58,  89,  34,  255, 85,  106, 56,  255, 215, 226, 127, 255, 180, 205, 104, 255, 164, 193, 94,  255, 178, 203, 101, 255, 132,
    148, 67,  255, 87,  120, 44,  255, 111, 138, 76,  255, 79,  105, 47,  255, 57,  87,  19,  255, 139, 166, 76,  255, 118, 140, 60,  255, 76,  110,
    31,  255, 172, 193, 109, 255, 150, 178, 128, 255, 191, 205, 157, 255, 196, 214, 172, 255, 189, 211, 176, 255, 187, 208, 184, 255, 197, 213, 184,
    255, 184, 208, 169, 255, 240, 243, 173, 255, 218, 214, 140, 255, 87,  104, 44,  255, 84,  105, 49,  255, 67,  78,  34,  255, 122, 140, 71,  255,
    148, 160, 96,  255, 209, 218, 132, 255, 132, 153, 65,  255, 31,  37,  21,  255, 9,   9,   12,  255, 84,  83,  37,  255, 196, 217, 84,  255, 154,
    183, 60,  255, 124, 153, 65,  255, 174, 192, 96,  255, 153, 175, 68,  255, 127, 152, 52,  255, 142, 163, 62,  255, 169, 185, 84,  255, 166, 189,
    106, 255, 157, 182, 116, 255, 157, 179, 118, 255, 184, 197, 111, 255, 163, 178, 93,  255, 147, 159, 67,  255, 149, 169, 80,  255, 128, 150, 72,
    255, 137, 154, 75,  255, 128, 145, 65,  255, 139, 164, 110, 255, 146, 179, 120, 255, 134, 169, 91,  255, 140, 170, 90,  255, 151, 171, 83,  255,
    144, 162, 84,  255, 107, 135, 46,  255, 121, 143, 44,  255, 159, 179, 71,  255, 172, 197, 82,  255, 163, 191, 73,  255, 165, 194, 73,  255, 175,
    202, 77,  255, 139, 169, 55,  255, 114, 140, 50,  255, 116, 141, 56,  255, 109, 136, 53,  255, 94,  125, 40,  255, 87,  119, 34,  255, 87,  125,
    41,  255, 84,  124, 42,  255, 67,  106, 38,  255, 65,  103, 36,  255, 65,  104, 36,  255, 73,  108, 37,  255, 63,  96,  37,  255, 34,  51,  21,
    255, 47,  57,  19,  255, 137, 153, 68,  255, 164, 187, 86,  255, 159, 182, 86,  255, 149, 174, 80,  255, 140, 164, 72,  255, 145, 169, 72,  255,
    107, 141, 50,  255, 123, 145, 55,  255, 214, 218, 121, 255, 216, 229, 129, 255, 200, 221, 107, 255, 197, 218, 105, 255, 193, 214, 111, 255, 181,
    205, 109, 255, 168, 194, 101, 255, 215, 224, 104, 255, 171, 195, 120, 255, 161, 187, 121, 255, 206, 217, 129, 255, 143, 155, 87,  255, 76,  98,
    38,  255, 73,  107, 32,  255, 83,  122, 36,  255, 91,  123, 31,  255, 119, 141, 56,  255, 89,  119, 62,  255, 91,  119, 58,  255, 80,  109, 43,
    255, 69,  94,  32,  255, 77,  98,  31,  255, 108, 126, 49,  255, 121, 145, 82,  255, 87,  115, 47,  255, 138, 159, 67,  255, 152, 175, 73,  255,
    161, 180, 91,  255, 153, 176, 91,  255, 142, 170, 81,  255, 81,  110, 43,  255, 130, 153, 76,  255, 159, 193, 74,  255, 179, 203, 119, 255, 177,
    204, 146, 255, 176, 202, 146, 255, 206, 217, 151, 255, 111, 124, 77,  255, 58,  76,  31,  255, 168, 172, 75,  255, 155, 170, 81,  255, 119, 141,
    62,  255, 173, 189, 90,  255, 109, 130, 65,  255, 110, 135, 72,  255, 185, 210, 142, 255, 176, 204, 140, 255, 199, 216, 123, 255, 187, 209, 94,
    255, 187, 209, 113, 255, 142, 166, 87,  255, 159, 183, 91,  255, 89,  111, 48,  255, 74,  101, 39,  255, 143, 160, 83,  255, 226, 232, 154, 255,
    199, 220, 158, 255, 190, 215, 150, 255, 177, 188, 122, 255, 55,  77,  43,  255, 65,  90,  46,  255, 58,  73,  39,  255, 55,  82,  36,  255, 135,
    168, 94,  255, 132, 166, 89,  255, 135, 166, 89,  255, 191, 209, 117, 255, 205, 221, 118, 255, 198, 217, 111, 255, 193, 215, 101, 255, 180, 205,
    96,  255, 136, 168, 80,  255, 125, 163, 68,  255, 142, 175, 74,  255, 194, 213, 121, 255, 221, 232, 119, 255, 222, 231, 115, 255, 224, 230, 132,
    255, 218, 229, 120, 255, 182, 209, 111, 255, 176, 208, 117, 255, 183, 212, 131, 255, 215, 230, 193, 255, 233, 235, 184, 255, 116, 125, 60,  255,
    100, 115, 68,  255, 111, 124, 76,  255, 94,  111, 60,  255, 105, 126, 65,  255, 124, 143, 82,  255, 131, 150, 87,  255, 164, 177, 97,  255, 179,
    187, 101, 255, 170, 172, 91,  255, 102, 109, 53,  255, 47,  69,  33,  255, 36,  52,  29,  255, 55,  82,  37,  255, 55,  83,  36,  255, 60,  91,
    36,  255, 65,  99,  47,  255, 111, 130, 62,  255, 152, 173, 77,  255, 97,  131, 75,  255, 101, 135, 73,  255, 158, 177, 75,  255, 93,  116, 44,
    255, 156, 178, 83,  255, 161, 179, 77,  255, 145, 176, 82,  255, 133, 165, 84,  255, 114, 146, 84,  255, 116, 149, 90,  255, 104, 131, 65,  255,
    62,  74,  34,  255, 74,  92,  43,  255, 110, 135, 78,  255, 101, 127, 71,  255, 58,  65,  34,  255, 23,  33,  23,  255, 47,  63,  32,  255, 76,
    108, 39,  255, 111, 146, 72,  255, 133, 167, 94,  255, 130, 164, 84,  255, 140, 173, 84,  255, 154, 184, 95,  255, 144, 175, 90,  255, 128, 161,
    65,  255, 141, 170, 60,  255, 160, 187, 86,  255, 166, 194, 115, 255, 190, 211, 128, 255, 209, 223, 116, 255, 176, 197, 86,  255, 137, 156, 71,
    255, 164, 183, 87,  255, 177, 196, 91,  255, 199, 214, 101, 255, 200, 213, 98,  255, 176, 198, 92,  255, 103, 113, 62,  255, 151, 166, 110, 255,
    194, 213, 154, 255, 191, 209, 138, 255, 155, 168, 95,  255, 116, 140, 71,  255, 162, 184, 109, 255, 171, 191, 110, 255, 200, 211, 126, 255, 175,
    195, 131, 255, 164, 190, 132, 255, 167, 192, 140, 255, 141, 164, 106, 255, 86,  110, 49,  255, 106, 131, 58,  255, 108, 134, 65,  255, 127, 151,
    68,  255, 146, 182, 81,  255, 124, 161, 87,  255, 100, 138, 90,  255, 96,  132, 91,  255, 87,  125, 86,  255, 104, 141, 86,  255, 139, 161, 94,
    255, 97,  130, 82,  255, 137, 173, 94,  255, 95,  124, 40,  255, 71,  102, 36,  255, 52,  83,  39,  255, 96,  118, 68,  255, 192, 202, 121, 255,
    225, 233, 143, 255, 201, 209, 115, 255, 37,  65,  21,  255, 74,  106, 50,  255, 129, 151, 87,  255, 95,  116, 52,  255, 55,  84,  17,  255, 125,
    157, 77,  255, 131, 156, 74,  255, 83,  114, 34,  255, 148, 177, 92,  255, 142, 174, 126, 255, 128, 154, 100, 255, 201, 210, 150, 255, 185, 208,
    174, 255, 188, 211, 185, 255, 190, 211, 189, 255, 179, 204, 181, 255, 192, 212, 167, 255, 233, 236, 164, 255, 162, 166, 95,  255, 126, 157, 62,
    255, 156, 180, 78,  255, 148, 165, 84,  255, 179, 186, 104, 255, 213, 223, 125, 255, 95,  118, 63,  255, 9,   15,  12,  255, 21,  23,  17,  255,
    86,  85,  42,  255, 156, 167, 68,  255, 135, 159, 68,  255, 128, 153, 52,  255, 158, 180, 63,  255, 135, 156, 50,  255, 167, 180, 67,  255, 172,
    186, 68,  255, 170, 188, 76,  255, 170, 188, 82,  255, 185, 198, 81,  255, 212, 219, 76,  255, 200, 215, 83,  255, 185, 205, 86,  255, 165, 190,
    68,  255, 142, 173, 65,  255, 114, 148, 60,  255, 128, 149, 65,  255, 138, 153, 65,  255, 128, 155, 76,  255, 109, 141, 58,  255, 114, 145, 47,
    255, 105, 136, 41,  255, 101, 129, 49,  255, 112, 128, 60,  255, 115, 136, 52,  255, 166, 189, 87,  255, 188, 212, 100, 255, 183, 208, 94,  255,
    191, 213, 96,  255, 197, 218, 104, 255, 142, 166, 68,  255, 89,  120, 36,  255, 91,  126, 31,  255, 94,  127, 33,  255, 104, 132, 43,  255, 116,
    141, 53,  255, 120, 147, 58,  255, 116, 144, 52,  255, 114, 141, 55,  255, 96,  126, 53,  255, 74,  110, 39,  255, 74,  112, 41,  255, 75,  113,
    42,  255, 75,  113, 44,  255, 66,  96,  39,  255, 53,  76,  19,  255, 88,  105, 31,  255, 112, 135, 48,  255, 116, 138, 52,  255, 110, 129, 52,
    255, 63,  77,  28,  255, 110, 128, 50,  255, 176, 188, 95,  255, 208, 221, 134, 255, 186, 211, 148, 255, 180, 209, 153, 255, 186, 209, 150, 255,
    188, 212, 156, 255, 212, 223, 149, 255, 209, 229, 98,  255, 180, 211, 97,  255, 209, 223, 102, 255, 193, 208, 101, 255, 183, 207, 120, 255, 206,
    222, 152, 255, 238, 243, 166, 255, 223, 228, 143, 255, 123, 155, 50,  255, 127, 158, 44,  255, 137, 166, 53,  255, 126, 148, 58,  255, 87,  116,
    58,  255, 85,  116, 55,  255, 78,  103, 47,  255, 68,  83,  31,  255, 78,  90,  39,  255, 65,  82,  32,  255, 80,  108, 42,  255, 89,  122, 47,
    255, 139, 158, 80,  255, 212, 222, 144, 255, 214, 227, 161, 255, 207, 223, 162, 255, 218, 229, 156, 255, 145, 166, 87,  255, 118, 141, 68,  255,
    189, 211, 110, 255, 179, 205, 146, 255, 178, 203, 148, 255, 189, 209, 119, 255, 207, 222, 148, 255, 216, 226, 161, 255, 200, 211, 148, 255, 194,
    207, 132, 255, 174, 200, 115, 255, 127, 167, 106, 255, 184, 208, 138, 255, 127, 144, 74,  255, 134, 157, 87,  255, 184, 204, 125, 255, 173, 186,
    92,  255, 157, 174, 69,  255, 167, 185, 81,  255, 179, 204, 89,  255, 188, 217, 105, 255, 167, 194, 100, 255, 93,  117, 55,  255, 112, 129, 74,
    255, 214, 225, 147, 255, 189, 209, 151, 255, 179, 206, 148, 255, 196, 212, 138, 255, 118, 129, 72,  255, 67,  89,  50,  255, 77,  102, 46,  255,
    79,  112, 38,  255, 97,  133, 53,  255, 139, 174, 96,  255, 147, 175, 99,  255, 202, 218, 134, 255, 214, 229, 126, 255, 205, 221, 117, 255, 202,
    218, 111, 255, 199, 216, 106, 255, 197, 216, 103, 255, 189, 210, 91,  255, 162, 178, 69,  255, 168, 179, 75,  255, 220, 229, 127, 255, 202, 215,
    93,  255, 204, 216, 84,  255, 222, 227, 118, 255, 231, 231, 116, 255, 225, 238, 133, 255, 190, 217, 131, 255, 186, 215, 139, 255, 192, 218, 147,
    255, 228, 235, 149, 255, 245, 241, 154, 255, 236, 235, 155, 255, 246, 241, 161, 255, 238, 235, 154, 255, 238, 238, 157, 255, 241, 243, 160, 255,
    203, 201, 119, 255, 136, 131, 63,  255, 105, 105, 55,  255, 49,  53,  31,  255, 21,  31,  21,  255, 49,  75,  36,  255, 55,  80,  37,  255, 65,
    92,  42,  255, 58,  90,  36,  255, 78,  117, 52,  255, 80,  112, 72,  255, 62,  90,  65,  255, 104, 123, 63,  255, 143, 163, 87,  255, 145, 168,
    90,  255, 101, 125, 52,  255, 151, 170, 75,  255, 188, 203, 92,  255, 143, 167, 81,  255, 121, 153, 79,  255, 112, 148, 80,  255, 110, 146, 80,
    255, 108, 139, 65,  255, 105, 129, 58,  255, 60,  84,  38,  255, 69,  87,  50,  255, 112, 134, 71,  255, 88,  96,  55,  255, 17,  21,  19,  255,
    26,  37,  25,  255, 44,  68,  33,  255, 63,  92,  46,  255, 138, 169, 98,  255, 139, 170, 92,  255, 153, 184, 101, 255, 162, 192, 102, 255, 164,
    193, 98,  255, 163, 194, 100, 255, 160, 192, 93,  255, 157, 191, 84,  255, 170, 199, 90,  255, 190, 210, 118, 255, 220, 229, 154, 255, 213, 226,
    133, 255, 214, 229, 111, 255, 198, 216, 102, 255, 148, 171, 84,  255, 127, 155, 73,  255, 140, 168, 87,  255, 184, 204, 116, 255, 190, 211, 110,
    255, 204, 217, 138, 255, 183, 206, 147, 255, 169, 198, 142, 255, 207, 220, 144, 255, 126, 132, 62,  255, 68,  92,  40,  255, 146, 165, 92,  255,
    192, 206, 129, 255, 169, 190, 133, 255, 154, 181, 128, 255, 155, 182, 115, 255, 153, 182, 108, 255, 167, 195, 110, 255, 149, 175, 95,  255, 151,
    174, 91,  255, 138, 149, 74,  255, 112, 132, 63,  255, 134, 171, 91,  255, 112, 148, 92,  255, 98,  132, 94,  255, 98,  132, 94,  255, 97,  132,
    92,  255, 98,  133, 92,  255, 134, 163, 92,  255, 133, 157, 87,  255, 137, 170, 94,  255, 132, 163, 73,  255, 92,  124, 47,  255, 79,  107, 42,
    255, 32,  58,  25,  255, 51,  79,  34,  255, 112, 129, 67,  255, 90,  111, 44,  255, 60,  84,  32,  255, 48,  74,  28,  255, 86,  114, 56,  255,
    92,  118, 49,  255, 81,  104, 36,  255, 86,  117, 41,  255, 78,  113, 36,  255, 94,  123, 43,  255, 130, 161, 78,  255, 137, 168, 122, 255, 91,
    125, 62,  255, 160, 183, 124, 255, 195, 212, 159, 255, 181, 207, 174, 255, 185, 210, 183, 255, 182, 206, 188, 255, 192, 212, 177, 255, 204, 218,
    164, 255, 189, 199, 129, 255, 117, 149, 71,  255, 151, 182, 90,  255, 172, 188, 90,  255, 200, 198, 103, 255, 228, 228, 136, 255, 74,  84,  52,
    255, 19,  26,  19,  255, 25,  37,  23,  255, 17,  31,  21,  255, 55,  62,  26,  255, 112, 121, 41,  255, 157, 175, 76,  255, 173, 194, 90,  255,
    170, 185, 65,  255, 193, 202, 71,  255, 155, 179, 74,  255, 130, 158, 68,  255, 128, 154, 74,  255, 161, 178, 68,  255, 211, 217, 77,  255, 174,
    198, 83,  255, 151, 180, 92,  255, 147, 178, 97,  255, 157, 184, 96,  255, 155, 180, 93,  255, 151, 168, 74,  255, 140, 159, 65,  255, 82,  114,
    45,  255, 67,  91,  33,  255, 103, 137, 46,  255, 103, 141, 42,  255, 106, 142, 41,  255, 109, 119, 47,  255, 173, 174, 97,  255, 198, 218, 112,
    255, 188, 208, 98,  255, 187, 205, 103, 255, 163, 180, 92,  255, 115, 134, 60,  255, 67,  92,  36,  255, 84,  111, 36,  255, 118, 145, 46,  255,
    113, 142, 47,  255, 122, 155, 62,  255, 129, 165, 71,  255, 127, 167, 68,  255, 119, 153, 55,  255, 87,  113, 40,  255, 87,  118, 41,  255, 91,
    124, 42,  255, 89,  122, 44,  255, 89,  122, 42,  255, 91,  123, 46,  255, 92,  126, 52,  255, 60,  84,  34,  255, 62,  72,  23,  255, 94,  115,
    39,  255, 83,  102, 34,  255, 60,  82,  23,  255, 69,  89,  32,  255, 173, 185, 117, 255, 217, 231, 161, 255, 189, 215, 158, 255, 174, 206, 152,
    255, 180, 210, 145, 255, 186, 216, 144, 255, 190, 219, 140, 255, 195, 216, 129, 255, 204, 212, 103, 255, 221, 226, 121, 255, 218, 225, 126, 255,
    199, 214, 105, 255, 186, 209, 121, 255, 186, 213, 147, 255, 190, 216, 158, 255, 217, 228, 163, 255, 172, 188, 80,  255, 142, 166, 52,  255, 157,
    178, 65,  255, 130, 153, 60,  255, 81,  109, 52,  255, 92,  122, 62,  255, 69,  95,  48,  255, 26,  31,  21,  255, 21,  23,  21,  255, 88,  110,
    55,  255, 135, 165, 87,  255, 167, 184, 112, 255, 214, 225, 157, 255, 191, 219, 159, 255, 178, 212, 150, 255, 174, 209, 146, 255, 175, 207, 145,
    255, 188, 212, 127, 255, 143, 165, 80,  255, 163, 188, 105, 255, 176, 204, 151, 255, 177, 203, 133, 255, 163, 193, 117, 255, 172, 203, 134, 255,
    199, 221, 141, 255, 206, 226, 145, 255, 198, 215, 137, 255, 158, 170, 92,  255, 151, 177, 110, 255, 175, 203, 149, 255, 135, 153, 89,  255, 109,
    132, 65,  255, 86,  107, 45,  255, 56,  79,  23,  255, 98,  119, 41,  255, 124, 146, 55,  255, 130, 148, 62,  255, 123, 144, 55,  255, 136, 162,
    74,  255, 117, 144, 74,  255, 158, 175, 95,  255, 202, 217, 150, 255, 174, 204, 145, 255, 205, 223, 150, 255, 173, 185, 99,  255, 65,  94,  36,
    255, 67,  95,  42,  255, 96,  128, 42,  255, 112, 146, 41,  255, 139, 167, 72,  255, 149, 175, 104, 255, 147, 164, 84,  255, 181, 192, 101, 255,
    224, 229, 133, 255, 232, 239, 143, 255, 227, 233, 137, 255, 223, 230, 133, 255, 221, 229, 124, 255, 214, 228, 103, 255, 124, 145, 49,  255, 160,
    173, 74,  255, 209, 218, 95,  255, 192, 210, 87,  255, 208, 217, 84,  255, 227, 227, 107, 255, 173, 177, 87,  255, 177, 172, 96,  255, 204, 210,
    127, 255, 215, 232, 149, 255, 201, 224, 158, 255, 226, 234, 160, 255, 248, 243, 160, 255, 243, 241, 158, 255, 243, 241, 155, 255, 254, 250, 153,
    255, 226, 219, 123, 255, 169, 164, 92,  255, 92,  92,  49,  255, 15,  28,  15,  255, 12,  28,  19,  255, 19,  37,  23,  255, 26,  34,  23,  255,
    32,  47,  26,  255, 62,  91,  40,  255, 65,  92,  41,  255, 69,  101, 42,  255, 98,  133, 74,  255, 80,  111, 77,  255, 67,  96,  68,  255, 56,
    87,  58,  255, 93,  119, 65,  255, 106, 128, 63,  255, 137, 157, 74,  255, 217, 225, 101, 255, 183, 201, 92,  255, 142, 172, 85,  255, 124, 157,
    83,  255, 120, 155, 86,  255, 116, 155, 83,  255, 107, 148, 68,  255, 119, 150, 65,  255, 93,  116, 50,  255, 92,  114, 56,  255, 65,  84,  39,
    255, 50,  65,  33,  255, 23,  34,  23,  255, 36,  52,  29,  255, 41,  65,  29,  255, 58,  87,  43,  255, 138, 168, 98,  255, 146, 171, 98,  255,
    178, 204, 117, 255, 177, 203, 109, 255, 175, 201, 99,  255, 173, 199, 98,  255, 169, 196, 92,  255, 154, 185, 77,  255, 134, 163, 74,  255, 180,
    198, 108, 255, 215, 226, 150, 255, 183, 204, 133, 255, 202, 220, 141, 255, 212, 226, 143, 255, 163, 183, 117, 255, 119, 150, 84,  255, 123, 155,
    84,  255, 175, 199, 117, 255, 185, 207, 120, 255, 183, 204, 142, 255, 167, 197, 144, 255, 169, 200, 143, 255, 213, 223, 145, 255, 134, 142, 67,
    255, 102, 139, 82,  255, 150, 179, 114, 255, 150, 178, 110, 255, 146, 178, 108, 255, 151, 181, 106, 255, 159, 188, 108, 255, 173, 193, 99,  255,
    178, 189, 86,  255, 162, 174, 87,  255, 141, 153, 74,  255, 97,  115, 60,  255, 87,  115, 65,  255, 121, 159, 99,  255, 111, 146, 103, 255, 114,
    146, 108, 255, 112, 145, 110, 255, 110, 145, 107, 255, 118, 153, 105, 255, 145, 172, 99,  255, 176, 195, 107, 255, 148, 173, 95,  255, 138, 172,
    83,  255, 110, 151, 62,  255, 124, 155, 73,  255, 85,  105, 52,  255, 76,  99,  47,  255, 100, 127, 55,  255, 109, 138, 60,  255, 90,  123, 65,
    255, 82,  110, 47,  255, 84,  107, 47,  255, 94,  122, 52,  255, 84,  109, 42,  255, 90,  112, 41,  255, 67,  92,  31,  255, 63,  97,  29,  255,
    112, 146, 55,  255, 120, 156, 103, 255, 92,  127, 65,  255, 135, 167, 112, 255, 197, 213, 136, 255, 175, 200, 161, 255, 187, 211, 182, 255, 183,
    206, 188, 255, 199, 215, 181, 255, 196, 212, 171, 255, 159, 181, 116, 255, 140, 165, 93,  255, 163, 183, 109, 255, 198, 205, 104, 255, 239, 231,
    124, 255, 143, 146, 82,  255, 15,  26,  12,  255, 40,  55,  26,  255, 94,  109, 52,  255, 132, 144, 62,  255, 140, 166, 76,  255, 139, 163, 75,
    255, 199, 213, 120, 255, 158, 177, 86,  255, 183, 190, 62,  255, 170, 192, 84,  255, 126, 160, 87,  255, 122, 154, 82,  255, 142, 168, 84,  255,
    154, 178, 71,  255, 175, 191, 73,  255, 174, 186, 76,  255, 163, 181, 103, 255, 162, 176, 106, 255, 192, 205, 114, 255, 163, 180, 98,  255, 94,
    115, 47,  255, 93,  118, 47,  255, 60,  86,  31,  255, 109, 125, 50,  255, 154, 176, 81,  255, 138, 170, 72,  255, 129, 166, 60,  255, 121, 155,
    52,  255, 119, 138, 58,  255, 122, 143, 60,  255, 105, 129, 48,  255, 128, 134, 48,  255, 188, 196, 119, 255, 172, 186, 121, 255, 172, 186, 144,
    255, 164, 177, 115, 255, 162, 180, 95,  255, 155, 185, 91,  255, 151, 185, 89,  255, 149, 183, 86,  255, 152, 185, 76,  255, 121, 152, 60,  255,
    26,  41,  17,  255, 53,  82,  26,  255, 65,  98,  29,  255, 68,  103, 31,  255, 63,  99,  26,  255, 73,  104, 31,  255, 87,  122, 36,  255, 81,
    118, 39,  255, 60,  82,  31,  255, 68,  89,  29,  255, 55,  81,  21,  255, 62,  91,  25,  255, 89,  110, 37,  255, 145, 154, 81,  255, 165, 172,
    105, 255, 186, 199, 122, 255, 197, 216, 133, 255, 181, 197, 116, 255, 159, 169, 89,  255, 141, 152, 73,  255, 126, 148, 63,  255, 119, 147, 65,
    255, 178, 186, 97,  255, 193, 202, 119, 255, 184, 198, 115, 255, 198, 208, 110, 255, 198, 212, 115, 255, 190, 214, 142, 255, 205, 222, 163, 255,
    179, 194, 104, 255, 161, 179, 75,  255, 166, 183, 76,  255, 118, 138, 50,  255, 86,  116, 52,  255, 87,  116, 56,  255, 75,  107, 41,  255, 47,
    72,  26,  255, 75,  87,  33,  255, 181, 195, 112, 255, 195, 211, 132, 255, 199, 218, 154, 255, 218, 225, 147, 255, 213, 224, 144, 255, 201, 217,
    132, 255, 196, 219, 121, 255, 187, 215, 109, 255, 183, 206, 102, 255, 184, 203, 96,  255, 174, 194, 112, 255, 171, 198, 120, 255, 179, 206, 101,
    255, 185, 210, 99,  255, 206, 219, 108, 255, 198, 206, 102, 255, 162, 179, 84,  255, 100, 119, 53,  255, 42,  62,  31,  255, 78,  100, 47,  255,
    152, 175, 116, 255, 135, 156, 93,  255, 69,  99,  43,  255, 58,  87,  37,  255, 47,  69,  31,  255, 41,  58,  23,  255, 39,  52,  21,  255, 40,
    52,  26,  255, 19,  26,  17,  255, 44,  48,  19,  255, 147, 165, 80,  255, 163, 184, 94,  255, 189, 213, 134, 255, 204, 219, 133, 255, 147, 149,
    77,  255, 94,  107, 37,  255, 106, 137, 55,  255, 100, 132, 50,  255, 111, 141, 46,  255, 133, 159, 56,  255, 137, 161, 60,  255, 135, 161, 63,
    255, 136, 168, 62,  255, 142, 176, 76,  255, 159, 177, 86,  255, 179, 181, 94,  255, 222, 222, 126, 255, 223, 224, 122, 255, 211, 212, 110, 255,
    176, 181, 81,  255, 186, 194, 100, 255, 186, 202, 98,  255, 193, 215, 114, 255, 192, 213, 118, 255, 207, 220, 119, 255, 166, 175, 84,  255, 83,
    100, 44,  255, 21,  31,  12,  255, 173, 177, 103, 255, 254, 250, 156, 255, 235, 238, 158, 255, 232, 236, 158, 255, 224, 228, 143, 255, 230, 235,
    138, 255, 250, 245, 136, 255, 177, 167, 94,  255, 49,  52,  26,  255, 38,  60,  29,  255, 82,  112, 52,  255, 96,  124, 63,  255, 85,  111, 56,
    255, 73,  102, 50,  255, 67,  95,  49,  255, 57,  86,  44,  255, 63,  95,  43,  255, 67,  96,  43,  255, 80,  117, 52,  255, 95,  128, 68,  255,
    75,  107, 68,  255, 78,  114, 67,  255, 84,  125, 62,  255, 81,  119, 62,  255, 129, 150, 76,  255, 229, 230, 122, 255, 213, 217, 111, 255, 194,
    207, 105, 255, 162, 185, 89,  255, 136, 168, 75,  255, 128, 164, 68,  255, 139, 171, 65,  255, 111, 152, 62,  255, 142, 173, 74,  255, 114, 137,
    62,  255, 65,  82,  39,  255, 40,  58,  31,  255, 41,  65,  32,  255, 42,  60,  31,  255, 33,  52,  26,  255, 34,  56,  28,  255, 94,  116, 68,
    255, 139, 157, 81,  255, 111, 135, 62,  255, 138, 163, 84,  255, 168, 189, 97,  255, 179, 202, 100, 255, 173, 197, 90,  255, 165, 191, 86,  255,
    146, 173, 77,  255, 171, 190, 111, 255, 187, 204, 121, 255, 233, 241, 155, 255, 204, 217, 131, 255, 163, 198, 121, 255, 180, 211, 139, 255, 214,
    229, 160, 255, 172, 190, 128, 255, 113, 145, 82,  255, 165, 196, 107, 255, 173, 201, 107, 255, 184, 209, 149, 255, 173, 203, 152, 255, 183, 211,
    149, 255, 220, 221, 140, 255, 117, 134, 56,  255, 123, 159, 68,  255, 132, 162, 71,  255, 147, 171, 76,  255, 159, 180, 86,  255, 167, 182, 87,
    255, 150, 164, 76,  255, 113, 130, 60,  255, 78,  102, 53,  255, 63,  89,  53,  255, 85,  118, 65,  255, 130, 168, 104, 255, 130, 166, 110, 255,
    116, 153, 101, 255, 113, 152, 96,  255, 123, 160, 106, 255, 127, 161, 115, 255, 126, 161, 120, 255, 146, 176, 120, 255, 185, 201, 112, 255, 142,
    167, 107, 255, 124, 159, 92,  255, 116, 148, 68,  255, 79,  113, 39,  255, 129, 151, 68,  255, 153, 183, 89,  255, 117, 154, 74,  255, 150, 176,
    114, 255, 97,  128, 68,  255, 69,  103, 62,  255, 75,  112, 67,  255, 96,  129, 68,  255, 124, 152, 81,  255, 113, 143, 65,  255, 45,  65,  25,
    255, 78,  98,  41,  255, 53,  73,  23,  255, 71,  107, 33,  255, 110, 146, 78,  255, 95,  132, 69,  255, 152, 180, 106, 255, 202, 216, 122, 255,
    199, 213, 160, 255, 178, 203, 174, 255, 183, 207, 184, 255, 192, 214, 180, 255, 193, 210, 175, 255, 135, 162, 98,  255, 69,  86,  43,  255, 147,
    165, 115, 255, 213, 224, 156, 255, 237, 238, 169, 255, 142, 153, 102, 255, 113, 121, 53,  255, 177, 179, 63,  255, 217, 215, 71,  255, 231, 234,
    115, 255, 182, 209, 128, 255, 165, 195, 121, 255, 198, 214, 139, 255, 188, 200, 115, 255, 175, 183, 75,  255, 178, 189, 92,  255, 177, 188, 83,
    255, 157, 168, 65,  255, 172, 184, 62,  255, 170, 191, 76,  255, 157, 184, 65,  255, 130, 158, 63,  255, 132, 155, 77,  255, 148, 166, 77,  255,
    174, 192, 91,  255, 166, 186, 89,  255, 87,  109, 44,  255, 69,  97,  36,  255, 98,  113, 44,  255, 162, 174, 76,  255, 148, 163, 73,  255, 132,
    152, 65,  255, 143, 170, 73,  255, 139, 172, 65,  255, 113, 145, 53,  255, 101, 125, 47,  255, 57,  86,  28,  255, 72,  85,  15,  255, 185, 180,
    83,  255, 208, 232, 148, 255, 190, 217, 151, 255, 205, 223, 158, 255, 217, 229, 147, 255, 205, 222, 124, 255, 163, 193, 96,  255, 161, 191, 87,
    255, 169, 196, 90,  255, 126, 153, 60,  255, 108, 129, 60,  255, 69,  98,  32,  255, 58,  90,  25,  255, 58,  95,  29,  255, 72,  112, 39,  255,
    95,  138, 50,  255, 99,  143, 47,  255, 105, 151, 44,  255, 67,  96,  32,  255, 36,  43,  19,  255, 104, 120, 49,  255, 150, 163, 77,  255, 160,
    168, 83,  255, 153, 162, 77,  255, 126, 147, 55,  255, 135, 163, 45,  255, 166, 187, 68,  255, 99,  122, 45,  255, 46,  72,  21,  255, 31,  58,
    15,  255, 65,  97,  34,  255, 113, 149, 74,  255, 124, 154, 76,  255, 153, 175, 93,  255, 150, 175, 103, 255, 150, 174, 100, 255, 156, 177, 82,
    255, 176, 193, 103, 255, 205, 216, 144, 255, 156, 174, 91,  255, 149, 169, 74,  255, 137, 152, 65,  255, 65,  90,  28,  255, 97,  127, 49,  255,
    91,  123, 52,  255, 65,  98,  36,  255, 65,  96,  31,  255, 113, 131, 44,  255, 197, 197, 119, 255, 195, 198, 114, 255, 187, 213, 156, 255, 175,
    203, 152, 255, 191, 210, 150, 255, 193, 204, 131, 255, 121, 134, 60,  255, 165, 179, 74,  255, 163, 189, 63,  255, 171, 179, 91,  255, 168, 182,
    104, 255, 165, 187, 127, 255, 187, 208, 141, 255, 202, 213, 120, 255, 161, 179, 84,  255, 134, 163, 73,  255, 95,  118, 48,  255, 47,  63,  33,
    255, 52,  77,  43,  255, 53,  82,  37,  255, 78,  103, 43,  255, 109, 137, 65,  255, 87,  122, 40,  255, 99,  133, 55,  255, 83,  111, 53,  255,
    86,  107, 62,  255, 97,  112, 73,  255, 111, 126, 75,  255, 147, 167, 109, 255, 130, 149, 96,  255, 130, 152, 78,  255, 133, 155, 79,  255, 153,
    169, 83,  255, 110, 125, 56,  255, 58,  73,  32,  255, 47,  53,  31,  255, 68,  75,  34,  255, 91,  106, 43,  255, 133, 151, 60,  255, 166, 178,
    77,  255, 171, 185, 74,  255, 154, 183, 62,  255, 144, 178, 68,  255, 157, 189, 97,  255, 160, 191, 104, 255, 94,  119, 47,  255, 101, 122, 34,
    255, 116, 132, 47,  255, 136, 144, 62,  255, 216, 217, 127, 255, 215, 226, 146, 255, 200, 215, 131, 255, 198, 214, 121, 255, 202, 216, 113, 255,
    212, 220, 112, 255, 191, 203, 101, 255, 69,  90,  37,  255, 135, 145, 90,  255, 239, 243, 154, 255, 224, 227, 138, 255, 210, 218, 130, 255, 197,
    215, 132, 255, 204, 219, 129, 255, 212, 213, 112, 255, 118, 111, 58,  255, 39,  53,  26,  255, 110, 135, 73,  255, 158, 185, 89,  255, 163, 191,
    92,  255, 157, 186, 89,  255, 141, 173, 84,  255, 123, 158, 83,  255, 103, 139, 69,  255, 94,  131, 62,  255, 82,  117, 56,  255, 68,  99,  46,
    255, 82,  119, 53,  255, 82,  118, 48,  255, 104, 141, 72,  255, 109, 143, 84,  255, 105, 140, 78,  255, 86,  114, 73,  255, 192, 201, 123, 255,
    202, 214, 120, 255, 173, 195, 103, 255, 151, 181, 90,  255, 147, 179, 84,  255, 147, 179, 81,  255, 163, 189, 74,  255, 176, 197, 78,  255, 157,
    182, 75,  255, 147, 168, 87,  255, 133, 154, 75,  255, 63,  82,  39,  255, 36,  52,  31,  255, 44,  67,  34,  255, 50,  75,  31,  255, 40,  58,
    36,  255, 85,  99,  58,  255, 98,  103, 60,  255, 88,  110, 37,  255, 128, 165, 58,  255, 118, 150, 62,  255, 111, 144, 65,  255, 122, 151, 68,
    255, 127, 155, 67,  255, 91,  114, 44,  255, 53,  74,  26,  255, 85,  92,  52,  255, 108, 118, 62,  255, 151, 161, 80,  255, 189, 203, 111, 255,
    202, 224, 135, 255, 170, 205, 123, 255, 181, 212, 148, 255, 201, 219, 147, 255, 168, 186, 111, 255, 182, 208, 114, 255, 179, 208, 123, 255, 187,
    212, 159, 255, 194, 216, 140, 255, 222, 235, 148, 255, 231, 230, 130, 255, 127, 147, 56,  255, 92,  119, 40,  255, 87,  110, 47,  255, 77,  98,
    41,  255, 87,  112, 44,  255, 75,  102, 40,  255, 60,  87,  46,  255, 62,  90,  58,  255, 65,  94,  65,  255, 63,  95,  58,  255, 58,  89,  48,
    255, 87,  119, 65,  255, 114, 151, 81,  255, 113, 151, 74,  255, 119, 157, 95,  255, 130, 165, 118, 255, 136, 169, 120, 255, 155, 180, 120, 255,
    151, 172, 99,  255, 111, 140, 80,  255, 83,  122, 80,  255, 119, 155, 92,  255, 71,  92,  36,  255, 94,  121, 50,  255, 156, 185, 102, 255, 124,
    163, 84,  255, 162, 190, 126, 255, 114, 143, 95,  255, 65,  98,  58,  255, 80,  112, 65,  255, 96,  128, 72,  255, 124, 153, 76,  255, 115, 143,
    67,  255, 60,  94,  29,  255, 47,  72,  26,  255, 82,  100, 44,  255, 131, 145, 60,  255, 86,  113, 28,  255, 81,  120, 38,  255, 113, 150, 68,
    255, 109, 140, 62,  255, 98,  125, 56,  255, 217, 223, 148, 255, 193, 211, 169, 255, 180, 206, 180, 255, 185, 208, 186, 255, 183, 206, 181, 255,
    123, 149, 90,  255, 32,  38,  15,  255, 112, 122, 91,  255, 174, 201, 155, 255, 193, 221, 175, 255, 219, 233, 179, 255, 249, 241, 137, 255, 249,
    235, 97,  255, 234, 225, 86,  255, 220, 221, 106, 255, 207, 219, 111, 255, 191, 206, 114, 255, 140, 157, 72,  255, 137, 158, 73,  255, 141, 168,
    87,  255, 131, 154, 68,  255, 107, 126, 45,  255, 56,  65,  21,  255, 96,  112, 26,  255, 158, 175, 63,  255, 170, 190, 72,  255, 158, 180, 72,
    255, 123, 146, 71,  255, 143, 165, 74,  255, 171, 188, 86,  255, 175, 186, 79,  255, 83,  105, 37,  255, 91,  109, 47,  255, 127, 136, 65,  255,
    114, 125, 58,  255, 79,  99,  44,  255, 75,  104, 43,  255, 81,  112, 47,  255, 94,  121, 41,  255, 120, 147, 46,  255, 121, 149, 49,  255, 121,
    149, 60,  255, 72,  102, 40,  255, 60,  75,  17,  255, 182, 185, 100, 255, 192, 224, 140, 255, 172, 205, 128, 255, 177, 207, 136, 255, 203, 221,
    127, 255, 199, 219, 113, 255, 183, 206, 103, 255, 183, 203, 97,  255, 179, 199, 87,  255, 130, 152, 63,  255, 81,  110, 36,  255, 69,  102, 29,
    255, 80,  116, 36,  255, 109, 151, 55,  255, 116, 156, 60,  255, 126, 164, 68,  255, 126, 167, 68,  255, 97,  138, 52,  255, 114, 126, 52,  255,
    187, 192, 90,  255, 185, 186, 83,  255, 191, 190, 92,  255, 193, 194, 100, 255, 186, 203, 93,  255, 182, 207, 84,  255, 143, 166, 71,  255, 63,
    84,  26,  255, 82,  104, 37,  255, 60,  87,  34,  255, 57,  86,  32,  255, 108, 144, 69,  255, 112, 149, 74,  255, 115, 149, 74,  255, 127, 150,
    65,  255, 200, 210, 89,  255, 162, 195, 85,  255, 139, 173, 83,  255, 151, 181, 87,  255, 163, 187, 87,  255, 207, 213, 101, 255, 145, 166, 67,
    255, 120, 151, 62,  255, 151, 173, 58,  255, 184, 198, 71,  255, 127, 148, 58,  255, 49,  74,  26,  255, 65,  92,  31,  255, 58,  81,  34,  255,
    97,  101, 47,  255, 207, 225, 148, 255, 176, 205, 155, 255, 173, 203, 159, 255, 186, 213, 160, 255, 146, 165, 108, 255, 121, 145, 56,  255, 176,
    205, 87,  255, 166, 182, 90,  255, 170, 185, 119, 255, 164, 187, 133, 255, 204, 222, 149, 255, 189, 205, 112, 255, 132, 156, 72,  255, 87,  106,
    41,  255, 62,  83,  36,  255, 49,  67,  36,  255, 58,  84,  44,  255, 63,  92,  40,  255, 47,  71,  23,  255, 118, 132, 68,  255, 186, 205, 128,
    255, 190, 206, 135, 255, 151, 168, 99,  255, 168, 194, 133, 255, 197, 213, 138, 255, 205, 223, 149, 255, 192, 216, 145, 255, 187, 215, 135, 255,
    172, 195, 98,  255, 116, 134, 55,  255, 71,  95,  42,  255, 62,  83,  41,  255, 56,  71,  38,  255, 44,  65,  33,  255, 47,  69,  28,  255, 146,
    159, 65,  255, 204, 211, 91,  255, 184, 197, 89,  255, 187, 199, 87,  255, 198, 208, 100, 255, 158, 184, 77,  255, 153, 182, 89,  255, 162, 192,
    103, 255, 143, 172, 75,  255, 120, 149, 47,  255, 133, 155, 62,  255, 212, 219, 136, 255, 205, 220, 143, 255, 171, 199, 130, 255, 167, 195, 130,
    255, 166, 193, 126, 255, 160, 190, 102, 255, 178, 196, 89,  255, 192, 200, 97,  255, 144, 163, 77,  255, 211, 222, 117, 255, 199, 212, 103, 255,
    211, 222, 109, 255, 228, 232, 133, 255, 225, 223, 131, 255, 190, 186, 78,  255, 114, 125, 45,  255, 67,  92,  40,  255, 156, 179, 87,  255, 182,
    202, 103, 255, 157, 183, 96,  255, 130, 159, 93,  255, 125, 158, 93,  255, 121, 154, 90,  255, 102, 138, 87,  255, 92,  128, 81,  255, 89,  125,
    67,  255, 89,  125, 55,  255, 73,  103, 47,  255, 69,  98,  46,  255, 89,  124, 52,  255, 120, 152, 87,  255, 115, 144, 95,  255, 105, 130, 86,
    255, 90,  113, 69,  255, 139, 155, 84,  255, 181, 194, 93,  255, 172, 187, 98,  255, 178, 189, 90,  255, 185, 191, 83,  255, 208, 212, 91,  255,
    202, 204, 87,  255, 181, 186, 87,  255, 127, 144, 86,  255, 96,  124, 87,  255, 125, 150, 84,  255, 81,  99,  48,  255, 43,  60,  36,  255, 50,
    76,  36,  255, 83,  106, 52,  255, 96,  107, 60,  255, 60,  74,  39,  255, 32,  52,  28,  255, 29,  42,  25,  255, 82,  103, 38,  255, 130, 160,
    60,  255, 138, 170, 71,  255, 137, 169, 83,  255, 148, 179, 98,  255, 162, 188, 106, 255, 67,  81,  44,  255, 21,  31,  23,  255, 34,  52,  29,
    255, 69,  96,  52,  255, 136, 157, 103, 255, 166, 178, 120, 255, 214, 227, 132, 255, 185, 215, 116, 255, 166, 200, 115, 255, 200, 218, 138, 255,
    212, 223, 139, 255, 178, 205, 142, 255, 173, 200, 104, 255, 176, 207, 97,  255, 192, 220, 132, 255, 195, 225, 142, 255, 207, 228, 137, 255, 172,
    187, 100, 255, 115, 148, 60,  255, 126, 164, 69,  255, 149, 179, 80,  255, 152, 174, 81,  255, 96,  118, 68,  255, 67,  94,  62,  255, 69,  99,
    58,  255, 68,  102, 50,  255, 77,  110, 47,  255, 96,  126, 52,  255, 113, 147, 62,  255, 159, 183, 84,  255, 180, 198, 101, 255, 176, 195, 115,
    255, 159, 177, 102, 255, 127, 145, 73,  255, 68,  86,  36,  255, 93,  122, 67,  255, 99,  132, 84,  255, 131, 160, 87,  255, 152, 176, 77,  255,
    155, 185, 95,  255, 132, 169, 93,  255, 138, 170, 96,  255, 120, 149, 94,  255, 71,  104, 62,  255, 74,  108, 62,  255, 131, 162, 72,  255, 139,
    168, 74,  255, 114, 150, 62,  255, 121, 148, 62,  255, 72,  104, 36,  255, 84,  122, 52,  255, 110, 139, 60,  255, 125, 148, 62,  255, 139, 156,
    60,  255, 114, 134, 43,  255, 129, 150, 60,  255, 77,  104, 44,  255, 69,  99,  36,  255, 111, 133, 65,  255, 211, 220, 153, 255, 183, 206, 170,
    255, 181, 207, 188, 255, 180, 204, 188, 255, 113, 141, 77,  255, 29,  42,  15,  255, 6,   12,  12,  255, 85,  96,  63,  255, 191, 218, 157, 255,
    190, 220, 177, 255, 208, 222, 158, 255, 239, 238, 156, 255, 207, 217, 102, 255, 204, 209, 97,  255, 205, 205, 81,  255, 174, 187, 68,  255, 99,
    124, 37,  255, 147, 172, 93,  255, 121, 152, 85,  255, 113, 147, 65,  255, 72,  102, 34,  255, 47,  74,  19,  255, 52,  75,  21,  255, 115, 136,
    56,  255, 141, 167, 65,  255, 149, 172, 69,  255, 138, 158, 71,  255, 148, 169, 68,  255, 149, 167, 67,  255, 110, 130, 52,  255, 72,  98,  36,
    255, 86,  103, 42,  255, 79,  104, 48,  255, 82,  118, 53,  255, 90,  131, 68,  255, 73,  109, 60,  255, 89,  121, 46,  255, 123, 150, 44,  255,
    130, 158, 50,  255, 128, 157, 52,  255, 149, 170, 68,  255, 91,  121, 45,  255, 73,  104, 25,  255, 125, 140, 41,  255, 204, 216, 118, 255, 188,
    220, 134, 255, 168, 204, 116, 255, 167, 199, 111, 255, 195, 219, 122, 255, 195, 215, 112, 255, 179, 202, 91,  255, 165, 188, 84,  255, 93,  119,
    38,  255, 83,  111, 29,  255, 84,  110, 37,  255, 139, 160, 79,  255, 186, 203, 121, 255, 200, 213, 140, 255, 212, 222, 152, 255, 206, 218, 146,
    255, 195, 208, 128, 255, 198, 210, 106, 255, 184, 197, 87,  255, 177, 183, 82,  255, 187, 192, 90,  255, 193, 202, 93,  255, 202, 207, 116, 255,
    175, 195, 93,  255, 90,  115, 48,  255, 28,  38,  17,  255, 41,  52,  21,  255, 75,  92,  34,  255, 68,  92,  34,  255, 82,  108, 47,  255, 110,
    146, 72,  255, 108, 145, 72,  255, 92,  122, 44,  255, 197, 206, 83,  255, 155, 189, 95,  255, 146, 178, 87,  255, 154, 188, 97,  255, 166, 195,
    107, 255, 212, 222, 130, 255, 193, 208, 99,  255, 133, 166, 78,  255, 137, 168, 76,  255, 192, 200, 77,  255, 218, 217, 92,  255, 69,  92,  31,
    255, 50,  74,  28,  255, 38,  58,  23,  255, 84,  93,  37,  255, 221, 229, 138, 255, 189, 213, 147, 255, 189, 213, 144, 255, 190, 214, 148, 255,
    205, 217, 148, 255, 162, 178, 90,  255, 191, 213, 111, 255, 121, 140, 62,  255, 134, 154, 83,  255, 161, 182, 113, 255, 135, 144, 77,  255, 73,
    84,  33,  255, 63,  80,  36,  255, 33,  51,  23,  255, 48,  69,  29,  255, 49,  68,  33,  255, 60,  87,  38,  255, 62,  91,  34,  255, 134, 147,
    84,  255, 201, 216, 146, 255, 199, 221, 149, 255, 184, 198, 112, 255, 137, 158, 69,  255, 185, 199, 120, 255, 200, 215, 136, 255, 177, 200, 122,
    255, 181, 199, 110, 255, 208, 219, 139, 255, 216, 231, 171, 255, 155, 171, 108, 255, 75,  89,  45,  255, 55,  68,  36,  255, 65,  94,  40,  255,
    68,  101, 31,  255, 149, 167, 62,  255, 193, 204, 86,  255, 159, 178, 92,  255, 128, 157, 92,  255, 145, 170, 85,  255, 193, 200, 94,  255, 159,
    181, 73,  255, 149, 182, 78,  255, 162, 190, 97,  255, 154, 180, 80,  255, 138, 164, 53,  255, 186, 199, 97,  255, 205, 222, 168, 255, 177, 207,
    157, 255, 173, 201, 134, 255, 173, 201, 123, 255, 180, 204, 113, 255, 182, 205, 101, 255, 212, 226, 114, 255, 176, 189, 95,  255, 141, 162, 87,
    255, 159, 181, 112, 255, 177, 195, 126, 255, 235, 230, 141, 255, 254, 241, 142, 255, 126, 124, 65,  255, 123, 129, 58,  255, 128, 145, 74,  255,
    134, 153, 82,  255, 190, 207, 106, 255, 145, 172, 102, 255, 116, 149, 101, 255, 108, 143, 97,  255, 116, 148, 96,  255, 116, 147, 89,  255, 110,
    144, 84,  255, 102, 139, 74,  255, 91,  132, 62,  255, 107, 146, 50,  255, 91,  121, 56,  255, 67,  92,  44,  255, 79,  104, 53,  255, 120, 148,
    97,  255, 100, 131, 97,  255, 100, 123, 79,  255, 93,  122, 80,  255, 75,  104, 60,  255, 130, 155, 77,  255, 137, 173, 107, 255, 115, 137, 74,
    255, 67,  87,  39,  255, 111, 132, 56,  255, 146, 165, 82,  255, 119, 148, 81,  255, 95,  128, 81,  255, 96,  127, 86,  255, 107, 136, 89,  255,
    89,  113, 58,  255, 60,  82,  46,  255, 96,  119, 65,  255, 119, 142, 76,  255, 89,  122, 60,  255, 74,  115, 55,  255, 76,  117, 52,  255, 74,
    112, 52,  255, 65,  98,  46,  255, 75,  102, 44,  255, 118, 142, 65,  255, 164, 189, 103, 255, 186, 208, 127, 255, 192, 214, 127, 255, 159, 176,
    102, 255, 55,  76,  40,  255, 53,  80,  41,  255, 94,  125, 62,  255, 136, 161, 103, 255, 90,  120, 92,  255, 125, 145, 99,  255, 173, 190, 107,
    255, 172, 198, 101, 255, 169, 198, 106, 255, 188, 206, 134, 255, 173, 199, 112, 255, 169, 201, 82,  255, 187, 217, 109, 255, 196, 214, 109, 255,
    189, 206, 106, 255, 164, 185, 96,  255, 154, 176, 87,  255, 123, 154, 69,  255, 119, 156, 72,  255, 129, 167, 83,  255, 172, 202, 99,  255, 194,
    203, 104, 255, 76,  98,  62,  255, 72,  106, 58,  255, 84,  114, 50,  255, 112, 144, 63,  255, 93,  125, 52,  255, 55,  92,  36,  255, 95,  127,
    55,  255, 105, 136, 60,  255, 109, 132, 71,  255, 121, 142, 78,  255, 86,  106, 47,  255, 53,  77,  38,  255, 65,  90,  46,  255, 99,  135, 75,
    255, 96,  127, 55,  255, 125, 162, 74,  255, 147, 182, 90,  255, 110, 141, 76,  255, 84,  117, 69,  255, 71,  108, 62,  255, 84,  120, 68,  255,
    105, 139, 71,  255, 138, 165, 63,  255, 108, 138, 68,  255, 97,  130, 76,  255, 124, 154, 82,  255, 97,  128, 48,  255, 86,  120, 50,  255, 103,
    133, 49,  255, 145, 166, 62,  255, 130, 154, 48,  255, 137, 162, 65,  255, 136, 156, 62,  255, 106, 125, 56,  255, 150, 164, 82,  255, 110, 129,
    55,  255, 130, 150, 92,  255, 201, 221, 156, 255, 186, 211, 181, 255, 183, 205, 184, 255, 102, 122, 63,  255, 37,  46,  19,  255, 62,  72,  32,
    255, 152, 160, 82,  255, 207, 224, 108, 255, 202, 223, 115, 255, 176, 206, 128, 255, 187, 203, 123, 255, 207, 216, 115, 255, 218, 212, 87,  255,
    212, 207, 83,  255, 127, 141, 47,  255, 102, 125, 48,  255, 119, 149, 87,  255, 109, 139, 75,  255, 101, 134, 55,  255, 44,  69,  19,  255, 42,
    65,  19,  255, 53,  71,  17,  255, 140, 155, 69,  255, 165, 191, 94,  255, 154, 183, 85,  255, 156, 182, 84,  255, 155, 171, 80,  255, 103, 126,
    58,  255, 55,  83,  26,  255, 69,  96,  28,  255, 76,  101, 33,  255, 100, 134, 68,  255, 101, 137, 83,  255, 91,  127, 85,  255, 94,  123, 68,
    255, 127, 152, 47,  255, 130, 156, 44,  255, 137, 162, 53,  255, 143, 168, 63,  255, 161, 180, 74,  255, 104, 131, 40,  255, 95,  128, 33,  255,
    87,  115, 32,  255, 198, 199, 119, 255, 218, 232, 149, 255, 210, 229, 142, 255, 184, 215, 125, 255, 173, 206, 110, 255, 186, 213, 106, 255, 164,
    188, 83,  255, 117, 139, 56,  255, 122, 143, 60,  255, 179, 189, 108, 255, 218, 222, 158, 255, 236, 241, 184, 255, 239, 245, 189, 255, 229, 239,
    187, 255, 226, 238, 187, 255, 227, 238, 187, 255, 234, 241, 186, 255, 235, 241, 184, 255, 241, 243, 174, 255, 203, 211, 128, 255, 185, 204, 93,
    255, 189, 210, 74,  255, 177, 185, 96,  255, 79,  114, 32,  255, 48,  80,  26,  255, 19,  31,  19,  255, 19,  31,  19,  255, 23,  28,  19,  255,
    55,  62,  28,  255, 68,  92,  31,  255, 89,  124, 47,  255, 99,  135, 60,  255, 74,  110, 43,  255, 146, 157, 62,  255, 191, 212, 114, 255, 142,
    181, 95,  255, 159, 188, 107, 255, 180, 202, 108, 255, 204, 218, 118, 255, 227, 216, 97,  255, 199, 206, 89,  255, 149, 177, 97,  255, 200, 205,
    97,  255, 215, 215, 89,  255, 97,  124, 38,  255, 43,  65,  23,  255, 60,  87,  31,  255, 85,  110, 36,  255, 225, 226, 137, 255, 216, 228, 141,
    255, 212, 224, 111, 255, 202, 219, 92,  255, 206, 221, 108, 255, 169, 186, 96,  255, 127, 153, 69,  255, 58,  84,  31,  255, 142, 157, 92,  255,
    190, 203, 122, 255, 166, 174, 93,  255, 123, 138, 65,  255, 68,  104, 39,  255, 90,  118, 55,  255, 124, 138, 78,  255, 139, 155, 78,  255, 120,
    143, 58,  255, 125, 140, 68,  255, 209, 226, 153, 255, 169, 202, 134, 255, 191, 210, 114, 255, 163, 187, 86,  255, 194, 210, 106, 255, 175, 192,
    100, 255, 198, 208, 116, 255, 199, 212, 123, 255, 174, 193, 110, 255, 177, 191, 108, 255, 233, 241, 168, 255, 216, 235, 178, 255, 192, 202, 138,
    255, 118, 133, 62,  255, 86,  104, 31,  255, 125, 145, 49,  255, 185, 198, 82,  255, 156, 176, 87,  255, 128, 160, 92,  255, 141, 169, 87,  255,
    195, 205, 84,  255, 171, 177, 60,  255, 124, 141, 37,  255, 147, 170, 63,  255, 166, 194, 92,  255, 159, 183, 78,  255, 154, 174, 52,  255, 203,
    213, 132, 255, 193, 218, 169, 255, 192, 212, 139, 255, 187, 208, 116, 255, 164, 180, 86,  255, 123, 132, 56,  255, 120, 129, 60,  255, 154, 153,
    75,  255, 171, 177, 90,  255, 114, 146, 91,  255, 147, 178, 135, 255, 209, 216, 143, 255, 232, 224, 122, 255, 236, 229, 131, 255, 108, 125, 60,
    255, 41,  48,  25,  255, 135, 144, 76,  255, 189, 205, 109, 255, 189, 205, 107, 255, 169, 190, 104, 255, 147, 175, 103, 255, 126, 158, 97,  255,
    114, 147, 89,  255, 108, 144, 84,  255, 104, 143, 84,  255, 97,  139, 71,  255, 123, 163, 63,  255, 117, 145, 65,  255, 68,  97,  68,  255, 69,
    97,  62,  255, 77,  104, 56,  255, 119, 146, 103, 255, 97,  119, 81,  255, 100, 124, 83,  255, 86,  116, 68,  255, 69,  99,  40,  255, 75,  102,
    48,  255, 152, 175, 112, 255, 107, 130, 71,  255, 60,  92,  44,  255, 63,  96,  42,  255, 102, 121, 52,  255, 145, 162, 75,  255, 153, 174, 87,
    255, 115, 142, 82,  255, 94,  125, 71,  255, 83,  113, 48,  255, 97,  128, 68,  255, 111, 143, 77,  255, 101, 138, 74,  255, 97,  136, 72,  255,
    94,  133, 68,  255, 89,  128, 62,  255, 86,  126, 55,  255, 86,  126, 53,  255, 86,  124, 53,  255, 76,  111, 41,  255, 87,  121, 49,  255, 133,
    158, 84,  255, 170, 191, 117, 255, 192, 212, 130, 255, 101, 116, 65,  255, 36,  53,  36,  255, 71,  95,  50,  255, 150, 176, 102, 255, 122, 148,
    97,  255, 89,  120, 89,  255, 92,  122, 86,  255, 105, 130, 92,  255, 142, 164, 106, 255, 161, 182, 102, 255, 171, 197, 134, 255, 207, 226, 160,
    255, 235, 238, 159, 255, 148, 151, 65,  255, 146, 169, 56,  255, 123, 157, 69,  255, 115, 155, 71,  255, 124, 159, 74,  255, 131, 164, 84,  255,
    134, 171, 90,  255, 150, 184, 104, 255, 195, 212, 117, 255, 142, 155, 76,  255, 82,  103, 47,  255, 101, 127, 60,  255, 132, 159, 75,  255, 77,
    106, 45,  255, 42,  65,  31,  255, 41,  62,  33,  255, 46,  78,  32,  255, 72,  105, 42,  255, 94,  121, 58,  255, 79,  107, 53,  255, 99,  123,
    60,  255, 83,  108, 47,  255, 87,  123, 47,  255, 80,  118, 47,  255, 84,  120, 60,  255, 103, 136, 74,  255, 118, 151, 80,  255, 145, 172, 86,
    255, 133, 159, 81,  255, 109, 140, 73,  255, 127, 159, 68,  255, 91,  116, 55,  255, 78,  107, 47,  255, 114, 145, 75,  255, 133, 162, 84,  255,
    128, 154, 65,  255, 91,  122, 43,  255, 75,  107, 33,  255, 96,  127, 37,  255, 113, 141, 47,  255, 92,  122, 47,  255, 47,  80,  26,  255, 55,
    76,  28,  255, 47,  71,  25,  255, 69,  96,  50,  255, 71,  86,  55,  255, 90,  110, 68,  255, 192, 214, 158, 255, 179, 199, 121, 255, 147, 168,
    73,  255, 148, 161, 69,  255, 158, 178, 79,  255, 217, 217, 139, 255, 236, 235, 165, 255, 227, 233, 141, 255, 201, 225, 131, 255, 170, 197, 102,
    255, 218, 225, 140, 255, 194, 193, 87,  255, 114, 127, 43,  255, 71,  100, 32,  255, 92,  117, 49,  255, 109, 140, 75,  255, 120, 155, 74,  255,
    65,  92,  33,  255, 37,  56,  19,  255, 38,  60,  23,  255, 28,  49,  12,  255, 55,  67,  19,  255, 115, 121, 52,  255, 129, 142, 62,  255, 120,
    137, 60,  255, 116, 135, 55,  255, 119, 131, 58,  255, 107, 120, 53,  255, 88,  110, 41,  255, 104, 134, 74,  255, 105, 136, 91,  255, 138, 161,
    109, 255, 133, 159, 98,  255, 115, 140, 50,  255, 134, 159, 47,  255, 132, 159, 50,  255, 148, 171, 62,  255, 162, 180, 71,  255, 175, 191, 83,
    255, 111, 141, 43,  255, 85,  117, 36,  255, 87,  109, 36,  255, 207, 212, 139, 255, 197, 216, 164, 255, 218, 225, 163, 255, 208, 222, 151, 255,
    193, 218, 125, 255, 174, 204, 97,  255, 94,  121, 48,  255, 149, 155, 65,  255, 238, 239, 136, 255, 241, 248, 185, 255, 218, 238, 190, 255, 208,
    229, 181, 255, 206, 228, 179, 255, 207, 227, 178, 255, 205, 226, 174, 255, 211, 229, 178, 255, 225, 235, 172, 255, 215, 223, 142, 255, 208, 214,
    109, 255, 190, 202, 92,  255, 171, 192, 65,  255, 181, 195, 82,  255, 107, 130, 50,  255, 69,  107, 29,  255, 60,  95,  29,  255, 60,  84,  40,
    255, 72,  106, 47,  255, 62,  95,  44,  255, 52,  83,  33,  255, 68,  103, 32,  255, 78,  108, 32,  255, 87,  119, 46,  255, 76,  115, 47,  255,
    80,  110, 40,  255, 163, 171, 83,  255, 177, 200, 115, 255, 162, 193, 122, 255, 191, 210, 128, 255, 201, 204, 99,  255, 82,  91,  28,  255, 156,
    157, 56,  255, 179, 191, 96,  255, 203, 206, 118, 255, 160, 176, 86,  255, 73,  94,  36,  255, 50,  65,  21,  255, 103, 135, 48,  255, 135, 160,
    75,  255, 188, 192, 101, 255, 217, 227, 155, 255, 183, 208, 156, 255, 182, 208, 145, 255, 193, 213, 125, 255, 178, 196, 96,  255, 132, 155, 68,
    255, 159, 177, 90,  255, 208, 224, 133, 255, 198, 222, 119, 255, 204, 222, 108, 255, 208, 216, 113, 255, 152, 170, 99,  255, 151, 177, 113, 255,
    158, 183, 117, 255, 181, 198, 112, 255, 189, 207, 84,  255, 207, 219, 123, 255, 170, 200, 136, 255, 170, 202, 113, 255, 179, 206, 102, 255, 171,
    200, 119, 255, 171, 189, 108, 255, 147, 172, 86,  255, 135, 162, 74,  255, 146, 157, 74,  255, 197, 208, 111, 255, 190, 202, 92,  255, 234, 232,
    137, 255, 228, 238, 172, 255, 210, 230, 172, 255, 222, 233, 169, 255, 181, 195, 106, 255, 164, 185, 76,  255, 181, 199, 90,  255, 199, 211, 113,
    255, 156, 179, 80,  255, 184, 199, 77,  255, 178, 182, 71,  255, 152, 162, 55,  255, 132, 147, 41,  255, 128, 143, 38,  255, 158, 174, 63,  255,
    148, 165, 62,  255, 142, 151, 42,  255, 176, 185, 110, 255, 187, 199, 122, 255, 166, 184, 103, 255, 150, 173, 93,  255, 134, 156, 77,  255, 75,
    97,  46,  255, 28,  55,  21,  255, 67,  89,  34,  255, 144, 164, 79,  255, 116, 150, 101, 255, 174, 194, 135, 255, 241, 231, 136, 255, 176, 189,
    73,  255, 178, 190, 97,  255, 87,  103, 50,  255, 23,  29,  19,  255, 129, 143, 73,  255, 212, 225, 118, 255, 196, 210, 121, 255, 151, 179, 115,
    255, 129, 165, 110, 255, 121, 158, 108, 255, 125, 160, 105, 255, 139, 170, 99,  255, 136, 170, 95,  255, 164, 190, 89,  255, 150, 173, 69,  255,
    84,  115, 62,  255, 62,  92,  58,  255, 56,  83,  55,  255, 86,  112, 65,  255, 111, 132, 83,  255, 96,  122, 80,  255, 102, 132, 73,  255, 81,
    109, 47,  255, 62,  91,  39,  255, 77,  105, 55,  255, 78,  106, 53,  255, 78,  107, 55,  255, 73,  103, 52,  255, 71,  99,  50,  255, 63,  87,
    42,  255, 53,  69,  33,  255, 92,  112, 43,  255, 117, 148, 53,  255, 93,  126, 45,  255, 74,  106, 37,  255, 90,  124, 63,  255, 108, 146, 76,
    255, 106, 145, 71,  255, 102, 141, 65,  255, 96,  136, 58,  255, 93,  132, 55,  255, 89,  128, 50,  255, 86,  125, 47,  255, 84,  125, 45,  255,
    74,  109, 37,  255, 77,  113, 42,  255, 82,  123, 53,  255, 90,  128, 55,  255, 112, 143, 71,  255, 72,  83,  52,  255, 40,  56,  38,  255, 52,
    75,  37,  255, 139, 165, 90,  255, 146, 171, 100, 255, 98,  129, 91,  255, 93,  125, 87,  255, 92,  124, 89,  255, 116, 143, 103, 255, 166, 181,
    118, 255, 158, 190, 151, 255, 204, 226, 175, 255, 175, 175, 98,  255, 69,  95,  29,  255, 130, 152, 50,  255, 172, 190, 84,  255, 138, 172, 86,
    255, 130, 167, 82,  255, 143, 176, 92,  255, 147, 181, 101, 255, 150, 186, 113, 255, 181, 207, 130, 255, 124, 116, 60,  255, 43,  65,  29,  255,
    147, 173, 87,  255, 123, 146, 67,  255, 63,  89,  37,  255, 52,  74,  40,  255, 68,  87,  47,  255, 102, 116, 68,  255, 150, 168, 87,  255, 138,
    161, 77,  255, 105, 134, 52,  255, 92,  123, 52,  255, 76,  110, 48,  255, 103, 135, 56,  255, 146, 170, 75,  255, 129, 166, 92,  255, 125, 167,
    100, 255, 127, 170, 102, 255, 152, 191, 121, 255, 177, 209, 134, 255, 193, 215, 135, 255, 161, 176, 93,  255, 124, 143, 90,  255, 87,  115, 55,
    255, 93,  124, 68,  255, 128, 158, 77,  255, 140, 169, 82,  255, 122, 144, 63,  255, 65,  91,  32,  255, 74,  105, 36,  255, 69,  104, 40,  255,
    76,  112, 42,  255, 65,  101, 36,  255, 49,  77,  28,  255, 47,  65,  21,  255, 75,  81,  62,  255, 48,  55,  38,  255, 9,   21,  9,   255, 77,
    98,  58,  255, 161, 190, 84,  255, 140, 175, 68,  255, 163, 189, 84,  255, 158, 182, 86,  255, 152, 169, 73,  255, 174, 179, 84,  255, 194, 194,
    106, 255, 186, 186, 100, 255, 159, 168, 80,  255, 144, 160, 75,  255, 100, 120, 60,  255, 60,  92,  32,  255, 67,  95,  33,  255, 83,  109, 44,
    255, 106, 136, 63,  255, 90,  118, 45,  255, 60,  79,  25,  255, 153, 166, 93,  255, 156, 176, 104, 255, 96,  123, 62,  255, 34,  58,  23,  255,
    48,  65,  25,  255, 52,  75,  33,  255, 26,  41,  17,  255, 39,  56,  17,  255, 49,  68,  21,  255, 67,  79,  28,  255, 132, 139, 71,  255, 121,
    142, 87,  255, 133, 156, 89,  255, 117, 142, 75,  255, 62,  86,  31,  255, 81,  99,  19,  255, 146, 167, 49,  255, 148, 172, 60,  255, 156, 177,
    65,  255, 176, 191, 75,  255, 171, 185, 76,  255, 89,  124, 34,  255, 63,  98,  37,  255, 80,  103, 31,  255, 221, 219, 134, 255, 207, 224, 169,
    255, 191, 212, 171, 255, 186, 210, 168, 255, 196, 212, 159, 255, 207, 220, 132, 255, 165, 195, 74,  255, 184, 210, 77,  255, 217, 227, 80,  255,
    228, 235, 133, 255, 202, 224, 176, 255, 204, 225, 170, 255, 207, 227, 167, 255, 221, 233, 168, 255, 231, 241, 169, 255, 225, 230, 141, 255, 175,
    185, 89,  255, 154, 162, 65,  255, 171, 179, 77,  255, 174, 192, 87,  255, 181, 194, 93,  255, 145, 164, 74,  255, 76,  109, 28,  255, 82,  118,
    31,  255, 116, 152, 65,  255, 123, 163, 77,  255, 111, 154, 69,  255, 104, 147, 62,  255, 99,  142, 58,  255, 96,  138, 52,  255, 97,  127, 43,
    255, 95,  119, 47,  255, 82,  116, 44,  255, 77,  117, 45,  255, 63,  92,  34,  255, 96,  103, 38,  255, 188, 198, 114, 255, 180, 196, 112, 255,
    114, 142, 62,  255, 92,  132, 62,  255, 87,  122, 52,  255, 112, 138, 67,  255, 128, 151, 80,  255, 142, 166, 73,  255, 81,  94,  36,  255, 72,
    82,  25,  255, 164, 178, 77,  255, 144, 165, 79,  255, 109, 130, 50,  255, 193, 196, 105, 255, 201, 219, 157, 255, 169, 199, 157, 255, 184, 205,
    153, 255, 187, 203, 115, 255, 153, 175, 84,  255, 164, 192, 112, 255, 168, 191, 103, 255, 195, 208, 97,  255, 122, 144, 75,  255, 139, 158, 100,
    255, 143, 172, 118, 255, 137, 168, 108, 255, 157, 179, 111, 255, 152, 175, 114, 255, 185, 204, 115, 255, 195, 216, 123, 255, 162, 194, 116, 255,
    196, 215, 124, 255, 174, 188, 91,  255, 173, 190, 114, 255, 143, 167, 84,  255, 140, 167, 78,  255, 123, 154, 73,  255, 113, 128, 60,  255, 171,
    192, 89,  255, 177, 189, 86,  255, 210, 208, 114, 255, 251, 251, 177, 255, 210, 227, 162, 255, 190, 218, 167, 255, 211, 231, 175, 255, 209, 223,
    150, 255, 180, 201, 120, 255, 211, 222, 127, 255, 210, 212, 82,  255, 157, 166, 67,  255, 82,  111, 52,  255, 76,  97,  41,  255, 71,  84,  40,
    255, 79,  95,  36,  255, 76,  99,  31,  255, 74,  101, 26,  255, 117, 131, 36,  255, 130, 140, 37,  255, 142, 153, 47,  255, 149, 175, 86,  255,
    111, 148, 84,  255, 125, 156, 92,  255, 145, 172, 91,  255, 89,  113, 43,  255, 111, 130, 60,  255, 154, 173, 93,  255, 138, 165, 109, 255, 233,
    230, 157, 255, 241, 234, 146, 255, 147, 174, 58,  255, 151, 174, 76,  255, 138, 155, 84,  255, 160, 179, 107, 255, 184, 197, 111, 255, 176, 185,
    103, 255, 186, 196, 108, 255, 193, 209, 122, 255, 176, 200, 121, 255, 166, 192, 118, 255, 176, 200, 113, 255, 187, 206, 108, 255, 186, 202, 95,
    255, 153, 171, 67,  255, 107, 136, 55,  255, 84,  118, 47,  255, 81,  116, 50,  255, 52,  79,  49,  255, 76,  97,  53,  255, 124, 149, 73,  255,
    159, 184, 83,  255, 101, 124, 53,  255, 52,  77,  32,  255, 60,  89,  41,  255, 84,  113, 55,  255, 89,  120, 62,  255, 87,  117, 62,  255, 77,
    104, 53,  255, 60,  90,  50,  255, 63,  94,  53,  255, 87,  122, 52,  255, 122, 161, 52,  255, 129, 169, 55,  255, 126, 165, 56,  255, 116, 156,
    49,  255, 85,  113, 44,  255, 104, 137, 63,  255, 118, 155, 63,  255, 121, 159, 62,  255, 124, 159, 62,  255, 108, 144, 60,  255, 101, 138, 58,
    255, 93,  128, 53,  255, 81,  112, 45,  255, 69,  92,  37,  255, 55,  81,  33,  255, 95,  134, 62,  255, 107, 150, 77,  255, 94,  127, 68,  255,
    48,  65,  39,  255, 55,  81,  40,  255, 53,  77,  34,  255, 91,  113, 56,  255, 158, 182, 99,  255, 115, 143, 90,  255, 84,  117, 81,  255, 88,
    120, 81,  255, 90,  119, 84,  255, 141, 160, 106, 255, 172, 200, 148, 255, 201, 202, 124, 255, 78,  99,  36,  255, 46,  71,  28,  255, 44,  71,
    26,  255, 148, 167, 75,  255, 192, 205, 101, 255, 174, 198, 103, 255, 163, 192, 108, 255, 160, 189, 117, 255, 176, 203, 126, 255, 225, 227, 135,
    255, 123, 134, 68,  255, 95,  127, 58,  255, 151, 176, 86,  255, 142, 167, 81,  255, 127, 153, 72,  255, 142, 166, 83,  255, 203, 216, 119, 255,
    246, 243, 128, 255, 234, 236, 108, 255, 128, 151, 62,  255, 60,  98,  41,  255, 68,  99,  43,  255, 91,  121, 58,  255, 68,  104, 36,  255, 130,
    160, 74,  255, 191, 213, 121, 255, 159, 191, 120, 255, 152, 189, 120, 255, 156, 194, 125, 255, 165, 199, 139, 255, 184, 217, 164, 255, 199, 222,
    164, 255, 180, 201, 139, 255, 108, 130, 67,  255, 89,  117, 69,  255, 120, 150, 83,  255, 118, 150, 76,  255, 130, 164, 86,  255, 82,  101, 37,
    255, 37,  58,  21,  255, 55,  84,  32,  255, 63,  97,  41,  255, 63,  97,  46,  255, 49,  79,  32,  255, 43,  62,  26,  255, 91,  97,  72,  255,
    32,  40,  25,  255, 31,  40,  25,  255, 55,  63,  39,  255, 139, 160, 67,  255, 158, 183, 71,  255, 141, 161, 68,  255, 147, 170, 75,  255, 144,
    172, 73,  255, 135, 160, 60,  255, 110, 127, 58,  255, 86,  89,  46,  255, 165, 170, 79,  255, 156, 183, 74,  255, 181, 201, 94,  255, 204, 215,
    114, 255, 76,  102, 46,  255, 77,  101, 37,  255, 93,  122, 39,  255, 88,  112, 26,  255, 141, 153, 67,  255, 169, 198, 126, 255, 148, 179, 118,
    255, 182, 198, 118, 255, 163, 182, 100, 255, 92,  123, 60,  255, 87,  117, 55,  255, 75,  108, 48,  255, 43,  69,  23,  255, 42,  67,  19,  255,
    58,  83,  25,  255, 100, 128, 65,  255, 120, 139, 71,  255, 121, 128, 65,  255, 91,  106, 52,  255, 26,  37,  23,  255, 65,  75,  19,  255, 151,
    171, 50,  255, 160, 179, 65,  255, 166, 185, 73,  255, 185, 197, 83,  255, 132, 155, 52,  255, 85,  122, 36,  255, 60,  97,  36,  255, 65,  92,
    23,  255, 223, 215, 127, 255, 227, 235, 166, 255, 190, 212, 167, 255, 193, 214, 168, 255, 187, 210, 166, 255, 213, 217, 141, 255, 225, 231, 115,
    255, 203, 224, 107, 255, 204, 224, 107, 255, 224, 231, 123, 255, 223, 233, 169, 255, 226, 236, 166, 255, 231, 238, 165, 255, 238, 238, 161, 255,
    238, 238, 155, 255, 208, 216, 108, 255, 113, 127, 39,  255, 154, 165, 60,  255, 193, 202, 97,  255, 193, 210, 105, 255, 183, 205, 94,  255, 196,
    213, 110, 255, 186, 197, 104, 255, 158, 178, 84,  255, 138, 170, 80,  255, 133, 167, 81,  255, 124, 161, 77,  255, 114, 153, 68,  255, 109, 148,
    60,  255, 99,  136, 48,  255, 82,  116, 41,  255, 78,  113, 42,  255, 79,  112, 37,  255, 80,  114, 40,  255, 55,  90,  31,  255, 71,  107, 36,
    255, 113, 142, 62,  255, 109, 143, 68,  255, 108, 144, 69,  255, 106, 145, 71,  255, 112, 143, 69,  255, 167, 182, 94,  255, 187, 199, 97,  255,
    145, 158, 68,  255, 49,  53,  29,  255, 39,  46,  21,  255, 125, 141, 52,  255, 122, 141, 56,  255, 140, 158, 82,  255, 130, 140, 56,  255, 196,
    198, 111, 255, 188, 211, 143, 255, 161, 188, 139, 255, 170, 187, 113, 255, 143, 169, 92,  255, 154, 185, 117, 255, 166, 188, 98,  255, 119, 134,
    55,  255, 116, 142, 67,  255, 145, 175, 114, 255, 136, 168, 110, 255, 157, 180, 111, 255, 145, 174, 111, 255, 136, 168, 108, 255, 170, 190, 102,
    255, 174, 198, 95,  255, 182, 201, 97,  255, 141, 158, 74,  255, 122, 149, 65,  255, 134, 161, 74,  255, 137, 158, 76,  255, 160, 179, 87,  255,
    162, 181, 100, 255, 127, 138, 69,  255, 156, 190, 71,  255, 179, 201, 106, 255, 155, 171, 104, 255, 228, 234, 166, 255, 216, 231, 165, 255, 199,
    220, 166, 255, 191, 218, 176, 255, 216, 230, 173, 255, 210, 221, 154, 255, 205, 217, 146, 255, 122, 130, 58,  255, 75,  107, 42,  255, 60,  98,
    40,  255, 49,  75,  40,  255, 44,  65,  47,  255, 55,  75,  40,  255, 67,  92,  34,  255, 63,  90,  29,  255, 93,  119, 34,  255, 107, 121, 39,
    255, 137, 143, 46,  255, 174, 184, 75,  255, 143, 171, 87,  255, 112, 147, 86,  255, 112, 143, 82,  255, 122, 151, 67,  255, 138, 157, 69,  255,
    150, 169, 87,  255, 201, 206, 136, 255, 255, 246, 162, 255, 204, 202, 106, 255, 143, 170, 68,  255, 154, 184, 82,  255, 173, 196, 111, 255, 170,
    197, 140, 255, 180, 205, 140, 255, 178, 198, 136, 255, 139, 156, 98,  255, 130, 144, 77,  255, 164, 177, 93,  255, 167, 182, 84,  255, 161, 180,
    79,  255, 155, 175, 79,  255, 131, 154, 62,  255, 106, 136, 50,  255, 99,  126, 50,  255, 147, 171, 62,  255, 136, 167, 65,  255, 82,  119, 49,
    255, 106, 138, 55,  255, 160, 187, 62,  255, 190, 209, 82,  255, 124, 142, 58,  255, 48,  77,  32,  255, 60,  87,  38,  255, 81,  113, 50,  255,
    96,  123, 65,  255, 72,  90,  50,  255, 65,  84,  47,  255, 86,  109, 56,  255, 83,  100, 55,  255, 101, 123, 47,  255, 148, 184, 65,  255, 142,
    180, 60,  255, 145, 180, 58,  255, 151, 186, 63,  255, 112, 144, 48,  255, 77,  112, 41,  255, 98,  135, 46,  255, 125, 158, 49,  255, 168, 190,
    62,  255, 156, 175, 65,  255, 83,  104, 48,  255, 67,  90,  47,  255, 58,  84,  41,  255, 77,  103, 40,  255, 48,  68,  29,  255, 60,  74,  43,
    255, 97,  119, 68,  255, 87,  111, 58,  255, 60,  84,  33,  255, 65,  89,  36,  255, 48,  68,  33,  255, 47,  69,  32,  255, 123, 148, 73,  255,
    130, 155, 91,  255, 129, 153, 100, 255, 144, 167, 100, 255, 128, 154, 92,  255, 102, 130, 75,  255, 150, 168, 92,  255, 96,  115, 50,  255, 56,
    97,  37,  255, 62,  101, 41,  255, 120, 150, 78,  255, 138, 162, 96,  255, 124, 148, 96,  255, 147, 163, 100, 255, 183, 194, 112, 255, 188, 206,
    126, 255, 200, 219, 146, 255, 224, 220, 137, 255, 95,  118, 78,  255, 103, 136, 73,  255, 152, 177, 87,  255, 144, 169, 84,  255, 136, 162, 77,
    255, 158, 179, 85,  255, 209, 218, 123, 255, 241, 238, 129, 255, 225, 227, 99,  255, 209, 213, 90,  255, 107, 125, 56,  255, 123, 136, 69,  255,
    136, 152, 78,  255, 65,  95,  49,  255, 47,  80,  48,  255, 117, 142, 87,  255, 186, 207, 133, 255, 183, 207, 141, 255, 178, 207, 141, 255, 181,
    203, 132, 255, 159, 184, 111, 255, 174, 201, 141, 255, 117, 144, 110, 255, 121, 145, 89,  255, 92,  121, 68,  255, 102, 134, 83,  255, 108, 140,
    83,  255, 107, 140, 84,  255, 122, 145, 73,  255, 38,  52,  19,  255, 55,  81,  31,  255, 26,  37,  21,  255, 29,  40,  23,  255, 43,  69,  26,
    255, 62,  79,  41,  255, 96,  104, 69,  255, 29,  43,  19,  255, 36,  46,  26,  255, 166, 186, 120, 255, 163, 184, 78,  255, 157, 182, 56,  255,
    151, 176, 58,  255, 158, 179, 68,  255, 187, 202, 110, 255, 207, 218, 142, 255, 211, 222, 158, 255, 224, 228, 161, 255, 245, 246, 144, 255, 184,
    215, 97,  255, 201, 220, 111, 255, 243, 243, 140, 255, 96,  118, 60,  255, 73,  100, 37,  255, 98,  127, 42,  255, 113, 130, 36,  255, 197, 202,
    108, 255, 203, 216, 135, 255, 196, 211, 143, 255, 161, 186, 124, 255, 208, 216, 124, 255, 156, 178, 107, 255, 83,  110, 63,  255, 114, 143, 68,
    255, 98,  133, 62,  255, 69,  98,  36,  255, 118, 138, 55,  255, 149, 174, 76,  255, 133, 163, 68,  255, 107, 133, 65,  255, 92,  104, 52,  255,
    67,  74,  39,  255, 81,  90,  33,  255, 152, 172, 52,  255, 176, 192, 68,  255, 186, 200, 75,  255, 137, 156, 58,  255, 87,  118, 29,  255, 87,
    122, 32,  255, 91,  117, 55,  255, 149, 162, 95,  255, 235, 234, 153, 255, 229, 235, 163, 255, 210, 225, 162, 255, 206, 224, 161, 255, 188, 211,
    151, 255, 188, 202, 133, 255, 189, 193, 94,  255, 246, 238, 121, 255, 245, 238, 123, 255, 241, 236, 123, 255, 246, 238, 115, 255, 236, 230, 99,
    255, 226, 231, 126, 255, 225, 232, 145, 255, 220, 228, 148, 255, 223, 230, 148, 255, 178, 189, 117, 255, 180, 190, 68,  255, 203, 207, 84,  255,
    214, 217, 111, 255, 213, 220, 111, 255, 225, 228, 127, 255, 227, 223, 129, 255, 221, 218, 117, 255, 169, 189, 93,  255, 135, 170, 80,  255, 130,
    166, 77,  255, 116, 152, 65,  255, 103, 137, 55,  255, 79,  115, 40,  255, 68,  105, 37,  255, 74,  107, 39,  255, 49,  68,  26,  255, 52,  69,
    23,  255, 65,  95,  25,  255, 99,  134, 48,  255, 110, 150, 69,  255, 113, 152, 72,  255, 116, 154, 74,  255, 112, 150, 74,  255, 105, 135, 58,
    255, 170, 174, 81,  255, 137, 142, 67,  255, 47,  62,  26,  255, 21,  33,  23,  255, 42,  56,  25,  255, 90,  123, 39,  255, 85,  112, 32,  255,
    116, 132, 55,  255, 98,  117, 43,  255, 177, 174, 84,  255, 225, 226, 125, 255, 154, 180, 98,  255, 134, 157, 82,  255, 152, 172, 102, 255, 188,
    205, 126, 255, 135, 148, 71,  255, 55,  83,  21,  255, 121, 148, 82,  255, 136, 169, 112, 255, 176, 196, 125, 255, 208, 218, 139, 255, 226, 232,
    129, 255, 211, 223, 102, 255, 202, 218, 91,  255, 180, 195, 84,  255, 176, 183, 86,  255, 165, 183, 84,  255, 174, 193, 102, 255, 135, 161, 98,
    255, 115, 147, 92,  255, 121, 155, 93,  255, 183, 198, 115, 255, 206, 216, 107, 255, 160, 194, 69,  255, 181, 203, 104, 255, 100, 131, 69,  255,
    178, 188, 123, 255, 211, 231, 179, 255, 196, 222, 171, 255, 189, 217, 169, 255, 192, 219, 175, 255, 226, 236, 173, 255, 190, 196, 129, 255, 111,
    129, 47,  255, 111, 138, 50,  255, 65,  99,  43,  255, 49,  76,  46,  255, 53,  76,  52,  255, 53,  80,  46,  255, 57,  87,  42,  255, 47,  68,
    36,  255, 85,  108, 39,  255, 87,  120, 53,  255, 68,  96,  48,  255, 105, 122, 48,  255, 143, 160, 68,  255, 151, 175, 82,  255, 134, 165, 80,
    255, 120, 153, 72,  255, 129, 157, 60,  255, 128, 150, 58,  255, 222, 220, 123, 255, 199, 200, 95,  255, 133, 158, 60,  255, 155, 181, 68,  255,
    157, 185, 75,  255, 155, 188, 106, 255, 162, 195, 126, 255, 169, 202, 136, 255, 186, 213, 142, 255, 199, 215, 140, 255, 113, 136, 69,  255, 89,
    125, 40,  255, 99,  133, 41,  255, 98,  129, 45,  255, 80,  111, 38,  255, 90,  121, 42,  255, 90,  120, 47,  255, 97,  127, 49,  255, 193, 209,
    79,  255, 158, 184, 74,  255, 111, 153, 58,  255, 117, 157, 67,  255, 126, 163, 62,  255, 197, 213, 90,  255, 118, 128, 53,  255, 46,  73,  31,
    255, 63,  91,  42,  255, 84,  110, 49,  255, 77,  96,  45,  255, 69,  82,  47,  255, 62,  68,  41,  255, 42,  47,  31,  255, 26,  33,  25,  255,
    38,  53,  25,  255, 159, 187, 84,  255, 160, 190, 80,  255, 157, 187, 68,  255, 176, 203, 76,  255, 128, 158, 58,  255, 82,  123, 48,  255, 106,
    141, 60,  255, 123, 156, 58,  255, 156, 180, 60,  255, 202, 210, 73,  255, 106, 115, 52,  255, 49,  74,  34,  255, 72,  100, 36,  255, 69,  90,
    34,  255, 34,  43,  26,  255, 41,  47,  36,  255, 36,  43,  33,  255, 34,  49,  31,  255, 58,  84,  36,  255, 43,  65,  31,  255, 44,  68,  33,
    255, 47,  75,  32,  255, 52,  79,  28,  255, 180, 193, 118, 255, 229, 236, 161, 255, 188, 211, 126, 255, 169, 199, 109, 255, 142, 176, 86,  255,
    164, 185, 91,  255, 95,  118, 47,  255, 83,  114, 45,  255, 130, 159, 78,  255, 118, 144, 91,  255, 99,  129, 96,  255, 97,  131, 98,  255, 94,
    129, 100, 255, 103, 132, 102, 255, 135, 155, 109, 255, 179, 191, 129, 255, 178, 185, 124, 255, 93,  124, 83,  255, 108, 143, 82,  255, 157, 180,
    93,  255, 144, 169, 84,  255, 136, 162, 76,  255, 153, 174, 71,  255, 181, 199, 94,  255, 194, 204, 109, 255, 164, 175, 74,  255, 172, 181, 89,
    255, 106, 126, 62,  255, 79,  105, 48,  255, 77,  96,  50,  255, 60,  83,  55,  255, 62,  87,  62,  255, 71,  101, 58,  255, 82,  113, 58,  255,
    58,  75,  38,  255, 56,  77,  40,  255, 43,  68,  29,  255, 34,  67,  15,  255, 81,  113, 55,  255, 91,  116, 92,  255, 109, 134, 91,  255, 125,
    155, 75,  255, 99,  131, 78,  255, 106, 138, 87,  255, 109, 139, 91,  255, 117, 144, 89,  255, 47,  55,  26,  255, 55,  76,  28,  255, 17,  23,
    17,  255, 25,  37,  21,  255, 36,  60,  25,  255, 82,  100, 56,  255, 69,  84,  47,  255, 34,  55,  23,  255, 37,  60,  21,  255, 113, 134, 84,
    255, 159, 178, 99,  255, 152, 170, 47,  255, 159, 179, 55,  255, 186, 189, 83,  255, 223, 231, 151, 255, 201, 226, 164, 255, 190, 217, 159, 255,
    197, 220, 163, 255, 220, 229, 159, 255, 195, 220, 128, 255, 218, 228, 137, 255, 243, 241, 147, 255, 156, 174, 95,  255, 92,  117, 47,  255, 105,
    134, 49,  255, 154, 159, 60,  255, 216, 219, 119, 255, 212, 221, 132, 255, 238, 238, 146, 255, 191, 209, 134, 255, 174, 192, 115, 255, 212, 218,
    124, 255, 109, 136, 83,  255, 101, 127, 65,  255, 130, 155, 74,  255, 164, 184, 84,  255, 189, 206, 95,  255, 181, 199, 84,  255, 173, 192, 75,
    255, 171, 193, 74,  255, 151, 178, 74,  255, 112, 141, 50,  255, 101, 121, 47,  255, 122, 134, 47,  255, 139, 152, 48,  255, 116, 134, 44,  255,
    74,  100, 31,  255, 94,  114, 37,  255, 172, 184, 100, 255, 223, 229, 162, 255, 224, 236, 176, 255, 207, 225, 167, 255, 201, 221, 161, 255, 195,
    216, 151, 255, 189, 214, 131, 255, 195, 214, 119, 255, 169, 186, 108, 255, 186, 186, 94,  255, 232, 218, 110, 255, 249, 233, 112, 255, 253, 238,
    117, 255, 250, 238, 113, 255, 248, 238, 111, 255, 217, 225, 86,  255, 205, 215, 91,  255, 221, 226, 129, 255, 222, 228, 141, 255, 231, 236, 148,
    255, 230, 233, 142, 255, 215, 217, 96,  255, 213, 213, 87,  255, 225, 218, 115, 255, 230, 226, 127, 255, 223, 223, 128, 255, 224, 219, 121, 255,
    214, 213, 108, 255, 127, 152, 62,  255, 105, 134, 52,  255, 101, 129, 53,  255, 96,  127, 52,  255, 90,  122, 46,  255, 84,  120, 40,  255, 72,
    100, 38,  255, 31,  46,  21,  255, 44,  68,  26,  255, 52,  76,  25,  255, 69,  95,  29,  255, 98,  128, 52,  255, 100, 131, 55,  255, 96,  125,
    52,  255, 90,  123, 47,  255, 86,  116, 39,  255, 78,  103, 40,  255, 40,  60,  26,  255, 40,  62,  26,  255, 44,  65,  31,  255, 47,  63,  28,
    255, 109, 139, 55,  255, 101, 131, 43,  255, 145, 162, 68,  255, 179, 192, 97,  255, 179, 194, 101, 255, 186, 197, 100, 255, 162, 183, 87,  255,
    117, 144, 62,  255, 139, 161, 93,  255, 201, 208, 110, 255, 170, 182, 92,  255, 99,  128, 47,  255, 134, 169, 98,  255, 149, 177, 100, 255, 188,
    206, 125, 255, 201, 212, 124, 255, 253, 249, 138, 255, 245, 245, 111, 255, 238, 239, 98,  255, 208, 214, 109, 255, 192, 205, 131, 255, 218, 225,
    145, 255, 226, 232, 160, 255, 225, 229, 162, 255, 209, 218, 148, 255, 184, 198, 127, 255, 204, 215, 113, 255, 203, 215, 112, 255, 172, 201, 79,
    255, 174, 200, 84,  255, 140, 166, 84,  255, 169, 187, 98,  255, 224, 234, 161, 255, 205, 227, 161, 255, 189, 217, 152, 255, 195, 220, 166, 255,
    195, 216, 141, 255, 189, 201, 146, 255, 87,  114, 38,  255, 123, 145, 50,  255, 112, 134, 55,  255, 52,  77,  48,  255, 53,  80,  53,  255, 58,
    87,  49,  255, 67,  100, 48,  255, 57,  82,  41,  255, 45,  62,  26,  255, 115, 139, 58,  255, 124, 151, 81,  255, 102, 136, 71,  255, 101, 120,
    58,  255, 55,  60,  26,  255, 97,  107, 43,  255, 115, 133, 50,  255, 103, 129, 49,  255, 107, 136, 56,  255, 147, 171, 67,  255, 134, 168, 65,
    255, 129, 166, 72,  255, 135, 169, 72,  255, 166, 186, 87,  255, 135, 162, 92,  255, 171, 188, 101, 255, 202, 206, 103, 255, 203, 204, 102, 255,
    194, 197, 87,  255, 155, 177, 62,  255, 126, 158, 52,  255, 106, 141, 47,  255, 80,  110, 40,  255, 55,  79,  29,  255, 69,  106, 38,  255, 77,
    113, 43,  255, 92,  122, 41,  255, 194, 206, 76,  255, 154, 186, 82,  255, 123, 164, 76,  255, 135, 171, 86,  255, 134, 172, 82,  255, 193, 204,
    92,  255, 85,  95,  37,  255, 40,  65,  29,  255, 75,  99,  48,  255, 100, 118, 60,  255, 67,  84,  38,  255, 40,  53,  31,  255, 26,  34,  25,
    255, 28,  41,  26,  255, 34,  48,  31,  255, 34,  48,  25,  255, 149, 171, 84,  255, 177, 202, 105, 255, 177, 203, 76,  255, 140, 154, 52,  255,
    174, 194, 76,  255, 151, 175, 69,  255, 117, 147, 62,  255, 119, 152, 69,  255, 144, 172, 62,  255, 220, 220, 78,  255, 136, 144, 53,  255, 87,
    116, 37,  255, 90,  106, 38,  255, 34,  46,  28,  255, 26,  38,  25,  255, 39,  47,  36,  255, 36,  43,  32,  255, 36,  51,  31,  255, 55,  77,
    36,  255, 42,  63,  33,  255, 50,  75,  36,  255, 50,  75,  33,  255, 79,  98,  50,  255, 228, 231, 166, 255, 207, 226, 170, 255, 190, 216, 150,
    255, 177, 206, 122, 255, 180, 207, 110, 255, 228, 236, 127, 255, 135, 138, 58,  255, 100, 130, 65,  255, 117, 142, 86,  255, 97,  128, 95,  255,
    107, 139, 105, 255, 109, 139, 104, 255, 115, 145, 110, 255, 119, 149, 113, 255, 114, 146, 103, 255, 116, 146, 94,  255, 121, 154, 89,  255, 132,
    166, 87,  255, 138, 166, 79,  255, 148, 175, 87,  255, 143, 170, 86,  255, 136, 166, 75,  255, 144, 171, 69,  255, 165, 182, 78,  255, 151, 163,
    65,  255, 133, 148, 55,  255, 94,  115, 55,  255, 60,  95,  47,  255, 65,  99,  39,  255, 55,  83,  36,  255, 75,  105, 49,  255, 84,  118, 52,
    255, 79,  114, 45,  255, 55,  77,  36,  255, 34,  52,  26,  255, 31,  52,  23,  255, 31,  58,  21,  255, 37,  68,  21,  255, 90,  123, 62,  255,
    98,  125, 90,  255, 87,  116, 92,  255, 128, 154, 84,  255, 139, 165, 84,  255, 103, 137, 81,  255, 104, 139, 92,  255, 113, 145, 91,  255, 120,
    141, 68,  255, 104, 127, 55,  255, 69,  80,  40,  255, 15,  21,  15,  255, 19,  25,  19,  255, 71,  76,  60,  255, 23,  37,  23,  255, 12,  25,
    17,  255, 98,  124, 60,  255, 126, 141, 76,  255, 116, 136, 71,  255, 118, 140, 60,  255, 101, 123, 45,  255, 113, 125, 26,  255, 204, 209, 89,
    255, 203, 204, 117, 255, 221, 234, 156, 255, 210, 229, 153, 255, 214, 229, 149, 255, 223, 235, 162, 255, 215, 229, 153, 255, 215, 226, 143, 255,
    239, 243, 148, 255, 162, 182, 84,  255, 130, 149, 60,  255, 193, 198, 94,  255, 207, 221, 119, 255, 196, 213, 127, 255, 197, 209, 133, 255, 168,
    189, 123, 255, 158, 184, 119, 255, 197, 208, 122, 255, 164, 187, 96,  255, 135, 160, 72,  255, 183, 197, 100, 255, 204, 216, 118, 255, 199, 213,
    111, 255, 194, 208, 98,  255, 189, 203, 91,  255, 182, 197, 81,  255, 182, 197, 74,  255, 175, 196, 69,  255, 120, 146, 49,  255, 37,  41,  23,
    255, 62,  67,  25,  255, 77,  99,  33,  255, 89,  106, 34,  255, 206, 206, 136, 255, 238, 245, 184, 255, 210, 228, 176, 255, 202, 222, 165, 255,
    197, 220, 152, 255, 191, 215, 136, 255, 195, 215, 122, 255, 213, 223, 131, 255, 207, 221, 167, 255, 161, 186, 134, 255, 192, 197, 103, 255, 188,
    189, 98,  255, 207, 205, 87,  255, 202, 199, 74,  255, 203, 198, 75,  255, 207, 200, 75,  255, 197, 204, 69,  255, 194, 216, 78,  255, 191, 207,
    68,  255, 219, 224, 120, 255, 227, 233, 154, 255, 230, 234, 154, 255, 231, 228, 126, 255, 231, 225, 106, 255, 228, 221, 97,  255, 225, 223, 109,
    255, 217, 221, 120, 255, 211, 216, 117, 255, 211, 215, 112, 255, 175, 187, 93,  255, 110, 137, 55,  255, 102, 131, 52,  255, 104, 134, 55,  255,
    100, 131, 52,  255, 98,  129, 48,  255, 97,  129, 49,  255, 69,  101, 36,  255, 52,  83,  31,  255, 46,  74,  26,  255, 47,  68,  23,  255, 47,
    60,  23,  255, 47,  63,  25,  255, 36,  52,  17,  255, 65,  95,  28,  255, 81,  111, 37,  255, 55,  80,  31,  255, 44,  63,  28,  255, 45,  63,
    26,  255, 40,  56,  29,  255, 28,  38,  21,  255, 92,  104, 42,  255, 165, 181, 87,  255, 168, 190, 107, 255, 137, 169, 99,  255, 117, 153, 92,
    255, 122, 155, 86,  255, 150, 173, 91,  255, 165, 189, 95,  255, 151, 184, 98,  255, 173, 200, 121, 255, 220, 231, 144, 255, 163, 182, 98,  255,
    100, 125, 43,  255, 121, 138, 48,  255, 162, 175, 75,  255, 179, 186, 90,  255, 238, 234, 143, 255, 200, 202, 94,  255, 172, 179, 71,  255, 155,
    166, 78,  255, 220, 229, 166, 255, 221, 236, 187, 255, 211, 229, 188, 255, 218, 232, 192, 255, 224, 235, 195, 255, 229, 238, 182, 255, 222, 230,
    166, 255, 208, 224, 141, 255, 164, 195, 82,  255, 168, 196, 83,  255, 166, 184, 101, 255, 197, 216, 123, 255, 185, 211, 105, 255, 184, 208, 84,
    255, 188, 210, 120, 255, 180, 204, 113, 255, 187, 217, 153, 255, 209, 226, 183, 255, 119, 140, 62,  255, 115, 140, 47,  255, 136, 148, 60,  255,
    62,  82,  50,  255, 58,  84,  56,  255, 65,  94,  53,  255, 68,  101, 48,  255, 74,  106, 44,  255, 69,  102, 40,  255, 63,  89,  38,  255, 114,
    131, 71,  255, 135, 154, 84,  255, 69,  87,  48,  255, 15,  26,  19,  255, 85,  94,  36,  255, 181, 196, 81,  255, 145, 171, 80,  255, 137, 167,
    80,  255, 140, 174, 87,  255, 133, 171, 72,  255, 126, 165, 68,  255, 151, 180, 74,  255, 160, 182, 82,  255, 124, 156, 68,  255, 149, 166, 75,
    255, 199, 197, 84,  255, 208, 206, 84,  255, 190, 187, 77,  255, 125, 148, 63,  255, 117, 143, 65,  255, 92,  126, 52,  255, 67,  96,  40,  255,
    60,  91,  29,  255, 101, 142, 55,  255, 107, 145, 69,  255, 79,  109, 43,  255, 130, 140, 47,  255, 192, 204, 84,  255, 148, 184, 93,  255, 146,
    179, 99,  255, 172, 198, 106, 255, 157, 161, 80,  255, 63,  89,  36,  255, 71,  97,  39,  255, 68,  89,  37,  255, 63,  86,  31,  255, 98,  137,
    47,  255, 103, 143, 62,  255, 98,  135, 60,  255, 73,  102, 43,  255, 34,  47,  26,  255, 23,  36,  19,  255, 115, 135, 68,  255, 207, 230, 123,
    255, 132, 137, 60,  255, 15,  19,  17,  255, 116, 124, 50,  255, 216, 221, 91,  255, 164, 186, 87,  255, 131, 161, 87,  255, 143, 171, 80,  255,
    212, 211, 87,  255, 148, 157, 62,  255, 109, 121, 47,  255, 43,  56,  29,  255, 40,  60,  36,  255, 38,  53,  31,  255, 39,  47,  33,  255, 36,
    44,  31,  255, 34,  51,  29,  255, 49,  73,  31,  255, 60,  95,  34,  255, 65,  101, 34,  255, 68,  101, 33,  255, 112, 132, 68,  255, 236, 239,
    179, 255, 204, 224, 174, 255, 200, 221, 159, 255, 195, 218, 142, 255, 213, 232, 154, 255, 204, 198, 111, 255, 106, 126, 65,  255, 108, 138, 84,
    255, 94,  127, 79,  255, 104, 137, 91,  255, 110, 140, 99,  255, 112, 141, 101, 255, 112, 142, 99,  255, 116, 149, 99,  255, 132, 163, 99,  255,
    136, 166, 95,  255, 156, 184, 100, 255, 158, 176, 83,  255, 99,  125, 43,  255, 123, 160, 76,  255, 145, 174, 87,  255, 146, 174, 82,  255, 135,
    151, 68,  255, 119, 139, 55,  255, 145, 173, 77,  255, 185, 204, 100, 255, 156, 165, 110, 255, 43,  69,  31,  255, 40,  68,  23,  255, 88,  111,
    42,  255, 95,  135, 52,  255, 74,  113, 50,  255, 68,  107, 41,  255, 63,  87,  36,  255, 45,  60,  32,  255, 36,  55,  26,  255, 34,  60,  26,
    255, 34,  62,  21,  255, 94,  124, 67,  255, 93,  122, 73,  255, 91,  117, 87,  255, 105, 132, 82,  255, 138, 167, 86,  255, 148, 175, 90,  255,
    122, 151, 83,  255, 106, 140, 75,  255, 116, 147, 75,  255, 124, 149, 73,  255, 154, 174, 99,  255, 50,  55,  31,  255, 39,  41,  29,  255, 89,
    94,  58,  255, 68,  75,  31,  255, 55,  62,  21,  255, 148, 157, 93,  255, 214, 227, 146, 255, 165, 176, 97,  255, 227, 233, 144, 255, 203, 219,
    141, 255, 165, 183, 79,  255, 180, 202, 74,  255, 101, 118, 38,  255, 151, 150, 65,  255, 183, 188, 102, 255, 178, 189, 102, 255, 184, 193, 104,
    255, 193, 205, 112, 255, 187, 201, 105, 255, 168, 181, 75,  255, 153, 163, 60,  255, 183, 187, 84,  255, 178, 186, 81,  255, 209, 208, 106, 255,
    189, 210, 136, 255, 147, 177, 131, 255, 156, 183, 131, 255, 152, 182, 120, 255, 187, 198, 118, 255, 185, 200, 99,  255, 150, 167, 79,  255, 207,
    210, 126, 255, 217, 222, 137, 255, 213, 218, 126, 255, 211, 217, 114, 255, 203, 212, 102, 255, 195, 205, 89,  255, 191, 201, 86,  255, 190, 204,
    81,  255, 101, 116, 43,  255, 12,  15,  19,  255, 32,  40,  19,  255, 78,  95,  21,  255, 189, 190, 113, 255, 227, 241, 184, 255, 206, 225, 174,
    255, 204, 224, 164, 255, 206, 226, 146, 255, 212, 227, 134, 255, 216, 225, 129, 255, 214, 224, 145, 255, 189, 207, 153, 255, 183, 209, 167, 255,
    165, 193, 146, 255, 180, 189, 102, 255, 223, 223, 134, 255, 207, 209, 100, 255, 191, 197, 75,  255, 194, 201, 68,  255, 195, 203, 72,  255, 189,
    199, 71,  255, 200, 214, 91,  255, 203, 222, 108, 255, 217, 226, 107, 255, 243, 241, 157, 255, 230, 236, 153, 255, 215, 223, 93,  255, 234, 232,
    112, 255, 241, 229, 103, 255, 227, 224, 108, 255, 211, 217, 113, 255, 211, 216, 117, 255, 207, 214, 119, 255, 213, 218, 116, 255, 184, 197, 97,
    255, 122, 148, 62,  255, 109, 137, 53,  255, 110, 140, 56,  255, 108, 139, 55,  255, 114, 144, 58,  255, 96,  129, 55,  255, 53,  87,  31,  255,
    48,  75,  26,  255, 41,  71,  19,  255, 31,  49,  21,  255, 40,  55,  25,  255, 48,  65,  26,  255, 62,  86,  28,  255, 63,  87,  36,  255, 48,
    68,  32,  255, 47,  62,  31,  255, 50,  65,  32,  255, 55,  71,  36,  255, 41,  58,  31,  255, 62,  75,  33,  255, 176, 197, 122, 255, 153, 188,
    111, 255, 158, 188, 92,  255, 143, 175, 75,  255, 117, 154, 68,  255, 169, 187, 99,  255, 206, 222, 147, 255, 172, 200, 122, 255, 176, 203, 134,
    255, 208, 223, 152, 255, 190, 198, 117, 255, 69,  84,  31,  255, 152, 157, 83,  255, 194, 197, 106, 255, 178, 183, 103, 255, 166, 174, 101, 255,
    178, 187, 104, 255, 159, 167, 72,  255, 134, 151, 58,  255, 172, 184, 76,  255, 220, 224, 146, 255, 224, 238, 182, 255, 217, 236, 185, 255, 215,
    232, 175, 255, 221, 234, 137, 255, 190, 213, 106, 255, 195, 214, 139, 255, 175, 199, 106, 255, 193, 204, 106, 255, 197, 201, 107, 255, 173, 182,
    106, 255, 174, 198, 140, 255, 195, 214, 123, 255, 175, 198, 100, 255, 162, 188, 86,  255, 178, 205, 137, 255, 204, 229, 193, 255, 157, 171, 83,
    255, 151, 165, 56,  255, 132, 143, 67,  255, 49,  74,  47,  255, 52,  75,  50,  255, 55,  86,  47,  255, 77,  112, 45,  255, 84,  115, 47,  255,
    73,  100, 47,  255, 55,  80,  46,  255, 62,  82,  48,  255, 77,  97,  53,  255, 65,  91,  47,  255, 72,  100, 43,  255, 87,  116, 45,  255, 144,
    165, 55,  255, 172, 185, 76,  255, 159, 186, 84,  255, 150, 181, 91,  255, 148, 179, 83,  255, 160, 188, 80,  255, 189, 201, 96,  255, 160, 176,
    67,  255, 164, 181, 67,  255, 187, 195, 74,  255, 205, 206, 79,  255, 202, 197, 84,  255, 100, 113, 56,  255, 63,  92,  58,  255, 63,  94,  55,
    255, 65,  100, 48,  255, 65,  100, 37,  255, 53,  86,  31,  255, 69,  99,  39,  255, 100, 132, 60,  255, 99,  125, 65,  255, 47,  68,  31,  255,
    88,  102, 43,  255, 160, 176, 83,  255, 182, 205, 138, 255, 186, 188, 112, 255, 86,  101, 36,  255, 77,  118, 41,  255, 69,  110, 43,  255, 78,
    117, 50,  255, 65,  97,  34,  255, 109, 146, 48,  255, 117, 152, 62,  255, 117, 153, 68,  255, 121, 157, 71,  255, 73,  95,  47,  255, 23,  37,
    21,  255, 65,  76,  43,  255, 119, 118, 69,  255, 26,  26,  21,  255, 15,  19,  21,  255, 23,  33,  21,  255, 106, 117, 48,  255, 176, 181, 78,
    255, 205, 212, 119, 255, 201, 214, 143, 255, 217, 211, 114, 255, 114, 122, 48,  255, 55,  65,  31,  255, 43,  65,  31,  255, 55,  76,  40,  255,
    47,  65,  39,  255, 45,  60,  37,  255, 39,  48,  31,  255, 36,  53,  26,  255, 31,  49,  23,  255, 55,  91,  28,  255, 68,  106, 34,  255, 68,
    104, 32,  255, 101, 125, 55,  255, 225, 229, 170, 255, 209, 228, 179, 255, 203, 223, 161, 255, 221, 236, 165, 255, 215, 211, 127, 255, 119, 127,
    56,  255, 86,  118, 49,  255, 97,  132, 58,  255, 105, 145, 74,  255, 114, 152, 91,  255, 114, 150, 95,  255, 115, 150, 97,  255, 119, 155, 98,
    255, 139, 171, 97,  255, 164, 190, 98,  255, 164, 185, 94,  255, 150, 166, 81,  255, 90,  113, 41,  255, 67,  103, 29,  255, 108, 145, 58,  255,
    141, 163, 76,  255, 135, 160, 82,  255, 141, 169, 82,  255, 141, 172, 67,  255, 158, 187, 71,  255, 207, 226, 134, 255, 126, 132, 96,  255, 32,
    52,  19,  255, 80,  111, 37,  255, 103, 141, 50,  255, 78,  117, 55,  255, 65,  97,  58,  255, 63,  100, 48,  255, 69,  100, 41,  255, 47,  62,
    33,  255, 34,  53,  26,  255, 32,  56,  23,  255, 31,  52,  21,  255, 81,  112, 55,  255, 85,  117, 55,  255, 86,  112, 72,  255, 124, 146, 79,
    255, 100, 132, 52,  255, 103, 139, 58,  255, 146, 170, 82,  255, 133, 160, 69,  255, 80,  112, 44,  255, 135, 158, 89,  255, 160, 180, 101, 255,
    144, 167, 69,  255, 141, 163, 60,  255, 154, 175, 65,  255, 172, 189, 75,  255, 194, 209, 83,  255, 170, 178, 67,  255, 212, 206, 106, 255, 219,
    224, 118, 255, 214, 221, 98,  255, 230, 238, 106, 255, 213, 228, 107, 255, 182, 206, 81,  255, 102, 137, 55,  255, 68,  97,  43,  255, 67,  92,
    47,  255, 65,  90,  38,  255, 65,  91,  36,  255, 76,  100, 38,  255, 84,  111, 36,  255, 75,  103, 39,  255, 67,  94,  31,  255, 80,  104, 34,
    255, 96,  123, 40,  255, 145, 150, 65,  255, 207, 221, 129, 255, 159, 189, 134, 255, 156, 187, 137, 255, 142, 177, 114, 255, 182, 197, 115, 255,
    176, 190, 96,  255, 157, 162, 93,  255, 225, 226, 147, 255, 224, 225, 146, 255, 224, 226, 141, 255, 220, 223, 127, 255, 213, 219, 116, 255, 206,
    214, 108, 255, 207, 213, 110, 255, 175, 184, 87,  255, 39,  44,  25,  255, 19,  31,  19,  255, 80,  97,  29,  255, 192, 197, 84,  255, 235, 245,
    180, 255, 213, 232, 177, 255, 220, 232, 157, 255, 234, 238, 142, 255, 209, 213, 121, 255, 143, 152, 75,  255, 135, 139, 48,  255, 201, 212, 124,
    255, 178, 204, 148, 255, 183, 207, 160, 255, 169, 197, 152, 255, 163, 177, 94,  255, 234, 227, 141, 255, 233, 228, 146, 255, 235, 229, 139, 255,
    239, 235, 122, 255, 226, 225, 109, 255, 215, 227, 94,  255, 196, 214, 74,  255, 209, 220, 87,  255, 202, 211, 86,  255, 203, 207, 97,  255, 220,
    221, 110, 255, 223, 226, 96,  255, 237, 227, 116, 255, 255, 238, 126, 255, 243, 234, 123, 255, 214, 220, 113, 255, 213, 217, 116, 255, 212, 216,
    115, 255, 207, 212, 110, 255, 206, 211, 107, 255, 184, 198, 96,  255, 127, 155, 65,  255, 125, 154, 67,  255, 130, 158, 71,  255, 121, 148, 65,
    255, 81,  107, 39,  255, 55,  87,  25,  255, 63,  97,  33,  255, 73,  109, 40,  255, 74,  110, 42,  255, 65,  102, 39,  255, 65,  98,  34,  255,
    69,  89,  36,  255, 53,  63,  33,  255, 62,  60,  44,  255, 65,  65,  46,  255, 72,  92,  41,  255, 82,  112, 43,  255, 82,  112, 45,  255, 93,
    115, 48,  255, 122, 122, 67,  255, 113, 109, 50,  255, 138, 138, 47,  255, 161, 172, 62,  255, 137, 158, 60,  255, 171, 178, 80,  255, 219, 227,
    143, 255, 191, 212, 118, 255, 180, 203, 121, 255, 229, 232, 150, 255, 226, 229, 135, 255, 182, 200, 100, 255, 183, 198, 104, 255, 187, 200, 97,
    255, 154, 173, 91,  255, 139, 158, 94,  255, 184, 189, 101, 255, 146, 163, 62,  255, 130, 148, 60,  255, 169, 177, 76,  255, 128, 140, 48,  255,
    146, 151, 74,  255, 211, 212, 138, 255, 217, 223, 143, 255, 213, 223, 137, 255, 214, 233, 156, 255, 213, 232, 161, 255, 208, 226, 152, 255, 173,
    178, 108, 255, 99,  110, 53,  255, 91,  118, 52,  255, 180, 207, 117, 255, 207, 222, 127, 255, 228, 232, 144, 255, 163, 192, 132, 255, 152, 179,
    110, 255, 175, 197, 139, 255, 208, 216, 134, 255, 191, 192, 97,  255, 162, 169, 106, 255, 124, 138, 98,  255, 144, 158, 110, 255, 159, 174, 124,
    255, 154, 173, 112, 255, 107, 126, 83,  255, 74,  101, 55,  255, 68,  100, 50,  255, 68,  97,  52,  255, 121, 143, 75,  255, 144, 170, 91,  255,
    115, 148, 87,  255, 92,  128, 75,  255, 94,  129, 55,  255, 80,  99,  31,  255, 128, 140, 58,  255, 199, 206, 105, 255, 205, 213, 118, 255, 209,
    216, 107, 255, 198, 207, 96,  255, 189, 199, 87,  255, 192, 204, 93,  255, 199, 212, 89,  255, 169, 171, 68,  255, 112, 129, 55,  255, 86,  118,
    60,  255, 72,  100, 62,  255, 69,  97,  62,  255, 69,  103, 52,  255, 72,  108, 43,  255, 65,  99,  39,  255, 58,  86,  38,  255, 53,  71,  36,
    255, 76,  102, 50,  255, 56,  80,  38,  255, 41,  68,  31,  255, 47,  67,  26,  255, 124, 137, 72,  255, 100, 117, 48,  255, 75,  114, 37,  255,
    77,  116, 49,  255, 68,  103, 49,  255, 75,  113, 49,  255, 98,  136, 47,  255, 126, 159, 52,  255, 126, 157, 55,  255, 128, 160, 71,  255, 132,
    163, 77,  255, 130, 157, 75,  255, 49,  65,  32,  255, 36,  53,  29,  255, 49,  74,  36,  255, 65,  98,  38,  255, 58,  84,  34,  255, 34,  48,
    28,  255, 38,  60,  31,  255, 43,  65,  26,  255, 100, 109, 49,  255, 175, 175, 121, 255, 131, 129, 75,  255, 38,  56,  25,  255, 32,  48,  26,
    255, 47,  68,  31,  255, 68,  90,  44,  255, 53,  71,  47,  255, 50,  65,  43,  255, 42,  58,  26,  255, 41,  75,  21,  255, 63,  97,  40,  255,
    111, 139, 76,  255, 147, 167, 103, 255, 140, 161, 95,  255, 118, 145, 68,  255, 195, 205, 137, 255, 219, 234, 185, 255, 220, 235, 172, 255, 212,
    213, 119, 255, 108, 125, 52,  255, 90,  122, 53,  255, 89,  120, 48,  255, 87,  112, 42,  255, 93,  117, 44,  255, 129, 152, 71,  255, 149, 175,
    86,  255, 159, 182, 90,  255, 158, 180, 92,  255, 173, 191, 93,  255, 142, 162, 76,  255, 125, 153, 74,  255, 133, 162, 53,  255, 106, 140, 47,
    255, 95,  126, 49,  255, 94,  113, 43,  255, 101, 116, 53,  255, 104, 132, 47,  255, 175, 200, 81,  255, 172, 200, 113, 255, 173, 198, 85,  255,
    204, 222, 117, 255, 60,  62,  47,  255, 65,  74,  37,  255, 121, 152, 71,  255, 71,  110, 49,  255, 79,  110, 58,  255, 72,  103, 58,  255, 63,
    96,  47,  255, 58,  96,  38,  255, 56,  75,  36,  255, 36,  52,  26,  255, 34,  56,  23,  255, 36,  58,  23,  255, 65,  97,  40,  255, 71,  105,
    48,  255, 75,  113, 52,  255, 78,  106, 69,  255, 115, 140, 89,  255, 99,  123, 53,  255, 99,  121, 58,  255, 127, 152, 77,  255, 85,  110, 34,
    255, 139, 162, 68,  255, 163, 181, 86,  255, 135, 157, 58,  255, 148, 166, 83,  255, 165, 182, 90,  255, 153, 167, 81,  255, 92,  103, 58,  255,
    95,  109, 60,  255, 121, 127, 41,  255, 213, 206, 102, 255, 230, 230, 129, 255, 228, 234, 105, 255, 207, 225, 77,  255, 176, 201, 65,  255, 141,
    168, 71,  255, 77,  105, 58,  255, 84,  107, 60,  255, 87,  116, 55,  255, 84,  113, 52,  255, 98,  125, 58,  255, 110, 135, 68,  255, 114, 144,
    76,  255, 87,  115, 49,  255, 130, 151, 68,  255, 158, 178, 89,  255, 121, 142, 55,  255, 180, 182, 86,  255, 208, 222, 133, 255, 159, 190, 138,
    255, 146, 178, 122, 255, 186, 202, 116, 255, 139, 160, 69,  255, 177, 174, 92,  255, 241, 233, 145, 255, 243, 236, 156, 255, 245, 238, 159, 255,
    238, 232, 152, 255, 230, 227, 136, 255, 220, 218, 125, 255, 192, 199, 96,  255, 85,  105, 39,  255, 17,  26,  12,  255, 93,  105, 48,  255, 183,
    191, 74,  255, 232, 236, 162, 255, 222, 231, 177, 255, 206, 215, 138, 255, 195, 201, 93,  255, 214, 217, 79,  255, 100, 120, 34,  255, 68,  97,
    29,  255, 83,  108, 28,  255, 163, 169, 55,  255, 210, 223, 138, 255, 183, 205, 158, 255, 175, 201, 155, 255, 165, 180, 99,  255, 193, 191, 95,
    255, 193, 187, 106, 255, 179, 179, 91,  255, 132, 140, 55,  255, 127, 138, 52,  255, 188, 199, 103, 255, 193, 204, 104, 255, 172, 187, 82,  255,
    144, 168, 72,  255, 126, 156, 62,  255, 148, 165, 60,  255, 193, 191, 84,  255, 163, 166, 79,  255, 141, 143, 48,  255, 193, 185, 77,  255, 222,
    224, 115, 255, 219, 222, 121, 255, 217, 220, 117, 255, 210, 214, 112, 255, 204, 210, 107, 255, 208, 214, 109, 255, 159, 175, 82,  255, 110, 128,
    55,  255, 100, 118, 50,  255, 63,  86,  29,  255, 42,  65,  15,  255, 84,  113, 45,  255, 100, 134, 55,  255, 102, 135, 56,  255, 104, 139, 56,
    255, 104, 141, 48,  255, 86,  121, 36,  255, 55,  80,  28,  255, 50,  62,  26,  255, 72,  62,  47,  255, 69,  73,  42,  255, 76,  105, 38,  255,
    94,  122, 52,  255, 102, 131, 55,  255, 89,  114, 48,  255, 23,  26,  19,  255, 9,   12,  17,  255, 17,  26,  15,  255, 58,  69,  28,  255, 37,
    47,  21,  255, 47,  55,  25,  255, 121, 130, 52,  255, 163, 165, 67,  255, 194, 210, 125, 255, 231, 234, 161, 255, 217, 221, 132, 255, 138, 169,
    97,  255, 136, 168, 100, 255, 140, 168, 95,  255, 170, 187, 112, 255, 212, 216, 131, 255, 186, 196, 84,  255, 167, 189, 65,  255, 130, 150, 55,
    255, 139, 155, 60,  255, 96,  121, 42,  255, 100, 126, 45,  255, 136, 153, 62,  255, 138, 157, 77,  255, 114, 134, 65,  255, 174, 190, 99,  255,
    210, 219, 131, 255, 176, 189, 104, 255, 124, 144, 72,  255, 131, 146, 75,  255, 179, 205, 102, 255, 189, 216, 114, 255, 186, 213, 128, 255, 224,
    233, 160, 255, 227, 235, 157, 255, 169, 199, 124, 255, 150, 176, 108, 255, 202, 210, 120, 255, 224, 225, 144, 255, 229, 231, 166, 255, 238, 241,
    175, 255, 221, 234, 179, 255, 207, 228, 180, 255, 208, 228, 181, 255, 223, 236, 180, 255, 208, 220, 154, 255, 126, 151, 84,  255, 116, 140, 71,
    255, 182, 197, 102, 255, 152, 174, 87,  255, 132, 159, 76,  255, 113, 145, 75,  255, 116, 148, 74,  255, 69,  97,  31,  255, 93,  116, 45,  255,
    193, 203, 104, 255, 211, 219, 109, 255, 197, 208, 97,  255, 194, 205, 92,  255, 193, 200, 89,  255, 183, 191, 84,  255, 137, 140, 65,  255, 48,
    57,  36,  255, 65,  89,  43,  255, 118, 149, 68,  255, 92,  124, 73,  255, 74,  101, 68,  255, 73,  108, 52,  255, 72,  109, 42,  255, 69,  104,
    42,  255, 71,  99,  46,  255, 29,  39,  25,  255, 42,  69,  32,  255, 53,  82,  36,  255, 47,  68,  31,  255, 63,  92,  29,  255, 82,  118, 29,
    255, 81,  117, 29,  255, 98,  136, 53,  255, 73,  108, 52,  255, 72,  105, 58,  255, 65,  99,  58,  255, 99,  136, 52,  255, 149, 175, 65,  255,
    136, 167, 60,  255, 140, 169, 73,  255, 138, 169, 82,  255, 146, 173, 84,  255, 77,  101, 42,  255, 81,  114, 44,  255, 91,  124, 55,  255, 72,
    102, 47,  255, 72,  105, 42,  255, 63,  94,  36,  255, 52,  75,  38,  255, 41,  55,  31,  255, 28,  43,  25,  255, 39,  55,  23,  255, 58,  84,
    37,  255, 71,  98,  48,  255, 69,  92,  47,  255, 44,  60,  31,  255, 67,  86,  40,  255, 69,  90,  49,  255, 49,  65,  40,  255, 68,  96,  44,
    255, 119, 148, 87,  255, 180, 199, 132, 255, 198, 211, 152, 255, 168, 190, 145, 255, 173, 197, 143, 255, 187, 206, 143, 255, 205, 215, 149, 255,
    232, 238, 179, 255, 211, 215, 121, 255, 122, 146, 58,  255, 87,  126, 60,  255, 95,  129, 58,  255, 110, 153, 55,  255, 123, 156, 52,  255, 50,
    74,  31,  255, 47,  74,  31,  255, 58,  86,  33,  255, 69,  94,  46,  255, 102, 124, 55,  255, 108, 132, 55,  255, 92,  122, 60,  255, 133, 162,
    89,  255, 164, 189, 72,  255, 153, 179, 83,  255, 81,  99,  56,  255, 29,  40,  21,  255, 42,  60,  32,  255, 119, 142, 52,  255, 212, 226, 119,
    255, 197, 217, 151, 255, 201, 218, 153, 255, 122, 135, 73,  255, 32,  40,  23,  255, 55,  69,  38,  255, 134, 161, 73,  255, 117, 150, 60,  255,
    83,  118, 62,  255, 75,  109, 58,  255, 68,  101, 50,  255, 55,  89,  36,  255, 55,  84,  37,  255, 41,  63,  31,  255, 38,  63,  25,  255, 43,
    68,  28,  255, 55,  81,  40,  255, 39,  65,  38,  255, 58,  90,  39,  255, 72,  103, 50,  255, 74,  104, 68,  255, 114, 140, 89,  255, 94,  124,
    50,  255, 92,  123, 47,  255, 91,  116, 42,  255, 137, 161, 91,  255, 152, 177, 93,  255, 90,  113, 32,  255, 111, 129, 77,  255, 143, 171, 104,
    255, 160, 180, 86,  255, 82,  87,  36,  255, 9,   9,   15,  255, 45,  52,  31,  255, 79,  89,  37,  255, 99,  102, 48,  255, 106, 106, 40,  255,
    136, 139, 48,  255, 144, 158, 55,  255, 166, 182, 68,  255, 140, 161, 62,  255, 186, 191, 81,  255, 195, 210, 110, 255, 146, 170, 105, 255, 148,
    175, 119, 255, 137, 168, 110, 255, 146, 168, 84,  255, 196, 203, 95,  255, 232, 238, 126, 255, 233, 239, 122, 255, 217, 230, 115, 255, 139, 160,
    72,  255, 176, 181, 75,  255, 195, 214, 125, 255, 155, 185, 118, 255, 179, 198, 98,  255, 129, 157, 68,  255, 102, 118, 50,  255, 127, 131, 60,
    255, 142, 138, 72,  255, 146, 138, 73,  255, 159, 161, 85,  255, 141, 154, 72,  255, 110, 132, 49,  255, 87,  118, 34,  255, 93,  128, 41,  255,
    104, 130, 48,  255, 151, 166, 75,  255, 190, 195, 78,  255, 170, 190, 91,  255, 139, 165, 84,  255, 134, 162, 87,  255, 174, 189, 65,  255, 180,
    189, 53,  255, 91,  116, 29,  255, 118, 139, 48,  255, 129, 149, 50,  255, 128, 139, 40,  255, 165, 159, 68,  255, 189, 210, 146, 255, 173, 200,
    152, 255, 169, 188, 108, 255, 134, 151, 58,  255, 89,  112, 23,  255, 127, 148, 56,  255, 151, 170, 75,  255, 193, 206, 107, 255, 210, 217, 120,
    255, 210, 217, 118, 255, 216, 221, 127, 255, 217, 224, 122, 255, 200, 217, 96,  255, 198, 216, 87,  255, 190, 198, 100, 255, 151, 151, 69,  255,
    114, 130, 44,  255, 109, 123, 26,  255, 202, 200, 92,  255, 222, 226, 122, 255, 216, 220, 117, 255, 216, 219, 116, 255, 211, 215, 114, 255, 213,
    218, 113, 255, 172, 179, 87,  255, 29,  37,  19,  255, 31,  39,  21,  255, 37,  60,  15,  255, 82,  108, 42,  255, 128, 153, 77,  255, 150, 173,
    95,  255, 130, 157, 75,  255, 144, 170, 90,  255, 139, 169, 89,  255, 75,  112, 34,  255, 48,  86,  19,  255, 52,  80,  28,  255, 62,  72,  36,
    255, 73,  89,  36,  255, 93,  121, 42,  255, 105, 131, 49,  255, 108, 127, 50,  255, 60,  77,  32,  255, 37,  58,  26,  255, 34,  48,  25,  255,
    47,  58,  32,  255, 68,  86,  42,  255, 60,  74,  42,  255, 62,  79,  40,  255, 56,  81,  31,  255, 97,  113, 49,  255, 190, 203, 120, 255, 230,
    231, 160, 255, 148, 168, 99,  255, 133, 164, 92,  255, 132, 164, 91,  255, 111, 147, 74,  255, 181, 197, 132, 255, 216, 232, 181, 255, 219, 231,
    152, 255, 136, 158, 69,  255, 91,  119, 38,  255, 116, 146, 50,  255, 110, 141, 56,  255, 111, 139, 68,  255, 120, 146, 77,  255, 141, 162, 80,
    255, 166, 182, 78,  255, 113, 139, 47,  255, 93,  117, 39,  255, 62,  91,  29,  255, 57,  95,  33,  255, 89,  118, 45,  255, 159, 162, 75,  255,
    224, 225, 127, 255, 221, 230, 136, 255, 229, 236, 143, 255, 224, 230, 137, 255, 186, 209, 101, 255, 189, 207, 99,  255, 181, 192, 98,  255, 183,
    203, 144, 255, 194, 216, 170, 255, 199, 220, 171, 255, 202, 222, 162, 255, 205, 222, 152, 255, 208, 218, 143, 255, 149, 150, 91,  255, 122, 125,
    65,  255, 117, 130, 62,  255, 153, 166, 89,  255, 208, 214, 100, 255, 216, 217, 74,  255, 198, 206, 60,  255, 177, 192, 58,  255, 152, 172, 65,
    255, 100, 129, 50,  255, 130, 155, 60,  255, 137, 152, 53,  255, 119, 132, 52,  255, 106, 124, 50,  255, 97,  118, 50,  255, 77,  98,  44,  255,
    55,  81,  36,  255, 32,  51,  29,  255, 38,  60,  41,  255, 60,  92,  37,  255, 92,  125, 47,  255, 112, 142, 75,  255, 83,  110, 69,  255, 72,
    105, 47,  255, 75,  111, 44,  255, 81,  115, 52,  255, 83,  114, 49,  255, 42,  65,  26,  255, 40,  65,  31,  255, 44,  68,  29,  255, 56,  74,
    31,  255, 107, 137, 41,  255, 97,  131, 36,  255, 84,  120, 31,  255, 98,  137, 48,  255, 74,  113, 58,  255, 75,  111, 68,  255, 76,  108, 73,
    255, 94,  127, 65,  255, 155, 176, 69,  255, 161, 185, 71,  255, 149, 176, 68,  255, 148, 176, 82,  255, 154, 181, 86,  255, 116, 143, 56,  255,
    97,  130, 48,  255, 96,  128, 55,  255, 74,  107, 47,  255, 67,  102, 42,  255, 77,  113, 38,  255, 87,  112, 40,  255, 41,  55,  32,  255, 39,
    60,  31,  255, 60,  87,  36,  255, 68,  92,  47,  255, 79,  107, 60,  255, 88,  115, 65,  255, 83,  108, 60,  255, 77,  95,  49,  255, 62,  81,
    37,  255, 105, 130, 81,  255, 164, 192, 142, 255, 166, 196, 155, 255, 162, 195, 154, 255, 155, 188, 157, 255, 154, 185, 157, 255, 159, 189, 159,
    255, 160, 191, 162, 255, 164, 193, 163, 255, 184, 204, 157, 255, 204, 213, 136, 255, 123, 149, 77,  255, 91,  131, 63,  255, 97,  131, 62,  255,
    93,  131, 55,  255, 143, 177, 58,  255, 89,  107, 41,  255, 62,  87,  41,  255, 137, 168, 84,  255, 116, 142, 79,  255, 115, 139, 76,  255, 135,
    160, 90,  255, 114, 139, 74,  255, 131, 156, 87,  255, 118, 141, 76,  255, 45,  62,  37,  255, 21,  31,  21,  255, 26,  38,  23,  255, 26,  38,
    23,  255, 40,  56,  26,  255, 103, 117, 69,  255, 227, 232, 167, 255, 133, 145, 86,  255, 37,  55,  21,  255, 42,  58,  34,  255, 26,  39,  31,
    255, 52,  76,  37,  255, 105, 134, 48,  255, 127, 156, 62,  255, 79,  119, 53,  255, 76,  112, 58,  255, 65,  101, 44,  255, 52,  84,  34,  255,
    49,  77,  34,  255, 47,  76,  31,  255, 32,  47,  23,  255, 37,  52,  34,  255, 36,  62,  26,  255, 39,  65,  28,  255, 52,  81,  36,  255, 62,
    87,  46,  255, 63,  92,  56,  255, 73,  102, 50,  255, 75,  100, 53,  255, 65,  92,  47,  255, 127, 157, 89,  255, 130, 156, 63,  255, 96,  114,
    38,  255, 56,  65,  39,  255, 118, 143, 83,  255, 147, 174, 97,  255, 162, 181, 84,  255, 77,  90,  34,  255, 34,  43,  26,  255, 79,  109, 52,
    255, 76,  109, 53,  255, 46,  73,  36,  255, 23,  44,  17,  255, 106, 110, 36,  255, 234, 234, 98,  255, 230, 231, 92,  255, 238, 234, 101, 255,
    200, 206, 108, 255, 149, 172, 119, 255, 147, 180, 119, 255, 139, 161, 81,  255, 193, 200, 84,  255, 236, 239, 115, 255, 218, 223, 103, 255, 199,
    206, 95,  255, 210, 215, 113, 255, 164, 187, 103, 255, 112, 135, 52,  255, 174, 185, 79,  255, 180, 201, 97,  255, 162, 185, 78,  255, 129, 158,
    71,  255, 76,  112, 49,  255, 42,  73,  28,  255, 36,  56,  19,  255, 46,  71,  15,  255, 80,  113, 43,  255, 79,  114, 45,  255, 76,  111, 40,
    255, 85,  115, 43,  255, 105, 133, 58,  255, 147, 164, 79,  255, 165, 180, 87,  255, 173, 181, 84,  255, 160, 184, 76,  255, 130, 164, 83,  255,
    167, 186, 95,  255, 184, 194, 65,  255, 124, 145, 38,  255, 103, 125, 32,  255, 163, 171, 74,  255, 177, 186, 83,  255, 121, 138, 68,  255, 39,
    52,  12,  255, 140, 139, 72,  255, 173, 198, 132, 255, 139, 167, 89,  255, 99,  119, 31,  255, 173, 188, 95,  255, 211, 227, 129, 255, 208, 220,
    119, 255, 205, 216, 106, 255, 210, 216, 110, 255, 215, 221, 126, 255, 217, 222, 120, 255, 212, 222, 108, 255, 204, 220, 106, 255, 214, 224, 126,
    255, 219, 229, 140, 255, 206, 217, 126, 255, 189, 194, 98,  255, 159, 165, 68,  255, 190, 192, 74,  255, 225, 226, 116, 255, 218, 221, 121, 255,
    218, 221, 118, 255, 218, 219, 119, 255, 212, 215, 114, 255, 199, 206, 104, 255, 183, 190, 102, 255, 201, 204, 117, 255, 159, 168, 90,  255, 139,
    160, 80,  255, 167, 188, 95,  255, 201, 211, 104, 255, 164, 185, 102, 255, 156, 179, 98,  255, 160, 184, 106, 255, 133, 162, 90,  255, 80,  113,
    42,  255, 72,  102, 33,  255, 96,  124, 45,  255, 112, 139, 55,  255, 107, 133, 47,  255, 101, 127, 41,  255, 56,  65,  26,  255, 67,  87,  34,
    255, 124, 151, 56,  255, 124, 152, 62,  255, 111, 139, 62,  255, 132, 153, 65,  255, 151, 172, 87,  255, 122, 148, 72,  255, 102, 127, 49,  255,
    135, 166, 75,  255, 114, 146, 73,  255, 128, 154, 76,  255, 112, 150, 65,  255, 118, 154, 60,  255, 128, 160, 62,  255, 132, 158, 60,  255, 188,
    196, 123, 255, 209, 230, 183, 255, 204, 222, 175, 255, 211, 223, 157, 255, 162, 178, 112, 255, 111, 140, 41,  255, 141, 171, 52,  255, 119, 151,
    65,  255, 99,  136, 72,  255, 129, 156, 80,  255, 192, 199, 84,  255, 130, 143, 52,  255, 53,  82,  31,  255, 71,  104, 42,  255, 80,  111, 43,
    255, 67,  95,  38,  255, 55,  79,  31,  255, 132, 140, 69,  255, 141, 156, 87,  255, 185, 196, 102, 255, 201, 218, 121, 255, 186, 202, 118, 255,
    145, 165, 77,  255, 135, 164, 99,  255, 171, 195, 127, 255, 193, 209, 139, 255, 206, 219, 137, 255, 198, 203, 109, 255, 193, 205, 124, 255, 158,
    182, 129, 255, 156, 169, 116, 255, 73,  80,  50,  255, 12,  17,  6,   255, 135, 145, 75,  255, 232, 229, 100, 255, 222, 221, 75,  255, 197, 206,
    63,  255, 174, 189, 71,  255, 136, 161, 73,  255, 123, 155, 63,  255, 179, 199, 68,  255, 128, 137, 47,  255, 36,  63,  23,  255, 52,  84,  33,
    255, 60,  92,  39,  255, 52,  84,  36,  255, 38,  65,  28,  255, 43,  62,  36,  255, 47,  72,  34,  255, 78,  111, 42,  255, 82,  118, 43,  255,
    98,  131, 53,  255, 84,  113, 53,  255, 55,  83,  34,  255, 77,  111, 50,  255, 100, 133, 62,  255, 91,  121, 53,  255, 47,  72,  31,  255, 34,
    52,  28,  255, 43,  60,  28,  255, 50,  68,  29,  255, 106, 138, 40,  255, 103, 141, 39,  255, 89,  126, 36,  255, 111, 146, 56,  255, 95,  132,
    68,  255, 90,  125, 85,  255, 92,  123, 89,  255, 94,  127, 78,  255, 120, 145, 63,  255, 165, 180, 72,  255, 175, 195, 82,  255, 166, 187, 82,
    255, 169, 190, 93,  255, 142, 164, 72,  255, 106, 134, 55,  255, 85,  115, 49,  255, 72,  104, 44,  255, 78,  113, 43,  255, 108, 142, 47,  255,
    108, 129, 43,  255, 39,  53,  31,  255, 52,  76,  34,  255, 62,  84,  47,  255, 56,  76,  50,  255, 63,  91,  55,  255, 74,  99,  63,  255, 74,
    101, 65,  255, 91,  116, 63,  255, 77,  94,  45,  255, 170, 191, 106, 255, 188, 213, 120, 255, 166, 197, 118, 255, 159, 194, 120, 255, 151, 185,
    121, 255, 150, 181, 128, 255, 149, 181, 133, 255, 151, 182, 144, 255, 159, 188, 162, 255, 159, 191, 164, 255, 182, 205, 166, 255, 199, 211, 147,
    255, 123, 153, 81,  255, 99,  131, 65,  255, 97,  131, 68,  255, 142, 175, 67,  255, 150, 174, 81,  255, 74,  94,  55,  255, 141, 168, 103, 255,
    152, 182, 113, 255, 138, 163, 93,  255, 185, 209, 145, 255, 182, 202, 129, 255, 124, 143, 74,  255, 39,  62,  31,  255, 34,  56,  26,  255, 36,
    56,  26,  255, 37,  52,  28,  255, 29,  40,  23,  255, 28,  41,  26,  255, 34,  49,  25,  255, 111, 133, 58,  255, 97,  131, 37,  255, 82,  117,
    31,  255, 72,  106, 28,  255, 52,  76,  28,  255, 36,  49,  31,  255, 49,  71,  33,  255, 127, 150, 62,  255, 125, 159, 65,  255, 83,  119, 58,
    255, 71,  108, 53,  255, 60,  97,  40,  255, 68,  104, 36,  255, 47,  68,  33,  255, 26,  29,  23,  255, 37,  58,  26,  255, 40,  65,  34,  255,
    38,  60,  36,  255, 34,  47,  33,  255, 43,  60,  41,  255, 58,  86,  49,  255, 63,  87,  43,  255, 58,  80,  38,  255, 71,  100, 47,  255, 124,
    153, 69,  255, 119, 146, 50,  255, 74,  87,  39,  255, 25,  36,  23,  255, 55,  82,  36,  255, 110, 141, 74,  255, 146, 172, 91,  255, 133, 153,
    65,  255, 69,  87,  34,  255, 92,  124, 65,  255, 103, 135, 65,  255, 72,  102, 44,  255, 104, 125, 58,  255, 175, 184, 100, 255, 225, 227, 127,
    255, 230, 230, 129, 255, 205, 211, 115, 255, 203, 212, 123, 255, 188, 192, 103, 255, 197, 197, 103, 255, 188, 198, 94,  255, 197, 205, 93,  255,
    134, 142, 60,  255, 78,  98,  31,  255, 84,  99,  31,  255, 152, 173, 92,  255, 129, 157, 90,  255, 141, 162, 87,  255, 126, 148, 68,  255, 131,
    147, 60,  255, 144, 167, 83,  255, 138, 169, 80,  255, 111, 146, 65,  255, 52,  79,  29,  255, 38,  56,  19,  255, 63,  95,  29,  255, 82,  112,
    45,  255, 78,  106, 53,  255, 82,  110, 52,  255, 99,  129, 56,  255, 120, 149, 68,  255, 144, 156, 69,  255, 174, 186, 91,  255, 120, 146, 74,
    255, 130, 146, 68,  255, 177, 189, 91,  255, 174, 186, 74,  255, 111, 124, 37,  255, 82,  100, 26,  255, 129, 148, 44,  255, 187, 190, 84,  255,
    199, 200, 102, 255, 187, 198, 101, 255, 79,  104, 44,  255, 38,  41,  12,  255, 117, 134, 56,  255, 118, 154, 60,  255, 109, 133, 39,  255, 192,
    203, 105, 255, 203, 213, 123, 255, 207, 218, 115, 255, 207, 217, 109, 255, 206, 214, 95,  255, 208, 215, 90,  255, 211, 215, 84,  255, 211, 217,
    89,  255, 216, 223, 103, 255, 220, 226, 102, 255, 216, 226, 106, 255, 224, 231, 113, 255, 227, 231, 101, 255, 223, 225, 84,  255, 231, 230, 98,
    255, 233, 230, 112, 255, 231, 229, 117, 255, 225, 224, 119, 255, 222, 222, 121, 255, 211, 216, 101, 255, 213, 218, 97,  255, 229, 230, 113, 255,
    236, 234, 120, 255, 248, 241, 132, 255, 231, 231, 129, 255, 214, 221, 112, 255, 192, 208, 72,  255, 172, 192, 87,  255, 155, 177, 98,  255, 159,
    180, 99,  255, 163, 183, 102, 255, 147, 168, 98,  255, 72,  92,  38,  255, 95,  124, 41,  255, 108, 135, 47,  255, 104, 131, 44,  255, 91,  123,
    40,  255, 76,  99,  31,  255, 158, 170, 63,  255, 177, 201, 90,  255, 138, 171, 86,  255, 105, 146, 65,  255, 95,  133, 47,  255, 112, 143, 58,
    255, 126, 148, 69,  255, 101, 129, 47,  255, 119, 148, 47,  255, 127, 161, 55,  255, 127, 163, 58,  255, 140, 169, 62,  255, 148, 170, 67,  255,
    125, 146, 68,  255, 96,  123, 48,  255, 183, 191, 106, 255, 213, 232, 178, 255, 181, 211, 161, 255, 199, 217, 167, 255, 236, 243, 184, 255, 201,
    209, 140, 255, 146, 167, 52,  255, 166, 185, 53,  255, 153, 177, 63,  255, 115, 147, 69,  255, 134, 158, 74,  255, 161, 170, 65,  255, 47,  63,
    26,  255, 47,  62,  33,  255, 38,  52,  29,  255, 21,  31,  21,  255, 23,  37,  19,  255, 113, 127, 58,  255, 136, 156, 78,  255, 102, 129, 83,
    255, 144, 164, 99,  255, 173, 194, 119, 255, 134, 164, 97,  255, 148, 177, 93,  255, 180, 202, 123, 255, 158, 176, 131, 255, 170, 181, 124, 255,
    161, 171, 91,  255, 203, 208, 114, 255, 162, 184, 125, 255, 170, 193, 129, 255, 203, 214, 139, 255, 93,  100, 62,  255, 81,  89,  44,  255, 223,
    223, 102, 255, 228, 224, 82,  255, 190, 201, 84,  255, 150, 175, 79,  255, 152, 180, 74,  255, 175, 193, 71,  255, 165, 173, 60,  255, 65,  89,
    31,  255, 100, 132, 58,  255, 144, 166, 76,  255, 159, 177, 82,  255, 144, 163, 75,  255, 81,  99,  44,  255, 36,  58,  26,  255, 48,  75,  36,
    255, 85,  116, 50,  255, 104, 135, 60,  255, 81,  112, 48,  255, 67,  97,  38,  255, 57,  87,  34,  255, 95,  131, 55,  255, 113, 145, 62,  255,
    116, 144, 60,  255, 83,  107, 43,  255, 40,  56,  26,  255, 44,  69,  29,  255, 47,  75,  31,  255, 82,  107, 36,  255, 124, 154, 47,  255, 102,
    140, 41,  255, 118, 153, 65,  255, 122, 159, 86,  255, 114, 147, 94,  255, 105, 140, 93,  255, 119, 156, 87,  255, 113, 139, 76,  255, 55,  67,
    26,  255, 145, 156, 71,  255, 188, 203, 96,  255, 190, 205, 108, 255, 154, 175, 84,  255, 132, 160, 83,  255, 100, 132, 58,  255, 80,  117, 43,
    255, 117, 148, 52,  255, 142, 166, 58,  255, 92,  102, 42,  255, 34,  47,  26,  255, 47,  68,  31,  255, 47,  72,  40,  255, 53,  80,  44,  255,
    69,  97,  53,  255, 79,  105, 62,  255, 95,  124, 67,  255, 112, 131, 63,  255, 52,  65,  26,  255, 50,  55,  23,  255, 116, 124, 53,  255, 149,
    169, 65,  255, 142, 165, 62,  255, 150, 172, 77,  255, 152, 172, 80,  255, 156, 180, 83,  255, 160, 188, 92,  255, 152, 183, 87,  255, 148, 181,
    97,  255, 148, 179, 118, 255, 175, 199, 130, 255, 183, 196, 120, 255, 97,  128, 60,  255, 97,  134, 72,  255, 120, 161, 77,  255, 143, 183, 100,
    255, 85,  109, 62,  255, 43,  65,  33,  255, 93,  124, 72,  255, 89,  125, 53,  255, 113, 151, 75,  255, 107, 140, 82,  255, 55,  82,  48,  255,
    47,  76,  37,  255, 49,  84,  32,  255, 62,  101, 36,  255, 84,  121, 49,  255, 72,  99,  44,  255, 39,  48,  25,  255, 118, 132, 58,  255, 127,
    156, 48,  255, 106, 142, 39,  255, 87,  125, 37,  255, 65,  107, 29,  255, 65,  106, 26,  255, 52,  82,  26,  255, 32,  46,  31,  255, 48,  60,
    34,  255, 108, 125, 58,  255, 131, 157, 71,  255, 122, 150, 67,  255, 106, 139, 52,  255, 80,  107, 39,  255, 37,  42,  28,  255, 33,  46,  28,
    255, 39,  65,  29,  255, 40,  60,  40,  255, 42,  60,  36,  255, 44,  67,  32,  255, 50,  73,  42,  255, 60,  91,  56,  255, 63,  89,  44,  255,
    55,  78,  31,  255, 83,  109, 52,  255, 124, 153, 65,  255, 139, 155, 65,  255, 165, 163, 69,  255, 107, 115, 47,  255, 76,  103, 43,  255, 80,
    102, 52,  255, 121, 144, 74,  255, 160, 180, 90,  255, 112, 135, 60,  255, 112, 138, 68,  255, 130, 158, 89,  255, 159, 174, 114, 255, 224, 229,
    128, 255, 219, 229, 135, 255, 201, 210, 116, 255, 198, 206, 111, 255, 170, 186, 99,  255, 207, 217, 108, 255, 194, 207, 102, 255, 183, 192, 93,
    255, 179, 181, 75,  255, 184, 195, 99,  255, 63,  87,  40,  255, 76,  93,  31,  255, 174, 188, 101, 255, 201, 218, 123, 255, 181, 204, 101, 255,
    179, 198, 89,  255, 153, 183, 80,  255, 110, 139, 58,  255, 110, 128, 56,  255, 135, 157, 71,  255, 145, 176, 87,  255, 88,  115, 58,  255, 55,
    77,  23,  255, 85,  116, 41,  255, 107, 135, 55,  255, 119, 147, 65,  255, 129, 154, 60,  255, 153, 173, 73,  255, 128, 151, 60,  255, 69,  87,
    31,  255, 120, 126, 60,  255, 127, 144, 69,  255, 126, 142, 60,  255, 127, 138, 53,  255, 80,  92,  32,  255, 19,  23,  17,  255, 52,  52,  15,
    255, 170, 175, 65,  255, 210, 209, 100, 255, 214, 214, 119, 255, 199, 205, 99,  255, 149, 166, 55,  255, 122, 143, 32,  255, 153, 169, 52,  255,
    184, 203, 86,  255, 155, 185, 87,  255, 177, 202, 127, 255, 191, 210, 147, 255, 209, 221, 155, 255, 223, 228, 153, 255, 218, 225, 141, 255, 170,
    188, 112, 255, 190, 202, 112, 255, 202, 211, 100, 255, 207, 209, 82,  255, 189, 195, 72,  255, 185, 196, 71,  255, 180, 191, 63,  255, 221, 218,
    80,  255, 235, 235, 92,  255, 236, 232, 102, 255, 238, 232, 105, 255, 236, 232, 113, 255, 219, 219, 108, 255, 215, 220, 105, 255, 210, 217, 90,
    255, 220, 222, 95,  255, 224, 225, 98,  255, 224, 223, 91,  255, 228, 227, 109, 255, 233, 231, 131, 255, 215, 223, 105, 255, 184, 205, 65,  255,
    194, 211, 99,  255, 163, 184, 102, 255, 160, 180, 97,  255, 159, 180, 98,  255, 169, 187, 107, 255, 114, 133, 68,  255, 85,  115, 36,  255, 94,
    126, 40,  255, 100, 127, 41,  255, 124, 147, 65,  255, 166, 181, 84,  255, 208, 219, 90,  255, 154, 185, 83,  255, 127, 164, 76,  255, 117, 155,
    72,  255, 118, 154, 71,  255, 133, 160, 69,  255, 152, 176, 62,  255, 99,  142, 47,  255, 119, 156, 97,  255, 152, 180, 108, 255, 114, 129, 52,
    255, 108, 127, 47,  255, 110, 139, 55,  255, 107, 141, 65,  255, 129, 154, 65,  255, 214, 212, 112, 255, 225, 235, 170, 255, 193, 221, 170, 255,
    191, 217, 165, 255, 215, 230, 177, 255, 230, 238, 184, 255, 187, 199, 130, 255, 119, 139, 36,  255, 155, 165, 47,  255, 174, 181, 60,  255, 149,
    163, 65,  255, 144, 156, 76,  255, 42,  55,  32,  255, 37,  47,  33,  255, 52,  60,  45,  255, 73,  81,  56,  255, 62,  68,  47,  255, 105, 111,
    49,  255, 169, 187, 83,  255, 101, 128, 69,  255, 117, 145, 95,  255, 165, 184, 101, 255, 171, 189, 89,  255, 195, 210, 99,  255, 188, 208, 123,
    255, 165, 198, 166, 255, 141, 167, 129, 255, 165, 178, 110, 255, 205, 210, 110, 255, 190, 205, 124, 255, 150, 177, 123, 255, 193, 207, 137, 255,
    219, 224, 140, 255, 96,  106, 53,  255, 188, 191, 98,  255, 234, 228, 118, 255, 181, 193, 116, 255, 193, 199, 89,  255, 191, 192, 77,  255, 120,
    128, 49,  255, 82,  110, 41,  255, 115, 143, 56,  255, 142, 162, 81,  255, 154, 167, 81,  255, 170, 180, 81,  255, 170, 180, 87,  255, 176, 183,
    92,  255, 80,  106, 41,  255, 55,  96,  41,  255, 69,  104, 50,  255, 79,  108, 53,  255, 74,  102, 48,  255, 80,  114, 40,  255, 89,  127, 41,
    255, 96,  134, 52,  255, 87,  124, 52,  255, 112, 147, 69,  255, 149, 174, 86,  255, 100, 120, 50,  255, 47,  75,  25,  255, 58,  87,  34,  255,
    63,  90,  36,  255, 94,  116, 39,  255, 142, 167, 60,  255, 143, 169, 74,  255, 144, 176, 96,  255, 130, 163, 97,  255, 130, 164, 104, 255, 156,
    189, 111, 255, 117, 139, 82,  255, 26,  43,  23,  255, 32,  44,  23,  255, 103, 117, 56,  255, 190, 204, 113, 255, 160, 180, 97,  255, 151, 177,
    99,  255, 154, 179, 97,  255, 131, 154, 60,  255, 122, 141, 50,  255, 102, 122, 44,  255, 56,  74,  33,  255, 28,  40,  19,  255, 44,  65,  25,
    255, 58,  87,  36,  255, 65,  97,  47,  255, 91,  121, 60,  255, 116, 142, 65,  255, 124, 140, 62,  255, 78,  87,  41,  255, 34,  51,  26,  255,
    23,  32,  25,  255, 38,  43,  29,  255, 60,  75,  31,  255, 86,  112, 41,  255, 86,  104, 45,  255, 67,  76,  34,  255, 75,  80,  36,  255, 87,
    90,  48,  255, 128, 140, 68,  255, 155, 174, 92,  255, 157, 178, 83,  255, 161, 188, 81,  255, 158, 180, 89,  255, 130, 154, 91,  255, 148, 171,
    100, 255, 161, 191, 83,  255, 158, 192, 87,  255, 85,  110, 55,  255, 36,  52,  29,  255, 47,  67,  36,  255, 74,  103, 47,  255, 75,  106, 45,
    255, 63,  94,  53,  255, 60,  91,  53,  255, 52,  83,  42,  255, 67,  102, 48,  255, 92,  130, 58,  255, 113, 150, 69,  255, 123, 159, 74,  255,
    138, 153, 68,  255, 180, 194, 81,  255, 162, 182, 63,  255, 130, 157, 47,  255, 106, 139, 42,  255, 77,  110, 34,  255, 58,  90,  28,  255, 44,
    76,  23,  255, 34,  55,  26,  255, 34,  46,  26,  255, 40,  63,  25,  255, 52,  77,  31,  255, 69,  90,  39,  255, 58,  79,  32,  255, 41,  62,
    31,  255, 52,  65,  37,  255, 37,  55,  31,  255, 40,  62,  37,  255, 45,  62,  40,  255, 74,  108, 36,  255, 62,  100, 29,  255, 55,  89,  37,
    255, 58,  95,  43,  255, 52,  82,  36,  255, 63,  84,  36,  255, 87,  118, 52,  255, 82,  111, 50,  255, 183, 184, 84,  255, 233, 238, 108, 255,
    211, 221, 89,  255, 175, 189, 76,  255, 138, 157, 74,  255, 128, 151, 83,  255, 152, 170, 100, 255, 125, 149, 68,  255, 140, 162, 71,  255, 172,
    189, 124, 255, 226, 232, 130, 255, 207, 212, 111, 255, 173, 182, 100, 255, 113, 132, 55,  255, 161, 176, 89,  255, 153, 171, 94,  255, 170, 186,
    97,  255, 139, 155, 90,  255, 150, 168, 104, 255, 202, 213, 111, 255, 180, 191, 84,  255, 157, 169, 81,  255, 175, 191, 91,  255, 185, 206, 120,
    255, 183, 206, 127, 255, 171, 198, 121, 255, 158, 190, 102, 255, 146, 181, 77,  255, 175, 197, 84,  255, 115, 146, 87,  255, 91,  116, 58,  255,
    117, 138, 68,  255, 127, 159, 86,  255, 67,  95,  29,  255, 111, 129, 41,  255, 144, 162, 63,  255, 141, 166, 71,  255, 138, 163, 58,  255, 183,
    197, 77,  255, 96,  124, 48,  255, 40,  62,  26,  255, 48,  68,  25,  255, 60,  77,  28,  255, 47,  58,  26,  255, 34,  48,  21,  255, 28,  47,
    19,  255, 21,  25,  19,  255, 17,  15,  17,  255, 80,  65,  31,  255, 174, 167, 75,  255, 200, 195, 97,  255, 195, 199, 69,  255, 180, 193, 44,
    255, 174, 188, 44,  255, 203, 208, 76,  255, 229, 233, 104, 255, 185, 208, 96,  255, 178, 202, 102, 255, 189, 212, 149, 255, 181, 207, 166, 255,
    186, 206, 153, 255, 214, 221, 148, 255, 204, 215, 136, 255, 179, 199, 120, 255, 185, 197, 94,  255, 112, 133, 46,  255, 84,  116, 34,  255, 85,
    110, 36,  255, 53,  77,  23,  255, 143, 136, 55,  255, 255, 250, 120, 255, 238, 235, 103, 255, 241, 235, 105, 255, 239, 236, 132, 255, 186, 191,
    86,  255, 201, 207, 89,  255, 213, 219, 100, 255, 201, 208, 84,  255, 171, 178, 63,  255, 204, 220, 90,  255, 176, 194, 84,  255, 196, 210, 134,
    255, 195, 214, 102, 255, 183, 206, 63,  255, 215, 225, 111, 255, 184, 199, 110, 255, 162, 182, 92,  255, 164, 183, 95,  255, 171, 188, 107, 255,
    151, 170, 93,  255, 84,  114, 39,  255, 92,  122, 48,  255, 146, 163, 78,  255, 176, 194, 100, 255, 158, 177, 94,  255, 192, 203, 105, 255, 175,
    199, 102, 255, 180, 202, 101, 255, 174, 195, 98,  255, 161, 176, 80,  255, 174, 185, 67,  255, 132, 154, 44,  255, 143, 176, 94,  255, 135, 173,
    143, 255, 140, 172, 125, 255, 97,  123, 49,  255, 60,  97,  34,  255, 65,  99,  34,  255, 82,  112, 45,  255, 122, 144, 79,  255, 173, 183, 98,
    255, 210, 213, 114, 255, 235, 243, 172, 255, 206, 225, 153, 255, 204, 221, 154, 255, 209, 228, 179, 255, 212, 227, 144, 255, 99,  122, 45,  255,
    62,  96,  37,  255, 77,  97,  40,  255, 74,  86,  36,  255, 152, 165, 102, 255, 178, 194, 130, 255, 188, 203, 132, 255, 205, 217, 157, 255, 211,
    225, 166, 255, 197, 216, 157, 255, 182, 201, 136, 255, 174, 194, 97,  255, 130, 156, 74,  255, 118, 140, 74,  255, 139, 161, 101, 255, 123, 146,
    100, 255, 111, 133, 80,  255, 148, 168, 78,  255, 172, 195, 93,  255, 171, 198, 134, 255, 139, 158, 96,  255, 191, 196, 102, 255, 211, 216, 114,
    255, 151, 180, 94,  255, 165, 193, 116, 255, 188, 206, 121, 255, 172, 194, 121, 255, 179, 202, 136, 255, 220, 219, 131, 255, 176, 176, 90,  255,
    133, 145, 68,  255, 83,  105, 37,  255, 62,  94,  33,  255, 84,  118, 41,  255, 100, 126, 52,  255, 96,  122, 68,  255, 112, 136, 83,  255, 122,
    143, 84,  255, 120, 143, 80,  255, 169, 181, 93,  255, 107, 117, 50,  255, 48,  76,  31,  255, 65,  102, 48,  255, 62,  94,  43,  255, 71,  100,
    48,  255, 98,  129, 53,  255, 139, 171, 58,  255, 114, 156, 50,  255, 94,  135, 60,  255, 117, 151, 87,  255, 124, 157, 91,  255, 154, 174, 83,
    255, 80,  98,  31,  255, 65,  95,  33,  255, 63,  94,  36,  255, 58,  87,  31,  255, 94,  116, 43,  255, 101, 121, 48,  255, 144, 171, 91,  255,
    154, 184, 109, 255, 154, 184, 115, 255, 166, 186, 110, 255, 69,  82,  47,  255, 36,  53,  37,  255, 28,  42,  26,  255, 56,  79,  36,  255, 162,
    185, 99,  255, 165, 188, 104, 255, 159, 182, 103, 255, 163, 187, 104, 255, 111, 131, 63,  255, 37,  58,  26,  255, 42,  68,  29,  255, 65,  101,
    41,  255, 98,  123, 83,  255, 117, 138, 89,  255, 95,  113, 53,  255, 73,  93,  33,  255, 91,  105, 44,  255, 87,  93,  43,  255, 43,  46,  26,
    255, 42,  51,  45,  255, 47,  58,  41,  255, 29,  46,  26,  255, 60,  72,  52,  255, 75,  74,  55,  255, 62,  67,  38,  255, 58,  74,  32,  255,
    72,  92,  45,  255, 92,  111, 65,  255, 126, 149, 89,  255, 132, 153, 111, 255, 105, 137, 92,  255, 144, 168, 75,  255, 161, 187, 76,  255, 169,
    197, 110, 255, 216, 227, 172, 255, 220, 230, 176, 255, 210, 223, 143, 255, 145, 164, 97,  255, 60,  80,  43,  255, 63,  86,  47,  255, 48,  71,
    34,  255, 71,  91,  47,  255, 85,  110, 62,  255, 69,  104, 62,  255, 63,  97,  55,  255, 68,  97,  58,  255, 76,  105, 74,  255, 88,  121, 87,
    255, 104, 141, 84,  255, 133, 170, 87,  255, 139, 171, 82,  255, 88,  106, 41,  255, 136, 152, 55,  255, 175, 189, 60,  255, 162, 182, 50,  255,
    130, 153, 42,  255, 110, 138, 37,  255, 97,  124, 33,  255, 85,  110, 31,  255, 60,  94,  29,  255, 43,  74,  25,  255, 36,  58,  26,  255, 32,
    51,  31,  255, 43,  65,  37,  255, 46,  74,  32,  255, 55,  75,  39,  255, 43,  65,  39,  255, 39,  56,  43,  255, 78,  102, 45,  255, 100, 133,
    43,  255, 71,  102, 38,  255, 53,  83,  37,  255, 55,  89,  41,  255, 60,  91,  36,  255, 68,  90,  42,  255, 37,  56,  26,  255, 26,  37,  21,
    255, 189, 192, 93,  255, 187, 204, 106, 255, 167, 190, 94,  255, 174, 196, 84,  255, 160, 179, 81,  255, 142, 159, 95,  255, 127, 151, 76,  255,
    123, 148, 62,  255, 115, 139, 58,  255, 145, 159, 76,  255, 135, 137, 62,  255, 128, 138, 68,  255, 134, 160, 89,  255, 149, 173, 84,  255, 157,
    184, 87,  255, 163, 189, 94,  255, 151, 177, 95,  255, 120, 144, 87,  255, 165, 180, 111, 255, 217, 222, 124, 255, 189, 201, 108, 255, 111, 123,
    65,  255, 181, 197, 99,  255, 184, 206, 119, 255, 177, 203, 128, 255, 155, 188, 107, 255, 141, 177, 79,  255, 160, 190, 83,  255, 191, 208, 99,
    255, 137, 170, 100, 255, 108, 145, 93,  255, 97,  126, 71,  255, 113, 130, 60,  255, 170, 186, 111, 255, 98,  119, 50,  255, 109, 137, 55,  255,
    102, 138, 62,  255, 132, 156, 60,  255, 195, 206, 81,  255, 160, 178, 78,  255, 49,  73,  33,  255, 52,  81,  28,  255, 43,  68,  26,  255, 34,
    52,  23,  255, 36,  55,  21,  255, 34,  52,  19,  255, 29,  42,  19,  255, 26,  38,  21,  255, 19,  28,  17,  255, 62,  77,  17,  255, 138, 146,
    41,  255, 196, 200, 52,  255, 182, 193, 48,  255, 178, 189, 52,  255, 191, 204, 77,  255, 221, 220, 81,  255, 241, 238, 103, 255, 215, 224, 94,
    255, 210, 220, 94,  255, 200, 217, 125, 255, 179, 206, 152, 255, 183, 204, 156, 255, 212, 221, 147, 255, 194, 206, 96,  255, 138, 156, 58,  255,
    95,  130, 45,  255, 99,  135, 47,  255, 87,  112, 36,  255, 120, 134, 62,  255, 185, 190, 94,  255, 236, 229, 115, 255, 249, 243, 124, 255, 249,
    243, 133, 255, 238, 236, 135, 255, 160, 176, 72,  255, 163, 173, 68,  255, 186, 197, 87,  255, 173, 194, 74,  255, 119, 139, 55,  255, 151, 148,
    78,  255, 187, 203, 72,  255, 171, 192, 77,  255, 189, 205, 105, 255, 180, 201, 63,  255, 211, 221, 109, 255, 199, 212, 119, 255, 162, 180, 90,
    255, 166, 185, 94,  255, 172, 189, 109, 255, 154, 171, 98,  255, 63,  84,  25,  255, 153, 169, 87,  255, 187, 203, 117, 255, 150, 175, 97,  255,
    152, 177, 103, 255, 173, 190, 108, 255, 194, 211, 115, 255, 191, 210, 130, 255, 178, 203, 130, 255, 147, 175, 92,  255, 154, 175, 71,  255, 111,
    135, 52,  255, 129, 151, 75,  255, 149, 182, 132, 255, 130, 158, 98,  255, 98,  121, 43,  255, 90,  128, 55,  255, 83,  111, 65,  255, 52,  89,
    41,  255, 84,  106, 49,  255, 173, 180, 82,  255, 218, 223, 100, 255, 209, 216, 107, 255, 198, 215, 121, 255, 192, 213, 122, 255, 200, 220, 141,
    255, 204, 223, 130, 255, 127, 149, 75,  255, 68,  98,  47,  255, 68,  99,  48,  255, 75,  100, 50,  255, 193, 206, 143, 255, 194, 218, 160, 255,
    183, 212, 158, 255, 190, 216, 168, 255, 189, 214, 167, 255, 185, 210, 154, 255, 186, 212, 133, 255, 190, 208, 104, 255, 180, 199, 108, 255, 123,
    142, 72,  255, 115, 140, 90,  255, 114, 148, 114, 255, 98,  130, 97,  255, 106, 134, 81,  255, 107, 125, 45,  255, 102, 118, 45,  255, 115, 137,
    62,  255, 167, 178, 84,  255, 172, 191, 92,  255, 137, 174, 86,  255, 139, 175, 96,  255, 140, 176, 107, 255, 150, 183, 122, 255, 163, 195, 133,
    255, 184, 196, 118, 255, 88,  96,  47,  255, 103, 123, 53,  255, 76,  104, 37,  255, 65,  92,  33,  255, 87,  121, 41,  255, 84,  118, 50,  255,
    103, 132, 68,  255, 111, 137, 76,  255, 125, 150, 75,  255, 141, 162, 76,  255, 169, 183, 93,  255, 127, 139, 67,  255, 39,  55,  25,  255, 47,
    62,  31,  255, 58,  78,  38,  255, 63,  89,  44,  255, 56,  81,  42,  255, 69,  84,  36,  255, 147, 165, 62,  255, 147, 182, 68,  255, 112, 151,
    74,  255, 121, 158, 87,  255, 170, 190, 94,  255, 87,  96,  37,  255, 60,  82,  31,  255, 72,  95,  34,  255, 65,  92,  31,  255, 63,  87,  34,
    255, 52,  69,  34,  255, 69,  84,  47,  255, 153, 179, 107, 255, 178, 203, 127, 255, 108, 121, 71,  255, 36,  55,  33,  255, 40,  60,  39,  255,
    29,  41,  28,  255, 52,  74,  31,  255, 133, 158, 77,  255, 178, 197, 110, 255, 168, 189, 102, 255, 161, 185, 89,  255, 130, 153, 73,  255, 60,
    86,  44,  255, 60,  84,  46,  255, 106, 134, 82,  255, 187, 204, 123, 255, 165, 186, 86,  255, 89,  103, 43,  255, 15,  17,  17,  255, 12,  15,
    17,  255, 25,  34,  23,  255, 34,  47,  26,  255, 40,  46,  39,  255, 67,  71,  60,  255, 47,  51,  34,  255, 84,  73,  56,  255, 94,  68,  55,
    255, 53,  46,  32,  255, 90,  112, 68,  255, 121, 153, 104, 255, 133, 161, 120, 255, 122, 149, 113, 255, 113, 144, 104, 255, 133, 165, 84,  255,
    145, 169, 77,  255, 178, 206, 141, 255, 155, 188, 122, 255, 156, 186, 117, 255, 190, 218, 145, 255, 158, 182, 105, 255, 74,  94,  52,  255, 65,
    91,  47,  255, 71,  96,  49,  255, 55,  77,  36,  255, 75,  93,  47,  255, 107, 137, 68,  255, 78,  111, 63,  255, 69,  100, 62,  255, 78,  112,
    72,  255, 87,  125, 74,  255, 91,  126, 87,  255, 87,  121, 91,  255, 95,  132, 87,  255, 132, 165, 89,  255, 52,  81,  29,  255, 39,  68,  25,
    255, 65,  79,  33,  255, 116, 121, 49,  255, 148, 155, 52,  255, 152, 161, 52,  255, 135, 148, 50,  255, 101, 133, 39,  255, 52,  87,  31,  255,
    46,  67,  36,  255, 44,  65,  34,  255, 42,  65,  38,  255, 60,  97,  43,  255, 52,  84,  36,  255, 44,  58,  33,  255, 49,  71,  41,  255, 42,
    65,  40,  255, 93,  105, 52,  255, 125, 150, 55,  255, 109, 142, 47,  255, 86,  119, 43,  255, 68,  101, 38,  255, 85,  115, 44,  255, 78,  99,
    43,  255, 43,  58,  26,  255, 91,  111, 48,  255, 152, 172, 86,  255, 211, 214, 131, 255, 187, 198, 125, 255, 172, 188, 122, 255, 176, 190, 109,
    255, 198, 208, 121, 255, 174, 191, 103, 255, 146, 164, 77,  255, 96,  110, 46,  255, 68,  83,  32,  255, 103, 127, 55,  255, 136, 162, 84,  255,
    108, 141, 90,  255, 127, 160, 98,  255, 131, 156, 75,  255, 106, 137, 56,  255, 149, 171, 86,  255, 119, 142, 84,  255, 147, 168, 101, 255, 131,
    155, 104, 255, 133, 150, 83,  255, 91,  108, 58,  255, 150, 180, 103, 255, 161, 189, 115, 255, 168, 195, 91,  255, 170, 196, 80,  255, 199, 213,
    91,  255, 224, 228, 101, 255, 208, 220, 103, 255, 174, 198, 91,  255, 136, 161, 74,  255, 99,  123, 58,  255, 157, 161, 71,  255, 248, 255, 157,
    255, 126, 159, 65,  255, 103, 138, 50,  255, 113, 147, 60,  255, 127, 159, 74,  255, 160, 178, 84,  255, 208, 211, 103, 255, 86,  112, 50,  255,
    53,  81,  28,  255, 38,  55,  21,  255, 37,  55,  23,  255, 39,  60,  21,  255, 40,  67,  21,  255, 38,  60,  23,  255, 29,  48,  19,  255, 21,
    37,  15,  255, 12,  21,  9,   255, 118, 113, 36,  255, 215, 218, 63,  255, 193, 201, 56,  255, 188, 196, 52,  255, 187, 203, 69,  255, 177, 199,
    71,  255, 185, 187, 72,  255, 243, 234, 113, 255, 238, 231, 108, 255, 245, 238, 98,  255, 229, 233, 108, 255, 201, 221, 141, 255, 197, 216, 161,
    255, 173, 190, 109, 255, 114, 147, 55,  255, 125, 157, 63,  255, 119, 151, 62,  255, 90,  112, 36,  255, 184, 194, 90,  255, 183, 204, 95,  255,
    178, 196, 87,  255, 229, 228, 119, 255, 248, 245, 153, 255, 205, 216, 97,  255, 171, 195, 67,  255, 160, 179, 80,  255, 146, 163, 65,  255, 155,
    166, 67,  255, 176, 188, 96,  255, 81,  93,  52,  255, 77,  69,  23,  255, 188, 199, 69,  255, 185, 204, 91,  255, 186, 207, 97,  255, 219, 228,
    133, 255, 201, 214, 123, 255, 154, 174, 83,  255, 160, 179, 82,  255, 165, 184, 97,  255, 145, 166, 89,  255, 34,  52,  21,  255, 94,  99,  37,
    255, 161, 176, 93,  255, 162, 186, 113, 255, 184, 205, 118, 255, 167, 200, 107, 255, 151, 191, 102, 255, 145, 186, 103, 255, 144, 182, 95,  255,
    149, 187, 80,  255, 153, 179, 83,  255, 114, 135, 62,  255, 115, 138, 65,  255, 116, 140, 65,  255, 124, 149, 80,  255, 99,  129, 67,  255, 136,
    160, 75,  255, 207, 216, 122, 255, 95,  124, 63,  255, 71,  105, 60,  255, 75,  105, 55,  255, 143, 170, 79,  255, 145, 171, 86,  255, 146, 169,
    80,  255, 164, 171, 94,  255, 192, 200, 115, 255, 172, 190, 114, 255, 113, 140, 77,  255, 69,  101, 52,  255, 65,  95,  46,  255, 135, 147, 95,
    255, 201, 219, 163, 255, 180, 208, 160, 255, 184, 211, 163, 255, 189, 213, 163, 255, 189, 213, 149, 255, 195, 213, 125, 255, 175, 183, 87,  255,
    188, 193, 102, 255, 208, 215, 118, 255, 156, 183, 102, 255, 109, 134, 68,  255, 126, 154, 102, 255, 132, 162, 119, 255, 122, 151, 109, 255, 115,
    143, 80,  255, 47,  76,  26,  255, 39,  52,  21,  255, 108, 116, 47,  255, 182, 203, 87,  255, 169, 195, 90,  255, 150, 183, 84,  255, 151, 182,
    87,  255, 156, 185, 99,  255, 158, 188, 116, 255, 197, 219, 144, 255, 110, 121, 75,  255, 47,  72,  33,  255, 69,  97,  37,  255, 63,  90,  32,
    255, 129, 151, 52,  255, 167, 183, 69,  255, 157, 174, 73,  255, 139, 160, 67,  255, 173, 185, 75,  255, 197, 203, 91,  255, 199, 199, 99,  255,
    112, 130, 58,  255, 60,  90,  37,  255, 58,  84,  38,  255, 38,  52,  32,  255, 31,  37,  26,  255, 23,  31,  25,  255, 12,  19,  21,  255, 53,
    58,  28,  255, 178, 184, 82,  255, 169, 194, 84,  255, 128, 162, 87,  255, 178, 196, 98,  255, 111, 118, 55,  255, 32,  52,  31,  255, 44,  58,
    29,  255, 50,  72,  37,  255, 48,  68,  47,  255, 42,  60,  44,  255, 33,  52,  36,  255, 82,  98,  62,  255, 132, 145, 84,  255, 46,  68,  29,
    255, 46,  73,  36,  255, 39,  55,  32,  255, 21,  26,  21,  255, 47,  68,  33,  255, 90,  120, 50,  255, 137, 158, 79,  255, 167, 186, 92,  255,
    170, 191, 84,  255, 135, 156, 67,  255, 75,  99,  58,  255, 120, 145, 71,  255, 151, 174, 79,  255, 171, 188, 75,  255, 163, 180, 82,  255, 143,
    165, 79,  255, 102, 119, 67,  255, 40,  49,  31,  255, 37,  55,  25,  255, 44,  63,  26,  255, 31,  49,  23,  255, 60,  68,  58,  255, 75,  67,
    53,  255, 65,  50,  44,  255, 48,  37,  34,  255, 112, 126, 76,  255, 156, 180, 116, 255, 118, 151, 115, 255, 122, 153, 118, 255, 123, 156, 113,
    255, 149, 181, 103, 255, 165, 183, 95,  255, 129, 162, 74,  255, 150, 180, 92,  255, 170, 195, 97,  255, 157, 179, 84,  255, 179, 195, 100, 255,
    160, 175, 85,  255, 43,  58,  37,  255, 23,  33,  23,  255, 63,  75,  40,  255, 104, 122, 68,  255, 71,  92,  46,  255, 97,  132, 55,  255, 86,
    119, 65,  255, 77,  108, 74,  255, 72,  105, 74,  255, 76,  114, 65,  255, 96,  136, 74,  255, 99,  133, 81,  255, 85,  120, 83,  255, 118, 152,
    92,  255, 75,  105, 38,  255, 44,  62,  26,  255, 34,  37,  26,  255, 50,  60,  36,  255, 55,  67,  33,  255, 41,  52,  26,  255, 41,  52,  28,
    255, 72,  110, 39,  255, 58,  92,  46,  255, 55,  81,  48,  255, 52,  73,  47,  255, 68,  97,  50,  255, 87,  130, 53,  255, 63,  92,  37,  255,
    36,  52,  29,  255, 55,  76,  41,  255, 34,  51,  29,  255, 28,  28,  25,  255, 39,  46,  29,  255, 73,  94,  36,  255, 107, 134, 47,  255, 106,
    133, 47,  255, 92,  120, 43,  255, 74,  96,  46,  255, 78,  104, 47,  255, 112, 140, 58,  255, 115, 140, 68,  255, 216, 215, 132, 255, 180, 193,
    134, 255, 153, 175, 131, 255, 154, 177, 125, 255, 195, 204, 122, 255, 155, 176, 84,  255, 140, 169, 68,  255, 101, 122, 52,  255, 47,  65,  28,
    255, 63,  83,  42,  255, 118, 146, 91,  255, 98,  131, 86,  255, 101, 134, 94,  255, 119, 145, 84,  255, 63,  90,  21,  255, 74,  104, 41,  255,
    115, 140, 77,  255, 97,  129, 77,  255, 114, 142, 97,  255, 101, 120, 67,  255, 94,  117, 55,  255, 130, 163, 87,  255, 199, 213, 110, 255, 228,
    233, 95,  255, 218, 226, 91,  255, 220, 221, 96,  255, 202, 213, 90,  255, 197, 210, 84,  255, 214, 227, 101, 255, 120, 148, 68,  255, 45,  65,
    31,  255, 159, 158, 68,  255, 218, 236, 132, 255, 145, 172, 63,  255, 164, 187, 68,  255, 168, 188, 68,  255, 188, 201, 73,  255, 200, 211, 87,
    255, 214, 219, 118, 255, 114, 135, 65,  255, 26,  39,  17,  255, 32,  46,  19,  255, 44,  65,  23,  255, 52,  83,  29,  255, 46,  74,  25,  255,
    31,  51,  23,  255, 36,  51,  21,  255, 87,  105, 55,  255, 100, 127, 62,  255, 140, 155, 71,  255, 197, 199, 89,  255, 196, 198, 71,  255, 195,
    198, 62,  255, 187, 198, 68,  255, 181, 204, 89,  255, 145, 166, 62,  255, 186, 200, 84,  255, 187, 201, 97,  255, 220, 221, 99,  255, 233, 225,
    95,  255, 208, 201, 86,  255, 204, 206, 110, 255, 191, 208, 128, 255, 138, 169, 77,  255, 143, 172, 78,  255, 133, 159, 68,  255, 160, 173, 76,
    255, 198, 214, 112, 255, 187, 208, 108, 255, 185, 206, 105, 255, 189, 204, 95,  255, 236, 234, 142, 255, 210, 220, 103, 255, 185, 201, 62,  255,
    170, 188, 86,  255, 162, 183, 78,  255, 148, 170, 67,  255, 146, 159, 56,  255, 160, 180, 76,  255, 65,  84,  44,  255, 53,  58,  19,  255, 167,
    179, 84,  255, 196, 201, 116, 255, 217, 226, 146, 255, 189, 206, 119, 255, 143, 166, 65,  255, 153, 174, 75,  255, 178, 192, 107, 255, 181, 192,
    121, 255, 168, 178, 125, 255, 170, 177, 128, 255, 191, 200, 142, 255, 217, 224, 161, 255, 211, 218, 141, 255, 189, 205, 107, 255, 191, 211, 111,
    255, 192, 210, 108, 255, 180, 199, 87,  255, 188, 210, 87,  255, 115, 143, 58,  255, 128, 158, 74,  255, 152, 184, 105, 255, 125, 165, 89,  255,
    147, 175, 93,  255, 159, 176, 101, 255, 153, 169, 83,  255, 215, 223, 103, 255, 185, 201, 100, 255, 100, 134, 73,  255, 87,  120, 63,  255, 117,
    145, 67,  255, 112, 136, 60,  255, 80,  106, 53,  255, 58,  84,  47,  255, 77,  95,  47,  255, 99,  118, 53,  255, 131, 151, 78,  255, 100, 126,
    60,  255, 99,  120, 60,  255, 204, 215, 152, 255, 184, 212, 166, 255, 183, 211, 164, 255, 189, 215, 163, 255, 200, 221, 158, 255, 217, 229, 150,
    255, 202, 209, 119, 255, 132, 149, 81,  255, 142, 164, 105, 255, 183, 191, 104, 255, 194, 208, 118, 255, 139, 162, 99,  255, 115, 136, 75,  255,
    142, 172, 117, 255, 125, 157, 119, 255, 131, 160, 102, 255, 98,  132, 41,  255, 52,  84,  26,  255, 65,  89,  33,  255, 164, 174, 87,  255, 154,
    168, 91,  255, 198, 211, 127, 255, 179, 196, 123, 255, 164, 184, 118, 255, 192, 202, 114, 255, 168, 178, 101, 255, 103, 121, 69,  255, 42,  63,
    32,  255, 45,  62,  26,  255, 55,  87,  29,  255, 69,  84,  29,  255, 123, 120, 43,  255, 175, 176, 68,  255, 189, 193, 78,  255, 192, 194, 83,
    255, 182, 182, 80,  255, 109, 125, 47,  255, 60,  89,  34,  255, 63,  95,  37,  255, 74,  115, 43,  255, 76,  115, 47,  255, 47,  68,  36,  255,
    25,  31,  25,  255, 31,  38,  26,  255, 36,  58,  23,  255, 65,  80,  28,  255, 161, 163, 74,  255, 176, 196, 106, 255, 167, 190, 113, 255, 105,
    115, 55,  255, 38,  62,  33,  255, 47,  68,  31,  255, 57,  84,  44,  255, 49,  75,  44,  255, 43,  72,  39,  255, 46,  73,  43,  255, 48,  76,
    47,  255, 50,  76,  36,  255, 34,  49,  25,  255, 25,  31,  21,  255, 19,  26,  21,  255, 19,  31,  21,  255, 43,  63,  31,  255, 95,  129, 58,
    255, 100, 128, 55,  255, 118, 144, 60,  255, 129, 147, 58,  255, 118, 141, 60,  255, 76,  104, 58,  255, 135, 154, 81,  255, 155, 179, 80,  255,
    151, 175, 80,  255, 153, 175, 86,  255, 163, 187, 92,  255, 180, 203, 105, 255, 166, 187, 101, 255, 84,  105, 49,  255, 36,  55,  23,  255, 34,
    51,  26,  255, 42,  56,  37,  255, 60,  62,  47,  255, 42,  34,  34,  255, 85,  99,  63,  255, 188, 206, 124, 255, 139, 166, 117, 255, 117, 150,
    115, 255, 150, 177, 108, 255, 191, 210, 89,  255, 163, 185, 87,  255, 172, 186, 101, 255, 180, 201, 117, 255, 153, 179, 82,  255, 167, 188, 92,
    255, 185, 200, 122, 255, 157, 180, 117, 255, 161, 180, 96,  255, 75,  87,  56,  255, 52,  55,  31,  255, 142, 163, 74,  255, 115, 144, 74,  255,
    48,  62,  34,  255, 58,  76,  37,  255, 117, 146, 72,  255, 107, 138, 75,  255, 89,  122, 72,  255, 85,  117, 74,  255, 100, 134, 79,  255, 140,
    175, 83,  255, 137, 171, 92,  255, 123, 156, 97,  255, 62,  81,  38,  255, 69,  87,  36,  255, 102, 127, 56,  255, 82,  110, 52,  255, 77,  104,
    40,  255, 79,  107, 36,  255, 105, 134, 52,  255, 101, 138, 60,  255, 75,  106, 62,  255, 73,  103, 60,  255, 86,  115, 62,  255, 116, 150, 65,
    255, 112, 147, 62,  255, 48,  72,  29,  255, 31,  43,  26,  255, 53,  67,  38,  255, 26,  26,  21,  255, 17,  17,  19,  255, 34,  40,  26,  255,
    39,  51,  26,  255, 40,  60,  28,  255, 50,  74,  32,  255, 53,  74,  31,  255, 62,  77,  40,  255, 102, 123, 60,  255, 112, 137, 62,  255, 124,
    141, 69,  255, 225, 221, 142, 255, 176, 191, 142, 255, 160, 182, 141, 255, 150, 174, 129, 255, 194, 206, 128, 255, 192, 199, 107, 255, 93,  117,
    43,  255, 28,  41,  21,  255, 12,  17,  17,  255, 76,  87,  48,  255, 120, 150, 92,  255, 101, 132, 90,  255, 103, 134, 94,  255, 111, 143, 94,
    255, 130, 153, 76,  255, 92,  114, 52,  255, 53,  74,  32,  255, 49,  71,  34,  255, 92,  116, 63,  255, 85,  100, 55,  255, 94,  122, 50,  255,
    119, 139, 58,  255, 184, 174, 74,  255, 196, 197, 87,  255, 109, 122, 52,  255, 140, 156, 74,  255, 193, 207, 90,  255, 202, 213, 91,  255, 219,
    229, 122, 255, 164, 183, 93,  255, 102, 121, 43,  255, 190, 195, 99,  255, 219, 232, 122, 255, 203, 219, 81,  255, 203, 207, 71,  255, 200, 196,
    62,  255, 192, 184, 60,  255, 169, 162, 62,  255, 103, 103, 48,  255, 41,  47,  26,  255, 29,  42,  21,  255, 38,  55,  19,  255, 63,  92,  34,
    255, 67,  101, 49,  255, 44,  69,  36,  255, 53,  74,  31,  255, 175, 188, 108, 255, 218, 235, 135, 255, 209, 228, 123, 255, 196, 215, 110, 255,
    173, 196, 99,  255, 153, 177, 90,  255, 147, 164, 71,  255, 171, 188, 74,  255, 187, 206, 81,  255, 136, 157, 55,  255, 161, 180, 63,  255, 185,
    200, 72,  255, 186, 193, 75,  255, 95,  113, 36,  255, 50,  75,  17,  255, 137, 150, 65,  255, 193, 205, 109, 255, 190, 204, 110, 255, 186, 202,
    106, 255, 184, 197, 93,  255, 215, 221, 110, 255, 209, 218, 119, 255, 205, 217, 123, 255, 200, 214, 106, 255, 188, 206, 69,  255, 195, 209, 67,
    255, 203, 215, 74,  255, 184, 201, 77,  255, 175, 196, 96,  255, 180, 199, 107, 255, 177, 197, 101, 255, 159, 183, 87,  255, 130, 155, 53,  255,
    122, 144, 50,  255, 69,  95,  34,  255, 118, 136, 65,  255, 183, 193, 112, 255, 195, 198, 124, 255, 165, 188, 89,  255, 156, 178, 67,  255, 212,
    217, 131, 255, 218, 225, 159, 255, 196, 214, 164, 255, 197, 216, 169, 255, 197, 219, 171, 255, 191, 214, 172, 255, 217, 226, 160, 255, 188, 204,
    108, 255, 159, 182, 83,  255, 138, 156, 58,  255, 138, 156, 58,  255, 97,  118, 43,  255, 89,  105, 43,  255, 145, 167, 73,  255, 161, 195, 104,
    255, 147, 182, 109, 255, 141, 177, 105, 255, 176, 202, 106, 255, 215, 218, 112, 255, 221, 223, 126, 255, 207, 219, 101, 255, 207, 217, 95,  255,
    155, 173, 79,  255, 87,  119, 47,  255, 96,  128, 58,  255, 84,  117, 52,  255, 73,  102, 48,  255, 73,  101, 55,  255, 123, 149, 84,  255, 156,
    190, 105, 255, 207, 223, 101, 255, 210, 217, 98,  255, 184, 195, 118, 255, 197, 220, 164, 255, 188, 213, 159, 255, 203, 220, 149, 255, 208, 220,
    148, 255, 203, 209, 133, 255, 183, 191, 116, 255, 187, 201, 107, 255, 182, 197, 112, 255, 165, 183, 110, 255, 117, 143, 67,  255, 152, 165, 81,
    255, 171, 193, 124, 255, 118, 146, 93,  255, 124, 148, 89,  255, 135, 167, 121, 255, 145, 171, 97,  255, 128, 157, 45,  255, 95,  129, 42,  255,
    68,  101, 36,  255, 140, 150, 68,  255, 148, 161, 87,  255, 143, 164, 105, 255, 174, 194, 140, 255, 136, 168, 136, 255, 188, 201, 134, 255, 85,
    93,  44,  255, 34,  52,  23,  255, 43,  62,  31,  255, 34,  51,  31,  255, 52,  79,  29,  255, 57,  87,  34,  255, 36,  60,  32,  255, 63,  87,
    40,  255, 72,  82,  32,  255, 78,  100, 31,  255, 68,  102, 29,  255, 55,  86,  28,  255, 57,  87,  29,  255, 69,  109, 33,  255, 81,  115, 37,
    255, 87,  119, 40,  255, 76,  98,  40,  255, 33,  41,  28,  255, 28,  38,  26,  255, 52,  71,  26,  255, 60,  94,  29,  255, 55,  86,  25,  255,
    113, 131, 52,  255, 162, 171, 93,  255, 68,  86,  41,  255, 53,  83,  38,  255, 66,  96,  43,  255, 49,  77,  32,  255, 47,  75,  28,  255, 52,
    79,  33,  255, 52,  75,  38,  255, 55,  81,  41,  255, 36,  51,  31,  255, 34,  52,  32,  255, 60,  89,  43,  255, 56,  80,  39,  255, 26,  38,
    25,  255, 31,  43,  25,  255, 94,  126, 55,  255, 110, 141, 63,  255, 82,  102, 45,  255, 43,  60,  29,  255, 111, 130, 63,  255, 139, 159, 62,
    255, 154, 181, 72,  255, 156, 183, 81,  255, 164, 189, 87,  255, 169, 193, 89,  255, 175, 197, 92,  255, 182, 203, 100, 255, 196, 213, 116, 255,
    130, 142, 69,  255, 29,  44,  19,  255, 29,  40,  23,  255, 52,  55,  43,  255, 74,  68,  52,  255, 94,  97,  56,  255, 186, 202, 115, 255, 167,
    187, 122, 255, 130, 162, 121, 255, 123, 160, 115, 255, 152, 176, 109, 255, 191, 204, 101, 255, 170, 200, 93,  255, 189, 213, 108, 255, 177, 196,
    116, 255, 105, 135, 62,  255, 126, 152, 87,  255, 149, 165, 100, 255, 183, 194, 108, 255, 113, 140, 60,  255, 99,  121, 53,  255, 142, 166, 62,
    255, 128, 170, 68,  255, 98,  118, 68,  255, 58,  80,  37,  255, 49,  74,  33,  255, 72,  96,  47,  255, 98,  129, 65,  255, 105, 135, 65,  255,
    111, 141, 68,  255, 107, 134, 68,  255, 105, 127, 65,  255, 106, 128, 68,  255, 93,  108, 62,  255, 31,  37,  23,  255, 58,  76,  33,  255, 91,
    124, 44,  255, 68,  99,  41,  255, 55,  83,  39,  255, 57,  84,  39,  255, 104, 134, 58,  255, 130, 160, 74,  255, 127, 156, 79,  255, 139, 167,
    83,  255, 144, 172, 82,  255, 134, 161, 74,  255, 78,  106, 47,  255, 55,  87,  32,  255, 36,  52,  25,  255, 49,  62,  36,  255, 34,  41,  25,
    255, 38,  41,  25,  255, 126, 146, 50,  255, 109, 139, 44,  255, 68,  94,  33,  255, 42,  62,  26,  255, 34,  49,  21,  255, 50,  68,  36,  255,
    100, 120, 62,  255, 107, 134, 69,  255, 140, 156, 84,  255, 238, 229, 147, 255, 198, 205, 142, 255, 158, 183, 140, 255, 152, 179, 135, 255, 179,
    196, 130, 255, 193, 202, 112, 255, 111, 130, 56,  255, 56,  68,  31,  255, 43,  49,  36,  255, 94,  110, 56,  255, 125, 156, 90,  255, 104, 136,
    91,  255, 114, 144, 101, 255, 106, 135, 94,  255, 113, 144, 92,  255, 115, 137, 76,  255, 39,  60,  23,  255, 43,  60,  32,  255, 93,  107, 68,
    255, 93,  108, 62,  255, 63,  90,  31,  255, 55,  83,  26,  255, 60,  74,  23,  255, 65,  94,  36,  255, 32,  58,  23,  255, 142, 153, 74,  255,
    208, 219, 104, 255, 210, 219, 108, 255, 231, 238, 143, 255, 124, 138, 69,  255, 160, 165, 55,  255, 230, 239, 127, 255, 210, 224, 102, 255, 204,
    220, 75,  255, 162, 178, 74,  255, 125, 147, 68,  255, 83,  113, 45,  255, 49,  84,  25,  255, 31,  58,  19,  255, 29,  41,  17,  255, 31,  43,
    21,  255, 40,  58,  21,  255, 69,  100, 47,  255, 62,  87,  52,  255, 44,  69,  36,  255, 110, 121, 53,  255, 241, 249, 153, 255, 211, 228, 132,
    255, 199, 217, 116, 255, 197, 213, 107, 255, 213, 222, 105, 255, 215, 222, 99,  255, 183, 198, 82,  255, 170, 188, 65,  255, 153, 174, 60,  255,
    167, 181, 72,  255, 157, 166, 68,  255, 163, 170, 77,  255, 98,  120, 38,  255, 93,  118, 43,  255, 155, 177, 92,  255, 192, 208, 109, 255, 193,
    207, 108, 255, 191, 204, 104, 255, 186, 199, 97,  255, 205, 211, 102, 255, 220, 224, 117, 255, 215, 221, 116, 255, 209, 217, 90,  255, 211, 220,
    68,  255, 216, 225, 68,  255, 172, 185, 58,  255, 131, 138, 47,  255, 158, 164, 65,  255, 175, 183, 77,  255, 211, 221, 136, 255, 210, 225, 163,
    255, 218, 228, 170, 255, 204, 217, 136, 255, 169, 189, 71,  255, 144, 165, 46,  255, 144, 166, 81,  255, 173, 195, 105, 255, 174, 187, 87,  255,
    197, 205, 107, 255, 234, 234, 150, 255, 222, 229, 165, 255, 186, 210, 164, 255, 180, 207, 168, 255, 182, 208, 165, 255, 192, 215, 168, 255, 215,
    227, 164, 255, 208, 215, 124, 255, 184, 202, 107, 255, 173, 193, 104, 255, 99,  131, 50,  255, 94,  129, 44,  255, 65,  97,  38,  255, 48,  74,
    32,  255, 166, 185, 84,  255, 184, 208, 108, 255, 157, 190, 105, 255, 181, 206, 116, 255, 205, 212, 104, 255, 203, 207, 106, 255, 223, 226, 127,
    255, 219, 227, 112, 255, 200, 213, 83,  255, 186, 200, 84,  255, 120, 153, 83,  255, 110, 148, 84,  255, 130, 159, 82,  255, 163, 176, 97,  255,
    203, 211, 121, 255, 223, 236, 134, 255, 182, 210, 117, 255, 223, 229, 105, 255, 235, 235, 122, 255, 213, 222, 151, 255, 184, 198, 126, 255, 203,
    211, 128, 255, 166, 179, 115, 255, 163, 179, 118, 255, 176, 195, 130, 255, 174, 195, 112, 255, 196, 212, 136, 255, 211, 219, 131, 255, 182, 199,
    116, 255, 117, 155, 96,  255, 107, 144, 87,  255, 168, 186, 102, 255, 169, 194, 118, 255, 122, 147, 83,  255, 124, 150, 90,  255, 150, 175, 84,
    255, 138, 164, 47,  255, 121, 151, 44,  255, 105, 136, 40,  255, 113, 139, 55,  255, 177, 186, 105, 255, 120, 141, 78,  255, 147, 173, 124, 255,
    143, 176, 137, 255, 178, 197, 138, 255, 113, 128, 58,  255, 90,  117, 36,  255, 89,  122, 43,  255, 67,  97,  46,  255, 80,  108, 52,  255, 90,
    120, 55,  255, 68,  107, 47,  255, 69,  110, 47,  255, 47,  76,  36,  255, 32,  47,  23,  255, 48,  69,  28,  255, 52,  79,  33,  255, 60,  94,
    37,  255, 72,  105, 40,  255, 75,  106, 47,  255, 81,  112, 50,  255, 72,  101, 50,  255, 41,  60,  36,  255, 32,  43,  26,  255, 38,  53,  26,
    255, 69,  95,  31,  255, 86,  119, 41,  255, 80,  113, 43,  255, 82,  104, 39,  255, 50,  71,  33,  255, 69,  98,  46,  255, 86,  121, 56,  255,
    73,  108, 47,  255, 57,  90,  32,  255, 48,  73,  28,  255, 33,  43,  28,  255, 43,  68,  38,  255, 73,  105, 48,  255, 124, 159, 69,  255, 125,
    162, 65,  255, 119, 156, 63,  255, 92,  123, 53,  255, 40,  62,  31,  255, 69,  102, 40,  255, 93,  118, 50,  255, 55,  68,  33,  255, 83,  106,
    47,  255, 150, 174, 60,  255, 180, 201, 71,  255, 182, 203, 77,  255, 179, 199, 74,  255, 166, 184, 77,  255, 181, 199, 95,  255, 186, 201, 105,
    255, 175, 188, 105, 255, 132, 141, 77,  255, 55,  56,  33,  255, 21,  28,  23,  255, 26,  34,  25,  255, 31,  38,  26,  255, 89,  94,  55,  255,
    198, 211, 120, 255, 184, 203, 121, 255, 161, 185, 98,  255, 142, 171, 104, 255, 135, 167, 103, 255, 148, 165, 95,  255, 179, 198, 127, 255, 193,
    212, 130, 255, 180, 201, 129, 255, 143, 167, 90,  255, 80,  117, 47,  255, 94,  128, 58,  255, 98,  127, 60,  255, 161, 181, 117, 255, 183, 194,
    118, 255, 143, 168, 71,  255, 131, 172, 62,  255, 122, 157, 68,  255, 65,  86,  40,  255, 57,  89,  40,  255, 82,  119, 60,  255, 77,  111, 53,
    255, 60,  90,  34,  255, 38,  55,  26,  255, 49,  53,  33,  255, 48,  55,  31,  255, 34,  38,  23,  255, 23,  23,  19,  255, 26,  26,  23,  255,
    34,  42,  23,  255, 40,  52,  26,  255, 99,  123, 52,  255, 91,  123, 42,  255, 68,  102, 33,  255, 50,  75,  36,  255, 50,  75,  36,  255, 77,
    106, 40,  255, 92,  123, 45,  255, 91,  119, 53,  255, 78,  103, 50,  255, 56,  79,  42,  255, 43,  65,  37,  255, 46,  75,  34,  255, 52,  84,
    32,  255, 50,  68,  33,  255, 43,  55,  31,  255, 133, 134, 60,  255, 160, 181, 62,  255, 134, 161, 55,  255, 119, 150, 55,  255, 96,  122, 47,
    255, 44,  57,  23,  255, 38,  53,  28,  255, 91,  108, 62,  255, 95,  120, 67,  255, 121, 144, 86,  255, 228, 225, 144, 255, 208, 213, 137, 255,
    164, 187, 144, 255, 166, 188, 147, 255, 165, 186, 136, 255, 179, 193, 111, 255, 128, 148, 71,  255, 105, 114, 62,  255, 88,  93,  71,  255, 123,
    139, 69,  255, 135, 163, 91,  255, 105, 139, 87,  255, 112, 143, 101, 255, 110, 140, 101, 255, 114, 144, 95,  255, 109, 130, 68,  255, 46,  68,
    23,  255, 55,  76,  38,  255, 80,  94,  55,  255, 63,  89,  32,  255, 65,  95,  33,  255, 60,  96,  34,  255, 51,  84,  33,  255, 42,  73,  26,
    255, 46,  75,  26,  255, 131, 147, 65,  255, 214, 218, 121, 255, 225, 229, 134, 255, 232, 236, 146, 255, 146, 172, 101, 255, 158, 176, 93,  255,
    210, 224, 101, 255, 193, 205, 89,  255, 219, 221, 106, 255, 223, 225, 122, 255, 229, 231, 127, 255, 207, 218, 125, 255, 145, 172, 96,  255, 110,
    142, 71,  255, 47,  72,  36,  255, 28,  41,  21,  255, 50,  67,  26,  255, 76,  107, 58,  255, 62,  95,  47,  255, 68,  107, 34,  255, 83,  106,
    31,  255, 164, 160, 75,  255, 219, 226, 124, 255, 215, 229, 118, 255, 221, 223, 99,  255, 209, 213, 92,  255, 176, 193, 76,  255, 146, 174, 65,
    255, 154, 179, 71,  255, 200, 211, 91,  255, 154, 165, 62,  255, 93,  118, 45,  255, 79,  108, 42,  255, 108, 133, 62,  255, 185, 200, 109, 255,
    194, 210, 112, 255, 175, 194, 101, 255, 168, 188, 97,  255, 161, 181, 95,  255, 165, 184, 89,  255, 212, 216, 113, 255, 226, 226, 123, 255, 224,
    223, 92,  255, 223, 225, 77,  255, 175, 175, 65,  255, 104, 111, 41,  255, 58,  84,  32,  255, 36,  65,  23,  255, 39,  62,  17,  255, 83,  104,
    36,  255, 155, 173, 81,  255, 207, 224, 149, 255, 197, 221, 163, 255, 205, 222, 165, 255, 219, 227, 147, 255, 208, 217, 104, 255, 193, 212, 115,
    255, 150, 182, 87,  255, 188, 207, 116, 255, 239, 236, 157, 255, 218, 226, 159, 255, 184, 209, 165, 255, 185, 209, 166, 255, 188, 212, 166, 255,
    195, 216, 167, 255, 213, 225, 163, 255, 220, 222, 130, 255, 193, 206, 108, 255, 196, 211, 116, 255, 176, 193, 99,  255, 119, 146, 68,  255, 111,
    139, 62,  255, 56,  76,  29,  255, 49,  65,  23,  255, 183, 197, 98,  255, 193, 215, 121, 255, 207, 219, 113, 255, 194, 200, 99,  255, 195, 196,
    96,  255, 206, 210, 115, 255, 223, 224, 133, 255, 232, 235, 124, 255, 203, 216, 78,  255, 201, 213, 83,  255, 146, 171, 95,  255, 167, 190, 115,
    255, 205, 217, 136, 255, 183, 204, 137, 255, 192, 205, 135, 255, 241, 241, 142, 255, 200, 221, 135, 255, 222, 228, 142, 255, 220, 224, 135, 255,
    204, 213, 121, 255, 159, 175, 72,  255, 186, 200, 100, 255, 162, 186, 110, 255, 158, 186, 110, 255, 163, 189, 111, 255, 135, 165, 68,  255, 163,
    193, 132, 255, 163, 189, 133, 255, 181, 202, 125, 255, 148, 178, 117, 255, 138, 175, 123, 255, 172, 193, 114, 255, 167, 173, 90,  255, 110, 127,
    60,  255, 82,  105, 42,  255, 134, 152, 63,  255, 147, 170, 55,  255, 145, 170, 52,  255, 132, 158, 52,  255, 116, 146, 71,  255, 134, 161, 99,
    255, 139, 160, 101, 255, 115, 139, 87,  255, 148, 177, 132, 255, 185, 201, 141, 255, 156, 166, 75,  255, 123, 140, 58,  255, 107, 131, 74,  255,
    107, 129, 76,  255, 116, 137, 86,  255, 69,  104, 52,  255, 65,  100, 55,  255, 68,  102, 47,  255, 55,  92,  36,  255, 34,  52,  31,  255, 38,
    62,  31,  255, 55,  86,  40,  255, 57,  84,  49,  255, 69,  98,  62,  255, 75,  109, 68,  255, 78,  113, 63,  255, 86,  127, 67,  255, 87,  127,
    65,  255, 47,  62,  33,  255, 23,  31,  21,  255, 29,  40,  23,  255, 76,  97,  37,  255, 96,  114, 53,  255, 62,  83,  36,  255, 46,  71,  28,
    255, 78,  109, 50,  255, 97,  133, 68,  255, 87,  124, 62,  255, 74,  113, 42,  255, 53,  77,  31,  255, 33,  47,  31,  255, 55,  79,  39,  255,
    163, 190, 93,  255, 150, 181, 72,  255, 132, 165, 58,  255, 126, 160, 55,  255, 119, 155, 52,  255, 95,  132, 45,  255, 69,  100, 38,  255, 75,
    100, 36,  255, 69,  98,  40,  255, 95,  133, 53,  255, 172, 195, 62,  255, 189, 206, 80,  255, 185, 203, 84,  255, 197, 213, 82,  255, 125, 136,
    55,  255, 140, 158, 77,  255, 140, 158, 74,  255, 114, 135, 58,  255, 77,  98,  43,  255, 48,  65,  37,  255, 36,  46,  29,  255, 23,  28,  25,
    255, 31,  43,  23,  255, 181, 193, 121, 255, 191, 213, 141, 255, 167, 195, 121, 255, 162, 188, 106, 255, 156, 183, 89,  255, 175, 195, 91,  255,
    190, 204, 115, 255, 179, 194, 107, 255, 145, 160, 82,  255, 147, 158, 77,  255, 132, 157, 71,  255, 134, 167, 69,  255, 108, 143, 82,  255, 112,
    140, 62,  255, 115, 138, 81,  255, 156, 183, 139, 255, 154, 178, 92,  255, 124, 162, 72,  255, 107, 133, 56,  255, 78,  92,  47,  255, 63,  92,
    44,  255, 97,  132, 83,  255, 111, 145, 100, 255, 109, 146, 62,  255, 101, 129, 41,  255, 69,  74,  37,  255, 53,  62,  31,  255, 47,  53,  28,
    255, 44,  47,  29,  255, 31,  36,  25,  255, 23,  26,  21,  255, 19,  19,  21,  255, 82,  91,  55,  255, 122, 148, 62,  255, 102, 130, 44,  255,
    79,  109, 39,  255, 63,  90,  40,  255, 60,  84,  40,  255, 65,  95,  34,  255, 58,  83,  38,  255, 46,  67,  38,  255, 48,  72,  43,  255, 47,
    67,  44,  255, 69,  90,  44,  255, 106, 131, 49,  255, 83,  109, 43,  255, 58,  76,  36,  255, 178, 183, 96,  255, 169, 183, 72,  255, 125, 152,
    55,  255, 123, 150, 50,  255, 122, 151, 55,  255, 90,  115, 44,  255, 60,  84,  31,  255, 84,  104, 53,  255, 86,  111, 73,  255, 95,  123, 72,
    255, 211, 215, 129, 255, 195, 205, 137, 255, 160, 185, 142, 255, 162, 186, 144, 255, 158, 182, 143, 255, 149, 171, 110, 255, 135, 157, 76,  255,
    124, 131, 77,  255, 85,  98,  63,  255, 125, 152, 69,  255, 144, 171, 89,  255, 112, 144, 86,  255, 113, 144, 101, 255, 113, 146, 106, 255, 110,
    142, 93,  255, 126, 148, 83,  255, 78,  103, 36,  255, 67,  80,  49,  255, 69,  90,  41,  255, 63,  95,  29,  255, 62,  87,  31,  255, 53,  77,
    31,  255, 55,  87,  36,  255, 55,  84,  31,  255, 53,  83,  28,  255, 43,  72,  26,  255, 178, 182, 113, 255, 254, 251, 158, 255, 196, 202, 116,
    255, 107, 128, 53,  255, 146, 173, 99,  255, 162, 177, 84,  255, 186, 197, 93,  255, 215, 219, 104, 255, 221, 222, 102, 255, 224, 223, 103, 255,
    162, 182, 112, 255, 131, 160, 112, 255, 160, 184, 114, 255, 151, 178, 101, 255, 80,  109, 55,  255, 60,  80,  32,  255, 92,  121, 58,  255, 84,
    115, 41,  255, 79,  104, 36,  255, 42,  60,  25,  255, 29,  39,  15,  255, 71,  75,  28,  255, 162, 156, 60,  255, 208, 220, 100, 255, 157, 186,
    99,  255, 153, 183, 87,  255, 152, 183, 85,  255, 190, 205, 95,  255, 170, 178, 68,  255, 93,  118, 39,  255, 96,  128, 55,  255, 124, 149, 78,
    255, 181, 195, 112, 255, 190, 206, 113, 255, 171, 189, 107, 255, 151, 177, 102, 255, 144, 171, 97,  255, 159, 181, 93,  255, 172, 190, 87,  255,
    211, 210, 106, 255, 190, 190, 81,  255, 188, 196, 93,  255, 141, 151, 79,  255, 33,  42,  23,  255, 17,  29,  15,  255, 57,  87,  32,  255, 58,
    94,  36,  255, 55,  86,  31,  255, 109, 143, 67,  255, 121, 149, 63,  255, 202, 206, 94,  255, 208, 223, 125, 255, 192, 217, 143, 255, 198, 218,
    154, 255, 198, 214, 129, 255, 172, 194, 94,  255, 198, 213, 112, 255, 211, 221, 147, 255, 198, 214, 157, 255, 190, 213, 162, 255, 191, 214, 165,
    255, 196, 218, 163, 255, 205, 222, 163, 255, 222, 231, 163, 255, 225, 226, 141, 255, 204, 211, 115, 255, 201, 213, 116, 255, 206, 215, 116, 255,
    146, 162, 81,  255, 131, 157, 84,  255, 92,  114, 53,  255, 47,  65,  23,  255, 67,  89,  31,  255, 171, 186, 100, 255, 159, 177, 87,  255, 104,
    124, 49,  255, 91,  104, 44,  255, 203, 202, 102, 255, 213, 215, 119, 255, 219, 219, 124, 255, 236, 238, 121, 255, 212, 223, 84,  255, 202, 214,
    84,  255, 197, 211, 122, 255, 210, 223, 139, 255, 181, 204, 143, 255, 166, 197, 142, 255, 168, 195, 138, 255, 199, 210, 132, 255, 227, 230, 143,
    255, 210, 223, 153, 255, 180, 200, 133, 255, 182, 203, 115, 255, 165, 194, 81,  255, 133, 172, 72,  255, 156, 185, 99,  255, 178, 201, 115, 255,
    158, 181, 82,  255, 122, 159, 49,  255, 177, 198, 102, 255, 173, 196, 114, 255, 172, 194, 122, 255, 165, 191, 127, 255, 150, 182, 125, 255, 176,
    192, 110, 255, 71,  89,  26,  255, 44,  76,  17,  255, 69,  103, 32,  255, 102, 121, 48,  255, 142, 158, 58,  255, 151, 176, 65,  255, 154, 177,
    75,  255, 134, 157, 72,  255, 133, 164, 90,  255, 121, 155, 103, 255, 122, 145, 89,  255, 123, 148, 95,  255, 185, 204, 136, 255, 195, 206, 113,
    255, 141, 158, 86,  255, 85,  99,  49,  255, 106, 133, 60,  255, 91,  123, 65,  255, 76,  112, 71,  255, 85,  123, 65,  255, 83,  126, 47,  255,
    78,  120, 41,  255, 55,  86,  40,  255, 44,  75,  36,  255, 53,  92,  37,  255, 62,  98,  40,  255, 68,  102, 49,  255, 74,  107, 60,  255, 92,
    123, 74,  255, 128, 157, 91,  255, 144, 167, 97,  255, 45,  55,  33,  255, 19,  26,  21,  255, 42,  68,  26,  255, 46,  80,  26,  255, 47,  72,
    28,  255, 43,  63,  31,  255, 39,  60,  23,  255, 78,  109, 48,  255, 105, 142, 76,  255, 95,  131, 69,  255, 77,  112, 49,  255, 37,  51,  26,
    255, 39,  58,  28,  255, 76,  110, 47,  255, 135, 159, 68,  255, 151, 177, 69,  255, 145, 178, 55,  255, 142, 173, 52,  255, 134, 166, 52,  255,
    109, 140, 44,  255, 56,  79,  29,  255, 76,  105, 34,  255, 125, 162, 67,  255, 125, 162, 72,  255, 168, 189, 68,  255, 202, 215, 78,  255, 201,
    214, 87,  255, 196, 203, 89,  255, 56,  58,  26,  255, 96,  114, 53,  255, 132, 154, 69,  255, 109, 139, 55,  255, 105, 140, 58,  255, 107, 141,
    62,  255, 88,  112, 53,  255, 29,  40,  23,  255, 75,  90,  44,  255, 222, 230, 155, 255, 183, 207, 140, 255, 174, 199, 125, 255, 171, 196, 106,
    255, 172, 194, 97,  255, 191, 203, 115, 255, 184, 195, 120, 255, 146, 166, 105, 255, 88,  102, 53,  255, 40,  52,  21,  255, 97,  117, 56,  255,
    165, 187, 82,  255, 145, 176, 106, 255, 155, 184, 134, 255, 132, 152, 92,  255, 132, 160, 121, 255, 162, 190, 105, 255, 146, 177, 69,  255, 130,
    163, 68,  255, 97,  119, 60,  255, 73,  104, 44,  255, 102, 136, 89,  255, 116, 150, 114, 255, 115, 153, 104, 255, 148, 182, 91,  255, 91,  111,
    43,  255, 29,  37,  23,  255, 32,  36,  26,  255, 34,  39,  28,  255, 34,  37,  28,  255, 23,  25,  21,  255, 17,  19,  19,  255, 43,  46,  39,
    255, 94,  109, 56,  255, 146, 168, 74,  255, 133, 155, 62,  255, 108, 134, 56,  255, 89,  116, 58,  255, 69,  92,  48,  255, 65,  89,  38,  255,
    60,  86,  43,  255, 63,  87,  44,  255, 101, 126, 43,  255, 138, 165, 45,  255, 166, 185, 50,  255, 169, 180, 56,  255, 102, 118, 52,  255, 55,
    63,  36,  255, 132, 140, 73,  255, 144, 164, 69,  255, 109, 137, 55,  255, 119, 144, 58,  255, 131, 156, 60,  255, 87,  114, 42,  255, 76,  98,
    47,  255, 76,  103, 60,  255, 107, 137, 55,  255, 159, 177, 84,  255, 212, 216, 138, 255, 160, 184, 131, 255, 158, 184, 142, 255, 164, 188, 151,
    255, 124, 152, 105, 255, 141, 164, 84,  255, 100, 114, 56,  255, 89,  105, 47,  255, 110, 140, 52,  255, 144, 167, 86,  255, 105, 138, 87,  255,
    115, 147, 103, 255, 114, 148, 106, 255, 104, 135, 85,  255, 136, 161, 87,  255, 107, 122, 60,  255, 77,  91,  53,  255, 72,  103, 39,  255, 74,
    101, 47,  255, 72,  98,  49,  255, 75,  101, 49,  255, 79,  104, 42,  255, 55,  84,  28,  255, 58,  94,  31,  255, 55,  79,  29,  255, 119, 127,
    55,  255, 165, 177, 69,  255, 140, 165, 62,  255, 73,  94,  36,  255, 121, 127, 55,  255, 195, 206, 96,  255, 214, 228, 111, 255, 213, 219, 87,
    255, 206, 210, 89,  255, 153, 175, 105, 255, 120, 153, 113, 255, 125, 160, 116, 255, 124, 160, 115, 255, 140, 168, 109, 255, 171, 193, 107, 255,
    109, 136, 65,  255, 58,  76,  26,  255, 49,  68,  25,  255, 36,  48,  23,  255, 33,  43,  23,  255, 38,  51,  26,  255, 21,  40,  23,  255, 84,
    82,  31,  255, 231, 227, 97,  255, 203, 220, 93,  255, 163, 191, 92,  255, 188, 203, 104, 255, 221, 226, 104, 255, 166, 192, 101, 255, 135, 168,
    106, 255, 109, 134, 60,  255, 162, 177, 96,  255, 174, 192, 109, 255, 162, 183, 106, 255, 148, 174, 107, 255, 136, 165, 93,  255, 160, 182, 84,
    255, 175, 193, 80,  255, 181, 197, 85,  255, 138, 155, 68,  255, 58,  75,  31,  255, 44,  60,  28,  255, 29,  42,  19,  255, 29,  43,  23,  255,
    33,  49,  26,  255, 39,  60,  23,  255, 52,  80,  26,  255, 84,  114, 47,  255, 126, 159, 81,  255, 120, 150, 69,  255, 172, 181, 69,  255, 214,
    219, 92,  255, 209, 219, 100, 255, 201, 218, 116, 255, 193, 216, 123, 255, 180, 202, 98,  255, 196, 206, 115, 255, 187, 209, 155, 255, 187, 210,
    166, 255, 196, 218, 166, 255, 196, 217, 156, 255, 201, 221, 162, 255, 218, 229, 158, 255, 225, 226, 142, 255, 207, 214, 118, 255, 209, 219, 116,
    255, 221, 224, 114, 255, 153, 165, 67,  255, 90,  119, 40,  255, 116, 140, 67,  255, 84,  111, 41,  255, 103, 132, 50,  255, 96,  130, 53,  255,
    82,  116, 47,  255, 78,  111, 53,  255, 87,  122, 56,  255, 95,  118, 47,  255, 213, 210, 112, 255, 219, 219, 121, 255, 217, 215, 120, 255, 224,
    223, 105, 255, 218, 228, 87,  255, 196, 213, 84,  255, 214, 227, 96,  255, 202, 211, 87,  255, 180, 189, 84,  255, 196, 205, 94,  255, 212, 221,
    109, 255, 211, 220, 113, 255, 206, 216, 112, 255, 177, 195, 109, 255, 144, 164, 84,  255, 95,  105, 41,  255, 116, 131, 53,  255, 154, 184, 77,
    255, 121, 164, 62,  255, 138, 174, 93,  255, 152, 178, 106, 255, 138, 167, 84,  255, 151, 174, 105, 255, 154, 179, 109, 255, 135, 168, 116, 255,
    147, 178, 130, 255, 157, 186, 127, 255, 173, 187, 102, 255, 60,  86,  21,  255, 80,  109, 26,  255, 180, 199, 62,  255, 150, 177, 69,  255, 137,
    167, 81,  255, 133, 168, 75,  255, 158, 185, 82,  255, 186, 202, 87,  255, 160, 184, 80,  255, 141, 175, 82,  255, 141, 170, 84,  255, 111, 136,
    65,  255, 143, 160, 90,  255, 156, 177, 106, 255, 191, 206, 116, 255, 163, 180, 97,  255, 129, 157, 77,  255, 104, 143, 60,  255, 106, 147, 58,
    255, 120, 162, 65,  255, 121, 164, 69,  255, 116, 157, 65,  255, 83,  122, 46,  255, 44,  63,  32,  255, 73,  110, 37,  255, 89,  134, 43,  255,
    101, 139, 58,  255, 133, 164, 80,  255, 152, 178, 87,  255, 167, 188, 99,  255, 169, 185, 106, 255, 65,  77,  43,  255, 53,  79,  31,  255, 69,
    109, 36,  255, 62,  101, 29,  255, 58,  94,  29,  255, 48,  75,  31,  255, 34,  52,  23,  255, 67,  97,  41,  255, 111, 147, 83,  255, 107, 142,
    80,  255, 60,  80,  40,  255, 21,  26,  21,  255, 31,  42,  28,  255, 55,  82,  33,  255, 81,  118, 52,  255, 98,  134, 60,  255, 110, 141, 48,
    255, 129, 158, 55,  255, 134, 168, 58,  255, 136, 161, 86,  255, 52,  71,  39,  255, 55,  89,  33,  255, 130, 150, 63,  255, 125, 154, 58,  255,
    145, 173, 79,  255, 177, 193, 84,  255, 206, 216, 99,  255, 169, 174, 87,  255, 12,  21,  15,  255, 43,  58,  29,  255, 130, 152, 72,  255, 124,
    147, 68,  255, 117, 144, 68,  255, 115, 146, 68,  255, 125, 155, 75,  255, 80,  102, 45,  255, 122, 136, 80,  255, 222, 232, 165, 255, 190, 213,
    137, 255, 190, 209, 115, 255, 182, 193, 104, 255, 164, 183, 113, 255, 153, 172, 108, 255, 123, 150, 94,  255, 137, 159, 91,  255, 72,  90,  34,
    255, 112, 142, 68,  255, 154, 178, 93,  255, 134, 157, 87,  255, 148, 176, 102, 255, 139, 176, 117, 255, 151, 179, 120, 255, 113, 138, 82,  255,
    137, 170, 86,  255, 160, 185, 112, 255, 92,  113, 68,  255, 33,  52,  19,  255, 92,  122, 62,  255, 119, 154, 110, 255, 126, 161, 123, 255, 125,
    161, 123, 255, 163, 189, 122, 255, 104, 130, 55,  255, 33,  46,  23,  255, 28,  31,  23,  255, 44,  51,  29,  255, 40,  42,  28,  255, 28,  29,
    25,  255, 15,  17,  17,  255, 37,  39,  34,  255, 28,  37,  26,  255, 68,  81,  43,  255, 133, 149, 74,  255, 155, 173, 83,  255, 143, 163, 77,
    255, 97,  115, 58,  255, 60,  82,  38,  255, 84,  111, 47,  255, 125, 148, 48,  255, 151, 173, 52,  255, 167, 185, 58,  255, 190, 200, 62,  255,
    219, 220, 84,  255, 127, 136, 62,  255, 60,  83,  36,  255, 41,  63,  25,  255, 123, 136, 65,  255, 156, 168, 72,  255, 114, 136, 58,  255, 113,
    139, 58,  255, 104, 132, 50,  255, 65,  87,  36,  255, 83,  104, 47,  255, 87,  114, 43,  255, 68,  100, 41,  255, 142, 159, 84,  255, 195, 205,
    127, 255, 163, 187, 132, 255, 155, 184, 141, 255, 123, 151, 100, 255, 126, 152, 71,  255, 89,  98,  62,  255, 91,  102, 55,  255, 129, 158, 55,
    255, 175, 194, 80,  255, 178, 189, 89,  255, 127, 152, 95,  255, 112, 147, 104, 255, 103, 132, 82,  255, 144, 168, 86,  255, 114, 129, 71,  255,
    75,  101, 48,  255, 74,  103, 47,  255, 79,  104, 60,  255, 130, 146, 86,  255, 115, 136, 71,  255, 86,  101, 44,  255, 17,  31,  17,  255, 72,
    94,  38,  255, 160, 180, 71,  255, 148, 171, 65,  255, 146, 171, 69,  255, 153, 181, 74,  255, 105, 133, 55,  255, 110, 109, 38,  255, 236, 235,
    129, 255, 239, 243, 141, 255, 218, 230, 131, 255, 145, 175, 105, 255, 126, 162, 109, 255, 127, 163, 110, 255, 124, 159, 113, 255, 124, 159, 115,
    255, 123, 158, 111, 255, 137, 164, 108, 255, 154, 180, 99,  255, 75,  107, 41,  255, 47,  71,  25,  255, 43,  68,  29,  255, 41,  60,  28,  255,
    40,  58,  28,  255, 80,  93,  43,  255, 177, 184, 89,  255, 238, 226, 99,  255, 235, 234, 105, 255, 191, 209, 117, 255, 191, 202, 103, 255, 156,
    175, 73,  255, 156, 182, 87,  255, 152, 179, 90,  255, 109, 135, 52,  255, 154, 175, 84,  255, 149, 177, 94,  255, 141, 172, 97,  255, 140, 170,
    92,  255, 153, 176, 81,  255, 177, 194, 77,  255, 174, 191, 77,  255, 145, 169, 68,  255, 144, 171, 71,  255, 152, 178, 82,  255, 125, 152, 72,
    255, 65,  90,  43,  255, 52,  79,  37,  255, 55,  87,  41,  255, 48,  76,  36,  255, 36,  55,  23,  255, 83,  99,  41,  255, 135, 163, 74,  255,
    123, 157, 65,  255, 124, 151, 60,  255, 192, 195, 81,  255, 209, 217, 90,  255, 197, 208, 84,  255, 191, 207, 89,  255, 167, 182, 87,  255, 179,
    195, 114, 255, 187, 208, 123, 255, 214, 222, 117, 255, 214, 225, 128, 255, 216, 227, 145, 255, 218, 222, 137, 255, 207, 212, 128, 255, 208, 216,
    121, 255, 218, 226, 117, 255, 200, 206, 97,  255, 121, 136, 50,  255, 62,  97,  26,  255, 76,  115, 38,  255, 86,  118, 43,  255, 99,  122, 50,
    255, 132, 156, 71,  255, 97,  126, 63,  255, 93,  125, 62,  255, 113, 144, 71,  255, 114, 138, 60,  255, 75,  87,  29,  255, 203, 199, 103, 255,
    227, 225, 124, 255, 221, 219, 120, 255, 214, 212, 110, 255, 216, 222, 99,  255, 206, 222, 94,  255, 211, 221, 87,  255, 209, 214, 106, 255, 210,
    214, 105, 255, 217, 219, 110, 255, 221, 224, 116, 255, 219, 221, 116, 255, 216, 222, 112, 255, 209, 218, 113, 255, 172, 188, 111, 255, 96,  121,
    81,  255, 89,  114, 60,  255, 139, 159, 71,  255, 151, 178, 68,  255, 129, 169, 62,  255, 121, 159, 73,  255, 137, 166, 87,  255, 162, 181, 98,
    255, 163, 188, 99,  255, 155, 184, 101, 255, 164, 190, 106, 255, 163, 189, 117, 255, 159, 173, 93,  255, 104, 122, 68,  255, 151, 165, 97,  255,
    215, 221, 87,  255, 162, 187, 68,  255, 143, 175, 87,  255, 131, 168, 81,  255, 161, 186, 87,  255, 220, 226, 106, 255, 145, 175, 84,  255, 118,
    159, 75,  255, 121, 163, 65,  255, 120, 159, 68,  255, 128, 152, 71,  255, 137, 164, 101, 255, 165, 187, 109, 255, 200, 213, 115, 255, 173, 185,
    99,  255, 97,  112, 43,  255, 119, 139, 52,  255, 129, 152, 65,  255, 123, 149, 68,  255, 125, 157, 68,  255, 82,  106, 44,  255, 26,  33,  25,
    255, 45,  65,  28,  255, 109, 140, 58,  255, 151, 177, 76,  255, 150, 176, 72,  255, 150, 177, 77,  255, 169, 191, 99,  255, 141, 153, 80,  255,
    58,  72,  33,  255, 78,  111, 39,  255, 75,  113, 36,  255, 73,  110, 34,  255, 68,  106, 29,  255, 57,  91,  29,  255, 34,  49,  26,  255, 55,
    81,  31,  255, 110, 142, 77,  255, 81,  99,  52,  255, 32,  43,  26,  255, 32,  39,  28,  255, 42,  65,  39,  255, 51,  79,  38,  255, 87,  122,
    62,  255, 98,  134, 75,  255, 90,  124, 62,  255, 93,  125, 58,  255, 104, 135, 55,  255, 145, 167, 74,  255, 127, 151, 67,  255, 76,  107, 42,
    255, 131, 152, 67,  255, 152, 177, 81,  255, 164, 186, 91,  255, 162, 185, 89,  255, 166, 188, 86,  255, 161, 183, 87,  255, 80,  97,  52,  255,
    36,  52,  26,  255, 107, 131, 56,  255, 131, 154, 74,  255, 130, 151, 75,  255, 126, 150, 72,  255, 122, 147, 71,  255, 141, 164, 87,  255, 206,
    213, 141, 255, 205, 216, 136, 255, 182, 198, 110, 255, 147, 159, 84,  255, 143, 161, 103, 255, 146, 165, 106, 255, 113, 142, 84,  255, 121, 155,
    92,  255, 127, 136, 67,  255, 107, 126, 62,  255, 158, 183, 110, 255, 131, 161, 105, 255, 101, 138, 77,  255, 84,  118, 52,  255, 120, 157, 80,
    255, 141, 174, 99,  255, 114, 141, 63,  255, 128, 152, 96,  255, 175, 194, 137, 255, 125, 136, 91,  255, 36,  42,  23,  255, 101, 125, 62,  255,
    145, 173, 107, 255, 143, 174, 125, 255, 159, 188, 131, 255, 158, 176, 103, 255, 71,  96,  46,  255, 49,  68,  36,  255, 25,  29,  23,  255, 49,
    55,  34,  255, 39,  44,  31,  255, 28,  29,  23,  255, 15,  17,  17,  255, 29,  31,  26,  255, 31,  39,  29,  255, 25,  37,  23,  255, 28,  40,
    26,  255, 45,  60,  36,  255, 44,  58,  36,  255, 17,  23,  21,  255, 52,  63,  34,  255, 149, 166, 72,  255, 171, 186, 68,  255, 183, 193, 69,
    255, 182, 192, 71,  255, 168, 178, 73,  255, 156, 171, 90,  255, 113, 134, 73,  255, 69,  92,  44,  255, 51,  79,  33,  255, 39,  67,  32,  255,
    99,  119, 58,  255, 160, 171, 77,  255, 162, 172, 75,  255, 175, 179, 82,  255, 152, 154, 68,  255, 94,  105, 58,  255, 43,  56,  31,  255, 58,
    79,  31,  255, 50,  73,  25,  255, 80,  98,  48,  255, 154, 176, 99,  255, 155, 183, 118, 255, 111, 143, 84,  255, 83,  114, 41,  255, 97,  117,
    65,  255, 144, 164, 76,  255, 177, 200, 78,  255, 208, 217, 83,  255, 234, 228, 100, 255, 148, 164, 98,  255, 112, 149, 110, 255, 110, 137, 80,
    255, 154, 176, 91,  255, 85,  106, 55,  255, 69,  100, 50,  255, 75,  100, 62,  255, 116, 139, 86,  255, 190, 209, 117, 255, 189, 206, 106, 255,
    95,  102, 47,  255, 6,   12,  9,   255, 53,  63,  31,  255, 167, 188, 81,  255, 176, 201, 86,  255, 169, 193, 84,  255, 123, 154, 56,  255, 143,
    173, 72,  255, 163, 171, 71,  255, 207, 206, 102, 255, 228, 227, 116, 255, 253, 250, 164, 255, 156, 184, 118, 255, 120, 157, 103, 255, 132, 167,
    111, 255, 138, 171, 121, 255, 131, 167, 121, 255, 124, 161, 112, 255, 120, 155, 109, 255, 126, 156, 99,  255, 125, 159, 79,  255, 60,  90,  28,
    255, 69,  101, 32,  255, 68,  104, 32,  255, 87,  109, 38,  255, 208, 209, 104, 255, 222, 227, 109, 255, 206, 211, 93,  255, 229, 223, 119, 255,
    208, 214, 122, 255, 134, 166, 82,  255, 107, 146, 68,  255, 103, 143, 60,  255, 113, 145, 49,  255, 102, 124, 45,  255, 123, 145, 62,  255, 148,
    169, 80,  255, 158, 178, 82,  255, 161, 182, 78,  255, 175, 191, 84,  255, 162, 178, 77,  255, 120, 143, 43,  255, 126, 158, 53,  255, 147, 173,
    72,  255, 160, 179, 80,  255, 172, 188, 84,  255, 163, 186, 84,  255, 83,  119, 53,  255, 74,  101, 53,  255, 92,  118, 62,  255, 58,  84,  43,
    255, 60,  81,  19,  255, 112, 136, 38,  255, 124, 150, 52,  255, 114, 140, 49,  255, 128, 146, 60,  255, 203, 207, 92,  255, 203, 212, 92,  255,
    192, 203, 84,  255, 158, 172, 76,  255, 192, 205, 126, 255, 199, 213, 105, 255, 200, 216, 93,  255, 221, 227, 110, 255, 187, 195, 98,  255, 143,
    150, 68,  255, 159, 176, 77,  255, 189, 199, 83,  255, 145, 151, 63,  255, 83,  110, 36,  255, 62,  102, 32,  255, 80,  116, 41,  255, 92,  127,
    50,  255, 96,  132, 60,  255, 118, 140, 56,  255, 142, 164, 75,  255, 116, 143, 73,  255, 112, 138, 72,  255, 153, 173, 75,  255, 63,  74,  28,
    255, 17,  23,  12,  255, 169, 166, 82,  255, 235, 230, 127, 255, 225, 222, 122, 255, 217, 215, 114, 255, 211, 210, 111, 255, 202, 209, 105, 255,
    212, 218, 117, 255, 219, 223, 122, 255, 220, 225, 122, 255, 220, 226, 123, 255, 220, 225, 126, 255, 222, 227, 131, 255, 230, 235, 134, 255, 235,
    233, 131, 255, 180, 186, 102, 255, 123, 157, 102, 255, 123, 157, 105, 255, 119, 150, 99,  255, 126, 153, 89,  255, 132, 157, 79,  255, 128, 155,
    69,  255, 129, 156, 67,  255, 156, 180, 82,  255, 143, 178, 62,  255, 151, 184, 65,  255, 163, 191, 76,  255, 191, 209, 113, 255, 207, 214, 122,
    255, 218, 223, 128, 255, 210, 216, 129, 255, 219, 221, 113, 255, 169, 193, 78,  255, 144, 179, 89,  255, 148, 180, 87,  255, 176, 197, 94,  255,
    197, 206, 117, 255, 124, 163, 91,  255, 117, 161, 79,  255, 123, 164, 81,  255, 121, 161, 73,  255, 125, 165, 73,  255, 158, 182, 83,  255, 157,
    177, 102, 255, 175, 193, 110, 255, 199, 214, 119, 255, 139, 158, 87,  255, 47,  62,  31,  255, 36,  46,  25,  255, 28,  29,  21,  255, 48,  68,
    32,  255, 58,  87,  33,  255, 52,  82,  33,  255, 72,  107, 43,  255, 134, 165, 67,  255, 145, 172, 67,  255, 149, 176, 79,  255, 159, 183, 94,
    255, 178, 197, 102, 255, 90,  99,  49,  255, 42,  63,  31,  255, 98,  132, 55,  255, 84,  124, 41,  255, 75,  117, 34,  255, 76,  114, 36,  255,
    87,  122, 50,  255, 65,  92,  41,  255, 43,  60,  26,  255, 47,  57,  33,  255, 29,  42,  28,  255, 38,  55,  26,  255, 42,  65,  32,  255, 73,
    105, 50,  255, 81,  116, 43,  255, 90,  127, 60,  255, 117, 149, 82,  255, 95,  129, 53,  255, 91,  126, 53,  255, 63,  96,  36,  255, 55,  96,
    23,  255, 99,  125, 56,  255, 127, 139, 68,  255, 161, 184, 74,  255, 173, 194, 91,  255, 169, 189, 92,  255, 172, 192, 95,  255, 171, 193, 92,
    255, 172, 198, 95,  255, 171, 193, 98,  255, 101, 126, 49,  255, 83,  111, 36,  255, 130, 154, 69,  255, 132, 155, 77,  255, 128, 152, 73,  255,
    132, 157, 76,  255, 177, 189, 121, 255, 168, 183, 132, 255, 146, 170, 106, 255, 120, 144, 62,  255, 108, 138, 91,  255, 125, 156, 104, 255, 99,
    134, 78,  255, 85,  119, 65,  255, 139, 158, 84,  255, 101, 117, 55,  255, 58,  78,  42,  255, 91,  105, 75,  255, 71,  99,  55,  255, 63,  95,
    36,  255, 93,  115, 49,  255, 147, 166, 74,  255, 124, 157, 68,  255, 111, 142, 60,  255, 105, 131, 67,  255, 133, 162, 112, 255, 130, 165, 71,
    255, 131, 157, 65,  255, 134, 159, 82,  255, 159, 175, 91,  255, 173, 188, 112, 255, 188, 206, 133, 255, 154, 166, 86,  255, 65,  87,  44,  255,
    52,  69,  37,  255, 15,  17,  17,  255, 23,  26,  23,  255, 33,  36,  29,  255, 31,  31,  26,  255, 19,  21,  21,  255, 31,  31,  26,  255, 33,
    37,  28,  255, 31,  44,  26,  255, 31,  44,  26,  255, 28,  41,  25,  255, 28,  38,  26,  255, 17,  19,  19,  255, 45,  49,  33,  255, 102, 122,
    56,  255, 106, 128, 50,  255, 105, 132, 52,  255, 89,  120, 47,  255, 62,  94,  39,  255, 51,  83,  40,  255, 71,  104, 48,  255, 65,  89,  41,
    255, 49,  72,  38,  255, 52,  82,  37,  255, 40,  69,  36,  255, 52,  74,  41,  255, 93,  112, 50,  255, 120, 139, 53,  255, 147, 168, 68,  255,
    163, 176, 83,  255, 88,  110, 41,  255, 72,  102, 40,  255, 96,  118, 47,  255, 97,  113, 48,  255, 78,  103, 47,  255, 120, 152, 73,  255, 118,
    144, 65,  255, 120, 141, 60,  255, 159, 185, 92,  255, 170, 195, 96,  255, 191, 204, 91,  255, 236, 228, 93,  255, 238, 226, 111, 255, 138, 161,
    107, 255, 115, 150, 110, 255, 117, 145, 77,  255, 131, 152, 76,  255, 63,  87,  47,  255, 81,  109, 75,  255, 100, 124, 87,  255, 166, 185, 112,
    255, 180, 204, 111, 255, 181, 205, 109, 255, 151, 168, 86,  255, 28,  29,  17,  255, 23,  31,  23,  255, 60,  83,  38,  255, 86,  100, 52,  255,
    125, 144, 71,  255, 145, 166, 81,  255, 121, 139, 65,  255, 136, 144, 62,  255, 176, 181, 84,  255, 176, 183, 82,  255, 206, 209, 105, 255, 172,
    195, 101, 255, 168, 189, 96,  255, 198, 203, 92,  255, 217, 218, 101, 255, 161, 189, 125, 255, 130, 168, 116, 255, 122, 158, 100, 255, 110, 147,
    89,  255, 108, 140, 71,  255, 115, 137, 48,  255, 126, 145, 48,  255, 123, 143, 43,  255, 205, 205, 99,  255, 230, 231, 118, 255, 203, 210, 108,
    255, 175, 191, 98,  255, 150, 175, 84,  255, 132, 164, 75,  255, 131, 165, 68,  255, 122, 158, 58,  255, 140, 170, 60,  255, 132, 166, 55,  255,
    95,  121, 39,  255, 108, 131, 56,  255, 111, 137, 74,  255, 101, 124, 60,  255, 122, 143, 65,  255, 140, 161, 73,  255, 100, 126, 53,  255, 63,
    89,  26,  255, 128, 151, 49,  255, 157, 179, 69,  255, 163, 184, 77,  255, 164, 184, 80,  255, 171, 188, 84,  255, 147, 170, 74,  255, 127, 142,
    75,  255, 128, 145, 76,  255, 103, 128, 60,  255, 96,  124, 31,  255, 101, 127, 29,  255, 119, 143, 44,  255, 145, 164, 76,  255, 137, 154, 77,
    255, 164, 177, 87,  255, 222, 220, 112, 255, 200, 205, 103, 255, 139, 158, 71,  255, 187, 201, 110, 255, 198, 201, 94,  255, 205, 209, 99,  255,
    199, 211, 120, 255, 166, 191, 96,  255, 138, 153, 69,  255, 142, 147, 71,  255, 99,  123, 45,  255, 47,  73,  23,  255, 65,  87,  32,  255, 96,
    129, 52,  255, 91,  126, 47,  255, 99,  128, 55,  255, 89,  116, 47,  255, 108, 125, 44,  255, 159, 176, 78,  255, 140, 162, 85,  255, 141, 162,
    82,  255, 144, 155, 74,  255, 108, 113, 68,  255, 192, 194, 118, 255, 233, 233, 135, 255, 230, 230, 126, 255, 223, 225, 116, 255, 216, 218, 112,
    255, 205, 208, 103, 255, 210, 221, 92,  255, 222, 230, 107, 255, 225, 230, 119, 255, 228, 232, 132, 255, 234, 236, 138, 255, 245, 243, 145, 255,
    246, 241, 145, 255, 219, 213, 120, 255, 114, 128, 62,  255, 69,  101, 41,  255, 115, 141, 65,  255, 120, 147, 73,  255, 124, 159, 84,  255, 121,
    156, 91,  255, 117, 153, 95,  255, 116, 146, 82,  255, 99,  129, 53,  255, 127, 152, 62,  255, 171, 198, 84,  255, 173, 201, 87,  255, 171, 200,
    100, 255, 198, 213, 126, 255, 186, 197, 121, 255, 153, 174, 110, 255, 146, 171, 114, 255, 167, 182, 121, 255, 193, 207, 109, 255, 161, 192, 104,
    255, 178, 202, 103, 255, 204, 214, 112, 255, 150, 177, 114, 255, 128, 170, 104, 255, 132, 170, 95,  255, 124, 165, 76,  255, 121, 162, 74,  255,
    129, 168, 74,  255, 175, 197, 80,  255, 194, 203, 99,  255, 197, 210, 111, 255, 191, 206, 113, 255, 191, 208, 117, 255, 97,  120, 58,  255, 31,
    44,  25,  255, 26,  40,  26,  255, 69,  107, 40,  255, 71,  109, 33,  255, 78,  112, 44,  255, 101, 135, 52,  255, 141, 173, 67,  255, 146, 174,
    74,  255, 156, 181, 90,  255, 165, 189, 99,  255, 165, 177, 89,  255, 53,  65,  33,  255, 58,  90,  47,  255, 67,  87,  39,  255, 55,  76,  26,
    255, 60,  89,  28,  255, 80,  108, 50,  255, 126, 150, 84,  255, 71,  103, 42,  255, 40,  58,  26,  255, 40,  63,  28,  255, 38,  63,  28,  255,
    36,  58,  26,  255, 51,  79,  38,  255, 75,  106, 47,  255, 107, 137, 55,  255, 94,  130, 47,  255, 115, 149, 68,  255, 111, 146, 60,  255, 105,
    139, 55,  255, 73,  103, 33,  255, 64,  105, 32,  255, 107, 125, 60,  255, 121, 138, 63,  255, 136, 157, 55,  255, 167, 185, 74,  255, 180, 197,
    99,  255, 188, 205, 109, 255, 173, 189, 86,  255, 154, 173, 78,  255, 122, 147, 62,  255, 94,  123, 55,  255, 74,  104, 41,  255, 97,  121, 47,
    255, 131, 155, 71,  255, 133, 160, 74,  255, 153, 172, 98,  255, 144, 167, 122, 255, 129, 162, 122, 255, 131, 148, 95,  255, 121, 145, 79,  255,
    148, 179, 94,  255, 161, 188, 78,  255, 141, 168, 87,  255, 122, 146, 82,  255, 112, 132, 67,  255, 78,  105, 55,  255, 126, 147, 74,  255, 116,
    147, 90,  255, 108, 143, 83,  255, 43,  68,  31,  255, 47,  68,  31,  255, 116, 133, 68,  255, 114, 143, 67,  255, 120, 149, 65,  255, 118, 150,
    62,  255, 108, 144, 67,  255, 89,  132, 45,  255, 87,  136, 36,  255, 111, 153, 48,  255, 135, 165, 62,  255, 128, 158, 60,  255, 160, 179, 75,
    255, 179, 190, 97,  255, 83,  108, 55,  255, 44,  62,  32,  255, 12,  12,  12,  255, 17,  23,  21,  255, 37,  39,  31,  255, 41,  42,  31,  255,
    29,  31,  26,  255, 36,  36,  32,  255, 32,  37,  29,  255, 26,  39,  25,  255, 32,  46,  29,  255, 31,  44,  26,  255, 29,  40,  26,  255, 23,
    32,  23,  255, 40,  49,  31,  255, 65,  87,  39,  255, 55,  87,  33,  255, 49,  73,  37,  255, 62,  87,  37,  255, 72,  106, 33,  255, 58,  91,
    31,  255, 62,  95,  36,  255, 62,  84,  39,  255, 74,  94,  47,  255, 75,  113, 32,  255, 71,  107, 26,  255, 55,  84,  25,  255, 44,  75,  21,
    255, 55,  89,  29,  255, 95,  131, 62,  255, 155, 181, 95,  255, 160, 171, 81,  255, 84,  106, 56,  255, 105, 130, 67,  255, 131, 146, 69,  255,
    126, 139, 68,  255, 97,  125, 55,  255, 127, 147, 71,  255, 168, 181, 91,  255, 179, 181, 87,  255, 179, 181, 95,  255, 197, 199, 116, 255, 241,
    232, 130, 255, 241, 235, 141, 255, 141, 171, 106, 255, 115, 149, 106, 255, 114, 140, 79,  255, 80,  102, 56,  255, 82,  109, 75,  255, 104, 131,
    93,  255, 121, 147, 93,  255, 183, 204, 114, 255, 178, 199, 112, 255, 174, 198, 111, 255, 186, 208, 113, 255, 131, 142, 68,  255, 42,  62,  26,
    255, 50,  73,  34,  255, 65,  86,  47,  255, 94,  120, 58,  255, 95,  127, 55,  255, 83,  116, 43,  255, 101, 119, 49,  255, 88,  110, 52,  255,
    167, 182, 80,  255, 202, 208, 86,  255, 223, 219, 93,  255, 230, 223, 94,  255, 243, 230, 100, 255, 241, 230, 106, 255, 181, 206, 121, 255, 154,
    190, 124, 255, 138, 176, 109, 255, 121, 162, 87,  255, 99,  141, 56,  255, 109, 134, 43,  255, 118, 132, 39,  255, 177, 177, 91,  255, 238, 238,
    142, 255, 195, 210, 111, 255, 174, 196, 101, 255, 153, 181, 91,  255, 136, 170, 75,  255, 149, 178, 67,  255, 144, 177, 65,  255, 166, 188, 67,
    255, 188, 202, 65,  255, 159, 179, 60,  255, 97,  125, 39,  255, 80,  104, 31,  255, 121, 147, 67,  255, 97,  125, 56,  255, 102, 133, 55,  255,
    120, 145, 60,  255, 56,  76,  29,  255, 47,  75,  29,  255, 58,  84,  31,  255, 81,  99,  36,  255, 117, 133, 47,  255, 136, 154, 53,  255, 132,
    153, 55,  255, 132, 152, 60,  255, 132, 149, 75,  255, 119, 137, 67,  255, 93,  120, 38,  255, 97,  121, 32,  255, 159, 173, 73,  255, 194, 208,
    115, 255, 189, 209, 135, 255, 193, 210, 136, 255, 191, 209, 135, 255, 194, 208, 120, 255, 168, 186, 93,  255, 152, 170, 81,  255, 148, 172, 86,
    255, 152, 172, 63,  255, 202, 206, 94,  255, 157, 177, 82,  255, 138, 162, 79,  255, 138, 159, 82,  255, 142, 150, 72,  255, 86,  102, 44,  255,
    31,  42,  17,  255, 38,  55,  23,  255, 55,  73,  28,  255, 65,  80,  33,  255, 44,  60,  25,  255, 78,  86,  40,  255, 163, 164, 85,  255, 208,
    206, 111, 255, 204, 202, 105, 255, 209, 207, 114, 255, 233, 231, 142, 255, 255, 250, 156, 255, 255, 249, 152, 255, 241, 238, 141, 255, 231, 233,
    130, 255, 222, 230, 110, 255, 210, 219, 92,  255, 224, 225, 108, 255, 234, 238, 92,  255, 234, 236, 108, 255, 243, 243, 124, 255, 246, 243, 132,
    255, 233, 225, 127, 255, 197, 188, 100, 255, 158, 166, 79,  255, 80,  104, 48,  255, 62,  95,  44,  255, 87,  119, 48,  255, 68,  84,  34,  255,
    125, 145, 87,  255, 154, 178, 104, 255, 159, 182, 102, 255, 166, 189, 104, 255, 153, 178, 91,  255, 145, 173, 71,  255, 112, 138, 52,  255, 151,
    169, 80,  255, 155, 176, 103, 255, 170, 189, 114, 255, 143, 167, 105, 255, 133, 163, 111, 255, 123, 161, 110, 255, 126, 162, 112, 255, 128, 161,
    114, 255, 178, 188, 121, 255, 204, 218, 144, 255, 234, 233, 143, 255, 186, 194, 112, 255, 137, 174, 117, 255, 136, 174, 118, 255, 128, 166, 86,
    255, 131, 169, 81,  255, 143, 180, 84,  255, 158, 184, 84,  255, 156, 177, 86,  255, 175, 190, 99,  255, 210, 212, 110, 255, 227, 226, 121, 255,
    195, 210, 117, 255, 134, 155, 79,  255, 32,  49,  23,  255, 63,  92,  52,  255, 77,  116, 47,  255, 53,  91,  28,  255, 87,  125, 47,  255, 124,
    158, 60,  255, 143, 173, 68,  255, 155, 180, 83,  255, 161, 186, 91,  255, 178, 197, 99,  255, 107, 115, 58,  255, 67,  101, 53,  255, 83,  119,
    62,  255, 72,  107, 55,  255, 44,  72,  33,  255, 48,  81,  34,  255, 94,  122, 60,  255, 101, 123, 58,  255, 67,  104, 39,  255, 63,  98,  29,
    255, 74,  109, 34,  255, 77,  113, 33,  255, 55,  79,  31,  255, 47,  75,  33,  255, 55,  92,  39,  255, 76,  104, 58,  255, 92,  117, 53,  255,
    86,  115, 43,  255, 113, 149, 56,  255, 103, 132, 49,  255, 60,  87,  29,  255, 99,  124, 56,  255, 111, 138, 65,  255, 128, 154, 76,  255, 100,
    126, 56,  255, 111, 133, 49,  255, 152, 172, 81,  255, 195, 210, 112, 255, 124, 140, 52,  255, 105, 130, 53,  255, 92,  120, 60,  255, 87,  111,
    65,  255, 77,  104, 60,  255, 65,  92,  47,  255, 68,  92,  40,  255, 91,  116, 47,  255, 148, 170, 111, 255, 137, 167, 127, 255, 137, 159, 98,
    255, 165, 183, 126, 255, 152, 181, 125, 255, 139, 171, 95,  255, 141, 174, 74,  255, 193, 208, 96,  255, 156, 169, 74,  255, 106, 137, 53,  255,
    129, 162, 76,  255, 131, 151, 75,  255, 91,  112, 67,  255, 95,  129, 65,  255, 58,  84,  36,  255, 34,  58,  23,  255, 48,  69,  29,  255, 96,
    125, 58,  255, 110, 139, 67,  255, 84,  112, 43,  255, 126, 150, 62,  255, 129, 154, 68,  255, 116, 152, 58,  255, 119, 158, 52,  255, 153, 186,
    69,  255, 162, 182, 78,  255, 97,  117, 52,  255, 69,  92,  52,  255, 71,  99,  55,  255, 47,  58,  40,  255, 41,  47,  52,  255, 15,  19,  19,
    255, 28,  33,  26,  255, 21,  26,  21,  255, 26,  28,  25,  255, 37,  37,  31,  255, 36,  39,  31,  255, 23,  29,  23,  255, 26,  40,  26,  255,
    26,  39,  26,  255, 23,  33,  26,  255, 21,  26,  25,  255, 31,  38,  26,  255, 68,  87,  42,  255, 65,  92,  43,  255, 65,  87,  49,  255, 72,
    98,  50,  255, 89,  111, 47,  255, 42,  56,  26,  255, 38,  58,  31,  255, 52,  68,  38,  255, 78,  95,  52,  255, 73,  98,  41,  255, 122, 149,
    42,  255, 140, 164, 43,  255, 137, 163, 40,  255, 140, 165, 50,  255, 146, 168, 65,  255, 173, 190, 84,  255, 190, 199, 100, 255, 102, 121, 67,
    255, 99,  123, 74,  255, 136, 150, 76,  255, 151, 161, 76,  255, 112, 132, 67,  255, 83,  109, 45,  255, 49,  60,  36,  255, 52,  48,  38,  255,
    38,  40,  26,  255, 81,  84,  50,  255, 135, 139, 83,  255, 197, 206, 119, 255, 162, 185, 109, 255, 121, 151, 103, 255, 100, 126, 60,  255, 91,
    110, 58,  255, 104, 124, 75,  255, 101, 122, 72,  255, 138, 159, 89,  255, 183, 204, 113, 255, 178, 199, 112, 255, 171, 196, 111, 255, 171, 197,
    113, 255, 180, 199, 104, 255, 73,  95,  34,  255, 55,  87,  44,  255, 74,  102, 53,  255, 105, 128, 68,  255, 75,  106, 52,  255, 99,  128, 58,
    255, 99,  126, 55,  255, 73,  103, 38,  255, 176, 189, 73,  255, 211, 216, 91,  255, 223, 218, 105, 255, 241, 228, 105, 255, 214, 206, 94,  255,
    116, 128, 47,  255, 129, 145, 68,  255, 131, 144, 74,  255, 126, 146, 65,  255, 135, 160, 68,  255, 113, 143, 55,  255, 107, 128, 48,  255, 127,
    138, 55,  255, 204, 203, 120, 255, 219, 220, 131, 255, 214, 219, 113, 255, 219, 223, 96,  255, 202, 214, 87,  255, 199, 210, 86,  255, 216, 218,
    81,  255, 203, 209, 78,  255, 194, 200, 74,  255, 168, 185, 60,  255, 139, 163, 55,  255, 67,  94,  31,  255, 41,  58,  21,  255, 93,  106, 47,
    255, 87,  116, 44,  255, 101, 126, 47,  255, 74,  96,  38,  255, 19,  31,  15,  255, 33,  46,  19,  255, 63,  92,  34,  255, 69,  100, 39,  255,
    79,  105, 42,  255, 82,  106, 38,  255, 75,  103, 31,  255, 77,  99,  36,  255, 118, 133, 65,  255, 106, 128, 55,  255, 81,  108, 23,  255, 135,
    148, 58,  255, 215, 227, 152, 255, 181, 207, 139, 255, 171, 198, 124, 255, 171, 196, 120, 255, 169, 196, 116, 255, 163, 193, 114, 255, 182, 202,
    102, 255, 175, 186, 90,  255, 138, 168, 79,  255, 124, 161, 56,  255, 181, 191, 82,  255, 176, 192, 100, 255, 201, 207, 120, 255, 216, 219, 124,
    255, 212, 216, 128, 255, 187, 195, 115, 255, 133, 146, 81,  255, 52,  72,  29,  255, 34,  58,  23,  255, 34,  53,  26,  255, 103, 112, 55,  255,
    206, 201, 104, 255, 224, 217, 117, 255, 220, 212, 117, 255, 215, 208, 113, 255, 243, 235, 143, 255, 255, 249, 154, 255, 250, 243, 150, 255, 245,
    238, 144, 255, 243, 241, 131, 255, 249, 249, 125, 255, 230, 231, 106, 255, 204, 210, 98,  255, 214, 214, 110, 255, 241, 236, 116, 255, 246, 245,
    120, 255, 255, 254, 138, 255, 198, 190, 83,  255, 74,  76,  32,  255, 52,  73,  23,  255, 77,  106, 43,  255, 72,  105, 58,  255, 77,  109, 53,
    255, 69,  92,  32,  255, 40,  55,  19,  255, 132, 158, 96,  255, 143, 171, 108, 255, 176, 197, 118, 255, 163, 190, 114, 255, 145, 178, 106, 255,
    136, 170, 98,  255, 125, 158, 77,  255, 120, 142, 60,  255, 147, 168, 71,  255, 168, 182, 91,  255, 130, 162, 98,  255, 121, 156, 94,  255, 124,
    157, 97,  255, 123, 156, 101, 255, 125, 159, 96,  255, 127, 156, 89,  255, 202, 206, 123, 255, 187, 194, 106, 255, 142, 166, 99,  255, 151, 176,
    138, 255, 145, 172, 115, 255, 142, 176, 89,  255, 161, 186, 84,  255, 168, 187, 84,  255, 137, 162, 75,  255, 125, 158, 80,  255, 136, 169, 87,
    255, 189, 205, 107, 255, 241, 235, 135, 255, 216, 223, 131, 255, 132, 150, 87,  255, 36,  55,  25,  255, 97,  133, 75,  255, 74,  112, 52,  255,
    90,  129, 50,  255, 146, 178, 71,  255, 185, 205, 93,  255, 191, 206, 104, 255, 161, 184, 87,  255, 149, 168, 78,  255, 104, 111, 53,  255, 81,
    110, 56,  255, 109, 148, 74,  255, 113, 145, 74,  255, 106, 139, 74,  255, 79,  119, 55,  255, 109, 141, 65,  255, 131, 157, 76,  255, 69,  100,
    38,  255, 71,  109, 36,  255, 89,  118, 38,  255, 106, 130, 48,  255, 99,  131, 45,  255, 80,  101, 37,  255, 42,  62,  31,  255, 68,  104, 52,
    255, 74,  104, 60,  255, 69,  100, 58,  255, 41,  52,  31,  255, 71,  97,  33,  255, 78,  103, 38,  255, 80,  104, 41,  255, 99,  132, 55,  255,
    95,  130, 47,  255, 150, 170, 69,  255, 113, 140, 63,  255, 79,  108, 49,  255, 145, 170, 90,  255, 192, 209, 93,  255, 143, 162, 62,  255, 124,
    148, 55,  255, 106, 134, 58,  255, 99,  128, 68,  255, 88,  116, 72,  255, 77,  105, 71,  255, 76,  106, 65,  255, 81,  110, 65,  255, 156, 180,
    130, 255, 123, 147, 99,  255, 156, 171, 62,  255, 204, 215, 101, 255, 170, 194, 152, 255, 151, 181, 133, 255, 116, 158, 78,  255, 163, 188, 95,
    255, 133, 147, 49,  255, 92,  127, 62,  255, 134, 167, 98,  255, 127, 153, 68,  255, 111, 134, 58,  255, 100, 134, 49,  255, 80,  112, 47,  255,
    63,  87,  37,  255, 82,  111, 45,  255, 83,  117, 52,  255, 107, 136, 62,  255, 90,  117, 55,  255, 82,  110, 47,  255, 80,  108, 41,  255, 121,
    145, 63,  255, 177, 196, 92,  255, 173, 189, 99,  255, 152, 172, 102, 255, 78,  100, 50,  255, 60,  90,  47,  255, 63,  87,  47,  255, 55,  62,
    52,  255, 55,  65,  68,  255, 17,  19,  17,  255, 25,  28,  23,  255, 21,  25,  21,  255, 21,  25,  23,  255, 34,  36,  31,  255, 42,  47,  33,
    255, 19,  26,  21,  255, 40,  44,  31,  255, 69,  84,  38,  255, 60,  75,  36,  255, 36,  40,  26,  255, 23,  25,  23,  255, 65,  83,  43,  255,
    63,  84,  47,  255, 76,  97,  58,  255, 89,  114, 60,  255, 99,  122, 55,  255, 41,  60,  29,  255, 33,  51,  31,  255, 36,  52,  33,  255, 69,
    87,  50,  255, 43,  60,  39,  255, 62,  80,  40,  255, 148, 166, 62,  255, 179, 191, 68,  255, 184, 199, 68,  255, 197, 211, 79,  255, 199, 211,
    91,  255, 206, 218, 107, 255, 121, 135, 69,  255, 86,  110, 69,  255, 124, 142, 80,  255, 151, 160, 77,  255, 52,  60,  28,  255, 62,  84,  34,
    255, 55,  55,  44,  255, 107, 113, 65,  255, 146, 163, 81,  255, 165, 184, 91,  255, 171, 188, 99,  255, 181, 195, 100, 255, 168, 186, 90,  255,
    133, 157, 84,  255, 115, 140, 60,  255, 127, 155, 62,  255, 97,  116, 45,  255, 56,  69,  31,  255, 140, 156, 86,  255, 188, 210, 118, 255, 177,
    199, 112, 255, 157, 184, 110, 255, 163, 189, 114, 255, 186, 205, 110, 255, 106, 130, 48,  255, 68,  98,  37,  255, 101, 125, 63,  255, 99,  131,
    65,  255, 99,  133, 65,  255, 112, 143, 68,  255, 88,  111, 50,  255, 63,  86,  37,  255, 141, 158, 55,  255, 144, 147, 41,  255, 181, 190, 60,
    255, 128, 141, 40,  255, 75,  95,  26,  255, 47,  76,  21,  255, 52,  80,  21,  255, 52,  79,  25,  255, 71,  99,  42,  255, 72,  99,  47,  255,
    75,  104, 47,  255, 75,  99,  43,  255, 110, 121, 55,  255, 148, 158, 65,  255, 149, 173, 103, 255, 144, 162, 102, 255, 155, 170, 103, 255, 153,
    165, 100, 255, 153, 160, 83,  255, 160, 169, 65,  255, 152, 169, 65,  255, 132, 153, 55,  255, 102, 128, 37,  255, 89,  120, 33,  255, 55,  87,
    25,  255, 58,  84,  31,  255, 65,  98,  31,  255, 63,  87,  28,  255, 60,  83,  34,  255, 38,  68,  23,  255, 40,  73,  21,  255, 60,  89,  26,
    255, 74,  103, 39,  255, 83,  108, 52,  255, 92,  115, 60,  255, 110, 132, 68,  255, 84,  99,  47,  255, 55,  63,  26,  255, 82,  90,  36,  255,
    85,  106, 38,  255, 78,  103, 23,  255, 187, 193, 111, 255, 204, 224, 167, 255, 186, 212, 153, 255, 180, 206, 138, 255, 178, 203, 116, 255, 182,
    204, 103, 255, 200, 215, 99,  255, 183, 193, 89,  255, 114, 136, 63,  255, 152, 181, 83,  255, 140, 172, 65,  255, 196, 206, 112, 255, 181, 197,
    130, 255, 159, 183, 123, 255, 151, 177, 121, 255, 150, 177, 126, 255, 148, 175, 119, 255, 183, 199, 125, 255, 158, 176, 89,  255, 49,  83,  26,
    255, 83,  103, 49,  255, 193, 197, 101, 255, 211, 205, 112, 255, 216, 212, 123, 255, 221, 213, 124, 255, 230, 223, 136, 255, 255, 248, 158, 255,
    251, 245, 151, 255, 249, 243, 144, 255, 255, 253, 137, 255, 246, 239, 121, 255, 183, 178, 82,  255, 107, 117, 43,  255, 153, 162, 68,  255, 187,
    198, 91,  255, 171, 174, 74,  255, 220, 213, 108, 255, 254, 250, 144, 255, 118, 124, 58,  255, 36,  60,  23,  255, 48,  74,  34,  255, 86,  106,
    50,  255, 152, 167, 92,  255, 167, 180, 101, 255, 125, 138, 75,  255, 74,  94,  47,  255, 111, 128, 58,  255, 194, 211, 131, 255, 157, 188, 126,
    255, 145, 180, 125, 255, 142, 176, 123, 255, 130, 169, 102, 255, 131, 171, 84,  255, 146, 167, 78,  255, 120, 135, 62,  255, 103, 119, 47,  255,
    156, 166, 75,  255, 171, 187, 95,  255, 158, 182, 95,  255, 146, 172, 97,  255, 139, 169, 84,  255, 107, 144, 60,  255, 120, 150, 55,  255, 126,
    154, 49,  255, 159, 172, 98,  255, 179, 188, 139, 255, 163, 177, 89,  255, 157, 172, 71,  255, 163, 185, 84,  255, 128, 162, 79,  255, 115, 153,
    68,  255, 121, 158, 77,  255, 136, 172, 97,  255, 196, 207, 116, 255, 250, 241, 142, 255, 235, 231, 143, 255, 132, 157, 98,  255, 81,  114, 60,
    255, 115, 151, 78,  255, 111, 146, 65,  255, 117, 156, 68,  255, 133, 166, 80,  255, 145, 179, 100, 255, 182, 204, 118, 255, 182, 193, 99,  255,
    67,  79,  31,  255, 91,  115, 58,  255, 157, 188, 94,  255, 171, 196, 96,  255, 188, 208, 110, 255, 189, 209, 115, 255, 164, 188, 103, 255, 142,
    173, 85,  255, 163, 185, 91,  255, 110, 142, 62,  255, 83,  112, 37,  255, 105, 125, 41,  255, 134, 151, 55,  255, 145, 165, 77,  255, 108, 125,
    60,  255, 29,  39,  23,  255, 69,  100, 55,  255, 86,  122, 71,  255, 65,  92,  48,  255, 23,  34,  23,  255, 68,  92,  46,  255, 107, 135, 55,
    255, 114, 153, 53,  255, 128, 166, 71,  255, 139, 171, 76,  255, 157, 179, 74,  255, 154, 172, 68,  255, 108, 136, 62,  255, 172, 191, 129, 255,
    189, 205, 101, 255, 150, 169, 72,  255, 129, 150, 55,  255, 131, 152, 58,  255, 132, 152, 62,  255, 133, 154, 74,  255, 127, 152, 76,  255, 132,
    159, 74,  255, 138, 162, 85,  255, 133, 148, 93,  255, 94,  124, 68,  255, 164, 186, 87,  255, 224, 226, 87,  255, 158, 184, 94,  255, 147, 178,
    103, 255, 126, 166, 93,  255, 160, 187, 96,  255, 128, 139, 52,  255, 118, 151, 81,  255, 145, 176, 107, 255, 150, 179, 99,  255, 149, 176, 87,
    255, 131, 160, 74,  255, 79,  114, 42,  255, 91,  122, 52,  255, 87,  119, 52,  255, 83,  116, 50,  255, 104, 137, 62,  255, 80,  118, 58,  255,
    90,  122, 55,  255, 86,  115, 47,  255, 103, 125, 55,  255, 151, 169, 75,  255, 168, 178, 80,  255, 114, 128, 58,  255, 43,  67,  31,  255, 60,
    87,  42,  255, 42,  55,  32,  255, 17,  19,  19,  255, 55,  58,  48,  255, 33,  36,  31,  255, 29,  31,  25,  255, 29,  32,  26,  255, 29,  31,
    28,  255, 31,  31,  29,  255, 39,  42,  31,  255, 52,  52,  29,  255, 144, 157, 69,  255, 149, 171, 73,  255, 135, 160, 60,  255, 116, 140, 53,
    255, 44,  53,  26,  255, 49,  60,  37,  255, 84,  107, 58,  255, 120, 144, 75,  255, 117, 138, 68,  255, 60,  81,  36,  255, 36,  56,  31,  255,
    36,  52,  34,  255, 37,  52,  36,  255, 65,  82,  47,  255, 47,  55,  40,  255, 57,  84,  43,  255, 66,  96,  43,  255, 75,  103, 47,  255, 73,
    90,  40,  255, 86,  96,  48,  255, 119, 138, 62,  255, 130, 145, 68,  255, 105, 124, 68,  255, 86,  110, 73,  255, 117, 137, 78,  255, 143, 153,
    76,  255, 49,  58,  26,  255, 73,  94,  38,  255, 130, 141, 74,  255, 171, 191, 96,  255, 159, 182, 87,  255, 154, 178, 90,  255, 161, 180, 98,
    255, 180, 196, 101, 255, 157, 178, 81,  255, 107, 141, 55,  255, 119, 150, 60,  255, 141, 168, 75,  255, 164, 184, 89,  255, 144, 161, 71,  255,
    151, 171, 84,  255, 186, 208, 115, 255, 177, 200, 117, 255, 169, 191, 110, 255, 181, 203, 107, 255, 183, 202, 107, 255, 69,  89,  36,  255, 91,
    120, 58,  255, 119, 144, 68,  255, 106, 138, 62,  255, 92,  119, 52,  255, 65,  84,  39,  255, 41,  55,  32,  255, 47,  58,  34,  255, 60,  74,
    37,  255, 47,  62,  23,  255, 69,  84,  28,  255, 48,  76,  25,  255, 43,  69,  21,  255, 49,  76,  23,  255, 63,  92,  32,  255, 77,  112, 49,
    255, 68,  95,  44,  255, 67,  95,  46,  255, 69,  97,  55,  255, 55,  84,  44,  255, 43,  75,  26,  255, 69,  90,  25,  255, 165, 177, 91,  255,
    136, 175, 110, 255, 99,  141, 90,  255, 99,  138, 89,  255, 96,  132, 89,  255, 92,  128, 72,  255, 101, 133, 58,  255, 109, 140, 68,  255, 92,
    126, 40,  255, 100, 134, 32,  255, 65,  101, 26,  255, 95,  108, 43,  255, 112, 142, 53,  255, 77,  114, 44,  255, 65,  89,  42,  255, 48,  74,
    26,  255, 47,  75,  23,  255, 62,  92,  28,  255, 60,  87,  38,  255, 99,  119, 60,  255, 144, 168, 77,  255, 123, 143, 68,  255, 53,  68,  33,
    255, 32,  47,  21,  255, 34,  46,  19,  255, 39,  49,  12,  255, 122, 130, 62,  255, 225, 234, 178, 255, 203, 222, 165, 255, 202, 219, 143, 255,
    198, 213, 121, 255, 203, 215, 116, 255, 182, 194, 108, 255, 175, 184, 80,  255, 137, 160, 62,  255, 92,  124, 55,  255, 152, 172, 82,  255, 172,
    192, 86,  255, 149, 178, 98,  255, 143, 174, 102, 255, 143, 173, 105, 255, 144, 174, 108, 255, 139, 172, 101, 255, 142, 175, 101, 255, 155, 184,
    106, 255, 204, 215, 130, 255, 125, 142, 68,  255, 148, 166, 62,  255, 214, 214, 97,  255, 223, 216, 97,  255, 222, 214, 106, 255, 218, 210, 117,
    255, 245, 235, 150, 255, 254, 246, 152, 255, 246, 239, 135, 255, 245, 234, 128, 255, 154, 142, 75,  255, 73,  68,  32,  255, 29,  41,  12,  255,
    84,  103, 40,  255, 175, 176, 84,  255, 172, 176, 79,  255, 151, 160, 71,  255, 179, 176, 86,  255, 206, 200, 109, 255, 133, 141, 80,  255, 53,
    68,  28,  255, 150, 163, 83,  255, 223, 219, 118, 255, 241, 228, 119, 255, 238, 225, 117, 255, 238, 228, 125, 255, 227, 222, 120, 255, 201, 209,
    124, 255, 168, 196, 135, 255, 158, 190, 134, 255, 154, 185, 128, 255, 147, 179, 110, 255, 150, 182, 103, 255, 176, 200, 100, 255, 159, 181, 74,
    255, 99,  124, 56,  255, 99,  136, 60,  255, 94,  121, 41,  255, 123, 134, 41,  255, 162, 172, 65,  255, 156, 168, 65,  255, 136, 155, 65,  255,
    92,  127, 67,  255, 86,  122, 58,  255, 86,  122, 52,  255, 97,  125, 55,  255, 121, 139, 56,  255, 104, 124, 42,  255, 95,  119, 31,  255, 151,
    168, 67,  255, 178, 198, 94,  255, 171, 197, 97,  255, 133, 169, 100, 255, 166, 193, 110, 255, 191, 208, 126, 255, 214, 220, 144, 255, 223, 218,
    136, 255, 109, 133, 65,  255, 104, 139, 68,  255, 102, 139, 60,  255, 104, 144, 60,  255, 105, 146, 65,  255, 115, 154, 77,  255, 128, 170, 96,
    255, 152, 186, 114, 255, 191, 208, 120, 255, 179, 200, 84,  255, 177, 202, 86,  255, 175, 199, 97,  255, 174, 199, 100, 255, 186, 207, 110, 255,
    196, 215, 121, 255, 206, 219, 124, 255, 167, 191, 91,  255, 117, 155, 60,  255, 159, 185, 105, 255, 104, 124, 67,  255, 52,  67,  26,  255, 103,
    120, 43,  255, 155, 163, 84,  255, 99,  108, 58,  255, 31,  42,  31,  255, 52,  75,  37,  255, 93,  126, 62,  255, 49,  67,  34,  255, 62,  90,
    41,  255, 86,  112, 53,  255, 107, 141, 52,  255, 147, 180, 62,  255, 152, 180, 80,  255, 157, 185, 90,  255, 162, 188, 92,  255, 164, 179, 77,
    255, 143, 162, 71,  255, 187, 204, 137, 255, 185, 201, 104, 255, 141, 163, 87,  255, 141, 167, 100, 255, 154, 179, 109, 255, 148, 167, 98,  255,
    141, 157, 62,  255, 134, 154, 63,  255, 107, 121, 52,  255, 95,  114, 49,  255, 111, 135, 52,  255, 160, 184, 75,  255, 138, 153, 55,  255, 204,
    206, 84,  255, 172, 198, 87,  255, 141, 177, 91,  255, 137, 173, 104, 255, 192, 208, 110, 255, 136, 154, 62,  255, 109, 139, 55,  255, 133, 163,
    75,  255, 136, 166, 80,  255, 148, 176, 82,  255, 120, 148, 68,  255, 92,  125, 53,  255, 74,  107, 37,  255, 83,  117, 53,  255, 83,  117, 53,
    255, 92,  124, 55,  255, 84,  119, 53,  255, 92,  123, 56,  255, 87,  118, 60,  255, 68,  97,  43,  255, 142, 154, 65,  255, 160, 177, 79,  255,
    200, 202, 103, 255, 115, 125, 55,  255, 41,  62,  23,  255, 32,  39,  26,  255, 12,  15,  17,  255, 68,  80,  63,  255, 37,  48,  34,  255, 26,
    31,  26,  255, 26,  28,  25,  255, 29,  31,  25,  255, 32,  42,  25,  255, 25,  40,  23,  255, 134, 136, 68,  255, 184, 196, 87,  255, 157, 177,
    76,  255, 128, 156, 58,  255, 113, 146, 56,  255, 97,  126, 45,  255, 58,  73,  33,  255, 69,  84,  44,  255, 60,  73,  41,  255, 53,  69,  39,
    255, 36,  58,  28,  255, 39,  58,  33,  255, 39,  55,  39,  255, 36,  55,  39,  255, 55,  72,  42,  255, 67,  87,  43,  255, 75,  104, 50,  255,
    75,  104, 46,  255, 65,  98,  37,  255, 58,  83,  28,  255, 38,  47,  21,  255, 49,  68,  28,  255, 43,  62,  25,  255, 68,  84,  52,  255, 90,
    112, 74,  255, 127, 145, 83,  255, 130, 141, 72,  255, 50,  71,  32,  255, 110, 136, 62,  255, 175, 194, 98,  255, 163, 183, 91,  255, 143, 164,
    87,  255, 137, 160, 95,  255, 145, 170, 92,  255, 152, 178, 90,  255, 145, 166, 76,  255, 91,  125, 41,  255, 90,  131, 38,  255, 106, 142, 43,
    255, 136, 169, 68,  255, 145, 169, 73,  255, 145, 169, 76,  255, 170, 197, 114, 255, 175, 198, 122, 255, 174, 196, 86,  255, 193, 211, 112, 255,
    174, 192, 100, 255, 41,  49,  23,  255, 71,  86,  47,  255, 33,  44,  25,  255, 26,  33,  26,  255, 19,  23,  19,  255, 28,  38,  29,  255, 37,
    48,  32,  255, 34,  42,  29,  255, 34,  44,  25,  255, 60,  82,  33,  255, 34,  52,  19,  255, 46,  71,  21,  255, 41,  67,  17,  255, 58,  87,
    32,  255, 69,  101, 50,  255, 60,  90,  41,  255, 57,  84,  39,  255, 53,  81,  39,  255, 53,  86,  33,  255, 62,  99,  32,  255, 63,  92,  32,
    255, 40,  58,  26,  255, 58,  56,  19,  255, 165, 164, 76,  255, 156, 188, 114, 255, 111, 152, 101, 255, 108, 146, 93,  255, 104, 142, 86,  255,
    92,  132, 71,  255, 89,  124, 60,  255, 125, 149, 55,  255, 115, 148, 47,  255, 78,  117, 36,  255, 71,  95,  36,  255, 96,  115, 52,  255, 98,
    123, 58,  255, 98,  128, 55,  255, 60,  89,  36,  255, 50,  67,  28,  255, 58,  82,  26,  255, 71,  104, 36,  255, 105, 132, 49,  255, 166, 193,
    65,  255, 155, 178, 63,  255, 48,  71,  26,  255, 34,  53,  17,  255, 60,  79,  41,  255, 81,  103, 58,  255, 179, 180, 111, 255, 211, 222, 155,
    255, 195, 207, 135, 255, 178, 194, 120, 255, 162, 185, 121, 255, 147, 178, 112, 255, 133, 170, 100, 255, 138, 168, 87,  255, 151, 170, 77,  255,
    112, 136, 58,  255, 143, 165, 69,  255, 148, 177, 75,  255, 148, 178, 75,  255, 140, 173, 68,  255, 149, 181, 72,  255, 164, 191, 77,  255, 174,
    193, 81,  255, 180, 190, 76,  255, 171, 179, 77,  255, 156, 168, 69,  255, 168, 184, 53,  255, 195, 205, 52,  255, 219, 216, 71,  255, 223, 216,
    71,  255, 225, 217, 68,  255, 219, 210, 86,  255, 223, 212, 99,  255, 227, 215, 92,  255, 231, 217, 96,  255, 144, 138, 60,  255, 26,  36,  17,
    255, 19,  29,  19,  255, 17,  26,  15,  255, 96,  101, 42,  255, 186, 185, 89,  255, 177, 179, 82,  255, 168, 181, 69,  255, 181, 190, 75,  255,
    193, 195, 92,  255, 190, 191, 105, 255, 191, 193, 95,  255, 228, 223, 112, 255, 233, 222, 119, 255, 232, 220, 111, 255, 224, 214, 104, 255, 223,
    215, 109, 255, 229, 221, 114, 255, 202, 216, 137, 255, 162, 195, 137, 255, 164, 196, 138, 255, 165, 196, 137, 255, 178, 205, 133, 255, 212, 224,
    122, 255, 187, 197, 94,  255, 148, 169, 82,  255, 87,  115, 68,  255, 112, 138, 67,  255, 96,  135, 50,  255, 77,  106, 40,  255, 93,  122, 41,
    255, 74,  103, 42,  255, 86,  114, 52,  255, 102, 137, 69,  255, 82,  117, 68,  255, 76,  112, 65,  255, 74,  108, 60,  255, 96,  132, 56,  255,
    73,  104, 41,  255, 55,  87,  36,  255, 58,  80,  31,  255, 111, 116, 43,  255, 171, 171, 75,  255, 186, 192, 107, 255, 230, 225, 131, 255, 248,
    238, 146, 255, 227, 233, 165, 255, 199, 207, 137, 255, 97,  129, 47,  255, 115, 151, 63,  255, 101, 140, 62,  255, 109, 147, 65,  255, 120, 158,
    72,  255, 127, 167, 83,  255, 133, 173, 94,  255, 143, 178, 107, 255, 170, 197, 126, 255, 165, 180, 77,  255, 156, 180, 48,  255, 174, 197, 58,
    255, 175, 197, 65,  255, 185, 207, 90,  255, 194, 213, 107, 255, 204, 218, 121, 255, 193, 210, 110, 255, 109, 149, 53,  255, 157, 182, 93,  255,
    148, 166, 94,  255, 63,  94,  48,  255, 68,  103, 55,  255, 90,  123, 68,  255, 75,  105, 49,  255, 41,  58,  29,  255, 37,  52,  26,  255, 67,
    92,  36,  255, 67,  92,  36,  255, 82,  111, 52,  255, 65,  95,  55,  255, 106, 138, 52,  255, 161, 187, 72,  255, 161, 186, 80,  255, 170, 193,
    94,  255, 165, 191, 99,  255, 167, 185, 90,  255, 166, 176, 80,  255, 195, 208, 120, 255, 171, 188, 87,  255, 179, 202, 109, 255, 196, 213, 118,
    255, 183, 202, 111, 255, 203, 208, 100, 255, 208, 210, 95,  255, 126, 155, 74,  255, 95,  128, 60,  255, 105, 137, 63,  255, 124, 158, 62,  255,
    172, 191, 67,  255, 186, 190, 68,  255, 141, 153, 56,  255, 195, 206, 99,  255, 143, 179, 98,  255, 154, 186, 131, 255, 202, 210, 117, 255, 169,
    190, 99,  255, 150, 173, 86,  255, 101, 132, 49,  255, 125, 152, 60,  255, 109, 135, 50,  255, 92,  124, 65,  255, 80,  113, 56,  255, 84,  117,
    52,  255, 79,  110, 50,  255, 96,  125, 52,  255, 92,  123, 50,  255, 78,  108, 52,  255, 80,  109, 56,  255, 71,  97,  47,  255, 67,  98,  36,
    255, 91,  116, 40,  255, 156, 165, 67,  255, 168, 180, 83,  255, 218, 210, 108, 255, 129, 135, 68,  255, 97,  102, 60,  255, 60,  60,  36,  255,
    31,  46,  21,  255, 37,  56,  28,  255, 36,  48,  28,  255, 26,  31,  23,  255, 55,  68,  37,  255, 145, 154, 107, 255, 73,  81,  48,  255, 172,
    172, 100, 255, 217, 218, 95,  255, 183, 192, 73,  255, 145, 164, 67,  255, 132, 152, 56,  255, 147, 164, 60,  255, 122, 139, 50,  255, 29,  36,
    23,  255, 12,  12,  21,  255, 40,  52,  34,  255, 42,  65,  32,  255, 40,  58,  34,  255, 43,  62,  43,  255, 52,  74,  48,  255, 52,  71,  41,
    255, 80,  105, 50,  255, 84,  114, 55,  255, 76,  104, 52,  255, 60,  87,  41,  255, 96,  122, 43,  255, 109, 136, 38,  255, 94,  116, 38,  255,
    80,  97,  37,  255, 60,  74,  40,  255, 92,  111, 68,  255, 129, 143, 79,  255, 89,  102, 45,  255, 65,  87,  36,  255, 119, 143, 65,  255, 163,
    184, 95,  255, 143, 167, 90,  255, 134, 158, 97,  255, 142, 166, 91,  255, 135, 160, 85,  255, 142, 166, 91,  255, 117, 140, 58,  255, 99,  132,
    37,  255, 108, 141, 42,  255, 115, 144, 63,  255, 127, 155, 77,  255, 139, 171, 84,  255, 147, 177, 84,  255, 161, 186, 108, 255, 174, 197, 101,
    255, 155, 191, 68,  255, 197, 218, 125, 255, 173, 194, 97,  255, 110, 131, 55,  255, 120, 139, 67,  255, 76,  81,  44,  255, 33,  33,  26,  255,
    12,  15,  17,  255, 21,  29,  25,  255, 40,  48,  32,  255, 37,  52,  26,  255, 81,  102, 40,  255, 91,  118, 47,  255, 58,  84,  26,  255, 65,
    97,  31,  255, 55,  87,  32,  255, 58,  86,  38,  255, 50,  79,  29,  255, 47,  79,  28,  255, 52,  86,  29,  255, 60,  97,  29,  255, 68,  105,
    32,  255, 48,  69,  26,  255, 32,  37,  21,  255, 36,  43,  23,  255, 19,  26,  19,  255, 47,  44,  15,  255, 169, 170, 74,  255, 175, 197, 111,
    255, 139, 175, 112, 255, 113, 153, 105, 255, 101, 140, 90,  255, 101, 134, 72,  255, 137, 161, 65,  255, 133, 163, 62,  255, 113, 149, 56,  255,
    75,  117, 47,  255, 99,  131, 52,  255, 116, 142, 58,  255, 84,  105, 52,  255, 80,  108, 52,  255, 75,  98,  44,  255, 65,  82,  31,  255, 88,
    108, 36,  255, 93,  107, 36,  255, 142, 167, 56,  255, 167, 199, 62,  255, 72,  90,  31,  255, 128, 141, 92,  255, 212, 221, 171, 255, 220, 231,
    177, 255, 221, 227, 153, 255, 175, 198, 133, 255, 152, 184, 121, 255, 148, 179, 109, 255, 156, 184, 108, 255, 157, 182, 100, 255, 146, 166, 89,
    255, 121, 140, 58,  255, 114, 136, 46,  255, 102, 125, 44,  255, 131, 148, 67,  255, 157, 173, 90,  255, 167, 182, 78,  255, 165, 182, 86,  255,
    198, 204, 100, 255, 181, 184, 78,  255, 113, 130, 44,  255, 91,  113, 37,  255, 119, 141, 41,  255, 155, 176, 48,  255, 190, 201, 60,  255, 208,
    209, 65,  255, 215, 212, 60,  255, 223, 215, 65,  255, 230, 220, 77,  255, 225, 216, 82,  255, 220, 211, 77,  255, 213, 197, 81,  255, 118, 113,
    47,  255, 31,  47,  15,  255, 31,  48,  21,  255, 34,  52,  21,  255, 23,  37,  15,  255, 102, 106, 42,  255, 190, 190, 89,  255, 194, 202, 82,
    255, 197, 211, 76,  255, 191, 208, 76,  255, 193, 207, 80,  255, 211, 212, 97,  255, 221, 216, 104, 255, 219, 213, 107, 255, 231, 221, 123, 255,
    229, 218, 115, 255, 226, 216, 113, 255, 228, 217, 107, 255, 230, 224, 119, 255, 187, 213, 149, 255, 185, 214, 159, 255, 193, 214, 148, 255, 208,
    219, 137, 255, 199, 207, 119, 255, 168, 180, 89,  255, 169, 184, 91,  255, 112, 139, 83,  255, 86,  123, 82,  255, 95,  125, 71,  255, 107, 134,
    58,  255, 96,  125, 63,  255, 94,  126, 60,  255, 65,  94,  56,  255, 75,  103, 55,  255, 122, 157, 75,  255, 91,  128, 74,  255, 84,  121, 73,
    255, 86,  121, 69,  255, 112, 146, 69,  255, 83,  110, 48,  255, 47,  69,  26,  255, 47,  72,  31,  255, 36,  53,  25,  255, 43,  62,  23,  255,
    68,  82,  31,  255, 110, 127, 49,  255, 144, 158, 74,  255, 177, 183, 101, 255, 161, 177, 91,  255, 123, 154, 52,  255, 163, 180, 62,  255, 152,
    180, 75,  255, 129, 166, 76,  255, 127, 165, 76,  255, 136, 173, 84,  255, 135, 174, 92,  255, 139, 178, 107, 255, 174, 202, 128, 255, 145, 152,
    84,  255, 73,  89,  33,  255, 152, 173, 60,  255, 175, 195, 68,  255, 185, 203, 76,  255, 192, 206, 84,  255, 199, 211, 93,  255, 192, 204, 111,
    255, 138, 172, 86,  255, 127, 160, 80,  255, 181, 197, 126, 255, 106, 128, 68,  255, 98,  133, 72,  255, 113, 146, 81,  255, 92,  130, 52,  255,
    77,  117, 39,  255, 55,  83,  33,  255, 63,  90,  36,  255, 67,  95,  38,  255, 75,  109, 53,  255, 83,  122, 65,  255, 100, 136, 65,  255, 159,
    183, 76,  255, 172, 197, 92,  255, 175, 198, 105, 255, 173, 197, 107, 255, 172, 191, 99,  255, 170, 180, 87,  255, 172, 185, 90,  255, 180, 197,
    91,  255, 202, 217, 87,  255, 202, 219, 72,  255, 194, 213, 82,  255, 205, 208, 91,  255, 197, 202, 89,  255, 141, 171, 82,  255, 128, 162, 74,
    255, 127, 159, 73,  255, 122, 161, 74,  255, 149, 179, 104, 255, 209, 209, 107, 255, 149, 170, 62,  255, 171, 190, 82,  255, 174, 197, 122, 255,
    173, 197, 152, 255, 187, 200, 109, 255, 167, 186, 89,  255, 149, 176, 80,  255, 124, 157, 69,  255, 150, 175, 84,  255, 129, 154, 69,  255, 71,
    104, 52,  255, 71,  103, 53,  255, 81,  112, 62,  255, 91,  122, 52,  255, 96,  123, 60,  255, 49,  74,  37,  255, 63,  92,  47,  255, 69,  99,
    47,  255, 31,  40,  28,  255, 36,  46,  31,  255, 50,  74,  31,  255, 90,  107, 38,  255, 151, 162, 67,  255, 190, 197, 107, 255, 204, 205, 125,
    255, 154, 172, 107, 255, 177, 184, 104, 255, 137, 141, 71,  255, 55,  65,  31,  255, 34,  52,  26,  255, 50,  73,  37,  255, 65,  89,  46,  255,
    198, 210, 155, 255, 194, 207, 152, 255, 100, 102, 68,  255, 95,  100, 50,  255, 159, 165, 74,  255, 176, 181, 84,  255, 193, 196, 104, 255, 180,
    185, 81,  255, 107, 121, 48,  255, 43,  57,  26,  255, 17,  23,  19,  255, 39,  52,  32,  255, 41,  67,  31,  255, 47,  68,  42,  255, 55,  76,
    52,  255, 37,  53,  34,  255, 65,  87,  44,  255, 80,  104, 50,  255, 84,  115, 55,  255, 69,  95,  55,  255, 69,  102, 48,  255, 84,  114, 44,
    255, 124, 142, 53,  255, 176, 194, 68,  255, 166, 188, 67,  255, 135, 153, 55,  255, 116, 132, 58,  255, 83,  99,  41,  255, 83,  109, 44,  255,
    91,  121, 47,  255, 123, 146, 63,  255, 156, 177, 93,  255, 124, 152, 97,  255, 132, 158, 99,  255, 125, 153, 83,  255, 146, 169, 86,  255, 152,
    169, 81,  255, 113, 136, 49,  255, 135, 162, 55,  255, 123, 152, 49,  255, 124, 154, 60,  255, 122, 153, 58,  255, 131, 165, 56,  255, 145, 173,
    72,  255, 169, 192, 101, 255, 160, 189, 69,  255, 166, 200, 83,  255, 200, 215, 121, 255, 190, 208, 122, 255, 161, 180, 87,  255, 180, 204, 102,
    255, 204, 224, 118, 255, 176, 187, 94,  255, 49,  49,  23,  255, 19,  23,  21,  255, 38,  47,  28,  255, 52,  74,  28,  255, 77,  100, 42,  255,
    69,  98,  40,  255, 80,  113, 43,  255, 87,  118, 38,  255, 107, 141, 47,  255, 84,  121, 43,  255, 52,  87,  25,  255, 49,  87,  25,  255, 60,
    92,  26,  255, 65,  97,  29,  255, 46,  68,  26,  255, 26,  37,  19,  255, 28,  40,  21,  255, 19,  25,  15,  255, 15,  19,  17,  255, 39,  58,
    23,  255, 69,  98,  29,  255, 123, 132, 52,  255, 175, 185, 87,  255, 169, 188, 101, 255, 154, 182, 114, 255, 127, 160, 94,  255, 149, 169, 69,
    255, 143, 169, 65,  255, 132, 162, 71,  255, 126, 157, 74,  255, 151, 178, 75,  255, 125, 152, 62,  255, 97,  126, 56,  255, 102, 124, 55,  255,
    58,  77,  31,  255, 55,  72,  26,  255, 53,  67,  26,  255, 34,  48,  17,  255, 116, 132, 45,  255, 170, 202, 91,  255, 148, 164, 89,  255, 221,
    233, 169, 255, 204, 227, 181, 255, 196, 223, 165, 255, 211, 229, 154, 255, 210, 221, 139, 255, 170, 184, 96,  255, 166, 177, 84,  255, 165, 177,
    74,  255, 130, 154, 58,  255, 86,  117, 40,  255, 76,  110, 37,  255, 85,  118, 34,  255, 87,  114, 45,  255, 119, 143, 73,  255, 108, 139, 73,
    255, 102, 130, 58,  255, 152, 168, 91,  255, 151, 161, 76,  255, 77,  109, 32,  255, 78,  109, 33,  255, 93,  119, 47,  255, 168, 182, 53,  255,
    195, 206, 53,  255, 199, 204, 55,  255, 208, 208, 63,  255, 215, 212, 65,  255, 225, 217, 76,  255, 243, 228, 101, 255, 232, 219, 95,  255, 153,
    151, 52,  255, 76,  98,  28,  255, 29,  58,  19,  255, 58,  78,  38,  255, 83,  103, 52,  255, 69,  92,  41,  255, 37,  60,  23,  255, 97,  105,
    41,  255, 203, 207, 86,  255, 209, 218, 80,  255, 203, 212, 78,  255, 205, 213, 87,  255, 203, 214, 74,  255, 209, 215, 81,  255, 216, 212, 97,
    255, 224, 215, 100, 255, 232, 222, 115, 255, 233, 223, 119, 255, 231, 221, 109, 255, 238, 225, 109, 255, 225, 217, 115, 255, 169, 181, 108, 255,
    121, 121, 74,  255, 140, 138, 68,  255, 159, 173, 89,  255, 115, 141, 75,  255, 110, 140, 76,  255, 110, 137, 86,  255, 86,  121, 80,  255, 87,
    123, 81,  255, 91,  125, 80,  255, 82,  112, 55,  255, 83,  110, 60,  255, 90,  117, 63,  255, 63,  95,  56,  255, 92,  125, 62,  255, 145, 174,
    76,  255, 146, 178, 84,  255, 116, 151, 82,  255, 95,  129, 78,  255, 106, 140, 81,  255, 77,  99,  50,  255, 15,  23,  17,  255, 34,  42,  28,
    255, 49,  71,  31,  255, 84,  120, 38,  255, 68,  111, 36,  255, 79,  120, 43,  255, 121, 158, 62,  255, 130, 161, 67,  255, 107, 134, 52,  255,
    72,  97,  34,  255, 84,  113, 31,  255, 155, 166, 58,  255, 197, 202, 86,  255, 175, 195, 97,  255, 170, 195, 104, 255, 175, 200, 102, 255, 177,
    202, 110, 255, 195, 217, 140, 255, 151, 165, 108, 255, 36,  58,  36,  255, 80,  107, 55,  255, 123, 148, 76,  255, 140, 165, 73,  255, 127, 159,
    65,  255, 131, 164, 74,  255, 133, 163, 73,  255, 142, 168, 87,  255, 135, 165, 92,  255, 155, 182, 123, 255, 152, 175, 95,  255, 112, 147, 65,
    255, 112, 146, 65,  255, 107, 143, 56,  255, 101, 140, 48,  255, 79,  112, 39,  255, 40,  60,  28,  255, 47,  80,  29,  255, 101, 137, 65,  255,
    108, 143, 84,  255, 102, 136, 84,  255, 107, 137, 68,  255, 141, 161, 74,  255, 167, 187, 98,  255, 187, 208, 118, 255, 181, 197, 110, 255, 148,
    151, 74,  255, 167, 177, 86,  255, 205, 220, 81,  255, 212, 223, 71,  255, 213, 225, 81,  255, 175, 181, 73,  255, 125, 132, 53,  255, 178, 194,
    87,  255, 145, 174, 75,  255, 136, 169, 73,  255, 141, 173, 84,  255, 154, 181, 95,  255, 192, 207, 106, 255, 190, 194, 72,  255, 138, 163, 52,
    255, 142, 169, 55,  255, 196, 209, 105, 255, 207, 217, 160, 255, 184, 189, 125, 255, 150, 176, 72,  255, 157, 183, 80,  255, 163, 187, 87,  255,
    166, 191, 85,  255, 107, 136, 60,  255, 63,  98,  46,  255, 82,  110, 62,  255, 98,  123, 60,  255, 121, 141, 65,  255, 158, 175, 92,  255, 101,
    121, 55,  255, 55,  81,  36,  255, 29,  40,  28,  255, 29,  38,  31,  255, 21,  31,  28,  255, 21,  31,  29,  255, 40,  60,  32,  255, 105, 120,
    42,  255, 156, 173, 82,  255, 191, 198, 124, 255, 150, 166, 107, 255, 148, 169, 114, 255, 184, 196, 122, 255, 181, 177, 94,  255, 65,  80,  36,
    255, 52,  77,  40,  255, 60,  76,  44,  255, 191, 204, 154, 255, 194, 223, 179, 255, 207, 222, 178, 255, 102, 100, 72,  255, 6,   12,  9,   255,
    125, 135, 69,  255, 188, 202, 103, 255, 55,  72,  37,  255, 36,  52,  31,  255, 56,  73,  36,  255, 41,  47,  31,  255, 69,  81,  47,  255, 74,
    95,  48,  255, 63,  92,  55,  255, 55,  83,  47,  255, 36,  46,  25,  255, 78,  106, 53,  255, 79,  104, 47,  255, 82,  113, 53,  255, 69,  96,
    56,  255, 79,  109, 55,  255, 80,  108, 45,  255, 130, 137, 65,  255, 197, 209, 81,  255, 145, 173, 58,  255, 140, 174, 62,  255, 152, 177, 60,
    255, 120, 140, 55,  255, 98,  125, 55,  255, 78,  110, 39,  255, 134, 159, 72,  255, 147, 172, 99,  255, 127, 156, 104, 255, 118, 147, 91,  255,
    133, 158, 92,  255, 175, 192, 100, 255, 138, 155, 69,  255, 165, 184, 102, 255, 199, 212, 137, 255, 190, 206, 128, 255, 189, 204, 118, 255, 170,
    185, 87,  255, 151, 172, 67,  255, 133, 158, 62,  255, 178, 200, 102, 255, 195, 214, 101, 255, 200, 214, 113, 255, 213, 221, 126, 255, 177, 199,
    117, 255, 198, 216, 113, 255, 190, 210, 97,  255, 188, 210, 106, 255, 204, 223, 117, 255, 163, 174, 84,  255, 44,  48,  26,  255, 23,  25,  21,
    255, 39,  51,  28,  255, 69,  100, 39,  255, 67,  98,  36,  255, 69,  108, 47,  255, 69,  107, 55,  255, 80,  113, 45,  255, 125, 154, 69,  255,
    106, 142, 58,  255, 71,  107, 39,  255, 68,  104, 39,  255, 75,  114, 40,  255, 52,  77,  33,  255, 32,  49,  21,  255, 38,  55,  25,  255, 31,
    47,  23,  255, 42,  60,  23,  255, 67,  96,  36,  255, 75,  109, 48,  255, 80,  114, 48,  255, 97,  123, 52,  255, 127, 143, 60,  255, 135, 151,
    62,  255, 128, 144, 58,  255, 160, 172, 73,  255, 157, 180, 80,  255, 160, 182, 91,  255, 162, 184, 80,  255, 117, 130, 47,  255, 74,  84,  26,
    255, 71,  87,  31,  255, 53,  74,  34,  255, 58,  78,  39,  255, 63,  83,  36,  255, 69,  91,  36,  255, 65,  97,  37,  255, 91,  110, 41,  255,
    175, 190, 87,  255, 200, 219, 104, 255, 193, 211, 112, 255, 179, 198, 118, 255, 139, 146, 69,  255, 116, 113, 56,  255, 111, 110, 52,  255, 102,
    115, 44,  255, 97,  111, 38,  255, 112, 127, 36,  255, 139, 164, 52,  255, 114, 147, 43,  255, 124, 148, 49,  255, 135, 157, 58,  255, 104, 136,
    60,  255, 136, 165, 55,  255, 148, 180, 60,  255, 121, 153, 58,  255, 142, 158, 74,  255, 75,  109, 34,  255, 91,  120, 41,  255, 89,  116, 41,
    255, 87,  115, 45,  255, 145, 156, 47,  255, 209, 211, 60,  255, 215, 217, 62,  255, 220, 218, 65,  255, 224, 223, 79,  255, 233, 229, 95,  255,
    254, 241, 117, 255, 232, 225, 129, 255, 65,  97,  31,  255, 65,  100, 28,  255, 107, 129, 52,  255, 127, 147, 63,  255, 135, 154, 68,  255, 120,
    142, 62,  255, 55,  89,  33,  255, 82,  103, 36,  255, 204, 207, 78,  255, 213, 218, 81,  255, 206, 215, 79,  255, 213, 217, 93,  255, 220, 222,
    81,  255, 221, 224, 73,  255, 225, 222, 91,  255, 232, 223, 104, 255, 239, 228, 115, 255, 241, 228, 118, 255, 243, 228, 117, 255, 221, 209, 105,
    255, 133, 140, 58,  255, 85,  108, 36,  255, 58,  83,  29,  255, 122, 141, 65,  255, 97,  124, 71,  255, 89,  122, 63,  255, 124, 151, 65,  255,
    146, 171, 74,  255, 126, 152, 75,  255, 98,  128, 74,  255, 87,  122, 65,  255, 81,  112, 50,  255, 78,  108, 47,  255, 91,  122, 55,  255, 84,
    125, 55,  255, 107, 145, 74,  255, 132, 167, 85,  255, 163, 190, 94,  255, 186, 208, 104, 255, 144, 171, 94,  255, 97,  132, 78,  255, 112, 143,
    74,  255, 91,  121, 55,  255, 76,  108, 37,  255, 101, 140, 43,  255, 121, 160, 55,  255, 106, 143, 58,  255, 86,  124, 60,  255, 127, 156, 75,
    255, 160, 183, 87,  255, 135, 158, 78,  255, 48,  76,  31,  255, 58,  95,  36,  255, 82,  117, 38,  255, 106, 134, 42,  255, 145, 164, 63,  255,
    167, 184, 86,  255, 175, 191, 93,  255, 189, 205, 95,  255, 192, 197, 101, 255, 111, 125, 77,  255, 52,  76,  48,  255, 55,  81,  42,  255, 100,
    130, 67,  255, 104, 130, 62,  255, 134, 157, 69,  255, 143, 174, 74,  255, 142, 177, 75,  255, 132, 164, 69,  255, 148, 174, 92,  255, 143, 171,
    116, 255, 154, 182, 122, 255, 118, 151, 52,  255, 116, 153, 55,  255, 114, 150, 58,  255, 106, 143, 47,  255, 76,  102, 40,  255, 41,  62,  31,
    255, 100, 133, 62,  255, 122, 154, 93,  255, 99,  133, 91,  255, 85,  122, 84,  255, 81,  120, 75,  255, 77,  105, 55,  255, 63,  86,  40,  255,
    92,  100, 52,  255, 72,  71,  44,  255, 73,  80,  47,  255, 181, 194, 109, 255, 192, 204, 101, 255, 197, 208, 90,  255, 177, 186, 84,  255, 82,
    99,  42,  255, 44,  63,  25,  255, 147, 147, 58,  255, 187, 200, 94,  255, 154, 183, 96,  255, 160, 184, 112, 255, 180, 197, 94,  255, 204, 203,
    77,  255, 142, 163, 43,  255, 134, 161, 50,  255, 131, 157, 55,  255, 170, 188, 74,  255, 177, 181, 86,  255, 114, 128, 55,  255, 141, 168, 62,
    255, 167, 187, 80,  255, 166, 191, 81,  255, 162, 186, 87,  255, 127, 147, 83,  255, 79,  110, 44,  255, 105, 139, 56,  255, 129, 161, 84,  255,
    158, 185, 109, 255, 173, 199, 114, 255, 184, 206, 116, 255, 114, 121, 60,  255, 17,  19,  19,  255, 32,  38,  28,  255, 111, 112, 44,  255, 126,
    135, 47,  255, 58,  73,  32,  255, 49,  71,  31,  255, 134, 151, 60,  255, 168, 184, 105, 255, 155, 173, 110, 255, 139, 161, 109, 255, 148, 166,
    109, 255, 190, 197, 111, 255, 165, 166, 84,  255, 55,  77,  42,  255, 47,  65,  36,  255, 187, 195, 150, 255, 204, 227, 186, 255, 193, 220, 175,
    255, 213, 228, 184, 255, 135, 135, 94,  255, 156, 166, 83,  255, 164, 186, 89,  255, 50,  74,  36,  255, 50,  72,  34,  255, 90,  110, 47,  255,
    106, 130, 52,  255, 100, 129, 50,  255, 63,  87,  41,  255, 48,  67,  36,  255, 50,  62,  31,  255, 87,  122, 36,  255, 87,  118, 48,  255, 79,
    105, 47,  255, 83,  111, 55,  255, 75,  101, 68,  255, 86,  113, 68,  255, 102, 125, 56,  255, 197, 199, 121, 255, 227, 226, 108, 255, 184, 197,
    72,  255, 118, 150, 60,  255, 114, 150, 60,  255, 143, 174, 68,  255, 146, 166, 78,  255, 98,  119, 49,  255, 129, 155, 87,  255, 131, 163, 102,
    255, 119, 150, 90,  255, 145, 168, 99,  255, 182, 196, 108, 255, 131, 144, 69,  255, 78,  96,  42,  255, 84,  104, 48,  255, 154, 170, 108, 255,
    208, 228, 165, 255, 196, 221, 163, 255, 203, 223, 165, 255, 203, 216, 145, 255, 145, 163, 84,  255, 166, 194, 84,  255, 187, 216, 102, 255, 184,
    205, 126, 255, 193, 211, 130, 255, 170, 198, 120, 255, 181, 202, 114, 255, 171, 190, 84,  255, 192, 213, 107, 255, 197, 216, 116, 255, 209, 225,
    123, 255, 95,  106, 43,  255, 28,  43,  19,  255, 34,  47,  26,  255, 58,  84,  37,  255, 121, 147, 74,  255, 155, 176, 106, 255, 114, 142, 82,
    255, 123, 152, 84,  255, 145, 172, 116, 255, 138, 168, 84,  255, 104, 140, 43,  255, 89,  127, 47,  255, 82,  119, 44,  255, 49,  75,  26,  255,
    41,  63,  25,  255, 53,  77,  23,  255, 92,  131, 34,  255, 72,  107, 29,  255, 58,  80,  28,  255, 86,  112, 39,  255, 93,  121, 41,  255, 68,
    94,  32,  255, 67,  92,  29,  255, 79,  114, 37,  255, 74,  105, 44,  255, 108, 123, 62,  255, 173, 184, 94,  255, 192, 207, 131, 255, 162, 180,
    111, 255, 91,  111, 82,  255, 90,  115, 77,  255, 128, 158, 95,  255, 182, 197, 122, 255, 193, 207, 117, 255, 164, 181, 105, 255, 174, 187, 92,
    255, 162, 187, 76,  255, 122, 148, 71,  255, 121, 136, 68,  255, 104, 113, 47,  255, 78,  87,  32,  255, 65,  75,  32,  255, 68,  82,  40,  255,
    116, 129, 77,  255, 122, 133, 84,  255, 130, 139, 81,  255, 180, 188, 90,  255, 183, 195, 72,  255, 155, 175, 52,  255, 165, 178, 58,  255, 171,
    184, 68,  255, 121, 151, 60,  255, 116, 151, 68,  255, 134, 162, 60,  255, 183, 203, 67,  255, 146, 176, 78,  255, 123, 154, 71,  255, 104, 133,
    47,  255, 118, 138, 55,  255, 122, 148, 53,  255, 115, 146, 55,  255, 104, 136, 52,  255, 132, 146, 49,  255, 178, 173, 53,  255, 192, 181, 58,
    255, 194, 181, 68,  255, 185, 177, 74,  255, 181, 172, 74,  255, 209, 194, 106, 255, 114, 132, 56,  255, 111, 131, 50,  255, 121, 139, 55,  255,
    124, 142, 58,  255, 132, 148, 63,  255, 120, 142, 60,  255, 58,  84,  29,  255, 55,  84,  31,  255, 157, 162, 52,  255, 236, 235, 89,  255, 223,
    225, 92,  255, 225, 225, 98,  255, 248, 241, 97,  255, 179, 165, 55,  255, 157, 139, 48,  255, 208, 188, 80,  255, 220, 203, 93,  255, 211, 196,
    92,  255, 173, 170, 80,  255, 116, 133, 55,  255, 73,  100, 43,  255, 77,  103, 39,  255, 113, 135, 53,  255, 98,  123, 55,  255, 107, 129, 55,
    255, 133, 145, 60,  255, 138, 151, 76,  255, 123, 140, 60,  255, 80,  105, 41,  255, 58,  87,  37,  255, 90,  123, 48,  255, 86,  115, 63,  255,
    86,  118, 52,  255, 94,  136, 52,  255, 100, 138, 62,  255, 110, 150, 84,  255, 120, 157, 94,  255, 132, 166, 103, 255, 147, 177, 111, 255, 173,
    194, 112, 255, 121, 150, 75,  255, 112, 140, 65,  255, 89,  117, 42,  255, 103, 133, 39,  255, 103, 138, 71,  255, 108, 143, 76,  255, 146, 180,
    84,  255, 114, 150, 75,  255, 107, 138, 86,  255, 144, 168, 89,  255, 164, 185, 91,  255, 104, 129, 56,  255, 44,  75,  28,  255, 87,  120, 46,
    255, 115, 149, 58,  255, 137, 173, 69,  255, 134, 171, 68,  255, 141, 179, 73,  255, 146, 171, 67,  255, 75,  98,  36,  255, 60,  94,  49,  255,
    65,  94,  55,  255, 47,  72,  41,  255, 76,  105, 50,  255, 93,  117, 55,  255, 52,  55,  32,  255, 47,  55,  31,  255, 99,  124, 65,  255, 111,
    135, 68,  255, 93,  106, 50,  255, 125, 136, 75,  255, 143, 159, 113, 255, 84,  98,  48,  255, 78,  94,  31,  255, 95,  115, 44,  255, 81,  99,
    37,  255, 45,  62,  31,  255, 41,  60,  32,  255, 132, 160, 87,  255, 108, 137, 98,  255, 97,  132, 94,  255, 120, 152, 93,  255, 146, 175, 96,
    255, 155, 181, 90,  255, 101, 130, 63,  255, 34,  52,  25,  255, 9,   15,  9,   255, 122, 134, 82,  255, 191, 211, 119, 255, 183, 203, 103, 255,
    151, 165, 75,  255, 73,  87,  36,  255, 58,  78,  33,  255, 53,  71,  34,  255, 52,  81,  29,  255, 137, 151, 60,  255, 201, 206, 114, 255, 227,
    234, 155, 255, 214, 224, 135, 255, 170, 186, 80,  255, 106, 131, 40,  255, 92,  118, 38,  255, 102, 129, 39,  255, 108, 140, 44,  255, 115, 144,
    55,  255, 95,  124, 49,  255, 102, 128, 52,  255, 154, 174, 84,  255, 179, 205, 112, 255, 172, 198, 147, 255, 195, 218, 158, 255, 167, 188, 113,
    255, 121, 152, 68,  255, 137, 169, 91,  255, 148, 181, 111, 255, 152, 185, 118, 255, 160, 191, 122, 255, 190, 210, 124, 255, 67,  80,  40,  255,
    36,  40,  28,  255, 202, 195, 72,  255, 193, 205, 65,  255, 155, 174, 60,  255, 80,  105, 37,  255, 65,  84,  31,  255, 124, 139, 65,  255, 144,
    164, 102, 255, 134, 156, 105, 255, 145, 162, 112, 255, 160, 173, 113, 255, 209, 207, 118, 255, 93,  104, 52,  255, 31,  53,  21,  255, 127, 140,
    87,  255, 222, 234, 196, 255, 184, 212, 134, 255, 186, 214, 125, 255, 210, 227, 175, 255, 215, 228, 133, 255, 138, 162, 71,  255, 74,  114, 45,
    255, 49,  87,  31,  255, 43,  75,  28,  255, 58,  92,  29,  255, 47,  83,  25,  255, 65,  83,  33,  255, 133, 154, 52,  255, 112, 146, 44,  255,
    96,  131, 41,  255, 78,  117, 38,  255, 75,  106, 47,  255, 81,  108, 56,  255, 82,  108, 73,  255, 95,  122, 71,  255, 83,  102, 48,  255, 87,
    115, 45,  255, 76,  103, 36,  255, 151, 164, 69,  255, 183, 197, 82,  255, 151, 171, 71,  255, 128, 156, 62,  255, 132, 163, 69,  255, 98,  126,
    50,  255, 96,  129, 63,  255, 140, 169, 87,  255, 158, 177, 91,  255, 167, 179, 96,  255, 118, 131, 65,  255, 40,  56,  26,  255, 29,  39,  26,
    255, 55,  76,  33,  255, 86,  113, 43,  255, 145, 163, 91,  255, 199, 212, 137, 255, 200, 221, 150, 255, 190, 219, 159, 255, 184, 210, 147, 255,
    149, 170, 84,  255, 164, 190, 102, 255, 164, 194, 134, 255, 180, 204, 138, 255, 192, 212, 135, 255, 203, 217, 137, 255, 185, 195, 104, 255, 173,
    195, 102, 255, 181, 206, 110, 255, 201, 220, 121, 255, 158, 169, 84,  255, 43,  55,  21,  255, 31,  47,  28,  255, 34,  49,  29,  255, 83,  105,
    55,  255, 213, 218, 149, 255, 226, 232, 163, 255, 176, 197, 128, 255, 141, 170, 100, 255, 114, 144, 58,  255, 106, 138, 41,  255, 101, 139, 55,
    255, 95,  133, 56,  255, 69,  103, 47,  255, 40,  65,  23,  255, 87,  113, 31,  255, 140, 173, 52,  255, 78,  113, 26,  255, 87,  113, 34,  255,
    74,  105, 34,  255, 93,  120, 38,  255, 53,  76,  26,  255, 55,  72,  23,  255, 98,  132, 56,  255, 92,  121, 68,  255, 98,  124, 72,  255, 154,
    165, 82,  255, 232, 238, 173, 255, 213, 236, 194, 255, 201, 228, 175, 255, 200, 227, 172, 255, 199, 224, 169, 255, 186, 211, 152, 255, 197, 212,
    128, 255, 239, 243, 130, 255, 200, 223, 110, 255, 185, 213, 87,  255, 193, 217, 94,  255, 119, 134, 62,  255, 55,  82,  25,  255, 58,  89,  26,
    255, 138, 154, 83,  255, 197, 210, 124, 255, 189, 207, 126, 255, 177, 198, 130, 255, 181, 197, 131, 255, 202, 212, 128, 255, 163, 181, 80,  255,
    145, 162, 60,  255, 208, 207, 74,  255, 124, 155, 60,  255, 107, 142, 55,  255, 120, 154, 71,  255, 120, 151, 60,  255, 194, 202, 69,  255, 154,
    177, 75,  255, 142, 167, 74,  255, 148, 162, 74,  255, 187, 195, 89,  255, 187, 199, 73,  255, 168, 186, 62,  255, 146, 170, 58,  255, 119, 149,
    47,  255, 101, 125, 44,  255, 77,  91,  36,  255, 47,  58,  15,  255, 44,  65,  12,  255, 52,  79,  19,  255, 71,  92,  23,  255, 103, 124, 47,
    255, 115, 137, 55,  255, 120, 139, 56,  255, 127, 144, 60,  255, 133, 149, 60,  255, 117, 136, 60,  255, 52,  75,  23,  255, 60,  90,  36,  255,
    90,  100, 28,  255, 223, 208, 75,  255, 245, 241, 113, 255, 251, 245, 123, 255, 187, 175, 80,  255, 34,  43,  19,  255, 42,  58,  23,  255, 98,
    109, 39,  255, 134, 144, 55,  255, 139, 152, 65,  255, 127, 148, 68,  255, 108, 133, 55,  255, 69,  97,  39,  255, 52,  77,  31,  255, 114, 134,
    67,  255, 141, 151, 90,  255, 152, 158, 105, 255, 179, 187, 140, 255, 203, 211, 156, 255, 86,  103, 53,  255, 60,  94,  38,  255, 69,  104, 44,
    255, 90,  116, 43,  255, 91,  117, 52,  255, 104, 131, 52,  255, 143, 180, 69,  255, 109, 150, 75,  255, 109, 150, 74,  255, 122, 158, 87,  255,
    139, 173, 110, 255, 134, 172, 118, 255, 153, 183, 123, 255, 148, 169, 87,  255, 111, 144, 58,  255, 128, 159, 67,  255, 139, 161, 60,  255, 104,
    138, 72,  255, 100, 137, 90,  255, 141, 172, 101, 255, 159, 189, 89,  255, 121, 151, 85,  255, 131, 160, 90,  255, 167, 186, 95,  255, 130, 153,
    68,  255, 52,  87,  23,  255, 108, 135, 60,  255, 139, 160, 73,  255, 168, 186, 83,  255, 166, 190, 76,  255, 152, 173, 73,  255, 75,  76,  39,
    255, 42,  68,  36,  255, 71,  106, 58,  255, 73,  103, 62,  255, 57,  83,  47,  255, 58,  87,  40,  255, 74,  90,  41,  255, 39,  60,  26,  255,
    72,  108, 48,  255, 94,  131, 55,  255, 107, 144, 71,  255, 102, 129, 69,  255, 83,  99,  50,  255, 104, 127, 60,  255, 73,  84,  50,  255, 26,
    43,  21,  255, 46,  69,  34,  255, 47,  75,  32,  255, 48,  75,  31,  255, 65,  83,  41,  255, 145, 173, 101, 255, 114, 150, 109, 255, 165, 191,
    119, 255, 212, 222, 120, 255, 218, 225, 115, 255, 203, 217, 100, 255, 198, 215, 92,  255, 130, 151, 55,  255, 52,  68,  31,  255, 170, 186, 114,
    255, 173, 187, 100, 255, 115, 120, 60,  255, 52,  62,  26,  255, 36,  52,  25,  255, 45,  63,  26,  255, 60,  89,  43,  255, 100, 126, 55,  255,
    133, 161, 58,  255, 142, 163, 62,  255, 204, 211, 118, 255, 234, 238, 142, 255, 215, 225, 131, 255, 155, 173, 89,  255, 97,  129, 39,  255, 89,
    128, 34,  255, 105, 143, 47,  255, 133, 162, 72,  255, 107, 135, 60,  255, 98,  128, 55,  255, 114, 140, 60,  255, 116, 141, 68,  255, 141, 166,
    106, 255, 125, 148, 93,  255, 119, 137, 69,  255, 150, 168, 81,  255, 166, 186, 92,  255, 169, 188, 98,  255, 183, 203, 116, 255, 188, 211, 133,
    255, 198, 213, 131, 255, 82,  109, 47,  255, 39,  62,  31,  255, 129, 132, 75,  255, 173, 187, 93,  255, 153, 174, 82,  255, 130, 160, 72,  255,
    105, 132, 55,  255, 110, 120, 58,  255, 126, 143, 87,  255, 136, 160, 107, 255, 137, 159, 114, 255, 139, 159, 115, 255, 182, 189, 119, 255, 162,
    163, 89,  255, 129, 145, 75,  255, 192, 209, 120, 255, 227, 238, 160, 255, 212, 229, 161, 255, 188, 212, 105, 255, 194, 218, 156, 255, 217, 232,
    171, 255, 167, 181, 112, 255, 58,  97,  42,  255, 46,  81,  34,  255, 29,  51,  26,  255, 75,  102, 36,  255, 62,  108, 29,  255, 114, 137, 56,
    255, 178, 193, 74,  255, 141, 163, 53,  255, 143, 164, 60,  255, 96,  125, 45,  255, 63,  92,  34,  255, 78,  100, 52,  255, 99,  128, 83,  255,
    71,  98,  47,  255, 31,  55,  19,  255, 95,  111, 55,  255, 124, 145, 80,  255, 132, 156, 82,  255, 142, 164, 73,  255, 151, 170, 76,  255, 158,
    174, 84,  255, 158, 174, 82,  255, 96,  119, 47,  255, 91,  113, 50,  255, 86,  102, 42,  255, 48,  57,  32,  255, 53,  60,  43,  255, 73,  98,
    48,  255, 91,  129, 52,  255, 73,  104, 41,  255, 58,  79,  33,  255, 71,  95,  40,  255, 94,  126, 52,  255, 117, 147, 65,  255, 160, 179, 96,
    255, 183, 201, 124, 255, 181, 206, 128, 255, 183, 204, 115, 255, 157, 181, 108, 255, 170, 199, 123, 255, 180, 206, 117, 255, 180, 207, 122, 255,
    190, 216, 146, 255, 220, 236, 175, 255, 188, 201, 139, 255, 151, 180, 118, 255, 177, 203, 127, 255, 195, 218, 134, 255, 142, 150, 77,  255, 42,
    55,  26,  255, 50,  71,  33,  255, 39,  58,  21,  255, 72,  89,  60,  255, 202, 217, 171, 255, 226, 230, 171, 255, 185, 204, 117, 255, 108, 142,
    67,  255, 104, 130, 52,  255, 137, 163, 75,  255, 95,  131, 52,  255, 104, 141, 58,  255, 63,  98,  31,  255, 122, 144, 38,  255, 131, 154, 45,
    255, 73,  103, 26,  255, 68,  99,  32,  255, 63,  98,  36,  255, 94,  121, 36,  255, 73,  100, 32,  255, 47,  60,  19,  255, 105, 123, 60,  255,
    133, 155, 87,  255, 146, 167, 86,  255, 127, 141, 68,  255, 118, 103, 49,  255, 199, 192, 125, 255, 231, 243, 179, 255, 207, 227, 176, 255, 197,
    220, 164, 255, 195, 219, 159, 255, 223, 230, 150, 255, 225, 238, 135, 255, 212, 235, 115, 255, 225, 233, 101, 255, 188, 195, 92,  255, 72,  104,
    34,  255, 114, 143, 65,  255, 183, 198, 117, 255, 213, 223, 138, 255, 198, 209, 131, 255, 186, 202, 130, 255, 173, 192, 126, 255, 148, 175, 123,
    255, 163, 183, 110, 255, 133, 159, 69,  255, 170, 180, 68,  255, 206, 210, 81,  255, 116, 153, 58,  255, 118, 151, 65,  255, 120, 156, 72,  255,
    153, 177, 63,  255, 195, 199, 73,  255, 123, 154, 65,  255, 150, 167, 74,  255, 206, 205, 107, 255, 216, 214, 108, 255, 199, 203, 84,  255, 191,
    197, 74,  255, 168, 183, 58,  255, 155, 176, 47,  255, 143, 168, 47,  255, 94,  119, 42,  255, 55,  76,  31,  255, 33,  52,  17,  255, 60,  84,
    25,  255, 80,  109, 36,  255, 102, 124, 45,  255, 113, 133, 49,  255, 124, 143, 58,  255, 123, 142, 58,  255, 134, 154, 62,  255, 77,  87,  39,
    255, 26,  37,  15,  255, 55,  78,  26,  255, 41,  67,  23,  255, 89,  92,  23,  255, 234, 220, 109, 255, 224, 213, 116, 255, 50,  55,  21,  255,
    63,  86,  36,  255, 121, 148, 55,  255, 129, 152, 62,  255, 139, 157, 68,  255, 151, 164, 77,  255, 165, 176, 89,  255, 151, 164, 83,  255, 90,
    111, 55,  255, 147, 161, 115, 255, 224, 230, 169, 255, 226, 234, 174, 255, 199, 221, 169, 255, 211, 232, 176, 255, 154, 165, 99,  255, 62,  92,
    29,  255, 79,  112, 47,  255, 89,  116, 50,  255, 73,  104, 40,  255, 40,  55,  23,  255, 45,  55,  26,  255, 136, 151, 55,  255, 171, 196, 87,
    255, 147, 183, 90,  255, 130, 171, 87,  255, 136, 175, 97,  255, 156, 190, 113, 255, 159, 191, 134, 255, 166, 191, 105, 255, 138, 171, 52,  255,
    151, 184, 79,  255, 135, 155, 62,  255, 159, 182, 77,  255, 117, 152, 94,  255, 115, 148, 109, 255, 169, 192, 99,  255, 148, 171, 90,  255, 165,
    183, 99,  255, 185, 199, 104, 255, 145, 164, 79,  255, 72,  113, 41,  255, 104, 137, 62,  255, 102, 128, 60,  255, 91,  119, 50,  255, 92,  113,
    43,  255, 62,  79,  34,  255, 65,  91,  37,  255, 81,  111, 55,  255, 73,  107, 62,  255, 79,  110, 67,  255, 63,  92,  52,  255, 69,  96,  49,
    255, 65,  84,  38,  255, 69,  111, 36,  255, 95,  136, 55,  255, 92,  129, 55,  255, 96,  133, 56,  255, 175, 197, 112, 255, 178, 204, 130, 255,
    147, 184, 101, 255, 135, 168, 74,  255, 98,  123, 50,  255, 60,  89,  44,  255, 60,  91,  47,  255, 58,  91,  37,  255, 100, 127, 58,  255, 139,
    164, 102, 255, 157, 179, 126, 255, 218, 225, 140, 255, 221, 227, 134, 255, 218, 225, 129, 255, 208, 219, 107, 255, 200, 214, 84,  255, 185, 202,
    67,  255, 136, 155, 65,  255, 143, 157, 77,  255, 103, 109, 55,  255, 52,  57,  34,  255, 29,  40,  25,  255, 34,  49,  21,  255, 43,  69,  23,
    255, 82,  112, 55,  255, 139, 160, 76,  255, 168, 187, 81,  255, 155, 177, 76,  255, 172, 187, 95,  255, 226, 229, 127, 255, 223, 229, 125, 255,
    224, 232, 138, 255, 185, 205, 107, 255, 139, 170, 74,  255, 118, 153, 56,  255, 149, 175, 84,  255, 114, 143, 68,  255, 98,  133, 52,  255, 105,
    134, 46,  255, 105, 136, 41,  255, 62,  92,  34,  255, 23,  43,  19,  255, 28,  43,  23,  255, 45,  65,  33,  255, 62,  75,  38,  255, 56,  68,
    40,  255, 78,  93,  58,  255, 132, 147, 93,  255, 139, 157, 99,  255, 55,  86,  39,  255, 63,  95,  44,  255, 32,  46,  29,  255, 74,  77,  55,
    255, 155, 164, 89,  255, 187, 193, 107, 255, 196, 198, 102, 255, 231, 220, 114, 255, 122, 132, 67,  255, 124, 146, 94,  255, 139, 163, 113, 255,
    144, 165, 117, 255, 167, 182, 128, 255, 158, 166, 98,  255, 65,  97,  32,  255, 110, 140, 50,  255, 163, 185, 83,  255, 204, 222, 117, 255, 198,
    217, 133, 255, 174, 203, 135, 255, 215, 233, 177, 255, 218, 223, 161, 255, 80,  115, 55,  255, 58,  99,  39,  255, 44,  74,  28,  255, 98,  129,
    49,  255, 90,  135, 38,  255, 55,  97,  31,  255, 89,  116, 52,  255, 145, 160, 68,  255, 91,  120, 43,  255, 122, 141, 58,  255, 123, 140, 60,
    255, 103, 122, 60,  255, 60,  86,  41,  255, 37,  65,  26,  255, 81,  104, 50,  255, 167, 187, 125, 255, 161, 189, 115, 255, 139, 173, 77,  255,
    147, 171, 74,  255, 112, 140, 69,  255, 100, 130, 80,  255, 104, 130, 76,  255, 73,  100, 39,  255, 139, 154, 84,  255, 119, 124, 63,  255, 52,
    49,  38,  255, 41,  47,  31,  255, 63,  87,  41,  255, 92,  134, 53,  255, 76,  114, 43,  255, 69,  101, 39,  255, 76,  111, 40,  255, 114, 146,
    65,  255, 117, 151, 68,  255, 93,  128, 60,  255, 77,  111, 60,  255, 127, 156, 75,  255, 181, 195, 111, 255, 139, 164, 84,  255, 188, 210, 121,
    255, 206, 219, 123, 255, 198, 216, 129, 255, 201, 214, 131, 255, 146, 171, 106, 255, 144, 177, 120, 255, 147, 181, 127, 255, 155, 187, 132, 255,
    156, 187, 138, 255, 191, 205, 127, 255, 83,  95,  37,  255, 67,  92,  43,  255, 74,  92,  47,  255, 119, 135, 107, 255, 193, 215, 167, 255, 215,
    223, 175, 255, 217, 227, 157, 255, 159, 185, 98,  255, 159, 187, 91,  255, 137, 162, 69,  255, 92,  128, 42,  255, 101, 137, 50,  255, 120, 148,
    67,  255, 165, 179, 94,  255, 171, 185, 107, 255, 160, 175, 115, 255, 104, 130, 71,  255, 72,  102, 31,  255, 107, 132, 40,  255, 82,  109, 39,
    255, 41,  65,  21,  255, 52,  71,  23,  255, 87,  103, 41,  255, 90,  110, 41,  255, 62,  80,  29,  255, 23,  23,  17,  255, 50,  40,  15,  255,
    155, 141, 73,  255, 207, 204, 127, 255, 219, 221, 144, 255, 227, 227, 148, 255, 222, 218, 138, 255, 208, 208, 124, 255, 153, 148, 69,  255, 99,
    105, 41,  255, 97,  120, 39,  255, 112, 147, 65,  255, 165, 190, 99,  255, 181, 203, 124, 255, 175, 199, 132, 255, 175, 199, 137, 255, 178, 201,
    131, 255, 200, 214, 130, 255, 193, 207, 124, 255, 163, 181, 97,  255, 188, 196, 84,  255, 194, 197, 69,  255, 208, 207, 78,  255, 139, 172, 76,
    255, 124, 159, 82,  255, 135, 167, 83,  255, 185, 195, 84,  255, 125, 151, 68,  255, 124, 159, 69,  255, 134, 148, 65,  255, 223, 218, 113, 255,
    218, 216, 102, 255, 211, 210, 92,  255, 201, 203, 90,  255, 186, 191, 60,  255, 176, 183, 47,  255, 178, 188, 53,  255, 101, 128, 39,  255, 65,
    91,  26,  255, 55,  78,  26,  255, 60,  89,  25,  255, 69,  99,  29,  255, 87,  114, 36,  255, 105, 129, 42,  255, 121, 142, 55,  255, 132, 153,
    60,  255, 113, 126, 52,  255, 29,  37,  21,  255, 26,  37,  21,  255, 31,  49,  21,  255, 58,  87,  36,  255, 75,  104, 41,  255, 112, 121, 49,
    255, 108, 116, 47,  255, 71,  89,  33,  255, 124, 147, 56,  255, 124, 146, 56,  255, 125, 146, 58,  255, 137, 157, 68,  255, 152, 167, 77,  255,
    175, 184, 97,  255, 176, 183, 93,  255, 191, 198, 119, 255, 238, 243, 176, 255, 215, 230, 170, 255, 181, 208, 156, 255, 183, 215, 173, 255, 210,
    223, 163, 255, 102, 122, 49,  255, 82,  114, 47,  255, 90,  119, 52,  255, 90,  120, 48,  255, 80,  105, 43,  255, 38,  53,  31,  255, 47,  75,
    48,  255, 69,  92,  37,  255, 135, 151, 47,  255, 151, 162, 60,  255, 177, 194, 90,  255, 185, 205, 94,  255, 193, 210, 92,  255, 201, 219, 122,
    255, 189, 209, 111, 255, 124, 156, 47,  255, 160, 188, 78,  255, 133, 161, 68,  255, 163, 175, 72,  255, 168, 190, 102, 255, 119, 152, 109, 255,
    163, 186, 105, 255, 159, 178, 103, 255, 162, 180, 101, 255, 207, 212, 110, 255, 152, 170, 83,  255, 116, 152, 72,  255, 128, 162, 77,  255, 129,
    165, 81,  255, 143, 180, 100, 255, 94,  129, 65,  255, 51,  83,  31,  255, 94,  116, 48,  255, 65,  78,  40,  255, 76,  110, 65,  255, 80,  111,
    68,  255, 65,  96,  56,  255, 65,  90,  43,  255, 39,  49,  31,  255, 51,  79,  31,  255, 94,  130, 52,  255, 91,  131, 55,  255, 122, 156, 75,
    255, 189, 209, 133, 255, 158, 189, 125, 255, 151, 185, 110, 255, 162, 194, 105, 255, 183, 197, 98,  255, 104, 129, 62,  255, 125, 155, 87,  255,
    119, 151, 84,  255, 134, 164, 81,  255, 125, 152, 96,  255, 129, 153, 105, 255, 141, 164, 91,  255, 173, 193, 100, 255, 204, 212, 128, 255, 204,
    211, 118, 255, 191, 200, 91,  255, 206, 213, 117, 255, 210, 217, 122, 255, 213, 220, 122, 255, 225, 229, 126, 255, 226, 229, 124, 255, 197, 205,
    109, 255, 112, 130, 58,  255, 43,  72,  26,  255, 67,  101, 42,  255, 146, 167, 83,  255, 179, 196, 89,  255, 173, 189, 89,  255, 175, 192, 96,
    255, 199, 209, 109, 255, 227, 233, 122, 255, 220, 228, 125, 255, 217, 228, 130, 255, 215, 227, 129, 255, 169, 190, 93,  255, 145, 167, 83,  255,
    96,  124, 60,  255, 101, 133, 55,  255, 92,  125, 36,  255, 128, 163, 55,  255, 81,  109, 44,  255, 29,  49,  28,  255, 36,  51,  33,  255, 37,
    56,  31,  255, 42,  58,  31,  255, 37,  55,  33,  255, 31,  48,  36,  255, 37,  55,  38,  255, 73,  91,  52,  255, 65,  89,  44,  255, 67,  98,
    46,  255, 42,  62,  33,  255, 19,  29,  23,  255, 53,  83,  33,  255, 99,  124, 58,  255, 137, 152, 81,  255, 140, 154, 74,  255, 154, 168, 80,
    255, 115, 131, 65,  255, 129, 149, 103, 255, 139, 161, 115, 255, 151, 172, 124, 255, 148, 162, 99,  255, 55,  86,  29,  255, 80,  106, 37,  255,
    115, 138, 52,  255, 126, 149, 73,  255, 195, 205, 142, 255, 193, 209, 141, 255, 186, 207, 126, 255, 231, 238, 174, 255, 140, 164, 69,  255, 100,
    137, 40,  255, 65,  100, 32,  255, 100, 130, 52,  255, 101, 142, 38,  255, 84,  117, 47,  255, 61,  94,  47,  255, 65,  99,  46,  255, 69,  99,
    44,  255, 29,  51,  21,  255, 58,  81,  33,  255, 100, 120, 52,  255, 85,  110, 50,  255, 84,  113, 55,  255, 169, 189, 128, 255, 159, 188, 121,
    255, 112, 142, 53,  255, 88,  113, 43,  255, 144, 162, 75,  255, 128, 155, 69,  255, 86,  123, 68,  255, 83,  114, 67,  255, 79,  105, 43,  255,
    143, 159, 80,  255, 192, 211, 104, 255, 132, 132, 73,  255, 65,  91,  43,  255, 73,  104, 50,  255, 85,  116, 52,  255, 79,  115, 43,  255, 62,
    100, 32,  255, 84,  121, 47,  255, 133, 165, 78,  255, 128, 162, 76,  255, 89,  122, 71,  255, 97,  130, 72,  255, 150, 175, 87,  255, 191, 204,
    125, 255, 129, 161, 97,  255, 173, 202, 142, 255, 170, 199, 142, 255, 183, 209, 151, 255, 182, 195, 107, 255, 141, 169, 81,  255, 160, 188, 102,
    255, 167, 194, 108, 255, 172, 197, 112, 255, 186, 204, 119, 255, 221, 228, 142, 255, 127, 135, 68,  255, 69,  97,  47,  255, 91,  108, 55,  255,
    165, 167, 120, 255, 214, 226, 135, 255, 200, 215, 116, 255, 208, 217, 150, 255, 162, 187, 89,  255, 155, 171, 69,  255, 100, 119, 39,  255, 120,
    137, 60,  255, 201, 209, 124, 255, 235, 233, 153, 255, 226, 227, 156, 255, 220, 223, 156, 255, 235, 235, 164, 255, 122, 141, 74,  255, 77,  106,
    32,  255, 122, 140, 48,  255, 78,  103, 39,  255, 48,  75,  23,  255, 43,  72,  23,  255, 55,  84,  26,  255, 58,  87,  28,  255, 63,  94,  28,
    255, 52,  58,  31,  255, 32,  33,  26,  255, 34,  37,  15,  255, 73,  92,  23,  255, 90,  111, 32,  255, 88,  108, 29,  255, 76,  100, 26,  255,
    60,  84,  23,  255, 29,  51,  15,  255, 47,  73,  26,  255, 97,  125, 44,  255, 140, 161, 78,  255, 177, 205, 142, 255, 177, 204, 139, 255, 176,
    201, 127, 255, 175, 199, 126, 255, 173, 198, 129, 255, 174, 199, 129, 255, 209, 217, 116, 255, 187, 193, 90,  255, 142, 153, 68,  255, 130, 152,
    48,  255, 135, 151, 53,  255, 178, 187, 100, 255, 161, 189, 126, 255, 194, 206, 126, 255, 150, 171, 95,  255, 112, 151, 77,  255, 139, 171, 73,
    255, 158, 168, 75,  255, 232, 226, 121, 255, 230, 223, 108, 255, 219, 215, 101, 255, 207, 206, 91,  255, 201, 201, 74,  255, 202, 202, 65,  255,
    181, 180, 60,  255, 55,  78,  23,  255, 48,  76,  19,  255, 74,  107, 29,  255, 73,  112, 26,  255, 74,  108, 28,  255, 82,  113, 31,  255, 96,
    124, 36,  255, 119, 140, 50,  255, 112, 130, 44,  255, 87,  108, 42,  255, 102, 123, 55,  255, 118, 145, 60,  255, 99,  131, 49,  255, 106, 133,
    52,  255, 121, 145, 55,  255, 115, 139, 49,  255, 104, 129, 41,  255, 120, 143, 52,  255, 141, 161, 68,  255, 171, 187, 90,  255, 153, 173, 82,
    255, 148, 165, 75,  255, 163, 176, 82,  255, 181, 187, 94,  255, 202, 208, 106, 255, 199, 218, 134, 255, 197, 218, 162, 255, 171, 203, 147, 255,
    181, 213, 171, 255, 221, 238, 183, 255, 173, 180, 103, 255, 94,  124, 50,  255, 96,  127, 52,  255, 101, 131, 56,  255, 104, 131, 56,  255, 60,
    79,  34,  255, 53,  82,  47,  255, 52,  83,  52,  255, 76,  99,  42,  255, 95,  123, 36,  255, 68,  97,  32,  255, 85,  103, 38,  255, 158, 169,
    75,  255, 170, 183, 81,  255, 145, 155, 65,  255, 175, 191, 84,  255, 138, 176, 87,  255, 156, 184, 101, 255, 203, 220, 111, 255, 162, 179, 82,
    255, 174, 177, 82,  255, 186, 204, 123, 255, 208, 218, 122, 255, 190, 202, 120, 255, 178, 195, 109, 255, 210, 208, 106, 255, 144, 166, 68,  255,
    139, 172, 74,  255, 145, 177, 83,  255, 144, 176, 82,  255, 158, 188, 98,  255, 112, 149, 73,  255, 63,  105, 42,  255, 65,  95,  43,  255, 37,
    52,  31,  255, 63,  91,  52,  255, 84,  116, 69,  255, 69,  96,  53,  255, 58,  81,  39,  255, 47,  75,  42,  255, 47,  74,  39,  255, 58,  87,
    38,  255, 92,  126, 55,  255, 159, 181, 98,  255, 196, 216, 138, 255, 160, 193, 121, 255, 154, 189, 112, 255, 186, 213, 121, 255, 206, 212, 115,
    255, 116, 138, 74,  255, 110, 140, 80,  255, 112, 150, 76,  255, 126, 154, 69,  255, 104, 133, 83,  255, 160, 182, 102, 255, 171, 194, 99,  255,
    141, 175, 91,  255, 147, 178, 95,  255, 144, 174, 87,  255, 87,  105, 38,  255, 185, 184, 108, 255, 249, 248, 153, 255, 229, 231, 134, 255, 226,
    227, 125, 255, 228, 229, 124, 255, 238, 238, 130, 255, 224, 235, 115, 255, 186, 198, 103, 255, 103, 130, 42,  255, 179, 193, 89,  255, 187, 198,
    91,  255, 183, 196, 93,  255, 187, 203, 102, 255, 184, 202, 107, 255, 213, 220, 119, 255, 228, 232, 122, 255, 226, 231, 122, 255, 223, 229, 120,
    255, 210, 218, 104, 255, 140, 160, 68,  255, 117, 143, 58,  255, 97,  121, 55,  255, 84,  118, 40,  255, 142, 172, 56,  255, 151, 174, 69,  255,
    58,  84,  39,  255, 36,  55,  33,  255, 36,  49,  31,  255, 44,  60,  33,  255, 49,  72,  38,  255, 42,  60,  36,  255, 39,  56,  39,  255, 60,
    74,  48,  255, 73,  92,  48,  255, 66,  96,  43,  255, 41,  65,  36,  255, 37,  55,  31,  255, 55,  92,  34,  255, 47,  87,  28,  255, 39,  82,
    21,  255, 32,  72,  15,  255, 79,  103, 41,  255, 151, 161, 77,  255, 119, 132, 65,  255, 128, 147, 97,  255, 151, 168, 123, 255, 121, 140, 73,
    255, 81,  112, 44,  255, 122, 143, 71,  255, 135, 157, 68,  255, 86,  117, 49,  255, 92,  121, 48,  255, 164, 179, 105, 255, 183, 196, 123, 255,
    181, 198, 117, 255, 111, 135, 60,  255, 108, 141, 47,  255, 103, 133, 37,  255, 104, 128, 42,  255, 172, 194, 100, 255, 172, 192, 114, 255, 86,
    120, 65,  255, 95,  133, 74,  255, 108, 126, 63,  255, 26,  41,  23,  255, 28,  48,  21,  255, 62,  79,  37,  255, 119, 144, 62,  255, 150, 178,
    80,  255, 161, 188, 110, 255, 128, 155, 75,  255, 86,  117, 47,  255, 80,  112, 47,  255, 132, 160, 83,  255, 156, 181, 84,  255, 105, 138, 58,
    255, 77,  109, 50,  255, 62,  92,  38,  255, 128, 144, 81,  255, 171, 198, 97,  255, 178, 201, 102, 255, 147, 169, 84,  255, 103, 130, 56,  255,
    65,  92,  40,  255, 74,  104, 43,  255, 78,  112, 47,  255, 90,  127, 50,  255, 136, 171, 83,  255, 134, 165, 84,  255, 94,  127, 79,  255, 134,
    164, 84,  255, 159, 181, 93,  255, 191, 204, 122, 255, 139, 168, 102, 255, 174, 203, 148, 255, 169, 200, 143, 255, 186, 205, 133, 255, 98,  125,
    49,  255, 76,  97,  43,  255, 100, 115, 56,  255, 154, 171, 84,  255, 150, 170, 74,  255, 129, 156, 71,  255, 95,  121, 42,  255, 86,  111, 43,
    255, 60,  81,  36,  255, 58,  83,  31,  255, 142, 152, 58,  255, 228, 230, 136, 255, 205, 223, 141, 255, 191, 208, 120, 255, 142, 169, 68,  255,
    81,  119, 29,  255, 139, 150, 73,  255, 233, 227, 146, 255, 238, 234, 154, 255, 218, 223, 154, 255, 199, 213, 153, 255, 185, 207, 156, 255, 178,
    192, 128, 255, 73,  106, 42,  255, 110, 137, 47,  255, 116, 133, 49,  255, 83,  105, 40,  255, 48,  72,  19,  255, 60,  92,  26,  255, 69,  101,
    29,  255, 72,  104, 31,  255, 81,  111, 33,  255, 60,  73,  31,  255, 34,  40,  21,  255, 31,  38,  17,  255, 75,  99,  31,  255, 87,  119, 39,
    255, 75,  108, 28,  255, 68,  102, 23,  255, 62,  97,  21,  255, 48,  80,  19,  255, 50,  73,  26,  255, 101, 126, 47,  255, 124, 149, 65,  255,
    205, 218, 150, 255, 204, 223, 159, 255, 175, 197, 138, 255, 178, 203, 135, 255, 180, 206, 129, 255, 186, 209, 131, 255, 199, 215, 138, 255, 170,
    186, 99,  255, 81,  117, 48,  255, 96,  123, 39,  255, 121, 154, 50,  255, 132, 152, 55,  255, 189, 196, 119, 255, 172, 187, 111, 255, 135, 166,
    84,  255, 145, 176, 91,  255, 143, 175, 76,  255, 164, 169, 74,  255, 238, 227, 125, 255, 230, 222, 114, 255, 220, 216, 100, 255, 216, 215, 95,
    255, 217, 215, 90,  255, 223, 216, 87,  255, 100, 104, 36,  255, 65,  93,  21,  255, 114, 143, 38,  255, 112, 147, 39,  255, 103, 142, 33,  255,
    115, 148, 39,  255, 128, 156, 53,  255, 84,  104, 37,  255, 60,  73,  21,  255, 93,  114, 41,  255, 155, 173, 77,  255, 157, 175, 77,  255, 144,
    163, 68,  255, 156, 172, 67,  255, 196, 199, 72,  255, 196, 198, 63,  255, 178, 186, 60,  255, 177, 186, 63,  255, 175, 188, 60,  255, 154, 170,
    62,  255, 166, 180, 80,  255, 199, 215, 101, 255, 182, 196, 87,  255, 176, 183, 87,  255, 189, 190, 93,  255, 215, 224, 138, 255, 187, 213, 160,
    255, 173, 202, 143, 255, 180, 212, 166, 255, 213, 235, 193, 255, 213, 216, 144, 255, 127, 144, 62,  255, 116, 144, 62,  255, 111, 141, 58,  255,
    112, 134, 56,  255, 74,  89,  39,  255, 38,  60,  26,  255, 53,  80,  37,  255, 68,  99,  48,  255, 84,  122, 52,  255, 105, 143, 53,  255, 87,
    128, 47,  255, 68,  103, 34,  255, 83,  101, 40,  255, 80,  99,  29,  255, 55,  77,  12,  255, 151, 170, 80,  255, 156, 191, 120, 255, 141, 178,
    117, 255, 200, 215, 134, 255, 216, 224, 137, 255, 117, 136, 58,  255, 167, 166, 78,  255, 162, 154, 77,  255, 231, 230, 149, 255, 224, 224, 141,
    255, 162, 177, 77,  255, 132, 166, 65,  255, 139, 172, 71,  255, 150, 179, 86,  255, 156, 185, 95,  255, 164, 190, 99,  255, 128, 164, 77,  255,
    89,  122, 63,  255, 57,  84,  46,  255, 50,  73,  36,  255, 40,  58,  31,  255, 72,  99,  49,  255, 67,  98,  42,  255, 60,  98,  40,  255, 63,
    101, 47,  255, 58,  87,  46,  255, 48,  76,  39,  255, 53,  84,  37,  255, 154, 173, 96,  255, 198, 217, 141, 255, 163, 195, 126, 255, 175, 208,
    138, 255, 213, 218, 132, 255, 120, 143, 74,  255, 87,  128, 60,  255, 93,  125, 49,  255, 102, 126, 53,  255, 73,  94,  36,  255, 105, 136, 76,
    255, 182, 201, 112, 255, 193, 209, 105, 255, 179, 202, 117, 255, 169, 194, 99,  255, 140, 168, 81,  255, 69,  92,  42,  255, 101, 109, 49,  255,
    191, 187, 102, 255, 251, 248, 149, 255, 236, 233, 135, 255, 232, 230, 126, 255, 231, 228, 125, 255, 236, 233, 115, 255, 233, 238, 116, 255, 216,
    225, 86,  255, 185, 194, 78,  255, 165, 182, 87,  255, 228, 233, 145, 255, 235, 236, 154, 255, 234, 236, 155, 255, 236, 238, 152, 255, 238, 239,
    145, 255, 231, 233, 127, 255, 217, 223, 99,  255, 202, 212, 91,  255, 182, 201, 78,  255, 199, 209, 82,  255, 131, 148, 74,  255, 87,  108, 47,
    255, 96,  127, 33,  255, 163, 186, 67,  255, 130, 150, 68,  255, 73,  100, 47,  255, 79,  105, 49,  255, 52,  68,  34,  255, 48,  74,  32,  255,
    52,  83,  31,  255, 53,  87,  36,  255, 55,  76,  43,  255, 71,  87,  50,  255, 63,  86,  44,  255, 38,  58,  36,  255, 44,  65,  33,  255, 56,
    96,  31,  255, 52,  90,  26,  255, 62,  95,  26,  255, 101, 125, 50,  255, 139, 156, 84,  255, 173, 189, 108, 255, 192, 203, 116, 255, 177, 191,
    117, 255, 181, 193, 124, 255, 112, 118, 63,  255, 74,  90,  39,  255, 129, 147, 65,  255, 121, 147, 55,  255, 78,  111, 40,  255, 85,  114, 43,
    255, 109, 135, 46,  255, 103, 134, 63,  255, 118, 149, 81,  255, 118, 139, 90,  255, 116, 142, 92,  255, 163, 183, 98,  255, 169, 189, 123, 255,
    185, 212, 152, 255, 169, 191, 107, 255, 134, 164, 99,  255, 162, 191, 100, 255, 34,  47,  23,  255, 34,  52,  26,  255, 29,  51,  23,  255, 45,
    60,  31,  255, 92,  110, 49,  255, 119, 148, 60,  255, 139, 168, 96,  255, 121, 152, 108, 255, 127, 157, 112, 255, 163, 191, 114, 255, 173, 191,
    108, 255, 85,  99,  55,  255, 72,  94,  36,  255, 63,  92,  31,  255, 47,  79,  31,  255, 104, 130, 71,  255, 180, 204, 110, 255, 175, 201, 95,
    255, 178, 197, 104, 255, 170, 188, 97,  255, 94,  121, 52,  255, 58,  84,  37,  255, 77,  110, 44,  255, 87,  119, 55,  255, 135, 171, 87,  255,
    141, 173, 90,  255, 133, 160, 92,  255, 154, 179, 91,  255, 130, 151, 75,  255, 186, 201, 119, 255, 141, 173, 105, 255, 167, 199, 143, 255, 175,
    203, 137, 255, 140, 164, 75,  255, 49,  68,  29,  255, 32,  41,  26,  255, 34,  51,  28,  255, 48,  76,  31,  255, 95,  130, 55,  255, 106, 146,
    71,  255, 83,  116, 37,  255, 74,  101, 26,  255, 31,  39,  23,  255, 32,  48,  26,  255, 102, 124, 38,  255, 193, 202, 76,  255, 207, 213, 113,
    255, 179, 199, 98,  255, 114, 148, 65,  255, 150, 170, 91,  255, 230, 228, 149, 255, 221, 224, 149, 255, 210, 219, 153, 255, 190, 208, 150, 255,
    185, 209, 151, 255, 210, 222, 151, 255, 121, 140, 58,  255, 102, 131, 36,  255, 109, 127, 44,  255, 93,  113, 42,  255, 150, 175, 109, 255, 39,
    55,  28,  255, 60,  84,  23,  255, 75,  104, 29,  255, 83,  111, 31,  255, 75,  93,  33,  255, 44,  55,  28,  255, 29,  44,  19,  255, 23,  36,
    17,  255, 55,  67,  21,  255, 100, 126, 39,  255, 90,  122, 36,  255, 81,  115, 31,  255, 77,  108, 31,  255, 67,  102, 25,  255, 42,  65,  17,
    255, 76,  91,  29,  255, 151, 172, 95,  255, 173, 187, 121, 255, 196, 204, 120, 255, 205, 218, 123, 255, 207, 215, 120, 255, 190, 194, 115, 255,
    164, 167, 75,  255, 197, 201, 92,  255, 184, 201, 98,  255, 105, 143, 43,  255, 104, 131, 47,  255, 123, 148, 65,  255, 123, 155, 67,  255, 108,
    143, 71,  255, 119, 155, 75,  255, 114, 145, 80,  255, 135, 164, 84,  255, 149, 178, 80,  255, 139, 145, 58,  255, 241, 230, 126, 255, 224, 220,
    111, 255, 224, 220, 104, 255, 239, 230, 112, 255, 231, 217, 106, 255, 125, 125, 58,  255, 60,  82,  19,  255, 160, 174, 48,  255, 162, 178, 53,
    255, 150, 172, 53,  255, 139, 168, 50,  255, 144, 172, 58,  255, 173, 192, 82,  255, 109, 121, 58,  255, 38,  48,  19,  255, 151, 165, 79,  255,
    166, 180, 86,  255, 154, 171, 76,  255, 149, 167, 69,  255, 208, 204, 83,  255, 218, 213, 76,  255, 203, 202, 67,  255, 202, 201, 80,  255, 208,
    206, 79,  255, 207, 205, 73,  255, 198, 200, 75,  255, 154, 169, 68,  255, 173, 189, 91,  255, 161, 193, 71,  255, 185, 197, 76,  255, 175, 180,
    92,  255, 190, 214, 151, 255, 160, 193, 134, 255, 186, 214, 172, 255, 210, 235, 197, 255, 217, 221, 159, 255, 113, 122, 47,  255, 95,  117, 43,
    255, 104, 124, 49,  255, 83,  98,  37,  255, 34,  37,  19,  255, 21,  34,  17,  255, 44,  74,  32,  255, 71,  99,  48,  255, 116, 147, 58,  255,
    124, 161, 60,  255, 105, 143, 58,  255, 95,  135, 53,  255, 90,  132, 40,  255, 89,  122, 40,  255, 62,  86,  31,  255, 57,  84,  21,  255, 141,
    156, 77,  255, 171, 200, 139, 255, 149, 185, 132, 255, 171, 198, 142, 255, 226, 231, 146, 255, 161, 178, 93,  255, 55,  75,  28,  255, 23,  31,
    15,  255, 134, 121, 78,  255, 173, 174, 98,  255, 144, 173, 74,  255, 153, 181, 86,  255, 157, 186, 97,  255, 162, 191, 102, 255, 170, 200, 105,
    255, 169, 196, 106, 255, 134, 164, 77,  255, 119, 147, 65,  255, 87,  115, 55,  255, 53,  79,  36,  255, 44,  69,  37,  255, 47,  75,  33,  255,
    58,  97,  36,  255, 77,  120, 44,  255, 86,  127, 47,  255, 67,  100, 46,  255, 58,  87,  41,  255, 52,  81,  38,  255, 103, 121, 62,  255, 192,
    216, 146, 255, 186, 217, 148, 255, 214, 223, 142, 255, 147, 161, 78,  255, 83,  122, 40,  255, 96,  126, 45,  255, 69,  90,  34,  255, 60,  87,
    36,  255, 60,  91,  31,  255, 108, 135, 68,  255, 197, 213, 131, 255, 198, 216, 116, 255, 197, 213, 111, 255, 171, 191, 84,  255, 136, 168, 82,
    255, 119, 139, 62,  255, 74,  86,  43,  255, 53,  65,  32,  255, 197, 194, 105, 255, 253, 248, 154, 255, 241, 236, 134, 255, 237, 233, 124, 255,
    231, 229, 119, 255, 221, 226, 111, 255, 211, 219, 94,  255, 153, 163, 60,  255, 213, 222, 119, 255, 251, 246, 143, 255, 243, 239, 135, 255, 238,
    238, 131, 255, 239, 238, 129, 255, 243, 241, 144, 255, 243, 238, 147, 255, 218, 218, 100, 255, 197, 209, 81,  255, 181, 192, 89,  255, 169, 172,
    90,  255, 177, 192, 76,  255, 157, 179, 58,  255, 138, 166, 60,  255, 137, 162, 60,  255, 89,  108, 52,  255, 94,  119, 55,  255, 142, 162, 83,
    255, 155, 169, 90,  255, 148, 162, 95,  255, 153, 167, 95,  255, 105, 130, 62,  255, 79,  104, 45,  255, 72,  90,  53,  255, 60,  75,  46,  255,
    52,  68,  39,  255, 47,  71,  32,  255, 52,  92,  25,  255, 90,  117, 43,  255, 158, 173, 90,  255, 161, 186, 112, 255, 151, 183, 125, 255, 150,
    185, 129, 255, 155, 188, 133, 255, 163, 195, 141, 255, 171, 200, 140, 255, 183, 209, 144, 255, 154, 167, 113, 255, 140, 152, 68,  255, 119, 138,
    47,  255, 76,  104, 36,  255, 87,  119, 46,  255, 126, 149, 58,  255, 105, 143, 71,  255, 132, 161, 97,  255, 204, 210, 112, 255, 234, 236, 139,
    255, 211, 226, 166, 255, 180, 212, 176, 255, 170, 202, 137, 255, 183, 206, 106, 255, 194, 215, 105, 255, 123, 145, 58,  255, 26,  41,  23,  255,
    60,  82,  36,  255, 98,  114, 56,  255, 108, 129, 68,  255, 136, 165, 91,  255, 156, 185, 107, 255, 175, 199, 122, 255, 179, 202, 134, 255, 173,
    195, 128, 255, 149, 162, 100, 255, 58,  65,  41,  255, 6,   9,   9,   255, 75,  81,  81,  255, 105, 119, 79,  255, 103, 130, 49,  255, 95,  126,
    55,  255, 169, 192, 106, 255, 193, 216, 110, 255, 174, 195, 112, 255, 184, 204, 126, 255, 158, 169, 90,  255, 69,  95,  37,  255, 82,  114, 47,
    255, 82,  111, 56,  255, 139, 171, 91,  255, 148, 178, 96,  255, 162, 187, 99,  255, 125, 148, 72,  255, 101, 130, 55,  255, 171, 190, 105, 255,
    151, 180, 116, 255, 171, 201, 146, 255, 158, 184, 87,  255, 118, 151, 40,  255, 75,  91,  36,  255, 53,  71,  32,  255, 60,  84,  31,  255, 68,
    95,  33,  255, 104, 138, 56,  255, 109, 146, 67,  255, 82,  119, 37,  255, 56,  81,  21,  255, 32,  44,  23,  255, 40,  60,  29,  255, 58,  73,
    32,  255, 102, 128, 47,  255, 117, 152, 65,  255, 145, 166, 81,  255, 153, 179, 99,  255, 192, 206, 116, 255, 207, 215, 135, 255, 199, 210, 148,
    255, 187, 207, 147, 255, 183, 205, 143, 255, 228, 230, 144, 255, 143, 148, 71,  255, 50,  67,  17,  255, 60,  74,  25,  255, 50,  72,  23,  255,
    120, 137, 72,  255, 197, 215, 150, 255, 123, 150, 95,  255, 52,  82,  25,  255, 56,  81,  26,  255, 76,  102, 34,  255, 56,  72,  33,  255, 33,
    46,  28,  255, 36,  52,  23,  255, 29,  40,  23,  255, 29,  37,  21,  255, 72,  87,  26,  255, 102, 128, 47,  255, 96,  127, 48,  255, 92,  123,
    47,  255, 78,  110, 34,  255, 82,  105, 43,  255, 118, 136, 73,  255, 143, 166, 68,  255, 163, 187, 82,  255, 179, 192, 81,  255, 161, 165, 67,
    255, 93,  97,  42,  255, 52,  71,  19,  255, 111, 136, 43,  255, 149, 181, 55,  255, 125, 152, 39,  255, 133, 159, 67,  255, 123, 148, 65,  255,
    132, 152, 74,  255, 128, 152, 67,  255, 137, 169, 87,  255, 152, 179, 106, 255, 159, 183, 123, 255, 184, 201, 127, 255, 195, 211, 124, 255, 188,
    199, 114, 255, 216, 215, 118, 255, 197, 198, 84,  255, 229, 221, 120, 255, 195, 188, 94,  255, 101, 115, 49,  255, 37,  72,  31,  255, 77,  94,
    31,  255, 185, 188, 62,  255, 183, 193, 65,  255, 182, 193, 68,  255, 175, 191, 74,  255, 173, 192, 76,  255, 193, 205, 91,  255, 161, 173, 84,
    255, 95,  110, 46,  255, 166, 180, 91,  255, 161, 176, 84,  255, 152, 167, 73,  255, 155, 167, 68,  255, 221, 215, 99,  255, 224, 220, 92,  255,
    216, 215, 87,  255, 221, 216, 92,  255, 223, 218, 92,  255, 227, 219, 94,  255, 192, 190, 76,  255, 138, 146, 56,  255, 152, 154, 68,  255, 163,
    184, 78,  255, 162, 194, 60,  255, 180, 203, 118, 255, 167, 197, 134, 255, 186, 212, 152, 255, 209, 228, 181, 255, 190, 199, 137, 255, 135, 142,
    74,  255, 143, 160, 86,  255, 180, 191, 109, 255, 190, 197, 114, 255, 167, 174, 107, 255, 104, 108, 72,  255, 83,  99,  58,  255, 119, 152, 79,
    255, 134, 161, 74,  255, 140, 168, 67,  255, 99,  135, 62,  255, 89,  126, 60,  255, 86,  126, 52,  255, 95,  139, 42,  255, 116, 154, 49,  255,
    77,  100, 45,  255, 65,  92,  37,  255, 102, 125, 53,  255, 186, 206, 134, 255, 162, 195, 138, 255, 157, 190, 143, 255, 205, 221, 146, 255, 182,
    189, 99,  255, 39,  52,  21,  255, 28,  43,  21,  255, 21,  37,  12,  255, 93,  119, 44,  255, 165, 193, 92,  255, 165, 191, 100, 255, 174, 198,
    110, 255, 176, 201, 107, 255, 177, 203, 110, 255, 153, 177, 98,  255, 109, 133, 79,  255, 133, 154, 86,  255, 89,  105, 47,  255, 48,  75,  31,
    255, 75,  118, 44,  255, 62,  99,  42,  255, 56,  99,  40,  255, 75,  117, 42,  255, 99,  139, 56,  255, 92,  124, 55,  255, 44,  63,  31,  255,
    41,  60,  31,  255, 28,  37,  17,  255, 143, 159, 101, 255, 181, 188, 110, 255, 128, 145, 60,  255, 100, 134, 47,  255, 80,  109, 42,  255, 60,
    83,  33,  255, 53,  83,  28,  255, 65,  99,  32,  255, 77,  103, 43,  255, 97,  122, 58,  255, 197, 212, 145, 255, 204, 219, 122, 255, 179, 197,
    84,  255, 164, 187, 76,  255, 130, 158, 73,  255, 115, 133, 58,  255, 63,  91,  36,  255, 37,  65,  25,  255, 75,  94,  33,  255, 220, 222, 122,
    255, 243, 241, 140, 255, 241, 232, 122, 255, 235, 231, 109, 255, 227, 228, 99,  255, 209, 213, 93,  255, 186, 198, 68,  255, 232, 230, 89,  255,
    196, 196, 74,  255, 221, 223, 94,  255, 231, 230, 107, 255, 232, 228, 107, 255, 233, 227, 112, 255, 224, 220, 90,  255, 224, 221, 97,  255, 195,
    205, 91,  255, 185, 201, 87,  255, 187, 203, 91,  255, 208, 220, 77,  255, 201, 207, 75,  255, 170, 175, 75,  255, 171, 188, 82,  255, 120, 145,
    69,  255, 169, 189, 101, 255, 187, 206, 128, 255, 168, 194, 129, 255, 164, 195, 132, 255, 179, 204, 140, 255, 185, 205, 140, 255, 173, 191, 123,
    255, 124, 138, 87,  255, 65,  78,  49,  255, 53,  68,  37,  255, 53,  79,  33,  255, 96,  121, 48,  255, 150, 172, 97,  255, 143, 173, 114, 255,
    145, 175, 121, 255, 151, 181, 127, 255, 154, 185, 129, 255, 160, 189, 132, 255, 173, 201, 136, 255, 181, 207, 135, 255, 191, 212, 136, 255, 195,
    213, 138, 255, 187, 199, 110, 255, 202, 204, 95,  255, 134, 147, 63,  255, 84,  114, 40,  255, 124, 145, 52,  255, 139, 163, 75,  255, 226, 227,
    130, 255, 251, 249, 146, 255, 217, 221, 139, 255, 197, 216, 173, 255, 173, 202, 136, 255, 150, 183, 86,  255, 164, 195, 90,  255, 124, 153, 65,
    255, 36,  55,  26,  255, 80,  95,  49,  255, 132, 153, 76,  255, 120, 151, 84,  255, 120, 159, 98,  255, 120, 161, 102, 255, 125, 164, 105, 255,
    151, 182, 113, 255, 150, 185, 115, 255, 127, 160, 91,  255, 39,  48,  26,  255, 12,  12,  15,  255, 12,  17,  15,  255, 90,  102, 93,  255, 127,
    145, 89,  255, 165, 187, 72,  255, 167, 184, 84,  255, 190, 201, 112, 255, 177, 200, 98,  255, 192, 208, 120, 255, 197, 208, 126, 255, 171, 181,
    108, 255, 78,  102, 41,  255, 80,  112, 52,  255, 75,  105, 62,  255, 140, 169, 95,  255, 155, 182, 98,  255, 130, 151, 72,  255, 87,  116, 44,
    255, 81,  115, 37,  255, 161, 185, 94,  255, 165, 191, 115, 255, 178, 201, 112, 255, 131, 163, 60,  255, 124, 161, 62,  255, 108, 142, 55,  255,
    98,  131, 41,  255, 113, 154, 44,  255, 119, 159, 47,  255, 131, 167, 60,  255, 122, 152, 62,  255, 49,  76,  21,  255, 39,  58,  21,  255, 53,
    77,  33,  255, 68,  98,  43,  255, 74,  91,  41,  255, 117, 136, 48,  255, 122, 156, 62,  255, 202, 211, 112, 255, 196, 215, 124, 255, 186, 208,
    137, 255, 188, 207, 147, 255, 192, 204, 148, 255, 219, 226, 147, 255, 239, 236, 139, 255, 137, 146, 58,  255, 23,  34,  9,   255, 32,  41,  21,
    255, 34,  48,  21,  255, 50,  63,  19,  255, 157, 176, 118, 255, 185, 209, 156, 255, 162, 191, 141, 255, 47,  75,  23,  255, 55,  81,  31,  255,
    78,  105, 38,  255, 69,  90,  38,  255, 34,  47,  23,  255, 37,  52,  26,  255, 31,  44,  26,  255, 31,  41,  25,  255, 29,  46,  19,  255, 55,
    79,  23,  255, 86,  107, 39,  255, 89,  113, 40,  255, 87,  108, 36,  255, 173, 182, 103, 255, 145, 166, 91,  255, 145, 164, 73,  255, 190, 200,
    99,  255, 129, 146, 74,  255, 37,  62,  34,  255, 46,  75,  39,  255, 65,  97,  41,  255, 115, 140, 55,  255, 71,  81,  31,  255, 23,  21,  12,
    255, 83,  91,  39,  255, 126, 149, 62,  255, 127, 152, 71,  255, 143, 164, 94,  255, 181, 199, 137, 255, 180, 200, 141, 255, 180, 204, 140, 255,
    165, 193, 137, 255, 174, 195, 131, 255, 166, 193, 126, 255, 160, 186, 112, 255, 158, 181, 67,  255, 158, 170, 73,  255, 125, 144, 62,  255, 126,
    147, 62,  255, 101, 131, 52,  255, 60,  91,  23,  255, 168, 166, 58,  255, 208, 209, 82,  255, 209, 210, 92,  255, 207, 209, 96,  255, 206, 206,
    95,  255, 193, 196, 93,  255, 225, 218, 105, 255, 215, 210, 107, 255, 220, 217, 114, 255, 197, 205, 108, 255, 173, 187, 98,  255, 197, 205, 124,
    255, 245, 241, 155, 255, 248, 243, 157, 255, 243, 239, 154, 255, 246, 241, 147, 255, 245, 236, 134, 255, 207, 207, 101, 255, 121, 135, 60,  255,
    21,  21,  12,  255, 34,  47,  17,  255, 80,  100, 26,  255, 156, 183, 72,  255, 185, 210, 139, 255, 192, 213, 137, 255, 188, 210, 73,  255, 197,
    213, 82,  255, 195, 202, 96,  255, 220, 222, 128, 255, 227, 227, 139, 255, 200, 211, 138, 255, 188, 203, 139, 255, 179, 200, 138, 255, 192, 210,
    142, 255, 188, 206, 140, 255, 192, 204, 133, 255, 180, 196, 117, 255, 134, 162, 86,  255, 84,  125, 69,  255, 89,  129, 65,  255, 97,  139, 52,
    255, 128, 167, 52,  255, 122, 153, 55,  255, 75,  106, 45,  255, 67,  92,  37,  255, 60,  91,  28,  255, 133, 147, 67,  255, 204, 221, 151, 255,
    158, 190, 149, 255, 195, 215, 157, 255, 161, 170, 87,  255, 52,  81,  32,  255, 50,  76,  34,  255, 36,  62,  21,  255, 97,  124, 41,  255, 167,
    194, 87,  255, 173, 195, 93,  255, 177, 198, 87,  255, 193, 211, 117, 255, 200, 215, 139, 255, 186, 202, 126, 255, 164, 181, 116, 255, 158, 175,
    116, 255, 65,  75,  50,  255, 26,  40,  19,  255, 74,  104, 34,  255, 94,  137, 47,  255, 72,  112, 48,  255, 69,  108, 49,  255, 117, 155, 77,
    255, 128, 158, 80,  255, 45,  63,  33,  255, 42,  62,  32,  255, 21,  28,  21,  255, 60,  68,  43,  255, 90,  113, 49,  255, 95,  133, 55,  255,
    128, 162, 86,  255, 140, 175, 96,  255, 124, 159, 81,  255, 104, 138, 60,  255, 87,  118, 47,  255, 73,  92,  47,  255, 75,  97,  41,  255, 152,
    169, 93,  255, 207, 222, 132, 255, 179, 200, 99,  255, 171, 192, 90,  255, 167, 189, 77,  255, 192, 208, 110, 255, 181, 201, 121, 255, 113, 130,
    80,  255, 40,  55,  23,  255, 108, 113, 50,  255, 223, 229, 116, 255, 231, 238, 144, 255, 236, 239, 126, 255, 231, 235, 101, 255, 231, 229, 91,
    255, 249, 246, 91,  255, 238, 233, 96,  255, 178, 187, 65,  255, 210, 218, 74,  255, 233, 228, 101, 255, 238, 230, 111, 255, 232, 226, 111, 255,
    220, 220, 90,  255, 222, 221, 94,  255, 218, 218, 109, 255, 191, 204, 97,  255, 182, 203, 133, 255, 190, 197, 103, 255, 117, 121, 47,  255, 117,
    134, 65,  255, 121, 143, 63,  255, 155, 177, 92,  255, 167, 194, 127, 255, 160, 189, 130, 255, 133, 160, 107, 255, 132, 161, 107, 255, 174, 201,
    144, 255, 188, 211, 153, 255, 197, 217, 157, 255, 131, 143, 105, 255, 74,  84,  55,  255, 39,  51,  31,  255, 78,  94,  47,  255, 130, 156, 87,
    255, 119, 153, 91,  255, 132, 165, 102, 255, 145, 175, 102, 255, 158, 185, 108, 255, 171, 196, 112, 255, 179, 197, 112, 255, 155, 172, 94,  255,
    95,  110, 58,  255, 116, 125, 71,  255, 158, 168, 99,  255, 136, 149, 82,  255, 122, 136, 60,  255, 119, 134, 53,  255, 144, 157, 72,  255, 107,
    124, 58,  255, 106, 122, 52,  255, 204, 214, 134, 255, 185, 206, 158, 255, 167, 186, 125, 255, 208, 213, 142, 255, 187, 202, 119, 255, 134, 169,
    71,  255, 139, 171, 75,  255, 47,  65,  29,  255, 29,  44,  26,  255, 137, 155, 82,  255, 134, 159, 99,  255, 123, 158, 104, 255, 121, 160, 105,
    255, 122, 162, 110, 255, 121, 160, 113, 255, 118, 155, 110, 255, 129, 165, 110, 255, 152, 181, 105, 255, 123, 152, 68,  255, 77,  104, 34,  255,
    60,  82,  31,  255, 106, 129, 68,  255, 85,  104, 43,  255, 74,  94,  36,  255, 148, 162, 82,  255, 206, 219, 126, 255, 170, 192, 106, 255, 196,
    210, 127, 255, 222, 223, 134, 255, 127, 141, 68,  255, 63,  95,  36,  255, 72,  103, 55,  255, 69,  102, 72,  255, 119, 153, 86,  255, 154, 177,
    90,  255, 176, 192, 118, 255, 128, 155, 76,  255, 92,  120, 44,  255, 114, 137, 60,  255, 130, 156, 69,  255, 127, 152, 65,  255, 121, 154, 60,
    255, 105, 142, 52,  255, 82,  121, 41,  255, 87,  124, 45,  255, 107, 141, 52,  255, 124, 158, 58,  255, 137, 173, 68,  255, 107, 128, 56,  255,
    49,  60,  31,  255, 72,  89,  38,  255, 94,  112, 47,  255, 122, 144, 65,  255, 108, 126, 48,  255, 101, 111, 32,  255, 155, 166, 67,  255, 232,
    221, 112, 255, 225, 236, 143, 255, 203, 221, 152, 255, 202, 220, 163, 255, 205, 213, 132, 255, 223, 219, 124, 255, 164, 175, 78,  255, 52,  83,
    29,  255, 19,  31,  17,  255, 21,  28,  15,  255, 43,  65,  28,  255, 55,  67,  23,  255, 166, 183, 124, 255, 170, 196, 140, 255, 161, 183, 143,
    255, 47,  75,  23,  255, 67,  97,  29,  255, 91,  113, 41,  255, 56,  67,  31,  255, 34,  47,  21,  255, 41,  58,  26,  255, 38,  60,  29,  255,
    31,  48,  26,  255, 62,  82,  33,  255, 129, 153, 53,  255, 158, 180, 73,  255, 145, 172, 68,  255, 129, 162, 65,  255, 135, 164, 73,  255, 135,
    157, 71,  255, 155, 169, 85,  255, 190, 199, 103, 255, 161, 176, 96,  255, 111, 134, 75,  255, 170, 188, 111, 255, 183, 201, 121, 255, 149, 174,
    100, 255, 42,  55,  36,  255, 3,   3,   6,   255, 65,  71,  33,  255, 118, 144, 53,  255, 140, 160, 74,  255, 187, 206, 151, 255, 155, 187, 148,
    255, 150, 183, 145, 255, 157, 186, 140, 255, 159, 190, 144, 255, 145, 178, 135, 255, 139, 173, 126, 255, 161, 186, 119, 255, 173, 197, 87,  255,
    177, 198, 84,  255, 153, 171, 78,  255, 132, 149, 67,  255, 124, 143, 60,  255, 89,  118, 41,  255, 106, 111, 32,  255, 226, 218, 104, 255, 209,
    209, 95,  255, 180, 189, 84,  255, 155, 174, 93,  255, 141, 164, 90,  255, 176, 186, 101, 255, 143, 165, 96,  255, 189, 194, 107, 255, 248, 241,
    147, 255, 241, 243, 169, 255, 241, 241, 171, 255, 227, 235, 171, 255, 222, 232, 170, 255, 217, 228, 165, 255, 216, 226, 161, 255, 225, 229, 158,
    255, 225, 230, 145, 255, 164, 177, 105, 255, 72,  84,  42,  255, 126, 150, 62,  255, 98,  136, 52,  255, 100, 126, 47,  255, 152, 168, 82,  255,
    170, 177, 100, 255, 173, 194, 92,  255, 193, 213, 108, 255, 201, 215, 122, 255, 199, 211, 138, 255, 173, 196, 139, 255, 153, 183, 137, 255, 153,
    185, 138, 255, 153, 185, 135, 255, 157, 187, 139, 255, 163, 191, 137, 255, 190, 208, 144, 255, 214, 226, 155, 255, 166, 182, 119, 255, 98,  137,
    81,  255, 100, 140, 69,  255, 130, 168, 65,  255, 167, 190, 72,  255, 135, 159, 81,  255, 101, 129, 65,  255, 75,  102, 39,  255, 62,  89,  34,
    255, 75,  101, 31,  255, 172, 181, 99,  255, 180, 210, 157, 255, 186, 207, 152, 255, 141, 155, 82,  255, 188, 207, 120, 255, 198, 216, 128, 255,
    165, 191, 103, 255, 125, 147, 68,  255, 96,  113, 41,  255, 160, 185, 69,  255, 201, 220, 114, 255, 218, 227, 133, 255, 224, 229, 139, 255, 229,
    231, 141, 255, 231, 234, 142, 255, 224, 231, 143, 255, 145, 158, 98,  255, 40,  56,  32,  255, 40,  60,  23,  255, 79,  102, 38,  255, 101, 135,
    55,  255, 87,  117, 58,  255, 104, 132, 60,  255, 133, 161, 81,  255, 52,  71,  36,  255, 44,  63,  32,  255, 23,  37,  23,  255, 43,  55,  34,
    255, 100, 127, 68,  255, 147, 184, 111, 255, 127, 166, 106, 255, 124, 160, 104, 255, 117, 152, 87,  255, 118, 153, 81,  255, 113, 148, 67,  255,
    91,  125, 50,  255, 74,  104, 47,  255, 91,  115, 50,  255, 176, 195, 97,  255, 179, 197, 101, 255, 177, 200, 77,  255, 203, 221, 91,  255, 221,
    229, 111, 255, 227, 230, 122, 255, 182, 193, 96,  255, 87,  119, 47,  255, 73,  103, 52,  255, 133, 148, 75,  255, 185, 186, 105, 255, 195, 191,
    105, 255, 161, 155, 69,  255, 121, 129, 41,  255, 176, 186, 72,  255, 228, 226, 86,  255, 230, 229, 84,  255, 238, 232, 97,  255, 239, 233, 108,
    255, 239, 232, 106, 255, 236, 228, 90,  255, 229, 222, 86,  255, 228, 224, 96,  255, 234, 229, 133, 255, 203, 211, 118, 255, 197, 215, 143, 255,
    162, 176, 119, 255, 71,  84,  38,  255, 78,  97,  42,  255, 143, 169, 78,  255, 146, 176, 87,  255, 162, 188, 121, 255, 167, 192, 122, 255, 178,
    196, 126, 255, 188, 201, 126, 255, 200, 212, 134, 255, 172, 190, 119, 255, 128, 154, 82,  255, 29,  43,  23,  255, 76,  90,  48,  255, 78,  97,
    41,  255, 76,  98,  50,  255, 130, 166, 78,  255, 146, 174, 83,  255, 156, 180, 92,  255, 161, 179, 90,  255, 160, 177, 87,  255, 130, 148, 74,
    255, 60,  68,  38,  255, 44,  60,  31,  255, 38,  60,  31,  255, 65,  91,  34,  255, 99,  131, 44,  255, 71,  98,  33,  255, 143, 146, 71,  255,
    227, 221, 121, 255, 233, 232, 142, 255, 218, 222, 145, 255, 190, 195, 128, 255, 206, 215, 148, 255, 171, 197, 158, 255, 158, 186, 146, 255, 166,
    184, 115, 255, 222, 230, 154, 255, 192, 203, 115, 255, 63,  82,  32,  255, 29,  42,  21,  255, 91,  106, 52,  255, 205, 214, 158, 255, 229, 233,
    164, 255, 205, 208, 139, 255, 127, 161, 108, 255, 125, 162, 116, 255, 118, 156, 111, 255, 108, 146, 101, 255, 142, 173, 107, 255, 148, 174, 90,
    255, 99,  130, 56,  255, 157, 171, 94,  255, 210, 212, 129, 255, 231, 231, 147, 255, 227, 226, 141, 255, 154, 156, 86,  255, 158, 159, 95,  255,
    184, 198, 125, 255, 143, 173, 115, 255, 170, 187, 112, 255, 211, 223, 135, 255, 197, 205, 119, 255, 126, 138, 68,  255, 127, 141, 82,  255, 133,
    149, 90,  255, 109, 130, 65,  255, 164, 179, 97,  255, 198, 219, 152, 255, 171, 201, 133, 255, 157, 185, 107, 255, 124, 148, 69,  255, 128, 144,
    60,  255, 43,  60,  23,  255, 62,  92,  32,  255, 80,  115, 38,  255, 83,  120, 39,  255, 84,  123, 43,  255, 92,  129, 52,  255, 94,  128, 47,
    255, 71,  99,  36,  255, 60,  80,  32,  255, 120, 142, 60,  255, 113, 138, 58,  255, 76,  92,  37,  255, 85,  91,  41,  255, 42,  55,  23,  255,
    25,  31,  15,  255, 92,  108, 45,  255, 138, 142, 52,  255, 235, 226, 117, 255, 233, 230, 124, 255, 205, 209, 101, 255, 174, 188, 80,  255, 162,
    181, 87,  255, 118, 150, 75,  255, 73,  108, 52,  255, 45,  65,  26,  255, 104, 128, 62,  255, 145, 180, 93,  255, 74,  101, 34,  255, 157, 175,
    121, 255, 164, 194, 140, 255, 126, 152, 80,  255, 49,  73,  23,  255, 60,  84,  31,  255, 58,  76,  31,  255, 42,  58,  23,  255, 44,  67,  25,
    255, 44,  65,  23,  255, 47,  69,  36,  255, 71,  90,  37,  255, 175, 188, 69,  255, 191, 208, 89,  255, 149, 178, 74,  255, 122, 160, 60,  255,
    125, 159, 68,  255, 155, 178, 101, 255, 127, 148, 87,  255, 155, 169, 85,  255, 183, 195, 97,  255, 200, 207, 111, 255, 204, 214, 124, 255, 199,
    210, 125, 255, 187, 200, 127, 255, 176, 189, 121, 255, 162, 180, 101, 255, 32,  42,  25,  255, 39,  40,  19,  255, 112, 135, 55,  255, 111, 139,
    55,  255, 137, 146, 67,  255, 184, 198, 124, 255, 169, 199, 137, 255, 149, 183, 125, 255, 166, 193, 124, 255, 175, 199, 134, 255, 170, 199, 142,
    255, 166, 195, 139, 255, 154, 183, 103, 255, 178, 196, 102, 255, 181, 197, 94,  255, 128, 152, 75,  255, 147, 167, 96,  255, 175, 190, 108, 255,
    127, 149, 69,  255, 167, 165, 68,  255, 168, 185, 86,  255, 136, 160, 84,  255, 137, 163, 93,  255, 138, 166, 99,  255, 133, 162, 100, 255, 166,
    184, 120, 255, 224, 228, 157, 255, 226, 233, 170, 255, 201, 220, 170, 255, 198, 219, 167, 255, 197, 219, 172, 255, 197, 220, 172, 255, 196, 219,
    172, 255, 192, 215, 164, 255, 186, 209, 157, 255, 188, 209, 156, 255, 212, 222, 153, 255, 238, 241, 138, 255, 210, 224, 105, 255, 175, 204, 90,
    255, 142, 176, 77,  255, 82,  115, 36,  255, 87,  112, 36,  255, 196, 204, 123, 255, 180, 196, 134, 255, 162, 187, 136, 255, 164, 192, 140, 255,
    162, 191, 141, 255, 159, 189, 141, 255, 170, 196, 147, 255, 173, 197, 142, 255, 163, 192, 135, 255, 173, 201, 136, 255, 192, 206, 125, 255, 156,
    159, 84,  255, 130, 160, 101, 255, 118, 159, 92,  255, 149, 179, 75,  255, 178, 192, 74,  255, 153, 167, 75,  255, 123, 144, 62,  255, 95,  120,
    39,  255, 79,  110, 33,  255, 77,  106, 38,  255, 62,  87,  33,  255, 69,  93,  25,  255, 145, 147, 84,  255, 146, 153, 87,  255, 197, 210, 115,
    255, 219, 228, 126, 255, 214, 226, 123, 255, 219, 232, 124, 255, 203, 221, 109, 255, 131, 154, 63,  255, 169, 185, 75,  255, 181, 185, 84,  255,
    215, 216, 114, 255, 238, 239, 146, 255, 233, 238, 148, 255, 233, 236, 140, 255, 233, 230, 137, 255, 200, 192, 112, 255, 81,  103, 43,  255, 42,
    77,  26,  255, 47,  72,  32,  255, 56,  68,  31,  255, 56,  68,  31,  255, 47,  60,  28,  255, 74,  87,  43,  255, 43,  56,  32,  255, 34,  48,
    31,  255, 21,  31,  21,  255, 71,  94,  48,  255, 160, 191, 121, 255, 127, 164, 120, 255, 114, 154, 105, 255, 108, 148, 96,  255, 101, 141, 82,
    255, 93,  135, 68,  255, 92,  133, 60,  255, 121, 158, 62,  255, 81,  102, 47,  255, 80,  106, 53,  255, 171, 185, 97,  255, 169, 184, 87,  255,
    195, 214, 87,  255, 215, 220, 107, 255, 191, 197, 90,  255, 145, 166, 60,  255, 121, 159, 55,  255, 135, 175, 69,  255, 158, 194, 106, 255, 157,
    187, 119, 255, 58,  63,  34,  255, 26,  33,  15,  255, 25,  43,  21,  255, 81,  107, 49,  255, 126, 161, 60,  255, 206, 213, 67,  255, 234, 230,
    77,  255, 233, 227, 90,  255, 238, 229, 100, 255, 234, 226, 84,  255, 236, 227, 78,  255, 236, 224, 95,  255, 226, 220, 110, 255, 224, 225, 137,
    255, 218, 225, 137, 255, 201, 201, 117, 255, 152, 171, 117, 255, 97,  123, 69,  255, 89,  109, 60,  255, 163, 189, 105, 255, 178, 202, 107, 255,
    191, 209, 121, 255, 198, 212, 129, 255, 197, 208, 135, 255, 150, 166, 104, 255, 93,  119, 74,  255, 102, 127, 68,  255, 129, 154, 77,  255, 122,
    146, 71,  255, 111, 143, 55,  255, 86,  110, 44,  255, 65,  84,  38,  255, 82,  99,  45,  255, 101, 122, 58,  255, 83,  109, 48,  255, 75,  103,
    50,  255, 69,  100, 46,  255, 72,  103, 47,  255, 36,  52,  33,  255, 25,  36,  26,  255, 29,  47,  26,  255, 87,  114, 40,  255, 112, 143, 47,
    255, 133, 154, 68,  255, 231, 233, 138, 255, 204, 218, 131, 255, 191, 210, 127, 255, 199, 218, 132, 255, 207, 223, 139, 255, 210, 223, 129, 255,
    200, 214, 119, 255, 169, 195, 132, 255, 143, 168, 108, 255, 198, 212, 150, 255, 233, 238, 162, 255, 141, 145, 82,  255, 136, 149, 89,  255, 190,
    203, 138, 255, 209, 218, 152, 255, 215, 228, 156, 255, 240, 243, 173, 255, 194, 203, 141, 255, 117, 153, 110, 255, 126, 162, 113, 255, 138, 170,
    108, 255, 127, 149, 83,  255, 77,  90,  36,  255, 170, 177, 104, 255, 212, 226, 161, 255, 202, 221, 157, 255, 187, 211, 149, 255, 190, 213, 152,
    255, 215, 231, 156, 255, 216, 229, 156, 255, 202, 216, 143, 255, 171, 188, 132, 255, 142, 161, 103, 255, 172, 194, 122, 255, 181, 204, 134, 255,
    203, 220, 152, 255, 209, 226, 161, 255, 214, 230, 165, 255, 212, 221, 152, 255, 221, 222, 136, 255, 193, 214, 144, 255, 166, 198, 128, 255, 168,
    200, 119, 255, 194, 214, 116, 255, 114, 125, 55,  255, 38,  56,  21,  255, 60,  84,  32,  255, 72,  105, 37,  255, 84,  120, 44,  255, 86,  122,
    42,  255, 87,  127, 47,  255, 93,  131, 48,  255, 75,  105, 36,  255, 78,  103, 36,  255, 104, 131, 58,  255, 98,  127, 65,  255, 90,  120, 52,
    255, 49,  63,  26,  255, 62,  72,  36,  255, 103, 120, 63,  255, 104, 132, 62,  255, 122, 146, 60,  255, 152, 166, 68,  255, 130, 151, 60,  255,
    111, 140, 63,  255, 127, 152, 73,  255, 166, 185, 97,  255, 186, 205, 117, 255, 111, 137, 68,  255, 131, 159, 76,  255, 150, 183, 107, 255, 142,
    171, 92,  255, 83,  109, 36,  255, 146, 162, 105, 255, 170, 199, 146, 255, 135, 161, 68,  255, 94,  126, 60,  255, 108, 138, 74,  255, 87,  119,
    56,  255, 71,  106, 40,  255, 52,  82,  31,  255, 40,  63,  23,  255, 93,  106, 45,  255, 198, 202, 90,  255, 172, 195, 76,  255, 150, 178, 68,
    255, 131, 169, 68,  255, 128, 167, 69,  255, 178, 195, 86,  255, 171, 186, 126, 255, 113, 139, 85,  255, 157, 172, 90,  255, 181, 192, 94,  255,
    167, 183, 110, 255, 147, 169, 113, 255, 143, 166, 118, 255, 130, 160, 118, 255, 114, 145, 105, 255, 168, 185, 105, 255, 131, 147, 79,  255, 17,
    19,  12,  255, 77,  90,  31,  255, 48,  60,  21,  255, 89,  111, 50,  255, 122, 142, 65,  255, 174, 178, 98,  255, 219, 228, 143, 255, 219, 228,
    151, 255, 208, 221, 149, 255, 206, 221, 154, 255, 199, 219, 152, 255, 173, 197, 120, 255, 164, 182, 96,  255, 177, 197, 94,  255, 181, 206, 119,
    255, 194, 215, 143, 255, 205, 221, 156, 255, 216, 227, 156, 255, 177, 191, 104, 255, 137, 163, 77,  255, 129, 159, 84,  255, 150, 173, 97,  255,
    140, 168, 105, 255, 175, 193, 134, 255, 226, 233, 171, 255, 201, 221, 170, 255, 193, 217, 169, 255, 192, 219, 166, 255, 190, 215, 162, 255, 191,
    215, 164, 255, 193, 217, 166, 255, 192, 217, 160, 255, 185, 211, 151, 255, 179, 207, 144, 255, 179, 204, 140, 255, 228, 233, 163, 255, 207, 226,
    152, 255, 167, 203, 118, 255, 164, 199, 97,  255, 181, 211, 87,  255, 154, 176, 77,  255, 154, 174, 108, 255, 195, 211, 153, 255, 183, 204, 143,
    255, 179, 201, 140, 255, 173, 199, 143, 255, 161, 190, 142, 255, 161, 191, 137, 255, 172, 195, 134, 255, 167, 195, 127, 255, 173, 202, 123, 255,
    186, 200, 121, 255, 119, 129, 71,  255, 58,  72,  31,  255, 148, 165, 102, 255, 140, 156, 78,  255, 112, 115, 47,  255, 119, 133, 55,  255, 124,
    145, 60,  255, 119, 145, 60,  255, 106, 137, 52,  255, 95,  127, 44,  255, 94,  124, 44,  255, 82,  107, 42,  255, 53,  69,  31,  255, 34,  47,
    17,  255, 151, 172, 87,  255, 224, 238, 134, 255, 212, 224, 126, 255, 216, 228, 133, 255, 225, 235, 141, 255, 200, 215, 108, 255, 111, 147, 58,
    255, 111, 144, 60,  255, 100, 126, 52,  255, 99,  116, 43,  255, 160, 160, 86,  255, 191, 192, 115, 255, 192, 196, 138, 255, 138, 144, 96,  255,
    52,  73,  25,  255, 56,  96,  31,  255, 52,  87,  34,  255, 58,  87,  46,  255, 45,  63,  36,  255, 29,  37,  23,  255, 42,  60,  33,  255, 36,
    51,  31,  255, 28,  41,  26,  255, 28,  46,  26,  255, 29,  48,  25,  255, 115, 140, 81,  255, 155, 186, 137, 255, 129, 165, 125, 255, 114, 154,
    101, 255, 107, 148, 87,  255, 102, 145, 83,  255, 102, 146, 85,  255, 129, 171, 77,  255, 131, 154, 58,  255, 55,  72,  36,  255, 123, 148, 87,
    255, 168, 174, 93,  255, 171, 186, 96,  255, 182, 196, 97,  255, 122, 146, 49,  255, 92,  130, 33,  255, 101, 146, 39,  255, 122, 162, 58,  255,
    143, 180, 87,  255, 158, 183, 104, 255, 116, 130, 73,  255, 43,  53,  31,  255, 58,  68,  47,  255, 67,  89,  48,  255, 65,  91,  33,  255, 133,
    164, 68,  255, 189, 204, 80,  255, 234, 230, 76,  255, 228, 223, 68,  255, 234, 226, 73,  255, 231, 224, 77,  255, 221, 218, 78,  255, 216, 213,
    103, 255, 199, 202, 110, 255, 169, 170, 98,  255, 141, 138, 74,  255, 74,  77,  36,  255, 99,  121, 72,  255, 123, 148, 83,  255, 118, 146, 78,
    255, 124, 148, 86,  255, 120, 141, 72,  255, 157, 175, 92,  255, 114, 137, 91,  255, 94,  118, 81,  255, 98,  122, 77,  255, 112, 137, 76,  255,
    133, 157, 79,  255, 135, 155, 76,  255, 125, 147, 67,  255, 104, 141, 47,  255, 96,  117, 58,  255, 71,  82,  49,  255, 26,  29,  25,  255, 65,
    76,  42,  255, 55,  81,  34,  255, 55,  87,  38,  255, 73,  102, 47,  255, 82,  112, 52,  255, 50,  72,  36,  255, 45,  55,  34,  255, 91,  98,
    58,  255, 91,  106, 43,  255, 119, 142, 55,  255, 148, 163, 81,  255, 209, 222, 142, 255, 185, 209, 122, 255, 197, 212, 127, 255, 163, 174, 105,
    255, 201, 205, 111, 255, 211, 221, 136, 255, 189, 210, 153, 255, 162, 187, 124, 255, 137, 163, 91,  255, 180, 197, 146, 255, 222, 229, 154, 255,
    216, 226, 144, 255, 213, 228, 152, 255, 217, 229, 159, 255, 213, 222, 124, 255, 187, 202, 120, 255, 162, 185, 130, 255, 203, 216, 154, 255, 160,
    181, 122, 255, 155, 180, 102, 255, 96,  119, 52,  255, 34,  49,  17,  255, 106, 113, 77,  255, 224, 238, 179, 255, 201, 224, 174, 255, 204, 225,
    166, 255, 202, 225, 165, 255, 197, 222, 160, 255, 196, 218, 144, 255, 187, 208, 125, 255, 192, 211, 127, 255, 196, 212, 126, 255, 146, 164, 95,
    255, 160, 181, 100, 255, 183, 203, 122, 255, 203, 217, 133, 255, 191, 213, 136, 255, 198, 221, 155, 255, 208, 229, 180, 255, 234, 241, 177, 255,
    199, 217, 152, 255, 181, 210, 147, 255, 204, 220, 127, 255, 129, 148, 60,  255, 39,  56,  19,  255, 34,  47,  26,  255, 33,  44,  26,  255, 41,
    58,  28,  255, 60,  95,  38,  255, 81,  114, 44,  255, 98,  130, 52,  255, 122, 156, 67,  255, 165, 183, 104, 255, 106, 129, 68,  255, 87,  117,
    53,  255, 94,  123, 48,  255, 104, 127, 50,  255, 110, 132, 55,  255, 174, 180, 69,  255, 213, 221, 84,  255, 199, 211, 80,  255, 153, 172, 76,
    255, 96,  126, 52,  255, 107, 140, 58,  255, 107, 143, 72,  255, 138, 163, 82,  255, 182, 196, 96,  255, 135, 154, 71,  255, 108, 133, 55,  255,
    152, 183, 105, 255, 139, 174, 123, 255, 132, 163, 102, 255, 95,  126, 50,  255, 114, 137, 56,  255, 167, 186, 94,  255, 153, 173, 74,  255, 134,
    157, 77,  255, 124, 149, 74,  255, 106, 136, 65,  255, 98,  129, 53,  255, 120, 139, 83,  255, 146, 157, 86,  255, 206, 206, 95,  255, 218, 216,
    101, 255, 170, 195, 87,  255, 151, 182, 100, 255, 157, 186, 105, 255, 180, 197, 99,  255, 145, 164, 62,  255, 137, 159, 79,  255, 114, 137, 75,
    255, 142, 159, 71,  255, 126, 156, 60,  255, 113, 147, 72,  255, 114, 147, 80,  255, 119, 149, 87,  255, 125, 155, 91,  255, 116, 149, 92,  255,
    147, 172, 97,  255, 188, 201, 111, 255, 52,  62,  36,  255, 40,  56,  19,  255, 44,  60,  26,  255, 126, 149, 75,  255, 128, 152, 87,  255, 201,
    206, 141, 255, 216, 229, 162, 255, 190, 217, 162, 255, 186, 213, 162, 255, 184, 209, 147, 255, 182, 207, 116, 255, 188, 210, 87,  255, 190, 205,
    83,  255, 187, 210, 114, 255, 180, 206, 119, 255, 181, 207, 125, 255, 191, 214, 149, 255, 203, 221, 162, 255, 222, 231, 167, 255, 197, 212, 124,
    255, 165, 188, 89,  255, 143, 172, 78,  255, 185, 199, 120, 255, 235, 243, 179, 255, 222, 238, 183, 255, 212, 235, 184, 255, 207, 231, 181, 255,
    200, 222, 169, 255, 189, 212, 158, 255, 188, 213, 169, 255, 198, 219, 168, 255, 198, 220, 164, 255, 199, 222, 163, 255, 202, 224, 161, 255, 219,
    229, 160, 255, 220, 233, 171, 255, 186, 217, 150, 255, 182, 215, 118, 255, 197, 226, 125, 255, 231, 239, 118, 255, 180, 196, 98,  255, 171, 198,
    145, 255, 180, 206, 171, 255, 190, 214, 170, 255, 208, 219, 161, 255, 224, 225, 148, 255, 202, 215, 137, 255, 163, 192, 119, 255, 175, 200, 121,
    255, 198, 214, 120, 255, 171, 180, 96,  255, 102, 118, 56,  255, 52,  75,  31,  255, 40,  62,  28,  255, 52,  68,  31,  255, 55,  68,  34,  255,
    50,  65,  32,  255, 56,  69,  25,  255, 82,  99,  36,  255, 94,  104, 44,  255, 116, 133, 55,  255, 117, 138, 55,  255, 94,  117, 45,  255, 74,
    97,  37,  255, 55,  75,  33,  255, 53,  73,  29,  255, 100, 102, 48,  255, 189, 193, 106, 255, 224, 234, 138, 255, 226, 232, 143, 255, 212, 220,
    124, 255, 179, 198, 83,  255, 140, 171, 73,  255, 115, 152, 65,  255, 153, 176, 78,  255, 109, 141, 65,  255, 97,  131, 47,  255, 132, 156, 75,
    255, 137, 158, 125, 255, 113, 136, 90,  255, 65,  101, 40,  255, 74,  115, 43,  255, 57,  90,  41,  255, 63,  99,  52,  255, 65,  83,  47,  255,
    26,  42,  19,  255, 52,  84,  33,  255, 43,  68,  33,  255, 48,  74,  36,  255, 49,  77,  31,  255, 53,  83,  33,  255, 130, 163, 106, 255, 136,
    177, 130, 255, 133, 174, 131, 255, 130, 173, 123, 255, 133, 175, 111, 255, 132, 174, 107, 255, 157, 192, 112, 255, 149, 159, 81,  255, 68,  71,
    31,  255, 92,  117, 53,  255, 173, 190, 118, 255, 162, 172, 94,  255, 179, 198, 106, 255, 118, 133, 53,  255, 78,  113, 33,  255, 100, 138, 43,
    255, 96,  124, 50,  255, 107, 139, 53,  255, 135, 159, 75,  255, 132, 148, 65,  255, 55,  81,  38,  255, 55,  68,  43,  255, 149, 170, 109, 255,
    120, 139, 94,  255, 96,  112, 62,  255, 169, 182, 96,  255, 127, 148, 72,  255, 169, 179, 75,  255, 199, 205, 84,  255, 206, 209, 80,  255, 149,
    172, 74,  255, 131, 161, 67,  255, 118, 150, 55,  255, 124, 140, 58,  255, 58,  74,  31,  255, 21,  32,  15,  255, 39,  60,  36,  255, 82,  112,
    74,  255, 100, 126, 67,  255, 103, 132, 88,  255, 103, 130, 90,  255, 82,  111, 65,  255, 89,  115, 58,  255, 84,  109, 72,  255, 157, 177, 106,
    255, 174, 198, 107, 255, 149, 176, 93,  255, 128, 151, 74,  255, 53,  65,  36,  255, 92,  112, 49,  255, 119, 147, 62,  255, 148, 169, 76,  255,
    154, 177, 72,  255, 158, 175, 98,  255, 165, 184, 120, 255, 150, 170, 108, 255, 104, 127, 68,  255, 71,  100, 43,  255, 73,  104, 44,  255, 67,
    98,  41,  255, 65,  97,  36,  255, 114, 145, 60,  255, 164, 188, 94,  255, 142, 158, 76,  255, 109, 126, 60,  255, 121, 157, 73,  255, 141, 175,
    72,  255, 160, 178, 97,  255, 96,  102, 81,  255, 212, 212, 130, 255, 218, 227, 167, 255, 178, 206, 175, 255, 173, 201, 169, 255, 127, 154, 84,
    255, 170, 191, 129, 255, 208, 219, 129, 255, 222, 226, 134, 255, 229, 230, 125, 255, 223, 228, 124, 255, 135, 172, 101, 255, 161, 189, 104, 255,
    166, 187, 94,  255, 119, 144, 69,  255, 99,  126, 56,  255, 65,  97,  32,  255, 47,  84,  21,  255, 47,  81,  21,  255, 90,  121, 62,  255, 125,
    148, 94,  255, 124, 142, 87,  255, 131, 146, 87,  255, 153, 165, 109, 255, 169, 175, 124, 255, 157, 171, 100, 255, 135, 159, 76,  255, 219, 223,
    132, 255, 173, 194, 122, 255, 136, 161, 95,  255, 128, 155, 84,  255, 162, 190, 133, 255, 202, 214, 126, 255, 120, 136, 60,  255, 110, 132, 60,
    255, 185, 203, 115, 255, 201, 213, 137, 255, 200, 214, 150, 255, 201, 217, 143, 255, 159, 174, 83,  255, 57,  84,  28,  255, 37,  49,  26,  255,
    34,  41,  26,  255, 55,  69,  34,  255, 34,  42,  26,  255, 68,  86,  38,  255, 91,  117, 42,  255, 96,  127, 49,  255, 156, 178, 87,  255, 218,
    223, 143, 255, 111, 143, 65,  255, 103, 142, 50,  255, 106, 147, 47,  255, 120, 152, 50,  255, 212, 217, 92,  255, 238, 236, 93,  255, 233, 229,
    89,  255, 235, 230, 77,  255, 177, 190, 69,  255, 109, 139, 47,  255, 146, 170, 56,  255, 171, 187, 78,  255, 162, 177, 77,  255, 117, 139, 55,
    255, 65,  99,  33,  255, 115, 134, 52,  255, 165, 193, 127, 255, 147, 181, 141, 255, 165, 192, 133, 255, 148, 176, 87,  255, 131, 153, 62,  255,
    157, 176, 85,  255, 153, 172, 77,  255, 146, 169, 97,  255, 156, 180, 107, 255, 160, 183, 110, 255, 144, 169, 89,  255, 155, 165, 85,  255, 199,
    205, 103, 255, 138, 167, 82,  255, 162, 174, 77,  255, 206, 218, 124, 255, 188, 207, 128, 255, 206, 214, 103, 255, 178, 190, 77,  255, 151, 173,
    62,  255, 153, 176, 84,  255, 97,  119, 55,  255, 131, 148, 58,  255, 159, 186, 60,  255, 152, 180, 72,  255, 138, 170, 83,  255, 131, 163, 87,
    255, 126, 159, 92,  255, 153, 176, 97,  255, 184, 195, 97,  255, 170, 179, 86,  255, 107, 131, 43,  255, 113, 144, 55,  255, 143, 170, 83,  255,
    111, 141, 65,  255, 198, 201, 122, 255, 231, 241, 172, 255, 196, 219, 170, 255, 194, 219, 165, 255, 186, 212, 134, 255, 190, 215, 112, 255, 179,
    188, 83,  255, 132, 134, 43,  255, 161, 168, 60,  255, 218, 223, 111, 255, 199, 220, 127, 255, 186, 209, 121, 255, 196, 215, 145, 255, 199, 219,
    164, 255, 211, 226, 175, 255, 217, 226, 157, 255, 175, 191, 91,  255, 221, 222, 96,  255, 249, 235, 109, 255, 228, 216, 102, 255, 175, 175, 77,
    255, 181, 186, 101, 255, 192, 195, 121, 255, 206, 219, 152, 255, 202, 219, 157, 255, 216, 230, 165, 255, 220, 232, 164, 255, 217, 231, 162, 255,
    234, 241, 161, 255, 249, 246, 164, 255, 234, 241, 172, 255, 201, 225, 159, 255, 204, 230, 150, 255, 224, 239, 157, 255, 223, 227, 136, 255, 174,
    176, 87,  255, 184, 202, 96,  255, 160, 192, 109, 255, 168, 197, 146, 255, 177, 206, 175, 255, 183, 211, 180, 255, 185, 207, 162, 255, 220, 223,
    153, 255, 226, 228, 138, 255, 204, 207, 109, 255, 166, 169, 90,  255, 68,  81,  38,  255, 44,  62,  26,  255, 43,  67,  26,  255, 42,  67,  31,
    255, 42,  65,  32,  255, 55,  71,  34,  255, 33,  41,  25,  255, 19,  25,  17,  255, 34,  53,  23,  255, 40,  58,  26,  255, 103, 122, 52,  255,
    98,  124, 56,  255, 77,  109, 52,  255, 68,  104, 40,  255, 63,  96,  32,  255, 67,  99,  36,  255, 47,  74,  28,  255, 116, 132, 49,  255, 191,
    205, 96,  255, 190, 203, 100, 255, 181, 201, 93,  255, 185, 206, 93,  255, 162, 186, 84,  255, 127, 161, 72,  255, 163, 179, 87,  255, 156, 177,
    100, 255, 142, 171, 96,  255, 171, 183, 93,  255, 69,  87,  29,  255, 67,  100, 28,  255, 84,  125, 50,  255, 82,  122, 55,  255, 65,  100, 50,
    255, 79,  119, 58,  255, 67,  83,  45,  255, 32,  47,  21,  255, 57,  92,  31,  255, 52,  83,  33,  255, 58,  84,  32,  255, 63,  94,  41,  255,
    62,  84,  37,  255, 136, 161, 105, 255, 152, 179, 122, 255, 158, 186, 126, 255, 170, 188, 115, 255, 173, 189, 107, 255, 158, 175, 92,  255, 127,
    129, 67,  255, 76,  69,  40,  255, 52,  46,  32,  255, 90,  96,  49,  255, 159, 168, 102, 255, 160, 182, 92,  255, 125, 138, 62,  255, 63,  91,
    31,  255, 75,  104, 37,  255, 67,  92,  40,  255, 76,  92,  50,  255, 80,  101, 49,  255, 69,  96,  44,  255, 106, 133, 63,  255, 81,  98,  49,
    255, 49,  58,  36,  255, 164, 179, 95,  255, 191, 206, 128, 255, 210, 226, 156, 255, 204, 210, 138, 255, 81,  99,  40,  255, 94,  123, 53,  255,
    158, 176, 86,  255, 154, 177, 91,  255, 120, 154, 71,  255, 99,  134, 50,  255, 71,  105, 47,  255, 103, 137, 71,  255, 113, 141, 72,  255, 38,
    52,  32,  255, 58,  84,  47,  255, 92,  124, 84,  255, 84,  115, 69,  255, 108, 136, 96,  255, 130, 158, 92,  255, 105, 140, 65,  255, 92,  127,
    62,  255, 97,  122, 55,  255, 149, 177, 103, 255, 154, 186, 107, 255, 141, 178, 92,  255, 56,  79,  36,  255, 17,  23,  15,  255, 97,  122, 52,
    255, 157, 187, 104, 255, 152, 184, 116, 255, 151, 185, 116, 255, 156, 189, 127, 255, 170, 200, 142, 255, 194, 212, 140, 255, 118, 137, 74,  255,
    71,  102, 46,  255, 60,  89,  41,  255, 49,  73,  37,  255, 48,  74,  36,  255, 52,  81,  29,  255, 128, 153, 69,  255, 179, 204, 101, 255, 121,
    141, 60,  255, 121, 145, 65,  255, 137, 168, 87,  255, 169, 195, 133, 255, 146, 159, 94,  255, 186, 199, 113, 255, 218, 227, 156, 255, 182, 207,
    162, 255, 185, 212, 178, 255, 143, 169, 114, 255, 158, 178, 94,  255, 220, 228, 151, 255, 226, 230, 152, 255, 163, 185, 97,  255, 131, 169, 89,
    255, 119, 159, 90,  255, 136, 174, 98,  255, 181, 203, 94,  255, 88,  109, 33,  255, 47,  77,  23,  255, 63,  100, 31,  255, 58,  98,  29,  255,
    62,  103, 28,  255, 51,  86,  26,  255, 47,  83,  26,  255, 48,  84,  25,  255, 55,  90,  26,  255, 42,  60,  21,  255, 25,  25,  19,  255, 68,
    94,  47,  255, 86,  126, 58,  255, 177, 187, 110, 255, 199, 211, 134, 255, 148, 176, 120, 255, 122, 152, 89,  255, 155, 184, 130, 255, 193, 207,
    120, 255, 80,  100, 34,  255, 38,  71,  23,  255, 62,  89,  36,  255, 49,  60,  28,  255, 44,  46,  31,  255, 52,  60,  36,  255, 31,  43,  23,
    255, 44,  68,  33,  255, 47,  55,  31,  255, 68,  91,  36,  255, 74,  106, 39,  255, 63,  79,  31,  255, 100, 121, 44,  255, 98,  121, 40,  255,
    100, 124, 41,  255, 109, 134, 50,  255, 129, 152, 63,  255, 108, 140, 49,  255, 98,  132, 50,  255, 113, 149, 63,  255, 134, 163, 58,  255, 229,
    227, 112, 255, 245, 238, 111, 255, 241, 232, 94,  255, 221, 218, 87,  255, 175, 187, 83,  255, 140, 159, 62,  255, 108, 122, 33,  255, 138, 148,
    60,  255, 153, 164, 84,  255, 184, 195, 108, 255, 169, 187, 98,  255, 95,  111, 36,  255, 165, 175, 99,  255, 164, 196, 147, 255, 154, 183, 132,
    255, 190, 208, 107, 255, 146, 154, 68,  255, 158, 173, 97,  255, 135, 165, 106, 255, 124, 153, 99,  255, 138, 166, 113, 255, 141, 170, 114, 255,
    149, 177, 123, 255, 181, 193, 118, 255, 190, 200, 103, 255, 167, 185, 89,  255, 197, 202, 94,  255, 237, 228, 119, 255, 211, 209, 80,  255, 179,
    184, 62,  255, 150, 159, 60,  255, 121, 133, 43,  255, 141, 154, 74,  255, 103, 128, 58,  255, 152, 164, 73,  255, 181, 191, 83,  255, 198, 208,
    95,  255, 195, 210, 106, 255, 192, 207, 111, 255, 195, 206, 107, 255, 168, 178, 84,  255, 119, 139, 62,  255, 118, 145, 49,  255, 140, 169, 49,
    255, 155, 176, 73,  255, 133, 159, 68,  255, 109, 135, 65,  255, 243, 236, 156, 255, 237, 241, 174, 255, 206, 223, 166, 255, 197, 221, 135, 255,
    209, 226, 122, 255, 170, 172, 87,  255, 55,  62,  21,  255, 81,  99,  44,  255, 168, 182, 93,  255, 204, 209, 108, 255, 222, 221, 114, 255, 217,
    228, 131, 255, 201, 222, 139, 255, 198, 219, 143, 255, 204, 224, 171, 255, 216, 229, 176, 255, 193, 206, 99,  255, 200, 193, 75,  255, 159, 158,
    60,  255, 126, 145, 42,  255, 97,  127, 36,  255, 93,  121, 36,  255, 69,  90,  19,  255, 163, 168, 74,  255, 200, 211, 138, 255, 191, 201, 138,
    255, 207, 212, 145, 255, 205, 211, 145, 255, 199, 208, 150, 255, 199, 205, 148, 255, 217, 228, 163, 255, 216, 225, 157, 255, 210, 211, 145, 255,
    215, 216, 131, 255, 150, 162, 77,  255, 93,  118, 45,  255, 175, 188, 87,  255, 202, 219, 126, 255, 166, 196, 127, 255, 164, 194, 137, 255, 179,
    209, 177, 255, 180, 213, 184, 255, 178, 206, 172, 255, 209, 220, 161, 255, 184, 197, 123, 255, 102, 114, 62,  255, 9,   12,  9,   255, 37,  58,
    26,  255, 52,  80,  33,  255, 47,  73,  31,  255, 50,  71,  32,  255, 47,  67,  31,  255, 23,  29,  19,  255, 15,  19,  17,  255, 19,  28,  17,
    255, 88,  105, 47,  255, 139, 155, 78,  255, 103, 131, 68,  255, 102, 136, 56,  255, 99,  135, 43,  255, 82,  116, 42,  255, 67,  100, 37,  255,
    86,  118, 40,  255, 149, 171, 71,  255, 183, 203, 98,  255, 181, 203, 99,  255, 194, 213, 110, 255, 207, 219, 121, 255, 162, 186, 95,  255, 138,
    173, 84,  255, 144, 168, 80,  255, 187, 201, 139, 255, 215, 226, 161, 255, 146, 148, 84,  255, 29,  62,  17,  255, 55,  96,  26,  255, 92,  126,
    45,  255, 95,  130, 65,  255, 104, 138, 74,  255, 107, 134, 62,  255, 43,  55,  31,  255, 21,  33,  23,  255, 32,  43,  25,  255, 34,  46,  25,
    255, 19,  21,  17,  255, 53,  71,  43,  255, 55,  81,  31,  255, 76,  108, 39,  255, 100, 124, 49,  255, 83,  87,  42,  255, 48,  47,  25,  255,
    49,  53,  26,  255, 55,  71,  36,  255, 52,  75,  37,  255, 46,  68,  28,  255, 79,  103, 36,  255, 124, 145, 52,  255, 150, 171, 55,  255, 175,
    197, 67,  255, 103, 128, 45,  255, 60,  82,  36,  255, 62,  84,  48,  255, 77,  98,  63,  255, 77,  94,  52,  255, 113, 136, 84,  255, 117, 148,
    93,  255, 129, 158, 87,  255, 74,  99,  41,  255, 52,  77,  32,  255, 84,  101, 48,  255, 117, 130, 73,  255, 186, 201, 133, 255, 175, 191, 114,
    255, 101, 134, 52,  255, 82,  116, 45,  255, 107, 132, 55,  255, 149, 170, 86,  255, 96,  128, 58,  255, 58,  95,  39,  255, 68,  102, 52,  255,
    101, 130, 63,  255, 123, 151, 65,  255, 95,  126, 58,  255, 97,  127, 65,  255, 99,  130, 85,  255, 89,  120, 75,  255, 119, 149, 100, 255, 90,
    110, 63,  255, 48,  62,  34,  255, 72,  97,  42,  255, 99,  130, 56,  255, 98,  133, 60,  255, 138, 162, 79,  255, 151, 179, 87,  255, 84,  110,
    52,  255, 49,  71,  29,  255, 132, 165, 97,  255, 143, 178, 116, 255, 157, 189, 128, 255, 163, 191, 129, 255, 172, 195, 125, 255, 163, 183, 112,
    255, 93,  116, 55,  255, 49,  69,  28,  255, 69,  92,  41,  255, 63,  95,  42,  255, 42,  68,  31,  255, 37,  62,  31,  255, 49,  69,  33,  255,
    143, 163, 75,  255, 161, 183, 78,  255, 165, 191, 76,  255, 167, 190, 81,  255, 129, 159, 84,  255, 161, 188, 128, 255, 189, 204, 106, 255, 149,
    173, 101, 255, 192, 202, 133, 255, 204, 217, 152, 255, 179, 205, 164, 255, 143, 169, 116, 255, 152, 171, 102, 255, 224, 231, 159, 255, 215, 223,
    142, 255, 135, 164, 84,  255, 116, 155, 83,  255, 126, 164, 105, 255, 124, 164, 104, 255, 165, 196, 96,  255, 97,  114, 43,  255, 28,  39,  23,
    255, 75,  97,  43,  255, 91,  117, 49,  255, 69,  94,  33,  255, 42,  65,  26,  255, 47,  65,  31,  255, 56,  77,  31,  255, 60,  81,  33,  255,
    47,  55,  31,  255, 43,  37,  31,  255, 69,  84,  45,  255, 97,  138, 63,  255, 99,  128, 63,  255, 191, 203, 110, 255, 182, 201, 119, 255, 128,
    154, 87,  255, 145, 176, 123, 255, 189, 204, 121, 255, 109, 135, 68,  255, 90,  124, 56,  255, 63,  86,  36,  255, 52,  65,  32,  255, 23,  31,
    17,  255, 23,  34,  21,  255, 28,  39,  23,  255, 55,  84,  33,  255, 77,  110, 38,  255, 58,  91,  33,  255, 81,  114, 39,  255, 71,  92,  32,
    255, 113, 132, 50,  255, 131, 149, 55,  255, 99,  117, 38,  255, 89,  106, 42,  255, 77,  98,  37,  255, 52,  72,  33,  255, 47,  63,  37,  255,
    68,  91,  44,  255, 60,  90,  29,  255, 92,  121, 45,  255, 205, 204, 95,  255, 245, 234, 106, 255, 174, 188, 96,  255, 142, 155, 73,  255, 120,
    135, 55,  255, 97,  113, 42,  255, 142, 149, 68,  255, 143, 158, 71,  255, 127, 151, 63,  255, 146, 165, 74,  255, 153, 175, 73,  255, 111, 123,
    50,  255, 102, 118, 74,  255, 104, 129, 83,  255, 170, 182, 102, 255, 135, 150, 75,  255, 106, 137, 86,  255, 126, 159, 112, 255, 121, 149, 103,
    255, 141, 174, 117, 255, 144, 177, 122, 255, 159, 185, 124, 255, 184, 196, 100, 255, 159, 171, 67,  255, 165, 174, 74,  255, 207, 204, 104, 255,
    197, 198, 110, 255, 114, 129, 47,  255, 91,  114, 32,  255, 85,  110, 39,  255, 72,  102, 36,  255, 72,  92,  37,  255, 101, 121, 45,  255, 131,
    150, 62,  255, 127, 149, 73,  255, 136, 151, 77,  255, 162, 172, 87,  255, 158, 170, 80,  255, 120, 134, 50,  255, 107, 137, 58,  255, 126, 153,
    65,  255, 158, 178, 62,  255, 150, 174, 60,  255, 147, 168, 77,  255, 112, 143, 65,  255, 164, 177, 113, 255, 231, 238, 181, 255, 211, 227, 168,
    255, 211, 225, 137, 255, 207, 210, 115, 255, 115, 109, 58,  255, 34,  42,  15,  255, 117, 135, 56,  255, 209, 220, 105, 255, 211, 221, 110, 255,
    178, 197, 98,  255, 159, 178, 79,  255, 196, 203, 71,  255, 200, 207, 96,  255, 206, 216, 121, 255, 204, 219, 137, 255, 216, 229, 166, 255, 205,
    216, 127, 255, 128, 149, 65,  255, 73,  105, 38,  255, 109, 140, 41,  255, 112, 143, 43,  255, 111, 141, 52,  255, 85,  116, 46,  255, 109, 130,
    37,  255, 198, 204, 102, 255, 180, 205, 138, 255, 149, 181, 136, 255, 150, 181, 143, 255, 148, 178, 145, 255, 154, 181, 141, 255, 175, 191, 141,
    255, 159, 182, 131, 255, 134, 166, 117, 255, 170, 190, 112, 255, 169, 190, 92,  255, 113, 141, 68,  255, 161, 183, 71,  255, 213, 216, 98,  255,
    209, 221, 138, 255, 165, 198, 125, 255, 167, 200, 137, 255, 186, 213, 180, 255, 188, 216, 180, 255, 203, 219, 165, 255, 233, 236, 155, 255, 75,
    81,  43,  255, 9,   17,  15,  255, 55,  79,  36,  255, 60,  84,  39,  255, 53,  74,  36,  255, 49,  75,  32,  255, 33,  47,  25,  255, 26,  36,
    21,  255, 43,  65,  34,  255, 39,  62,  31,  255, 109, 122, 62,  255, 147, 162, 77,  255, 121, 150, 65,  255, 126, 154, 60,  255, 115, 144, 50,
    255, 96,  126, 55,  255, 74,  106, 47,  255, 74,  110, 39,  255, 136, 159, 65,  255, 204, 219, 118, 255, 202, 219, 123, 255, 219, 232, 137, 255,
    209, 220, 124, 255, 155, 184, 99,  255, 152, 185, 95,  255, 156, 183, 97,  255, 134, 134, 83,  255, 152, 146, 79,  255, 71,  102, 33,  255, 64,
    108, 36,  255, 80,  124, 40,  255, 79,  105, 40,  255, 67,  84,  39,  255, 92,  115, 47,  255, 79,  101, 40,  255, 43,  65,  36,  255, 31,  47,
    33,  255, 26,  34,  26,  255, 19,  31,  23,  255, 42,  68,  29,  255, 65,  104, 40,  255, 67,  107, 40,  255, 72,  114, 44,  255, 87,  129, 52,
    255, 72,  92,  44,  255, 26,  37,  28,  255, 33,  40,  29,  255, 58,  81,  34,  255, 76,  101, 38,  255, 40,  62,  23,  255, 97,  119, 36,  255,
    191, 213, 80,  255, 129, 158, 56,  255, 144, 169, 68,  255, 115, 143, 58,  255, 52,  76,  39,  255, 82,  94,  60,  255, 72,  81,  52,  255, 33,
    42,  25,  255, 115, 136, 72,  255, 139, 166, 83,  255, 101, 124, 52,  255, 69,  96,  36,  255, 48,  71,  33,  255, 47,  65,  29,  255, 41,  60,
    21,  255, 97,  121, 52,  255, 115, 147, 76,  255, 92,  128, 68,  255, 89,  123, 62,  255, 72,  109, 49,  255, 112, 132, 68,  255, 78,  108, 48,
    255, 71,  106, 41,  255, 102, 132, 53,  255, 131, 155, 56,  255, 107, 138, 58,  255, 103, 137, 72,  255, 116, 143, 68,  255, 101, 132, 84,  255,
    95,  125, 79,  255, 101, 132, 86,  255, 52,  62,  43,  255, 34,  36,  29,  255, 63,  89,  34,  255, 73,  111, 36,  255, 83,  117, 42,  255, 82,
    117, 43,  255, 97,  128, 49,  255, 133, 162, 68,  255, 82,  120, 41,  255, 101, 133, 60,  255, 130, 156, 78,  255, 144, 169, 78,  255, 155, 176,
    90,  255, 114, 136, 62,  255, 74,  108, 32,  255, 65,  104, 28,  255, 72,  104, 32,  255, 47,  63,  28,  255, 75,  98,  44,  255, 98,  123, 52,
    255, 49,  75,  31,  255, 65,  87,  37,  255, 156, 177, 76,  255, 148, 170, 73,  255, 128, 150, 65,  255, 116, 138, 62,  255, 151, 175, 86,  255,
    158, 180, 101, 255, 171, 189, 96,  255, 153, 172, 100, 255, 142, 157, 98,  255, 208, 219, 143, 255, 176, 200, 154, 255, 145, 172, 123, 255, 152,
    172, 104, 255, 217, 227, 157, 255, 208, 220, 138, 255, 129, 162, 77,  255, 121, 159, 90,  255, 128, 160, 79,  255, 126, 159, 83,  255, 100, 126,
    49,  255, 33,  53,  21,  255, 34,  49,  28,  255, 44,  52,  32,  255, 41,  53,  33,  255, 41,  58,  28,  255, 40,  65,  26,  255, 55,  79,  36,
    255, 48,  60,  36,  255, 29,  37,  26,  255, 67,  68,  48,  255, 65,  65,  42,  255, 85,  96,  53,  255, 101, 133, 58,  255, 96,  133, 53,  255,
    107, 139, 56,  255, 162, 185, 101, 255, 156, 176, 95,  255, 145, 172, 110, 255, 197, 211, 124, 255, 142, 168, 103, 255, 119, 159, 98,  255, 111,
    151, 77,  255, 92,  132, 62,  255, 78,  116, 55,  255, 69,  98,  41,  255, 58,  84,  31,  255, 65,  98,  33,  255, 52,  84,  31,  255, 69,  103,
    42,  255, 101, 134, 52,  255, 116, 147, 75,  255, 132, 162, 98,  255, 160, 188, 106, 255, 158, 168, 80,  255, 42,  41,  23,  255, 12,  19,  19,
    255, 28,  39,  25,  255, 36,  47,  29,  255, 37,  52,  32,  255, 62,  90,  34,  255, 58,  90,  26,  255, 85,  113, 40,  255, 184, 200, 72,  255,
    111, 128, 55,  255, 58,  63,  41,  255, 149, 165, 68,  255, 119, 147, 60,  255, 73,  98,  41,  255, 145, 165, 68,  255, 116, 146, 55,  255, 94,
    130, 47,  255, 130, 159, 62,  255, 166, 175, 90,  255, 41,  51,  28,  255, 46,  75,  32,  255, 47,  76,  36,  255, 76,  107, 55,  255, 108, 142,
    83,  255, 147, 176, 116, 255, 63,  81,  55,  255, 99,  121, 69,  255, 180, 196, 91,  255, 186, 197, 78,  255, 200, 202, 68,  255, 184, 196, 73,
    255, 120, 154, 60,  255, 170, 178, 78,  255, 111, 128, 47,  255, 71,  103, 21,  255, 82,  111, 26,  255, 75,  99,  26,  255, 69,  95,  26,  255,
    62,  94,  52,  255, 68,  91,  44,  255, 113, 136, 56,  255, 120, 148, 65,  255, 103, 133, 65,  255, 106, 136, 60,  255, 109, 133, 52,  255, 75,
    98,  29,  255, 107, 138, 58,  255, 115, 150, 55,  255, 136, 159, 58,  255, 155, 174, 76,  255, 141, 165, 73,  255, 144, 167, 83,  255, 217, 226,
    171, 255, 212, 226, 156, 255, 203, 209, 119, 255, 152, 158, 68,  255, 68,  76,  29,  255, 6,   17,  9,   255, 95,  106, 40,  255, 215, 225, 98,
    255, 186, 201, 97,  255, 156, 178, 98,  255, 140, 169, 90,  255, 124, 158, 68,  255, 167, 187, 60,  255, 189, 203, 67,  255, 158, 182, 68,  255,
    162, 187, 84,  255, 157, 177, 98,  255, 174, 190, 93,  255, 112, 135, 60,  255, 90,  121, 52,  255, 124, 161, 55,  255, 127, 166, 52,  255, 115,
    146, 56,  255, 102, 128, 53,  255, 100, 127, 49,  255, 114, 133, 52,  255, 197, 196, 99,  255, 214, 226, 137, 255, 178, 202, 137, 255, 172, 196,
    134, 255, 174, 196, 121, 255, 162, 188, 112, 255, 162, 187, 104, 255, 164, 187, 91,  255, 158, 177, 86,  255, 172, 189, 118, 255, 148, 166, 115,
    255, 161, 177, 96,  255, 144, 164, 93,  255, 161, 171, 100, 255, 209, 217, 138, 255, 181, 213, 141, 255, 171, 203, 142, 255, 185, 212, 176, 255,
    179, 207, 169, 255, 219, 227, 168, 255, 128, 133, 92,  255, 6,   12,  9,   255, 60,  78,  37,  255, 60,  76,  37,  255, 47,  65,  31,  255, 34,
    47,  25,  255, 25,  34,  23,  255, 63,  90,  49,  255, 62,  89,  52,  255, 44,  62,  41,  255, 112, 124, 67,  255, 157, 167, 77,  255, 139, 159,
    56,  255, 138, 165, 60,  255, 120, 152, 58,  255, 96,  129, 55,  255, 81,  113, 48,  255, 105, 137, 55,  255, 106, 120, 44,  255, 192, 203, 114,
    255, 228, 235, 139, 255, 179, 178, 94,  255, 126, 139, 62,  255, 166, 190, 109, 255, 179, 205, 120, 255, 126, 138, 73,  255, 19,  23,  12,  255,
    19,  23,  15,  255, 39,  52,  23,  255, 55,  67,  31,  255, 65,  80,  36,  255, 68,  92,  36,  255, 57,  87,  32,  255, 65,  90,  37,  255, 50,
    68,  41,  255, 52,  77,  41,  255, 53,  79,  39,  255, 23,  37,  21,  255, 17,  31,  17,  255, 114, 142, 48,  255, 106, 144, 58,  255, 79,  123,
    48,  255, 84,  126, 53,  255, 97,  139, 68,  255, 123, 155, 71,  255, 53,  75,  31,  255, 41,  58,  31,  255, 47,  69,  31,  255, 48,  75,  34,
    255, 48,  79,  21,  255, 89,  115, 39,  255, 171, 177, 76,  255, 208, 219, 117, 255, 179, 188, 100, 255, 87,  116, 55,  255, 82,  107, 58,  255,
    119, 126, 68,  255, 125, 131, 58,  255, 146, 153, 68,  255, 161, 174, 75,  255, 160, 174, 76,  255, 162, 177, 77,  255, 154, 174, 71,  255, 113,
    135, 53,  255, 60,  75,  36,  255, 39,  55,  23,  255, 100, 134, 65,  255, 100, 136, 79,  255, 100, 135, 72,  255, 83,  120, 62,  255, 78,  115,
    48,  255, 93,  117, 49,  255, 107, 134, 52,  255, 116, 138, 50,  255, 115, 145, 67,  255, 103, 141, 73,  255, 114, 150, 84,  255, 144, 176, 112,
    255, 134, 160, 87,  255, 107, 139, 84,  255, 99,  128, 79,  255, 84,  111, 69,  255, 29,  33,  26,  255, 26,  31,  26,  255, 36,  48,  26,  255,
    74,  103, 36,  255, 73,  107, 45,  255, 42,  74,  38,  255, 69,  98,  36,  255, 145, 172, 82,  255, 116, 152, 72,  255, 95,  123, 55,  255, 68,
    92,  37,  255, 67,  98,  34,  255, 124, 151, 65,  255, 89,  115, 50,  255, 84,  113, 39,  255, 87,  114, 39,  255, 63,  87,  32,  255, 40,  55,
    28,  255, 40,  48,  31,  255, 100, 119, 52,  255, 150, 172, 77,  255, 113, 136, 58,  255, 156, 179, 74,  255, 160, 181, 82,  255, 96,  116, 47,
    255, 12,  21,  12,  255, 48,  68,  29,  255, 134, 160, 74,  255, 153, 175, 100, 255, 124, 144, 86,  255, 149, 179, 124, 255, 185, 203, 125, 255,
    189, 210, 142, 255, 147, 174, 126, 255, 150, 171, 105, 255, 206, 219, 159, 255, 194, 208, 125, 255, 132, 161, 73,  255, 130, 161, 81,  255, 53,
    68,  32,  255, 55,  80,  31,  255, 36,  58,  23,  255, 39,  58,  25,  255, 34,  51,  26,  255, 37,  47,  31,  255, 31,  47,  28,  255, 46,  71,
    26,  255, 47,  75,  21,  255, 106, 135, 68,  255, 89,  103, 60,  255, 34,  40,  28,  255, 94,  93,  69,  255, 101, 103, 68,  255, 123, 127, 80,
    255, 110, 121, 67,  255, 90,  119, 47,  255, 68,  97,  36,  255, 83,  110, 47,  255, 149, 171, 87,  255, 151, 171, 94,  255, 192, 207, 111, 255,
    149, 172, 94,  255, 126, 157, 99,  255, 122, 154, 90,  255, 110, 146, 77,  255, 107, 145, 71,  255, 104, 143, 60,  255, 83,  119, 36,  255, 65,
    98,  32,  255, 73,  106, 39,  255, 86,  124, 47,  255, 97,  136, 65,  255, 102, 144, 79,  255, 111, 150, 87,  255, 111, 154, 93,  255, 170, 197,
    105, 255, 118, 118, 48,  255, 12,  17,  15,  255, 29,  39,  26,  255, 32,  43,  26,  255, 32,  48,  28,  255, 44,  69,  32,  255, 58,  83,  31,
    255, 53,  81,  25,  255, 157, 171, 63,  255, 56,  62,  36,  255, 106, 104, 62,  255, 155, 167, 65,  255, 55,  84,  31,  255, 74,  100, 36,  255,
    139, 164, 72,  255, 133, 162, 71,  255, 131, 158, 65,  255, 95,  122, 40,  255, 56,  78,  33,  255, 34,  52,  25,  255, 60,  94,  38,  255, 67,
    102, 39,  255, 52,  86,  39,  255, 91,  121, 65,  255, 141, 162, 75,  255, 53,  60,  23,  255, 42,  49,  23,  255, 183, 188, 58,  255, 183, 193,
    63,  255, 192, 199, 67,  255, 207, 213, 99,  255, 131, 165, 69,  255, 135, 162, 60,  255, 97,  131, 34,  255, 120, 150, 62,  255, 107, 135, 50,
    255, 86,  116, 42,  255, 62,  87,  26,  255, 77,  104, 40,  255, 85,  113, 49,  255, 99,  130, 50,  255, 130, 158, 58,  255, 137, 166, 60,  255,
    120, 149, 60,  255, 75,  85,  41,  255, 43,  52,  19,  255, 110, 134, 52,  255, 133, 163, 74,  255, 123, 156, 65,  255, 150, 172, 76,  255, 151,
    174, 80,  255, 135, 159, 76,  255, 170, 181, 110, 255, 160, 174, 92,  255, 115, 137, 62,  255, 122, 146, 63,  255, 29,  42,  23,  255, 45,  55,
    19,  255, 190, 196, 77,  255, 177, 194, 91,  255, 131, 162, 90,  255, 120, 154, 86,  255, 114, 152, 67,  255, 148, 176, 67,  255, 213, 219, 73,
    255, 154, 164, 62,  255, 119, 133, 65,  255, 148, 164, 74,  255, 160, 184, 99,  255, 179, 198, 106, 255, 110, 141, 58,  255, 106, 133, 62,  255,
    183, 201, 116, 255, 180, 199, 108, 255, 145, 169, 83,  255, 115, 140, 60,  255, 95,  119, 47,  255, 90,  121, 52,  255, 103, 123, 41,  255, 179,
    182, 80,  255, 203, 211, 122, 255, 161, 185, 114, 255, 151, 179, 114, 255, 138, 171, 109, 255, 129, 167, 92,  255, 121, 159, 73,  255, 133, 168,
    93,  255, 147, 175, 103, 255, 164, 185, 95,  255, 156, 174, 97,  255, 125, 151, 93,  255, 151, 175, 105, 255, 176, 188, 113, 255, 201, 209, 138,
    255, 187, 213, 143, 255, 171, 202, 151, 255, 174, 203, 166, 255, 187, 210, 169, 255, 197, 204, 148, 255, 44,  52,  33,  255, 45,  63,  26,  255,
    52,  82,  31,  255, 46,  72,  32,  255, 29,  47,  25,  255, 47,  68,  36,  255, 82,  114, 62,  255, 60,  87,  56,  255, 49,  74,  46,  255, 86,
    99,  47,  255, 162, 168, 80,  255, 139, 152, 58,  255, 147, 171, 58,  255, 128, 161, 56,  255, 108, 142, 58,  255, 94,  128, 58,  255, 123, 149,
    60,  255, 58,  68,  26,  255, 105, 113, 56,  255, 121, 128, 68,  255, 69,  91,  43,  255, 43,  58,  26,  255, 71,  79,  41,  255, 111, 114, 65,
    255, 37,  37,  23,  255, 29,  44,  26,  255, 63,  92,  43,  255, 66,  96,  46,  255, 60,  87,  48,  255, 58,  80,  44,  255, 58,  76,  38,  255,
    52,  71,  38,  255, 58,  81,  43,  255, 58,  82,  50,  255, 53,  77,  44,  255, 60,  87,  40,  255, 28,  41,  23,  255, 25,  37,  28,  255, 113,
    131, 48,  255, 152, 183, 86,  255, 101, 144, 73,  255, 106, 147, 72,  255, 132, 168, 79,  255, 164, 187, 78,  255, 58,  80,  36,  255, 39,  62,
    31,  255, 49,  74,  36,  255, 65,  89,  36,  255, 94,  122, 45,  255, 118, 132, 56,  255, 91,  107, 36,  255, 125, 152, 67,  255, 97,  125, 60,
    255, 77,  115, 41,  255, 98,  117, 47,  255, 194, 199, 95,  255, 165, 183, 81,  255, 167, 183, 75,  255, 175, 187, 76,  255, 177, 187, 82,  255,
    171, 185, 82,  255, 166, 182, 75,  255, 172, 186, 79,  255, 157, 174, 77,  255, 106, 128, 48,  255, 106, 137, 47,  255, 114, 142, 58,  255, 111,
    140, 60,  255, 109, 138, 56,  255, 112, 138, 58,  255, 93,  115, 48,  255, 65,  81,  31,  255, 75,  101, 36,  255, 100, 139, 65,  255, 130, 168,
    102, 255, 147, 185, 120, 255, 82,  103, 65,  255, 79,  84,  52,  255, 108, 141, 80,  255, 83,  115, 62,  255, 72,  95,  58,  255, 29,  37,  26,
    255, 31,  36,  28,  255, 74,  80,  55,  255, 100, 119, 58,  255, 62,  97,  43,  255, 47,  71,  43,  255, 41,  63,  31,  255, 134, 159, 89,  255,
    170, 198, 114, 255, 191, 211, 108, 255, 123, 146, 65,  255, 80,  102, 41,  255, 138, 168, 68,  255, 90,  114, 52,  255, 55,  68,  40,  255, 26,
    37,  21,  255, 32,  48,  26,  255, 39,  62,  26,  255, 40,  53,  28,  255, 32,  43,  23,  255, 114, 137, 50,  255, 160, 186, 71,  255, 159, 181,
    76,  255, 161, 183, 82,  255, 87,  114, 42,  255, 45,  65,  28,  255, 29,  47,  26,  255, 98,  117, 60,  255, 119, 140, 76,  255, 133, 161, 115,
    255, 156, 183, 126, 255, 179, 198, 116, 255, 178, 197, 123, 255, 154, 181, 130, 255, 147, 168, 103, 255, 213, 226, 161, 255, 145, 160, 84,  255,
    62,  80,  25,  255, 55,  60,  36,  255, 56,  83,  25,  255, 36,  58,  23,  255, 37,  60,  25,  255, 55,  77,  33,  255, 60,  74,  41,  255, 41,
    52,  31,  255, 62,  84,  36,  255, 52,  82,  25,  255, 78,  105, 36,  255, 152, 178, 108, 255, 145, 166, 108, 255, 50,  51,  38,  255, 121, 116,
    83,  255, 137, 134, 90,  255, 146, 144, 102, 255, 134, 138, 84,  255, 76,  93,  41,  255, 67,  92,  39,  255, 84,  118, 60,  255, 113, 146, 81,
    255, 121, 147, 65,  255, 150, 175, 87,  255, 176, 198, 113, 255, 186, 203, 110, 255, 189, 205, 109, 255, 176, 199, 96,  255, 105, 131, 58,  255,
    73,  94,  42,  255, 76,  110, 36,  255, 60,  92,  32,  255, 129, 161, 60,  255, 107, 146, 58,  255, 100, 143, 65,  255, 113, 153, 75,  255, 122,
    159, 84,  255, 120, 159, 89,  255, 181, 204, 105, 255, 133, 130, 53,  255, 17,  23,  17,  255, 37,  49,  28,  255, 34,  49,  28,  255, 34,  52,
    29,  255, 38,  58,  31,  255, 36,  58,  29,  255, 43,  55,  31,  255, 80,  87,  47,  255, 48,  55,  31,  255, 147, 145, 62,  255, 84,  99,  47,
    255, 73,  102, 39,  255, 72,  87,  36,  255, 53,  67,  32,  255, 104, 128, 65,  255, 87,  107, 47,  255, 60,  83,  32,  255, 46,  68,  26,  255,
    40,  60,  28,  255, 52,  77,  33,  255, 81,  118, 48,  255, 71,  106, 43,  255, 65,  92,  47,  255, 84,  117, 52,  255, 55,  75,  31,  255, 23,
    28,  17,  255, 169, 172, 50,  255, 151, 177, 79,  255, 179, 189, 71,  255, 208, 218, 122, 255, 157, 185, 87,  255, 136, 166, 58,  255, 159, 183,
    82,  255, 167, 188, 101, 255, 155, 178, 83,  255, 146, 172, 86,  255, 94,  129, 45,  255, 119, 143, 47,  255, 107, 136, 58,  255, 110, 141, 56,
    255, 145, 170, 63,  255, 161, 184, 74,  255, 91,  110, 42,  255, 12,  19,  12,  255, 32,  42,  17,  255, 109, 139, 60,  255, 118, 148, 68,  255,
    116, 147, 60,  255, 130, 158, 68,  255, 143, 166, 77,  255, 96,  133, 60,  255, 123, 153, 75,  255, 118, 146, 74,  255, 93,  123, 65,  255, 146,
    168, 75,  255, 55,  79,  28,  255, 113, 120, 43,  255, 178, 195, 81,  255, 122, 157, 78,  255, 133, 163, 81,  255, 157, 187, 73,  255, 189, 207,
    75,  255, 200, 201, 72,  255, 114, 107, 38,  255, 90,  109, 55,  255, 92,  123, 73,  255, 92,  119, 56,  255, 128, 138, 47,  255, 165, 171, 69,
    255, 159, 176, 68,  255, 135, 155, 73,  255, 185, 198, 120, 255, 178, 201, 135, 255, 170, 193, 126, 255, 180, 197, 111, 255, 128, 152, 68,  255,
    96,  124, 49,  255, 85,  117, 37,  255, 134, 155, 48,  255, 160, 184, 92,  255, 125, 161, 94,  255, 132, 165, 93,  255, 132, 166, 91,  255, 127,
    164, 91,  255, 136, 171, 101, 255, 160, 186, 86,  255, 158, 187, 60,  255, 184, 205, 73,  255, 144, 164, 100, 255, 119, 146, 78,  255, 134, 161,
    99,  255, 129, 160, 107, 255, 136, 157, 99,  255, 186, 194, 125, 255, 193, 216, 153, 255, 173, 204, 158, 255, 177, 204, 166, 255, 206, 222, 169,
    255, 140, 149, 97,  255, 46,  75,  15,  255, 80,  116, 36,  255, 82,  115, 42,  255, 69,  106, 38,  255, 74,  109, 50,  255, 89,  123, 65,  255,
    68,  96,  56,  255, 52,  81,  47,  255, 60,  86,  43,  255, 95,  106, 53,  255, 58,  63,  31,  255, 106, 116, 34,  255, 151, 175, 62,  255, 143,
    170, 79,  255, 136, 162, 74,  255, 89,  98,  42,  255, 33,  47,  23,  255, 55,  71,  29,  255, 87,  110, 60,  255, 81,  110, 58,  255, 56,  77,
    42,  255, 23,  31,  23,  255, 12,  9,   12,  255, 23,  36,  23,  255, 84,  118, 56,  255, 92,  123, 58,  255, 87,  118, 56,  255, 80,  110, 55,
    255, 77,  106, 50,  255, 69,  92,  46,  255, 62,  74,  46,  255, 62,  81,  44,  255, 75,  101, 56,  255, 62,  87,  47,  255, 55,  81,  36,  255,
    55,  84,  42,  255, 73,  97,  73,  255, 77,  91,  47,  255, 160, 180, 76,  255, 144, 182, 102, 255, 124, 167, 89,  255, 129, 169, 86,  255, 168,
    192, 94,  255, 120, 151, 82,  255, 52,  71,  34,  255, 42,  58,  26,  255, 52,  73,  31,  255, 105, 126, 56,  255, 116, 140, 68,  255, 94,  127,
    71,  255, 100, 137, 65,  255, 77,  117, 39,  255, 83,  119, 37,  255, 147, 164, 84,  255, 199, 208, 108, 255, 141, 165, 84,  255, 107, 139, 81,
    255, 151, 169, 81,  255, 171, 183, 71,  255, 166, 181, 73,  255, 166, 180, 73,  255, 166, 180, 73,  255, 162, 178, 77,  255, 151, 176, 72,  255,
    101, 129, 45,  255, 69,  94,  48,  255, 69,  96,  56,  255, 71,  94,  56,  255, 84,  103, 58,  255, 69,  91,  41,  255, 46,  67,  34,  255, 71,
    96,  42,  255, 118, 150, 68,  255, 160, 194, 128, 255, 139, 163, 101, 255, 88,  97,  40,  255, 63,  72,  33,  255, 83,  103, 47,  255, 84,  119,
    53,  255, 63,  91,  48,  255, 47,  75,  36,  255, 63,  84,  37,  255, 168, 186, 120, 255, 172, 194, 121, 255, 138, 154, 86,  255, 53,  75,  44,
    255, 36,  60,  33,  255, 90,  116, 58,  255, 183, 203, 123, 255, 142, 159, 80,  255, 91,  114, 52,  255, 125, 157, 71,  255, 131, 170, 56,  255,
    159, 181, 86,  255, 145, 157, 90,  255, 94,  103, 55,  255, 122, 135, 82,  255, 151, 170, 115, 255, 117, 130, 83,  255, 47,  60,  32,  255, 41,
    55,  23,  255, 99,  122, 43,  255, 162, 187, 84,  255, 136, 163, 68,  255, 85,  117, 37,  255, 99,  130, 49,  255, 109, 131, 60,  255, 98,  120,
    55,  255, 124, 153, 82,  255, 146, 177, 111, 255, 156, 183, 92,  255, 160, 177, 92,  255, 133, 143, 103, 255, 161, 183, 117, 255, 141, 163, 97,
    255, 206, 220, 145, 255, 107, 127, 56,  255, 69,  98,  32,  255, 67,  92,  31,  255, 89,  126, 31,  255, 79,  104, 31,  255, 43,  71,  21,  255,
    79,  109, 48,  255, 166, 185, 130, 255, 109, 118, 87,  255, 94,  116, 50,  255, 75,  101, 33,  255, 92,  114, 62,  255, 168, 196, 129, 255, 159,
    187, 122, 255, 79,  92,  52,  255, 124, 124, 73,  255, 152, 139, 95,  255, 158, 150, 111, 255, 133, 134, 81,  255, 62,  84,  31,  255, 100, 135,
    52,  255, 118, 152, 74,  255, 122, 154, 77,  255, 114, 145, 58,  255, 116, 146, 68,  255, 140, 169, 87,  255, 152, 178, 87,  255, 164, 185, 94,
    255, 112, 127, 60,  255, 23,  23,  19,  255, 23,  26,  21,  255, 75,  104, 42,  255, 48,  79,  32,  255, 115, 142, 65,  255, 163, 186, 87,  255,
    156, 185, 91,  255, 175, 197, 101, 255, 184, 203, 107, 255, 186, 202, 103, 255, 222, 229, 127, 255, 149, 147, 78,  255, 21,  23,  15,  255, 36,
    51,  25,  255, 41,  62,  29,  255, 36,  52,  29,  255, 39,  60,  29,  255, 39,  65,  29,  255, 47,  65,  31,  255, 44,  58,  34,  255, 120, 127,
    60,  255, 111, 111, 52,  255, 15,  21,  19,  255, 38,  48,  26,  255, 152, 173, 89,  255, 105, 115, 53,  255, 29,  48,  21,  255, 40,  60,  31,
    255, 43,  62,  31,  255, 40,  60,  26,  255, 41,  55,  28,  255, 37,  52,  29,  255, 53,  82,  37,  255, 81,  116, 49,  255, 79,  111, 48,  255,
    81,  112, 58,  255, 72,  95,  41,  255, 78,  94,  45,  255, 152, 179, 89,  255, 145, 176, 94,  255, 136, 163, 76,  255, 180, 202, 118, 255, 210,
    220, 130, 255, 168, 187, 117, 255, 148, 175, 112, 255, 143, 168, 74,  255, 175, 192, 107, 255, 197, 212, 132, 255, 152, 168, 73,  255, 182, 189,
    65,  255, 121, 150, 63,  255, 124, 150, 65,  255, 167, 183, 73,  255, 170, 188, 83,  255, 91,  122, 58,  255, 65,  91,  38,  255, 128, 151, 68,
    255, 155, 180, 103, 255, 151, 178, 101, 255, 132, 161, 81,  255, 109, 141, 58,  255, 119, 144, 67,  255, 106, 138, 63,  255, 123, 148, 72,  255,
    94,  126, 68,  255, 87,  121, 67,  255, 143, 166, 75,  255, 92,  120, 36,  255, 149, 160, 65,  255, 151, 181, 93,  255, 154, 181, 87,  255, 196,
    203, 72,  255, 197, 190, 65,  255, 130, 120, 47,  255, 53,  52,  21,  255, 23,  37,  15,  255, 101, 117, 53,  255, 120, 144, 76,  255, 99,  125,
    53,  255, 53,  81,  19,  255, 123, 144, 44,  255, 171, 186, 58,  255, 146, 163, 48,  255, 174, 184, 80,  255, 178, 203, 138, 255, 155, 187, 136,
    255, 156, 185, 136, 255, 170, 191, 121, 255, 163, 184, 86,  255, 138, 159, 58,  255, 183, 196, 68,  255, 146, 174, 74,  255, 121, 159, 79,  255,
    126, 164, 87,  255, 125, 162, 84,  255, 139, 170, 100, 255, 140, 171, 80,  255, 150, 178, 65,  255, 162, 187, 63,  255, 183, 199, 69,  255, 121,
    143, 69,  255, 103, 140, 65,  255, 117, 151, 84,  255, 126, 157, 99,  255, 120, 153, 101, 255, 130, 156, 97,  255, 181, 188, 117, 255, 196, 214,
    150, 255, 182, 209, 161, 255, 190, 211, 162, 255, 206, 214, 146, 255, 104, 133, 43,  255, 82,  117, 32,  255, 87,  120, 42,  255, 86,  119, 44,
    255, 89,  125, 58,  255, 84,  115, 68,  255, 71,  100, 60,  255, 75,  103, 60,  255, 77,  108, 53,  255, 56,  78,  38,  255, 26,  36,  21,  255,
    39,  52,  25,  255, 115, 129, 56,  255, 148, 159, 84,  255, 108, 120, 56,  255, 34,  42,  23,  255, 38,  49,  26,  255, 50,  71,  31,  255, 69,
    91,  42,  255, 74,  102, 52,  255, 60,  91,  50,  255, 34,  47,  31,  255, 9,   6,   12,  255, 60,  81,  42,  255, 112, 144, 73,  255, 105, 136,
    68,  255, 93,  124, 62,  255, 78,  111, 50,  255, 84,  115, 58,  255, 80,  106, 47,  255, 37,  49,  29,  255, 42,  53,  31,  255, 62,  76,  41,
    255, 58,  80,  39,  255, 58,  91,  37,  255, 80,  116, 52,  255, 110, 135, 76,  255, 58,  78,  42,  255, 87,  104, 39,  255, 164, 185, 80,  255,
    156, 188, 105, 255, 149, 186, 115, 255, 171, 195, 113, 255, 152, 182, 107, 255, 100, 127, 63,  255, 77,  107, 31,  255, 68,  102, 36,  255, 119,
    138, 63,  255, 128, 159, 89,  255, 110, 146, 91,  255, 97,  127, 75,  255, 74,  109, 36,  255, 133, 151, 68,  255, 190, 208, 118, 255, 158, 182,
    105, 255, 196, 202, 101, 255, 140, 163, 94,  255, 111, 142, 97,  255, 141, 163, 89,  255, 165, 178, 74,  255, 176, 187, 76,  255, 179, 190, 83,
    255, 167, 182, 83,  255, 155, 177, 79,  255, 127, 157, 65,  255, 60,  86,  36,  255, 65,  92,  48,  255, 60,  87,  49,  255, 83,  102, 53,  255,
    60,  86,  41,  255, 55,  86,  48,  255, 48,  74,  44,  255, 67,  92,  47,  255, 140, 168, 107, 255, 111, 134, 74,  255, 157, 180, 80,  255, 122,
    158, 67,  255, 63,  86,  36,  255, 62,  89,  36,  255, 48,  75,  38,  255, 42,  67,  38,  255, 69,  92,  46,  255, 168, 189, 120, 255, 156, 186,
    127, 255, 184, 205, 134, 255, 150, 162, 93,  255, 46,  69,  33,  255, 44,  63,  28,  255, 52,  74,  38,  255, 58,  95,  46,  255, 65,  97,  41,
    255, 115, 148, 55,  255, 154, 185, 74,  255, 183, 208, 124, 255, 211, 229, 171, 255, 197, 223, 162, 255, 206, 232, 165, 255, 197, 214, 146, 255,
    126, 139, 79,  255, 104, 121, 53,  255, 100, 113, 52,  255, 79,  98,  47,  255, 129, 160, 68,  255, 118, 148, 60,  255, 87,  122, 43,  255, 153,
    172, 79,  255, 217, 229, 129, 255, 167, 197, 115, 255, 164, 193, 114, 255, 165, 194, 119, 255, 157, 186, 95,  255, 136, 167, 62,  255, 107, 124,
    76,  255, 128, 143, 87,  255, 129, 155, 77,  255, 148, 175, 94,  255, 98,  131, 47,  255, 86,  123, 42,  255, 81,  119, 31,  255, 94,  122, 36,
    255, 65,  89,  31,  255, 52,  82,  28,  255, 52,  75,  26,  255, 160, 180, 124, 255, 192, 217, 169, 255, 168, 175, 116, 255, 127, 150, 68,  255,
    92,  115, 63,  255, 158, 185, 139, 255, 170, 195, 142, 255, 119, 144, 65,  255, 94,  108, 52,  255, 150, 131, 106, 255, 168, 166, 127, 255, 96,
    111, 58,  255, 23,  42,  12,  255, 52,  65,  29,  255, 143, 169, 73,  255, 176, 197, 83,  255, 158, 186, 75,  255, 140, 171, 82,  255, 166, 192,
    95,  255, 178, 198, 99,  255, 94,  112, 48,  255, 21,  28,  21,  255, 26,  26,  25,  255, 44,  57,  31,  255, 69,  99,  40,  255, 57,  84,  37,
    255, 72,  99,  56,  255, 110, 135, 68,  255, 135, 152, 74,  255, 129, 141, 73,  255, 99,  111, 49,  255, 67,  73,  33,  255, 76,  83,  60,  255,
    75,  84,  62,  255, 17,  19,  17,  255, 29,  46,  26,  255, 47,  75,  31,  255, 42,  62,  33,  255, 39,  63,  31,  255, 42,  69,  29,  255, 42,
    67,  28,  255, 75,  91,  47,  255, 199, 197, 89,  255, 55,  67,  38,  255, 21,  31,  19,  255, 56,  71,  38,  255, 167, 191, 95,  255, 165, 184,
    77,  255, 47,  57,  23,  255, 42,  62,  31,  255, 55,  75,  33,  255, 34,  51,  25,  255, 33,  44,  26,  255, 39,  55,  28,  255, 104, 120, 60,
    255, 130, 149, 72,  255, 92,  127, 45,  255, 76,  113, 47,  255, 86,  112, 53,  255, 113, 132, 68,  255, 129, 150, 78,  255, 107, 131, 52,  255,
    114, 145, 65,  255, 129, 152, 74,  255, 164, 183, 98,  255, 208, 221, 131, 255, 164, 185, 127, 255, 133, 168, 109, 255, 147, 181, 116, 255, 159,
    188, 132, 255, 193, 206, 112, 255, 192, 198, 75,  255, 156, 176, 68,  255, 149, 164, 68,  255, 183, 191, 75,  255, 170, 180, 72,  255, 161, 183,
    103, 255, 155, 192, 114, 255, 135, 173, 90,  255, 117, 155, 86,  255, 122, 159, 98,  255, 120, 155, 95,  255, 117, 152, 84,  255, 110, 140, 65,
    255, 121, 147, 68,  255, 101, 131, 68,  255, 86,  122, 69,  255, 86,  121, 71,  255, 124, 151, 74,  255, 98,  124, 41,  255, 167, 169, 87,  255,
    194, 195, 102, 255, 156, 155, 58,  255, 116, 127, 34,  255, 56,  72,  26,  255, 12,  21,  17,  255, 17,  25,  17,  255, 29,  42,  19,  255, 68,
    83,  29,  255, 115, 129, 58,  255, 69,  94,  32,  255, 55,  83,  21,  255, 174, 192, 77,  255, 177, 197, 74,  255, 156, 181, 58,  255, 157, 177,
    60,  255, 191, 208, 121, 255, 163, 192, 134, 255, 158, 191, 146, 255, 152, 185, 145, 255, 156, 184, 117, 255, 158, 178, 85,  255, 194, 204, 87,
    255, 155, 187, 87,  255, 131, 170, 82,  255, 130, 167, 90,  255, 140, 174, 99,  255, 133, 166, 75,  255, 148, 177, 65,  255, 169, 193, 68,  255,
    173, 186, 65,  255, 132, 147, 49,  255, 133, 156, 55,  255, 130, 164, 79,  255, 127, 160, 84,  255, 127, 161, 95,  255, 143, 173, 100, 255, 128,
    159, 102, 255, 112, 144, 91,  255, 142, 160, 97,  255, 199, 209, 141, 255, 194, 215, 163, 255, 204, 218, 157, 255, 202, 210, 114, 255, 96,  130,
    41,  255, 94,  127, 41,  255, 100, 130, 53,  255, 92,  125, 50,  255, 81,  108, 53,  255, 82,  106, 52,  255, 80,  102, 49,  255, 67,  84,  42,
    255, 38,  47,  26,  255, 15,  21,  17,  255, 41,  55,  26,  255, 81,  107, 58,  255, 78,  100, 56,  255, 81,  108, 58,  255, 63,  87,  44,  255,
    42,  63,  31,  255, 52,  76,  31,  255, 43,  68,  29,  255, 47,  74,  34,  255, 58,  92,  43,  255, 44,  67,  34,  255, 17,  29,  17,  255, 83,
    109, 55,  255, 130, 158, 87,  255, 105, 133, 68,  255, 99,  134, 68,  255, 122, 156, 80,  255, 135, 164, 87,  255, 119, 145, 74,  255, 58,  84,
    47,  255, 23,  40,  26,  255, 23,  29,  21,  255, 49,  72,  33,  255, 78,  116, 49,  255, 86,  118, 60,  255, 114, 137, 75,  255, 53,  63,  32,
    255, 69,  90,  41,  255, 103, 130, 56,  255, 143, 163, 77,  255, 172, 196, 120, 255, 172, 198, 116, 255, 159, 186, 110, 255, 153, 182, 99,  255,
    112, 138, 52,  255, 96,  119, 58,  255, 145, 170, 95,  255, 118, 150, 101, 255, 125, 150, 101, 255, 123, 144, 80,  255, 106, 120, 52,  255, 182,
    199, 108, 255, 141, 173, 101, 255, 117, 154, 102, 255, 172, 184, 106, 255, 218, 218, 107, 255, 154, 174, 101, 255, 140, 164, 100, 255, 154, 176,
    107, 255, 167, 184, 102, 255, 184, 194, 99,  255, 181, 194, 94,  255, 163, 183, 87,  255, 149, 175, 82,  255, 85,  112, 47,  255, 36,  58,  23,
    255, 60,  83,  36,  255, 76,  90,  47,  255, 38,  51,  29,  255, 60,  90,  43,  255, 44,  68,  43,  255, 42,  67,  42,  255, 48,  72,  41,  255,
    60,  87,  41,  255, 143, 157, 71,  255, 159, 189, 83,  255, 111, 151, 65,  255, 84,  117, 52,  255, 81,  110, 47,  255, 55,  81,  41,  255, 63,
    82,  47,  255, 177, 193, 124, 255, 161, 188, 134, 255, 149, 180, 135, 255, 186, 204, 127, 255, 126, 143, 72,  255, 33,  46,  26,  255, 87,  87,
    47,  255, 103, 123, 58,  255, 87,  110, 52,  255, 138, 164, 75,  255, 169, 198, 117, 255, 164, 201, 149, 255, 161, 199, 130, 255, 188, 212, 127,
    255, 177, 193, 118, 255, 91,  114, 47,  255, 130, 148, 63,  255, 187, 204, 82,  255, 191, 209, 80,  255, 168, 189, 75,  255, 128, 154, 62,  255,
    91,  120, 60,  255, 92,  122, 62,  255, 126, 143, 56,  255, 190, 197, 114, 255, 211, 226, 157, 255, 191, 214, 151, 255, 192, 214, 148, 255, 197,
    219, 142, 255, 121, 148, 55,  255, 89,  113, 47,  255, 101, 126, 60,  255, 102, 133, 50,  255, 97,  131, 45,  255, 91,  126, 40,  255, 95,  128,
    40,  255, 98,  131, 38,  255, 37,  51,  28,  255, 52,  73,  31,  255, 72,  102, 34,  255, 45,  57,  26,  255, 100, 110, 74,  255, 162, 196, 143,
    255, 192, 214, 175, 255, 190, 206, 137, 255, 144, 173, 82,  255, 170, 194, 149, 255, 172, 193, 149, 255, 91,  113, 52,  255, 69,  94,  47,  255,
    121, 117, 91,  255, 127, 133, 85,  255, 86,  109, 52,  255, 102, 117, 74,  255, 91,  99,  62,  255, 99,  118, 47,  255, 199, 210, 96,  255, 150,
    182, 87,  255, 139, 177, 99,  255, 154, 186, 106, 255, 190, 212, 131, 255, 166, 174, 93,  255, 21,  23,  15,  255, 56,  74,  36,  255, 83,  114,
    47,  255, 76,  106, 41,  255, 58,  83,  36,  255, 78,  108, 56,  255, 71,  97,  41,  255, 33,  46,  21,  255, 25,  40,  19,  255, 23,  31,  23,
    255, 25,  23,  28,  255, 23,  26,  26,  255, 25,  33,  23,  255, 28,  41,  25,  255, 33,  53,  26,  255, 49,  81,  32,  255, 52,  81,  36,  255,
    47,  71,  33,  255, 49,  76,  34,  255, 47,  75,  31,  255, 63,  75,  36,  255, 117, 121, 55,  255, 42,  60,  34,  255, 17,  33,  19,  255, 93,
    113, 60,  255, 178, 200, 103, 255, 163, 189, 68,  255, 112, 131, 42,  255, 112, 130, 50,  255, 53,  67,  28,  255, 26,  39,  23,  255, 29,  48,
    21,  255, 127, 148, 73,  255, 206, 223, 121, 255, 176, 192, 92,  255, 84,  117, 41,  255, 65,  105, 39,  255, 65,  99,  44,  255, 38,  53,  25,
    255, 26,  36,  19,  255, 19,  31,  19,  255, 33,  44,  29,  255, 31,  41,  28,  255, 67,  94,  48,  255, 127, 154, 73,  255, 187, 202, 115, 255,
    188, 208, 123, 255, 170, 196, 114, 255, 160, 185, 110, 255, 175, 188, 84,  255, 176, 178, 62,  255, 177, 187, 73,  255, 155, 173, 73,  255, 178,
    188, 74,  255, 101, 119, 37,  255, 100, 110, 41,  255, 150, 162, 100, 255, 163, 191, 112, 255, 148, 185, 92,  255, 144, 183, 99,  255, 152, 190,
    104, 255, 158, 192, 92,  255, 147, 173, 80,  255, 124, 142, 65,  255, 107, 126, 65,  255, 87,  119, 68,  255, 92,  125, 79,  255, 122, 147, 77,
    255, 106, 127, 50,  255, 91,  107, 31,  255, 83,  103, 32,  255, 49,  83,  25,  255, 62,  101, 28,  255, 63,  91,  31,  255, 28,  38,  23,  255,
    28,  37,  21,  255, 37,  55,  25,  255, 43,  65,  23,  255, 52,  63,  23,  255, 34,  48,  17,  255, 79,  95,  34,  255, 197, 209, 93,  255, 186,
    204, 77,  255, 177, 196, 75,  255, 167, 192, 93,  255, 178, 200, 103, 255, 178, 203, 134, 255, 161, 192, 148, 255, 153, 188, 145, 255, 152, 185,
    135, 255, 169, 188, 100, 255, 197, 203, 95,  255, 207, 222, 104, 255, 151, 182, 102, 255, 146, 176, 100, 255, 147, 177, 100, 255, 147, 177, 81,
    255, 189, 201, 76,  255, 177, 182, 65,  255, 92,  118, 33,  255, 62,  98,  26,  255, 129, 146, 49,  255, 166, 192, 96,  255, 149, 177, 92,  255,
    147, 177, 94,  255, 144, 170, 95,  255, 153, 182, 104, 255, 128, 164, 104, 255, 119, 155, 97,  255, 131, 153, 93,  255, 185, 198, 132, 255, 203,
    216, 155, 255, 221, 223, 130, 255, 151, 173, 86,  255, 99,  133, 44,  255, 110, 138, 55,  255, 109, 138, 52,  255, 63,  79,  37,  255, 62,  81,
    47,  255, 53,  68,  34,  255, 26,  39,  21,  255, 28,  47,  23,  255, 21,  34,  21,  255, 23,  31,  17,  255, 74,  96,  47,  255, 90,  116, 58,
    255, 92,  116, 55,  255, 81,  106, 55,  255, 60,  84,  47,  255, 41,  56,  29,  255, 38,  51,  26,  255, 36,  56,  26,  255, 43,  73,  28,  255,
    43,  68,  33,  255, 33,  52,  32,  255, 71,  92,  48,  255, 130, 159, 86,  255, 125, 160, 87,  255, 144, 175, 96,  255, 142, 169, 96,  255, 138,
    164, 96,  255, 146, 173, 96,  255, 145, 176, 93,  255, 105, 137, 65,  255, 43,  62,  33,  255, 33,  48,  19,  255, 91,  118, 40,  255, 122, 144,
    65,  255, 100, 117, 58,  255, 40,  47,  29,  255, 79,  101, 50,  255, 109, 143, 68,  255, 107, 137, 60,  255, 125, 149, 71,  255, 137, 161, 82,
    255, 157, 180, 91,  255, 157, 184, 87,  255, 115, 140, 62,  255, 127, 148, 75,  255, 153, 179, 108, 255, 168, 186, 116, 255, 137, 155, 87,  255,
    42,  55,  21,  255, 158, 165, 85,  255, 165, 195, 109, 255, 136, 170, 103, 255, 123, 159, 104, 255, 108, 144, 90,  255, 177, 184, 95,  255, 231,
    226, 112, 255, 209, 210, 109, 255, 194, 203, 116, 255, 176, 192, 116, 255, 183, 196, 118, 255, 167, 185, 98,  255, 170, 186, 93,  255, 161, 182,
    89,  255, 126, 154, 68,  255, 38,  58,  25,  255, 65,  79,  39,  255, 62,  74,  41,  255, 25,  32,  21,  255, 69,  95,  43,  255, 57,  86,  42,
    255, 46,  68,  46,  255, 44,  67,  43,  255, 43,  65,  42,  255, 79,  93,  48,  255, 166, 184, 91,  255, 145, 179, 84,  255, 136, 171, 75,  255,
    149, 177, 72,  255, 157, 174, 65,  255, 60,  83,  38,  255, 168, 182, 116, 255, 168, 193, 134, 255, 156, 184, 137, 255, 163, 190, 130, 255, 178,
    193, 111, 255, 47,  52,  34,  255, 157, 167, 100, 255, 164, 187, 83,  255, 174, 200, 81,  255, 191, 211, 103, 255, 180, 209, 135, 255, 181, 211,
    121, 255, 163, 187, 84,  255, 105, 123, 60,  255, 62,  91,  43,  255, 65,  101, 31,  255, 121, 141, 53,  255, 183, 196, 84,  255, 187, 203, 92,
    255, 173, 192, 83,  255, 139, 163, 62,  255, 84,  114, 53,  255, 91,  122, 62,  255, 82,  103, 42,  255, 84,  114, 42,  255, 120, 147, 65,  255,
    134, 161, 77,  255, 135, 162, 81,  255, 141, 170, 92,  255, 102, 132, 48,  255, 97,  126, 52,  255, 95,  121, 45,  255, 92,  121, 42,  255, 99,
    129, 41,  255, 105, 135, 44,  255, 98,  122, 44,  255, 62,  76,  33,  255, 73,  99,  36,  255, 89,  124, 39,  255, 99,  135, 39,  255, 114, 143,
    47,  255, 116, 125, 65,  255, 154, 180, 115, 255, 151, 185, 147, 255, 175, 203, 163, 255, 164, 189, 111, 255, 160, 187, 125, 255, 122, 145, 97,
    255, 90,  116, 63,  255, 65,  90,  43,  255, 97,  116, 62,  255, 179, 198, 123, 255, 182, 206, 118, 255, 207, 226, 140, 255, 190, 207, 110, 255,
    150, 173, 81,  255, 185, 198, 101, 255, 195, 209, 112, 255, 147, 181, 106, 255, 146, 181, 115, 255, 192, 215, 131, 255, 130, 133, 68,  255, 34,
    48,  19,  255, 97,  133, 44,  255, 78,  113, 37,  255, 72,  101, 41,  255, 55,  84,  33,  255, 69,  98,  41,  255, 39,  52,  25,  255, 48,  60,
    33,  255, 29,  43,  28,  255, 44,  48,  34,  255, 44,  42,  36,  255, 29,  37,  28,  255, 32,  46,  28,  255, 34,  49,  29,  255, 29,  44,  26,
    255, 37,  56,  32,  255, 53,  82,  39,  255, 58,  89,  39,  255, 60,  92,  39,  255, 60,  92,  38,  255, 29,  40,  23,  255, 6,   19,  12,  255,
    94,  107, 62,  255, 119, 128, 60,  255, 135, 152, 74,  255, 182, 204, 104, 255, 165, 188, 77,  255, 173, 200, 63,  255, 122, 139, 42,  255, 26,
    38,  17,  255, 33,  56,  23,  255, 114, 140, 62,  255, 195, 216, 113, 255, 192, 210, 111, 255, 171, 186, 92,  255, 81,  117, 47,  255, 81,  122,
    49,  255, 87,  129, 47,  255, 89,  130, 42,  255, 43,  62,  23,  255, 25,  33,  21,  255, 26,  33,  23,  255, 29,  39,  32,  255, 44,  58,  41,
    255, 53,  87,  31,  255, 78,  117, 47,  255, 120, 149, 72,  255, 159, 182, 91,  255, 183, 203, 103, 255, 190, 207, 113, 255, 156, 173, 69,  255,
    176, 189, 75,  255, 182, 198, 86,  255, 141, 151, 62,  255, 45,  62,  23,  255, 69,  99,  34,  255, 75,  100, 37,  255, 89,  105, 36,  255, 124,
    137, 55,  255, 150, 162, 74,  255, 155, 157, 82,  255, 112, 119, 47,  255, 91,  110, 36,  255, 71,  95,  34,  255, 100, 121, 53,  255, 109, 133,
    62,  255, 94,  122, 72,  255, 123, 149, 93,  255, 82,  94,  44,  255, 60,  91,  21,  255, 65,  102, 31,  255, 65,  96,  34,  255, 83,  117, 39,
    255, 68,  92,  33,  255, 26,  36,  19,  255, 45,  58,  29,  255, 38,  51,  25,  255, 38,  58,  23,  255, 47,  71,  26,  255, 50,  77,  36,  255,
    95,  112, 45,  255, 213, 219, 110, 255, 201, 215, 98,  255, 173, 194, 73,  255, 166, 195, 92,  255, 164, 192, 91,  255, 200, 217, 122, 255, 181,
    209, 145, 255, 163, 197, 145, 255, 148, 184, 138, 255, 164, 187, 119, 255, 195, 212, 95,  255, 193, 213, 110, 255, 178, 200, 120, 255, 165, 191,
    98,  255, 182, 202, 111, 255, 190, 200, 98,  255, 106, 119, 44,  255, 65,  102, 36,  255, 58,  101, 36,  255, 60,  91,  42,  255, 98,  121, 41,
    255, 184, 201, 92,  255, 160, 186, 102, 255, 179, 201, 101, 255, 136, 170, 93,  255, 166, 189, 98,  255, 159, 188, 108, 255, 141, 176, 121, 255,
    132, 167, 112, 255, 135, 167, 113, 255, 166, 184, 122, 255, 190, 202, 116, 255, 202, 205, 111, 255, 124, 149, 65,  255, 107, 139, 56,  255, 111,
    142, 58,  255, 82,  105, 42,  255, 150, 174, 82,  255, 84,  106, 47,  255, 21,  47,  17,  255, 42,  72,  31,  255, 40,  68,  31,  255, 21,  29,
    19,  255, 34,  46,  23,  255, 55,  69,  34,  255, 44,  51,  26,  255, 65,  84,  37,  255, 81,  108, 50,  255, 58,  82,  44,  255, 42,  63,  33,
    255, 41,  65,  28,  255, 40,  65,  31,  255, 42,  73,  31,  255, 47,  72,  38,  255, 47,  68,  42,  255, 130, 166, 100, 255, 141, 172, 105, 255,
    122, 153, 101, 255, 101, 137, 95,  255, 100, 133, 92,  255, 102, 133, 89,  255, 107, 138, 83,  255, 124, 154, 76,  255, 124, 154, 72,  255, 58,
    84,  40,  255, 44,  65,  26,  255, 71,  86,  36,  255, 58,  73,  37,  255, 52,  80,  37,  255, 111, 145, 69,  255, 118, 148, 69,  255, 109, 143,
    67,  255, 106, 139, 62,  255, 69,  99,  38,  255, 76,  101, 28,  255, 151, 172, 71,  255, 138, 153, 68,  255, 140, 166, 81,  255, 179, 198, 115,
    255, 146, 163, 87,  255, 29,  51,  25,  255, 52,  65,  31,  255, 202, 209, 107, 255, 181, 203, 107, 255, 141, 176, 95,  255, 118, 158, 82,  255,
    118, 155, 71,  255, 110, 134, 55,  255, 183, 180, 84,  255, 239, 232, 125, 255, 221, 223, 124, 255, 215, 220, 124, 255, 205, 214, 120, 255, 179,
    196, 107, 255, 150, 173, 91,  255, 154, 175, 89,  255, 143, 170, 78,  255, 69,  98,  31,  255, 75,  92,  42,  255, 49,  62,  36,  255, 17,  23,
    21,  255, 58,  74,  34,  255, 96,  128, 52,  255, 93,  117, 58,  255, 110, 133, 68,  255, 120, 144, 74,  255, 103, 126, 62,  255, 128, 142, 76,
    255, 157, 176, 98,  255, 152, 172, 86,  255, 149, 166, 81,  255, 100, 115, 48,  255, 58,  90,  34,  255, 135, 156, 84,  255, 182, 203, 138, 255,
    165, 193, 137, 255, 160, 189, 133, 255, 185, 204, 133, 255, 87,  94,  58,  255, 170, 186, 138, 255, 132, 155, 78,  255, 119, 150, 60,  255, 142,
    166, 69,  255, 131, 151, 69,  255, 86,  95,  55,  255, 63,  91,  48,  255, 69,  99,  55,  255, 63,  94,  47,  255, 72,  105, 39,  255, 65,  95,
    33,  255, 150, 167, 75,  255, 171, 186, 83,  255, 154, 173, 75,  255, 142, 166, 68,  255, 101, 131, 52,  255, 94,  125, 56,  255, 97,  125, 53,
    255, 96,  131, 49,  255, 91,  128, 43,  255, 89,  126, 41,  255, 108, 143, 65,  255, 91,  126, 58,  255, 78,  109, 48,  255, 101, 131, 67,  255,
    130, 156, 68,  255, 153, 176, 80,  255, 184, 197, 91,  255, 128, 148, 65,  255, 97,  119, 58,  255, 55,  74,  31,  255, 76,  112, 38,  255, 81,
    116, 45,  255, 87,  124, 47,  255, 106, 142, 55,  255, 148, 173, 71,  255, 181, 200, 110, 255, 142, 179, 122, 255, 155, 187, 157, 255, 185, 206,
    159, 255, 142, 159, 103, 255, 52,  69,  31,  255, 65,  92,  36,  255, 121, 137, 79,  255, 187, 210, 154, 255, 170, 201, 145, 255, 166, 195, 106,
    255, 162, 195, 85,  255, 157, 182, 91,  255, 135, 161, 97,  255, 127, 155, 91,  255, 178, 192, 102, 255, 193, 208, 130, 255, 170, 196, 135, 255,
    177, 198, 105, 255, 149, 162, 83,  255, 137, 157, 85,  255, 136, 167, 69,  255, 125, 155, 62,  255, 83,  108, 41,  255, 58,  87,  34,  255, 77,
    107, 44,  255, 55,  69,  33,  255, 60,  68,  41,  255, 36,  43,  29,  255, 42,  49,  31,  255, 33,  44,  25,  255, 34,  42,  28,  255, 37,  55,
    28,  255, 37,  52,  33,  255, 34,  52,  32,  255, 34,  52,  31,  255, 39,  55,  31,  255, 38,  51,  28,  255, 55,  81,  38,  255, 52,  74,  36,
    255, 41,  52,  31,  255, 74,  92,  49,  255, 52,  62,  39,  255, 159, 180, 83,  255, 195, 220, 75,  255, 167, 194, 60,  255, 159, 189, 68,  255,
    163, 189, 68,  255, 177, 194, 79,  255, 76,  92,  31,  255, 68,  95,  40,  255, 201, 218, 114, 255, 187, 205, 112, 255, 194, 211, 116, 255, 167,
    186, 92,  255, 109, 147, 58,  255, 118, 154, 58,  255, 103, 136, 48,  255, 60,  81,  31,  255, 41,  55,  29,  255, 26,  37,  21,  255, 26,  36,
    21,  255, 29,  37,  29,  255, 25,  36,  23,  255, 60,  87,  36,  255, 63,  92,  36,  255, 72,  106, 39,  255, 55,  87,  26,  255, 136, 152, 77,
    255, 203, 216, 110, 255, 178, 196, 82,  255, 174, 193, 83,  255, 146, 160, 52,  255, 88,  106, 36,  255, 41,  71,  19,  255, 82,  113, 49,  255,
    83,  115, 47,  255, 83,  117, 48,  255, 87,  121, 55,  255, 69,  92,  33,  255, 23,  33,  12,  255, 63,  86,  25,  255, 100, 131, 43,  255, 74,
    108, 37,  255, 87,  117, 40,  255, 118, 141, 52,  255, 92,  113, 44,  255, 100, 123, 65,  255, 60,  82,  37,  255, 96,  122, 47,  255, 104, 141,
    52,  255, 82,  118, 39,  255, 94,  125, 43,  255, 52,  65,  31,  255, 21,  25,  19,  255, 52,  65,  31,  255, 31,  37,  26,  255, 65,  91,  41,
    255, 98,  132, 55,  255, 76,  111, 39,  255, 94,  117, 41,  255, 219, 218, 118, 255, 216, 221, 115, 255, 187, 202, 82,  255, 169, 191, 67,  255,
    206, 222, 109, 255, 210, 226, 97,  255, 204, 220, 92,  255, 189, 212, 101, 255, 168, 196, 115, 255, 155, 187, 108, 255, 186, 209, 104, 255, 180,
    194, 115, 255, 196, 206, 98,  255, 193, 208, 87,  255, 199, 215, 105, 255, 181, 202, 99,  255, 122, 158, 72,  255, 131, 165, 73,  255, 116, 148,
    68,  255, 92,  121, 60,  255, 73,  110, 32,  255, 144, 167, 55,  255, 200, 210, 93,  255, 209, 220, 106, 255, 191, 210, 110, 255, 193, 208, 100,
    255, 200, 215, 108, 255, 170, 197, 124, 255, 149, 183, 127, 255, 152, 185, 127, 255, 145, 179, 121, 255, 163, 187, 117, 255, 193, 194, 105, 255,
    121, 140, 62,  255, 124, 156, 81,  255, 160, 186, 103, 255, 160, 184, 107, 255, 177, 196, 106, 255, 120, 149, 75,  255, 57,  97,  40,  255, 43,
    81,  31,  255, 52,  87,  37,  255, 32,  47,  29,  255, 29,  33,  28,  255, 49,  49,  38,  255, 34,  38,  31,  255, 53,  69,  29,  255, 95,  119,
    50,  255, 63,  87,  41,  255, 52,  79,  36,  255, 51,  89,  31,  255, 44,  73,  34,  255, 51,  81,  38,  255, 63,  101, 47,  255, 49,  71,  38,
    255, 122, 149, 87,  255, 136, 173, 112, 255, 129, 164, 106, 255, 122, 157, 104, 255, 112, 147, 99,  255, 103, 138, 96,  255, 95,  130, 86,  255,
    97,  129, 80,  255, 99,  129, 73,  255, 99,  133, 56,  255, 63,  89,  40,  255, 60,  82,  44,  255, 58,  84,  42,  255, 84,  117, 65,  255, 139,
    168, 84,  255, 129, 159, 78,  255, 121, 154, 78,  255, 120, 153, 75,  255, 87,  122, 55,  255, 47,  82,  21,  255, 124, 142, 58,  255, 148, 164,
    81,  255, 138, 166, 83,  255, 138, 161, 81,  255, 111, 137, 60,  255, 39,  58,  31,  255, 73,  86,  40,  255, 173, 191, 94,  255, 152, 177, 82,
    255, 144, 169, 80,  255, 142, 162, 74,  255, 112, 133, 55,  255, 52,  72,  31,  255, 48,  62,  26,  255, 141, 144, 72,  255, 218, 215, 121, 255,
    226, 228, 131, 255, 220, 227, 128, 255, 217, 224, 121, 255, 191, 207, 96,  255, 151, 174, 74,  255, 141, 169, 72,  255, 96,  129, 47,  255, 76,
    95,  44,  255, 29,  41,  25,  255, 43,  55,  29,  255, 112, 133, 60,  255, 142, 168, 83,  255, 154, 179, 93,  255, 163, 184, 96,  255, 162, 184,
    95,  255, 158, 180, 90,  255, 144, 165, 83,  255, 120, 139, 63,  255, 74,  90,  44,  255, 48,  63,  47,  255, 34,  48,  37,  255, 37,  52,  34,
    255, 85,  101, 55,  255, 202, 214, 133, 255, 164, 191, 135, 255, 157, 186, 138, 255, 179, 200, 142, 255, 100, 115, 58,  255, 142, 167, 87,  255,
    174, 198, 121, 255, 143, 170, 125, 255, 116, 150, 89,  255, 100, 133, 68,  255, 45,  65,  34,  255, 25,  36,  23,  255, 53,  77,  42,  255, 69,
    99,  53,  255, 102, 133, 65,  255, 68,  102, 43,  255, 65,  91,  50,  255, 130, 148, 73,  255, 152, 173, 76,  255, 139, 164, 69,  255, 102, 133,
    53,  255, 87,  115, 50,  255, 106, 139, 53,  255, 120, 153, 62,  255, 111, 145, 55,  255, 113, 145, 52,  255, 90,  124, 42,  255, 65,  103, 38,
    255, 78,  111, 45,  255, 77,  104, 44,  255, 94,  128, 56,  255, 156, 184, 80,  255, 230, 236, 118, 255, 186, 195, 93,  255, 95,  124, 48,  255,
    77,  113, 37,  255, 67,  99,  44,  255, 83,  117, 48,  255, 94,  131, 52,  255, 118, 150, 58,  255, 146, 169, 60,  255, 151, 168, 84,  255, 165,
    194, 120, 255, 145, 181, 138, 255, 172, 194, 142, 255, 142, 157, 95,  255, 82,  115, 40,  255, 120, 146, 62,  255, 184, 208, 152, 255, 163, 196,
    134, 255, 180, 204, 116, 255, 152, 178, 107, 255, 133, 168, 89,  255, 157, 189, 87,  255, 164, 192, 94,  255, 117, 150, 82,  255, 131, 160, 74,
    255, 175, 191, 94,  255, 137, 159, 76,  255, 110, 146, 63,  255, 149, 186, 115, 255, 192, 216, 139, 255, 146, 169, 91,  255, 139, 171, 87,  255,
    168, 188, 92,  255, 104, 129, 49,  255, 75,  106, 38,  255, 53,  74,  31,  255, 33,  41,  26,  255, 40,  46,  31,  255, 41,  56,  29,  255, 31,
    42,  25,  255, 21,  26,  21,  255, 38,  55,  31,  255, 48,  74,  36,  255, 49,  75,  36,  255, 47,  74,  33,  255, 34,  49,  25,  255, 60,  68,
    58,  255, 68,  80,  60,  255, 53,  63,  49,  255, 62,  74,  42,  255, 119, 152, 90,  255, 78,  92,  60,  255, 15,  17,  19,  255, 108, 123, 65,
    255, 187, 211, 104, 255, 159, 186, 68,  255, 174, 198, 77,  255, 167, 183, 84,  255, 91,  113, 40,  255, 147, 173, 86,  255, 194, 212, 111, 255,
    189, 209, 110, 255, 187, 202, 105, 255, 97,  119, 47,  255, 65,  94,  41,  255, 69,  103, 41,  255, 62,  95,  40,  255, 55,  84,  37,  255, 60,
    82,  40,  255, 34,  43,  23,  255, 23,  33,  19,  255, 21,  28,  21,  255, 48,  71,  32,  255, 80,  115, 43,  255, 97,  129, 52,  255, 68,  103,
    37,  255, 52,  84,  31,  255, 31,  43,  23,  255, 105, 123, 55,  255, 192, 207, 98,  255, 153, 172, 72,  255, 92,  120, 31,  255, 48,  76,  19,
    255, 65,  99,  33,  255, 84,  119, 49,  255, 90,  119, 53,  255, 85,  112, 58,  255, 94,  126, 53,  255, 62,  83,  36,  255, 29,  37,  17,  255,
    111, 129, 47,  255, 116, 146, 52,  255, 89,  121, 47,  255, 92,  120, 47,  255, 118, 142, 50,  255, 98,  121, 42,  255, 89,  114, 45,  255, 97,
    132, 60,  255, 162, 188, 93,  255, 131, 148, 62,  255, 65,  81,  29,  255, 56,  67,  32,  255, 26,  31,  21,  255, 21,  25,  19,  255, 36,  43,
    23,  255, 81,  101, 47,  255, 115, 150, 69,  255, 82,  115, 58,  255, 67,  102, 55,  255, 80,  106, 58,  255, 206, 204, 122, 255, 222, 225, 135,
    255, 206, 214, 126, 255, 220, 224, 125, 255, 201, 207, 94,  255, 181, 200, 87,  255, 184, 209, 91,  255, 170, 202, 93,  255, 156, 185, 83,  255,
    167, 186, 97,  255, 148, 164, 93,  255, 119, 141, 72,  255, 156, 173, 62,  255, 176, 196, 80,  255, 180, 201, 100, 255, 176, 197, 98,  255, 180,
    198, 97,  255, 174, 192, 97,  255, 159, 181, 100, 255, 168, 186, 97,  255, 142, 169, 82,  255, 131, 164, 62,  255, 136, 152, 76,  255, 152, 154,
    76,  255, 198, 193, 93,  255, 218, 220, 99,  255, 233, 231, 107, 255, 233, 235, 121, 255, 176, 203, 128, 255, 156, 189, 129, 255, 166, 196, 134,
    255, 185, 210, 140, 255, 204, 208, 124, 255, 151, 171, 84,  255, 158, 183, 120, 255, 145, 175, 122, 255, 147, 178, 117, 255, 159, 178, 105, 255,
    123, 151, 86,  255, 142, 174, 91,  255, 82,  120, 55,  255, 69,  108, 48,  255, 42,  65,  36,  255, 50,  46,  39,  255, 82,  67,  60,  255, 43,
    40,  34,  255, 73,  87,  39,  255, 105, 135, 58,  255, 76,  105, 62,  255, 62,  97,  43,  255, 63,  109, 37,  255, 53,  94,  34,  255, 53,  87,
    44,  255, 68,  106, 52,  255, 52,  81,  37,  255, 52,  75,  26,  255, 133, 153, 77,  255, 172, 197, 114, 255, 160, 188, 110, 255, 149, 178, 108,
    255, 132, 163, 106, 255, 110, 143, 103, 255, 99,  132, 91,  255, 87,  125, 80,  255, 86,  121, 58,  255, 79,  106, 43,  255, 58,  72,  39,  255,
    55,  73,  34,  255, 58,  74,  31,  255, 141, 165, 83,  255, 136, 167, 84,  255, 127, 160, 83,  255, 133, 165, 87,  255, 97,  125, 55,  255, 53,
    82,  26,  255, 95,  102, 42,  255, 114, 118, 55,  255, 148, 164, 90,  255, 155, 177, 111, 255, 117, 143, 69,  255, 57,  84,  25,  255, 57,  87,
    32,  255, 55,  90,  40,  255, 67,  97,  47,  255, 63,  86,  48,  255, 53,  75,  47,  255, 52,  82,  41,  255, 50,  76,  41,  255, 39,  62,  38,
    255, 28,  42,  21,  255, 96,  118, 48,  255, 112, 136, 65,  255, 137, 153, 84,  255, 148, 164, 86,  255, 136, 154, 69,  255, 121, 147, 55,  255,
    117, 147, 52,  255, 102, 129, 53,  255, 82,  100, 47,  255, 82,  104, 45,  255, 131, 156, 72,  255, 154, 178, 90,  255, 154, 177, 90,  255, 164,
    186, 99,  255, 168, 187, 102, 255, 171, 188, 102, 255, 171, 187, 104, 255, 167, 185, 98,  255, 166, 185, 90,  255, 166, 182, 82,  255, 122, 137,
    71,  255, 52,  73,  52,  255, 50,  71,  50,  255, 46,  69,  52,  255, 125, 144, 82,  255, 173, 197, 127, 255, 151, 181, 135, 255, 160, 185, 132,
    255, 93,  116, 55,  255, 81,  111, 47,  255, 138, 168, 72,  255, 152, 178, 90,  255, 114, 139, 62,  255, 114, 144, 81,  255, 107, 142, 69,  255,
    69,  97,  47,  255, 32,  43,  25,  255, 63,  91,  46,  255, 115, 140, 79,  255, 83,  106, 55,  255, 88,  111, 72,  255, 86,  107, 68,  255, 72,
    100, 49,  255, 68,  97,  43,  255, 74,  101, 47,  255, 82,  109, 45,  255, 79,  110, 38,  255, 94,  123, 47,  255, 126, 149, 63,  255, 136, 160,
    63,  255, 128, 156, 58,  255, 106, 136, 46,  255, 87,  118, 39,  255, 76,  105, 43,  255, 63,  91,  42,  255, 160, 182, 74,  255, 236, 235, 99,
    255, 238, 235, 108, 255, 119, 138, 42,  255, 53,  87,  34,  255, 74,  108, 40,  255, 101, 132, 44,  255, 138, 165, 55,  255, 148, 166, 60,  255,
    104, 120, 45,  255, 90,  117, 44,  255, 171, 187, 106, 255, 208, 224, 140, 255, 186, 203, 147, 255, 140, 159, 87,  255, 152, 176, 90,  255, 182,
    206, 137, 255, 168, 200, 125, 255, 174, 198, 108, 255, 190, 203, 110, 255, 170, 184, 104, 255, 166, 184, 100, 255, 176, 194, 92,  255, 166, 190,
    85,  255, 171, 191, 94,  255, 158, 186, 105, 255, 119, 157, 84,  255, 116, 151, 74,  255, 161, 189, 103, 255, 196, 216, 128, 255, 152, 175, 87,
    255, 95,  135, 65,  255, 113, 150, 94,  255, 155, 183, 110, 255, 166, 184, 84,  255, 83,  112, 36,  255, 49,  68,  31,  255, 29,  33,  25,  255,
    41,  44,  29,  255, 34,  44,  26,  255, 26,  31,  25,  255, 17,  19,  19,  255, 19,  23,  21,  255, 31,  42,  28,  255, 41,  55,  31,  255, 31,
    40,  23,  255, 29,  37,  34,  255, 105, 124, 111, 255, 78,  94,  62,  255, 105, 133, 81,  255, 105, 135, 68,  255, 102, 135, 75,  255, 114, 138,
    82,  255, 39,  49,  23,  255, 63,  84,  38,  255, 140, 165, 94,  255, 166, 187, 92,  255, 96,  122, 45,  255, 107, 135, 52,  255, 179, 198, 95,
    255, 197, 216, 115, 255, 189, 208, 108, 255, 189, 208, 111, 255, 100, 121, 49,  255, 47,  79,  26,  255, 52,  82,  31,  255, 55,  87,  36,  255,
    63,  95,  46,  255, 58,  87,  46,  255, 66,  95,  50,  255, 69,  95,  46,  255, 29,  39,  23,  255, 47,  60,  32,  255, 110, 147, 56,  255, 87,
    129, 55,  255, 119, 155, 72,  255, 87,  117, 46,  255, 63,  98,  41,  255, 23,  37,  17,  255, 91,  104, 63,  255, 211, 226, 121, 255, 185, 203,
    106, 255, 181, 202, 118, 255, 137, 163, 86,  255, 110, 143, 62,  255, 95,  128, 58,  255, 78,  108, 58,  255, 79,  108, 58,  255, 112, 141, 58,
    255, 60,  82,  29,  255, 45,  65,  17,  255, 118, 140, 49,  255, 120, 144, 55,  255, 90,  119, 50,  255, 107, 136, 53,  255, 107, 127, 44,  255,
    108, 135, 52,  255, 118, 153, 68,  255, 120, 157, 87,  255, 166, 191, 107, 255, 131, 151, 73,  255, 65,  87,  29,  255, 73,  97,  38,  255, 42,
    55,  28,  255, 29,  42,  23,  255, 48,  71,  31,  255, 114, 143, 63,  255, 94,  124, 65,  255, 78,  111, 65,  255, 80,  112, 73,  255, 71,  103,
    58,  255, 170, 172, 99,  255, 231, 228, 145, 255, 191, 191, 109, 255, 167, 174, 69,  255, 112, 140, 38,  255, 107, 134, 34,  255, 131, 147, 47,
    255, 204, 210, 100, 255, 186, 207, 112, 255, 132, 160, 102, 255, 129, 155, 92,  255, 117, 153, 84,  255, 148, 172, 81,  255, 172, 192, 110, 255,
    160, 183, 115, 255, 157, 182, 108, 255, 143, 171, 101, 255, 137, 167, 104, 255, 137, 169, 106, 255, 143, 172, 110, 255, 159, 184, 124, 255, 167,
    185, 104, 255, 100, 118, 65,  255, 44,  62,  31,  255, 60,  84,  28,  255, 97,  117, 43,  255, 144, 150, 68,  255, 189, 183, 93,  255, 201, 199,
    110, 255, 195, 202, 125, 255, 185, 196, 131, 255, 193, 199, 135, 255, 222, 222, 143, 255, 173, 193, 123, 255, 141, 174, 126, 255, 137, 172, 120,
    255, 154, 184, 112, 255, 161, 180, 111, 255, 97,  130, 90,  255, 140, 167, 93,  255, 145, 173, 97,  255, 106, 142, 78,  255, 73,  96,  50,  255,
    52,  55,  33,  255, 87,  75,  49,  255, 34,  34,  26,  255, 52,  60,  26,  255, 110, 138, 60,  255, 93,  125, 77,  255, 81,  117, 56,  255, 77,
    123, 47,  255, 72,  117, 48,  255, 65,  103, 48,  255, 78,  117, 58,  255, 58,  78,  37,  255, 32,  48,  26,  255, 33,  44,  17,  255, 108, 116,
    53,  255, 172, 188, 104, 255, 164, 191, 121, 255, 138, 170, 117, 255, 121, 159, 111, 255, 131, 167, 106, 255, 127, 158, 93,  255, 102, 130, 60,
    255, 73,  96,  47,  255, 56,  76,  40,  255, 42,  62,  37,  255, 23,  31,  21,  255, 84,  96,  42,  255, 148, 176, 84,  255, 140, 170, 82,  255,
    132, 159, 74,  255, 69,  91,  36,  255, 99,  113, 50,  255, 60,  62,  32,  255, 50,  62,  43,  255, 107, 116, 72,  255, 171, 179, 100, 255, 111,
    136, 58,  255, 97,  117, 26,  255, 133, 144, 42,  255, 72,  96,  43,  255, 55,  83,  53,  255, 62,  87,  58,  255, 60,  86,  52,  255, 52,  76,
    50,  255, 50,  73,  48,  255, 42,  60,  36,  255, 47,  60,  28,  255, 85,  117, 47,  255, 51,  86,  38,  255, 44,  76,  38,  255, 44,  75,  37,
    255, 63,  92,  39,  255, 92,  126, 47,  255, 106, 136, 58,  255, 107, 124, 68,  255, 98,  121, 58,  255, 132, 157, 75,  255, 160, 181, 94,  255,
    165, 184, 98,  255, 171, 189, 99,  255, 175, 192, 102, 255, 179, 194, 108, 255, 181, 196, 107, 255, 179, 194, 102, 255, 181, 196, 96,  255, 189,
    201, 93,  255, 158, 172, 82,  255, 90,  108, 67,  255, 62,  87,  65,  255, 58,  81,  62,  255, 77,  99,  69,  255, 113, 132, 86,  255, 168, 184,
    113, 255, 170, 195, 129, 255, 136, 161, 94,  255, 92,  115, 48,  255, 129, 145, 82,  255, 175, 193, 106, 255, 145, 173, 73,  255, 179, 196, 111,
    255, 165, 183, 113, 255, 116, 144, 68,  255, 109, 142, 63,  255, 87,  120, 48,  255, 68,  96,  36,  255, 149, 164, 82,  255, 196, 206, 110, 255,
    205, 217, 136, 255, 160, 176, 119, 255, 67,  95,  48,  255, 57,  84,  44,  255, 74,  101, 47,  255, 110, 135, 53,  255, 134, 153, 62,  255, 148,
    168, 77,  255, 151, 177, 89,  255, 139, 168, 90,  255, 144, 174, 95,  255, 156, 180, 97,  255, 140, 156, 83,  255, 109, 125, 68,  255, 99,  115,
    62,  255, 179, 195, 90,  255, 231, 229, 117, 255, 245, 241, 131, 255, 223, 221, 112, 255, 84,  108, 36,  255, 166, 180, 90,  255, 191, 205, 98,
    255, 149, 161, 74,  255, 71,  73,  37,  255, 31,  37,  21,  255, 168, 181, 83,  255, 236, 238, 111, 255, 144, 156, 74,  255, 158, 187, 139, 255,
    129, 140, 95,  255, 180, 202, 135, 255, 177, 204, 115, 255, 153, 176, 80,  255, 103, 133, 62,  255, 107, 142, 72,  255, 146, 176, 98,  255, 168,
    193, 107, 255, 144, 166, 75,  255, 97,  117, 40,  255, 126, 156, 75,  255, 146, 188, 111, 255, 176, 205, 119, 255, 203, 221, 124, 255, 187, 196,
    107, 255, 186, 196, 90,  255, 164, 186, 77,  255, 129, 162, 87,  255, 117, 156, 101, 255, 144, 177, 116, 255, 158, 172, 92,  255, 72,  102, 37,
    255, 42,  55,  26,  255, 32,  32,  26,  255, 26,  32,  23,  255, 25,  31,  23,  255, 23,  29,  23,  255, 21,  28,  21,  255, 17,  23,  19,  255,
    19,  21,  23,  255, 19,  23,  23,  255, 15,  17,  19,  255, 23,  31,  28,  255, 52,  63,  55,  255, 84,  102, 56,  255, 106, 142, 80,  255, 103,
    137, 73,  255, 93,  127, 62,  255, 120, 150, 104, 255, 100, 127, 49,  255, 93,  127, 73,  255, 118, 142, 93,  255, 121, 145, 58,  255, 112, 141,
    55,  255, 158, 184, 72,  255, 172, 192, 75,  255, 183, 203, 96,  255, 170, 189, 93,  255, 106, 124, 60,  255, 67,  91,  43,  255, 65,  90,  44,
    255, 48,  67,  37,  255, 42,  65,  34,  255, 63,  99,  41,  255, 63,  96,  44,  255, 58,  87,  47,  255, 67,  96,  50,  255, 47,  68,  31,  255,
    60,  80,  37,  255, 149, 183, 81,  255, 114, 148, 71,  255, 118, 152, 84,  255, 110, 142, 58,  255, 86,  117, 43,  255, 43,  57,  23,  255, 38,
    40,  34,  255, 134, 147, 72,  255, 187, 200, 75,  255, 177, 188, 83,  255, 150, 170, 81,  255, 117, 145, 68,  255, 91,  121, 68,  255, 82,  113,
    65,  255, 115, 147, 68,  255, 117, 146, 60,  255, 60,  87,  21,  255, 65,  92,  23,  255, 116, 135, 43,  255, 120, 143, 63,  255, 112, 139, 68,
    255, 116, 132, 50,  255, 105, 121, 42,  255, 151, 183, 95,  255, 130, 166, 84,  255, 130, 165, 95,  255, 170, 193, 115, 255, 157, 173, 82,  255,
    92,  114, 39,  255, 109, 131, 48,  255, 87,  109, 43,  255, 38,  62,  23,  255, 72,  102, 38,  255, 106, 140, 68,  255, 90,  124, 73,  255, 84,
    119, 73,  255, 73,  109, 62,  255, 84,  119, 58,  255, 128, 147, 67,  255, 159, 159, 85,  255, 121, 139, 68,  255, 129, 163, 72,  255, 118, 154,
    60,  255, 103, 137, 47,  255, 115, 140, 52,  255, 181, 194, 89,  255, 193, 205, 104, 255, 150, 175, 98,  255, 180, 199, 92,  255, 199, 218, 108,
    255, 210, 221, 120, 255, 166, 190, 115, 255, 145, 174, 110, 255, 137, 169, 106, 255, 136, 168, 106, 255, 139, 171, 107, 255, 139, 172, 107, 255,
    157, 185, 114, 255, 167, 189, 89,  255, 143, 166, 56,  255, 73,  109, 31,  255, 75,  110, 37,  255, 63,  101, 39,  255, 52,  94,  55,  255, 53,
    95,  56,  255, 62,  98,  65,  255, 73,  96,  63,  255, 96,  112, 83,  255, 90,  111, 75,  255, 108, 128, 83,  255, 165, 183, 116, 255, 138, 171,
    123, 255, 141, 177, 125, 255, 139, 172, 115, 255, 160, 187, 115, 255, 171, 187, 114, 255, 104, 137, 97,  255, 111, 144, 96,  255, 156, 184, 107,
    255, 130, 153, 87,  255, 62,  79,  36,  255, 58,  89,  26,  255, 65,  94,  32,  255, 47,  52,  36,  255, 19,  21,  17,  255, 60,  69,  31,  255,
    80,  99,  47,  255, 62,  77,  37,  255, 74,  102, 40,  255, 103, 146, 68,  255, 99,  142, 68,  255, 108, 146, 74,  255, 49,  65,  34,  255, 29,
    46,  29,  255, 28,  42,  29,  255, 26,  38,  21,  255, 67,  81,  31,  255, 116, 129, 56,  255, 142, 155, 84,  255, 136, 147, 81,  255, 109, 114,
    56,  255, 85,  102, 48,  255, 53,  68,  47,  255, 47,  65,  46,  255, 55,  76,  46,  255, 55,  84,  50,  255, 32,  44,  29,  255, 19,  25,  17,
    255, 81,  97,  38,  255, 144, 170, 65,  255, 116, 141, 58,  255, 95,  119, 55,  255, 134, 157, 72,  255, 102, 127, 62,  255, 48,  69,  44,  255,
    45,  62,  36,  255, 160, 176, 96,  255, 130, 150, 68,  255, 118, 135, 34,  255, 162, 171, 43,  255, 138, 150, 49,  255, 77,  104, 63,  255, 65,
    94,  65,  255, 74,  100, 65,  255, 78,  106, 62,  255, 68,  95,  50,  255, 34,  47,  23,  255, 55,  69,  33,  255, 86,  113, 47,  255, 58,  90,
    44,  255, 52,  86,  43,  255, 83,  111, 45,  255, 107, 136, 48,  255, 102, 132, 52,  255, 97,  124, 56,  255, 94,  110, 58,  255, 118, 142, 65,
    255, 160, 180, 83,  255, 174, 189, 87,  255, 179, 193, 91,  255, 180, 196, 92,  255, 184, 200, 97,  255, 191, 202, 100, 255, 198, 206, 101, 255,
    205, 213, 102, 255, 196, 201, 94,  255, 126, 141, 65,  255, 60,  86,  49,  255, 60,  83,  68,  255, 69,  97,  71,  255, 79,  104, 60,  255, 92,
    122, 60,  255, 133, 156, 87,  255, 189, 206, 120, 255, 202, 220, 134, 255, 179, 200, 117, 255, 186, 200, 116, 255, 197, 212, 130, 255, 172, 196,
    136, 255, 157, 185, 117, 255, 152, 180, 114, 255, 142, 176, 109, 255, 155, 183, 104, 255, 158, 177, 90,  255, 151, 173, 62,  255, 187, 203, 80,
    255, 205, 220, 101, 255, 154, 174, 95,  255, 91,  116, 76,  255, 76,  106, 65,  255, 71,  102, 58,  255, 75,  101, 52,  255, 155, 174, 89,  255,
    199, 211, 112, 255, 184, 202, 101, 255, 151, 177, 94,  255, 119, 149, 93,  255, 106, 139, 92,  255, 109, 141, 96,  255, 121, 153, 103, 255, 136,
    164, 110, 255, 163, 184, 111, 255, 202, 211, 120, 255, 246, 248, 167, 255, 245, 245, 189, 255, 248, 245, 184, 255, 250, 249, 178, 255, 204, 209,
    133, 255, 248, 249, 178, 255, 226, 235, 133, 255, 205, 217, 119, 255, 69,  73,  41,  255, 65,  68,  34,  255, 234, 238, 105, 255, 156, 160, 68,
    255, 48,  67,  28,  255, 129, 146, 101, 255, 132, 143, 102, 255, 145, 164, 75,  255, 183, 196, 106, 255, 150, 180, 103, 255, 142, 175, 91,  255,
    134, 168, 84,  255, 119, 159, 75,  255, 127, 168, 83,  255, 136, 167, 75,  255, 97,  121, 45,  255, 94,  121, 50,  255, 99,  121, 60,  255, 118,
    127, 68,  255, 96,  103, 55,  255, 36,  49,  23,  255, 55,  72,  34,  255, 140, 153, 74,  255, 171, 184, 97,  255, 150, 172, 95,  255, 177, 197,
    117, 255, 142, 149, 77,  255, 60,  82,  34,  255, 37,  38,  28,  255, 29,  31,  23,  255, 21,  31,  23,  255, 28,  37,  26,  255, 28,  42,  26,
    255, 23,  32,  23,  255, 23,  31,  25,  255, 29,  34,  33,  255, 26,  31,  29,  255, 17,  21,  21,  255, 21,  21,  25,  255, 49,  60,  40,  255,
    123, 148, 74,  255, 94,  131, 79,  255, 105, 138, 73,  255, 107, 142, 58,  255, 141, 171, 102, 255, 138, 161, 74,  255, 152, 174, 103, 255, 182,
    202, 104, 255, 175, 196, 86,  255, 174, 195, 87,  255, 173, 197, 83,  255, 137, 157, 62,  255, 136, 156, 62,  255, 114, 143, 52,  255, 112, 144,
    60,  255, 134, 166, 69,  255, 136, 170, 72,  255, 126, 155, 68,  255, 84,  109, 50,  255, 83,  112, 48,  255, 87,  117, 47,  255, 65,  89,  38,
    255, 46,  67,  36,  255, 56,  78,  37,  255, 48,  74,  28,  255, 128, 159, 74,  255, 150, 180, 91,  255, 122, 155, 85,  255, 104, 136, 52,  255,
    104, 137, 44,  255, 105, 135, 47,  255, 75,  93,  36,  255, 52,  65,  32,  255, 121, 145, 68,  255, 156, 178, 99,  255, 145, 170, 89,  255, 105,
    135, 68,  255, 86,  121, 72,  255, 114, 144, 76,  255, 140, 166, 77,  255, 94,  115, 42,  255, 80,  102, 29,  255, 84,  110, 33,  255, 88,  111,
    31,  255, 114, 130, 50,  255, 104, 122, 52,  255, 50,  71,  15,  255, 110, 117, 45,  255, 189, 209, 113, 255, 148, 186, 105, 255, 136, 173, 103,
    255, 172, 195, 116, 255, 126, 140, 60,  255, 98,  114, 45,  255, 123, 138, 56,  255, 92,  109, 42,  255, 44,  73,  29,  255, 117, 143, 72,  255,
    160, 177, 90,  255, 170, 181, 89,  255, 161, 176, 87,  255, 133, 160, 77,  255, 102, 137, 62,  255, 123, 154, 72,  255, 163, 184, 102, 255, 182,
    199, 116, 255, 177, 197, 111, 255, 186, 204, 113, 255, 196, 209, 121, 255, 188, 204, 124, 255, 160, 186, 121, 255, 132, 166, 113, 255, 143, 170,
    95,  255, 218, 223, 101, 255, 226, 231, 106, 255, 235, 236, 128, 255, 216, 226, 142, 255, 150, 183, 111, 255, 149, 184, 111, 255, 145, 178, 109,
    255, 155, 182, 109, 255, 168, 188, 99,  255, 145, 161, 68,  255, 141, 164, 44,  255, 134, 156, 58,  255, 77,  115, 42,  255, 94,  130, 47,  255,
    77,  111, 43,  255, 69,  101, 62,  255, 65,  105, 68,  255, 71,  109, 74,  255, 68,  103, 77,  255, 73,  104, 72,  255, 72,  104, 50,  255, 119,
    142, 68,  255, 171, 193, 98,  255, 163, 188, 108, 255, 147, 179, 121, 255, 134, 171, 114, 255, 175, 199, 116, 255, 146, 166, 105, 255, 116, 147,
    102, 255, 119, 152, 109, 255, 144, 175, 111, 255, 144, 165, 96,  255, 55,  84,  26,  255, 53,  84,  29,  255, 53,  75,  26,  255, 52,  65,  42,
    255, 36,  53,  42,  255, 23,  36,  26,  255, 26,  36,  25,  255, 28,  39,  26,  255, 26,  32,  19,  255, 78,  100, 43,  255, 122, 154, 81,  255,
    122, 152, 81,  255, 63,  99,  37,  255, 68,  105, 39,  255, 68,  107, 42,  255, 60,  99,  42,  255, 58,  95,  50,  255, 60,  98,  53,  255, 53,
    86,  31,  255, 47,  58,  31,  255, 15,  12,  15,  255, 44,  65,  39,  255, 55,  81,  58,  255, 50,  71,  47,  255, 55,  81,  55,  255, 60,  87,
    55,  255, 38,  48,  31,  255, 19,  28,  23,  255, 21,  36,  19,  255, 99,  126, 47,  255, 119, 141, 65,  255, 119, 138, 71,  255, 120, 145, 76,
    255, 120, 143, 74,  255, 65,  87,  49,  255, 81,  95,  55,  255, 163, 176, 96,  255, 149, 165, 77,  255, 133, 150, 50,  255, 152, 168, 44,  255,
    159, 170, 46,  255, 149, 156, 58,  255, 115, 133, 58,  255, 92,  122, 62,  255, 81,  110, 53,  255, 29,  39,  26,  255, 40,  47,  28,  255, 60,
    77,  34,  255, 89,  115, 52,  255, 77,  109, 58,  255, 96,  123, 58,  255, 101, 127, 52,  255, 79,  106, 39,  255, 87,  119, 52,  255, 92,  119,
    55,  255, 105, 118, 67,  255, 135, 155, 73,  255, 163, 180, 68,  255, 184, 196, 74,  255, 199, 207, 87,  255, 207, 212, 100, 255, 210, 214, 108,
    255, 212, 214, 102, 255, 207, 207, 100, 255, 167, 176, 83,  255, 86,  105, 42,  255, 60,  82,  36,  255, 60,  84,  49,  255, 62,  87,  67,  255,
    85,  110, 58,  255, 118, 144, 68,  255, 58,  94,  37,  255, 65,  101, 36,  255, 104, 129, 48,  255, 183, 194, 101, 255, 211, 224, 119, 255, 194,
    217, 119, 255, 190, 212, 120, 255, 185, 206, 119, 255, 170, 193, 103, 255, 166, 184, 89,  255, 141, 163, 77,  255, 86,  101, 55,  255, 122, 134,
    58,  255, 196, 212, 84,  255, 157, 176, 79,  255, 109, 127, 67,  255, 92,  118, 68,  255, 87,  120, 86,  255, 88,  120, 75,  255, 79,  107, 58,
    255, 89,  114, 52,  255, 106, 127, 60,  255, 168, 183, 84,  255, 173, 193, 84,  255, 143, 170, 79,  255, 128, 160, 87,  255, 116, 148, 90,  255,
    114, 146, 94,  255, 114, 147, 100, 255, 114, 146, 103, 255, 112, 145, 108, 255, 121, 152, 94,  255, 197, 207, 126, 255, 255, 255, 184, 255, 243,
    246, 179, 255, 243, 246, 180, 255, 250, 253, 183, 255, 246, 249, 184, 255, 232, 239, 161, 255, 191, 212, 95,  255, 163, 176, 93,  255, 218, 224,
    97,  255, 186, 196, 77,  255, 77,  101, 32,  255, 91,  120, 43,  255, 96,  114, 63,  255, 152, 149, 124, 255, 78,  102, 39,  255, 60,  74,  32,
    255, 96,  111, 62,  255, 143, 154, 91,  255, 160, 172, 89,  255, 192, 211, 108, 255, 176, 197, 99,  255, 166, 190, 97,  255, 159, 181, 84,  255,
    49,  63,  23,  255, 6,   9,   12,  255, 12,  17,  15,  255, 44,  69,  26,  255, 53,  89,  31,  255, 38,  63,  26,  255, 33,  52,  23,  255, 38,
    53,  29,  255, 53,  69,  36,  255, 62,  82,  43,  255, 58,  76,  40,  255, 37,  46,  29,  255, 28,  28,  25,  255, 32,  38,  23,  255, 36,  47,
    29,  255, 63,  86,  52,  255, 45,  65,  31,  255, 31,  43,  23,  255, 23,  28,  23,  255, 25,  31,  31,  255, 21,  23,  26,  255, 23,  28,  26,
    255, 15,  19,  21,  255, 80,  96,  56,  255, 117, 152, 83,  255, 93,  131, 78,  255, 145, 174, 87,  255, 170, 194, 91,  255, 163, 188, 87,  255,
    211, 220, 124, 255, 216, 224, 117, 255, 200, 215, 105, 255, 194, 210, 100, 255, 192, 210, 100, 255, 180, 199, 87,  255, 134, 157, 60,  255, 124,
    147, 60,  255, 134, 165, 69,  255, 121, 158, 68,  255, 128, 164, 75,  255, 145, 178, 77,  255, 144, 173, 76,  255, 100, 129, 58,  255, 86,  114,
    60,  255, 89,  118, 62,  255, 92,  121, 55,  255, 60,  76,  34,  255, 56,  77,  41,  255, 55,  77,  33,  255, 82,  115, 48,  255, 80,  109, 62,
    255, 104, 139, 60,  255, 107, 142, 48,  255, 103, 137, 48,  255, 108, 143, 49,  255, 111, 147, 48,  255, 97,  126, 47,  255, 113, 141, 68,  255,
    158, 182, 106, 255, 133, 159, 87,  255, 125, 154, 81,  255, 134, 163, 82,  255, 141, 165, 79,  255, 88,  105, 44,  255, 81,  97,  29,  255, 102,
    124, 39,  255, 105, 130, 46,  255, 98,  126, 42,  255, 96,  120, 34,  255, 90,  116, 39,  255, 99,  131, 58,  255, 127, 154, 75,  255, 174, 186,
    91,  255, 195, 214, 119, 255, 157, 193, 119, 255, 172, 192, 113, 255, 120, 135, 56,  255, 101, 116, 43,  255, 126, 133, 53,  255, 65,  77,  26,
    255, 143, 154, 78,  255, 199, 200, 97,  255, 187, 190, 82,  255, 185, 189, 83,  255, 186, 191, 87,  255, 175, 186, 83,  255, 162, 180, 80,  255,
    182, 197, 100, 255, 187, 203, 108, 255, 180, 198, 115, 255, 195, 209, 123, 255, 195, 209, 130, 255, 177, 195, 134, 255, 158, 187, 138, 255, 154,
    187, 129, 255, 168, 195, 110, 255, 191, 210, 95,  255, 228, 233, 123, 255, 241, 241, 135, 255, 243, 239, 135, 255, 250, 249, 157, 255, 192, 196,
    105, 255, 177, 185, 80,  255, 187, 202, 83,  255, 168, 184, 75,  255, 113, 141, 58,  255, 94,  125, 47,  255, 150, 171, 63,  255, 132, 157, 65,
    255, 99,  127, 58,  255, 117, 143, 69,  255, 104, 136, 65,  255, 76,  105, 68,  255, 74,  108, 89,  255, 78,  113, 87,  255, 79,  112, 92,  255,
    77,  108, 82,  255, 96,  118, 55,  255, 152, 171, 89,  255, 153, 187, 84,  255, 142, 175, 65,  255, 173, 193, 93,  255, 164, 196, 119, 255, 162,
    184, 104, 255, 108, 141, 98,  255, 114, 148, 101, 255, 122, 156, 109, 255, 136, 169, 122, 255, 162, 186, 117, 255, 76,  103, 52,  255, 41,  69,
    34,  255, 52,  79,  37,  255, 55,  83,  53,  255, 65,  96,  72,  255, 43,  72,  49,  255, 36,  62,  33,  255, 44,  67,  36,  255, 29,  41,  26,
    255, 21,  36,  15,  255, 79,  113, 39,  255, 95,  130, 47,  255, 83,  119, 50,  255, 73,  109, 47,  255, 68,  108, 50,  255, 68,  107, 58,  255,
    87,  126, 80,  255, 90,  112, 62,  255, 55,  72,  37,  255, 33,  37,  29,  255, 29,  37,  25,  255, 47,  63,  33,  255, 63,  92,  55,  255, 55,
    84,  50,  255, 79,  113, 65,  255, 65,  89,  43,  255, 56,  68,  36,  255, 32,  41,  26,  255, 58,  87,  47,  255, 112, 138, 76,  255, 128, 140,
    68,  255, 133, 159, 68,  255, 132, 161, 60,  255, 112, 143, 71,  255, 140, 160, 93,  255, 179, 191, 103, 255, 188, 202, 111, 255, 132, 150, 68,
    255, 123, 135, 53,  255, 157, 171, 71,  255, 158, 171, 63,  255, 151, 158, 58,  255, 149, 159, 55,  255, 110, 130, 47,  255, 44,  63,  26,  255,
    36,  48,  23,  255, 56,  68,  36,  255, 60,  82,  36,  255, 67,  92,  38,  255, 92,  117, 58,  255, 74,  96,  52,  255, 58,  80,  41,  255, 94,
    122, 56,  255, 98,  131, 62,  255, 93,  115, 55,  255, 114, 126, 69,  255, 103, 126, 63,  255, 101, 127, 58,  255, 107, 135, 55,  255, 133, 148,
    71,  255, 159, 171, 86,  255, 155, 172, 80,  255, 123, 147, 63,  255, 76,  103, 48,  255, 34,  60,  25,  255, 28,  47,  17,  255, 43,  60,  26,
    255, 58,  84,  47,  255, 60,  87,  44,  255, 134, 154, 76,  255, 165, 192, 83,  255, 84,  113, 43,  255, 65,  101, 40,  255, 79,  110, 44,  255,
    111, 135, 52,  255, 191, 198, 89,  255, 179, 186, 90,  255, 156, 165, 67,  255, 185, 200, 87,  255, 198, 218, 104, 255, 184, 204, 97,  255, 187,
    201, 131, 255, 161, 172, 117, 255, 87,  101, 36,  255, 71,  92,  41,  255, 40,  62,  34,  255, 48,  75,  34,  255, 88,  117, 65,  255, 102, 130,
    93,  255, 110, 133, 89,  255, 111, 129, 82,  255, 47,  60,  31,  255, 25,  37,  23,  255, 56,  69,  36,  255, 122, 134, 53,  255, 160, 179, 65,
    255, 154, 179, 62,  255, 129, 162, 62,  255, 108, 146, 65,  255, 102, 139, 67,  255, 104, 140, 68,  255, 109, 143, 78,  255, 111, 147, 81,  255,
    116, 145, 68,  255, 196, 205, 127, 255, 255, 255, 174, 255, 249, 249, 171, 255, 241, 246, 172, 255, 246, 249, 174, 255, 243, 246, 178, 255, 218,
    227, 150, 255, 236, 245, 139, 255, 206, 214, 91,  255, 82,  113, 28,  255, 75,  112, 32,  255, 85,  114, 37,  255, 94,  116, 52,  255, 122, 122,
    84,  255, 62,  84,  31,  255, 26,  44,  19,  255, 36,  58,  23,  255, 36,  55,  23,  255, 38,  56,  28,  255, 142, 162, 86,  255, 155, 184, 100,
    255, 137, 173, 102, 255, 160, 185, 103, 255, 110, 133, 63,  255, 63,  83,  45,  255, 36,  51,  26,  255, 72,  109, 31,  255, 65,  102, 31,  255,
    55,  91,  32,  255, 68,  107, 33,  255, 44,  65,  25,  255, 26,  42,  23,  255, 26,  44,  23,  255, 34,  41,  29,  255, 28,  26,  28,  255, 31,
    36,  26,  255, 36,  52,  26,  255, 69,  98,  55,  255, 87,  124, 76,  255, 76,  105, 56,  255, 41,  58,  26,  255, 31,  41,  25,  255, 42,  67,
    26,  255, 42,  65,  25,  255, 28,  42,  25,  255, 17,  28,  19,  255, 81,  105, 58,  255, 109, 145, 87,  255, 101, 139, 87,  255, 131, 166, 80,
    255, 162, 191, 91,  255, 160, 186, 90,  255, 162, 186, 86,  255, 172, 194, 91,  255, 188, 205, 101, 255, 185, 200, 99,  255, 156, 174, 76,  255,
    108, 132, 62,  255, 107, 144, 63,  255, 120, 151, 58,  255, 132, 161, 73,  255, 130, 165, 74,  255, 129, 166, 69,  255, 132, 165, 67,  255, 97,
    129, 55,  255, 76,  107, 52,  255, 74,  100, 62,  255, 73,  98,  67,  255, 78,  108, 65,  255, 104, 135, 65,  255, 65,  87,  38,  255, 56,  77,
    39,  255, 79,  111, 48,  255, 73,  105, 55,  255, 90,  124, 60,  255, 119, 152, 58,  255, 120, 154, 53,  255, 111, 146, 48,  255, 113, 146, 52,
    255, 110, 142, 53,  255, 132, 155, 77,  255, 180, 198, 115, 255, 147, 162, 87,  255, 128, 148, 71,  255, 117, 139, 60,  255, 87,  105, 44,  255,
    31,  39,  17,  255, 87,  92,  26,  255, 128, 145, 47,  255, 131, 148, 55,  255, 117, 140, 48,  255, 125, 148, 56,  255, 154, 176, 86,  255, 162,
    181, 95,  255, 146, 169, 92,  255, 129, 155, 84,  255, 156, 168, 89,  255, 181, 195, 116, 255, 181, 199, 119, 255, 136, 156, 68,  255, 119, 136,
    55,  255, 81,  94,  36,  255, 34,  49,  12,  255, 133, 129, 52,  255, 205, 206, 102, 255, 187, 193, 89,  255, 188, 194, 93,  255, 185, 192, 90,
    255, 169, 181, 77,  255, 180, 192, 92,  255, 188, 199, 89,  255, 183, 198, 97,  255, 189, 202, 112, 255, 214, 223, 134, 255, 176, 200, 138, 255,
    160, 189, 139, 255, 176, 200, 124, 255, 208, 219, 111, 255, 222, 227, 103, 255, 209, 217, 90,  255, 214, 211, 102, 255, 255, 250, 158, 255, 250,
    245, 152, 255, 255, 255, 169, 255, 157, 164, 79,  255, 80,  106, 17,  255, 113, 138, 38,  255, 164, 177, 58,  255, 121, 153, 58,  255, 112, 140,
    63,  255, 162, 176, 81,  255, 103, 130, 63,  255, 84,  114, 62,  255, 87,  116, 71,  255, 118, 144, 80,  255, 82,  107, 77,  255, 68,  95,  83,
    255, 72,  100, 69,  255, 79,  113, 81,  255, 78,  114, 83,  255, 52,  79,  29,  255, 143, 159, 74,  255, 172, 205, 95,  255, 124, 170, 68,  255,
    149, 180, 65,  255, 166, 177, 80,  255, 130, 156, 87,  255, 125, 164, 104, 255, 111, 150, 100, 255, 118, 154, 108, 255, 132, 160, 112, 255, 159,
    186, 118, 255, 99,  125, 65,  255, 41,  73,  36,  255, 62,  94,  65,  255, 60,  94,  62,  255, 65,  98,  67,  255, 71,  111, 50,  255, 67,  108,
    32,  255, 55,  92,  28,  255, 41,  72,  23,  255, 60,  102, 32,  255, 87,  130, 42,  255, 72,  111, 43,  255, 72,  108, 58,  255, 73,  110, 63,
    255, 75,  113, 72,  255, 81,  121, 82,  255, 106, 142, 77,  255, 77,  97,  43,  255, 60,  86,  39,  255, 47,  60,  31,  255, 32,  40,  23,  255,
    34,  42,  21,  255, 81,  108, 52,  255, 151, 177, 93,  255, 152, 178, 84,  255, 110, 143, 58,  255, 84,  103, 52,  255, 45,  51,  31,  255, 87,
    115, 60,  255, 122, 141, 74,  255, 134, 154, 69,  255, 140, 170, 52,  255, 148, 174, 63,  255, 117, 143, 74,  255, 151, 168, 92,  255, 189, 201,
    106, 255, 161, 176, 90,  255, 88,  105, 39,  255, 81,  106, 36,  255, 78,  105, 48,  255, 102, 122, 62,  255, 133, 146, 67,  255, 147, 159, 65,
    255, 127, 147, 52,  255, 77,  102, 37,  255, 43,  60,  23,  255, 60,  77,  39,  255, 77,  100, 44,  255, 103, 129, 52,  255, 87,  122, 49,  255,
    55,  83,  39,  255, 88,  109, 52,  255, 120, 148, 69,  255, 108, 138, 65,  255, 94,  113, 55,  255, 96,  119, 56,  255, 92,  124, 55,  255, 76,
    109, 49,  255, 53,  83,  50,  255, 50,  77,  53,  255, 55,  83,  55,  255, 62,  92,  55,  255, 68,  105, 56,  255, 77,  113, 56,  255, 122, 141,
    91,  255, 116, 119, 86,  255, 78,  87,  55,  255, 50,  74,  32,  255, 115, 134, 65,  255, 170, 195, 96,  255, 168, 196, 73,  255, 141, 163, 63,
    255, 102, 124, 52,  255, 92,  118, 47,  255, 110, 133, 62,  255, 108, 132, 68,  255, 105, 132, 71,  255, 69,  87,  50,  255, 52,  62,  31,  255,
    75,  82,  37,  255, 130, 138, 68,  255, 216, 230, 163, 255, 223, 233, 159, 255, 78,  86,  47,  255, 48,  73,  36,  255, 36,  55,  33,  255, 58,
    69,  50,  255, 129, 140, 101, 255, 190, 205, 174, 255, 211, 220, 180, 255, 99,  107, 71,  255, 60,  72,  34,  255, 97,  119, 47,  255, 104, 131,
    46,  255, 75,  98,  31,  255, 77,  96,  36,  255, 117, 126, 52,  255, 152, 172, 62,  255, 157, 182, 68,  255, 151, 180, 68,  255, 151, 183, 68,
    255, 137, 173, 63,  255, 139, 172, 68,  255, 110, 137, 55,  255, 83,  110, 36,  255, 184, 196, 105, 255, 229, 230, 151, 255, 250, 250, 168, 255,
    255, 251, 134, 255, 248, 250, 125, 255, 239, 248, 145, 255, 219, 228, 137, 255, 201, 208, 108, 255, 96,  122, 33,  255, 80,  115, 34,  255, 60,
    89,  28,  255, 44,  52,  32,  255, 95,  93,  71,  255, 44,  68,  26,  255, 48,  75,  31,  255, 53,  82,  32,  255, 55,  84,  32,  255, 42,  63,
    28,  255, 69,  87,  42,  255, 159, 180, 94,  255, 144, 174, 106, 255, 128, 161, 106, 255, 136, 171, 114, 255, 121, 149, 81,  255, 55,  84,  23,
    255, 94,  123, 39,  255, 90,  124, 38,  255, 80,  115, 36,  255, 100, 134, 40,  255, 77,  106, 29,  255, 57,  87,  29,  255, 57,  87,  33,  255,
    50,  75,  32,  255, 42,  52,  28,  255, 28,  26,  26,  255, 55,  77,  42,  255, 85,  120, 73,  255, 69,  103, 67,  255, 79,  116, 68,  255, 76,
    107, 42,  255, 63,  99,  26,  255, 58,  102, 25,  255, 53,  92,  23,  255, 46,  76,  23,  255, 33,  53,  19,  255, 86,  110, 58,  255, 112, 147,
    98,  255, 116, 150, 96,  255, 117, 140, 76,  255, 118, 151, 69,  255, 144, 176, 75,  255, 163, 187, 87,  255, 171, 193, 96,  255, 152, 178, 74,
    255, 138, 168, 71,  255, 87,  114, 40,  255, 79,  106, 42,  255, 137, 168, 80,  255, 130, 162, 69,  255, 129, 158, 63,  255, 146, 175, 81,  255,
    89,  115, 37,  255, 71,  101, 33,  255, 86,  120, 47,  255, 87,  121, 52,  255, 90,  122, 58,  255, 90,  119, 65,  255, 86,  116, 68,  255, 98,
    130, 72,  255, 92,  121, 56,  255, 60,  80,  36,  255, 78,  106, 55,  255, 97,  129, 68,  255, 92,  118, 52,  255, 73,  92,  37,  255, 104, 134,
    48,  255, 123, 157, 52,  255, 120, 153, 52,  255, 163, 185, 92,  255, 230, 236, 140, 255, 228, 233, 136, 255, 228, 235, 144, 255, 172, 184, 108,
    255, 52,  62,  26,  255, 33,  41,  17,  255, 33,  51,  19,  255, 77,  89,  23,  255, 145, 153, 55,  255, 142, 156, 60,  255, 144, 164, 69,  255,
    142, 167, 94,  255, 121, 148, 94,  255, 114, 141, 91,  255, 103, 134, 90,  255, 101, 136, 91,  255, 99,  132, 87,  255, 113, 135, 91,  255, 127,
    146, 90,  255, 116, 142, 79,  255, 129, 154, 80,  255, 80,  107, 47,  255, 68,  89,  47,  255, 77,  87,  37,  255, 199, 192, 101, 255, 210, 210,
    109, 255, 200, 203, 101, 255, 190, 196, 98,  255, 175, 186, 84,  255, 187, 196, 86,  255, 187, 198, 80,  255, 187, 199, 83,  255, 205, 213, 117,
    255, 199, 214, 145, 255, 174, 201, 145, 255, 200, 217, 141, 255, 234, 238, 126, 255, 234, 233, 118, 255, 220, 222, 106, 255, 177, 191, 76,  255,
    136, 153, 55,  255, 207, 202, 103, 255, 255, 250, 159, 255, 255, 251, 170, 255, 205, 218, 97,  255, 150, 182, 58,  255, 92,  130, 47,  255, 122,
    140, 49,  255, 166, 183, 76,  255, 123, 150, 78,  255, 156, 167, 90,  255, 77,  110, 67,  255, 80,  112, 69,  255, 86,  117, 79,  255, 75,  101,
    68,  255, 60,  81,  73,  255, 56,  83,  68,  255, 49,  81,  58,  255, 51,  83,  49,  255, 50,  73,  36,  255, 32,  53,  19,  255, 110, 132, 55,
    255, 199, 217, 112, 255, 166, 206, 95,  255, 146, 185, 72,  255, 121, 146, 58,  255, 131, 159, 56,  255, 153, 174, 82,  255, 167, 194, 117, 255,
    143, 176, 119, 255, 125, 160, 104, 255, 142, 171, 107, 255, 129, 160, 87,  255, 62,  97,  62,  255, 60,  94,  62,  255, 65,  96,  69,  255, 68,
    104, 68,  255, 91,  132, 53,  255, 93,  133, 55,  255, 74,  114, 40,  255, 62,  103, 32,  255, 80,  120, 41,  255, 76,  113, 44,  255, 72,  110,
    49,  255, 78,  117, 69,  255, 92,  129, 93,  255, 95,  133, 92,  255, 105, 145, 83,  255, 100, 136, 52,  255, 62,  104, 33,  255, 65,  100, 33,
    255, 58,  81,  29,  255, 25,  36,  19,  255, 36,  52,  25,  255, 170, 185, 109, 255, 189, 204, 108, 255, 161, 180, 81,  255, 136, 166, 68,  255,
    99,  126, 50,  255, 37,  51,  29,  255, 104, 127, 52,  255, 112, 138, 71,  255, 124, 152, 68,  255, 156, 183, 56,  255, 141, 167, 67,  255, 123,
    147, 75,  255, 160, 177, 87,  255, 163, 181, 87,  255, 50,  65,  34,  255, 56,  60,  33,  255, 158, 168, 74,  255, 104, 132, 53,  255, 69,  102,
    47,  255, 81,  110, 52,  255, 115, 137, 65,  255, 135, 155, 65,  255, 103, 130, 42,  255, 55,  77,  29,  255, 141, 146, 69,  255, 186, 198, 91,
    255, 173, 195, 86,  255, 148, 179, 68,  255, 98,  135, 43,  255, 111, 134, 62,  255, 132, 156, 79,  255, 112, 138, 67,  255, 93,  111, 52,  255,
    99,  123, 58,  255, 104, 136, 62,  255, 80,  119, 52,  255, 62,  90,  53,  255, 58,  84,  58,  255, 60,  83,  58,  255, 60,  83,  60,  255, 58,
    85,  60,  255, 63,  87,  58,  255, 167, 181, 126, 255, 218, 239, 175, 255, 208, 223, 155, 255, 112, 124, 77,  255, 104, 122, 62,  255, 177, 205,
    98,  255, 173, 199, 87,  255, 140, 162, 67,  255, 88,  112, 43,  255, 77,  101, 55,  255, 109, 126, 86,  255, 143, 162, 109, 255, 162, 182, 122,
    255, 128, 155, 93,  255, 34,  48,  31,  255, 3,   6,   9,   255, 132, 133, 99,  255, 213, 232, 178, 255, 238, 241, 168, 255, 214, 221, 134, 255,
    108, 128, 62,  255, 107, 118, 72,  255, 193, 206, 143, 255, 204, 226, 185, 255, 216, 236, 197, 255, 159, 178, 107, 255, 102, 132, 40,  255, 123,
    156, 58,  255, 121, 156, 58,  255, 117, 155, 55,  255, 132, 167, 55,  255, 103, 131, 38,  255, 53,  68,  23,  255, 47,  68,  29,  255, 82,  109,
    55,  255, 101, 127, 52,  255, 84,  95,  44,  255, 60,  69,  36,  255, 81,  94,  48,  255, 148, 160, 84,  255, 140, 152, 73,  255, 190, 200, 91,
    255, 225, 227, 111, 255, 255, 255, 133, 255, 167, 180, 86,  255, 179, 195, 94,  255, 186, 201, 106, 255, 196, 208, 110, 255, 213, 215, 113, 255,
    127, 139, 48,  255, 81,  110, 29,  255, 58,  90,  25,  255, 36,  56,  21,  255, 103, 110, 75,  255, 77,  109, 50,  255, 80,  117, 48,  255, 76,
    114, 43,  255, 91,  119, 47,  255, 131, 150, 78,  255, 145, 168, 104, 255, 132, 164, 109, 255, 120, 155, 110, 255, 121, 158, 114, 255, 150, 182,
    129, 255, 120, 142, 71,  255, 42,  80,  17,  255, 81,  114, 39,  255, 119, 147, 58,  255, 109, 137, 48,  255, 106, 130, 46,  255, 55,  82,  23,
    255, 68,  102, 32,  255, 79,  111, 38,  255, 74,  109, 41,  255, 81,  111, 40,  255, 55,  73,  31,  255, 84,  117, 60,  255, 75,  109, 69,  255,
    69,  101, 63,  255, 69,  103, 62,  255, 84,  122, 52,  255, 62,  100, 26,  255, 55,  94,  25,  255, 52,  92,  21,  255, 52,  87,  25,  255, 41,
    68,  21,  255, 85,  108, 65,  255, 124, 158, 106, 255, 119, 142, 84,  255, 81,  100, 53,  255, 68,  101, 43,  255, 132, 159, 80,  255, 196, 213,
    124, 255, 204, 217, 130, 255, 172, 191, 86,  255, 137, 166, 58,  255, 87,  114, 33,  255, 103, 130, 48,  255, 165, 186, 84,  255, 106, 130, 58,
    255, 93,  117, 48,  255, 141, 169, 76,  255, 76,  91,  37,  255, 28,  47,  19,  255, 73,  100, 40,  255, 105, 137, 56,  255, 116, 148, 62,  255,
    112, 144, 62,  255, 94,  125, 58,  255, 83,  115, 58,  255, 92,  124, 62,  255, 85,  113, 49,  255, 69,  96,  48,  255, 145, 168, 84,  255, 184,
    200, 94,  255, 176, 193, 92,  255, 150, 171, 72,  255, 134, 164, 60,  255, 116, 152, 49,  255, 121, 154, 58,  255, 139, 159, 76,  255, 182, 198,
    111, 255, 219, 228, 129, 255, 124, 130, 79,  255, 21,  32,  15,  255, 34,  52,  19,  255, 50,  72,  23,  255, 62,  90,  23,  255, 95,  103, 31,
    255, 152, 163, 72,  255, 166, 186, 99,  255, 131, 160, 100, 255, 108, 142, 99,  255, 106, 142, 98,  255, 104, 139, 94,  255, 107, 139, 97,  255,
    108, 140, 100, 255, 102, 135, 95,  255, 98,  132, 89,  255, 101, 133, 89,  255, 111, 138, 90,  255, 107, 137, 76,  255, 153, 171, 75,  255, 163,
    187, 74,  255, 157, 162, 72,  255, 222, 212, 121, 255, 215, 214, 117, 255, 200, 202, 105, 255, 182, 192, 86,  255, 188, 196, 73,  255, 200, 206,
    79,  255, 196, 204, 81,  255, 206, 216, 135, 255, 203, 219, 154, 255, 218, 226, 140, 255, 228, 222, 121, 255, 178, 177, 77,  255, 183, 188, 75,
    255, 174, 187, 76,  255, 140, 161, 73,  255, 108, 140, 63,  255, 145, 166, 50,  255, 221, 221, 84,  255, 241, 238, 135, 255, 200, 213, 97,  255,
    196, 213, 89,  255, 152, 181, 75,  255, 111, 143, 50,  255, 166, 175, 62,  255, 161, 174, 84,  255, 137, 157, 91,  255, 78,  111, 65,  255, 85,
    117, 68,  255, 93,  126, 78,  255, 80,  109, 74,  255, 53,  82,  62,  255, 63,  98,  67,  255, 81,  110, 75,  255, 68,  91,  52,  255, 63,  84,
    42,  255, 110, 140, 81,  255, 138, 161, 89,  255, 157, 171, 94,  255, 182, 195, 93,  255, 161, 190, 84,  255, 172, 199, 92,  255, 149, 186, 62,
    255, 178, 201, 97,  255, 205, 217, 119, 255, 217, 225, 141, 255, 190, 205, 122, 255, 136, 161, 77,  255, 133, 159, 80,  255, 83,  111, 73,  255,
    58,  92,  62,  255, 69,  103, 77,  255, 76,  110, 90,  255, 86,  120, 73,  255, 116, 151, 73,  255, 101, 139, 63,  255, 69,  111, 36,  255, 58,
    98,  36,  255, 68,  106, 45,  255, 78,  117, 58,  255, 100, 137, 81,  255, 148, 177, 98,  255, 167, 191, 92,  255, 154, 180, 83,  255, 100, 135,
    41,  255, 89,  125, 52,  255, 62,  84,  33,  255, 58,  91,  29,  255, 53,  91,  29,  255, 60,  91,  29,  255, 171, 181, 94,  255, 186, 202, 96,
    255, 160, 180, 73,  255, 149, 173, 67,  255, 114, 146, 53,  255, 78,  100, 38,  255, 83,  98,  45,  255, 86,  101, 55,  255, 87,  99,  45,  255,
    110, 118, 36,  255, 159, 170, 60,  255, 165, 182, 74,  255, 135, 156, 62,  255, 52,  68,  28,  255, 28,  38,  26,  255, 28,  38,  26,  255, 80,
    85,  43,  255, 137, 154, 60,  255, 139, 160, 68,  255, 142, 161, 84,  255, 81,  111, 47,  255, 86,  117, 46,  255, 97,  121, 37,  255, 162, 166,
    72,  255, 198, 213, 99,  255, 173, 195, 94,  255, 150, 175, 87,  255, 142, 172, 67,  255, 128, 161, 62,  255, 133, 158, 71,  255, 135, 159, 82,
    255, 110, 130, 65,  255, 105, 123, 62,  255, 109, 133, 65,  255, 105, 132, 67,  255, 86,  120, 60,  255, 65,  99,  60,  255, 62,  90,  60,  255,
    63,  90,  62,  255, 65,  92,  65,  255, 65,  92,  65,  255, 60,  86,  62,  255, 69,  90,  56,  255, 163, 181, 108, 255, 177, 210, 135, 255, 183,
    205, 130, 255, 101, 119, 56,  255, 165, 193, 94,  255, 179, 201, 93,  255, 98,  120, 58,  255, 135, 148, 95,  255, 195, 202, 139, 255, 200, 216,
    150, 255, 182, 207, 150, 255, 199, 214, 143, 255, 102, 119, 60,  255, 19,  25,  19,  255, 36,  40,  29,  255, 195, 205, 153, 255, 202, 224, 167,
    255, 235, 238, 168, 255, 241, 239, 159, 255, 197, 212, 124, 255, 185, 209, 129, 255, 177, 212, 160, 255, 200, 227, 172, 255, 190, 203, 131, 255,
    101, 132, 53,  255, 102, 137, 53,  255, 103, 138, 60,  255, 101, 138, 60,  255, 106, 146, 62,  255, 142, 171, 62,  255, 125, 157, 43,  255, 110,
    138, 36,  255, 101, 117, 56,  255, 106, 127, 72,  255, 55,  84,  28,  255, 29,  36,  21,  255, 21,  26,  23,  255, 25,  28,  26,  255, 103, 106,
    67,  255, 136, 148, 75,  255, 167, 177, 90,  255, 200, 208, 115, 255, 179, 188, 95,  255, 170, 186, 110, 255, 161, 176, 105, 255, 153, 169, 97,
    255, 162, 180, 90,  255, 162, 175, 77,  255, 104, 118, 45,  255, 118, 135, 56,  255, 148, 159, 71,  255, 138, 145, 72,  255, 129, 134, 85,  255,
    81,  111, 60,  255, 84,  114, 62,  255, 140, 159, 82,  255, 166, 187, 115, 255, 152, 180, 127, 255, 143, 174, 129, 255, 132, 166, 123, 255, 131,
    166, 119, 255, 133, 170, 117, 255, 174, 197, 123, 255, 109, 128, 52,  255, 84,  114, 47,  255, 106, 133, 55,  255, 95,  123, 47,  255, 84,  117,
    40,  255, 53,  73,  28,  255, 19,  34,  19,  255, 52,  79,  29,  255, 94,  129, 41,  255, 91,  124, 47,  255, 91,  125, 47,  255, 67,  95,  36,
    255, 81,  117, 62,  255, 77,  111, 72,  255, 72,  105, 68,  255, 69,  105, 65,  255, 69,  107, 58,  255, 57,  89,  36,  255, 46,  76,  28,  255,
    48,  83,  28,  255, 52,  84,  28,  255, 42,  73,  19,  255, 85,  104, 73,  255, 140, 163, 109, 255, 126, 153, 91,  255, 101, 139, 77,  255, 115,
    146, 83,  255, 193, 208, 128, 255, 204, 219, 132, 255, 203, 212, 119, 255, 92,  115, 39,  255, 77,  101, 40,  255, 145, 164, 71,  255, 188, 212,
    74,  255, 108, 120, 43,  255, 17,  19,  17,  255, 19,  26,  19,  255, 94,  119, 47,  255, 84,  103, 42,  255, 34,  52,  21,  255, 31,  44,  23,
    255, 49,  68,  37,  255, 92,  116, 53,  255, 112, 138, 62,  255, 111, 138, 60,  255, 92,  120, 45,  255, 67,  97,  37,  255, 63,  92,  41,  255,
    114, 132, 68,  255, 213, 221, 113, 255, 183, 202, 94,  255, 170, 196, 93,  255, 167, 194, 87,  255, 160, 185, 75,  255, 128, 162, 55,  255, 98,
    140, 43,  255, 91,  122, 44,  255, 93,  128, 60,  255, 188, 211, 120, 255, 137, 144, 89,  255, 33,  46,  23,  255, 67,  95,  36,  255, 50,  69,
    19,  255, 45,  63,  19,  255, 58,  80,  19,  255, 149, 170, 86,  255, 137, 166, 104, 255, 115, 148, 100, 255, 116, 149, 100, 255, 118, 153, 103,
    255, 115, 150, 100, 255, 114, 147, 101, 255, 113, 146, 101, 255, 115, 149, 102, 255, 111, 143, 94,  255, 117, 149, 93,  255, 126, 159, 91,  255,
    136, 166, 75,  255, 149, 170, 60,  255, 195, 212, 84,  255, 159, 182, 63,  255, 122, 119, 49,  255, 198, 182, 91,  255, 203, 195, 100, 255, 179,
    181, 76,  255, 188, 195, 56,  255, 218, 219, 93,  255, 219, 224, 117, 255, 217, 221, 128, 255, 224, 222, 127, 255, 148, 155, 60,  255, 86,  107,
    26,  255, 117, 137, 46,  255, 188, 199, 91,  255, 154, 174, 79,  255, 127, 156, 69,  255, 141, 168, 63,  255, 191, 207, 81,  255, 206, 217, 83,
    255, 210, 216, 87,  255, 207, 217, 96,  255, 205, 214, 98,  255, 194, 202, 90,  255, 181, 187, 68,  255, 103, 122, 52,  255, 77,  97,  37,  255,
    130, 153, 74,  255, 114, 152, 75,  255, 79,  114, 58,  255, 81,  118, 60,  255, 98,  134, 73,  255, 101, 139, 71,  255, 110, 144, 60,  255, 170,
    190, 111, 255, 163, 194, 131, 255, 162, 197, 135, 255, 148, 185, 114, 255, 135, 164, 77,  255, 122, 152, 69,  255, 151, 175, 87,  255, 148, 174,
    91,  255, 166, 195, 115, 255, 162, 196, 92,  255, 171, 199, 108, 255, 154, 188, 116, 255, 162, 194, 123, 255, 188, 213, 145, 255, 181, 203, 134,
    255, 122, 151, 65,  255, 113, 136, 69,  255, 79,  105, 67,  255, 75,  104, 74,  255, 80,  110, 84,  255, 83,  111, 80,  255, 85,  107, 52,  255,
    122, 149, 72,  255, 94,  129, 48,  255, 68,  107, 37,  255, 84,  123, 50,  255, 98,  137, 60,  255, 147, 173, 80,  255, 176, 196, 84,  255, 173,
    192, 72,  255, 179, 197, 80,  255, 155, 180, 60,  255, 118, 139, 56,  255, 60,  89,  32,  255, 97,  140, 48,  255, 65,  108, 36,  255, 47,  87,
    28,  255, 69,  92,  29,  255, 149, 159, 65,  255, 168, 184, 76,  255, 156, 180, 65,  255, 135, 158, 56,  255, 79,  86,  52,  255, 56,  52,  43,
    255, 39,  40,  26,  255, 26,  37,  21,  255, 28,  38,  21,  255, 47,  53,  21,  255, 76,  80,  31,  255, 29,  41,  21,  255, 25,  34,  25,  255,
    33,  47,  29,  255, 32,  46,  28,  255, 21,  33,  23,  255, 47,  55,  31,  255, 108, 116, 45,  255, 198, 198, 95,  255, 189, 205, 97,  255, 110,
    132, 39,  255, 179, 178, 96,  255, 249, 241, 143, 255, 193, 209, 117, 255, 149, 184, 72,  255, 154, 178, 87,  255, 110, 146, 65,  255, 112, 147,
    60,  255, 118, 152, 58,  255, 130, 158, 81,  255, 102, 122, 62,  255, 119, 140, 71,  255, 118, 142, 68,  255, 125, 146, 69,  255, 88,  109, 48,
    255, 69,  100, 53,  255, 79,  112, 67,  255, 75,  106, 67,  255, 68,  98,  72,  255, 62,  92,  67,  255, 60,  86,  62,  255, 46,  73,  47,  255,
    69,  86,  39,  255, 185, 203, 109, 255, 161, 197, 112, 255, 153, 178, 92,  255, 173, 199, 87,  255, 144, 161, 84,  255, 198, 197, 138, 255, 228,
    233, 171, 255, 191, 214, 156, 255, 175, 200, 153, 255, 204, 219, 161, 255, 156, 169, 98,  255, 68,  97,  29,  255, 23,  34,  19,  255, 73,  75,
    56,  255, 214, 230, 182, 255, 188, 213, 149, 255, 226, 231, 139, 255, 235, 239, 164, 255, 185, 207, 140, 255, 172, 207, 154, 255, 185, 215, 142,
    255, 162, 174, 114, 255, 112, 131, 62,  255, 119, 140, 60,  255, 125, 149, 73,  255, 128, 154, 74,  255, 130, 157, 68,  255, 150, 175, 84,  255,
    145, 169, 74,  255, 109, 139, 49,  255, 153, 170, 87,  255, 216, 230, 161, 255, 117, 127, 77,  255, 50,  62,  32,  255, 29,  34,  25,  255, 21,
    29,  21,  255, 15,  23,  19,  255, 26,  31,  23,  255, 93,  105, 62,  255, 122, 140, 75,  255, 157, 175, 102, 255, 162, 179, 106, 255, 210, 221,
    149, 255, 197, 216, 150, 255, 201, 218, 148, 255, 210, 220, 143, 255, 205, 212, 109, 255, 227, 228, 100, 255, 245, 243, 106, 255, 251, 246, 118,
    255, 255, 255, 134, 255, 199, 198, 106, 255, 99,  127, 55,  255, 147, 169, 92,  255, 173, 196, 125, 255, 150, 180, 130, 255, 149, 179, 134, 255,
    150, 181, 138, 255, 150, 180, 130, 255, 146, 177, 122, 255, 181, 204, 130, 255, 157, 167, 85,  255, 103, 132, 40,  255, 151, 182, 77,  255, 156,
    186, 97,  255, 171, 195, 100, 255, 126, 147, 58,  255, 49,  67,  23,  255, 52,  68,  31,  255, 65,  87,  37,  255, 106, 137, 52,  255, 106, 140,
    55,  255, 87,  123, 39,  255, 62,  87,  32,  255, 69,  106, 58,  255, 76,  110, 73,  255, 79,  112, 74,  255, 73,  105, 65,  255, 69,  104, 65,
    255, 65,  99,  46,  255, 49,  79,  31,  255, 44,  72,  29,  255, 44,  68,  29,  255, 44,  71,  32,  255, 105, 122, 79,  255, 120, 141, 73,  255,
    142, 172, 97,  255, 133, 167, 99,  255, 179, 201, 119, 255, 201, 217, 125, 255, 209, 222, 131, 255, 195, 205, 115, 255, 89,  117, 52,  255, 177,
    194, 114, 255, 205, 222, 90,  255, 194, 213, 94,  255, 78,  85,  41,  255, 19,  28,  17,  255, 21,  34,  15,  255, 44,  62,  28,  255, 83,  100,
    40,  255, 47,  63,  25,  255, 43,  62,  26,  255, 34,  49,  23,  255, 29,  41,  21,  255, 34,  51,  26,  255, 49,  69,  32,  255, 47,  69,  31,
    255, 44,  69,  32,  255, 29,  51,  29,  255, 175, 182, 115, 255, 233, 235, 122, 255, 169, 188, 82,  255, 146, 174, 79,  255, 138, 170, 82,  255,
    145, 176, 87,  255, 138, 171, 65,  255, 104, 147, 47,  255, 96,  125, 48,  255, 97,  123, 53,  255, 116, 140, 68,  255, 126, 146, 68,  255, 141,
    160, 75,  255, 121, 145, 69,  255, 44,  65,  33,  255, 50,  68,  36,  255, 58,  75,  33,  255, 116, 127, 60,  255, 156, 182, 101, 255, 136, 172,
    105, 255, 121, 157, 104, 255, 119, 153, 101, 255, 117, 150, 101, 255, 120, 152, 100, 255, 128, 161, 100, 255, 130, 163, 103, 255, 130, 164, 101,
    255, 136, 163, 87,  255, 164, 178, 71,  255, 207, 220, 71,  255, 196, 213, 92,  255, 201, 217, 103, 255, 172, 193, 75,  255, 69,  92,  40,  255,
    79,  98,  36,  255, 115, 122, 49,  255, 108, 111, 42,  255, 150, 153, 58,  255, 178, 170, 76,  255, 195, 188, 84,  255, 178, 181, 83,  255, 143,
    155, 53,  255, 114, 144, 37,  255, 104, 132, 34,  255, 187, 195, 87,  255, 200, 210, 104, 255, 179, 195, 82,  255, 187, 199, 73,  255, 190, 200,
    64,  255, 205, 213, 84,  255, 211, 219, 92,  255, 216, 221, 101, 255, 224, 226, 108, 255, 203, 210, 97,  255, 134, 150, 69,  255, 112, 134, 69,
    255, 79,  116, 68,  255, 58,  96,  48,  255, 74,  100, 38,  255, 128, 152, 65,  255, 116, 152, 62,  255, 118, 154, 55,  255, 118, 149, 49,  255,
    99,  120, 33,  255, 157, 172, 90,  255, 190, 213, 142, 255, 160, 195, 136, 255, 161, 194, 124, 255, 150, 184, 99,  255, 165, 194, 77,  255, 182,
    200, 96,  255, 188, 215, 103, 255, 149, 189, 76,  255, 170, 199, 94,  255, 191, 213, 122, 255, 194, 221, 129, 255, 178, 214, 136, 255, 181, 214,
    136, 255, 176, 201, 132, 255, 153, 172, 113, 255, 141, 171, 82,  255, 119, 139, 48,  255, 83,  102, 60,  255, 60,  83,  58,  255, 92,  121, 75,
    255, 105, 137, 80,  255, 100, 125, 73,  255, 120, 139, 79,  255, 116, 137, 52,  255, 98,  127, 47,  255, 83,  111, 45,  255, 99,  125, 49,  255,
    176, 194, 95,  255, 183, 202, 92,  255, 185, 200, 82,  255, 153, 173, 68,  255, 117, 145, 53,  255, 144, 162, 60,  255, 81,  118, 46,  255, 95,
    129, 68,  255, 82,  123, 48,  255, 75,  120, 39,  255, 49,  94,  29,  255, 73,  116, 38,  255, 101, 114, 48,  255, 111, 120, 47,  255, 96,  118,
    58,  255, 67,  86,  56,  255, 34,  47,  28,  255, 33,  49,  26,  255, 34,  51,  29,  255, 42,  62,  32,  255, 36,  55,  31,  255, 47,  62,  28,
    255, 60,  69,  47,  255, 17,  21,  19,  255, 21,  31,  21,  255, 19,  29,  19,  255, 17,  31,  19,  255, 17,  28,  21,  255, 17,  26,  19,  255,
    69,  72,  37,  255, 241, 245, 114, 255, 201, 206, 99,  255, 173, 171, 106, 255, 206, 205, 112, 255, 218, 222, 105, 255, 163, 194, 77,  255, 155,
    185, 65,  255, 149, 172, 78,  255, 102, 138, 56,  255, 101, 138, 53,  255, 103, 131, 62,  255, 109, 127, 63,  255, 141, 159, 86,  255, 165, 176,
    93,  255, 155, 168, 94,  255, 109, 120, 77,  255, 127, 143, 89,  255, 169, 189, 118, 255, 136, 166, 98,  255, 97,  132, 76,  255, 99,  131, 75,
    255, 80,  110, 67,  255, 62,  90,  46,  255, 47,  72,  28,  255, 89,  100, 47,  255, 151, 173, 81,  255, 131, 162, 71,  255, 122, 144, 65,  255,
    199, 203, 132, 255, 218, 229, 142, 255, 191, 214, 117, 255, 195, 214, 135, 255, 190, 210, 158, 255, 217, 223, 157, 255, 102, 121, 65,  255, 69,
    105, 36,  255, 37,  58,  21,  255, 97,  100, 68,  255, 223, 238, 182, 255, 193, 218, 176, 255, 183, 208, 108, 255, 198, 216, 109, 255, 158, 187,
    115, 255, 190, 215, 138, 255, 172, 186, 109, 255, 58,  76,  36,  255, 60,  90,  32,  255, 52,  75,  34,  255, 56,  80,  37,  255, 56,  79,  33,
    255, 69,  103, 46,  255, 96,  125, 53,  255, 94,  126, 48,  255, 161, 176, 102, 255, 211, 227, 178, 255, 201, 227, 173, 255, 108, 116, 73,  255,
    36,  47,  29,  255, 26,  34,  23,  255, 53,  55,  39,  255, 71,  74,  52,  255, 128, 135, 84,  255, 227, 234, 151, 255, 223, 228, 151, 255, 220,
    226, 148, 255, 215, 223, 147, 255, 232, 232, 149, 255, 226, 229, 149, 255, 206, 217, 147, 255, 181, 205, 151, 255, 197, 215, 156, 255, 224, 229,
    141, 255, 239, 238, 136, 255, 248, 243, 136, 255, 255, 255, 153, 255, 211, 210, 124, 255, 160, 178, 76,  255, 186, 207, 122, 255, 155, 187, 129,
    255, 158, 188, 139, 255, 164, 192, 151, 255, 161, 190, 132, 255, 155, 184, 119, 255, 172, 196, 122, 255, 196, 206, 103, 255, 127, 151, 71,  255,
    69,  101, 36,  255, 106, 133, 48,  255, 149, 174, 82,  255, 174, 198, 108, 255, 160, 180, 83,  255, 119, 153, 68,  255, 138, 172, 77,  255, 157,
    182, 82,  255, 164, 183, 86,  255, 113, 134, 60,  255, 45,  65,  21,  255, 63,  87,  36,  255, 83,  119, 65,  255, 77,  113, 73,  255, 80,  115,
    75,  255, 77,  110, 69,  255, 69,  107, 62,  255, 74,  112, 47,  255, 72,  106, 36,  255, 63,  99,  34,  255, 55,  83,  34,  255, 83,  104, 56,
    255, 68,  83,  41,  255, 25,  36,  17,  255, 63,  75,  39,  255, 126, 143, 74,  255, 194, 213, 121, 255, 198, 214, 126, 255, 213, 224, 129, 255,
    170, 183, 90,  255, 141, 161, 65,  255, 199, 220, 86,  255, 196, 215, 109, 255, 216, 228, 158, 255, 166, 175, 99,  255, 138, 149, 86,  255, 81,
    89,  47,  255, 53,  77,  28,  255, 128, 158, 55,  255, 42,  53,  19,  255, 31,  42,  23,  255, 37,  53,  23,  255, 37,  62,  26,  255, 34,  58,
    26,  255, 36,  58,  26,  255, 55,  81,  37,  255, 63,  89,  40,  255, 39,  62,  25,  255, 102, 110, 67,  255, 190, 194, 101, 255, 215, 220, 91,
    255, 178, 196, 68,  255, 146, 173, 68,  255, 132, 164, 72,  255, 143, 175, 76,  255, 126, 158, 58,  255, 101, 123, 50,  255, 83,  100, 41,  255,
    75,  103, 36,  255, 181, 194, 105, 255, 170, 186, 99,  255, 125, 147, 69,  255, 85,  112, 56,  255, 65,  90,  52,  255, 55,  75,  48,  255, 45,
    63,  31,  255, 102, 105, 36,  255, 169, 182, 87,  255, 167, 193, 111, 255, 126, 163, 106, 255, 125, 160, 108, 255, 129, 163, 105, 255, 152, 179,
    110, 255, 156, 179, 99,  255, 162, 173, 82,  255, 133, 143, 55,  255, 86,  96,  23,  255, 159, 168, 56,  255, 210, 220, 104, 255, 200, 215, 109,
    255, 190, 200, 99,  255, 149, 153, 74,  255, 112, 133, 55,  255, 158, 176, 76,  255, 86,  103, 41,  255, 145, 172, 77,  255, 83,  93,  41,  255,
    52,  71,  12,  255, 189, 194, 71,  255, 188, 192, 67,  255, 141, 163, 44,  255, 163, 175, 62,  255, 213, 218, 111, 255, 217, 219, 109, 255, 210,
    213, 90,  255, 202, 209, 76,  255, 197, 207, 78,  255, 203, 204, 82,  255, 217, 220, 89,  255, 214, 221, 97,  255, 225, 225, 109, 255, 196, 204,
    100, 255, 112, 151, 86,  255, 107, 146, 89,  255, 119, 155, 92,  255, 97,  135, 81,  255, 67,  107, 53,  255, 65,  102, 44,  255, 91,  118, 43,
    255, 96,  112, 43,  255, 69,  91,  36,  255, 52,  76,  19,  255, 176, 193, 108, 255, 171, 202, 138, 255, 167, 196, 129, 255, 157, 189, 105, 255,
    157, 190, 96,  255, 185, 202, 84,  255, 199, 206, 107, 255, 184, 214, 96,  255, 165, 202, 78,  255, 190, 212, 104, 255, 175, 197, 135, 255, 193,
    208, 143, 255, 214, 224, 150, 255, 209, 215, 124, 255, 124, 141, 71,  255, 47,  62,  32,  255, 115, 155, 65,  255, 117, 133, 53,  255, 78,  96,
    56,  255, 122, 150, 98,  255, 116, 150, 104, 255, 117, 155, 103, 255, 130, 160, 97,  255, 127, 151, 81,  255, 136, 157, 63,  255, 118, 137, 55,
    255, 81,  100, 53,  255, 126, 143, 78,  255, 190, 199, 113, 255, 165, 183, 84,  255, 112, 139, 58,  255, 53,  90,  38,  255, 109, 134, 56,  255,
    149, 165, 65,  255, 86,  114, 55,  255, 85,  122, 65,  255, 100, 138, 67,  255, 87,  129, 47,  255, 94,  143, 48,  255, 119, 160, 76,  255, 74,
    98,  53,  255, 60,  81,  31,  255, 80,  117, 38,  255, 94,  129, 53,  255, 106, 133, 58,  255, 42,  65,  36,  255, 94,  106, 47,  255, 80,  91,
    38,  255, 31,  43,  21,  255, 50,  60,  29,  255, 76,  87,  58,  255, 65,  60,  44,  255, 189, 187, 125, 255, 143, 145, 99,  255, 90,  93,  60,
    255, 49,  52,  38,  255, 9,   15,  17,  255, 17,  23,  17,  255, 151, 150, 74,  255, 255, 255, 129, 255, 216, 225, 115, 255, 150, 165, 83,  255,
    152, 160, 68,  255, 197, 211, 95,  255, 143, 181, 68,  255, 183, 199, 78,  255, 177, 191, 65,  255, 153, 177, 65,  255, 103, 131, 52,  255, 114,
    135, 60,  255, 193, 202, 119, 255, 210, 223, 142, 255, 195, 219, 155, 255, 188, 217, 160, 255, 200, 225, 170, 255, 179, 194, 136, 255, 99,  121,
    58,  255, 84,  109, 47,  255, 91,  115, 52,  255, 79,  104, 50,  255, 48,  71,  36,  255, 36,  55,  29,  255, 23,  46,  21,  255, 60,  76,  34,
    255, 124, 147, 67,  255, 145, 162, 80,  255, 181, 203, 100, 255, 172, 199, 86,  255, 184, 208, 105, 255, 195, 215, 144, 255, 212, 225, 171, 255,
    179, 186, 129, 255, 55,  81,  43,  255, 76,  107, 48,  255, 41,  68,  26,  255, 101, 102, 63,  255, 234, 243, 185, 255, 200, 221, 186, 255, 201,
    219, 155, 255, 184, 209, 93,  255, 184, 202, 106, 255, 204, 215, 130, 255, 185, 195, 116, 255, 69,  92,  38,  255, 108, 142, 60,  255, 69,  94,
    44,  255, 37,  55,  29,  255, 47,  65,  37,  255, 65,  97,  53,  255, 72,  104, 47,  255, 129, 152, 78,  255, 205, 219, 153, 255, 176, 206, 155,
    255, 201, 223, 148, 255, 88,  97,  62,  255, 28,  37,  26,  255, 152, 160, 100, 255, 220, 227, 139, 255, 228, 235, 138, 255, 238, 241, 148, 255,
    231, 233, 144, 255, 230, 231, 145, 255, 234, 233, 150, 255, 233, 232, 148, 255, 229, 231, 156, 255, 227, 230, 155, 255, 229, 232, 153, 255, 220,
    225, 154, 255, 185, 204, 149, 255, 174, 201, 149, 255, 194, 205, 118, 255, 189, 195, 105, 255, 195, 203, 112, 255, 200, 205, 127, 255, 178, 196,
    100, 255, 170, 196, 134, 255, 165, 195, 145, 255, 170, 199, 153, 255, 163, 191, 132, 255, 155, 185, 111, 255, 171, 195, 114, 255, 176, 190, 97,
    255, 117, 144, 63,  255, 109, 147, 58,  255, 99,  136, 47,  255, 58,  87,  31,  255, 86,  116, 44,  255, 115, 149, 68,  255, 106, 142, 77,  255,
    107, 144, 83,  255, 121, 155, 87,  255, 136, 167, 90,  255, 176, 196, 100, 255, 148, 161, 76,  255, 26,  36,  15,  255, 56,  73,  38,  255, 89,
    123, 74,  255, 84,  121, 75,  255, 86,  123, 80,  255, 79,  116, 74,  255, 79,  119, 63,  255, 60,  87,  31,  255, 42,  62,  25,  255, 58,  83,
    33,  255, 75,  97,  50,  255, 56,  71,  36,  255, 32,  42,  21,  255, 21,  31,  21,  255, 9,   15,  12,  255, 78,  93,  50,  255, 203, 219, 127,
    255, 209, 222, 127, 255, 167, 179, 84,  255, 104, 124, 45,  255, 180, 194, 105, 255, 200, 218, 104, 255, 206, 221, 133, 255, 212, 227, 130, 255,
    224, 236, 134, 255, 219, 228, 126, 255, 107, 121, 48,  255, 112, 146, 58,  255, 173, 205, 75,  255, 91,  109, 36,  255, 21,  31,  21,  255, 58,
    86,  44,  255, 58,  95,  40,  255, 40,  73,  28,  255, 69,  100, 37,  255, 126, 158, 63,  255, 144, 171, 75,  255, 129, 150, 68,  255, 76,  92,
    40,  255, 52,  68,  29,  255, 124, 139, 65,  255, 187, 196, 80,  255, 198, 206, 73,  255, 183, 197, 68,  255, 177, 193, 68,  255, 193, 201, 69,
    255, 147, 154, 53,  255, 132, 156, 63,  255, 162, 190, 84,  255, 239, 243, 160, 255, 163, 179, 103, 255, 132, 155, 71,  255, 101, 125, 67,  255,
    56,  84,  55,  255, 55,  84,  47,  255, 60,  86,  39,  255, 46,  69,  21,  255, 73,  87,  23,  255, 130, 135, 62,  255, 154, 170, 87,  255, 163,
    182, 92,  255, 166, 185, 99,  255, 192, 199, 110, 255, 79,  87,  34,  255, 90,  99,  36,  255, 131, 139, 55,  255, 72,  91,  31,  255, 159, 172,
    77,  255, 213, 219, 109, 255, 201, 214, 108, 255, 204, 218, 96,  255, 214, 221, 120, 255, 194, 202, 94,  255, 186, 191, 74,  255, 144, 158, 71,
    255, 167, 187, 86,  255, 147, 147, 58,  255, 32,  47,  9,   255, 153, 161, 69,  255, 251, 238, 95,  255, 215, 210, 80,  255, 221, 214, 103, 255,
    200, 210, 129, 255, 224, 222, 121, 255, 210, 214, 113, 255, 205, 212, 104, 255, 210, 213, 104, 255, 132, 142, 68,  255, 145, 144, 58,  255, 222,
    223, 108, 255, 224, 225, 122, 255, 184, 198, 92,  255, 173, 195, 84,  255, 152, 178, 77,  255, 162, 187, 97,  255, 147, 177, 99,  255, 112, 154,
    81,  255, 107, 150, 71,  255, 110, 153, 74,  255, 121, 151, 85,  255, 140, 167, 92,  255, 151, 177, 82,  255, 188, 208, 119, 255, 174, 203, 127,
    255, 177, 199, 108, 255, 184, 206, 105, 255, 187, 202, 94,  255, 127, 142, 48,  255, 164, 174, 82,  255, 205, 226, 124, 255, 190, 200, 98,  255,
    195, 210, 106, 255, 181, 211, 122, 255, 167, 199, 133, 255, 183, 206, 139, 255, 164, 186, 108, 255, 95,  128, 62,  255, 91,  108, 60,  255, 129,
    166, 86,  255, 164, 185, 101, 255, 148, 163, 90,  255, 146, 167, 77,  255, 134, 154, 87,  255, 120, 151, 102, 255, 130, 164, 107, 255, 109, 131,
    67,  255, 100, 114, 65,  255, 62,  71,  38,  255, 76,  85,  45,  255, 69,  84,  49,  255, 63,  73,  40,  255, 77,  106, 45,  255, 58,  98,  38,
    255, 39,  71,  33,  255, 73,  92,  45,  255, 79,  100, 48,  255, 73,  104, 44,  255, 69,  99,  52,  255, 109, 147, 75,  255, 113, 161, 69,  255,
    133, 169, 86,  255, 83,  111, 47,  255, 65,  92,  36,  255, 82,  109, 43,  255, 128, 163, 87,  255, 154, 182, 93,  255, 183, 199, 78,  255, 138,
    158, 63,  255, 152, 163, 62,  255, 76,  87,  34,  255, 32,  47,  23,  255, 21,  23,  21,  255, 9,   12,  15,  255, 28,  29,  19,  255, 207, 205,
    128, 255, 251, 255, 165, 255, 239, 243, 155, 255, 218, 222, 139, 255, 130, 135, 84,  255, 43,  51,  32,  255, 33,  47,  21,  255, 156, 157, 69,
    255, 248, 255, 124, 255, 220, 231, 136, 255, 157, 173, 103, 255, 140, 158, 74,  255, 175, 203, 107, 255, 188, 208, 101, 255, 219, 219, 86,  255,
    202, 205, 65,  255, 180, 191, 72,  255, 176, 195, 112, 255, 202, 224, 157, 255, 180, 214, 153, 255, 176, 210, 150, 255, 199, 223, 165, 255, 188,
    203, 135, 255, 69,  97,  29,  255, 62,  92,  28,  255, 57,  86,  34,  255, 50,  76,  38,  255, 52,  79,  37,  255, 55,  83,  39,  255, 48,  75,
    37,  255, 50,  68,  29,  255, 158, 169, 60,  255, 143, 159, 67,  255, 203, 215, 149, 255, 191, 212, 164, 255, 195, 213, 166, 255, 192, 212, 166,
    255, 206, 222, 168, 255, 211, 217, 152, 255, 96,  115, 63,  255, 57,  86,  47,  255, 69,  100, 47,  255, 39,  62,  25,  255, 101, 99,  69,  255,
    217, 233, 181, 255, 198, 221, 180, 255, 205, 222, 168, 255, 189, 205, 121, 255, 182, 191, 121, 255, 177, 192, 126, 255, 206, 217, 138, 255, 104,
    126, 65,  255, 107, 137, 67,  255, 99,  124, 58,  255, 63,  80,  46,  255, 55,  69,  40,  255, 73,  106, 58,  255, 73,  103, 52,  255, 160, 179,
    100, 255, 185, 211, 156, 255, 164, 198, 153, 255, 177, 207, 115, 255, 87,  105, 47,  255, 129, 147, 94,  255, 212, 235, 154, 255, 172, 195, 107,
    255, 146, 165, 68,  255, 194, 202, 92,  255, 218, 221, 110, 255, 230, 233, 128, 255, 228, 234, 142, 255, 225, 230, 147, 255, 224, 230, 125, 255,
    229, 232, 146, 255, 227, 231, 156, 255, 230, 232, 159, 255, 224, 229, 151, 255, 196, 213, 149, 255, 176, 196, 118, 255, 195, 207, 130, 255, 166,
    185, 81,  255, 136, 150, 65,  255, 174, 193, 122, 255, 168, 199, 155, 255, 176, 203, 157, 255, 169, 195, 138, 255, 172, 199, 123, 255, 195, 213,
    125, 255, 195, 205, 103, 255, 160, 180, 74,  255, 147, 172, 63,  255, 114, 138, 47,  255, 53,  80,  29,  255, 37,  60,  26,  255, 62,  90,  31,
    255, 120, 156, 60,  255, 124, 158, 74,  255, 119, 156, 82,  255, 121, 155, 94,  255, 130, 161, 100, 255, 165, 187, 104, 255, 200, 215, 109, 255,
    89,  92,  40,  255, 41,  52,  28,  255, 106, 137, 74,  255, 90,  123, 82,  255, 90,  126, 83,  255, 81,  118, 74,  255, 94,  133, 68,  255, 65,
    89,  31,  255, 32,  51,  25,  255, 60,  81,  43,  255, 47,  60,  32,  255, 21,  31,  21,  255, 26,  37,  23,  255, 12,  23,  15,  255, 3,   9,
    9,   255, 118, 137, 71,  255, 208, 225, 126, 255, 221, 234, 122, 255, 175, 189, 69,  255, 155, 173, 90,  255, 216, 228, 150, 255, 198, 218, 127,
    255, 195, 215, 119, 255, 198, 214, 117, 255, 182, 198, 105, 255, 136, 158, 68,  255, 124, 156, 60,  255, 173, 203, 93,  255, 179, 202, 101, 255,
    124, 149, 50,  255, 71,  102, 52,  255, 78,  111, 74,  255, 47,  74,  37,  255, 82,  119, 43,  255, 135, 168, 62,  255, 144, 175, 69,  255, 150,
    177, 73,  255, 159, 185, 81,  255, 170, 194, 93,  255, 148, 168, 80,  255, 83,  107, 44,  255, 115, 142, 74,  255, 180, 195, 90,  255, 182, 193,
    84,  255, 200, 204, 84,  255, 199, 202, 80,  255, 169, 185, 69,  255, 169, 194, 87,  255, 170, 193, 87,  255, 171, 193, 91,  255, 130, 158, 76,
    255, 133, 156, 68,  255, 170, 178, 90,  255, 133, 152, 89,  255, 106, 134, 68,  255, 72,  96,  42,  255, 74,  100, 31,  255, 57,  87,  26,  255,
    48,  74,  28,  255, 67,  89,  29,  255, 93,  112, 33,  255, 75,  93,  25,  255, 136, 155, 71,  255, 97,  116, 49,  255, 101, 120, 47,  255, 160,
    170, 68,  255, 187, 193, 83,  255, 201, 206, 91,  255, 204, 210, 99,  255, 222, 226, 121, 255, 224, 225, 120, 255, 222, 222, 112, 255, 218, 222,
    98,  255, 190, 196, 86,  255, 223, 222, 110, 255, 218, 216, 113, 255, 254, 246, 134, 255, 184, 169, 84,  255, 63,  68,  23,  255, 220, 218, 111,
    255, 226, 226, 139, 255, 178, 193, 127, 255, 161, 189, 132, 255, 173, 192, 129, 255, 158, 185, 127, 255, 173, 193, 122, 255, 210, 214, 98,  255,
    157, 181, 103, 255, 116, 140, 78,  255, 180, 183, 107, 255, 208, 212, 114, 255, 146, 178, 68,  255, 126, 165, 65,  255, 128, 169, 75,  255, 173,
    201, 107, 255, 164, 191, 104, 255, 144, 174, 79,  255, 142, 175, 62,  255, 180, 202, 77,  255, 163, 191, 102, 255, 139, 173, 106, 255, 142, 171,
    100, 255, 171, 186, 99,  255, 175, 188, 93,  255, 134, 155, 82,  255, 122, 146, 84,  255, 131, 157, 81,  255, 97,  128, 45,  255, 100, 118, 52,
    255, 127, 132, 89,  255, 63,  80,  52,  255, 86,  96,  44,  255, 118, 121, 53,  255, 170, 186, 99,  255, 189, 211, 136, 255, 145, 173, 108, 255,
    119, 156, 80,  255, 154, 182, 98,  255, 163, 193, 116, 255, 162, 191, 123, 255, 163, 194, 124, 255, 146, 178, 104, 255, 155, 180, 94,  255, 136,
    157, 87,  255, 133, 160, 108, 255, 102, 122, 79,  255, 85,  86,  73,  255, 21,  26,  25,  255, 21,  31,  23,  255, 19,  29,  21,  255, 58,  76,
    38,  255, 73,  107, 49,  255, 58,  94,  38,  255, 42,  68,  37,  255, 38,  62,  37,  255, 63,  92,  42,  255, 62,  100, 31,  255, 74,  104, 41,
    255, 151, 179, 96,  255, 153, 179, 84,  255, 124, 148, 62,  255, 29,  43,  19,  255, 47,  72,  37,  255, 75,  97,  58,  255, 184, 206, 145, 255,
    165, 184, 106, 255, 129, 150, 72,  255, 85,  103, 41,  255, 72,  92,  36,  255, 41,  60,  26,  255, 52,  73,  38,  255, 29,  36,  26,  255, 108,
    117, 79,  255, 109, 137, 90,  255, 150, 167, 104, 255, 235, 234, 147, 255, 229, 234, 148, 255, 227, 233, 142, 255, 238, 243, 148, 255, 215, 221,
    134, 255, 93,  103, 62,  255, 38,  47,  26,  255, 145, 158, 56,  255, 217, 230, 123, 255, 216, 230, 176, 255, 212, 220, 148, 255, 204, 222, 121,
    255, 181, 206, 107, 255, 195, 205, 117, 255, 170, 172, 94,  255, 172, 183, 101, 255, 189, 219, 151, 255, 179, 212, 150, 255, 182, 211, 141, 255,
    217, 234, 167, 255, 205, 212, 159, 255, 90,  109, 52,  255, 83,  106, 38,  255, 90,  111, 39,  255, 94,  117, 43,  255, 98,  128, 47,  255, 73,
    108, 39,  255, 75,  110, 47,  255, 71,  102, 48,  255, 63,  86,  36,  255, 129, 136, 47,  255, 193, 195, 114, 255, 207, 223, 185, 255, 183, 209,
    182, 255, 188, 211, 167, 255, 219, 232, 165, 255, 214, 220, 145, 255, 107, 129, 63,  255, 63,  95,  41,  255, 66,  96,  44,  255, 58,  89,  40,
    255, 43,  65,  23,  255, 69,  68,  52,  255, 210, 225, 176, 255, 201, 223, 182, 255, 188, 207, 156, 255, 187, 197, 133, 255, 131, 145, 77,  255,
    149, 165, 100, 255, 181, 198, 126, 255, 113, 148, 77,  255, 111, 143, 68,  255, 129, 159, 67,  255, 75,  92,  41,  255, 62,  74,  40,  255, 89,
    123, 69,  255, 77,  108, 62,  255, 159, 176, 106, 255, 181, 208, 156, 255, 172, 203, 164, 255, 177, 203, 129, 255, 178, 203, 96,  255, 168, 198,
    98,  255, 166, 191, 90,  255, 116, 142, 55,  255, 82,  118, 40,  255, 72,  104, 38,  255, 76,  104, 40,  255, 124, 141, 56,  255, 184, 192, 87,
    255, 217, 224, 108, 255, 158, 176, 85,  255, 187, 199, 89,  255, 206, 216, 107, 255, 222, 233, 130, 255, 230, 236, 139, 255, 229, 238, 148, 255,
    196, 209, 115, 255, 183, 200, 114, 255, 181, 201, 119, 255, 148, 161, 83,  255, 175, 193, 139, 255, 188, 210, 140, 255, 218, 227, 131, 255, 219,
    224, 134, 255, 149, 163, 84,  255, 128, 147, 71,  255, 127, 145, 68,  255, 90,  101, 43,  255, 65,  79,  32,  255, 44,  67,  29,  255, 40,  63,
    31,  255, 39,  60,  26,  255, 39,  62,  23,  255, 97,  124, 45,  255, 159, 186, 74,  255, 152, 178, 84,  255, 147, 174, 96,  255, 141, 170, 104,
    255, 150, 179, 109, 255, 208, 222, 124, 255, 143, 141, 74,  255, 37,  53,  21,  255, 111, 144, 68,  255, 106, 137, 84,  255, 95,  128, 81,  255,
    87,  121, 69,  255, 111, 140, 71,  255, 55,  73,  26,  255, 58,  79,  39,  255, 50,  68,  31,  255, 32,  47,  21,  255, 48,  58,  34,  255, 50,
    58,  37,  255, 47,  52,  38,  255, 49,  57,  40,  255, 152, 172, 81,  255, 164, 176, 80,  255, 150, 155, 83,  255, 159, 168, 80,  255, 180, 198,
    89,  255, 151, 173, 90,  255, 168, 190, 99,  255, 170, 191, 94,  255, 158, 179, 77,  255, 145, 169, 74,  255, 131, 161, 68,  255, 149, 181, 87,
    255, 193, 216, 127, 255, 166, 191, 97,  255, 97,  128, 40,  255, 92,  123, 49,  255, 53,  80,  33,  255, 60,  89,  31,  255, 129, 167, 62,  255,
    143, 174, 68,  255, 143, 174, 69,  255, 153, 179, 77,  255, 155, 180, 78,  255, 160, 185, 91,  255, 170, 195, 102, 255, 150, 170, 89,  255, 118,
    143, 74,  255, 161, 183, 90,  255, 126, 153, 69,  255, 115, 148, 68,  255, 131, 159, 80,  255, 155, 182, 80,  255, 167, 194, 87,  255, 175, 197,
    87,  255, 165, 188, 84,  255, 125, 154, 75,  255, 153, 176, 76,  255, 178, 191, 86,  255, 180, 186, 92,  255, 164, 176, 87,  255, 133, 150, 74,
    255, 93,  118, 37,  255, 73,  104, 38,  255, 60,  91,  38,  255, 58,  87,  36,  255, 82,  110, 39,  255, 116, 137, 53,  255, 181, 193, 84,  255,
    211, 211, 90,  255, 199, 200, 86,  255, 203, 207, 95,  255, 225, 228, 105, 255, 201, 210, 95,  255, 218, 223, 131, 255, 233, 232, 148, 255, 222,
    225, 139, 255, 206, 214, 127, 255, 204, 215, 117, 255, 218, 218, 98,  255, 226, 224, 107, 255, 213, 205, 99,  255, 227, 223, 121, 255, 255, 246,
    140, 255, 199, 188, 100, 255, 183, 198, 136, 255, 179, 204, 159, 255, 188, 209, 160, 255, 175, 202, 138, 255, 172, 203, 140, 255, 168, 195, 133,
    255, 170, 189, 108, 255, 192, 200, 71,  255, 157, 184, 107, 255, 142, 172, 115, 255, 146, 170, 110, 255, 152, 180, 101, 255, 136, 179, 93,  255,
    151, 194, 109, 255, 175, 204, 118, 255, 169, 194, 119, 255, 161, 189, 84,  255, 159, 182, 73,  255, 150, 182, 67,  255, 166, 192, 67,  255, 169,
    192, 95,  255, 130, 165, 92,  255, 126, 162, 95,  255, 125, 161, 91,  255, 154, 178, 93,  255, 114, 149, 87,  255, 94,  136, 87,  255, 112, 151,
    86,  255, 108, 132, 55,  255, 56,  76,  40,  255, 68,  92,  60,  255, 58,  84,  55,  255, 37,  63,  42,  255, 19,  39,  19,  255, 81,  98,  48,
    255, 132, 159, 109, 255, 126, 161, 109, 255, 108, 138, 83,  255, 115, 147, 76,  255, 144, 165, 74,  255, 170, 193, 93,  255, 165, 194, 99,  255,
    154, 186, 98,  255, 149, 182, 96,  255, 153, 184, 89,  255, 142, 164, 86,  255, 113, 127, 91,  255, 38,  46,  39,  255, 25,  33,  26,  255, 31,
    42,  32,  255, 28,  37,  29,  255, 72,  92,  48,  255, 69,  101, 53,  255, 63,  97,  48,  255, 46,  71,  38,  255, 101, 126, 47,  255, 97,  139,
    47,  255, 87,  129, 48,  255, 91,  132, 49,  255, 101, 136, 55,  255, 102, 140, 56,  255, 157, 185, 77,  255, 119, 144, 55,  255, 41,  72,  29,
    255, 36,  55,  31,  255, 115, 135, 87,  255, 78,  100, 62,  255, 80,  106, 62,  255, 36,  52,  34,  255, 98,  109, 58,  255, 91,  111, 53,  255,
    36,  55,  26,  255, 47,  53,  36,  255, 179, 192, 117, 255, 102, 134, 84,  255, 76,  98,  67,  255, 146, 149, 86,  255, 241, 243, 144, 255, 222,
    228, 134, 255, 221, 227, 137, 255, 230, 235, 142, 255, 207, 216, 122, 255, 81,  91,  45,  255, 144, 150, 84,  255, 213, 226, 141, 255, 212, 226,
    152, 255, 201, 199, 111, 255, 231, 223, 143, 255, 206, 215, 116, 255, 240, 238, 150, 255, 255, 255, 184, 255, 201, 222, 149, 255, 173, 209, 131,
    255, 190, 219, 140, 255, 214, 229, 137, 255, 151, 166, 97,  255, 114, 132, 84,  255, 157, 177, 125, 255, 179, 194, 130, 255, 195, 203, 120, 255,
    188, 194, 103, 255, 171, 180, 91,  255, 140, 157, 65,  255, 91,  114, 41,  255, 72,  100, 39,  255, 44,  63,  29,  255, 52,  67,  28,  255, 199,
    208, 147, 255, 199, 219, 187, 255, 204, 219, 160, 255, 201, 211, 129, 255, 147, 152, 90,  255, 65,  80,  36,  255, 77,  109, 34,  255, 79,  113,
    47,  255, 63,  96,  43,  255, 57,  87,  37,  255, 55,  84,  31,  255, 48,  65,  25,  255, 183, 190, 140, 255, 205, 229, 191, 255, 167, 188, 145,
    255, 191, 204, 132, 255, 126, 146, 67,  255, 127, 147, 65,  255, 154, 173, 68,  255, 112, 142, 49,  255, 92,  129, 48,  255, 97,  130, 48,  255,
    86,  103, 52,  255, 86,  93,  49,  255, 108, 143, 75,  255, 89,  121, 76,  255, 151, 173, 103, 255, 183, 209, 158, 255, 170, 198, 146, 255, 174,
    199, 111, 255, 157, 185, 78,  255, 108, 136, 47,  255, 105, 135, 43,  255, 111, 146, 52,  255, 93,  125, 55,  255, 81,  114, 50,  255, 81,  118,
    44,  255, 108, 137, 42,  255, 101, 121, 55,  255, 113, 135, 80,  255, 95,  128, 81,  255, 72,  94,  42,  255, 60,  80,  33,  255, 91,  108, 47,
    255, 107, 121, 53,  255, 146, 162, 77,  255, 203, 216, 102, 255, 194, 208, 84,  255, 195, 210, 99,  255, 188, 201, 91,  255, 204, 215, 92,  255,
    219, 223, 91,  255, 229, 231, 116, 255, 246, 243, 141, 255, 176, 176, 100, 255, 47,  68,  28,  255, 51,  80,  31,  255, 36,  52,  23,  255, 39,
    52,  31,  255, 40,  63,  31,  255, 40,  63,  31,  255, 47,  69,  31,  255, 58,  92,  37,  255, 44,  73,  32,  255, 94,  117, 47,  255, 162, 178,
    76,  255, 181, 193, 98,  255, 189, 198, 105, 255, 185, 194, 106, 255, 180, 188, 100, 255, 99,  109, 52,  255, 49,  76,  26,  255, 92,  124, 46,
    255, 115, 143, 84,  255, 96,  130, 80,  255, 99,  132, 71,  255, 91,  113, 45,  255, 45,  60,  31,  255, 65,  82,  38,  255, 101, 114, 62,  255,
    154, 167, 99,  255, 182, 196, 123, 255, 186, 202, 129, 255, 189, 207, 137, 255, 189, 202, 130, 255, 186, 191, 105, 255, 159, 168, 62,  255, 149,
    167, 75,  255, 153, 171, 93,  255, 172, 189, 87,  255, 140, 155, 62,  255, 157, 175, 81,  255, 163, 183, 83,  255, 155, 178, 76,  255, 156, 177,
    80,  255, 151, 175, 77,  255, 174, 201, 108, 255, 183, 207, 115, 255, 137, 166, 68,  255, 100, 133, 43,  255, 72,  99,  29,  255, 55,  78,  25,
    255, 116, 153, 47,  255, 146, 176, 62,  255, 145, 173, 62,  255, 148, 176, 65,  255, 155, 180, 73,  255, 157, 183, 74,  255, 163, 187, 86,  255,
    171, 193, 97,  255, 139, 153, 77,  255, 93,  119, 52,  255, 158, 183, 87,  255, 135, 163, 69,  255, 84,  123, 47,  255, 151, 180, 83,  255, 184,
    205, 100, 255, 185, 206, 103, 255, 179, 203, 97,  255, 134, 161, 76,  255, 166, 189, 95,  255, 193, 210, 100, 255, 175, 189, 86,  255, 146, 162,
    71,  255, 139, 158, 73,  255, 135, 161, 74,  255, 133, 154, 65,  255, 99,  126, 43,  255, 82,  116, 39,  255, 69,  107, 37,  255, 103, 128, 53,
    255, 155, 174, 79,  255, 191, 202, 91,  255, 241, 233, 107, 255, 239, 233, 110, 255, 234, 232, 108, 255, 224, 224, 80,  255, 224, 227, 100, 255,
    219, 226, 148, 255, 204, 219, 155, 255, 189, 208, 146, 255, 182, 205, 145, 255, 180, 205, 144, 255, 175, 187, 113, 255, 114, 133, 65,  255, 129,
    150, 73,  255, 128, 138, 56,  255, 138, 152, 65,  255, 200, 214, 138, 255, 176, 203, 152, 255, 177, 205, 148, 255, 189, 213, 145, 255, 197, 218,
    134, 255, 215, 223, 122, 255, 200, 195, 84,  255, 121, 131, 47,  255, 71,  96,  28,  255, 135, 167, 91,  255, 162, 193, 98,  255, 132, 164, 74,
    255, 155, 182, 92,  255, 167, 195, 93,  255, 183, 199, 106, 255, 175, 192, 95,  255, 163, 192, 81,  255, 163, 188, 87,  255, 144, 165, 80,  255,
    125, 142, 71,  255, 148, 160, 81,  255, 163, 181, 87,  255, 158, 187, 87,  255, 148, 182, 89,  255, 144, 181, 91,  255, 154, 186, 110, 255, 148,
    175, 107, 255, 110, 145, 78,  255, 164, 188, 101, 255, 183, 199, 120, 255, 77,  102, 69,  255, 124, 143, 92,  255, 148, 172, 92,  255, 58,  82,
    42,  255, 36,  53,  32,  255, 76,  97,  40,  255, 127, 150, 63,  255, 101, 132, 65,  255, 90,  116, 48,  255, 100, 126, 50,  255, 120, 145, 62,
    255, 128, 149, 60,  255, 116, 137, 60,  255, 130, 151, 67,  255, 135, 160, 69,  255, 105, 130, 53,  255, 78,  102, 34,  255, 116, 129, 74,  255,
    62,  73,  52,  255, 26,  42,  33,  255, 29,  46,  36,  255, 33,  43,  33,  255, 76,  99,  55,  255, 75,  103, 60,  255, 63,  94,  53,  255, 55,
    80,  43,  255, 161, 183, 63,  255, 127, 166, 60,  255, 107, 147, 62,  255, 114, 152, 65,  255, 104, 145, 58,  255, 123, 160, 74,  255, 183, 203,
    92,  255, 170, 192, 77,  255, 58,  92,  46,  255, 39,  68,  39,  255, 36,  60,  33,  255, 55,  81,  41,  255, 60,  87,  48,  255, 55,  83,  46,
    255, 115, 141, 65,  255, 148, 170, 73,  255, 42,  55,  29,  255, 55,  62,  36,  255, 187, 197, 113, 255, 65,  89,  52,  255, 39,  62,  36,  255,
    52,  69,  39,  255, 185, 185, 102, 255, 239, 241, 138, 255, 231, 232, 134, 255, 228, 229, 120, 255, 231, 233, 118, 255, 223, 227, 120, 255, 182,
    209, 125, 255, 171, 203, 156, 255, 182, 212, 172, 255, 159, 169, 130, 255, 184, 169, 144, 255, 233, 231, 160, 255, 217, 219, 142, 255, 239, 241,
    163, 255, 167, 194, 106, 255, 170, 192, 113, 255, 202, 214, 123, 255, 185, 199, 101, 255, 116, 145, 71,  255, 122, 147, 84,  255, 179, 199, 145,
    255, 152, 183, 148, 255, 153, 183, 148, 255, 179, 197, 140, 255, 205, 213, 131, 255, 217, 220, 117, 255, 164, 172, 79,  255, 104, 121, 49,  255,
    55,  74,  31,  255, 90,  113, 48,  255, 185, 203, 133, 255, 205, 219, 142, 255, 211, 222, 128, 255, 158, 170, 107, 255, 28,  42,  15,  255, 25,
    42,  19,  255, 41,  56,  28,  255, 63,  90,  34,  255, 69,  106, 34,  255, 55,  87,  31,  255, 47,  71,  31,  255, 36,  58,  21,  255, 122, 131,
    85,  255, 206, 226, 186, 255, 165, 182, 129, 255, 181, 197, 111, 255, 147, 174, 90,  255, 171, 193, 98,  255, 220, 226, 117, 255, 153, 166, 87,
    255, 82,  101, 52,  255, 45,  62,  28,  255, 83,  107, 47,  255, 86,  105, 45,  255, 113, 142, 76,  255, 101, 135, 86,  255, 139, 166, 87,  255,
    182, 207, 144, 255, 163, 195, 134, 255, 127, 160, 73,  255, 72,  101, 29,  255, 86,  115, 36,  255, 142, 162, 60,  255, 139, 168, 68,  255, 114,
    148, 62,  255, 122, 151, 56,  255, 130, 156, 53,  255, 151, 171, 60,  255, 140, 157, 62,  255, 78,  110, 74,  255, 114, 138, 65,  255, 52,  74,
    28,  255, 38,  65,  25,  255, 36,  62,  21,  255, 28,  48,  19,  255, 90,  108, 50,  255, 181, 196, 102, 255, 168, 186, 80,  255, 175, 192, 87,
    255, 178, 186, 109, 255, 199, 206, 109, 255, 229, 231, 108, 255, 234, 234, 119, 255, 239, 238, 137, 255, 228, 225, 128, 255, 67,  81,  32,  255,
    46,  73,  29,  255, 44,  60,  26,  255, 33,  49,  26,  255, 40,  65,  33,  255, 42,  65,  31,  255, 53,  82,  32,  255, 75,  113, 47,  255, 68,
    101, 47,  255, 53,  84,  43,  255, 65,  98,  38,  255, 62,  81,  31,  255, 60,  74,  36,  255, 65,  84,  38,  255, 63,  90,  36,  255, 55,  78,
    33,  255, 60,  79,  34,  255, 74,  111, 33,  255, 104, 133, 60,  255, 101, 133, 72,  255, 94,  127, 56,  255, 67,  92,  36,  255, 93,  115, 58,
    255, 169, 181, 113, 255, 208, 219, 140, 255, 207, 220, 140, 255, 199, 216, 143, 255, 192, 209, 139, 255, 185, 197, 117, 255, 178, 186, 99,  255,
    153, 164, 82,  255, 189, 209, 84,  255, 202, 221, 95,  255, 199, 216, 101, 255, 200, 215, 104, 255, 222, 230, 126, 255, 198, 208, 105, 255, 179,
    196, 90,  255, 168, 187, 81,  255, 167, 186, 75,  255, 168, 185, 75,  255, 159, 182, 76,  255, 137, 166, 62,  255, 137, 167, 53,  255, 101, 124,
    34,  255, 50,  65,  26,  255, 69,  99,  37,  255, 121, 153, 47,  255, 150, 178, 56,  255, 147, 176, 58,  255, 155, 182, 67,  255, 164, 186, 75,
    255, 172, 194, 87,  255, 172, 191, 94,  255, 123, 142, 58,  255, 45,  65,  19,  255, 55,  82,  31,  255, 122, 146, 68,  255, 147, 175, 74,  255,
    93,  125, 48,  255, 111, 141, 65,  255, 160, 179, 92,  255, 179, 195, 101, 255, 163, 183, 89,  255, 151, 173, 81,  255, 180, 197, 93,  255, 147,
    165, 69,  255, 171, 174, 82,  255, 170, 177, 90,  255, 114, 143, 63,  255, 110, 144, 60,  255, 148, 167, 80,  255, 121, 145, 47,  255, 110, 138,
    37,  255, 107, 136, 42,  255, 107, 130, 62,  255, 95,  120, 55,  255, 154, 168, 85,  255, 243, 229, 117, 255, 206, 199, 87,  255, 195, 193, 79,
    255, 208, 209, 76,  255, 203, 203, 69,  255, 130, 139, 44,  255, 158, 177, 111, 255, 209, 226, 164, 255, 194, 215, 151, 255, 179, 205, 143, 255,
    171, 198, 142, 255, 125, 150, 95,  255, 102, 134, 75,  255, 134, 148, 67,  255, 143, 161, 84,  255, 167, 197, 136, 255, 177, 204, 124, 255, 193,
    209, 116, 255, 184, 195, 101, 255, 145, 155, 73,  255, 105, 122, 47,  255, 84,  105, 29,  255, 48,  76,  17,  255, 48,  83,  21,  255, 101, 132,
    52,  255, 149, 182, 68,  255, 144, 183, 60,  255, 164, 185, 78,  255, 157, 177, 93,  255, 113, 145, 84,  255, 121, 152, 74,  255, 160, 183, 82,
    255, 177, 195, 95,  255, 103, 128, 79,  255, 83,  115, 79,  255, 89,  119, 82,  255, 107, 131, 80,  255, 153, 167, 84,  255, 132, 147, 62,  255,
    160, 169, 68,  255, 148, 171, 86,  255, 120, 148, 84,  255, 104, 138, 79,  255, 169, 188, 91,  255, 164, 176, 96,  255, 141, 160, 120, 255, 136,
    156, 110, 255, 60,  90,  55,  255, 47,  74,  37,  255, 62,  91,  43,  255, 82,  112, 42,  255, 117, 137, 50,  255, 114, 136, 50,  255, 116, 140,
    55,  255, 124, 146, 58,  255, 125, 142, 67,  255, 69,  100, 38,  255, 58,  87,  36,  255, 55,  86,  41,  255, 65,  100, 43,  255, 21,  34,  21,
    255, 32,  47,  21,  255, 39,  55,  23,  255, 78,  87,  50,  255, 53,  73,  48,  255, 29,  49,  36,  255, 36,  48,  34,  255, 72,  97,  58,  255,
    69,  100, 65,  255, 57,  87,  50,  255, 53,  82,  36,  255, 100, 119, 42,  255, 183, 197, 68,  255, 132, 171, 67,  255, 115, 159, 62,  255, 125,
    166, 72,  255, 130, 168, 79,  255, 173, 196, 95,  255, 165, 185, 78,  255, 55,  89,  56,  255, 60,  87,  55,  255, 142, 156, 107, 255, 107, 129,
    87,  255, 60,  96,  48,  255, 57,  94,  36,  255, 136, 159, 68,  255, 163, 199, 71,  255, 128, 149, 63,  255, 60,  89,  37,  255, 144, 161, 84,
    255, 65,  91,  52,  255, 53,  77,  49,  255, 60,  85,  63,  255, 68,  84,  40,  255, 236, 226, 136, 255, 255, 255, 161, 255, 245, 241, 131, 255,
    238, 233, 111, 255, 229, 234, 127, 255, 174, 206, 136, 255, 177, 207, 160, 255, 188, 211, 174, 255, 182, 202, 147, 255, 171, 182, 125, 255, 182,
    206, 144, 255, 169, 191, 125, 255, 169, 187, 121, 255, 194, 208, 120, 255, 150, 152, 91,  255, 67,  87,  31,  255, 138, 156, 74,  255, 170, 187,
    87,  255, 160, 178, 85,  255, 210, 216, 137, 255, 174, 196, 142, 255, 148, 180, 149, 255, 168, 188, 149, 255, 207, 217, 123, 255, 181, 204, 113,
    255, 181, 205, 103, 255, 179, 202, 101, 255, 166, 188, 97,  255, 160, 180, 84,  255, 156, 175, 90,  255, 148, 169, 83,  255, 165, 182, 107, 255,
    196, 218, 158, 255, 167, 184, 117, 255, 58,  75,  31,  255, 23,  37,  25,  255, 33,  51,  26,  255, 45,  67,  26,  255, 47,  68,  32,  255, 40,
    62,  31,  255, 39,  62,  33,  255, 72,  87,  55,  255, 172, 191, 137, 255, 137, 160, 92,  255, 150, 178, 96,  255, 185, 209, 135, 255, 195, 217,
    151, 255, 204, 223, 158, 255, 215, 228, 167, 255, 227, 235, 174, 255, 174, 181, 125, 255, 73,  87,  38,  255, 65,  81,  40,  255, 96,  115, 58,
    255, 116, 148, 89,  255, 127, 156, 97,  255, 145, 169, 96,  255, 145, 176, 92,  255, 77,  107, 49,  255, 127, 154, 76,  255, 185, 211, 98,  255,
    211, 224, 106, 255, 176, 190, 87,  255, 147, 175, 69,  255, 143, 171, 62,  255, 153, 174, 68,  255, 159, 174, 68,  255, 116, 138, 63,  255, 91,
    123, 72,  255, 63,  92,  31,  255, 43,  75,  25,  255, 46,  75,  29,  255, 63,  92,  37,  255, 60,  87,  33,  255, 109, 127, 60,  255, 183, 196,
    104, 255, 164, 180, 86,  255, 158, 175, 73,  255, 152, 155, 102, 255, 162, 170, 109, 255, 143, 158, 68,  255, 215, 216, 113, 255, 251, 246, 148,
    255, 215, 212, 110, 255, 162, 175, 73,  255, 189, 198, 100, 255, 192, 195, 103, 255, 137, 143, 71,  255, 62,  79,  36,  255, 55,  77,  32,  255,
    39,  49,  21,  255, 80,  105, 48,  255, 77,  109, 53,  255, 69,  98,  58,  255, 89,  121, 62,  255, 67,  90,  38,  255, 56,  82,  36,  255, 103,
    136, 53,  255, 112, 141, 53,  255, 92,  121, 49,  255, 62,  84,  33,  255, 63,  86,  33,  255, 63,  90,  32,  255, 82,  119, 50,  255, 69,  101,
    43,  255, 96,  118, 60,  255, 182, 199, 84,  255, 190, 210, 81,  255, 183, 200, 93,  255, 186, 204, 116, 255, 185, 205, 118, 255, 175, 191, 80,
    255, 173, 191, 87,  255, 175, 199, 99,  255, 166, 194, 94,  255, 169, 194, 98,  255, 182, 203, 100, 255, 188, 207, 102, 255, 188, 205, 108, 255,
    152, 167, 87,  255, 123, 137, 58,  255, 165, 177, 75,  255, 184, 196, 83,  255, 185, 197, 80,  255, 181, 194, 73,  255, 166, 183, 63,  255, 150,
    173, 55,  255, 101, 122, 36,  255, 41,  62,  21,  255, 38,  55,  23,  255, 52,  68,  32,  255, 69,  95,  38,  255, 134, 160, 65,  255, 168, 190,
    81,  255, 173, 193, 87,  255, 168, 186, 87,  255, 137, 158, 68,  255, 91,  118, 39,  255, 58,  95,  25,  255, 51,  91,  25,  255, 52,  86,  28,
    255, 62,  81,  36,  255, 105, 132, 53,  255, 118, 150, 55,  255, 79,  115, 45,  255, 81,  111, 48,  255, 82,  103, 40,  255, 71,  92,  31,  255,
    81,  107, 37,  255, 84,  110, 32,  255, 85,  113, 36,  255, 138, 155, 69,  255, 135, 156, 74,  255, 95,  134, 50,  255, 105, 139, 56,  255, 130,
    148, 69,  255, 131, 149, 56,  255, 122, 146, 49,  255, 129, 149, 63,  255, 140, 156, 81,  255, 134, 149, 73,  255, 98,  114, 47,  255, 73,  91,
    29,  255, 58,  68,  26,  255, 52,  67,  25,  255, 79,  107, 32,  255, 126, 146, 48,  255, 94,  111, 34,  255, 93,  116, 44,  255, 137, 154, 87,
    255, 216, 226, 159, 255, 214, 227, 166, 255, 213, 227, 164, 255, 197, 210, 129, 255, 157, 176, 92,  255, 143, 159, 82,  255, 177, 193, 86,  255,
    186, 201, 78,  255, 193, 198, 71,  255, 155, 166, 52,  255, 91,  111, 34,  255, 51,  80,  32,  255, 65,  97,  33,  255, 63,  89,  25,  255, 63,
    96,  31,  255, 108, 137, 52,  255, 117, 143, 53,  255, 125, 154, 68,  255, 166, 191, 91,  255, 166, 186, 87,  255, 145, 180, 102, 255, 129, 169,
    105, 255, 129, 168, 102, 255, 140, 173, 101, 255, 173, 192, 109, 255, 101, 130, 90,  255, 90,  120, 84,  255, 103, 132, 91,  255, 97,  128, 92,
    255, 98,  126, 84,  255, 111, 138, 83,  255, 85,  104, 45,  255, 132, 151, 58,  255, 113, 152, 75,  255, 108, 146, 81,  255, 146, 164, 73,  255,
    65,  86,  26,  255, 103, 122, 55,  255, 132, 154, 82,  255, 80,  106, 55,  255, 72,  102, 44,  255, 83,  109, 47,  255, 84,  108, 45,  255, 73,
    107, 34,  255, 58,  84,  28,  255, 49,  71,  26,  255, 47,  69,  26,  255, 36,  55,  21,  255, 43,  69,  23,  255, 48,  73,  34,  255, 80,  106,
    50,  255, 99,  125, 58,  255, 104, 124, 65,  255, 113, 142, 75,  255, 94,  126, 72,  255, 97,  126, 67,  255, 109, 132, 71,  255, 58,  82,  55,
    255, 44,  69,  43,  255, 67,  94,  50,  255, 58,  92,  50,  255, 63,  89,  44,  255, 116, 142, 60,  255, 86,  123, 33,  255, 107, 133, 36,  255,
    163, 183, 65,  255, 157, 185, 78,  255, 149, 180, 84,  255, 145, 180, 95,  255, 172, 194, 90,  255, 126, 150, 58,  255, 58,  95,  50,  255, 138,
    150, 90,  255, 211, 228, 175, 255, 198, 213, 160, 255, 102, 134, 65,  255, 43,  74,  23,  255, 132, 142, 65,  255, 151, 191, 65,  255, 171, 194,
    74,  255, 121, 146, 58,  255, 131, 150, 48,  255, 109, 132, 52,  255, 74,  98,  75,  255, 60,  85,  65,  255, 134, 138, 75,  255, 192, 196, 115,
    255, 153, 156, 86,  255, 226, 225, 116, 255, 233, 233, 119, 255, 219, 232, 150, 255, 203, 222, 134, 255, 194, 206, 121, 255, 185, 197, 109, 255,
    187, 203, 117, 255, 182, 200, 131, 255, 188, 207, 144, 255, 174, 197, 132, 255, 144, 160, 97,  255, 202, 207, 134, 255, 238, 241, 168, 255, 115,
    131, 75,  255, 51,  84,  33,  255, 96,  118, 49,  255, 130, 146, 62,  255, 185, 190, 104, 255, 218, 222, 146, 255, 170, 193, 140, 255, 166, 189,
    147, 255, 204, 216, 129, 255, 186, 205, 112, 255, 178, 200, 113, 255, 182, 201, 108, 255, 189, 200, 98,  255, 135, 153, 68,  255, 101, 129, 76,
    255, 91,  121, 80,  255, 153, 169, 110, 255, 186, 210, 150, 255, 198, 221, 167, 255, 195, 206, 124, 255, 69,  86,  36,  255, 36,  52,  25,  255,
    34,  49,  26,  255, 37,  51,  29,  255, 33,  49,  26,  255, 69,  90,  47,  255, 150, 164, 97,  255, 145, 163, 90,  255, 146, 165, 89,  255, 190,
    209, 127, 255, 200, 218, 133, 255, 209, 224, 141, 255, 209, 227, 154, 255, 202, 225, 165, 255, 204, 227, 173, 255, 221, 239, 187, 255, 205, 214,
    155, 255, 129, 149, 76,  255, 94,  115, 52,  255, 107, 132, 68,  255, 110, 141, 82,  255, 92,  119, 60,  255, 126, 155, 72,  255, 152, 181, 89,
    255, 187, 211, 109, 255, 162, 187, 93,  255, 105, 129, 62,  255, 69,  87,  41,  255, 95,  108, 52,  255, 97,  120, 52,  255, 96,  120, 52,  255,
    90,  116, 52,  255, 92,  122, 58,  255, 96,  123, 52,  255, 142, 153, 77,  255, 139, 150, 82,  255, 98,  120, 53,  255, 79,  109, 41,  255, 81,
    108, 42,  255, 71,  84,  36,  255, 177, 192, 95,  255, 170, 185, 92,  255, 160, 176, 73,  255, 136, 147, 69,  255, 157, 175, 86,  255, 103, 134,
    48,  255, 82,  111, 34,  255, 180, 187, 105, 255, 230, 231, 118, 255, 216, 224, 102, 255, 221, 228, 110, 255, 224, 230, 116, 255, 229, 235, 114,
    255, 199, 202, 102, 255, 127, 145, 71,  255, 96,  116, 62,  255, 108, 127, 65,  255, 85,  110, 58,  255, 71,  100, 62,  255, 100, 128, 74,  255,
    102, 124, 55,  255, 94,  122, 44,  255, 111, 145, 60,  255, 118, 149, 58,  255, 134, 159, 68,  255, 112, 139, 53,  255, 89,  111, 43,  255, 40,
    53,  26,  255, 78,  106, 56,  255, 89,  112, 50,  255, 168, 186, 104, 255, 209, 218, 97,  255, 194, 210, 67,  255, 178, 200, 60,  255, 180, 201,
    73,  255, 175, 198, 60,  255, 187, 207, 63,  255, 172, 198, 81,  255, 170, 199, 103, 255, 175, 203, 107, 255, 171, 196, 97,  255, 168, 193, 98,
    255, 171, 195, 108, 255, 176, 201, 117, 255, 163, 185, 105, 255, 98,  116, 56,  255, 58,  80,  31,  255, 82,  100, 42,  255, 96,  115, 41,  255,
    108, 132, 46,  255, 101, 126, 41,  255, 79,  108, 36,  255, 49,  73,  29,  255, 48,  74,  32,  255, 48,  76,  25,  255, 41,  58,  23,  255, 55,
    76,  32,  255, 47,  68,  34,  255, 84,  105, 47,  255, 94,  121, 47,  255, 81,  111, 37,  255, 68,  100, 28,  255, 69,  103, 34,  255, 62,  98,
    34,  255, 51,  87,  25,  255, 48,  83,  26,  255, 60,  84,  38,  255, 58,  80,  32,  255, 71,  101, 36,  255, 81,  109, 37,  255, 68,  101, 36,
    255, 60,  86,  26,  255, 55,  81,  25,  255, 53,  78,  25,  255, 39,  60,  17,  255, 46,  73,  21,  255, 86,  123, 47,  255, 94,  133, 52,  255,
    97,  137, 52,  255, 105, 142, 53,  255, 97,  122, 47,  255, 116, 134, 50,  255, 144, 163, 71,  255, 171, 180, 86,  255, 175, 182, 86,  255, 181,
    182, 86,  255, 148, 151, 58,  255, 80,  97,  28,  255, 60,  73,  29,  255, 63,  84,  33,  255, 74,  101, 36,  255, 97,  119, 41,  255, 92,  117,
    40,  255, 99,  120, 45,  255, 53,  75,  17,  255, 158, 176, 104, 255, 193, 206, 135, 255, 176, 191, 127, 255, 153, 175, 119, 255, 156, 180, 115,
    255, 142, 157, 86,  255, 173, 189, 97,  255, 199, 202, 67,  255, 179, 188, 56,  255, 171, 185, 55,  255, 158, 175, 52,  255, 112, 131, 47,  255,
    84,  103, 33,  255, 55,  84,  26,  255, 110, 141, 58,  255, 134, 157, 65,  255, 126, 154, 63,  255, 129, 156, 71,  255, 146, 169, 77,  255, 142,
    160, 73,  255, 178, 196, 101, 255, 185, 213, 126, 255, 170, 206, 131, 255, 162, 196, 130, 255, 177, 201, 131, 255, 124, 150, 100, 255, 93,  125,
    89,  255, 100, 131, 99,  255, 100, 132, 101, 255, 99,  133, 93,  255, 112, 142, 94,  255, 114, 144, 82,  255, 73,  97,  44,  255, 124, 147, 65,
    255, 149, 170, 77,  255, 127, 144, 58,  255, 107, 129, 47,  255, 178, 199, 63,  255, 168, 188, 69,  255, 164, 181, 91,  255, 170, 190, 95,  255,
    184, 204, 107, 255, 189, 204, 112, 255, 179, 196, 105, 255, 154, 172, 91,  255, 104, 123, 65,  255, 58,  81,  40,  255, 21,  39,  15,  255, 56,
    75,  29,  255, 112, 135, 63,  255, 131, 160, 86,  255, 119, 150, 90,  255, 113, 149, 87,  255, 103, 141, 86,  255, 87,  125, 80,  255, 89,  124,
    76,  255, 117, 147, 80,  255, 102, 130, 69,  255, 75,  99,  56,  255, 80,  113, 52,  255, 52,  83,  36,  255, 65,  89,  52,  255, 99,  125, 65,
    255, 112, 150, 52,  255, 94,  138, 39,  255, 89,  126, 37,  255, 117, 140, 56,  255, 161, 179, 90,  255, 179, 193, 111, 255, 162, 184, 105, 255,
    87,  117, 48,  255, 95,  111, 47,  255, 214, 219, 144, 255, 193, 215, 166, 255, 201, 223, 181, 255, 130, 151, 103, 255, 23,  40,  12,  255, 108,
    118, 53,  255, 160, 200, 73,  255, 171, 194, 81,  255, 169, 186, 75,  255, 160, 175, 56,  255, 169, 178, 55,  255, 93,  116, 60,  255, 73,  100,
    55,  255, 89,  116, 43,  255, 52,  81,  23,  255, 21,  40,  17,  255, 79,  91,  36,  255, 187, 197, 75,  255, 212, 222, 102, 255, 201, 214, 105,
    255, 157, 174, 71,  255, 154, 176, 75,  255, 164, 181, 87,  255, 148, 179, 109, 255, 153, 183, 125, 255, 167, 193, 143, 255, 151, 172, 121, 255,
    149, 163, 102, 255, 201, 221, 162, 255, 191, 198, 135, 255, 55,  74,  37,  255, 47,  71,  29,  255, 43,  67,  26,  255, 56,  68,  33,  255, 190,
    191, 123, 255, 174, 198, 142, 255, 151, 179, 139, 255, 173, 194, 150, 255, 170, 192, 146, 255, 167, 189, 149, 255, 191, 201, 122, 255, 131, 150,
    75,  255, 163, 180, 132, 255, 146, 169, 127, 255, 142, 166, 121, 255, 174, 188, 121, 255, 195, 216, 148, 255, 165, 198, 157, 255, 201, 222, 172,
    255, 170, 184, 107, 255, 36,  47,  21,  255, 26,  36,  23,  255, 28,  37,  26,  255, 26,  31,  21,  255, 136, 147, 84,  255, 159, 183, 118, 255,
    146, 160, 100, 255, 121, 149, 93,  255, 139, 161, 96,  255, 180, 195, 105, 255, 179, 194, 106, 255, 176, 188, 110, 255, 190, 201, 124, 255, 201,
    216, 141, 255, 190, 209, 141, 255, 196, 214, 154, 255, 145, 172, 107, 255, 128, 160, 89,  255, 104, 126, 60,  255, 83,  107, 49,  255, 88,  114,
    55,  255, 118, 139, 76,  255, 94,  117, 72,  255, 91,  114, 67,  255, 66,  95,  49,  255, 78,  110, 52,  255, 63,  89,  40,  255, 38,  48,  31,
    255, 52,  74,  36,  255, 53,  81,  36,  255, 62,  87,  36,  255, 47,  62,  28,  255, 98,  109, 47,  255, 191, 192, 105, 255, 182, 191, 113, 255,
    193, 198, 110, 255, 159, 171, 85,  255, 126, 142, 73,  255, 52,  62,  32,  255, 140, 158, 74,  255, 178, 193, 95,  255, 153, 171, 69,  255, 148,
    160, 71,  255, 153, 172, 80,  255, 137, 161, 72,  255, 91,  124, 40,  255, 172, 194, 65,  255, 205, 219, 84,  255, 217, 225, 95,  255, 224, 229,
    113, 255, 223, 229, 115, 255, 219, 225, 101, 255, 232, 235, 133, 255, 222, 224, 133, 255, 132, 155, 94,  255, 111, 143, 90,  255, 127, 152, 84,
    255, 77,  103, 58,  255, 94,  122, 62,  255, 119, 144, 62,  255, 103, 137, 48,  255, 99,  137, 48,  255, 113, 146, 56,  255, 141, 166, 99,  255,
    111, 139, 76,  255, 65,  87,  29,  255, 67,  81,  36,  255, 92,  112, 62,  255, 136, 157, 78,  255, 198, 212, 120, 255, 197, 209, 120, 255, 207,
    212, 86,  255, 200, 215, 72,  255, 195, 216, 81,  255, 194, 209, 77,  255, 131, 153, 56,  255, 137, 172, 75,  255, 178, 207, 118, 255, 186, 213,
    124, 255, 181, 206, 108, 255, 168, 195, 92,  255, 161, 190, 87,  255, 164, 194, 97,  255, 177, 204, 112, 255, 191, 211, 120, 255, 143, 158, 82,
    255, 71,  96,  31,  255, 65,  97,  28,  255, 55,  90,  25,  255, 49,  89,  21,  255, 65,  100, 29,  255, 78,  111, 38,  255, 74,  108, 36,  255,
    67,  104, 32,  255, 55,  87,  29,  255, 52,  75,  31,  255, 47,  65,  29,  255, 42,  68,  28,  255, 55,  92,  26,  255, 68,  105, 29,  255, 75,
    110, 34,  255, 72,  107, 33,  255, 65,  103, 31,  255, 49,  81,  25,  255, 43,  76,  25,  255, 52,  82,  32,  255, 62,  77,  39,  255, 63,  81,
    47,  255, 85,  110, 36,  255, 77,  107, 34,  255, 58,  84,  29,  255, 67,  96,  34,  255, 77,  106, 32,  255, 83,  105, 28,  255, 62,  83,  21,
    255, 83,  118, 46,  255, 103, 140, 60,  255, 107, 145, 62,  255, 101, 134, 50,  255, 110, 137, 53,  255, 110, 132, 48,  255, 97,  122, 42,  255,
    183, 190, 92,  255, 173, 177, 80,  255, 171, 178, 76,  255, 182, 187, 81,  255, 155, 155, 62,  255, 63,  72,  29,  255, 93,  115, 42,  255, 139,
    158, 47,  255, 124, 144, 43,  255, 140, 156, 52,  255, 119, 128, 42,  255, 53,  69,  23,  255, 94,  117, 58,  255, 202, 212, 131, 255, 155, 181,
    126, 255, 152, 180, 134, 255, 150, 177, 129, 255, 137, 157, 93,  255, 159, 181, 113, 255, 199, 208, 93,  255, 181, 192, 68,  255, 178, 189, 60,
    255, 182, 194, 60,  255, 166, 171, 49,  255, 52,  71,  17,  255, 86,  119, 52,  255, 137, 162, 73,  255, 133, 158, 72,  255, 137, 158, 76,  255,
    144, 159, 82,  255, 138, 157, 68,  255, 136, 162, 68,  255, 163, 178, 74,  255, 164, 172, 80,  255, 187, 190, 108, 255, 173, 185, 111, 255, 155,
    170, 112, 255, 122, 148, 99,  255, 103, 135, 92,  255, 106, 137, 99,  255, 107, 141, 101, 255, 110, 146, 104, 255, 120, 152, 102, 255, 173, 193,
    106, 255, 122, 157, 86,  255, 144, 170, 97,  255, 116, 140, 62,  255, 131, 149, 56,  255, 192, 210, 87,  255, 193, 212, 107, 255, 193, 211, 115,
    255, 194, 212, 116, 255, 193, 211, 113, 255, 192, 209, 109, 255, 195, 210, 113, 255, 198, 212, 119, 255, 206, 219, 123, 255, 221, 231, 138, 255,
    216, 225, 140, 255, 147, 158, 93,  255, 126, 153, 86,  255, 123, 158, 95,  255, 111, 145, 92,  255, 100, 136, 92,  255, 98,  135, 89,  255, 95,
    133, 89,  255, 90,  126, 84,  255, 83,  120, 77,  255, 84,  120, 79,  255, 109, 142, 78,  255, 108, 139, 68,  255, 65,  92,  46,  255, 60,  87,
    42,  255, 68,  98,  58,  255, 69,  102, 56,  255, 73,  105, 62,  255, 100, 124, 65,  255, 122, 149, 60,  255, 106, 137, 58,  255, 105, 129, 52,
    255, 132, 155, 78,  255, 120, 145, 99,  255, 117, 148, 95,  255, 134, 153, 65,  255, 217, 227, 162, 255, 192, 215, 162, 255, 189, 213, 171, 255,
    182, 206, 170, 255, 171, 184, 144, 255, 124, 134, 75,  255, 169, 196, 81,  255, 191, 209, 101, 255, 188, 199, 98,  255, 195, 198, 92,  255, 214,
    216, 117, 255, 180, 193, 109, 255, 170, 186, 119, 255, 144, 162, 99,  255, 97,  119, 67,  255, 77,  107, 48,  255, 50,  68,  31,  255, 146, 161,
    74,  255, 175, 194, 74,  255, 182, 200, 73,  255, 158, 179, 65,  255, 140, 172, 73,  255, 115, 136, 60,  255, 159, 168, 93,  255, 164, 189, 120,
    255, 157, 185, 127, 255, 168, 195, 143, 255, 140, 160, 108, 255, 178, 193, 134, 255, 211, 223, 162, 255, 71,  76,  48,  255, 36,  49,  26,  255,
    58,  82,  37,  255, 36,  56,  26,  255, 73,  76,  42,  255, 203, 204, 125, 255, 188, 206, 138, 255, 148, 178, 135, 255, 147, 175, 138, 255, 143,
    172, 142, 255, 181, 198, 134, 255, 135, 156, 71,  255, 141, 159, 83,  255, 204, 224, 166, 255, 199, 226, 198, 255, 189, 207, 145, 255, 198, 215,
    139, 255, 177, 206, 132, 255, 186, 210, 130, 255, 217, 228, 156, 255, 60,  67,  42,  255, 21,  31,  21,  255, 12,  21,  19,  255, 85,  89,  50,
    255, 182, 201, 128, 255, 142, 170, 123, 255, 127, 154, 92,  255, 118, 154, 111, 255, 133, 162, 108, 255, 133, 156, 71,  255, 153, 179, 82,  255,
    114, 144, 74,  255, 95,  121, 53,  255, 127, 151, 68,  255, 134, 157, 84,  255, 136, 161, 80,  255, 130, 155, 72,  255, 159, 176, 86,  255, 202,
    213, 122, 255, 168, 175, 105, 255, 100, 120, 60,  255, 63,  94,  55,  255, 65,  97,  68,  255, 60,  96,  63,  255, 86,  111, 71,  255, 151, 162,
    95,  255, 197, 203, 118, 255, 207, 211, 127, 255, 204, 211, 127, 255, 189, 198, 116, 255, 163, 176, 106, 255, 134, 144, 82,  255, 175, 179, 95,
    255, 174, 192, 117, 255, 178, 189, 102, 255, 213, 219, 121, 255, 224, 228, 133, 255, 223, 227, 138, 255, 204, 211, 128, 255, 179, 191, 108, 255,
    180, 195, 97,  255, 158, 179, 65,  255, 154, 173, 65,  255, 164, 183, 73,  255, 179, 196, 77,  255, 171, 188, 69,  255, 183, 200, 74,  255, 180,
    194, 80,  255, 179, 189, 87,  255, 197, 208, 100, 255, 192, 203, 107, 255, 201, 210, 117, 255, 217, 222, 123, 255, 226, 227, 146, 255, 157, 168,
    122, 255, 94,  129, 92,  255, 140, 168, 102, 255, 144, 163, 84,  255, 78,  102, 39,  255, 104, 132, 58,  255, 123, 154, 71,  255, 111, 144, 58,
    255, 110, 143, 52,  255, 136, 164, 104, 255, 103, 131, 72,  255, 92,  123, 39,  255, 100, 125, 49,  255, 76,  93,  36,  255, 172, 188, 94,  255,
    187, 201, 103, 255, 164, 177, 77,  255, 162, 178, 68,  255, 201, 212, 97,  255, 177, 192, 84,  255, 107, 130, 50,  255, 71,  105, 40,  255, 94,
    127, 55,  255, 135, 160, 79,  255, 159, 181, 101, 255, 180, 201, 113, 255, 183, 206, 107, 255, 175, 199, 91,  255, 171, 197, 84,  255, 173, 196,
    86,  255, 171, 193, 87,  255, 178, 194, 97,  255, 109, 134, 48,  255, 79,  111, 36,  255, 62,  100, 28,  255, 65,  105, 31,  255, 81,  114, 42,
    255, 90,  122, 47,  255, 87,  119, 44,  255, 80,  115, 42,  255, 72,  108, 36,  255, 57,  84,  29,  255, 47,  62,  26,  255, 47,  73,  25,  255,
    71,  106, 32,  255, 79,  115, 37,  255, 84,  119, 43,  255, 84,  123, 42,  255, 65,  91,  29,  255, 25,  34,  19,  255, 21,  32,  21,  255, 23,
    33,  19,  255, 45,  55,  36,  255, 69,  92,  38,  255, 147, 176, 62,  255, 135, 164, 48,  255, 97,  127, 52,  255, 108, 143, 56,  255, 148, 178,
    58,  255, 191, 204, 63,  255, 115, 124, 33,  255, 85,  112, 36,  255, 114, 144, 67,  255, 100, 131, 53,  255, 86,  118, 37,  255, 101, 126, 47,
    255, 95,  118, 39,  255, 68,  92,  26,  255, 150, 155, 67,  255, 171, 172, 62,  255, 166, 174, 69,  255, 172, 179, 77,  255, 175, 179, 75,  255,
    86,  84,  36,  255, 84,  96,  34,  255, 193, 203, 55,  255, 191, 194, 48,  255, 195, 196, 60,  255, 214, 206, 65,  255, 209, 197, 69,  255, 121,
    128, 39,  255, 170, 183, 102, 255, 202, 213, 145, 255, 162, 188, 144, 255, 160, 186, 143, 255, 144, 163, 105, 255, 156, 180, 122, 255, 205, 214,
    116, 255, 194, 199, 74,  255, 195, 200, 74,  255, 198, 201, 80,  255, 199, 195, 73,  255, 91,  104, 28,  255, 112, 143, 67,  255, 138, 161, 72,
    255, 135, 156, 72,  255, 140, 160, 74,  255, 148, 168, 76,  255, 156, 179, 68,  255, 159, 185, 67,  255, 151, 179, 67,  255, 135, 166, 71,  255,
    108, 139, 79,  255, 92,  118, 68,  255, 82,  112, 68,  255, 107, 138, 93,  255, 106, 139, 95,  255, 105, 142, 97,  255, 107, 142, 102, 255, 115,
    149, 107, 255, 138, 174, 112, 255, 153, 176, 111, 255, 160, 183, 107, 255, 152, 176, 94,  255, 53,  62,  36,  255, 129, 145, 68,  255, 197, 217,
    119, 255, 197, 215, 125, 255, 201, 215, 121, 255, 200, 215, 120, 255, 204, 215, 119, 255, 210, 218, 120, 255, 218, 225, 126, 255, 222, 227, 130,
    255, 214, 221, 126, 255, 183, 191, 106, 255, 163, 173, 87,  255, 184, 208, 118, 255, 132, 172, 105, 255, 118, 154, 101, 255, 117, 152, 102, 255,
    111, 148, 99,  255, 107, 146, 97,  255, 107, 144, 98,  255, 106, 140, 95,  255, 95,  134, 83,  255, 89,  128, 77,  255, 91,  126, 81,  255, 111,
    143, 87,  255, 87,  122, 62,  255, 61,  94,  43,  255, 65,  100, 55,  255, 74,  103, 63,  255, 72,  105, 68,  255, 68,  102, 69,  255, 71,  100,
    63,  255, 72,  103, 58,  255, 67,  97,  44,  255, 137, 157, 68,  255, 138, 170, 82,  255, 121, 151, 90,  255, 122, 144, 82,  255, 221, 223, 152,
    255, 208, 223, 165, 255, 208, 223, 156, 255, 204, 222, 169, 255, 207, 225, 178, 255, 193, 202, 151, 255, 156, 170, 84,  255, 156, 179, 76,  255,
    202, 211, 122, 255, 202, 221, 145, 255, 189, 219, 143, 255, 184, 215, 132, 255, 193, 220, 145, 255, 209, 229, 158, 255, 224, 235, 163, 255, 182,
    195, 121, 255, 114, 134, 58,  255, 155, 174, 79,  255, 150, 175, 80,  255, 150, 175, 76,  255, 149, 170, 62,  255, 154, 178, 65,  255, 151, 171,
    68,  255, 148, 154, 63,  255, 210, 218, 118, 255, 172, 196, 123, 255, 164, 191, 135, 255, 162, 187, 140, 255, 154, 171, 113, 255, 213, 225, 167,
    255, 81,  93,  55,  255, 25,  37,  19,  255, 34,  46,  26,  255, 41,  58,  29,  255, 26,  40,  21,  255, 62,  65,  33,  255, 170, 167, 89,  255,
    197, 208, 120, 255, 175, 196, 129, 255, 149, 176, 133, 255, 176, 194, 133, 255, 140, 158, 68,  255, 129, 148, 58,  255, 179, 190, 86,  255, 185,
    205, 126, 255, 178, 206, 159, 255, 180, 203, 116, 255, 156, 191, 71,  255, 170, 200, 107, 255, 202, 224, 167, 255, 118, 128, 86,  255, 21,  34,
    21,  255, 21,  32,  17,  255, 145, 152, 87,  255, 167, 193, 135, 255, 144, 172, 125, 255, 128, 156, 99,  255, 134, 168, 132, 255, 161, 186, 129,
    255, 76,  90,  42,  255, 71,  97,  36,  255, 144, 172, 91,  255, 115, 138, 77,  255, 97,  124, 53,  255, 56,  65,  31,  255, 53,  60,  29,  255,
    67,  84,  36,  255, 58,  72,  32,  255, 171, 185, 96,  255, 223, 235, 137, 255, 165, 177, 99,  255, 148, 164, 101, 255, 95,  118, 80,  255, 149,
    163, 106, 255, 221, 224, 131, 255, 235, 238, 137, 255, 220, 228, 138, 255, 206, 219, 141, 255, 190, 208, 136, 255, 185, 206, 127, 255, 167, 195,
    131, 255, 161, 192, 128, 255, 158, 186, 121, 255, 197, 202, 105, 255, 214, 219, 107, 255, 216, 221, 110, 255, 218, 224, 119, 255, 217, 222, 110,
    255, 215, 221, 109, 255, 212, 222, 115, 255, 202, 213, 109, 255, 189, 206, 91,  255, 147, 168, 63,  255, 152, 172, 63,  255, 170, 191, 74,  255,
    166, 182, 87,  255, 124, 150, 52,  255, 109, 136, 37,  255, 48,  71,  29,  255, 92,  123, 38,  255, 145, 178, 65,  255, 128, 164, 87,  255, 149,
    178, 93,  255, 122, 147, 87,  255, 107, 139, 97,  255, 111, 142, 95,  255, 117, 148, 100, 255, 150, 177, 122, 255, 118, 134, 76,  255, 90,  117,
    45,  255, 123, 154, 65,  255, 112, 144, 55,  255, 101, 133, 41,  255, 121, 150, 76,  255, 110, 140, 63,  255, 72,  100, 34,  255, 49,  68,  28,
    255, 109, 128, 50,  255, 153, 171, 68,  255, 126, 147, 55,  255, 131, 157, 62,  255, 139, 164, 69,  255, 132, 156, 71,  255, 111, 136, 55,  255,
    94,  123, 50,  255, 81,  109, 44,  255, 67,  90,  41,  255, 58,  84,  42,  255, 63,  95,  46,  255, 89,  122, 52,  255, 84,  104, 43,  255, 63,
    74,  37,  255, 63,  75,  36,  255, 65,  77,  36,  255, 69,  90,  33,  255, 86,  118, 39,  255, 82,  107, 50,  255, 84,  119, 46,  255, 86,  120,
    40,  255, 94,  125, 47,  255, 97,  125, 49,  255, 98,  128, 48,  255, 103, 132, 48,  255, 103, 132, 50,  255, 94,  123, 42,  255, 75,  103, 31,
    255, 50,  60,  28,  255, 58,  75,  38,  255, 58,  87,  34,  255, 79,  114, 43,  255, 91,  118, 44,  255, 58,  76,  31,  255, 23,  31,  17,  255,
    26,  32,  21,  255, 55,  68,  31,  255, 47,  60,  29,  255, 62,  79,  38,  255, 65,  90,  34,  255, 104, 136, 65,  255, 185, 200, 84,  255, 172,
    187, 76,  255, 143, 168, 73,  255, 192, 205, 84,  255, 133, 122, 47,  255, 32,  36,  17,  255, 60,  84,  29,  255, 68,  98,  32,  255, 68,  104,
    31,  255, 84,  118, 36,  255, 102, 130, 45,  255, 92,  115, 38,  255, 60,  84,  26,  255, 88,  113, 42,  255, 176, 180, 69,  255, 165, 171, 60,
    255, 164, 174, 68,  255, 177, 183, 80,  255, 117, 115, 45,  255, 68,  83,  36,  255, 151, 167, 65,  255, 214, 209, 72,  255, 212, 203, 60,  255,
    204, 198, 62,  255, 222, 213, 68,  255, 217, 202, 62,  255, 119, 129, 39,  255, 194, 210, 129, 255, 194, 209, 157, 255, 167, 192, 155, 255, 148,
    168, 114, 255, 158, 182, 124, 255, 210, 217, 124, 255, 210, 207, 86,  255, 222, 216, 93,  255, 230, 220, 97,  255, 187, 184, 68,  255, 114, 132,
    38,  255, 104, 129, 47,  255, 114, 142, 55,  255, 124, 153, 60,  255, 130, 155, 63,  255, 136, 160, 68,  255, 122, 146, 50,  255, 142, 168, 65,
    255, 185, 208, 87,  255, 183, 204, 92,  255, 181, 203, 101, 255, 170, 182, 92,  255, 124, 150, 76,  255, 129, 164, 97,  255, 127, 162, 97,  255,
    140, 172, 103, 255, 157, 183, 119, 255, 144, 170, 107, 255, 143, 142, 76,  255, 136, 150, 74,  255, 139, 168, 94,  255, 142, 165, 84,  255, 131,
    153, 79,  255, 181, 200, 96,  255, 196, 214, 106, 255, 207, 219, 116, 255, 217, 224, 121, 255, 217, 224, 121, 255, 219, 224, 121, 255, 215, 219,
    121, 255, 185, 194, 104, 255, 154, 172, 86,  255, 94,  121, 52,  255, 29,  47,  19,  255, 33,  42,  17,  255, 105, 118, 62,  255, 160, 187, 114,
    255, 140, 175, 119, 255, 127, 166, 118, 255, 124, 164, 112, 255, 115, 158, 108, 255, 111, 152, 104, 255, 110, 148, 98,  255, 105, 147, 84,  255,
    100, 143, 82,  255, 91,  131, 68,  255, 109, 142, 72,  255, 113, 148, 83,  255, 82,  113, 52,  255, 119, 139, 62,  255, 118, 147, 63,  255, 78,
    114, 52,  255, 69,  108, 52,  255, 67,  108, 47,  255, 74,  115, 50,  255, 87,  124, 41,  255, 117, 143, 60,  255, 124, 156, 74,  255, 126, 155,
    55,  255, 118, 134, 60,  255, 191, 188, 108, 255, 234, 241, 155, 255, 190, 215, 119, 255, 185, 210, 100, 255, 191, 214, 107, 255, 195, 213, 125,
    255, 122, 137, 69,  255, 144, 162, 76,  255, 186, 212, 107, 255, 188, 219, 113, 255, 195, 219, 116, 255, 217, 225, 125, 255, 220, 229, 139, 255,
    214, 222, 124, 255, 209, 217, 99,  255, 216, 223, 103, 255, 215, 220, 117, 255, 186, 201, 104, 255, 149, 175, 79,  255, 141, 166, 73,  255, 174,
    189, 73,  255, 190, 207, 71,  255, 192, 207, 79,  255, 184, 204, 76,  255, 184, 201, 77,  255, 208, 219, 123, 255, 184, 206, 142, 255, 177, 203,
    154, 255, 153, 174, 129, 255, 201, 212, 161, 255, 96,  108, 68,  255, 26,  43,  19,  255, 23,  29,  23,  255, 28,  32,  25,  255, 34,  43,  28,
    255, 21,  34,  23,  255, 21,  31,  19,  255, 83,  87,  39,  255, 170, 175, 83,  255, 178, 194, 112, 255, 162, 182, 102, 255, 106, 129, 44,  255,
    149, 165, 89,  255, 172, 186, 100, 255, 173, 192, 98,  255, 173, 198, 113, 255, 158, 187, 97,  255, 144, 178, 74,  255, 174, 203, 149, 255, 191,
    219, 174, 255, 142, 156, 109, 255, 17,  31,  17,  255, 26,  37,  21,  255, 173, 181, 108, 255, 168, 195, 142, 255, 137, 165, 116, 255, 135, 163,
    114, 255, 146, 180, 148, 255, 171, 189, 128, 255, 89,  96,  50,  255, 123, 129, 83,  255, 200, 214, 137, 255, 190, 211, 156, 255, 178, 205, 152,
    255, 169, 186, 131, 255, 154, 169, 107, 255, 151, 170, 95,  255, 93,  110, 58,  255, 69,  86,  42,  255, 148, 170, 81,  255, 170, 187, 99,  255,
    238, 241, 145, 255, 218, 222, 134, 255, 215, 224, 127, 255, 212, 224, 111, 255, 202, 215, 137, 255, 175, 196, 134, 255, 177, 198, 134, 255, 176,
    198, 114, 255, 176, 200, 114, 255, 180, 204, 133, 255, 175, 197, 122, 255, 185, 198, 113, 255, 194, 205, 102, 255, 201, 214, 108, 255, 200, 212,
    100, 255, 204, 216, 95,  255, 210, 218, 96,  255, 212, 219, 91,  255, 207, 217, 84,  255, 204, 215, 89,  255, 197, 210, 87,  255, 162, 179, 73,
    255, 131, 152, 60,  255, 138, 159, 60,  255, 186, 202, 101, 255, 166, 180, 90,  255, 62,  69,  29,  255, 45,  58,  32,  255, 34,  47,  25,  255,
    77,  87,  36,  255, 124, 148, 62,  255, 135, 165, 83,  255, 124, 152, 76,  255, 132, 160, 82,  255, 156, 179, 94,  255, 166, 184, 101, 255, 151,
    170, 100, 255, 150, 168, 95,  255, 103, 136, 62,  255, 111, 146, 67,  255, 106, 138, 47,  255, 98,  131, 36,  255, 111, 135, 63,  255, 80,  105,
    48,  255, 65,  89,  32,  255, 101, 121, 52,  255, 137, 160, 58,  255, 141, 164, 49,  255, 130, 151, 47,  255, 118, 138, 53,  255, 122, 143, 65,
    255, 123, 145, 72,  255, 120, 146, 71,  255, 113, 138, 65,  255, 63,  87,  34,  255, 60,  91,  38,  255, 71,  103, 39,  255, 72,  102, 36,  255,
    58,  84,  28,  255, 34,  52,  19,  255, 17,  23,  19,  255, 12,  19,  15,  255, 15,  19,  21,  255, 23,  31,  26,  255, 63,  91,  38,  255, 87,
    116, 48,  255, 85,  110, 45,  255, 53,  67,  31,  255, 69,  89,  41,  255, 115, 140, 52,  255, 122, 147, 55,  255, 120, 147, 58,  255, 113, 141,
    50,  255, 111, 141, 47,  255, 82,  108, 34,  255, 47,  72,  31,  255, 119, 150, 81,  255, 110, 136, 68,  255, 132, 157, 94,  255, 98,  121, 48,
    255, 45,  62,  28,  255, 29,  34,  21,  255, 90,  108, 55,  255, 117, 148, 60,  255, 95,  131, 47,  255, 89,  125, 45,  255, 73,  94,  38,  255,
    75,  105, 47,  255, 112, 135, 60,  255, 195, 201, 105, 255, 207, 213, 126, 255, 167, 172, 82,  255, 72,  84,  37,  255, 43,  52,  29,  255, 46,
    69,  23,  255, 52,  87,  23,  255, 65,  103, 29,  255, 82,  116, 36,  255, 99,  127, 42,  255, 91,  112, 40,  255, 52,  71,  28,  255, 36,  55,
    19,  255, 99,  114, 49,  255, 174, 179, 72,  255, 170, 176, 65,  255, 161, 171, 63,  255, 131, 144, 52,  255, 101, 120, 44,  255, 119, 138, 60,
    255, 150, 167, 67,  255, 205, 204, 83,  255, 222, 212, 87,  255, 212, 203, 87,  255, 226, 214, 84,  255, 156, 154, 55,  255, 118, 138, 60,  255,
    215, 224, 146, 255, 193, 210, 161, 255, 151, 172, 122, 255, 159, 182, 124, 255, 218, 224, 137, 255, 226, 215, 114, 255, 199, 190, 87,  255, 158,
    165, 60,  255, 133, 157, 48,  255, 114, 138, 41,  255, 90,  108, 29,  255, 58,  87,  28,  255, 80,  111, 38,  255, 78,  104, 33,  255, 86,  115,
    40,  255, 94,  125, 38,  255, 77,  105, 31,  255, 112, 130, 55,  255, 174, 193, 90,  255, 211, 222, 112, 255, 225, 231, 122, 255, 146, 147, 71,
    255, 110, 113, 53,  255, 128, 135, 68,  255, 131, 129, 68,  255, 121, 113, 58,  255, 82,  83,  42,  255, 23,  23,  17,  255, 31,  28,  15,  255,
    107, 113, 60,  255, 173, 190, 89,  255, 162, 190, 77,  255, 156, 180, 86,  255, 163, 187, 77,  255, 126, 147, 62,  255, 134, 151, 69,  255, 141,
    163, 67,  255, 116, 139, 55,  255, 78,  103, 52,  255, 52,  83,  37,  255, 56,  96,  32,  255, 52,  86,  33,  255, 21,  23,  21,  255, 55,  76,
    34,  255, 72,  106, 39,  255, 105, 130, 58,  255, 148, 172, 89,  255, 153, 181, 101, 255, 148, 179, 111, 255, 154, 185, 118, 255, 155, 188, 115,
    255, 145, 181, 109, 255, 140, 171, 102, 255, 134, 156, 90,  255, 134, 158, 65,  255, 137, 169, 68,  255, 105, 142, 55,  255, 109, 137, 60,  255,
    143, 163, 72,  255, 65,  94,  36,  255, 47,  60,  28,  255, 78,  104, 47,  255, 75,  102, 47,  255, 77,  102, 44,  255, 100, 125, 44,  255, 95,
    128, 60,  255, 75,  103, 58,  255, 75,  99,  52,  255, 148, 160, 90,  255, 203, 216, 130, 255, 200, 220, 126, 255, 201, 221, 120, 255, 193, 216,
    108, 255, 190, 210, 110, 255, 197, 216, 119, 255, 157, 176, 90,  255, 82,  100, 48,  255, 62,  65,  33,  255, 82,  87,  41,  255, 130, 134, 58,
    255, 223, 223, 128, 255, 223, 230, 144, 255, 208, 219, 128, 255, 197, 211, 102, 255, 192, 207, 82,  255, 203, 213, 89,  255, 186, 202, 86,  255,
    192, 205, 105, 255, 176, 194, 101, 255, 162, 185, 95,  255, 161, 184, 76,  255, 167, 188, 63,  255, 167, 187, 65,  255, 163, 186, 68,  255, 175,
    195, 80,  255, 202, 215, 116, 255, 196, 214, 138, 255, 160, 187, 127, 255, 194, 205, 155, 255, 167, 178, 118, 255, 26,  39,  19,  255, 33,  47,
    26,  255, 41,  58,  29,  255, 43,  60,  31,  255, 53,  76,  31,  255, 56,  76,  32,  255, 32,  49,  26,  255, 33,  40,  23,  255, 121, 135, 58,
    255, 137, 159, 68,  255, 115, 141, 65,  255, 141, 166, 97,  255, 153, 179, 95,  255, 148, 179, 108, 255, 138, 169, 106, 255, 127, 158, 100, 255,
    125, 153, 84,  255, 163, 189, 125, 255, 184, 214, 166, 255, 141, 159, 117, 255, 17,  26,  17,  255, 21,  31,  19,  255, 160, 169, 108, 255, 171,
    199, 152, 255, 125, 155, 107, 255, 145, 176, 139, 255, 159, 189, 150, 255, 200, 213, 139, 255, 187, 207, 139, 255, 194, 219, 156, 255, 175, 206,
    152, 255, 176, 205, 153, 255, 172, 203, 154, 255, 171, 203, 152, 255, 165, 196, 135, 255, 157, 191, 110, 255, 163, 195, 108, 255, 107, 134, 63,
    255, 71,  91,  39,  255, 134, 158, 67,  255, 207, 220, 133, 255, 197, 213, 146, 255, 181, 203, 138, 255, 183, 206, 104, 255, 176, 201, 126, 255,
    168, 195, 133, 255, 175, 200, 107, 255, 172, 197, 96,  255, 183, 197, 110, 255, 138, 144, 82,  255, 112, 112, 56,  255, 199, 197, 100, 255, 200,
    217, 134, 255, 200, 212, 98,  255, 190, 203, 82,  255, 184, 200, 81,  255, 186, 201, 87,  255, 188, 202, 91,  255, 180, 196, 91,  255, 175, 192,
    87,  255, 169, 190, 72,  255, 113, 133, 52,  255, 89,  109, 44,  255, 114, 136, 46,  255, 177, 193, 86,  255, 180, 191, 109, 255, 71,  80,  43,
    255, 55,  65,  36,  255, 36,  38,  26,  255, 31,  38,  32,  255, 40,  51,  32,  255, 77,  101, 34,  255, 102, 129, 47,  255, 112, 138, 56,  255,
    114, 137, 60,  255, 93,  113, 52,  255, 55,  73,  32,  255, 41,  55,  23,  255, 122, 151, 83,  255, 133, 167, 107, 255, 106, 140, 62,  255, 89,
    121, 38,  255, 84,  103, 52,  255, 76,  99,  39,  255, 146, 165, 55,  255, 170, 191, 63,  255, 179, 198, 72,  255, 189, 201, 67,  255, 191, 204,
    63,  255, 182, 195, 65,  255, 121, 140, 58,  255, 115, 134, 62,  255, 108, 134, 62,  255, 106, 132, 58,  255, 50,  62,  31,  255, 29,  37,  21,
    255, 34,  43,  21,  255, 52,  77,  31,  255, 55,  84,  29,  255, 53,  81,  26,  255, 26,  32,  21,  255, 19,  21,  19,  255, 19,  21,  19,  255,
    26,  31,  29,  255, 32,  43,  31,  255, 43,  55,  31,  255, 34,  44,  23,  255, 23,  33,  21,  255, 21,  28,  19,  255, 42,  51,  26,  255, 101,
    121, 48,  255, 126, 152, 63,  255, 120, 145, 55,  255, 101, 123, 41,  255, 47,  72,  23,  255, 48,  80,  46,  255, 133, 163, 90,  255, 167, 190,
    105, 255, 159, 180, 93,  255, 85,  111, 52,  255, 80,  117, 53,  255, 63,  84,  36,  255, 80,  96,  52,  255, 128, 156, 71,  255, 106, 138, 47,
    255, 112, 142, 60,  255, 140, 156, 73,  255, 119, 136, 49,  255, 81,  104, 31,  255, 96,  115, 52,  255, 143, 155, 89,  255, 95,  120, 58,  255,
    93,  125, 67,  255, 108, 133, 65,  255, 69,  86,  28,  255, 52,  84,  21,  255, 67,  104, 29,  255, 82,  117, 38,  255, 89,  110, 37,  255, 44,
    51,  23,  255, 38,  51,  29,  255, 41,  55,  26,  255, 52,  77,  26,  255, 103, 127, 47,  255, 135, 150, 60,  255, 120, 133, 45,  255, 93,  110,
    36,  255, 84,  105, 36,  255, 129, 150, 49,  255, 156, 169, 55,  255, 163, 174, 62,  255, 193, 198, 92,  255, 220, 214, 115, 255, 217, 210, 97,
    255, 187, 183, 84,  255, 74,  94,  23,  255, 104, 126, 52,  255, 207, 220, 150, 255, 164, 183, 131, 255, 155, 180, 121, 255, 181, 191, 109, 255,
    127, 142, 52,  255, 86,  117, 31,  255, 79,  114, 26,  255, 93,  126, 37,  255, 118, 143, 50,  255, 109, 135, 42,  255, 89,  122, 38,  255, 105,
    135, 49,  255, 113, 139, 50,  255, 116, 140, 49,  255, 133, 155, 60,  255, 132, 147, 55,  255, 49,  55,  23,  255, 84,  114, 58,  255, 113, 135,
    72,  255, 131, 146, 81,  255, 43,  51,  36,  255, 9,   17,  15,  255, 32,  46,  29,  255, 38,  60,  36,  255, 25,  43,  32,  255, 36,  52,  37,
    255, 32,  44,  31,  255, 9,   9,   15,  255, 87,  108, 75,  255, 173, 200, 115, 255, 170, 193, 102, 255, 162, 186, 99,  255, 168, 191, 87,  255,
    113, 140, 55,  255, 98,  136, 52,  255, 111, 155, 41,  255, 105, 144, 37,  255, 78,  111, 40,  255, 52,  86,  36,  255, 48,  81,  28,  255, 47,
    81,  26,  255, 55,  84,  31,  255, 72,  113, 44,  255, 65,  101, 44,  255, 82,  115, 39,  255, 85,  123, 31,  255, 91,  127, 33,  255, 97,  132,
    44,  255, 113, 141, 60,  255, 116, 144, 68,  255, 97,  125, 62,  255, 79,  94,  48,  255, 124, 128, 52,  255, 167, 191, 84,  255, 140, 172, 90,
    255, 144, 175, 94,  255, 131, 148, 76,  255, 49,  60,  32,  255, 50,  72,  34,  255, 34,  47,  26,  255, 47,  74,  31,  255, 33,  52,  28,  255,
    43,  60,  33,  255, 74,  99,  55,  255, 100, 129, 56,  255, 108, 147, 80,  255, 86,  124, 84,  255, 108, 139, 98,  255, 110, 140, 97,  255, 130,
    154, 98,  255, 162, 171, 98,  255, 217, 220, 136, 255, 194, 216, 167, 255, 213, 224, 179, 255, 158, 176, 100, 255, 43,  65,  36,  255, 6,   9,
    15,  255, 9,   12,  12,  255, 138, 147, 75,  255, 203, 213, 120, 255, 221, 227, 136, 255, 220, 230, 143, 255, 214, 224, 133, 255, 196, 208, 97,
    255, 180, 200, 73,  255, 154, 183, 58,  255, 206, 217, 112, 255, 170, 195, 117, 255, 129, 166, 104, 255, 129, 161, 101, 255, 185, 199, 104, 255,
    207, 217, 110, 255, 171, 190, 78,  255, 169, 191, 81,  255, 193, 207, 90,  255, 212, 213, 84,  255, 173, 192, 95,  255, 152, 172, 106, 255, 109,
    117, 72,  255, 36,  47,  21,  255, 62,  91,  29,  255, 52,  84,  26,  255, 58,  86,  34,  255, 67,  94,  36,  255, 105, 127, 47,  255, 100, 123,
    45,  255, 60,  79,  36,  255, 77,  105, 46,  255, 109, 128, 72,  255, 115, 136, 65,  255, 140, 170, 77,  255, 119, 158, 71,  255, 127, 161, 77,
    255, 131, 161, 78,  255, 121, 154, 80,  255, 113, 145, 83,  255, 129, 156, 93,  255, 176, 202, 144, 255, 132, 148, 110, 255, 23,  34,  19,  255,
    26,  46,  17,  255, 135, 150, 94,  255, 175, 200, 154, 255, 128, 154, 102, 255, 153, 184, 150, 255, 181, 201, 146, 255, 180, 197, 117, 255, 184,
    205, 124, 255, 185, 207, 138, 255, 180, 208, 153, 255, 187, 212, 155, 255, 184, 209, 150, 255, 179, 205, 142, 255, 178, 204, 134, 255, 189, 211,
    123, 255, 203, 217, 113, 255, 169, 183, 83,  255, 106, 131, 52,  255, 125, 148, 63,  255, 181, 205, 124, 255, 188, 212, 131, 255, 209, 223, 133,
    255, 203, 216, 125, 255, 206, 217, 116, 255, 205, 215, 118, 255, 168, 192, 93,  255, 199, 210, 113, 255, 196, 199, 112, 255, 180, 191, 121, 255,
    185, 197, 127, 255, 191, 209, 129, 255, 157, 161, 74,  255, 180, 183, 68,  255, 171, 188, 93,  255, 131, 161, 97,  255, 120, 154, 113, 255, 124,
    157, 120, 255, 113, 151, 113, 255, 120, 157, 106, 255, 155, 186, 97,  255, 115, 136, 62,  255, 52,  75,  26,  255, 69,  92,  31,  255, 154, 169,
    73,  255, 192, 205, 113, 255, 67,  83,  36,  255, 45,  65,  29,  255, 47,  52,  31,  255, 42,  51,  31,  255, 43,  52,  34,  255, 55,  84,  32,
    255, 63,  101, 31,  255, 57,  94,  33,  255, 49,  87,  33,  255, 40,  68,  26,  255, 28,  44,  23,  255, 15,  17,  17,  255, 53,  72,  34,  255,
    101, 128, 65,  255, 129, 158, 91,  255, 88,  109, 58,  255, 108, 134, 75,  255, 128, 160, 92,  255, 182, 196, 80,  255, 192, 205, 63,  255, 187,
    203, 67,  255, 195, 207, 77,  255, 199, 209, 69,  255, 185, 196, 62,  255, 115, 137, 53,  255, 107, 130, 58,  255, 103, 128, 58,  255, 98,  126,
    58,  255, 49,  65,  34,  255, 26,  37,  23,  255, 26,  41,  23,  255, 60,  89,  41,  255, 89,  120, 49,  255, 58,  82,  26,  255, 15,  19,  17,
    255, 89,  107, 50,  255, 93,  108, 44,  255, 56,  75,  38,  255, 52,  68,  37,  255, 29,  36,  25,  255, 50,  65,  33,  255, 42,  58,  23,  255,
    19,  31,  21,  255, 19,  21,  21,  255, 21,  23,  21,  255, 41,  48,  31,  255, 55,  68,  33,  255, 32,  46,  21,  255, 86,  110, 47,  255, 92,
    124, 47,  255, 133, 161, 80,  255, 159, 184, 93,  255, 143, 171, 62,  255, 85,  107, 56,  255, 68,  99,  56,  255, 89,  124, 53,  255, 34,  47,
    21,  255, 43,  47,  29,  255, 65,  74,  40,  255, 148, 171, 106, 255, 149, 174, 87,  255, 122, 150, 53,  255, 110, 134, 47,  255, 77,  97,  33,
    255, 71,  97,  40,  255, 77,  105, 60,  255, 96,  125, 77,  255, 136, 161, 87,  255, 105, 115, 43,  255, 49,  75,  19,  255, 67,  106, 28,  255,
    71,  101, 31,  255, 53,  74,  25,  255, 33,  47,  21,  255, 28,  39,  23,  255, 43,  58,  31,  255, 55,  80,  26,  255, 69,  101, 34,  255, 83,
    112, 36,  255, 48,  65,  19,  255, 48,  60,  28,  255, 125, 143, 63,  255, 175, 185, 87,  255, 175, 184, 89,  255, 183, 191, 80,  255, 183, 191,
    74,  255, 192, 196, 90,  255, 191, 194, 87,  255, 150, 157, 68,  255, 73,  93,  25,  255, 41,  69,  12,  255, 112, 140, 72,  255, 188, 201, 141,
    255, 144, 169, 111, 255, 143, 169, 68,  255, 107, 142, 31,  255, 100, 138, 32,  255, 95,  133, 31,  255, 89,  118, 31,  255, 101, 129, 36,  255,
    115, 146, 49,  255, 112, 139, 46,  255, 122, 147, 58,  255, 133, 156, 65,  255, 140, 160, 65,  255, 147, 167, 69,  255, 165, 181, 76,  255, 155,
    160, 74,  255, 89,  110, 58,  255, 65,  93,  62,  255, 58,  87,  58,  255, 119, 140, 77,  255, 113, 123, 67,  255, 84,  106, 58,  255, 92,  123,
    52,  255, 99,  126, 55,  255, 43,  63,  38,  255, 29,  40,  28,  255, 21,  26,  23,  255, 80,  107, 65,  255, 85,  113, 72,  255, 62,  82,  58,
    255, 58,  72,  55,  255, 128, 155, 108, 255, 122, 150, 92,  255, 106, 138, 58,  255, 127, 165, 52,  255, 134, 173, 49,  255, 142, 179, 56,  255,
    140, 174, 50,  255, 81,  117, 32,  255, 47,  76,  23,  255, 53,  87,  33,  255, 57,  89,  41,  255, 80,  109, 45,  255, 68,  111, 32,  255, 55,
    97,  32,  255, 58,  97,  33,  255, 52,  90,  31,  255, 46,  84,  26,  255, 44,  81,  26,  255, 49,  83,  28,  255, 52,  81,  29,  255, 36,  47,
    23,  255, 93,  111, 67,  255, 99,  122, 81,  255, 109, 127, 83,  255, 52,  68,  39,  255, 29,  37,  28,  255, 34,  47,  28,  255, 50,  68,  32,
    255, 48,  75,  26,  255, 29,  48,  23,  255, 47,  62,  31,  255, 100, 126, 60,  255, 60,  91,  41,  255, 106, 133, 58,  255, 106, 145, 62,  255,
    93,  132, 62,  255, 100, 133, 85,  255, 112, 146, 107, 255, 112, 145, 109, 255, 141, 160, 97,  255, 183, 199, 120, 255, 194, 209, 132, 255, 137,
    158, 82,  255, 95,  121, 74,  255, 86,  102, 60,  255, 91,  102, 53,  255, 125, 153, 74,  255, 92,  126, 71,  255, 177, 186, 112, 255, 227, 233,
    138, 255, 217, 226, 135, 255, 219, 228, 139, 255, 177, 202, 90,  255, 171, 198, 80,  255, 187, 208, 119, 255, 152, 182, 121, 255, 178, 198, 130,
    255, 212, 223, 149, 255, 223, 231, 142, 255, 197, 212, 133, 255, 173, 192, 91,  255, 181, 199, 89,  255, 169, 183, 87,  255, 190, 198, 89,  255,
    153, 172, 73,  255, 117, 139, 63,  255, 29,  40,  23,  255, 71,  82,  39,  255, 139, 159, 68,  255, 102, 124, 53,  255, 72,  104, 37,  255, 75,
    103, 43,  255, 98,  122, 48,  255, 94,  125, 60,  255, 89,  116, 55,  255, 92,  119, 49,  255, 133, 151, 84,  255, 103, 128, 81,  255, 154, 175,
    109, 255, 163, 183, 76,  255, 188, 202, 82,  255, 204, 216, 92,  255, 185, 202, 84,  255, 175, 193, 94,  255, 167, 184, 106, 255, 143, 163, 92,
    255, 93,  108, 65,  255, 25,  43,  21,  255, 25,  49,  15,  255, 120, 135, 83,  255, 169, 192, 145, 255, 123, 153, 106, 255, 171, 199, 155, 255,
    163, 174, 106, 255, 143, 161, 79,  255, 157, 179, 94,  255, 172, 190, 103, 255, 184, 199, 115, 255, 191, 207, 130, 255, 191, 205, 124, 255, 218,
    224, 128, 255, 203, 211, 117, 255, 174, 183, 98,  255, 124, 138, 68,  255, 55,  69,  31,  255, 86,  114, 47,  255, 99,  125, 52,  255, 87,  105,
    47,  255, 87,  103, 52,  255, 147, 157, 81,  255, 158, 173, 92,  255, 187, 203, 103, 255, 195, 209, 116, 255, 196, 212, 131, 255, 198, 214, 141,
    255, 185, 207, 128, 255, 181, 205, 136, 255, 175, 201, 131, 255, 169, 187, 112, 255, 143, 156, 74,  255, 163, 176, 74,  255, 166, 185, 87,  255,
    130, 160, 89,  255, 117, 151, 94,  255, 116, 151, 111, 255, 114, 149, 117, 255, 115, 152, 108, 255, 134, 166, 99,  255, 108, 131, 74,  255, 60,
    82,  29,  255, 36,  56,  23,  255, 96,  118, 40,  255, 185, 200, 101, 255, 93,  108, 48,  255, 28,  43,  21,  255, 29,  37,  23,  255, 31,  37,
    25,  255, 39,  52,  26,  255, 55,  84,  33,  255, 65,  104, 32,  255, 60,  94,  37,  255, 53,  84,  37,  255, 41,  60,  25,  255, 36,  52,  23,
    255, 31,  43,  25,  255, 41,  58,  26,  255, 40,  65,  19,  255, 79,  102, 55,  255, 127, 144, 87,  255, 141, 171, 101, 255, 133, 162, 92,  255,
    119, 142, 62,  255, 149, 164, 53,  255, 191, 202, 75,  255, 196, 210, 90,  255, 212, 221, 93,  255, 160, 163, 58,  255, 86,  109, 40,  255, 104,
    132, 55,  255, 105, 131, 58,  255, 87,  111, 47,  255, 42,  58,  31,  255, 38,  53,  32,  255, 34,  49,  31,  255, 45,  63,  34,  255, 84,  111,
    45,  255, 52,  68,  32,  255, 49,  67,  34,  255, 136, 165, 72,  255, 161, 181, 83,  255, 112, 142, 56,  255, 120, 149, 47,  255, 88,  111, 36,
    255, 99,  129, 42,  255, 65,  86,  23,  255, 48,  63,  34,  255, 44,  58,  31,  255, 31,  42,  23,  255, 38,  52,  29,  255, 40,  62,  28,  255,
    34,  58,  23,  255, 63,  84,  36,  255, 148, 175, 62,  255, 124, 156, 62,  255, 160, 184, 95,  255, 139, 163, 60,  255, 100, 124, 62,  255, 65,
    93,  62,  255, 82,  118, 65,  255, 62,  80,  34,  255, 9,   9,   12,  255, 62,  75,  56,  255, 149, 177, 101, 255, 119, 150, 78,  255, 103, 131,
    65,  255, 86,  116, 49,  255, 78,  101, 36,  255, 72,  97,  42,  255, 132, 158, 93,  255, 174, 185, 100, 255, 165, 174, 79,  255, 78,  87,  28,
    255, 33,  48,  21,  255, 58,  86,  32,  255, 56,  80,  31,  255, 40,  65,  28,  255, 47,  75,  25,  255, 43,  62,  23,  255, 44,  60,  28,  255,
    46,  69,  21,  255, 55,  84,  26,  255, 87,  116, 36,  255, 71,  101, 26,  255, 63,  87,  26,  255, 141, 154, 65,  255, 205, 212, 109, 255, 141,
    168, 110, 255, 165, 189, 111, 255, 188, 203, 102, 255, 200, 211, 101, 255, 196, 205, 104, 255, 146, 157, 69,  255, 56,  74,  17,  255, 55,  77,
    31,  255, 93,  111, 52,  255, 184, 193, 105, 255, 147, 162, 78,  255, 126, 151, 52,  255, 129, 157, 48,  255, 132, 160, 50,  255, 139, 159, 55,
    255, 74,  97,  25,  255, 111, 146, 50,  255, 139, 168, 50,  255, 127, 158, 44,  255, 127, 155, 43,  255, 133, 157, 48,  255, 155, 174, 65,  255,
    172, 184, 79,  255, 148, 154, 60,  255, 81,  98,  34,  255, 81,  107, 63,  255, 77,  102, 72,  255, 69,  99,  60,  255, 134, 162, 86,  255, 208,
    216, 114, 255, 161, 178, 102, 255, 98,  130, 62,  255, 138, 165, 60,  255, 92,  121, 44,  255, 84,  104, 47,  255, 44,  62,  36,  255, 28,  47,
    28,  255, 33,  52,  33,  255, 47,  65,  41,  255, 89,  108, 47,  255, 122, 144, 58,  255, 141, 171, 89,  255, 114, 141, 75,  255, 122, 152, 65,
    255, 148, 184, 73,  255, 143, 179, 63,  255, 166, 194, 67,  255, 138, 163, 58,  255, 114, 141, 74,  255, 107, 131, 55,  255, 81,  115, 47,  255,
    90,  122, 46,  255, 82,  117, 41,  255, 62,  94,  31,  255, 62,  95,  32,  255, 67,  100, 32,  255, 74,  106, 33,  255, 65,  95,  32,  255, 55,
    82,  32,  255, 26,  37,  21,  255, 31,  38,  26,  255, 55,  77,  48,  255, 56,  84,  58,  255, 41,  71,  36,  255, 29,  44,  25,  255, 33,  40,
    31,  255, 32,  40,  26,  255, 38,  48,  29,  255, 55,  77,  33,  255, 37,  58,  28,  255, 47,  60,  31,  255, 119, 141, 68,  255, 58,  96,  47,
    255, 62,  89,  48,  255, 108, 129, 65,  255, 152, 174, 82,  255, 136, 167, 75,  255, 105, 142, 67,  255, 109, 143, 78,  255, 110, 143, 98,  255,
    124, 152, 97,  255, 140, 164, 79,  255, 113, 143, 63,  255, 151, 173, 95,  255, 192, 210, 131, 255, 199, 215, 147, 255, 193, 209, 129, 255, 175,
    194, 114, 255, 178, 193, 115, 255, 224, 228, 138, 255, 224, 229, 134, 255, 215, 225, 127, 255, 194, 214, 104, 255, 174, 201, 94,  255, 171, 196,
    124, 255, 200, 216, 140, 255, 224, 236, 148, 255, 223, 233, 134, 255, 215, 224, 142, 255, 150, 176, 113, 255, 123, 153, 84,  255, 170, 186, 83,
    255, 196, 200, 114, 255, 239, 243, 146, 255, 193, 212, 109, 255, 152, 176, 79,  255, 128, 146, 77,  255, 161, 183, 91,  255, 232, 238, 117, 255,
    166, 175, 74,  255, 87,  112, 45,  255, 92,  116, 52,  255, 110, 129, 53,  255, 103, 131, 52,  255, 91,  120, 55,  255, 126, 150, 62,  255, 114,
    138, 65,  255, 103, 133, 90,  255, 118, 147, 109, 255, 139, 158, 92,  255, 156, 166, 77,  255, 166, 179, 99,  255, 187, 209, 118, 255, 176, 203,
    104, 255, 170, 196, 90,  255, 143, 162, 79,  255, 119, 132, 75,  255, 81,  108, 45,  255, 33,  58,  19,  255, 90,  109, 60,  255, 168, 187, 123,
    255, 146, 173, 126, 255, 178, 195, 133, 255, 63,  68,  36,  255, 144, 165, 87,  255, 139, 168, 97,  255, 135, 163, 95,  255, 114, 146, 81,  255,
    136, 161, 83,  255, 153, 174, 78,  255, 133, 156, 56,  255, 108, 132, 47,  255, 90,  117, 44,  255, 65,  94,  40,  255, 92,  112, 55,  255, 109,
    133, 58,  255, 145, 165, 80,  255, 137, 154, 75,  255, 136, 151, 81,  255, 165, 177, 98,  255, 191, 201, 109, 255, 165, 182, 97,  255, 169, 197,
    122, 255, 167, 197, 113, 255, 168, 198, 112, 255, 186, 213, 126, 255, 211, 228, 151, 255, 219, 231, 159, 255, 185, 194, 113, 255, 182, 195, 113,
    255, 159, 174, 79,  255, 167, 182, 87,  255, 122, 151, 86,  255, 115, 151, 94,  255, 117, 151, 103, 255, 115, 150, 117, 255, 110, 146, 110, 255,
    114, 148, 97,  255, 110, 134, 75,  255, 114, 132, 58,  255, 47,  67,  26,  255, 63,  87,  31,  255, 136, 158, 60,  255, 84,  98,  38,  255, 23,
    38,  19,  255, 29,  47,  26,  255, 26,  40,  23,  255, 26,  39,  23,  255, 42,  67,  26,  255, 56,  95,  26,  255, 58,  89,  33,  255, 36,  55,
    26,  255, 49,  72,  28,  255, 68,  109, 32,  255, 67,  104, 34,  255, 74,  105, 34,  255, 48,  68,  34,  255, 65,  82,  56,  255, 111, 121, 80,
    255, 82,  102, 38,  255, 102, 125, 39,  255, 99,  127, 38,  255, 100, 136, 44,  255, 124, 152, 62,  255, 148, 164, 72,  255, 201, 207, 109, 255,
    136, 142, 63,  255, 60,  80,  31,  255, 88,  112, 43,  255, 92,  116, 43,  255, 48,  63,  29,  255, 45,  65,  36,  255, 79,  103, 47,  255, 82,
    103, 47,  255, 52,  68,  32,  255, 52,  65,  32,  255, 87,  114, 52,  255, 103, 138, 50,  255, 132, 161, 62,  255, 159, 184, 83,  255, 146, 172,
    75,  255, 127, 157, 50,  255, 120, 156, 39,  255, 137, 167, 60,  255, 132, 159, 67,  255, 148, 177, 77,  255, 86,  109, 38,  255, 47,  71,  25,
    255, 56,  76,  34,  255, 47,  73,  26,  255, 47,  75,  28,  255, 39,  62,  23,  255, 68,  82,  39,  255, 108, 137, 48,  255, 155, 179, 96,  255,
    143, 168, 79,  255, 113, 141, 69,  255, 90,  123, 69,  255, 92,  128, 68,  255, 69,  87,  41,  255, 23,  23,  19,  255, 28,  31,  21,  255, 92,
    103, 50,  255, 173, 188, 87,  255, 169, 180, 87,  255, 158, 166, 77,  255, 91,  102, 38,  255, 80,  103, 37,  255, 116, 137, 55,  255, 127, 140,
    55,  255, 99,  113, 40,  255, 63,  78,  28,  255, 69,  84,  36,  255, 106, 125, 53,  255, 119, 134, 60,  255, 126, 136, 68,  255, 123, 134, 69,
    255, 87,  102, 41,  255, 50,  69,  25,  255, 43,  60,  21,  255, 58,  80,  31,  255, 126, 152, 60,  255, 106, 132, 44,  255, 109, 137, 44,  255,
    97,  115, 36,  255, 148, 164, 67,  255, 182, 197, 99,  255, 153, 180, 113, 255, 149, 175, 109, 255, 170, 192, 109, 255, 190, 204, 115, 255, 183,
    200, 119, 255, 164, 166, 90,  255, 69,  75,  31,  255, 60,  82,  26,  255, 126, 154, 56,  255, 185, 198, 110, 255, 145, 162, 99,  255, 157, 177,
    104, 255, 192, 207, 108, 255, 198, 199, 90,  255, 105, 122, 41,  255, 146, 175, 84,  255, 163, 183, 65,  255, 163, 185, 82,  255, 163, 185, 84,
    255, 167, 186, 80,  255, 164, 175, 72,  255, 133, 146, 58,  255, 109, 128, 55,  255, 89,  114, 49,  255, 73,  101, 62,  255, 74,  100, 68,  255,
    78,  107, 56,  255, 87,  119, 49,  255, 146, 166, 89,  255, 147, 168, 107, 255, 96,  133, 63,  255, 136, 160, 58,  255, 62,  92,  33,  255, 98,
    125, 47,  255, 87,  114, 44,  255, 86,  114, 68,  255, 78,  100, 63,  255, 68,  86,  40,  255, 77,  96,  39,  255, 74,  101, 36,  255, 82,  108,
    41,  255, 113, 140, 60,  255, 145, 170, 80,  255, 153, 181, 97,  255, 153, 184, 94,  255, 168, 196, 108, 255, 171, 192, 90,  255, 113, 148, 83,
    255, 101, 130, 69,  255, 140, 167, 83,  255, 102, 133, 58,  255, 99,  127, 47,  255, 77,  91,  41,  255, 53,  68,  36,  255, 29,  44,  25,  255,
    42,  56,  28,  255, 37,  55,  26,  255, 29,  40,  25,  255, 37,  49,  25,  255, 52,  74,  36,  255, 60,  87,  49,  255, 62,  87,  50,  255, 36,
    53,  31,  255, 33,  40,  26,  255, 31,  39,  29,  255, 32,  43,  29,  255, 29,  41,  29,  255, 55,  75,  36,  255, 58,  87,  34,  255, 45,  62,
    26,  255, 133, 149, 69,  255, 87,  125, 62,  255, 65,  100, 55,  255, 67,  95,  62,  255, 83,  104, 58,  255, 140, 158, 73,  255, 146, 170, 79,
    255, 133, 158, 72,  255, 156, 177, 77,  255, 154, 177, 87,  255, 154, 172, 86,  255, 170, 194, 91,  255, 169, 196, 102, 255, 174, 201, 130, 255,
    178, 206, 154, 255, 184, 206, 152, 255, 209, 220, 129, 255, 196, 214, 100, 255, 208, 219, 110, 255, 223, 228, 125, 255, 219, 228, 128, 255, 189,
    212, 93,  255, 189, 205, 102, 255, 186, 206, 119, 255, 177, 203, 111, 255, 176, 206, 102, 255, 199, 221, 117, 255, 191, 208, 127, 255, 145, 165,
    87,  255, 111, 144, 58,  255, 122, 152, 74,  255, 199, 209, 129, 255, 228, 235, 135, 255, 186, 209, 118, 255, 183, 208, 110, 255, 184, 210, 111,
    255, 200, 216, 108, 255, 202, 202, 90,  255, 142, 155, 56,  255, 112, 136, 63,  255, 102, 129, 67,  255, 113, 135, 53,  255, 107, 127, 48,  255,
    55,  87,  31,  255, 58,  84,  36,  255, 89,  114, 55,  255, 113, 143, 99,  255, 134, 157, 98,  255, 103, 121, 53,  255, 55,  81,  28,  255, 21,
    28,  17,  255, 98,  105, 55,  255, 181, 196, 95,  255, 177, 196, 95,  255, 135, 160, 79,  255, 136, 155, 79,  255, 180, 202, 91,  255, 113, 144,
    67,  255, 85,  112, 60,  255, 132, 153, 89,  255, 153, 174, 118, 255, 68,  80,  42,  255, 34,  44,  21,  255, 144, 166, 82,  255, 106, 141, 86,
    255, 105, 139, 89,  255, 107, 143, 94,  255, 112, 146, 93,  255, 103, 134, 81,  255, 112, 143, 71,  255, 76,  105, 47,  255, 78,  107, 40,  255,
    146, 161, 80,  255, 154, 173, 86,  255, 110, 138, 68,  255, 176, 193, 100, 255, 196, 209, 109, 255, 195, 209, 109, 255, 201, 210, 122, 255, 166,
    178, 114, 255, 158, 184, 128, 255, 186, 210, 132, 255, 198, 218, 111, 255, 199, 218, 109, 255, 186, 206, 116, 255, 181, 198, 127, 255, 193, 210,
    140, 255, 201, 215, 138, 255, 167, 182, 81,  255, 162, 177, 83,  255, 162, 179, 81,  255, 134, 161, 83,  255, 100, 137, 89,  255, 113, 146, 100,
    255, 121, 153, 112, 255, 111, 145, 112, 255, 114, 147, 104, 255, 109, 133, 75,  255, 168, 184, 94,  255, 84,  105, 43,  255, 75,  99,  39,  255,
    109, 132, 44,  255, 84,  107, 39,  255, 63,  89,  29,  255, 102, 123, 42,  255, 113, 132, 52,  255, 109, 123, 47,  255, 53,  67,  26,  255, 68,
    101, 31,  255, 111, 139, 47,  255, 97,  113, 45,  255, 55,  79,  31,  255, 73,  103, 42,  255, 88,  113, 47,  255, 55,  65,  31,  255, 41,  55,
    37,  255, 76,  94,  55,  255, 50,  63,  31,  255, 43,  63,  31,  255, 76,  101, 41,  255, 87,  119, 46,  255, 93,  124, 47,  255, 90,  121, 38,
    255, 93,  118, 38,  255, 105, 128, 46,  255, 107, 133, 50,  255, 90,  113, 45,  255, 68,  84,  33,  255, 53,  67,  31,  255, 28,  40,  25,  255,
    77,  99,  43,  255, 104, 131, 52,  255, 110, 134, 55,  255, 84,  104, 39,  255, 53,  67,  36,  255, 120, 142, 79,  255, 118, 148, 62,  255, 137,
    161, 72,  255, 144, 169, 65,  255, 169, 195, 87,  255, 177, 198, 103, 255, 138, 165, 53,  255, 162, 186, 84,  255, 171, 194, 94,  255, 134, 159,
    65,  255, 48,  76,  15,  255, 47,  71,  31,  255, 60,  89,  33,  255, 57,  87,  29,  255, 58,  89,  31,  255, 52,  75,  26,  255, 26,  41,  19,
    255, 42,  71,  25,  255, 129, 152, 84,  255, 125, 142, 74,  255, 68,  97,  36,  255, 71,  96,  39,  255, 49,  62,  29,  255, 28,  32,  19,  255,
    23,  26,  21,  255, 26,  28,  23,  255, 25,  29,  21,  255, 93,  94,  44,  255, 130, 128, 53,  255, 102, 112, 47,  255, 62,  82,  34,  255, 69,
    87,  31,  255, 74,  90,  29,  255, 63,  84,  26,  255, 90,  111, 41,  255, 112, 129, 58,  255, 135, 148, 69,  255, 137, 146, 72,  255, 137, 147,
    80,  255, 137, 152, 80,  255, 140, 150, 78,  255, 127, 135, 60,  255, 81,  109, 38,  255, 73,  103, 32,  255, 62,  84,  26,  255, 131, 148, 75,
    255, 144, 160, 69,  255, 121, 147, 52,  255, 114, 141, 49,  255, 86,  105, 39,  255, 151, 166, 75,  255, 168, 188, 100, 255, 139, 171, 111, 255,
    139, 173, 119, 255, 170, 193, 129, 255, 150, 176, 123, 255, 172, 197, 133, 255, 166, 173, 93,  255, 86,  111, 36,  255, 124, 151, 52,  255, 160,
    182, 78,  255, 207, 215, 143, 255, 197, 208, 117, 255, 171, 189, 92,  255, 150, 170, 72,  255, 128, 157, 60,  255, 149, 179, 89,  255, 196, 218,
    159, 255, 215, 230, 184, 255, 209, 226, 171, 255, 209, 229, 164, 255, 204, 216, 141, 255, 180, 193, 117, 255, 163, 183, 93,  255, 165, 182, 92,
    255, 93,  110, 55,  255, 60,  84,  37,  255, 60,  84,  29,  255, 83,  115, 47,  255, 132, 157, 80,  255, 141, 155, 97,  255, 100, 140, 74,  255,
    137, 159, 62,  255, 87,  110, 36,  255, 93,  126, 40,  255, 86,  122, 46,  255, 138, 163, 95,  255, 113, 134, 78,  255, 41,  63,  29,  255, 47,
    63,  25,  255, 72,  92,  33,  255, 103, 123, 63,  255, 108, 133, 62,  255, 160, 183, 87,  255, 160, 186, 100, 255, 159, 181, 100, 255, 125, 141,
    76,  255, 147, 163, 76,  255, 134, 169, 84,  255, 91,  123, 95,  255, 138, 164, 89,  255, 141, 167, 68,  255, 162, 183, 74,  255, 179, 200, 84,
    255, 173, 191, 87,  255, 112, 125, 65,  255, 33,  47,  26,  255, 38,  53,  25,  255, 48,  69,  29,  255, 37,  55,  25,  255, 55,  76,  36,  255,
    47,  69,  39,  255, 29,  39,  26,  255, 36,  47,  34,  255, 31,  38,  28,  255, 31,  40,  31,  255, 34,  42,  31,  255, 33,  42,  31,  255, 45,
    60,  34,  255, 67,  101, 36,  255, 49,  79,  28,  255, 126, 133, 65,  255, 142, 167, 84,  255, 76,  112, 62,  255, 83,  113, 69,  255, 77,  108,
    76,  255, 100, 126, 71,  255, 118, 139, 58,  255, 168, 177, 80,  255, 182, 201, 104, 255, 129, 163, 84,  255, 112, 141, 60,  255, 171, 187, 89,
    255, 183, 204, 111, 255, 170, 195, 112, 255, 175, 203, 144, 255, 182, 207, 153, 255, 202, 218, 128, 255, 184, 208, 93,  255, 164, 198, 74,  255,
    160, 191, 69,  255, 194, 210, 113, 255, 200, 216, 110, 255, 182, 204, 96,  255, 163, 192, 84,  255, 174, 201, 89,  255, 193, 214, 110, 255, 162,
    183, 84,  255, 110, 133, 49,  255, 71,  94,  32,  255, 108, 133, 52,  255, 115, 149, 69,  255, 138, 166, 108, 255, 216, 222, 122, 255, 214, 227,
    118, 255, 189, 214, 127, 255, 208, 221, 121, 255, 135, 141, 68,  255, 44,  48,  21,  255, 110, 121, 47,  255, 111, 137, 68,  255, 96,  121, 84,
    255, 106, 132, 62,  255, 97,  125, 41,  255, 82,  113, 40,  255, 58,  92,  37,  255, 63,  91,  42,  255, 97,  123, 72,  255, 132, 159, 101, 255,
    115, 144, 75,  255, 79,  109, 50,  255, 72,  86,  48,  255, 99,  122, 67,  255, 141, 163, 83,  255, 130, 158, 80,  255, 100, 133, 82,  255, 110,
    140, 82,  255, 169, 186, 93,  255, 148, 183, 90,  255, 130, 163, 87,  255, 96,  122, 58,  255, 87,  110, 58,  255, 125, 144, 75,  255, 63,  81,
    28,  255, 149, 169, 80,  255, 122, 153, 85,  255, 91,  128, 85,  255, 95,  129, 87,  255, 89,  124, 87,  255, 79,  114, 75,  255, 119, 149, 76,
    255, 117, 142, 58,  255, 97,  114, 47,  255, 135, 162, 99,  255, 92,  127, 73,  255, 90,  125, 71,  255, 130, 155, 87,  255, 166, 181, 90,  255,
    177, 189, 90,  255, 153, 168, 96,  255, 169, 193, 124, 255, 189, 210, 128, 255, 184, 198, 109, 255, 205, 214, 107, 255, 162, 169, 77,  255, 91,
    95,  47,  255, 96,  104, 47,  255, 152, 165, 60,  255, 167, 182, 72,  255, 185, 199, 92,  255, 160, 175, 71,  255, 135, 164, 49,  255, 147, 172,
    65,  255, 129, 161, 89,  255, 107, 144, 95,  255, 119, 151, 110, 255, 120, 152, 115, 255, 120, 150, 107, 255, 112, 135, 81,  255, 177, 192, 100,
    255, 120, 140, 60,  255, 148, 169, 75,  255, 170, 188, 75,  255, 162, 179, 68,  255, 161, 180, 74,  255, 162, 184, 68,  255, 164, 190, 56,  255,
    183, 200, 71,  255, 134, 155, 63,  255, 132, 159, 62,  255, 144, 170, 58,  255, 159, 184, 69,  255, 145, 159, 75,  255, 56,  82,  26,  255, 52,
    74,  31,  255, 23,  28,  21,  255, 52,  65,  39,  255, 79,  97,  47,  255, 52,  81,  32,  255, 55,  83,  43,  255, 58,  87,  46,  255, 62,  95,
    47,  255, 69,  101, 48,  255, 83,  117, 46,  255, 81,  110, 36,  255, 80,  108, 34,  255, 81,  111, 32,  255, 63,  86,  26,  255, 60,  75,  37,
    255, 56,  65,  36,  255, 31,  42,  23,  255, 69,  87,  36,  255, 106, 129, 49,  255, 105, 127, 50,  255, 92,  114, 39,  255, 68,  81,  40,  255,
    103, 114, 71,  255, 183, 198, 115, 255, 214, 221, 130, 255, 147, 166, 67,  255, 180, 200, 89,  255, 165, 187, 84,  255, 169, 195, 87,  255, 182,
    206, 98,  255, 176, 191, 101, 255, 147, 161, 79,  255, 135, 148, 80,  255, 116, 127, 67,  255, 96,  120, 55,  255, 75,  101, 42,  255, 56,  82,
    31,  255, 44,  65,  23,  255, 29,  52,  17,  255, 48,  77,  31,  255, 112, 130, 76,  255, 107, 121, 60,  255, 60,  95,  31,  255, 39,  67,  23,
    255, 48,  76,  31,  255, 58,  76,  37,  255, 28,  34,  23,  255, 23,  26,  19,  255, 26,  28,  23,  255, 19,  21,  19,  255, 60,  65,  31,  255,
    73,  97,  40,  255, 72,  99,  38,  255, 68,  84,  32,  255, 80,  94,  39,  255, 120, 125, 62,  255, 146, 154, 79,  255, 169, 172, 105, 255, 141,
    147, 84,  255, 126, 142, 79,  255, 128, 150, 71,  255, 124, 153, 75,  255, 104, 123, 47,  255, 83,  110, 36,  255, 75,  107, 36,  255, 78,  109,
    32,  255, 74,  101, 28,  255, 60,  79,  29,  255, 84,  102, 45,  255, 97,  120, 47,  255, 92,  130, 39,  255, 89,  119, 39,  255, 63,  78,  31,
    255, 155, 169, 85,  255, 167, 190, 102, 255, 139, 173, 111, 255, 147, 180, 128, 255, 168, 194, 139, 255, 192, 208, 120, 255, 197, 211, 107, 255,
    164, 184, 80,  255, 149, 169, 71,  255, 138, 159, 65,  255, 136, 157, 58,  255, 132, 156, 53,  255, 125, 151, 58,  255, 135, 160, 62,  255, 144,
    176, 72,  255, 169, 204, 116, 255, 186, 216, 139, 255, 193, 220, 143, 255, 194, 223, 141, 255, 206, 228, 142, 255, 218, 224, 119, 255, 175, 188,
    87,  255, 195, 208, 125, 255, 231, 234, 143, 255, 210, 211, 118, 255, 107, 115, 44,  255, 67,  96,  33,  255, 146, 174, 83,  255, 169, 185, 111,
    255, 149, 152, 87,  255, 119, 153, 92,  255, 146, 170, 80,  255, 103, 138, 50,  255, 91,  126, 52,  255, 133, 170, 74,  255, 98,  137, 55,  255,
    74,  106, 37,  255, 81,  114, 42,  255, 100, 132, 53,  255, 105, 137, 63,  255, 120, 150, 87,  255, 127, 154, 92,  255, 142, 169, 86,  255, 104,
    129, 52,  255, 108, 117, 50,  255, 68,  83,  28,  255, 147, 164, 84,  255, 139, 173, 87,  255, 112, 145, 100, 255, 113, 148, 73,  255, 104, 141,
    53,  255, 110, 144, 60,  255, 123, 153, 76,  255, 155, 177, 81,  255, 193, 208, 97,  255, 148, 168, 82,  255, 43,  69,  29,  255, 42,  65,  31,
    255, 39,  62,  29,  255, 40,  62,  29,  255, 21,  32,  21,  255, 19,  26,  21,  255, 45,  55,  41,  255, 38,  47,  38,  255, 31,  41,  29,  255,
    37,  47,  34,  255, 46,  68,  34,  255, 47,  71,  36,  255, 58,  79,  36,  255, 58,  97,  34,  255, 96,  112, 45,  255, 192, 202, 100, 255, 116,
    148, 78,  255, 87,  121, 72,  255, 94,  124, 85,  255, 112, 135, 98,  255, 153, 168, 91,  255, 185, 197, 91,  255, 163, 188, 98,  255, 143, 173,
    97,  255, 111, 142, 60,  255, 143, 165, 67,  255, 193, 205, 108, 255, 184, 202, 119, 255, 181, 199, 117, 255, 172, 197, 136, 255, 184, 202, 142,
    255, 181, 196, 122, 255, 178, 198, 117, 255, 195, 215, 100, 255, 186, 209, 73,  255, 160, 184, 68,  255, 170, 193, 75,  255, 186, 204, 93,  255,
    202, 215, 111, 255, 152, 174, 67,  255, 113, 143, 36,  255, 117, 144, 38,  255, 110, 134, 40,  255, 89,  116, 44,  255, 107, 134, 56,  255, 112,
    142, 80,  255, 165, 179, 111, 255, 231, 235, 147, 255, 185, 203, 130, 255, 132, 153, 84,  255, 105, 131, 68,  255, 115, 140, 72,  255, 115, 137,
    63,  255, 107, 132, 58,  255, 149, 167, 74,  255, 155, 177, 68,  255, 105, 140, 55,  255, 87,  123, 48,  255, 86,  120, 44,  255, 72,  100, 39,
    255, 63,  90,  46,  255, 114, 143, 95,  255, 127, 160, 101, 255, 145, 175, 94,  255, 150, 176, 93,  255, 105, 139, 84,  255, 105, 132, 86,  255,
    167, 184, 95,  255, 130, 161, 94,  255, 112, 147, 98,  255, 130, 153, 90,  255, 169, 190, 98,  255, 157, 189, 105, 255, 160, 189, 106, 255, 175,
    198, 112, 255, 163, 180, 98,  255, 88,  108, 52,  255, 149, 169, 86,  255, 140, 169, 83,  255, 92,  126, 77,  255, 90,  124, 82,  255, 90,  123,
    82,  255, 74,  108, 75,  255, 89,  120, 68,  255, 126, 152, 68,  255, 90,  106, 52,  255, 121, 152, 102, 255, 89,  122, 68,  255, 141, 162, 92,
    255, 135, 160, 82,  255, 131, 157, 78,  255, 146, 169, 80,  255, 196, 211, 103, 255, 182, 194, 97,  255, 100, 127, 79,  255, 106, 136, 75,  255,
    91,  115, 50,  255, 63,  87,  42,  255, 145, 164, 60,  255, 174, 195, 67,  255, 169, 191, 68,  255, 176, 194, 84,  255, 185, 198, 89,  255, 138,
    165, 52,  255, 135, 167, 47,  255, 135, 163, 48,  255, 154, 178, 73,  255, 139, 168, 99,  255, 110, 144, 104, 255, 125, 157, 116, 255, 126, 157,
    114, 255, 108, 129, 80,  255, 131, 145, 69,  255, 150, 174, 90,  255, 156, 181, 94,  255, 152, 175, 79,  255, 124, 148, 52,  255, 157, 175, 60,
    255, 193, 201, 96,  255, 185, 199, 95,  255, 162, 186, 98,  255, 160, 194, 132, 255, 164, 193, 136, 255, 167, 194, 128, 255, 165, 188, 103, 255,
    177, 190, 89,  255, 108, 131, 40,  255, 104, 135, 37,  255, 85,  103, 31,  255, 65,  81,  42,  255, 73,  99,  47,  255, 63,  96,  52,  255, 63,
    94,  55,  255, 68,  99,  62,  255, 68,  99,  67,  255, 74,  105, 63,  255, 87,  120, 62,  255, 89,  116, 52,  255, 52,  76,  32,  255, 60,  91,
    38,  255, 50,  76,  31,  255, 41,  60,  29,  255, 50,  60,  34,  255, 40,  47,  31,  255, 53,  74,  34,  255, 79,  103, 38,  255, 93,  116, 37,
    255, 80,  103, 31,  255, 75,  81,  52,  255, 118, 135, 80,  255, 211, 222, 144, 255, 228, 236, 138, 255, 206, 215, 101, 255, 202, 218, 99,  255,
    184, 205, 91,  255, 181, 207, 100, 255, 207, 226, 139, 255, 202, 213, 135, 255, 202, 216, 143, 255, 205, 220, 148, 255, 218, 231, 155, 255, 217,
    226, 152, 255, 164, 176, 109, 255, 65,  92,  28,  255, 90,  118, 49,  255, 106, 131, 58,  255, 76,  103, 33,  255, 75,  100, 44,  255, 115, 122,
    72,  255, 63,  92,  33,  255, 102, 131, 60,  255, 170, 193, 97,  255, 195, 215, 111, 255, 87,  94,  47,  255, 47,  52,  42,  255, 25,  25,  19,
    255, 25,  31,  26,  255, 50,  65,  36,  255, 79,  89,  36,  255, 73,  83,  34,  255, 69,  81,  34,  255, 106, 117, 52,  255, 158, 163, 83,  255,
    150, 154, 91,  255, 112, 126, 72,  255, 107, 128, 71,  255, 146, 169, 83,  255, 117, 149, 74,  255, 123, 148, 82,  255, 62,  82,  23,  255, 68,
    100, 26,  255, 80,  111, 34,  255, 95,  123, 40,  255, 97,  120, 37,  255, 74,  98,  28,  255, 52,  82,  19,  255, 95,  129, 44,  255, 111, 147,
    47,  255, 89,  121, 38,  255, 40,  44,  19,  255, 28,  33,  19,  255, 135, 145, 75,  255, 161, 187, 101, 255, 151, 180, 107, 255, 204, 218, 134,
    255, 178, 198, 117, 255, 142, 175, 99,  255, 139, 174, 95,  255, 146, 178, 110, 255, 150, 177, 112, 255, 154, 174, 81,  255, 164, 180, 81,  255,
    137, 156, 67,  255, 158, 182, 97,  255, 186, 209, 123, 255, 177, 204, 132, 255, 181, 207, 141, 255, 187, 210, 147, 255, 196, 215, 155, 255, 209,
    223, 154, 255, 217, 222, 135, 255, 185, 194, 105, 255, 168, 185, 93,  255, 197, 207, 109, 255, 230, 233, 130, 255, 200, 202, 100, 255, 151, 172,
    75,  255, 171, 188, 94,  255, 171, 178, 99,  255, 125, 138, 58,  255, 126, 138, 74,  255, 158, 182, 87,  255, 84,  123, 56,  255, 83,  117, 55,
    255, 136, 166, 87,  255, 140, 175, 93,  255, 106, 145, 84,  255, 94,  129, 83,  255, 95,  125, 87,  255, 92,  125, 90,  255, 106, 139, 91,  255,
    104, 135, 98,  255, 130, 159, 105, 255, 139, 160, 93,  255, 110, 121, 55,  255, 74,  79,  31,  255, 130, 144, 68,  255, 132, 165, 82,  255, 113,
    151, 68,  255, 102, 137, 62,  255, 108, 146, 71,  255, 98,  135, 65,  255, 124, 157, 80,  255, 138, 169, 87,  255, 159, 183, 97,  255, 200, 215,
    111, 255, 125, 146, 72,  255, 48,  75,  38,  255, 48,  75,  36,  255, 37,  58,  29,  255, 31,  48,  26,  255, 31,  48,  23,  255, 45,  53,  43,
    255, 43,  55,  47,  255, 38,  51,  32,  255, 56,  79,  39,  255, 78,  110, 40,  255, 79,  114, 40,  255, 69,  106, 33,  255, 58,  89,  29,  255,
    60,  80,  31,  255, 179, 178, 87,  255, 156, 183, 101, 255, 100, 136, 91,  255, 112, 141, 92,  255, 117, 144, 94,  255, 127, 148, 89,  255, 159,
    175, 90,  255, 159, 184, 100, 255, 153, 173, 77,  255, 113, 133, 47,  255, 168, 187, 102, 255, 148, 180, 126, 255, 158, 181, 128, 255, 180, 193,
    107, 255, 173, 191, 103, 255, 171, 191, 121, 255, 170, 189, 111, 255, 200, 208, 113, 255, 238, 238, 111, 255, 228, 235, 99,  255, 222, 233, 93,
    255, 191, 211, 92,  255, 162, 179, 82,  255, 146, 171, 67,  255, 136, 167, 53,  255, 149, 172, 58,  255, 142, 169, 62,  255, 134, 164, 58,  255,
    123, 158, 63,  255, 106, 140, 58,  255, 110, 139, 58,  255, 125, 149, 74,  255, 167, 181, 113, 255, 136, 160, 99,  255, 108, 140, 81,  255, 101,
    129, 71,  255, 112, 146, 83,  255, 134, 164, 83,  255, 165, 181, 74,  255, 185, 196, 71,  255, 143, 167, 68,  255, 110, 142, 65,  255, 119, 150,
    60,  255, 112, 141, 50,  255, 154, 170, 58,  255, 92,  123, 47,  255, 128, 158, 92,  255, 100, 133, 97,  255, 125, 156, 94,  255, 142, 173, 90,
    255, 140, 170, 90,  255, 112, 142, 84,  255, 143, 163, 90,  255, 167, 188, 104, 255, 126, 160, 105, 255, 117, 153, 104, 255, 141, 161, 98,  255,
    194, 209, 132, 255, 158, 175, 90,  255, 110, 130, 65,  255, 82,  102, 62,  255, 98,  121, 71,  255, 137, 161, 76,  255, 136, 164, 76,  255, 89,
    124, 74,  255, 81,  112, 73,  255, 90,  121, 76,  255, 77,  109, 74,  255, 77,  107, 67,  255, 122, 152, 68,  255, 86,  102, 45,  255, 120, 141,
    83,  255, 91,  119, 55,  255, 209, 216, 111, 255, 194, 213, 109, 255, 168, 195, 102, 255, 183, 207, 115, 255, 214, 221, 130, 255, 127, 150, 93,
    255, 100, 137, 90,  255, 134, 158, 87,  255, 98,  115, 65,  255, 112, 132, 73,  255, 143, 161, 74,  255, 171, 188, 83,  255, 178, 193, 84,  255,
    186, 201, 96,  255, 124, 145, 60,  255, 106, 134, 47,  255, 113, 139, 46,  255, 107, 132, 41,  255, 100, 122, 37,  255, 140, 159, 76,  255, 134,
    161, 105, 255, 122, 154, 115, 255, 131, 163, 123, 255, 88,  107, 67,  255, 65,  86,  36,  255, 138, 169, 91,  255, 150, 177, 101, 255, 129, 161,
    96,  255, 82,  121, 68,  255, 76,  115, 45,  255, 118, 142, 60,  255, 169, 182, 102, 255, 143, 174, 115, 255, 142, 180, 134, 255, 141, 177, 127,
    255, 155, 189, 130, 255, 176, 205, 135, 255, 172, 191, 106, 255, 127, 149, 50,  255, 137, 161, 52,  255, 149, 167, 56,  255, 67,  74,  36,  255,
    36,  49,  29,  255, 74,  104, 49,  255, 86,  121, 56,  255, 79,  113, 68,  255, 82,  112, 75,  255, 83,  112, 79,  255, 89,  121, 74,  255, 111,
    145, 74,  255, 72,  92,  40,  255, 52,  77,  31,  255, 65,  95,  40,  255, 65,  94,  39,  255, 45,  60,  29,  255, 45,  52,  32,  255, 69,  90,
    45,  255, 79,  105, 44,  255, 56,  77,  31,  255, 53,  62,  36,  255, 90,  89,  58,  255, 192, 202, 132, 255, 235, 243, 169, 255, 241, 243, 178,
    255, 220, 228, 117, 255, 217, 230, 112, 255, 198, 213, 111, 255, 179, 207, 111, 255, 180, 205, 119, 255, 168, 195, 123, 255, 176, 202, 130, 255,
    185, 208, 130, 255, 195, 208, 127, 255, 163, 172, 99,  255, 92,  115, 39,  255, 84,  119, 34,  255, 149, 177, 87,  255, 212, 227, 134, 255, 195,
    209, 117, 255, 120, 142, 65,  255, 112, 121, 76,  255, 97,  128, 56,  255, 193, 212, 108, 255, 199, 218, 120, 255, 170, 182, 93,  255, 33,  36,
    15,  255, 140, 150, 106, 255, 118, 119, 75,  255, 39,  49,  31,  255, 50,  74,  37,  255, 60,  80,  37,  255, 65,  69,  37,  255, 87,  81,  53,
    255, 87,  94,  42,  255, 106, 117, 52,  255, 87,  98,  52,  255, 69,  87,  53,  255, 121, 149, 75,  255, 128, 156, 60,  255, 123, 158, 84,  255,
    102, 119, 55,  255, 52,  75,  31,  255, 136, 163, 78,  255, 161, 184, 95,  255, 155, 179, 92,  255, 147, 173, 89,  255, 150, 175, 90,  255, 134,
    156, 78,  255, 98,  123, 47,  255, 105, 141, 49,  255, 95,  123, 39,  255, 23,  28,  15,  255, 12,  17,  17,  255, 33,  47,  29,  255, 153, 178,
    77,  255, 203, 215, 127, 255, 193, 211, 147, 255, 166, 195, 131, 255, 161, 189, 112, 255, 153, 183, 102, 255, 143, 177, 106, 255, 152, 183, 125,
    255, 160, 183, 108, 255, 143, 164, 76,  255, 152, 177, 87,  255, 158, 185, 102, 255, 152, 182, 115, 255, 153, 185, 123, 255, 161, 192, 133, 255,
    164, 192, 128, 255, 171, 199, 131, 255, 183, 206, 137, 255, 200, 219, 149, 255, 216, 228, 157, 255, 198, 204, 123, 255, 164, 179, 87,  255, 195,
    205, 104, 255, 220, 222, 105, 255, 187, 197, 89,  255, 169, 178, 95,  255, 170, 179, 91,  255, 97,  119, 47,  255, 83,  104, 39,  255, 120, 155,
    55,  255, 82,  125, 55,  255, 80,  114, 49,  255, 115, 144, 76,  255, 114, 151, 86,  255, 99,  137, 86,  255, 108, 140, 86,  255, 107, 138, 98,
    255, 103, 137, 107, 255, 106, 139, 99,  255, 104, 138, 99,  255, 101, 136, 102, 255, 116, 146, 107, 255, 127, 152, 92,  255, 87,  102, 43,  255,
    107, 108, 42,  255, 139, 168, 62,  255, 104, 141, 52,  255, 109, 145, 68,  255, 116, 151, 76,  255, 136, 165, 84,  255, 153, 181, 96,  255, 155,
    184, 107, 255, 165, 192, 122, 255, 163, 179, 103, 255, 72,  84,  44,  255, 26,  40,  25,  255, 34,  47,  28,  255, 31,  44,  26,  255, 47,  72,
    32,  255, 57,  87,  40,  255, 36,  47,  32,  255, 39,  49,  38,  255, 56,  77,  46,  255, 97,  119, 52,  255, 122, 155, 53,  255, 91,  129, 42,
    255, 60,  101, 33,  255, 53,  87,  32,  255, 46,  77,  31,  255, 103, 114, 49,  255, 188, 197, 103, 255, 161, 179, 96,  255, 184, 197, 101, 255,
    177, 194, 99,  255, 150, 174, 87,  255, 146, 171, 74,  255, 119, 140, 60,  255, 58,  75,  29,  255, 106, 131, 53,  255, 152, 178, 106, 255, 152,
    179, 105, 255, 148, 176, 95,  255, 146, 174, 99,  255, 171, 188, 106, 255, 184, 196, 102, 255, 151, 167, 72,  255, 157, 176, 82,  255, 136, 166,
    87,  255, 135, 163, 98,  255, 133, 156, 72,  255, 153, 176, 90,  255, 159, 182, 75,  255, 159, 180, 67,  255, 169, 192, 83,  255, 150, 179, 87,
    255, 127, 164, 75,  255, 115, 156, 65,  255, 119, 156, 62,  255, 121, 155, 62,  255, 146, 171, 75,  255, 168, 189, 86,  255, 174, 195, 93,  255,
    188, 208, 105, 255, 189, 209, 111, 255, 141, 160, 84,  255, 178, 196, 123, 255, 155, 175, 107, 255, 168, 179, 78,  255, 155, 173, 67,  255, 120,
    150, 69,  255, 152, 172, 69,  255, 149, 169, 56,  255, 140, 161, 55,  255, 126, 140, 52,  255, 78,  98,  43,  255, 128, 158, 93,  255, 93,  128,
    96,  255, 103, 132, 95,  255, 137, 166, 90,  255, 132, 162, 87,  255, 142, 168, 86,  255, 128, 153, 83,  255, 155, 172, 96,  255, 171, 192, 110,
    255, 149, 181, 111, 255, 124, 158, 96,  255, 119, 139, 79,  255, 128, 152, 82,  255, 69,  91,  55,  255, 65,  89,  55,  255, 87,  116, 52,  255,
    90,  112, 47,  255, 130, 154, 67,  255, 121, 149, 81,  255, 85,  117, 75,  255, 76,  112, 72,  255, 79,  111, 75,  255, 74,  106, 69,  255, 119,
    148, 74,  255, 91,  108, 45,  255, 36,  52,  29,  255, 101, 126, 58,  255, 190, 202, 115, 255, 206, 219, 129, 255, 197, 217, 132, 255, 198, 209,
    131, 255, 140, 164, 111, 255, 111, 146, 104, 255, 132, 161, 107, 255, 168, 183, 99,  255, 175, 187, 101, 255, 177, 193, 99,  255, 163, 183, 86,
    255, 151, 172, 76,  255, 150, 173, 68,  255, 168, 183, 84,  255};
}
